#include <bits/stdc++.h>

using namespace std;

template<typename t>
struct vec : vector<t> {
  using vector<t>::vector;
};

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
  for (t &e : a) {
    in >> e;
  }
  return in;
}

template<typename t>
ostream &operator<<(ostream &out, vector<t> a) {
  for (t e : a) {
    out << e << ' ';
  }
  return out << '\n';
}

int main() {
  int n, m;
  cin >> n >> m;
  vec<vec<bool>> t(n, vec<bool>(m));
  for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) {
    char c;
    cin >> c;
    t[i][j] = c == '1';
  }
  vec<vec<int>> sz(n, vec<int>(m));
  for (int i = 0; i < n; ++i) {
    sz[i][m - 1] = t[i][m - 1];
    for (int j = m - 2; j >= 0; --j) {
      sz[i][j] = (sz[i][j + 1] + 1) * t[i][j];
    }
  }
  int ans = 0;
  for (int j = 0; j < m; ++j) {
    deque<pair<int, int>> q; //i, sz[i][j];
    int s = 0;
    for (int i = 0; i < n; ++i) {
      while (!q.empty() && q.back().second > sz[i][j]) {
        pair<int, int> qb = q.back();
        q.pop_back();
        s -= (qb.second - max(sz[i][j], (!q.empty() ? q.back().second : 0))) * (i - qb.first);
        if (q.empty() || q.back().second <= sz[i][j]) {
          q.emplace_back(qb.first, sz[i][j]);
          break;
        }
      }
      if (q.empty() || q.back().second < sz[i][j]) {
        q.emplace_back(i, sz[i][j]);
      }
      s += q.back().second;
      ans = max(ans, s);
    }
  }
  cout << ans << '\n';
}