#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> ve(k);
    for (auto& [li, ri, mi] : ve) {
        cin >> li >> mi >> ri;
        --li, --ri, --mi;
    }
    sort(ve.begin(), ve.end(), [&](const auto& a, const auto& b) {
        const auto& [la, ra, ma] = a;
        const auto& [lb, rb, mb] = b;
        if (la != lb)
            return la < lb;
        return ra > rb;
        });
    vector<int> good(k);
    bool ans = false;
    for (int i = 0; i < k; ++i) {
        auto [li, ri, mi] = ve[i];
        if (li == 0) {
            good[i] = 1;
            continue;
        }
        for (int j = 0; j < i; ++j) {
            if (!good[j])
                continue;
            auto [lj, rj, mj] = ve[j];
            if (rj < li - 1)
                continue;
            if (li <= mj && mi <= rj)
                continue;
            good[i] = 1;
            break;
        }
    }
    for (int i = 0; i < k; ++i) {
        auto [li, ri, mi] = ve[i];
        if (ri == n - 1 && good[i])
            ans = true;
    }
    cout << (ans ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}