#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

using i128 = __int128;

constexpr i128 inf = 1e18;

template<class T> bool cmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i : x)
        cin >> i;
    int s, d, t;
    cin >> s >> d;
    sort(all(x));
    vector<int> ss(n + 1);
    vector<i128> sss(n + 1);
    sss[n] = ss[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        ss[i] = ss[i + 1] + x[i];
        sss[i] = sss[i + 1] + x[i] * x[i];
    }
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        int mn = min(x[i] - (x[i] / d) * d, (x[i] / d + 1) * d - x[i]);
        v[i] = mn * mn;
    }
    vector<i128> pr(n + 1);
    pr[0] = 0;
    for (int i = 1; i <= n; ++i)
        pr[i] = pr[i - 1] + v[i - 1];
    auto get = [&](int l, int r) {
        return pr[r + 1] - pr[l];
    };
    auto calc = [&](int l) {
        i128 res = (i128)l * t;
        int ind = upper_bound(all(x), l * d) - x.begin();
        res += get(0, ind - 1);
        int cnt = n - ind;
        res += sss[ind] + (i128)cnt * l * d * l * d - 2 * ss[ind] * l * d;
        return res;
    };
    int m;
    cin >> m;
    int mx = *max_element(all(x));
    while (m--) {
        cin >> t;
        int l = 0, r = 1e9 / d + 3;
        while (r - l > 2) {
            int m1 = (r - l) / 3 + l, m2 = (r - l) / 3 * 2 + l;
            if (calc(m1) < calc(m2))
                r = m2;
            else
                l = m1;
        }
        cout << (int)min({calc(l), calc(l + 1), calc(r)}) << '\n';
    }
}

signed main() { // windows faster
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}