#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int n, m;
	std::cin >> n >> m;
	std::vector<std::vector<bool>> a(n, std::vector<bool>(m));
	std::vector<std::vector<int>> c(n, std::vector<int>(m));
	for (int i = 0; i < n; ++i) {
		std::string s;
		std::cin >> s;
		for (int j = 0; j < m; ++j) {
			a[i][j] = (s[j] - '0');
		}
	}
	for (int i = 0; i < n; ++i) {
		int last = m;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j]) {
				c[i][j] = last - j;
			}
			else {
				last = j;
			}
		}
	}
	int ans = 0;
	for (int j = 0; j < m; ++j) {
		std::vector<int> ls(n, -1), dp(n);
		std::vector<std::pair<int, int>> p;
		for (int i = n - 1; i >= 0; --i) {
			while (p.size() > 0 && p.back().first >= c[i][j]) {
				ls[p.back().second] = i;
				p.pop_back();
			}
			if (a[i][j]) {
				p.push_back({ c[i][j], i });
			}
		}
		for (int i = 0; i < n; ++i) {
			if (a[i][j]) {
				dp[i] = c[i][j] * (i - ls[i]) + (ls[i] == -1 ? 0 : dp[ls[i]]);
				ans = std::max(dp[i], ans);
			}
		}
	}
	std::cout << ans;
	return 0;
}