#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;
#ifdef LOCAL
#define __int128 ll
#endif

int n, d;
vector<vector<int>> g;
vector<pair<int, int>> ans;
vector<vector<vector<int>>> t;
vector<int> sz;

void dfs(int v, int p) {
	t[v].resize(d + 1);
	t[v][0].push_back(v);
	for (auto to : g[v]) {
		if (to != p) {
			dfs(to, v);
			if (sz[v] < sz[to]) {
				swap(t[v], t[to]);
				for (int i = 0; i < d; i++) {
					for (auto u : t[to][i]) {
						t[v][i + 1].push_back(u);
					}
				}
			}
			sz[v] += sz[to];
		}
	}
	for (int i = d - 1; i >= 0; i--) {
		for (int j = d; j > i; j--) {
			if ((i + j) % 2 == 1 && i + j <= d && i + j + 2 > d) {
				while (t[v][i].size() && t[v][j].size()) {
					ans.push_back({ t[v][i].back(), t[v][j].back() });
					t[v][i].pop_back();
					t[v][j].pop_back();
				}
			}
		}
	}
}

void solve() {
	cin >> n >> d;
	g.resize(n);
	sz.resize(n, 1);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, -1);
	for (int i = d - 1; i >= 0; i--) {
		for (int j = d; j > i; j--) {
			if ((i + j) % 2 == 1 && i + j <= d) {
				while (t[0][i].size() && t[0][j].size()) {
					ans.push_back({ t[0][i].back(), t[0][j].back() });
					t[0][i].pop_back();
					t[0][j].pop_back();
				}
			}
		}
	}
	cout << ans.size() << '\n';
	for (auto [i, j] : ans) {
		cout << i + 1 << ' ' << j + 1 << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
#endif
	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}