#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct seg {
    int l, m, r;
};

bool check(vector<int> pref, vector<int> prefm, vector<int> suf, vector<int> sufm) {
    if (pref.empty() || suf.empty()) return false;
    vector<int> preff(suf.size());
    preff[0] = sufm[0];
    for (int i = 1; i < suf.size(); ++i) {
        preff[i] = max(preff[i - 1], sufm[i]);
    }
    for (int i = 0; i < pref.size(); ++i) {
        int j = (--upper_bound(suf.begin(), suf.end(), pref[i])) - suf.begin();
        if (j < 0) continue;
        if (preff[j] > pref[i]) return true;
        if (prefm[i] < suf[j]) return true;
    }
    return false;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> arr(k);
    for (int i = 0; i < k; ++i) cin >> arr[i].l >> arr[i].m >> arr[i].r;
    sort(arr.begin(), arr.end(), [](seg a, seg b) {
        return a.l < b.l || (a.l == b.l && a.m < b.m);
    });
    vector<pair<int, int>> pref1;
    vector<int> pref, prefm, suf, sufm;
    for (int i = 0; i < k; ++i) {
        if (arr[i].l == 1) {
            pref1.emplace_back(arr[i].r, arr[i].m);
        } else {
            suf.push_back(arr[i].l);
            sufm.push_back(arr[i].m);
        }
    }
    sort(pref1.begin(), pref1.end());
    for (int i = 0; i < pref1.size(); ++i) {
        pref.push_back(pref1[i].first);
        prefm.push_back(pref1[i].second);
    }
    if (check(pref, prefm, suf, sufm)) cout << "YES\n";
    else cout << "NO\n";
    return;


    vector<bool> dp(n + 1, false);
    vector<int> best(n + 1, n);
    vector<int> ones = {0};
    dp[0] = true;
    for (int i = 0; i < k; ++i) {
        int j1 = lower_bound(ones.begin(), ones.end(), arr[i].l - 1) - ones.begin();
        int j2 = lower_bound(ones.begin(), ones.end(), arr[i].m) - ones.begin();
        int j3 = lower_bound(ones.begin(), ones.end(), arr[i].r) - ones.begin();
        if (j1 != j2) {
            dp[arr[i].r] = true;
            best[arr[i].r] = min(best[arr[i].r], arr[i].m);
            if (j3 == ones.size() || ones[j3] != arr[i].r) ones.push_back(arr[i].r);
            sort(ones.begin(), ones.end());
            continue;
        }
        vector<int> suf, sufm;
        for (int j = 0; j < i; ++j) {
            if (arr[j].m < arr[i].l && arr[j].r <= arr[i].r && arr[j].r >= arr[i].m) {
                suf.push_back(arr[j].l);
                sufm.push_back(arr[j].m);
            }
        }
        vector<int> prefm;
        for (auto j : ones) prefm.push_back(best[j]);
        if (check(ones, prefm, suf, sufm)) {
            dp[arr[i].r] = true;
            best[arr[i].r] = min(best[arr[i].r], arr[i].m);
            if (j3 == ones.size() || ones[j3] != arr[i].r) ones.push_back(arr[i].r);
            sort(ones.begin(), ones.end());
        }
    }
    if (dp.back()) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) solve();
}