#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
// typedef __int128 lll;

vector<pair<int, int>> dp;
vector<vector<int>> g;
vector<int> used;
vector<bool> has1, has2;


void dfs1(int v, int p = -1) {
    for (auto i : g[v]) if (i != p) dfs1(i, v);
    for (auto i : g[v]) {
        if (i == p) continue;
        dp[v].first += dp[i].second;
    }
    dp[v].second = dp[v].first;
    for (auto i : g[v]) {
        if (i == p) continue;
        if (has2[i]) {
            dp[v].second = dp[v].first + 1;
            break;
        }
    }
    if (dp[v].second == dp[v].first) {
        for (auto i : g[v]) {
            if (i == p) continue;
            if (dp[i].first == dp[i].second) {
                dp[v].second = dp[v].first + 1;
                used[i] = 1;
                break;
            }
        }
    }

    for (auto i : g[v]) {
        if (i != p && !used[i] && dp[i].first == dp[i].second) {
            has1[v] = true;
        }
    }
    for (auto i : g[v]) if (i != p && has1[i]) has2[v] = true;
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    dp.assign(n, {0, 0});
    used.assign(n, 0);
    has1.assign(n, false);
    has2.assign(n, false);
    for (int i = n - 1; i >= 0; --i) {
        if (g[i].size() == 1) {
            dfs1(i);
            cout << dp[i].second << "\n";
            break;
        }
    }
    cout << -1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}