#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>
#define int long long
#define ll __int128

using namespace std;

ll tr(int mx, vector<int> &x, vector<ll> &calc, vector<ll> &pr1, vector<ll> &pr2) {
    int n = (int)x.size();
    int l = -1, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (x[m] <= mx) {
            l = m;
        } else {
            r = m;
        }
    }
    ll out = calc[l + 1];
    out += (n - l - 1) * (ll)mx * mx + (pr2[n] - pr2[l + 1]) - 2 * (ll)mx * (pr1[n] - pr1[l + 1]);
    return out;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    vector<ll> calc(n + 1);
    vector<ll> pref1(n + 1), pref2(n + 1);
    for (int i = 0; i < n; ++i) {
        pref1[i + 1] = pref1[i] + (ll)x[i];
        pref2[i + 1] = pref2[i] + (ll)x[i] * x[i];
        int l = x[i] / d;
        int r = l + 1;
        int dx1 = (x[i] - l * d);
        int dx2 = (x[i] - r * d);
        calc[i + 1] = calc[i] + min((ll)dx1 * dx1, (ll)dx2 * dx2);
    }
    for (int qw = 0; qw < m; ++qw) {
        int pw = t[qw];
        int l = 0, r = x.back() / d + 1;
        while (r - l > 2) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (m1 * pw + tr(m1 * d, x, calc, pref1, pref2) > m2 * pw + tr(m2 * d, x, calc, pref1, pref2)) {
                l = m1;
            } else {
                r = m1;
            }
        }
        ll ans = l * pw + tr(l * d, x, calc, pref1, pref2);
        for (int i = l - 2; i <= r + 2; ++i) {
            if (i >= 0) {
                ans = min(ans, i * pw + tr(i * d, x, calc, pref1, pref2));
            }
        }
        cout << (int)ans << endl;
    }
    return 0;
}