#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>
#define int long long
#define ll __int128

using namespace std;

void dfs(int v, int pr, vector<vector<int>> &g, vector<int> &c, int cur) {
    c[v] = cur;
    for (auto u : g[v]) {
        if (u != pr) {
            dfs(u, v, g, c, 1 - cur);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<vector<int>> g(n);
    int u, v;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> c(n, -1);
    dfs(0, -1, g, c, 1);
    vector<int> c0, c1;
    for (int i = 0; i < n; ++i) {
        if (c[i]) {
            c1.push_back(i + 1);
        } else {
            c0.push_back(i + 1);
        }
    }
    vector<pair<int, int>> ans;
    while (!c0.empty() && !c1.empty()) {
        int u = c0.back();
        c0.pop_back();
        int v = c1.back();
        c1.pop_back();
        ans.push_back({u, v});
    }
    cout << (int)ans.size() << endl;
    for (auto [u, v]: ans) {
        cout << u << " " << v << endl;
    }
    return 0;
}