#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);

    vector dp(n + 2, vector<bool>(n+2, false));
    dp[0][0] = true;

    for (int i = 0; i < k; i++) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
    }

    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            if (!dp[i][j]) continue;

            for (int p = 0; p < k; p++) {
                if (i < a[p][1] || j < a[p][0]) {
                    if (a[p][0] <= i + 1) {
                        dp[a[p][2]][a[p][1]] = true;
                    }
                }
            }
        }
    }

    bool ok = false;

    for (int i = 0; i <= n; i++) {
        if (dp[n][i]) ok = true;
    }

    cout << (ok ? "YES" : "NO");
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--)
        solve(), cout << '\n';
}