#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

int gu(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 + d * mx >= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 - d * mx <= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 - d * lx;
    }
}

int gl(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 + d * mx > x) rx = mx - 1;
            else lx = mx;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 - d * mx < x) rx = mx - 1;
            else lx = mx;
        }

        return x0 - d * lx;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int ans = 0;
        for (int i : a) {
            int q = gu(i, x0, d);
            int w = gl(i, x0, d);
            ans += min((q - i) * (q - i), (w - i) * (w - i));
        }

        cout << ans << '\n';;
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}