#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

int gu(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 + d * mx >= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 - d * mx <= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 - d * lx;
    }
}

int gl(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 + d * mx > x) rx = mx - 1;
            else lx = mx;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 - d * mx < x) rx = mx - 1;
            else lx = mx;
        }

        return x0 - d * lx;
    }
}

#define iint __int128

void solve() {
    int n;
    cin >> n;
    vector<iint> a(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        a[i] = t;
    }
    sort(a.begin(), a.end());
    vector<iint> suf(n + 1);
    vector<iint> sufsq(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i+1] + a[i];
        sufsq[i] = sufsq[i+1] + (iint) a[i] * a[i];
    }
    int x0, d;
    cin >> x0 >> d;
    a[0] -= x0;
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;

        auto f = [&](iint t, iint x0) {
            if (x0 < 0) x0 = -x0;
            iint l = gl(x0, 0, d);
            iint r = gu(x0, 0, d);

            iint xl = l / d;
            iint xr = r / d;

            iint ans = min(xl * t + (x0 - l) * (x0 - l), xr * t + (x0 - r) * (x0 - r));

            iint lx = 0, rx = xr - 1;
            while (lx < rx) {
                iint mx = lx + (rx - lx) / 2;

                iint mxd = mx * d;

                iint cur = (mx * d) * (mx * d) - mxd * 2 * x0;
                iint nxt = (mxd + d) * (mxd + d) - (mxd + d) * 2 * x0;
                if (cur - nxt >= t) lx = mx + 1;
                else rx = mx;
            }

            ans = min(ans, lx * t + (x0 - lx * d) * (x0 - lx * d));

            return ans;
        };

        iint ans = min({f(t, a[1]) + a[0] * a[0], f(t, a[0]) + a[1] * a[1], f(t * 2, a[1]) + f(t, a[0]), f(t * 2, a[0]) + f(t, a[1])});
        cout << (int) ans << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}