#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

int gu(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 + d * mx >= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 - d * mx <= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 - d * lx;
    }
}

int gl(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 + d * mx > x) rx = mx - 1;
            else lx = mx;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 - d * mx < x) rx = mx - 1;
            else lx = mx;
        }

        return x0 - d * lx;
    }
}

#define iint __int128

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    sort(a.begin(), a.end());
    vector<iint> suf(n + 1);
    vector<iint> sufsq(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i+1] + a[i];
        sufsq[i] = sufsq[i+1] + (iint) a[i] * a[i];
    }
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int ans = 0;
        int t;
        cin >> t;

        iint lx = 0, rx = 1e9;
        while (lx < rx) {
            iint mx = rx - (rx - lx) / 2;
            int nxt = upper_bound(a.begin(), a.end(), mx) - a.begin();
            iint cur = mx * mx - 2 * mx * suf[nxt];
            iint ee = (mx + 1) * (mx + 1) - 2 * (mx + 1) * suf[nxt];

            if (cur - ee < t) {
                rx = mx - 1;
            } else {
                lx = mx;
            }
        }

        int pos = upper_bound(a.begin(), a.end(), lx) - a.begin();
        ans = lx * t + lx * lx * (a.size() - pos) - lx * 2 * suf[pos] + sufsq[pos];

        cout << ans << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}