#include <bits/stdc++.h>
using namespace std;
#define int long long
#pragma GCC optimize("O3,unroll-loops")

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

int gu(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 + d * mx >= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 - d * mx <= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 - d * lx;
    }
}

int gl(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 + d * mx > x) rx = mx - 1;
            else lx = mx;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 - d * mx < x) rx = mx - 1;
            else lx = mx;
        }

        return x0 - d * lx;
    }
}

#define iint __int128

const int maxn = 500005;
vector<int> g[maxn];

vector<int> cols[2];

void dfs(int c, int v, int p) {
    cols[c].push_back(v);

    for (int u : g[v]) {
        if (u == p) continue;
        dfs(1 - c, u, v);
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n-1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(0, 1, -1);

    cout << min(cols[0].size(), cols[1].size()) << '\n';
    for (int i = 0; i < min(cols[0].size(), cols[1].size()); i++) {
        cout << cols[0][i] << ' ' << cols[1][i] << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}