#include <bits/stdc++.h>
using namespace std;
#define int long long
// #pragma GCC optimize("O3,unroll-loops")

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

const int maxn = 500005;
vector<int> g[maxn];

vector<int> cols[2];
bool taken[maxn];

// vector<pair<int, int>> ans;

int ans;

array<int, 4> dfs(int v, int p) {
    array<int, 4> cur = {0, 0, 0};
    for (int u : g[v]) {
        if (u == p) continue;
        array<int, 4> ar = dfs(u, v);
        cur[1] += ar[0];
        cur[2] += ar[1];
        cur[3] += ar[2];
    }

    cur[0]++;
    int q = min(cur[0], cur[3]);
    ans += q;
    cur[0] -= q;
    cur[3] -= q;

    int w = min(cur[1], cur[2]);
    cur[1] -= w;
    cur[2] -= w;
    ans += w;

    w = min(cur[0], cur[1]);
    ans += w;
    cur[0] -= w;
    cur[1] -= w;

    return cur;
}

void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n-1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(1, -1);

    cout << ans << '\n';
    cout << -1;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}