#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
using namespace std;
 
vector<int> x;
vector<__int128_t> pref_min, pref_val, pref_val_sq, suff_min, suff_val, suff_val_sq;
int n, x0, d;
 
long long nearest(int x) {
  int x1 = x - x % d + x0 % d;
  if (x1 > x) {
    x1 -= d;
  }
  int x2 = x1 + d;
  return min({1LL * (x - x1) * (x - x1), 1LL * (x - x2) * (x - x2)});
}
 
__int128_t eval_b1(int R1, int a, int b, int T) {
  __int128_t answer = 1LL * (a + 2LL * b) * T;
  {

    long long xl = x0 - 1LL * a * d;
    answer += pref_val_sq[R1] - 2 * pref_val[R1] * xl + (__int128_t)xl * xl * R1;
    answer -= pref_min[R1];
  }
  {
    int L = -1, R = n;
    while (R - L > 1) {
      int mid = (L + R) / 2;
      if (x[mid] >= x0 + 1LL * b * d) {
        R = mid;
      } else {
        L = mid;
      }
    }
    long long xr = x0 + 1LL * b * d;
    answer += suff_val_sq[R] - 2 * suff_val[R] * xr + (__int128_t)xr * xr * (n - R);
    answer += pref_min[R];
  }
  return answer;
}
 
__int128_t eval_a1(int a, int T) {
  int L = -1, R = n;
  while (R - L > 1) {
    int mid = (L + R) / 2;
    if (x[mid] >= x0 - 1LL * a * d) {
      R = mid;
    } else {
      L = mid;
    }
  }
  int lb = -1, rb = 1e9;
  while (rb - lb > 1) {
    int mb = (lb + rb) / 2;
    if (eval_b1(R, a, mb + 1, T) - eval_b1(R, a, mb, T) >= 0) {
      rb = mb;
    } else {
      lb = mb;
    }
  }
  return eval_b1(R, a, rb, T);
}
 
__int128_t eval_b2(int R1, int a, int b, int T) {
  __int128_t answer = 1LL * (2LL * a + b) * T;
  {

    long long xl = x0 - 1LL * a * d;
    answer += pref_val_sq[R1] - 2 * pref_val[R1] * xl + (__int128_t)xl * xl * R1;
    answer -= pref_min[R1];
  }
  {
    int L = -1, R = n;
    while (R - L > 1) {
      int mid = (L + R) / 2;
      if (x[mid] >= x0 + 1LL * b * d) {
        R = mid;
      } else {
        L = mid;
      }
    }
    long long xr = x0 + 1LL * b * d;
    answer += pref_min[R];
    answer += suff_val_sq[R] - 2 * suff_val[R] * xr + (__int128_t)xr * xr * (n - R);
  }
  return answer;
}
 
__int128_t eval_a2(int a, int T) {
  int L = -1, R = n;
  while (R - L > 1) {
    int mid = (L + R) / 2;
    if (x[mid] >= x0 - 1LL * a * d) {
      R = mid;
    } else {
      L = mid;
    }
  }
  int lb = -1, rb = 1e9;
  while (rb - lb > 1) {
    int mb = (lb + rb) / 2;
    if (eval_b2(R, a, mb + 1, T) - eval_b2(R, a, mb, T) >= 0) {
      rb = mb;
    } else {
      lb = mb;
    }
  }
  return eval_b2(R, a, rb, T);
}
 
int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  cin >> n;
  x.resize(n);
  for (int &value : x) {
    cin >> value;
  }
  cin >> x0 >> d;
  sort(x.begin(), x.end());
  pref_min = pref_val = pref_val_sq = suff_min = suff_val = suff_val_sq = vector<__int128_t>(n + 1);
  for (int i = 0; i < n; i++) {
    pref_min[i + 1] = pref_min[i] + nearest(x[i]);
    pref_val[i + 1] = pref_val[i] + x[i];
    pref_val_sq[i + 1] = pref_val_sq[i] + 1LL * x[i] * x[i];
  }
  for (int i = n - 1; i >= 0; i--) {
    suff_min[i] = suff_min[i + 1] + nearest(x[i]);
    suff_val[i] = suff_val[i + 1] + x[i];
    suff_val_sq[i] = suff_val_sq[i + 1] + 1LL * x[i] * x[i];
  }
  int m;
  cin >> m;
  while (m--) {
    int t;
    cin >> t;
    int la = -1, ra = 1e9;
    while (ra - la > 1) {
      int ma = (la + ra) / 2;
      if (eval_a1(ma + 1, t) - eval_a1(ma, t) >= 0) {
        ra = ma;
      } else {
        la = ma;
      }
    }
    __int128_t answer = eval_a1(ra, t);
    la = -1, ra = 1e9;
    while (ra - la > 1) {
      int ma = (la + ra) / 2;
      if (eval_a2(ma + 1, t) - eval_a2(ma, t) >= 0) {
        ra = ma;
      } else {
        la = ma;
      }
    }
    answer = min(answer, eval_a2(ra, t));
    cout << (long long)answer << "\n";
  }
}
// trash problem
