#include<bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, sz;
        cin >> n >> sz;
        vector<vector<pair<int, int>>> occ(n + 1);
        for (int i = 0; i < sz; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            occ[r].emplace_back(l, m);
        }
        vector<int> dp(n + 1, n + 1);
        dp[0] = 0;
        for (int i = 1; i <= n; ++i) {
            for (auto [l, m] : occ[i]) {
                for (int j = l - 1; j < i; ++j) {
                    if (dp[j] > n) continue;
                    if (dp[j] < l || j < m) {
                        dp[i] = min(dp[i], m);
                    }
                }
            }
        }
        if (dp[n] <= n) cout << "YES\n";
        else cout << "NO\n";
    }
}