#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<vector<int> > g;
vector<vector<int> > edge;
vector<vector<int> > gr;
vector<int> len;
vector<int> used;
int d;
int tim = 0;
void dfs(int u, int p) {
    used[u] = true;
    for (auto v : g[u]) {
        if (!used[v]) {
            len[v] = len[u] + 1;
            if (len[v] > d) {
                return;
            }
            if (len[v] % 2 == 1) {
                edge[p].push_back(v);
            }
            dfs(v, p);
        }
    }
}
void dfs1(int u) {
    used[u] = true;
    for (auto v : g[u]) {
        if (!used[v]) {
            len[v] = len[u] + 1;
            dfs1(v);
        }
    }
}
vector<int> mt;
bool kuhn(int i) {
    used[i] = tim;
    for (auto u : gr[i]) {
        if (mt[u] == -1) {
            mt[u] = i;
            return true;
        }
    }
    for (auto u : gr[i]) {
        if (used[mt[u]] != tim && kuhn(mt[u])) {
            mt[u] = i;
            return true;
        }
    }
    return false;
}
signed main() {
    int n;
    cin >> n >> d;
    g.resize(n);
    used.resize(n);
    len.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    edge.resize(n);
    for (int i = 0; i < n; i++) {
        used.assign(n, 0);
        len[i] = 0;
        dfs(i, i);
    }
    for (int i = 0; i < n; i++) {
        if (len[i] % 2 == 0) {
            gr.push_back({});
            for (auto u : edge[i]) {
                gr.back().push_back(u);
            }
        }
    }
    d = n;
    used.assign(n, 0);
    dfs1(0);
    used.assign(n, 0);
    mt.resize(n, -1);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        tim++;
        if (kuhn(i)) {
            ans++;
        }
    }
    cout << ans << -1;;
    return 0;
}