#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#define int long long
using namespace std;

void resh() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> otr(k);

    for (auto& [l, m, r] : otr) {
        cin >> l >> m >> r;
    }

    vector<int> pr(k);
    for (int i = 0; i < k; i++) {
        pr[i] = i;
    }

    do {
        vector<int> w(n + 1, 0);
        for (auto i : pr) {
            auto [l, m, r] =  otr[i];

            if (!w[m]) {
                for (int j = l; j <= r; j++) {
                    w[j] = 1;
                }
            }
        }
        int fl = 1;
        for (int i = 1; i <= n; i++) {
            if (!w[i]) {
                fl = 0;
            }
        }

        if (fl) {
            cout << "YES\n";
            return;
        }

    } while (next_permutation(pr.begin(), pr.end()));
    cout << "NO\n";
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        resh();
    }
}