//#pragma GCC optimize("O2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#define int long long
#define ll __int128_t
using namespace std;
const int maxn = 4e5, INF = 1e11;
vector<int> g[maxn], used, save;

vector<pair<int, int>> ans;

void dfs(int v) {
    used[v] = 1;

    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
            if (!save[u] && !save[v]) {
                ans.push_back({u, v});
                save[u] = save[v] = 1;
            }
        }
    }
}

signed main() {
    int n, d;
    cin >> n >> d;

    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    used.resize(n + 1, 0);
    save.resize(n + 1, 0);

    dfs(1);

    cout << ans.size() << '\n';

    for (auto [a, b] : ans) {
        cout << a << ' ' << b << '\n';
    }
}