#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<vector<int> > cg(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        cg[v].emplace_back(u);
        cg[u].emplace_back(v);
    }
    auto g = cg;
    // vector<vector<int> > g(n);
    // vector<vector<int> > dst(n, vector<int>(n, n + 1));
    // auto dfs = [&](auto &&self, int v, int s, int d) -> void {
    //     dst[s][v] = d;
    //     if (d <= k & v != s && (d & 1)) {
    //         g[v].emplace_back(s);
    //         cout << v << ' ' << s << endl;
    //     }
    //     for (auto &u: cg[v]) {
    //         if (dst[s][u] >= n) {
    //             self(self, u, s, d + 1);
    //         }
    //     }
    // };
    // for (int v = 0; v < n; v++) {
    //     dfs(dfs, v, v, 0);
    // }
    vector<vector<int> > dp(n, vector<int>(2, 0));
    auto kdfs = [&](auto &&self, int v, int par) -> void {
        for (auto &u: g[v]) {
            if (u == par) {
                continue;
            }
            self(self, u, v);
            dp[v][1] += dp[u][1];
            dp[v][0] += dp[u][1];
        }
        int best = dp[v][1];
        for (auto &u: g[v]) {
            if (u == par) {
                continue;
            }
            best = max(best, dp[v][1] - dp[u][1] + dp[u][0] + 1);
        }
        dp[v][1] = max(dp[v][1], best);
    };
    kdfs(kdfs, 0, -1);
    cout << max(dp[0][0], dp[0][1]) << '\n';
    cout << "-1\n";
    return 0;
}
