#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("unroll-loops", "O3")
int n;
vector<vector<int>> g;
vector<int> merged;
vector<int> used;
int curMx;
bool check(int v) {
    if (used[v] == curMx)
        return false;
    used[v] = curMx;
    for (int u: g[v]) {
        if (merged[u] == -1 || check(merged[u])) {
            if (merged[v] != -1)
                merged[merged[v]] = -1;
            merged[v] = u;
            merged[u] = v;
            return true;
        }
    }
    return false;
}

void khun() {
    merged.assign(n, -1);
    used.assign(n, 0);
    curMx = 1;
    for (int i = 0; i < n; i++) {
        check(i);
        curMx++;
    }
    // for (int i: merged)
    //     cout << i << " ";
    // cout << "\n";

    vector<bool> p(n, true);
    vector<pair<int, int>> res;
    for (int i = 0; i < n; i++) {
        if (merged[i] != -1 && p[i] && p[merged[i]]) {
            res.push_back({i + 1, merged[i] + 1});
            p[i] = p[merged[i]] = false;
        }
    }
    cout << res.size() << "\n";
    cout << -1;
}

vector<vector<int>> fg;
int d;
void bfs(int v) {
    vector<bool> p(n, false);
    p[v] = true;
    queue<pair<int, int>> q;
    q.push({v, 0});
    while (!q.empty()) {
        auto [u, x] = q.front();
        q.pop();
        if (x > d)
            continue;
        if (x % 2 == 1)
            g[v].push_back(u);
        for (int j: fg[u]) {
            if (!p[j]) {
                p[j] = true;
                q.push({j, x + 1});
            }
        }
    }
}

int32_t main() {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    cin >> n >> d;
    fg.resize(n);
    g.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        fg[u].push_back(v);
        fg[v].push_back(u);
    }

    for (int i = 0; i < n; i++)
        bfs(i);
    // for (int i = 0; i < n; i++) {
    //     for (int j: g[i])
    //         cout << j << " ";
    //     cout << "\n";
    // }

    khun();
}