#include <bits/stdc++.h>

using ll = long long;

using namespace std;

void solve() {
    ll h, w;
    cin >> h >> w;
    vector<string> v(h);
    for (int i = 0; i < h; i++) {
        cin >> v[i];
    }
    vector<vector<ll>> a(h, vector<ll>(w)), b(h, vector<ll>(w));
    for (int i = 0; i < w; i++) {
        if (v[0][i] == '1') {
            a[0][i] = 1;
            b[0][i] = 1;
        }
    }
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (v[i][j] == '1') {
                a[i][j] = a[i - 1][j] + 1;
            }
        }
    }
    ll ans = -1;
    for (int i = 0; i < h; i++) {
        ll maxx = 0;
        vector<ll> c(w);
        for (int j = w - 1; j >= 0; j--) {
            maxx += a[i][j];
            c[j] = a[i][j];
            ll ind = j + 1;
            while (ind < w && c[ind] > a[i][j]) {
                maxx -= c[ind] - a[i][j];
                c[ind] = a[i][j];
                ind++;
            }
            ans = max(ans, maxx);
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 0;

    #ifdef egg
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}