#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

#define int __int128
const int maxn = 6e5 + 12;
const int inf = 1e9 + 1;

ll n, m, x0, d;

int x[maxn];

int t[maxn];

vector<int> a, b, pref_a, pref_b, pref_sq_a, pref_sq_b, near_a, near_b, ans_a, ans_b;

__int128 value(vector<int>& y, vector<int>& near, vector<int>& ans, vector<int>& pref, vector<int>& pref_sq, int r, int j) {
    __int128 res = t[j] * r;
    int l = -1, right = y.size();
    while (right - l > 1) {
        int mid = (l + right) / 2;
        if (near[mid] > r) {
            right = mid;
        } else {
            l = mid;
        }
    }
    if (l != -1) {
        res += ans[l];
        res += (pref_sq.back() - pref_sq[l]) - 2 * d * r * (pref.back() - pref[l]) + d * d * r * r * (y.size() - l - 1);
    } else {
        res += pref_sq.back() - 2 * d * r * pref.back() + d * d * r * r * (y.size());
    }
    return res;
}

__int128 value_comeback(vector<int>& y, vector<int>& near, vector<int>& ans, vector<int>& pref, vector<int> pref_sq, int r, int j) {
    __int128 res = 2 * t[j] * r;
    int l = -1, right = y.size();
    while (right - l > 1) {
        int mid = (l + right) / 2;
        if (near[mid] > r) {
            right = mid;
        } else {
            l = mid;
        }
    }
    if (l != -1) {
        res += ans[l];
        res += (pref_sq.back() - pref_sq[l]) - 2 * d * r * (pref.back() - pref[l]) + d * d * r * r * (y.size() - l - 1);
    } else {
        res += pref_sq.back() - 2 * d * r * pref.back() + d * d * r * r * (y.size());
    }
    return res;
}

__int128 solve(vector<int>& y, vector<int>& near, vector<int>& ans, vector<int>& pref, vector<int> pref_sq, int j) {
    if (y.empty()) {
        return 0;
    }
    int l = 0, r = inf;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (value(y, near, ans, pref, pref_sq, mid, j) <= value(y, near, ans, pref, pref_sq, mid - 1, j)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cout << l << " " << (ll) value(l, j) << "\n";
    return value(y, near, ans, pref, pref_sq, l, j);
}

__int128 solve_comeback(vector<int>& y, vector<int>& near, vector<int>& ans, vector<int>& pref, vector<int> pref_sq, int j) {
    if (y.empty()) {
        return 0;
    }
    int l = 0, r = y.back() / d + 10;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (value_comeback(y, near, ans, pref, pref_sq, mid, j) <= value_comeback(y, near, ans, pref, pref_sq, mid - 1, j)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cout << l << " " << (ll) value(l, j) << "\n";
    return value_comeback(y, near, ans, pref, pref_sq, l, j);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i < n + 1; i++) {
        ll k; cin >> k;
        x[i] = k;
    }
    cin >> x0 >> d;
    cin >> m;
    for (int i = 1; i < m + 1; i++) {
        ll p; cin >> p;
        t[i] = p;
    }
    sort(x + 1, x + n + 1);
    a.resize(0);
    for (int i = 1; i < n + 1; i++) {
        if (x[i] > x0) {
            a.push_back(x[i] - x0);
        }
    }
    b.resize(0);
    for (int i = 1; i < n + 1; i++) {
        if (x[i] < x0) {
            b.push_back(x0 - x[i]);
        }
    }
    if (!a.empty()) {
        pref_a.resize(a.size());
        pref_sq_a.resize(a.size());
        near_a.resize(a.size());
        ans_a.resize(a.size());
        pref_a[0] = a[0];
        for (int i = 1; i < a.size(); i++) {
            pref_a[i] = pref_a[i - 1] + a[i];
        }
        pref_sq_a[0] = a[0] * a[0];
        for (int i = 1; i < a.size(); i++) {
            pref_sq_a[i] = pref_sq_a[i - 1] + a[i] * a[i];
        }
        for (int i = 0; i < a.size(); i++) {
            int l = 0, r = inf;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (mid * d < a[i]) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (a[i] - l * d <= r * d - a[i]) {
                near_a[i] = l;
            } else {
                near_a[i] = r;
            }
        }
        ans_a[0] = (a[0] - near_a[0] * d) * (a[0] - near_a[0] * d);
        for (int i = 1; i < a.size(); i++) {
            ans_a[i] = ans_a[i - 1] + (a[i] - near_a[i] * d) * (a[i] - near_a[i] * d);
        }
    }
    if (!b.empty()) {
        pref_b.resize(b.size());
        pref_sq_b.resize(b.size());
        near_b.resize(b.size());
        ans_b.resize(b.size());
        pref_b[0] = b[0];
        for (int i = 1; i < b.size(); i++) {
            pref_b[i] = pref_b[i - 1] + b[i];
        }
        pref_sq_b[0] = b[0] * b[0];
        for (int i = 1; i < b.size(); i++) {
            pref_sq_b[i] = pref_sq_b[i - 1] + b[i] * b[i];
        }
        for (int i = 0; i < b.size(); i++) {
            int l = 0, r = inf;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (mid * d < b[i]) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (b[i] - l * d <= r * d - b[i]) {
                near_b[i] = l;
            } else {
                near_b[i] = r;
            }
        }
        ans_b[0] = (b[0] - near_b[0] * d) * (b[0] - near_b[0] * d);
        for (int i = 1; i < b.size(); i++) {
            ans_b[i] = ans_b[i - 1] + (b[i] - near_b[i] * d) * (b[i] - near_b[i] * d);
        }
    }
    for (int j = 1; j < m + 1; j++) {
        int res = min(solve(a, near_a, ans_a, pref_a, pref_sq_a, j) + solve_comeback(b, near_b, ans_b, pref_b, pref_sq_b, j), solve(b, near_b, ans_b, pref_b, pref_sq_b, j) + solve_comeback(a, near_a, ans_a, pref_a, pref_sq_a, j));
        cout << (ll) res << "\n";
    }
}
