#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

#define int __int128
const int maxn = 6e5 + 12;
const int inf = 1e9 + 1;

ll n, m, x0, d;

int x[maxn];

int t[maxn];

vector<int> a, b;

__int128 value(vector<int>& y, int r, int j) {
    __int128 res = t[j] * r;
    for (int x : y) {
        //cout << x << " " << d * r << "\n";
        if (x >= d * r) {
            res += (__int128) (x - d * r) * (x - d * r);
        } else {
            int ls = (x / d) * d;
            int mr = (x / d + 1) * d;
            //cout << ls << " " << rs << "\n";
            __int128 lc_res = (__int128) (x - ls) * (x - ls);
            if (mr <= d * r) {
                lc_res = min(lc_res, (__int128) (mr - x) * (mr - x));
            }
            res += lc_res;
        }
    }
    //cout << r << " " << j << " : \t" << (ll) res << "\n";
    return res;
}

__int128 value_comeback(vector<int>& y, int r, int j) {
    __int128 res = 2 * t[j] * r;
    for (int x : y) {
        //cout << x << " " << d * r << "\n";
        if (x >= d * r) {
            res += (__int128) (x - d * r) * (x - d * r);
        } else {
            int ls = (x / d) * d;
            int mr = (x / d + 1) * d;
            //cout << ls << " " << rs << "\n";
            __int128 lc_res = (__int128) (x - ls) * (x - ls);
            if (mr <= d * r) {
                lc_res = min(lc_res, (__int128) (mr - x) * (mr - x));
            }
            res += lc_res;
        }
    }
    //cout << r << " " << j << " : \t" << (ll) res << "\n";
    return res;
}

__int128 solve(vector<int>& y, int j) {
    if (y.empty()) {
        return 0;
    }
    int l = 0, r = inf;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (value(y, mid, j) <= value(y, mid - 1, j)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cout << l << " " << (ll) value(l, j) << "\n";
    return value(y, l, j);
}

__int128 solve_comeback(vector<int>& y, int j) {
    if (y.empty()) {
        return 0;
    }
    int l = 0, r = y.back() / d + 10;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (value_comeback(y, mid, j) <= value_comeback(y, mid - 1, j)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    //cout << l << " " << (ll) value(l, j) << "\n";
    return value_comeback(y, l, j);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i < n + 1; i++) {
        ll k; cin >> k;
        x[i] = k;
    }
    cin >> x0 >> d;
    cin >> m;
    for (int i = 1; i < m + 1; i++) {
        ll p; cin >> p;
        t[i] = p;
    }
    sort(x + 1, x + n + 1);
    a.resize(0);
    for (int i = 1; i < n + 1; i++) {
        if (x[i] > x0) {
            a.push_back(x[i] - x0);
        }
    }
    b.resize(0);
    for (int i = 1; i < n + 1; i++) {
        if (x[i] < x0) {
            b.push_back(x0 - x[i]);
        }
    }
    for (int j = 1; j < m + 1; j++) {
        int res = min(solve(a, j) + solve_comeback(b, j), solve(b, j) + solve_comeback(a, j));
        cout << (ll) res << "\n";
    }
}
