#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using i128 = __int128;

#define int ll

const ll INF = 1e18;

int get(int x0, int x1, int k, int d, int t) {
    i128 A = (x0 + k * d) - x1;
    A *= A;
    A += t * abs(k);
    if (A > INF) return INF;
    return (ll) A;
}

pair<int, int> solve1(int n, int x0, int x1, int d, int t) {
    int ans = INF;
    if (x1 < x0) {
        x1 = 2 * x0 - x1;
    }
    int opt = (2 * d * (x1 - x0) - t) / (2 * d * d);
    int best = opt;
    for (int k = max(0ll, opt - 100); k <= opt + 100; ++k) {
        auto x = get(x0, x1, k, d, t);
        if (x < ans) {
            ans = x;
            best = k;
        }
    }
    return {ans, best};
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i];
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        auto [ans1, x1] = solve1(n, x0, v[0], d, t);
        auto [ans2, x2] = solve1(n, x1, v[1], d, t);
        auto [ans3, x3] = solve1(n, x0, v[1], d, t);
        auto [ans4, x4] = solve1(n, x3, v[0], d, t);
        cout << min(ans1 + ans2, ans3 + ans4) << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
