#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using i128 = __int128;

const ll INF = 1e18;

#define int ll

vector<vector<int> > g;
vector<int> dist;

void dfs(int v, int p) {
    dist[v] = 1 - dist[p];
    for (auto to: g[v]) {
        if (to == p) continue;
        dfs(to, v);
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.assign(n + 1, {});
    dist.assign(n + 1, 0);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 0);
    vector<int> a, b;
    for (int i = 1; i <= n; ++i) {
        if (dist[i] == 0) a.push_back(i);
        else b.push_back(i);
    }
    cout << min(a.size(), b.size()) << "\n";
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        cout << a[i] << " " << b[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
