#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> cur;
vector<vector<int>> dist;
vector<int> used;
int ans = 0, d;
vector<pair<int, int>> ians;
void rec(int v, int n) {
    if (v == n) {
        if (cur.size() > ans) {
            ians = cur;
            ans = cur.size();
        }
        return;
    }
    if (used[v]) {
        rec(v + 1, n);
        return;
    }
    for (int i = v + 1; i < n; i++) {
        if (!used[i] && dist[v][i] % 2 == 1 && dist[v][i] <= d) {
            used[v] = used[i] = 1;
            cur.emplace_back(v + 1, i + 1);
            rec(v + 1, n);
            cur.pop_back();
            used[v] = used[i] = 0;
        }
    }
    used[v] = 1;
    rec(v + 1, n);
    used[v] = 0;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    g.resize(n);
    cin >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v, u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dist = vector<vector<int>> (n, vector<int> (n, -1));
    for (int i = 0; i < n; i++) {
        for (auto e : g[i]) {
            dist[i][e] = 1;
        }
        dist[i][i] = 0;
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (dist[i][k] != -1 && dist[k][j] != -1 && dist[i][j] == -1) {
                    dist[i][j] = dist[i][k] + dist[k][j];
                }
            }
        }
    }
    used.resize(n);
    rec(0, n);
    cout << ans << '\n';
    for (auto [x, y] : ians) {
        cout << x << ' ' << y << '\n';
    }
    return 0;
}