#include <iostream>
#include <vector>

using namespace std;

constexpr int maxn = 5e5 + 10;
int n, k;

struct Seg {
    int l, m, r;
};

Seg segs[maxn];

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        auto &[l,m,r] = segs[i];
        cin >> l >> m >> r;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (std::max(segs[i].l, segs[j].l) <= std::min(segs[i].m, segs[j].m) &&
                std::max(segs[i].m, segs[j].m) <= std::min(segs[i].r, segs[j].r)) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    cin >> t;
    while (t--) solve();
    return 0;
}
