// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef ll dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

typedef tree<pdd, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve() {
    dgt n;
    cin >> n;
    vector<dgt> x(n);
    for (dgt i = 0; i < n; ++i)
        cin >> x[i];
    dgt x0, d;
    cin >> x0 >> d;
    dgt m;
    cin >> m;
    for (; m > 0; --m) {
        dgt t;
        cin >> t;
        dgt ans = 0;
        {
            i128 xi = abs(x[0] - x0);
            i128 k1 = (2 * d * xi - t) / (2 * d * d);
            k1 = max(k1, i128(0));
            i128 k2 = k1 + 1;
            i128 a1 = k1 * d, a2 = k2 * d;
            ans += min(k1 * t + (xi - a1) * (xi - a1), k2 * t + (xi - a2) * (xi - a2));
        }
        ans = min(ans, (x[0] - x0) * (x[0] - x0));
        cout << ans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " =======================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===========================\n";
#endif
    }

    return 0;
}