#include <bits/stdc++.h>

using ll = long long;
using namespace std;
#define int long long
using bint = __int128;
class tree {
    int n;
    int m;
    vector <vector <int>> gr, gr1;
    vector <int> v1, v2, last, in;
    vector <int> is;
    void dfs(int num, int last, int d) {
        if (d & 1) {
            v1.push_back(num);
        }
        for (int next : gr[num]) {
            if (next != last) {
                dfs(next, num, d + 1);
            }
        }
    }
    void dfs1(int num, int last, int d, int start) {
        if (d & 1) {
            gr1[start].push_back(num);
        }
        for (int next : gr[num]) {
            if (next != last && d + 1 <= m) {
                dfs1(next, num, d + 1, start);
            }
        }
    }
    bool dfs2(int num) {
        is[num] = 1;
        bool flag = false;
        for (int next : gr[num]) {
            if (!is[next]) {
                is[next] = 1;
                if (last[next] == - 1) {
                    in[num] = 1;
                    last[next] = num;
                    return true;
                } else {
                    flag |= dfs2(last[next]);
                    if (flag) {
                        in[num] = 1;
                        last[next] = num;
                        return true;
                    }
                }
            }
        }
        return false;
    }
public:
    void init() {
        cin >> n;
        gr.resize(n);
        gr1.resize(n);
        is.resize(n, 0);
        last.resize(n, - 1);
        in.resize(n, 0);
        cin >> m;
        for (int i = 0; i < n - 1; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            gr[a].push_back(b);
            gr[b].push_back(a);
        }
    }
    void get_ans() {
        dfs(0, - 1, 0);
        for (int i = 0; i < n; ++i) {
            dfs1(i, - 1, 0, i);
        }
        swap(gr1, gr);
//        for (int i = 0; i < n; ++i) {
//            for (int next : gr[i]) {
//                cout << next << ' ';
//            }
//            cout << endl;
//        }
        while (true) {
            bool flag = false;
            fill(is.begin(), is.end(), 0);
            for (int num : v1) {
                if (!is[num] && !in[num]) {
                    flag |= dfs2(num);
                }
            }
            if (!flag) {
                break;
            }
        }
        vector <pair <int, int>> ans{};
        for (int i = 0; i < n; ++i) {
            if (last[i] != - 1) {
                ans.push_back({i, last[i]});
            }
        }
        cout << ans.size() << '\n';
        for (auto [a, b] : ans) {
            cout << a + 1 << " " << b + 1 << '\n';
        }
    }
};
void solve() {
    tree now;
    now.init();
    now.get_ans();
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
