#include <bits/stdc++.h>

using namespace std;
#define int long long

void print(__int128_t r) {
    if (r == 0) {
        cout << 0;
        return;
    }
    vector<int> d;
    while (r > 0) {
        d.emplace_back(r % 10);
        r /= 10;
    }
    reverse(d.begin(), d.end());
    for (int i: d)
        cout << i;
}

void read(__int128_t &x) {
    long long _x;
    cin >> _x;
    x = _x;
}

__int128_t solve(__int128_t t, __int128_t x, __int128_t st, __int128_t d, __int128_t coef) {
    __int128_t a = d * d, b = (coef * t - 2 * d * (x - st)), c = (x - st) * (x - st);
    __int128_t r = (-b) / (2 * a), res = -1;
    if (r < 0) r = 0;
    for (int nx = r - 5; nx <= r + 5; nx++) {
        if (nx < 0) continue;
        __int128_t cur_ans = nx * nx * a + nx * b + c;
        if (res == -1 || cur_ans < res)
            res = cur_ans;
    }
    b -= 2 * t;
    r = (-b) / (2 * a);
    if (r > 0) r = 0;
    for (int nx = r - 5; nx <= r + 5; nx++) {
        if (nx > 0) continue;
        __int128_t cur_ans = nx * nx * a + nx * b + c;
        if (res == -1 || cur_ans < res)
            res = cur_ans;
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    __int128_t x1, x2;
    read(x1), read(x2);
    __int128_t st, d;
    read(st), read(d);
    int m;
    __int128_t t;
    cin >> m;
    for (int i = 0; i < m; i++) {
        read(t);
        __int128_t res = -1;
        __int128_t c1 = solve(2 * t, x2, st, d, 1), c2 = solve(t, x2, st, d, 1);
        __int128_t d1 = solve(2 * t, 2 * st - x1, st, d, 1), d2 = solve(t, 2 * st - x1, st, d, 1);
        res = c1 + d2;
        if (res == -1 || c2 + d1 < res)
            res = c2 + d1;
        print(res);
        cout << "\n";
    }
    return 0;
}
