#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 210;

vector<int> g[N], t[N];

int n, d;

int cur;

void dfs(int v, int dist, int p) {
    if (dist > d) return;
    for (auto u: t[v]) {
        if (u != p)
            dfs(u, dist + 1, v);
    }
    if (dist % 2 == 1)
        g[cur].emplace_back(v);
}

bool used[N];
int mt[N], col[N];

void calc(int v) {
    used[v] = true;
    for (auto u: g[v]) {
        if (!used[u]) {
            col[u] = 1 - col[v];
            calc(u);
        }
    }
}

bool gfs(int v) {
    used[v] = true;
    for (auto u: g[v]) {
        if (mt[u] == -1 || (!used[mt[u]] && gfs(mt[u]))) {
            mt[u] = v;
            return true;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        t[u - 1].emplace_back(v - 1);
        t[v - 1].emplace_back(u - 1);
    }
    for (int i = 0; i < n; i++) {
        cur = i;
        dfs(i, 0, -1);
        mt[i] = -1;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            calc(i);
    }
    for (int i = 0; i < n; i++) {
        fill(used, used + n, false);
        if (col[i] == 1) continue;
        gfs(i);
    }
    int res = 0;
    for (int i = 0; i < n; i++)
        if (mt[i] != -1)
            res++;
    cout << res << "\n";
    cout << -1;
    return 0;
}
