#include<bits/stdc++.h>
using namespace std;

int n, d, timer = 0;
vector<int> h, p, used, in_m;
vector<vector<int>> g, g2;
vector<array<int, 2>> ans;

void dfsh(int v, int pr = -1) {
    for (auto u: g[v]) {
        if (u == pr) continue;
        h[u] = h[v] + 1;
        dfsh(u, v);
    }
}

void dfs(int st, int v, int pr, int dx) {
    if (dx&1) {
        g2[st].push_back(v);
    }
    if (dx == d) return;
    for (auto u: g[v]) {
        if (u == pr) continue;
        dfs(st, u, v, dx + 1);
    }
}

bool kuhn(int a) {
    used[a] = timer;
    for (auto b: g2[a]) {
        if (p[b] == -1 || (used[p[b]] != timer && kuhn(p[b]))) {
            p[b] = a;
            in_m[a] = 1;
            return 1;
        }
    }
    return 0;
}

void solve() {
    cin >> n >> d;
    h.assign(n + 1, 0);
    g.assign(n + 1, {});
    g2.assign(n + 1, {});
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfsh(1, -1);
    for (int v = 1; v <= n; v++) {
        if (h[v]&1) {
            dfs(v, v, -1, 0);
        }
    }
    bool flag = 1;
    used.assign(n + 1, 0);
    p.assign(n + 1, -1);
    in_m.assign(n + 1, 0);
    while (flag) {
        flag = 0;
        timer++;
        for (int v = 1; v <= n; v++) {
            if (h[v] % 2 == 0) continue;
            if (in_m[v]) continue;
            if (used[v] != timer && kuhn(v)) flag = 1;
        }
    }
    for (int v = 1; v <= n; v++) {
        if (h[v] % 2 == 0 && p[v] != -1) {
            ans.push_back({v, p[v]});
        }
    }
    cout << ans.size() << '\n';
    for (auto [v, u]: ans) cout << v << ' ' << u << '\n';
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
