#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

// #define int ll;

using vi = vector<int>;
using pii = pair<int, int>;
using vv = vector<vi>;

vi fen;
int n, k;

int f(int x) {
    return x & -x;
}

void upd(int i, int p) {
    for (; i <= n; i += f(i)) {
        fen[i] = max(fen[i], p);
    }
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= f(i)) {
        res = max(res, fen[i]);
    }
    return res;
}

void solve() {
    cin >> n >> k;

    vector<array<int, 3> > p(k);
    vi cnt(n + 1);
    vi all;

    for (int i = 0; i < k; ++i) {
        int l, r, m;
        cin >> l >> m >> r;
        cnt[m]++;
        p[i] = {m, l, r};
        all.push_back(m);
        all.push_back(l);
        all.push_back(r);
    }
    vector<deque<int> > idx(n + 1);
    sort(all.begin(), all.end());
    int o = 1;
    for (int i: all) {
        idx[i].push_back(o++);
    }
    vi fi, se;
    for (int i = 0; i < k; ++i) {
        int pdd = idx[p[i][1]][0];
        fi.push_back(p[i][1]);
        p[i][1] = pdd;
    }
    for (int i = 0; i < k; ++i) {
        int pdd = idx[p[i][2]].back();
        se.push_back(p[i][2]);

        p[i][2] = pdd;
    }
    for (int i = 0; i < k; ++i) {
        int pdd = idx[p[i][0]][0];
        idx[p[i][0]].pop_front();
        p[i][0] = pdd;
    }
    n = o - 1;
    vi nw(n + 1);
    vi pos(n + 1);
    fen.clear();
    fen.resize(n + 1);
    sort(p.begin(), p.end());
    vi dp(k + 1);
    set<pair<int, int> > lb;
    lb.insert({0, 0});
    for (int i = 0; i < k; ++i) {
        dp[i + 1] = dp[i];
        auto [m,l,r] = p[i];
        auto [p,idx] = *--lb.lower_bound({m, -1});
        if (p >= l - 1) {
            dp[i + 1] = max(dp[i + 1], r);
        }
        int gr = get(l - 1);
        if (gr >= l - 1) {
            dp[i + 1] = max(gr, r);
        }
        upd(m, dp[i + 1]);
        lb.insert({dp[i + 1], -1});
    }
    if (dp[k] == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);

#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    cin >> t_;
    while (t_--) {
        solve();
    }
}
