#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

// #define int ll

using vi = vector<int>;
using pii = pair<int, int>;
using vv = vector<vi>;

vi fen;
int n, k;

int f(int x) {
    return x & -x;
}

void upd(int i, int p) {
    for (; i <= n; i += f(i)) {
        fen[i] = max(fen[i], p);
    }
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= f(i)) {
        res = max(res, fen[i]);
    }
    return res;
}

bool coll(array<int, 3> &a, array<int, 3> &b) {
    return a[0] <= b[1] && b[1] <= a[2];
}

int get(vector<array<int, 3> > p) {
    sort(p.begin(), p.end(), [](array<int, 3> &a, array<int, 3> &b) {
        return tie(a[0], a[1], a[2]) < tie(b[0], b[1], b[2]);
    });
    vi dp(k + 1);
    set<int> lb;
    lb.insert(0);
    int mx = 0;
    for (int i = 0; i < k; ++i) {
        dp[i + 1] = dp[i];
        auto [m,l,r] = p[i];
        int p = *--lb.lower_bound(m);
        if (p >= l - 1) {
            dp[i + 1] = max({dp[i + 1], r, p});
        }
        int gr = get(l - 1);
        if (gr >= l - 1) {
            dp[i + 1] = max({gr, r, dp[i + 1]});
        }
        upd(m, dp[i + 1]);
        lb.insert(dp[i + 1]);
        mx = max(mx, dp[i + 1]);
    }
    return mx;
}

vv g(1e6);
vi dp0(1e6), dp1(1e6);

void dfs(int v, int pr) {
    dp0[v] = 0;
    dp1[v] = 0;
    int mx0 = g[v][0];
    int smn = 0;
    for (int u: g[v]) {
        if (u != pr) {
            dfs(u, v);
            dp0[v] += max(dp1[u], dp0[u]);
            if (dp0[u] > dp0[mx0]) {
                mx0 = u;
            }
            smn += dp0[u];
        }
    }
    dp1[v] = 1 + smn - dp0[mx0];
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, -1);
    cout << max(dp0[0], dp1[0]) << '\n';
    cout << -1 << ' ' << -1;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);

#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    // cin >> t_;
    while (t_--) {
        solve();
    }
}
