#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, a, b;
vector <vector <int>> g;
vector <pair <int, int>> ans;
vector <int> a1, a2;
set <int> b1, b2;
vector <int> rn1, rn2;
bool dist[15][15];
vector <bool> lag;
bool checked[500000];
int d;

void dfs(int v, bool h, int p) {
    //cout << v + 1 << " start" << endl;
    if (h) a1.push_back(v);
    else a2.push_back(v);
    checked[v] = true;
    int cnt = 0;
    for (auto i : g[v]) {
        if (checked[i]) continue;
        dfs(i, !h, v);
        if (lag[i]) ++cnt;
    }
    if (cnt == 0 && lag[v]) {
        if (p != -1 && lag[p]) {
            ans.push_back({v, p});
            lag[p] = false;
            lag[v] = false;
        }
    }
    //cout << v + 1 << " end" << endl;
}
void go(int i, int v, int r) {
    checked[v] = true;
    if (r <= d) dist[i][v] = true;
    for (auto j : g[v]) {
        if (!checked[j]) {
            go(i, j, r + 1);
        }
    }
}
void check() {
    if (int(rn1.size()) > ans.size()) {
        ans.clear();
        for (int i = 0; i < int(rn1.size()); ++i) {
            ans.push_back({rn1[i], rn2[i]});
        }
    }
}
void per() {
    check();
    if (int(b1.size()) == 0 || int(b2.size()) == 0) {
        return;
    }
    vector <int> left1, left2;
    for (auto i : b1) left1.push_back(i);
    for (auto i : b2) left2.push_back(i);
    for (auto i : left1) {
        rn1.push_back(i);
        b1.erase(i);
        for (auto j : left2) {
            if (!dist[i][j]) continue;
            rn2.push_back(j);
            b2.erase(j);
            per();
            rn2.pop_back();
            b2.insert(j);
        }
        b1.insert(i);
        rn1.pop_back();
    }
}

int main() {
    cin >> n;
    g.resize(n);
    cin >> d;
    lag.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
        lag[i] = true;
    }
    lag[0] = true;
    dfs(0, false, -1);
    if (n <= 14) {
        for (int i = 0; i < n; ++i) {
            for (int i = 0; i < n; ++i) checked[i] = false;
            go(i, i, 0);
        }
        for (auto i : a1) b1.insert(i);
        for (auto i : a2) b2.insert(i);
        per();
        cout << int(ans.size()) << endl;
        for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << endl;
        return 0;
    }
    if (d == n - 1) {
        cout << min(int(a1.size()), int(a2.size())) << endl;
        for (int i = 0; i < min(int(a1.size()), int(a2.size())); ++i) {
            cout << a1[i] + 1 << " " << a2[i] + 1 << endl;
        }
    } else {
        cout << int(ans.size()) << endl;
        for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << endl;
    }
}
