#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
vector<vector<ll>>v; ll n, k;
vector<ll>used;
void solve() {
	cin >> n >> k;
	v = vector<vector<ll>>(k); used = vector<ll>(k, 0);
	bool f = 0;
	for (int i = 0; i < k; i++) {
		ll l, x, r; cin >> l >> x >> r;
		l--; x--; r--; f |= (l == 0);
		v[i] = { l, r, x};
	}
	sort(v.begin(), v.end());
	if (!f) {
		cout << "NO\n";
		return;
	}
	vector<ll>dp(k, -1);
	for (int i = 1; i < k; i++) {
		for (int j = 0; j < i; j++) {
			if (dp[j] == -1)continue;
			if (v[i][0] - 1 > dp[j] || v[i][2]<=dp[j])
				dp[i] = max(dp[i], (ll)-1);
			else {
				dp[i] = max(dp[i], v[i][1]);
			}
		}
		if (v[i][0] == 0)dp[i] = max(dp[i], v[i][1]);
	}
	ll mx = 0;
	for (auto x : dp)mx = max(mx, x);
	if (mx == n - 1)cout << "YES\n";
	else cout << "NO\n";
	return;
}
int main()
{
	ll t; cin >> t;
	while (t--) {
		solve();
	}
}
/*1
11 7
1 2 8
3 4 5
6 6 6
7 8 9
1 4 11
2 8 10
3 5 11*/