#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
void solve() {
	ll n, k; cin >> n >> k;
	vector<vector<ll>>v(k);
	for (int i = 0; i < k; i++) {
		ll l, x, r; cin >> l >> x >> r;
		l--; x--;
		v[i] = { l, x, r };
	}
	ll f = -1, s = -1;
	for (int i = 0; i < k; i++) {
		if (v[i][0] == 0 && v[i][1] == n) {
			cout << "YES\n";
			return;
		}
		if (v[i][1] == 0 && (f == -1 || v[f][2] < v[i][2]))f = i;
		if (v[i][1] == n-1 && (s == -1 || v[s][0] > v[i][0]))s = i;
	}
	if (s!=-1 && f!=-1 && v[s][0] - v[f][2] <= 1)cout << "YES\n";
	else cout << "NO\n";
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t; cin >> t;
	while (t--) {
		solve();
	}
}
/*11 10
0111000000
1110000000
1111100000
1111110000
1110000000
1111111110
1111111000
0111111100
0100000000
0111111111
0100000000*/