#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
vector<vector<ll>>v; ll n, k;
vector<ll>used;
ll ans = 0;
vector<ll>h;
vector<vector<ll>>g;
void dfs(ll v, ll p) {
	h[v] = 0;
	if (p != -1)h[v] = h[p] + 1;
	for (auto u : g[v]) {
		if (u == p)continue;
		dfs(u, v);
	}
}
vector<ll>work; vector<pair<ll,ll>>answer;
void rec(ll H) {
	if (H == n) {
		vector<pair<ll, ll>>res;
		for (int i = 0; i < n; i+=2) {
			ll v = work[i], u = work[i + 1];
			ll dist = h[u] - h[v];
			if (dist <= k && dist%2) {
				res.push_back({ u + 1, v + 1 });
			}
		}
		if (res.size() > answer.size())swap(answer, res);
		return;
	}
	for (int i = 0; i < n; i++) {
		if (used[i])continue;
		used[i] = 1; work.push_back(i);
		rec(H + 1);
		used[i] = 0; work.pop_back();
	}
}
void solve() {
	cin >> n >> k;
	g.resize(n); h.assign(n, 0);
	used.assign(n, 0);
	for (int i = 0; i < n - 1; i++) {
		ll a, b; cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dfs(0, -1);
	rec(0);
	cout << answer.size() << endl;
	for (auto x : answer) {
		cout << x.first << " " << x.second << endl;
	}
}
int main()
{
	ll t = 1;
	while (t--) {
		solve();
	}
}