#include <bits/stdc++.h>

using namespace std;

struct node {
    int ans;
    bool is;
    int pl;
};

vector<node> b;

void merge(int v, int ql, int qr) {
    if (b[v].is) {
        b[2 * v].ans = b[v].pl * (qr - ql) / 2;
        b[2 * v + 1].ans = b[v].pl * (qr - ql) / 2;
        b[2 * v].is = 1;
        b[2 * v + 1].is = 1;
        b[2 * v].pl = b[v].pl;
        b[2 * v + 1].pl = b[v].pl;
        b[v].is = 0;
    }
}

void set_on_s(int v, int x, int ql, int qr, int vl, int vr) {
    if (vr <= ql || qr <= vl) {
        return;
    }
    if (vl <= ql && qr <= vr) {
        b[v].ans = x * (qr - ql);
        b[v].pl = x;
        b[v].is = 1;
        return;
    }
    merge(v, ql, qr);
    set_on_s(2 * v, x, ql, (ql + qr) / 2, vl, vr);
    set_on_s(2 * v + 1, x, (ql + qr) / 2, qr, vl, vr);
    b[v].ans = b[2 * v].ans + b[2 * v + 1].ans;
}

int get_sum(int v, int ql, int qr, int vl, int vr) {
    if (qr <= vl || vr <= ql) {
        return 0;
    }
    if (vl <= ql && qr <= vr) {
        return b[v].ans;
    }
    merge(v, ql, qr);
    return get_sum(2 * v, ql, (ql + qr) / 2, vl, vr) + get_sum(2 * v + 1, (ql + qr) / 2, qr, vl, vr);
}

signed main() {
    //cout << 1;
    int h, w;
    cin >> h >> w;
    //cout << 1;
    vector<vector<int>> a(h, vector<int> (w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char x;
            cin >> x;
            if (x == '1') {
                a[i][j] = 1;
            } else {
                a[i][j] = 0;
            }
        }
    }
    vector<vector<int>> cc(w);
    if (h > w) {
        for (int j = w - 1; j >= 0; --j) {
            for (int i = 0; i < h; ++i) {
                cc[w - j - 1].push_back(a[i][j]);
            }
            reverse(cc[w - j - 1].begin(), cc[w - j - 1].end());
        }

        swap(a, cc);
        swap(h, w);
    }
    vector<vector<int>> dp(h, vector<int> (w));
    for (int i = 0; i < h; ++i) {
        dp[i][w - 1] = a[i][w - 1];
    }
    int h1, now = 1;
    while (true) {
        if (now > h) {
            h1 = now;
            break;
        }
        now *= 2;
    }
    //cout << 1;
    for (int i = 0; i < h; ++i) {
        for (int j = w - 2; j >= 0; --j) {
            if (a[i][j] == 0) {
                dp[i][j] = 0;
            } else {
                dp[i][j] = 1 + dp[i][j + 1];
            }
        }
    }
    int ans = 0;
    b.resize(2 * h1);
    for (int j = 0; j < w; ++j) {
        vector<node> c(2 * h1);
        swap(c, b);
        int nw = 0;
        for (int i = 0; i < h; ++i) {
            //cout << ans << ' ';
            if (nw == 0 && dp[i][j] != 0) {
                set_on_s(1, dp[i][j], 0, h1, 0, 1);
                nw++;
                ans = max(ans, dp[i][j]);
                //cout << 1;
            }  else {
                if (dp[i][j] == 0) {
                    vector<node> c(2 * h1);
                    swap(c, b);
                    nw = 0;
                    //cout << 1;
                    continue;
                }
                int l = -1;
                int r = nw;
                while (r - l > 1) {
                    int m = (r + l) / 2;
                    if (get_sum(1, 0, h1, m, m + 1) <= dp[i][j]) {
                        l = m;
                    } else {
                        r = m;
                    }
                }

                int s1 = get_sum(1, 0, h1, 0, l + 1);

                ans = max(ans, s1 + dp[i][j] * (nw - l));
                //cout << nw << ' ' << l << ' ' << i << ' ' << s1 << ' ' << ans << '\n';
                set_on_s(1, dp[i][j], 0, h1, r, nw + 1);
                nw++;
            }
            //cout << ans << 'l6 4
        }
    }
    cout << ans;
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.
