#include <bits/stdc++.h>


using namespace std;


const int inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


string solve() {
    int n, k;
    cin >> n >> k;
    map<int, int> otr;
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        otr[l] = max(otr[l], r);
    }
    vector<pair<int, int>> event;
    for (auto el : otr) {
        int l = el.first;
        int r = el.second;
        event.push_back({l, 0});
        event.push_back({r + 1, 1});
    }
    sort(event.begin(), event.end());
    int opened = 0;
    for (auto el : event) {
        if (el.second == 0) {
            opened++;
        } else {
            opened--;
        }
        if (opened == 0 && el.first <= n) {
            return "NO";
        }
    }
    return "YES";
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        string ans = solve();
        cout << ans << '\n';
    }
    return 0;
}
