#include <bits/stdc++.h>
using namespace std;

void solve() {
    int N, M;
    cin >> N >> M;
    vector<int> l(M), r(M), md(M), add(N + 1);
    for (int i = 0; i < M; i++) {
        cin >> l[i] >> md[i] >> r[i];
        l[i]--;
        r[i]--;
        md[i]--;
        add[l[i]]++;
        add[r[i] + 1]--;
    }
    int C = 0;
    for (int i = 0; i < N; i++) {
        C += add[i];
        if (C == 0) {
            cout << "NO\n";
            return;
        }
    }
    bool ok = true;
    for (int i = 0; i < M; i++) {
        for (int j = i + 1; j < M; j++) {
            int lb = max(l[i], l[j]);
            int rb = min(r[i], r[j]);
            if (lb <= md[i] && md[i] <= rb && lb <= md[j] && md[j] <= rb) {
                ok = false;
            }
        }
    }
    cout << (ok ? "YES\n" : "NO\n");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
