#include <bits/stdc++.h>
using namespace std;

vector<vector<int> > graph;
vector<vector<int> > dp;

void dfs(int v, int prv) {
    int curr = 0;
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        dfs(to, v);
        dp[v][0] += max(dp[to][0], dp[to][1]);
        curr += max(dp[to][0], dp[to][1]);
    }
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        curr -= max(dp[to][0], dp[to][1]);
        curr += dp[to][0];
        dp[v][1] = max(dp[v][1], curr + 1);
        curr += max(dp[to][0], dp[to][1]);
        curr -= dp[to][0];
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    graph.assign(n, {});
    dp.assign(n, vector<int>(2));
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(0, -1);
    cout << max(dp[0][0], dp[0][1]) << "\n-1";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
