#include <bits/stdc++.h>
using namespace std;
using pp = pair<int, int>;

vector<vector<int> > graph;
vector<vector<int> > dp;
vector<int> down;

void dfs(int v, int prv) {
    int curr = 0;
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        dfs(to, v);
        dp[v][0] += max(dp[to][0], dp[to][1]);
        curr += max(dp[to][0], dp[to][1]);
    }
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        curr -= max(dp[to][0], dp[to][1]);
        curr += dp[to][0];
        if (curr + 1 > dp[v][1]) {
            dp[v][1] = curr + 1;
            down[v] = to;
        }
        curr += max(dp[to][0], dp[to][1]);
        curr -= dp[to][0];
    }
}

vector<pp> ans;

void rec(int v, int prv, bool is_skip) {
    if (is_skip) {
        for (int to: graph[v]) {
            if (to == prv) {
                continue;
            }
            if (dp[to][0] >= dp[to][1]) {
                rec(to, v, true);
            } else {
                rec(to, v, false);
            }
        }
    } else {
        for (int to: graph[v]) {
            if (to == prv) {
                continue;
            }
            if (to == down[v]) {
                ans.emplace_back(v, to);
                rec(to, v, true);
            } else {
                if (dp[to][0] >= dp[to][1]) {
                    rec(to, v, true);
                } else {
                    rec(to, v, false);
                }
            }
        }
    }
}

const int inf = 1e9;

void solve() {
    int n, d;
    cin >> n >> d;
    graph.assign(n, {});
    dp.assign(n, vector<int>{0, -inf});
    down.assign(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(0, -1);
    rec(0, -1, dp[0][0] >= dp[0][1]);
    cout << max(dp[0][0], dp[0][1]) << "\n";
    for (auto [a, b]: ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
