#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

//#define int long long
#define all(a) a.begin(), a.end()

vector<vector<int>> g;

vector<int> col;

void coldfs(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            col[u] = 1 - col[v];
            coldfs(u, v);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    col.resize(n, 0);
    coldfs(0, 0);
    vector<int> bl, wh;
    for (int i = 0; i < n; i++) {
        if (col[i] == 0) {
            bl.push_back(i);
        } else {
            wh.push_back(i);
        }
    }
    cout << min(bl.size(), wh.size()) << '\n';
    for (int i = 0; i < min(bl.size(), wh.size()); i++) {
        cout << wh[i] + 1 << ' ' << bl[i] + 1 << '\n';
    }
}