#include <bits/stdc++.h>


using namespace std;

#define int int64_t
#define pb push_back

int const inf = 1e18;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), r(k), m(k);
    vector<vector<pair<int, int> > > w(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        w[m[i]].pb({l[i], r[i]});
    }
    vector<int> dp(n + 1, n + 1);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        for (auto [L, R]: w[i]) {

            for (int j = L - 1; j < i; j++) {
                if (dp[j] != n + 1) {
                    dp[R] = min(dp[R], i);
                }
            }
            for (int j = i; j <= R; j++) {
                if (dp[j] < L) {
                    dp[R] = min(dp[R], i);
                }
            }
        }
    }
    if (dp[n] != n + 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
