#include <bits/stdc++.h>


using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define F first
#define S second


int const inf = 1e18;
int const maxn = 5e5;

int d1, d2, d;
int v;
int t;

int f2(int e) {
    int v2 = v - e * d;
    return e * t + (d2 - v2) * (d2 - v2);
}

unordered_map<int, int> mp;

int f(int e) {
    if (mp[e]) {
        return mp[e];
    }
    v = e * d;

    int l = 0, r = 1e6;
    while (l + 2 < r) {
        int m1 = l + (r - l) / 3, m2 = l + (r - l) / 3 * 2;
        if (f2(m1) < f2(m2)) r = m2;
        else l = m1;
    }
    return mp[e] = min({f2(l), f2(l + 1), f2(l + 2)}) + e * t + (v - d1) * (v - d1);
}

void solve() {
    int n;
    cin >> n;
    int x1, x2;
    cin >> x1 >> x2;
    int x0;
    cin >> x0 >> d;
    d1 = abs(x1 - x0), d2 = abs(x2 - x0);
    if (d1 > d2) {
        swap(d1, d2);
    }
    d2 = -d2;

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        mp.clear();
        cin >> t;
        int l = 0, r = 100;
        while (l + 2 < r) {
            int m1 = l + (r - l) / 3, m2 = l + (r - l) / 3 * 2;
            if (f(m1) < f(m2)) r = m2;
            else l = m1;
        }
        cout << min({f(l), f(l + 1), f(l + 2)}) << '\n';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
