#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<bool>> a(n, vector<bool>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++)
			a[i][j] = s[j] == '1';
	}
	vector<int> nxt(n);
	vector<int> st;
	int ans = 0;
	for (int j = m - 1; j > -1; j--) {
		for (int i = 0; i < n; i++) {
			if (!a[i][j])
				nxt[i] = 0;
			else
				nxt[i]++;
		}
		int res = 0;
		for (int i = 0; i < n; i++) {
			if (!a[i][j]) {
				st.clear();
				res = 0;
				st.push_back(i);
				continue;
			}
			while (!st.empty()) {
				int pri = st.back();
				if (nxt[pri] < nxt[i])
					break;
				int b, cnt;
				if (st.size() == 1)
					b = -1, cnt = 0;
				else {
					b = st[st.size() - 2];
					cnt = nxt[b];
				}
				res -= (pri - b) * (nxt[pri] - nxt[i]);
				st.pop_back();
			}
			res += nxt[i];
			st.push_back(i);
			if (res == 10)
				int mat = 1;
			ans = max(ans, res);
		}
	}
	cout << ans << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}