#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

inline void solve() {
	int n, k;
	cin >> n >> k;
	vector<pii> a(k);
	vector<int> m(k);
	vector<int> pref(n + 1);
	for (int i = 0; i < k; i++) {
		cin >> a[i].first >> a[i].second >> m[i];
		a[i].first--;
		a[i].second--;
		m[i]--;
		pref[a[i].first]++;
		pref[a[i].second]--;
	}
	for (int i = 0; i < n; i++)
		pref[i + 1] += pref[i];
	bool has0 = false;
	for (int i = 0; i < n; i++)
		if (pref[i] == 0)
			has0 = true;
	if (has0) {
		cout << "NO\n";
		return;
	}
	cout << "YES\n";
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
	cin >> tt;
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}