
#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n, k;
    std::cin >> n >> k;
    std::vector<int> l(k), m(k), r(k);
    for (int i = 0; i < k; i++) {
        std::cin >> l[i] >> m[i] >> r[i];
        l[i]--, m[i]--, r[i]--;
    }
    std::vector<int> cnt(k);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) {
                continue;
            }
            if (m[j] >= l[i] && m[j] <= r[i]) {
                cnt[i]++;
            }
        }
    }
    std::vector<bool> got(k, false);
    int next = -1;
    for (int i = 0; i < k; i++) {
        if (cnt[i] == 0) {
            next = i;
            break;
        }
    }

    while (true) {
        if (next == -1) {
            break;
        }
        int v = next;
        next = -1;
        got[v] = true;
        cnt[v] = -1;
        for (int u = 0; u < k; u++) {
            if (cnt[u] == -1) {
                continue;
            }
            if (m[v] >= l[u] && m[v] <= r[u]) {
                cnt[u]--;
                if (cnt[u] == 0) {
                    next = u;
                }
            }
        }
    }
    std::vector<int> sum(n + 1);
    for (int i = 0; i < k; i++) {
        if (got[i]) {
            sum[l[i]]++;
            sum[r[i] + 1]--;
        }
    }
    for (int i = 1; i < n + 1; i++) {
        sum[i] += sum[i - 1];
    }
    bool ok = true;
    for (int i = 0; i < n; i++) {
        if (!sum[i]) {
            ok = false;
            break;
        }
    }
    if (ok) {
        std::cout << "YES\n";
        return;
    }

    std::cout << "NO\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
}