#include <bits/stdc++.h>

using namespace std;

vector<set<int> > G;

int main() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    G.resize(n);
    vector<int> used(n, 0);
    queue<int> q;
    int f, s;
    for (int i = 0; i < n - 1; i++) {
        cin >> f >> s;
        f--;
        s--;
        G[f].insert(s);
        G[s].insert(f);
    }
    for (int i = 0; i < n; i++) {
        if ((int) G[i].size() == 1) {
            q.push(i);
        }
    }
    vector<pair<int, int> > ans;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (!used[v] && (int) G[v].size() == 1) {
            used[v] = 1;
            int u = *G[v].begin();
            G[u].erase(v);
            for (auto w: G[u]) {
                G[w].erase(u);
                if ((int) G[w].size() == 1) {
                    q.push(w);
                }
            }
            ans.push_back({v, u});
        }
    }
    cout << (int) ans.size() << "\n";
    for (auto u: ans) {
        cout << u.first + 1 << " " << u.second + 1 << "\n";
    }
    return 0;
}
