#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

template<typename T>ostream &operator<<(ostream &s,vector<T> v) {
    for(auto j:v) {s<<j<<' ';}
    return s;
}

int main() {
    int n,m;
    cin>>n>>m;
    vector<vector<char>> a(n,vector<char> (m));
    vector<vector<int>> bstc(n,vector<int> (m,0));
    for(auto &i:a) {
        for(auto &j:i) {cin>>j;}
        debug(i)
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(i==0) {bstc[i][j]=a[i][j]-'0';continue;}
            if(a[i][j]=='0') {bstc[i][j]=0;}
            else {bstc[i][j]=bstc[i-1][j]+1;}
        }
        debug(bstc[i])
    }
    vector<pair<int,int>> cols;
    int res;
    int ans=0;
    for(int i=0;i<n;i++) {
        res=0;
        for(int j=m-1;j>=0;j--) {
            int num=1;
            while(!cols.empty() && cols.back().first>bstc[i][j]) {
                num+=cols.back().second;
                res-=cols.back().first*cols.back().second;
                cols.pop_back();
            }
            res+=num*bstc[i][j];
            cols.push_back({bstc[i][j],num});
            if(res>ans) { ans=res;}
        }
    }
    cout<<ans<<'\n';
    return 0;
}
