#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAX_N = 5e5 + 1, INF = 1e18;
array<int, 3> lns[MAX_N];
int tree[MAX_N * 4];
void build(int l_b, int r_b, int val, int m) {
    if (l_b == r_b - 1) {
        tree[m] = val;
        return;
    }
    int m_b = (l_b + r_b) / 2, l_s = 2 * m + 1, r_s = 2 * m + 2;
    build(l_b, m_b, val, l_s);
    build(m_b, r_b, val, r_s);
    tree[m] = min(tree[l_s], tree[r_s]);
}
void update(int l_b, int r_b, int p, int val, int m) {
    if (l_b == r_b - 1) {
        tree[m] = val;
        return;
    }
    int m_b = (l_b + r_b) / 2, l_s = 2 * m + 1, r_s = 2 * m + 2;
    if (p < m_b) {
        update(l_b, m_b, p, val, l_s);
    }
    else {
        update(m_b, r_b, p, val, r_s);
    }
    tree[m] = min(tree[l_s], tree[r_s]);
}
int get(int l_b, int r_b, int l, int r, int m) {
    if (l_b == l && r_b == r) {
        return tree[m];
    }
    int m_b = (l_b + r_b) / 2, l_s = 2 * m + 1, r_s = 2 * m + 2;
    int ans = INF;
    if (l < m_b) {
        ans = min(ans, get(l_b, m_b, l, min(r, m_b), l_s));
    }
    if (r > m_b) {
        ans = min(ans, get(m_b, r_b, max(l, m_b), r, r_s));
    }
    return ans;
}
int dp[MAX_N];
void solve() {
    int n, k;
    cin >> n >> k;
    fill(dp, dp + n + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < k; i++) {
        cin >> lns[i][1] >> lns[i][0] >> lns[i][2];
    }
    sort(lns, lns + k);
    build(0, n + 1, INF, 0);
    update(0, n + 1, 0, 0, 0);
    set<int> st;
    st.insert(0);
    for (int i = 0; i < k; i++) {
        auto fu = st.lower_bound(lns[i][1] - 1);
        if ((get(0, n + 1, lns[i][1] - 1, lns[i][2] + 1, 0) < lns[i][1] || (fu != st.end() && *fu < lns[i][0])) && dp[lns[i][2]] > lns[i][0]) {
            dp[lns[i][2]] = lns[i][0];
            update(0, n + 1, lns[i][2], lns[i][0], 0);
            st.insert(lns[i][2]);
        }
    }
    if (dp[n] != INF) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3

*/