#include <bits/stdc++.h>

using namespace std;

struct cell{
    int l = 0, r = 0, up = 0, down = 0;
};

void solve() {
    int h, w; cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    vector<vector<cell>> t(h, vector<cell> (w));
    for (int i=0; i < h; ++i) {
        for (int j=0; j < w; ++j) {
            char inp; cin >> inp;
            a[i][j] = inp - '0';
        }
    }

    for (int i=1; i < h; ++i) {
        for (int j=0; j < w; ++j) {
            if (a[i-1][j]) {
                t[i][j].up = t[i-1][j].up + 1;
            }
        }
    }

    for (int i=0; i < h; ++i) {
        for (int j=1; j < w; ++j) {
            if (a[i][j-1]) {
                t[i][j].l = t[i][j-1].l + 1;
            }
        }
    }

    for (int i = h - 1 - 1; i >= 0; --i) {
        for (int j=0; j < w; ++j) {
            if (a[i + 1][j]) {
                t[i][j].down = t[i + 1][j].down + 1;
            }
        }
    }

    for (int i=0; i < h; ++i) {
        for (int j = w - 2; j >= 0; --j) {
            if (a[i][j + 1]) {
                t[i][j].r = t[i][j + 1].r + 1;
            }
        }
    }

    int ans = 0;

    for (int j = 0; j < w; ++j) {
        for (int i = h - 1; i >= 0; --i) {
            pair<int, int> start = {i, j};

            int cur = 0;
            int border = w - 1;
            while (true) {
                if (i < h && a[i][j]) {
                    j = min(j + t[i][j].r, border);
                    border = j;
                    cur += j - start.second + 1;
                    ++i;
                    j = start.second;
                } else {
                    ans = max(ans, cur);
                    cur = 0;
                    break;
                }
            }

            i = start.first;
            j = start.second;
        }
    }
    cout << ans << '\n';
    /*
    int ans = 0;
    for (int j=0; j < w; ++j) {
        for (int i=0; i < h; ++i) {
            while (!a[i][j] && i < h;) {
                ++i;
            }

            int start = i;
            while (a[i][j] && i < h) {
                ++i;
            } if (i >= h || !a[i][j]) --i;
            int endo = i;

            int flag = endo;

            while (endo > start) {
                int k = j;
                while (a[endo][k] && k < w) {
                    ++k;
                } if (j >= w || !a[endo][k]) --k;

                if (k == j) {
                    ans = max(ans, endo - start + 1);
                    --endo;
                } else {

                }
            }


        }
    }
    */
}

int main()
{
    solve();
    return 0;
}
