#include <bits/stdc++.h>

using namespace std;

struct cell{
    int l = 0, r = 0, up = 0, down = 0;
};

void solve() {
    int h, w; cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    vector<vector<cell>> t(h, vector<cell> (w));
    for (int i=0; i < h; ++i) {
        for (int j=0; j < w; ++j) {
            char inp; cin >> inp;
            a[i][j] = inp - '0';
        }
    }

    for (int i=1; i < h; ++i) {
        for (int j=0; j < w; ++j) {
            if (a[i-1][j]) {
                t[i][j].up = t[i-1][j].up + 1;
            }
        }
    }

    for (int i=0; i < h; ++i) {
        for (int j=1; j < w; ++j) {
            if (a[i][j-1]) {
                t[i][j].l = t[i][j-1].l + 1;
            }
        }
    }

    for (int i = h - 1 - 1; i >= 0; --i) {
        for (int j=0; j < w; ++j) {
            if (a[i + 1][j]) {
                t[i][j].down = t[i + 1][j].down + 1;
            }
        }
    }

    for (int i=0; i < h; ++i) {
        for (int j = w - 2; j >= 0; --j) {
            if (a[i][j + 1]) {
                t[i][j].r = t[i][j + 1].r + 1;
            }
        }
    }

    int ans = 0;

    for (int i = h-1; i >= 0; --i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j]) {
                pair<int, int> start = {i, j};
                deque<int> jes;
                int cur = 0;
                int border = t[i][j].up;
                for (int k = j; k <= j + t[i][j].r; ++k) {
                    //if (t[i][k].up)
                    border = min(border, t[i][k].up);
                    cur += border + 1;
                }
                ans = max(ans, cur);
                i = start.first;
                j = start.second;

                //cout << cur << ' ' << ' ' << i << ' ' << j << '\n';
            }

            /*
            int cur = 0;
            int border = w - 1;
            while (true) {
                if (i >= 0 && a[i][j]) {
                    j = min(j + t[i][j].r, border);
                    border = j;
                    cur += j - start.second + 1;
                    --i;
                    j = start.second;
                } else {
                    ans = max(ans, cur);
                    cur = 0;
                    break;
                }
            }

            i = start.first;
            j = start.second;
            */
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
