#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
int n, d;
vector <vector <int>> gtree;
vector <int> used, glyb, pred;
void dfsbase(int v) {
	used[v] = 1;
	for (auto elem : gtree[v]) {
		if (!used[elem]) {
			glyb[elem] = glyb[v] + 1;
			pred[elem] = v;
			dfsbase(elem);
		}
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	cin >> n >> d; gtree.resize(n); used.resize(n); glyb.resize(n); pred.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int v, u; cin >> v >> u; v--; u--;
		gtree[v].push_back(u); gtree[u].push_back(v);
	}
	dfsbase(0);
	vector <int> dolya1, dolya2;
	for (int i = 0; i < n; i++) {
		if (glyb[i] % 2 == 0) {
			dolya1.push_back(i);
		} else {
			dolya2.push_back(i);
		}
	}
	if (d == n - 1) {
		int mins = min(dolya1.size(), dolya2.size());
		cout << mins << "\n";
		for (int i = 0; i < mins; i++) {
			cout << dolya1[i] + 1 << " " << dolya2[i] + 1 << "\n";
		}
	}
	return 0;
}
