#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>

#define int long long

using namespace std;

/*__int128 abs(__int128 a) {
    if (a > 0) {
        return a;
    }
    return -a;
}*/

int32_t main() {
    int n, x0, d, m;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    cin >> x0 >> d >> m;
    vector<int> t(m);
    for (int i = 0; i < m; i++) {
        cin >> t[i];
    }

    vector<int> l, r;
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) {
            l.push_back(x0-x[i]);
        } else {
            r.push_back(x[i]-x0);
        }
    }
    sort(l.begin(), l.end());
    sort(r.begin(), r.end());
    vector<long long> costl(l.size()+1), costr(r.size()+1), prefl(l.size()+1), prefr(r.size()+1);
    for (int i = 1; i <= l.size(); i++) {
        int k = abs(x0-l[i-1])%d;
        costl[i] = costl[i-1]+min(1ll*k*k, 1ll*(d-k)*(d-k));
    }
    for (int i = 1; i <= r.size(); i++) {
        int k = abs(x0-r[i-1])%d;
        costr[i] = costr[i-1]+min(1ll*k*k, 1ll*(d-k)*(d-k));
    }
    for (int i = 1; i <= l.size(); i++) {
        prefl[i] = prefl[i-1]+l[i-1];
    }
    for (int i = 1; i <= r.size(); i++) {
        prefr[i] = prefr[i-1]+r[i-1];
    }
    for (int i = 0; i < m; i++) {
        long long ans = 1e18;
        long long ansl1 = 1e18;
        long long ansr1 = 1e18;
        long long ansl2 = 1e18;
        long long ansr2 = 1e18;
        for (int j = 0; j < l.size()+1; j++) {
            long long anst = 0;
            __int128 kd2 = 2*(prefl[l.size()]-prefl[j])*d-t[i];
            long long k = kd2/2/d/d;
            while (abs(2ll*d*d*(k+1)-kd2) <= abs(2ll*d*d*k-kd2)) {
                k++;
            }
            k = max(k, 0ll);
            if ((j != 0 && k*d < l[j-1] && abs(k*d-l[j-1])*abs(k*d-l[j-1]) > costl[j]-costl[j-1]) || (j < l.size() && l[j] < k*d)) {
                continue;
            }
            anst += k*t[i];
            anst += costl[j];
            for (int h = j; h < l.size(); h++) {
                anst += abs(l[h]-k*d)*abs(l[h]-k*d);
            }
            ansl1 = min(ansl1, anst);
        }
        for (int j = 0; j < r.size()+1; j++) {
            long long anst = 0;
            __int128 kd2 = 2*(prefr[r.size()]-prefr[j])*d-t[i];
            long long k = kd2/2/d/d;
            while (abs((__int128)2*d*d*(k+1)-kd2) <= abs((__int128)2ll*d*d*k-kd2)) {
                k++;
            }
            k = max(k, 0ll);
            if (j != 0 && k < r[j-1]/d) {
                continue;
            }
            anst += k*t[i];
            anst += costr[j];
            for (int h = j; h < r.size(); h++) {
                anst += abs(r[h]-k*d)*abs(r[h]-k*d);
            }
            ansr1 = min(ansr1, anst);
        }
        t[i] *= 2;
        for (int j = 0; j < l.size()+1; j++) {
            long long anst = 0;
            __int128 kd2 = 2*(prefl[l.size()]-prefl[j])*d-t[i];
            long long k = kd2/2/d/d;
            while (abs(2ll*d*d*(k+1)-kd2) <= abs(2ll*d*d*k-kd2)) {
                k++;
            }
            k = max(k, 0ll);
            if ((j != 0 && k*d < l[j-1] && abs(k*d-l[j-1])*abs(k*d-l[j-1]) > costl[j]-costl[j-1]) || (j < l.size() && l[j] < k*d)) {
                continue;
            }
            anst += k*t[i];
            anst += costl[j];
            for (int h = j; h < l.size(); h++) {
                anst += abs(l[h]-k*d)*abs(l[h]-k*d);
            }
            ansl2 = min(ansl2, anst);
        }
        for (int j = 0; j < r.size()+1; j++) {
            long long anst = 0;
            __int128 kd2 = 2*(prefr[r.size()]-prefr[j])*d-t[i];
            long long k = kd2/2/d/d;
            while (abs((__int128)2ll*d*d*(k+1)-kd2) <= abs((__int128)2ll*d*d*k-kd2)) {
                k++;
            }
            k = max(k, 0ll);
            if (j != 0 && k < r[j-1]/d) {
                continue;
            }
            anst += k*t[i];
            anst += costr[j];
            for (int h = j; h < r.size(); h++) {
                anst += abs(r[h]-k*d)*abs(r[h]-k*d);
            }
            ansr2 = min(ansr2, anst);
        }
        cout << ansr1 << endl;
    }
    return 0;
}