#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long int;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl = vector <vl>;
using vb = vector <bool>;
using vvb = vector <vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

struct thing {
	ll l, r, x;
};

void solut() {
	ll n, m;

	cin >> n >> m;

	vector <thing> mas(m);

	for (int i = 0; i < m; i++) {
		cin >> mas[i].l >> mas[i].x >> mas[i].r;
		--mas[i].l; --mas[i].x; --mas[i].r;
	}

	sort(mas.begin(), mas.end(), [](thing a, thing b) {
		if (a.l == b.l) return a.r < b.r;
		return a.l < b.l;
		});

	{
		ll r = -1;
		for (int i = 0; i < m; i++) {
			if (mas[i].l > r + 1) {
				cout << "NO\n";
				return;
			}

			r = max(r, mas[i].r);
		}

		if (r != n - 1) {
			cout << "NO\n";
			return;
		}
	}

	ll l = n, r = -1;

	vb dp(m);

	sort(mas.begin(), mas.end(), [](thing a, thing b) {
		return a.x < b.x;
		});

	for (int i = 0; i < m; i++) {
		if (mas[i].l == 0) {
			dp[i] = 1;
		}
		
		for (int j = i - 1; j >= 0 && !dp[i]; j--) {
			if (mas[j].r >= mas[i].x && mas[i].l <= mas[j].x) continue;

			if (dp[j] && mas[i].l <= mas[j].r + 1 && mas[i].r >= mas[j].r) dp[i] = 1;
		}
	}

	for (int i = 0; i < m; i++) {
		if (dp[i] && mas[i].r == n - 1) {
			cout << "YES\n";
			return;
		}
	}

	cout << "NO\n";
}

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	cin >> t;

	while (t--) {
		solut();
	}
}