#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct e {
    ll x, t, i;
};

bool operator<(e& a, e& b) {
    return tie(a.x, a.t, a.i) < tie(b.x, b.t, b.i);
}

vector<vector<ll>> g;
vector<bool> used;
vector<ll> ans;

void dfs(ll v) {
    used[v] = true;
    for (ll i : g[v]) if (!used[i]) dfs(i);
    ans.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        g.resize(k);
        vector<e> v(k * 3);
        vector<e> vv(k);
        for (ll i = 0; i < k; ++i) {
            ll a, b, c;
            cin >> a >> b >> c;
            vv[i] = {a, b, c};
            v[i * 3] = {a, 0, i};
            v[i * 3 + 1] = {b, 1, i};
            v[i * 3 + 2] = {c, 2, i};
        }
        sort(v.begin(), v.end());
        unordered_set<ll> s;
        g.resize(k);
        for (auto& p : v) {
            if (p.t == 0) {
                s.insert(p.i);
            } else if (p.t == 2) {
                s.erase(p.i);
            } else {
                for (ll i : s) g[p.i].push_back(i);
            }
        }
        used.assign(k, false);
        ans.clear();
        for (ll i = 0; i < k; ++i) {
            if (!used[i]) dfs(i);
        }
        reverse(ans.begin(), ans.end());
        vector<bool> a(n);
        for (ll i : ans) {
            if (!a[vv[i].t - 1]) {
                for (ll j = vv[i].x - 1; j <= vv[i].i - 1; ++j) a[j] = true;
            }
        }
        bool f = true;
        for (bool i : a) if (!i) {
            f = false;
            break;
        }
        if (f) cout << "YES\n";
        else cout << "NO\n";
    }
}
