#include <bits/stdc++.h>
using namespace std;

vector<int> ls, ms, rs;

void solve() {
    int n, m;
    cin >> m >> n;
    ls.assign(n, 0);
    ms.assign(n, 0);
    rs.assign(n, 0);
    vector<int> toshuffle(n);
    iota(toshuffle.begin(), toshuffle.end(), 0);
    mt19937 icantbeatit{222222};
    shuffle(toshuffle.begin(), toshuffle.end(), icantbeatit);
    for (int i = 0; i < n; ++i) {
        cin >> ls[toshuffle[i]] >> ms[toshuffle[i]] >> rs[toshuffle[i]];
        ls[toshuffle[i]]--; ms[toshuffle[i]]--;
    }
    // vector<vector<bool>> dp(m + 1, vector<bool>(m + 1));
    vector<bool> okL0(m + 1), okRm(m + 1);
    vector<set<int>> withL(m + 1), withR(m + 1);
    for (int i = 0; i < n; ++i) {
        if (ls[i] == 0) {
            okL0[rs[i]] = true;
            withL[0].insert(rs[i]);
        }
        if (rs[i] == m) {
            okRm[ls[i]] = true;
            withR[m].insert(ls[i]);
        }
    }
    okL0[0] = true;
    okRm[m] = true;
    for (int i = 0; i <= m; ++i) {
        withL[i].insert(i);
        withR[i].insert(i);
    }
    auto elemExists = [&](const set<int> &st, int l, int r) {
        auto it = st.lower_bound(l);
        return it != st.end() && *it <= r;
    };
    int l = 0;
    int r = m;
    for (int i = 0; i < n; ++i) {
        if (l <= ls[i] && rs[i] <= r) {
            if (elemExists(withL[l], ls[i], ms[i]) && elemExists(withR[r], ms[i] + 1, rs[i])) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

int main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        solve();
    }
}