#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((ll)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const ll INF = 1e9 + 7, MAXX = 50;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

ll s, d;

ll cost(ll x, ll k) {
    return (s + k * d - x) * (s + k * d - x);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    
    vector<ll> lst(n);
    for (ll i = 0; i < n; i++) cin >> lst[i];

    cin >> s >> d;

    ll cur = 0;
    for (auto x : lst) {
        ll k = (x - s) / d;
        ll res = cost(x, k);
        res = min(res, cost(x, k - 1));
        res = min(res, cost(x, k + 1));
        cur += res;
    }

    cout << cur << endl;
}
