#include <bits/stdc++.h>
 
#define all(x) x.begin(), x.end()
#define len(x) ((ll)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif
 
using namespace std;
using ll = long long;
using i128 = __int128;
 
const ll INF = 1e9 + 7, MAXX = 50;
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}
 
ll s, d;
 
ll cost(ll x, ll k) {
    return (s + k * d - x) * (s + k * d - x);
}
 
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
 
    ll n; cin >> n;
     
    vector<ll> lst(n);
    for (ll i = 0; i < n; i++) cin >> lst[i];
 
    cin >> s >> d;
 
    ll m; cin >> m;
    while (m--) {
        ll t; cin >> t;
 
        // debug(t);
 
        ll left = -INF, right = 2 * INF;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            if ((i128)t * abs(mid) + cost(lst[0], mid) > (i128)t * abs(mid + 1) + cost(lst[0], mid + 1)) {
                left = mid;
            } else {
                right = mid;
            }
        }
 
        // for (int k = -10; k <= 10; k++) {
        //     cout << k << ": " << t * abs(k) + cost(lst[0], k) << endl;
        // }

        cout << t * abs(right) + cost(lst[0], right) << endl;
    }
}
