#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(),v.end()

struct ev {
    int l, r, m;
};


inline void solve() {
    int n, k;
    cin >> n >> k;
    vector<ev> a;
    for (auto i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        --l, --m, --r;
        a.push_back({l, r, m});
    }
    vector<int> perm(k);
    iota(all(perm), 0);
    do {
        vector<char> used(n);
        for (auto const it: perm) {
            if (used[a[it].m])
                continue;
            for (int i = a[it].l; i <= a[it].r; ++i) {
                used[i] = 1;
            }
        }
        if (*min_element(all(used)) == 1) {
            cout<<"YES\n";
            return;
        }
    } while (next_permutation(all(perm)));
    cout<<"NO\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
