#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(),v.end()

struct ev {
    int l, r, m;
};


inline void solve() {
    int n, k;
    cin >> n >> k;
    vector<ev> a;
    for (auto i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        --l, --m, --r;
        a.push_back({l, r, m});
    }
    sort(all(a), [](auto const &l, auto const &r) {
        return l.r < r.r;
    });
    unordered_set<int> rs;
    int last = 0;
    rs.insert(-1);
    for (auto const &[l, r, m]: a) {
        if (rs.find(l - 1) != rs.end()) {
            last = r;
            rs.insert(r);
        }
    }
    if (last == n-1) {
        cout<<"YES\n";
    } else {
        cout<<"NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
