#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(),v.end()
using pii = pair<int, int>;

struct ev {
    int l, r, m;
};


inline void solve() {
    int n, k;
    cin >> n >> k;
    vector<ev> a;
    for (auto i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        --l, --m, --r;
        a.push_back({l, r, m});
    }
    sort(all(a), [](auto const &l, auto const &r) {
        return l.l > r.l;
    });
    if (a.back().l != 0) {
        cout << "NO\n";
        return;
    }


    vector<pii> s;
    for (auto const elem: a) {
        s.emplace_back(elem.l, -1);
        s.emplace_back(elem.r+1, 1);
    }
    sort(all(s));
    int bal = 0;
    if (s.back().first != n ) {
        cout << "NO\n";
        return;
    }
    for (auto const &[x, t]: s) {
        bal -= t;
        if (bal == 0 && x != n) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
