#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0); 

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef __int128_t lll;

struct SegmentTree {
	int n;
	vector<ll> d;
	
	SegmentTree (int tn) {
		n = 1;
		while (n < tn) n <<= 1;
		d.resize(n * 2 - 1, 0);
	}

	ll query(int v, int lt, int rt, int L, int R) {
		if (L <= lt && rt <= R) return d[v];
		if (R <= lt || rt <= L) return 0;
		int m = (lt + rt) / 2;
		return max(
				query(v * 2 + 1, lt, m, L, R),
				query(v * 2 + 2, m, rt, L, R)
				);
	}
	ll query(int lt, int rt) {
		return query(0, 0, n, lt, rt);
	}
	
	void change(int ind, ll val) {
		ind += n - 1;
		d[ind] = val;
		while (ind) {
			ind = (ind - 1) / 2;
			d[ind] = max(d[ind * 2 + 1], d[ind * 2 + 2]);
		}
	}
};

signed main() {
	FastIO;
	int n, m;
	cin >> n >> m;
	vector<vector<int>> field;
	if (m > n) {
		field.resize(m, vector<int>(n, 0));
		for (int j = n - 1; j >= 0; --j) {
			string s;
			cin >> s;
			for (int i = m - 1; i >= 0; --i) field[i][j] = (s[m - i - 1] = '1');
		}
		swap(n, m);
	} else {
		field.resize(n, vector<int>(m, 0));
		for (int i = 0; i < n; ++i) {
			string s;
			cin >> s;
			for (int j = 0; j < m; ++j) field[i][j] = (s[j] == '1');
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = m - 2; j >= 0; --j) {
			if (!field[i][j]) continue;
			field[i][j] += field[i][j + 1];
		}
	}

	ll mx = 0;
	for (int j = 0; j < m; ++j) {
		ll cur = 0;
		vector<pair<int, int>> st;
		for (int i = 0; i < n; ++i) {
			int tcnt = 0;
			while (!st.empty() && st.back().first >= field[i][j]) {
				tcnt += st.back().second;
				cur -= st.back().first * 1ll * st.back().second;
				st.pop_back();
			}
			++tcnt;
			st.emplace_back(field[i][j], tcnt);
			cur += field[i][j] * 1ll * tcnt;
			mx = max(mx, cur);
		}
	}
	cout << mx;
	return 0;
}

