#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0); 

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef __int128_t lll;

#define int long long

struct Func {
	lll a, b, c;
	lll f(ll x) const {
		return a * ((lll) x * (lll) x) + b * x + c;
	}
};

ll x0, d;

lll fn(ll n, const vector<ll> &inds, const vector<Func> &fs) {
	int i = upper_bound(all(inds), n) - inds.begin() - 1;
	return fs[i].f(x0 + n * d);
}

signed main() {
	FastIO;
	int n;
	cin >> n;
	vector<int> xs(n);
	for (auto &it : xs) cin >> it;
	sort(all(xs));
	
	cin >> x0 >> d;
	
	int m;
	cin >> m;
	vector<int> ts(m);
	for (auto &it : ts) cin >> it;

	Func pcur{0, 0, 0};
	Func ncur{0, 0, 0};
	for (auto &it : xs) {
		if (it > x0) {
			pcur.a++;
			pcur.c += (lll) it * it;
			pcur.b -= (lll) 2 * it;
		} else {
// 			cerr << "added one ot ncur" << endl;
			ncur.a++;
			ncur.c += (lll) it * it;
			ncur.b -= (lll) 2 * -it;
		}
	}

	vector<ll> pinds;
	vector<Func> pfs;

	vector<ll> ninds;
	vector<Func> nfs;

	ninds.emplace_back(0);
	pinds.emplace_back(0);

	pfs.push_back(pcur);
	nfs.push_back(ncur);

	for (auto &it : xs) {
		if (it > x0) {
			ll ind = (it - x0 + d - 1) / d;
			pcur.c -= (lll) it * it;
			pcur.b += (lll) 2 * it;
			pcur.a--;
			pcur.c += min(
					(lll) (x0 + ind * d - it) * (x0 + ind * d - it), 
					(lll) (x0 + (ind - 1) * d - it) * (x0 + (ind - 1) * d - it)
					);
			if (pinds.back() == ind) {
				pfs.back() = pcur;
				continue;
			} 
			pinds.emplace_back(ind);
			pfs.push_back(pcur);
		} else {
			ll ind = (x0 - it + d - 1) / d;
			ncur.c -= (lll) it * it;
			ncur.b += (lll) 2 * -it;
			ncur.a--;
			ncur.c += min(
					(lll) (x0 - ind * d - it) * (x0 - ind * d - it), 
					(lll) (x0 - (ind - 1) * d - it) * (x0 - (ind - 1) * d - it)
					);
			if (ninds.back() == ind) {
				nfs.back() = ncur;
				continue;
			} 
			ninds.emplace_back(ind);
			nfs.push_back(ncur);
		}
	}

// 	cerr << "pinds: ";
// 	for (auto &it : pinds) cerr << it << ' ';
// 	cerr << endl;
// 	cerr << "ninds: ";
// 	for (auto &it : ninds) cerr << it << ' ';
// 	cerr << endl;
// 	cerr << "pfs: " << endl;
// 	for (auto &it : pfs) cerr << (ll) it.a << "x^2 + " << (ll) it.b << "x + " << (ll) it.c << endl;
// 	cerr << "nfs: " << endl;
// 	for (auto &it : nfs) cerr << (ll) it.a << "x^2 + " << (ll) it.b << "x + " << (ll) it.c << endl;
	
	ll mxn = pinds.back() + ninds.back() + min(pinds.back(), ninds.back()) * 2;;

	auto aboba = [&pinds, &pfs, &ninds, &nfs](ll n, ll t){
// 		cerr << "n = " << n << endl;
// 		return fn(n, pinds, pfs) + n * t;
		lll mn = -1;
		for (ll b = 0; b <= n - 2 * b; ++b) {
			ll a = n - b * 2;
// 			cerr << "\ta, b = " << a << ", " << b << endl;
			lll val1 = fn(a, pinds, pfs) + fn(b, ninds, nfs);
			lll val2 = fn(b, pinds, pfs) + fn(a, ninds, nfs);
			if (mn == -1) mn = val1;
			mn = min(mn, val1);
			mn = min(mn, val2);
		}
		return mn + n * t;
	};
	
	for (auto &it : ts) {
// 		cerr << "aboba(" << it << "):";
// 		for (int i = 0; i < mxn; ++i) cerr << (ll) aboba(i, it) << ' ';
// 		cerr << endl;
		ll lt = 0;
		ll rt = mxn;
		while (rt - lt - 1 >= 2) {
			ll m1 = lt + (rt - lt) / 3;
			ll m2 = rt - (rt - lt) / 3;
// 			lll val1 = fn(m1, inds, fs) + (lll) m1 * it;
// 			lll val2 = fn(m2, inds, fs) + (lll) m2 * it;
			lll val1 = aboba(m1, it);
			lll val2 = aboba(m2, it);
			if (val1 < val2) rt = m2;
			else lt = m1;
		}
		if (lt + 1 <= rt && aboba(lt + 1, it) < aboba(lt, it)) lt = lt + 1;
		if (aboba(rt, it) < aboba(lt, it)) lt = rt;
// 		cerr << "lt = " << lt << endl;
		cout << (ll) aboba(lt, it) << '\n';
	}
	return 0;
}

