#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

void solve_case() {
    int n, k; cin >> n >> k;
    vector<int> l(k), m(k), r(k);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<int> p(n);
    iota(all(p), 0);
    do {
        vector<bool> used(n + 1);
        for (int i = 0; i < n; i++) {
            if (used[m[i]]) {
                continue;
            }
            for (int x = l[i]; x <= r[i]; x++) {
                used[x] = true;
            }
        }
        bool ok = true;
        for (int x = 1; x <= n; x++) {
            ok &= used[x];
        }
        if (ok) {
            cout << "YES\n";
        }
    } while (next_permutation(all(p)));
    cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve_case();
    }
}