#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#define int long long

using namespace std;

vector<int> lo, ro;

int check(vector<int> x, int mid, int d, int t, bool f) {
    int s = 0;
    for (int i = 0; i < x.size(); ++i) {
        if (abs(x[i]) > mid * d) {
            s += (abs(x[i]) - mid * d) * (abs(x[i]) - mid * d);
        } else {
            if (!f) {
                s += lo[i + 1] - lo[i];
            } else {
                s += ro[i + 1] - ro[i];
            }
        }

    }
    s += mid * t;
    return s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n;
    cin >> n;
    vector<long long> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    long long x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i) {
        x[i] -= x0;
    }
    x0 = 0;
    int la = 0, ra = 0;
    vector<int> l, r;
    for (int i = 0; i < n; ++i) {
        if (x[i] < 0) {
            la += x[i] * x[i];
            l.push_back(x[i]);
        } else {
            ra += x[i] * x[i];
            r.push_back(x[i]);
        }
    }
    sort(l.rbegin(), l.rend());
    sort(r.begin(), r.end());
    int s = 0;
    lo.resize(l.size() + 1);
    for (int i = 0; i < l.size(); ++i) {
        int rr = -((-l[i]) / d * d);
        int ll = -(((-l[i]) / d + 1) * d);
        lo[i + 1] = lo[i] + min((rr - l[i]) * (rr - l[i]), (ll - l[i]) * (ll - l[i]));
    }
    ro.resize(r.size() + 1);
    for (int i = 0; i < r.size(); ++i) {
        int rr = ((r[i]) / d * d);
        int ll = (((r[i]) / d + 1) * d);
        ro[i + 1] = ro[i] + min((rr - r[i]) * (rr - r[i]), (ll - r[i]) * (ll - r[i]));
    }
    long long m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        long long t;
        cin >> t;
        int s11, s12, s21, s22;
        if (l.size()) {
            int left = -1, right = abs(l.back()) / d + 2;
            while (right - left > 1) {
                int mid = (right + left) / 2;
                if (check(l, mid, d, t, 0) > check(l, mid + 1, d, t, 0)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            s11 = check(l, right, d, t, 0);
            left = -1, right = abs(l.back()) / d + 2;
            while (right - left > 1) {
                int mid = (right + left) / 2;
                if (mid * t + check(l, mid, d, t, 0) > (mid + 1) * t + check(l, mid + 1, d, t, 0)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            s12 = check(l, right, d, t, 0) + right * t;
        } else {
            s11 = 0;
            s12 = 0;
        }
        if (r.size()) {
            int left = -1, right = abs(r.back()) / d + 2;
            while (right - left > 1) {
                int mid = (right + left) / 2;
                if (check(r, mid, d, t, 1) > check(r, mid + 1, d, t, 1)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            s21 = check(r, right, d, t, 1);
            left = -1, right = abs(r.back()) / d + 2;
            while (right - left > 1) {
                int mid = (right + left) / 2;
                if (mid * t + check(r, mid, d, t, 1) > (mid + 1) * t + check(r, mid + 1, d, t, 1)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            s22 = check(r, right, d, t, 1) + right * t;
        } else {
            s21 = 0;
            s22 = 0;
        }
        cout << (long long)min({s12 + s21, s11 + s22, la + s21, ra + s11}) << '\n';
    }
}