#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
#define int long long
int inf = 1e18;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
// int slow(int n, int k, vector<vector<int>> &v) {
//     vector<int> ord;
//     for (int i = 0; i < k; ++i) {
//         ord.push_back(i);
//     }
//     for (int i = 0; i < k; ++i) {
//         if (ord[i] != i) {
//
//         }
//     }
// }

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> v(k);
    for (int i =0 ; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        v[i] = {l, m , r};
    }

    vector<vector<int>> g(k, vector<int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j =0 ; j < k; ++j) {
            if (i == j) {
                continue;
            }
            if (v[j][0] <= v[i][1] && v[i][1] <= v[j][2]) {
                g[i][j] = 1;
            }
        }
    }
    vector<int> good;
    set<int> nogood;
    vector<vector<int>> bad(k);
    for (int i =0 ; i < k; ++i) {
        bool flag = 1;
        for (int j =0; j < k; ++j) {
            if (g[i][j] && g[j][i]) {
                flag = 0;
                bad[i].push_back(j);
            }
        }
        if (flag) {
           good.push_back(i);
        }else {
            nogood.insert(i);
        }
    }
    for (int i = 0; i < k; ++i) {
        if (bad[i].size() == 2) {
            int b = bad[i][0];
            int c = bad[i][1];
            if (!g[b][c] && !g[c][b]) {
                good.push_back(b);
                good.push_back(c);
                nogood.erase(b);
                nogood.erase(c);
            }
        }
    }
    vector<int> b(n+2);
    vector<int> used(n+1);
    for (auto i : good) {
        b[v[i][2]+1]--;
        b[v[i][0]]++;
    }
    used[0] = 0;
    for (int i= 1; i <= n; ++i) {
        used[i] = used[i-1] + b[i];
    }
    used[0] = 1;
    int x =0 ;
    for (int i = 0; i <  k; ++i) {
        if (used[v[i][1]]) {
            nogood.erase(i);
        }
    }
    vector<vector<int>> p;
    for (auto i : nogood) {
        p.push_back({v[i][2], v[i][1], v[i][0]});
    }
    sort(all(p));
    vector<int> dp(n+1);
    dp[0] = 1;
    while (true) {
        while (x < n && used[x]) {
            dp[x] = 1;
            x++;
        }
        if (x == n && used[x]) {
            cout << "YES";
            return;
        }
        pair<int, int> best = {0, 0};
        for (auto i : nogood) {
            if (v[i][2] > best.first && v[i][0] <= x && !used[v[i][1]]) {
                best.first = v[i][2];
                best.second = i;
            }
        }
        if (best.first == 0) {
            cout << "NO";
            return;
        }
        for (int u = x; u <= best.first; ++u) {
            used[u] = 1;
        }
        nogood.erase(best.second);
    }
    cout << "YES";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}