#include <bits/stdc++.h>
using namespace std;
struct node {
    int l,m,r,id;
};
bool comp(node &n1, node &n2) {
    if (n1.l == n2.l) {
        return n1.r > n2.r;
    }
    return n1.l > n2.l;
}
int get(vector<int> &t, int ind, int l, int r, int id) {
    if (t[ind] != 0) return t[ind];
    if (l + 1 == r) {
        return t[ind];
    }
    int mid = (l + r) / 2;
    if (mid > id) {
        return get(t, ind * 2, l, mid, id);
    }else {
        return get(t, ind * 2 + 1, mid, r, id);
    }
}
void upd(vector<int> &t, int ind, int l, int r, int ql, int qr) {
    if (l >= ql and r <= qr) {
        t[ind]++;
        return;
    }
    if (l >= qr or r <= ql) {
        return;
    }
    int mid = (l + r) / 2;
    upd(t, ind * 2, l, mid, ql, qr);
    upd(t, ind * 2 + 1, mid, r, ql, qr);
}
bool check(vector<int> &ids, vector<node> &a, int n) {
    int h = 0;
    while (1 << (++h) <= n);
    vector<int> t(1 << (h + 1));
    for (int i = 0; i < ids.size(); i++) {
        int val = get(t, 1, 0, 1<<h, a[ids[i]].m);
        if (val != 0) continue;
        upd(t, 1, 0, 1<<h, a[ids[i]].l, a[ids[i]].r + 1);
    }
    for (int i = 1; i <= n; i++) {
        int val = get(t, 1, 0, 1<<h, i);
        if (val == 0) return false;
    }
    return true;
}
mt19937 rng(69);
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int q;
    cin >> q;
    while (q--) {
        int n,k;
        cin >> n >> k;
        vector<node>a(k);
        vector<int> add(n + 2);
        for (int i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            add[a[i].l]++;
            add[a[i].r + 1]--;
        }
        sort(a.begin(), a.end(), comp);
        vector<int> ids(k);
        for (int i = 0; i < k; i++) {
            ids[i] = i;
        }
        bool ans = false;
        for (int j = 0; j < 500; j++) {
            if (check(ids, a, n)) {
                ans = true;
                break;
            }
            shuffle(ids.begin(), ids.end(), rng);
        }
        if (ans) {
            cout << "YES\n";
        }else {
            cout << "NO\n";
        }
    }
}
