#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 1e18;

mt19937 rng(52);
vector<int> bfs(vector<vector<int>> &g, int u, int n) {
    vector<int> dst(n, INF);
    dst[u] = 0;
    vector<int> deq = {u};
    for (int i = 0; i < deq.size(); i++) {
        int a = deq[i];
        for (auto v : g[a]) {
            if (dst[v] > dst[a] + 1) {
                dst[v] = dst[a] + 1;
                deq.push_back(v);
            }
        }
    }
    return dst;
}
vector<pair<int, int>> ans;
void rec(int i, int n, int d, vector<bool> &used, vector<pair<int, int>> &myans, vector<vector<int>> &dst) {
    if (1.0 * clock() / CLOCKS_PER_SEC >= 1.9) return;
    if (i == n) {
        if (myans.size() > ans.size()) {
            ans = myans;
        }
        return;
    }
    rec(i + 1, n, d, used, myans, dst);
    if (used[i]) {
        return;
    }
    for (int j = i + 1; j < n; j++) {
        if (dst[i][j] <= d and dst[i][j] % 2 == 1 and !used[j]) {
            used[j] = true;
            used[i] = true;
            myans.push_back({i, j});
            rec(i + 1, n, d, used, myans, dst);
            myans.pop_back();
            used[i] = false;
            used[j] = false;
        }
    }
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u,v;
        cin >> u >> v;
        u--,v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> dst(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        dst[i] = bfs(g, i, n);
    }
    vector<bool> used(n);
    vector<pair<int, int>> my;
    rec(0, n, d, used,my, dst );
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << " " << i.second + 1 << '\n';
    }
}