#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #pragma GCC optimize("unroll-loops")
// #define LOCAL
vector<pair<int, int>> pairs;
vector<int> odd, even;
vector<vector<int>> g;
vector<int> dist;
void dfs2(int v, int p=-1) {
    dist[v] = 1 + (p == -1 ? 0 : dist[p]);
    if (dist[v] % 2 == 1) {
        odd.push_back(v);
    } else {
        even.push_back(v);
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs2(u, v);
    }
}
void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dist.resize(n);
    dfs2(0);
    vector<bool> used(n);
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (dist[i] % 2 == 0) {
            while (!odd.empty() && used[odd.back()]) odd.pop_back();
            if (odd.empty()) continue;
            pairs.emplace_back(i, odd.back());
            used[odd.back()] = true;
            used[i] = true;
            odd.pop_back();
        } else {
            while (!even.empty() && used[even.back()]) even.pop_back();
            if (even.empty()) continue;
            pairs.emplace_back(i, even.back());
            used[even.back()] = true;
            used[i] = true;
            even.pop_back();
        }
    }
    cout << sz(pairs) << '\n';
    for (auto [v, u] : pairs) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}