#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}
void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

int sq(int n) {return n * n;}

void solve() {
    int n; cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    int x0, d; cin >> x0 >> d;
    sort(all(x));
    int ln = max(0ll, divup(x0 - x[0], d)) + 1;
    int rn = max(0ll, divup(x[n - 1] - x0, d)) + 1;
    vector<int> a(ln, 0), b(rn, 0);
    for (int i = 0; i < n && x[i] < x0; i++) {
        a[0] += (x[i] - x0) * (x[i] - x0);
    }
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) continue;
        b[0] += sq(x[i] - x0);
        //cout << i << ' ' << sq(x[i] - x0) << '\n';
    }
    for (int i = 1; i < ln; i++) {
        a[i] = a[i - 1];
        for (int j = 0; j < n && x[j] < x0; j++) {
            if (abs((x0 - i * d) - x[j]) < abs(x0 - (i - 1) * d - x[j])) {
                a[i] -= sq(x0 - (i - 1) * d - x[j]);
                a[i] += sq((x0 - i * d) - x[j]);
            }
        }
    }
    for (int i = 1; i < rn; i++) {
        b[i] = b[i - 1];
        for (int j = 0; j < n; j++) {
            if (x[j] < x0) continue;
            if (abs(x0 + i * d - x[j]) < abs(x0 + (i - 1) * d - x[j])) {
                b[i] -= sq(x0 + (i - 1) * d - x[j]);
                b[i] += sq(x0 + i * d - x[j]);
                //cout  << i << ' ' << j << ":\n";
                //cout << sq(x0 + (i - 1) * d - x[j]) << ' ' << sq(x0 + i * d - x[j]) << '\n';
            }
        }
    }

    //wr(a);
    //wr(b);

    int q; cin >> q;
    while (q--) {
        int t; cin >> t;
        int res = INF;
        for (int i = 0; i < ln; i++) {
            for (int j = 0; j < rn; j++) {
                res = min(res, a[i] + b[j] + min(2 * i + j, i + 2 * j) * t);
            }
        }
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1; //cin >> tt;
    while (tt--) solve();
}