#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}
void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

int n, d;
vector<vector<int>> g;
vector<int> dp0, dp1;


void dfs(int u, int p) {
    for (int v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        dp0[u] += dp1[v];
    }
    dp1[u] = dp0[u];
    for (int v : g[u]) {
        if (v == p) continue;
        dp1[u] = max(dp1[u], dp0[u] - dp1[v] + dp0[v] + 1);
    }
}

void solve() {
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dp0.resize(n, 0);
    dp1.resize(n, 0);
    dfs(0, -1);
    cout << dp1[0] << '\n';
    cout << -1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1; //cin >> tt;
    while (tt--) solve();
}