#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <algorithm>
#pragma GCC target("avx2")

using namespace std;
//#define int long long
mt19937 rnd(42);

int max_node = 1;
vector<int> t(3000000);
vector<int> flag(3000000);
vector<int> flag2(3000000);

void push(int now, int left, int right) {
	int mid = (left + right) / 2;
	if (flag2[now] == 1) {
		flag2[now * 2] = 1;
		flag[now * 2] = 0;
		t[now * 2] = 0;
		flag2[now * 2 + 1] = 1;
		flag[now * 2 + 1] = 0;
		t[now * 2 + 1] = 0;
		flag2[now] = 0;
	}
	flag[now * 2] += flag[now];
	t[now * 2] += flag[now] * (mid - left + 1);
	flag[now * 2 + 1] += flag[now];
	t[now * 2 + 1] += flag[now] * (right - mid);
	flag[now] = 0;
}

int cnt = 0;

void update(int now, int left, int right, int tleft, int tright, int val) {
	if (tleft > tright) return;
	if (tleft == left and tright == right) {
		t[now] += val * (right - left + 1);
		flag[now] += val;
		return;
	}
	int mid = (left + right) / 2;
	push(now, left, right);
	update(now * 2, left, mid, tleft, min(tright, mid), val);
	update(now * 2 + 1, mid + 1, right, max(tleft, mid + 1), tright, val);
	t[now] = t[now * 2] + t[now * 2 + 1];
}

void update2(int now, int left, int right, int tleft, int tright, int val) {
	if (tleft > tright) return;
	if (tleft == left and tright == right) {
		t[now] = 0;
		flag[now] = 0;
		flag2[now] = 1;
		return;
	}
	int mid = (left + right) / 2;
	push(now, left, right);
	update2(now * 2, left, mid, tleft, min(tright, mid), val);
	update2(now * 2 + 1, mid + 1, right, max(tleft, mid + 1), tright, val);
	t[now] = t[now * 2] + t[now * 2 + 1];
}

int sum(int now, int left, int right, int tleft, int tright) {
	if (tleft > tright) return 0;
	if (tleft == left and tright == right) {
		return t[now];
	}
	int mid = (left + right) / 2;
	push(now, left, right);
	return sum(now * 2, left, mid, tleft, min(tright, mid)) +
		sum(now * 2 + 1, mid + 1, right, max(tleft, mid + 1), tright);
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int n, m;
	cin >> n >> m;
	vector<string> l(n);
	for (int i = 0; i < n; i++) {
		//l[i] = string(m, '1');
		cin >> l[i];
	}
	vector<vector<int>> l2(n, vector<int>(m));
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (j != m - 1) l2[i][j] = l2[i][j + 1];
			if (l[i][j] == '1') l2[i][j]++;
			else l2[i][j] = 0;
		}
	}

	for (int j = 0; j < m; j++) {
		t[1] = 0;
		flag[1] = 0;
		flag2[1] = 1;
		if (ans >= (m - j) * n / 2 + 2) continue;
		for (int i = 0; i < n; i++) {
			cnt = 0;
			update2(1, 0, m, l2[i][j] + 1, m, 1);
			//cout << i << " " << j << " " << u << " ehhee\n";
			if (ans < (i + 1) * l2[i][j]) {
				ans = max(ans, sum(1, 0, m, 1, l2[i][j]) + l2[i][j]);
			}
			if (l2[i][j] != 0) update(1, 0, m, 1, l2[i][j], 1);
		}
	}



	cout << ans;

}

/*


6 4
0011
1101
0111
1110
0111
0100


*/