#pragma GCC optimize("Ofast, unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <algorithm>
#pragma GCC target("avx2")

using namespace std;
#define int long long
mt19937 rnd(42);

bool comp(vector<int> a, vector<int> b) {
	if (a[0] != b[0]) return a[0] < b[0];
	return a[2] > b[2];
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		int n, k;
		cin >> n >> k;
		vector<vector<int>> l(k, vector<int>(3));
		vector<int> l2(n + 1);
		for (int i = 0; i < k; i++) {
			cin >> l[i][0] >> l[i][1] >> l[i][2];
			l[i][0]--;
			l[i][1]--;
			l[i][2]--;
			l2[l[i][1] + 1]++;
		}

		bool ans = true;
		for (int i = 0; i < k; i++) {
			if (l2[l[i][2] + 1] - l2[l[i][0]] > 1) ans = false;
		}
		sort(l.begin(), l.end(), comp);
		int right = 0;
		for (int i = 0; i < k; i++) {
			if (l[i][0] <= right) right = max(right, l[i][2] + 1);
			else ans = false;
		}
		if (right != n) ans = false;
		
		if (ans) cout << "YES\n";
		else cout << "NO\n";
	}


}

/*

1
3 2
1 2 2
2 2 3


*/