// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define vc vector
#define all(v) v.begin(), v.end()
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
#define endl "\n"

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

void gen()
{
    ofstream cout("inp.txt");
    random_device rd;
    ll h = uniform_int_distribution<ll>(1, 5)(rd), w = uniform_int_distribution<ll>(1, 5)(rd);
    cout << h << " " << w << endl;

    for (ll i = 0; i < h; ++i)
    {
        for (ll j = 0; j < w; ++j)
        {
            cout << rd() % 2;
        }
        cout << endl;
    }
}

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        // gen();
        solve();
        cout << endl;
    }

    return 0;
}
ll stress()
{
    ifstream cin("inp.txt");

    ll h, w;
    cin >> h >> w;

    vc<vc<ll>> a(h, vc<ll>(w));
    for (ll i = 0; i < h; ++i)
    {
        string inp;
        cin >> inp;
        for (ll j = 0; j < w; ++j)
            a[i][j] = inp[j] - '0';
    }

    vc<vc<ll>> nxt(h, vc<ll>(w, 0));
    for (ll i = 0; i < h; ++i)
        for (ll j = w - 1; j >= 0; --j)
        {
            if (a[i][j])
            {
                nxt[i][j] = 1;
                if (j + 1 < w)
                    nxt[i][j] += nxt[i][j + 1];
            }
        }

    ll ans = 0;

    for (ll i = 0; i < h; ++i)
        for (ll j = 0; j < w; ++j)
        {
            if (!nxt[i][j])
                continue;

            ll cnt = nxt[i][j];
            ll curw = nxt[i][j];

            for (ll _i = i - 1; _i >= 0; --_i)
            {
                if (!nxt[_i][j])
                    break;
                remin(curw, nxt[_i][j]);
                cnt += curw;
            }
            remax(ans, cnt);
        }

    return ans;
}
ll dumb()
{
    // ifstream cin("inp.txt");

    ll h, w;
    cin >> h >> w;

    vc<vc<ll>> a(h, vc<ll>(w));
    for (ll i = 0; i < h; ++i)
    {
        string inp;
        cin >> inp;
        for (ll j = 0; j < w; ++j)
            a[i][j] = inp[j] - '0';
    }

    vc<vc<ll>> nxt(h, vc<ll>(w, 0));
    for (ll i = 0; i < h; ++i)
        for (ll j = w - 1; j >= 0; --j)
        {
            if (a[i][j])
            {
                nxt[i][j] = 1;
                if (j + 1 < w)
                    nxt[i][j] += nxt[i][j + 1];
            }
        }

    vc<vc<ll>> up(h, vc<ll>(w, -1));

    for (ll i = 1; i < h; ++i)
    {
        for (ll j = 0; j < w; ++j)
        {
            if (nxt[i - 1][j] < nxt[i][j])
                up[i][j] = i - 1;
            else
                up[i][j] = up[i - 1][j];
        }
    }

    ll ans = 0;

    for (ll i = 0; i < h; ++i)
        for (ll j = 0; j < w; ++j)
        {
            if (!nxt[i][j])
                continue;

            ll cnt = 0;
            ll _i = i;
            ll curw = 1e18;
            while (_i != -1 && nxt[_i][j] > 0)
            {
                remin(curw, nxt[_i][j]);
                if (curw == 0)
                    break;

                cnt += curw * (_i - up[_i][j]);

                _i = up[_i][j];
            }
            remax(ans, cnt);
        }

    return ans;
}

void solve()
{
    cout << dumb();
    // if (dumb() != stress())
    // {
    //     cout << dumb() << " " << stress() << endl;
    //     exit(0);
    // }
    return;
    ll h, w;
    cin >> h >> w;

    vc<vc<ll>> a(h, vc<ll>(w));
    for (ll i = 0; i < h; ++i)
    {
        string inp;
        cin >> inp;
        for (ll j = 0; j < w; ++j)
            a[i][j] = inp[j] - '0';
    }

    vc<vc<ll>> nxt(h, vc<ll>(w, 0));
    for (ll i = 0; i < h; ++i)
        for (ll j = w - 1; j >= 0; --j)
        {
            if (a[i][j])
            {
                nxt[i][j] = 1;
                if (j + 1 < w)
                    nxt[i][j] += nxt[i][j + 1];
            }
        }

    vc<vc<ll>> dp_(h, vc<ll>(w, 0));

    for (ll j = w - 1; j >= 0; --j)
    {
        if (a[0][j] == 0 || j && a[0][j - 1] == 0)
            continue;

        dp_[0][j] = nxt[0][j];
    }

    for (ll i = 1; i < h; ++i)
        for (ll j = w - 1; j >= 0; --j)
        {
            if (a[i][j] == 0 || j && a[i][j - 1] == 0)
                continue;

            dp_[i][j] = nxt[i][j] + dp_[i - 1][j];
            if (dp_[i - 1][j] != 0 && nxt[i - 1][j] > nxt[i][j])
                dp_[i][j] -= dp_[i - 1][j + nxt[i][j]];
        }

    vc<vc<ll>> dp(h, vc<ll>(w, 0));
    dp[0] = nxt[0];

    ll ans = 0;
    for (ll i = 1; i < h; ++i)
    {
        for (ll j = w - 1; j >= 0; --j)
        {
            dp[i][j] = nxt[i][j] + dp[i - 1][j];

            if (nxt[i - 1][j] > nxt[i][j])
            {
                dp[i][j] -= dp_[i - 1][j + nxt[i][j]];
            }

            remax(ans, dp[i][j]);
        }
    }

    cout << ans;
}

/*

6 4
0011
1101
0111
1110
0111
0100





*/