#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g;

int cnt0 = 0, cnt1 = 0;

void dfs(int v, int p, int col) {
    if (col == 0) {
        ++cnt0;
    } else {
        ++cnt1;
    }
    for (auto u : g[v]) {
        if (p == u) continue;
        dfs(u, v, 1 - col);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1, 0);
    cout << min(cnt0, cnt1);
    cout << "\n" << -1 << "\n";
}
