// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int INF = 1e9 + 69;

struct segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    int max_r = -1;
    int min_l = n;
    vector<segment> a(k);
    vector<int> max_suf(n, -1);
    vector<int> max_pref(n, -1);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        if (a[i].l == 0) {
            max_pref[a[i].m] = max(max_pref[a[i].m], a[i].r);
        } else {
            max_suf[a[i].l] = max(max_suf[a[i].l], a[i].m);
        }
    }
    for (int i = 1; i < n; i++) {
        max_suf[i] = max(max_suf[i], max_suf[i - 1]);
    }
    int cur_pref = -1;
    for (int i = 0; i < n; i++) {
        if (a[i].l == 0) {
            if (a[i].r == n - 1) {
                cout << "YES\n";
                return;
            }
            if (max_suf[a[i].m + 1] > a[i].r) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
