#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18;

void solve() {
    int h, w; cin >> h >> w;
    int a[h][w];
    for (int i = 0; i < h; i++) {
        string s; cin >> s;
        for (int j = 0; j < w; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    vector<int> cur(h);
    int res = 0;
    for (int j = w - 1; j >= 0; j--) {
        for (int i = 0; i < h; i++) {
            if (a[i][j] == 0) {
                cur[i] = 0;
            } else {
                cur[i]++;
            }
        }
        for (int r = h - 1; r >= 0; r--) {
            int temp = 0, mn = inf;
            for (int l = r; l >= 0; l--) {
                mn = min(mn, cur[l]);
                temp += mn;
                res = max(res, temp);
            }
        }
    }
    cout << res;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
