#include <bits/stdc++.h>

using ll = long long;

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> a(k);
    for (int i = 0; i < k; i++) {
        int l, r, m;
        cin >> l >> m >> r;
        a[i] = {l, r, m};
    }
    sort(a.begin(), a.end());

    vector<int> possible(n + 1);
    possible[0] = 1;
    for (auto [l, r, m] : a) {
        if (possible[l - 1]) {
            possible[r] = 1;
        }
    }
    cout << (possible[n] ? "YES" : "NO") << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }


    cout << "\n";
    return 0;
}