#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

using ll = long long;

int foo(int v, vector<vector<int>>& gr, vector<int>& us, vector<int>& p, int T) {
	us[v] = T;
	for (int u : gr[v]) {
		if (p[u] == -1) {
			p[u] = v;
			return 1;
		}
		if (us[p[u]] == T) continue;
		if (foo(p[u], gr, us, p, T)) {
			p[u] = v;
			return 1;
		}
	}
	return 0;
}

vector<int> kun(vector<vector<int>>& gr, int n) {
	vector<int> p(n*2, -1);
	vector<int> gus(n * 2);
	vector<int> us(n * 2);
	int T = 1;
	for (int i = n; i < n * 2; i++) {
		for (int u : gr[i]) {
			if (us[u] != T) {
				gus[u] = 1;
				us[u] = T;
				p[i] = u;
				break;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		T++;
		if (!gus[i]) {
			foo(i, gr, us, p, T);
		}
	}
	return p;
}

void dfs(int v, vector<vector<int>>& gr, vector<int>& us, int C =1) {
	us[v] = C;
	for (int u : gr[v]) if (!us[u]) dfs(u, gr, us, 3-C);
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, d;
	cin >> n >> d;
	vector<vector<int>> gr(n);
	for (int i = 0; i < n - 1; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		gr[A].push_back(B);
		gr[B].push_back(A);
	}
	vector<int> us(n);
	dfs(0, gr, us);
	vector<int> A, B;
	for (int i = 0; i < n; i++) {
		if (us[i] == 1) A.push_back(i);
		else B.push_back(i);
	}
	cout << min(int(A.size()) , int(B.size())) << "\n";
	for (int i = 0; i < min(int(A.size()), int(B.size())); i++) {
		cout << A[i]+1 << ' ' << B[i]+1 << "\n";
	}

}