#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto &i : x) cin >> i;
    int x0, d;
    cin >> x0 >> d;

    vector<int> p(n + 1), p2(n + 1), opt(n);
    auto f = [&](int xi) {
        int k = (xi - x0) / d;
        int pos1 = (k - 1) * d + x0;
        int pos2 = k * d + x0;
        int pos3 = (k + 1) * d + x0;
        return min({(xi - pos1) * (xi - pos1), (xi - pos2) * (xi - pos2), (xi - pos3) * (xi - pos3)});
    };
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        opt[i] = f(x[i]);
        ans += opt[i];
        p[i + 1] = p[i] + x[i];
        p2[i + 1] = p2[i] + x[i] * x[i];
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int l = -1e7, r = 1e7;
        auto check = [&](int k) {
            return (x[0] - (x0 + (__int128)k * d)) * (x[0] - (x0 + (__int128)k * d)) + (__int128)t * k;
        };
        for (int i = 0; i < 70; ++i) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (check(m1) < check(m2)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        __int128 ans = 1e36;
        for (int i = l; i <= r; ++i) {
            ans = min(ans, check(i));
        }
        cout << (int)ans << '\n';
    }
    return 0;
}