#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()
bool cmax(int &a, int b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<vector<int>> dp(n, vector<int>(2));
    vector<int> p(n, -1);
    auto dfs = [&](auto &&self, int v) ->void {
        int sum = 0;
      for (auto u : g[v]) {
          g[u].erase(find(all(g[u]), v));
          self(self, u);
          sum += max(dp[u][0], dp[u][1]);
      }
        dp[v][0] = sum;
        for (auto u : g[v]) {
            if (cmax(dp[v][1], sum - max(dp[u][0], dp[u][1]) + dp[u][0] + 1)) {
                p[v] = u;
            }
        }
    };
    dfs(dfs, 0);
    vector<pair<int, int>> ans;
    auto dfs2 = [&](auto &&self, int v, int type) ->void {
      if (type == 0) {
          for (auto u : g[v]) {
              int nxt;
              if (dp[u][1] > dp[u][0]) {
                  nxt = 1;
              } else {
                  nxt = 0;
              }
              self(self, u, nxt);
          }
      } else {
          ans.emplace_back(v + 1, p[v] + 1);
          self(self, p[v], 0);
          for (auto u : g[v]) {
              if (u == p[v]) continue;
              int nxt;
              if (dp[u][1] > dp[u][0]) {
                  nxt = 1;
              } else {
                  nxt = 0;
              }
              self(self, u, nxt);
          }
      }
    };
    int nxt;
    if (dp[0][0] > dp[0][1]) {
        nxt = 0;
    } else {
        nxt = 1;
    }
    dfs2(dfs2, 0, nxt);
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i << ' ' << j << '\n';
    }
    return 0;
}