#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void solve() {
    int n;
    cin >> n;
    assert(n == 1);
    ll x;
    cin >> x;
    ll x0, d;
    cin >> x0 >> d;
    x -= x0;

    auto calc = [&](ll k, ll x) {
        ll xm = k * d;
        return (x - xm) * (x - xm);
    };

    ll ans = 0;

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        ll t;
        cin >> t;
        ll k = (2 * d * x - t) / (2 * d * d);
        ans += min({calc(k, x[i]), calc(k-1, x[i]), calc(k+1,x[i])});
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}