#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


struct Otr {
    int l, r, m;
};


void solve() {

    int n, k;
    cin >> n >> k;
    vector<Otr> otrs(k);
    for (int i=0; i<k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; r--; m--;
        otrs[i] = {l, r, m};
    }

    vector<int> cnt(n);
    for (int i=0; i<k; i++) {
        cnt[otrs[i].l]++;
        if (otrs[i].r+1<n) cnt[otrs[i].r+1]--;
    }
    for (int i=1; i<n; i++) cnt[i] += cnt[i-1];
    if (*min_element(cnt.begin(), cnt.end())==0) {cout << "NO\n"; return;}

    sort(otrs.begin(), otrs.end(), [](Otr a, Otr b) {
        return a.r < b.r;
    });

    for (int i=0; i<k; i++) {
        for (int j=0; j<i; j++) {
            if (otrs[j].r <= otrs[i].l) {
                if (otrs[j].m >= otrs[i].m) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }
    cout << "YES\n";

}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int tt;
    cin >> tt;
    while (tt--) solve();


    return 0;
}