// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


ll nearest(ll st, ll x, ll d) {
    if (st==x) return x;
    if (st<x) {
        st = ((x-st)/d) * d + st;
        if (abs(x-st) > abs(x-(st+d))) st = st+d;
    }
    else {
        st = - ((st-x)/d) * d + st;
        if (abs(x-st) > abs(x-(st-d))) st = st-d;
    }
    return st;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n;
    cin >> n;
    vector<ll> cords(n);
    for (int i=0; i<n; i++) cin >> cords[i];
    ll st, d;
    cin >> st >> d;

    int q;
    cin >> q;
    while (q--) {
        int t; cin >> t;
        ll ans = 0;
        for (int i=0; i<n; i++) {
            ll a = nearest(st, cords[i], d);
            ans += (cords[i]-a)*(cords[i]-a);
        }
        cout << ans << '\n';
    }


    return 0;
}