#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    ll x0, d; cin >> x0 >> d;
    ll m; cin >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        ll t = a[i];
        ll ans = inf;
        ll l = 0, r = ll(1e6);
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            ll rr = max(0LL, ll(abs(x0 - x[0])) - m1 * d);
            ll ans1 = abs(m1) * d * t + rr * rr;
            rr = max(0LL, ll(abs(x0 - x[0])) - m2 * d);
            ll ans2 = abs(m2) * d * t + rr * rr;
            ans = min(ans, ans1);
            ans = min(ans, ans2);
            if (ans1 > ans2) {
                l = m1;
            } else {
                r = m2;
            }
        }
        for (ll m1 = l; m1 <= r; m1++) {
            ll rr = max(0LL, ll(abs(x0 - x[0])) - m1 * d);
            ll ans1 = abs(m1) * d * t + rr * rr;
            ans = min(ans, ans1);
        }
        cout << ans << "\n";
    }
    return 0;
}
