#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef __int128 ll1;

const ll1 inf = 1e18;

ll x0, d;
ll t = 0;
map<pair<ll, ll>, ll1> mapa;
vector<ll> x1;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    x1.assign(n, 0);
    for (int i = 0; i < n; i++) cin >> x1[i];
    sort(x1.begin(), x1.end());
    cin >> x0 >> d;
    ll m; cin >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        t = a[i];
        ll res = inf;
        for (ll j1 = -100; j1 <= 0; j1++) {
            for (ll j2 = 0; j2 < 100; j2++) {
                ll l = x0 + j1 * d, r = x0 + j2 * d;
                ll ind = l;
                ll ans = min((-j1), j2) * t + (j2 - j1) * t;
                for (int j = 0; j < n; j++) {
                    while (1) {
                        ll next = min(r, ind + d);
                        ll r1 = abs(ind - x1[j]);
                        ll r2 = abs(next - x1[j]);
                        if (r2 < r1) {
                            ind = next;
                        } else {
                            break;
                        }
                    }
                    ans += (ind - x1[j]) * (ind - x1[j]);
                }
                res = min(res, ans);
            }
        }
        cout << res << "\n";
    }
    return 0;
}
