#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef __int128 ll1;

const ll1 inf = 1e30;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    ll x0, d; cin >> x0 >> d;
    ll m; cin >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        ll1 t = a[i];
        ll1 ans = inf;
        ll1 l = 0, r = ll(2 * 1e9);
        while (r - l > 2) {
            ll1 m1 = l + (r - l) / 3;
            ll1 m2 = r - (r - l) / 3;
            ll1 rr = max(ll1(0), ll1(abs(x0 - x[0])) - m1 * d);
            ll1 ans1 = m1 * d * t + rr * rr;
            rr = max(ll1(0), ll1(abs(x0 - x[0])) - m2 * d);
            ll1 ans2 = m2 * d * t + rr * rr;
            ans = min(ans, ans1);
            ans = min(ans, ans2);
            if (ans1 > ans2) {
                l = m1;
            } else {
                r = m2;
            }
        }
        for (ll1 m1 = l; m1 <= r; m1++) {
            ll1 rr = max(ll1(0), ll1(abs(x0 - x[0])) - m1 * d);
            ll1 ans1 = m1 * d * t + rr * rr;
            ans = min(ans, ans1);
        }
        cout << ll(ans) << "\n";
    }
    return 0;
}
