#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef __int128 ll1;

const ll1 inf = 1e30;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    ll x0, d; cin >> x0 >> d;
    ll m; cin >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        ll ans = 0;
        for (int j = 0; j < n; j++) {
            ll rr = abs(x[j] - x0) % d;
            ans += rr;
        }
        cout << ans << "\n";
    }
    return 0;
}