
#include <bits/stdc++.h>
using namespace std;
#define ll long long
struct segtree
{
	int g;
	vector<int> t;
	void upd(int i, int x)
	{
		t[i += g] = x;
		for (i = i >> 1; i > 0; i = i >> 1)
			t[i] = max(t[i << 1], t[i << 1 | 1]);
	}
	int get(int l, int r)
	{
		l += g, r += g;
		int ans = -1;
		while (r > l)
		{
			if (l & 1) ans = max(ans, t[l++]);
			if (r & 1) ans = max(ans, t[--r]);
			l = l >> 1, r = r >> 1;
		}
		return ans;
	}
	segtree(int n)
	{
		g = n;
		t.assign(n * 2, -1);
	}
};
int n, k;
struct seg {int l, m, r;};
vector<seg> v;
bool check()
{
	int rm = -1;
	vector<int> rk(n + 1, -1);
	for (auto [l, m, r] : v)
		rk[l] = max(rk[l], r);
	for (int i = 1; i <= n; i++)
	{
		rm = max(rm, rk[i]);
		if (rm < i) return 0;
	}
	return 1;
}
bool check_seg(seg s, segtree& rg, vector<int>& dpm)
{
	return (rg.get(s.l, s.m) == 1) || (dpm[s.l - 1] >= s.l - 1);
}
bool solve()
{
	cin >> n >> k;
	v.resize(k);
	vector<vector<seg>> ms(n + 1), rs(n + 1);
	for (auto& [l, m, r] : v)
	{
		cin >> l >> m >> r;
		ms[m].push_back({l, m, r});
		rs[r].push_back({l, m, r});
	}
	vector<int> dpm(n + 1), dpr(n + 1);
	segtree rg(n + 1);
	for(int i = 1; i <= n; i++)
	{
		for (auto s : rs[i])
			if (check_seg(s, rg, dpm))
				dpr[i] = 1;
		rg.upd(i, dpr[i]);	
		dpm[i] = dpm[i - 1];
		for (auto s : ms[i])
			if (dpm[i] < s.r && check_seg(s, rg, dpm))
				dpm[i] = s.r;
	}
	return dpr[n];
}
bool solve1()
{

	cin >> n >> k;
	v.resize(k);
	for (auto& [l, m, r] : v)
		cin >> l >> m >> r;
	sort(v.begin(), v.end(), [] (seg a, seg b) {return a.r < b.r;});
	vector<bool> dp(k);
	for (int i = 0; i < k; i++)
	{
		if (v[i].l == 1) 
		{
			dp[i] = 1;
			continue;
		}
		for (int j = 0; j < i; j++)
			if (dp[j] && v[j].r >= v[i].l - 1 && (v[i].m > v[j].r || v[j].m < v[i].l))
			{
				dp[i] = 1;
				break;
			}
	}
	for (int i = 0; i < k; i++)
		if (v[i].r == n && dp[i])
			return 1;
	return 0;
}
int main()
{
	int t;
	cin >> t;
	while (t--)
		cout << (solve1() ? "YES\n" : "NO\n");
}
