#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const int mxN = 5e2 + 10;

int dp[mxN][mxN];
void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int>>> pref(n + 1), suf(n + 1);
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = i; j <= n + 1; ++j) {
            dp[i][j] = 0;
        }
        dp[i + 1][i] = 1;
    }
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        pref[l].push_back({r, m});
        suf[r].push_back({l, m});
    }
    for (int len = 1; len <= n; ++len) {
        for (int l = 1; l + len - 1 <= n; ++l) {
            int r = l + len - 1;
            for (auto & [sr, sm] : pref[l]) {
                if (dp[l][r]) break;
                if (sr <= r) {
                    for (int i = sm + 1; i <= sr + 1; ++i) {
                        if (dp[i][r]) {
                            dp[l][r] = 1;
                            break;
                        }
                    }
                }
            }
            for (auto & [sl, sm] : suf[r]) {
                if (dp[l][r]) break;
                if (l <= sl) {
                    for (int i = sl - 1; i < sm; ++i) {
                        if (dp[l][i]) {
                            dp[l][r] = 1;
                            break;
                        }
                    }
                }
            }
        }
    }
    cout << (dp[1][n] ? "YES\n" : "NO\n");
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}