#include<bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int MAXK = 1e4;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<bool> > e(k, vector<bool>(k));
    vector<vector<int> > a(k, vector<int>(3));
    for (auto &x: a) cin >> x[0] >> x[2] >> x[1];
    vector<vector<int> > g(k);
    sort(all(a));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (a[i][2] >= a[j][0] && a[i][2] <= a[j][1]) {
                g[i].push_back(j);
                e[i][j] = true;
            }
        }
    }
    vector<int> used(k);
    int mx = 1;
    for (int i = 0; i < k; i++) {
        int l = a[i][0], r = a[i][1], m = a[i][2];
        if (mx < l) {
            cout << "NO\n";
            return;
        }
        bool f = 1;
        for (int j = 0; j < k; j++) {
            if (used[j] && e[i][j] && e[j][i]) {
                f = 0;
            }
        }
        if (f) {
            mx = max(mx, r);
            used[i] = 1;
        }
    }
    if (mx == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
