#include<bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

bool f = 1;

void dfs(int v, vector<vector<int> > g, vector<int> used) {
    used[v] = 1;
    for (auto &u: g[v]) {
        if (used[u] == 1) {
            f = 0;
        } else if (!used[u]) {
            dfs(u, g, used);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int> > a(k, vector<int>(3));
    for (auto &x: a) cin >> x[0] >> x[1] >> x[2];
    vector<vector<int> > g(k);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (a[i][1] >= a[j][0] && a[i][1] <= a[j][2]) {
                g[i].push_back(j);
            }
        }
    }
    f = 1;
    vector<int> used(k);
    for (int i = 0; i < k; i++) {
        if (!f) break;
        if (!used[i]) {
            dfs(i, g, used);
        }
    }
    if (f) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
