#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    cin >> a;
    vector<vector<int>> ind(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '0') {
                ind[i].push_back(j);
            }
        }
        ind[i].push_back(m);
    }
    int ans = 0;
    for (int j = 0; j < m; ++j) {
        vector<int> cur;
        for (int i = 0; i < n; ++i) {
            int k = *lower_bound(ind[i].begin(), ind[i].end(), j);
            cur.push_back(k - j);
        }
        vector<int> l(n);
        for (int i = 0; i < n; ++i) {
            l[i] = i - 1;
            while (l[i] >= 0 && cur[l[i]] >= cur[i]) {
                l[i] = l[l[i]];
            }
        }
        vector<int> dp(n);
        for (int i = 0; i < n; ++i) {
            if (l[i] >= 0) {
                dp[i] = dp[l[i]] + (i - l[i]) * cur[i];
            } else {
                dp[i] = (i + 1) * cur[i];
            }
        }
        ans = max(ans, *max_element(dp.begin(), dp.end()));
    }
    cout << ans << "\n";
    return 0;
}