#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<array<int, 3>> seg(k);
        for (auto &[l, m, r] : seg) {
            cin >> l >> m >> r;
            --l, --m, --r;
        }
        sort(seg.begin(), seg.end(), [](const array<int, 3> &p, const array<int, 3> &q) {
            if (p[0] == q[0]) {
                return p[2] > q[2];
            }
            return p[0] < q[0];
        });
        vector<bool> used(n);
        for (int i = 0; i < k; ++i) {
            auto [l, m, r] = seg[i];
            if (!used[m]) {
                for (int j = l; j <= r; ++j) {
                    used[j] = true;
                }
            }
        }
        if (!count(used.begin(), used.end(), false)) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}