#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

#define int long long

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int x0, d;
    cin >> x0 >> d;
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        auto f = [&](int k) {
            int x = x0 + k * d;
            return abs(k) * t + (x - a[0]) * (x - a[0]);
        };
        int l = -1e9, r = 1e9;
        while (r - l > 1) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (f(m1) <= f(m2)) {
                r = m1;
            } else {
                l = m2;
            }
        }
        cout << min(f(l), f(r)) << "\n";
    }
    return 0;
}