#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#define int long long

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, d;
    cin>>n>>d;
    vector<vector<int> > g(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin>>a>>b;
        --a; --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (d == n-1) {
        vector<int> h(n);
        auto dfs = [&](auto self, int v, int p = -1) -> void {
            if (p != -1) h[v] = (h[p] ^ 1);
            for (int u:g[v]) {
                if (u == p) continue;
                self(self, u, v);
            }
        };
        dfs(dfs, 0);
        vector<int> nc, c;
        for (int i = 0; i < n; ++i) {
            if (h[i]) nc.push_back(i);
            else c.push_back(i);
        }
        cout<<min(c.size(), nc.size())<<'\n';
        for (int i = 0; i < min(c.size(), nc.size()); ++i) {
            cout<<c[i]+1<<' '<<nc[i]+1<<'\n';
        }
        return 0;
    }

    vector<int> h(n);
    auto dfs = [&](auto self, int v, int p = -1) -> void {
        if (p != -1) h[v] = (h[p] ^ 1);
        for (int u:g[v]) {
            if (u == p) continue;
            self(self, u, v);
        }
    };
    dfs(dfs, 0);
    vector<int> nc, c;
    for (int i = 0; i < n; ++i) {
        if (h[i]) nc.push_back(i);
        else c.push_back(i);
    }
    vector<int> CC(n);
    for (int i:c) {
        CC[i] = 1;
    }
    vector<vector<int> > gr(n);
    vector<int> dist(n), col(n);
    queue<int> q;
    for (int i:nc) {
        dist.assign(n, 1e18);
        col.assign(n, 0);
        q.push(i);
        col[i] = 1;
        dist[i] = 0;
        while (!q.empty()) {
            int f = q.front(); q.pop();
            if (dist[f] >= d) continue;
            if (CC[f]) {
                gr[i].push_back(f);
            }
            for (int u:g[f]) {
                if (!col[u]) {
                    col[u] = 1;
                    dist[u] = dist[f] + 1;
                    q.push(u);
                }
            }
        }
    }
    vector<int> mt(n, -1), used(n);
    int _T = 0;
    auto kun = [&](auto self, int v) -> bool {
        if (used[v] == _T) return false;
        used[v] = _T;
        for (int u:gr[v]) {
            if (mt[u] == -1 || self(self, mt[u])) {
                mt[u] = v;
                return true;
            }
        }
        return false;
    };
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ++_T;
        ans += kun(kun, i);
    }
    cout<<ans<<endl;
    for (int i = 0; i < n; ++i) {
        if (mt[i] != -1) {
            cout<<i+1<<' '<<mt[i]+1<<endl;
        }
    }
    return 0;
}