#include<bits/stdc++.h>
#define all(v) v.begin(), v.end()

using namespace std;
using i64 = int64_t;
using i128 = __int128_t;
vector<int> l, m, r;
multiset<int> ms, cur;
vector<int> hasm;
vector<bool> used;

bool dfs(int i) {
    if (used[i]) return true;
    int cl = l[i], cr = r[i];
    {
        auto it = cur.lower_bound(cl);
        if (it != cur.end() && *it <= cr) return false;
    }
    ms.erase(m[i]);
    cur.emplace(m[i]);
    while (1) {
        auto it = ms.lower_bound(cl);
        if (it == ms.end()) break;
        if (*it > cr) break;

        int v = hasm[*it];
        ms.erase(it);
        if (!dfs(v)) return false;
    }
    cur.erase(m[i]);
    used[i] = 1;
    return true;
}

void solve() {
    int n, k;
    cin >> n >> k;
    l.assign(k, 0);
    m.assign(k, 0);
    r.assign(k, 0);
    used.assign(k, 0);

    hasm.assign(n, -1);
    ms.clear();
    cur.clear();
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--, m[i]--, r[i]--;
        ms.emplace(m[i]);
        if (hasm[m[i]] != -1) {
            cout << "NO\n";
            return;
        }
        hasm[m[i]] = i;
    }

    for (int i = 0; i < k; ++i) {
        if (!dfs(i)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t= 1;
    cin >> t;
    while (t--) {
        solve();
    }
}