#include<bits/stdc++.h>
#define all(v) v.begin(), v.end()

using namespace std;
using i64 = int64_t;
using i128 = __int128_t;

struct Seg {
    vector<int> t;
    int n;
    Seg(int n): n(n) {
        t.resize(4*n, -1);
    }

    void upd(int i, int l, int r, int ind, int x) {
        if (ind < l || r <= ind) return;
        if (l == ind && ind + 1 == r) {
            t[i] = x;
            return;
        }
        int m = (l + r) / 2;
        upd(2*i+1, l, m, ind, x);
        upd(2*i+2, m, r, ind, x);
        t[i] = max(t[2*i+1], t[2*i+2]);
    }

    int mx(int i, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return -1;
        if (ql <= l && r <= qr) return t[i];
        int m = (l + r) / 2;
        return max(mx(2*i+1, l, m, ql, qr), mx(2*i+2, m, r, ql, qr));
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> l(k), m(k), r(k);
    vector<tuple<int, int, int>> t(k);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--, m[i]--, r[i]--;
        t[i] = {m[i], l[i], r[i]};
    }
    Seg sg(n);
    sort(all(t));
    for (auto [mi, li, ri] : t) {
        if (sg.mx(0, 0, n, li, mi + 1) >= mi) {
            cout << "NO\n";
            return;
        }
        sg.upd(0, 0, n, mi, ri);
    }
    cout << "YES\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t= 1;
    cin >> t;
    while (t--) {
        solve();
    }
}