#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'
#define int long long
using namespace std;
using ll = long long;
int n, m, k;


vector<int> dp[2];
int d;
vector<vector<int>> g;
void dfs(int v, int pr) {
    if (g[v].size() == 1 && g[v][0] == pr) return;
    int mx = -1;
    dp[1][v] = 1;
    for (auto u : g[v]) {
        if (u != pr) {
            dfs(u, v);
            dp[0][v] += max(dp[1][u], dp[0][u]);
            dp[1][v] += max(dp[1][u], dp[0][u]);
            mx = max(mx, dp[0][u] - max(dp[1][u], dp[0][u]));
        }
    }
    dp[1][v] += mx;
}

//#define LOCAL
void solve() {
    cin >> n >> d;
    dp[0].resize(n, 0);
    dp[1].resize(n, 0);
    g.resize(n);
    for (int i= 1; i < n; i++) {
        int a, b; cin >> a >> b; --a; --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, -1);
    cout << max(dp[0][0], dp[1][0]) << "\n-1\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}