#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define int long long
#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vb vector<bool>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define gb(a, b) (((a) >> (b)) & 1)

#define cont(l, m, r) ((l) <= (m) && (m) <= r)

vvi graph;
vi c;
vi nc;
void dfs(int u, int p, int h) {
	if (h & 1) {
		nc.push_back(u);
	}
	else {
		c.push_back(u);
	}
	for (int v : graph[u]) {
		if (v == p) continue;
		dfs(v, u, h + 1);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	int d;
	cin >> d;
	graph.assign(n, vi());
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}
	cout << 0 << endl;
	
}