#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define int long long
#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vb vector<bool>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define gb(a, b) (((a) >> (b)) & 1)

#define cont(l, m, r) ((l) <= (m) && (m) <= r)

vvi graph;
vi par;
vvi dp;
void dfs(int u, int p) {
	for (int v : graph[u]) {
		if (v == p) continue;
		dfs(v, u);
		dp[u][0] += dp[v][1];
	}
	dp[u][1] = dp[u][0];
	for (int v : graph[u]) {
		if (v == p) continue;
		dp[u][1] = max(dp[u][1], dp[u][0] - dp[v][1] + dp[v][0] + 1);
	}
}

int cnt(int mask) {
	int ans = 0;
	while (mask) {
		ans += (mask & 1);
		mask /= 2;
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	int d;
	cin >> d;
	graph.assign(n, vi());
	dp.assign(n, vi(2));
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}
	dfs(0, 0);
	cout << max(dp[0][0], dp[0][1]) << endl;
	cout << -1 << endl;
}