#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3, unroll-loops, inline, fast-math, no-stack-protector")
#pragma GCC terget("avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
#define int long long

const ll INF = 2e9 + 228;

mt19937 rnd(228 + 57 - 179 + 1337);

struct el {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> cnt(n);
    vector<el> w(k);
    for (int i = 0; i < k; ++i) {
        cin >> w[i].l >> w[i].m >> w[i].r;
        --w[i].l;
        --w[i].m;
        ++cnt[w[i].m];
    }
    vector<int> p(n + 1);
    int good = 1;
    for (int i = 0; i < k; ++i) {
        ++p[w[i].l];
        --p[w[i].r];
        for (int j = i + 1; j < k; ++j) {
            if (w[j].l <= w[i].m && w[i].m < w[j].r) {
                if (w[i].l <= w[j].m && w[j].m < w[i].r) {
                    good = 0;
                }
            }
        }
    }
    if (!good) {
        cout << "NO\n";
        return;
    }
    vector<int> ogo(n);
    ogo[0] = p[0];
    if (ogo[0] == 0) good = 0;
    for (int i = 1; i < n; ++i) {
        ogo[i] = ogo[i - 1] + p[i];
        if (ogo[i] == 0) good = 0;
    }
    cout << (good? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
    return 0;
}