#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
struct seg {
    int l, m, r;
};
void solve() noexcept {
    int n, k;
    cin >> n >> k;
    swap(n, k);
    vector<seg> vs(n);
    for (int i = 0; i < vs.size(); ++i) cin >> vs[i].l >> vs[i].m >> vs[i].r, vs[i].l--, vs[i].m--, vs[i].r--;
    {
        auto ccm = vs;
        sort(all(ccm), [](auto a, auto b) {
           return a.l < b.l;
        });
        int cm = 0;
        for (auto [l, m, r] : ccm) {
            if (cm < l) {
                cout << "NO\n";
                return;
            }
            cm = max(r + 1, cm);
        }
        if (cm < k) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (vs[i].l == 0 && vs[i].r == k - 1) {
            cout << "YES\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if (vs[i].l == 0 && vs[j].r == k - 1 && vs[i].r + 1 >= vs[j].l && (vs[i].m < vs[j].l || vs[j].m > vs[i].r)) {
                cout << "YES\n";
                return;
            }
        }
    }
}

auto main() -> signed {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}