#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll MAXN = (1 << 22);
ll INF = 1e9;

void solve() {
	ll n, m, t;
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) cin >> x[i];
	sort(all(x));
	ll x0, d;
	cin >> x0 >> d;
	cin >> m;
	for (ll i = 0; i < m; i++) {
		cin >> t;
		ll ans = 0;
		for (ll i = 0; i < n; i++) {
			ll time = abs(x0 - x[i]) / d;
			if (x0 < x[i]) {
				ll dist1 = abs(x[i] - (x0 + d * time)), dist2 = abs(x[i] - (x0 + d * (time + 1)));
				ans += min(dist1 * dist1, dist2 * dist2);
			}
			else {
				ll dist1 = abs(x[i] - (x0 - d * time)), dist2 = abs(x[i] - (x0 - d * (time + 1)));
				ans += min(dist1 * dist1, dist2 * dist2);
			}
		}
		cout << ans << '\n';
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}