#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;
using ll = long long;

signed main() {
	int h, w;
	cin >> h >> w;
	vector <string> arr(h);
	for (int i = 0; i < h; i++) {
		cin >> arr[i];
	}
	vector <vector <int>> sum(h);
	for (int i = 0; i < h; i++) {
		vector <int> brr(w + 1);
		for (int j = 0; j < w; j++) {
			brr[j + 1] = brr[j] + arr[i][j] - '0';
		}
		sum[i] = brr;
	}
	int ans = 0;
	for (int i = 0; i < w; i++) {
		vector <int> brr(h);
		for (int j = 0; j < h; j++) {
			int l = 0, r = w - i + 1;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (sum[j][i + mid] - sum[j][i] == mid) {
					l = mid;
				}
				else {
					r = mid;
				}
			}
			brr[j] = l;
		}
		stack <pair<int, int>> st;
		vector <int> hl(h);
		for (int j = 0; j < h; j++) {
			while (!st.empty() && st.top().first > brr[j]) {
				st.pop();
			}
			if (st.empty()) {
				hl[j] = -1;
			}
			else {
				hl[j] = st.top().second;
			}
			st.push({ brr[j], j });
		}
		vector <int> dp(h + 1);
		int curr = 0;
		for (int j = 0; j < h; j++) {
			if (brr[j] >= curr) {
				dp[j + 1] = dp[j] + brr[j];
			}
			else {
				dp[j + 1] = dp[hl[j] + 1] + brr[j] * (j - hl[j]);
			}
			curr = brr[j];
			ans = max(ans, dp[j + 1]);
		}
	}
	cout << ans << '\n';
}
