#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;
using ll = long long;

struct Staff {
	int l, m, r;
};

bool comp(Staff a, Staff b) {
	return a.l <= b.m && b.m <= a.r;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector <Staff> arr(k);
	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--;
		arr[i].m--;
		arr[i].r--;
	}
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i == j) {
				continue;
			}
			if (arr[i].l <= arr[j].m && arr[j].m <= arr[i].r) {
				if (arr[j].l <= arr[i].m && arr[i].m <= arr[j].r) {
					cout << "NO\n";
					return;
				}
			}
		}
	}
	//sort(arr.begin(), arr.end(), comp);
	cout << "YES\n";
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
