#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#include <numeric>
#define int long long

using namespace std;
using ll = long long;

const int INF = 2e18;

struct Staff {
	int l, m, r;
};

void solve() {
	int n, k;
	cin >> n >> k;
	vector <Staff> arr(k);
	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--;
		arr[i].m--;
		arr[i].r--;
	}
	vector <int> p(k);
	iota(p.begin(), p.end(), 0);
	do {
		vector <bool> used(n);
		for (int i = 0; i < k; i++) {
			if (!used[arr[p[i]].m]) {
				for (int j = arr[p[i]].l; j <= arr[p[i]].r; j++) {
					used[j] = true;
				}
			}
		}
		bool flag = true;
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				flag = false;
				break;
			}
		}
		if (flag) {
			cout << "YES\n";
			return;
		}
	} while (next_permutation(p.begin(), p.end()));
	cout << "NO\n";
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
