#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#include <numeric>
#define int long long

using namespace std;
using ll = long long;

const int INF = 2e18;

struct Staff {
	int l, m, r;
};

void solve() {
	int n, k;
	cin >> n >> k;
	vector <Staff> arr(k);
	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--;
		arr[i].m--;
		arr[i].r--;
	}
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i == j) {
				continue;
			}
			if (!(arr[i].l <= arr[j].m && arr[j].m <= arr[i].r)) {
				if (arr[i].r + 1 >= arr[j].l && arr[i].l == 1 && arr[j].r == n - 1) {
					cout << "YES\n";
					return;
				}
				if (arr[j].r + 1 >= arr[i].l && arr[j].l == 1 && arr[i].r == n - 1) {
					cout << "YES\n";
					return;
				}
			}
			else if (!(arr[j].l <= arr[i].m && arr[i].m <= arr[j].r)) {
				if (arr[i].r + 1 >= arr[j].l && arr[i].l == 1 && arr[j].r == n - 1) {
					cout << "YES\n";
					return;
				}
				if (arr[j].r + 1 >= arr[i].l && arr[j].l == 1 && arr[i].r == n - 1) {
					cout << "YES\n";
					return;
				}
			}
		}
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
