#include <bits/stdc++.h>
using namespace std;
using ll = int;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll h, w;
    cin >> h >> w;

    vector<string> a(h);
    for (auto &u : a) {
        cin >> u;
    }

    vector<vector<ll>> cnt(h, vector<ll>(w, 0));
    vector<vector<ll>> pref(h, vector<ll>(w + 1, 0));
    for (ll i = 0; i < h; ++i) {
        for (ll j = 1; j <= w; ++j) {
            pref[i][j] = pref[i][j - 1] + (a[i][j - 1] == '1');
        }
    }
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            ll l = 0, r = w - j + 1;
            while (l + 1 < r) {
                ll m = (l + r) / 2;
                if (pref[i][j + m] - pref[i][j] == m) {
                    l = m;
                } else {
                    r = m;
                }
            }
            cnt[i][j] = l;
        }
    }

    ll ans = 0;
    for (ll j = 0; j < w; ++j) {
        ll k = 0;
        for (ll i = 0; i < h; ++i) {
            if (cnt[i][j] == 0) {
                k = i + 1;
                continue;
            }
            ll mn = 1e9, sum = 0;
            for (ll x = i; x >= k; --x) {
                mn = min(mn, cnt[x][j]);
                sum += mn;
            }
            ans = max(ans, sum);
        }
    }

    cout << ans << endl;
}