#include <bits/stdc++.h>
using namespace std;
using ll = int64_t;

int main() {
    ll n, d;
    cin >> n >> d;
    vector<vector<ll>> a(n, vector<ll>(n, 1e18));
    for (ll i = 0; i < n; ++i) {
        a[i][i] = 0;
    }
    for (ll i = 1; i < n; ++i) {
        ll u, v;
        cin >> u >> v;
        --u; --v;
        a[u][v] = 1;
        a[v][u] = 1;
    }
    for (ll i = 0; i < n; ++i) {
        for (ll s = 0; s < n; ++s) {
            for (ll t = 0; t < n; ++t) {
                a[s][t] = min(a[s][t], a[s][i] + a[i][t]);
            }
        }
    }
    vector<ll> b(n);
    iota(b.begin(), b.end(), 0);
    ll ans = 0;
    vector<pair<ll, ll>> res;
    do {
        ll cnt = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i][b[i]] <= d && a[i][b[i]] % 2) {
                ++cnt;
            }
        }
        if (cnt / 2 > ans) {
            res.clear();
            vector<bool> used(n, 0);
            ans = cnt / 2;
            for (ll i = 0; i < n; ++i) {
                if (a[i][b[i]] <= d && a[i][b[i]] % 2 && !used[i]) {
                    used[b[i]] = 1;
                    res.emplace_back(i + 1, b[i] + 1);
                }
            }
        }
    } while (next_permutation(b.begin(), b.end()));
    cout << ans << endl;
    for (auto &u : res) {
        cout << u.first << ' ' << u.second << endl;
    }
}