#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int ll

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n + 2);
    vector<vector<ll>> dp(n + 2);
    vector<vector<ll>> z(n + 2);
    for (ll i = 1; i <= n + 1; i++) {
        a[i].resize(m + 2);
        dp[i].resize(m + 2);
        z[i].resize(m + 2);
    }
    char w;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> w;
            a[i][j] = w - '0';
        }
    }


    for (int i = 1; i <= n; i++) {
        for (int j = m; j >= 1; j--) {
            if (a[i][j] == 0) continue;
            dp[i][j] = dp[i][j + 1] + 1;
        }
    }
    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i][j] == 0) continue;
            ll sum = 0;
            vector<ll> c;
            for (int h = i; h <= n; h++) {
                if (a[h][j] == 0) break;
                int k = 0;
                while (!c.empty() && c.back() > dp[h][j]) {
                    sum -= c.back();
                    sum += dp[h][j];
                    c.pop_back();
                    c.push_back(dp[h][j]);
                    k++;
                }
                for (int i = 1; i <= k; i++) c.push_back(dp[h][j]);
                sum += dp[h][j];
                //cout << i << " " << h << " " << j << " " << sum << "\n";
                c.push_back(dp[h][j]);
                ans = max(ans, sum);
            }
            c.clear();
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
