#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int ll
#define pll pair<ll, ll>

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> dp(n + 1);
    vector<vector<int>> g(n + 1);
    dp[0] = 1;
    for (int i = 1; i <= k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        g[l].push_back(r);
    }
    queue<ll> q;
    q.push(1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto now : g[v]) {
            if (dp[now]) continue;
            dp[now] = 1;
            if (now + 1 <= n) q.push(now + 1);
        }
    }
    if (dp[n]) {
        cout << "YES\n";
    } else cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
