#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using i128 = __int128;

#define pll pair<ll, ll>
#define all(vec) vec.begin(), vec.end()

struct rb {
    ll l, r, pos;
};

bool cmp(rb a, rb b) {
    return a.pos < b.pos;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<rb> a(k);
    vector<ll> used(n + 1);
    used[0] = -1;
    for (auto &[l, r, pos] : a) cin >> l >> pos >> r;
    sort(all(a), cmp);

    for (auto [l, r, pos] : a) {
        //cout << l << " " << r << " " << pos << "\n";
        bool f = false;
        for (int i = l - 1; i <= r; i++) {
            if (used[i] != 0 && (used[i] < l || pos > i)) {
                f = true;
                break;
            }
        }
        if (f) {
            if (used[r] == 0) used[r] = pos;
            else used[r] = min(used[r], pos);
        }
    }
    if (used[n] != 0) {
        cout << "YES\n";
    } else cout << "NO\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
