#include <bits/stdc++.h>
//#define int long long
#define F first
#define S second
using namespace std;
int n, d;
vector<vector<int> > g;
vector<pair<vector<int>, vector<int> > > cnt;
vector<pair<int, int> > ans;

void dfs(int v, int p) {
    cnt[v].F.push_back(v);
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
        for (int j: cnt[i].S) {
            cnt[v].F.push_back(j);
        }
        for (int j: cnt[i].F) {
            cnt[v].S.push_back(j);
        }
    }
    int mn = min(cnt[v].F.size(), cnt[v].S.size());
    for (int i = 0; i < mn; ++i) {
        ans.push_back({cnt[v].F.back(), cnt[v].S.back()});
        cnt[v].F.pop_back();
        cnt[v].S.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d;
    g.resize(n);
    cnt.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, 0);
    cout << ans.size() << '\n';
    for (auto [v,u]: ans) {
        cout << v + 1 << " " << u + 1 << '\n';
    }
    return 0;
}
