#include <bits/stdc++.h>
//#define int long long
#define F first
#define S second
using namespace std;
int n, d;
vector<vector<int> > g;
vector<vector<vector<int> > > cnt;
vector<pair<int, int> > ans;

void dfs(int v, int p) {
    cnt[v][0].push_back(v);
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
        for (int j = 0; j < d; ++j) {
            for (int k: cnt[i][j]) {
                cnt[v][j + 1].push_back(k);
            }
        }
    }
    cnt[v][d + 1].clear();
    int id1 = d, id2 = d - 1;
    while (id1 >= 0) {
        if (id2 < 0) {
            id1 -= 2;
            id2 = d - 1;
            continue;
        }
        if (id2 + id1 > d) {
            id2 -= 2;
            continue;
        }
        while (cnt[v][id1].size() > 0 && cnt[v][id2].size() > 0) {
            ans.push_back({cnt[v][id1].back(), cnt[v][id2].back()});
            cnt[v][id1].pop_back();
            cnt[v][id2].pop_back();
        }
        if (cnt[v][id1].empty()) {
            id1 -= 2;
        }
        if (cnt[v][id2].empty()) {
            id2 -= 2;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d;
    g.resize(n);
    cnt.resize(n, vector<vector<int> >(d + 2));
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, 0);
    cout << ans.size() << '\n';
    for (auto [v,u]: ans) {
        cout << v + 1 << " " << u + 1 << '\n';
    }
    return 0;
}
