#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

struct Fast {
    struct seg {
        ll l, m, r;

        seg() = default;

        seg(ll l, ll m, ll r) : l(l), m(m), r(r) {}
    };

    void main() {
        ll n, k;
        cin >> k >> n;
        vector<seg> a(n);
        for (auto &[l, m, r]: a) {
            cin >> l >> m >> r;
        }
        sort(a.begin(), a.end(), [&](auto f, auto s) {
            return tie(f.m, f.l, f.r) < tie(s.m, s.l, s.r);
        });
        vector<bool> d(n);
        for (ll i = 0; i < n; i++) {
            if (a[i].l == 1) d[i] = true;
        }
        for (ll i = 0; i < n; i++) {
            for (ll j = i - 1; j >= 0; j--) {
                if (!d[j]) continue;
                if (a[j].m < a[i].l && a[i].l - 1 <= a[j].r && a[j].r <= a[i].r) {
                    d[i] = true;
                    break;
                }
                if (a[i].l - 1 <= a[j].r && a[j].r < a[i].m) {
                    d[i] = true;
                    break;
                }
            }
        }
        for (ll i = 0; i < n; i++) {
            if (a[i].r == k && d[i]) {
                cout << "YES";
                return;
            }
        }
        cout << "NO";
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll testC;
    cin >> testC;
    while (testC--) {
        Fast().main();
        cout << '\n';
    }
    return 0;
}
