#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n;
    cin >> n;
    vector<ll> x(n);
    ll xm = 0;
    for (ll i = 0; i < n; i++) {
        cin >> x[i];
        xm = max(xm, abs(x[i]));
    }
    sort(x.begin(), x.end());
    ll x0, d;
    cin >> x0 >> d;
    ll q; cin >> q;
    vector <ll> sfq(n), sf(n);
    for (ll i = n - 1; i >= 0; i--) {
        sfq[i] = (i < n - 1 ? sfq[i + 1] : 0) + x[i] * x[i];
        sf[i] = (i < n - 1 ? sf[i + 1] : 0) + x[i];
    }
    while (q--) {
        ll t; cin >> t;
        vector <ll> x1, x2;
        for (ll i = 0; i < n; i++) {
            if (x[i] < x0) x1.emplace_back(i);
            else if (x[i] > x0) x2.emplace_back(i);
        }
        reverse(x2.begin(), x2.end());
        ll S = 0;
        ll f1 = inf, s1 = inf;
        for (ll k = 0; x0 + k * d <= xm; k++) {
            ll cx = x0 + k * d;
            while (!x2.empty() && x2.back() <= cx) {
                ll i = x2.back();
                x2.pop_back();
                S += min(abs(cx - x[i]) * abs(cx - x[i]),
                         abs(cx - d - x[i]) * abs(cx - d - x[i]));
                ll cur1 = t * k + S + (i < n - 1 ? sfq[i + 1] : 0) - 2 * k * (i < n - 1 ? sf[i + 1] : 0);
                f1 = min(f1, cur1);
                ll cur2 = 2 * t * k + S + (i < n - 1 ? sfq[i + 1] : 0) - 2 * k * (i < n - 1 ? sf[i + 1] : 0);
                s1 = min(s1, cur2);
            }
        }
        ll f2 = inf, s2 = inf;
        for (ll k = 0; x0 + k * d <= xm; k++) {
            ll cx = x0 - k * d;
            while (!x1.empty() && x1.back() >= cx) {
                ll i = x1.back();
                x1.pop_back();
                S += min(abs(cx - x[i]) * abs(cx - x[i]),
                         abs(cx + d - x[i]) * abs(cx + d - x[i]));
                ll cur1 = 2 * t * k + S + (i < n - 1 ? sfq[i + 1] : 0) - 2 * k * (i < n - 1 ? sf[i + 1] : 0);
                s2 = min(s2, cur1);
                ll cur2 = t * k + S + (i < n - 1 ? sfq[i + 1] : 0) - 2 * k * (i < n - 1 ? sf[i + 1] : 0);
                f2 = min(f2, cur2);
            }
        }
        cout << min(f1 + s2, s1 + f2) << '\n';
    }
    return 0;
}