#include<bits/stdc++.h>
using namespace std;

template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << "\n";
    }
    return out;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<bool>> a(n, vector<bool>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            a[i][j] = (c == '1');
        }
    }

    vector<vector<int>> max_len(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        int len = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j]) {
                len++;
            } else {
                len = 0;
            }
            max_len[i][j] = len;
        }
    }

    //cout << max_len << "\n";

    int ans = 0;
    for (int j = 0; j < m; ++j) {
        vector<int> dp(n);
        for (int i = 0; i < n; ++i) {
            if (a[i][j] == 0) {
                continue;
            }
            int k;
            for (k = i - 1; k >= 0; --k) {
                if (max_len[k][j] <= max_len[i][j]) {
                    break;
                }
            }
            dp[i] = (k != -1 ? dp[k] : 0) + (i - k) * max_len[i][j];
        }
        ans = max(ans, *max_element(dp.begin(), dp.end()));
    }
    cout << ans;
}

/*
6 4
0011
1101
0111
1110
0111
0100
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}