// #include<iostream>
// #pragma GCC target("avx2")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("inline")

#include<bits/stdc++.h>
using namespace std;
#define all(x) (x).begin(), (x).end()

const int inf = 2e9;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

vector<vector<int>> g;
vector<int> dp0, dp1;
vector<set<pair<int, int>>> ans01, ans11;
vector<set<pair<int, int>>> ans00, ans10;

void merge(set<pair<int, int>> &s1, set<pair<int, int>> &s2) {
    if (s1.size() < s2.size()) {
        swap(s1, s2);
    }
    while (!s2.empty()) {
        s1.insert(*s2.begin());
        s2.erase(s2.begin());
    }
}

const int c = 40;

void dfs(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp0[v] += max(dp0[u], dp1[u]);
            if (dp0[u] > dp1[u]) {
                merge(ans00[v], ans00[u]);
            } else {
                merge(ans00[v], ans10[u]);
            }
        }
    }
    dp1[v] = dp0[v];
    int mx_delta = 0, mx_u = -1;
    for (int u : g[v]) {
        if (u != p) {
            if (mx_delta < 1 + dp0[u] - max(dp0[u], dp1[u])) {
                mx_delta = max(mx_delta, 1 + dp0[u] - max(dp0[u], dp1[u]));
                mx_u = u;
            }
        }
    }
    dp1[v] += mx_delta;
    for (int u : g[v]) {
        if (u != p) {
            if (u == mx_u) {
                merge(ans10[v], ans01[u]);
                ans10[v].insert({v, u});
            } else {
                if (dp0[u] > dp1[u]) {
                    merge(ans10[v], ans01[u]);
                } else {
                    merge(ans10[v], ans11[u]);
                }
            }
            if (ans00.size() > c) ans00[u].clear();
            if (ans01.size() > c) ans01[u].clear();
            if (ans10.size() > c) ans10[u].clear();
            if (ans11.size() > c) ans11[u].clear();
        }
    }

    if (v != 0) {
        ans01[v] = ans00[v];
        ans11[v] = ans10[v];
    }

    // cout << v << "\n";
    // for (auto i : ans10[v]) {
    //     cout << i.first + 1 << " " << i.second + 1 << "\n";
    // }
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    dp0.resize(n);
    dp1.resize(n);
    ans00.resize(n);
    ans10.resize(n);
    ans01.resize(n);
    ans11.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs(0, -1);

    cout << max(dp0[0], dp1[0]) << "\n";
    if (ans00[0].size() > ans10[0].size()) {
        for (auto i : ans00[0]) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }
    } else {
        for (auto i : ans10[0]) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }
    }

}

/*
8
7
1 2
2 3
3 4
3 5
1 6
6 7
3 8
3
2 7
6 3
4 1
11
3
1 2
2 3
3 4
3 5
3 6
3 7
1 8
8 9
8 10
8 11
4
3 7
11 8
10 2
1 6

*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}