#include "bits/stdc++.h"
using namespace std;

vector<vector<int>> g;
int answer = 0;
int n, m;

void solve() {
    cin >> n >> m;
    g.assign(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            g[i][j] = c - '0';
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!g[i][j]) continue;
            vector<vector<int>> taken(n, vector<int>(m));
            int lenup = 0;
            int istop = i;
            while (istop >= 0 && g[istop][j]) {
                taken[istop][j] = true;
                lenup++;
                istop--;
            }
            int lenright = 0;
            int jstop = j;
            while (jstop < m && g[i][jstop]) {
                taken[i][jstop] = true;
                lenright++;
                jstop++;
            }
            // lenup, lenright
            int res = lenup + lenright - 1;
            for (int ii = i - 1; ii > istop; --ii) {
                for (int jj = j + 1; jj < jstop; ++jj) {
                    if (taken[ii + 1][jj] && taken[ii][jj - 1] && g[ii][jj]) {
                        res++;
                        taken[ii][jj] = 1;
                    }
                }
            }
            answer = max(answer, res);
        }
    }
    cout << answer << endl;
}

signed main() {
#ifdef SEREGA
    freopen("/home/roi/work/CLionProject/input.txt", "r", stdin);
    freopen("/home/roi/work/CLionProject/output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}