#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
vector <vector <int>> g;

vector <int> dep(n);

vector <int> cnt0;
vector <int> cnt1;

void dfs(int v, int p) {
	if (dep[v] % 2 == 0) {
		cnt0.push_back(v);
	}
	if (dep[v] % 2 == 1) {
		cnt1.push_back(v);
	}
	for (auto u : g[v]) {
		if (u == p) continue;
		dep[u] = dep[v] + 1;
		dfs(u, v);
	}
}

int main() {
	int d;
	cin >> n >> d;

	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dep.resize(n);
	dfs(0, 0);

	int rr;
	cout << (rr = min(cnt0.size(), cnt1.size())) << '\n';
	for (int i = 0; i <rr; i++) {
		cout << cnt0[i] + 1 << ' ' << cnt1[i] + 1 << '\n';
	}
}