#include<bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> color;

void dfs(int v, int c = 1) {
    color[v] = c;
    for (int u : g[v]) {
        if (color[u] == 0)
            dfs(u, 3 - c);
    }
}

inline void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;

    g = vector<vector<int>>(n);
    for (int i = 0; i < n-1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }
    color = vector<int>(n);
    dfs(0);
    vector<int> one;
    vector<int> two;
    for (int i = 0; i < n; i++) {
        if(color[i] == 1) {
            one.push_back(i);
        }
        if (color[i] == 2) {
            two.push_back(i);
        }
    }

    cout << min(one.size(), two.size()) << '\n';
    for (int i = 0; i < min(one.size(), two.size()); i++) {
        cout << one[i] + 1 << ' ' << two[i] + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    cin >> t;
#endif

    while (t--) {
        solve();
        cout << '\n';
    }
}