#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> graph;
vector<int> used;
vector<pair<int, int>> ans;

void dfs(int v, int p = -1) {
    for (auto elem : graph[v]) {
        if (elem == p) continue;
        dfs(elem, v);
        if (!used[elem] && !used[v]) {
            ans.emplace_back(v, elem);
            used[v] = true;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d;
    cin >> n >> d;
    graph.resize(n);
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        graph[--a].push_back(--b);
        graph[b].push_back(a);
    }
    used.resize(n);
    dfs(0);
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) cout << a + 1 << ' ' << b + 1 << '\n';
}