#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()

struct node {
	int l, r, m;
	node() {}
	node(int l, int r, int m) : l(l), r(r), m(m) {}
	bool operator < (node b) {
		if (l != b.l) return l < b.l;
		if (r != b.r) return r < b.r;
		return m > b.m;
	}
};

void solve() {
	int n, k; cin >> n >> k;
	vector<node> v(k);
	for (int i = 0; i < k; ++i) {
		cin >> v[i].l >> v[i].m >> v[i].r;
	}
	sort(all(v));
	vector<int> dp(k + 1, 0);

	bool f = 0;
	for (int i = 1; i <= k; ++i) {
		for (int j = i - 1; j >= 0; --j) {
			if (v[i - 1].l <= dp[j] + 1 && dp[j] < v[i - 1].m) { 
				dp[i] = v[i - 1].r; break;
			}
		}
	}

	for (int i = 1; i <= k; ++i) {
		if (dp[i] == n) {
			cout << "YES\n"; return;
		}
	}
	cout << "NO\n";
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t; cin >> t;
	while (t--) solve();

}