#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

struct node {
	int l, r, m;
	node() {}
	node(int l, int r, int m) : l(l), r(r), m(m) {}
	bool operator < (node b) {
		return l < b.l;
	}
};

bool cmp(node a, node b) {
	return a.l < b.l;
}

bool fl = 0;
vector<int> cl(505);
int n, k;
vector<node> v;

void f() {
	if (fl) return;

	bool cur = 1;
	for (int i = 0; i < n && cur; ++i)
		if (!cl[i]) cur = 0;
	if (cur) {
		fl = 1; return;
	}

	for (int i = 0; i < k; ++i) {
		if (cl[v[i].m - 1]) continue;
		for (int j = v[i].l - 1; j < v[i].r; ++j) cl[j]++;
		f();
		for (int j = v[i].l - 1; j < v[i].r; ++j) cl[j]--;
	}
}

void solve() {
	int n; cin >> n;
	vector<int> x(n);
	for (int i = 0; i < n; ++i) cin >> x[i];
	int x0, d; cin >> x0 >> d;
	for (int& X : x)
		X -= x0;

	int m; cin >> m;
	while (m--) {
		int t; cin >> t;
		int ans = 0;
		if (t == 0) {
			for (int X : x) {
				int A = X / d;
				int cur = min((A * d - X) * (A * d - X), ((A + 1) * d - X) * ((A + 1) * d - X));
				cur = min(cur, ((A - 1) * d - X) * ((A - 1) * d - X));
				ans += cur;
			}
		}
		cout << ans << '\n';
	}
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t = 1; //cin >> t;
	while (t--) solve();

}