#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()


#pragma GCC optimize ("O3, Ofast")
#pragma GCC target ("avx2")

struct node {
	int l, r, m;
	node() {}
	node(int l, int r, int m) : l(l), r(r), m(m) {}
	bool operator < (node b) {
		return l < b.l;
	}
};


vector<vector<int>> g;
vector<vector<int>> dp;

void dfs(int v, int p) {
	int sm = 0;
	for (int u : g[v]) {
		if (u == p) continue;
		dfs(u, v);
		sm += dp[u][1];
	}

	for (int u : g[v]) {
		if (u == p) continue;
		dp[v][0] += max(dp[u][0], dp[u][1]);
		dp[v][1] = max(dp[v][1], sm - dp[u][1] + dp[u][0] + 1);
	}
}

void go(int v, int p, int t) {
	if (dp[v][t] == 0) return;

	int sm = 0;
	for (int u : g[v]) {
		if (u == p) continue;
		sm += dp[u][1];
	}

	if (t == 0) {
		for (int u : g[v]) {
			if (u == p) continue;
			if (dp[u][0] > dp[u][1]) go(u, v, 0);
			else go(u, v, 1);
		}
		return;
	}

	bool f = 1;
	for (int u : g[v]) {
		if (u == p) continue;
		if (f && dp[v][1] == sm - dp[u][1] + dp[u][0] + 1) {
			f = 0;
			cout << v + 1 << ' ' << u + 1 << '\n';
			go(u, v, 0);
		}
		else{
			go(u, v, 1);
		}
	}
}
void solve() {
	int n, d; cin >> n >> d;
	g.assign(n, {});
	dp.assign(n, { 0, 0 });

	for (int i = 1; i < n; ++i) {
		int u, v; cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, 0);
	cout << max(dp[0][1], dp[0][0]) << '\n';
	if (dp[0][1] > dp[0][0])
		go(0, 0, 1);
	else
		go(0, 0, 0);
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t = 1; //cin >> t;
	while (t--) solve();

}