#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#ifdef _DEBUG
#define debug(x) cerr << (#x) << " = " << (x) << '\n';
#else
#define debug(x) ;
#endif

struct Work {
    ll l;
    ll m;
    ll r;
    constexpr bool operator< (const Work& an) const { return l < an.l; }
};

constexpr bool cmp (const Work& m1, const Work& m2) { return m1.r > m2.r; }

istream& operator>> (istream& is, Work& man) { return is >> man.l >> man.m >> man.r; }

void solve() {
    ll qe, qm;
    cin >> qe >> qm;
    vector<Work> men = vector<Work>(qm, {0, 0, 0});
    for (auto &i : men) {
        cin >> i;
        --i.l;
        --i.m;
        //debug(i.l);
        //debug(i.m);
        //debug(i.r);
    }
    vector<ll> fenvl = vector<ll>(qe + 1, 0), fenvr = vector<ll>(qe + 1, qe);
    sort(men.begin(), men.end());
    for (auto [cl, cm, cr] : men) {
        //debug(cl);
        //debug(cm);
        //debug(cr);
        ll res = 0, ci = cm;
        while (ci > 0) {
            //debug(ci);
            res = max<ll>(res, fenvl[ci]);
            ci &= ci - 1;
        }
        //debug(res);
        if (res >= cl && res < cr) {
            //dp[cm] = max(dp[cm], cr)
            for (ll i = 0; (((cm >> i) | 1) << i) < qe; ++i) {
                //debug(i);
                //debug((((cm >> i) | 1) << i));
                if (((cm >> i) & 1) == 0) {
                    fenvl[(((cm >> i) | 1) << i)] = max<ll>(fenvl[(((cm >> i) | 1) << i)], cr);
                }
            }
        }
    }
    sort(men.begin(), men.end(), &cmp);
    for (auto [cl, cm, cr] : men) {
        debug(cl);
        debug(cm);
        debug(cr);
        ll res = qe, ci = cm;
        while (ci < qe) {
            debug(ci);
            res = min<ll>(res, fenvr[ci]);
            ci = qe - ((qe - ci) & (qe - ci - 1));
        }
        debug(res);
        if (res <= cr && res > cl) {
            //dpb[cm] = min(dpb[cm], cl)
            for (ll i = 0; ((((qe - cm) >> i) | 1) << i) <= qe; ++i) {
                if ((((qe - cm) >> i) & 1) == 0) {
                    debug(qe - ((((qe - cm) >> i) | 1) << i));
                    fenvr[qe - ((((qe - cm) >> i) | 1) << i)] = min<ll>(fenvr[qe - ((((qe - cm) >> i) | 1) << i)], cl);
                }
            }
        }

        res = 0, ci = cl;
        while (ci > 0) {
            res = max<ll>(res, fenvl[ci]);
            ci &= ci - 1;
        }
        debug(res);

        if (res >= cl && res < cr) {
            res = qe, ci = cr - 1;
            while (ci < qe) {
                //debug(ci);
                res = min<ll>(res, fenvr[ci]);
                ci = qe - ((qe - ci) & (qe - ci - 1));
            }
            if (res <= cr && res > cl) {
                cout << "YES\n";
                return;
            }
        }

    }
    cout << "NO\n";
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cout << fixed << setprecision(30);
    cerr << fixed << setprecision(30);

    ll t = 1;

    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}