#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

#define all(x) x.begin(), x.end()

const ll INF = (ll) 1e18;

void solve() {
    int n;
    cin >> n;
    vll a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll x, d;
    cin >> x >> d;
    int m;
    cin >> m;

    auto f = [&](ll a, ll b) {
        return (a - b) * (a - b);
    };


    auto get_opt = [&](ll p) {
        ll left = (ll) -1e9 - 100;
        ll right = (ll) 1e9 + 100;
        while (left + 1 != right) {
            ll mid = (left + right) / 2;
            if (p < x + d * mid) {
                right = mid;
            } else {
                left = mid;
            }
        }
        if ((p - (x + d * left)) * (p - (x + d * left)) < (x + d * right - p) * (x + d * right - p)) {
            return left;
        } else {
            return right;
        }
    };


    vector<ll> opt(n);
    for (int i = 0; i < n; ++i) {
        opt[i] = get_opt(a[i]);
    }
    // auto get_res = [&](int opt) {
    //     ll res = t * abs(opt);
    //     for (int i = 0; i < n; ++i) {
            
    //     }
    // };

    vector<pair<ll, ll>> q;
    for (int i = 0; i < m; ++i) {
        ll t;
        cin >> t;
        q.push_back({t, i});
    }
    sort(all(q));
    vll ans(m);
    for (auto [t, ind] : q) {
        for (int d1 = 0; d1 < 100; ++d1) {
            int p = x + d1 * d;
            for (int i = 0; i < n; ++i) {
                if (opt[i] <= d1) {
                    ans[ind] += f(x + d * opt[i], a[i]);
                } else {
                    ans[ind] += f(p, a[i]);
                }
            }
        }
        ans[ind] += opt[i] * t;
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}