#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(v) (v).begin(), (v).end()
typedef pair<int, int> pii;
const int N = 4e6;
const int mod = 1e9 + 7;

#define SQR(x) ((x)*(x))
#define num __int128

int n;
int x[N];
int x0, d;
int m;

num suf[N];
num sqrsuf[N];
num bestpref[N];

num best(int x)
{
	num d0 = x/d*d;
	return min({SQR(d0-x), SQR(d0+d-x), SQR(d0-d - x)});
}

int t;

num getans(int z)
{
	int i = upper_bound(x, x+n, z*d) - x;
	if (x[i] > z*d)
		i--;
	num res = t*z;
	if (i != 0)
		res += bestpref[i];
	if (i != n-1)
		res += sqrsuf[i+1];
	res += (n-i-1)*SQR(z*d);
	if (i != n-1)
		res -= 2*suf[i+1]*z*d;
	return res;
}

int32_t main()
{
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> x[i];
	cin >> x0 >> d;
	for (int i = 0; i < n; i++)
		x[i] -= x0;
	sort(x, x+n);
	bestpref[0] = best(x[0]);
	for (int i = 1; i < n; i++)
		bestpref[i] = bestpref[i-1] + best(x[i]);
	suf[n-1] = x[n-1];
	for (int i = n-2; i >= 0; i--)
		suf[i] = suf[i+1] + x[i];
	sqrsuf[n-1] = SQR(x[n-1]);
	for (int i = n-2; i >= 0; i--)
		sqrsuf[i] = sqrsuf[i+1] + SQR(x[i]);

	cin >> m;

	while (m--)
	{
		cin >> t;
		int ans = LONG_MAX;
		int z0 = (2*d*x[0] - SQR(x[0]) - t)/2/d/d;
		for (int z = z0-100; z <= z0+100; z++)
		{
			if (z < 0) continue;
			int val = SQR(x[0]-z*d) + z*t;
			ans = min(ans, val);
		}
		z0 = (2*d*x[0] - SQR(x[0]) + t)/2/d/d;
		for (int z = z0-100; z <= z0+100; z++)
		{
			if (z > 0) continue;
			int val = SQR(x[0]+z*d) - z*t;
			ans = min(ans, val);
		}
		
		cout << ans << '\n';
	}
}


