#include<bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
typedef long long ll;
using namespace std;

const __int128 INF = 1e18;
const int N = 3e5 + 5;
ll x0, d;
int n, m;
ll kx[N], dist[N];
ll ans[N];

void solve() {
    cin >> n;

    vector<ll> x(n + 1);
    for (int i = 0; i < n; i++) cin >> x[i];
    sort(all(x));


    cin >> x0 >> d >> m;
    vector<pair<ll, int>> e(m);
    for (int i = 0; i < m; i++) {
        ll t;
        cin >> t;
        e[i] = {t, i};
    }
    sort(allr(e));


    for (int i = 0; i <= n; i++) {
        kx[i] = abs(x[i] - x0);
        if (kx[i] % d) {
            kx[i] /= d;
            kx[i]++;
        }
        else kx[i] /= d;

        dist[i] = kx[i] * d - x[i];
        if (kx[i] != 0) dist[i] = min(dist[i], x[i] - (kx[i] - 1) * d);
    }

    ll opt = 0;
    for (auto [t, j] : e) {

        __int128 w = INF;
        for (ll opt2 = opt; opt2 <= kx[n] + 1; opt2++) {
            __int128 cost = 0;
            __int128 y = opt2 * d;
            for (int i = 1; i <= n; i++) {
                ll h = (y - x[i]) * (y - x[i]);
                if (opt2 >= kx[i]) {
                    h = min(h, dist[i] * dist[i]);
                }
                cost += h;
            }
            cost += opt2 * t;

            if (cost <= w) {
                w = cost;
                //cout << j << " " << opt2 << " " << endl;
                opt = opt2;
            }
        }

        ans[j] = w;
    }

    for (int i = 0; i < m; i++) cout << ans[i] << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
