#include <bits/stdc++.h>
using namespace std;
#define int long long

int dp[300001][2];
void dfs(int v, int p, vector <vector <int>> &g) {
  dp[v][0] = 0;
  dp[v][1] = 1e9;
  bool f = false;
  for (int u : g[v]) {
    if (u == p) continue;
    dfs(u, v, g);
    dp[v][0] += max(dp[u][0], dp[u][1]);
    if (dp[u][0] >= dp[u][1]) f = true;
  }
  if (f) {
    dp[v][1] = dp[v][0] + 1;
    return;
  }
  int m = -1, best = 1e9;
  for (int u : g[v]) {
    if (dp[v][1] - dp[v][0] < best) {
      best = dp[v][1] - dp[v][0];
      m = u;
    }
  }
  dp[v][1] = dp[v][0] - best + 1;
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int n, d;
  cin >> n >> d;
  vector <vector <int>> g(n + 1);
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  vector <int> b, w;
  queue <int> q;
  q.push(1);
  int s = 0;
  bool used[n + 1] = {false};
  used[1] = true;
  if (d == n - 1) {
    while (!q.empty()) {
      int cap = q.size();
      for (int i = 0; i < cap; i++) {
        int cur = q.front();
        q.pop();
        used[cur] = true;
        (s % 2 == 0 ? b : w).push_back(cur);
        for (int v : g[cur])
          if (!used[v])
            q.push(v);
      }
      s++;
    }
    cout << min(w.size(), b.size()) << '\n';
    while (!w.empty() and !b.empty()) {
      cout << w.back() << ' ' << b.back() << '\n';
      w.pop_back();
      b.pop_back();
    }
  } else if (d == 1) {
    dfs(1, 0, g);
    cout << max(dp[1][0], dp[1][1]) << '\n' << -1;
  }

  return 0;
}