#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("popcnt,avx,avx2")

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;

// #define int ll


int d;

__int128 get(int x, int k, int t, int type) {
    return (__int128) type * abs(k) * t + (__int128) (x - k * d) * (x - k * d);
}

ll solve(int x, int t, int type) {
    ll l = -1e9 - 1, r = 1e9 + 1;
    while (r - l > 1) {
        ll m1 = (l + r) / 2;
        ll m2 = m1 + 1;
        __int128 x1 = get(x, m1, t, type);
        __int128 x2 = get(x, m2, t, type);
        if (x1 > x2) l = m2;
        else r = m1;
    }
    ll x1 = get(x, l, t, type);
    ll x2 = get(x, r, t, type);
    return min(x1, x2);
}


__int128 get2(int x1, int x2, int k, int t) {
    __int128 res = (__int128) abs(k) * t + (__int128) (x1 - k * d) * (x1 - k * d) + (__int128) (x2 - k * d) * (x2 - k * d);
    return res;
}
ll solve2(int x1, int x2, int t) {
    ll l = -1e9 - 1, r = 1e9 + 1;
    while (r - l > 1) {
        ll m1 = (l + r) / 2;
        ll m2 = m1 + 1;
        __int128 val1 = get2(x1, x2, m1, t);
        __int128 val2 = get2(x1, x2, m2, t);
        if (val1 > val2) l = m2;
        else r = m1;
    }
    ll val1 = get2(x1, x2, l, t);
    ll val2 = get2(x1, x2, r, t);
    return min(val1, val2);
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n;
    cin >> n;
    int x1, x2;
    cin >> x1 >> x2;
    int x0;
    cin >> x0 >> d;
    x1 -= x0;
    x2 -= x0;


    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int t;
        cin >> t;
        ll ans = solve(x1, t, 1) + solve(x2, t, 2);
        ans = min(ans, solve(x1, t, 2) + solve(x2, t, 1));
        ans = min(ans, solve2(x1, x2, t));
        cout << ans << "\n";
    }
}
