#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

void solve() {
	int n, k;
	cin >> n >> k;
	swap(n, k);
	vector<tuple<int, int, int>>a(n);
	vector<vector<int>>b(n);
	for (int i = 0; i < n; ++i) {
		int l, m, r;
		cin >> l >> m >> r;
		--l; --m;
		b[l].push_back(r - l);
		a[i] = { l, m, r };
	}
	for (int i = 0; i < n; ++i) {
		sort(b[i].begin(), b[i].end());
		if (b[i].back() != b[i][0]) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) solve();
}
