#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct str {
    int l, m, r;
};


void solve() {
    int n, k;
    cin >> n >> k;

    vector <str> a(k);
    vector <int> cov(n + 2);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        cov[a[i].l]++;
        cov[a[i].r + 1]--;
    }

    bool ok = 1;
    for (int i = 1; i <= n; i++) {
        cov[i] += cov[i-1];

        if (cov[i] == 0) {
            ok = 0;
        }
    }

    for (int i = 0; i < k && ok; i++) {
        for (int j = 0; j < k && ok; j++) {
            if (i == j) {
                continue;
            }

            if (a[i].m >= a[j].l && a[i].m <= a[j].r && a[j].m >= a[i].l && a[j].m <= a[i].r) {
                ok = 0;
            }
        }
    }

    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}