#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 7;

struct e{
    int l;
    int start;
    int r;
};

int n, k;
vector<e> lst;

bool comp(e a, e b) {
    return a.l < b.l;
}

bool can_all() {
    sort(lst.begin(), lst.end(), comp);
    int r = 0;
    for (auto v : lst) {
        if (r + 1 < v.l) {
            return false;
        }
        r = max(r, v.r);
    }
    return (r == n);
}

bool final_ans;

void perebor(vector<bool> used) {
    if (final_ans) {
        return;
    }
    int cou = 0;
    for (int i = 1; i <= n; i++) {
        if (used[i]) {
            cou++;
        }
    }
    if (cou == 0) {
        final_ans = true;
        return;
    }
    for (auto v : lst) {
        if (used[v.start]) {
            vector<bool> new_used = used;
            for (int i = v.l; i <= v.r; i++) {
                new_used[i] = false;
            }
            perebor(new_used);
        }
    }
}


void sol() {
    cin >> n >> k;
    vector<e> one, two;
    for (int i = 0; i < k; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        lst.push_back({a, b, c});
    }
    final_ans = false;
    perebor(vector<bool>(n + 1, true));
    if (final_ans) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
    lst.clear();
}



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
