#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e11 + 7;
const int real_inf = 1e18 + 100;

const int maxn = 3e5 + 100;
vector<int> left_lower(maxn, -1);
vector<int> lst_all;
int n;
int start, d;

void make_lower() {
    for (int i = 0; i < n; i++) {
        int v = lst_all[i];
        int l = -inf, r = inf;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (start + d * mid <= v) {
                l = mid;
            } else {
                r = mid;
            }
        }
        left_lower[i] = l;
    }
}

int find_dist(int ind, int chang) {
    return (lst_all[ind] - (start + chang * d)) * (lst_all[ind] - (start + chang * d));
}


void sol() {
    int cost_dist;
    cin >> cost_dist;
    int ans = real_inf;
    for (int l = 0; l <= 0; l++) {
        for (int r = 0; r <= 1e6; r++) {
            int a = l;
            int b = r;
            if (a > b) {
                swap(a, b);
            }
            int start_ans = (a + a + b) * cost_dist;
            for (int i = 0; i < n; i++) {
                int val_there = find_dist(i, 0);
                val_there = min(val_there, find_dist(i, -l));
                val_there = min(val_there, find_dist(i, r));
                for (int j = left_lower[i] - 5; j <= left_lower[i] + 5; j++) {
                    if (-l <= j && j <= r) {
                        val_there = min(val_there, find_dist(i, j));
                    }
                }
                start_ans += val_there;
            }
            ans = min(ans, start_ans);
        }
    }
    cout << ans << '\n';
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int num;
        cin >> num;
        lst_all.push_back(num);
    }
    sort(lst_all.begin(), lst_all.end());
    cin >> start >> d;
    make_lower();
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
