#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define ff first
#define sc second
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

using ll = long long;
using pii = pair<int, int>;

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l; --r; --m;
    }
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    for (int M = 0; M <= n; ++M)
        dp[M][n] = 1;
    vector<seg> cur;
    for (int M = n; M >= 0; --M) {
        for (int R = n - 1; R >= M; --R) {
            cur.clear();
            for (int i = 0; i < k; ++i) {
                if (a[i].l <= R && a[i].r >= R && !(a[i].m < R && a[i].l < M)) {
                    cur.pb({R, a[i].m, a[i].r});
                }
            }

            for (int i = 0; i < sz(cur); ++i) {
                dp[M][R] = max(dp[M][R], dp[max(M, cur[i].m + 1)][cur[i].r + 1]);
            }
            // cout << L << " " << M << ' ' << R << ": " << dp[L][M][R] << endl;
        }
    }

    cout << (dp[0][0] ? "YES" : "NO") << '\n';
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}