#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>

using namespace std;

long long solve0(long long x, long long d, long long i) {
    long long ans = 0;
    long long dst1 = i % d;
    long long dst2 = d - dst1;
    dst1 *= dst1;
    dst2 *= dst2;
    ans += min(dst1, dst2);
    return ans;
}

long long solve(long long x, long long d, long long v, long long t) {
    if (t == 0) {
        return solve0(x, d, v);
    }
    long long y = (2 * d * v - 2 * x * d - t) / (2 * d * d);
    if (y < 0) {
        y = 0;
    }
    long long mn = 1e18;
    for (long long i = y - 1; i <= y + 1; i++) {
        long long to = x + d * i;
        long long k = (v - to);
        mn = min(mn, abs(i) * t + k * k);
    }
    return mn;
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    long long x, d;
    cin >> x >> d;
    int m;
    cin >> m;
    for (auto &i : v) {
        i -= x;
    }
    x = 0;
    if (v[0] < 0) {
        v[0] *= -1;
    }
    for (int i = 0; i < m; i++) {
        long long t;
        cin >>t;
        cout << (long long)solve(x, d, v[0], t) << endl;
    }


    return 0;
}
