#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>

using namespace std;

int main()
{
    int n;
    cin >> n;
    __int128 mx = 0;
    vector<__int128> v(n);
    for (int i = 0; i < n; i++) {
        long long tmp;
        cin >> tmp;
        v[i] = tmp;
        mx = max(mx, v[i]);
    }
    sort(v.begin(), v.end());
    __int128 x, d;
    long long x2, d2;
    cin >> x2 >> d2;
    x = x2;
    d = d2;
    int m;
    cin >> m;
    __int128 mv = d - (x % d);
    for (auto &i : v){
        i += mv;
    }
    x += mv;
    vector<pair<__int128, __int128>> t(m);
    for (int i = 0; i < m; i++) {
        long long p;
        cin >> p;
        t[i] = {p, i};

    }
    sort(t.begin(), t.end());
    vector<__int128> to(n);
    map<__int128, __int128> mp;
    map<__int128, __int128> mp_p;
    map<__int128, __int128> mp_s;
    for (int i = 0; i < n; i++) {
        __int128 dst1 = v[i] % d, dst2 = d - (v[i] % d);
        dst1 *= dst1;
        dst2 *= dst2;
        if (dst1 < dst2) {
            to[i] = (v[i] / d) * d;
            mp_s[to[i]] += dst1;
        } else {
            to[i] = (v[i] / d + 1) * d;
            mp_p[to[i]] += dst2;

        }
        mp[to[i]] += min(dst1, dst2);
    }
    map<__int128, __int128> pref;
    map<__int128, __int128> suf;
    for (int i = 0; i < n; i++) {
        for (int j = -2; j * d <= mx + d; j++) {
            if (v[i] < j * d) {
                pref[j * d] += (v[i] - j * d) * (v[i] - j * d);
            } else {
                suf[j * d] += (v[i] - j * d) * (v[i] - j * d);
            }
        }
    }
    vector<__int128> ans(m);
    for (int i = 0; i < m; i++) {
        auto [p, id] = t[i];
        __int128 mn = 1e18;
        for (int j = x; j >= -d; j -= d) {
            for (int k = x; k <= mx + d; k += d) {
                __int128 sum = pref[j] + suf[k] + (x - j) / d * 2 * p + (k - x) / d * p - mp_p[j] - mp_s[k];
                for (int y = j; y <= k; y += d) {
                    sum += mp[y];
                }
                mn = min(mn, sum);
            }
        }
        ans[id] = mn;
    }
    for (auto i : ans) {
        cout << (long long)i << '\n';
    }
    return 0;
}
