#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>
 
using namespace std;

long long solve0(long long x, long long d, long long i) {
    long long ans = 0;
    long long dst1 = i % d;
    long long dst2 = d - dst1;
    dst1 *= dst1;
    dst2 *= dst2;
    ans += min(dst1, dst2);
    return ans;
}

long long solve(long long x, long long d, long long v, long long t) {
    long long y = (2 * x * d - 2 * d * v - t) / (2 * d * d);
    long long mn = 1e18;
    for (int i = y - 10; i <= y + 10; i++) {
        long long to = x - d * y;
        long long k = (v - to);
        mn = min(mn, abs(i) * t + k * k);
    }
    return mn;
}
 
int main()
{
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    long long x, d;
    cin >> x >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        long long t;
        cin >>t;
        cout << solve(x, d, v[0], t) << endl;
    }
    
    
    return 0; 
}