#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif


#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, k;
vector<int> l, m, r;

void solve() {
    int mn = 1e9, mx = -1e9;
    for (int i = 0; i < k; ++i) {
        if (m[i] == 1) {
            mx = max(mx, r[i]);
        } else {
            mn = min(mn, l[i]);
        }
    }
    cout << (mn == 1 || mx == n || mx + 1 >= mn ? "YES\n" : "NO\n");
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        cin >> n >> k;
        l.resize(k);
        m.resize(k);
        r.resize(k);
        for (int i = 0; i < k; ++i) {
            cin >> l[i] >> m[i] >> r[i];
        }
        solve();
    }
}