#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int INF = 1e18;

vector<int> l_a, r_a, l_sum, r_sum, l_sum_sq, r_sum_sq, l_from0, r_from0;
int n, m, x0, d;
int l_sum_x0, r_sum_x0;

int get_res(int pos, int t) {
    if (pos > x0) {
        int id = upper_bound(all(r_a), pos) - r_a.begin();
        return ((int)r_a.size() - id) * pos * pos + r_sum_sq[id] - 2 * pos * r_sum[id] + r_from0[id] + l_sum_x0 + (pos - x0) / d * t;
    }
    else {
        int id = upper_bound(all(l_a), pos) - l_a.begin();
        return ((int)l_a.size() - id) * pos * pos + l_sum_sq[id] - 2 * pos * l_sum[id] + l_from0[id] + r_sum_x0 + (x0 - pos) / d * t;
    }
}

int find_best(int pos, int t, int width) {
    int best = get_res(pos, t);
    for (int i = 1; i <= width; i++) {
        best = min(best, get_res(pos + i * d, t));
        best = min(best, get_res(pos - i * d, t));
    }
    return best;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    cin >> x0 >> d;

    for (auto i : a) {
        if (i >= x0)
            r_a.push_back(i);
        else
            l_a.push_back(i);
    }
    sort(all(r_a));
    sort(rall(l_a));

    r_sum.resize(r_a.size() + 1);
    r_sum_sq.resize(r_a.size() + 1);
    r_from0.resize(r_a.size() + 1);
    for (int i = r_a.size() - 1; i >= 0; i--) {
        r_sum[i] = r_sum[i + 1] + r_a[i];
        r_sum_sq[i] = r_sum_sq[i + 1] + r_a[i] * r_a[i];
    }
    for (int i = 1; i <= r_a.size(); i++) {
        int dist = min((r_a[i - 1] - x0) % d, d - (r_a[i - 1] - x0) % d);
        r_from0[i] = r_from0[i - 1] + dist * dist;
    }
    r_sum_x0 = r_a.size() * x0 * x0 + r_sum_sq[0] - 2 * x0 * r_sum[0];

    l_sum.resize(l_a.size() + 1);
    l_sum_sq.resize(l_a.size() + 1);
    l_from0.resize(r_a.size() + 1);
    for (int i = l_a.size() - 1; i >= 0; i--) {
        l_sum[i] = l_sum[i + 1] + l_a[i];
        l_sum_sq[i] = l_sum_sq[i + 1] + l_a[i] * l_a[i];
    }
    for (int i = 1; i <= l_a.size(); i++) {
        int dist = min((x0 - l_a[i - 1]) % d, d - (x0 - l_a[i - 1]) % d);
        l_from0[i] = l_from0[i - 1] + dist * dist;
    }
    l_sum_x0 = l_a.size() * x0 * x0 + l_sum_sq[0] - 2 * x0 * l_sum[0];

    int mx_width = *max_element(all(a)) / d + 1;

    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        cout << find_best(x0, t, mx_width) << '\n';
    }
}