#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
// #define int ll
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int INF = 1e18;

vector<vector<int>> g;
vector<int> parent, busy;
vector<pair<int, int>> ans, hs;
int n, d;

vector<int> h;

void get_h(int v) {
    hs.push_back({h[v], v});
    for (auto to : g[v]) {
        if (h[to] == -1) {
            parent[to] = v;
            h[to] = h[v] + 1;
            get_h(to);
        }
    }
}

int dfs(int v, int prev, int dist) {
    if (!busy[v] and dist % 2 == 1)
        return v;
    if (dist > d)
        return -1;
    for (auto to : g[v]) {
        if (to == prev or h[to] < h[v])
            continue;
        int res = dfs(to, v, dist + 1);
        if (res != -1)
            return res;
    }
    for (auto to : g[v]) {
        if (to == prev or h[to] > h[v])
            continue;
        int res = dfs(to, v, dist + 1);
        if (res != -1)
            return res;
    }
    return -1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        g[v1 - 1].push_back(v2 - 1);
        g[v2 - 1].push_back(v1 - 1);
    }

    h.resize(n, -1);
    parent.resize(n, -1);
    busy.resize(n, 0);
    h[0] = 0;
    get_h(0);
    
    sort(rall(hs));
    for (auto [cur_h, v] : hs) {
        if (busy[v])
            continue;
        int res = dfs(v, -1, 0);
        if (res != -1) {
            busy[v] = true;
            busy[res] = true;
            ans.push_back({v, res});
        }
    }

    cout << ans.size() << '\n';
    for (auto i : ans)
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
}