#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e9;

vector<ll> x;
ll n, x0;
ll d;


ll count(ll l, ll r, ll t) {
    ll ans = min(abs((x0 - l)) / d + abs((r - l)) / d, abs((r - x0)) / d + abs((r - l)) / d) * t;
    for (ll i = 0; i < n; ++i) {
        if (x[i] < l) {
            ans += (x[i] - l) * (x[i] - l);
        } else if (x[i] > r) {
            ans += (x[i] - r) * (x[i] - r);
        } else {
            ans += min((x[i] - x[i] / d * d) * (x[i] - x[i] / d * d), (x[i] - (x[i] / d * d + d)) * (x[i] - (x[i] / d * d + d)));
        }
    }
    return ans;
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif


    cin >> n;
    x.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    cin >> x0 >> d;
    for (ll i = 0; i < n; ++i) {
        x[i] += d - x0 % d;
    }
    x0 += d - x0 % d;
    ll m;
    cin >> m;
    if (x[0] < x0) {
        swap(x[0], x0);
    }
    x[0] -= x0;
    x0 -= x0;
    while (m--) {
        ll ans = 1e18;
        ll t;
        cin >> t;
        ll L = -1;
        ll R = x[0] / d + 3;
        while (R - L > 2) {
            ll ML = (L + R) / 2;
            ll MR = ML + 1;
            ll resL = t * ML + (x[0] - ML * d) * (x[0] - ML * d);
            ll resR = t * MR + (x[0] - MR * d) * (x[0] - MR * d);
            if (resL < resR) {
                R = MR;
            } else {
                L = ML;
            }
            ans = min({ans, resL, resR});
        }
        cout << ans << "\n";
    }

    return 0;
}
