#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e9;

vector<vector<ll>> g;
ll d;
ll n;
vector<array<ll, 2>> dp;
vector<vector<ll>> q;

void dfs(ll v, ll lvl = 0, ll p = -1) {
    q[lvl % 2].push_back(v);
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, lvl + 1, v);
    }
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    cin >> n;
    g.resize(n);
    dp.resize(n);
    q.resize(2);
    cin >> d;
    for (ll i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);
    cout << min(q[0].size(), q[1].size()) << "\n";
    for (ll i = 0; i < min(q[0].size(), q[1].size()); ++i) {
        cout << q[0][i] + 1 << " " << q[1][i] + 1 << "\n";
    }

    return 0;
}