#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
__int128 sq(ll num) {
    return num * num;
}
vector<__int128>pref; vector<__int128>suf; vector<__int128>pref_sq; vector<__int128>suf_sq;
vector<int>low, up; vector<__int128>good_pref, good_suf;
vector<ll>bs, bst;
vector<ll>best; vector<ll>x;
__int128 solve(ll point) {
    auto first = lower_bound(bs.begin(), bs.end(), point) - bs.begin();
    return pref_sq[first] - pref[first] * 2 * point + point * point * first + good_suf[first];
}
__int128 count(ll point) {
    auto first = lower_bound(bst.begin(), bst.end(), point) - bst.begin();
    return good_pref[first] + suf_sq[first] - 2 * suf[first] * point + point * point * ((int)up.size() - first);
}
ll x0, d;
__int128 solve(ll t, ll less) {
    ll left = -1; ll right = less;
    while (left + 1 < right) {
        ll mid = (left + right) / 2; ll nxt = mid + 1;
        auto first = t * mid + solve(x0 - mid * d);
        auto second = t * nxt + solve(x0 - nxt * d);
        if (first > second) left = mid;
        else right = mid;
    }
    auto val = left + 1;
    left = -1; right = 1e6;
    while (left + 1 < right) {
        ll mid = (left + right) / 2; ll nxt = mid + 1;
        auto first = t * mid + count(x0 + mid * d);
        auto second = t * nxt + count(x0 + d * nxt);
        if (first > second) left = mid;
        else right = mid;
    }
    auto sec = left + 1;
    __int128 first = t * sec + t * val + (ll)solve(x0 - d * val) + (ll)count(x0 + d * sec);
    left = -1; right = 1e6;
    while (left + 1 < right) {
        ll mid = (left + right) / 2; ll nxt = mid + 1;
        auto first = t * mid + solve(x0 - mid * d);
        auto second = t * nxt + solve(x0 - nxt * d);
        if (first > second) left = mid;
        else right = mid;
    }
    val = left + 1;
    left = -1; right = less;
    while (left + 1 < right) {
        ll mid = (left + right) / 2; ll nxt = mid + 1;
        auto first = t * mid + count(x0 + mid * d);
        auto second = t * nxt + count(x0 + d * nxt);
        if (first > second) left = mid;
        else right = mid;
    }
    sec = left + 1;
    __int128 second = t * sec + t * val + (ll)solve(x0 - d * val) + (ll)count(x0 + d * sec);
    return min(first, second);
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n; x.resize(n); best.resize(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    sort(x.begin(), x.end());
    ll m; cin >> x0 >> d >> m;
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) {
            ll add = (x0 - x[i]) / d;
            if (sq(x0 - x[i] - add * d) < sq(x0 - x[i] - (add + 1) * d)) {
                best[i] = x0 - add * d;
            }else best[i] = x0 - (add + 1) * d;
        }else {
            ll add = (x[i] - x0) / d;
            if (sq(x[i] - x0 - add * d) < sq(x[i] - x0 - (add + 1) * d)) {
                best[i] = x0 + add * d;
            }else best[i] = x0 + (add + 1) * d;
        }
    }
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) low.push_back(i);
        else up.push_back(i);
    }
    pref_sq.resize(low.size() + 1); pref.resize(low.size() + 1); suf.resize(up.size() + 1);
    suf_sq.resize(up.size() + 1);  good_pref.resize(up.size() + 1);
    good_suf.resize(low.size() + 1);
    for (int i = 0; i < low.size(); i++) {
        bs.push_back(best[low[i]]);
        pref_sq[i + 1] = pref_sq[i] + sq(x[low[i]]);
        pref[i + 1] = pref[i] + x[low[i]];
    }
    for (int i = (int)up.size() - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + x[up[i]];
        suf_sq[i] = suf_sq[i + 1] + sq(x[up[i]]);
    }
    for (int i = (int)low.size() - 1; i >= 0; i--) {
        good_suf[i] = good_suf[i + 1] + sq(best[low[i]] - x[low[i]]);
    }
    for (int i = 0; i < up.size(); i++) {
        bst.push_back(best[up[i]]);
        good_pref[i + 1] = good_pref[i] + sq(best[up[i]] - x[up[i]]);
    }
    for (int i = 0; i < m; i++) {
        ll t; cin >> t;
        ll left = -1; ll right = 1e6;
        while (left + 1 < right) {
            ll mid = (left + right) / 2; ll nxt = mid + 1;
            auto first = t * mid + solve(t, mid);
            auto second = t * nxt + solve(t, nxt);
            if (first > second) left = mid;
            else right = mid;
        }
        cout << t * (left + 1) + (ll)solve(t, left + 1) << '\n';
    }
}