#include <bits/stdc++.h>

using namespace std;

vector<bool> segTree;
vector<bool> mod;

void push(int v){
    if(!mod[v])return;
    segTree[v] = true;
    mod[v * 2 + 1] = true;
    mod[v * 2 + 2] = true;
    mod[v] = false;
}

bool get(int v){
    return mod[v] || segTree[v];
}

void setVal(int l1, int r1, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return;
    }else if(l1 <= l && r <= r1){
        mod[v] = true;
        return;
    }
    int m = l + (r - l) / 2;
    push(v);
    setVal(l1, r1, l, m, v * 2 + 1);
    setVal(l1, r1, m, r, v * 2 + 2);
    segTree[v] = get(v * 2 + 1) || get(v * 2 + 2);
}

bool get(int l1, int r1, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return false;
    }else if(l1 <= l && r <= r1){
        return get(v);
    }
    int m = l + (r - l) / 2;
    push(v);
    return get(l1, r1, l, m, v * 2 + 1) || get(l1, r1, m, r, v * 2 + 2);
}

struct worker{
    int l, m, r;
    bool operator<(worker oth){
        return r > oth.r;
    }
};

void solve(){
    int n, k;
    cin >> n >> k;

    vector<worker> arr(k);

    for(int i = 0; i < k; i++){
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        arr[i].l--;
        arr[i].m--;
    }

    sort(arr.begin(), arr.end());

    segTree.assign(n * 4, false);
    mod.assign(n * 4, false);

    for(int i = 0; i < k; i++){
        if(arr[i].r == n || get(arr[i].m, arr[i].r + 1, 0, n, 0)){
            int l1 = arr[i].l;
            int r1 = arr[i].m + 1;
            setVal(l1, r1, 0, n, 0);
        }
    }
    // for(int i = 0; i < n; i++){
    //     cout << get(i, i + 1, 0, n, 0);
    // }
    // cout << '\n';
    if(get(0, 1, 0, n, 0)){
        cout << "YES\n";
    }else{
        cout << "NO\n";
    }
}

int main(){
    #ifdef _LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    freopen("C:\\work\\output.txt", "w", stdout);
    #endif

    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}