#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll, ll>>

void solve() {
    ll n, m;
    cin >> n >> m;
    vii up(n, vi(m, 0));
    vector<string> s(n);
    vii a(n, vi(m));
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
        for (ll j = 0; j < m; j++) {
            a[i][j] = s[i][j] - '0';
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i][j] == 0) {
                up[i][j] = i + 1;
            } else if (i != 0) {
                up[i][j] = up[i-1][j];
            }
        }
    }
    ll ans=  0;
    vii dp(n + 1, vi (m + 1));
    for (ll i = 1; i <= n; i++) {
        vi last(m + 1);
        for (ll j = m; j >= 1; j--) {
            last[j] = up[i-1][j-1];
        }
        vi nxt(m + 1);
        vi st;
        for (ll j = m; j >= 1; j--) {
            while (st.size() && last[st.back()] <= last[j]) {
                st.pop_back();
            }
            if (st.empty()) {
                nxt[j] = m + 1;
            } else {
                nxt[j] = st.back();
            }
            st.pb(j);
            if (nxt[j] == m + 1) {
                dp[i][j] = (i  -last[j]) * (m - j + 1);
            } else {
                dp[i][j] = (i - last[j]) * (nxt[j] - j) + dp[i][nxt[j]];
            }
            //cout << i << " " << j << " " << nxt[j] << " " << dp[i][j] << " " << last[j] << endl;
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
