#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll, ll>>

ll INF = 1e18;

ll get(ll x0, ll t, vi &x, ll d) {
    ll gg = (abs(x0 - x[1]) + d - 1) / d;
    ll mn = INF;
    if (x0 < x[1]) {
        ll l = 0, r = gg;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            ll x1 = x0 + d * m1;
            ll x2 = x0 + d * m2;
            ll c1 = m1 * t + (x[1] - x1) * (x[1] - x1);
            ll c2 = m2 * t + (x[1] - x2) * (x[1] - x2);
            if (c1 <= c2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        for (ll j = l; j <= r; j++) {
            ll x1 = x0 + d * j;
            ll c1 = j * t + (x[1] - x1) * (x[1] - x1);
            mn = min(c1, mn);
        }
    } else {
        ll l = 0, r = gg;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            ll x1 = x0 - d * m1;
            ll x2 = x0 - d * m2;
            ll c1 = m1 * t + (x[1] - x1) * (x[1] - x1);
            ll c2 = m2 * t + (x[1] - x2) * (x[1] - x2);
            if (c1 <= c2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        for (ll j = l; j <= r; j++) {
            ll x1 = x0 - d * j;
            ll c1 = j * t + (x[1] - x1) * (x[1] - x1);
            mn = min(c1, mn);
        }
    }
    return mn;
}

void solve() {
    ll n;
    cin >> n;
    vi x(n);
    for (ll i = 0; i < n; i++) {
        cin >> x[i];
    }
    ll x0, d;
    cin >> x0 >> d;
    ll m;
    cin >> m;
    vi t(m);
    for (ll i = 0; i < m; i++) {
        cin >> t[i];
        ll gg = (abs(x0 - x[0]) + d - 1) / d;
        ll l = 0, r = gg;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            ll x1 = x0 - d * m1;
            ll x2 = x0 - d * m2;
            ll c1 = m1 * t[i] + (x[0] - x1) * (x[0] - x1) + get(x1, t[i], x, d);
            ll c2 = m2 * t[i] + (x[0] - x2) * (x[0] - x2) + get(x2, t[i], x, d);
            if (c1 <= c2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        ll mn = INF;
        for (ll j = l; j <= r; j++) {
            ll x1 = x0 - d * j;
            ll c1 = j * t[i] + (x[0] - x1) * (x[0] - x1) + get(x1, t[i], x, d);
            mn = min(mn, c1);
        }
        ll ans = mn;
        swap(x[0], x[1]);
        gg = (abs(x0 - x[0]) + d - 1) / d;
        l = 0, r = gg;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            ll x1 = x0 + d * m1;
            ll x2 = x0 + d * m2;
            ll c1 = m1 * t[i] + (x[0] - x1) * (x[0] - x1) + get(x1, t[i], x, d);
            ll c2 = m2 * t[i] + (x[0] - x2) * (x[0] - x2) + get(x2, t[i], x, d);
            if (c1 <= c2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        mn = INF;
        for (ll j = l; j <= r; j++) {
            ll x1 = x0 + d * j;
            ll c1 = j * t[i] + (x[0] - x1) * (x[0] - x1) + get(x1, t[i], x, d);
            mn = min(mn, c1);
        }
        ans = min(ans, mn);
        swap(x[0], x[1]);
        cout << ans << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
