#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll, ll>>

const ll N = 5e5;
vii g;
vi used;
vii dp(N, vi(2));

void dfs(ll v) {
    used[v] = 1;
    ll sum1 = 0;
    vi child;
    for (ll to : g[v]) {
        if (!used[to]) {
            dfs(to);
            sum1 += max(dp[to][0], dp[to][1]);
            child.pb(to);
        }
    }
    for (ll to : child) {
        dp[v][1] = max(dp[v][1], sum1 - max(dp[to][0], dp[to][1]) + 1 + dp[to][0]);
    }
    dp[v][0] = sum1;
}

void solve() {
    ll n, d;
    cin >> n >> d;
    used.assign(n, 0);
    g.assign(n, vi());
    for (ll i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    dfs(0);
    cout << max(dp[0][0], dp[0][1])<< endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test = 1;
   // cin >> test;
    while (test--) {
        solve();
    }
}
