#include <iostream>
#include <vector>
#include <string>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<string> a(n + 1);
    string s = "";
    for (int i = 0; i < m; ++i) {
        s += '0';
    }
    a[0] = s;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>> (m + 1, vector<ll> (m + 1)));
    vector<vector<ll>> next(n + 1, vector<ll> (m + 1, -1));
    for (ll i = 1; i <= n; ++i) {
        ll cntnw = 0, l2 = 0, r2 = -1;

        for (ll j = 0; j < m; ++j) {
            if (a[i][j] == '1') {
                if (cntnw == 0) {
                    l2 = j, r2 = j;
                } else {
                    r2++;
                }
                cntnw++;
            } else {
                for (int k = l2; k <= r2; ++k) {
                    next[i][k] = r2;
                }
                l2 = 0, r2 = -1;
                cntnw = 0;
            }
        }
        for (int k = l2; k <= r2; ++k) {
            next[i][k] = r2;
        }
    }
    ll mx = 0;
    for (ll i = 1; i <= n; ++i) {
        ll cntnw = 0, l2 = 0, r2 = -1;
        for (ll j = 0; j < m; ++j) {

            if (a[i][j] == '1') {
                if (cntnw == 0) {
                    l2 = j, r2 = j;
                } else {
                    r2++;
                }
                cntnw++;
            } else {
                for (ll k = l2; k <= r2; ++k) {
                    for (ll l = k; l <= r2; ++l) {
                        if (next[i - 1][k] == -1) {
                            dp[i][k][l] = l - k + 1;
                        } else {
                            dp[i][k][l] = dp[i - 1][k][min(l, next[i - 1][k])] + l - k + 1;
                        }
                        mx = max(mx, dp[i][k][l]);
                    }
                }
                l2 = 0, r2 = -1;
                cntnw = 0;
            }
        }
        for (ll k = l2; k <= r2; ++k) {
            for (ll l = k; l <= r2; ++l) {
                if (next[i - 1][k] == -1) {
                    dp[i][k][l] = l - k + 1;
                } else {
                    dp[i][k][l] = dp[i - 1][k][min(l, next[i - 1][k])] + l - k + 1;
                }
                mx = max(mx, dp[i][k][l]);
            }
        }
    }

    cout << mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll T = 1;
    //cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}
// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.