#include <iostream>
#include <vector>
#include <string>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e9;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, pair<ll, ll>>> p(k);
    bool okk = 0;
    for (int i = 0; i < k; ++i) {
        cin >> p[i].se.fi >> p[i].fi >> p[i].se.se;
        if (p[i].se.fi == 1 && p[i].se.se == n) {
            okk = 1;
        }
    }
    vector<ll> per(k);
    for (int i = 0; i < k; ++i) {
        per[i] = i;
    }
    do {
        vector<int> used(n + 1);
        for (int i = 0; i < k; ++i) {
            ll nw = per[i];
            if (!used[p[nw].fi]) {
                for (int j = p[nw].se.fi; j <= p[nw].se.se; ++j) {
                    used[j] = 1;
                }
            }
        }
        bool ok = 1;
        for (int i = 1; i <= n; ++i) {
            if (!used[i]) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            cout << "YES";
            return;
        }
    } while (next_permutation(per.begin(), per.end()));
    cout << "NO";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}