#include <bits/stdc++.h>
using namespace std;

// #define FILE

int n, d;
const int INF = 1e9, N = 5e5;
vector<int> dp0(N), dp1(N); // dp0 - не берем с ним
vector<vector<int>> g(N);
vector<int> pred(N, -1); // с кем берем

void dfs(int v, int p) {
    int sum = 0;
    for (auto x : g[v]) {
        if (x == p) continue;
        dfs(x, v);
        sum += max(dp0[x], dp1[x]);
    }
    dp0[v] = sum;
    for (auto x : g[v]) {
        if (x == p) continue;
        sum -= max(dp0[x], dp1[x]);
        if (dp1[v] < sum + dp0[x] + 1) {
            dp1[v] = sum + dp0[x] + 1;
            pred[v] = x;
        }
        sum += max(dp0[x], dp1[x]);
    }
}

vector<pair<int, int>> otv;

void get_ans(int v, int p, int f) {
    if (f ||  dp0[v] > dp1[v]) {
        for (auto x : g[v]) {
            if (x == p) continue;
            get_ans(x, v, 0);
        }
    } else {
        for (auto x : g[v]) {
            if (x == p) continue;
            if (x == pred[v]) {
                otv.push_back({v, x});
                get_ans(x, v, 1);
            } else {
                get_ans(x, v, 0);
            }
        }
    }
    
}





signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y; x--; y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0, 0);
    get_ans(0, 0, 0);
    cout << otv.size() << endl;
    for (auto [x, y] : otv) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}