#include <bits/stdc++.h>

using namespace std;
using ll=long long;
using ull=unsigned long long;
using ld=long double;

#define all(x) x.begin(), x.end()
#define arr(x) x.rbegin(), x.rend()
#define deb(x) cout<<__LINE__<<": "<<(#x)<<" = "<<x<<endl;
#define int ll

struct node {
    int first,second,third;
    node() {}
    node(int a, int b, int c) : first(a), second(b),  third(c) {}
};
constexpr int INF=1e18;
vector<node> t;
vector<pair<int, int>> d;
node merge(node a, node b) {
    if (a.first>b.first) swap(a,b);
    return {a.first, a.second, a.third+b.third};
}
void build(int p, int l, int r) {
    if (l+1==r) {
        t[p]={0, l, 0};
        return;
    }
    int m=(l+r)/2;
    build(p*2+1, l, m);
    build(p*2+2, m, r);
    t[p]=merge(t[p*2+1], t[p*2+2]);
}
void push(int p, int l, int r) {
    int m=(l+r)/2;
    t[p*2+1].first+=d[p].first;
    t[p*2+2].first+=d[p].first;
    t[p*2+1].third+=d[p].second*(m-l);
    t[p*2+2].third+=d[p].second*(r-m);
    d[p*2+1].first+=d[p].first;
    d[p*2+2].first+=d[p].first;
    d[p*2+1].second+=d[p].second;
    d[p*2+2].second+=d[p].second;
    d[p]={0,0};
}
void add(int p, int l, int r, int ql, int qr, int v1, int v2) {
    if (l>=qr || r<=ql) return;
    if (ql<=l && r<=qr) {
        t[p].first+=v1;
        t[p].third+=v2*(r-l);
        d[p].first+=v1;
        d[p].second+=v2;
        return;
    }
    push(p, l, r);
    int m=(l+r)/2;
    add(p*2+1, l, m, ql, qr, v1, v2);
    add(p*2+2, m, r, ql, qr, v1, v2);
    t[p]=merge(t[p*2+1], t[p*2+2]);
}
node get(int p, int l, int r, int ql, int qr) {
    if (l>=qr || r<=ql) return {INF, 0, 0};
    if (ql<=l && r<=qr) {
        return t[p];
    }
    push(p, l, r);
    int m=(l+r)/2;
    return merge(get(p*2+1, l, m, ql, qr), get(p*2+2, m, r, ql, qr));
}
void solve() {
    int n,k;
    cin>>n>>k;
    vector<node> a(k);
    vector<int> b(n);
    vector<set<int>> c(k);
    for (auto i=0; i<k; ++i) cin>>a[i].first>>a[i].second>>a[i].third;
    for (auto i=0; i<k; ++i) {
        for (auto j=0; j<k; ++j) {
            if (i!=j && a[i].second>=a[j].first && a[j].second<=a[i].third && a[i].second<=a[j].third && a[j].second>=a[i].first) {
                c[i].insert(j);
                c[j].insert(i);
            }
        }
    }
    set<int> l;
    for (auto i=0; i<k; ++i) l.insert(i);
    t.assign(4*n, node());
    d.assign(4*n, {0,0});
    build(0,0,n);
    for (auto i=0; i<k; ++i) {
        add(0,0,n,a[i].first-1,a[i].third,1, i);
    }
    while (l.size()) {
        auto y=t[0];
        if (y.first==0) {
            cout<<"NO\n";
            return;
        }else  {
            int z=0;
            if (y.first==1) z=get(0,0,n,y.second, y.second+1).third;
            else {
                z=*l.begin();
            }
            add(0,0,n,a[z].first-1, a[z].third, INF, 0);
            l.erase(z);
            for (auto r: c[z]) {
                add(0,0,n,a[r].first-1, a[r].third, -1, -r);
                for (auto j: c[r]) {
                    if (j!=z)
                    c[j].erase(r);
                }
                c[r].clear();
                l.erase(r);
            }
            c[z].clear();
        }
    }
    auto y=t[0];
    if (y.first==0) {
        cout<<"NO\n";
        return;
    }
    cout<<"YES\n";
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin>>t;
    while (t--) solve();
}