#include <bits/stdc++.h>
 
using ll = long long;
 
#define pb push_back
#define int ll
 
const int INF = 1e18;
 
using namespace std;
 
int n;
vector<int>x;
int x0, d;
int m;
int t;
 
signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
 
    cin >> n;
    x.resize(n);
    for (int i=0; i<n; i++) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    cin >> x0 >> d;
    cin >> m;

    vector<pair<int, int>>best(n);
    for (int i=0; i<n; i++) {
        int l = x[i]/d;
        int r = l+1;
        int l_res = (x[i]-l*d)*(x[i]-l*d);
        int r_res = (x[i]-r*d)*(x[i]-r*d);
        if (l_res <= r_res) {
            best = {l, l_res};
        }
        else {
            best = {r_res};
        }
    }
    vector<int>suf(n+1);
    suf[n] = 0;
    for (int i=n-1; i>=0; i--) {
        suf[i] = suf[i+1]+x[i];
    }
    vector<int>suf2(n+1);
    suf2[n] = 0;
    for (int i=n-1; i>=0; i--) {
        suf2[i] = suf2[i+1]+x[i]*x[i];
    }

    while (m--) {
        cin >> t;
        int ans = INF;
        int uk = -1;
        int best_res = 0;
        for (int k = 0; k <= 1e6; k++) {
            while (uk < n and best[uk].first <= k) {
                uk++;
                best_res += best[uk].second;
            }
            int cur = best_res + suf2[uk+1] + (k*d)*(k*d)*(n-uk)-(k*d)*suf[uk+1]*2;
            ans = min(ans, cur);
        }
        cout << ans << "\n";
    }
 
}