#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
#define int __int128
const int MAXN = 3e5 + 1;
int A[MAXN];

istream &operator>>(istream &in, __int128 &x) {
    long long tmp;
    in >> tmp;
    x = tmp;
    return in;
}

ostream &operator<<(ostream &out, __int128 x) {
    out << (long long) x;
    return out;
}

array<int, 6> move(int res, int sumx, int cnt, int a_last, int x0, int d) {
    while (a_last >= 0 && A[a_last] <= x0 + d) {
        res -= (A[a_last] - x0) * (A[a_last] - x0);
        res += min(A[a_last] - x0, x0 + d - A[a_last]) * min(A[a_last] - x0, x0 + d - A[a_last]);
        sumx -= A[a_last];
        cnt--;
        a_last--;
    }
    x0 += d;
    res -= 2 * sumx * d - d * d * (2 * x0 / d - 1) * cnt;
    return {res, sumx, cnt, a_last, x0, d};
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> A[i];
    sort(A, A + n);
    reverse(A, A + n);
    int x0, d, m;
    cin >> x0 >> d >> m;
    vector<pair<int, int> > T(m);
    for (int i = 0; i < m; i++) {
        cin >> T[i].first;
        T[i].second = i;
    }
    sort(T.rbegin(), T.rend());
    vector<int> ans(m);
    for (auto [t, qi]: T) {
        int res = 0;
        for (int i = 0; i < n; i++) {
            res += (A[i] - x0) * (A[i] - x0);
        }
        ans[qi] = res;
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
