#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (auto& [l, m, r] : a) cin >> l >> m >> r;
    ranges::sort(a);
    vector<bool> ok(k);
    auto isec = [&](int fl, int fr, int sl, int sr) {
        if (fl > sl) {
            swap(fl, sl);
            swap(fr, sr);
        }
        return (fl <= sl && sl <= fr);
    };
    for (int i = 0; i < k; ++i) {
        auto [l, m, r] = a[i];
        if (l == 1) {
            ok[i] = 1;
        } else {
            for (int j = 0; j < i; ++j) {
                auto [tl, tm, tr] = a[j];
                if ((!isec(l, m, tl, tm) || !isec(m, r, tm, tr)) && l <= tr + 1) {
                    ok[i] = (ok[i] | ok[j]);
                }
            }
        }
    }
    bool ans = 0;
    for (int i = 0; i < k; ++i) {
        auto [l, m, r] = a[i];
        if (r == n) ans |= ok[i];
    }
    cout << (ans ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tst;
    cin >> tst;
    while (tst--) {
        solve();
    }
}