#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i128 = ll;

constexpr ll inf = 0x3f3f3f3f3f3f3f3f;

inline ll sq(ll x) {
    return x * x;
}

bool ckmin(i128& a, i128 b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

const int max_lg = 31;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    ranges::sort(a);
    int x0, d;
    cin >> x0 >> d;
    vector<int> lft, rig;
    for (int i = 0; i < n; ++i) {
        if (a[i] < x0) lft.push_back(a[i]);
        else if (a[i] > x0) rig.push_back(a[i]);
    }
    ranges::reverse(lft);
    int lsz = (int) lft.size(), rsz = (int) rig.size();
    ll mn = x0;
    vector<ll> l_opt(lsz), r_opt(rsz), l_val(lsz), r_val(rsz);
    for (int i = 0; i < lsz; ++i) {
        ll cx = lft[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 - t * d, rx = x0 - (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mn = min(mn, opt);
        l_opt[i] = opt;
        l_val[i] = sq(cx - opt);
    }
    ll mx = x0;
    for (int i = 0; i < rsz; ++i) {
        ll cx = rig[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 + t * d, rx = x0 + (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mx = max(mx, opt);
        r_opt[i] = opt;
        r_val[i] = sq(cx - opt);
    }
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        ll ff = 0, ss = 0;
        {
            auto get = [&](ll cnt) {
                if (cnt < 0) cnt = 0;
                i128 x = x0 - cnt * d, val = t * cnt;
                for (int i = 0; i < (int) lft.size(); ++i) {
                    if (x <= l_opt[i]) {
                        val += l_val[i];
                    } else {
                        val += sq(x - lft[i]);
                    }
                }
                return val;
            };
            ll cur = 0;
            for (ll pw = (1ll << max_lg); pw; pw >>= 1) {
                ll lx = cur - pw, rx = cur + pw;
                if (lx < 0) lx = 0;
                if (get(lx) < get(cur)) cur = lx;
                if (get(rx) < get(cur)) cur = rx;
            }
            ff = get(cur);
        }
        {
            auto get = [&](ll cnt) {
                i128 x = x0 + cnt * d, val = t * cnt;
                for (int i = 0; i < (int) rig.size(); ++i) {
                    if (x >= r_opt[i]) {
                        val += r_val[i];
                    } else {
                        val += sq(x - rig[i]);
                    }
                }
                return val;
            };
            ll cur = 0;
            for (ll pw = (1ll << max_lg); pw; pw >>= 1) {
                ll lx = cur - pw, rx = cur + pw;
                if (lx < 0) lx = 0;
                if (get(lx) < get(cur)) cur = lx;
                if (get(rx) < get(cur)) cur = rx;
            }
            ss = get(cur);
        }
        ll ans = inf;
        {
            auto get = [&](ll cnt) {
                i128 x = x0 - cnt * d, val = t * 2 * cnt;
                for (int i = 0; i < (int) lft.size(); ++i) {
                    if (x <= l_opt[i]) {
                        val += l_val[i];
                    } else {
                        val += sq(x - lft[i]);
                    }
                }
                return val;
            };
            ll cur = 0;
            for (ll pw = (1ll << max_lg); pw; pw >>= 1) {
                ll lx = cur - pw, rx = cur + pw;
                if (lx < 0) lx = 0;
                if (get(lx) < get(cur)) cur = lx;
                if (get(rx) < get(cur)) cur = rx;
            }
            ans = min(ans, get(cur) + ss);
        }
        {
            auto get = [&](ll cnt) {
                i128 x = x0 + cnt * d, val = t * 2 * cnt;
                for (int i = 0; i < (int) rig.size(); ++i) {
                    if (x >= r_opt[i]) {
                        val += r_val[i];
                    } else {
                        val += sq(x - rig[i]);
                    }
                }
                return val;
            };
            ll cur = 0;
            for (ll pw = (1ll << max_lg); pw; pw >>= 1) {
                ll lx = cur - pw, rx = cur + pw;
                if (lx < 0) lx = 0;
                if (get(lx) < get(cur)) cur = lx;
                if (get(rx) < get(cur)) cur = rx;
            }
            ans = min(ans, ff + get(cur));
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tst = 1;
    // cin >> tst;
    while (tst--) {
        solve();
    }
}