#include <bits/stdc++.h>

using namespace std;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (int i = 0; i < h; ++i) {
        cin >> a[i];
    }
    vector<int> cnt_up(w);
    int ans = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == '0') {
                cnt_up[j] = 0;
            } else {
                cnt_up[j]++;
            }
        }
        vector<int> nxt(w, w), ans_nw(w + 1);
        vector<int> st;
        for (int j = 0; j < w; ++j) {
            while (!st.empty() && cnt_up[st.back()] > cnt_up[j]) {
                nxt[st.back()] = j;
                st.pop_back();
            }
            st.push_back(j);
        }
        for (int j = w - 1; j >= 0; --j) {
            ans_nw[j] = ans_nw[nxt[j]] + (nxt[j] - j) * cnt_up[j];
            ans = max(ans, ans_nw[j]);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
