#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    vector<int> x_l, x_r;
    for (int i = 0; i < n; ++i) {
        if (x[i] < x0) {
            x_l.push_back(x[i]);
        } else if (x[i] > x0) {
            x_r.push_back(x[i]);
        }
    }
    auto get_ans_x = [&](int x_nw) -> long long {
        int pos_l, pos_r;
        if (x_nw % d == x0 % d) {
            pos_l = pos_r = x_nw;
        } else {
            if (x_nw % d > x0 % d) {
                pos_l = x_nw - (x_nw % d - x0 % d);
                pos_r = pos_l + d;
            } else {
                pos_r = x_nw + (x0 % d - x_nw % d);
                pos_l = pos_r - d;
            }
        }
        return min((x_nw - pos_l) * 1LL * (x_nw - pos_l), (x_nw - pos_r) * 1LL * (x_nw - pos_r));
    };
    vector<__int128_t> pr_sum_l(x_l.size() + 1), pr_sum_l2(x_l.size() + 1), pr_sum_l_ans(x_l.size() + 1);
    for (int i = 0; i < (int)x_l.size(); ++i) {
        pr_sum_l[i + 1] = pr_sum_l[i] + x_l[i];
        pr_sum_l2[i + 1] = pr_sum_l2[i] + x_l[i] * 1LL * x_l[i];
        pr_sum_l_ans[i + 1] = pr_sum_l_ans[i] + get_ans_x(x_l[i]);
    }
    vector<__int128_t> pr_sum_r(x_r.size() + 1), pr_sum_r2(x_r.size() + 1), pr_sum_r_ans(x_r.size() + 1);
    for (int i = 0; i < (int)x_r.size(); ++i) {
        pr_sum_r[i + 1] = pr_sum_r[i] + x_r[i];
        pr_sum_r2[i + 1] = pr_sum_r2[i] + x_r[i] * 1LL * x_r[i];
        pr_sum_r_ans[i + 1] = pr_sum_r_ans[i] + get_ans_x(x_r[i]);
    }
    // auto get_ans_nw = [&](int t, int l, int r) -> __int128_t {
    //     __int128_t ans_nw = min(x0 - l, r - x0) / d * 2LL * t + max(x0 - l, r - x0) / d * 1LL * t;
    //     int pos_l = lower_bound(x_l.begin(), x_l.end(), l) - x_l.begin();
    //     int pos_r = upper_bound(x_r.begin(), x_r.end(), r) - x_r.begin();
    //     ans_nw += pr_sum_l_ans.back() - pr_sum_l_ans[pos_l];
    //     ans_nw += pr_sum_r_ans[pos_r];
    //     ans_nw += pr_sum_l2[pos_l];
    //     ans_nw += pr_sum_r2.back() - pr_sum_r2[pos_r];
    //     __int128_t l_nw = l, r_nw = r;
    //     ans_nw += l_nw * l_nw * pos_l;
    //     ans_nw += r_nw * r_nw * ((int)x_r.size() - pos_r);
    //     ans_nw -= l_nw * 2 * pr_sum_l[pos_l];
    //     ans_nw -= r_nw * 2 * (pr_sum_r.back() - pr_sum_r[pos_r]);
    //     return ans_nw;
    // };
    auto get_ans_nw_l = [&](int t, int l) -> __int128_t {
        __int128_t ans_nw = (x0 - l) / d * 1LL * t;
        int pos_l = lower_bound(x_l.begin(), x_l.end(), l) - x_l.begin();
        ans_nw += pr_sum_l_ans.back() - pr_sum_l_ans[pos_l];
        ans_nw += pr_sum_l2[pos_l];
        __int128_t l_nw = l;
        ans_nw += l_nw * l_nw * pos_l;
        ans_nw -= l_nw * 2 * pr_sum_l[pos_l];
        return ans_nw;
    };
    auto get_ans_nw_r = [&](int t, int r) -> __int128_t {
        __int128_t ans_nw = (r - x0) / d * t;
        int pos_r = upper_bound(x_r.begin(), x_r.end(), r) - x_r.begin();
        ans_nw += pr_sum_r_ans[pos_r];
        ans_nw += pr_sum_r2.back() - pr_sum_r2[pos_r];
        __int128_t r_nw = r;
        ans_nw += r_nw * r_nw * ((int)x_r.size() - pos_r);
        ans_nw -= r_nw * 2 * (pr_sum_r.back() - pr_sum_r[pos_r]);
        return ans_nw;
    };
    auto get_ans_nw = [&](int t_l, int t_r, int l, int r) -> __int128_t {
        return get_ans_nw_l(t_l, x0 - l * d) + get_ans_nw_r(t_r, x0 + r * d);
    };
    auto get_l = [&](int t) -> int {
        int l_add = -1, r_add = x0 / d + 2;
        while (l_add < r_add - 1) {
            int m_add = (l_add + r_add) / 2;
            __int128_t ans1 = get_ans_nw_l(t, x0 - m_add * d), ans2 = get_ans_nw_l(t, x0 - (m_add + 1) * d);
            if (ans1 > ans2) {
                l_add = m_add;
            } else {
                r_add = m_add;
            }
        }
        return r_add;
    };
    auto get_r = [&](int t) -> int {
        int l_add = -1, r_add = (x.back() - x0) / d + 2;
        while (l_add < r_add - 1) {
            int m_add = (l_add + r_add) / 2;
            __int128_t ans1 = get_ans_nw_r(t, x0 + m_add * d), ans2 = get_ans_nw_r(t, x0 + (m_add + 1) * d);
            if (ans1 > ans2) {
                l_add = m_add;
            } else {
                r_add = m_add;
            }
        }
        return r_add;
    };
    auto get_ans = [&](int t) -> __int128_t {
        int l1 = get_l(t), l2 = get_l(t * 2), r1 = get_r(t), r2 = get_r(t * 2);
        __int128_t ans = get_ans_nw(t, t, 0, 0);
        ans = min(ans, get_ans_nw(t, t * 2, l1, r2));
        ans = min(ans, get_ans_nw(t * 2, t, l2, r1));
        return ans;
    };
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        cout << (unsigned long long)get_ans(t) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
