#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<int>> g, dp;

void dfs(int v, int p) {
    vector<pair<int, int>> c;
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
            dp[v][0] += max(dp[to][0], dp[to][1]);
            c.push_back({dp[to][1] - dp[to][0], to});
        }
    }
    sort(c.begin(), c.end());
    if (c.size()) {
        int j = c[0].second;
        for (auto to : g[v]) {
            if (to != p && to != j) {
                dp[v][1] += max(dp[to][0], dp[to][1]);
            }
        }
        dp[v][1] += 2 + dp[j][0];
    }
}


void solve() {
    ll n, d; cin >> n >> d;
    g.resize(n);
    dp.resize(n, vector<int>(2));
    for (int i = 0; i < n - 1; i++) {
        ll v, u; cin >> v >> u;
        v--, u--;
        g[v].push_back(u), g[u].push_back(v);
    }
    dfs(0, -1);
    cout << max(dp[0][1], dp[0][0]) / 2;
}

int main() {
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}