#include <iostream>
#include <vector>
#include <bitset>
#include <random>
#include <chrono>
#include <algorithm>

using namespace std;
int n, k;

mt19937 rng(time(0));

vector <bool> ban;
vector <bool> used;
vector <vector <int>> seg;
int cnt;


bool dfs(int v) {

    int l = seg[v][0], r = seg[v][1], m = seg[v][2];
    //cout <<"&" << l << " " << r << "&\n";
    if (used[m]) {
        return false;
    }
   // for (int i = 0; i < k; i++) {
   //     cout << ban[i];
    //}
    //cout << "\n";
    vector <int> changed;
    for (int i = l; i <= r; i++) {
        if (!used[i]) {
            used[i] = true;
            changed.push_back(i);
            cnt++;
        }
    }
    if (cnt == n) {
        return true;
    }
    vector <int> changed2;
    ban[v] = true;
    for (int i = 0; i < k; i++) {
        if (!ban[i]) {
            if (seg[i][2] >= l && seg[i][2] <= r) {
                ban[i] = true;
                changed2.push_back(i);
            }
        }
    }
    //cout << cnt << "\n";
    for (int i = 0; i < k; i++) {
        //cout << ban[i];
        if (!ban[i]) {
            if (dfs(i)) {
                return true;
            }
        }
    }
    //cout << "\n";
    for (int j = 0; j < changed.size(); j++) {
        cnt--;
        used[changed[j]] = false;
    }
    for (int j = 0; j < changed2.size(); j++) {
        ban[changed2[j]] = false;
    }
    ban[v] = false;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qtest;
    cin >> qtest;
    for (int _ = 0; _ < qtest; _++) {
        cin >> n >> k;
        seg.clear();
        seg.resize(k, vector <int> (3));
        for (int i = 0; i < k; i++) {
            cin >> seg[i][0] >> seg[i][2] >> seg[i][1]; //l, r, m
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
        }
        ban.clear();
        ban.resize(k);
        vector <int> nums(k);
        iota(nums.begin(), nums.end(), 0);
        shuffle(nums.begin(), nums.end(), rng);
        bool fl = false;
        used.clear();
        used.resize(n);
        cnt = 0;
        for (int i = 0; i < k; i++) {
            //cout << cnt << "*\n";
            if (dfs(nums[i])) {
                fl = true;
                break;
            }
        }
        if (fl) {
            cout << "YES\n";
    }   else {
            cout << "NO\n";
    }
    }

}

