#include <iostream>
#include <vector>

using namespace std;

vector <vector <int>> a;

int dfs(int v, int p, int versh, int h) {
    if (v == versh) {
        return h;
    }
    int min_ = 1000000001;
    for (int i = 0; i < a[v].size(); i++) {
        int to = a[v][i];
        if (to != p) {
            min_ = min(min_, dfs(to, v, versh, h + 1));
        }
        if (min_ != 1000000001) {
            return min_;
        }
    }
    return min_;
}

int dist(int u, int v) {
    return dfs(u, u, v, 0);
}

vector <int> mt;
vector <vector <bool>> pos;

int func(vector <bool> used) {
    int n = used.size();
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt += used[i];
    }
    if (cnt <= 1) {
        return 0;
    }
    int pos;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            pos = i;
            break;
        }
    }
    int maxres = -1;
    for (int i = pos + 1; i < n; i++) {
        if (used[i]) {
            used[pos] = false;
            used[i] = false;
            maxres = max(maxres, func(used) + 1);
        }
    }
    return maxres;
}

int main() {
    int n, D;
    cin >> n >> D;
    a.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        a[u].push_back(v);
        a[v].push_back(u);
    }
    pos.resize(n, vector <bool> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int d = dist(i, j);
            if (d <= D && d % 2 == 1) {
                pos[i][j] = true;
            }
        }
    }
    vector <int> y;
    vector <bool> used(n, true);
}
