#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> d;

void upd(int item, int l, int r, int v) {
    if (r <= item || item < l) {
        return;
    }

    if (r == l + 1) {
        d[v] += 1;
        return;
    }

    int m = (l + r) / 2, v1 = 2 * v + 1, v2 = 2 * v + 2;

    upd(item, l, m, v1);
    upd(item, m, r, v2);

    d[v] = d[v1] + d[v2];
}

int sum(int ql, int qr, int l,  int r, int v) {
    if (qr <= l || r <= ql)
        return 0;

    if (ql <= l && r <= qr)
        return d[v];

    int m = (l + r) / 2, v1 = 2 * v + 1, v2 = 2 * v + 2;

    return sum(ql, qr, l, m, v1) + sum(ql, qr, m, r, v2);
}

void solve() {
    int n, k;

    cin >> n >> k;

    vector<vector<int>> v(k, vector<int> (3));

    for (int i = 0; i < k; ++i) {
        cin >> v[i][0] >> v[i][2] >> v[i][1];
    }

    sort(v.begin(), v.end());

    d.assign(4 * n + 4, 0);
    upd(0, 0, n + 1, 0);
    for (int i = 0; i < k; ++i) {
        int l = v[i][0];
        int r = v[i][1];
        int m = v[i][2];

        if (sum(l - 1, m + 1, 0, n + 1, 0) > 0)
            upd(r, 0, n + 1, 0);
    }

    if (sum(n, n + 1, 0, n + 1, 0) > 0) {
        cout << "YES\n";
    }
    else
        cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}