#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve1(vector<vector<int>>& v, int n, int k) {
    sort(v.begin(), v.end());

    int l = n;
    for (int i = 0; i < k; ++i) {
        if (-v[i][0] + 1 < l) {
            cout << "NO\n";
            return;
        }

        l = min(l, v[i][1]);
    }


    if (l != 1) {
        cout << "NO\n";
    }
    else
        cout << "YES\n";
}

void solve2(vector<vector<int>>& v, int n, int k) {
    int r = 0;
    int l = n;

    for (int i = 0; i < k; ++i) {
        if (v[i][2] == 1) {
            r = max(r, -v[i][0]);
        }
        else {
            l = min(l, v[i][1]);
        }
    }

    if (r + 1 < l)
        cout << "NO\n";
    else
        cout << "YES\n";

}

vector<int> d;
vector<bool> f;

void push(int m, int v, int v1, int v2) {
    if (f[v]) {
        d[v1] = 1;
        f[v1] = true;
        d[v2] = 1;
        f[v2] = true;
        f[v] = false;
    }
}

void upd(int ql, int qr, int l, int r, int v) {
    if (r <= ql || qr <= l) {
        return;
    }

    if (ql <= l && r <= qr) {
        d[v] = 1;
        f[v] = true;
        return;
    }

    int m = (l + r) / 2, v1 = 2 * v + 1, v2 = 2 * v + 2;

    push(m, v, v1, v2);
    upd(ql, qr, l, m, v1);
    upd(ql, qr, m, r, v2);

    d[v] = min(d[v1], d[v2]);
}

int ma(int ql, int qr, int l,  int r, int v) {
    if (qr <= l || r <= ql)
        return 1;

    if (ql <= l && r <= qr)
        return d[v];

    int m = (l + r) / 2, v1 = 2 * v + 1, v2 = 2 * v + 2;

    push(m, v, v1, v2);

    return min(ma(ql, qr, l, m, v1), ma(ql, qr, m, r, v2));
}

void solve() {
    int n, k;
    cin >> n >> k;

    bool f1 = true;
    bool f2 = true;
    int r = 0;
    int l = n;

    vector<vector<int>> v(k, vector<int>(3));
    for (int i = 0; i < k; ++i) {
        cin >> v[i][1] >> v[i][2] >> v[i][0];
        v[i][0] *= -1;
        if (v[i][2] != v[i][1])
            f1 = false;
        if (v[i][2] != n && v[i][2] != 1)
            f2 = false;

        if (v[i][2] == 1) {
            r = max(r, -v[i][0]);
        }
        else if (v[i][2] == n){
            l = min(l, v[i][1]);
        }
    }

    if (f1) {
        solve1(v, n, k);
        return;
    }

    if (f2) {
        if (r + 1 < l)
            cout << "NO\n";
        else
            cout << "YES\n";
        return;
    }

    vector<int> perm(k);
    for (int i = 0; i < k; ++i)
        perm[i] = i;

    d.assign(4 * n, 0);
    f.assign(4 * n, false);

    for (int i = 0; i < k; ++i) {
        int l = v[i][1] - 1;
        int m = v[i][2] - 1;
        int r = -v[i][0] - 1;

        if (ma(m, m + 1, 0 , n, 0) == 0)
            upd(l, r + 1, 0, n, 0);
    }

    if (d[0]) {
        cout << "YES\n";
        return;
    }

    while (next_permutation(perm.begin(), perm.end())) {
        d.assign(4 * n, 0);
        f.assign(4 * n, false);
        for (auto i : perm) {
            int l = v[i][1] - 1;
            int m = v[i][2] - 1;
            int r = -v[i][0] - 1;

            if (ma(m, m + 1, 0 , n, 0) == 0)
                upd(l, r + 1, 0, n, 0);
        }

        if (d[0]) {
            cout << "YES\n";
            return;
        }
    }

    cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}