#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> v(n);
	for (auto& x : v) cin >> x;

	vector<vector<int>> dp(n, vector<int>(m)), len(n, vector<int>(m));
	int ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (v[i][j] == '0') continue;
			len[i][j] = (j + 1 < m ? len[i][j + 1] : 0) + 1;
			if (i + 1 < n) {
				dp[i][j] = dp[i + 1][j] + min(len[i][j], len[i + 1][j]);
				dp[i][j] = max(dp[i][j], len[i][j]);
			}
			else dp[i][j] = len[i][j];
			ans = max(ans, dp[i][j]);
		}
	}

	cout << ans;
}

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}