 #ifdef LOCAL
 #define _GLIBCXX_DEBUG
 #endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

struct lf {

	lf() {}
	lf(ll k, ll b) : k(k), b(b) {}

	ll get(ll x) {
		return k * x + b;
	}

	ll k = 0, b = 1e18;

};

ld intersect(lf a, lf b) {
	assert(a.k != b.k);
	return (ld)(a.b - b.b) / (b.k - a.k);
}

struct cht {

	cht() {}

	void add(lf f) {
		while (v.size() >= 2 && intersect(f, v[v.size() - 2]) >= p.back()) {
			v.pop_back();
			p.pop_back();
		}
		if (v.empty()) {
			p.push_back(4e18);
		} else {
			p.push_back(intersect(f, v.back()));
		}
		v.push_back(f);
	}

	ll get(ll x) {
		// for (auto f : v) cout << f.k << " " << f.b << "\n";
		// for (ld x : p) cout << x << " ";
		// cout << "\n";
		assert(!v.empty());
		int pos = lower_bound(rall(p), x) - p.rbegin();
		// cout << x << ": " << pos << "\n";
		pos = v.size() - pos - 1;
		return v[pos].get(x);
	}

	vector<lf> v;
	vector<ld> p;

};

using i128 = __int128_t;

vector<ll> solve(vector<int> x, int d, vector<int> t) {
	if (x.empty()) {
		return vector<ll>(t.size(), 0);
	}
	int n = x.size(), m = t.size();
	vector<i128> suff(n + 1), suff2(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		suff[i] = x[i];
		suff2[i] = (ll)x[i] * x[i];
		suff[i] += suff[i + 1];
		suff2[i] += suff2[i + 1];
	}

	// for (int y : x) cout << y << " ";
	// cout << "\n";

	vector<ll> ans(m, 4e18);
	for (int id = 0; id < m; id++) {
		for (int i = 0; i < n; i++) {
			ll l = (i == 0 ? 0 : x[i - 1]), r = x[i];
			ll opt = (ll)((ld)(2 * suff[i] - t[id]) / (ld)(2ll * (n - i)));
			opt = max(l, min(r, opt));

			auto upd = [&](ll x) {
				i128 r = (i128)x * t[id] + (i128)x * x * (n - i) - (i128)2 * x * suff[i] + suff2[i];
				if (r < ans[id]) ans[id] = (ll)r;
			};

			for (ll x = max(l, opt - 5); x <= min(r, opt + 5); x++) upd(x);
			for (ll x = l; x <= min(r, l + 2); x++) upd(x);
			for (ll x = max(l, r - 2); x <= r; x++) upd(x);
		}
	}

	return ans;
}

// 3
// 0 4 5
// 2 1
// 5
// 0
// 1
//
// 2
// 3
// 4

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int n;
	cin >> n;
	vector<int> x(n);
	for (int& y : x) cin >> y;
	sort(all(x));
	int x0, d, m;
	cin >> x0 >> d >> m;
	vector<int> t(m);
	for (int& y : t) cin >> y;

	vector<int> x1, x2;
	for (int i = 0; i < n; i++) {
		if (x[i] < x0) x1.push_back(x0 - x[i]);
		else x2.push_back(x[i] - x0);
	}
	reverse(all(x1));

	auto ans1  = solve(x1, d, t);
	auto ans3 = solve(x2, d, t);
	for (int i = 0; i < m; i++) t[i] *= 2;
	auto ans2 = solve(x1, d, t);
	auto ans4 = solve(x2, d, t);
	for (int i = 0; i < m; i++) {
		cout << min(ans1[i] + ans4[i], ans2[i] + ans3[i]) << "\n";
	}
}