#include <bits/stdc++.h>
#define int long long
using namespace std;

struct seg {
    int l, m, r;

    void in() {
        cin >> l >> m >> r;
    }
};

bool cmp(seg a, seg b) {
    return a.m < b.m;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    for (int i = 0; i < k; ++i) {
        a[i].in();
    }
    sort(a.begin(), a.end(), cmp);
    vector<bool> used(n + 1, false);
    for (int i = 0; i < k; ++i) {
        if (used[a[i].m])continue;
        for (int j = a[i].l; j <= a[i].r; ++j) {
            used[j] = true;
        }
    }
    bool e = true;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            e = false;
        }
    }
    if (e) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
