#include <bits/stdc++.h>
#define int long long
using namespace std;
const int inf = 2e9, inf1 = 2e18;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        x[i] = abs(x[i]);
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i) {
        x[i] -= x0;
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int l = -(inf / d);
        int r = inf / d;
        while (l + 2 < r) {
            int mid1 = l + (r - l) / 3;
            int mid2 = r - (r - l) / 3;
            __int128 ans1 = mid1 * d + (x[0] - mid1 * d) * (x[0] - mid1 * d);
            __int128 ans2 = mid2 * d + (x[0] - mid2 * d) * (x[0] - mid2 * d);
            if (ans1 < ans2) {
                r = mid2;
            } else {
                l = mid1;
            }
        }
        __int128 ans = inf1;
        for (__int128 i = l - 3; i < r + 3; ++i) {
            ans = min(ans, (__int128) i * d + (x[0] - i * d) * (x[0] - i * d));
        }
        cout << (int) ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
