#include <bits/stdc++.h>
#define int long long
using namespace std;
const int inf = 8e18;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i) {
        x[i] -= x0;
    }
    vector<__int128> pref1(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        pref1[i + 1] = pref1[i] + x[i] * x[i];
    }
    vector<__int128> pref2(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        pref2[i + 1] = pref2[i] + x[i];
    }
    vector<__int128> opt(n, 0);
    vector<__int128> sm(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        sm[i + 1] = sm[i];
        if (x[i] == 0) {
            continue;
        }
        __int128 d1 = x[i] - x[i] / d * d;
        __int128 d2 = x[i] / d * d + d - x[i];
        if (d1 <= d2) {
            opt[i] = x[i] / d;
            sm[i + 1] += d1 * d1;
        } else {
            opt[i] = x[i] / d + 1;
            sm[i + 1] += d2 * d2;
        }
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        __int128 T = t;
        __int128 ans = inf;
        for (__int128 i = 0; i <= 1000000; ++i) {
            __int128 sum = T * i;
            int I = upper_bound(opt.begin(), opt.end(), i) - opt.begin();
            sum += sm[I];
            __int128 Cn = n - I;
            sum += (pref1[n] - pref1[n - Cn]) + Cn * i * (__int128) d * i * (__int128) d - (__int128) 2 * i * (__int128)
                    d * (pref2[n] - pref2[n - Cn]);
            ans = min(ans, sum);
        }
        cout << (int) ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
