#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
void solve() 
{
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> a(k);
	for (int i = 0; i < k; i++)
	{
		int l, r, m;
		cin >> l >> m >> r;
		a[i] = { l - 1,r - 1,m - 1 };
	}
	sort(a.begin(), a.end());
	set<pair<int,int>> last{ {0,-1} };
	for (int i = 0; i < k; i++)
	{
		auto [l, r, m] = a[i];
		auto [lst, lstm] = *last.lower_bound({ l,-1 });
		if (lst <= m||lstm<l)
		{
			last.insert({ r + 1,m });
		}
	}
	if ((*last.rbegin()).first == n)
	{
		cout << "YES\n";
	}
	else
	{
		cout << "NO\n";
	}
}
int main()
{
	int t;
	cin >> t;
	while (t--) solve();
}