#define __GLIBCXX_DEBUG__ 1;
#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> h;
vector<int> used;
vector<pair<int, int>> ans;
void dfs (int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
            if (used[u] + used[v] == 0) {
                ans.push_back({v + 1, u + 1});
                used[u] = used[v] = 1;
            }
        }
    }
}

signed main() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    h.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0, 0);
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first << " " << ans[i].second << endl;
    }
}