#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> arr(n, vector<ll>(m));
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}
	vector<ll> now(n, 0);
	ll ans = 0;
	for (ll i = 0; i < m; i++) {
		for (ll j = 0; j < n; j++) {
			if (arr[i][j] == 0) {
				now[j] = 0;
			} else {
				now[j]++;
			}
		}
		vector<pair<ll, ll>> na;
		na.emplace_back(0, 0);
		ll nsum = 0;
		for (ll j = 0; j < n; j++) {
			ll ncol = 0;
			while (na.back().first > now[j]) {
				auto[a, b] = na.back();
				na.pop_back();
				ncol += b;
				nsum -= a * b;
			}
			ncol++;
			nsum += now[j] * ncol;
			na.emplace_back(now[j], ncol);
			assign_max(ans, nsum);
		}
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
