#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll square(ll x) {
	return x * x;
}

void calc(ll d, vector<ll>& ps, vector<ll>& ans, vector<pair<ll, ll>>& qs) {
	if (ps.empty()) {
		return;
	}
	map<ll, vector<ll>> stops;
	ll n = ps.size();
	__int128 nsums = 0;
	for (auto i : ps) {
		ll fir = i / d * d;
		ll sec = fir + d;
		if (i - fir <= sec - i) {
			stops[fir].push_back(i);
			nsums += square(i - fir);
		} else {
			stops[sec].push_back(i);
			nsums += square(sec - i);
		}
	}
	ll now = stops.rbegin()->first + d;
	__int128 ssq = 0, sx = 0, col = 0;
	for (auto[t, i] : qs) {
		while (true) {
			if (now > 0 && ssq - 2 * (now - d) * sx + square(now - d) * col + (now - d) / d * t < ssq - 2 * now * sx + square(now) * col + now / d * t) {
				now -= d;
			} else {
				break;
			}
			ll nnow = now - (col == 0 ? now : ((t + 2 * now * d * col - 2 * sx * d) / (2 * d * d * col) * d));
			if (nnow < 0) {
				nnow = 0;
			}
			if (!stops.empty() && nnow < stops.rbegin()->first) {
				nnow = stops.rbegin()->first;
			}
			now = nnow;
			if (stops.find(now) == stops.end()) {
				break;
			}
			for (auto j : stops[now]) {
				nsums -= square(now - j);
				ssq += square(j);
				sx += j;
				col++;
			}
			stops.erase(now);
		}
		while (now > 0 && ssq - 2 * (now - d) * sx + square(now - d) * col + (now - d) / d * t < ssq - 2 * now * sx + square(now) * col + now / d * t) {
			now -= d;
			for (auto j : stops[now]) {
				nsums -= square(now - j);
				ssq += square(j);
				sx += j;
				col++;
			}
			stops.erase(now);
		}
		ans[i] = ssq - 2 * now * sx + square(now) * col + now / d * t + nsums;
	}
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) {
		cin >> x[i];
	}
	ll st, d;
	cin >> st >> d;
	vector<ll> otrx, polx;
	for (ll i = 0; i < n; i++) {
		x[i] -= st;
		if (x[i] < 0) {
			otrx.push_back(-x[i]);
		} else {
			polx.push_back(x[i]);
		}
	}
	ll m;
	cin >> m;
	vector<pair<ll, ll>> qs;
	vector<ll> ansotr(m * 2, 0), anspol(m * 2, 0);
	for (ll i = 0; i < m; i++) {
		ll t;
		cin >> t;
		qs.emplace_back(t, i * 2);
		qs.emplace_back(t * 2, i * 2 + 1);
	}
	sort(qs.begin(), qs.end());
	calc(d, otrx, ansotr, qs);
	calc(d, polx, anspol, qs);
	vector<ll> ans(m);
	for (ll i = 0; i < m; i++) {
		ans[i] = min(ansotr[i * 2] + anspol[i * 2 + 1], ansotr[i * 2 + 1] + anspol[i * 2]);
	}
	for (auto i : ans) {
		cout << i << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
