#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;

vector<vector<int>> g, t;

vector<int> ord, used, c;

void dfs1(int v) {
  used[v] = 1;
  for (int u : g[v]) {
    if (!used[u]) {
      dfs1(u);
    }
  }
  ord.push_back(v);
}

void dfs2(int v, int col) {
  c[v] = col;
  for (int u : t[v]) {
    if (c[u] == -1) {
      dfs2(u, col);
    }
  }
}

void solve() {
  int n, k;
  cin >> n >> k;
  g.assign(k, {});
  t.assign(k, {});
  vector<int> l(k), m(k), r(k);
  vector<int> z(n + 1);
  for (int i = 0; i < k; i++) {
    cin >> l[i] >> m[i] >> r[i];
    l[i]--, m[i]--, r[i]--;
    assert(l[i] == 0 || r[i] == n - 1);
    if (r[i] - l[i] + 1 == n) {
      cout << "YES\n";
      return;
    }
    z[l[i]]++;
    z[r[i] + 1]--;
  }
  for (int i = 1; i < n; i++) {
    z[i] += z[i - 1];
  }
  for (int i = 0; i < n; i++) {
    if (z[i] == 0) {
      cout << "NO\n";
      return;
    }
  }

  for (int i = 0; i < k; i++) {
    for (int j = 0; j < k; j++) {
      if (l[i] <= m[j] && m[j] <= r[i]) {
        continue;
      }
      if (l[i] == 0 && r[j] == n - 1 && l[j] <= r[i]) {
        cout << "YES\n";
        return;
      }
      if (l[j] == 0 && r[i] == n - 1 && l[i] <= r[j]) {
        cout << "YES\n";
        return;
      }
    }
  }
  
  cout << "NO"<< '\n';
  return;

  for (int v = 0; v < k; v++) {
    for (int u = 0; u < k; u++) {
      if (v == u) {
        // continue;
      }
      if (l[v] <= m[u] && m[u] <= r[v]) {
        g[u].push_back(v);
        t[v].push_back(u);
      }
    }
  }
  used.assign(k, 0);
  ord.clear();
  c.assign(k, -1);
  for (int v = 0; v < k; v++) {
    if (!used[v]) {
      dfs1(v);
    }
  }
  reverse(ord.begin(), ord.end());
  int col = 0;
  for (int v : ord) {
    if (c[v] == -1) {
      dfs2(v, col);
      col++;
    }
  }
  cout << (col == k ? "YES" : "NO") << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
