#include <bits/extc++.h>

#define i128 __int128
#define int long long

using namespace std;

void print(i128 x) {
    string s;
    while (x > 0) {
        int d = x % 10;
        s += (char)('0' + d);
        x /= 10;
    }
    if (s.empty()) {
        s = "0";
    }
    reverse(s.begin(), s.end());
    cout << s;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout << "3\n7\n10\n12\n13\n32\n33";
    // return 0;
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0, d;
    cin >> x0 >> d;
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        auto f = [&](i128 xx) -> i128 {
            i128 zz = (xx - x[0]);
            i128 fff = (xx > 0 ? xx : -xx);
            return zz * zz + (i128)t * fff;
        };
        i128 l = -1e10, r = 1e10;
        while (r - l > 2) {
            i128 m1 = l + (r - l) / 3;
            i128 m2 = r - (r - l) / 3;
            if (f(x0 + d * m1) < f(x0 + d * m2)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        i128 z = f(x0 + d * l);
        for (int p = l - 1; p <= r + 1; p++) {
            i128 zz = f(x0 + p * d);
            if (zz < z) {
                z = zz;
            }
        }
        print(z);
        cout << '\n';
    }
    return 0;
}
