#pragma GCC optimize("Ofast,unroll-loops")
 
#include <bits/stdc++.h>
 
using namespace std;
 
#define int long long
 
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
 
using ll = long long;
using ull = unsigned long long;
 
const ll INF = 2e18;
 
template <typename T> inline void chmin(T &a, T b) {
    if (b < a) {
        a = b;
    }
}
 
using B = __int128;
void solve() {
    int n, d;
    cin >> n >> d;
    vector c(n, 0);
    int ans = 0;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int>> res;
    vector<int> c0(n), c1(n), c2(n);
    function<void(int, int)> dfs = [&](int v, int p) {
        int a0 = 0;
        int a1 = 0;
        int a2 = 0;
        for (int u : g[v]) {
            if (u == p) continue;
            dfs(u, v);
            int mn = min(a0, c1[u]);
            ans += mn;
            a0 -= mn;
            c1[u] -= mn;
            mn = min(a1, c0[u]);
            ans += mn;
            a1 -= mn;
            c0[u] -= mn;
            a0 += c0[u];
            a1 += c1[u];
            a2 += c2[u];
        }
        if (a2) {
            ++ans;
            c0[v] = 0;
            c1[v] = a0;
            c2[v] = a1;
        }
        else if (a0) {
            ++ans;
            c0[v] = 0;
            c1[v] = a0 - 1;
            c2[v] = a1;
        } else {
            c0[v] = 1;
            c1[v] = a0;
            c2[v]= a1;
        }
    };
    dfs(0, 0);
    cout << ans << '\n';
    // for (auto[x, y] : res) {
    //     cout << x + 1 << ' ' << y + 1 << '\n';
    // }
    cout << -1 << '\n';
}
 
signed main() {
#ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    cout << fixed;
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}