#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;

int n;

vector<vector<int>> dist;
vector<vector<int>> g;
vector<bool> used;

void dfs(int v, int root) {
    used[v] = true;
    for (int u : g[v]) {
        if (used[u]) {
            continue;
        }
        dist[root][u] = dist[root][v] + 1;
        dfs(u, root);
    }
}
 
void solve() {
    cin >> n;
    int d;
    cin >> d;
    dist.resize(n, vector<int>(n));
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < n; i++) {
        used.assign(n, false);
        dfs(i, i);
    }
    vector<vector<int>> dp(n + 1, vector<int>(1 << n));
    for (int i = 2; i <= n; i++) {
        for (int mask = 0; mask < (1 << n); mask++) {
            for (int v = 0; v < i; v++) {
                for (int u = 0; u < i; u++) {
                    if (((mask >> v) & 1) || ((mask >> u) & 1) || dist[v][u] % 2 == 0) {
                        continue;
                    }
                    int next_mask = mask;
                    next_mask |= (1 << v);
                    next_mask |= (1 << u);
                    dp[i][next_mask] = max(dp[i][next_mask], dp[i - 1][mask] + 1);
                }
            }
        }
    }
    int res = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        res = max(res, dp[n][mask]);
    }
    cout << res << "\n";
}
 
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}