#include <bits/stdc++.h>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long divl(long long a, long long b)
{
	if (a >= 0)
	{
		return a / b;
	}
	return -((-a + b - 1) / b);
}

long long divr(long long a, long long b)
{
	if (a >= 0)
	{
		return (a + b - 1) / b;
	}
	return a / b;
}

void solve()
{
	long long n;
	cin >> n;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	long long s, d;
	cin >> s >> d;
	long long q;
	cin >> q;
	sort(v.begin(), v.end());
	vector<long long> best(n);

	auto get_thr = [&](long long a, long long b) -> long long
	{
		return (a - b) * (a - b);
	};

	for (long long i = 0; i < n; i++)
	{
		long long k = divl(v[i] - s, d);
		best[i] = get_thr(s + k * d, v[i]);
		k = divr(v[i] - s, d);
		best[i] = min(best[i], get_thr(s + k * d, v[i]));
	}

	auto calc = [&](long long r, long long t) -> __int128
	{
		__int128 res = (r / d) * t;
		for (long long i = 0; i < n; i++)
		{
			if (v[i] <= r)
			{
				res += best[i];
			}
			else
			{
				res += get_thr(r, v[i]);
			}
		}
		return res;
	};

	vector<long long> pbest(n + 1);
	for (long long i = 0; i < n; i++)
	{
		pbest[i + 1] = pbest[i] + best[i];
	}
	while (q--)
	{
		long long t;
		cin >> t;

		long long left = 0, right = (v.back() + d - 1) / d + 3;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			__int128 res1 = calc(s + mid * d, t), res2 = calc(s + (mid + 1) * d, t);
			if (res1 >= res2)
			{
				left = mid;
			}
			else
			{
				right = mid;
			}
		}
        long long ans = min(calc(s + left * d, t), calc(s + (left + 1) * d, t));
		cout << ans << "\n";
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
