#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(0);

const long long INF = 2e18, MOD = 1e9 + 7;

long long n, d;
vector<long long> g[500000];

vector<long long> dp[500000];
vector<long long> ans;

void dfs(long long v, long long p)
{
	bool leaf = true;
	vector<long long> sons;
	dp[v][0] = 1;
	for (auto& i : g[v])
	{
		if (i == p)
		{
			continue;
		}

		dfs(i, v);
		leaf = false;
		sons.push_back(i);
		ans[v] += ans[i];
		for (long long sum = d; sum >= 0; sum--)
		{
			if (sum % 2 == 0)
			{
				continue;
			}

			for (long long j = d; j >= 0; j--)
			{
				long long sumd = j + 1;
				long long nd = sum - sumd;
				if (nd < 0 || sumd > sum || nd > sum)
				{
					continue;
				}

				long long x = min(dp[v][nd], dp[i][j]);
				ans[v] += x;
				dp[v][nd] -= x;
				dp[i][j] -= x;
			}
		}
		for (long long j = 0; j < d; j++)
		{
			dp[v][j + 1] += dp[i][j];
		}
	}
}

void solve()
{
	cin >> n >> d;
	for (long long i = 0; i < n - 1; i++)
	{
		long long a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	long long ANS = 0;
	for (long long _ = 0; _ < 100; _++)
	{
		long long rt = rnd() % n;
		for (long long i = 0; i < n; i++)
		{
			dp[i].resize(d + 1, 0);
		}
		ans.resize(n, 0);
		dfs(rt, -1);
		ANS = max(ANS, ans[rt]);
	}
	cout << ANS << "\n";
	cout << -1 << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
