#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long n, m;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	vector<vector<long long>> v1(n, vector<long long>(m)), v2(n, vector<long long>(m, 0));

	for (long long i = 0; i < n; ++i) {
		for (long long j = 0; j < m; ++j) {
			char c1;
			cin >> c1;
			v1[i][j] = c1 - '0';
		}
		for (long long j = m - 1; j >= 0; --j) {
			if (j < m - 1)
				v2[i][j] = v2[i][j + 1];
			if (v1[i][j] == 1)
				++v2[i][j];
			else
				v2[i][j] = 0;
		}
	}

	long long ans = 0;

	for (long long j = 0; j < m; ++j) {
		vector<vector<long long>> vv(n);
		vector<pair<long long, long long>> v3;
		vector<long long> sz(n);
		for (long long i = n - 1; i >= 0; --i) {
			while (v3.size() > 0 && v3.back().first > v2[i][j])
				v3.pop_back();

			if (v3.size() > 0)
				vv[v3.back().second].push_back(i);

			v3.push_back({ v2[i][j], i });
		}

		v3.clear();

		for (long long i = 0; i < n; ++i) {
			while (v3.size() > 0 && v3.back().first >= v2[i][j])
				v3.pop_back();

			if (v3.size() > 0)
				sz[i] = i - v3.back().second;
			else
				sz[i] = i + 1;

			v3.push_back({ v2[i][j], i });
		}

		long long sum = 0, nom = n - 1;
		while (nom >= 0) {
			sum += sz[nom] * v2[nom][j];
			nom -= sz[nom];
		}
		ans = max(ans, sum);

		for (long long i = n - 1; i >= 0; --i) {
			sum -= sz[i] * v2[i][j];
			for (long long j2 = 0; j2 < (long long)vv[i].size(); ++j2) {
				sum += sz[vv[i][j2]] * v2[vv[i][j2]][j];
			}
			ans = max(ans, sum);
		}
	}

	cout << ans;
	return 0;
}