//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long n, x, d, m, ans11 = 0;
vector<long long> v1, vl, vr;

long long cos(long long sh, long long t, long long x1, long long x2) {
	return sh * t + (x1 - x2) * (x1 - x2);
}

long long f1(long long x1, long long x2, long long t) {
	long long xx = 1;
	if (x1 > x2)
		xx = -1;
	long long l = 0, r = (abs(x1 - x2) + d - 1) / d, ans1 = 1e18;
	ans1 = min(ans1, cos(r, t, x1 + xx * r * d, x2));
	while (r - l > 2) {
		long long mid1 = l + (r - l) / 3;
		long long mid2 = l + (r - l) / 3 * 2;
		ans1 = min(ans1, cos(mid1, t, x1 + xx * mid1 * d, x2));
		ans1 = min(ans1, cos(mid2, t, x1 + xx * mid2 * d, x2));
		if (cos(mid1, t, x1 + xx * mid1 * d, x2) < cos(mid2, t, x1 + xx * mid2 * d, x2))
			r = mid2;
		else
			l = mid1;
	}
	ans1 = min(ans1, cos(l, t, x1 + xx * l * d, x2));
	ans1 = min(ans1, cos(l - 1, t, x1 + xx * (l - 1) * d, x2));
	ans1 = min(ans1, cos(l + 1, t, x1 + xx * (l + 1) * d, x2));
	ans1 = min(ans1, cos(l + 2, t, x1 + xx * (l + 2) * d, x2));
	return ans1;
}

long long cos2(long long x1, long long x2, long long x3, long long t) {
	return (x1 - x2) * (x1 - x2) + f1(x1, x3, t);
}

long long f(long long x1, long long x2, long long x3, long long t, long long sh) {
	long long xx = 1;
	if (x1 > x2)
		xx = -1;
	return cos2(x1 + xx * sh * d, x2, x3, t) + sh * t;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	v1.resize(n);
	for (long long i = 0; i < n; ++i)
		cin >> v1[i];
	sort(v1.begin(), v1.end());

	cin >> x >> d >> m;

	for (long long i = 0; i < m; ++i) {
		long long t, ans = 1e18;
		cin >> t;
		for (long long j = 0; j < 50; ++j) {
			long long sum = 0;
			for (long long h = 0; h < n; ++h) {
				long long x3 = (long long)1e18;
				if (v1[h] / d * d <= j * d)
					x3 = (v1[h] / d * d - v1[h])* (v1[h] / d * d - v1[h]);
				if ((v1[h] / d + 1) * d <= j * d)
					x3 = min(((v1[h] / d + 1) * d - v1[h]) * ((v1[h] / d + 1) * d - v1[h]), x3);
				x3 = min(x3, (v1[h] - d * j) * (v1[h] - d * j));
				sum += x3;
			}
			ans = min(sum + j * t, ans);
		}
		cout << ans << '\n';
	}

	return 0;
}
