//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long n, d, x1 = 0, x2 = 0, nom = 0;
vector<vector<long long>> g;
vector<long long> used, mt, used2;

void dfs1(long long v, long long c, long long pr) {
	if (c == 0)
		used[v] = 1;
	for (long long i = 0; i < (long long)g[v].size(); ++i)
		if (pr != g[v][i])
			dfs1(g[v][i], c ^ 1, v);
}

bool dfs(long long v, long long c) {
	if (used2[v] == c)
		return false;
	used2[v] = c;
	for (long long i = 0; i < (long long)g[v].size(); ++i)
		if (mt[g[v][i]] == -1) {
			mt[g[v][i]] = v;
			return true;
		}
	for (long long i = 0; i < (long long)g[v].size(); ++i)
		if (dfs(mt[g[v][i]], c)) {
			mt[g[v][i]] = v;
			return true;
		}
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> d;

	g.resize(n);
	used.resize(n, 0);
	used2.resize(n, -1);
	mt.resize(n, -1);

	for (long long i = 0; i < n - 1; ++i) {
		long long a, b;
		cin >> a >> b;
		--a;
		--b;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dfs1(0, 0, 0);

	for (long long i = 0; i < n; ++i) {
		if (used[i] == 0)
			continue;
		dfs(i, i);
	}

	vector<pair<long long, long long>> ans;

	for (long long i = 0; i < n; ++i)
		if (mt[i] != -1)
			ans.push_back({ mt[i] + 1, i + 1 });

	cout << ans.size() << '\n';
	for (long long i = 0; i < (long long)ans.size(); ++i)
		cout << ans[i].first << ' ' << ans[i].second << '\n';
	return 0;
}
