#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using ll = long long;
using ld = long double;
using namespace std;
int INF = 1e9;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<vector<pair<int, int>>>seg(n+1);
        int l, r, m;
        for (int i = 0; i < k; i++) {
            cin >> l >> m >> r;
            seg[r].push_back({m, l});
        }
        vector<int>dp(n+1, INF);
        for (int i = 0; i <= n; i++) {
            for (auto [s, l_i] : seg[i]) {
                if (l_i == 1) {
                    dp[i] = min(dp[i], s);
                    continue;
                }
                bool ok = false;
                for (int x = l_i - 1; x < s; x++) {
                    if (dp[x] != INF) {
                        ok = true;
                    }
                }
                for (int x = s; x <= i; x++) {
                    if (dp[x] < l_i) {
                        ok = true;
                    }
                }
                if (ok) {
                    dp[i] = min(dp[i], s);
                }
            }
        }
        if (dp.back() != INF) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
