//#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>

using ll = long long;
using ld = long double;
using namespace std;
vector<vector<int>>g;
int n, d;
vector<pair<int, int>>all_ans;
void rec(vector<int>not_used, vector<pair<int, int>>cur_ans, const vector<vector<int>>&dist) {
    if (not_used.empty()) {
        if (cur_ans.size() > all_ans.size()) {
            all_ans=cur_ans;
        }
        return;
    }
    for (int i = 0; i < (int)not_used.size(); i++) {
        for (int j = i + 1; j < (int)not_used.size(); j++) {
            if (dist[not_used[i]][not_used[j]] <= d && dist[not_used[i]][not_used[j]] % 2 == 1) {
                cur_ans.push_back({not_used[i], not_used[j]});
                int val_i = not_used[i], val_j = not_used[j];
                not_used.erase(not_used.begin() + j);
                not_used.erase(not_used.begin() + i);
                rec(not_used, cur_ans, dist);
                cur_ans.pop_back();
                not_used.insert(not_used.begin() + i, val_i);
                not_used.insert(not_used.begin() + j, val_j);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> d;
    g.resize(n);
    int a, b;
    for (int i = 0; i < n-1;i++) {
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<vector<int>>dist(n, vector<int>(n));
    for (int i= 0; i < n; i++) {
        queue<int>q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u : g[v]) {
                if (dist[i][u] == 0) {
                    dist[i][u] = dist[i][v] + 1;
                    q.push(u);
                }
            }
        }
    }
    vector<int>not_used(n);
    for (int i = 0; i < n; i++) {
        not_used[i] = i;
    }
    rec(not_used, {}, dist);
    cout << all_ans.size() << '\n';
    for (pair<int, int > cur : all_ans) {
        cout << cur.first + 1 << ' ' << cur.second + 1 << '\n';
    }
    return 0;
}
