#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> lst(n+1);
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> m >> r;
        lst[m].emplace_back(l, r);
    }
    vector<int> dp(n+1);
    for (int i = 1; i <= n; ++i) {
        dp[i] = dp[i-1];
        for (auto [l, r] : lst[i]) {
            if (r<=dp[i]) continue;
            if (dp[l-1]+1>=l) {dp[i] = r; continue;}
            for (int id = l; id < i; ++id) {
                if (dp[id]>=id && dp[id]<i) {dp[i] = r; break;}
            }
            int L = 0, R = i;
            while (R-L > 1) {
                int M = (L+R)/2;
                if (dp[M]<i) L = M;
                else R = M;
            }
            if (dp[L]+1>=l) dp[i] = r;
        }
    }
    cout << (dp[n]==n?"YES":"NO") << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) solve();


    return 0;
}