#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

const int MAX_N = 1e4 + 2;
using ll = long long;

array<int, 3> arr[MAX_N];
int n, k;

mt19937 mt;

int dp[MAX_N][MAX_N];

void solve() {
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        arr[i] = {l, m, r};
    }
    shuffle(arr, arr + k, mt);
    for (int i = 0; i < n + 2; ++i) {
        for (int j = 0; j < i; ++j) {
            dp[i][j] = 1e9;
        }
        for (int j = i; j < n + 2; ++j) {
            dp[i][j] = 0;
        }
    }
    for (int len = 1; len <= n; ++len) {
        for (int l = 1; l <= n; ++l) {
            int r = l + len - 1;
            for (int i = 0; i < k; ++i) {
                auto [li, mi, ri] = arr[i];
                if (mi >= l && mi <= r) {
                    if (dp[ri + 1][r] >= li + 1) {
                        dp[l][r] = max(dp[l][r], min(dp[l][li - 1], li));
                    }
                }
            }
        }
    }
    cout << (dp[1][n] > 0 ? "YES\n" : "NO\n");
}

signed main() {
    // ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}