#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using ll = long long;

#define all(x) (x).begin(), (x).end()

ll sqr(ll x) {
    return x * x;
}

ll mod(ll a, ll d) {
    if (a >= 0) return a % d;
    return (d - (-a) % d) % d;
}

void solve() {
    int n;
    cin >> n;
    vector<int> targets(n);
    for (int &x : targets) cin >> x;
    int x0, d;
    cin >> x0 >> d;
    int min_x = 2e9;
    int max_x = -2e9;
    for (int &x : targets) {
        x -= x0;
        min_x = min(min_x, x);
        max_x = max(max_x, x);
    }
    int m;
    cin >> m;
    vector<pair<int, int>> people(m);
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        people[i] = {x, i};
    }
    sort(all(people));
    vector<ll> answers(m);
    for (auto [t, i] : people) {
        ll ans = 9e18;
        for (ll l = 0; (l + 1) * d >= min_x; --l) {
            for (ll r = 0; (r - 1) * d <= max(0, max_x); ++r) {
                ll res = (r - l + min(-l, r)) * t;
                for (int j = 0; j < n; ++j) {
                    if (targets[j] < l * d || targets[j] > r * d) {
                        res += min(sqr(targets[j] - l * d), sqr(targets[j] - r * d));
                    } else {
                        res += min(sqr(mod(targets[j], d)), sqr(mod(-targets[j], d)));
                    }
                }
                ans = min(ans, res);
            }
        }
        answers[i] = ans;
    }
    for (ll x : answers) {
        cout << x << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
