#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define ret return
#define con continue
#define all(v) v.begin(), v.end()
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll inf = 1e18;

ll h, w, res, m, ans = 0;
vvll v;
vector <string> vs;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> h >> w;
	v.resize(h, vll(w, 0)); vs.resize(h);
	for0(i, h)
		cin >> vs[i];
	for0(i, h) {
		res = 0;
		for (ll j = w - 1; j >= 0; --j) {
			if (vs[i][j] == '1')
				res++;
			else
				res = 0;
			v[i][j] = res;
		}
	}
	for0(j, w) {
		m = inf; res = 0;
		for (ll i = h - 1; i >= 0; --i) {
			if (vs[i][j] == '0') {
				m = inf; res = 0;
			}
			else {
				m = min(m, v[i][j]); res += m;
				ans = max(res, ans);
			}
		}
	}
	for0(j, w) {
		res = 0;
		for (ll i = h - 1; i >= 0; --i) {
			if (vs[i][j] == '1')
				res++;
			else
				res = 0;
			v[i][j] = res;
		}
	}
	for0(i, h) {
		m = inf; res = 0;
		for0(j, w) {
			if (vs[i][j] == '0') {
				m = inf; res = 0;
			}
			else {
				m = min(m, v[i][j]); res += m;
				ans = max(res, ans);
			}
		}
	}
	cout << ans << "\n";
}