#include <bits/stdc++.h>
using namespace std;

using ll = long long;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector c(n + 2, vector<char>(m + 2, '0'));
    vector cnt(n + 2, vector<ll>(m + 2, 0));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> c[i][j];
        }
    }
    for (int j = 1; j <= m; ++j) {
        for (int i = 1; i <= n; ++i) {
            cnt[i][j] = cnt[i - 1][j];
            if (c[i][j] == '1') {
                cnt[i][j]++;
            } else {
                cnt[i][j] = 0;
            }
        }
    }
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        vector<pair<ll, ll>> e;
        e.emplace_back(-1, 0);
        ll sum = 0;
        for (int j = m; j >= 1; --j) {
            ll k = 1;
            while (cnt[i][j] <= e.back().first) {
               sum -= e.back().first * e.back().second;
                k += e.back().second;
                e.pop_back();
            }
            sum += k * cnt[i][j];
            e.emplace_back(cnt[i][j], k);
            ans = max(ans, sum);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
