#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll N = 5e5 + 5;

ll tree[N * 4];

void add(ll v, ll tl, ll tr, ll k, ll x) {
    if (tl > k || tr < k) {
        return;
    }
    if (tl == tr) {
        tree[v] = min(tree[v], x);
        return;
    }
    ll tm = (tl + tr) / 2;
    add(v * 2, tl, tm, k, x);
    add(v * 2 + 1, tm + 1, tr, k, x);
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

ll n, k;
ll get(ll v, ll tl, ll tr, ll l, ll r) {
    if (tl > r || tr < l) {
        return n + 1;
    }
    if (tl >= l && tr <= r) {
        return tree[v];
    }
    ll tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}
ll lk[N];

struct node {
    ll l, m, r;
};
void solve() {
    cin >> n >> k;
    for (int i = 0; i < n * 4 + 10; ++i) {
        tree[i] = n + 1;
    }
    vector<node> e;
    for (int i = 0; i < k; ++i) {
        ll l_, m, r_;
        cin >> l_ >> m >> r_;
        e.emplace_back(l_, m, r_);
    }
    sort(e.begin(), e.end(), [&] (node &a, node &b) {
        return a.m < b.m;
    });
    add(1, 0, n, 0, 0);
    for (auto &[l, m, r] : e) {
        if (get(1, 0, n, l - 1, m - 1) != n + 1 || get(1, 0 ,n, m, r) < l) {
            add(1, 0, n, r, m);
        }
    }
    if (get(1, 0, n, n, n) == n + 1) {
        cout << "NO" << '\n';
    } else {
        cout << "YES" << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
}
