#include <bits/stdc++.h>
using namespace std;

using ll = __int128;

void solve() {
    int n;
    cin >> n;
    vector<long long> xx(n);
    for (int i = 0; i < n; ++i) {
        cin >> xx[i];
    }
    long long x0, d;
    cin >> x0 >> d;
    vector<pair<ll, ll> > x1, x2;
    for (int i = 0; i * d <= (ll) 1e6 + d; ++i) {
        x1.push_back({i * d, 0});
        x2.push_back({i * d, 0});
    }
    for (auto x: xx) {
        if (x < x0) {
            x1.push_back({x0 - x, 1});
        } else if (x > x0) {
            x2.push_back({x - x0, 1});
        }
    }
    sort(x1.begin(), x1.end());
    sort(x2.begin(), x2.end());
    vector<ll> dp1((ll) x1.size()), dp2((ll) x2.size());
    vector<pair<ll, ll> > kht1, kht2;
    auto build = [&](vector<pair<ll, ll> > &x, vector<ll> &dp, vector<pair<ll, ll>> &kht) {
        ll sz = (ll) x.size();
        ll sum = 0;
        for (int i = 0; i < sz; ++i) {
            ll l = x[i].first / d * d;
            ll r = l;
            if (r < x[i].first) {
                r += d;
            }
            if (x[i].second) sum += min((x[i].first - l) * (x[i].first - l), (r - x[i].first) * (r - x[i].first));
            dp[i] += sum;
        }
        sum = 0;
        ll gg = 0;
        ll ff = 0;
        ll hh = 0;
        vector<pair<ll, ll> > lol;
        for (int i = sz - 1; i >= 0; --i) {
            ll l = x[i].first / d * d;
            ll r = l;
            if (r < x[i].first) {
                r += d;
            }
            dp[i] += gg + ff * r + r * r * (hh);
            if (x[i].second) {
                hh++;
                gg += x[i].first * x[i].first;
                ff -= 2 * x[i].first;
            }
            lol.emplace_back(dp[i], r / d);
        }
        sort(lol.begin(), lol.end());
        ll mn = 1e18;
        for (auto[ b, k] : lol) {
            if (k < mn) {
                mn = k;
                kht.emplace_back(b, k);
            }
        }
    };
    build(x1, dp1, kht1), build(x2, dp2, kht2);
    int m;
    cin >> m;
    while (m--) {
        long long t;
        cin >> t;
        auto f = [&](vector<pair<ll, ll>> &kht, ll tk) -> ll {
            auto aboba = [&] (ll ind) {
                return kht[ind].first + kht[ind].second * tk;
            };
            ll l = 0;
            ll r = (ll) kht.size() - 1;
            while (l < r - 1) {
                ll mid = (l + r) / 2;
                if (aboba(mid) >= aboba(mid + 1)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            return min(aboba(l), aboba(r));
        };
        cout << (long long) min(f(kht1, t) + f(kht2, t * 2), f(kht1, t * 2) + f(kht2, t)) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
