#include <bits/stdc++.h>
using namespace std;

using ll = long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const ll N = 5e5 + 5;
const ll M = 21;
vector<ll> g[N];

ll h[N];
ll dp[M][N];
vector<ll> l, r;

ll rast(ll v, ll u) {
    if (h[v] < h[u]) {
        swap(v, u);
    }
    ll ans = 0;
    for (int i = M - 1; i >= 0; --i) {
        if (h[dp[i][v]] >= h[u]) {
            ans += (1 << i);
            v = dp[i][v];
        }
    }
    if (v == u) {
        return ans;
    }
    for (int i = M - 1; i >= 0; --i) {
        if (dp[i][v] != dp[i][u]) {
            ans += (1 << i) * 2;
            v = dp[i][v];
            u = dp[i][u];
        }
    }
    return ans + 2;
}
void dfs(ll v, ll p) {
    dp[0][v] = p;
    for (int i = 1; i < M; ++i) {
        dp[i][v] = dp[i - 1][dp[i - 1][v]];
    }
    h[v] = h[p] + 1;
    if (h[v] & 1) {
        l.push_back(v);
    } else {
        r.push_back(v);
    }
    for (ll u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}
void solve() {
    ll n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        ll v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(1, 0);
    vector<pair<ll, ll>> ans;
    for (int i = 0; i < 30000; ++i) {
        ranges::shuffle(l, rnd);
        ranges::shuffle(r, rnd);
        vector<ll> lk = l;
        vector<ll> rk = r;
        vector<pair<ll, ll>> now;
        while (!lk.empty() && !rk.empty()) {
            ll v = lk.back();
            ll u = rk.back();
            lk.pop_back();
            rk.pop_back();
            if (rast(v, u) <= d) {
                now.emplace_back(v, u);
            } else {
                if ((ll) lk.size() < (ll) rk.size()) {
                    lk.push_back(v);
                } else {
                    rk.push_back(v);
                }
            }
        }
        if ((ll) now.size() > ans.size()) {
            swap(ans, now);
        }
    }
    cout << (ll) ans.size() << '\n';
    for (auto[v, u] : ans) {
        cout << v << " " << u << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
