#include <bits/stdc++.h>
//#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> vis;

bool dfs(int v) {
    vis[v] = 1;
    for (int u : g[v]) {
        if (vis[u] == 1) return true;
        if (dfs(u)) return true;
    }
    vis[v] = 2;
    return false;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> a(k);
    vector<int> m(k);
    for (int i = 0; i < k; ++i) cin >> a[i].first >> m[i] >> a[i].second;
    g.assign(n, {});
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) continue;
            if (a[j].first <= m[i] && a[j].second >= m[i]) {
                g[i].push_back(j);
            }
        }
    }
    vis.assign(k, 0);
    for (int i = 0; i < k; ++i) {
        if (!vis[k]) {
            if (dfs(i)) {
                cout << "NO";
                return;
            }
        }
    }
    cout << "YES";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
