#include <bits/stdc++.h>
#define int long long

using namespace std;

int get_dist(int x, int y) {
    return (x - y) * (x - y);
}

int get_p(__int128 x0, __int128 d, __int128 t, __int128 x) {
    if (x0 < x) {
        __int128 a = x0 - x;
        __int128 b = 2 * d * a + d * t;
        __int128 dekr = b * b - 4 * a * a * d * d;
        dekr = max(dekr, (__int128)0);
        __int128 k = (-b + sqrtl(dekr)) / (2 * d * d);
        return x0 + k * d;
    } else {
        swap(x, x0);
        __int128 a = x0 - x;
        __int128 b = 2 * d * a + d * t;
        __int128 dekr = b * b - 4 * a * a * d * d;
        dekr = max(dekr, (__int128)0);
        __int128 k = (-b + sqrtl(dekr)) / (2 * d * d);
        swap(x, x0);
        return x0 - k * d;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) cin >> x[i];
    if (n == 1) {
        int x0, d, m;
        cin >> x0 >> d >> m;
        while (m--) {
            int t;
            cin >> t;
            int ans = 4e18;
            int p = get_p(x0, d, t, x[0]);
            for (int i = p - d - d; i <= p + d + d; i += d) {
                ans = min(ans, abs(i - x0) * t + get_dist(i, x[0]));
            }
            cout << ans << endl;
        }
        return;
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        vector<int> best(n);
        cout << "###";
        for (int i = 0; i < n; ++i) {
            best[i] = get_p(x0, d, t, x[i]);
            cout << best[i] << " ";
        }
        cout << endl;
        int mini = *min_element(best.begin(), best.end());
        int maxi = *max_element(best.begin(), best.end());
        int mainans = 1e18;
        for (int l = mini - d; l <= maxi + d; l += d) {
            for (int r = l; r <= maxi + d; r += d) {
                int ans = min(abs(x0 - l) + r - l, abs(x0 - r) + r - l) / d * t;
                for (int i = 0; i < n; ++i) {
                    if (best[i] > r || best[i] < l) ans += min(get_dist(l, x[i]), get_dist(r, x[i]));
                    else {
                        ans += get_dist(best[i], x[i]);
                    }
                }
                mainans = min(mainans, ans);
            }
        }
        cout << mainans << "\n";
    }

}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
