#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct f{
    int l, r;
    int x;
};
void task(int y) {
    int n, k;
    cin >> n >> k;
    vector<f> a(k, {0, 0, 0});
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].x >> a[i].r;
        a[i].l -= 1;
        a[i].r -= 1;
        a[i].x -= 1;
    }
    sort(a.begin(), a.end(), [](f c, f d){
        return c.r < d.r;
    });
    vector<int> dp(k + 1, 0);
    if (a[0].l == 0) {
        dp[1] = a[0].r;
    }
    for (int i = 1; i < k; ++i) {
        if (a[i].l == 0) {
            dp[i + 1] = a[i].r;
            continue;
        }
        dp[i + 1] = dp[i];
        if (a[i].x > a[i - 1].r) {
            if (dp[i] + 1 >= a[i].l) {
                dp[i + 1] = a[i].r;
            }
            continue;
        }
        int l = -1;
        int r = i;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (a[m].r < a[i].x) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l > -1) {
            if (dp[l] + 1 >= a[i].l) {
                dp[i] = a[i].r;
            }
        }
    }
    if (dp[k] == n - 1) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}
int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        task(i);
    }
    return 0;
}
