#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> graph;
vector<pair<ll, ll>> pairs;

bool is_av(ll v, ll p=-1) {
    ll av = -1;
    for (auto x : graph[v]) {
        if (x == p) continue;
        if (is_av(x, v)) {
            av = x;
        }
    }

    if (av != -1) {
        pairs.push_back({v, av});
        return false;
    } else {
        return true;
    }
}

void solve() {
    ll n;
    cin >> n;
    ll d;
    cin >> d;
    graph.resize(n + 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    is_av(1);

    cout << pairs.size() << "\n";
    for (auto x : pairs) {
        cout << x.first << " " << x.second << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}