#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> graph;
vector<ll> c;

void dfs(ll v, ll p=-1, ll c_=0) {
    c[v] = c_;
    for (auto x : graph[v]) {
        if (x == p) continue;
        dfs(x, v, 1 - c_);
    }
}

void solve() {
    ll n;
    cin >> n;
    ll d;
    cin >> d;
    c.resize(n + 1);
    graph.resize(n + 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(1);

    vector<ll> l1;
    vector<ll> l2;
    for (ll i = 1; i <= n; ++i) {
        if (c[i] == 1) {
            l1.push_back(i);
        } else {
            l2.push_back(i);
        }
    }

    cout << min(l1.size(), l2.size()) << "\n";
    for (ll i = 0; i < min(l1.size(), l2.size()); ++i) {
        cout << l1[i] << " " << l2[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}