#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 0, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 0, INF = 1e9 + 228 * 1e4;
#endif

inline ll sq(ll x) { return x * x; }
signed main() {
    int n;
    cin >> n;
    vector<ll> xs(n);
    for (ll &i : xs) cin >> i;
    sort(allv(xs));
    ll x0, d; cin >> x0 >> d;
    vector<__int128> pref1(n + 1, 0), pref2(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref1[i + 1] = pref1[i] + xs[i];
        pref2[i + 1] = pref2[i] + xs[i] * xs[i];
    }
    int m; cin >> m;
    while (m--) {
        ll t;
        cin >> t;
        ll x = xs.back() / d * d + d;
        __int128 nxt_dp = x / d * t;
        int i = n - 1;
        for (x -= d; x >= 0; x -= d) {
            while (i > 0 && xs[i - 1] >= x)
                i--;
            __int128 cur_dp = (pref2[n] - pref2[i]) + (__int128)(n - i) * sq(x) - 2 * x * (pref1[n] - pref1[i]) + t * (x / d);
            if (x + d > xs[i])
                smin(cur_dp, sq(min(xs[i] - x, x + d - xs[i])) + nxt_dp);
            else
                smin(cur_dp, nxt_dp);
            nxt_dp = cur_dp;
        }
        cout << (ll)nxt_dp << '\n';
    }
    return 0;
}
