#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-prtotector")

using namespace std;

typedef long long ll;
typedef long double ld;
// #define int ll
#define double ld

struct Node {
    int mx;
    int cnt;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (int i = 0; i < n;i ++) {
        cin >> a[i];
    }
    vector<deque<Node>> q(m);
    int ans = 0;
    vector<int> cur_ans(m, 0);
    for (int i = 0; i < n; i++) {
        vector<int> len(m + 1, 0);
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '1') {
                len[j] = len[j + 1] + 1;
            }
        }
        for (int j = 0; j < m; j++) {
            int cur_cnt = 1;
            while (!q[j].empty() && q[j].back().mx > len[j]) {
                cur_ans[j] -= (q[j].back().mx - len[j]) * q[j].back().cnt;
                cur_cnt += q[j].back().cnt;
                q[j].pop_back();
            }
            cur_ans[j] += len[j];
            q[j].push_back({len[j], cur_cnt});
            ans = max(ans, cur_ans[j]);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}