#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-prtotector")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
vector<vector<int>> up;

const int L = 22;

int t = 0;
void cnt(int v, int p = -1) {
    tin[v] = t++;
    up[v][0] = p;
    for (int i = 1; i <= L; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto i : g[v]) {
        if (i == p) {
            continue;
        }
        cnt(i, v);
    }
    tout[v] = t++;
}

vector<vector<int>> dp;

void dfs_dp(int v, int p) {
    vector<int> dp_0;
    vector<int> dp_1;
    for (auto i : g[v]) {
        if (i == p) {
            continue;
        }
        dfs_dp(i, v);
        dp_0.push_back(dp[i][0]);
        dp_1.push_back(dp[i][1]);
    }
    int s0 = accumulate(all(dp_0), 0LL);
    int s1 = accumulate(all(dp_1), 0LL);
    dp[v][0] = s1;
    int mx1 = 0;
    for (int i = 0; i < dp_0.size(); i++) {
        mx1 = max(mx1, s1 - dp_1[i] + dp_0[i] + 1);
    }
    dp[v][1] = mx1;
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    up.resize(n, vector<int>(L + 1, 0));
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cnt(0, 0);

    if (d == 1) {
        dp.resize(n, vector<int>(2, 0));
        dfs_dp(0, 0);
        cout << max(dp[0][0], dp[0][1]) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}