#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-prtotector")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
vector<int> depth;
vector<vector<int>> up;

const int L = 22;

int t = 0;
void cnt(int v, int p = -1) {
    tin[v] = t++;
    up[v][0] = p;
    for (int i = 1; i <= L; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto i : g[v]) {
        if (i == p) {
            continue;
        }
        depth[i] = depth[v] + 1;
        cnt(i, v);
    }
    tout[v] = t++;
}

bool is_ancestor(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int lca(int a, int b) {
    if (is_ancestor(a, b)) return a;
    if (is_ancestor(b, a)) return b;
    for (int i = L; i >= 0; i--) {
        if (!is_ancestor(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

int dist(int a, int b) {
    int l = lca(a, b);
    return depth[a] + depth[b] - 2 * depth[l];
}

vector<vector<int>> dp;
vector<int> pp;

void dfs_dp(int v, int p) {
    vector<int> dp_0;
    vector<int> dp_1;
    vector<int> px;
    for (auto i : g[v]) {
        if (i == p) {
            continue;
        }
        dfs_dp(i, v);
        px.push_back(i);
        dp_0.push_back(dp[i][0]);
        dp_1.push_back(dp[i][1]);
    }
    int sans = 0;
    for (int i = 0; i < dp_0.size(); i++) {
        sans += max(dp_0[i], dp_1[i]);
    }
    dp[v][0] = sans;
    int mx1 = 0;
    for (int i = 0; i < dp_0.size(); i++) {
        if (sans - max(dp_0[i], dp_1[i]) + dp_0[i] + 1 > mx1) {
            mx1 = max(mx1, sans - max(dp_0[i], dp_1[i]) + dp_0[i] + 1);
            pp[v] = px[i];
        }

    }
    dp[v][1] = mx1;
}

void dfs_pp(int v, int p, int need_ans) {
    vector<int> dp_0;
    vector<int> dp_1;
    vector<int> px;
    for (auto i : g[v]) {
        if (i == p) {
            continue;
        }
        px.push_back(i);
        dp_0.push_back(dp[i][0]);
        dp_1.push_back(dp[i][1]);
    }
    int s1 = accumulate(all(dp_1), 0LL);
    int sans = 0;
    for (int i = 0; i < dp_0.size(); i++) {
        sans += max(dp_0[i], dp_1[i]);
    }
    if (need_ans == sans) {
        for (int i = 0; i < dp_0.size(); i++) {
            dfs_pp(px[i], v, max(dp_0[i], dp_1[i]));
        }
        return;
    }
    cout << v + 1 << ' ' << pp[v] + 1 << '\n';
    for (int i = 0; i < dp_0.size(); i++) {
        if (px[i] == pp[v]) {
            dfs_pp(px[i], v, dp_0[i]);
        }
        else {
            dfs_pp(px[i], v, max(dp_0[i], dp_1[i]));
        }
    }
}


vector<vector<int>> new_g;
vector<int> mt;
vector<int> used;

bool dfs_pair(int v) {
    used[v] = true;
    for (auto i : new_g[v]) {
        if (!used[i] || mt[i] == -1 || dfs_pair(mt[i])) {
            mt[i] = v;
            return true;
        }
    }
    return false;
}

int ans_rec = 0;

// void rec(int v, int cur_ans = 0) {
//     ans_rec = max(ans_rec, cur_ans);
//     if (!used[v])
// }


vector<int> cv;

void dfs_c(int v, int c) {
    used[v] = true;
    cv[c] = c;
    for (auto i : new_g[v]) {
        if (!used[i]) {
            dfs_c(i, 3 - cv[v]);
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    mt.resize(n, -1);
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    depth.resize(n, 0);
    up.resize(n, vector<int>(L + 1, 0));
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cnt(0, 0);
    if (true) {
        dp.resize(n, vector<int>(2, 0));
        pp.resize(n);
        dfs_dp(0, 0);
        // cout << "ok\n";
        int ans = max(dp[0][0], dp[0][1]);
        cout << ans  << '\n';
        dfs_pp(0, 0, ans);
    }
    // else {
    //     new_g.resize(n);
    //     used.resize(n, 0);
    //     for (int i = 0; i < n; i++) {
    //         for (int j = 0; j < n; j++) {
    //             int dx = dist(i, j);
    //             if (dx % 2 && dx <= d) {
    //                 new_g[i].push_back(j);
    //                 new_g[j].push_back(i);
    //             }
    //         }
    //     }
    //     for (int i = 0; i < n; i++) {
    //         fill(all(used), false);
    //         dfs_pair(i);
    //     }
    //     for (int i = 0; i < n; i++) {
    //         if (mt[i] != -1) {
    //             cout << i + 1 << ' ' << mt[i] + 1 << '\n';
    //         }
    //     }
    // }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}