#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

void solve() {
    ll n, k; cin >> n >> k;
    vector<vector<ll>> a(k), b(k);
    for (int i = 0; i < k; i++) {
        ll l, m, r; cin >> l >> m >> r;
        a[i] = {l, m, r};
        b[i] = {r, -l, m};
    }
    sort(b.begin(), b.end());
    vector<ll> dp(n + 1, INF);
    dp[0] = -INF;
    for (int i = 0; i < k; i++) {
        ll l = -b[i][1], m = b[i][2], r = b[i][0];
        for (int j = m - 1; j >= l - 1; j--) {
            if (dp[j] != INF) {
                dp[r] = min(dp[r], m);
            }
        }
        for (int j = m; j <= r; j++) {
            if (dp[j] < l) {
                dp[r] = min(dp[r], m);
            }
        }
    }
    if (dp[n] != INF) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }

    return 0;
}
