#include <bits/stdc++.h>
using namespace std;
typedef __int128 lll;
typedef long long ll;

const ll M = 1e6 + 5;
const ll N = 405;
const ll INF = 2e18;

ll mt[N];
vector<ll> g[N];
vector<ll> gh[N];
bool used[N];

ll dep[N];
void precalc(ll v, ll par = -1) {
    for (auto to : g[v]) {
        if (to == par) continue;
        dep[to] = dep[v] + 1;
        precalc(to, v);
    }
}

bool dfs(ll v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (auto to : gh[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
        if (dfs(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    ll n, d; cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        ll u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<ll> odd, even;
    precalc(0);
    for (int i = 0; i < n; i++) {
        // cout << i + 1 << " -- " << dep[i] << '\n';
        if (dep[i] % 2 == 0) {
            even.push_back(i);
        } else {
            odd.push_back(i);
        }
    }
    vector<vector<ll>> dsts(n, vector<ll> (n));
    for (int i = 0; i < n; i++) {
        vector<ll> dst(n, INF);
        dst[i] = 0;
        queue<ll> q;
        q.push(i);
        while (!q.empty()) {
            auto v = q.front();
            q.pop();
            for (auto to : g[v]) {
                if (dst[to] > dst[v] + 1) {
                    dst[to] = dst[v] + 1;
                    q.push(to);
                }
            }
        }
        dsts[i] = dst;
    }
    for (auto u : odd) {
        for (auto v : even) {
            if (dsts[u][v] <= d) {
                // cout << u << " " << v + n << '\n';
                gh[u].push_back(v + n);
                gh[v + n].push_back(u);
            }
        }
    }
    for (int i = 0; i < 2 * n; i++) {
        mt[i] = -1;
    }
    for (int tmr = 0; tmr < n; tmr++) {
        for (int j = 0; j < n; j++) {
            used[j] = false;
        }
        for (int j = 0; j < n; j++) {
            dfs(j);
            cout << "new" << '\n';
            for (int i = n; i < 2 * n; i++) {
                if (mt[i] != -1) {
                    cout << mt[i] + 1 << " " << i - n + 1 << '\n';
                }
            }
        }
    }
    vector<pair<ll, ll>> ans;
    for (int i = n; i < 2 * n; i++) {
        if (mt[i] != -1) {
            ans.push_back({mt[i], i - n});
        }
    }
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }

    return 0;
}