#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define f first
#define s second

using namespace std;

struct X
{
    int l, m, r;
};

bool cmp(X a, X b)
{
    return a.l > b.l || (a.l == b.l && a.r > b.r);
}

bool in(X a, int x)
{
    return a.l <= x && x <= a.r;
}

void solve()
{
    int n, k; cin >> n >> k;
    X a[k];
    vector<int> l, r;
    for(int i = 0; i<k; ++i)
        cin >> a[i].l >> a[i].m >> a[i].r;
    for(int i = 0; i+1<k; ++i)
    {
        for(int j = i+1; j<k; ++j)
        {
            if(in(a[j], a[i].m) && in(a[i], a[j].m))
            {
                cout << "NO\n";
                return;
            }
        }
    }
    sort(a, a+k, cmp);
    set<pii> st;
    int last = n;
    for(int i = 0; i<k; ++i)
    {
        if(last < a[i].l) continue;
        if(last <= a[i].r)
            last = a[i].l-1;
        else
        {
            st.insert({a[i].r+1, last});
        }
        while(!st.empty())
        {
            pii x = *st.begin();
            if(x.f > a[i].r) break;
            x.f = a[i].r+1;
            st.erase(st.begin());
            if(x.f <= x.s)
            {
                st.insert(x);
                break;
            }
        }
    }
    if(!st.empty() || last!=0)
        cout << "NO\n";
    else cout << "YES\n";
    return;
}

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); int t = 1; cin >> t;
    //freopen("in.txt", "r", stdin); int t; cin >> t;
    while(t--)
        solve();
    return 0;
}
