#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;
using ld = long double;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int((x).size())

struct segment {
    int l, m, r;
};

bool mcmp(const segment& a, const segment& b) {
    return a.m < b.m;
}

bool lcmp(const segment& a, const segment& b) {
    return a.l < b.l;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n, k;
        cin >> n >> k;
        vector<segment> segments(k);
        for (int i = 0; i < k; i++) {
            int l, r, m;
            cin >> l >> m >> r;
            segments[i] = {l, m, r};
        }
        sort(all(segments), lcmp);
        vector<int> dp(n + 1, 1e9);
        dp[0] = 0;
        for (int i = 1; i <= n; i++) {
            if (dp[i - 1] != 1e9) {
                for (auto [l, m, r] : segments) {
                    if (l > i) break;
                    if (dp[i - 1] < l) {
                        dp[r] = min(dp[r], max(m, dp[i - 1]));
                    }
                }
                for (auto [l, m, r] : segments) {
                    if (l > i) break;
                    if (m >= i) {
                        dp[r] = min(dp[r], max(m, dp[i - 1]));
                    }
                }
            }
        }
        cout << (dp[n] != 1e9 ? "YES\n" : "NO\n");
    }
}