#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;

#define int int64_t
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;
using ld = long double;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int((x).size())

int start, d;

int get_closest(int z) {
    ll closest = z / d * d;
    if (abs(z - closest) > abs(z - (closest + d))) {
        closest += d;
    }
    return closest;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    sort(all(x));
    cin >> start >> d;
    ll c = d - start % d;
    for (auto& z : x) z += c;
    start += c;
    assert(start % d == 0);
    int q;
    cin >> q;
    vector<pii> t(q);
    for (int i = 0; i < q; i++) {
        int z;
        cin >> z;
        t[i] = {z, i};
    }
    vector<ll> ans(q, INT64_MAX);
    ll SZ = max(start, *max_element(all(x))) + 2 * d + 1;
    SZ /= d;
    vector<ll> groups(SZ);
    vector<ll> pref_z(SZ + 1);
    vector<ll> pref_z2(SZ + 1);
    vector<ll> pref_amounts(SZ + 1);
    for (int z : x) {
        int closest = get_closest(z);
        groups[closest / d] += (z - closest) * (z - closest);
        pref_z[closest / d + 1] += z;
        pref_z2[closest / d + 1] += z * z;
        pref_amounts[closest / d + 1]++;
    }
    // vector<ll> costs(SZ);
    // ll pref_cost = 0;
    // for (int i = start; i < sz(groups); i += d) {
    //     pref_cost += groups[i];
    //     ll now_cost = 0;
    //     for (int z : x) {
    //         if (get_closest(z) > i) {
    //             now_cost += (z - i) * (z - i);
    //         }
    //     }
    //     costs[i] = pref_cost + now_cost;
    // }
    start /= d;
    vector<ll> pref_groups(SZ + 1);
    for (int i = 1; i <= SZ; i++) {
        pref_groups[i] = pref_groups[i - 1] + groups[i - 1];
        pref_z[i] += pref_z[i - 1];
        pref_z2[i] += pref_z2[i - 1];
        pref_amounts[i] += pref_amounts[i - 1];
    }
    vector<ll> rights(SZ);
    vector<ll> lefts(SZ);
    for (int l = 0; l <= start; l++) {
        ll now_ans = 0;
        now_ans += pref_groups[start] - pref_groups[l];
        now_ans -= pref_z[l] * 2 * l * d;
        now_ans += pref_z2[l];
        now_ans += pref_amounts[l] * l * l * d * d;
        lefts[l] = now_ans;
    }
    for (int r = start; r < SZ; r++) {
        ll now_ans = 0;
        now_ans += pref_groups[r + 1] - pref_groups[start];
        now_ans -= (pref_z[SZ] - pref_z[r + 1]) * 2 * r * d;
        now_ans += (pref_z2[SZ] - pref_z2[r + 1]);
        now_ans += (pref_amounts[SZ] - pref_amounts[r + 1]) * r * r * d * d;
        rights[r] = now_ans;
    }
    for (auto [f, i] : t) {
        for (int l = 0; l <= start; l++) {
            // ll C = lefts[l];
            for (int r = start; r < SZ; r++) {
                ll now_ans = 2 * r * f + rights[r];
                ans[i] = min(ans[i], now_ans + lefts[l] - l * f - start * f);
            }
            for (int r = 2 * start - l; r < SZ; r++) {
                ll now_ans = (start + r - 2 * l) * f;
                now_ans += lefts[l];
                now_ans += rights[r];
                ans[i] = min(ans[i], now_ans);
            }
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}