#include <bits/stdc++.h>

using namespace std;
#define ll long long

ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll h, w;
    cin >> h >> w;
    vector<string> s(h);
    for (ll i = 0; i < h; i++) {
        cin >> s[i];
    }
    vector<vector<ll> > pref(h, vector<ll>(w));
    for (ll i = 0; i < h; i++) {
        ll cnt = 0;
        for (ll j = w - 1; j >= 0; j--) {
            if (s[i][j] == '0') {
                cnt = 0;
            } else {
                cnt++;
            }
            pref[i][j] = cnt;
        }
    }
    vector<vector<ll> > mn_up(h, vector<ll>(w, -1));
    for (ll i = 0; i < w; i++) {
        deque<pair<ll,ll> > mn;
        for (ll j = 0; j < h; j++) {
            if (s[j][i] == '0') {
                mn.clear();
                mn.push_back({-INF, j});
            } else {
                while (!mn.empty() && mn.back().first >= pref[j][i]) {
                    mn.pop_back();
                }
                if (!mn.empty()) {
                    mn_up[j][i] = mn.back().second;
                }
                mn.emplace_back(pref[j][i], j);
            }
        }
    }
    vector<vector<ll> > dp(h, vector<ll>(w, INF));
    ll ans = 0;
    for (ll i = 0; i < w; i++) {
        for (ll j = 0; j < h; j++) {
            if (s[j][i] == '0') {
                dp[j][i] = 0;
            } else {
                ll x = mn_up[j][i];
                ll add = 0;
                if (x >= 0) {
                    add += dp[x][i];
                }
                dp[j][i] = (j - x) * (pref[j][i]) + add;
                ans = max(ans, dp[j][i]);
            }
        }
    }
    cout << ans;
}
