#include <bits/stdc++.h>

using namespace std;
#define ll long long

ll INF = 1e18;

vector<vector<ll> > g;
vector<ll> used;
vector<ll> color;
ll v1 = 0;
ll v2 = 0;

void dfs(ll v,ll t) {
    used[v] = 1;
    color[v] = t;
    if (t == 1) {
        v1++;
    } else {
        v2++;
    }
    for (auto to: g[v]) {
        if (used[to] == 0) {
            dfs(to, 1 - t);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, d;
    cin >> n >> d;
    g.resize(n);
    color.resize(n);
    used.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    cout << min(v1, v2) << endl;
    vector<ll> a1, a2;
    for (ll i = 0; i < color.size(); i++) {
        if (color[i] == 1) {
            a1.push_back(i);
        } else {
            a2.push_back(i);
        }
    }
    for (ll i = 0; i < min(v1, v2); i++) {
        cout << a1[i] + 1 << " " << a2[i] + 1 << endl;
    }
}
