#include <bits/stdc++.h>

using namespace std;

#define pb push_back

using ll = long long;

const ll maxn = 5e5 + 9;

struct el {
    ll l, m, r;
};

ostream &operator <<(ostream &s, const el &a) {
    s << a.l << ' ' << a.m << ' ' << a.r;
    return s;
}

bool operator <(const el &a, const el &b) {
    return a.m < b.m;
}

el a[maxn];
ll dp[maxn], dp2[maxn];

void solve() {
    ll n, k;
    cin >> n >> k;
    for (ll i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    sort(a, a + k);
    for (ll i = 0; i < k; i++) {
        fill(dp, dp + n + 1, 0);
        auto [l, m, r] = a[i];
        for (ll j = a[i].l; j <= a[i].r; j++) {
            dp[j] = 1;
        }
        for (ll j = i - 1; j >= 0; j--) {
            if (!dp[a[j].m]) {
                for (ll h = a[j].l; h <= a[j].r; h++) {
                    dp[h] = 1;
                }
            }
        }
        for (ll j = i + 1; j < k; j++) {
            if (!dp[a[j].m]) {
                for (ll h = a[j].l; h <= a[j].r; h++) {
                    dp[h] = 1;
                }
            }
        }
        bool f = true;
        for (ll j = 1; j <= n; j++) {
            if (!dp[j]) {
                f = false;
            break;
            }
        }
        if (f) {
            cout << "YES";
            return;
        }
    }
    cout << "NO";
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
