#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;

const ll maxn = 5e5 + 9;

ll z[maxn], clr[maxn], color = 0, mt[maxn];
vector <ll> g[maxn];

void dfs(ll v, ll p) {
    z[v] = 1 - z[p];
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
}

bool dfs2(ll v) {
    clr[v] = color;
    for (auto to : g[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
    }
    for (auto to : g[v]) {
        if (clr[mt[to]] != color && dfs2(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    fill(mt, mt + maxn, -1);
    ll n, d;
    cin >> n >> d;
    for (ll i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(1, 0);
    for (ll i = 1; i <= n; i++) {
        if (z[i]) {
            color++;
            dfs2(i);
        }
    }
    vector <pair <ll, ll>> ans;
    for (ll i = 1; i <= n; i++) {
        if (mt[i] != -1) {
            ans.pb({mt[i], i});
        }
    }
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a << ' ' << b << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
}
