#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;

const ll maxn = 5e5 + 9;

ll dist[maxn];
vector <ll> g[maxn];

void dfs(ll v, ll p) {
    for (auto to : g[v]) {
        if (to != p) {
            dist[to] = dist[v] + 1;
            dfs(to, v);
        }
    }
}

void solve() {
    ll n, d;
    cin >> n >> d;
    for (ll i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        g[a].pb(b);
        g[b].pb(a);
    }
    dist[1] = 0;
    dfs(1, 0);
    ll mxi = 1;
    for (ll i = 2; i <= n; i++) {
        if (dist[i] > dist[mxi]) {
            mxi = i;
        }
    }
    dist[mxi] = 0;
    dfs(mxi, 0);
    vector <pair <ll, ll>> ans;
    for (ll i = 1; i <= n; i++) {
        if (dist[i] == n - 1) {
            ans.pb({mxi, i});
            break;
        }
    }
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a << ' ' << b << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
}
