#include <bits/stdc++.h>

using namespace std;

#define pb push_back

using ll = long long;

ostream &operator <<(ostream &s, const pair <ll, ll> &a) {
    s << a.first << ' ' << a.second;
    return s;
}

const ll maxn = 5e5 + 9;

ll z[maxn];
vector <ll> g[maxn];

void dfs(ll v, ll p) {
    z[v] = 1 - z[p];
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
}

void solve() {
    ll n, d;
    cin >> n >> d;
    for (ll i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(1, 0);
    vector <ll> a, b;
    for (ll i = 1; i <= n; i++) {
        if (z[i]) {
            a.pb(i);
        }
        else {
            b.pb(i);
        }
    }
    vector <pair <ll, ll>> ans;
    for (ll i = 0; i < min(a.size(), b.size()); i++) {
        ans.pb({a[i], b[i]});
    }
    cout << ans.size() << '\n';
    for (auto e : ans) {
        cout << e << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
}
