#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()

using namespace std;

void solve(){
    int n, k; cin >> n >> k;

    vector<array<int, 3>> a(k);
    for(auto &[l, m, r]: a) cin >> l >> m >> r;

    sort(all(a), [](auto a, auto b){ return a[2] < b[2]; });
    vector<int> mark(k, 0);

    bool flag= 1;
    function<void(int, int)> dfs= [&](int u, int last){
        mark[u]= 1;

        for(int v= 0; v < k; v++){
            if(v == last || v == u) continue;

            auto [l1, m1, r1]= a[u];
            auto [l2, m2, r2]= a[v];
            if(l1 <= m2 && m2 <= r1){
                if(mark[v]) flag= 0;
                else dfs(v, u);
            }
        }
    };

    for(int u= 0; u < k; u++){
        if(!mark[u]) dfs(u, -1);
    }

    int ind= a[0][0];
    for(auto [l, m, r]: a){
        if(ind < l) flag= 0;
        ind= r;
    }

    if(flag) cout << "YES\n";
    else cout << "NO\n";
}

int main(){
    int _; cin >> _;
    while(_--){
        solve();
    }
}