#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll h, w;
    cin >> h >> w;

    vector<vector<ll>> a(h, vector<ll>(w));
    for (int i=0; i<h; ++i) {
        for (int j=0; j<w; ++j) {
            char c; cin >> c;
            a[i][j] = c - '0';
        }
    }

    vector<vector<ll>> dp(h, vector<ll>(w));

    for (int j=0; j<w; ++j)
        dp[0][j] = (a[0][j]) ? 1 : 0;

    for (int j=0; j<w; ++j) {
        for (int i=1; i<h; ++i) {
            dp[i][j] = (a[i][j]) ? dp[i-1][j] + 1 : 0;
        }
    }

    ll res = 0;
    for (int i=0; i<h; ++i) {
        for (int j=0; j<w; ++j) {
            ll curres = dp[i][j], maxx = dp[i][j];
            ll it = j+1;
            while (it < w && dp[i][it]) {
                curres += min(maxx, dp[i][it]);
                maxx = min(maxx, dp[i][it]);
                it++;
            }
            res = max(res, curres);
        }
    }

    cout << res;

    return 0;
}
















