#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll> > g;
vector<ll> col;

void dfs(const ll v, const ll p, ll c) {
    col[v] = c;
    for (const auto &to: g[v]) {
        if (to != p) {
            dfs(to, v, 1 - c);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    ll d;
    cin >> d;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    col.assign(n, 0);
    dfs(0, 0, 0);
    vector<ll> a, b;
    for (ll i = 0; i < n; i++) {
        if (col[i] == 0) {
            a.push_back(i);
        } else {
            b.push_back(i);
        }
    }
    const ll ans = min(a.size(), b.size());
    cout << ans << '\n';
    for (ll i = 0; i < ans; i++) {
        cout << a[i] + 1 << ' ' << b[i] + 1 << '\n';
    }
}
