#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 5e5 + 10;

int n, k, m[N];
pii otr[N];
vector<int> by_end[N];
bool dp[N];

void solve() {
    cin >> n >> k;
    fill(dp, dp + n + 1, false);
    for (int i = 0; i <= n; ++i) by_end[i].clear();
    for (int i = 1; i <= k; ++i) {
        int x, y; cin >> x >> m[i] >> y;
        otr[i] = {x, y};
        by_end[y].pb(i);
    }

    dp[0] = true;

    for (int i = 1; i <= n; ++i) {
        for (auto j : by_end[i]) {
            for (int i1 = otr[j].X - 1; i1 < m[j]; ++i1) {
                if (dp[i1]) dp[i] = true;
                if (dp[i]) break;
            }
        }
    }

    if (dp[n]) cout << "YES\n";
    else cout << "NO\n";
}

void solve1() {
    cin >> n >> k;
    for (int i = 1; i <= k; ++i) {
        cin >> otr[i].X >> m[i] >> otr[i].Y;
    }

    vector<int> inds(k);
    iota(all(inds), 1);
    do {
        vector<bool> usd(n + 1, false);
        for (int i : inds) {
            if (usd[m[i]]) continue;
            for (int j = otr[i].X; j <= otr[i].Y; ++j) usd[j] = true;
        }
        bool f = true;
        for (int i = 1; i <= n; ++i) {
            if (!usd[i]) f = false;
        }
        if (f) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(all(inds)));
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve1();
    }
    return 0;
}