#include<bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
//#pragma GCC target("avx")

typedef long long ll;
#define int __int128
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()

const int MOD = 1e9 + 7;
const int INF = 1e6;
const int N = 3e5 + 10;

void input(int &x) {
    ll y; cin >> y;
    x = y;
}

void print(int x) {
    string res;
    while (x > 0) {
        res += (char)('0' + (x % 10));
        x /= 10;
    }
    reverse(all(res));
    if ((int)res.size() == 0) res += '0';
    cout << res << ' ';
}

ll n, x0, d, x[N], optr[N], optl[N], suf_x_r[N], suf_x_l[N];
int suf_x2_l[N], suf_x2_r[N], pref_optr[N], pref_optl[N];
vector<ll> lft, rgh;

ll dst(ll x, ll y) {
    return (x - y) * (x - y);
}

unordered_map<int, int> lll, rrr;

int val_l(ll l) {
    if (lll.find(l) == lll.end()) {
        ll x = x0 - d * l;
        ll j = (upper_bound(optl + 1, optl + (int)lft.size(), l) - optl);
        lll[l] = pref_optl[j - 1] + ((int)lft.size() - j) * x * x - 2 * x * suf_x_l[j] + suf_x2_l[j];
    }
    return lll[l];
}

int val_r(ll r) {
    if (rrr.find(r) == rrr.end()) {
        ll x = x0 + d * r;
        ll j = (upper_bound(optr + 1, optr + (int)rgh.size(), r) - optr);
        rrr[r] = pref_optr[j - 1] + ((int)rgh.size() - j) * x * x - 2 * x * suf_x_r[j] + suf_x2_r[j];
    }
    return rrr[r];
}

int f(ll r, ll tj) {
    int right = val_r(r);
    int ans = right + tj * r + val_l(0);

    ll lb = 0, rb = INF;
    while (rb - lb > 4) {
        ll m1 = (rb + 2 * lb) / 3;
        ll m2 = (2 * rb + lb) / 3;
        int v1 = right + val_l(m1) + tj * (m1 + r) + tj * min(m1, r);
        int v2 = right + val_l(m2) + tj * (m2 + r) + tj * min(m2, r);
        if (v2 > v1) rb = m2;
        else lb = m1;
    }

    for (ll i = lb; i <= rb; ++i) ans = min(ans, right + val_l(i) + tj * (i + r) + tj * min(i, r));

    return ans;
}

void solve() {
    cin >> n;
    for (ll i = 1; i <= n; ++i) cin >> x[i];
    cin >> x0 >> d;

    sort(x + 1, x + n + 1);

    rgh.pb(x0);
    for (ll i = 1; i <= n; ++i) {
        if (x[i] < x0) lft.pb(x[i]);
        if (x[i] > x0) rgh.pb(x[i]);
    }
    lft.pb(x0);
    reverse(all(lft));

    for (ll i = 1; i < (ll)rgh.size(); ++i) {
        optr[i] = (rgh[i] - x0) / d;
        for (ll dx = optr[i] - 1; dx <= optr[i] + 1; ++dx) {
            if (dst(rgh[i], x0 + d * dx) < dst(rgh[i], x0 + d * optr[i])) optr[i] = dx;
        }
        pref_optr[i] = pref_optr[i - 1] + dst(rgh[i], x0 + d * optr[i]);
    }

    for (ll i = 1; i < (ll)lft.size(); ++i) {
        optl[i] = (x0 - lft[i]) / d;
        for (ll dx = optl[i] - 1; dx <= optl[i] + 1; ++dx) {
            if (dst(lft[i], x0 - d * dx) < dst(lft[i], x0 - d * optl[i])) optl[i] = dx;
        }
        pref_optl[i] = pref_optl[i - 1] + dst(lft[i], x0 - d * optl[i]);
    }

    suf_x2_l[(ll)lft.size() - 1] = lft.back() * lft.back();
    suf_x_l[(ll)lft.size() - 1] = lft.back();
    for (ll i = (ll)lft.size() - 2; i >= 0; --i) {
        suf_x2_l[i] = suf_x2_l[i + 1] + lft[i] * lft[i];
        suf_x_l[i] = suf_x_l[i + 1] + lft[i];
    }

    suf_x2_r[(ll)rgh.size() - 1] = rgh.back() * rgh.back();
    suf_x_r[(ll)rgh.size() - 1] = rgh.back();
    for (ll i = (ll)rgh.size() - 2; i >= 0; --i) {
        suf_x2_r[i] = suf_x2_r[i + 1] + rgh[i] * rgh[i];
        suf_x_r[i] = suf_x_r[i + 1] + rgh[i];
    }

    ll q; cin >> q;
    while (q--) {
        ll tj; cin >> tj;
        int ans = f(0, tj);

        ll l = 0, r = INF;

        while (r - l > 4) {
            ll m1 = (r + 2 * l) / 3;
            ll m2 = (2 * r + l) / 3;
            int v1 = f(m1, tj);
            int v2 = f(m2, tj);
            if (v2 > v1) r = m2;
            else l = m1;
        }

        for (ll i = l; i <= r; ++i) ans = min(ans, f(i, tj));
        print(ans);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}