#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector <pair<int, int>> lr(k);
    vector <int> m(k);
    for (int i = 0; i < k; ++i) {
        cin >> lr[i].first >> m[i] >> lr[i].second;
        --m[i];
        --lr[i].first;
    }
    vector <bool> a(n, false);
    bool res = true;
    for (int i = 0; i < k && res; ++i) {
        if (a[m[i]]) res = false;
        else {
            for (int x = m[i]; x >= lr[i].first && !a[x]; --x) a[x] = true;
            for (int x = m[i] + 1; x < lr[i].second && !a[x]; ++x) a[x] = true;
        }
    }
    res = res && all_of(a.begin(), a.end(), [](const bool x){return x;});
    cout << (res ? "YES" : "NO") << "\n";
}

int main() {
    int T;
    for (cin >> T; T--; solve()) {}
    return 0;
}