#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector <pair<int, int>> lr(k);
    vector <int> m(k);
    for (int i = 0; i < k; ++i) {
        cin >> lr[i].first >> m[i] >> lr[i].second;
        --m[i];
        --lr[i].first;
    }
    vector <bool> a(n, false);
    bool res = false;
    unordered_set<int> S;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k && !res; ++j) {
            if (i == j) continue;
            res = (m[i] < lr[j].first && lr[i].second >= lr[j].first) || (m[i] >= lr[j].second && lr[i].first <= lr[j].second);
        }
    }

    cout << (res ? "YES" : "NO") << "\n";
}

int main() {
    int T;
    for (cin >> T; T--; solve()) {}
    return 0;
}