#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector <pair<int, int>> lr(k);
    vector <int> m(k);
    for (int i = 0; i < k; ++i) {
        cin >> lr[i].first >> m[i] >> lr[i].second;
        assert((m[i] == 1) || (m[i] == n));
        --m[i];
        --lr[i].first;

    }
    vector <bool> a(n, false);
    bool res = false;
    int max_R = -1;
    for (int i = 0; i < k && !res; ++i) {
        auto [l, r] = lr[i];
        if (m[i] == 0) {
            if (r == n) res = true;
            max_R = max(max_R, r);
        }
    }
    for (int i = 0; i < k && !res; ++i) {
        auto [l, r] = lr[i];
        if (m[i] == n - 1) {
            if (l == n) res = true;
            if (l <= max_R) res = true;
        }
    }
    cout << (res ? "YES" : "NO") << "\n";
}

int main() {
    int T;
    for (cin >> T; T--; solve()) {}
    return 0;
}