#include <bits/stdc++.h>
using namespace std;
vector<vector<int>> gr;
vector<vector<int>> g;
vector<int> h;
vector<int> pr;
void dfs(int v, int p) {
    pr[v] = p;
    for (auto x : gr[v]) {
        if (x != p) {
            h[x] = h[v] + 1;
            dfs(x, v);

        }
    }
}
vector<int> vst;
vector<int> mth;
bool kuhn(int v, int ver) {
    if (vst[v] == ver) return false;
    vst[v] = ver;
    for (auto x : g[v]) {
        if (mth[x] == -1 || (kuhn(mth[x], ver))) {
            mth[x] = v;
            return true;
        }
    }
    return false;
}
void dfs(int u, int v, int d, int ok, int ver) {
    vst[v] = ver;
    if (ok) {
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (d == 0) return;
    for (auto x : gr[v]) {
        if (vst[x] != ver) dfs(u, x, d - 1, (ok ^ 1), ver);
    }
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, d; cin >> n >> d;
    gr.resize(n);
    pr.resize(n);
    h.resize(n);
    for (int i = 0; i + 1 < n; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    g.resize(n);
    dfs(0, -1);
    int ans = 0;
    vst.assign(n, 0);
    for (int v = 0; v < n; v++) {
        dfs(v, v, d, 0, v + 1);
    }
    vst.resize(n);
    vst.assign(n, 0);
    mth.assign(n, -1);

    for (int i = 0; i < n; i++) {
        if (h[i] % 2) continue;
        if (kuhn(i, i + 5)) ans++;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; i++) {
        if (mth[i] != -1) cout << i + 1 << ' ' << mth[i] + 1 << '\n';
    }
    return 0;
}