#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

void solve(){
    int n, k;
    cin >> n >> k;
    vector<int> delta(n + 1);
    while(k--){
        int l, r, m;
        cin >> l >> r >> m;
        l--;
        delta[l]++;
        delta[r]--;
    }
    int d = 0;
    for(int i = 0; i < n; i++){
        d += delta[i];
        if(d <= 0){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}