#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vb vc<bool>
 
struct P {
    int l, r, m;
};
 
void solve() {
    int n, k;
    cin >> n >> k;
    vc<P> p(k);
    for (int i = 0; i < k; ++i) {
        cin >> p[i].l >> p[i].m >> p[i].r;
        // --p[i].l; --p[i].r;
    }
    vi dp(n + 1);
    dp[0] = 1;
    for (int r = 1; r <= n; ++r) {
        for (P el : p) {
            if (el.r == r) {
                for (int i = el.l; i <= el.m; ++i) {
                    dp[r] |= dp[i - 1];
                }
            }
        }
    }
    cout << (dp[n] ? "YES\n" : "NO\n");
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}