#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>

#include <functional>

using namespace std;

#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vb vc<bool>
#define pb push_back
#define ld long double

i64 del(i64 a, i64 b) {
    if (a >= 0) {
        return a / b;
    }
    if (abs(a) % b == 0) {
        return a / b;
    }
    return a / b - 1;
}

#define int int64_t

void solve() {
    int n;
    cin >> n;
    vi x(n);
    for (int &el : x) {
        cin >> el;
    }
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vi t(m);
    for (int &el : t) cin >> el;
    // for (int &el : x) {
    //     el -= x0;
    // }


    for (int el : t) {
        function<__int128_t(int)> get = [&](int k) {
            __int128_t ans = 0;
            for (int ell : x) {
                ans += (__int128_t)abs(k) * el + (ell - x0 - k * d) * (ell - x0 - k * d);
            }
            return ans;
        };
        int r = 1e8 / d;
        int l = -r;
        while (r > l + 2) {
            int ll = (2 * l + r) / 3;
            int rr = (2 * r + l) / 3;
            __int128_t ans1 = get(ll), ans2 = get(rr);
            if (ans1 > ans2) {
                l = ll;
            } else {
                r = rr;
            }
        }
        cout << min({(i64)get(l), (i64)get(l + 1), (i64)get(r)}) << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}