#include <iostream>
#include <vector>
#include <string>

using namespace std;

vector<vector<int>> Sept;
vector<vector<vector<int>>> dpmn, dpind;
int iln, jln;

int Envy (int row, int st, int fn) {
    if (st == fn) {
        return st;
    }
    int ind = 0, ln = 2;
    while (ln < st - fn + 2) {
        ind++;
        ln *= 2;
    }
    ln /= 2;
    if (Sept[row][Envy(row, st + ln, fn)] > dpmn[row][ind][st]) {
        return dpind[row][ind][st];
    }
    return Envy(row, st + ln, fn);
}

int Hate (int row, int st, int fn) {
    if (st > fn) {
        return 0;
    }
    if (st == fn) {
        return Sept[row][st];
    }
    int LOX = Envy(row, st, fn);
    if (Hate(row, LOX + 1, fn) > Hate(row, st, LOX - 1) + Sept[row][LOX] * (fn - LOX + 1)) {
        return Hate(row, LOX + 1, fn);
    }
    return Hate(row, st, LOX - 1) + Sept[row][LOX] * (fn - LOX + 1);
}

int main() {
    cin >> iln >> jln;
    vector<string> HKMP;
    for (int i = 0; i < iln; i++) {
        vector<int> nSept (jln, 0), nndpind;
        vector<vector<int>> ndpmn, ndpind;
        string Gnida; cin >> Gnida; HKMP.push_back(Gnida);
        for (int j = 0; j < jln; j++) {
            nndpind.push_back(j);
        }
        Sept.push_back(nSept); dpmn.push_back(ndpmn); ndpind.push_back(nndpind); dpind.push_back(ndpind);
    }
    for (int j = 0; j < jln; j++) {
        if (HKMP[0][j] == '1') {
            Sept[0][j] = 1;
        }
    }
    for (int j = 0; j < jln; j++) {
        for (int i = 1; i < iln; i++) {
            if (HKMP[i][j] == '1') {
                Sept[i][j] = Sept[i - 1][j] + 1;
            }
        }
    }
    for (int i = 0; i < iln; i++) {
        vector<int> ndpmn;
        for (int j = 0; j < jln; j++) {
            ndpmn.push_back(Sept[i][j]);
        }
        dpmn[i].push_back(ndpmn);
    }
    for (int i = 0; i < iln; i++) {
        int ind = 1;
        for (int ln = 2; ln <= jln; ln *= 2) {
            vector<int> ndpmn, ndpind;
            for (int j = 0; j <= jln - ln; j++) {
                if (dpmn[i][ind - 1][j] > dpmn[i][ind - 1][j + ln / 2]) {
                    ndpmn.push_back(dpmn[i][ind - 1][j + ln / 2]);
                    ndpind.push_back(dpind[i][ind - 1][j + ln / 2]);
                } else {
                    ndpmn.push_back(dpmn[i][ind - 1][j]);
                    ndpind.push_back(dpind[i][ind - 1][j]);
                }
            }
            dpmn[i].push_back(ndpmn); dpind[i].push_back(ndpind);
            ind++;
        }
    }
    int mx = 0;
    for (int i = 0; i < iln; i++) {
        int res = Hate(i, 0, jln - 1);
        if (mx < res) {
            mx = res;
        }
    }
    cout << mx << endl;
}
