#include  <bits/extc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-lopps")
#endif

//#define int long long
#define ll long long
#define all(x) x.begin(), x.end()

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr), ios_base::sync_with_stdio(false);
#endif
    int h, w;
    cin >> h >> w;
    vector<vector<int> > a(h, vector<int>(w));
    for (int i = 0; i < h; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < w; j++)
            a[i][j] = s[j] - '0';
    }
    vector<vector<int> > u(h, vector<int>(w, 0));
    for (int j = 0; j < w; j++)
        u[0][j] = a[0][j];
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < w; j++)
            if (a[i][j])
                u[i][j] = 1 + u[i - 1][j];
    }
    vector<vector<int> > dp(h, vector<int>(w + 1, 0));
    vector<int> f(w);
    for (int i = 0; i < h; i++) {
        f.assign(w, -1);
        vector<int> st;
        st.push_back(w - 1);
        for (int j = w - 2; j >= 0; j--) {
            int cur = u[i][j];
            while (!st.empty() && u[i][st.back()] > cur)
                st.pop_back();
            if (!st.empty())
                f[j] = st.back();
            st.push_back(j);
        }
        dp[i][w - 1] = u[i][w - 1];
        for (int j = w - 2; j >= 0; j--) {
            if (a[i][j] == 0) {
                continue;
            }
            if (a[i][j + 1] == 0) {
                dp[i][j] = u[i][j];
                continue;
            }
            if (u[i][j] >= u[i][j + 1]) {
                dp[i][j] = dp[i][j + 1] + u[i][j];
            } else {
                int k = f[j];
                if (k == -1) {
                    dp[i][j] = u[i][j] * (w - j);
                } else {
                    dp[i][j] = dp[i][k] + u[i][j] * (k - j);
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            ans = max(ans, dp[i][j]);
    cout << ans;
    return 0;
}
