#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > seg;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        seg.emplace_back(l, r);
    }
    vector<int> used(n + 1, 0);
    sort(all(seg), [&](const pair<int, int> p1, const pair<int, int> p2) {
        if (p1.second != p2.second) {
            return p1.second < p2.second;
        }
        return p1.first < p2.first;
    });
    used[0] = 1;
    for (int i = 0; i < n; ++i) {
        if (used[seg[i].first - 1]) {
            used[seg[i].second] = 1;
        }
    }
    if (used[n]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
