#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    for (auto &[l, m, r]: s) cin >> l >> m >> r;
    vector<seg> x, y;
    for (auto [l, m, r] : s) {
        if (l == 1 && r == n) {
            cout << "YES\n";
            return;
        }
        if (l == 1) {
            x.emplace_back(l, m, r);
        } else {
            y.emplace_back(l, m, r);
        }
    }
    for (auto u : x) {
        for (auto v : y) {
            if (u.r < v.l) {
                continue;
            }
            if (u.r < v.m || v.l > u.m) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
    
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
