#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> seg(k);
    for (int i = 0; i < k; ++i) {
        int m;
        cin >> seg[i].first >> m >> seg[i].second;
    }
    sort(all(seg), [&](const pair<int, int> p1, const pair<int, int> p2) {
        if (p1.second != p2.second) {
            return p1.second < p2.second;
        }
        return p1.first < p2.first;
    });
    int mn = n;
    for (int i = k - 1; i >= 0; --i) {
        if (seg[i].second >= mn) {
            mn = min(mn, seg[i].first);
        }
    }
    if (mn == 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
