#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int) x.size()
#define all(x) x.begin(), x.end()
#define int long long

vector<pair<int, int>> ans;
vector<vector<int>> g, dp;
vector<int> h, e, o;
int n, d;

void dfss1(int v, int pred) {
    h[v] = h[pred] + 1;
    for (int i: g[v]) {
        if (i == pred) {
            continue;
        }
        dfss1(i, v);
    }
}

void dfss(int v, int pred) {
    vector<vector<int>> now(4);
    now[0].pb(v);
    for (int i: g[v]) {
        if (i == pred) {
            continue;
        }
        dfss(i, v);
        for (auto it: dp[i]) {
            now[h[it] - h[v]].pb(it);
        }
    }
    while (sz(now[0]) && sz(now[3])) {
        ans.pb({now[0].back(), now[3].back()});
        now[0].pop_back();
        now[3].pop_back();
    }
    while (sz(now[1]) && sz(now[2])) {
        ans.pb({now[1].back(), now[2].back()});
        now[1].pop_back();
        now[2].pop_back();
    }
    while (sz(now[0]) && sz(now[1])) {
        ans.pb({now[0].back(), now[1].back()});
        now[0].pop_back();
        now[1].pop_back();
    }
    for (int i = 0; i < 3; ++i) {
        for (int j : now[i]) {
            dp[v].pb(j);
        }
    }
}

int dfs(int v, int pred) {
    bool was = false;
    for (int i : g[v]) {
        if (i == pred) {
            continue;
        }
        int x = dfs(i, v);
        if (x && !was) {
            was = true;
            ans.pb({i, v});
        }
    }
    if (!was) {
        return 1;
    }
    return 0;
}

void dfs1(int v, int pred) {
    h[v] = h[pred] + 1;
    if (h[v] & 1) {
        o.pb(v);
    } else {
        e.pb(v);
    }
    for (int i : g[v]) {
        if (i == pred) {
            continue;
        }
        dfs1(i, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d;
    h.resize(n + 1);
    g.resize(n + 1);
    dp.resize(n + 1);
    for (int i = 1; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        g[l].pb(r);
        g[r].pb(l);
    }
    if (d == 1) {
        dfs(1, 1);
    } else if (d == n - 1) {
        dfs1(1, 1);
        if (sz(e) > sz(o)) {
            swap(o, e);
        }
        for (int i = 0; i < sz(e); ++i) {
            ans.pb({e[i], o[i]});
        }
    } else {
        dfss1(1, 1);
        dfss(1, 1);
    }
    cout << sz(ans) << "\n";
    for (auto it: ans) {
        cout << it.first << " " << it.second << "\n";
    }
    return 0;
}