#include <bits/stdc++.h>

using namespace std;

struct node {
    int l, m, r;
};

vector<int> tree, modif;

void change(int x, int l, int r, int ql, int qr, int val) {
    if (l == ql && r == qr) {
        tree[x] = val;
        modif[x] = val;
        return;
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (qr <= m) {
        change(2 * x + 1, l, m, ql, qr, val);
        return;
    }
    if (ql >= m) {
        change(2 * x + 2, m, r, ql, qr, val);
        return;
    }
    change(2 * x + 1, l, m, ql, m, val);
    change(2 * x + 2, m, r, m, qr, val);
}

int get(int x, int l, int r, int id) {
    if (r - l == 1) {
        return tree[x];
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (id < m) {
        return get(2 * x + 1, l, m, id);
    } else {
        return get(2 * x + 2, m, r, id);
    }
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k, f = 0;
        cin >> n >> k;
        set<int> s;
        vector<node> a, b;
        for (int i = 0; i < k; i++) {
            node x;
            cin >> x.l >> x.m >> x.r;
            if (x.l == 1) {
                a.push_back(x);
            } else {
                b.push_back(x);
            }
            if (x.l == 1 && x.r == n) {
                f = 1;
            }
        }
        for (auto x : a) {
            for (auto y : b) {
                if (x.m < y.l || y.m > x.r) {
                    if (x.l >= y.r) {
                        f = 1;
                    }
                }
            }
        }
        if (f) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}