#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <iomanip>
using namespace std;
using ll = int;
void solve() {
	ll n, m;
	cin >> n >> m;
	vector <vector <ll>> a(n, vector <ll>(m));
	for (ll i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (ll j = 0; j < m; ++j) {
			a[i][j] = s[j] - '0';
		}
	}
	vector <vector <ll>> r(n, vector <ll>(m));
	for (ll i = 0; i < n; ++i) {
		for (ll j = m - 1; j > -1; --j) {
			if (a[i][j] == 0) {
				continue;
			}
			if (j < m - 1 && a[i][j + 1] == 0) {
				r[i][j] = 1;
			}
			else if (j < m - 1) {
				r[i][j] = r[i][j + 1] + 1;
			}
			else {
				r[i][j] = m - j;
			}
			//cout << r[i][j] << ' ' << i << ' ' << j << "\n";
		}
	}
	ll ans = 0;
	for (ll j = 0; j < m; ++j) {
		vector <ll> s;
		for (ll i = 0; i < n; ++i) {
			if (a[i][j] == 0) {
				s.clear();
			}
			else {
				ll sum = 0;
				for (auto& c : s) {
					c = min(c, r[i][j]);
					sum += c;
				}
				s.push_back(r[i][j]);
				sum += r[i][j];
				ans = max(ans, sum);
			}
		}
	}
	cout << ans;
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}