#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, d;
vector<vector<ll>> g;
vector<bool> used, f;
vector<ll> dist;
vector<vector<ll>> up;
vector<pair<ll, ll>> res = {};
vector<vector<ll>> dp;

void dfs(ll v){
    used[v] = true;
    for (auto u : g[v]){
        if (!used[u]){
            dfs(u);
            if (!f[v] && !f[u]){
                res.push_back({u, v});
                f[v] = true;
                f[u] = true;
            }
            //dp[v][0] = max({dp[v][0], dp[u][1], dp[u][0]});
            //dp[v][1] = max(dp[v][1], dp[u][0]);
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll u, v;
    cin >> n >> d;
    g.resize(n);
    used.resize(n, false);
    f.resize(n, false);
    dp.resize(n, vector<ll> (2, 0));
    for (int i = 0; i < n - 1; ++i){
        cin >> u >> v;
        u -= 1, v -= 1;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    cout << res.size() << '\n';
    for (int i = 0; i < res.size(); ++i){
        cout << res[i].first + 1 << " " << res[i].second + 1 << '\n';
    }
    return 0;
}
