#include<iostream>
#include<vector>
#include<algorithm>
#include<stack>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (ll i = 0; i < h; i++) {
        cin >> a[i];
    }
    vector<vector<ll>> b(w, vector<ll>(h));
    for (ll i = 0; i < h; i++) {
        for (ll j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                b[j][i] = 0;
            } else {
                if (j == w - 1) {
                    b[j][i] = 1;
                } else {
                    b[j][i] = b[j + 1][i] + 1;
                }
            }
        }
    }
    ll answer = 0;
    for (ll j = 0; j < w; j++) {
        stack<pair<ll, ll>> s1;
        ll answer1 = 0;
        for (ll i = 0; i < h; i++) {
            ll k1 = 0;
            while (!s1.empty() && s1.top().first > b[j][i]) {
                k1 += s1.top().second;
                answer1 -= s1.top().second * s1.top().first;
                s1.pop();
            }
            if (!s1.empty() && s1.top().first == b[j][i]) {
                k1 += s1.top().second;
                answer1 -= s1.top().second * s1.top().first;
                s1.pop();
            }
            k1++;
            answer1 += k1 * b[j][i];
            s1.push({b[j][i], k1});
            answer = max(answer, answer1);
        }
    }
    cout << answer;
}