#include<iostream>
#include<algorithm>
#include<vector>
#include<set>

using namespace std;

#define ll long long

struct str {
    ll l, m, r;
    str() {}
    str(ll l, ll m, ll r) : l(l), m(m), r(r) {}
};

struct str1 {
    ll x, type;
    str1() {}
    str1(ll x, ll type) : x(x), type(type) {}
};

bool cmp(const str1 &p1, const str1 &p2) {
    return make_pair(p1.x, p1.type) < make_pair(p2.x, p2.type);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        vector<str> a(k);
        for (ll i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        ll f = 0;
        for (ll i1 = 0; i1 < (1 << k); i1++) {
            ll x = i1;
            vector<str> b;
            set<ll> s1;
            for (ll i = 0; i < k; i++) {
                if (x % 2 == 1) {
                    b.push_back(a[i]);
                    s1.insert(a[i].m);
                }
                x = x / 2;
            }
            if (s1.size() != b.size()) {
                continue;
            }
            if (b.size() == 0) {
                continue;
            }
            vector<str1> c;
            for (auto elem : b) {
                c.push_back(str1(elem.l, 0));
                if (elem.l != 1) {
                    c.push_back(str1(elem.l - 1, 1));
                }
                if (elem.r != n) {
                    c.push_back(str1(elem.r + 1, 1));
                }
                c.push_back(str1(elem.r, 2));
            }
            sort(c.begin(), c.end(), cmp);
            if (c[0].x != 1 || c.back().x != n) {
                continue;
            }
            ll f1 = 0;
            ll k1 = 0;
            for (auto elem : c) {
                if (elem.type == 0) {
                    k1++;
                } else if (elem.type == 1) {
                    if (k1 == 0) {
                        f1 = 1;
                        break;
                    }
                } else {
                    k1--;
                }
            }
            for (ll i = 0; i < b.size(); i++) {
                for (ll j = i + 1; j < b.size(); j++) {
                    pair<ll, ll> p = {max(b[i].l, b[j].l), min(b[i].r, b[j].r)};
                    if (p.first > p.second) {
                        continue;
                    }
                    if (b[i].m >= p.first && b[i].m <= p.second && b[j].m >= p.first && b[j].m <= p.second) {
                        f1 = 1;
                        break;
                    }
                }
                if (f1 == 1) {
                    break;
                }
            }
            if (f1 == 0) {
                f = 1;
                break;
            }
        }
        if (f == 1) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}