#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
 
using namespace std;
 
#define ll long long
 
struct str {
    ll l, m, r;
    str() {}
    str(ll l, ll m, ll r) : l(l), m(m), r(r) {}
};
 
struct str1 {
    ll x, type;
    str1() {}
    str1(ll x, ll type) : x(x), type(type) {}
};
 
bool cmp(const str1 &p1, const str1 &p2) {
    return make_pair(p1.x, p1.type) < make_pair(p2.x, p2.type);
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        vector<str> a(k);
        ll f2 = 0;
        for (ll i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].l--;
            a[i].m--;
            a[i].r--;
            if (a[i].l == 0 && a[i].r == n - 1) {
                f2 = 1;
            }
        }
        if (f2 == 1) {
            cout << "YES" << '\n';
            continue;
        }
        ll f = 0;
        for (ll i = 0; i < k; i++) {
            for (ll j = i + 1; j < k; j++) {
                pair<ll, ll> p = {max(a[i].l, a[j].l), min(a[i].r, a[j].r)};
                if (p.first <= p.second && p.first <= a[i].m && p.second >= a[i].m && p.first <= a[j].m && p.second >= a[j].m) {
                    continue;
                }
                pair<ll, ll> p1 = {a[i].l, a[i].r};
                pair<ll, ll> p2 = {a[j].l, a[j].r};
                if (p1.first > p2.first) {
                    swap(p1, p2);
                }
                if (p1.first != 0 || p2.second != n - 1) {
                    continue;
                }
                if (p2.first - p1.second <= 1) {
                    f = 1;
                    break;
                }
            }
            if (f == 1) {
                break;
            }
        }
        if (f == 1) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}