#include<iostream>
#include<algorithm>
#include<vector>
#include<set>

using namespace std;

#define ll long long

struct str {
    ll l, m, r;
    str() {}
    str(ll l, ll m, ll r) : l(l), m(m), r(r) {}
};

struct str1 {
    ll x, type;
    str1() {}
    str1(ll x, ll type) : x(x), type(type) {}
};

bool cmp(const str1 &p1, const str1 &p2) {
    return make_pair(p1.x, p1.type) < make_pair(p2.x, p2.type);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        vector<str> a(k);
        vector<ll> b1(n, -1e18);
        for (ll i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].l--;
            a[i].m--;
            a[i].r--;
            b1[a[i].l] = max(b1[a[i].l], a[i].r);
        }
        vector<str1> c;
        for (ll i = 0; i < n; i++) {
            if (b1[i] == -1e18) {
                continue;
            }
            if (i != 0) {
                c.push_back(str1(i - 1, 1));
            }
            if (i != n - 1) {
                c.push_back(str1(i + 1, 1));
            }
            c.push_back(str1(i, 0));
            c.push_back(str1(b1[i], 2));
        }
        sort(c.begin(), c.end(), cmp);
        if (c[0].x != 0 || c.back().x != n - 1) {
            cout << "NO" << '\n';
            continue;
        }
        ll f1 = 0;
        ll k1 = 0;
        for (auto elem : c) {
            if (elem.type == 0) {
                k1++;
            } else if (elem.type == 1) {
                if (k1 == 0) {
                    f1 = 1;
                    break;
                }
            } else {
                k1--;
            }
        }
        if (f1 == 0) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}