#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll int

vector<vector<ll>> gr;
vector<vector<ll>> dp;

void dfs(ll v, ll p) {
    for (auto elem : gr[v]) {
        if (elem != p) {
            dfs(elem, v);
        }
    }
    if (v != p) {
        ll x = 0;
        for (auto elem : gr[v]) {
            if (elem != p) {
                x += dp[elem][0];
            }
        }
        dp[v][1] = x + 1;
    }
    ll x = 0;
    for (auto elem : gr[v]) {
        if (elem != p) {
            x += dp[elem][0];
        }
    }
    for (auto elem : gr[v]) {
        if (elem != p) {
            dp[v][0] = max(dp[v][0], x - dp[elem][0] + dp[elem][1]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, d1;
    cin >> n >> d1;
    gr.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dp.resize(n, vector<ll>(2));
    dfs(0, 0);
    cout << max(dp[0][0], dp[0][1]) << endl;
    cout << -1;
}