#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> h(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        int bal = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '1') {
                bal++;
            } else {
                bal = 0;
            }
            h[i][j] = bal;
        }
    }
    int ans = 0;
    for (int j = 0; j < m; j++) {
        vector<pair<int, int>> st;
        int val = 0;
        for (int i = 0; i < n; i++) {
            int res = 1;
            while (!st.empty() && st.back().first >= h[i][j]) {
                res += st.back().second;
                val -= st.back().first * st.back().second;
                st.pop_back();
            }
            val += res * h[i][j];
            if (val==16) {
                cout<<"";
            }
            ans = max(ans, val);
            st.emplace_back(h[i][j], res);
        }
    }
    cout << ans << '\n';
}