#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0,d;
    cin >> x0 >> d;
    int q;
    cin >> q;
    while (q--) {
        int c;
        cin >> c;
        assert(c == 0);
        int ans = 0;
        for (int j = 0; j < n; j++) {
            int dist = abs(x0 - x[j]);
            int Do = (dist + d - 1) / d;
            int relax = numeric_limits<int>::max();
            for (int i = -1; i <= 1; i++) {
                int point = x0 + i * Do * d;
                relax = min(relax, power2(point - x[j]));
            }
            ans += relax;
        }
        cout << ans << '\n';
    }
}