#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using lli = __int128;

const ll maxn = 3e5 + 5;

const ll INF = 2e18;
ll mmod(ll a, ll mod) {
    a %= mod;
    if (a < 0) {
        a+= mod;
    }
    return a;
}
ll cnta = 0, cntb = 0;
vector<vector<ll>> graph(maxn);
vector<ll> de(maxn);
vector<bool>used(maxn, 0);
vector<ll> col(maxn);
vector<ll> tin(maxn), tout(maxn);
vector<vector<ll>> dp(maxn, vector<ll>(11, -1));
ll ti = 0;
void dfs(ll v, ll c) {
    tin[v] = ++ti;
    col[v] = c;
    used[v] = 1;
    for (int i = 1; i <= 10; ++i) {
        dp[v][i] = dp[dp[v][i-1]][i-1];
    }
    for (auto e : graph[v]) {
        if (!used[e]) {
            dp[e][0] = v;
            de[e] = de[v] +1;
            dfs(e, c^1);
        }
    }
    tout[v] = ++ti;
}

bool isa(ll v, ll u) {
    if (tin[v] < tin[u] && tout[v] > tout[u]) {
        return 1;
    }
    return 0;
}

ll lca(ll v, ll u) {
    if (u == v) {
        return v;
    }
    if (isa(u, v)) {
        return u;
    }
    if (isa(v, u)) {
        return v;
    }
    for (int i = 10; i >=0; --i) {
        if (isa(dp[u][i], v)) {
            continue;
        }
        u = dp[u][i];
    }
    return dp[u][0];
}


void solve() {
    // ll n;
    // cin >> n;
    // vector<lli> a(n);
    // lli maxn = 0;
    // for (int i = 0; i < n; ++i) {
    //     ll l;
    //     cin >> l;
    //     a[i] = l;
    //     maxn = max((ll)maxn, l);
    // }
    // ll x, d;
    // cin >> x >> d;
    // ll m;
    // cin >> m;
    // vector<lli> t(m);
    // for (int i = 0; i < m; ++i) {
    //     ll l;
    //     cin >> l;
    //     t[i] = l;
    // }
    // for (int i = 0; i < maxn; ++i) {
    //
    // }
    ll n;
    cin >> n;
    ll d;
    cin >> d;
    for (int i = 0; i < n-1; ++i) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        graph[l].push_back(r);
        graph[r].push_back(l);
    }
    dp[0][0] = 0;
    de[0] = 0;
    dfs(0, 0);
    vector<ll> a;
    for (int i = 0; i < n; ++i){
        a.push_back(i);
    }
    ll ans = 0;
    vector<pair<ll, ll>> tot;
    for (int i = 0; i < n-1; i+= 2) {
        ll lc = lca(a[i], a[i+1]);
        ll dst = de[a[i]] + de[a[i+1]] - 2 * de[lc];
        if (col[a[i]] == col[a[i+1]] && dst <= d) {
            ans++;
            tot.push_back({a[i], a[i+1]});
        }
    }
    while (next_permutation(a.begin(), a.end())) {
        ll res = 0;
        vector<pair<ll, ll>> pr;
        for (int i = 0; i < n-1; i+=2) {
            ll lc = lca(a[i], a[i+1]);
            ll dst = de[a[i]] + de[a[i+1]] - 2 * de[lc];
            if (col[a[i]] == col[a[i+1]] && dst <= d) {
                res++;
                pr.push_back({a[i], a[i+1]});
            }
        }
        if (res > ans) {
            ans = res;
            tot = pr;
        }
    }
    cout << ans << '\n';
    for (auto e : tot) {
        cout << e.first << " " << e.second << '\n';
    }
    // cout << min(cnta, cntb);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    // freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while(tt--) {
        solve();
        cout << '\n';
    }
}