#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
 
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define mkp make_pair

void run2();
 
int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int tst; cin >> tst;
    while(tst--) run2();
}

struct pers {
    int l, r, m;
    pers(){}
    pers(int _l, int _m, int _r): l(_l), r(_r), m(_m){}
};

bool cmp(pers a, pers b) {
    return a.r < b.r;
}
 
void run2() {
    int n, k; cin >> n >> k;
    vector<pers> a(k);
    for(int i = 0; i < k; i++) {
        int _l, _r, _m; cin >> _l >> _m >> _r;
        a[i] = pers(_l, _m, _r);
    }
    vector<int> mx(n + 1);
    for(int i = 0; i < k; i++) {
        mx[a[i].l] = max(mx[a[i].l], a[i].r);
    }
    vector<pii> t;
    for(int i = 1; i <= n; i++) {
        t.push_back(mkp(i, 1));
        t.push_back(mkp(mx[i], 2));
    }
    sort(t.begin(), t.end());
    vector<int> val(n + 1);
    for(int i = 0; i < t.size(); i++) {
        if(t[i].second == 1) val[t[i].first]++;
        else val[t[i].first]--;
    }
    int cur = 0;
    for(int i = 1; i <= n; i++) {
        cur += val[i];
        if(cur <= 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

