#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <functional>
 
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
using namespace std;
using ll = long long;
//using lll = __int128_t;

void run1();
 
int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    run1();
}

void run1() {
    int n; cin >> n;
    vector<vector<int>> g(n);
    int d; cin >> d;
    for(int i = 1; i < n; i++) {
        int x, y; cin >> x >> y; x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<int> dp0(n), dp1(n);
    function<void(int, int)> dfs = [&](int v, int par)->void {
        if(g[v].size() == 1) {
            dp0[v] = dp1[v] = 0;
            return;
        }
        for(int u : g[v]) if(u != par) dfs(u, v);
        bool flg = 0;
        for(int u : g[v]) if(u != par) {
            dp0[v] += max(dp1[u], dp0[u]);
            if(dp0[u] != dp1[u]) flg = 1;
        }
        dp1[v] = dp0[v];
        if(flg) dp1[v]++;
    };
    dfs(0, -1);
    cout << max(dp0[0], dp1[0]) << endl << -1 << endl; 
}
