#include <iostream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
using namespace std;
#define int long long
using dist = std::uniform_int_distribution<int>;
bool a_per_b(vector<int> &a,vector<int>&b) {
    if (b[1] <= a[2])return 1;
    return 0;
}
bool solve() {
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    int n,k;
    cin >> n >> k;
    vector <vector <int>> vec(k);
    for (int i = 0;i < k;i++) {
        int li,mi,ri;
        cin >> li >> mi >> ri;
        vec[i] = {li,mi,ri};
    }
    bool flag = 0;
    sort(vec.begin(),vec.end());
    int cntit = 1e5;
    do {
        shuffle(vec.begin(),vec.end(),rng);
        vector <int> pole(n+1);
        for (auto el : vec) {
            if (pole[el[1]] == 0) {
                for (int i = el[0];i <= el[2];i++) {
                    pole[i] = 1;
                }
            }
        }
        bool fl = 1;
        for (int i = 1;i <= n;i++)if (!pole[i])fl = 0;
        if (fl) {
            flag = 1;
        }
    }while (!flag && cntit--);
    return flag;
}
signed main() {
    int t;
    cin >> t;
    while (t--) {
        if (solve()) {
            cout << "YES\n";
        }else {
            cout << "NO\n";
        }
    }
}