#include <bits/stdc++.h>
using namespace std;

struct D_O {
    vector<bool> tree;

    D_O(int n) {
        tree.resize(n*4, false);
    }

    void update(int i, int l, int r, int lq, int rq) {
        if (l >= lq && r <= rq) {tree[i] = true; return;}
        if (l >= rq || r <= lq) return;
        int m = (r+l)/2;
        update(i*2+1, l, m, lq, rq);
        update(i*2+2, m, r, lq, rq);
        tree[i] = tree[i*2+1] || tree[i*2+2];
    }

    bool get(int i, int l, int r, int lq, int rq) {
        if (l >= lq && r <= rq) return tree[i];
        if (l >= rq || r <= lq) return false;
        int m = (r+l)/2;
        return get(i*2+1, l, m, lq, rq) || get(i*2+2, m, r, lq, rq);
    }
};

bool comp(vector<int>&a, vector<int>&b) {
    return a[0] < b[0];
}

int main() {
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        vector<vector<int> >a(m, vector<int>(3)); for (int i = 0; i < m; i++) cin >> a[i][0] >> a[i][1] >> a[i][2];
        sort(a.begin(), a.end(), comp);
        D_O tree0(n+1), tree1(n+1);
        tree1.update(0, 0, n+1, 0, 1);
        for (int i = 0; i < m; i++) {
            if (tree0.get(0, 0, n+1, a[i][0]-1, a[i][0]+1) || tree1.get(0, 0, n+1, a[i][0]-1, a[i][1])) {
                tree0.update(0, 0, n+1, a[i][1]+1, a[i][2]+1);
                tree1.update(0, 0, n+1, a[i][2], a[i][2]+1);
            }
        }
        if (tree1.get(0, 0, n+1, n, n+1)) cout << "YES" << endl;
        else cout << "NO" << endl;
    }
    return 0;
}