#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int get(int a, int b, int c, int l, int r) {
    int mn = inf;
    for (int x = l; x <= r; x ++) {
        mn = min(mn, a * x * x + b * x + c);
    }
    return mn;
}

struct st {
    vector <int> pref;

    void build(vector <int> &a) {
        int n = a.size();
        pref.resize(n + 1);
        pref[0] = 0;
        for (int i = 0; i < n; i ++) {
            pref[i + 1] = pref[i] + a[i];
        }
    }

    int get(int l, int r) {
        return pref[r + 1] - pref[l];
    }
};

int f(int a) {
    return a * a;
}

void solve() {
    int n;
    cin >> n;
    vector <int> x(n);
    for (int i = 0; i < n; i ++)
    {
        cin >> x[i];
    }

    sort(x.begin(), x.end());

    st pref;
    pref.build(x);

    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;

    int ind = 0;
    int start_ans = 0;
    while (ind < n) {
        if (x[ind] <= x0) {
            start_ans += (x0 - x[ind]) * (x0 - x[ind]);
            ind ++;
        }
        else {
            break;
        }
    }

    for (int _ = 0; _ < m; _ ++) {
        int t;
        cin >> t;

        /*
        int mn = inf;

        int cnt = 0;
        int cnt2 = 0;
        for (int i = ind; i < n; i ++) {
            cnt2 += f(x[i] - x0);
        }
        for (int tek_r = ind; tek_r < n; tek_r ++) {
            int ans = start_ans + cnt2;
            if (tek_r == ind) {
                ans += get(d * d * (n - tek_r), t - 2 * d * pref.get(tek_r, n - 1) + 2 * d * (n - tek_r) * x0, 0,
                    0, (x[tek_r] - x0) / d);
            }
            else {
                ans += get(d * d * (n - tek_r), t - 2 * d * pref.get(tek_r, n - 1) + 2 * d * (n - tek_r) * x0, 0,
                    (x[tek_r - 1] - x0 + d - 1) / d, (x[tek_r] - x0) / d);
            }
            ans += cnt;
            mn = min(mn, ans);

            cnt += min(f(x[tek_r] % d), f(d - x[tek_r] % d));
            cnt2 -= f(x[tek_r] - x0);
        }

        if (ind != n) {
            cout << mn << '\n';
        }
        else {
            cout << start_ans << '\n';
        }
        */

        int mn = inf;
        for (int k = -100; k < 100; k ++) {
            int cnt = abs(k) * t;
            for (int i = 0; i < n; i ++) {
                if (min(x0, x0 + k * d) <= x[i] && max(x0, x0 + k * d) >= x[i]) {
                    cnt += min(f(x[i] % d), f(d - x[i] % d));
                }
                else {
                    cnt += min(f(x0 - x[i]), f(x[i] - x0 - d * k));
                }
            }
            mn = min(mn, cnt);
        }
        cout << mn << '\n';
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --) {
        solve();
    }
}