// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct Man {
    int l, m, r;
};

bool comp(Man m1, Man m2) {
    return m1.l < m2.l;
}

void test() {
    int n, k;
    cin >> n >> k;

    vector<bool> f(n + 1);
    f[0] = true;
    vector<Man> d(k);
    for (int i = 0; i < k; i++) {
        cin >> d[i].l >> d[i].m >> d[i].r;
    }
    sort(d.begin(), d.end(), comp);

    int max_r = 0;

    for (int i = 0; i < k; i++) {
        int l = d[i].l;
        int m = d[i].m;
        int r = d[i].r;

        if (max_r < l - 1) {
            cout << "NO\n";
            return;
        }
        max_r = max(max_r, r);
    }

    if (f[n]) {
        cout << "YES\n";
    }

    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int T;
    cin >> T;
    while (T--) {
        test();
    }
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/
