// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

vector<bool> used;

vector<vector<int>> g;
int d;
int n;

vector<pii> res;

bool dfs(int v) {
    used[v] = true;

    bool flag = false;
    for (auto u : g[v]) {
        if (!used[u]) {
            bool resp = dfs(u);
            if (!resp && !flag) {
                flag = true;
                res.emplace_back(u, v);
            }
        }
    }

    return flag;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int n;
    cin >> n;
    cin >> d;
    g.resize(n + 1);
    used.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(1);
    cout << res.size() << '\n';
    for (auto [v, u] : res) cout << v << ' ' << u << "\n";
}
