#include <bits/stdc++.h>
using namespace std;
#define int long long
#define no cout<<"NO\n"
#define yes cout<<"YES\n"

struct pers {
    int l,r,m;
};

const int MAXN=5e5+5,MAXK=5e5+5,inf=1e18;
int n,k;
pers a[MAXK];
int t[4*MAXN], p[4*MAXN];
char is_stable[4*MAXN];

void push(int u, int tl, int tr) {
    if (p[u]==-1) return;
    is_stable[u]=true;
    if (tr-tl != 1) {
        p[2*u+1]=p[u];
        p[2*u+2]=p[u];
    }
    p[u]=-1;
}

bool get_range(int l, int r, int u, int tl, int tr) {
    push(u,tl,tr);
    if (tl>=r || tr<=l) return true;
    if (tl>=l && tr<=r) return is_stable[u];
    int mid=(tl+tr)/2;
    return get_range(l,r,2*u+1,tl,mid) && get_range(l,r,2*u+2,mid,tr);
}

void assign(int l, int r, int x, int u, int tl, int tr) {
    push(u,tl,tr);
    if (tl>=l && tr<=r) {
        p[u]=x;
        push(u,tl,tr);
        return;
    }
    if (tl>=r || tr<=l) return;
    int mid=(tl+tr)/2;
    assign(l,r,x,2*u+1,tl,mid);
    assign(l,r,x,2*u+2,mid,tr);
    is_stable[u]=is_stable[2*u+1] && is_stable[2*u+2];
}

bool check(vector<int> perm) {
    fill(t, t+4*MAXN, 0LL);
    fill(is_stable, is_stable+4*MAXN, false);
    fill(p, p+4*MAXN, -1);
    for (int i=0;i<perm.size();++i) {
        if (!get_range(a[perm[i]].m,a[perm[i]].m+1, 0,0,n)) {
            assign(a[perm[i]].l, a[perm[i]].r+1, 1, 0, 0, n);
        }
    }
    return is_stable[0];
}

void solve() {
    cin>>n>>k;
    for (int i=0;i<k;++i) {
        int l,m,r; cin>>l>>m>>r;
        a[i].l=l-1;
        a[i].r=r-1;
        a[i].m=m-1;
    }
    vector<int> perm(k);
    for (int i=0;i<k;++i) perm[i]=i;
    do {
        if (check(perm)) {
            yes;
            return;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    no;
}



int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt; cin>>tt;
    while (tt--) {
        solve();
    }
    return 0;
}