#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

// #define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using pii = pair<int, int>;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct q {
    int l, m, r;
    q() = default;
};

bool comp1(q &a, q &b) {
    return a.l < b.l || a.l == b.l && a.m < b.m;
}
bool comp2(q &a, q b) {
    return a.r < b.r || a.r == b.r && a.m < b.m;
}



void solve() {
    int n, k;
    cin >> n >> k;
    vector<q> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    vector<int> ms;
    for (auto q : a) {
        ms.push_back(q.m);
    }
    sort(all(ms));
    for (auto q : a) {
        auto it1 = lower_bound(all(ms), q.l);
        auto it2 = upper_bound(all(ms), q.r);
        if (it2 - it1 > 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    // ios_base::sync_with_stdio(false);
    int t = 1;

// #ifdef LOCAL
//     freopen("in.txt", "r", stdin);
//     freopen("out.txt", "w", stdout);
// #endif

    cin >> t;
    while (t--) {
        solve();
    }
}
