#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rarr(a) a.rbegin(), a.rend()
using pii = pair<int, int>;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
const int INF = 1e18;

int sq(int x) {
    return x * x;
}

int f1(int dist1, int d, int m, int t) {
    return t * m + sq(dist1 - d * m);
}

int tern1(int dist, int d, int t) {
    int l = 0, r = dist / d + 2;
    while (r > l + 2) {
        int m1 = (r - l) / 3 + l;
        int m2 = (r - l) * 2 / 3 + l;
        if (f1(dist, d, m1, t) < f1(dist, d, m2, t)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    return min({f1(dist, d, l, t), f1(dist, d, l + 1, t), f1(dist, d, l + 2, t)});
}

int f2(int dist1, int d, int m, int t) {
    return 2 * t * m + sq(dist1 - d * m);
}

int tern2(int dist, int d, int t) {
    int l = 0, r = dist / d + 2;
    while (r > l + 2) {
        int m1 = (r - l) / 3 + l;
        int m2 = (r - l) * 2 / 3 + l;
        if (f2(dist, d, m1, t) < f2(dist, d, m2, t)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    return min({f2(dist, d, l, t), f2(dist, d, l + 1, t), f2(dist, d, l + 2, t)});
}




void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int x0, d, m;
    cin >> x0 >> d >> m;
    int dist1 = abs(x0 - a[0]);
    int dist2 = abs(x0 - a[1]);
    while (m--) {
        int t;
        cin >> t;
        cout << min(tern1(dist1, d, t) + tern2(dist2, d, t), tern2(dist1, d, t) + tern1(dist2, d, t)) << "\n";
    }
    
    

}

signed main() {
    // cin.tie(0);
    // cout.tie(0);
    // ios_base::sync_with_stdio(false);
    int t = 1;

// #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
// #endif

    // cin >> t;
    while (t--) {
        solve();
    }
}
