#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct que {
    int l, m, r;
};

bool check(que a, que b) {
    return !(a.l <= b.m and b.m <= a.r);
}



void solve() {
    int m, n;
    cin >> m >> n;
    vector<que> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].r--;
        a[i].m--;
    }
    sort(a.begin(), a.end(), [&] (que a, que b) {
        if (a.l == b.l) {
            if (a.r == b.r)
                return a.m < b.m;
            return a.r < b.r;
        }
        return a.l < b.l;
    });
    if (a[0].l != 0) {
        cout << "NO" << endl;
        return;
    }
    vector<bool> dp(n);
    for (int i = 0; i < n; i++) {
        if (a[i].l == 0) {
            dp[a[i].r] = 1;
        }
        else {
            for (int j = a[i].l - 1; j < a[i].m; j++) {
                if (dp[j]) {
                    dp[a[i].r] = 1;
                    break;
                }
            }
        }
    }
    if (dp[m - 1]) {
        cout << "YES" << endl;
    }
    else {
        cout << "NO" << endl;
    }

}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}