#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct que {
    int l, m, r;
};

bool check(que a, que b) {
    return !(a.l <= b.m and b.m <= a.r);
}
vector<int> used;
vector<vector<int>> gr, gr2;
vector<int> tp;
bool ans = 0;

void topsort(int v) {
    used[v] = 1;
    for (int u: gr[v]) {
        if (!used[u])
            topsort(u);
    }
    tp.push_back(v);
}
vector<int> cmp;
void build(int v, int cmn) {
    cmp[v] = cmn;
    for (int u: gr2[v]) {
        //cout << u << endl;
        if (cmp[u] == -1)
            build(u, cmn);
    }
}
int n, m;

vector<vector<int>> g;
vector<vector<que>> otr;
vector<int> tp2;
void topsort2(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u])
            topsort(u);
    }
    tp2.push_back(v);
}

bool operator<(que a, que b) {
    if (a.l == b.r) {
        if (a.r == b.r) {
            return a.m < b.m;
        }
        return a.r < b.r;
    }
    return a.l < b.l;
}

set<que> stdf;

int cm;

void dfs(int v) {
    used[v] = 1;
    for (que x: otr[v])
        stdf.insert(x);
    
    int lst = -100;
    for (que i: stdf) {
        if (i.l == 0) {
            lst = max(lst, i.r);
            continue;
        }
        if (lst + 1 >= i.l) {
            lst = max(lst, i.r);
        }
    }
    if (lst == m - 1)
        ans = 1;
        
    for (int u: g[v]) {
        if (!used[u])
            dfs(u);
    }
    for (que x: otr[v])
        stdf.erase(x);
}

void solve() {
    ans = 0;
    cin >> m >> n;
    vector<que> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].r--;
        a[i].m--;
    }
    gr.assign(n, vector<int>());
    gr2.assign(n, vector<int>());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (check(a[i], a[j])) {
                gr[i].push_back(j);
                gr2[j].push_back(i);
            }
        }
    }
    used.assign(n, 0);
    tp.clear();
    for (int i = 0; i < n; i++) {
        if (!used[i])
            topsort(i);
    }
    reverse(tp.begin(), tp.end());
    cmp.assign(n, -1);
    cm = 0;
    for (int i: tp) {
        if (cmp[i] == -1)
            build(i, cm++);
    }
    g.assign(cm, vector<int>());
    set<pii> rb;
    otr.assign(cm, vector<que>());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (check(a[i], a[j])) {
                rb.insert({cmp[i], cmp[j]});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        otr[cmp[i]].push_back(a[i]);
    }
    for (pii i: rb) {
        g[i.first].push_back(i.second);
    }
    tp2.clear();
    used.assign(cm, 0);
    for (int i = 0; i < cm; i++) {
        if (!used[i])
            topsort2(i);
    }
    used.assign(cm, 0);
    for (int i: tp2) {
        if (!used[i])
            dfs(i);
    }

    if (ans)
        cout << "YES" << endl;
    else
        cout << "NO" << endl;
}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}