#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const long long inf_ll = 1e18;


int main() {
    ll n, m;
    cin >> n >> m;
    vector<vector<bool> > pole(n + 1, vector<bool>(m + 1));
    vector<vector<ll> > stolb(n + 1, vector<ll>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            pole[i][j] = (c == '1');
            if (pole[i][j] != 0) {
                stolb[i][j] = stolb[i - 1][j] + 1;
            }
        }
    }
    /*for (auto i: stolb) {
        for (auto j: i) { cout << j << ' '; }
        cout << '\n';
    }cout << '\n';*/
    vector<ll> dp(max(n, m) + 1);
    vector<ll> last(max(n, m) + 1);
    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        for (ll j = 0; j <= max(n, m); j++) {
            dp[j] = 0;
            last[j] = inf_ll;
        }
        ll h = 0;
        for (ll j = 1; j <= m; j++) {
            ll val = 0;
            for (ll k = stolb[i][j]; k <= min(h, max(n, m)); k++) {
                dp[k] = dp[k] + k * max(0ll, (j - 1 - last[k]));
                val = max(val, dp[k]);
                last[k] = inf_ll;
                dp[k] = 0;
            }
            dp[stolb[i][j]] = val + stolb[i][j];
            last[stolb[i][j]] = j;
            h = stolb[i][j] + 50;
        }
        for (ll k = 1; k <= max(n, m); k++) {
            dp[k] = dp[k] + k * max(0ll, (m - last[k]));
            ans = max(ans, dp[k]);
        }
        if (0 == 1) {
            cout << "dp\n";
            for (auto i: dp) {
                cout << i << ' ';
            }
            cout << '\n';
            for (auto j: last) {
                cout << j << ' ';
            }
            cout << '\n';
        }
    }
    cout << ans << '\n';
}

/*4 4
0010
0110
0110
1111

4 4
0010
0110
0111
1111


4 5
00101
01101
01111
11111


6 4
0011
1101
0111
1110
0111
0100*/
