#include <bits//stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

struct emp {
    int l = 0, m = 0, r = 0;
    emp() = default;
    emp(int x, int y, int z) : l(x), m(y), r(z) {}
};

bool operator < (emp e1, emp e2) {
    return make_pair(e1.l, e1.r) < make_pair(e2.l, e2.r);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<emp> es(k);
    for (int i = 0; i < k; ++i) {
        cin >> es[i].l >> es[i].m >> es[i].r;
    }
    sort(es.begin(), es.end());
    int c = 0;
    for (auto e : es) {
        if (c + 1 < e.l) {
            cout << "NO\n";
            return;
        }
        c = max(c, e.r);
    }
    if (c < n) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
}