#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()

struct seg {
    int l, r, m;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> arr(k);
    for (int i = 0; i < k; i++) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
    }
    sort(all(arr), [](seg a, seg b) {
        return a.r > b.r || (a.r == b.r && a.l < b.l);
    });
    int l = n;
    for (int i = 0; i < k; i++) {
        if (arr[i].r < l) {
            cout << "NO";
            return;
        }
        l = min(l, arr[i].l - 1);
    }
    if (l > 0) {
        cout << "NO";
    } else {
        cout << "YES";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
