// TaskB.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

using ll = long long;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<vector<int>> a;
	vector<int> ls(k), ms(k), rs(k);
	for (int i = 0; i < k; i++) {
		cin >> ls[i] >> ms[i] >> rs[i];
		a.push_back({ ls[i], 0, i });
		a.push_back({ rs[i], 1, i });
	}
	sort(a.begin(), a.end());
	int cnt = 0;
	for (int i = 0; i < k * 2; i++) {
		if (a[i][1] == 0) {
			cnt++;
		}
		else {
			cnt--;
			if (cnt == 0 && i != k * 2 - 1) {
				cout << "NO" << '\n';
				return;
			}
		}
	}
	if (a[0][0] != 1 || a[2 * k - 1][0] != n) {
		cout << "NO" << '\n';
	}
	else {
		cout << "YES" << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
