#include <bits/stdc++.h>
#define int long long

using namespace std;

istream& operator>>(istream& in, vector<auto>& v) {
    for (auto& el : v) {
        in >> el;
    }
    return in;
}

ostream& operator<<(ostream& out, vector<auto> v) {
    for (auto el : v) {
        out << el << " ";
    }
    out << "\n";
    return out;
}
ostream& operator<<(ostream& out, vector<vector<auto>> v) {
    for (auto el : v) {
        out << el;
    }
    out << "\n";
    return out;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for (auto& el : v) {
        cin >> el;
        reverse(el.begin(), el.end());
    }
    vector<vector<int>> b(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '1') {
                b[i][j] = 1;
            }
            else {
                continue;
            }
            if (i != 0) {
                b[i][j] += b[i - 1][j];
            }
        }
    }
//    cout << b;
    vector<pair<int, int>> st;
    int sum = 0;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        sum = 0;
        st = {};
        for (int j = 0; j < m; j++) {
            int k = 1;
            while (!st.empty() && st.back().first >= b[i][j]) {
                k += st.back().second;
                sum -= st.back().first * st.back().second;
                st.pop_back();
            }
            st.emplace_back(b[i][j], k);
            sum += b[i][j] * k;
            ans = max(ans, sum);
//            cout << sum << " ";
        }
//        cout << "\n";
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
4 4
1111
1011
1101
1111
*/
