#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

const int N = 2e5;
string s[N];
vector<int> d[N];
int n, m, ans;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        d[i].resize(m + 1);
        for (int j = m - 1; j >= 0; --j) {
            if (s[i][j] == '0') {
                d[i][j] = 0;
            } else {
                d[i][j] = d[i][j + 1] + 1;
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        vector<int> a(n), dp(n + 1);
        for (int i = 0; i < n; ++i) {
            a[i] = d[i][j];
        }
        vector<pair<int, int> > deq;
        deq.emplace_back(-1, 0);
        for (int i = 0; i < n; ++i) {
            while (deq.back().first >= a[i]) {
                deq.pop_back();
            }
            int pos = deq.back().second;
            deq.emplace_back(a[i], i + 1);
            dp[i + 1] = dp[pos] + a[i] * (i + 1 - pos);
            ans = max(ans, dp[i + 1]);
        }
    }
    cout << ans;
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
