#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

const int N = 5e5;
int n, k;
tuple<int, int, int> a[N];
vector<tuple<int, int, int> > b;

void solve() {
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        --l, --m, --r;
        a[i] = {l, m, r};
    }
    sort(a, a + k);
    for (int i = 0; i < k; ++i) {
        auto [l,m,r] = a[i];
        if (l == 0) {
            b.emplace_back(a[i]);
        } else {
            for (auto [l1,m1,r1]: b) {
                if (l1 < l && r1 < r) {
                    int L = l, R = r1;
                    if (!(L <= m1 && m1 <= R && L <= m && m <= R)) {
                        b.emplace_back(a[i]);
                        break;
                    }
                }
            }
        }
        if (!b.empty() && get<2>(b.back()) == n - 1) {
            break;
        }
    }
    if (!b.empty() && get<2>(b.back()) == n - 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    b.clear();
}

signed main() {
    fast_in_out();
    int qwe = 1;
    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
