#include <bits/stdc++.h>
using namespace std;
const int maxn = 4e5 + 1;
int t[maxn * 4], cnt[maxn * 4], lazy[maxn * 4];
void push(int v) {
    lazy[v * 2] = lazy[v];
    lazy[v * 2 + 1] = lazy[v];
    t[v] = lazy[v];
    lazy[v] = 0;
}
void upd(int v, int tl, int tr, int ql, int qr, int val) {
    if (lazy[v] != 0) {
        push(v);
    }
    if (ql >= tr || tl >= qr) {
        return;
    }
    if (ql <= tl && tr <= qr) {
        lazy[v] = val;
        push(v);
        return;
    }
    int tm = (tl + tr)/ 2;
    upd(v * 2, tl, tm, ql, qr, val);
    upd(v * 2 + 1, tm, tr, ql, qr, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}
void build(int v, int tl, int tr) {
    t[v] = 0;
    lazy[v] = 0;
    if (tl + 1 == tr) {
        cnt[v] = 1;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm, tr);
    cnt[v] = cnt[v * 2] + cnt[v * 2 + 1];
}
int find(int v, int tl,int tr, int ql, int qr, int x) {
    if (lazy[v] != 0) {
        push(v);
    }
    if (tl >= qr || ql >=tr)
        return -1;
    if (t[v] <= x) {
        return -1;
    }
    int tm = (tl + tr) / 2;
    if (ql <= tl && tr <= qr) {
        if (tl + 1 == tr)
            return tl;
        if (lazy[v * 2] != 0) {
            push(v * 2);
        }
        if (lazy[v * 2 + 1] != 0) {
            push(v * 2 + 1);
        }
        if (t[v * 2] > x) {
            return find(v * 2, tl, tm, ql, qr, x);
        }
        return find(v * 2 + 1, tm, tr, ql, qr, x);
    }
    int res = find(v * 2, tl ,tm ,ql, qr, x);
    if (res != -1)
        return res;
    else
        return find(v * 2 + 1, tm, tr, ql ,qr, x);
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n + 1, vector<int>(m + 2));
    for (int i = 1; i <= n; i++) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; j++) {
            a[i][j] = (s[j - 1] - '0');
        }
    }
    vector<vector<int> > v(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {

        for (int j = 1; j <= m; j++) {
            int kl = j;
            while (a[i][j] == 1) {
                j++;
            }
            for (int u = kl; u < j; u++) {
                v[i][u] = j - u;
            }
        }
    }
    int res = 0;
    for (int j = 1; j <= m; j++) {
        int li = 0;
        vector<int> pr(n + 1);
        build(1,1,n + 1);
        for (int i = 1; i <= n; i++) {
            if (v[i][j] == 0) {
                li = i;
                pr[i] = 0;
            } else {
                int l, r;
                r = find(1, 1, n + 1,li + 1, i, v[i][j]);
                if (r == -1)
                    r = i;
                l = r - 1;
                upd(1, 1, n  + 1, r, i + 1, v[i][j]);
                pr[i] = pr[l] + (i - l) * v[i][j];
                res = max(res, pr[l] + (i - l) * v[i][j]);
                //cout << i << ' ' << j << ' ' << pr[i] << ' ' << l << '\n';
            }
        }
    }
    cout << res << '\n';
}