#include <bits/stdc++.h>

using ll = long long;

using namespace std;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll> > dp(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (ll j = 0; j < m; j++) {
            dp[i][j] = (s[j] - '0');
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (dp[i][j] == 1) {
                ll l = j;
                while (j < m && dp[i][j] == 1) {
                    j++;
                }
                for (ll p = l; p < j; p++) {
                    dp[i][p] = j - p;
                }
            }
        }
    }
    ll mx = 0;
    for (ll j = 0; j < m; j++) {
        ll s = 0;
        stack<pair<ll, ll>> S;
        for (ll i = 0; i < n; i++) {
            ll k = 1;
            while (!S.empty() && S.top().first > dp[i][j]) {
                k += S.top().second;
                s -= S.top().second * S.top().first;
                S.pop();
            }
            s += k * dp[i][j];
            S.push({dp[i][j], k});
            mx = max(s, mx);
        }
    }
    cout << mx << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin > t;
    for (ll i = 0; i < t; i++) {
        solve();
    }
}
