#include <bits/stdc++.h>

using ll = long long;

using namespace std;

struct Node {
    ll l, r, m;
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<Node> A(k);
    map<ll, vector<pair<ll, ll>>> M;
    for (ll i = 0; i < k; i++) {
        cin >> A[i].l >> A[i].m >> A[i].r;
        M[A[i].m].push_back({A[i].l, A[i].r});
    }
    vector<ll> dp(n + 1);
    for (auto [x, v] : M) {
        for (auto [l, r] : v) {
            ll t = 0;
            if (l == 1) {
                t = 1;
            }
            for (ll i = l; i < x; i++) {
                if (dp[i] == -2) {
                    t = 1;
                }
            }
            if (t) {
                for (ll i = l; i <= r; i++) {
                    if (dp[i] == 0) {
                        dp[i] = 1;
                    }
                }
                dp[r] = -2;
            }
        }
    }
    for (ll i = 1; i <= n; i++) {
        if (dp[i] == 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        solve();
    }
}
