#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define emp emplace_back
#define popb pop_back
#define pf push_front
#define popf pop_front
#define ins insert
#define ers erase
#define m_p make_pair
const int INF = 1e18;


bool cross (pair < int, int > a, pair < int, int > b) {
    if (a.first <= b.first && b.first <= a.second) {
        return 1;
    }
    if (a.first <= b.second && b.second <= a.second) {
        return 1;
    }
    swap(a,b);
    if (a.first <= b.first && b.first <= a.second) {
        return 1;
    }
    if (a.first <= b.second && b.second <= a.second) {
        return 1;
    }
    return 0;
}




vector < int > tree;
int SZ;
void add (int pos,int val) {
    pos++;
    for (pos; pos <= SZ; pos += pos & -pos) {
        tree[pos] += val;
    }
}

int sum (int r) {
    r++;
    int ans = 0;
    for (r; r > 0; r -= r & -r) {
        ans += tree[r];
    }
    return ans;
}

int sum (int l,int r) {
    return sum(r) - sum(l - 1);
}
void solve () {
    int n,k;
    cin >> n >> k;
    list < tuple < int, int, int > > a,b;
    bool fl = 0;
    for (int i = 0; i < k; ++i) {
        int l,m,r;
        cin >> l >> m >> r;
        if (l == 1 && r == n) {
            fl = 1;
        }
        if (l == 1) {
            a.pb({l,m,r});
        } else {
            b.pb({l,m,r});
        }
    }

    if (fl) {
        cout << "YES" << endl;
        return ;
    }

    for (auto [l1,m1,r1]: a) {
        for (auto [l2,m2,r2]: b) {
            if (!cross(m_p(l1,r1),m_p(l2,r2))) {
                continue;
            }
            int l3 = max(l1,l2), r3 = min(r1,r2);
            if (l3 <= m1 && m1 <= r3 && l3 <= m2 && m2 <= r3) {
                continue;
            }
            if (l3 <= m1 && m1 <= r3) {
                cout << "YES" << endl;
                return ;
            } else {
                cout << "YES" << endl;
                return ;
            }
        }
    }
    cout << "NO" << endl;





}
signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt","r",stdin);
    int qwerty;
    cin >> qwerty;
    while (qwerty--) {
        solve();
    }

}