#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<vector<pair<ll, ll>>> seg(n + 1);
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        seg[r].emplace_back(l, m);
    }
    vector<ll> dp(n + 1);
    dp[0] = 1;
    for (int i = 1; i <= n; i++) {
        for (auto [l, m] : seg[i]) {
            for (ll j = l - 1; j < m; j++) {
                if (dp[j]) {
                    dp[i] = 1;
                }
            }
        }
    }
    if (dp[n]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}