#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

struct st {
    ll l, m, r;
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<st> seg;
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        seg.push_back({l, m, r});
    }
    vector<vector<ll>> dp(n + 2, vector<ll>(n + 2));
    dp[0][n + 1] = 1;
    queue<pair<ll, ll>> bfs;
    bfs.emplace(0, n + 1);
    while (!empty(bfs)) {
        ll l = bfs.front().first;
        ll r = bfs.front().second;
        bfs.pop();
        for (auto [lf, m, rf] : seg) {
            if (m > l && m < r) {
                if (lf <= l + 1 && rf >= r - 1) {
                    cout << "YES\n";
                    return;
                }
                if (lf <= l + 1 && dp[rf][r] == 0) {
                    dp[rf][r] = 1;
                    bfs.emplace(rf, r);
                }
                if (rf >= r - 1 && dp[l][lf] == 0) {
                    dp[l][lf] = 1;
                    bfs.emplace(l, lf);
                }
            }
        }
    }
    cout << "NO\n";
}