#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}
vector<vector<ll>> g;
ll d;

vector<vector<ll>> dp;

void dfs(ll v, ll p) {
    ll sm = 0;
    ll mx = -INF;
    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        sm += max(dp[u][0], dp[u][1]);
        mx = max(mx, dp[u][0] - max(dp[u][0], dp[u][1]));
    }
    dp[v][0] = sm;
    dp[v][1] = sm + mx;
}

void solve() {
    ll n;
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dp.resize(n, vector<ll>(2, -INF));
    dfs(0, -1);
    cout << max(dp[0][0], dp[0][1]) << '\n' << -1;
}