#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Cleaner{
    int l, m, r;
};

bool comp(Cleaner a, Cleaner b){
    if (a.l != b.l) return a.l < b.l;
    if (a.r != b.r) return a.r < b.r;
    return a.m < b.m;
}

int find_ind(vector<Cleaner> &v, int i){
    int l = -1, r = i;
    while (r - l > 1){
        int mid = (r + l) / 2;
        if (v[mid].r < v[i].l){
            l = mid;
        }
        else{
            r = mid;
        }
    }
    return l;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_){
        int n, k;
        cin >> n >> k;
        vector<Cleaner> v(k);
        for (int i = 0; i < k; ++i){
            int l, m, r;
            cin >> l >> m >> r;
            v[i] = {l, m, r};
        }
        sort(v.begin(), v.end(), comp);
        vector<bool> dp(k, false);
        int first = 0;
        bool ans = false;
        while (first < k && v[first].l == 1){
            dp[first] = true;
            if (v[first].r >= n){
                ans = true;
                break;
            }
            ++first;
        }
        for (int i = first; i < k; ++i){
            int start = find_ind(v, i) + 1;
            while (start < i && v[start].r < v[i].m){
                if (dp[start]){
                    dp[i] = true;
                    if (v[i].r >= n){
                        ans = true;
                        break;
                    }
                    break;
                }
                ++start;
            }
            if (ans) break;
        }
        if (ans){
            cout << "YES" << '\n';
        }
        else{
            cout << "NO" << '\n';
        }
    }
    return 0;
}