#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Cleaner{
    int l, m, r;
};

bool possible(vector<Cleaner> &v, int i, set<int> cleaned, int k, int n){
    for (auto el: cleaned) {
        if (v[el].l <= v[i].m && v[i].m <= v[el].r) {
            return false;
        }
    }
    cleaned.insert(i);
    for (int j = 0; j < k; ++j) {
        if (cleaned.find(j) == cleaned.end() && possible(v, j, cleaned, k, n)) {
            return true;
        }
    }
    vector<bool> has(n + 1, false);
    for (auto el: cleaned) {
        for (int i = v[el].l; i <= v[el].r; ++i) {
            has[i] = true;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!has[i]) {
            return false;
        }
    }
    return true;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, k;
        cin >> n >> k;
        vector<Cleaner> v(k);
        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            v[i] = {l, m, r};
        }
        bool ans = false;
        set<int> cleaned;
        for (int i = 0; i < k; ++i) {
            if (possible(v, i, cleaned, k, n)){
                ans = true;
            }
        }
        if (ans){
            cout << "YES" << '\n';
        }
        else{
            cout << "NO" << '\n';
        }
    }
    return 0;
}