#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using namespace std;

vector<vector<long long>> g;
vector<long long> dp0, dp1, how_we_got_dp1, h;

void dfs(long long v, long long p) {
    bool has_good = false;
    for (auto &i : g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
        dp0[v] += max(dp1[i], dp0[i]);
        dp1[v] += dp1[i];
        //for one we can get dp0, not dp1 and ans += 1
        if (dp0[i] >= dp1[i]) {
            dp1[v] -= dp1[i];
            dp1[v] += dp0[i];
            if (!has_good) {
                dp1[v]++;
                has_good = true;
                how_we_got_dp1[v] = i;
            }
        }
    }
    if (!has_good) {
        dp1[v] = -1e18;
    }
}

void find_ans(long long v, long long p, long long type) {
    if (v == 5) {
        //cout << type << endl;
    }
    if (type == 0) {
        for (auto &i : g[v]) {
            if (i == p) {
                continue;
            }
            if (dp1[i] >= dp0[i]) {
                find_ans(i, v, 1);
            } else {
                find_ans(i, v, 0);
            }
        }
    } else {
        cout << v + 1 << " " << how_we_got_dp1[v] + 1 << endl;
        for (auto &i : g[v]) {
            if (i == p) {
                continue;
            }
            if (dp0[i] >= dp1[i]) {
                find_ans(i, v, 0);
            } else {
                find_ans(i, v, 1);
            }
        }
    }
}

void find_h(long long v, long long p) {
    for (auto &i : g[v]) {
        if (i == p) {
            continue;
        }
        h[i] = h[v] + 1;
        find_h(i, v);
    }
}

int main() {
    long long n, d;
    cin >> n >> d;
    g.resize(n);
    for (long long i = 1; i < n; i++) {
        long long u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (d == n - 1) {
        h.resize(n);
        find_h(0, -1);
        vector<long long> even, not_even;
        vector<pair<long long, long long>> ans;
        for (long long i = 0; i < n; i++) {
            if (h[i] % 2) {
                if (not_even.empty()) {
                    even.push_back(i);
                } else {
                    ans.emplace_back(i + 1, not_even.back() + 1);
                    not_even.pop_back();
                }
            } else {
                if (even.empty()) {
                    not_even.push_back(i);
                } else {
                    ans.emplace_back(i + 1, even.back() + 1);
                    even.pop_back();
                }
            }
        }
        cout << ans.size() << endl;
        for (auto &[i, j] : ans) {
            cout << i << " " << j << endl;
        }
    } else {
        dp0.resize(n);
        dp1.resize(n);
        how_we_got_dp1.resize(n);
        dfs(0, -1);
        cout << max(dp1[0], dp0[0]) << endl;
        if (dp1[0] > dp0[0]) {
            find_ans(0, -1, 1);
        } else {
            find_ans(0, -1, 0);
        }
    }
}