#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;

void solve2() {
    int n, k;
    cin >> n >> k;
    vi open(n + 1, 0);

    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        open[l] = max(open[l], r);
    }

    set<int> fs;

    for (int i = 1; i <= n; ++i) fs.insert(i);

    for (int i = n; i >= 1; --i) {
        while (!fs.empty()) {
            if (fs.lower_bound(i) == fs.end()) break;
            int v = *fs.lower_bound(i);
            if (v <= open[i] && v >= i) fs.erase(fs.lower_bound(i));
            else break;
        }
    }


    if (fs.empty()) cout << "YES" << endl;
    else cout << "NO" << endl;
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve2();
    }
}