#include <bits/stdc++.h>
#define pb push_back
  
using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;
  
const int INF = 1e8;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pi, int>> ps(k);
    
    vector<pi> pref1, suff1, pref2, suff2;
    int ok = 0;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        if (l == 1 && r == n) {
            ok = 1;
        }
        if (l == 1) {
            pref1.pb({r, m});
            pref2.pb({m, r});
        }
        else {
            suff1.pb({l, m});
            suff2.pb({m, l});
        }
    }
  
    sort(suff2.begin(), suff2.end());
    sort(suff1.rbegin(), suff1.rend());

    sort(pref1.begin(), pref1.end());
    sort(pref2.begin(), pref2.end());

    int p = pref1.size();
    int s = suff1.size();

    vi ms(s, INF);
    vi mp(p, 0);
    if (s > 0) ms[s - 1] = suff2[s - 1].second;
    if (p > 0) mp[0] = pref2[0].first;
    for (int i = s - 2; i >= 0; --i) ms[i] = min(ms[i + 1], suff2[i].second);
    for (int i = 1; i < p; ++i) mp[i] = max(mp[i - 1], pref2[i].second);

    for (int i = 0; i < p; ++i) {
        int l = -1;
        int r = s;

        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (suff2[mid].first > pref1[i].first) r = mid;
            else l = mid;
        }

        if (r == s) continue;
        // cout << "j " << i << ' ' << r << ' ' << ms[r] << endl;
        if (ms[r] - 1 <= pref1[i].first) ok = 1;
    }

    for (int i = 0; i < s; ++i) {
        int l = -1;
        int r = p;

        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (suff1[i].first > pref2[mid].first) l = mid;
            else r = mid;
        }

        if (l == -1) continue;
        // cout << "i " << i << ' ' << l << ' ' << mp[l] << endl;
        if (mp[l] + 1 >= suff2[i].second) ok = 1;
    }
  
    if (ok) cout << "YES" << endl;
    else cout << "NO" << endl;
}
  
  
signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    // freopen("out1.txt", "w", stdout);
#endif
  
    ios_base::sync_with_stdio(0);
    cin.tie(0);
  
    int t;
    cin >> t;
  
    while (t--) {
        solve();
    }
}