#include <iostream>
#include <stack>

#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int h, w; cin >> h >> w;
    string arr[h];
    for (int y = 0; y < h; ++y)
        cin >> arr[y];

    int f0[h][w];
    for (int y = 0; y < h; ++y) {
        int i0 = w;
        for (int x = w - 1; x >= 0; --x) {
            if (arr[y][x] == '0')
                i0 = x;
            f0[y][x] = i0 - x;
        }
    }

    int ful[h][w];
    for (int x = 0; x < w; ++x) {
        stack<int> s;
        for (int y = 0; y < h; ++y) {
            while (!s.empty() && f0[s.top()][x] > f0[y][x])
                s.pop();
            if (!s.empty())
                ful[y][x] = s.top();
            else
                ful[y][x] = -1;
            s.push(y);
        }
    }

    // for (int y = 0; y < h; ++y) {
    //     for (int x = 0; x < w; ++x)
    //         cout << f0[y][x] << ' ' << ful[y][x] << '\t';
    //     cout << endl;
    // }

    int dp[h][w];
    int ans = 0;
    for (int x = 0; x < w; ++x) {
        for (int y = 0; y < h; ++y) {
            dp[y][x] = f0[y][x] * (y - ful[y][x]);
            if (ful[y][x] != -1)
                dp[y][x] += dp[ful[y][x]][x];
            ans = max(ans, dp[y][x]);
        }
    }
    cout << ans;

    return 0;
}
