#include <iostream>
#include <algorithm>

using namespace std;

struct s {
    int l, m, r;

    bool operator<(const s& a) {
        return l < a.l;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    s arr[k];
    for (int i = 0; i < k; ++i)
        cin >> arr[i].l >> arr[i].m >> arr[i].r, --arr[i].l, --arr[i].m, --arr[i].r;

    sort(arr, arr + k);
    do {
        bool used[n] = {};
        int cnt = 0;
        for (int i = 0; i < k; ++i) {
            if (!used[arr[i].m]) {
                for (int j = arr[i].l; j <= arr[i].r; ++j) {
                    cnt += !used[j];
                    used[j] = true;
                }
            }
        }
        if (cnt == n) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(arr, arr + k));
    cout << "NO\n";
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int _; cin >> _;
    while (_--) {
        solve();
    }

    return 0;
}
