#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
// #define int long long

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using i128 = __int128;

mt19937 rnd(time(0));

const int INF = 1e9;

void sol() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    vector<vector<int>> h(n, vector<int>(m));
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) {
        if (i == 0) h[i][j] = a[i][j] - '0';
        else if (a[i][j] == '0') h[i][j] = 0;
        else h[i][j] = h[i - 1][j] + 1;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int last = INF, now = 0;
        for (int j = 0; j < m; j++) {
            if (h[i][j]) {
                now += min(h[i][j], last);
                last = min(h[i][j], last);
            } else {
                last = h[i][j];
                if (last == 0) last = INF;
                ans = max(ans, now);
                now = h[i][j];
            }
        }
        ans = max(ans, now);
    }
    cout << ans << '\n';
    return;
}

int main() {
    sol();
    return 0;
}
