#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define int long long

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using i128 = __int128;

mt19937 rnd(time(0));

const ll INF = 8e18;

vector<ll> sol(int &n, vector<int> &x, int &x0, int &d, int &m, vector<int> &t) {
    vector<ll> ans(m, INF);
    for (int i = 0; i < m; i++) {
        int l = -2e9, r = 2e9;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (2 * (x[0] - x0 - (ll)mid * d) - 1 >= t[i]) l = mid;
            else r = mid;
        }
        //cout << l << "*\n";
        ans[i] = min(ans[i], (ll)t[i] * abs(l) + (x0 + (ll)l * d - x[0]) * (x0 + (ll)l * d - x[0]));
        ans[i] = min(ans[i], (ll)t[i] * abs(r) + (x0 + (ll)r * d - x[0]) * (x0 + (ll)r * d - x[0]));
    }
    return ans;
}

signed main() {
    int n, x0, d, m;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    cin >> x0 >> d >> m;
    vector<int> t(m);
    for (int i = 0; i < m; i++) cin >> t[i];
    vector<ll> ans = sol(n, x, x0, d, m, t);
    for (ll i : ans) cout << i << '\n';
    return 0;
}

/*
1
1000000000
0 100000000
5
1 2 3 4 5
*/
