#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
	for (T &elem: a) is >> elem;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
	for (T &elem: a) os << elem << ' ';
	return (os << '\n');
}

#define int long long

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;

      vector<string> a(n);
      for (int i = 0; i < n; ++i) cin >> a[i];

      vector<int> cnt(n);
      int res = 0;
      for (int j = m - 1; j >= 0; --j) {
            for (int i = 0; i < n; ++i) {
                  if (a[i][j] == '1') cnt[i]++;
                  else cnt[i] = 0;
            }

            for (int i = 0; i < n; ++i) {
                  int mn = 1e18, now =0;
                  for (int k = i; k >= 0; --k) {
                        mn = min(mn, cnt[k]);
                        now += mn;
                  }
                  res = max(res, now);
            }
      }
      cout << res << '\n';
}

