#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> p;

void dfs(int v, int pr) {
    int mn = 2e9, mni = -1;
    for (int u : g[v]) {
        if (u == pr)
            continue;
        dfs(u, v);
        dp[v][0] += dp[u][1];
        if (mn > dp[u][1] - dp[u][0]) {
            mn = dp[u][1] - dp[u][0];
            mni = u;
        }
    }
    if (mn == 2e9)
        dp[v][1] = 0;
    else
        dp[v][1] = dp[v][0] - mn + 1;
    p[v] = mni;
}

void get_p(int v, int pr, int t) {
    if (t == 1 && p[v] != -1) {
        cout << v + 1 << ' ' << p[v] + 1 << '\n';
        get_p(p[v], v, 0);
    }
    for (int u : g[v]) {
        if (u == pr ||(t == 1 && u == p[v]))
            continue;
        get_p(u, v, 1);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    int d;
    cin >> d;

    g.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;

        g[v].push_back(u);
        g[u].push_back(v);
    }

    dp.assign(n, vector<int>(2, 0));
    p.assign(n, -1);
    dfs(0, -1);

    cout << dp[0][1] << '\n';
    get_p(0, -1, 1);
}