#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<string> ar(n, string(m, '0'));
    vector<vector<int>> dp(n, vector<int>(m));
    for (auto& i : ar) {
        for (auto& j : i) {
            cin >> j;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (ar[i][j] == '1') {
                dp[i][j] = 1;
                if (j != m - 1) {
                    dp[i][j] += dp[i][j + 1];
                }
            }
        }
    }

    int ans = 0;
    for (int j = 0; j < m; ++j) {
        vector<pair<int, int>> st;
        int cur = 0;
        for (int i = 0; i < n; ++i) {
            int ptr = i - 1;
            int cnt = 1;
            while (!st.empty() && st.back().first > dp[i][j]) {
                cur -= st.back().first * st.back().second;
                cnt += st.back().second;
                st.pop_back();
            }
            cur += dp[i][j] * cnt;
            st.emplace_back(dp[i][j], cnt);
            ans = max(ans, cur);
        }
    }
    cout << ans;
}

signed main()
{
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("/home/roi/work/input.txt", "r", stdin);
#endif
    solve();
}