#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

using ll = long long;
using i128 = __int128_t;

__int128_t sqr(__int128_t x)
{
    return x * x;
}

ll calc(ll t, vector<ll>& pr, ll n, ll k, vector<i128>& pr2, vector<ll>& xs)
{
    auto ind = upper_bound(all(xs), k) - xs.begin();
    return t * k + (n - ind) * sqr(k) + pr2.back() - pr2[ind] - 2 * (pr.back() - pr[ind]) * k;
}

void solve()
{
    int n;
    cin >> n;
    vector<ll> xs(n);
    vector<i128> pr2(n + 1);
    vector<ll> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> xs[i];
    }
    sort(all(xs));
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + xs[i];
        pr2[i + 1] = pr2[i] + sqr(xs[i]);
    }
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        ll t;
        cin >> t;
        ll l = 0;
        ll r = 1e9;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (calc(t, pr, n, mid, pr2, xs) > calc(t, pr, n, mid + 1, pr2, xs)) {
                l = mid;
            } else {
                r = mid;
            }
        }

        cout << calc(t, pr, n, r, pr2, xs) << '\n';
    }
}

signed main()
{
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("/home/roi/work/input.txt", "r", stdin);
#endif
    solve();
}