#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

using ll = long long;

const int maxn = 5e5;

vector<int> g[maxn];
int match[maxn];
int color[maxn];
vector<int> cnt[2];

void dfs(int v, int p, int c)
{
    color[v] = c;
    cnt[c].push_back(v);
    for (int i : g[v]) {
        if (i != p) {
            dfs(i, v, c ^ 1);
        }
    }
}

void solve()
{
    int n, d;
    cin >> n >> d;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    dfs(0, -1, 0);
    int ans = min(cnt[0].size(), cnt[1].size());
    cout << ans << "\n";
    for (int i = 0; i < ans; ++i) {
        cout << cnt[0][i] + 1 << ' ' << cnt[1][i] + 1 << '\n';
    }
}

signed main()
{
    memset(match, -1, sizeof match);
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("/home/roi/work/input.txt", "r", stdin);
#endif
    solve();
}