// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <utility>
#include <bitset>
#include <queue>

using namespace std;
using ll =long long;
using ld = long double;
#ifdef _MSC_VER
#define __int128 ll
#endif
//using __int128 = ll;

ll cost(ll a)
{
	return a * a;
}

__int128 calc(__int128 a, __int128 b, __int128 x)
{
	return x * x * a + x * b;
}

// min(t*t*a+t*x*b+c*t+d*x+e)
__int128 solve_equation(ll a, ll b, ll c, ll d, ll e, ll x, ll ql, ll qr)
{
	ll base = e + d * x;
	b *= x;
	b += c;
	// now it is t*t*a+t*b+base
	__int128 cur = min(calc(a, b, ql), calc(a, b, qr));
	if (a != 0)
	{
		ll mid = -b / (2 * a);
		cur = min(cur, calc(a, b, min(qr, max(ql, mid))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid + 1))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid - 1))));
	}
	return cur + (__int128)base;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	vector <ll> lst(n);
	for (auto& i : lst)
	{
		cin >> i;
	}
	ll x0, ds;
	cin >> x0 >> ds;
	int m;
	cin >> m;
	for (size_t i = 0; i < m; i++)
	{
		ll x;
		cin >> x;
		// equation is t*t*a+t*x*b+c*t+d*x+e
		ll y = x0 - lst[0];
		// (t - y)^2 = t*t-2*t*y+y*y
		ll a = 1, b = 1, c = -2 * y, d = 0, e = y * y;
		a *= ds;
		a *= ds;
		b *= ds;
		c *= ds;
		ll ans = solve_equation(a, b, c, d, e, x, -1e9, 1e9);
		cout << ans << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
