#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e18;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), r(k), m(k);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        --l[i], --m[i];
    }
    vector<int> ord(k);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int x, int y) {
        return r[x] < r[y];
    });
    vector<int> dp(n + 1, n + 1);
    dp[0] = 0;
    for (int i : ord) {
        int mn = n + 1;
        for (int j = l[i]; j <= m[i]; ++j) {
            mn = min(mn, dp[j]);
        }
        if (mn < m[i]) {
            dp[r[i]] = min(dp[r[i]], m[i]);
        }
        mn = n + 1;
        for (int j = l[i]; j <= r[i]; ++j) {
            mn = min(mn, dp[j]);
        }
        if (mn < l[i]) {
            dp[r[i]] = min(dp[r[i]], m[i]);
        }
    }
    cout << (dp[n] < n ? "YES\n" : "NO\n");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
