#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool check(int l1, int m1, int r1, int l2, int m2, int r2) {
    return l1 <= m2 && m2 <= r1 && l2 <= m1 && m1 <= r2;
}

ll get(ll x, ll y) {
    return (x - y) * (x - y);
}

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (auto &x : a) cin >> x;
    sort(all(a));
    int x0, d;
    cin >> x0 >> d;
    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int t; cin >> t;
        ll ans = 0;
        if (n == 1) {
            int x = a[0];
            int l = -((abs(x - x0) + d - 1) / d + 1), r = (abs(x - x0) + d - 1) / d + 1;
            while (r - l > 2) {
                int len = (r - l + 1) / 3;
                int m1 = l + len;
                int m2 = l + 2 * len;
                if (get(x, x0 + m1 * d) < get(x, x0 + m2 * d)) {
                    r = m2;
                }
                else {
                    l = m1;
                }
            }
            ans = min(get(x, x0 + l * d), get(x, x0 + (l + 1) * d), get(x, x0 + (l + 2) * d));
            continue;
        }
        for (int j = 0; j < n; j++) {
            ll k = (a[j] - x0) / d;
            ans += min({get(a[j], x0 + k * d), get(a[j], x0 + (k + 1) * d), get(a[j], x0 + (k - 1) * d)});
        }
        cout << ans << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
