#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> dp(n + 1);
    vector<int> nxt(n + 1, inf);
    vector<vector<vector<int>>> segs(n + 1);
    for (int i = 0, l, m, r; i < k; ++i) {
        cin >> l >> m >> r;
        segs[m].push_back({l, r});
    }

    dp[0] = 1;
    vector<vector<int>> curr;
    for (int i = 1; i <= n; ++i) {
        for (auto seg : segs[i]) {
            if (dp[seg[0] - 1] || nxt[seg[0] - 1] < i) {
                bool flag = dp[seg[0] - 1];
                for (int pos = seg[0]; pos <= seg[1]; ++pos) {
                    if (i <= pos) dp[pos] = 1;
                    nxt[pos] = min(nxt[pos], seg[1]);
                }
            }
        }
    }

    cout << (dp[n] == 1 ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}