#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

vector<vector<int>> arr;
vector<vector<int>> g;
vector<vector<int>> f;

vector<pair<int, int>> res;
vector<pair<int, int>> ans;
vector<int> vis;
int n, d;
void perebor(int i) {
    if (i == n) {
        if (res.size() < ans.size()) {
            res = ans;
        }
        return;
    }
    if (vis[i]) {
        perebor(i + 1);
        return;
    }
    for (int u : arr[i]) {
        if (!vis[u]) {
            vis[i] = 1;
            vis[u] = 1;
            ans.push_back({i + 1, u + 1});
            perebor(i + 1);
            vis[i] = 0;
            vis[u] = 0;
            ans.pop_back();
        }
    }
    perebor(i + 1);
}

void solve() {
    cin >> n >> d;

    g.resize(n);
    arr.resize(n);
    vis.resize(n);
    f.resize(n, vector<int>(n, inf));
    for (int i = 0, v, u; i < n - 1; ++i) {
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
        f[v][u] = 1;
        f[u][v] = 1;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            for (int k = 0; k < n; ++k) {
                f[i][j] = min(f[i][j], f[i][k] + f[k][j]);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if ((f[i][j] & 1) && f[i][j] <= d) {
                arr[i].push_back(j);
            }
        }
    }

    perebor(0);

    cout << res.size() << '\n';
    for (auto val : res) {
        cout << val.first << ' ' << val.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}