//#pragma GCC optimize("O3", "unroll-loops")
//#pragma GCC target("avx2")

#include<bits/stdc++.h>

#define vi vector<int>
#define vvi vector<vi>
#define vc vector<char>
#define vvc vector<vc>
#define mii map<int, int>

#define f(i, n) for(int i=0;i<n;i++)
#define fr(i, n) for(int i=n-1;i>=0;i--)
#define all(v) v.begin(), v.end()

using namespace std;

struct ra
{
    int l, m, r;
};

bool cmp(const ra &r1, const ra &r2)
{
    return r1.r < r2.r;
}

void dfs(vvi &gr, vc &was, int v, vi &res)
{
    was[v] = 1;
    for (int u : gr[v])
        if (!was[u])
            dfs(gr, was, u, res);
    res.push_back(v);
}

vi topsrt(vvi &gr)
{
    vi res;
    vc was(gr.size());

    f(i, gr.size())
        if (!was[i])
            dfs(gr, was, i, res);
    return res;
}

struct nd
{
    int s, e;
    nd *l, *r;
    bool some;
    bool v;
    int cnt;

    nd(int st, int en)
    {
        s = st;
        e = en;
        some = 1;
        v = 0;
        cnt = 0;
        if (e == s+1)
            return;
        
        int m = (s + e) / 2;
        l = new nd(s, m);
        r = new nd(m, e);
    }

    void calc()
    {
        if (e == s+1)
            return;
        
        cnt = l->cnt + r->cnt;
        if (l->some && r->some && l->v == r->v)
        {
            some = 1;
            v = l->v;
        }
    }

    void se(int st, int en)
    {
        if (st >= e || en <= s)
            return;
        if (st <= s && en >= e)
        {
            some = 1;
            cnt = e - s;
            v = 1;
            return;
        }

        l->se(st, en);
        r->se(st, en);

        calc();
    }
};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    f(q, t)
    {
        int n, k;
        cin >> n >> k;

        // vvi gr(k);

        //vi ls(k), ms(k), rs(k);
        vector<ra> rs(k);
        f(i, k)
        {
            cin >> rs[i].l >> rs[i].m >> rs[i].r;
            rs[i].l--, rs[i].m--, rs[i].r--;
        }

        nd root(0, n);

        //sort(all(rs), cmp);

        // f(i, k)
        //     f(j, k)
        //     {
        //         if (i == j)
        //             continue;
        //         if (rs[i].m >= rs[j].l && rs[i].m <= rs[j].r)
        //             gr[i].push_back(j);
        //     }

        bool can = 1;

        f(i, k)
            f(j, i)
            {
                if (i == j)
                    continue;
                if (rs[i].m >= rs[j].l && rs[i].m <= rs[j].r)
                    if (rs[j].m >= rs[i].l && rs[j].m <= rs[i].r)
                        can = 0;
            }

        if (can)
        {
            f(i, k)
                root.se(rs[i].l, rs[i].r+1);
            if (root.cnt != n)
                can = 0;
        }

        // vi ts = topsrt(gr);
        // vi rts(k);
        // f(i, k)
        //     rts[ts[i]] = i;

        // f(v, k)
        //     for (int u : gr[v])
        //         if (rts[u] > rts[v])
        //             can = 0;

        if (can)
            cout << "YES\n";
        else
            cout << "NO\n";
    }
}