#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)
#define fj(from, to) for(int j = from; j <= to; j++)

using namespace std;

int main() {
	int n;
	cin >> n;
	vector <ll> x(n);
	fi(0, n - 1) {
		cin >> x[i];
	}
	int x0, d;
	cin >> x0 >> d;
	fi(0, n - 1) {
		x[i] -= x0;
	}
	int m;
	cin >> m;
	fj(0, m - 1) {
		ll t;
		cin >> t;
		ll ans = 0;
		ll place = 0;
		fi(0, n - 1) {
			ll dist = (x[i] - place);
			ll l = 0, r = abs(dist) / d + 2;
			if (dist < 0) d = -d;
			while (l + 2 != r) {
				ll m1 = (2 * l + r) / 3, m2 = (2 * r + l) / 3;
				ll new_place1 = place + d * m1;
				ll new_place2 = place + d * m2;
				if (m1 * t + (new_place1 - x[i]) * (new_place1 - x[i]) < m2 * t + (new_place2 - x[i]) * (new_place2 - x[i])) {
					r = m2;
				}
				else {
					l = m1;
				}
			}
			ll m1 = (l + r) / 2;
			ll new_place1 = place + d * m1;
			ans += m1 * t + (new_place1 - x[i]) * (new_place1 - x[i]);
			d = abs(d);
		}
		cout << ans << "\n";
	}
}