#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<deque>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<ctime>
#include<random>
#include<unordered_set>
#include<unordered_map>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

const int N = 5e2 + 2;
struct st {
	int l, m, r;
};
int n, m;
st a[N];
vector<int> b[N];
struct segtree {
	int t[N * 2];
	segtree() {
		fill(t, t + N * 2, -1);
	}
	void build() {
		fill(t, t + n * 2, -1);
	}
	void upd(int v, int l, int r, int i, int val) {
		t[v] = max(t[v], val);
		if (r - l == 1) return;
		int m = (l + r) >> 1;
		if (i < m) upd(v + 1, l, m, i, val);
		else
			upd(v + 2 * (m - l), m, r, i, val);
	}
	void upd(int i, int val) {
		upd(0, 0, n, i, val);
	}
	int get(int v, int l, int r, int ql, int qr) {
		if (r <= ql || qr <= l) return -1;
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) >> 1;
		return max(get(v + 1, l, m, ql, qr), get(v + 2 * (m - l), m, r, ql, qr));
	}
	int get(int l, int r) {
		return get(0, 0, n, l, r);
	}
};
segtree t1, t2;

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) b[i].clear();
	t1.build();
	t2.build();
	for (int i = 0; i < m; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
		--a[i].l, --a[i].m, --a[i].r;
		b[a[i].l].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		for (auto j : b[i]) {
			if (t1.get(0, i) >= i - 1 || t2.get(i, a[i].m) >= 1) {
				t1.upd(a[i].m, a[i].r);
				t2.upd(a[i].r, 1);
			}
		}
	}
	cout << (t2.get(n - 1, n) == 1 ? "YES" : "NO");
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}