#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<deque>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<ctime>
#include<random>
#include<unordered_set>
#include<unordered_map>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

const int N = 3e5 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;
int n, q, x0, d, a[N];
ll get(int x, int t) {
	ll sum = 1ll * x * t;
	x *= d;
	for (int i = 0; i < n; ++i) {
		if (a[i] <= x) {
			ll dist = min(a[i] % d, d - a[i] % d);
			sum += dist * dist;
		}
		else {
			sum += 1ll * (x - a[i]) * (x - a[i]);
		}
	}
	return sum;
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> a[i];
	cin >> x0 >> d >> q;
	while (q--) {
		int t;
		cin >> t;
		int l = x0, r = 60000;
		while (l != r) {
			int m = (l + r) >> 1;
			ll g1 = get(m, t);
			ll g2 = get(m + 1, t);
			if (g1 <= g2) r = m;
			else
				l = m + 1;
		}
		cout << get(l, t) << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}