#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
#define all(a) a.begin(), a.end() 

long long f(long long x, long long k, long long d, long long t, long long x0)
{
    return (x - (x0 - d * k)) * (x - (x0 - d * k)) + t * abs(k); 
}

long long g(long long x, long long k, long long d, long long t, long long x0)
{
    return (x - (x0 - d * k)) * (x - (x0 - d * k));
}
long long tern(long long x, long long d, long long t, long long x0)
{
    long long l = -1e9/d;
    long long r = 1e9/d;
    long long midl, midr, resl, resr;
    while(r - l > 7)
    {
        midl = (2 * l + r)/3;
        midr = (2 * r + l)/3;
        resl = f(x, midl, d, t, x0);
        resr = f(x, midr, d, t, x0);
        if(resr > resl)
        {
            r = midr;
        }
        else
        {
            l = midl;
        }
    }
    midl = l;
    for(long long i = l; i <= r; i++)
    {
        if(f(x, midl, d, t, x0) > f(x, i, d, t, x0))
        {
            midl = i;
        }
    }
    return midl;
}

long long tern2(long long x, long long d, long long t, long long x0)
{
    long long l = -1e9/d;
    long long r = 1e9/d;
    long long midl, midr, resl, resr;
    while(r - l > 7)
    {
        midl = (2 * l + r)/3;
        midr = (2 * r + l)/3;
        resl = f(x, midl, d, t, x0);
        resr = f(x, midr, d, t, x0);
        if(resr > resl)
        {
            r = midr;
        }
        else
        {
            l = midl;
        }
    }
    midl = l;
    for(long long i = l; i <= r; i++)
    {
        if(g(x, midl, d, t, x0) > g(x, i, d, t, x0))
        {
            midl = i;
        }
    }
    return midl;
}
signed main()
{
    long long n;
    cin >> n;
    vector<long long>x(n);
    for(long long i = 0; i < n; i++)
    {
        cin >> x[i];
    }
    long long x0, d;
    cin >> x0 >> d;
    long long flag = 0; 
    for(long long i = 0; i < n; i++)
    {
        if(x[i] == x0)
        {
            flag = 1;
        }
    }
    if(flag == 0)
    {
        n++;
        x.push_back(x0);
    }
    sort(all(x));
    for(long long i = 0; i < n; i++)
    {
        if(x[i] == x0)
        {
            flag = i;
        }
    }
    long long m;
    cin >> m;
    long long lr, rr, s, t;
    long long a, b, c;
    long double v;
    for(long long i = 0; i < m; i++)
    {
        cin >> t; 
        a = 0;
        rr = 0; b = 0;
        s = 0; c = 0;
        v = 0;
        rr = tern(x[n - 1], d, t, x0);
        s += g(x[n - 1], rr, d, t, x0);
        for(long long j = flag + 1; j < n - 1; j++)
        {
            c = tern2(x[j], d, t, x0);
            s += g(x[j], c, d, t, x0);
        }
        cout << s + rr * t << endl;
    }
    return 0;
}