#include <iostream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <fstream>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <array>
#include <vector>
#include <string>
#include <bitset>
#pragma gcc optimize("Ofast");
using namespace std;

//struct node {
//	int v, m, f, c;
//	node* l, * r;
//};
//
//node* create(node* s, int i, vector<vector<int>>& a, int l, int r) {
//	if (l == r) {
//		s->l = NULL;
//		s->r = NULL;
//		s->v = a[i][l];
//		s->m = a[i][l];
//		s->f = 1;
//		s->c = a[i][l];
//		return s;
//	}
//	s->l = new node;
//	s->r = new node;
//	s->l = create(s->l, i, a, l, (l + r) / 2);
//	s->r = create(s->r, i, a, (l + r) / 2 + 1, r);
//	if (s->l->f and s->r->f and s->l->c == s->r->c) {
//		s->f = 1;
//		s->c = s->l->c;
//	}
//	s->v = s->l->v + s->r->v;
//	s->m = min(s->l->m, s->r->m);
//
//}

bool check(int n, vector<array<int,3>>& b) {
	vector<int> t(n);
	for (int i = 0; i < b.size(); i++) {
		if (t[b[i][1]] == 0) {
			for (int j = b[i][0]; j <= b[i][2]; j++) {
				t[j] = 1;
			}
		}
	}
	return *min_element(t.begin(), t.end());
}

bool send(int n, vector<array<int, 3>> & a, vector<array<int, 3>> & b) {
	if (a.size() == b.size()) {
		return check(n, b);
	}
	int f1 = 0;
	for (int i = 0; i < a.size(); i++) {
		int f = 1;
		for (int j = 0; j < b.size(); j++) {
			if (a[i] == b[j]) {
				f = 0;
				break;
			}
		}
		if (f) {
			b.push_back(a[i]);
			if (send(n, a, b)) {
				return true;
			}
			b.pop_back();
		}
	}
	return false;
}

bool cmpl(array<int, 3> a, array<int, 3> b) {
	if (a[2] != b[2]) {
		return a[2] < b[2];
	}
	return a[1] < b[1];
}

bool cmpr(array<int, 3> a, array<int, 3> b) {
	if (a[0] != b[0]) {
		return a[0] > b[0];
	}
	return a[1] > b[1];
}

int main()
{
	int qweqwe;
	cin >> qweqwe;
	for (int qweqweqwe = 0; qweqweqwe < qweqwe; qweqweqwe++) {
		int n, k2;
		cin >> n >> k2;
		int f2 = 1;
		vector<array<int, 3>> a1;
		for (int i = 0; i < k2; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			if (m != l) {
				f2 = 0;
			}
			a1.push_back({ l - 1, m - 1, r - 1 });
		}
		if (k2 <= 8) {//k2<=8
			vector<array<int, 3>> a = a1;
			sort(a.begin(), a.end());
			vector<array<int, 3>> c = { a[0] };
			for (int i = 1; i < a.size(); i++) {
				if (a[i] != c[c.size() - 1]) {
					c.push_back(a[i]);
				}
			}
			vector<array<int, 3>> b;
			if (send(n, c, b)) {
				cout << "YES\n";
			}
			else {
				cout << "NO\n";
			}
		}
		else {
			if (f2) {//f2
				vector<array<int, 2>>a;
				for (int i = 0; i < k2; i++) {
					int l, m, r;
					l = a1[i][0];
					m = a1[i][1];
					r = a1[i][2];
					a.push_back({ r, l });
				}
				sort(a.begin(), a.end());
				vector<int> b(n);
				int k = n - 1;
				int f = 1;
				for (int i = a.size() - 1; i >= 0; i--) {
					if (a[i][0] < k) {
						cout << "NO\n";
						f = 0;
						break;
					}
					k = min(a[i][1] - 1, k);
					if (k < 0) {
						cout << "YES\n";
						f = 0;
						break;
					}
				}
				if (f) {
					cout << "NO\n";
				}
			}
			else {
				vector<array<int, 3>> l, r;
				int f3 = 0;
				for (int i = 0; i < a1.size(); i++) {
					if (a1[i][0] == 0) {
						if (a1[i][2] == n - 1) {
							cout << "YES\n";
							f3 = 1;
							break;
						}
						l.push_back(a1[i]);
					}
					else {
						r.push_back(a1[i]);
					}
				}
				if (f3) {
					continue;
				}
				sort(l.begin(), l.end(), cmpl);
				sort(r.begin(), r.end(), cmpr);
				vector<array<int, 3>> l1 = { l[0] }, r1 = { r[0] };
				for (int i = 1; i < l.size(); i++) {
					while (l1.size() > 0 and l1[l1.size() - 1][2] <= l[i][2] and l1[l1.size() - 1][1] >= l[i][1]) {
						l1.pop_back();
					}
					//if (l[i][2] == l[i - 1][2]) {
					//	l1.pop_back();
					//}
					l1.push_back(l[i]);
				}
				for (int i = 1; i < r.size(); i++) {
					while (r1.size() > 0 and r1[r1.size() - 1][0] >= r[i][0] and r1[r1.size() - 1][1] <= r[i][1]) {
						r1.pop_back();
					}
					//if (r[i][0] == r[i - 1][0]) {
					//	r1.pop_back();
					//}
					r1.push_back(r[i]);
				}
				int j = r.size() - 1;
				int f4 = 1;
				for (int i = 0; i < l.size(); i++) {
					while (j >=0 and l[i][2] >= r[j][0] - 1) {
						if (l[i][2] >= r[j][0] - 1 and l[i][1] < r[j][0] and r[j][1] > l[i][2]) {
							cout << "YES\n";
							f4 = 0;
							break;
						}
						j--;
					}
					if (f4 == 0) {
						break;
					}
				}
				if (f4) {
					cout << "NO\n";
				}
				
			}
		}
	}
	return 0;
}

