#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

struct worker {
	int l, m, r;
};

bool comp(worker a, worker b) {
	if (a.r > b.r) {
		return true;
	}
	if (a.r == b.r and a.l < b.l) {
		return true;
	}
	return false;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<worker> arr(k);
	for (int i = 0; i < k; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		arr[i] = { l, m, r };
	}
	sort(arr.begin(), arr.end(), comp);
	int minl = n + 1;
	for (int i = 0; i < k; i++) {
		if (arr[i].r < minl - 1) {
			cout << "NO\n";
			return;
		}
		if (arr[i].l < minl) {
			minl = arr[i].l;
		}
	}
	if (minl == 1) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
	return 0;
}	