#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

struct worker {
	int l, m, r;
};

bool comp(worker a, worker b) {
	if (a.r > b.r) {
		return true;
	}
	if (a.r == b.r and a.l < b.l) {
		return true;
	}
	return false;
}

int fact(int n) {
	if (n == 0) {
		return 1;
	}
	return n * fact(n - 1);
}

bool comp2(worker a, worker b) {
	if (a.l < b.l) {
		return true;
	}
	return false;
}

bool check(worker a, worker b) {
	if (a.l <= b.m and b.m <= a.r) {
		return true;
	}
	return false;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<worker> arr(k);
	for (int i = 0; i < k; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		arr[i] = { l, m, r };
	}
	vector<worker> left;
	vector<worker> right;
	for (int i = 0; i < k; i++) {
		if (arr[i].l == 1) {
			left.push_back(arr[i]);
		}
		else if (arr[i].r == n) {
			right.push_back(arr[i]);
		}
	}
	int n1 = left.size();
	int m1 = right.size();
	for (int i = 0; i < n1; i++) {
		for (int j = 0; j < m1; j++) {
			if (left[i].r == n or right[j].l == 1) {
				cout << "YES\n";
				return;
			}
			if (left[i].r >= right[j].l - 1 and !(check(left[i], right[j]) and check(right[j], left[i]))) {
				cout << "YES\n";
				return;
			}
		}
	}
	cout << "NO\n";
	return;
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
	return 0;
}