#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

ll res(ll a, ll b) {
	return (a - b) * (a - b);
}

ll check(ll m, ll t, ll d, ll x) {
	return m * t + res(x, m * d);
}

ll trinary_search(ll l, ll r, ll t, ll d, ll x) {
	while (r - l > 2) {
		ll m1 = (2 * l + r) / 3;
		ll m2 = (2 * r + l) / 3;
		ll ans1 = check(m1, t, d, x);
		ll ans2 = check(m2, t, d, x);
		if (ans1 < ans2) {
			r = m2;
		}
		else {
			l = m1;
		}
	}
	ll m = (l + r) / 2;
	ll ansl = check(l, t, d, x);
	ll ansm = check(m, t, d, x);
	ll ansr = check(r, t, d, x);
	return min({ ansl, ansm, ansr });
}

ll ans(ll x, ll t, ll x0, ll d) {
	if (x0 != 0) {
		x -= x0;
	}
	if (x < 0) {
		x = -x;
	}
	return trinary_search(0, (x + d - 1) / d, t, d, x);
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> arr(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	ll x0, d;
	cin >> x0 >> d;
	ll m;
	cin >> m;
	ll x = arr[0];
	for (ll i = 0; i < m; i++) {
		ll t;
		cin >> t;
		cout << ans(x, t, x0, d) << '\n';
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
	return 0;
}