#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <random>
#include <array>
#include <iomanip>
#include <queue>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#ifdef _DEBUG
#define int128 ll
#else
#define int128 __int128
#endif
const ll INF = 1e18, MOD = 1e9 + 7, N = 3e5 + 20;
const ld EPS = 1e-9;
ll n, d;
vector<ll> g[N];
vector<pair<ll, ll>> ans;
const ll D = 14;
set<pair<ll, ll>> st[N]{};
void eee(ll v, ll p) {
	st[v].insert({ 0, v });
	for (ll u : g[v]) {
		if (u != p) {
			eee(u, v);
			for (auto ep : st[u]) {
				if (ep.first < d) {
					st[v].insert({ ep.first + 1, ep.second });
				}
			}
		}
	}
	for (ll c0 = d; c0 >= 0; c0--) {
		for (ll c1 = d - c0; c1 >= 0; c1--) {
			if ((c0 + c1) % 2 == 0) continue;
			while (true) {
				auto it0 = st[v].lower_bound({ c0, 0 });
				auto it1 = st[v].lower_bound({ c1, 0 });
				if (it0 == st[v].end() || it1 == st[v].end() || 
					it0->first != c0 || it1->first != c1) break;
				ans.push_back({ it0->second + 1, it1->second + 1 });
				st[v].erase(it0);
				st[v].erase(it1);
			}
			break;
		}
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d;
	for (ll i = 0; i < n - 1; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	eee(0, -1);
	ll v = 0;
	for (ll c0 = d; c0 >= 1; c0--) {
		for (ll c1 = c0 - 1; c1 >= 0; c1 -= 2){
			if (c0 + c1 > d) continue;
			while (true) {
				auto it0 = st[v].lower_bound({ c0, 0 });
				auto it1 = st[v].lower_bound({ c1, 0 });
				if (it0 == st[v].end() || it1 == st[v].end() ||
					it0->first != c0 || it1->first != c1) break;
				ans.push_back({ it0->second + 1, it1->second + 1 });
				st[v].erase(it0);
				st[v].erase(it1);
			}
		}
	}
	cout << ans.size() << "\n";
	for (auto p : ans) cout << p.first << " " << p.second << "\n";
	return 0;
}