#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;

struct rab{
    int l, r, m;
};

vector <vector <int>> arr;
vector <int> used;

bool dfs(int v, int c) {
    used[v] = c;
    for (int to : arr[v]) {
        if (used[to] == c) return true;
        if (used[to] == 0 && dfs(to, c)) return true;
    }
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        arr.clear();
        arr.resize(k);
        vector <rab> v(k);
        for (int i = 0; i < k; ++i) {
            cin >> v[i].l >> v[i].m >> v[i].r;
        }
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (v[i].l <= v[j].m && v[j].m <= v[i].r && i != j) {
                    arr[j].push_back(i);
                    //cout << j << ' ' << i << endl;
                }
            }
        }
        bool is = false;
        used.clear();
        used.resize(k);
        for (int i = 0; i < k; ++i) {
            if (used[i] == 0) {
                is = (is || dfs(i, i + 1));
            }
        }
        if (is) {
            cout << "NO" << endl;
        } else {
            vector <pair <int, int>> sc;
            for (int i = 0; i < k; ++i) {
                sc.push_back({v[i].l, -1});
                sc.push_back({v[i].r, 1});
            }
            int cnt = 0;
            sort(sc.begin(), sc.end());
            for (int i = 0; i < 2 * k; ++i) {
                cnt += sc[i].second;
                //cout << cnt << " " << sc[i].first << endl;
                if (cnt == 0 && sc[i].first != n && !(i < 2 * k - 1 && sc[i + 1].first - 1 == sc[i].first)) {
                    is = true;
                    break;
                }
            }
            if (is) {
                cout << "NO" << endl;
            } else {
                cout << "YES" << endl;
            }
        }
    }
    return 0;
}
