#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void solve() {
    int n, k;
    cin >> n >> k;

    vector<pii> a(k);
    for (auto &e : a) {
        cin >> e.first >> e.first >> e.second;
    }

    sort(all(a));
    int cur = 0;
    for (int i = 0; i < k; ++i) {
        if (a[i].first > cur + 1) {
            cout << "NO\n";
            return;
        }
        cur = max(cur, a[i].second);
    }
    if (cur == n) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    solve();
}