#ifndef LOCAL
  // #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  // #pragma GCC target("avx2,fma")
#endif

using namespace std;

using ll = long long;

auto& setmax(auto& a, const auto& b) {
  return a = a > b ? a : b;
}

auto& setmin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}

int isz(const auto& c) {
  return c.size();
}

vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> mt;

void dfs(int u, int p) {
  for (int v : g[u]) {
    if (v == p) continue;
    dfs(v, u);
    dp[u][0] += max(dp[v][0], dp[v][1]);
  }
  for (int v : g[u]) {
    if (v == p) continue;
    int val = dp[u][0] - max(dp[v][0], dp[v][1]) + 1 + dp[v][0];
    if (dp[u][1] < val) {
      dp[u][1] = val;
      mt[u] = v;
    }
  }
}

vector<pair<int, int>> ans;

void calc_ans(int u, int p, int type) {
  if (type == 1) {
    if (dp[u][1] > dp[u][0]) {
      ans.emplace_back(u, mt[u]);
    }
  }
  for (int v : g[u]) {
    if (v == p) continue;
    if (type == 1) {
      calc_ans(v, u, (mt[u] == v ? 0 : 1));
    } else {
      calc_ans(v, u, 1);
    }
  }
}

void solve() {
  int n;
  cin >> n;
  int d;
  cin >> d;
  g.assign(n + 1, {});
  dp.assign(n + 1, vector<int>(2));
  mt.assign(n + 1, -1);
  for (int i = 0; i < n - 1; ++i) {
    int u, v;
    cin >> u >> v;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  dfs(1, -1);
  cout << max(dp[1][0], dp[1][1]) << '\n';
  calc_ans(1, -1, 1);
  for (auto [u, v] : ans) cout << u << ' ' << v << '\n';
}

signed main() {
  #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
  #endif
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  while (t --> 0) {
    solve();
  }
}