#include <bits/stdc++.h>
using namespace std;
#define int long long
vector <int> tree, kol;
void update(int i, int l, int r, int qi, int x) {
    if (l + 1 == r) {
        kol[i] += x;
        tree[i] += (l + 1) * x;
        return;
    }
    int m = (l + r) / 2;
    if (tree[i] == 0) {
        tree[i * 2 + 1] = 0;
        tree[i * 2 + 2] = 0;
        kol[i * 2 + 1] = 0;
        kol[i * 2 + 2] = 0;
    }
    if (qi < m) update(i * 2 + 1, l, m, qi, x);
    else update(i * 2 + 2, m, r, qi, x);
    tree[i] = tree[i * 2 + 1] + tree[i * 2 + 2];
    kol[i] = kol[i * 2 + 1] + kol[i * 2 + 2];
}
int get_s(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql)
        return 0;
    if (l >= ql && r <= qr) {
        return tree[i];
    }
    if (tree[i] == 0) {
        tree[i * 2 + 1] = 0;
        tree[i * 2 + 2] = 0;
        kol[i * 2 + 1] = 0;
        kol[i * 2 + 2] = 0;
    }
    int m = (l + r) / 2;
    return get_s(i* 2 + 1, l, m, ql, qr) + get_s(i * 2 + 2, m, r, ql, qr);
}
int get_kol(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql)
        return 0;
    if (l >= ql && r <= qr) {
        int t = kol[i];
        kol[i] = 0;
        tree[i] = 0;
        return t;
    }
    if (tree[i] == 0) {
        tree[i * 2 + 1] = 0;
        tree[i * 2 + 2] = 0;
        kol[i * 2 + 1] = 0;
        kol[i * 2 + 2] = 0;
    }
    int m = (l + r) / 2;
    int t = get_kol(i* 2 + 1, l, m, ql, qr) + get_kol(i * 2 + 2, m, r, ql, qr);
    kol[i] = kol[i * 2 + 1] + kol[i * 2 + 2];
    tree[i] = tree[i * 2 + 1] + tree[i * 2 + 2];
    return t;
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector<bool>> a(n, vector<bool>(m));
    vector <vector<int>> d(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char h;
            cin >> h;
            a[i][j] = h == '1';
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (j == m - 1) {
                d[i][j] = a[i][j];
            } else {
                d[i][j] = (a[i][j] ? d[i][j + 1] + 1 : 0);
            }
        }
    }
    int mx = 0;
    tree = kol = vector<int>(4 * m, 0);
    for (int j = 0; j < m; j++) {
        get_kol(0, 0, m, 0, m);
        for (int i = 0; i < n; i++) {
            if (d[i][j]) {
                int cnt = get_kol(0, 0, m, d[i][j], m);
                update(0, 0, m, d[i][j] - 1, cnt + 1);
                mx = max(mx, tree[0]);
            } else {
                get_kol(0, 0, m, 0, m);
            }
        }
    }
    cout << mx << endl;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}