#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

struct person {
    int l;
    int m;
    int r;

    person(int l_, int m_, int r_) {
        l = l_;
        m = m_;
        r = r_;
    }
};

void all(int sz, vector<pair<int, int>> &ost, vector<int> &now, vector<vector<int> > &ans) {
    if (now.size() == sz) {
        ans.push_back(now);
        return;
    }

    for (int i = 0; i < ost.size(); ++i) {
        auto [val, am] = ost[i];
        if (!am)
            continue;
        now.push_back(val);
        ost[i].second = 0;
        all(sz, ost, now, ans);
        ost[i].second = 1;
        now.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    for (int p = 0; p < t; ++p) {
        int n, k;
        cin >> n >> k;
        vector<person> v;

        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            v.push_back({l, m, r});
        }

        vector<pair<int, int>> numb;
        for (int i = 0; i < k; ++i)
            numb.emplace_back(i, 1);

        int answer = 0;
        for (int sz = 1; sz <= k; ++sz) {
            vector<int> now;
            vector<vector<int> > ans;
            cout << endl;
            all(sz, numb, now, ans);

            for (auto &x: ans) {
                vector<int> rooms(n + 1);
                for (auto y : x) {
                    if (rooms[v[y].m])
                        continue;
                    for (int i = v[y].l; i <= v[y].r; ++i)
                        rooms[i] = 1;
                }

                int flag = 1;
                for (int i = 1; i <= n; ++i)
                    if (!rooms[i])
                        flag = 0;

                if (flag)
                    answer = 1;
            }
        }
        if (answer)
            cout << "YES" << endl;
        else
            cout << "NO" << endl;
    }
}
