// Created by roi on 27.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int h, w;
    cin >> h >> w;
    vector<vector<int> > a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char x;
            cin >> x;

            a[i][j] = int(x - '0');
        }
    }

    ll res = 0;
    vector<int> b(w);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == 0) {
                b[j] = 0;
            } else {
                ++b[j];
            }
        }

        // {H, cnt}
        ll sum = 0;
        vector<pair<int, int> > st;
        for (int j = w - 1; j >= 0; --j) {
            while (!st.empty() && st.back().first > b[j]) {
                if (st.size() == 1 || st[st.size() - 2].first < b[j]) {
                    sum -= (st.back().first - b[j]) * st.back().second;
                    st.back().first = b[j];
                } else {
                    sum -= (st.back().first - st[st.size() - 2].first) * st.back().second;
                    int c = st.back().second;
                    st.pop_back();
                    st.back().second += c;
                }
            }

            if (st.empty() || st.back().first != b[j]) {
                st.emplace_back(b[j], 1);
            } else {
                ++st.back().second;
            }
            sum += b[j];

            res = max(res, sum);
        }
    }
    cout << res << '\n';
}
