
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int INF = 1e9;

void solve() {
    int n, k;
    cin >> n >> k;

    vector <vector <int>> a(n + 1);
    for (int i = 0; i < k; i++) {
        int l, r, m;
        cin >> l >> m >> r;
        a[l].push_back(r);
    }

    vector <bool> dp(n + 1);
    dp[0] = 1;
    for (int i = 1; i <= n; i++) {
        if (!dp[i - 1]) continue;
        for (auto r : a[i]) {
            dp[r] = true;
        }
    }
    if (dp.back()) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}