#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using lll = __int128;
template<typename T>
void _print(T a) {cerr << a;}
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(vector<T> a) {cerr << "[";int f = 0;for (auto v : a) {if (f++)cerr << ", ";_print(v);}cerr << "]";}

#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n';
#else
#define debug(x)
#endif

struct empl {
    int l, m, r;
};
const int maxn = 600'000;
vector<int> g[maxn];



int n, k;

void solve() {
    cin >> n >> k;
    vector<empl> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    vector<bool> no(k);
    vector<bool> used(n + 1);
    for (int i = 0; i < k; ++i) {
        bool flag = false;
        for (int j = 0; j < k; ++j) {
            if (i == j)continue;
            if (a[i].l <= a[j].m && a[i].r >= a[j].m) {
                flag = true;
            }
        }
        if (!flag) {
            debug(i);
            no[i] = false;
            for (int j = a[i].l; j <= a[i].r; ++j)used[j] = true;
        }
    }
    int cnt = 0;
    for (int i = 1; i <= n; ++i)if (used[i])cnt++;

    while (cnt < n) {
        int ind = -1;
        int val = -1;
        for (int i = 0; i < k; ++i) {
            if (no[i])continue;
            int now = 0;
            for (int j = a[i].l; j <= a[i].r; ++j) {
                if (!used[j])now++;
            }
            if (now > val) {
                val = now;
                ind = i;
            }
        }
        if (ind == -1)break;
        no[ind] = true;
        for (int i = a[ind].l; i <= a[ind].r; ++i) {
            if (!used[i])cnt++;
            used[i] = true;
        }
        for (int i = 0; i < k; ++i) {
            if (no[i] || ind == i)continue;
            if (a[ind].l <= a[i].m && a[ind].r >= a[i].m)no[i] = true;
        }
    }
    if (cnt == n) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}
signed main() {
    std::ios_base::sync_with_stdio(false);std::cin.tie(nullptr);std::cout.tie(nullptr);

    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}