#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using lll = __int128;
template<typename T>
void _print(T a) {cerr << a;}
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(vector<T> a) {cerr << "[";int f = 0;for (auto v : a) {if (f++)cerr << ", ";_print(v);}cerr << "]";}

#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n';
#else
#define debug(x)
#endif

struct empl {
    int l, m, r;
};
const int maxn = 600'000;
vector<int> g[maxn];

bool flag = false;

int n, k;
void dfs(int v, int l, int r, vector<int> used, vector<empl> &a) {
    l = min(l, a[v].l);
    r = max(r, a[v].r);
    if (flag)return;
    if (l == 1 && r == n) {
        flag = true;
        return;
    }
    for (auto to : g[v]) {
        used[to] = true;
    }
    for (int i = 0; i < k; ++i) {
        if (used[i])continue;
        dfs(i, l, r, used, a);
    }
}

void solve() {
    cin >> n >> k;

    vector<empl> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    //ребро i->j означает что после выполнения работы i, мы не можем выполнить работу j
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (a[i].l <= a[j].m && a[j].m <= a[i].r) {
                debug(i);
                debug(j);
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < k; ++i) {
        vector<int> used(k);
        dfs(i, INT_MAX, -1, used, a);
        if (flag)break;
    }
    if (flag) {
        cout << "YES";
    } else {
        cout << "NO";
    }
    for (int i = 0; i < k; ++i)g[i].clear();
}
signed main() {
    std::ios_base::sync_with_stdio(false);std::cin.tie(nullptr);std::cout.tie(nullptr);

    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
        flag = false;
        cout << '\n';
    }
}