#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <bitset>
#include <cmath>
 
using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
 
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

void solve();
 
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
 
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

struct trip {
    int l, m, r;
    trip() : l(0), m(0), r(0) {}
    trip(int l, int m, int r) : l(l), m(m), r(r) {}
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<trip> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
    }
    vector<int> order(k);
    for (int i = 0; i < k; i++) order[i] = i + 1;
    do {
        vector<int> used(n);
        for (auto kek : order) {
            int ind = kek - 1;
            dbg(a[ind].m);
            if (used[a[ind].m]) continue;
            for (int i = a[ind].l; i < a[ind].r; i++) {
                used[i] = 1;
            }
        }
        if (count(used.begin(), used.end(), 1) == n) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(order.begin(), order.end()));
    cout << "NO\n";
}