//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e9;
__int128 get(ll pos, vector<__int128> &pr, vector<ll> &prsum, vector<ll> &v, vector<__int128> &lsum) {
    ll ind = upper_bound(v.begin(), v.end(), pos) - v.begin();
    ll cnt = v.size() - ind;
    return (__int128)cnt * pos * pos - (__int128)pos * 2 *(prsum.back() - prsum[ind]) + (pr.back() - pr[ind]) + lsum[ind];
}

__int128 run(ll n, vector<ll> &v, ll x0, ll d, ll t) {
    vector<__int128> pr(n + 1);
    vector<ll> prsum(n + 1);
    vector<__int128> lsum(n + 1);
    sort(v.begin(), v.end());
    for (ll i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + (__int128)v[i] * v[i];
        prsum[i + 1] = prsum[i] + v[i];
        ll x1 = v[i] / d * d;
        ll x2 = x1 + d;
        lsum[i + 1] = lsum[i] + (__int128)min((v[i] - x1) * (v[i] - x1), (v[i] - x2) * (v[i] - x2));
    }
        ll l = -1, r = 1e9 + 2;
        while (l + 2 < r) {
            ll mid1 = (l * 2 + r) / 3;
            ll mid2 = (l + r * 2) / 3;
            __int128 x1 = get(mid1 * d + x0, pr, prsum, v, lsum) + mid1 * t;
            __int128 x2 = get(mid2 * d + x0, pr, prsum, v, lsum) + mid2 * t;
            if (x1 < x2)
                r = mid2;
            else
                l = mid1;
        }
        ll pos = (l + r) / 2;
        ll ans = get(pos * d + x0, pr, prsum, v, lsum) + pos * t;
        //ans = min((ll)get((pos + 1) * d + x0, pr, prsum, v, lsum) + (pos + 1)  * t, ans);
        //ans = min((ll)get((pos - 1) * d + x0, pr, prsum, v, lsum) + (pos - 1)  * t, ans);
    return ans;
}

void solve() {
    ll n;
    cin>>n;
    vector<ll> v3, v2, v(n);
    for (ll i = 0; i < n; ++i) {
       cin>>v[i];
    }
    ll x0, d;
    cin>>x0>>d;
    for (ll i = 0; i  < n; ++i) {
        if (v[i] < x0) {
            v3.push_back(-v[i]);
        }
        else {
            v2.push_back(v[i]);
        }
    }sort(v2.begin(), v2.end());
        sort(v3.begin(), v3.end());
    ll m;
    cin>>m;
    vector<ll> q(m);
    for (ll i = 0; i  <m; ++i) {
        cin >> q[i];
        ll ans = run(v2.size(), v2, x0, d, q[i]) + run(v3.size(), v3, x0, d, q[i]);
        cout << ans << endl;
    }
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}