// #pragma GCC target("avx2")
#pragma GCC optimize("o3")

#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w));
    vector<vector<int>> up(h, vector<int> (w));
    for (int i = 0; i < h; ++i) {
        string x;
        cin >> x;
        for (int j = 0; j < w; ++j) {
            if (x[j] == '1') a[i][j] = 1;
            else a[i][j] = 0;

            if (x[j] == '1') up[i][j] = 1;
            if (x[j] == '1' && i > 0) up[i][j] += up[i - 1][j];
        }
    }

    int maxx = 0;
    if (h > w) {
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                int minn = up[i][j], ans = 0;
                for (int k = j; k < w; ++k) {
                    if (a[i][k] == 0) break;
                    ans += min(minn, up[i][k]);
                    minn = min(up[i][k], minn);
                }
                maxx = max(ans, maxx);
            }
        }
    } else {
        vector<vector<int>> right(h, vector<int> (w));
        for (int j = w - 1; j >= 0; --j) {
            for (int i = 0; i < h; ++i) {
                if (a[i][j] == 1) right[i][j] = 1;
                if (a[i][j] == 1 && j != w - 1) right[i][j] += right[i][j + 1];
            }
        }

        for (int j = w - 1; j >= 0; --j) {
            for (int i = h - 1; i >= 0; --i) {
                int minn = right[i][j], ans = 0;
                for (int k = i; k >= 0; --k) {
                    if (a[k][j] == 0) break;
                    ans += min(minn, right[k][j]);
                    minn = min(right[k][j], minn);
                }
                maxx = max(ans, maxx);
            }
        }
    }
    cout << maxx;
}