#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<numeric>
#include<functional>
#include<cstdint>
#include<deque>
#include<chrono>
#include<ctime>

using namespace std;
using namespace chrono;

#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmax(a, b) a = max(a, b)
#define chmin(a, b) a = min(a, b)
#define pii pair<int, int>
#define tiii tuple<int, int, int>
#define tiiii tuple<int, int, int,int>
const int N = 3e5;
vector<int> t[N], g[N];
int dp0[N], dp1[N], h[N];
int n, d;
int timer = -1;
void dfs(int v, int par) {
	h[v] = h[par] + (v != 0);
	for (auto u : g[v]) {
		if (u == par) continue;
		dfs(u, v);
	}
}
int used[N];
vector<int> ans;
int tk = 1;
bool dfs2(int v) {
	used[v] = tk;
	for (auto u : g[v]) {
		if (ans[u] == -1) {
			ans[u] = v; return 1;
		}
	}
	for (auto u : g[v]) {
		if (used[ans[u]] != tk && dfs2(ans[u])) {
			ans[u] = v; return 1;
		}
	}
	return 0;
}


void solve() {
	cin >> n >> d;
	for (int i = 0; i < n - 1; ++i) {
		int v, u; cin >> v >> u; --v; --u;
		g[v].push_back(u); g[u].push_back(v);
	}
	ans.resize(n, -1);
	dfs(0, 0);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (h[i] % 2 == 0) {
			++tk; cnt += dfs2(i);
		}
	}
	cout << cnt << "\n";
	for (int i = 0; i < n; ++i) {
		if (h[i] % 2 == 1 && ans[i] != -1) {
			cout << i + 1 << " " << ans[i] + 1 << "\n";
		}
	}
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}



