#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll INF = 1e18;
const ll MAXX = 100;
ll sign(ll x) {
    return (x > 0) - (x < 0);
}
 
 
void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }
  
    ll x0, d;
    cin >> x0 >> d;
  
    for (auto &el : a) {
        el -= x0;
        //el = abs(el); //breaks the whole
    }
    x0 = 0;
 
 
    auto get = [&](ll id, ll t, ll ub) {
        ll ax = d * d;
        ll bx = t - 2 * a[id] * d * sign(a[id]);
        ll vl = -bx / (2 * ax);
  
        ll mn = a[id] * a[id];
        for (auto &i : {vl - 1, vl, vl + 1, ub}) {
            if (i < 0 || i > ub) {
                continue;
            }
  
            mn = min(mn, i * t + (a[id] - i * d * sign(a[id])) * (a[id] - i * d * sign(a[id])));
        }
        return mn;
    };

    auto nig = [&](ll id) {
        ll ax = d * d;
        ll bx = -2 * a[id] * d * sign(a[id]);
        ll vl = -bx / (2 * ax);
  
        vector<ll> rs;
        for (auto &i : {vl - 1, vl, vl + 1}) {
            if (i < 0) {
                continue;
            }
            rs.push_back(i);
        }
        return rs;
    };

    ll s = 0;
    vector<ll> hv(n);
    for (ll i = 0; i < n; i++) {
        //move = 0;
        hv[i] = (a[i] - 0ll * d * sign(a[i])) * (a[i] - 0ll * d * sign(a[i]));
        s += hv[i];
    }

    vector<pii> bord = {{0, s}};
    vector<pii> all;
    for (ll i = 0; i < n; i++) {
        auto cc = nig(i);
        for (auto &el : cc) {
            all.push_back({el, i});
        }
    }
    sort(all.begin(), all.end());

    for (auto &[f, id] : all) {
        s -= hv[id];
        hv[id] = min(hv[id], (a[id] - f * d * sign(a[id])) * (a[id] - f * d * sign(a[id])));
        s += hv[id];
        bord.push_back({f, s});
    }

    ll m;
    cin >> m;
    while (m--) {
        ll t;
        cin >> t;

        ll mn = INF;
        for (ll i = 0; i < 1000; i++) {
            //auto it = lower_bound(bord.begin(), bord.end(), pii{i + 1, -INF});
            //mn = min(mn, i * t + prev(it)->second);
            ll ss = i * t;
            for (ll j = 0; j < n; j++) {
                ss += get(j, 0, i);
            }
            mn = min(mn, ss);
        }
        cout << mn << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}