#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll INF = 1e18;
ll sign(ll x) {
    return (x > 0) - (x < 0);
}


void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }
 
    ll x0, d;
    cin >> x0 >> d;
 
    for (auto &el : a) {
        el -= x0;
        //el = abs(el); //breaks the whole
    }
    x0 = 0;


    auto get = [&](ll id, ll t) {
        ll ax = d * d;
        ll bx = t - 2 * a[id] * d * sign(a[id]);
        ll vl = -bx / (2 * ax);
 
        ll mn = a[id] * a[id];
        for (ll i = vl - 2; i <= vl + 2; i++) {
            if (i < 0) {
                continue;
            }
 
            mn = min(mn, i * t + (a[id] - i * d * sign(a[id])) * (a[id] - i * d * sign(a[id])));
        }
        return mn;
    };

 
    ll m;
    cin >> m;
    while (m--) {
        ll t;
        cin >> t;
        cout << min(get(0, 2 * t) + get(1, t), get(0, t) + get(1, 2 * t)) << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}