#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define szof(x) ((ll) x.size())

vector<vector<int>> fens;

void add(int i, int x, vector<int> &fen) {
    for (; i < szof(fen); i += i & -i) {
        fen[i] += x;
    }
}

int get(int i, vector<int> &fen) {
    int res = 0;
    for (; i > 0; i -= i & -i) {
        res += fen[i];
    }
    return res;
}

void solve() {
    ll h, w;
    cin >> h >> w;
    vector<vector<int>> a(h + 1, vector<int>(w + 1));
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    if (w > h) {
        vector<vector<int>> b(w + 1, vector<int>(h + 1));
        for (int i = 1; i <= h; ++i) {
            reverse(a[i].begin() + 1, a[i].end());
        }
        for (int i = 1; i <= h; ++i) {
            for (int j = 1; j <= w; ++j) {
                b[j][i] = a[i][j];
            }
        }
        for (int i = 1; i <= w; ++i) {
            reverse(b[i].begin() + 1, b[i].end());
        }
        swap(w, h);
        swap(a, b);
    }
    vector<vector<ll>> dp(h + 1, vector<ll>(w + 1));
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            if (!a[i][j]) {
                continue;
            }
            dp[i][j] = dp[i - 1][j] + 1;
        }
    }
    ll ans = 0;
    for (int i = 1; i <= h; ++i) {
        vector<ll> right(w + 1, w + 1);
        vector<pair<ll, ll>> st = {{-INT_MAX, 0}};
        for (int j = 1; j <= w; ++j) {
            while (dp[i][j] < st.back().first) {
                right[st.back().second] = j;
                st.pop_back();
            }
            st.emplace_back(dp[i][j], j);
        }

        vector<ll> dp1(w + 1);
        for (int j = w; j >= 1; --j) {
            if (right[j] == w + 1) {
                dp1[j] = (w - j + 1) * dp[i][j];
            } else {
                dp1[j] = dp1[right[j]] + (right[j] - j) * dp[i][j];
            }
        }
        for (int j = 1; j <= w; ++j) {
            // ll sum = 0, mn = dp[i][j];
            // for (int k = j; k <= w; ++k) {
            //     if (dp[i][k] == 0) {
            //         break;
            //     }
            //     mn = min(mn, dp[i][k]);
            //     sum += mn;
            // }
            ans = max(ans, dp1[j]);
        }
    }
    cout << ans;
    // fens.resize(h + 1, vector<int>(w + 1));
    // for (int i = 0; i < h; ++i) {
    //     int l = 0, r = 0;
    //     for (; r < w; ++r) {
    //
    //     }
    // }

}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}