#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <queue>
#include <set>
#include <map>

using namespace std;
using ll = long long;
const int SZ = 3e5 + 100;

int n, d;
vector<int> g[SZ];
vector<pair<int, int>> ans;
int cnt0[SZ];
int cnt1[SZ];
int cnt2[SZ];
int rnk[SZ];

int dfs(int v, int p = -1) {
	cnt0[v] = cnt1[v] = cnt2[v] = 0;
	cnt0[v]++;
	int ans = 0;
	bool tf = 0;
	for (auto u : g[v]) {
		if (u == p)
			continue;
		rnk[u] = rnk[v] + 1;
		ans += dfs(u, v);
		cnt1[v] += cnt0[u];
		cnt2[v] += cnt1[u];
		tf |= (cnt2[u] > 0);
	}

	int k = min(cnt1[v], cnt2[v]);
	ans += k;
	cnt1[v] -= k;
	cnt2[v] -= k;
	if (tf) {
		ans++;
		cnt0[v]--;
	}
	else if (cnt1[v] > 0) {
		ans++;
		cnt0[v]--;
		cnt1[v]--;
	}
	return ans;
}

void solve() {
	cin >> n >> d;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	rnk[1] = 0;
	cout << dfs(1) << endl << -1;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	solve();
}