#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
#ifdef _DEBUG
typedef long long ll;
#else
typedef __int128 ll;
decltype(cin)& operator>>(decltype(cin)& in, ll& x) {
	long long f;
	in >> f;
	x = f;
	return in;
}

decltype(cout)& operator<<(decltype(cout)& out, ll x) {
	long long f = x;
	out << f;
	return out;
}
#endif

const int maxn = 3e5 + 1;
ll x[maxn], ps[maxn], pd[maxn], sx[maxn];
ll x0, d, n, m, t, id;

ll f(ll x) {
	x -= x0;
	x %= d;
	x += d;
	return min((x % d) * (x % d), (d - x % d) * (d - x % d));
}

ll h(ll mr, ll ml) {
	ll lx = x0 - d * ml;
	ll rx = x0 + d * mr;
	ll rs = 0;
	for (int i = 0; i < n; ++i) {
		if (x[i] >= lx && x[i] <= rx) {
			rs += f(x[i]);
		}
		else {
			rs += min((x[i] - lx) * (x[i] - lx), (x[i] - rx) * (x[i] - rx));
		}
	}
	rs += t * (ml + mr + min(ml, mr));
	return rs;
	/*
	ll i1 = lower_bound(x, x + n, x0 - d * ml + d) - x;
	i1 = min(i1, id);
	ll i2 = upper_bound(x, x + n, x0 + d * mr) - x;
	i2 = max(i2, id);
	ll rs = (ml + mr + min(ml, mr)) * t;
	rs += pd[i2] - pd[i1];
	rs += i1 * lx * lx - 2 * lx * ps[i1] + sx[i1];
	rs += (n - i2) * rx * rx - 2 * rx * (ps[n] - ps[i2]) + sx[n] - sx[i2];
	return rs;
	*/
}

ll g(ll mx) {
	ll mn = 1e18;
	mn *= mn;
	for (int i = 0; i < x0 / d + 2; ++i) {
		mn = min(mn, h(mx, i));
	}
	return mn;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}
	cin >> x0 >> d >> m;
	sort(x, x + n);
	for (int i = 0; i < n; ++i) {
		ps[i + 1] = ps[i] + x[i];
		pd[i + 1] = pd[i] + f(x[i]);
		sx[i + 1] = sx[i] + x[i] * x[i];
	}
	id = lower_bound(x, x + n, x0) - x;
	while (m--) {
		cin >> t;
		ll mn = 1e18;
		mn *= mn;
		for (int i = 0; i < max((ll)0, (x[n - 1] - x0) / d) + 2; ++i) {
			mn = min(mn, g(i));
		}
		cout << mn << '\n';
		continue;
		ll lt = 0, rt = (1e9 - x0) / d + 1;
		while (rt - lt > 2) {
			ll l = (lt * 2 + rt) / 3, r = (lt + 2 * rt) / 3;
			if (g(l) > g(r)) {
				lt = l;
			}
			else {
				rt = r;
			}
		}
		cout << min({ g(lt), g((lt + rt) / 2), g(rt) }) << '\n';
	}

	return 0;
}