#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef __int128 ll;

const int maxn = 3e5 + 1;
ll x[maxn], ps[maxn], pd[maxn], sx[maxn];
ll x0, d, n, m, t;

ll f(ll x, ll x0, ll d) {
	x -= x0;
	x %= d;
	x += d;
	return min((x % d) * (x % d), (d - x % d) * (d - x % d));
}

decltype(cin)& operator>>(decltype(cin)& in, ll& x) {
	long long f;
	in >> f;
	x = f;
	return in;
}

decltype(cout)& operator<<(decltype(cout)& out, ll x) {
	long long f = x;
	out << f;
	return out;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}
	cin >> x0 >> d >> m;
	sort(x, x + n);
	for (int i = 0; i < n; ++i) {
		ps[i + 1] = ps[i] + x[i];
		pd[i + 1] = pd[i] + f(x[i], x0, d);
		sx[i + 1] = sx[i] + x[i] * x[i];
	}
	while (m--) {
		cin >> t;
		cout << pd[n] << '\n';
	}

	return 0;
}