#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

const int maxn = 3e5;
vector<int> g[maxn];
int c[maxn];

void dfs(int v, int p = -1) {
	for (auto u : g[v]) {
		if (u != p) {
			c[u] = 1 - c[v];
			dfs(u, v);
		}
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, d;
	cin >> n >> d;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0);
	vector<int> a, b;
	for (int i = 0; i < n; ++i) {
		if (c[i] == 0) {
			a.push_back(i);
		}
		else {
			b.push_back(i);
		}
	}
	cout << min(a.size(), b.size()) << '\n';
	for (int i = 0; i < min(a.size(), b.size()); ++i) {
		cout << a[i] + 1 << ' ' << b[i] + 1 << '\n';
	}

	return 0;
}
