#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<int>> g(h, vector<int>(w));
    vector<vector<int>> up(h + 1, vector<int>(w + 1, 0));
    vector<vector<int>> left(h + 1, vector<int>(w + 2, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char a;
            cin >> a;
            g[i][j] = a - '0';
            if (g[i][j] == 0)
                continue;
            up[i + 1][j + 1] = up[i][j + 1] + 1;
        }
    }
    for (int i = 0; i < h; i++) {
        for (int j = w - 1; j >= 0; j--) {
            if (g[i][j] == 0)
                continue;
            left[i + 1][j + 1] = left[i + 1][j + 2] + 1;
        }
    }
    vector<vector<int>> dp(h + 1, vector<int>(w + 1, 0));
    int ans = 0;
    for (int i = 1; i <= h; i++) {
        for (int j = w; j >= 1; j--) {
            if (g[i - 1][j - 1] == 0)
                continue;
            if (j == w || up[i][j] < up[i][j + 1]) {
                if (left[i][j] < left[i - 1][j]) {
                    int cur = INF;
                    if (left[i][j] < up[i][j]) {
                    for (int x = 0; x < left[i][j]; x++) {
                        cur = min(cur, up[i][j + x]);
                        if (cur == 1) {
                            dp[i][j] += (left[i][j] - x);
                            break;
                        }
                        dp[i][j] += cur;
                    }
                    } else {
                    for (int x = 0; x < up[i][j]; x++) {
                        cur = min(cur, left[i - x][j]);
                        if (cur == 1) {
                            dp[i][j] += (up[i][j] - x);
                            break;
                        }
                        dp[i][j] += cur;
                    }
                    }
                } else {
                    dp[i][j] = dp[i - 1][j] + left[i][j];
                }
            } else {
                dp[i][j] = dp[i][j + 1] + up[i][j];
            }
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
    return 0;
}
