#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#pragma optimize("unroll-loops")

struct t {
    ll upd = -1 , sum = 0, max = -1e10;
};

void push(ll i, ll l, ll r, vector<t>& tree) {
    if (tree[i].upd == -1) {
        return;
    }
    ll d = tree[i].upd;
    ll m = (l + r) / 2;
    tree[2 * i + 1].upd = d;
    tree[2 * i + 2].upd = d;
    tree[2 * i + 1].sum = d * (m - l);
    tree[2 * i + 2].sum = d *(r - m);
    tree[2 * i + 1].max = d;
    tree[2 * i + 2].max = d;
    tree[i].upd = -1;
}

void upd1(ll i , ll l, ll r, ll qi, ll x, vector<t>& tree) {
    if (r - l == 1) {
        tree[i] = {x, x, x};
        return;
    }
    push(i, l, r, tree);
    ll m = (l + r) / 2;
    if (qi < m) {
        upd1(2 * i + 1, l, m, qi, x, tree);
    } else {
        upd1(2 * i + 2, m, r, qi, x, tree);
    }
    tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
    tree[i].max = max(tree[2 * i + 1].max, tree[2 * i + 2].max);
}

void upd2(ll i, ll l, ll r, ll ql, ll qr, ll x, vector<t>& tree) {
    if (ql >= r || l >= qr) {
        return;
    }
    if (tree[i].max <= x) {
        return;
    }
    if (l >= ql && r <= qr && tree[i].upd != -1) {
        tree[i].upd = x;
        tree[i].max = x;
        tree[i].sum = x * (r - l);
        return;
    }
    push(i, l, r, tree);
    ll m = (l + r) / 2;
    upd2(2 * i + 1, l, m, ql, qr, x, tree);
    upd2(2 * i + 2, m, r, ql, qr, x, tree);
    tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
    tree[i].max = max(tree[2 * i + 1].max, tree[2 * i + 2].max);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<bool>> ls;
    if (n > m) {
        ls.resize(m, vector<bool>(n));
        for (ll i = 0; i < n; i++) {
            string s;
            cin >> s;
            for (ll j = 0; j < m; j++) {
                ls[m - j - 1][n - i - 1] = (s[j] == '1');
            }
        }
        swap(n, m);
    } else {
        ls.resize(n, vector<bool>(m));
        for (ll i = 0; i < n; i++) {
            string s;
            cin >> s;
            for (ll j = 0; j < m; j++) {
                ls[i][j] = (s[j] == '1');
            }
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, 0));
    for (ll i = 0; i < n; i++) {
        if (ls[i][m - 1]) {
            dp[i][m - 1] = 1;
        }
        for (ll j = m - 2; j > -1; j--) {
            if (ls[i][j]) {
                dp[i][j] = dp[i][j + 1] + 1;
            }
        }
    }
    ll ansq = 0;
    for (ll i = m - 1; i > -1; i--) {
        ll j = n - 1;
        while (j >= 0 && !ls[j][i]) {
            j--;
        }
        while (j >= 0 && ls[j][i]) {
            ll y = j;
            while (y >= 0 && ls[y][i]) {
                y--;
            }
            y++;
            ll res = 0;
            vector<t> tree(4 * n, {-1, 0});
            vector<ll> took(n, 0);
            for (ll e = y; e <= j; e++) {
                upd1(0, 0, n, e, dp[e][i], tree);
                upd2(0, 0, n, 0, e, dp[e][i], tree);
                res = tree[0].sum;
                ansq = max(ansq, res);
            }
            j = y - 1;
            while (j >= 0 && !ls[j][i]) {
                j--;
            }
        }
    }
    cout << ansq;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}