#include <bits/stdc++.h>
#include <cmath>

using namespace std;

mt19937 rnd(time(0));

//#define int long long
#define endl '\n'

const int maxn = 5e5 + 5;
vector <int> g[maxn], G[maxn];
vector <int> lft;
int mate[maxn], clr[maxn];
int n, d, cur = 0;


void paint(int v, bool f, int r) {
    if (f) lft.push_back(v);
    for (auto u : g[v]) {
        if (u == r) continue;
        paint(u, !f, v);
    }
}


void edge(int V, int v, int r, int h) {
    if (h > d) return;
    if (h % 2 == 1) G[V].push_back(v);
    for (auto u : g[v]) {
        if (u == r) continue;
        edge(V, u, v, h + 1);
    }
}


bool dfs(int v) {
    clr[v] = cur;
    for (auto u : G[v]) {
        if (mate[u] == 0) {
            mate[u] = v;
            return true;
        }
    }
    for (auto u : G[v]) {
        if (mate[u] == v) continue;
        if (clr[mate[u]] != cur && dfs(mate[u])) {
            mate[u] = v;
            return true;
        }
    }
    return false;
}


void solve() {
    cin >> n >> d;
    for (int i = 1; i <= n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    paint(1, true, 0);

    for (auto v : lft) edge(v, v, 0, 0);

    int ans = 0;
    for (auto v : lft) {
        cur++;
        if (dfs(v)) ans++;
    }
    cout << ans << endl;
    cout << -1;
    return;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}