#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}

struct f {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<f> q(k);
    for (int i = 0; i < k; ++i) {
        cin >> q[i].l >> q[i].m >> q[i].r;
    }
    vector<ll> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < n; ++i) {
        if (dp[i] != INF) {
            for (int j = 0; j < k; ++j) {
                if ( (dp[i] < q[j].l || q[j].m > i)) {
                    dp[q[j].r] = min(dp[q[j].r], q[j].m);
                }
            }
        }
    }
    if (dp[n] != INF) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
