#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

vector<int> x;
vector<int> pr;
vector<int> pr2;
vector<int> prsum;
int get(int v) {
    int l = -1;
    int r = x.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (x[m] <= v) {
            l = m;
        } else {
            r = m;
        }
    }
    int sum = 0;
    if (l != -1) {
        sum += pr[l];
    }
    if (r == x.size()) {
        return sum;
    }
    sum += pr2[x.size() - 1];
    if (l != -1) {
        sum -= pr2[l];
    }
    sum += ((int) x.size() - 1 - l) * v * v;
    sum += prsum[x.size() - 1] * v;
    if (l != -1) {
        sum -= prsum[l] * v;
    }
    return sum;
}

void solve() {
    int n;
    cin >> n;
    x.resize(n);
    pr.resize(n);
    pr2.resize(n);
    prsum.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i) {
        int u = min(x[i] % d, d - x[i] % d);
        pr[i] = u * u;
        if (i > 0) {
            pr[i] += pr[i - 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        pr2[i] += x[i] * x[i];
        if (i > 0) {
            pr2[i] += pr2[i - 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        prsum[i] += -2 * x[i];
        if (i > 0) {
            prsum[i] += prsum[i - 1];
        }
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int l = 0;
        int r = 2e9;
        while (r - l > 10) {
            int m = (l + r) / 2;
            int pr = -1;
            bool p = false;
            for (int i = m; i < min(m + 10, r); ++i) {
                int pos = i * d + x0;
                int de = get(pos) + abs(i) * t;
                if (pr == -1) {
                    pr = de;
                } else {
                    if (de > pr) {
                        r = i;
                        p = true;
                        break;
                    } else if (de < pr) {
                        l = m;
                        p = true;
                        break;
                    }
                }
            }
            if (!p) {
                r = m;
            }
        }
        int ans = -1;
        for (int i = l; i <= r; ++i) {
            int pos = i * d + x0;
            int de = abs(i) * t + get(pos);
            if (ans == -1) {
                ans = de;
            }
            ans = min(ans, de);
        }
        cout << ans << '\n';
    }
}
