#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

vector<vector<int> > g;
vector<vector<int> > g1;
vector<int> fir;
vector<int> sec;

void dfs(int v,int o,int pr) {
    if (o % 2 == 0) {
        fir.push_back(v);
    } else {
        sec.push_back(v);
    }
    for (auto to: g[v]) {
        if (to != pr) {
            dfs(to, o + 1, v);
        }
    }
}

int cur;
int c;

void dfs2(int v,int o,int pr) {
    if (o % 2 == 1 && o <= c) {
        g1[cur].push_back(v);
    }
    for (auto to: g[v]) {
        if (to != pr) {
            dfs2(to, o + 1, v);
        }
    }
}

vector<int> match;
int col = 1;
vector<int> us;

bool dfs(int v) {
    if (us[v] == col) {
        return false;
    }
    us[v] = col;
    for (auto to: g[v]) {
        if (match[to] == -1) {
            match[to] = v;
            return true;
        }
    }
    for (auto to: g[v]) {
        if (dfs(match[to])) {
            match[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    g1.resize(n);
    cin >> c;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0, -1);
    for (int i = 0; i < n; i++) {
        cur = i;
        dfs2(i, 0, -1);
    }
    swap(g, g1);
    match.resize(n, -1);
    us.resize(n);
    col = 1;
    for (int i = 0; i < fir.size(); ++i) {
        int v = fir[i];
        if (match[v] == -1) {
            if (dfs(v)) {
                col++;
            }
        }
    }
    cout << col - 1 << "\n";
    for (auto to: sec) {
        if (match[to] != -1) {
            cout << match[to] + 1 << " " << to + 1 << "\n";
        }
    }
}
