#include <bits/stdc++.h>
#define int long long
#define ll __int128

using namespace std;

void print(ll x) {
    if (!x) return;

    print(x / 10);
    cout << (int)(x % 10);
}

ll f(int x, int y) {
    ll val = x - y;
    return val * val;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    sort(a.begin(), a.end());

    int x0, d; cin >> x0 >> d;

    ll sm = 0;

    for (int el : a) {
        int k = (el - x0) / d;
        ll val = (el - x0 - k * d), best = val * val;

        for (int i = k - 1; i <= k + 1; ++i) {
            val = (el - x0 - i * d), best = min(best, val * val);
        }

        sm += best;
    }

    int m; cin >> m;
    while (m--) {
        int t; cin >> t;

        if (!t) {
            if (!sm) {
                cout << "0\n";
            } else {
                print(sm);
                cout << "\n";
            }

            continue;
        }

        int l = 0, r = abs((a[0] - x0) / d) + 1;
        while (r - l > 2) {
            int m1 = (l + r) / 2, m2 = m1 + 1;

            int ql = x0, qr = x0;
            if (a[0] < x0) {
                ql -= m1 * d;
            } else {
                qr += m1 * d;
            }

            ll ans1 = m1 * t, ans2 = m2 * t;

            if (ql <= a[0] && a[0] <= qr) {
                ans1 += sm;
            } else {
                ans1 += min(f(a[0], ql), f(a[0], qr));
            }

            ql = x0, qr = x0;
            if (a[0] < x0) {
                ql -= m2 * d;
            } else {
                qr += m2 * d;
            }

            if (ql <= a[0] && a[0] <= qr) {
                ans2 += sm;
            } else {
                ans2 += min(f(a[0], ql), f(a[0], qr));
            }

            if (ans1 > ans2) {
                l = m;
            } else {
                r = m;
            }
        }

        ll ans = -1;

        for (int m1 = l; m1 <= r; ++m1) {
            int ql = x0, qr = x0;
            if (a[0] < x0) {
                ql -= m1 * d;
            } else {
                qr += m1 * d;
            }

            ll ans1 = m1 * t;

            if (ql <= a[0] && a[0] <= qr) {
                ans1 += sm;
            } else {
                ans1 += min(f(a[0], ql), f(a[0], qr));
            }

            if (ans == -1 || ans1 < ans) {
                ans = ans1;
            }
        }


        if (!ans) {
            cout << "0\n";
        } else {
            print(ans);
            cout << "\n";
        }
    }
}