#include <bits/stdc++.h>
#define int long long
#define ll __int128

using namespace std;

void print(ll x) {
    if (!x) return;

    print(x / 10);
    cout << (int)(x % 10);
}

ll f(int x, int y) {
    ll val = x - y;
    return val * val;
}

const int N = 3 * 1e5 + 1;
int n;
vector<int> a;
ll best[N], pref[N], pref1[N], pref2[N];

ll func(int x, int y) {
    ll sm = 0;

    int l = lower_bound(a.begin(), a.end(), x) - a.begin();
    int r = upper_bound(a.begin(), a.end(), y) - a.begin() - 1;

    sm = pref[r + 1] - pref[l];

    ll val1 = x, val2 = y;

    sm += val1 * val1 * l + val2 * val2 * (n - r - 1);
    sm += pref2[n] + pref2[l] - pref2[r + 1];
    sm -= 2 * pref1[l] * val1;
    sm -= 2 * (pref1[n] - pref1[r + 1]) * val2;

    return sm;
}

int x0, d, t;

ll bup_pol(int m) {
    int l = 0, r = (x0 - a[0]) / d + 2;

    while (r - l > 2) {
        int m1 = (l + r) / 2, m2 = m1 + 1;

        ll res1 = func(x0 - m1 * d, x0 + m * d) + (m + m1 + min(m, m1)) * t;
        ll res2 = func(x0 - m2 * d, x0 + m * d) + (m + m2 + min(m, m2)) * t;

        if (res1 < res2) {
            r = m1;
        } else {
            l = m1;
        }
    }

    ll res = -1;
    for (int m1 = l; m1 <= r; ++m1) {
        ll res1 = func(x0 - m1 * d, x0 + m * d) + (m + m1 + min(m, m1)) * t;

        if (res == -1 || res1 < res) {
            res = res1;
        }
    }

    return res;
}

ll bul_otr(int m) {
    int l = 0, r = (a[n - 1] - x0) / d + 2;

    while (r - l > 2) {
        int m1 = (l + r) / 2, m2 = m1 + 1;

        ll res1 = func(x0 - m * d, x0 + m1 * d) + (m + m1 + min(m, m1)) * t;
        ll res2 = func(x0 - m * d, x0 + m2 * d) + (m + m2 + min(m, m2)) * t;

        if (res1 < res2) {
            r = m1;
        } else {
            l = m1;
        }
    }

    ll res = -1;
    for (int m1 = l; m1 <= r; ++m1) {
        ll res1 = func(x0 - m * d, x0 + m1 * d) + (m + m1 + min(m, m1)) * t;

        if (res == -1 || res1 < res) {
            res = res1;
        }
    }

    return res;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n;

    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    sort(a.begin(), a.end());

    pref1[0] = pref2[0] = 0;

    for  (int i = 0; i < n; ++i) {
        pref1[i + 1] = pref1[i] + a[i];
        pref2[i + 1] = pref2[i] + (ll)a[i] * (ll)a[i];
    }

    cin >> x0 >> d;

    ll sm = 0;

    for (int j = 0; j < n; ++j) {
        int el = a[j], k = (el - x0) / d;
        ll val = (el - x0 - k * d);
        best[j] = val * val;

        for (int i = k - 1; i <= k + 1; ++i) {
            val = (el - x0 - i * d);
            best[j] = min(best[j], val * val);
        }

        sm += best[j];
    }

    pref[0] = 0;
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + best[i];
    }

    int m; cin >> m;
    while (m--) {
        cin >> t;
        ll ans = -1;

        if (!t) {
            if (!sm) {
                cout << "0\n";
            } else {
                print(sm);
                cout << "\n";
            }

            continue;
        }

        if (x0 <= a[0] || x0 >= a[n - 1]) {
            int l = 0, r = max(x0 - a[0], a[n - 1] - x0) / d + 2;

            while (r - l > 2) {
                int m1 = (l + r) / 2, m2 = m1 + 1;

                ll res1 = m1 * t, res2 = m2 * t, ql = x0, qr = x0;

                if (x0 <= a[0]) {
                    qr += m1 * d;
                } else {
                    ql -= m1 * d;
                }

                res1 += func(ql, qr);

                if (x0 <= a[0]) {
                    qr += d;
                } else {
                    ql -= d;
                }

                res2 += func(ql, qr);

                if (res1 < res2) {
                    r = m1;
                } else {
                    l = m1;
                }
            }

            for (int m1 = l; m1 <= r; ++m1) {
                ll res1 = m1 * t, ql = x0, qr = x0;

                if (x0 <= a[0]) {
                    qr += m1 * d;
                } else {
                    ql -= m1 * d;
                }

                res1 += func(ql, qr);

                if (ans == -1 || res1 < ans) {
                    ans = res1;
                }
            }

            if (!ans) {
                cout << "0\n";
            } else {
                print(ans);
                cout << "\n";
            }

            continue;
        }

        int l = 0, r = (a[n - 1] - x0) / d + 2;
        while (r - l > 2) {
            int m1 = (l + r) / 2, m2 = m1 + 1;

            ll res1 = bup_pol(m1), res2 = bup_pol(m2);

            if (res1 < res2) {
                r = m1;
            } else {
                l = m1;
            }
        }

        for (int m1 = l; m1 <= r; ++m1) {
            ll res1 = bup_pol(m1);

            if (ans == -1 || res1 < ans) {
                ans = res1;
            }
        }

        if (!ans) {
            cout << "0\n";
        } else {
            print(ans);
            cout << "\n";
        }
    }
}