#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

long long d, x0;
long long y;

long long znach(long long k, long long t) {
	return (k * d + x0 - y) * (k * d + x0 - y) + k * t;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	cin >> x0 >> d;
	y = v[0];
	long long m;
	cin >> m;
	for (int gh = 0; gh < m; gh++) {
		long long t;
		cin >> t;
		long long l = -3e11, r = 3e11;
		while (l + 2 < r) {
			long long lm = l + (r - l) / 3;
			long long rm = r - (r - l) / 3;
			if (znach(lm, t) < znach(rm, t)) {
				r = rm;
			}
			else {
				l = lm;
			}
		}
		cout << min({ znach(l, t), znach(r, t), znach(l + 1, t) }) << '\n';
	}
}