#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout<<#x<<" = "<<x<<endl;
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

struct Tree {
    vector<vector<int>> g;
    int n;
    vector<bool> t;
    vector<int> sz;

    struct S {
        vector<int> a;
        int b;
    };

    // void dcmp(int i, int p) {
    //     int ind = 0;
    //     for (int u : g[i]) {
    //         if (i == p) {
    //             g[i].erase(g[i].begin() + ind);
    //             break;
    //         } 
    //         ind++;
    //     }

    //     int mxi = 0;

    //     for (int ind = 0; ind < g[i].size(); ++ind) {
    //         int u = g[i][ind];
            
    //         dcmp(u, i);
    //         sz[i] += sz[u];
    //         if (sz[g[i][mxi]] < sz[u]) {
    //             mxi = ind;
    //         }
    //     }

    //     if (g[i].size()) {
    //         swap(g[i][0], g[i][ind]);
    //     }
    // }


    S dfs(int i, int p) {
        vector<int> a;
        S res;
        res.b = -1;
        int b = -1;
        for (int u : g[i]) {
            if (u == p) continue;
            S s = dfs(u, i);
            for (int i : s.a) a.push_back(i);
            if (b == -1) {
                b = s.b; 
            }
        }

        if (b != -1) {
            t[i] = 1;
            ps.push_back({b, i});
        }

        for (int u : g[i]) {
            if (u == p) continue;
            if (!t[u]) {
                if (a.size()) {
                    t[u] = 1;
                    t[a.back()] = 1;
                    ps.push_back({a.back(), u});
                    a.pop_back();
                } else if (!t[i]) {
                    t[i] = 1;
                    t[u] = 1;
                    ps.push_back({i, u});
                } else {
                    res.a.push_back(u);
                }
            }
        }

        if (a.size()) {
            res.b = a.back();
        }

        return res;
    }

    vector<pair<int, int>> ps;
    Tree(vector<vector<int>> g_): g(g_) {
        n = g.size();
        t.assign(n, 0);
        sz.assign(n, 1);
        set<pair<int, int>> st;
        dfs(0, 0);

        cout << ps.size() << '\n';
        for (auto [a, b] : ps) {
            cout << a + 1 << " " << b + 1 << '\n';
        }
    }
};

void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    Tree tr(g);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
    }
}