#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout<<#x<<" = "<<x<<endl;
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using S = vector<vector<int>>;

int d;

struct Tree {
    vector<vector<int>> g;
    int n;
    vector<bool> t;
    vector<int> sz;

    // struct S {
    //     vector<int> a;
    //     int b;
    // };

    // void dcmp(int i, int p) {
    //     int ind = 0;
    //     for (int u : g[i]) {
    //         if (i == p) {
    //             g[i].erase(g[i].begin() + ind);
    //             break;
    //         } 
    //         ind++;
    //     }

    //     int mxi = 0;

    //     for (int ind = 0; ind < g[i].size(); ++ind) {
    //         int u = g[i][ind];
            
    //         dcmp(u, i);
    //         sz[i] += sz[u];
    //         if (sz[g[i][mxi]] < sz[u]) {
    //             mxi = ind;
    //         }
    //     }

    //     if (g[i].size()) {
    //         swap(g[i][0], g[i][ind]);
    //     }
    // }


    S dfs(int v, int p) {
        vector<int> a;
        S res(d);

        S nw(d);
        int b = -1;
        for (int u : g[v]) {
            if (u == p) continue;
            S s = dfs(u, v);
            for (int i = 0; i < d; ++ i) {
                for (int x : s[i]) {
                    nw[i].push_back(x);
                }
            }
        }

        for (int i = d - 1; i >= 0; --i) {
            for (int j = d - (i + 1) - 1; nw[i].size() && j >= -1; j--) {
                if (((i + j) & 1) == 0) continue;
                if (j == -1) {
                    if (!t[v]) {
                        t[v] = 1;
                        ps.push_back({v, nw[i].back()});
                        nw[i].pop_back();
                    }
                    continue;
                }
                while (nw[i].size() && nw[j].size()) {
                    ps.push_back({nw[i].back(), nw[j].back()});
                    nw[i].pop_back();
                    nw[j].pop_back();
                }
            }
        }

        for (int i = 1; i < d; ++i) {
            res[i] = nw[i - 1];
        }
        if (!t[v]) {
            res[0].push_back(v);
        }

        return res;
    }

    vector<pair<int, int>> ps;
    Tree(vector<vector<int>> g_): g(g_) {
        n = g.size();
        t.assign(n, 0);
        sz.assign(n, 1);
        set<pair<int, int>> st;
        dfs(0, 0);

        cout << ps.size() << '\n';
        for (auto [a, b] : ps) {
            cout << a + 1 << " " << b + 1 << '\n';
        }
    }
};

void solve() {
    int n;
    cin >> n >> d;
    vector<vector<int>> g(n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    Tree tr(g);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
    }
}