#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;


int main() {

    int h, w; cin >> h >> w;
    vector<vector<bool>> a(h, vector<bool>(w, false));
    char x;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> x;
            if (x == '1') a[i][j] = true;
        }
    }
    vector<vector<int>> b(h, vector<int>(w, 0));
    for (int i = 0; i < w; i++) {
        b[0][i] = (a[0][i]?1:0);
    }
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (!a[i][j]) continue;
            b[i][j] = b[i - 1][j] + 1;
        }
    }
    int ans = 0;
    for (int i = 0; i < h; i++) {
        int prev = -1, cur = 0;
        for (int j = 0; j < w; j++) {
            prev = 1000000000;
            cur = 0;
            for (int k = j; k < w; k++) {
                if (prev == 0) break;
                cur += min(b[i][k], prev);
                prev = b[i][k];
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << endl;

    return 0;
}