#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

struct  pers {
    int l, m, r;
};

int n, k;
vector<pers> a;
vector<vector<bool>> gr;
vector<vector<int>> gr2;

vector<bool> used;
vector<int> pole;


bool dfs(int v) {
    used[v] = true;
    int colvo = 0;
    pole[a[v].l]++;
    if (a[v].r + 1 < n) pole[a[v].r + 1]--;
    for (int u : gr2[v]) {
        if (used[u]) continue;
        colvo++;
        if (dfs(u)) return true;
    }
    if (colvo == 0) {
        bool ans = true;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += pole[i];
            if (cnt <= 0) {ans = false; break;}
        }
        if (ans) return true;
    }
    pole[a[v].l]--;
    if (a[v].r + 1 < n) pole[a[v].r + 1]++;
    return false;
}

 
int main() {
 
    int q, q1, q2, q3; cin >> q;

    for (int qr = 0; qr < q; qr++) {
        cin >> n >> k;
        gr.assign(n, vector<bool>(n, true));
        gr2.assign(n, vector<int>());
        a.resize(0);

        for (int i = 0; i < k; i++) {
            cin >> q1 >> q2 >> q3;
            q1--, q2--, q3--;
            a.push_back(pers{q1, q2, q3});
        }

        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if (a[i].l <= a[j].m && a[j].m <= a[i].r) {
                    gr[i][j] = false;
                }
            }
        }
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if (gr[i][j]) gr2[i].push_back(j);
            }
        }
        bool totans = false;
        for (int ver = 0; ver < k; ver++) {
            used.assign(n, false);
            pole.assign(n, 0);
            if (dfs(ver)) totans = true;
        }
        if (totans) cout << "YES" << endl;
        else cout << "NO" << endl;
    }
 
    return 0;
}