#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
vector<vector<int>> arr;
bool* visited;
bool dfs(int k) {
	if (k == n-1) return true;
	if (visited[k]) return false;
	visited[k] = true;
	if (arr[k].size() > 0) {
		for (int i = 0; i < arr[k].size(); i++)
			if (dfs(arr[k][i])) return true;
	}
	return false;
}
int main() {
	int t;
	cin >> t;
	int k, l, m, r;
	for (int i = 0; i < t; i++)
	{
		cin >> n >> k;
		n += 1;
		arr = {};
		visited = new bool[n];
		for (int j = 0; j < n; j++) {
			arr.push_back({});
			visited[j] = false;
		}
		for (int j = 0; j < k; j++)
		{
			cin >> l >> m >> r;
			l -= 1; m -= 1; r -= 1;
			arr[l].push_back(r+1);
		}
		if (dfs(0)) cout << "YES";
		else cout << "NO";
		
	}
}