#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
struct seg {
    int x, t;
};
bool operator <(seg a, seg b) {
    if (a.x == b.x) return a.t > b.t;
    return a.x < b.x;
}
int l[10002], r[10002], m[10002], p[10002];
seg a[1000002];
bool mark[502];
bool all(int n, int k) {
    for (int i = 0; i < k; ++i) {
        a[2 * i].x = l[i];
        a[2 * i].t = 1;
        a[2 * i + 1].x = r[i];
        a[2 * i + 1].x++;
        a[2 * i + 1].t = -1;
    }
    sort(a, a + k * 2);
    int bal = 0;
    if (a[0].x != 1) {
        return false;
    }
    for (int i = 0; i < k * 2; ++i) {
        bal += a[i].t;
        if (bal == 0 && a[i].x != n + 1) {
            return false;
        }
    }
    return true;
}
vector<vector<int>>g;
int vis[10002];
bool ans = true;
void dfs(int u) {
    vis[u] = 1;
    for (auto v : g[u]) {
        if (vis[v] == 1) {
            ans = false;
        }
        if (vis[v] == 0) {
            dfs(v);
        }
    }
    vis[u] = 2;
}
void solve2() {
    int n, k;
    cin >> n >> k;
    g.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i != j && l[i] <= m[j] && m[j] <= r[i]) {
                g[j].push_back(i);
                //cout << "!" << j << ' ' << i << endl;
            }
        }
    }
    fill(vis, vis + k, 0);
    ans = true;
    for (int i = 0; i < k; ++i) {
        if (!vis[i]) dfs(i);
    }
    if (ans && all(n, k)) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}
int main()
{
    #ifdef LOCAL
    freopen("input", "r", stdin);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve2();
    }
    return 0;
}
