#include <iostream>
#include <algorithm>
using namespace std;
struct seg {
    int x, t;
};
bool operator <(seg a, seg b) {
    if (a.x == b.x) return a.t > b.t;
    return a.x < b.x;
}
int l[502], r[502], m[502], p[502];
seg a[1000002];
bool mark[502];
void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        r[i]--;
        p[i] = i;
    }
    do {
        fill(mark, mark + n, 0);
        for (int pos = 0; pos < k; ++pos) {
            int i = p[pos];
            if (mark[m[i]]) {
                continue;
            }
            for (int j = l[i]; j <= r[i]; ++j) {
                mark[j] = 1;
            }
        }
        //cout << "*" << p[0] << endl;
        bool f = true;
        for (int i = 0; i < n; ++i) {
            //cout << mark[i];
            if (!mark[i]) {
                f = false;
                //break;
            }
        }
        //cout << endl;
        if (f) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(p, p + k));
    cout << "NO\n";
}
int main()
{
    freopen("input", "r", stdin);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
