#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define int long long

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    vector<vector<int>> dp(h, vector<int> (w, 0));
    vector<vector<int>> dpl(h, vector<int> (w, 0));
    vector<vector<int>> dpg(h, vector<int> (w, 0)), dpv(h, vector<int> (w, 0));
    for (int i = 0; i < h; i++) {
        cin >> a[i];
    }
    for (int i = h - 1; i > -1; i--) {
        for (int j = w - 1; j > -1; j--) {
            if (a[i][j] == '1') {
                if (i == h - 1 && j == w - 1) {
                    dp[i][j] = 1;
                    dpv[i][j] = 1;
                    dpg[i][j] = 1;
                    dpl[i][j] = 1;
                }
                else if (i == h - 1) {
                    if (a[i][j + 1] == '1') {
                        dp[i][j] = dp[i][j + 1] + 1;
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dpl[i][j] = dpl[i][j + 1] + 1;
                        dpv[i][j] = 1;
                    }
                    else {
                        dp[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dpl[i][j] = 1;
                    }
                } else if (j == w - 1) {
                    if (a[i + 1][j] == '1') {
                        dp[i][j] = dp[i + 1][j] + 1;
                        dpv[i][j] = dpv[i][j + 1] + 1;
                        dpg[i][j] = 1;
                        dpl[i][j] = 1;
                    }
                    else {
                        dp[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dpl[i][j] = 1;
                    }
                } else {
                    if (a[i + 1][j] == '0' && a[i][j + 1] == '0') {
                        dp[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dpl[i][j] = 1;
                    } else if (a[i + 1][j] == '0') {
                        dp[i][j] = dpg[i][j + 1] + 1;
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dpl[i][j] = dpg[i][j + 1] + 1;
                        dpv[i][j] = 1;
                    } else if (a[i][j + 1] == '0') {
                        dp[i][j] = dp[i + 1][j] + 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = dpv[i + 1][j] + 1;
                        dpl[i][j] = 1;
                    } else {
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dpv[i][j] = dpv[i + 1][j] + 1;
                        dp[i][j] = dp[i + 1][j] + min(dpg[i][j], dpl[i + 1][j]);
                        dpl[i][j] = min(dpg[i][j], dpl[i + 1][j]);
                        if (dp[i][j] <= dpg[i + 1][j] + min(dpg[i + 1][j], dpg[i][j])) {
                            dp[i][j] = dpg[i + 1][j] + min(dpg[i + 1][j], dpg[i][j]);
                            dpl[i][j] = min(dpg[i + 1][j], dpg[i][j]);
                        }
                    }
                }
            }
        }
    }
    int res = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            res = max(res, dp[i][j]);
        }
    }
    cout << res << endl;
}