#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define int long long
struct seg {
    int l, r, m;
};

vector<pair<int, int>> segs;
vector<vector<int>> g;
vector<vector<int>> grev;
vector<int> tpsrt;
vector<bool> used;
vector<int> colors;

void dfs1(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u])
            dfs1(u);
    }
    tpsrt.emplace_back(v);
}

void dfs2(int v, int col) {
    colors[v] = col;
    for (auto u : grev[v]) {
        if (colors[u] == -1)
            dfs2(u, col);
    }
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.first < b.first || (a.first == b.first && a.second < b.second);
}

void solve() {
    int n, k;
    cin >> n >> k;
    segs.resize(k);
    vector<vector<int>> inds(n);
    for (int i = 0; i < k; i++) {
        int x;
        cin >> segs[i].first >> x >> segs[i].second;
        inds[segs[i].first - 1].emplace_back(i);
    }
    bool fl = true;
    vector<bool> dp(n, false);
    for (int i = 0; i < n; i++) {
        if (i == 0 || dp[i - 1]) {
            for (int j = 0; j < inds[i].size(); j++) {
                dp[i + segs[inds[i][j]].second - segs[inds[i][j]].first] = true;
            }
        }
    }
    if (dp[n - 1]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    segs.clear();
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}