// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>

using namespace std;

int n, k;
vector<vector<int>> g;
vector<int> topsort;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for(auto t : g[v]) {
        if(used[t]) continue;
        dfs(t);
    }
    topsort.push_back(v);
}

void solve() {
    cin >> n >> k;
    vector<array<int, 3>> arr(k);
    for(int i = 0; i < k; i++) {
        int l, r, t;
        cin >> l >> t >> r;
        l--; r--; t--;
        arr[i] = {l, r, t};
    }
    topsort.clear();
    used.assign(k, false);
    g.clear();
    g.resize(k);
    for(int i = 0; i < k; i++) {
        for(int j = 0; j < k; j++) {
            auto [l1, r1, t1] = arr[i];
            auto [l2, r2, t2] = arr[j];
            if(l1 <= t2 && t2 <= r1) g[i].push_back(j);
        }
    }
    for(int i = 0; i < k; i++) {
        if(used[i]) continue;
        dfs(i);
    }
    vector<int> ca(n, 1);
    for(auto ii : topsort) {
        auto [l, r, t] = arr[ii];
        if(ca[t] == 0) continue;
        for(int i = l; i <= r; i++) ca[i] = 0;
    }
    if(*max_element(ca.begin(), ca.end()) == 0) {
        cout << "YES\n";
        return;
    }
    cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
