#include <bits/stdc++.h>

using namespace std;

int n, k;
vector<array<int, 3>> arr;

int f(vector<int> pp) {
    vector<int> ca(n, 1);
    for(auto ii : pp) {
        auto [l, r, t] = arr[ii];
        if(ca[t] == 0) continue;
        for(int i = l; i <= r; i++) ca[i] = 0;
    }
    return count(ca.begin(), ca.end(), 1);
}

mt19937 rng(1248912);

float rnd() {
    return (float)rng() / rng.max();
}

bool tr(int a, int b, float t) {
    float p = exp((a - b) / t);
    return rnd() < p;
}

void solve() {
    cin >> n >> k;
    arr.resize(k);
    for(int i = 0; i < k; i++) {
        int l, r, t;
        cin >> l >> t >> r;
        l--; r--; t--;
        arr[i] = {l, r, t};
    }
    vector<int> pp(k);
    iota(pp.begin(), pp.end(), 0);
    int iters = 50000;
    int cans = f(pp);
    float t = 1.0f;
    while(cans > 0 && iters--) {
        t *= 0.99f;
        int i = rng() % k, j = rng() % k;
        swap(pp[i], pp[j]);
        int nans = f(pp);
        if(tr(cans, nans, t)) {
            cans = nans;
        } else {
            swap(pp[i], pp[j]);
        }
    }
    if(cans == 0) cout << "YES\n";
    else cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
