#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> arr(k);
    for(int i = 0; i < k; i++) {
        int l, r, t;
        cin >> l >> r >> t;
        l--; r--; t--;
        arr[i] = {l, r, t};
    }
    sort(arr.begin(), arr.end());
    do {
        vector<int> ca(n, 1);
        for(auto [l, r, t] : arr) {
            if(ca[t] == 0) continue;
            for(int i = l; i <= r; i++) ca[i] = 0;
        }
        if(*max_element(ca.begin(), ca.end()) == 0) {
            cout << "YES\n";
            return;
        }
    } while(next_permutation(arr.begin(), arr.end()));
    cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
