#include <bits/stdc++.h>

using namespace std;

int n, d;
vector<vector<int>> g;
vector<int> dd;

vector<vector<int>> g2;

void dfs(int v, int p) {
    for(auto t : g[v]) {
        if(t == p) continue;
        dd[t] = dd[v] + 1;
        dfs(t, v);
    }
}

void dfsM(int v, int p, int fr, int cd) {
    if(cd < 0) return;
    if((dd[v] & 1) != (dd[fr] & 1)) g2[fr].push_back(v);
    if(cd == 0) return;
    for(auto t : g[v]) {
        if(t == p) continue;
        dfsM(t, v, fr, cd - 1);
    }
}

vector<int> mt, used;
int timer = 0;

bool kuhn(int v) {
    if(used[v] == timer) return false;
    used[v] = timer;
    for(auto t : g2[v]) {
        if(mt[t] == -1 || (used[mt[t]] != timer && kuhn(mt[t]))) {
            mt[t] = v;
            return true;
        }
    }
    return false;
}

int main() {
    cin >> n >> d;
    g.resize(n);
    dd.resize(n);
    for(int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    g2.resize(n);
    dfs(0, -1);
    for(int i = 0; i < n; i++) dfsM(i, -1, i, d);
    mt.resize(n, -1);
    used.resize(n, -1);
    for(int i = 0; i < n; i++) {
        if(dd[i] & 1) continue;
        if(kuhn(i)) {
            timer++;
        }
    }
    vector<pair<int, int>> anss;
    for(int i = 0; i < n; i++) {
        if(!(dd[i] & 1)) continue;
        if(mt[i] == -1) continue;
        anss.push_back({i, mt[i]});
    }
    cout << anss.size() << '\n';
    for(auto [a, b] : anss) cout << a + 1 << ' ' << b + 1 << '\n';
}
