#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

// 10:30

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> l(k), m(k), r(k);
	for (int i = 0; i < k; ++i) {
		cin >> l[i] >> m[i] >> r[i];
	}
	vector<int> ord(k);
	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(), [&](int i, int j) -> bool {
		return l[i] > l[j] || (l[i] == l[j] && r[i] > r[j]);
	});
	vector<int> pref(n + 1);
	auto add = [&](int l, int r) -> void {
		pref[l]++;
		if (r + 1 <= n) {
			pref[r + 1]--;
		}
	};
	int last = n + 1;
	for (int i : ord) {
		if (last == l[i]) {
			continue;
		}
		add(l[i], r[i]);
		last = l[i];
	}
	for (int i = 1; i <= n; ++i) {
		pref[i] += pref[i - 1];
	}
	for (int i = 1; i <= n; ++i) {
		if (pref[i] == 0) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
