#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
  
using namespace std;
using ll = long long;
using ld = long double;

#define int long long

const int inf = (int)1e9 + 5;

// 260

struct Line {
	int k, l;
	int get(int x) {
		//cout << "TAKE " << k << ' ' << l << ' ' << x << endl;
		return k * x + l;
	}
	Line(int _k, int _l) {
		k = _k;
		l = _l;
	}
};

ld dot(const Line &a, const Line &b) {
	return ld(b.l - a.l) / (a.k - b.k);
}

bool operator <(const pair<ld, Line> &a, const pair<ld, Line> &b) {
	return a.first < b.first;
}

// min
struct CHT {
	vector<pair<ld, Line>> arr;
	void add(Line line) {
		if (arr.empty()) {
			arr.push_back(make_pair((ld)-inf, line));
			return;
		}
		if (arr.back().second.k == line.k) {
			return;
		}
		while ((int)arr.size() >= 2 && !(arr.back().first < dot(line, arr.back().second))) {
			arr.pop_back();
		}
		arr.push_back({dot(line, arr.back().second), line});
	}
	void build(vector<Line> lines) {
		arr.clear();
		sort(lines.begin(), lines.end(), [&](Line &a, Line &b) -> bool {
			if (a.k == b.k) {
				return a.l < b.l;
			}
			return a.k > b.k;
		});
		for (auto it : lines) {
			arr.push_back({0, it});
			continue;
			add(it);
		}
	}
	int get(int x) {
		ll temp = 1e18;
		for (auto it : arr) {
			temp = std::min(temp, it.second.get(x));
		}
		return temp;
		/*
		if (arr.empty()) return (int)1e18;
		auto it = *(--upper_bound(arr.begin(), arr.end(), make_pair((ld)x, Line(1, 0))));
		return it.second.get(x);*/
	}
};

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    /*
    CHT pp;
    vector<Line> tt;
    while (true) {
    	char type;
    	cin >> type;
    	if (type == '+') {
    		int k, l;
    		cin >> k >> l;
    		tt.push_back(Line(k, l));
    	} else {
    		int x;
    		cin >> x;
    		pp.build(tt);
    		cout << pp.get(x) << endl;
    	}
    }
    */

    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
    	cin >> x[i];
    }
    int s_pos, d;
    cin >> s_pos >> d;
    for (int i = 0; i < n; ++i) {
    	x[i] -= s_pos;
    }
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
    	cin >> t[i];
    }

    vector<int> left, right;
    for (int i = 0; i < n; ++i) {
    	if (x[i] == 0) continue;
    	if (x[i] < 0) {
    		left.push_back(-x[i]);
    	} else {
    		right.push_back(x[i]);
    	}
    }

    if (left.empty() && right.empty()) {
    	for (int q = 0; q < m; ++q) {
    		cout << 0 << '\n';
    	}
    	return 0;
    }

    if (right.empty()) {
		left.swap(right);
	}

    ll sum_l = 0, sum_r = 0;

    for (int i : left) {
    	sum_l += i * i;
    }

    for (int i : right) {
    	sum_r += i * i;
    }

    auto get = [&](int p) -> int {
    	if (p < 0) {
    		p = -p;
    	}
		ll temp = 1e18;
		int s = p;
        p = (p / d) * d;
        temp = std::min(temp, (s - p) * (s - p));
        p += d;
        temp = std::min(temp, (s - p) * (s - p));
        return temp;
	};

	sort(left.begin(), left.end());
	sort(right.begin(), right.end());

	int k = (int)right.size();

	vector<int> sq_sum(k), sum(k);

	for (int i = k - 1; i >= 0; --i) {
		sq_sum[i] += right[i] * right[i];
		sum[i] += right[i];
		if (i + 1 < k) {
			sq_sum[i] += sq_sum[i + 1];
			sum[i] += sum[i + 1];
		}
	}

	vector<int> pref(k);

	for (int i = 0; i < k; ++i) {
		pref[i] = get(right[i]);
		if (i > 0) {
			pref[i] += pref[i - 1];
		}
	}

	vector<Line> lines;

	int lim = *max_element(right.begin(), right.end());
	if (!left.empty()) lim = std::max(lim, *max_element(left.begin(), left.end()));
	if (lim % d) lim = (lim / d + 1) * d;

	int ptr = 0;

	for (int x = 0; x * d <= lim; x++) {
		ll sum_take = 0;
		while (ptr < (int)right.size() && right[ptr] <= x * d) ptr++;
		if (ptr > 0) {
			sum_take += pref[sum_take - 1];
		}
		sum_take += (k - ptr) * d * d * x * x;
		sum_take += sq_sum[ptr];
		sum_take -= 2 * d * x * sum[ptr];
		lines.push_back({Line(x, sum_take)});
	}

	CHT st;
	st.build(lines);

    for (int q = 0; q < m; ++q) {
    	cout << sum_l + st.get(t[q]) << '\n';
    }
}
