#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
using ll = long long;

void solve1(int n, int m)
{
    vector<string> a(n);
    for (auto &s : a)
        cin >> s;
    vector<vector<int>> d(n, vector<int>(m, 0));
    for (int i = 0; i < m; i++)
    {
        if (a[0][i] == '1')
            d[0][i] = 1;
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (a[i][j] == '0')
                continue;
            d[i][j] = d[i - 1][j] + 1;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            int prev = d[i][j];
            int curres = d[i][j];
            for (int k = j + 1; k < m; k++)
            {
                curres += min(prev, d[i][k]);
                prev = min(d[i][k], prev);
                if (prev == 0)
                    break;
            }
            ans = max(ans, curres);
        }
    }
    cout << ans << endl;
}

void solve2(int n, int m)
{
    vector<string> a(n);
    for (auto &s : a)
        cin >> s;
    vector<vector<int>> d(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
    {
        if (a[i][m-1] == '1')
            d[i][m-1] = 1;
    }
    for (int i = m - 2; i >= 0; i--)
    {
        for (int j = 0; j < n; j++)
        {
            if (a[j][i] == '0')
                continue;
            d[j][i] = d[j][i + 1] + 1;
        }
    }
    // for (int i = 0; i < n; i++)
    // {
    //     for (int j = 0; j < m; j++)
    //     {
    //         cout << d[i][j] << " ";
    //     }
    //     cout << endl;
    // }
    int ans = 0;
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (a[j][i] == '0')
                continue;
            int prev = d[j][i];
            int curres = d[j][i];
            for (int k = j - 1; k >= 0; k--)
            {
                curres += min(prev, d[k][i]);
                prev = min(d[k][i], prev);
                if (prev == 0)
                    break;
            }
            ans = max(ans, curres);
        }
    }
    cout << ans << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIMISHA
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    if (m < n)
    {
        solve1(n, m);
    }
    else
    {
        solve2(n, m);
    }
    return 0;
}