#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream &operator >> (istream &in, pair<T, T1> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T, typename T1>
ostream &operator << (ostream &in, pair<T, T1> &a) {
    in << a.ff << a.ss;
    return in;
}

template<typename T>
istream &operator >> (istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator << (ostream &in, vector<T> &a) {
    for (auto i : a) in << a << " ";
    return in;
}

void solve() {
    int n, k; cin >> n >> k;

    vector<vector<int>> sk;
    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r;
        r++;
        sk.pb({l, -1, m, r});
        sk.pb({r, 1, m});
    }
    sk.pb({1, 1, -1});
    sort(all(sk));

    multiset<int> m1, r1;
    r1.insert(1); m1.insert(-1);
    for (auto i : sk) {
        int g = i[0], t = i[1], m = i[2];

        if (t == -1) {
            auto c1 = r1.lower_bound(g);
            auto c2 = m1.lower_bound(g);

            if (sz(r1) > 0 && (( c1 != r1.end() && *c1 <= m) || c2 != m1.begin())) {
                m1.insert(m); r1.insert(i[3]);

                if (i[3] == n + 1) {
                    cout << "YES\n";
                    return;
                }
            }
        } else {
            if (r1.find(g) != r1.end()) {
                r1.erase(r1.find(g));
                if (m1.find(m) != m1.end()) m1.erase(m1.find(m));
            }
        }
    }
    cout << "NO\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}