#include <bits/stdc++.h>
using namespace std;
using ll = long long;
ll n, k, t, i, j, s[2000002], f[2000002], used[500002], bl;
pair<pair<ll, ll>, ll> a[500002];
vector<ll> gr[500002], srt;

void build(ll v, ll l, ll r) {
    s[v] = 0;
    f[v] = 0;
    if (l == r) {
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

void push(ll v) {
    if (f[v]) {
        f[v] = 0;
        s[v] = 1;
        f[2 * v] = 1;
        f[2 * v + 1] = 1;
    }
}

void upd(ll v, ll l, ll r, ll a, ll b) {
    if (l == a && r == b) {
        f[v] = 1;
        push(v);
        return;
    }
    push(v);
    ll m = (l + r) / 2;
    if (b <= m) {
        upd(2 * v, l, m, a, b);
    } else if (a > m) {
        upd(2 * v + 1, m + 1, r, a, b);
    } else {
        upd(2 * v, l, m, a, m);
        upd(2 * v + 1, m + 1, r, m + 1, b);
    }
    push(2 * v);
    push(2 * v + 1);
    s[v] = min(s[2 * v], s[2 * v + 1]);
}

ll get(ll v, ll l, ll r, ll p) {
    push(v);
    if (l == r) {
        return s[v];
    }
    ll m = (l + r) / 2;
    if (p <= m) {
        return get(2 * v, l, m, p);
    } else {
        return get(2 * v + 1, m + 1, r, p);
    }
}

ll cmp(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
    if (a.second >= b.first.first && a.second <= b.first.second) {
        return 1;
    } else if (b.second >= a.first.first && b.second <= a.first.second) {
        return 2;
    } else {
        return 0;
    }
}

void dfs(ll v) {
    used[v] = 1;
    for (auto u: gr[v]) {
        if (!used[u]) {
            dfs(u);
        } else if (used[u] == 1) {
            if (!bl) {
                cout << "NO\n";
                bl = 1;
            }
        }
    }
    used[v] = 2;
    srt.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> t;
    while (t--) {
        bl = 0;
        cin >> n >> k;
        for (i = 0; i < k; i++) {
            gr[i].clear();
            used[i] = 0;
            cin >> a[i].first.first >> a[i].second >> a[i].first.second;
        }
        for (i = 0; i < k; i++) {
            for (j = 0; j < k; j++) {
                if (i != j && cmp(a[i], a[j]) == 1) {
                    gr[i].push_back(j);
                }
            }
        }
        for (i = 0; i < k; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        if (bl) {
            continue;
        }
        reverse(srt.begin(), srt.end());
        build(1, 1, n);
        for (i = 0; i < k; i++) {
            if (get(1, 1, n, a[srt[i]].second) == 0) {
                upd(1, 1, n, a[srt[i]].first.first, a[srt[i]].first.second);
            }
        }
        push(1);
        if (s[1] == 0) {
            cout << "NO";
        } else {
            cout << "YES";
        }
        cout << '\n';
    }
    return 0;
}
