#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
#include <array>
using namespace std;

const int INF = 1000000000;

bool foo(array<int, 3> a, array<int, 3> b){
    return a[2] < b[2];
}


int main(){
    int t;
    cin >> t;
    while (t--){
        int n, k;
        cin >> n >> k;
        vector<vector<int>> g(k);
        // vector<int> l(k), m(k), r(k);
        vector<array<int, 3>> otr(k);
        for (int i = 0; i < k; i++){
            cin >> otr[i][0] >> otr[i][1] >> otr[i][2];
        }

        sort(otr.begin(), otr.end(), foo);

        vector<int> dp(k, INF);

        for (int i = 0; i < k; i++){
            if (otr[i][0] == 1){
                dp[i] = 0;
                continue;
            }
            
            for (int j = 0; j < i; j++){
                if (otr[j][0] < otr[i][0] && otr[j][2] >= otr[i][0] - 1){
                    if (!(otr[i][0] <= otr[j][1] && otr[j][1] <= otr[i][2] &&
                          otr[j][0] <= otr[i][1] && otr[i][1] <= otr[j][2])){
                        if (dp[j] < otr[i][0] - 1){
                            dp[i] = min(dp[i], otr[j][2]);
                        }
                    }
                }
            }
        }

        bool ans = false;

        for (int i = 0; i < k; i++){
            if (otr[i][2] == n && dp[i] != INF){
                ans = true;
                break;
            }
        }

        cout << (ans ? "YES" : "NO") << endl;
    }
}