#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
using namespace std;
 
bool dfs(int v, int p, vector<vector<int>>& g, vector<int>& used){
    if (used[v]) return false;
    used[v] = 1;
 
    for (auto u: g[v]){
        // if (u == p) continue;
        if (used[u] == 1) return true;
        if (used[u] == 2) continue;
        if (dfs(u, v, g, used)) return true;
    }

    used[v] = 2;
 
    return false;
}
 
int main(){
    int t;
    cin >> t;
    while (t--){
        int n, k;
        cin >> n >> k;
        vector<vector<int>> g(k);
        vector<vector<int>> line(n + 1);
        vector<int> l(k), m(k), r(k);
        for (int i = 0; i < k; i++){
            cin >> l[i] >> m[i] >> r[i];
            line[l[i] - 1].push_back(i + 1);
            line[r[i]].push_back(-i - 1);
        }
 
        unordered_set<int> st;
 
        for (int i = 0; i < k; i++){
            for (int j = 0; j < k; j++){
                if (i == j) continue;
                if (l[i] <= m[j] && m[j] <= r[i]){
                    g[i].push_back(j);
                    st.insert(j);
                }
            }
        }
 
        vector<int> used(k);
 
        bool ans = true;
 
        for (int i = 0; i < k; i++){
            if (dfs(i, -1, g, used)){
                ans = false;
                break;
            }
        }

        set<int> st1;
        for (int i = 0; i < n; i++){
            for (auto k: line[i]){
                if (k < 0) st1.erase(-k);
            }
            for (auto k: line[i]){
                if (k > 0) st1.insert(k);
            }
            if (st1.empty()) ans = false;
        }
 
        cout << (ans ? "YES" : "NO") << endl;

        // for (auto r: g){
        //     for (auto rr: r){
        //         cout << rr << ' ';
        //     }
        //     cout << endl;
        // }
    }
}