#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
using namespace std;

long long mod(long long x, long long m){
    return (x % m + m) % m;
}

int main(){
    int n; 
    cin >> n;
    vector<long long> x(n);
    for (int i = 0; i < n; i++){
        cin >> x[i];
    }

    long long x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--){
        int t;
        cin >> t;

        long long ans = 0;
        for (int i = 0; i < n; i++){
            long long y = min(mod(x[i] - x0, d), mod(-x[i] + x0, d));

            ans += y * y;
        }

        cout << ans << endl;
    }
}