#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
using namespace std;

int n;
vector<long long> x;
long long x0, d;

long long mod(long long x, long long m){
    return (x % m + m) % m;
}

long long fr(long long y){
    long long ans = 0;
    for (int i = 0; i < n; i++){
        if (x[i] < x0) continue;
        if (x[i] > x0 + d * y){
            ans += (x0 + d * y - x[i]) * (x0 + d * y - x[i]);
        }
        else{
            long long z = min(mod(x[i] - x0, d), mod(-x[i] + x0, d));
            ans += z * z;
        }
    }

    return ans;
}

long long fl(long long y){
    long long ans = 0;
    for (int i = 0; i < n; i++){
        if (x[i] > x0) continue;
        if (x[i] < x0 - d * y){
            ans += (x0 - d * y - x[i]) * (x0 - d * y - x[i]);
        }
        else{
            long long z = min(mod(x[i] - x0, d), mod(-x[i] + x0, d));
            ans += z * z;
        }
    }

    return ans;
}

int main(){
    cin >> n;
    x.resize(n);
    for (int i = 0; i < n; i++){
        cin >> x[i];
    }

    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--){
        int t;
        cin >> t;

        long long ans1 = 0;
        
        long long l = 0, r = 2500000000 / d + 1, m1, m2;
        while (r - l > 2){
            m1 = (l * 2 + r) / 3;
            m2 = (l + r * 2) / 3;
            if (fr(m1) + t * m1 * 2 < fr(m2) + t * m2 * 2){
                r = m2;
            }
            else{
                l = m1;
            }
        }

        m1 = (l + r) / 2;

        ans1 += min(min(fr(l) + t * l * 2, fr(r) + t * r * 2), fr(m1) + t * m1 * 2);

        l = 0; r = 2500000000 / d + 1;

        while (r - l > 2){
            m1 = (l * 2 + r) / 3;
            m2 = (l + r * 2) / 3;
            if (fl(m1) + t * m1 < fl(m2) + t * m2){
                r = m2;
            }
            else{
                l = m1;
            }
        }

        m1 = (l + r) / 2;

        ans1 += min(min(fl(l) + t * l, fl(r) + t * r), fl(m1) + t * m1);


        long long ans2 = 0;

        l = 0; r = 2500000000 / d + 1;
        while (r - l > 2){
            m1 = (l * 2 + r) / 3;
            m2 = (l + r * 2) / 3;
            if (fl(m1) + t * m1 * 2 < fl(m2) + t * m2 * 2){
                r = m2;
            }
            else{
                l = m1;
            }
        }

        m1 = (l + r) / 2;

        ans2 += min(min(fl(l) + t * l * 2, fl(r) + t * r * 2), fl(m1) + t * m1 * 2);
        // cout << ans2 << endl;

        
        l = 0; r = 2500000000 / d + 1;

        while (r - l > 2){
            m1 = (l * 2 + r) / 3;
            m2 = (l + r * 2) / 3;
            // cout << l << ' ' << m1 << ' ' << m2 << ' ' << r << endl;
            if (fr(m1) + t * m1 < fr(m2) + t * m2){
                r = m2;
            }
            else{
                l = m1;
            }
        }

        m1 = (l + r) / 2;

        ans2 += min(min(fr(l) + t * l, fr(r) + t * r), fr(m1) + t * m1);


        // cout << "ans: ";
        cout << min(ans1, ans2) << endl;
    }
}