#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#define f first
#define s second
#define pii pair<int, int>

//
//int solve(vector<vector<int>> &right, vector<string> &a, int h, int w, int k) {
//    int ans = 0;
//    for (int j = 0; j < w; ++j) {
//        int cur = 0;
//        int last = 0;
//        for (int i = h - 1; i >= 0; --i) {
//            if (a[i][j] == '1' && (i + 1 == h || a[i + 1][j] == '0'))
//                last = right[i][j];
//            if (a[i][j] == '0') {
//                ans = max(ans, cur);
//                cur = 0;
//            } else {
//                last = min(last, right[i][j]);
//                cur += last;
//                ans = max(ans, cur);
//            }
//        }
//    }
//    return ans;
//}


int solve(vector<vector<int>> &right, vector<string> &a, int h, int w) {
    int ans = 0;
    for (int j = 0; j < w; ++j) {
        int cur = 0;
        int last = 0;
        int gm = 0;
        vector<int> cnt(w + 1);
        for (int i = 0; i < h; ++i) {
            if (a[i][j] == '0') {
                for (int k = 0; k <= w; ++k) {
                    if (k > gm) break;
                    cnt[k] = 0;
                }
                cur = 0;
            } else {
                ans = max(ans, cur);
                int mx = right[i][j];
                gm = max(mx, gm);
                cur += mx;
                cnt[mx]++;
                for (int k = mx + 1; k <= w; ++k) {
                    if (k > gm) break;
                    cur -= (k - mx) * cnt[k];
                    cnt[mx] += cnt[k];
                    cnt[k] = 0;
                }
                ans = max(ans, cur);
            }
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (int i = 0; i < h; ++i) {
        cin >> a[i];
    }
    int ans = 0;
    vector<vector<int>> right(h, vector<int> (w));
    for (int i = 0; i < h; ++i) {
        int last = -1;
        for (int j = w - 1; j >= 0; --j) {
            if (last == -1 && a[i][j] == '1') {
                last = j;
            }
            if (a[i][j] == '0') {
                last = -1;
            }
            right[i][j] = max(last - j + 1, 0);
        }
    }
//    for (auto el : right) {
//        for (auto e : el)
//            cout << e << " ";
//        cout << endl;
//    }
    ans = solve(right, a, h, w);
//    for (int i = 0; i <= w; ++i) {
//        ans = max(ans, solve(right, a, h, w, i));
//    }
    cout << ans;
//    vector<vector<int>> pref(h, vector<int> (w + 1));
//    for (int i = 0; i < h; ++i) {
//        for (int j = 1; j <= w; ++j) {
//            pref[i][j] = pref[i][j - 1] + (a[i][j - 1] == '1');
//        }
//    }
//    for (int i = 0; i < h; ++i) {
//        for (int j = 0; j < w; ++j) {
//            int cur = 0;
//            int last = 0;
//            int j1 = j;
//            while (j1 < w && a[i][j1] == '1') {
//                ++j1;
//            }
//            last = j1 - j;
//            int i1 = i - 1;
//            cur += last;
//            while (i1 >= 0 && last > 0) {
//                while (j1 >= 0 && pref[i1][j1] - pref[i1][j] != (j1 - j)) {
//                    //cout << i1 << " " << j1 << endl;
//                    --j1;
//                }
//                last = max(j1 - j, 0);
//                cur += last;
//                --i1;
//            }
//            //cout << i << " " << j << " " << cur << endl;
//            ans = max(ans, cur);
//        }
//    }
//    cout << ans;
}

