#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#define f first
#define s second
#define pii pair<int, int>

vector<int> ts;

int tmr = 0;

void dfs(int v, vector<vector<int>> &g, vector<int> &up, vector<int> &tin, vector<int> &in_comp, vector<int> &buf, vector<int> &used) {
    up[v] = tin[v] = tmr++;
    buf.push_back(v);
    used[v]  =1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u, g, up, tin, in_comp, buf, used);
            up[v] = min(up[v], up[u]);
        }
        if (in_comp[u] == -1) {
            up[v] = min(up[v], tin[u]);
        }
    }
    if (up[v] == tin[v]) {
        while (buf.back() != v) {
            int u = buf.back();
            buf.pop_back();
            in_comp[u] = v;
        }
        in_comp[v] = v;
        buf.pop_back();
        ts.push_back(v);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        ts.clear();
        int n, k;
        cin >> n >> k;
        vector<vector<int>> a(k, vector<int> (3));
        for (int i = 0; i < k; ++i) {
            cin >> a[i][0] >> a[i][1] >> a[i][2];
        }
        vector<vector<int>> g(k);
        vector<int> up(k), used(k), tin(k), in_comp(k, -1), buf;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (i == j) continue;
                if (a[j][0] <= a[i][1] && a[i][1] <= a[j][2]) {
                    g[i].push_back(j);
                }
            }
        }
//        for (auto el : g) {
//            for (auto e : el)
//                cout << e << " ";
//            cout << endl;
//        }
        //exit(0);
        for (int i = 0; i < k; ++i) {
            if (!used[i])
                dfs(i, g, up, tin, in_comp, buf, used);
        }
        reverse(ts.begin(), ts.end());
//        for (auto el : ts)
//            cout << el << " ";
//        cout << endl;
        vector<int> colored(n + 1);
        //cout << colored.size() << endl;
        for (auto v : ts) {
            int cnt = 0;
            for (auto u : g[v]) {
                if (in_comp[u] == in_comp[v]) cnt++;
            }
            //cout << v << " " << cnt << endl;
            if (cnt == 0) {
                for (int i = a[v][0]; i <= a[v][2]; ++i) {
                    colored[i] = 1;
                }
            }
        }
        //exit(0);
        string ans = "YES";
        for (int i = 1; i <= n ;++i) {
            if (!colored[i]) ans = "NO";
        }
        cout << ans << "\n";
    }
}
