//#define _GLIBCXX_DEBUG
#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;
using ll = long long;
using ii = __int128;
using vll = vector<ll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvll = vector<vll>;
ll n1;
struct node{
int n;
ll m;
node() {
n = 0;
m = 0;
}
node(ll x, ll y) {
n = x;
m = y;
}
node(pll a) {
n = a.first;
m = a.first * a.second;
}
node operator +(node other) const {
return node(n + other.n, m + other.m);
}
};
vector<node> a((1 << 19) + 10, node());
vector<bool> is((1 << 19) + 10, 0);
void upd(ll i) {
is[i] = 1;
a[i] = node();
}
void push(ll i) {
if (!is[i]) {
    return;
}
is[i] = 0;
if (i >= n1) {
    return;
}
upd(i * 2);
upd(i * 2 + 1);
}
void clr(ll i, ll l, ll r, ll x, ll y) {
    if (x > y) {
        return;
    }
if (x <= l && r <= y) {
    upd(i);
    return;
}
if (y < l || r < x) {
    return;
}
push(i);
ll m = (r + l) / 2;
clr(i * 2, l, m, x, y);
clr(i * 2 + 1, m + 1, r, x, y);
a[i] = a[i * 2] + a[i * 2 + 1];
}
void upd_on_path(ll i) {
    if (i < n1) {
        a[i] = a[i * 2] + a[i * 2 + 1];
    }
    //cout << i << " " << a[i].n << " " << a[i].m << " " << is[i] << endl;
if (i != 1) {
    upd_on_path(i / 2);
}
}
void clr_on_path(ll i, ll l, ll r, ll t, node x) {
    //cout << i << " " << l << " " << r << " " << t << endl;
    push(i);
    if (i == t + n1) {
        a[i] = a[i] + x;
        return;
    }
    ll m = (r + l) / 2;
    if (t <= m) {
        clr_on_path(i * 2, l, m, t, x);
    } else {
        clr_on_path(i * 2 + 1, m + 1, r, t, x);
    }
    a[i] = a[i * 2] + a[i * 2 + 1];
}
void add_1(ll i, ll x) {
    auto o = node(x, i * x);
    clr_on_path(1, 0, n1 - 1, i, o);
}

node sum(ll i, ll l, ll r, ll x, ll y) {
    //cout << "         " << i << " " << l << " " << r << " " << x << " " << y << endl;
    if (x > y) {
        return node();
    }
if (x <= l && r <= y) {
    return a[i];
}
if (y < l || r < x) {
    return node();
}
ll m = (r + l) / 2;
push(i);
node al = sum(i * 2, l, m, x, y);
node ar = sum(i * 2 + 1, m + 1, r, x, y);
//cout << "    " << i << " " << al.m << " " << ar.m << "  " << al.m + ar.m << endl;
return al + ar;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vvll a(n, vll(m));
    vvll b(n, vll(m));
    for (int i = 0; i < n; ++i)
    {
        string s1;
        cin >> s1;
        ll l = 0;
        for (int j = m - 1; j >= 0; --j)
        {
            a[i][j] = s1[j] - '0';
            if (a[i][j] == 0) {
                l = 0;
                b[i][j] = l;
                continue;
            }
            l = l + 1;
            b[i][j] = l;
        }
    }
    ll ans = 0;
    n1 = (1 << ((ll) log2(m + 2) + 1));
    for (int j = 0; j < m; ++j) {
        clr(1, 0, n1 - 1, 0, n1 - 1);
        ll d = n1 - 1;
        for (int i = 0; i < n; ++i) {

                //cout << i << " " << j << endl;
            ll y = b[i][j];
            if (y == 0) {
                clr(1, 0, n1 - 1, 0, n1 - 1);
                d = n1 - 1;
                continue;
            }
            ll cnt = 1;
            //cout << 1 << endl;
            if (y < d) {
            auto c = sum(1, 0, n1 - 1, y + 1, d);
            clr(1, 0, n1 - 1, y + 1, d);
            //cout << 2 << endl;
            //cout << y << " " << c.n << " " << c.m << endl;
            cnt += c.n;
            //cout << 3 << endl;
            //cout << 2 << endl;
            }
            //cout << y << " " << cnt << endl;
            add_1(y, cnt);
            //cout << 4 << endl;
            d = y;
            auto s = sum(1, 0, n1 - 1, 0, d);
            //cout << i << " " << j << " " << d << " " << y << " " << cnt  << "  " << s.n << " " << s.m << endl;
            ans = max(ans, s.m);
        }
        //cout << endl << endl;
    }
    cout << ans;
    return 0;
}
