#include <bits/stdc++.h>

#define int long long

int min(int a, int b)
{
	if (a <= b)
		return a;
	else
		return b;
}

int max(int a, int b)
{
	if (a <= b)
		return b;
	else
		return a;
}

void build(std::vector< int >& t, std::vector< int >& a, int u, int l, int r)
{
	if (l == r)
	{
		t[u] = a[l];

		return;
	}

	build(t, a, 2 * u, l, (l + r) / 2);
	build(t, a, 2 * u + 1, (l + r) / 2 + 1, r);

	t[u] = t[2 * u] + t[2 * u + 1];
}

int get(std::vector< int >& t, int u, int l, int r, int L, int R)
{
	if (r < L || R < l)
		return LLONG_MAX;

	if (L <= l && r <= R)
		return t[u];

	return min(get(t, 2 * u, l, (l + r) / 2, L, R), get(t, 2 * u + 1, (l + r) / 2 + 1, r, L, R));
}


signed main()
{
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);

	int h, w, max_ans = 0;
	std::cin >> h >> w;

	char a;
	std::vector< std::vector< bool > > b(h, std::vector< bool >(w));
	std::vector< std::vector< int > > v(h, std::vector< int >(w, 0))
		, ans(h, std::vector< int >(w, 0));

	for (int i = 0; i < h; ++i)
		for (int j = 0; j < w; ++j)
			std::cin >> a, ((a == '1') ? (b[i][j] = true) : (b[i][j] = false));

	for (int i = 0; i < h; ++i)
		for (int j = 0; j < w; ++j)
			if (b[i][j])
				if (i == 0)
					v[i][j] = 1;
				else
					v[i][j] = v[i - 1][j] + 1;

	std::vector< std::vector< int > > t(h, std::vector< int >(4 * w));
	for (int i = 0; i < h; ++i)
		build(t[i], v[i], 1, 0, w - 1);

	for (int i = h - 1; i >= 0; --i)
		for (int j = w - 1; j >= 0; --j)
			if (j == w - 1)
				ans[i][j] = v[i][j], max_ans = max(max_ans, ans[i][j]);
			else
			{
				int l = j + 1, r = w;
				while (r - l > 1)
				{
					int m = (l + r) / 2;

					int x = min(v[i][m], get(t[i], 1, 0, w - 1, j + 1, m));
					if (x >= v[i][j])
						l = m;
					else
						r = m;
				}

				int ot = j;

				if (r != w && min(v[i][r], get(t[i], 1, 0, w - 1, j + 1, r)) >= v[i][j])
					ot = r;
				else if (min(v[i][l], get(t[i], 1, 0, w - 1, j + 1, l)) >= v[i][j])
					ot = l;
				else
					ot = j;

				ans[i][j] = ((ot + 1 == w) ? (0) : (ans[i][ot + 1])) + (ot - j + 1) * v[i][j];

				max_ans = max(max_ans, ans[i][j]);
			}

	std::cout << max_ans << '\n';

	return 0;
}
