#include "iostream"
#include "stack"
#include "vector"
#include "numeric"
#include "algorithm"
using namespace std;
//#pragma GCC optimize("O0")
#define all(arr) arr.begin(), arr.end()
struct person {
    int l, m, r;
};
int k, n;
bool can;
vector<person> personal;
auto person_r_cmp = [](const person& p1, const person& p2) { return (p1.r == p2.r ? p1.l < p2.l : p1.r < p2.r);};
void rec(int start, int prev, int last) {
    if (last == n) {
        can = true;
        return;
    }
    for (int i = start + 1; i < k; i++) {
        if (personal[i].r == last) continue;
        if (personal[i].l <= prev) continue;
        if (personal[i].l > last + 1) continue;
        if (personal[i].m > last || personal[start].m < personal[i].l) {
            rec(i, last + 1, personal[i].r);
            if (can) return;
        }
    }
}
void solve() {
    cin >> n >> k; can = false;
    personal.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> personal[i].l >> personal[i].m >> personal[i].r;
    }
    sort(all(personal), person_r_cmp);
    for (int i = 0; i < k; i++) {
        if (personal[i].l == 1) {
            rec(i, 1, personal[i].r);
            if (can) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; cin >> t;
    while (t--) {
        solve();
        personal.clear();
        can = false;
    }
    return 0;
}