#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct obj
{
    ll l, m, r;
};

bool operator<(obj x, obj y)
{
    //if (x.l != y.l) return x.l > y.l;
    return x.r > y.r;
}

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<obj> a(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].l >> a[i].m >> a[i].r;
        --a[i].l;
        --a[i].m;
        --a[i].r;
    }
    for (int i = 0; i < k; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            if (i == j) continue;
            int l1 = max(a[i].l, a[j].l);
            int r1 = min(a[i].r, a[j].r);
            if (l1 <= a[i].m && a[i].m <= r1 && l1 <= a[j].m && a[j].m <= r1)
            {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

