#include <bits/stdc++.h>
#define int int64_t
#pragma GCC optimize("O3,unroll-loops")
using namespace std;

const int N = 5e5 + 100;

vector<int> g[N];

int dp[N][2];
int id[N];

void dfs(int v, int p) {
    id[v] = -1;
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);

            dp[v][0] += max(dp[u][0], dp[u][1]);


            if (id[v] == -1 || dp[u][0] - max(dp[u][0], dp[u][1]) > dp[id[v]][0] - max(dp[id[v]][0], dp[id[v]][1])) {
                id[v] = u;
            }
        }
    }

    if (id[v] != -1) {
        dp[v][1] += dp[v][0];
        dp[v][1]++;
        dp[v][1] += dp[id[v]][0] - max(dp[id[v]][0], dp[id[v]][1]);
    }
}

vector<pair<int, int>> a;

void restore(int v, int p, bool fl) {
    if (fl) {
        a.push_back({v,id[v]});
        restore(id[v], v, false);
    }

    for (int u : g[v]) {
        if (fl && u == id[v]) {
            continue;
        }

        if (u != p) {
            if (dp[u][1] > dp[u][0])
                restore(u, v, true);
            else
                restore(u, v, false);
        }
    }
}

int d;

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int n; cin >> n >> d;
    for (int i = 1; i < n; i++) {
        int v, u; cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs(1,1);
    restore(1, 1, dp[1][1] > dp[1][0]);
    cout << max(dp[1][1], dp[1][0]) << '\n';
    

    for (auto [f,s] : a)
        cout << f <<  ' ' << s << '\n';
}