#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

struct T {
    int l, m, r;
};

bool operator<(T a, T b) {
    if (a.l != b.l) return a.l < b.l;
    if (a.r != b.r) return a.r < b.r;
    return a.m < b.m;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> A;
    int min_l = n + 1, max_r = -1;
    while (k--) {
        int l, m, r;
        cin >> l >> m >> r;
        A.push_back({l, 1});
        A.push_back({r, -1});
        min_l = min(min_l, l);
        max_r = max(max_r, r);
    }
    if (min_l != 1 || max_r != n) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < (int)A.size(); i++) {
    int cnt = 0;
        cnt += A[i].second;
        if (i != (int)A.size() - 1 && cnt == 0 && A[i].first != A[i + 1].first) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
