#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

#define int long long

vector<vector<int>> graph;
vector<vector<int>> dp;
vector<int> arr;

void dfs(int v, int p) {
    if (graph[v].size() == 1 && v != 0) {
        dp[v][0] = dp[v][1] = 0;
        return;
    }
    int sm = 0;
    for (auto u : graph[v]) {
        if (u == p) continue;
        dfs(u, v);
        sm += max(dp[u][0], dp[u][1]);
    }
    dp[v][0] = sm;
    int mx = -9e18;
    for (auto u : graph[v]) {
        if (u == p) continue;
        if (dp[u][0] - max(dp[u][0], dp[u][1]) > mx) {
            arr[v] = u;
        }
        mx = max(mx, dp[u][0] - max(dp[u][0], dp[u][1]));
    }
    dp[v][1] = sm + 1 + mx;
}

vector<pair<int, int>> res;

void calc(int v, int p, int st) {
    if (st == 0 || (graph[v].size() == 1 && v != 0)) {
        for (auto i : graph[v]) {
            if (i == p) continue;
            calc(i, v, (dp[i][0] > dp[i][1] ? 0 : 1));
        }
    } else {
        res.push_back({v, arr[v]});
        for (auto i : graph[v]) {
            if (i == p) continue;
            if (arr[v] == i) {
                calc(i, v, 0);
            } else {
                calc(i, v, (dp[i][0] > dp[i][1] ? 0 : 1));
            }
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d;
    cin >> n >> d;
    graph.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    dp.resize(n, vector<int>(2, 0));
    arr.resize(n, -1);
    dfs(0, -1);
    calc(0, -1, dp[0][0] > dp[0][1] ? 0 : 1);
    cout << max(dp[0][0], dp[0][1]) << "\n";
    for (auto [i, j] : res) {
        cout << i + 1 << ' ' << j + 1 << '\n';
    }
}
