#include <bits/stdc++.h>

using ll = long long;

void solve() {
    ll h, w;
    std::cin >> h >> w;
    std::vector<std::string> s(h);
    std::vector<std::vector<ll> > a(h, std::vector<ll>(w));
    std::vector<std::vector<ll> > lft(h, std::vector<ll>(w, -1));
    for (int i = 0; i < h; ++i) {
        std::cin >> s[i];
    }
    for (int i = 0; i < h; ++i) {
        ll cnt = 0;
        for (int j = w - 1; j >= 0; --j) {
            cnt *= s[i][j] == '1';
            cnt += s[i][j] == '1';
            a[i][j] = cnt;
        }
    }
    ll ans = 0;
    for (int j = 1; j < w; ++j) {
        std::vector<ll> stk;
        for (int i = 0; i < h; ++i) {
            while (!stk.empty() && a[stk.back()][j] >= a[i][j]) {
                stk.pop_back();
            }
            if (!stk.empty()) {
                lft[i][j] = stk.back();
            }
            stk.push_back(i);
        }
        std::vector<ll> dp(h + 1);
        for (int i = 0; i < h; ++i) {
            dp[0] = 0;
            dp[i + 1] = dp[lft[i][j] + 1] + (i - lft[i][j]) * a[i][j];
        }
        ans = std::max(ans, *std::max_element(dp.begin(), dp.end()));
    }
    std::cout << ans;
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}
