#include <bits/stdc++.h>

using namespace std;
#define rep(x) for (int rep_i = 0; rep_i < x; rep_i++)
#define all(x) x.begin(), x.end()
#define int long long

using pii = pair<int, int>;
using ll = long long;
const int maxn = 500010;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int n, d;
vector <int> g[maxn];
int used[maxn];
int used2[maxn];
int level[maxn];
vector <int> cnt1, cnt2;

void dfs(int v, int parent) {
    used[v] = 1;
    if (parent != -1)
        level[v] = level[parent] + 1;
    if (level[v] % 2 == 1)
        cnt1.push_back(v);
    else
        cnt2.push_back(v);
    for (auto u : g[v]) {
        if (!used[u])
            dfs(u, v);
    }
}

signed main() {
    cin >> n >> d;
    vector <pii> ans;
    rep(n - 1) {
        int a, b;
        cin >> a >> b;
        if (!used2[a] && !used2[b]) {
            ans.emplace_back(a,b);
            used2[a] = 1;
            used2[b] = 1;
        }
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (d == n-1) {
        dfs(1, -1);
        cout << min(cnt1.size(), cnt2.size()) << endl;
        for (int i = 0; i < min(cnt1.size(), cnt2.size()); i++) {
            cout << cnt1[i] << ' ' << cnt2[i] << endl;
        }
    }
    else {
        cout << ans.size() << endl;
        for (auto el : ans)
            cout << el.first << ' ' << el.second << endl;
    }
    cerr << "ULYANOVSK IS THE BEST" << ' ' << clock() << endl;
    return 0;
}
