#include <bits/stdc++.h>
using namespace std;
#define int int64_t

int dist(int a, int b) {
    return (a - b) * (a - b);
}

__int128_t dva = 2;

__int128_t dist2(int t, int k, int d, int x, int x0) {
    __int128_t t1 = t;
    __int128_t k1 = k;
    __int128_t d1 = d;
    __int128_t x1 = x;
    __int128_t x2 = x0;
    __int128_t s = d1 * d1 * k1;
    s += (dva * x2 * d1);
    s -= (dva * x1 * d1);
    s *= k1;
    if (k1 < 0) {
        k1 = k1 * (-1);
    }
    s += (t1 * k1);
    return s;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int x, d;
    cin >> x >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        int l = -1e18, r = 1e18;
        while (l + 2 < r) {
            int mid = (r - l + 1) / 3;
            int l1 = l + mid;
            int r1 = l + 2 * mid;
            __int128_t s1 = dist2(t[i], l1, d, a[0], x);
            __int128_t s2 = dist2(t[i], r1, d, a[0], x);
            if (s1 < s2) {
                r = r1;
                continue;
            }
            l = l1;
        }
        __int128_t ans = min(dist2(t[i], l, d, a[0], x), dist2(t[i], l + 1, d, a[0], x));
        ans = min(dist2(t[i], l + 2, d, a[0], x), ans);
            int s = ans + dist(x, t[i]);
            cout << s << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

