#include <bits/stdc++.h>
using namespace std;
#define int int64_t

vector<vector<int> > a;
vector<pair<int, int> > dp;

vector<bool> used;
void dfs(int v) {
    used[v] = true;
    vector<int> g(0);
    for (int i = 0; i < a[v].size(); i++) {
        int u = a[v][i];
        if (used[u] == true) {
            continue;
        }
        dfs(u);
        dp[v].first += max(dp[u].first, dp[u].second);
        g.push_back(dp[u].second - max(dp[u].first, dp[u].second) + 1);
    }
    if (g.size() == 0) {
        return;
    }
    sort(g.rbegin(), g.rend());
    dp[v].second += g[0];
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    a = vector<vector<int> > (n + 1);
    used = vector<bool> (n + 1, 0);
    dp = vector<pair<int,int> > (n + 1, {0, 0});
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        a[v].push_back(u);
        a[u].push_back(v);
    }
    dfs(1);
    cout << max(dp[1].first, dp[1].second);
    for (int i = 0; i < max(dp[1].first, dp[1].second); i++) {
        cout << -1 << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}


