#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll INF = 1e18;

struct node {
    ll l, m, r;
};

bool cmp (const node a, const node b) {
    return a.l < b.l;
}

void solve () {
    ll n, k;
    cin >> n >> k;
    vector<node> v (k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i].l >> v[i].m >> v[i].r;
        v[i].l--;
        v[i].m--;
        v[i].r--;
    }
    sort(v.begin(), v.end(), cmp);
    ll last = -1;
    for (int i = 0; i < k; ++i) {
        if (v[i].l > last + 1) {
            cout << "NO" << '\n';
            return;
        }
        last = v[i].r;
    }
    if (v[k-1].r != n-1) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
}

int main () {
    ios_base::sync_with_stdio(0), cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve ();
    }
}