#include <bits/stdc++.h>

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
//#define int long long
const int MAXN = 5e5;
const int INF = 2e9;

int tree[MAXN * 4];

void sett(int t, int l, int r, int x, int y) {
    if (r - l == 1) {
        tree[t] = y;
        return;
    }
    int m = (r + l)/2;
    if (x < m) {
        sett(t * 2,l,m,x,y);
    }  else {
        sett(t * 2 + 1,m,r,x,y);
    }
    tree[t] = tree[t * 2] + tree[t * 2 + 1];
}

int get(int t, int l, int r, int tl, int tr) {
    if (tl >=l && tr <= r) {
        return tree[t];
    }
    if (tl >= r || tr <= l) {
        return 0;
    }
    int m = (tl + tr)/2;
    return get(t * 2,l,r,tl,m) + get(t * 2 + 1,l,r,m,tr);
}

void solve() {
    int n,k;
    cin >> n >> k;
    for (int i = 0; i < n * 4; i++) {
        tree[i]=0;
    }
    vector<vector<pair<int,int>>> vec(n + 1);
    for (int i = 0; i < k; i++) {
        int l,mid,r;
        cin >> l >> mid >> r;
        vec[r].push_back({l, mid});
    }
    sett(1,0,n+1,0,1);
    for (int i = 1; i <= n; i++) {
        bool f = 0;
        for (auto [l, mm] : vec[i]) {
            int sum = get(1,l-1, mm, 0, n + 1);
            if (sum) {
                f=1;
                break;
            }
        }
        if (f) {
            sett(1,0,n+1,i,1);
        }
    }
    if (get(1,n,n+1,0,n+1)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}