#include <bits/stdc++.h>

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t=1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
//#define int long long
const int MAXN = 5e5;
const int INF = 2e9;
const int K = 20;

int n,d;
vector<int> gr[MAXN];
int h[MAXN];

set<pair<int,int>> st;
void dfs(int v, int p) {
    st.insert({h[v],v});
    for (int i : gr[v]) {
        if (i == p)continue;
        h[i] =  h[v] + 1;
        dfs(i,v);
    }
}

int lvl[MAXN];
bool used[MAXN];
int sz[MAXN];
int dist[K][MAXN];
int p[MAXN];

void find_centr(int v, int p, int tot_sz, int &centr) {
    int mx = 0;
    sz[v]=1;
    for (int i : gr[v]) {
        if (used[i] || i == p)continue;
        find_centr(i,v,tot_sz, centr);
        sz[v] += sz[i];
        mx = max(mx, sz[i]);
    }
    mx = max(mx, tot_sz - sz[v]);
    if (mx * 2 <= tot_sz) {
        centr = v;
    }
}

void find_dist(int v, int p, int l) {
    for (int i : gr[v]) {
        if (i == p || used[i])continue;
        dist[l][i] = dist[l][v] + 1;
        find_dist(i,v,l);
    }
}

void ddfs(int v,int par, int tot_sz, int l) {
    int centr;
    find_centr(v,v,tot_sz,centr);
    find_dist(centr,centr,l);
    lvl[centr]=l;
    p[centr] =par;
    used[centr]=1;
    for (int i : gr[centr]) {
        if (used[i]) continue;
        int to_sz = sz[i];
        if (to_sz > sz[centr]) {
            to_sz = tot_sz - sz[centr];
        }
        ddfs(i, centr,to_sz, l + 1);
    }
}

set<pair<int,int>> kras[MAXN];

void add(int v) {
    int u = v;
    while (u != -1) {
        int dd = dist[lvl[u]][v];
        if (dd <= d) {
            kras[u].insert({d- dd, v});
        }
        u = p[u];
    }
}

int get(int v) {
    int u = v;
    while (u != -1) {
        int dd = dist[lvl[u]][v];
        if (dd >= 0) {
            if (!kras[u].empty()) {
                for (auto i = --kras[u].end(); ; i--) {
                    if ((*i).first < dd)break;
                    if ((*i).first % 2 == 0) {
                        if (dd % 2 == 0) {
                            return (*i).second;
                        }
                    } else {
                        if (dd % 2 == 1) {
                            return (*i).second;
                        }
                    }
                    if (i == kras[u].begin())break;
                }
            }

        }
        u = p[u];
    }
    return -1;
}

void del(int v) {
    int u = v;
    while (u != -1) {
        int dd = dist[lvl[u]][v];
        if (dd <= d) {
            kras[u].erase({d- dd, v});
        }
        u = p[u];
    }
}

void solve() {
    cin >> n >> d;

    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    dfs(0,0);
    ddfs(0,-1,n,0);
    if (d == 1) {
        vector<bool> us(n);
        vector<pair<int,int>> ans;
        while (!st.empty()) {
            auto z = *--st.end();
            st.erase(--st.end());
            int v =z.second;
            if (us[v])continue;
            for (int i : gr[v]) {
                if (!us[i]) {
                    us[i]=1;
                    us[v]=1;
                    ans.push_back({i,v});
                    break;
                }
            }
        }
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    } else {
        vector<bool> us(n);
        vector<pair<int,int>> ans;
        while (!st.empty()) {
            auto z = *--st.end();
            st.erase(--st.end());
            int y = get(z.second);
            if (y == -1) {
                add(z.second);
            } else {
                ans.push_back({y, z.second});
                del(y);
            }
        }
        cout << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    }


}