#include <bits/stdc++.h>

// #pragma GCC Optimize("Ofast, O3")
// #pragma GCC Optimize("unroll-loops")
// #pragma GCC target("avx,avx2,bmi")

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t=1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
#define int long long
const int MAXN = 5e5 + 1;
const int INF = 2e9;
const __int128 INF2 = 2e18;
const int K = 20;

int n,d;
vector<int> gr[MAXN];
bool used[MAXN];
int ans = 0;
vector<pair<int,int>>an;
vector<pair<int,int>>now;
vector<vector<int>> dist;

void di() {
    for (int st = 0; st < n; st++) {
        dist[st].resize(n);
        deque<int> q;
        q.push_back(st);
        vector<bool> us(n);
        us[st]=1;
        while (!q.empty()) {
            int v = q.front();
            q.pop_front();
            for (int i : gr[v]) {
                if (!us[i]) {
                    us[i] = 1;
                    dist[st][i] = dist[st][v] + 1;
                    q.push_back(i);
                }
            }
        }
    }
}

vector<int> g[MAXN];
int mt[MAXN];
int us[MAXN];
int timer = 1;
bool khun(int v) {
    if (us[v] == timer) return false;
    us[v] = timer;
    for (int i : g[v]) {
        if (mt[i] == -1) {
            mt[i] = v;
            return true;
        }
    }
    for (int i : g[v]) {
        if (khun(mt[i])) {
            mt[i] = v;
            return true;
        }
    }
    return false;
}

void togr(int v, int st, int dd, int p) {
    if (dd % 2 == 1) {
        g[st].emplace_back(v);
    }
    if (d == dd)return;
    for (int i : gr[v]) {
        if (i == p)continue;
        togr(i, st, dd + 1,v);
    }
}

void solve() {
    cin >> n >> d;

    memset(mt,-1,sizeof mt);
    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    //di();
    vector<int> c(n,-1);
    c[0]=0;
    deque<int> q;
    q.push_back(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int i : gr[v]) {
            if (c[i] == -1) {
                c[i ] =1-c[v];
                q.push_back(i);
            }
        }
    }
    vector<int>start;
    for (int i = 0; i < n; i++) {
        if (c[i] == 0) {
            start.emplace_back(i);
            togr(i,i,0);
        }
    }

    for (int i : start) {
        if (khun(i)) {
            timer++;
        }
    }
    for (int i = 0; i <n; i++) {
        if (c[i] == 1) {
            if (mt[i] != -1) {
                an.push_back({i, mt[i]});
            }
        }
    }
    cout << an.size() << '\n';
    for (auto i : an) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}