#include <bits/stdc++.h>

using namespace std;
//-------------------------------------//
#define int long long
//-------------------------------------//
#pragma GCC optimize("O3")
//------------------------------------//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//---------------------------------------//



int fact[9];

const int bigK = 1e4 + 10;

vector<int> G[bigK];
vector<int> used(bigK, 0);

bool dfs(int v) { //are there cycles
    bool exist = false;
    used[v] = 1;
    for (auto u : G[v]) {
        if (used[u] == 1) {
            exist = true;
        } else if (used[u] == 0) {
            exist |= dfs(u);
        }
    }
    used[v] = 2;
    return exist;
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pii, int>> sotr(k);
    for (int i = 0; i < k; ++i) {
        cin >> sotr[i].ft.ft >> sotr[i].sd >> sotr[i].ft.sd;
    }
    sort(sotr.begin(), sotr.end());
    int cur_ptr = 0;
    for (int j = 1; j <= n; ++j) {
        while (cur_ptr < k && j > sotr[cur_ptr].ft.sd) {
            ++cur_ptr;
        }
        if (cur_ptr == k || j < sotr[cur_ptr].ft.ft) {
            cout << "NO\n";
            return;
        }
    }
    vector<pii> left, right;
    for (int i = 0; i < k; ++i) {
        if (sotr[i].ft.ft == 1 && sotr[i].ft.sd == n) {
            cout << "YES\n";
            return;
        }
        if (sotr[i].ft.ft == 1) {
            left.push_back({sotr[i].ft.sd, sotr[i].sd});
        }
        if (sotr[i].ft.sd == n) {
            right.push_back({sotr[i].ft.ft, sotr[i].sd});
        }
    }
    sort(left.begin(), left.end());
    sort(right.begin(), right.end());
    for (auto e : left) {
        int R = e.ft; pii pR = {R, -1};
        int L = e.sd; pii pL = {L, -1};
        if (upper_bound(right.begin(), right.end(), pL) == upper_bound(right.begin(), right.end(), pR)) {
            continue;
        } else {
            cout << "YES\n";
            return;
        }
    }
    for (auto e : right) {
        int L = e.ft; pii pL = {L, -1};
        int R = e.sd; pii pR = {R, -1};
        if (lower_bound(left.begin(), left.end(), pL) == lower_bound(left.begin(), left.end(), pR)) {
            continue;
        } else {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
    return;
}

signed main() {
    fast;

    fact[0] = 1;
    for (int m = 1; m <= 8; ++m) {
        fact[m] = m * fact[m - 1];
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
