#include <bits/stdc++.h>

using namespace std;
//-------------------------------------//
#define int long long
//-------------------------------------//
#pragma GCC optimize("O3")
//------------------------------------//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//---------------------------------------//

const int N = 20;

vector<int> G[N];
int color[N];
vector<int> lag[3];

int dist[N][N];

void dfs(int v, int c) {
    color[v] = c;
    lag[c].push_back(v);
    for (auto u : G[v]) {
        if (color[u] == 0) {
            dfs(u, 3 - c);
        }
    }
}

void dfs_root(int v, int parent, int root) {
    for (auto u : G[v]) {
        if (u != parent) {
            dist[root][u] = dist[root][v] + 1;
            dfs_root(u, v, root);
        }
    }
}

signed main() {
    fast;

    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int rt = 1; rt <= n; ++rt) {
        dfs_root(rt, -1, rt);
    }

    dfs(1, 1);

    int c1 = (int)lag[1].size();
    int c2 = (int)lag[2].size();

    int dp[(1 << c1)][(1 << c2)];
    int WhereTo[(1 << c1)][(1 << c2)];
    int Ft[(1 << c1)][(1 << c2)];


    for (int mask1 = 0; mask1 < (1 << c1); ++mask1) {
        for (int mask2 = 0; mask2 < (1 << c2); ++mask2) {
            if (mask1 == 0 || mask2 == 0) {
                dp[mask1][mask2] = 0;
                WhereTo[mask1][mask2] = -1;
                Ft[mask1][mask2] = -1;
                continue;
            }
            int t = 0;
            while ((mask2 & (1 << t)) == 0) ++t; //last zero
            Ft[mask1][mask2] = t;
            dp[mask1][mask2] = dp[mask1][(mask2 ^ (1 << t))];
            WhereTo[mask1][mask2] = -1;
            for (int j = 0; j < c1; ++j) {
                if ((mask1 & (1 << j)) == 0) continue;
                if (dist[lag[1][j]][lag[2][t]] > d) continue;
                if (dp[mask1][mask2] < dp[mask1 ^ (1 << j)][mask2 ^ (1 << t)] + 1) {
                    dp[mask1][mask2] = dp[mask1 ^ (1 << j)][mask2 ^ (1 << t)] + 1;
                    WhereTo[mask1][mask2] = j;
                }
            }
        }
    }

    cout << dp[(1 << c1) - 1][(1 << c2) - 1] << "\n";

    /*cout << -1;
    return 0;*/

    int M1 = ((1 << c1) - 1);
    int M2 = ((1 << c2) - 1);
    while (M1 != 0 && M2 != 0) {
        int f = Ft[M1][M2];
        int s = WhereTo[M1][M2];
        if (s == -1) {
            M2 ^= (1 << f);
            continue;
        }
        cout << lag[2][f] << " " << lag[1][s] << "\n";
        M1 ^= (1 << s);
        if (f != -1) {
            M2 ^= (1 << f);
        }
    }
    return 0;
}
