#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> g;
vector<bool> used;

void dfs(int u)
{
    used[u] = true;
    for (int v : g[u])
    {
        if (!used[v])
            dfs(v);
    }
}

void solve()
{
    g.clear();
    used.clear();
    int n, k;
    cin >> n >> k;

    vector<int> l(k);
    vector<int> m(k);
    vector<int> r(k);
    used.resize(k);
    for (int i = 0; i < k; i++)
    {
        cin >> l[i] >> m[i] >> r[i];
        --l[i];
        --m[i];
        --r[i];
    }
    g.resize(k);

    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < k; j++)
        {
            if (j == i)
                continue;
            if (l[i] <= l[j] && l[j] <= r[i] && r[j] >= r[i])
            {
                if (m[i] < l[j] || m[j] > r[i])
                {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
            else if (l[j] == r[i] + 1)
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (int i = 0; i < k; i++)
    {
        if (!used[i] && l[i] == 0)
        {
            dfs(i);
        }
    }

    for (int i = 0; i < k; i++)
    {
        if (used[i] && r[i] == n - 1)
            return void(cout << "YES\n");
    }
    cout << "NO\n";
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif

    while (t--)
        solve();
    return 0;
}