#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <algorithm>
#pragma GCC optimize("Ofast")

using namespace std;

const int inf = 1e9;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int it = 0; it < t; it++) {
        int n, k, fl = 0;
        cin >> n >> k;
        vector<pair<pair<int, int>, int>> a(k);
        vector<int> pr(n + 1, 0);
        for (int i = 0; i < k; i++) {
            cin >> a[i].first.first >> a[i].second >> a[i].first.second;
            pr[a[i].first.first - 1]++;
            pr[a[i].first.second]--;
        }
        fl = 1;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += pr[i];
            if (sum <= 0) {
                fl = 0;
            }
        }
        if (fl) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
    return 0;
}