#include <iostream>
#include <vector>
#include <stack>
#include <set>

using namespace std;

const int inf = 1e9;

typedef long long ll;

vector<pair<pair<int, int>, int>> a;
vector<int> p;
vector<int> used;
bool fl;

void dfs(int k) {
    used[k] = 1;
    if (fl) {
        return;
    }
    vector<int> h = p;
    for (int i = a[k].first.first; i <= a[k].first.second; i++) {
        p[i] = 1;
    }
    bool s = 1;
    for (int i = 0; i < p.size(); i++) {
        if (!p[i]) {
            s = 0;
            break;
        }
    }
    if (s == 1) {
        fl = 1;
        return;
    }
    for (int i = 0; i < a.size(); i++) {
        if (!used[i] && !p[a[i].second]) {
            dfs(i);
        }
    }
    p = h;
}

int main() {
    int t;
    cin >> t;
    for (int it = 0; it < t; it++) {
        int n, k;
        fl = 0;
        cin >> n >> k;
        a.clear();
        p.clear();
        a.resize(k);
        p.resize(n, 0);
        for (int i = 0; i < k; i++) {
            cin >> a[i].first.first >> a[i].second >> a[i].first.second;
            a[i].first.first--, a[i].second--, a[i].first.second--;
        }
        for (int i = 0; i < k; i++) {
            used.clear();
            used.resize(k, 0);
            dfs(i);
        }
        if (fl) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
    return 0;
}