#include <iostream>
#include <vector>
#include <stack>
#include <set>
#pragma GCC optimize("Ofast")

using namespace std;

const int inf = 1e9;

typedef long long ll;

int u = 0;
vector<int> used;
vector<pair<int, int>> ans;
vector<vector<int>> gr;

int dfs(int ind) {
    used[ind] = 1;
    int h = 0;
    for (auto i : gr[ind]) {
        if (used[i] == 0) {
            int g = dfs(i);
            if (g == 0 && h == 0) {
                h = 1;
                u++;
                ans.push_back({i + 1, ind + 1});
            }
        }
    }
    return h;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, d, u, v;
    cin >> n >> d;
    vector<int> a(n);
    gr.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    u = 0;
    dfs(0);
    cout << u << '\n';
    for (auto [i, j] : ans) {
        cout << i << " " << j << '\n';
    }
    return 0;
}