#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct person {
    int l, m, r;
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<person> people;
        for (int i = 0; i < k; i++) {
            int l, m, r;
            cin >> l >> m >> r;
            people.emplace_back(l, m, r);
        }
        vector<vector<person>> begin(n + 1);
        for (int i = 0; i < k; i++) {
            begin[people[i].l].push_back(people[i]);
        }
        vector<int> dp(n + 1);
        dp[0] = 1;
        for (int i = 1; i <= n; i++) {
            if (dp[i - 1]) {
                for (auto p : begin[i]) {
                    dp[p.r] = 1;
                }
            }
        }
        if (dp[n]) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
    return 0;
}