#include <iostream>
#include <cassert>
#include <vector>
using namespace std;
#define int long long
#define line cout << "\n"
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
 
 
int max(int a, int b) {
    return (a > b ? a : b);
}
 
int min(int a, int b) {
    return (a < b ? a : b);
}
 
 
struct event{
    int l, m, r;
};
 
const int MAXN = 1e5;
vector<int> g[MAXN];
int used[MAXN];
 
bool f = true;
 
void dfs(int v) {
    used[v] = 1;
    for (auto &u : g[v]) {
        if (used[u]) {
            if (used[v] == used[u]) {
                f = false;
            }
            continue;
        }
        dfs(u);
    }
    used[v] = 2;
}
 
bool between(int a, int b, int c) {
    return a <= b && b <= c;
}
 
 
void solve() {
    int n, k;
    cin >> n >> k;
    f = true;
    for (int i = 0; i < k; i++) {
        g[i].clear();
        used[i] = 0;
    }
    vector<event> arr(k);
    vector<int> enter(n + 1), exit(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        enter[arr[i].l]++;
        exit[arr[i].r]++;
    }
    int calc = 0;
    for (int i = 1; i <= n; i++) {
        calc += enter[i];
        if (calc == 0) {
            cout << "NO"; line;
            return;
        }
        calc -= exit[i];
    }
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (between(arr[i].l, arr[j].m, arr[i].r) && between(arr[j].l, arr[i].m, arr[j].r)) {
                f = false;
            }
        }
    }
    if (!f) {
        cout << "NO";
        return;
    }
    cout << "YES"; line;
}
 
 
signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}