#include <iostream>
#include <cassert>
#include <vector>
#include <climits>
#include <algorithm>
using namespace std;
#define int __int128
#define line cout << "\n"
#define pii pair<int, int>
#define pb push_back
#define all(a) a.begin(), a.end()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(a) (int) a.size()
typedef long long ll;
  
  
int max(int a, int b) {
    return (a > b ? a : b);
}
  
int min(int a, int b) {
    return (a < b ? a : b);
}


int pow2(int a) {
    return a * a;
}

int abs(int a) {
    return (a > 0 ? a : -a);
}


void solve() {
    ll n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        ll a;
        cin >> a;
        x[i] = a;
    }
    sort(all(x));
    ll a, b, c;
    cin >> a >> b >> c;
    int x0 = a, d = b, m = c;
    while (m--) {
        ll a;
        cin >> a;
        int t = a;
        int tl = -1e9, tr = 1e9;
        while (tl + 2 < tr) {
            int m1 = tl + (tr - tl) / 3;
            int m2 = tr - (tr - tl) / 3;
            int p1 = x0 + m1 * d;
            int p2 = x0 + m2 * d;
            if (pow2(p1 - x[0]) + abs(m1) * t < pow2(p2 - x[0]) + abs(m2) * t) {
                tr = m2;
            } else {
                tl = m1;
            }
        }
        int ans = 1e20;
        for (int i = tl - 1; i <= tr + 1; i++) {
            int p = x0 + i * d;
            ans = min(ans, pow2(p - x[0]) + abs(i) * t);
        }
        cout << (ll) ans; line;
    }
}
  
  
signed main() {
    // fast;
 
 
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}