
// A_1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>

using namespace std;

int max(int a, int b) {
	if (a > b)return a;
	return b;
}

int min(int a, int b) {
	return a + b - max(a, b);
}

int main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<string> v(n);
	for (auto& i : v)cin >> i;
	vector<vector<int>> R(n, vector<int>(m + 1));
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (v[i][j] == '0')R[i][j] = 0;
			else R[i][j] = R[i][j + 1] + 1;
		}
	}
	vector<vector<int>> UP(n, vector<int>(m + 1));
	for (int i = 0; i < m; i++) {
		vector<int> STK;
		for (int j = 0; j < n; j++) {
			if (STK.size() == 0) {
				UP[j][i] = 0;
			}
			else {
				while (STK.size() > 0 and R[STK.back()][i] >= R[j][i])STK.pop_back();
				if (STK.size() == 0)UP[j][i] = 0;
				else UP[j][i] = STK.back() + 1;
			}
			STK.push_back(j);
		}
	}
	vector<vector<int>> dp(n + 1, vector<int>(m));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			dp[j + 1][i] = dp[UP[j][i]][i] + R[j][i] * (1 + j - UP[j][i]);
		}
	}
	int MAXX = -1;
	for (auto& i : dp) {
		for (auto& j : i) {
			MAXX = max(MAXX, j);
		}
	}
	cout << MAXX << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
