#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
#define int long long


vector<int>vis;
struct node {
    int l, r, m;
    bool operator<(const node b) const {
        if (l < b.l) return 1;
        return r < b.r;
    }
};

vector<node>s;
vector<vector<int>>G;
vector<int>res;

void dfs(int v) {
    res[v]=1;
    vis[v]=1;
    vector<int>nd;
    for (auto j : G[v]) {
        if (!vis[j]) {
            nd.push_back(j);
            vis[j]=1;
        }
    }
    for (auto j : nd) {
        dfs(j);
    }
    for (auto j : nd) {
        vis[j]=0;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while (T--) {
        int n, k;
        cin >> n >> k;
        s={};
        G={};
        G.resize(k+1);
        s.resize(k);
        vector<int>idx_1, idx_n;
        vector<vector<int>>col(n+1);
        for (int i = 0; i < k; ++i) {
            cin >> s[i].l >> s[i].m >> s[i].r;
            for (int j = s[i].l; j <= s[i].r; ++j) {
                col[j].push_back(i);
            }
            if (s[i].l == 1) idx_1.push_back(i);
            if (s[i].r == n) idx_n.push_back(i);
        }
        if (idx_1.empty() || idx_n.empty()) {
            cout << "NO\n";
            continue;
        }
        bool f=0;
        for (int i = 1; i < (1 << k); ++i) {
            vector<int>idx;
            for (int j = 0; j < k; ++j) {
                if ((i>>j)&1) {
                    idx.push_back(j);
                }
            }

            bool g = 0;
            for (int j = 0; j < idx.size(); ++j) {
                for (int l = j+1; l < idx.size(); ++l) {
                    int L = max(s[idx[j]].l, s[idx[l]].l), R = min(s[idx[l]].r, s[idx[j]].r);
                    if ((s[idx[l]].m >= L && s[idx[l]].m <= R) && (s[idx[j]].m >= L && s[idx[j]].m <= R)) {
                        g = 1;
                        break;
                    }
                }
                if (g) break;
            }
            if (!g) {
                vector<int>v(n+1, 0);
                for (auto j : idx) {
                    for (int l=s[j].l;l<=s[j].r;++l) v[l]++;
                }
                for (int j=1;j<=n;++j) {
                    if (!v[j]) g=1;
                }
            }
            if (!g) {
                cout<<"YES\n";
                f=1;
                break;
            }
        }
        if (!f) {
            cout<<"NO\n";
        }
    }
}