#include <bits/stdc++.h>

using namespace std;

void solve();

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}

vector<vector<int> > g;
vector<deque<pair<int, int> > > r, b;
vector<int> used;
vector<pair<int, int> > ans;
int d;

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second > b.second;
}

void dfs(int u) {
    used[u] = 1;
    deque<pair<int, int> > all_r, all_b;
    for (auto v: g[u]) {
        if (used[v] == 0) {
            dfs(v);
        }
        if (used[v] == 2) {
            for (int i = 0; i < r[v].size(); i++) {
                all_r.push_back(r[v][i]);
            }
            for (int i = 0; i < b[v].size(); i++) {
                all_b.push_back(b[v][i]);
            }
        }
    }
    for (int i = 0; i < all_r.size(); i++) {
        all_r[i].second++;
    }
    for (int i = 0; i < all_b.size(); i++) {
        all_b[i].second++;
    }
    swap(all_r, all_b);

    all_r.push_back({u, 0});
    sort(all_r.begin(), all_r.end(), cmp);
    sort(all_b.begin(), all_b.end(), cmp);
    vector<int> usedr(all_r.size()), usedb(all_b.size());
    int l = all_r.size() - 1, l1 = 0;
    while (l >= 0 && l1 < all_b.size()) {
        if (all_r[l].second + all_b[l1].second > d) {
            l1++;
            continue;
        }

        ans.push_back({all_r[l].first, all_b[l1].first});
        usedr[l] = 1;
        usedb[l1] = 1;
        l--;
        l1++;
    }
    deque<pair<int, int> > a1, a2;
    for (int i = 0; i < all_r.size(); i++) {
        if (usedr[i] == 0) {
            a1.push_back(all_r[i]);
        }
    }
    for (int i = 0; i < all_b.size(); i++) {
        if (usedb[i] == 0) {
            a2.push_back(all_b[i]);
        }
    }
    r[u] = a1;
    b[u] = a2;
    used[u] = 2;
}

void solve() {
    int n;
    cin >> n;
    cin >> d;
    g.resize(n);
    used.resize(n);
    r.resize(n);
    b.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);
    cout << ans.size() << "\n";
    for (auto [a, b]: ans) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}
