#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;

int segTree[2][4*maxn];

void modify(int i,int x,int l,int r,int indV,int j)
{
    if(l > i || r < i)
    {
        return ;
    }
    else if(l == r)
    {
        segTree[j][indV] = max(segTree[j][indV],x);
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1,j);
    modify(i,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = max(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}
int get(int lx,int rx,int l,int r,int indV,int j)
{
    if(l > rx || r < lx)
    {
        return 0;
    }
    else if(l >= lx && r <= rx)
    {
        return segTree[j][indV];
    }
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1,j);
    int sr = get(lx,rx,m+1,r,indV*2+2,j);
    return max(sl,sr);
}

bool satisfy(int l1,int m1,int r1,int l2,int m2,int r2)
{
    if((l2 > m1 && l2 <= r1+1 && r2 > r1) || (r1 >= l2-1 && r1 < m2 && l1 < l2))
    {
        return true;
    }
    else
        return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--)
    {
        int n,k;
        cin >> n >> k;
        vector<pair<int,int>> s;
        int ll[k],mm[k],rr[k];
        for(int i = 0;i < k;++i)
        {
            cin >> ll[i] >> mm[i] >> rr[i];
            ll[i]--;
            rr[i]--;
            mm[i]--;
            s.push_back({mm[i],i});
            s.push_back({rr[i],i+k});
        }
        for(int i = 0;i < 2;++i)
        {
            for(int j =0;j < 4*(n+1);++j)
            {
                segTree[i][j] = 0;
            }
        }
        sort(s.begin(),s.end());
        bool dp[k];
        for(int i = k-1;i >= 0;--i)
        {
            dp[i] =0;
        }
        bool yes = 0;
        for(int i = 2*k-1;i >= 0;--i)
        {
            int ind = s[i].second % k;
            int l = ll[ind],m = mm[ind],r = rr[ind];
            if(s[i].second > k)
            {
                dp[ind] |= get(l+1,r+1,0,n,0,0);
            }
            else
            {
                dp[ind] |= (get(m+1,r+1,0,n,0,1) > r);
                dp[ind] |= (r == n-1);
                if(dp[ind] == 1)
                {
                    modify(l,1,0,n,0,0);
                    modify(l,r,0,n,0,1);
                }
                if(dp[ind] == 1 && l == 0)
                {
                    yes = 1;
                    break;
                }
            }
        }
        cout << (yes ? "YES\n" : "NO\n");
    }
}