#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

__int128 find_ans_pos(int k,vector<ll>& x,vector<ll> & sum,vector<pair<__int128,__int128>> & suff,ll d,ll t)
{
    int pos = upper_bound(x.begin(),x.end(),k * d) - x.begin() - 1;
    __int128 ans = sum[pos+1];
   // if(k == 1)
    //    cout << k << ' ' << pos << ' ' << x.size() << ' ' << ll(ans) << endl; 
    ans += suff[pos+1].first - 2 * suff[pos+1].second * k * d + (k * d * k * d) * (int(x.size())-pos-1);
    ans += t * k;
    return ans;
}

__int128 find_ans(vector<ll>& x,vector<ll> & sum,vector<pair<__int128,__int128>> & suff,ll d,ll t)
{
    ll lg = 0,rg = (int(1e9)+d-1)/d;
    while(lg < rg)
    {
        ll mg = (lg+rg)/2;
        __int128 ans1 = find_ans_pos(mg,x,sum,suff,d,t);
        __int128 ans2 = find_ans_pos(mg+1,x,sum,suff,d,t);
        if(ans2 < ans1)
        {
            lg = mg + 1;
        }
        else
        {
            rg = mg;
        }
    }
  //  cout << lg << ' ' << ll(find_ans_pos(lg+1,x,sum,suff,d,t)) << endl;
    return find_ans_pos(lg,x,sum,suff,d,t);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    ll x[n];
    vector<ll> x1,x2;
    for(int i = 0;i < n;++i)
    {
        cin >> x[i];
    }
    ll x0,d;
    cin >> x0 >> d;
    //cout << "!" << endl;
    for(int j = 0;j < n;++j)
    {
        if(x[j] < x0)
        {
            x1.push_back(x0-x[j]);
        }
        else if(x[j] > x0)
        {
            x2.push_back(x[j]-x0);
        }
    }
 //   cout << "!" << endl;
    sort(x1.begin(),x1.end());
    sort(x2.begin(),x2.end());
    vector<ll> sum1(x1.size()+1,0);
    vector<ll> sum2(x2.size()+1,0);
    for(int j = 0;j < x1.size();++j)
    {
        ll dd = min(d-x1[j]%d,x1[j]%d);
        sum1[j+1] = sum1[j] + dd * dd;
    }
    for(int j = 0;j < x2.size();++j)
    {
        ll dd = min(d-x2[j]%d,x2[j]%d);
        sum2[j+1] = sum2[j] + dd * dd;
    }
  //  cout << "!" << endl;
    vector<pair<__int128,__int128>> suff1(x1.size()+1,{0,0});
    vector<pair<__int128,__int128>> suff2(x2.size()+1,{0,0});
    for(int j = int(x1.size())-1;j >= 0;--j)
    {
        suff1[j] = {suff1[j+1].first + x1[j] * x1[j],suff1[j+1].second + x1[j]};
    }
    for(int j = int(x2.size())-1;j >= 0;--j)
    {
        suff2[j] = {suff2[j+1].first + x2[j] * x2[j],suff2[j+1].second + x2[j]};
    }
    int q;
    cin >> q;
    while(q--)
    {
        ll t;
        cin >> t;
        __int128 l1 = find_ans(x1,sum1,suff1,d,t),l2 = find_ans(x1,sum1,suff1,d,2*t),r1 = find_ans(x2,sum2,suff2,d,t),r2 = find_ans(x2,sum2,suff2,d,2*t);
        cout << ll(min(l1 + r2,r1 + l2)) << "\n";
    }
    return 0;
}