#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
using namespace std;
pair <long long, vector <long long>> x(vector <long long> v1, vector <long long> v2) {
    long long cnt = 0, i = 0, j = 0, n = v1.size(), m = v2.size();
    vector <long long> v;
    while (i < n && j < m) {
        if (v1[i] < v2[j]) {
            v.push_back(v1[i]);
            i++;
            cnt += j;
        } else {
            v.push_back(v2[j]);
            j++;
        }
    }
    while (i < n) {
        v.push_back(v1[i]);
        i++;
        cnt += j;
    }
    while (j < m) {
        v.push_back(v2[j]);
        j++;
    }
    return {cnt, v};
}
pair <long long, vector <long long>> f(vector <long long> v) {
    if (v.size() == 1) {
        return {0, v};
    }
    //cout << "!" << endl;
    long long n = v.size(), m = n / 2;
    vector <long long> v1, v2;
    for (long long i = 0; i < n; i++) {
        if (i < m) {
            v1.push_back(v[i]);
        } else {
            v2.push_back(v[i]);
        }
    }
    //f(v1);
    auto o1 = (f(v1));
    auto o2 = (f(v2));
    long long x1 = o1.first, x2 = o2.first;
    vector <long long> p1 = o1.second, p2 = o2.second;
    auto o = x(p1, p2);
    return {x1 + x2 + o.first, o.second};
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long r, c;
    cin >> r >> c;
    vector <vector <long long>> v(r, vector <long long> (c));
    for (long long i = 0; i < r; i++) {
        for (long long j = 0; j < c; j++) {
            cin >> v[i][j];
        }
    }
    vector <vector <long long>> dp(r, vector <long long> (c, 1000'000'000));
    dp[r - 1][c - 1] = 0;
    for (long long i = r - 1; i >= 0; i--) {
        for (long long j = c - 1; j >= 0; j--) {
            //cout << i << " " << j << endl;
            if (i == r - 1 && j == c - 1) {
                continue;
            }
            if (i != r - 1) {
                vector <long long> x;
                for (long long k = j; k < c; k++) {
                    x.push_back(v[i][k]);
                }
                auto o = f(x);
                x = o.second;
                long long cnt = o.first;
                cnt += dp[i + 1][j];
                vector <long long> v1;
                for (long long k = i + 1; k < r; k++) {
                    for (long long l = j; l < c; l++) {
                        v1.push_back(v[k][l]);
                    }
                }
                sort(v1.begin(), v1.end());
                for (auto i : v1) {
                    x.push_back(i);
                }
                cnt += f(x).first;
                dp[i][j] = min(dp[i][j], cnt);
            }
            if (j != c - 1) {
                vector <long long> x;
                for (long long k = i; k < r; k++) {
                    x.push_back(v[k][j]);
                }
                auto o = f(x);
                x = o.second;
                long long cnt = o.first;
                cnt += dp[i][j + 1];
                vector <long long> v1;
                for (long long k = i; k < r; k++) {
                    for (long long l = j + 1; l < c; l++) {
                        v1.push_back(v[k][l]);
                    }
                }
                sort(v1.begin(), v1.end());
                for (auto i : v1) {
                    x.push_back(i);
                }
                cnt += f(x).first;
                dp[i][j] = min(dp[i][j], cnt);
            }
            //c//out << dp[i][j] << " ";
        }
        //cout << endl;
    }
    cout << dp[0][0];
    return 0;
}
