#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Vector {
    int x, y;

    Vector operator-(const Vector& rhs) const {
        return { x - rhs.x, y - rhs.y };
    }

    int operator*(const Vector& rhs) const {
        return x * rhs.x + y * rhs.y;
    }

    int sqlen() const {
        return (*this) * (*this);
    }
};

using Point = Vector;

const int LOG = 21;

vector<vector<int>> g;
vector<int> used, comp, depth;
// vector<int> up[LOG];
// vector<int> tin, tout;
// int timer = 1;

void dfs(int v, int curd, int cc) {
    if (used[v])
        return;
    // tin[v] = timer++;
    used[v] = true;
    comp[v] = cc;
    depth[v] = curd;
    // up[0][v] = p;
    // for (int l = 1; l < LOG; ++l)
        // up[l][v] = up[l - 1][up[l - 1][v]];
    for (auto to : g[v])
        dfs(to, curd + 1, cc);
    // tout[v] = timer;
}

// bool is_up(int a, int b) {
//     return tin[a] <= tin[b] && tout[b] <= tout[a];
// }

// int lca(int a, int b) {
//     if (is_up(a, b))
//         return a;
//     if (is_up(b, a))
//         return b;
//     for (int l = LOG - 1; l >= 0; --l)
//         if (!is_up(up[l][a], b))
//             a = up[l][a];
//     return up[0][a];
// }

vector<int> mind;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, r;
    cin >> n >> r;
    vector<Point> pts(n);
    for (auto& [x, y] : pts)
        cin >> x >> y;
    g.resize(n);
    vector<pair<int, int>> edg;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            int tmp = (pts[i] - pts[j]).sqlen();
            if (tmp <= r * r) {
                edg.push_back({ i, j });
                g[i].push_back(j);
            }
        }
    }
    used.resize(n), depth.resize(n);
    // for (int l = 0; l < LOG; ++l)
    //     up[l].assign(n, 0);
    // tin.resize(n), tout.resize(n);
    comp.resize(n);
    int cc = 1;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i, 0, cc++);
        }
    }
    vector<int> goodc(cc + 1);
    for (auto [u, v] : edg) {
        if (depth[u] % 2 == depth[v] % 2) {
            goodc[comp[u]] = 1;
        }
    }
    for (int i = 0; i < n; ++i)
        cout << goodc[comp[i]];
}