#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> p(n);
    for (auto &i : p)
        cin >> i.first >> i.second;
    map<int, set<pair<int, int>>> c;
    for (int i = 0; i < n; ++i)
        c[p[i].first].insert({p[i].second, i});
    vector<vector<int>> gr(n);
    for (int i = 0; i < n; ++i)
        for (int j = -r; j <= r && gr[i].size() < 9; ++j) {
            int x = p[i].first + j;
            if (c[x].empty())
                continue;
            int y = sqrtl(r * r - j * j);
            auto it = c[x].lower_bound({p[i].second - y, -1});
            while (it != c[x].end() && it->first <= p[i].second + y && gr[i].size() < 9) {
                if (it->second != i)
                    gr[i].push_back(it->second);
                ++it;
            }
        }
    vector<int> col(n, -1), now, bad(n, 0);
    for (int i = 0; i < n; ++i)
        if (gr[i].size() > 8)
            gr[i].resize(8), bad[i] = 1;
    vector<pair<int, int>> e;
    for (int i = 0; i < n; ++i)
        for (int j : gr[i])
            gr[j].push_back(i);
    auto dfs = [&](auto self, int v, int c)-> bool  {
        if (col[v] != -1 && col[v] != c)
            return false;
        if (col[v] == -1) {
            now.push_back(v);
            col[v] = c;
            bool ok = true;
            for (int u : gr[v])
                ok &= self(self, u, c ^ 1);
            if (bad[v])
                ok = false;
            return ok;
        }
        return true;
    };
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            now.clear();
            if (!dfs(dfs, i, 0)) {
                for (int j : now)
                    ans[j] = 1;
            }
        }
    }
    for (int i : ans)
        cout << i;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}