#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef __int128 lll;

ll R;

struct point {
    ll x, y, idx;
};

vector<vector<ll>> g;
vector<bool> answer;
vector<ll> col;
bool flag = false;

void dfs(ll v) {
    for (auto i : g[v]) {
        if (answer[i] || (col[i] == col[v])) {
            flag = true;
        }
        if (!col[i]) {
            col[i] = (col[v] % 2) + 1;
            dfs(i);
        }
    }
}

void dfs1(ll v) {
    for (auto i : g[v]) {
        if (!answer[i]) {
            answer[i] = true;
            dfs1(i);
        }
    }
}

void update_answer() {
    col.assign(g.size(), 0);
    for (ll i = 0; i < g.size(); ++i) {
        if (col[i] || answer[i]) continue;
        col[i] = 1;
        flag = false;
        dfs(i);
        if (flag) dfs1(i);
    }
}

bool check(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= R * R;
}

void solve() {
    ll n, r;
    cin >> n >> r;
    R = r;
    g.assign(n, {});
    vector<point> arr(n);
    for (ll i = 0; i < n; ++i) cin >> arr[i].x >> arr[i].y;
    for (int i = 0; i < n; ++i) arr[i].idx = i;
    sort(arr.begin(), arr.end(), [](point a, point b) {
        return a.x + a.y < b.x + b.y;
    });
    // vector<ll> arrs;
    // for (ll i = 0; i < n; ++i) arrs.push_back(arr[i].x + arr[i].y);
    // vector<pair<ll, ll>> seg;
    // for (ll i = 0; i < n; ++i) {
        // ll l = lower_bound(arrs.begin(), arrs.end(), arr[i].x + arr[i].y - 2 * r) - arrs.begin();
        // ll ri = lower_bound(arrs.begin(), arrs.end(), arr[i].x + arr[i].y + 2 * r) - arrs.begin();
        // if (ri - l > 6) {
        //     seg.push_back({l, ri});
        //     continue;
        // }
        int l = 0, ri = n;
        for (ll j1 = l; j1 < ri; ++j1) {
            for (ll j2 = j1 + 1; j2 < ri; ++j2) {
                if (check(arr[j1], arr[j2])) {
                    g[j1].push_back(j2);
                    g[j2].push_back(j1);
                }
            }
        }
    // }
    answer.assign(n, false);
    // sort(seg.begin(), seg.end());
    // ll j = 0, now = 0;
    // for (ll i = 0; i < n; ++i) {
    //     while (j < seg.size() && seg[j].first == i) {
    //         now = max(now, seg[j].second);
    //         ++j;
    //     }
    //     if (i < now) answer[i] = true;
    // }
    update_answer();
    vector<int> realans(n);
    for (int i = 0; i < n; ++i) realans[arr[i].idx] = answer[i];
    for (ll i = 0; i < n; ++i) cout << (realans[i] ? 1 : 0);
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}