#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
// #pragma GCC target("avx2")

using namespace std;

// #define int long long

struct SparseTable {
    vector<vector<pair<int, int>>> sp;

    SparseTable(vector<int> a) {
        int n = a.size();
        int lg2n = log2(n) + 1;
        sp.resize(lg2n, vector<pair<int, int>>(n));
        for (int i = 0; i < n; ++i) sp[0][i] = {a[i], i};
        for (int i = 1; i < lg2n; ++i) {
            for (int j = 0; j < n; ++j) {
                sp[i][j] = min(sp[i - 1][j], sp[i - 1][min(n - 1, j + (1 << (i - 1)))]);
            }
        }
    }

    int get(int l, int r) {
        int sz = (r - l);
        int lg2 = log2(sz);
        return min(sp[lg2][l], sp[lg2][r - (1 << lg2)]).second;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> nx(n, n - 1);
    vector<int> cur;
    for (int i = n - 1; i >= 0; --i) {
        while (cur.size() && a[cur.back()] < a[i]) cur.pop_back();
        if (cur.size()) nx[i] = cur.back();
        cur.push_back(i);
    }
    vector<int> sufmx(n);
    sufmx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) sufmx[i] = max(sufmx[i + 1], a[i]);
    vector<vector<int>> ans(4);
    SparseTable lol(a);
    ans[1].push_back(n);
    for (int sz = 2; sz <= 3; ++sz) {
        ans[sz].push_back(a[0]);
        int l = 0;
        for (int i = 2; i <= sz - 1; ++i) {
            int r = min(nx[l] + 1, n - (sz - i));
            // cout << sz << ' ' << i << ' ' << l << ' ' << r << '\n';
            int ind = lol.get(l + 1, r);
            ans[sz].push_back(a[ind]);
            l = ind;
        }
        // cout << 
        ans[sz].push_back(sufmx[nx[l]]);
        // cout << sz << ' ';
        // for (auto e : ans[sz]) cout << e << ' '; cout << endl;
    }
    // for (auto e : ans) {
    //     for (auto i : e) cout << i << ' ';
    //     cout << endl;
    // }
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        --i;
        cout << ans[k][i] << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}