#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
// #pragma GCC target("avx2")
 
using namespace std;
 
// #define int long long

// struct SparseTable {
//     vector<vector<pair<int, int>>> sp;
 
//     SparseTable(vector<int> a) {
//         int n = a.size();
//         int lg2n = log2(n) + 1;
//         sp.resize(lg2n, vector<pair<int, int>>(n));
//         for (int i = 0; i < n; ++i) sp[0][i] = {a[i], i};
//         for (int i = 1; i < lg2n; ++i) {
//             for (int j = 0; j < n; ++j) {
//                 sp[i][j] = min(sp[i - 1][j], sp[i - 1][min(n - 1, j + (1 << (i - 1)))]);
//             }
//         }
//     }
 
//     int get(int l, int r) {
//         int sz = (r - l);
//         int lg2 = log2(sz);
//         return min(sp[lg2][l], sp[lg2][r - (1 << lg2)]).second;
//     }
// };

struct Fenwick {
    int n;
    vector<int> tr;

    Fenwick(int n) : n(n) {
        tr.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = (i | (i + 1))) tr[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) ans += tr[i];
        return ans;
    }
};
 
void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<pair<int, int>>> qs(n + 1);
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        // --i;
        qs[k].push_back({i, _});
    }
    vector<int> backord(n + 1);
    for (int i = 0; i < n; ++i) backord[a[i]] = i;
    vector<int> ans(q);
    Fenwick lol(n + 1);
    for (int i = 1; i <= n; ++i) {
        lol.upd(backord[i], 1);
        for (auto e : qs[i]) {
            int l = -1, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (e.first >= lol.get(m)) r = m;
                else l = m;
            }
            ans[e.second] = a[r];
        }
    }
    for (auto e : ans) cout << e << '\n';
}
 
signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}