#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#define int long long

using namespace std;

int n, r;
vector<int> col;
vector<pair<int, int>> p;

unordered_map<int, int> yes;

bool go(pair<int, int> &a, pair<int, int> &b) {
    int dx = a.first - b.first;
    int dy = a.second - b.second;
    return dx * dx + dy * dy <= r * r;
}

void dfs(int v, int c) {
    col[v] = c;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1 && go(p[v], p[i])) {
            dfs(i, c);
        }
    }
}

vector<int> bincol;

void dfs1(int v, int C, int c) {
    bincol[v] = c;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1 && go(p[v], p[i])) {
            dfs1(i, C, 1 - c);
        } else if (col[i] == c && go(p[v], p[i])) {
            yes[C] = 1;
        }
    }
}

signed main() {
    cin >> n >> r;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    col.resize(n, -1);
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            dfs(i, c);
            c++;
        }
    }
    bincol.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (bincol[i] == -1) {
            dfs1(i, col[i], 0);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (yes.find(col[i]) != yes.end()) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    cout << endl;
    return 0;
}