#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#define int long long

using namespace std;

int ans = 1e9;

pair<vector<int>, int> cnt(vector<int> &a) {
    int n = (int)a.size();
    if (n == 1) {
        return {a, 0};
    }
    vector<int> l, r;
    for (int i = 0; i < n; ++i) {
        if (i < n / 2) {
            l.push_back(a[i]);
        } else {
            r.push_back(a[i]);
        }
    }
    pair<vector<int>, int> l1 = cnt(l), r1 = cnt(r);
    int cur = l1.second + r1.second;
    vector<int> c = l1.first, d = r1.first;
    vector<int> nw;
    int i = 0, j = 0;
    while (i < (int)c.size() && j < (int)d.size()) {
        if (c[i] < d[j]) {
            nw.push_back(c[i]);
            i++;
        } else {
            cur += (int)c.size() - i;
            nw.push_back(d[j]);
            j++;
        }
    }
    while (i < (int)c.size()) {
        nw.push_back(c[i]);
        i++;
    }
    while (j < (int)d.size()) {
        cur += (int)c.size() - i;
        nw.push_back(d[j]);
        j++;
    }
    return {nw, cur};
}

vector<int> ch;

void gen(vector<vector<int>> &a) {
    if ((int)a.size() == 1 || (int)a[0].size() == 1) {
        for (int i = 0; i < (int)a.size(); ++i) {
            for (int j = 0; j < (int)a[0].size(); ++j) {
                ch.push_back(a[i][j]);
            }
        }
        ans = min(ans, cnt(ch).second);
        for (int i = 0; i < (int)a.size(); ++i) {
            for (int j = 0; j < (int)a[0].size(); ++j) {
                ch.pop_back();
            }
        }
        return;
    }
    vector<vector<int>> b = a;
    for (int i = 0; i < (int)a.size(); ++i) {
        ch.push_back(a[i][0]);
        reverse(b[i].begin(), b[i].end());
        b[i].pop_back();
        reverse(b[i].begin(), b[i].end());
    }
    gen(b);
    for (int i = 0; i < (int)a.size(); ++i) {
        ch.pop_back();
    }
    b = a;
    for (int i = 0; i < (int)a[0].size(); ++i) {
        ch.push_back(a[0][i]);
    }
    reverse(b.begin(), b.end());
    b.pop_back();
    reverse(b.begin(), b.end());
    gen(b);
    for (int i = 0; i < (int)a[0].size(); ++i) {
        ch.pop_back();
    }
}

signed main() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    gen(a);
    cout << ans << endl;
    return 0;
}