#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
ll r;
bool f;
vector<ll> x;
vector<ll> y;
vector<int> h;
vector<bool> used;
vector<bool> ans;

bool edge(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r;
}

void dfs(int v, int p) {
    used[v] = true;
    h[v] = h[p] + 1;
    for (int u = 0; u < n; ++u) {
        if (u == v) continue;
        if (edge(v, u)) {
            if (used[u]) {
                if ((h[v] - h[u]) % 2 == 0) {
                    f = true;
                }
                continue;
            }
            dfs(u, v);
        }
    }
}

void dfs2(int v) {
    ans[v] = true;
    for (int u = 0; u < n; ++u) {
        if (u == v) continue;
        if (edge(v, u)) {
            if (ans[u]) continue;
            dfs2(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    h.resize(n);
    x.resize(n);
    y.resize(n);
    used.assign(n, false);
    ans.assign(n, false);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        h[i] = -1;
        f = false;
        dfs(i, i);
        if (f) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (ans[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
}