#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
ll r;
bool f;
vector<ll> x;
vector<ll> y;
vector<int> h;
vector<vector<int>> g;
vector<bool> used;
vector<bool> ans;

bool edge(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r;
}

void dfs(int v, int p) {
    used[v] = true;
    h[v] = h[p] + 1;
    for (int u : g[v]) {
        if (used[u]) {
            if ((h[v] - h[u]) % 2 == 0) {
                f = true;
            }
            continue;
        }
        dfs(u, v);
    }
}

void dfs2(int v) {
    ans[v] = true;
    for (int u : g[v]) {
        if (ans[u]) continue;
        dfs2(u);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    h.resize(n);
    x.resize(n);
    y.resize(n);
    g.resize(n);
    used.assign(n, false);
    ans.assign(n, false);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    set<pair<int, pair<int, int>>> s;
    for (int i = 0; i < n; ++i) {
        s.insert(make_pair(x[i], make_pair(y[i], i)));
    }
    for (int i = 0; i < n; ++i) {
        for (ll dx = -r; dx <= r; ++dx) {
            for (ll dy = -r; dy <= r; ++dy) {
                if (dx == 0 && dy == 0) continue;
                if (dx * dx + dy * dy <= r * r) {
                    auto it = s.lower_bound(make_pair(x[i] + dx, make_pair(y[i] + dy, -1)));
                    if (it == s.end()) continue;
                    auto p = *it;
                    if (p.first == x[i] + dx && p.second.first == y[i] + dy) {
                        g[i].push_back(p.second.second);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        h[i] = -1;
        f = false;
        dfs(i, i);
        if (f) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (ans[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
}