#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
ll r;
bool f;
vector<ll> x;
vector<ll> y;
vector<int> h;
vector<vector<int>> g;
vector<bool> used;
vector<bool> ans;

bool edge(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r;
}

void dfs(int v, int p) {
    used[v] = true;
    h[v] = h[p] + 1;
    for (int u : g[v]) {
        if (used[u]) {
            if ((h[v] - h[u]) % 2 == 0) {
                f = true;
            }
            continue;
        }
        dfs(u, v);
    }
}

void dfs2(int v) {
    ans[v] = true;
    for (int u : g[v]) {
        if (ans[u]) continue;
        dfs2(u);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    h.resize(n);
    x.resize(n);
    y.resize(n);
    g.resize(n);
    used.assign(n, false);
    ans.assign(n, false);
    map<ll, int> m;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        m[x[i]] = i;
    }
    sort(x.begin(), x.end());
    f = false;
    int cur = 0;
    if (x[1] - x[0] > r) {
        cur = 1;
    }
    for (int i = 1; i < n - 1; ++i) {
        if (x[i + 1] - x[i - 1] <= r) {
            f = true;
            continue;
        }
        if (x[i + 1] - x[i] > r) {
            if (f) {
                for (int j = cur; j <= i; ++j) {
                    ans[j] = true;
                }
            }
            cur = i + 1;
            f = false;
        }
    }
    if (f) {
        for (int j = cur; j < n; ++j) {
            ans[j] = true;
        }
    }
    vector<bool> ans2(n);
    for (int i = 0; i < n; ++i) {
        ans2[m[x[i]]] = ans[i];
    }
    for (int i = 0; i < n; ++i) {
        if (ans2[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
}