#include <bits/stdc++.h>
using namespace std;

constexpr int INF = 1e9;

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, q;
  cin >> n >> q;
  vector<int> a(n);
  for (int &x : a) {
    cin >> x;
    --x;
  }
  int max_k = n;
  vector<vector<int>> dp(max_k + 1, vector<int>(n, INF));
  vector<vector<int>> best_par(max_k + 1, vector<int>(n, -1));
  for (int i = n - 1; i >= 0; i--) {
    if (i == n - 1) {
      dp[1][i] = a[i];
    } else {
      dp[1][i] = max(dp[1][i + 1], a[i]);
    }
  }
  for (int k = 2; k <= max_k; k++) {
    stack<array<int, 3>> S;
    vector<int> b(n - k + 1);
    for (int i = n - 1; i >= 0; i--) {
      array<int, 2> opt_dp = {INF, INF};
      while (!S.empty() && a[S.top()[0]] <= a[i]) {
        opt_dp = min(opt_dp, {S.top()[1], S.top()[2]});
        S.pop();
      }
      if (i <= n - k) {
        array<int, 2> cur_dp = opt_dp;
        if (!S.empty()) {
          cur_dp = min(cur_dp, {dp[k - 1][S.top()[0]], S.top()[0]});
        }
        b[i] = cur_dp[0];
        best_par[k][i] = cur_dp[1];
      }
      opt_dp = min(opt_dp, {dp[k - 1][i], i});
      S.push({i, opt_dp[0], opt_dp[1]});
    }
    vector<int> ord(n - k + 1);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int x, int y) {
      return a[x] != a[y] ? a[x] < a[y] : b[x] < b[y];
    });
    dp[k][ord[0]] = 0;
    for (int i = 1; i <= n - k; i++) {
      dp[k][ord[i]] = dp[k][ord[i - 1]] + (a[ord[i]] != a[ord[i - 1]] || b[ord[i]] != b[ord[i - 1]]);
    }
  }
  vector<vector<int>> ans(max_k + 1);
  for (int k = 1; k <= n; k++) {
    int pos = 0;
    for (int i = 0; i < k; i++) {
      ans[k].push_back(i + 1 == k ? dp[1][pos] : a[pos]);
      pos = best_par[k - i][pos];
    }
  }
  while (q--) {
    int k, i;
    cin >> k >> i;
    --i;
    cout << 1 + ans[k][i] << "\n";
  }
}
