#include<bits/stdc++.h>
using namespace std;

using ll = long long;


int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    int r;
    cin >> n >> r;
    vector<vector<int>> g(n);
    vector<pair<int, int>> pts(n);
    vector<int> vals;
    for (auto& [x, y] : pts) {
        cin >> x >> y;
        for (int dx = -r; dx <= r; ++dx) vals.push_back(x + dx);
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    vector<int> occ(vals.size(), -1);
    vector<int> prv(n, -1);
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    sort(perm.begin(), perm.end(), [&](int i, int j) {return pts[i].second < pts[j].second;});
    for (auto i : perm) {
        int j = lower_bound(vals.begin(), vals.end(), pts[i].first) - vals.begin();
        for (int dx = -r; dx <= r; ++dx) {
            int x = j + dx;
            for (int k = occ[j]; k != -1 && pts[k].second >= pts[i].second - r; k = prv[k]) {
                int dy = pts[k].second - pts[i].second;
                if (dx * dx + dy * dy <= r * r) g[i].push_back(k), g[k].push_back(i);
            }
        }
        prv[i] = occ[j];
        occ[j] = i;
    }
    vector<int> comps(2 * n, 0);
    int col = 0;
    auto dfs = [&](auto dfs, int u, int c) -> void {
        comps[u + n * c] = col;
        for (auto to : g[u]) {
            if (!comps[to + n * (c ^ 1)]) dfs(dfs, to, c ^ 1);
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!comps[i]) {
            col++;
            dfs(dfs, i, 0);
        }
        if (!comps[i + n]) {
            col++;
            dfs(dfs, i, 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << (comps[i] == comps[i + n]);
    }
}