#include<bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto& i : a) cin >> i, --i;
    vector<int> nxt(n, n);
    {
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            while (st.size() && a[st.back()] < a[i]) {
                nxt[st.back()] = i;
                st.pop_back();
            }
            st.push_back(i);
        }
    }
    vector<int> pos;
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i + 1] <  a[i]) pos.push_back(i);
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i) b[a[i]] = i;
    vector<int> tr(2 * n);
    copy(a.begin(), a.end(), tr.begin() + n);
    for (int i = n - 1; i > 0; --i) tr[i] = min(tr[i << 1], tr[i << 1 | 1]);
    auto get = [&](int l, int r) -> int {
        int ret = n + 1;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) ret = min(ret, tr[l++]);
            if (~r & 1) ret = min(ret, tr[r--]);
        }
        return ret;
    };
    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; --i) suf[i] = max(suf[i + 1], a[i]);
    auto process = [&](auto process, int k, int c) -> int {
        if (k == 1) return 0;
        if (c == k - 1) {
            int pos = process(process, k, k - 2);
            int npos = min(n - 1, nxt[pos]);
            return npos;
        }
        int cur = 0;
        int move = 0;
        for (int i = 0; i < pos.size(); ++i) {
            if (pos[i] < cur) continue;
            if (c <= pos[i] - cur) return cur + c;
            c -= pos[i] - cur;
            move += pos[i] - cur;
            int j = b[get(cur + 1, min(n - (k - move - 1), nxt[cur]))];
            c--;
            move++;
            cur = j;
        }
        return cur + c;
    };
    while (q--) {
        int k, c;
        cin >> k >> c;
        int pos = process(process, k, c - 1);
        int j;
        if (c == k) j = n;
        else if (c == k - 1) j = min(n - 1, nxt[pos]);
        else j = b[get(pos + 1, min(n - (k - c), nxt[pos]))];
        if (j == n) cout << suf[pos] + 1 << '\n';
        else cout << a[pos] + 1 << '\n';
    }
}