//#pragma GCC optimize("O2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define int long long
const int INF = 1e12;
using namespace std;
 
signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> ab(n), bb(n, n);
 
    for (auto& i : ab)
        cin >> i;
 
    vector<int> st;
 
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && ab[i] >= ab[st.back()]) {
            st.pop_back();
        }
        if (!st.empty()) {
            bb[i] = st.back();
        }
        st.push_back(i);
    }

    vector<int> suf(n + 1, -INF);

    for (int i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], ab[i]);
    }
 
    for (int qwe = 0; qwe < q; qwe++) {
        int k, w;
        cin >> k >> w;
        int cnt = 0, ind = 0;
 
        while (cnt < min(w - 1, k - 2)) {
            int r = min(min(bb[ind] + 1, n), n - k + cnt + 2);
 
            int nind = -1;
 
            for (int i = ind + 1; i < r; i++) {
                if (nind == -1 || (ab[nind] > ab[i])) {
                    nind = i;
                }
            }
 
            ind = nind;
            cnt++;
        }
 
        if (w == k) {
            ind = min(bb[ind], n - 1);

            cout << suf[ind] << '\n';
        }
        else {
            cout << ab[ind] << '\n';
        }
    }
}