#include <bits/stdc++.h>
using namespace std;

#define int long long
//
const int inf = 1e18;
//
// mt19937_64 rng(time(0));

const int N = 2e6 + 2;

int tree[N];
void upd (int pos, int x) {
    for (; pos < N; pos += (pos & -pos)) {
        tree[pos] += x;
    }
}

int get (int pos) {
    int sum = 0;
    for (; pos > 0; pos -= (pos & -pos)) {
        sum += tree[pos];
    }
    return sum;
}

int get_sum (int l, int r) {
    return get(r) - get(l - 1);
}


void solve() {
    int r, c;
    cin >> r >> c;
    vector<int> a(c);
    for (auto &x : a)
        cin >> x;
    int ans = 0;
    for (auto &x : a) {
         ans += get_sum(x + 1, N - 1);
         upd(x, 1);
    }
    cout << ans << '\n';
}


signed main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}