#include <bits/stdc++.h>
using namespace std;


//
#define int long long
const int inf = 1e9;

//
// mt19937_64 rng(time(0));

const int N = 2e6 + 5;

int tree[N];
void upd (int pos, int x) {
    for (; pos < N; pos += (pos & -pos)) {
        tree[pos] += x;
    }
}

int get (int pos) {
    int sum = 0;
    for (; pos > 0; pos -= (pos & -pos)) {
        sum += tree[pos];
    }
    return sum;
}

int get_sum (int l, int r) {
    return get(r) - get(l - 1);
}


int tree2[N];
void upd2 (int pos, int x) {
    for (; pos < N; pos += (pos & -pos)) {
        tree2[pos] += x;
    }
}

int get2 (int pos) {
    int sum = 0;
    for (; pos > 0; pos -= (pos & -pos)) {
        sum += tree2[pos];
    }
    return sum;
}

int get_sum2 (int l, int r) {
    return get2(r) - get2(l - 1);
}

int n, m;
vector<vector<int>> a;

void solve() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) cin >> a[i][j];
    }
    if (n == 1) {

        int ans = 0;
        for (int i = 0; i < m; ++i) {
            ans += get_sum(a[0][i] + 1, N - 1);
            upd(a[0][i], 1);
        }
        cout << ans << '\n';
        return;
    }

    vector<int> suff(m);
    for (int i = m - 1; i >= 0; --i) {
        suff[i] = (i == m - 1 ? 0 : suff[i + 1]) + get(a[0][i] - 1);
        suff[i] += get2(a[1][i] - 1);
        upd2(a[1][i], 1);
        upd(a[0][i], 1);
        suff[i] += get2(a[0][i] - 1);
    }
    for (int i = 0; i < m; ++i) {
        upd(a[1][i], 1);
        upd2(a[1][i], -1);
    }
    int ans = suff[0];
 //   cout << ans << '\n';
    int cur = 0;
    for (int i = 0; i < m; ++i) {
        upd(a[0][i], -1);
        upd(a[1][i], -1);
        int res = (i + 1 == m ? 0 : suff[i + 1]);
        cur += get(a[0][i] - 1);
        cur += get(a[1][i] - 1);
        if (a[0][i] > a[1][i]) ++res;
        upd2(a[0][i], 1);
        upd2(a[1][i], 1);
        res += cur;
      //  cout << i + 1 << ' ' << res << '\n';
        ans = min(ans, res);

    }
    cout << ans << '\n';

}


signed main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}