#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<int> qrs(q);
    for (int i = 0; i < q; i++) {
        cin >> qrs[i];
    }
    vector<int> ans(n + 1);
    vector<bool> active(n, false);
    for (int i = 0; i < n; i++) {
        active[i] = (s[i] - '0') && ((i > 0 && s[i - 1] - '0') || (i + 1 < n && s[i + 1] - '0'));
        ans[0] += active[i];
    }
    vector<int> kek(n);
    set<pair<int, int> > buff;
    for (int i = 0; i < n; i++) {
        if (s[i] - '0') {
            continue;
        }
        int lft = 0, rgh = 0;
        if (i > 0 && s[i - 1] - '0') {
            if (active[i - 1]) {
                lft = 2;
            } else {
                lft = 1;
            }
        }
        if (i + 1 < n && s[i + 1] - '0') {
            if (active[i + 1]) {
                rgh = 2;
            } else {
                rgh = 1;
            }
        }
        int prir = 0;
        if (lft == 1 && rgh == 1) {
            prir = 3;
        } else if (lft == 1 || rgh == 1) {
            prir = 2;
        } else if (lft == 2 || rgh == 2) {
            prir = 1;
        }
        kek[i] = -prir;
        buff.emplace(-prir, i);
    }
    int cur = ans[0];
    auto update = [&](int i) -> void {
        if (i < 0 || i >= n) {
            return;
        }
        if (s[i] - '0') {
            cur -= active[i];
            active[i] = (s[i] - '0') && ((i > 0 && s[i - 1] - '0') || (i + 1 < n && s[i + 1] - '0'));
            cur += active[i];
        } else {
            buff.erase({kek[i], i});
            int lft = 0, rgh = 0;
            if (i > 0 && s[i - 1] - '0') {
                if (active[i - 1]) {
                    lft = 2;
                } else {
                    lft = 1;
                }
            }
            if (i + 1 < n && s[i + 1] - '0') {
                if (active[i + 1]) {
                    rgh = 2;
                } else {
                    rgh = 1;
                }
            }
            int prir = 0;
            if (lft == 1 && rgh == 1) {
                prir = 3;
            } else if (lft == 1 || rgh == 1) {
                prir = 2;
            } else if (lft == 2 || rgh == 2) {
                prir = 1;
            }
            kek[i] = -prir;
            buff.emplace(-prir, i);
        }
    };
    for (int j = 1; j <= n; j++) {
        if (buff.empty()) {
            ans[j] = ans[j - 1];
            continue;
        }
        int i = buff.begin()->second;
        buff.erase(buff.begin());
        s[i] = '1';
        update(i);
        update(i - 1);
        update(i + 1);
        update(i - 2);
        update(i + 2);
        ans[j] = cur;
    }
    for (int i = 0; i < q; i++) {
        cout << ans[qrs[i]] << '\n';
    }
    return 0;
}
