#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct r {
    int x, y;

    r(const int x = 0, const int y = 0) : x(x), y(y) {
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    auto can = [&](const r foo, const r bar) -> bool {
        int dx = foo.x - bar.x, dy = foo.y - bar.y;
        return 1ll * dx * dx + 1ll * dy * dy <= 1ll * k * k;
    };
    vector<r> a(n);
    map<pair<int, int>, int> have;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        have[{x, y}] = i;
    }
    vector<vector<int> > g(n);
    for (int v = 0; v < n; v++) {
        for (int x = a[v].x - k; x <= a[v].x + k; x++) {
            for (int y = a[v].y - k; y <= a[v].y + k; y++) {
                if (have.find({x, y}) != have.end() && can(r(x, y), a[v]) && !(a[v].x == x && a[v].y == y)) {
                    g[v].emplace_back(have[{x, y}]);
                    g[have[{x, y}]].emplace_back(v);
                }
            }
        }
    }
    vector<vector<int> > color(n, vector<int>(2, -1));
    int cur = 0;
    for (int v = 0; v < n; v++) {
        if (color[v][0] == -1 && color[v][1] == -1) {
            vector<pair<int, int> > q;
            q.reserve(n);
            q.emplace_back(v, 0);
            color[v][0] = cur;
            while (!q.empty()) {
                auto [v, c] = q.back();
                q.pop_back();
                for (auto u: g[v]) {
                    if (color[u][c ^ 1] == -1) {
                        color[u][c ^ 1] = cur;
                        q.emplace_back(u, c ^ 1);
                    }
                }
            }
            cur++;
        }
        cout << (color[v][0] == color[v][1]);
    }
    return 0;
}
