#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct r {
    int x, y;

    r(const int x = 0, const int y = 0) : x(x), y(y) {
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<r> a(n);
    vector<int> evr;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        evr.emplace_back(x);
    }
    ranges::sort(evr);
    evr.erase(unique(evr.begin(), evr.end()), evr.end());
    int m = (int) evr.size();
    vector<vector<pair<int, int> > > xs(m);
    for (int i = 0; i < n; i++) {
        xs[(int) (ranges::lower_bound(evr, a[i].x) - evr.begin())].emplace_back(a[i].y, i);
    }
    for (int i = 0; i < m; i++) {
        ranges::sort(xs[i]);
    }
    vector<vector<int> > g(n);
    for (int v = 0; v < n; v++) {
        int j = (int) (ranges::lower_bound(evr, a[v].x - k) - evr.begin());
        for (; j < m && evr[j] <= a[v].x + k; j++) {
            int x = evr[j];
            auto &ys = xs[j];
            int dx = abs(a[v].x - x);
            int l = 0, r = k + 1;
            while (r - l > 1) {
                int mid = (l + r) >> 1;
                (1ll * mid * mid + 1ll * dx * dx <= 1ll * k * k ? l : r) = mid;
            }
            int dy = l;
            int ly = a[v].y - dy, ry = a[v].y + dy;
            for (int i = (int) (ranges::lower_bound(ys, make_pair(ly, -1)) - ys.begin());
                 i < (int) ys.size() && ys[i].first <= ry; i++) {
                auto &[_, u] = ys[i];
                if (v != u) {
                    g[u].emplace_back(v);
                }
            }
        }
    }
    vector<vector<int> > color(n, vector<int>(2, -1));
    int cur = 0;
    for (int v = 0; v < n; v++) {
        if (color[v][0] == -1 && color[v][1] == -1) {
            vector<pair<int, int> > q;
            q.reserve(n);
            q.emplace_back(v, 0);
            color[v][0] = cur;
            while (!q.empty()) {
                auto [v, c] = q.back();
                q.pop_back();
                for (auto u: g[v]) {
                    if (color[u][c ^ 1] == -1) {
                        color[u][c ^ 1] = cur;
                        q.emplace_back(u, c ^ 1);
                    }
                }
            }
            cur++;
        }
        cout << (color[v][0] == color[v][1]);
    }
    return 0;
}
