#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct r {
    int x, y;

    r(const int x = 0, const int y = 0) : x(x), y(y) {
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    auto can = [&](const r foo, const r bar) -> bool {
        int dx = foo.x - bar.x, dy = foo.y - bar.y;
        return 1ll * dx * dx + 1ll * dy * dy <= 1ll * k * k;
    };
    vector<r> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    vector<vector<int> > g(n);
    for (int v = 0; v < n; v++) {
        for (int u = v + 1; u < n; u++) {
            if (can(a[v], a[u])) {
                g[v].emplace_back(u);
                g[u].emplace_back(v);
            }
        }
    }
    vector<vector<int> > color(n, vector<int>(2, -1));
    int cur = 0;
    auto dfs = [&](auto &&self, int v, int c) -> void {
        color[v][c] = cur;
        for (auto &u: g[v]) {
            if (color[u][c ^ 1] == -1) {
                self(self, u, c ^ 1);
            }
        }
    };
    for (int v = 0; v < n; v++) {
        if (color[v][0] == -1) {
            dfs(dfs, v, 0);
            cur++;
        }
        cout << (color[v][0] == color[v][1]);
    }
    return 0;
}
