#include<bits/stdc++.h>
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
struct pt {
    ll x=0, y=0;
    pt(){}
    pt (ll tx, ll ty) {x = tx, y = ty;}
    pt operator+ (pt b) {
        pt nw;
        nw.x = x + b.x;
        nw.y = y + b.y;
        return nw;
    }
    pt operator- (pt b) {
        pt nw;
        nw.x = x - b.x;
        nw.y = y - b.y;
        return nw;
    }
    ll len() {
        return x * x + y * y;
    }
    void input() {
        cin >> x >> y;
    }
};
bool flg = 0;
vector<vector<ll>> a;
vector<bool> ans;
vector<ll> clr;
vector<ll> wr;
void dfs(ll u, ll c) {
    clr[u] = c;
    ll nc = (c==1?2:1);
    for (ll i:a[u]) {
        if (clr[i] == 0) dfs(i, nc);
        if (clr[i] == c) {
            wr.push_back(u);
        }
    }
}
void paint(ll u) {
    ans[u] = 1;
    for (ll i:a[u]) if (!ans[i]) paint(i);
}
string f(pll x) {
    return to_string(x.first) + " " + to_string(x.second);
}
void solve() {
    ll n, r;
    cin >> n >> r;
    ll tr = r;
    r = r*r;
    pt p[n];
    a.resize(n);
    for (ll i=0;i<n;i++) p[i].input();
    // cout << "!" << endl;
    unordered_map<string, ll> ind;
    ind.reserve(10000);
    for (ll i=0;i<n;i++) {
        pll tmp = {p[i].x, p[i].y};
        ind[f(tmp)] = i+1;
    }

        for (ll i=0;i<n;i++) {
            pll cur = {p[i].x, p[i].y};
            for (ll x1=-tr; x1<=+tr;x1++) for (ll y1=-tr; y1<=+tr;y1++) {
                if (x1 * x1 + y1 * y1 > r) continue;
                pll nw = {cur.first+x1, cur.second+y1};
                if (nw == cur) continue;

                pt nwp;
                nwp.x = nw.first;
                nwp.y = nw.second;
                ll tt = ind[f(nw)];
                if (tt) {
                    // cout << cur.first << ' ' << cur.second << ' ' << nw.first << ' ' << nw.second << endl;
                    ll nd = tt-1;
                    a[nd].push_back(i);
                }
            }
        }

    ans.resize(n);
    clr.resize(n);
    for (ll i=0;i<n;i++) if (clr[i] == 0) dfs(i, 1);
    for (ll i:wr) if (!ans[i]) paint(i);
    for (ll i:ans) cout << i;
    cout << endl;
}

int main() {
    ll test=1;
    // cin >> test;
    while (test--) solve();
}
/*
3 4
000
0
1
2
3

4 3
1010
0
1
2

11 6
11010101001
5
2
0
1
4
3

12 1
011110101110
5
*/
