#include <bits/stdc++.h>
using namespace std;
#define int long long

int dist(pair<int, int> a, pair<int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}
int n, r;
vector<int> color, used;
vector<bool> check;
set<pair<int, int>> pos;
void dfs(int v, int c1, int c2, vector<pair<int, int>> &a, int d) {
    used[v] = c1;
    color[v] = c2;
    pos.erase({a[v].first, v});
    auto mn = *pos.lower_bound({a[v].first - r, 0});
    if (abs(mn.first - a[v].first) <= r) {
        int i = mn.second;
        dfs(i, 1 - c1, c2, a, d);
    }
}

void calcCheck(vector<pair<int, int>> &a, int nc) {
    vector<pair<int, pair<int, int>>> ev;
    for (int i = 0; i < n; i++) {
        if (used[i] == nc) {
            ev.push_back({a[i].first - r, {0, 0}});
            ev.push_back({a[i].first + r, {2, 0}});
            ev.push_back({a[i].first, {1, i}});
        }
    }
    sort(ev.begin(), ev.end());
    int cnt = 0;
    for (auto e: ev) {
        if (e.second.first == 1) {
            if (cnt > 1)
                check[color[e.second.second]] = true;
        }
        else if (e.second.first == 0)
            cnt++;
        else cnt--;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    for (int i = 0; i < n; i++) {
        pos.insert({a[i].first, i});
    }
    color.assign(n, -1);
    used.assign(n, -1);
    check.assign(n, false);
    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (color[i] == -1) {
            dfs(i, 1, cur, a, r * r);
            cur++;
        }
    }

    calcCheck(a);

    for (int i = 0; i < n; i++) {
        if (check[color[i]])
            cout << 1;
        else
            cout << 0;
    }
}