#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("unroll-loops", "O3")
#define int long long

struct fenv {
    vector<int> t;
    void build(int n) {
        t.assign(n, 0);
    }

    void update(int ind, int x) {
        for (; ind < t.size(); ind = (ind | (ind + 1)))
            t[ind] += x;
    }

    int get(int ind) {
        int res = 0;
        for (; ind >= 0; ind = (ind & (ind + 1)) - 1)
            res += t[ind];
        return res;
    }
};

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int> (c));

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j] = r * c - a[i][j];
        }
    }
    fenv tree;
    tree.build(r * c + 1);
    vector<vector<int>> dp(r + 1, vector<int> (c + 1, 2e18));
    dp[r][c] = 0;
    for (int i = r; i >= 1; i--) {
        for (int j = c; j >= 1; j--) {
            for (int l = 0; l < r - i; l++) {
                for (int m = 0; m < c; m++) {
                    tree.update(a[l][m], 1);
                }
            }
            for (int l = r - i; l < r; l++) {
                for (int m = 0; m < c - j; m++) {
                    tree.update(a[l][m], 1);
                }
            }
            {
                int cntAdd = 0;
                for (int k = c - j; k < c; k++) {
                    cntAdd += tree.get(a[r - i][k] - 1);
                    tree.update(a[r - i][k], 1);
                }
                for (int k = c - j; k < c; k++)
                    tree.update(a[r - i][k], -1);
                dp[i - 1][j] = min(dp[i - 1][j], dp[i][j] + cntAdd);
            }
            {
                int cntAdd = 0;
                for (int k = r - i; k < r; k++) {
                    cntAdd += tree.get(a[k][c - j] - 1);
                    tree.update(a[k][c - j], 1);
                }
                for (int k = r - i; k < r; k++)
                    tree.update(a[k][c - j], -1);
                dp[i][j - 1] = min(dp[i][j - 1], dp[i][j] + cntAdd);
            }
            for (int l = 0; l < r - i; l++) {
                for (int m = 0; m < c; m++) {
                    tree.update(a[l][m], -1);
                }
            }
            for (int l = r - i; l < r; l++) {
                for (int m = 0; m < c - j; m++) {
                    tree.update(a[l][m], -1);
                }
            }
        }
    }
    int ans = 2e18;
    for (int i = 0; i <= r; i++)
        ans = min(ans, dp[i][0]);
    for (int i = 0; i <= c; i++)
        ans = min(ans, dp[0][i]);
    cout << ans << "\n";
}