#include <bits/stdc++.h>
#define int long long
using namespace std;
const int N = 2e6, N1 = 1007, inf = 1e18;

int t[4*N];
int a[N1][N1];
int dp[N1][N1];

void update(int v, int l, int r, int pos, int zn) {
    if (l > pos || r <= pos) {
        return;
    }
    if (l == r - 1) {
        t[v] = zn;
        return;
    }
    int m = (r + l)/2;
    update(2*v, l, m, pos, zn);
    update(2*v + 1, m, r, pos, zn);
    t[v] = t[2*v] + t[2*v + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return t[v];
    }
    int m = (r + l)/2;
    return get(2*v, l, m, ql, qr) + get(2*v + 1, m, r, ql, qr);
}

signed main() {
    int r, c;
    cin >> r >> c;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    dp[0][0] = 0;
    //cout << endl;
    int mx = r*c + 1;
    for (int i = 0; i <= r; i++) {
        for (int j = 0; j <= c; j++) {
            if (i == 0 && j == 0) {
                continue;
            }
            //remove r
            for (int i1 = 0; i1 < i - 1; i1++) {
                for (int j = 0; j < c; j++) {
                    update(1, 0, mx, a[i1][j], 1);
                }
            }
            for (int j1 = 0; j1 < j - 1; j1++) {
                for (int i = 0; i < r; i++) {
                    update(1, 0, mx, a[i][j1], 1);
                }
            }
            //cout << "!! " << t[1] << endl;
            int ans1 = inf;
            if (i != 0) {
                if (j != 0) {
                    for (int it = 0; it < r; it++) {
                        update(1, 0, mx, a[it][j - 1], 1);
                    }
                }
                ans1 = dp[i - 1][j];
                for (int it = j; it < c; it++) {
                    ans1 += get(1, 0, mx, a[i - 1][it], mx);
                    update(1, 0, mx, a[i - 1][it], 1);
                }
                for (int it = j; it < c; it++) {
                    update(1, 0, mx, a[i - 1][it], 0);
                }
                if (j != 0) {
                    for (int it = 0; it < r; it++) {
                        update(1, 0, mx, a[it][j - 1], 0);
                    }
                }
            }
            int ans2 = inf;
            if (j != 0) {
                if (i != 0) {
                    for (int j1 = 0; j1 < c; j1++) {
                        update(1, 0, mx, a[i - 1][j1], 1);
                    }
                }
                ans2 = dp[i][j - 1];
                for (int it = i; it < r; it++) {
                    ans2 += get(1, 0, mx, a[it][j - 1], mx);
                    update(1, 0, mx, a[it][j - 1], 1);
                }
                for (int it = i; it < r; it++) {
                    update(1, 0, mx, a[it][j - 1], 0);
                }
                if (i != 0) {
                    for (int j1 = 0; j1 < c; j1++) {
                        update(1, 0, mx, a[i - 1][j1], 0);
                    }
                }
            }
            fill(t, t + 4*mx, 0);
            dp[i][j] = min(ans1, ans2);
            //cout << i << " " << j << "  " << ans1 << " " << ans2 << endl;
        }
    }
    int ans1 = inf;
    for (int i = 0; i < r; i++) {
        ans1 = min(ans1, dp[i][c]);
    }
    for (int i = 0; i < c; i++) {
        ans1 = min(ans1, dp[r][i]);
    }
    cout << ans1 << endl;
}
