#include <bits/stdc++.h>

using ll = long long;

const ll INF = 1e9;

using namespace std;

ll count(vector<ll>& v, ll l, ll r) {
    if (r == l + 1) {
        return 0;
    }
    ll mid = (l + r) / 2, k = 0;
    k += count(v, l, mid);
    k += count(v, mid, r);
    ll i = l, j = mid;
    vector<ll> a;
    while (i < mid && j < r) {
        if (v[i] < v[j]) {
            a.push_back(v[i]);
            i++;
            k += (j - mid);
        } else {
            a.push_back(v[j]);
            j++;
        }
    }
    if (j == r) {
        for (int x = i; x < mid; x++) {
            a.push_back(v[x]);
            k += (r - mid);
        }
    } else {
        for (int x = j; x < r; x++) {
            a.push_back(v[x]);
        }
    }
    for (int i = l; i < r; i++) {
        v[i] = a[i - l];
    }
    return k;
}

void solve() {
    ll r, c;
    cin >> r >> c;
    ll ans = INF;
    vector<ll> v(c);
    for (int i = 0; i < c; i++) {
        cin >> v[i];
    }
    cout << count(v, 0, c);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 0;

    #ifdef egg 
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}
