
#include <iostream>
#include <vector>
#include<set>
#include <algorithm>

using namespace std;

#define ll long long 
#define str string
#define vc vector
#define sz(a) (a).size()
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(), (a).rend()



int main()
{
	ll n, r; cin >> n >> r;
	vc<pair<ll,ll>> p(n);
	vc<ll> xs;
	for (int i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		p[i] = { x, i };
		xs[i] = x;
	}
	sort(its(xs));

	auto dist = [&](ll x1, ll x2) -> bool {
		return (x1 - x2)*(x1-x2) <= r*r;
	};

	//sort(its(p));
	for (auto [x, i] : p) {
		ll p1 = -1,  p2 = -1, p3 = -1, p4 = -1;
		auto it = upper_bound(its(xs), x);
		if (it != xs.end()) {
			if (dist(x, *it)) {
				p1 = x;
				if (it + 1 != xs.end()) {
					++it;
					if (dist(x, *it)) {
						p2 = x;
					}
				}
			}
		}
		it = upper_bound(its(xs), x);
		--it;
		if (it != xs.begin()) {
			--it;
			if (dist(x, *it)) {
				p3 = x;
				if (it != xs.begin()) {
					--it;
					if (dist(x, *it)) {
						p4 = x;
					}
				}
			}
		}
		bool ans = 0;
		if (p1 != -1 and p3 != -1 and dist(p1, p3)) ans = 1;
		if (p1 != -1 and p2 != -1 and dist(p1, p2)) ans = 1;
		if (p3 != -1 and p4 != -1 and dist(p3, p4)) ans = 1;
		cout << ans;
	}

}

