
#include <iostream>
#include <vector>
#include<set>
#include <algorithm>

using namespace std;

#define ll long long 
#define str string
#define vc vector
#define sz(a) (a).size()
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(), (a).rend()



int main()
{
	ll n, r; cin >> n >> r;
	vc<pair<ll,ll>> p(n);
	vc<ll> xs(n);
	for (int i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		p[i] = { x, y };
		xs[i] = x;
	}
	auto dist = [&](pair<ll, ll> p1, pair<ll, ll> p2) -> bool {
		return (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second) <= r * r;
	};
	vc<vc<ll>> g(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (dist(p[i], p[j]) and i!=j) g[i].push_back(j);
		}
	}
	vc<ll> used(n);
	vc<ll> good(n);
	vc<ll> h(n);
	auto dfs = [&](auto dfs, int u, int p) -> void
	{
		used[u] = 1;
		for (auto v : g[u]) {
			if (used[v] and v!=p) {
				if ((h[u] - h[v]+1) % 2) good[u] = 1;
			}
		}
		for (auto v : g[u]) {
			if (!used[v]) {
				h[v] = h[u] + 1;
				dfs(dfs, v, u);
			}
		}
	};
	
	for (int i = 0; i < n; ++i) if (!used[i]) dfs(dfs, i, -1);
	used = vc<ll>(n);
	auto ns = [&](auto ns, int u, int p) -> void {
		good[u] = 1;
		used[u] = 1;
		for (auto v : g[u]) {
			if (!used[v]) {
				ns(ns, v, u);
			}
		}
	};
	for (int i = 0; i < n; ++i) if (good[i] and !used[i]) ns(ns, i, i);
	for (int i = 0; i < n; ++i) cout << good[i];
}

