#include <iostream>
#include <vector>
#include<set>
#include<map>
#include <algorithm>

using namespace std;

#define ll long long 
#define str string
#define vc vector
#define sz(a) (a).size()
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(), (a).rend()



int main()
{
	ll n, m; cin >> n >> m;
	vc<vc<ll>> mat(n, vc<ll>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) cin >> mat[i][j];
	}
	vc<vc<ll>> dp(n, vc<ll>(m, n * n * m * m));
	dp[n - 1][m - 1] = 0;
	ll ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		for (int j = n - 1; j > i; --j) {
			if (mat[i][m - 1] > mat[j][m - 1]) ++ans;
		}
		dp[i][m - 1] = ans;
	}
	ans = 0;
	for (int i = m - 1; i >= 0; --i) {
		for (int j = m - 1; j > i; --j) {
			if (mat[n - 1][i] > mat[n - 1][j]) ++ans;
		}
		dp[n - 1][i] = ans;
	}

	auto count = [&](vc<ll>& v)->ll {
		ll as = 0;
		for (int i = 0; i < sz(v); ++i) {
			for (int j = 0; j < i; ++j) {
				if (v[j] > v[i])++as;
			}
		}
		return as;
	};
	vc<vc<ll>> invRow(n, vc<ll>(m));
	vc<vc<ll>> invRow1(n, vc<ll>(m));
	for (int j = 0; j < n; ++j) {
		ll cur = 0;
		for (int i = m - 1; i >= 0; --i) {
			ll c1 = 0;
			for (int k = m - 1; k > i; --k) {
				if (mat[j][i] > mat[j][k]) ++cur, ++c1;
			}
			invRow[j][i] = cur;
			invRow1[j][i] = c1;
		}
	}
	vc<vc<ll>> invCol(n, vc<ll>(m));
	vc<vc<ll>> invCol1(n, vc<ll>(m));
	for (int j = 0; j < m; ++j) {
		ll cur = 0;
		for (int i = n - 1; i >= 0; --i) {
			ll c1 = 0;
			for (int k = n - 1; k > i; --k) {
				if (mat[i][j] > mat[k][j]) ++cur, ++c1;
			}
			invCol[i][j] = cur;
			invCol1[i][j] = c1;
		}
	}
	vc<vc<ll>> dpCol(n, vc<ll>(m));
	vc<vc<ll>> dpRow(n, vc<ll>(m));
	vc<ll> cur;
	for (int j = m - 2; j >= 0; --j) {
		for (int i = n - 2; i >= 0; --i) {
			for (int k = j; k < m; ++k) cur.push_back(mat[i + 1][k]);
			sort(its(cur));
			for (int k = j; k < m; ++k) {
				auto it = lower_bound(its(cur), mat[i][k]) - cur.begin();
				dpRow[i][j] += it;
			}

			//dpRow[i][j] = dpRow[i+1][j] + invRow1[i][j];
		}
		cur.clear();
	}
	for (int j = n - 2; j >= 0; --j) {
		for (int i = m - 2; i >= 0; --i) {
			for (int k = j; k < n; ++k) cur.push_back(mat[k][i + 1]);
			sort(its(cur));
			for (int k = j; k < n; ++k) {
				auto it = lower_bound(its(cur), mat[k][i]) - cur.begin();
				dpCol[j][i] += it;
			}

			//dpRow[i][j] = dpRow[i+1][j] + invRow1[i][j];
		}
		cur.clear();
	}

	for (int i = n - 2; i >= 0; --i) {
		for (int j = m - 2; j >= 0; --j) {
			/*ans = 0;
			ll ans1 = 0, ans2 = 0;
			vc<ll> els1;
			vc<ll> els2;
			for (int x = i + 1; x < n; ++x) {
				for (int y = j + 1; y < m; ++y) {
					els1.push_back(mat[x][y]);
					els2.push_back(mat[x][y]);
				}
			}
			for (int y = j + 1; y < m; ++y) els1.push_back(mat[i][y]);
			for (int y = i + 1; y < n; ++y) els2.push_back(mat[y][j]);

			ans1 = 0;
			ans2 = 0;
			sort(its(els1));
			sort(its(els2));
			for (int x = i; x < n; ++x) {
				auto it = lower_bound(its(els1), mat[x][j]) - els1.begin();
				ans1 += it;
			}
			for (int x = j; x < m; ++x) {
				auto it = lower_bound(its(els2), mat[i][x]) - els2.begin();
				ans2 += it;
			}*/
			dp[i][j] = min(dp[i][j + 1] + invCol[i][j] + dpCol[i][j], dp[i + 1][j] + invRow[i][j] + dpRow[i][j]);
			/*sort(its(els));
			vc<ll> cur1, cur2;
			for (int x = i + 1; x < n; ++x) cur1.push_back(mat[x][j]);
			for (int y = j + 1; y < m; ++y) cur2.push_back(mat[i][y]);
			for (auto e : cur1) {
				auto it = lower_bound(its(els), e)-els.begin();
				ans += max(it - 1, 0);
			}
			for (auto e : cur2) {
				auto it = lower_bound(its(els), e) - els.begin();
				ans += max(it - 1, 0);
			}
			auto it = lower_bound(its(els), mat[i][j])-els.begin();
			ans += max(it - 1, 0);
			vc<ll> tmp;
			tmp.push_back(mat[i][j]);
			for (auto e : cur1) tmp.push_back(e);
			for (auto e : cur2) tmp.push_back(e);
			ans1 = count(tmp);
			for (int k = 0;k<sz(cur1)+sz(cur2);++k) tmp.pop_back();
			for (auto e : cur2) tmp.push_back(e);
			for (auto e : cur1) tmp.push_back(e);
			ans2 = count(tmp);
			dp[i][j] = ans + min(ans1, ans2)+dp[i][j];*/
		}
	}
	cout << dp[0][0];
}