#include<bits/stdc++.h>

using namespace std;

using ll = long long;
const ll INF = 1e18;
#define int ll

vector<vector<int> > g;

bool bfs(int start, int n) {
    vector<vector<int> > dist(n, vector<int>(2, INF));
    dist[start][0] = 0;
    queue<pair<int, int> > q;
    q.push({start, 0});
    while (!q.empty()) {
        auto [v, d] = q.front();
        q.pop();
        for (auto to: g[v]) {
            if (dist[to][1 - d] == INF) {
                dist[to][1 - d] = dist[v][d] + 1;
                q.push({to, 1 - d});
            }
        }
    }
    return dist[start][1] != INF;
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << bfs(i, n);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
