#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
using ll = long long;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int> suf(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		suf[i] = max(suf[i + 1], a[i]);
	}
	for (int _ = 0; _ < q; ++_) {
		int k, i;
		cin >> k >> i;
		if (k == 1) {
			cout << "    " << n << "\n";
		}
		else if (i != k) {
			cout << "    " << a[i - 1] << "\n";
		}
		else {
			if (k % 2 == 1) {
				cout << "    " << a[n - 1] << "\n";
			}
			else {
				cout << "   " << suf[i - 1] << "\n";
			}
		}
	}

	return 0;
}