#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
using namespace std;
using ll = long long;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<vector<int>> mini(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		int cur = i;
		for (int j = i; j < n; ++j) {
			if (a[j] < a[cur]) cur = j;
			mini[i][j] = cur;
		}
	}
	vector<int> suf(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		suf[i] = max(suf[i + 1], a[i]);
	}
	vector<int> more(n, n);
	vector<int> st;
	for (int i = 0; i < n; ++i) {
		while (!st.empty() && a[st.back()] < a[i]) {
			more[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	set<int> allk;
	vector<pair<int, int>> ques(q);
	for (int j = 0; j < q; ++j) {
		int k, i;
		cin >> k >> i;
		i--;
		ques[j] = { k, i };
		allk.insert(k);
	}

	vector<vector<int>> ans(n + 1); 
	for (int k: allk) {
		int curi = 0;
		for (int j = 1; j <= k; ++j) {
			if (j != k) {
				ans[k].push_back(a[curi]);
				if (j != k - 1) {
					curi = mini[curi + 1][min(more[curi], n - (k - j))];
				}
				else {
					if (more[curi] == n) curi = n - 1;
					else curi = more[curi];
				}
			}
			else {
				ans[k].push_back(suf[curi]);
			}
		}
	}
	for (int j = 0; j < q; ++j) {
		int k = ques[j].first, i = ques[j].second;
		cout << "    " << ans[k][i] << "\n";
	}

	return 0;
}