#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vii = vector<pair<int, int>>;
using pii = pair<int, int>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

ve<vi> g;

long long count_dist(pii &a, pii &b) {
        return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

ve<vb> used;

bool dfs(int v, int d) {
        used[v][d & 1] = true;
        for (auto u : g[v]) {
                if (used[u][0]) {
                        if (d % 2 == 0) {
                                return true;
                        }
                        continue;
                }
                if (used[u][1]) {
                        if (d % 2 == 1) {
                                return true;
                        }
                        continue;
                }
                if (dfs(u, d + 1)) return true;
        }
        return false;
}

void solve() {
        int n, r; cin >> n >> r;
        vi pts(n);
        vi nums;
        for (int i = 0; i < n; i++) {
                int x, y; cin >> x >> y;
                pts[i] = x;
                nums.push_back(x);
        }
        sort(all(nums));
        // vi inds(n);
        // iota(all(inds), 0);
        // sort(all(inds), [ & ](int i, int j) {
        //         return pts[i] < pts[j];
        // });
        auto getCoord = [ & ](int x) -> int {
                return lower_bound(all(nums), x) - nums.begin();
        };
        for (int i = 0 ; i< n; i++) {
                int c = getCoord(pts[i]);
                bool f1 = false, f2 = false, f3 = false;
                if (c < n - 2 && nums[c + 2] - nums[c] <= r) f1 = true;
                if (c >= 2 && nums[c] - nums[c - 2] <= r) f2 = true;
                if (c < n - 1 && c > 0 && nums[c + 1] - nums[c - 1] <= r) f3 = true;
                if (f1 || f2 || f3) cout << 1;
                else cout << 0;
        }
        cout << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test =========\n\n";
                #endif
        }

        return 0;
}