#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vii = vector<pair<int, int>>;
using pii = pair<long long, long long>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

ve<vi> g;

long long count_dist(pii &a, pii &b) {
        return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

ve<vb> used;

bool dfs(int v, int d) {
        used[v][d & 1] = true;
        for (auto u : g[v]) {
                if (used[u][0]) {
                        if (d % 2 == 0) {
                                return true;
                        }
                        continue;
                }
                if (used[u][1]) {
                        if (d % 2 == 1) {
                                return true;
                        }
                        continue;
                }
                if (dfs(u, d + 1)) return true;
        }
        return false;
}

void solve() {
        int n; long long r; cin >> n >> r;
        ve<pii> pts(n);
        for (int i = 0; i < n; i++) {
                cin >> pts[i].first >> pts[i].second;
        }
        g.clear();
        g.resize(n);
        for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                        if (count_dist(pts[i], pts[j]) <= r * r) {
                                g[i].push_back(j);
                                g[j].push_back(i);
                        }
                }
        }
        for (int i = 0; i < n; i++) {
                used.clear();
                used.resize(n, vb(2));
                (dfs(i, 0)) ? cout << 1 : cout << 0;
        }
        cout << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test =========\n\n";
                #endif
        }

        return 0;
}