#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

void solve() {
        int n, q; cin >> n >> q;
        vi a(n);
        for (int i = 0 ;i  <n ; i++) cin >> a[i];
        ve<vi> spt(30, vi(n));
        for (int i = 0; i < n; i++) {
                spt[0][i] = a[i];
        }
        for (int l = 1; l < 30; l++) {
                for (int i = 0; i < n; i++) {
                        spt[l][i] = min(spt[l - 1][i], spt[l - 1][min(n - 1, i + (1 << (l - 1)))]);
                }
        }
        auto get = [ & ](int l, int r) -> int {
                int k = __lg(r - l);
                return min(spt[k][l], spt[k][max(0, r - (1 << k))]);
        };
        vi suff(n + 1);
        for (int i = n - 1; i >= 0; i--) {
                suff[i] = max(suff[i + 1], a[i]);
        }
        vi el_ind(n + 1);
        for (int i = 0 ; i < n; i++) {
                el_ind[a[i]] = i;
        }
        ve<ve<pair<int, int>>> qs(n + 1);
        for (int j = 0; j < q; j++) {
                int k, i; cin >> k >> i;
                qs[k].emplace_back(i, j);
        }
        vi R(n);
        ve<pair<int, int>> stack;
        stack.emplace_back(n + 1, n);
        for (int i = n - 1; i >= 0; i--) {
                while (!stack.empty() && stack.back().first < a[i]) {
                        stack.pop_back();
                }
                R[i] = stack.back().second;
                stack.emplace_back(a[i], i);
        }
        vi ans(q);
        for (int k = 1; k <= n; k++) {
                if (qs[k].empty()) continue;
                sort(all(qs[k]));

                if (k == 1) {
                        for (const auto &[i, ind] : qs[k]) ans[ind] = suff[0];
                        continue;
                }

                int ind_in = 0;
                int i = 1;
                int l = 1;
                while (ind_in < (int)qs[k].size() && qs[k][ind_in].first == i) {
                        ans[qs[k][ind_in].second] = a[0];
                        ind_in++;
                }
                while (ind_in < (int)qs[k].size()) {
                        int r = n - k + i + 1;
                        r = min(r, R[l - 1] + 1);
                        int cur = get(l, r);
                        l = el_ind[cur] + 1;
                        i++;
                        if (i == k) {
                                cur = suff[el_ind[cur]];
                        }
                        while (ind_in < (int)qs[k].size() && qs[k][ind_in].first == i) {
                                ans[qs[k][ind_in].second] = cur;
                                ind_in++;
                        }
                }
        }
        for (auto el : ans) cout << el << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test =======\n\n";
                #endif
        }

        return 0;
}