#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


ll calc_need(string s) {
    ll n = (ll)s.size();
    ll ans = 0;
    auto bad = [&](ll i) -> bool {
        if (i > 0 && s[i - 1] == '1') {
            return false;
        }
        if (i + 1 < n && s[i + 1] == '1') {
            return false;
        }
        return true;
    };
    for (ll i = 0; i < n; ++i) {
        if (i + 1 == n && bad(i)) {
            ++ans;
        } else {
            if (s[i] == '1' && bad(i)) {
                s[i + 1] = '1';
                ++ans;
            }
        }
    }
    return ans;
}


void solve() {
    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    ll need = calc_need(s);
    vector<ll> res(need + 1);
    auto bad = [&](ll i) -> bool {
        if (s[i] == '0') {
            return false;
        }
        if (i > 0 && s[i - 1] == '1') {
            return false;
        }
        if (i + 1 < n && s[i + 1] == '1') {
            return false;
        }
        return true;
    };
    ll cur = 0;
    for (ll i = 0; i < n; ++i) {
        if (!bad(i) && s[i] == '1') {
            ++cur;
        }
    }
    res[0] = cur;
    ll cnt1 = count(all(s), '1');
    vector<bool> used(n);
    ll can2 = 0, can1 = 0;
    for (ll i = 1; i < n - 1; ++i) {
        if (s[i] == '0' && bad(i - 1) && bad(i + 1) && !used[i - 1] && !used[i + 1]) {
            ++can2;
            used[i - 1] = used[i + 1] = true;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!used[i] && bad(i)) {
            ++can1;
        }
    }
    while (q--) {
        ll k;
        cin >> k;
        if (cnt1 == 0) {
            if (k == 1) {
                cout << "0\n";
            } else {
                cout << k << '\n';
            }
        } else {
            ll ans = cur;
            ans += min(k, can2) * 3;
            k -= min(k, can2);
            ans += min(k, can1) * 2;
            k -= min(k, can1);
            ans += k;
            cout << ans << '\n';
        }
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}