#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

void solve() {
    dgt n, q;
    cin >> n >> q;
    vector<dgt> a(n);
    for (dgt i = 0; i < n; ++i)
        cin >> a[i];
    for (; q > 0; --q) {
        dgt k, c;
        cin >> k >> c;
        if (c < k || c % 2 == 0) {
            --c;
            cout << a[c] << '\n';
        } else {
            cout << a.back() << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
