#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using ll = long long;
using namespace std;
#define int long long
using namespace __gnu_pbds;
using ordered_set = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;
void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> val(n, vector <int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> val[i][j];
        }
    }
    ordered_set now, now1;
    vector <vector <int>> down(n + 1, vector <int> (m + 1, 0)), right(n + 1, vector <int> (m + 1, 0));
    for (int j = m - 1; j >= 0; --j) {
        now.clear();
        now1.clear();
        for (int i = n - 1; i >= 0; --i) {
            down[i][j] = down[i + 1][j];
            down[i][j] += (int)(now.order_of_key(val[i][j]));
            now.insert(val[i][j]);
            down[i][j] += (int)(now1.order_of_key(val[i][j]));
            for (int k = j + 1; k < m; ++k) {
                down[i][j] += (int)(now.size()) - (int)(now.order_of_key(val[i][k]));
                now1.insert(val[i][k]);
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        now.clear();
        now1.clear();
        for (int j = m - 1; j >= 0; --j) {
            right[i][j] = right[i][j + 1];
            right[i][j] += (int)(now.order_of_key(val[i][j]));
            now.insert(val[i][j]);
            right[i][j] += (int)(now1.order_of_key(val[i][j]));
            for (int k = i + 1; k < n; ++k) {
                right[i][j] += (int)(now.size()) - (int)(now.order_of_key(val[k][j]));
                now1.insert(val[k][j]);
            }
        }
    }
    vector <vector <int>> dp(n + 1, vector <int> (m + 1, 0));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i + 1][j] + right[i][j], dp[i][j + 1] + down[i][j]);
        }
    }
    cout << dp[0][0] << '\n';
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
