#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

bool ans[100000];
int col[100000];
ll x[100000], y[100000], r;
vector <int> g[100000];

map <pair <ll, ll>, vector <int>> m;
set <pair <ll, ll>> cool;

void dfs(int v, int c) {
    if (cool.contains({x[v] * 2 / r, y[v] *  2 / r}))
        ans[v] = 1;
    col[v] = c;
    for (int u : g[v]) {
        if (!col[u]) {
            dfs(u, 3 - c);
            if (ans[u])
                ans[v] = 1;
        } else if (col[u] == col[v] || ans[u])
            ans[v] = 1;
    }
}

void dfs2(int v) {
    col[v] = 1;
    for (int u : g[v]) {
        if (ans[v])
            ans[u] = 1;
        if (!col[u])
            dfs2(u);
    }
}

int main() {
    int n;
    ll R;
    cin >> n >> r;
    R = r * r;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        m[{x[i] * 2 / r, y[i] * 2 / r}].push_back(i);
        if (m[{x[i] * 2 / r, y[i] * 2 / r}].size() == 3)
            cool.insert({x[i] * 2 / r, y[i] * 2 / r});
    }
    for (int i = 0; i < n; ++i) {
        if (m[{x[i] * 2 / r, y[i] * 2 / r}].size() < 3) {
            pair <ll, ll> ngh[25];
            int ind = -1;
            for (int j = -2; j < 3; ++j)
                for (int k = -2; k < 3; ++k)
                    ngh[++ind] = {x[i] * 2 / r + j, y[i] * 2 / r + k};
            for (auto ng : ngh) {
                if (m[ng].size() < 3) {
                    for (int s : m[ng])
                        if (s != i && (x[i] - x[s]) * (x[i] - x[s]) + (y[i] - y[s]) * (y[i] - y[s]) <= R)
                            g[i].push_back(s);
                } else {
                    for (int s : m[ng])
                        if ((x[i] - x[s]) * (x[i] - x[s]) + (y[i] - y[s]) * (y[i] - y[s]) <= R) {
                            cool.insert({x[i] * 2 / r, y[i] * 2 / r});
                            break;
                        }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i)
        if (!cool.contains({x[i] * 2 / r, y[i] * 2 / r}) && !col[i])
            dfs(i, 1);
    for (int i = 0; i < n; ++i)
        col[i] = 0;
    for (int i = 0; i < n; ++i)
        if (!col[i])
            dfs2(i);
    for (auto p : cool)
        for (auto i : m[p])
            ans[i] = 1;
    for (int i = 0; i < n; ++i)
        cout << (int)ans[i];
    cout << endl;
}