#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define ff first
#define ss second

struct node {
    int mn;
    int pos;
};

struct sparce_table {
    int n;
    int LOG = 15;
    vector<vector<node>> st;
    node merge(node a, node b) {
        if (a.mn < b.mn) {
            return a;
        } return b;
    }
    sparce_table(int N, vector<int>&a) : n(N) {
        st.resize(LOG, vector<node>(n));
        for (int i = 0; i< n; ++i) st[0][i] = {a[i], i};

        for (int i = 1; i < LOG ; ++i) {
            for (int j = 0; j <= n - (1 << i); ++j) {
                st[i][j] = merge(st[i-1][j], st[i-1][j + (1 << (i-1))]);
            }
        }
    }
    int get_log(int p) {
        int l1 = 0, r1 = LOG, mid;
        while (r1 - l1 > 1) {
            mid = ((r1 + l1)>>1);
            if ((1 << mid) > p) r1 = mid;
            else l1 = mid;
        }
        return l1;
    }

    node get_ans(int l, int r) {
        int lg = get_log(r - l + 1);
        return merge(st[lg][l], st[lg][r - (1 << lg) + 1]);
    }
};

int n, q;
vector<int> a, r;

void solve() {
    cin >> n >> q;
    a.resize(n);
    r.resize(n, n-1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[j] > a[i]) {
                r[i] = j;
                break;
            }
        }
    }

    sparce_table st(n, a);

    vector<vector<int>> answers(n);
    for (int q = 1; q <= n; ++q) {
        answers[q-1].resize(q);
        if (q == 1) {
            answers[0][0] = n;
            continue;
        } else answers[q-1][0] = a[0];
        int cur = 0;
        int qq = 1;
        int rr = n - q;
        while (qq <= q-1) {
            node nxt = st.get_ans(cur + 1, min(cur + rr + 1, r[cur]));
            //cout << cur + 1 << ' ' << cur + rr + 1 << ' ' << r[cur] << '\n';
            rr -= (nxt.pos - cur) - 1;
            answers[q-1][qq] = nxt.mn;
            cur = nxt.pos;
            //cout << nxt.mn << ' ';
            qq++;
        }
        //cout << '\n';
        for (int i = cur + 1; i < n; ++i) {
            answers[q-1][q-1] = max(answers[q-1][q-1], a[i]);
        }
    }

    while (q--){
        int k, i; cin >> k >> i;
        cout << answers[k-1][i-1] << '\n';
    }

}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int ttt = 1;
    // cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
