#include <bits/stdc++.h>

using namespace std;
#define int long long

map<pair<int, int>, vector<int> > p;

const int N = (int) 1e5 + 10;

vector<int> g[N];

vector<int> new_g[2 * N];

bool used[2 * N], pobeda = false, used1[2 * N];
int ans[N];

void dfs(int v) {
    if (ans[v] == 1)
        pobeda = true;
    used[v] = true;
    for (auto u: new_g[v])
        if (!used[u])
            dfs(u);
}

int n;

void full(int v, int t) {
    if (t == 1)
        ans[v % n] = 1;
    used1[v] = true;
    used[v % n] = used[v % n + n] = true;
    for (auto u: new_g[v])
        if (!used1[u])
            full(u, t);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int r;
    cin >> n >> r;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> y[i];
    int cube = r / 2;
    if (r == 1) {
        cube = 1;
    }
    for (int i = 0; i < n; i++)
        p[{x[i] / cube, y[i] / cube}].emplace_back(i);
    for (const auto &[coord, v]: p) {
        int pL = coord.first, pR = coord.second;
        for (auto i: v) {
            for (int nL = pL - 3; nL <= pL + 3; nL++) {
                for (int nR = pR - 3; nR <= pR + 3; nR++) {
                    if (p.find({nL, nR}) == p.end()) continue;
                    if ((int) p[{nL, nR}].size() >= 3) continue;
                    if (nL == pL && nR == pR) continue;
                    for (auto ind: p[{nL, nR}]) {
                        if ((x[ind] - x[i]) * (x[ind] - x[i]) +
                            (y[ind] - y[i]) * (y[ind] - y[i]) <= r * r) {
                            g[i].emplace_back(ind);
                            if ((int) v.size() >= 3)
                                g[ind].emplace_back(i);
                        }
                    }
                }
            }
            for (auto j : v)
                if (i != j)
                    g[i].emplace_back(j);
        }
        if ((int) v.size() == 2) {
            // g[v[0]].emplace_back(v[1]);
            // g[v[1]].emplace_back(v[0]);
        } else if ((int) v.size() > 2) {
            for (auto i: v)
                ans[i] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j: g[i]) {
            // cout << i << " " << j << "\n";
            new_g[i].emplace_back(j + n), new_g[i + n].emplace_back(j);
        }
    }
    for (int i = 0; i < 2 * n; i++) used[i] = used1[i] = false;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        pobeda = false;
        dfs(i);
        if (used[i + n] || pobeda) {
            full(i, 1);
        } else {
            full(i, 0);
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i];
    return 0;
}
