#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e18;

struct Ft{
    int sz;
    vector<int> t;

    void init(int n) {
        sz = n;
        t.assign(n + 1, 0);
    }

    void upd(int i, int v = 1) {
        for (; i <= sz; i += (i&(-i))) {
            t[i] += v;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i > 0; i -= (i&(-i))) {
            res += t[i];
        }
        return res;
    }

    int get2(int i) {
        return get(sz) - get(i);
    }
};

void solve() {
    int n, m, ans = INF;
    cin >> n >> m;
    if (n == 1) {
        ans = 0;
        Ft f;
        f.init(m);
        for (int i = 1; i <= m; i++) {
            int x;
            cin >> x;
            ans += f.get(m) - f.get(x);
            f.upd(x);
        }
        cout << ans;
        return;
    }
    vector<int> a(m + 1), b(m + 1);
    for (int i = 1; i <= m; i++) cin >> a[i];
    for (int i = 1; i <= m; i++) cin >> b[i];
    vector<int> res1(m + 2), res2(m + 2);
    Ft f1, f2, f3, f4;
    f1.init(n * m);
    f2.init(n * m);
    f3.init(n * m);
    f4.init(n * m);
    for (int i = 1; i <= m; i++) {
        res1[i] = res1[i - 1];
        res1[i] += f1.get2(a[i]) + f2.get2(a[i]);
        f1.upd(a[i]);
        res1[i] += f1.get2(b[i]) + f2.get2(b[i]);
        f2.upd(b[i]);
    }
    for (int i = m; i >= 1; i--) {
        res2[i] = res2[i + 1];
        res2[i] += f4.get(b[i]) + f3.get2(b[i]);
        f4.upd(b[i]);
        res2[i] += f4.get(a[i]) + f3.get(a[i]);
        f3.upd(a[i]);
    }
    ans = res2[1];
    int res3 = 0;
    f1.init(n * m);
    f2.init(n * m);
    for (int i = 1; i <= m; i++) {
        res3 -= f1.get2(a[i]) + f2.get2(a[i]) + f1.get2(b[i]) + f2.get2(b[i]);
        f3.upd(a[i], -1);
        f4.upd(b[i], -1);
        f1.upd(a[i]);
        f2.upd(b[i]);
        res3 += f3.get(a[i]) + f4.get(a[i]) + f3.get(b[i]) + f4.get(b[i]);
        ans = min(ans, res1[i] + res2[i + 1] + res3);
    }
    cout << ans;
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
