#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,inline,unroll-loops")
#pragma GCC target("avx,avx2")
using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 5;

pair<int, int> v[MAXN];

vector<int> g[MAXN];

bool used[MAXN];

bool ans[MAXN];

ll sqr(ll x)
{
    return x * x;
}

ll dist(pair<int, int> a, pair<int, int> b)
{
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

bool h[MAXN];

bool ban = false;

vector<int> cmp;

void dfs(int x, bool deep)
{
    used[x] = 1;
    cmp.push_back(x);
    h[x] = deep;
    for (auto i : g[x])
    {
        if (!used[i])
        {
            dfs(i, deep ^ 1);
        }
        else if (h[i] == deep)
        {
            ban = true;
        }
    }
}

void solve()
{
    int n;
    ll r;
    cin >> n >> r;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        v[i] = {x, y};
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (dist(v[i], v[j]) <= r * r)
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            cmp.clear();
            ban = false;
            dfs(i, 0);
            if (ban)
            {
                for (auto i : cmp)
                {
                    ans[i] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        cout << ans[i];
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}