#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace std;

using namespace __gnu_pbds;

/*#pragma GCC optimize("O3,inline,unroll-loops")
#pragma GCC target("avx,avx2")*/
typedef long long ll;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int MAXN = 1005;
constexpr int INF = 1e9 + 7;

#define int long long

vector<vector<int>> a;

struct Fen
{
    vector<int> t;
    Fen(int n)
    {
        t.resize(n + 5, 0);
    }

    void add(int pos, int d)
    {
        for (int i = pos; i < t.size(); i += i & -i)
        {
            t[i] += d;
        }
    }

    int get(int pos)
    {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & -i)
        {
            ans += t[i];
        }
        return ans;
    }

};

int dp[MAXN][MAXN];

void solve()
{
    int r, c;
    cin >> r >> c;
    a.resize(r, {});
    for (int i = 0; i < r; i++)
    {
        for (int j = 0; j < c; j++)
        {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    Fen fen(r * c);
    for (int i = 1; i <= r * c; i++)
    {
        fen.add(i, 1);
    }
    int ans = INF;
    for (int i = 0; i <= r; i++)
    {
        for (int j = 0; j <= c; j++)
        {
            if (i == 0 && j == 0)
            {
                continue;
            }
            dp[i][j] = INF;
            int cnt1 = 0;
            int cnt2 = 0;
            int from = 0;
            if (j > 0)
            {
                for (int ii = i; ii < r; ii++)
                {
                    fen.add(a[ii][j - 1], -1);
                }
            }
            if (i != 0)
            {
                for (int jj = j; jj < c; jj++)
                {
                    fen.add(a[i - 1][jj], 1);
                }
                for (int jj = j; jj < c; jj++)
                {
                    cnt1 += fen.get(a[i - 1][jj] - 1);
                    fen.add(a[i - 1][jj], -1);
                }

                if (dp[i][j] > dp[i - 1][j] + cnt1)
                {
                    dp[i][j] = dp[i - 1][j] + cnt1;
                    from = 1;
                }
            }
            if (j != 0)
            {
                cnt1 = 0;
                for (int ii = i; ii < r; ii++)
                {
                    fen.add(a[ii][j - 1], 1);
                }
                for (int ii = i; ii < r; ii++)
                {
                    cnt1 += fen.get(a[ii][j - 1] - 1);
                    fen.add(a[ii][j - 1], -1);
                }

                if (dp[i][j] > dp[i][j - 1] + cnt1)
                {
                    dp[i][j] = dp[i][j - 1] + cnt1;
                    from = 2;
                }
            }


            if (i == r || j == c)
            {
                ans = min(ans, dp[i][j]);
            }
        }
        for (int j = 0; j < c; j++)
        {
            for (int ii = i; ii < r; ii++)
            {
                fen.add(a[ii][j], 1);
            }
        }
        if (i == r)
        {
            break;
        }
        for (int jj = 0; jj < c; jj++)
        {
            fen.add(a[i][jj], -1);
        }
    }
    cout << ans;

}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}