#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace std;

using namespace __gnu_pbds;

#pragma GCC optimize("O3,inline,unroll-loops")
#pragma GCC target("avx,avx2")
typedef long long ll;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int MAXN = 3e5 + 5;
constexpr int LOGN = 20;
constexpr int INF = 1e9 + 7;

#define int long long


struct Fen
{
    vector<int> t;
    Fen(int n)
    {
        t.resize(n + 5, 0);
    }

    void add(int pos, int d)
    {
        for (int i = pos; i < t.size(); i += i & -i)
        {
            t[i] += d;
        }
    }

    int get(int pos)
    {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & -i)
        {
            ans += t[i];
        }
        return ans;
    }

};

vector<int> st;

pair<int, int> spt[LOGN][MAXN];

void build(vector<int>& a)
{
    for (int i = 0; i < a.size(); i++)
    {
        spt[0][i] = {a[i], i};
    }
    for (int j = 1; j < LOGN; j++)
    {
        for (int i = 0; i < a.size(); i++)
        {
            if (i + (1 << (j - 1)) >= a.size())
            {
                break;
            }
            spt[j][i] = min(spt[j - 1][i], spt[j - 1][i + (1 << (j - 1))]);
        }
    }
}

vector<int> a;

pair<int, int> get(int l, int r)
{
    if (r < l)
    {
        abort();
    }
    if (l == r)
    {
        return spt[0][l];
    }
    auto step = st[r - l + 1];
    return min(spt[step][l], spt[step][r - (1 << step) + 1]);
}

vector<int> ansK[MAXN];

int blizer[MAXN];

int sufMax[MAXN];

void solve()
{
    int n, q;
    cin >> n >> q;

    st.push_back(0);
    st.push_back(0);
    st.push_back(1);
    for (int i = 3; i <= n; i++)
    {
        st.push_back(st[i / 2] + 1);
    }
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        a.push_back(x);
    }
    vector<pair<int, int>> bb;
    bb.push_back({INF, n});
    sufMax[n - 1] = a[n - 1];
    for (int i = n - 1; i >= 0; i--)
    {
        while (bb.back().first <= a[i])
        {
            bb.pop_back();
        }
        blizer[i] = bb.back().second;
        bb.push_back({a[i], i});
    }
    for (int i = n - 2; i >= 0; i--)
    {
        sufMax[i] = max(sufMax[i + 1], a[i]);
    }
    build(a);
    for (int i = 0; i < q; i++)
    {
        int k, ii;
        cin >> k >> ii;
        ii--;
        if (ii != k - 1)
        {
            cout << a[ii] << '\n';
        }
        else
        {
            if (k > 1 && k % 2 == 1)
            {
                cout << a.back() << '\n';
            }
            else
            {
                cout << sufMax[ii] << '\n';
            }
        }
        continue;
        if (ansK[k].size() > 0)
        {
            cout << ansK[k][ii - 1] << '\n';
            continue;
        }
        int now = k;
        int pos = 0;
        while (now > 0)
        {
            if (ansK[k].size() > 3)
            {
                break;
            }
            if (now == 1)
            {
                ansK[k].push_back(sufMax[pos]);
                break;
            }
            if (now == 2 && blizer[pos] == n)
            {
                int to = n - 1 - now + 1;
                auto gh = blizer[pos];
                gh = min(gh, to + 1);
                int tot = get(pos + 1, gh).second;
                ansK[k].push_back(a[pos]);
                pos = n - 1;
                now--;
                continue;
            }
            int to = n - 1 - now + 1;
            auto gh = blizer[pos];
            gh = min(gh, to + 1);
            int tot = get(pos + 1, gh).second;
            ansK[k].push_back(a[pos]);
            pos = tot;
            now--;
        }
        cout << ansK[k][ii - 1] << '\n';
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}