#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
// #pragma GCC optimize("O3, Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

// #define int ll

using vi = vector<int>;
using pii = pair<ll, ll>;
using vv = vector<vi>;
using vp = vector<pii>;

vi tree(1 << 20);
vi a;

int mx(int i, int j) {
    if (i == -1)return j;
    if (j == -1) return i;
    if (a[i] > a[j]) {
        return j;
    }
    return i;
}

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        tree[v] = tl;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm, tr);
    tree[v] = mx(tree[v * 2], tree[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return tree[v];
    }
    if (r <= tl || tr <= l) {
        return -1;
    }
    int tm = (tl + tr) / 2;
    return mx(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
}

void solve() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build(1, 0, n);
    vi br(n, n);
    vi st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            br[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    vi suf(n);
    suf[n - 1] = a[n - 1];
    for (int i = n - 1 - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    map<int, vi> res;
    for (int i = 0; i < q; ++i) {
        int k, p;
        cin >> k >> p;
        if (k == 1) {
            cout << n << '\n';
            continue;
        }
        if (res[k].empty()) {
            vi an = {a[0]};
            int j = 0;
            for (int _ = 0; _ < k - 1; ++_) {
                int ost = k - _ - 1;
                int r = n - ost + 1;
                r = min(r, br[j] + 1);
                int old = j;
                j = get(1, 0, n, j + 1, r);
                if (_ + 1 != k - 1) {
                    an.push_back(a[j]);
                } else {
                    an.push_back(suf[j]);
                }
            }
            res[k] = an;
        }
        cout << res[k][p - 1] << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t_ = 1;
    // cin >> t_;
    while (t_--) {
        solve();
    }
}
