#include <bits/stdc++.h>


using namespace std;


using ll = long long;


const ll inf = 1e18 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
ostream & operator <<(ostream &os, const vector<vector<T>> &a) {
    for (vector<T> el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int F(int x) {
    return (x & (-x));
}


void upd(vector<int> &f, int pos, int x) {
    for (int i = pos; i < int(f.size()); i += F(i)) {
        f.at(i) += x;
    }
}


int getpref(const vector<int> &f, int pos) {
    int res = 0;
    for (int i = pos; i > 0; i -= F(i)) {
        res += f.at(i);
    }
    return res;
}


ll funcRow(vector<int> &f, int r, int c, const vector<vector<int>> &a) {
    ll ans = 0;
    for (int i = c; i < int(a.at(r).size()); i++) {
        ll all = a.at(r).at(i) - 1;
        ll have = ll(getpref(f, a.at(r).at(i) - 1));
        ans += (all - have);
        upd(f, a.at(r).at(i), 1);
    }
    for (int i = c; i < int(a.at(r).size()); i++) {
        upd(f, a.at(r).at(i), -1);
    }
    return ans;
}


ll funcCol(vector<int> &f, int r, int c, const vector<vector<int>> &a) {
    ll ans = 0;
    for (int i = r; i < int(a.size()); i++) {
        ll all = a.at(i).at(c) - 1;
        ll have = ll(getpref(f, a.at(i).at(c) - 1));
        ans += (all - have);
        upd(f, a.at(i).at(c), 1);
    }
    for (int i = r; i < int(a.size()); i++) {
        upd(f, a.at(i).at(c), -1);
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a.at(i).at(j);
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1, inf));
    vector<int> f(r * c + 1, 0), prevf(r * c + 1, 0);
    dp.at(0).at(0) = 0;
    ll ans = inf;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            ll r1 = dp.at(i).at(j) + funcRow(f, i, j, a);
            ll r2 = dp.at(i).at(j) + funcCol(f, i, j, a);
            dp.at(i + 1).at(j) = min(dp.at(i + 1).at(j), r1);
            dp.at(i).at(j + 1) = min(dp.at(i).at(j + 1), r2);
            for (int k = i; k < r; k++) {
                upd(f, a.at(k).at(j), 1);
            }
            upd(prevf, a.at(i).at(j), 1);
        }
        f = prevf;
    }
    for (int i = 0; i < r; i++) {
        ans = min(ans, dp.at(i).at(c));
    }
    for (int j = 0; j < c; j++) {
        ans = min(ans, dp.at(r).at(j));
    }
    cout << ans;
    return 0;
}


/*2 2
1 4
2 3*/
