#include <bits/stdc++.h>
using namespace std;

using pp = pair<int, int>;
using ll = long long;

const int inf = 1e9 + 11;

void solve() {
    int n, R;
    cin >> n >> R;
    vector<pp> pts(n); //x, id
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts[i] = {x, i};
    }
    sort(pts.begin(), pts.end());
    vector<vector<pp> > blocks;
    int prv = -inf;
    for (auto [x, i]: pts) {
        if (prv + R >= x) {
            blocks.back().emplace_back(x, i);
        } else {
            blocks.emplace_back();
            blocks.back().emplace_back(x, i);
        }
        prv = x;
    }
    vector<bool> ans(n);
    for (auto &bl: blocks) {
        bool ok = false;
        for (int i = 0; i + 2 < int(bl.size()); i++) {
            if (bl[i].first + R >= bl[i + 2].first) {
                ok = true;
            }
        }
        if (ok) {
            for (auto [x, id]: bl) {
                ans[id] = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
