#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define F first
#define S second

int const maxn = 2e5;

vector<pair<int, int> > g[maxn][2];

int used[maxn][2];

vector<int> l;

int dist(pair<int, int> a, pair<int, int> b) {
    return (a.F - b.F) * (a.F - b.F) + (a.S - b.S) * (a.S - b.S);
}

void dfs(int v, int c) {
    l.pb(v);
    used[v][c] = 1;
    for (auto [u, f] : g[v][c]) {
        if (!used[u][f]) dfs(u, f);
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int> > a(n);
    l.reserve(n);

    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> a[i].F >> a[i].S;
        mp[a[i]] = i;
    }


    int R = r * r;
    for (int i = 0; i < n; i++) {
        int x = a[i].F, y = a[i].S;

        for (int nx = x - r; nx <= x + r; nx++) {
            for (int ny = y - r; ny <= y + r; ny++) {
                if (!mp.count({nx, ny})) continue;

                int ind = mp[{nx, ny}];

                if (i == ind) continue;

                if (dist(a[i], a[ind]) <= R) {
                    g[i][0].pb({ind, 1});
                    g[i][1].pb({ind, 0});
                    g[ind][0].pb({i, 1});
                    g[ind][1].pb({i, 0});
                }
            }
        }
    }



    vector<int> ans(n, -1);
    for (int i = 0; i < n; i++) {
        if (ans[i] != -1) continue;
        l.clear();

        dfs(i, 0);
        if (used[i][1]) {
            for (int v: l) ans[v] = 1;
        } else {
            for (int v: l) ans[v] = 0;
        }
    }

    for (int x : ans) {
        cout << x;
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}