#include <bits/stdc++.h>

using namespace std;

//#define int int64_t
#define ll int64_t

#define pb push_back
#define all(a) a.begin(), a.end()
#define F first
#define S second

int const maxn = 1e5 + 2;

vector<pair<int, int> > g[maxn][2];

int used[maxn][2];

pair<int, int> a[maxn];

vector<int> l;

ll dist(pair<int, int> a, pair<int, int> b) {
    return (ll) (a.F - b.F) * (ll) (a.F - b.F) + (ll) (a.S - b.S) * (ll) (a.S - b.S);
}


map<pair<int, int>, int> mp;

ll n, r;

void dfs(int v, int c) {
    l.pb(v);
    used[v][c] = 1;
    int x = a[v].F, y = a[v].S;

    for (int nx = x - r; nx <= x + r; nx++) {
        for (int ny = y - r; ny <= y + r; ny++) {
            if (!mp.count({nx, ny})) continue;

            int ind = mp[{nx, ny}];

            if (v == ind) continue;

            if (dist(a[v], a[ind]) <= r * r) {
                if (!used[ind][1 - c]) dfs(ind, 1 - c);
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    l.reserve(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].F >> a[i].S;
        mp[a[i]] = i;
    }


    vector<int> ans(n, -1);
    for (int i = 0; i < n; i++) {
        if (ans[i] != -1) continue;
        l.clear();

        dfs(i, 0);
        if (used[i][1]) {
            for (int v: l) ans[v] = 1;
        } else {
            for (int v: l) ans[v] = 0;
        }
    }

    for (int x: ans) {
        cout << x;
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
