#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ll int64_t

#define pb push_back
#define all(a) a.begin(), a.end()
#define F first
#define S second

int const maxn = 3e5;
int const inf = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    vector<int> r(n, n);
    vector<int> sf(n + 1);
    for (int i = n - 1; i > -1; i--) {
        sf[i] = max(a[i], sf[i + 1]);
    }

    vector<int> st;
    for (int i = 0; i < n; i++) {
        while (st.size() && a[st.back()] < a[i]) {
            r[st.back()] = i;
            st.pop_back();
        }
        st.pb(i);
    }

    int mx = a[0];

    vector<int> ans = {inf, inf, inf};

    for (int i = 1; i + 1 < n; i++) {
        int u = r[i];
        vector<int> e = {mx, a[i], sf[min(n - 1, u)]};
        if (ans > e) ans = e;
        mx = max(mx, a[i]);
    }

    while (m--) {
        int k, x;
        cin >> k >> x;
        x--;
        cout << ans[x] << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
