#include <iostream>

#include <vector>

#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    long long r, y;
    cin >> n >> r;
    vector <long long> x(n);
    vector <pair <long long, int>> b(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y;
        b[i] = {x[i], i};
    }
    sort(b.begin(), b.end());
    vector <int> cols(n, 0);
    int col = 1;
    for (int i = 0; i < n; i++) {
        if (i == 0 || b[i].first - b[i - 1].first <= r) {
            cols[i] = col;
        } else {
            col++;
            cols[i] = col;
        }
    }
    vector <int> good(col + 57, 0);
    for (int i = 1; i < n - 1; i++) {
        if (b[i + 1].first - b[i - 1].first <= r) {
            good[cols[i]] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << good[cols[i]];
    }
    return 0;
}