#include <iostream>

#include <vector>

#include <algorithm>

using namespace std;

vector <int> xx;
int flg = 0;

void dfs(int v, vector <vector <int>>& a, vector <int>& used, int col) {
    used[v] = col;
    xx.push_back(v);
    for (int i : a[v]) {
        if (used[i] == 0) {
            dfs(i, a, used, col % 2 + 1);
        }
        if (used[i] == col) {
            flg = 1;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    long long r;
    cin >> n >> r;
    vector <pair <long long, long long>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector <vector <int>> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r) {
                b[i].push_back(j);
                b[j].push_back(i);
            }
        }
    }
    vector <int> used(n, 0);
    vector <int> ans(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            flg = 0;
            xx = {};
            dfs(i, b, used, 1);
            if (flg) {
                for (int j : xx) {
                    ans[j] = 1;
                }
            }
        }
    }
    for (int i : ans) {
        cout << i;
    }
    return 0;
}