#include <iostream>

#include <vector>

#include <algorithm>

using namespace std;

pair <long long, vector <int>> g(vector <int> a, int n) {
    if (n == 1) {
        return {0, a};
    }
    vector <int> b(n / 2);
    vector <int> c(n - n / 2);
    for (int i = 0; i < n / 2; i++) {
        b[i] = a[i];
    }
    for (int i = n / 2; i < n; i++) {
        c[i - n / 2] = a[i];
    }
    pair <long long, vector <int>> x1 = g(b, n / 2);
    pair <long long, vector <int>> x2 = g(c, n - n / 2);
    vector <int> a1 = x1.second;
    vector <int> a2 = x2.second;
    int ans = 0;
    vector <int> pp;
    int ii = 0, jj = 0, n1 = n / 2, n2 = n - n / 2;
    while (ii < n1 && jj < n2) {
        if (a1[ii] <= a2[jj]) {
            pp.push_back(a1[ii]);
            ii++;
            ans += jj;
        } else {
            pp.push_back(a2[jj]);
            jj++;
        }
    }
    while (ii < n1) {
        pp.push_back(a1[ii]);
        ii++;
        ans += n2;
    }
    while (jj < n2) {
        pp.push_back(a2[jj]);
        jj++;
    }
    return {x1.first + x2.first + ans, pp};
}

long long f(vector <int>& a, vector <int>& b) {
    long long ans = g(b, b.size()).first;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int n = a.size(), ii = 0;
    for (int i : b) {
        while (ii < n && a[ii] <= i) {
            ii++;
        }
        ans += n - ii;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << g(a, n).first;
    return 0;
}