#include <iostream>

#include <vector>

using namespace std;

long long f(vector <int> a, vector <int> b) {
    long long ans = 0;
    for (int i : a) {
        for (int j : b) {
            if (i > j) {
                ans++;
            }
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector <vector <long long>> dp(n, vector <long long>(m, 1000000000000000000));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i != 0 || j != 0) {
                if (i != 0) {
                    vector <int> a1, a2;
                    for (int ii = 0; ii < n; ii++) {
                        for (int jj = 0; jj < m; jj++) {
                            if (!(ii >= i - 1 && jj >= j)) {
                                a1.push_back(a[ii][jj]);
                            }
                            if (ii == i - 1 && jj >= j) {
                                a2.push_back(a[ii][jj]);
                            }
                        }
                    }
                    dp[i][j] = min(dp[i][j], dp[i - 1][j] + f(a1, a2));
                }
                if (j != 0) {
                    vector <int> a1, a2;
                    for (int ii = 0; ii < n; ii++) {
                        for (int jj = 0; jj < m; jj++) {
                            if (!(ii >= i && jj >= j - 1)) {
                                a1.push_back(a[ii][jj]);
                            }
                            if (jj == j - 1 && ii >= i) {
                                a2.push_back(a[ii][jj]);
                            }
                        }
                    }
                    dp[i][j] = min(dp[i][j], dp[i][j - 1] + f(a1, a2));
                }
            }
        }
    }
    vector <int> a1, a2;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == n - 1 && j == m - 1) {
                a2.push_back(a[i][j]);
            } else {
                a1.push_back(a[i][j]);
            }
        }
    }
    long long ans = 1000000000000000000;
    for (int i = 0; i < n; i++) {
        vector <int> b1, b2;
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (jj == m - 1 && ii >= i) {
                    b1.push_back(a[ii][jj]);
                } else {
                    b2.push_back(a[ii][jj]);
                }
            }
        }
        ans = min(ans, dp[i][m - 1] + f(b1, b2));
    }
    for (int j = 0; j < m; j++) {
        vector <int> b1, b2;
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (ii == n - 1 && jj >= j) {
                    b1.push_back(a[ii][jj]);
                } else {
                    b2.push_back(a[ii][jj]);
                }
            }
        }
        ans = min(ans, dp[n - 1][j] + f(b1, b2));
    }
    cout << ans;
    return 0;
}