#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
//#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;
typedef long long ll;

template<typename T> ostream &operator<<(ostream &s,vector<T> v) {
    for(auto i:v) {s<<i<<' ';}
    return s;
}

vector<ll> tree;

void add(int v,int l,int r,int qx) {
    if(l>qx || r<=qx) {return;}
    if(r-l==1) {tree[v]++; return; }
    int m=(r+l)/2;
    add(v*2+1,l,m,qx);
    add(v*2+2,m,r,qx);
    tree[v]=tree[v*2+1]+tree[v*2+2];
}

ll gt(int v,int l,int r,int ql,int qr) {
    if(l>=qr || ql>=r) {return 0;}
    if(l>=ql && r<=qr) {return tree[v];}
    int m=(r+l)/2;
    return gt(v*2+1,l,m,ql,qr)+gt(v*2+2,m,r,ql,qr);
}

int main() {
    ll n,m;
    cin>>n>>m;
    tree.resize(n*m*4);
    vector<vector<ll>> a(n,vector<ll> (m));
    ll res=0;
    set<ll> st;
    vector<ll> arr;
    for(auto &i:a) {
        for(auto &j:i) {cin>>j;}
    }
    ll ans=n*m*n*m;
    for(int msk=0;msk<(1<<(m+n));msk++) {
        if(__builtin_popcount(msk)!=n) {continue;}
        arr.clear();
        int i=0,j=0;
        for(int it=0;it<n+m;it++) {
            if(i==n || j==m) {continue;}
            if((msk<<it)&1) {
                for(int it2=j;it2<m;it2++) {
                    arr.push_back(a[i][it2]);
                }
                i++;
            } else {
                for(int it2=i;it2<n;it2++) {
                    arr.push_back(a[it2][j]);
                }
                j++;
            }
        }
        ll res=0;
        for(auto &j:arr) {cin>>j;add(0,0,n*m+1,j);res+=gt(0,0,n*m+1,j+1,n*m+1);}
        tree.assign(n*m*4,0);
        if(res<ans) {ans=res;debug(msk)debug(arr)}
    }
    cout<<ans<<'\n';
    return 0;
}
