#include <iostream>
#include <string>
#include <vector>
using namespace std;
long long n, r;
vector <long long> x, y;
vector<short> g[10005];
vector <int> color, order, answer;
int ok = 1;
void dfs(int v, int col) {
	color[v] = col;
	order.push_back(v);
	for (auto elem : g[v]) {
		if (color[elem] == 0) {
			dfs(elem, 3 - col);
		} else if (color[v] == color[elem]) {
			ok = 0;
		}
	}
}
int main() {
	cin >> n >> r;
	x.resize(n); y.resize(n);
	for (int i = 0; i < n; i++) { cin >> x[i] >> y[i]; }
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	color.resize(n); order.resize(n); answer.resize(n);
	for (int i = 0; i < n; i++) {
		if (color[i] == 0) {
			ok = 1; order.clear();
			dfs(i, 1);
			for (auto elem : order) { answer[elem] = 1 - ok; }
		}
	}
	for (int i = 0; i < n; i++) {
		cout << answer[i];
	}
	return 0;
}