#include <bits/stdc++.h>
using namespace std;
#define int long long
struct pt{
    int x, y;
    pt(int x, int y): x(x), y(y){}
};
vector <pt> pts;
int dist(int u, int v){
    return (pts[u].x - pts[v].x) * (pts[u].x - pts[v].x) + (pts[u].y - pts[v].y) * (pts[u].y - pts[v].y);
}
vector <bool> used, color, ans, used2;
vector <vector <int> > g;
bool dfs_color(int u, bool c = false){
    used[u] = true;
    color[u] = c;
    bool res = false;
    for (auto& v: g[u]){
        if (!used[v]){
            if (dfs_color(v, !c))
                res = true;
        }
        else{
            if (color[u] == color[v]){
                res = true;
            }
        }
    }
    return res;
}
void dfs_ans(int u){
    used2[u] = true;
    ans[u] = true;
    for (auto& v: g[u]){
        if (!used2[v]){
            dfs_ans(v);
        }
    }
}
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, r;
    cin>>n>>r;
    used.resize(n);
    used2.resize(n, false);
    color.resize(n);
    ans.resize(n);
    g.resize(n);
    for (int i = 0, x, y; i < n; i++){
        cin>>x>>y;
        pts.emplace_back(x, y);
    }
    map <pair <int, int>, vector <int> > mp;
    for (int i = 0; i < n; i++){
        mp[{pts[i].x / (1e9 * r), pts[i].y / (1e9* r)}].push_back(i);
    }
    for (auto& [k, val]: mp){
        for (int i = 0; i < val.size(); i++){
            for (int j = i + 1; j < val.size(); j++){
                if (dist(val[i], val[j]) <= r * r){
                    g[val[i]].push_back(val[j]);
                    g[val[j]].push_back(val[i]);
                }
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (!used[i] && dfs_color(i)){
            dfs_ans(i);
        }
    }
    for (int i = 0; i < n; i++){
        cout<<ans[i];
    }
}