#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <queue>

using namespace std;

using ll = long long;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vi = vector<int>;
using vvi = vector<vi>;
using vvl =vector<vl>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

ll INF = 9e18;

ll r;
struct point {
	ll x, y;
};

ll dist2(point a, point b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

bool dfs(int v, vi& h, vb& was, vvi& g) {
	was[v] = 1;

	bool res = 0;
	for (auto u : g[v]) {
		if (!was[u]) {
			h[u] = h[v] + 1;

			res |= dfs(u, h, was, g);
		}
		else if (abs(h[v] - h[u]) % 2 == 0) {
			res = 1;
		}
	}

	return res;
}

void goodmark(int v, vb& mark, vi& resst, vvi& g) {
	resst[v] = 1;
	mark[v] = 1;

	for (auto u : g[v]) {
		if (mark[u]) continue;

		goodmark(u, mark, resst, g);
	}
}

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);
	ll n;

	cin >> n >> r;

	vvi g(n, vi{});
	vector <point> mas(n);

	for (int i = 0; i < n; i++) {
		cin >> mas[i].x >> mas[i].y;
	}

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (dist2(mas[i], mas[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}

	vb was(n);
	vb was2(n);
	vi resst(n);
	vi h(n);

	for (int i = 0; i < n; i++) {
		if (!was[i]) {
			bool res = dfs(i, h, was, g);

			if (res) {
				goodmark(i, was2, resst, g);
			}
		}
	}

	for (auto now : resst) {
		cout << now;
	}
}