#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<ll> v, par, r;

ll get(ll a) {
    if (par[a] != a) par[a] = get(par[a]);
    return par[a];
}

ll vall(ll a) {
    a = get(a);
    if (v[a] > 1) return v[a];
    return 0;
}

void unite(ll a, ll b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    if (r[a] > r[b]) swap(a, b);
    if (r[a] == r[b]) ++r[b];
    v[b] += v[a];
    par[a] = b;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    v.resize(n);
    par.resize(n);
    r.resize(n);
    for (ll i = 0; i < n; ++i) {
        par[i] = i;
        v[i] = s[i] - '0';
    }
    for (ll i = 1; i < n; ++i) {
        if (s[i] == '1' && s[i - 1] == '1') unite(i - 1, i);
    }
    vector<ll> fp, sp, tp, gp;
    for (ll i = 0; i < n; ++i) {
        if (v[get(i)] != 0) continue;
        if (i > 0 && v[get(i - 1)] == 1 && i < n - 1 && v[get(i + 1)] == 1) fp.push_back(i);
        else if (i > 0 && v[get(i - 1)] == 1 || i < n - 1 && v[get(i + 1)] == 1) sp.push_back(i);
        else if (i > 0 && s[i - 1] == '1' || i < n - 1 && s[i + 1] == '1') tp.push_back(i);
        else gp.push_back(i);
    }
    ll ss = 0;
    vector<bool> used(n);
    for (ll i = 0; i < n; ++i) {
        ll x = get(i);
        if (!used[x]) {
            used[x] = true;
            ss += vall(x);
        }
    }
    vector<ll> dp(fp.size() + sp.size() + tp.size() + gp.size() + 1);
    dp[0] = ss;
    ll y = 1;
    for (ll x : fp) {
        if (!((x > 0 && v[get(x - 1)] == 1 && x < n - 1 && v[get(x + 1)] == 1))) {
            sp.push_back(x);
            continue;
        }
        v[x] = 1;
        if (x > 0 && v[get(x - 1)] != 0) {
            ss -= vall(x - 1);
            unite(x - 1, x);
        }
        if (x < n - 1 && v[get(x + 1)] != 0) {
            ss -= vall(x + 1);
            unite(x, x + 1);
        }
        ss += vall(x);
        dp[y] = ss;
        ++y;
    }
    for (ll x : sp) {
        if (!(x > 0 && v[get(x- 1)] == 1 || x < n - 1 && v[get(x + 1)] == 1)) {
            tp.push_back(x);
            continue;
        }
        v[x] = 1;
        if (x > 0 && v[get(x - 1)] != 0) {
            ss -= vall(x - 1);
            unite(x - 1, x);
        }
        if (x < n - 1 && v[get(x + 1)] != 0) {
            ss -= vall(x + 1);
            unite(x, x + 1);
        }
        ss += vall(x);
        dp[y] = ss;
        ++y;
    }
    for (ll i : gp) tp.push_back(i);
    for (ll x : tp) {
        v[x] = 1;
        if (x > 0 && v[get(x - 1)] != 0) {
            ss -= vall(x - 1);
            unite(x - 1, x);
        }
        if (x < n - 1 && v[get(x + 1)] != 0) {
            ss -= vall(x + 1);
            unite(x, x + 1);
        }
        ss += vall(x);
        dp[y] = ss;
        ++y;
    }
    for (ll i = 0; i < q; ++i) {
        ll b;
        cin >> b;
        cout << dp[b] << '\n';
    }
}