// #pragma GCC optimize ("O3")
// #pragma GCC optimize ("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<ll> > v, dp;
vector<vector<vector<ll>>> dd;
ll n, m;

ll cb(ll x, ll y, ll a, ll b, ll k) {
    if (x == n || y == m) return 0;
    --k;
    ll res = dd[k][x][y];
    if (a != n) {
        res -= dd[k][a][y];
    }
    if (b != m) {
        res -= dd[k][x][b];
    }
    if (a != n && b != m) res += dd[k][a][b];
    return res;
}

ll gen(ll x, ll y) {
    if (x == n || y == m) return 0;
    if (dp[x][y] != 0) return dp[x][y];
    ll res = 0, s = 0;
    for (ll i = x; i < n; ++i) {
        s += cb(x, y + 1, n, m, v[i][y]);
        s += cb(i + 1, y, n, y + 1, v[i][y]);
    }
    res = s;
    s = 0;
    for (ll j = y; j < m; ++j) {
        s += cb(x + 1, y, n, m, v[x][j]);
        s += cb(x, j + 1, x + 1, m, v[x][j]);
    }
    res += gen(x, y + 1);
    s += gen(x + 1, y);
    dp[x][y] = min(res, s);
    return min(res, s);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    v.resize(n, vector<ll>(m));
    dp.resize(n, vector<ll>(m));
    for (auto &i: v) for (ll &j: i) cin >> j;
    dd.resize(n * m, vector<vector<ll>>(n, vector<ll>(m)));
    for (ll k = 0; k < n * m; ++k) {
        dd[k][n - 1][m - 1] = v[n - 1][m - 1] <= k;
        for (ll i = n - 2; i >= 0; --i) {
            dd[k][i][m - 1] = dd[k][i + 1][m - 1] + (v[i][m - 1] <= k);
        }
        for (ll j = m - 2; j >= 0; --j) {
            dd[k][n - 1][j] = dd[k][n - 1][j + 1] + (v[n - 1][j] <= k);
        }
        for (ll i = n - 2; i >= 0; --i) {
            for (ll j = m - 2; j >= 0; --j) {
                dd[k][i][j] = dd[k][i + 1][j] + dd[k][i][j + 1] - dd[k][i + 1][j + 1];
                if (v[i][j] <= k) dd[k][i][j]++;
            }
        }
    }
    cout << gen(0, 0) << '\n';
}
