// Author: Boris_Ber

#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

#define int long long
typedef pair<int,int> pii;
typedef long long ll;
typedef long double ld;

int tmp;

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].ff >> tmp;
        a[i].ss = i;
    }
    sort(all(a));
    vector<int> hs;
    vector<bool> ans(n, false);
    for (int i = 2; i < n; ++i) {
        if (a[i].ff - a[i - 2].ff <= r) {
            hs.pb(a[i].ss);
            ans[a[i].ss] = true;
        }
    }
    for (int i: hs) {
        for (int cur = i - 1; cur >= 0 && !ans[a[cur].ss]; --cur) {
            if (a[cur + 1].ff - a[cur].ff <= r) {
                ans[a[cur].ss] = true;
            } else break;
        }
        for (int cur = i + 1; cur < n && !ans[a[cur].ss]; ++cur) {
            if (a[cur].ff - a[cur - 1].ff <= r) {
                ans[a[cur].ss] = true;
            } else break;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << (ans[i] ? '1' : '0');
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
