// Author: Boris_Ber

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

#define int long long
typedef pair<int,int> pii;
typedef long long ll;
typedef long double ld;
typedef tree<int, bool, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int tmp;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m)), dp(n, vector<int>(m));
    for (auto &i: a) for (auto &j: i) cin >> j;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            int ans = 1e18;
            if (j != m - 1) {
                ans = dp[i][j + 1];
                ordered_set s;
                for (int ki = i; ki < n; ++ki) {
                    for (int kj = j + 1; kj < m; ++kj) {
                        s.insert({a[ki][kj], true});
                    }
                }
                for (int ki = n - 1; ki >= i; ki--) {
                    ans += s.order_of_key(a[ki][j]);
                    s.insert({a[ki][j], true});
                }
            }
            if (i != n - 1) {
                int ans2 = dp[i + 1][j];
                ordered_set s;
                for (int ki = i + 1; ki < n; ++ki) {
                    for (int kj = j; kj < m; ++kj) {
                        s.insert({a[ki][kj], true});
                    }
                }
                for (int kj = m - 1; kj >= j; kj--) {
                    ans2 += s.order_of_key(a[i][kj]);
                    s.insert({a[i][kj], true});
                }
                ans = min(ans, ans2);
            }
            if (ans == 1e18) ans = 0;
            dp[i][j] = ans;
        }
    }
    cout << dp[0][0];
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
