// #pragma GCC optimize("O3,unroll-loops,Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(),v.end()


const int maxn = 1e5 + 1;

mt19937 rnd(52525252);

inline int get_inv(const vector<int> &a) {
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        for (int j = i + 1; j < a.size(); ++j) {
            ans += a[i] > a[j];
        }
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int ans = 1e9;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto &elem:a)
        for (auto &e:elem)
            cin>>e;
    for (int i = 0; i < (1 << (m + n - 1)); ++i) {
        vector<int> now;
        int i1 = 0, j1 = 0;
        for (int j = 0; true; ++j) {
            if (i&(1<<j)) {
                for (int k=i1; k<n; ++k) {
                    now.push_back(a[k][j1]);
                }
                ++j1;
            } else {
                for (int k=j1; k<m; ++k) {
                    now.push_back(a[i1][k]);
                }
                ++i1;
            }
            if (i1 == n || j1 == m) {
                break;
            }
        }
        ans = min(ans, get_inv(now));
    }
    cout<<ans;
    return 0;
}
