#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC Optimize("O3,Ofalse,unroll-loops")
#pragma GCC Target("avx,avx2,bmi,bmi2,sse,sse2")
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define endl "\n"
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MAX_NM = 3e5;

int nm;

struct F {
    ll t[MAX_NM];
    F() {
        memset(t, 0, sizeof(t));
    }
    void inc(int i, int x) {
        for (; i < nm; i = (i|(i + 1))) {
            t[i] += x;
        }
    }
    int sum(int r) {
        int ans = 0;
        for (; r >= 0; r = (r&(r+1))-1) {
            ans += t[r];
        }
        return ans;
    }
};

F L, R;

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    nm = n * m;
    vector<vector<int>> a(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    auto calc = [&]() {
        vector<vector<ll>> to(n, vector<ll>(m));
        if (m > n) {
            for (int i = 0; i < n; ++i) {
                ll ans = 0;
                for (int j = m - 1; j >= 0; --j) {
                    ans += L.sum(a[i][j]);
                    L.inc(a[i][j], 1);
                    ans += R.sum(a[i][j]);
                    for (int x = i + 1; x < n; ++x) {
                        R.inc(a[x][j], 1);
                        ans += L.sum(MAX_NM-1) - L.sum(a[x][j]);
                    }
                    to[i][j] = ans;
                }
                for (int j = m - 1; j >= 0; --j) {
                    L.inc(a[i][j], -1);
                    for (int x = i + 1; x < n; ++x) {
                        R.inc(a[x][j], -1);
                    }
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                for (int i = n - 1; i >= 0; --i) {
                    ll ans = 0;
                    for (int x = m - 1; x >= j; --x) {
                        ans += L.sum(a[i][x]);
                        L.inc(a[i][x], 1);
                        ans += R.sum(a[i][x]);
                    }
                    for (int x = m - 1; x >= j; --x) {
                        L.inc(a[i][x], -1);
                    }
                    to[i][j] = ans;
                    for (int x = j; x < m; ++x) {
                        R.inc(a[i][x], 1);
                    }
                }
                for (int i = n - 1; i >= 0; --i) {
                    for (int x = j; x < m; ++x) {
                        R.inc(a[i][x], -1);
                    }
                }
            }
            // for (int i = 0; i < n; ++i) {
            //     for (int j = 0; j < m; ++j) {
            //         cout << a[i][j] << ' ';
            //     }
            //     cout << endl;
            // }
            // for (int i = 0; i < n; ++i) {
            //     for (int j = 0; j < m; ++j) {
            //         cout << to[i][j] << ' ';
            //     }
            //     cout << endl;
            // }
        }
        return to;
    };
    auto x = calc();
    vector<vector<int>> b(m, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            b[j][i] = a[i][j];
        }
    }
    a = b;
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 0));
    swap(n, m);
    auto y = calc();
    swap(n, m);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i + 1][j] + x[i][j], dp[i][j + 1] + y[j][i]);
        }
    }
    cout << dp[0][0] << endl;
}