#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/list_update_policy.hpp>

constexpr int INF = 1e9;

typedef
__gnu_pbds::tree<
int,
__gnu_pbds::null_type,
std::less<int>,
__gnu_pbds::rb_tree_tag,
__gnu_pbds::tree_order_statistics_node_update> tree;

void solve()
{
  int r, c;
  std::cin >> r >> c;
  std::vector<std::vector<int>> a(r, std::vector<int>(c));
  for (int i = 0; i < r; ++i) {
    for (int j = 0; j < c; ++j)
      std::cin >> a[i][j];
  }
  tree rt;
  int val = 0;
  for (int j = c - 1; j > 0; --j) {
    val += rt.order_of_key(a[0][j]);
    rt.insert(a[0][j]);    
  }
  std::cout << val << '\n';
}

int main()
{
  int t = 1;
#ifdef LOCAL
  freopen("in/c.txt", "r", stdin);
  freopen("out/c.txt", "w", stdout);
  std::cin >> t;
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  for (int i_t = 0; i_t < t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case: " << i_t + 1 << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}