#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gr;
vector<int> used;
vector<int> c;

bool dfs(int v, int p, int timer) {
    used[v] = timer;
    c[v] = c[p] ^ 1;
    bool f = false;
    for (auto to : gr[v]) {
        if (used[to] != timer) {
            f |= dfs(to, v, timer);
        } else if (c[to] == c[v]) {
            f = true;
        }
    }
    return f;
}

int dist(pair<int, int> a, pair<int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    gr.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dist(p[i], p[j]) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    vector<int> ans(n);
    c.resize(n);
    used.resize(n);
    int t = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            bool f = dfs(i, i, t);
            if (f) {
                for (int j = 0; j < n; ++j) {
                    if (used[j] == t) {
                        ans[j] = 1;
                    }
                }
            }
        }
    }
    for (auto elem : ans) {
        cout << elem;
    }
}