#include <bits/stdc++.h>
typedef long long ll;

using namespace std;

vector<vector<int>> gr;
vector<int> c;

bool dfs(int v, int p) {
    c[v] = c[p] ^ 1;
    bool f = false;
    for (auto to : gr[v]) {
        if (!c[to]) {
            f |= dfs(to, v);
        } else if (c[to] == c[v]) {
            f = true;
        }
    }
    return f;
}

ll dist(pair<ll, ll> a, pair<ll, ll> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    gr.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dist(p[i], p[j]) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    vector<int> ans(n);
    c.resize(n);
    int t = 1;
    for (int i = 0; i < n; ++i) {
        if (!c[i]) {
            c[i] = 2 * t;
            bool f = dfs(i, i);
            if (f) {
                for (int j = 0; j < n; ++j) {
                    if (c[j] == 2 * t || c[j] == 2 * t + 1) {
                        ans[j] = 1;
                    }
                }
            }
            t++;
        }
    }
    for (auto elem : ans) {
        cout << elem;
    }
}