#include <bits/stdc++.h>
using namespace std;

void dfs(int v, vector<int> &used, vector<vector<int>> &g, bool &flag) {
    for (auto u : g[v]) {
        if (used[u] == used[v]) {
            flag = 1;
            break;
        }
        if (!used[u]) {
            used[u] = 3-used[v];
            dfs(u, used, g, flag);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> v(n);
    for (int i = 0; i< n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            if ((v[i].first - v[j].first)*(v[i].first - v[j].first) + (v[i].second - v[j].second )*(v[i].second  - v[j].second )<= r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        vector<int> used(n);
        bool flag = 0;
        used[i] = 1;
        dfs(i, used, g, flag);
        cout << flag;

    }
}