#include <bits/stdc++.h>
using namespace std;
const int nMax=1<<17;
bool used[nMax*2];
using ll = long long;
struct pt {
    ll x;
    ll y;
    ll id;
    bool operator<(pt oth) const{
        return tie(x,y,id) < tie(oth.x,oth.y,oth.id);
    }
    pt fs() const{
        return pt{y,x,id};
    }
    ll dist(pt oth) const {
        return (x-oth.x)*(x-oth.x) + (y-oth.y)*(y-oth.y);
    }
};
pt pts[nMax];
pt ptsor[nMax];
vector<int> g[nMax*4];
int cmp[nMax*2];
bool goodCmp[nMax];
int cmpCnt=1;
vector<int> great;
void dfs(int v) {
    cmp[v]=cmp[v^nMax]=cmpCnt;
    if (used[v^nMax])
        goodCmp[cmpCnt]=true;
    used[v] =true;
    for (auto u : g[v]) {
        if (used[u])continue;
        dfs(u);
    }

}
void dfs2(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (used[u])continue;
        dfs2(u);
    }
}
int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("ouput.txt","w",stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    ll n,r;
    cin >> n >> r;
    for (int i=0;i<n;i++) {
        cin>>pts[i].x >> pts[i].y;
        pts[i].id = i;
        ptsor[i]=pts[i];
    }
    sort(pts,pts+n);
    int i=0,j=0;
    set<pt> cur;
    cur.insert(pts[0].fs());
    for (int k =0;k<n;k++) {
        while (pts[i].x<pts[k].x-r) {
            cur.erase(pts[i].fs());
            i++;
        }
        while (j+1 <n && pts[j+1].x<=pts[k].x+r) {
            cur.insert(pts[++j].fs());
        }
        vector<pt> curr;
        {
            auto it = cur.find(pts[k].fs());
            for (int i =0;i<10 && it !=cur.begin();i++) {
                curr.push_back((--it)->fs());
            }
        }
        {
            auto it = cur.find(pts[k].fs());
            for (int i =0;i<10 && it !=cur.end();i++) {
                curr.push_back((it++)->fs());
            }
        }
        for (int j=0; j < curr.size();j++) {
            for (int k1 = 0;k1<j;k1++) {
                if (curr[j].dist(curr[k1]) > r*r)continue;
                g[curr[j].id].push_back(curr[k1].id^nMax);
                g[curr[k1].id].push_back(curr[j].id^nMax);
                g[curr[j].id^nMax].push_back(curr[k1].id);
                g[curr[k1].id^nMax].push_back(curr[j].id);
                for (int k2 = 0;k2 < k1; k2++) {
                    if (curr[j].dist(curr[k2]) <= r *r &&
                        curr[k1].dist(curr[k2]) <= r *r) {
                        great.push_back(curr[k1].id);
                        great.push_back(curr[j].id);
                        great.push_back(curr[k2].id);
                        if (curr[j].dist(curr[k])<=r*r ||
                            curr[k1].dist(curr[k])<=r*r ||
                            curr[k2].dist(curr[k])<=r*r )great.push_back(k)
                    }
                }
            }
        }
    }
    sort(great.begin(),great.end());
    great.erase(unique(great.begin(),great.end()),great.end());
    for (int i =0;i<n;i++) {
        if (cmp[i])continue;
        cmpCnt++;
        dfs(i);
    }
    for (int i=0;i<n;i++) {
        for (auto u : great) {
            if (ptsor[u].dist(ptsor[i])<=r*r)
                goodCmp[cmp[i]]=true;
        }
        cout << (goodCmp[cmp[i]] ? 1 : 0);
    }
}
