#include <bits/stdc++.h>
using namespace std;
#define int long long
struct point {
    int x,y;
};
bool sml(point &p1, point &p2, int d) {
    int dx = p1.x - p2.x, dy = p1.y - p2.y;
    if (dx * dx + dy * dy <= d * d) {
        return true;
    }
    return false;
}
void dfs1(vector<point> &pts, vector<int> &colors, int u, int col, int r) {
    colors[u] = col;
    for (int v = 0; v < pts.size(); v++) {
        if (colors[v] != 0) continue;
        if (sml(pts[u], pts[v] ,r)) {
            dfs1(pts, colors, v, col, r);

        }
    }
}
bool dfs2(vector<point> &pts, vector<int> &colors, int u, int col, int r) {
    colors[u] = col;
    for (int v = 0; v < pts.size(); v++) {
        if (v == u) continue;
        if (sml(pts[u], pts[v], r)) {
            if (colors[v] == col) return true;
            if (colors[v] == -col) continue;
            bool che = dfs2(pts, colors, v, -col, r);
            if (che) return true;
        }
    }
    return false;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n,r;
    cin >> n >> r;
    vector<point> pts(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
    }
    vector<int> colors(n);
    int col = 1;
    for (int i = 0; i < n; i++) {
        if (colors[i] == 0) {
            dfs1(pts, colors, i, col++, r);
        }
    }
    vector<bool> used_c(col);
    vector<bool> good_c(col);
    vector<int> colors2(n);
    for (int i = 0; i < n; i++) {
        if (used_c[colors[i]]) continue;
        used_c[colors[i]] = true;
        good_c[colors[i]] = dfs2(pts, colors2, i, 1, r);
    }
    for (int i = 0; i < n; i++) {
        if (good_c[colors[i]]) {
            cout << '1';
        }else {
            cout << '0';
        }
    }
    cout << '\n';
}