#pragma GCC optimize("03")
#include <bits/stdc++.h>
#include <bits/extc++.h>
#pragma GCC target("avx2")
using namespace std;
using namespace __gnu_pbds;
#define int long long
struct point {
    int x,y,id;
};
bool sml(point &p1, point &p2, int d) {
    int dx = p1.x - p2.x, dy = p1.y - p2.y;
    if (dx * dx + dy * dy <= d * d) {
        return true;
    }
    return false;
}
void dfs1(vector<vector<int>> &g, vector<int> &colors, int u, int col) {
    colors[u] = col;
    for (auto v : g[u]) {
        if (colors[v] != 0) continue;
        dfs1(g, colors, v, col);
    }
}
bool dfs2(vector<vector<int>> &g, vector<int> &colors, int u, int col) {
    colors[u] = col;
    for (auto v : g[u]) {
        if (colors[v] == col) return true;
        if (colors[v] == -col) continue;
        bool che = dfs2(g, colors, v, -col);
        if (che) return true;
    }
    return false;
}
bool comp(point &p1, point &p2) {
    return p1.x < p2.x;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n,r;
    cin >> n >> r;
    vector<point> pts(n);
    cc_hash_table<int, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
        pts[i].id;
    }
    sort(pts.begin(), pts.end(), comp);
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        if (sml(pts[i], pts[i + 1], r)) {
            g[pts[i].id].push_back(pts[i + 1].id);
            g[pts[i + 1].id].push_back(pts[i].id);
        }
        if (i + 2 < n) {
            if (sml(pts[i], pts[i + 2], r)) {
                g[pts[i].id].push_back(pts[i + 2].id);
                g[pts[i + 2].id].push_back(pts[i].id);
            }
        }
    }
    vector<int> colors(n);
    int col = 1;
    for (int i = 0; i < n; i++) {
        if (colors[i] == 0) {
            dfs1(g, colors, i, col++);
        }
    }
    vector<bool> used_c(col);
    vector<bool> good_c(col);
    vector<int> colors2(n);
    for (int i = 0; i < n; i++) {
        if (used_c[colors[i]]) continue;
        used_c[colors[i]] = true;
        good_c[colors[i]] = dfs2(g, colors2, i, 1);
    }
    for (int i = 0; i < n; i++) {
        if (good_c[colors[i]]) {
            cout << '1';
        }else {
            cout << '0';
        }
    }
    cout << '\n';
}
