#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
// #define LOCAL

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> points(n);
    vector<bool> marked(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        points[i] = make_pair(x, i);
    }
    sort(all(points));
    for (int i = 0; i < n; ++i) {
        auto [x, v] = points[i];
        int l = upper_bound(all(points), make_pair(x + r, n)) - lower_bound(all(points), make_pair(x + 1, 0));
        int l2 = lower_bound(all(points), make_pair(x, 0)) - lower_bound(all(points), make_pair(x - r, 0)) - 1;
        if (l > 1 || l2 > 1) {
            marked[i] = true;
        }
    }
    bool mark = false;
    vector<int> used;
    int prev = points[0].first;
    for (int i = 0; i < n; ++i) {
        auto [x, v] = points[i];
        if (x - prev > r) {
            if (mark) {
                for (auto el : used) {
                    marked[el] = true;
                }
            }
            used.clear();
            mark = false;
        }
        used.push_back(v);
        mark = (mark || marked[v]);
        prev = x;
    }
    if (mark) {
        for (auto el : used) {
            marked[el] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (marked[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}