#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5 + 2;
pair<int, int> x[maxn];
array<int, 3> xcop[maxn];
int n, r;

bool used[maxn * 2];

int cmp[maxn * 2], comp = 1;

long long sqr(long long x) {
    return x * x;
}
int idx(int x1, int y1) {
    array<int, 3> empt = {x1, y1, 0};
    auto it = lower_bound(xcop, xcop + n, empt) - xcop;
    if (it == n) return -1;
    if (xcop[it][0] != x1 || xcop[it][1] != y1) return -1;
    return xcop[it][2];
}

vector<int> g[maxn];

void dfs(int v) {
    used[v] = 1;
    cmp[v] = comp;
    for (auto u : g[v]) {
        if (used[u]) continue;
        dfs(u);
    }
}

void brainrot() {
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        cin >> x[i].first >> x[i].second;
        xcop[i] = {x[i].first, x[i].second, i};
    }
    sort(xcop, xcop + n);
    for (int i1 = 0; i1 < n; i1++) {
        int x1 = x[i1].first, y1 = x[i1].second;
        for (int i = -r; i <= r; i++) {
            for (int j = -r; j <= r; j++) {
                if (i == 0 && j == 0) continue;
                if (i * i + j * j <= r * r) {
                    int pos = idx(i + x1, j + y1);
                    if (pos == -1 || used[pos + n]) continue;
                    g[pos].push_back(i1 + n);
                    g[pos + n].push_back(i1);
                    g[i1].push_back(pos + n);
                    g[i1 + n].push_back(pos);
                }
            }
        }
    }
    for (int i = 0; i < n * 2; i++) {
        if (used[i]) continue;
        dfs(i);
        comp++;
    }
    for (int i = 0; i < n; i++) {
        if (cmp[i] == cmp[i + n]) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int iq = 1;
    // cin >> iq;
    while (iq--) brainrot();
}
