#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
#define int long long


const int maxn = 1e6;
int r, c;
int dp[maxn], a[maxn];
vector<int> recans[maxn];

int countrec(vector<int> & a, vector<int> & b) {
    int ans = 0, n = b.size();
    for (auto i : a) {
        auto it = lower_bound(b.begin(), b.end(), i) - b.begin();
        ans += it;
    }
    return ans;
}

int f[maxn];

void inc(int pos, int val) {
    for (; pos < maxn; pos += (pos) & (-pos)) {
        f[pos] += val;
    }
}

int getans(int pos) {
    int ans = 0;
    for (; pos > 0; pos -= (pos) & (-pos)) {
        ans += f[pos];
    }
    return ans;
}

int getans(int l, int r) {
    return getans(r) - getans(l);
}

int countrec1(vector<int> & v) {
    int n = v.size();
    vector<pair<int, int>> v1;
    for (int i = 0; i < n; i++) {
        v1.push_back({v[i], i});
    }
    sort(v1.begin(), v1.end());
    int alans = 0;
    for (auto [x, y] : v1) {
        inc(y + 1, 1);
        alans += getans(y + 1, n + 1);
    }
    for (auto [x, y] : v1) {
        inc(y + 1, -1);
    }
    return alans;
}

void recalc(int n, int m) {
    if (n == 0 || m == 0) {
        dp[n * c + m] = 0;
        return;
    }
    if (dp[n * c + m] != -1) return;
    //   n - 1, m;    
    recalc(n - 1, m);
    int ans1 = dp[(n - 1) * c + m];
    vector<int> v1;
    for (int j = m - 1; j >= 0; j--) {
        v1.push_back(a[(n - 1) * c + j]);
    }
    ans1 += countrec(v1, recans[(n - 1) * c + m]);
    ans1 += countrec1(v1);

    //   n, m - 1,    
    recalc(n, m - 1);
    int ans2 = dp[n * c + m - 1];
    vector<int> v2;
    for (int j = n - 1; j >= 0; j--) {
        v2.push_back(a[j * c + m - 1]);
    }
    ans2 += countrec(v2, recans[n * c + m - 1]);
    ans2 += countrec1(v2);
    dp[n * c + m] = min(ans1, ans2);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            recans[n * c + m].push_back(a[i * c + j]);
        }
    }
    sort(recans[n * c + m].begin(), recans[n * c + m].end());
}

void brainrot() {
    cin >> r >> c;
    fill(dp, dp + maxn, -1);
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i * c + j];
        }
    }
    for (int i = 0; i < r; i++) {
        for (int j = 0; j * 2 < c; j++) {
            swap(a[i * c + j], a[i * c + c - j - 1]);
        }
    }
    for (int i = 0; i * 2 < r; i++) {
        for (int j = 0; j < c; j++) {
            swap(a[i * c + j], a[(r - i - 1) * c + j]);
        }
    }
    recalc(r, c);
    cout << dp[r * c + c] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int iq = 1;
    // cin >> iq;
    while (iq--) brainrot();
}
