#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;


struct point {
    int x, y;
    point () {}
    point (int x, int y): x(x), y(y) {}
};

int dst2(point a, point b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return dx * dx + dy * dy;
}

pii srtd(pii p) {
    if (p.first > p.second) swap(p.first, p.second);
    return p;
}

void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<bool> a) {
    for (bool i : a) cout << i << ' ';
    cout << '\n';
}

int n, r, B, k;
vector<point> v;
vector<int> ind;
vector<bool> sup;
vector<point> pos;
vector<vector<int>> pts(k);
vector<point> neib;
vector<vector<int>> g;
vector<bool> used;
vector<int> clr;


void dfs(int u, int p) {
    used[u] = 1;
    if (p == -1) clr[u] = 0;
    else clr[u] = clr[p] ^ 1;
    if (p != -1 && sup[p]) sup[u] = 1;
    for (int v : g[u]) {
        if (sup[v]) sup[u] = 1;
        if (used[v]) continue;
        dfs(v, u);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> r;
    int lb = 1, rb = r + 1;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].x >> v[i].y;
    }

    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (dst2(v[i], v[j]) <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    clr.resize(n);
    sup.resize(n, 0);
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i, -1);
    }
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            if (clr[i] == clr[j]) sup[i] = 1;
        }
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i, -1);
    }
    for (int i = 0; i < n; i++) cout << sup[i];
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.