#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;
using i64 = long long;
using ld = long double;

const i64 S = 1e5 + 10;
i64 query[S];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	i64 n, q; cin >> n >> q;
	string s; cin >> s;

	i64 cntSuper = 0, alr = 0, cntEx = 0;
	bool empty = true;

	for (auto x : s) {
		if (x == '1') empty = false;
	}

	if (empty) {
		for (i64 x = 1; x <= q; ++x) {
			i64 val; cin >> val;
			if (val <= 1) {
				cout << 0 << endl;
			}
			else {
				cout << val << endl;
			}
		}
		exit(0);
	}

	for (i64 x = 0; x < (i64)s.size(); ++x) {
		if (x + 4 < (i64)s.size() && s.substr(x, 5) == "01010") {
			++cntSuper;
			x += 3;
		}
		else if (x == 0 && x + 3 < (i64)s.size() && s.substr(x, 4) == "1010") {
			++cntSuper;
			x += 2;
		}
		else if (x == (i64)s.size() - 4 && s.substr(x, 4) == "0101") {
			++cntSuper;
			break;
		}
		else if (x == (i64)s.size() - 3 && s.substr(x, 3) == "101") {
			++cntSuper;
			break;
		}
		else if (s[x] == '1') {
			i64 r = x;
			while (r + 1 < (i64)s.size() && s[r + 1] == '1') ++r;
			if (r == x) ++cntEx;
			else alr += (r - x + 1);
			x = r;
		}
	}

	for (i64 x = 0; x <= s.size(); ++x) {
		if (x == 0) query[x] = alr;
		else {
			if (cntSuper) {
				query[x] = query[x - 1] + 3;
				--cntSuper;
			}
			else if (cntEx) {
				query[x] = query[x - 1] + 2;
				--cntEx;
			}
			else query[x] = query[x - 1] + 1;
		}
	}

	for (i64 x = 1; x <= q; ++x) {
		i64 val; cin >> val;
		cout << query[val] << endl;
	}
}