// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define vc vector
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
// #define endl "\n"

const ll inf = 1e15;
const ld eps = 1e-6;

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }

    return 0;
}

void solve()
{
    ll n, q;
    cin >> n >> q;

    vc<ll> a(n);
    for (ll &i : a)
        cin >> i;

    vc<ll> sufmax = a;
    for (ll i = n - 2; i >= 0; --i)
        remax(sufmax[i], sufmax[i + 1]);

    while (q--)
    {
        ll k, pos;
        cin >> k >> pos;

        if (pos <= k - 1)
            cout << a[k - 1];
        else
            cout << sufmax[k];
    }
}