#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;


using ll = long long;
using pii = pair<int, int>;

int r, c;
vector<vector<int>> a;
vector<int> now;
ll ans = 0;



vector<int> merge(vector<int> b) {
    int n = b.size();
    if (b.size() <= 10) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (b[j] < b[i]) ++ans;
            }
        }
        sort(b.begin(), b.end());
        return b;
    }
    vector<int> f, s;
    int m = n / 2;
    for (int i = 0; i < m; ++i) {
        f.push_back(b[i]);
    }
    for (int i = m; i < n; ++i) {
        s.push_back(b[i]);
    }
    f = merge(f);
    s = merge(s);
    int ptr_f = 0, ptr_s = 0;
    int sz_f = m, sz_s = n - m;
    vector<int> res;
    while (ptr_f != sz_f && ptr_s != sz_s) {
        if (f[ptr_f] <= s[ptr_s]) {
            res.push_back(f[ptr_f]);
            ++ptr_f;
        } else {
            res.push_back(s[ptr_s]);
            ans += sz_f - ptr_f;
            ++ptr_s;
        }
    }
    while (ptr_f != sz_f) {
        res.push_back(f[ptr_f]);
        ++ptr_f;
    }
    while (ptr_s != sz_s) {
        res.push_back(s[ptr_s]);
        ++ptr_s;
    }
    return res;
}


ll get_cnt(vector<int> &now, int i, int j) {
    ll cnt = 0;
    int sz = now.size();
    for (int i1 = 0; i1 < sz; ++i1) {
        for (int j1 = i1 + 1; j1 < sz; ++j1) {
            if (now[j1] < now[i1]) ++cnt;
        }
    }
    sort(now.begin(), now.end());
    for (int i1 = i; i1 < r; ++i1) {
        for (int j1 = j; j1 < c; ++j1) {
            int id = upper_bound(now.begin(), now.end(), a[i1][j1]) - now.begin();
            cnt += sz - id;
        }
    }
    return cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> r >> c;
    a.resize(r, vector<int> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll> (c + 1));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            {
                vector<int> now;
                for (int l = j; l < c; ++l) now.push_back(a[i][l]);
                dp[i][j] = dp[i + 1][j] + get_cnt(now, i + 1, j);
            }
            {
                vector<int> now;
                for (int l = i; l < r; ++l) now.push_back(a[l][j]);
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + get_cnt(now, i, j + 1));
            }
        }
    }
    cout << dp[0][0];
}
