#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define endl "\n"
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

const int maxlog = 19;
const int maxn = 3e5 + 10;
pii mn[maxlog][maxn];
int mx[maxlog][maxn];
int lg[maxn];

void build(int n, vector<int> &a) {
    for (int i = 0; i < n; ++i) {
        mx[0][i] = a[i];
        mn[0][i].first = a[i];
        mn[0][i].second = i;
    }
    for (int j = 1; j < maxlog; ++j) {
        for (int i = 0; i < n; ++i) {
            mx[j][i] = mx[j - 1][i];
            if (i + (1 << (j - 1)) < n && mx[j][i] < mx[j - 1][i + (1 << (j - 1))]) mx[j][i] = mx[j - 1][i + (1 << (j - 1))];

            mn[j][i] = mn[j - 1][i];
            if (i + (1 << (j - 1)) < n && mn[j][i] > mn[j - 1][i + (1 << (j - 1))]) mn[j][i] = mn[j - 1][i + (1 << (j - 1))];
        }
    }
}
vector<int> a;
int n;

pii get_min(int l, int r) {
    int len = r - l + 1;
    return min(mn[lg[len]][l], mn[lg[len]][r - (1 << lg[len]) + 1]);
}

int get_max(int l, int r) {
    int len = r - l + 1;
    return max(mx[lg[len]][l], mx[lg[len]][r - (1 << lg[len]) + 1]);
}

// pii get_min(int l, int r) {
//     int res = a[l], ind = l;
//     for (int i = l; i <= r; ++i) {
//         if (a[i] < res) {
//             res = a[i];
//             ind = i;
//         }
//     }
//     return {res, ind};
// }
//
// int get_max(int l, int r) {
//     int res = a[l];
//     for (int i = l; i <= r; ++i) {
//         if (a[i] > res) res = a[i];
//     }
//     return res;
// }


void solve() {
    int q;
    cin >> n >> q;
    // vector<int> a(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(n, a);
    vector<vector<pii>> queries(n + 1);
    for (int j = 0; j < q; ++j) {
        int k, i;
        cin >> k >> i;
        // i--;
        queries[k].pb({i, j});
    }

    vector<int> good(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] < a[i + 1]) good[i + 1] = 1;
    }
    vector<int> next_b(n, -1);
    int last = n;
    for (int i = n - 1; i > -1; --i) {
        next_b[i] = last;
        if (good[i]) last = i;
    }
    vector<int> ans(q, -1);
    for (int k = 1; k <= n; ++k) {
        if (queries[k].empty()) continue;
        // sort(queries[k].begin(), queries[k].end());
        int max_ind = queries[k].back().first;
        for (int i = 0; i < queries[k].size(); ++i) {
            if (max_ind < queries[k][i].first) max_ind = queries[k][i].first;
        }
        vector<int> now;
        int next = 0;
        for (int i = 0; i < max_ind; ++i) {
            if (i == k - 1) {
                now.pb(get_max(next, n - 1));
                continue;
            }

            now.pb(a[next]);
            int l = next_b[next];
            int ost = (k - (i + 1));
            l = min(l, n - ost - 1);
            if (i == k - 2) {
                next = l + 1;
                continue;
            }
            int now_min = get_min(next + 1, l + 1).second;
            next = now_min;
        }
        for (auto [i, j] : queries[k]) {
            ans[j] = now[i - 1];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << endl;
    }
}

signed main() {
    lg[1] = 0;
    for (int i = 2; i < maxn; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
    ios_base::sync_with_stdio(0); cin.tie(0);
    solve();
}