#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

using namespace std;

#define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18 + 57, max_n = 1e5 + 5;

void solve() {
    int n, q; cin >> n >> q;
    string s; cin >> s;
    vector<int> res(n + 1, 0);
    auto calc_f = [&] () -> int {
        int st = 0;
        for (int i = 0; i < n; i++) {
            if (s[i] == '1' && ((i > 0 && s[i - 1] == '1') || (i < n - 1 && s[i + 1] == '1'))) {
                st++;
            }
        }
        return st;
    };
    res[0] = calc_f();
    int lim = 0;
    for (auto x : s) {
        lim += (x == '0');
    }
    if (lim == n) {
        while (q--) {
            int x; cin >> x;
            if (x == 1) {
                x--;
            }
            cout << x << '\n';
        }
        return;
    }
    vector<int> uno;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1' && (i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
            uno.push_back(i);
        }
    }
    set<pii> suno;
    for (int i = 0; i + 1 < uno.size(); i++) {
        suno.insert({uno[i + 1] - uno[i], i});
    }
    int op = 1;
    while (!suno.empty()) {
        auto [val, id] = *suno.begin();
        int s_id = uno[id];
        s[s_id + 1] = '1';
        if (val == 2) {
            res[op] = res[op - 1] + 3;
        } else {
            res[op] = res[op - 1] + 2;
        }
        suno.erase(suno.begin());
        if (id + 1 < uno.size()) {
            id++;
            suno.erase({uno[id + 1] - uno[id], id});
        }
        op++;
    }
    /*for (int i : res) {
        cout << i << " ";
    }
    cout << endl;*/
    for (int i = 0; i < n; i++) {
        if (s[i] == '1' && (i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
            res[op] = res[op - 1] + 2;
            op++;
            break;
        }
    }
    for (int i = op; i <= n; i++) {
        res[i] = res[i - 1] + 1;
    }
    while (q--) {
        int x; cin >> x;
        cout << res[x] << '\n';
    }
}

/*
3 4
000
0
1
2
3
*/

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
