#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

using namespace std;

// #define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e9 + 57, max_n = 1e5 + 5;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> vres[n + 1];
    for (int k = 1; k <= n; k++) {
        vector<bool> from(n + 1, false), to(n, false);
        from[0] = true;
        for (int op = 0; op < k; op++) {
            int mn = inf;
            int mx = 0;
            bool f = false;
            for (int i = 0; i < n; i++) {
                if (from[i]) {
                    mx = a[i];
                    f = true;
                } else {
                    mx = max(mx, a[i]);
                }
                if (f) {
                    if (i + 1 == n || op < k - 1) {
                        if (op + (n - i) >= k) {
                            mn = min(mn, mx);
                        }
                    }
                }
            }
            mx = 0;
            f = false;
            for (int i = 0; i < n; i++) {
                if (from[i]) {
                    mx = a[i];
                    f = true;
                } else {
                    mx = max(mx, a[i]);
                }
                if (f) {
                    if (i + 1 == n || op < k - 1) {
                        if (op + (n - i) >= k && mx == mn) {
                            to[i + 1] = true;
                        }
                    }
                }
            }
            swap(from, to);
            fill(to.begin(), to.end(), false);
            vres[k].push_back(mn);
        }
    }
    while (q--) {
        int k, id; cin >> k >> id;
        cout << vres[k][id - 1] + 1 << '\n';
    }
}

/*
3 1
2 1 3
*/

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
