#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

using ll = long long;

ll get(vector<ll>& vec, ll pos, ll k) {
	if (k == 1) return vec.size() - pos;
	ll cantake = 1;
	ll nans = vec[pos + 1];
	for (int i = pos + 1; i < vec.size() && vec[i] < vec[pos] && vec.size() >= i + k - 1; i++) {
		if (vec[i] < nans || k == 2) {
			nans = vec[i];
			cantake = i - pos;
		}
	}
	return cantake;
}

int main() {
	ll n, q; cin >> n >> q;
	vector<ll> vec(n);
	for (int i = 0; i < n; i++) cin >> vec[i];
	vector<pair<ll, ll>> qs;
	vector<ll> ks;
	unordered_map<ll, ll> um2;
	while (q--) {
		ll k, i; cin >> k >> i;
		qs.push_back({ k, i - 1 });
		um2[k] = max(um2[k], i);
		ks.push_back(k);
	}
	sort(ks.begin(), ks.end());
	ks.erase(unique(ks.begin(), ks.end()), ks.end());
	unordered_map<ll, vector<ll>*> um;
	for (auto k : ks) {
		ll pos = 0;
		ll ck = k;
		vector<ll>* ans = new vector<ll>();
		while (ck > k - um2[k]) {
			ll take = get(vec, pos, ck);
			ll lans = vec[pos];
			if (ck == 1) for (int i = pos; i < pos + take; i++) lans = max(lans, vec[i]);
			ans->push_back(lans);
			pos += take;
			ck--;
		}
		um[k] = ans;
	}
	for (auto p : qs) {
		cout << um[p.first]->operator[](p.second) << endl;
	}
}