#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
using ld = long double;
 
#define all(a) a.begin(), a.end()
 
void solve();
void prec();
 
int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    solve();
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXTIME: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}
 
void prec() {
 
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for(int i = 0; i < r; i++) {
        for(int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1, 1e18));
    for(int it1 = 0; it1 <= r; it1++) {
        for(int it2 = 0; it2 <= c; it2++) {
            if(it1 == 0 && it2 == 0) {
                dp[0][0] = 0;
                continue;;
            }
            if(it2 - 1 < c && it2 - 1 >= 0 && it1 < r) {
                vector<ll> was;
                for(int i = 0; i < r; i++) {
                    for(int j = 0; j < c; j++) {
                        if(i < it1 || j < it2 - 1) {
                            was.push_back(a[i][j]);
                        }
                    }
                }
                sort(all(was));
                ll last = dp[it1][it2 - 1];
                vector<ll> temp2;
                for(int i = it1; i < r; i++) {
                    temp2.push_back(a[i][it2 - 1]);
                }
                for(int i = 0; i < temp2.size(); i++) {
                    auto k = lower_bound(all(was), temp2[i]);
                    last += was.end() - k;
                    for(int j = 0; j < i; j++) {
                        if(temp2[j] > temp2[i]) {
                            last++;
                        }
                    }
                }
                dp[it1][it2] = min(dp[it1][it2], last);
            }
            if(it1 - 1 < r && it1 - 1 >= 0 && it2 < c) {
                vector<ll> was;
                for(int i = 0; i < r; i++) {
                    for(int j = 0; j < c; j++) {
                        if(i < it1 - 1 || j < it2) {
                            was.push_back(a[i][j]);
                        }
                    }
                }
                sort(all(was));
                ll last = dp[it1 - 1][it2];
                vector<ll> temp2;
                for(int i = it2; i < c; i++) {
                    temp2.push_back(a[it1 - 1][i]);
                }
                for(int i = 0; i < temp2.size(); i++) {
                    auto k = lower_bound(all(was), temp2[i]);
                    last += was.end() - k;
                    for(int j = 0; j < i; j++) {
                        if(temp2[j] > temp2[i]) {
                            last++;
                        }
                    }
                }
                dp[it1][it2] = min(dp[it1][it2], last);
            }
        }
    }
    ll ans = 1e18;
    for(int i = 0; i < r; i++) {
        ans = min(ans, dp[i][c]);
    }
    for(int i = 0; i < c; i++) {
        ans = min(ans, dp[r][i]);
    }
    cout << ans;
}
