#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <deque>

using namespace std;

using ll = long long;

#pragma GCC optimize("Ofast")



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m;
	cin >> n >> m;
	deque<deque<int>> a(n, deque<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<int> S;
	for (int i = 0; i < (1 << (n + m - 1)); i++) {
		int cnt = 0;
		for (int j = 0; j < n + m - 1; j++) {
			if (i & (1 << j)) cnt++;
		}
		if (cnt == n) S.push_back(i);
	}
	ll CNT = 1e18;
	for (int I : S) {
		deque<deque<int>> A = a;
		vector<int> res;
		for (int j = 0; j < n + m - 1; j++) {
			if (I & (1 << j)) {
				for (int c : A[0]) res.push_back(c);
				A.pop_front();
			}
			else {
				for (int i = 0; i<int(A.size()); i++) res.push_back(A[i][0]);
				for (int i = 0; i<int(A.size()); i++) A[i].pop_front();
			}
		}
		ll cnt = 0;
		for (int i = 0; i<int(res.size()); i++) {
			for (int j = i + 1; j<int(res.size()); j++) {
				if (res[j] < res[i]) cnt++;
			}
		}
		CNT = min(CNT, cnt);
	}
	cout << CNT;
}