#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        p[a[i]] = i;
    }

    vector<vector<pair<int, int>>> quer(n+1);
    vector<int> ans(q);
    for (int i = 0; i < q; ++i) {
        int k, x;
        cin >> k >> x;
        // assert(k == 2);
        --x;
        quer[k].emplace_back(x,i);
    }

    vector<vector<int>> res(n+1);

    for (int s = 1; (s < (1 << n)); ++s) {
        vector<int> end = {0};
        for (int i = 1; i < n; ++i) {
            if (1 & (s >> i)) {
                end.push_back(i);
            }
        }
        end.push_back(n);
        vector<int> b;

        for (int i = 0; i + 1 < len(end); ++i) {
            int mx = -INFi;
            for (int j = end[i]; j < end[i+1]; ++j) {
                mx = max(mx, a[j]);
            }
            b.push_back(mx);
        }

        int k = len(b);
        if (res[k].empty() || res[k] > b) {
            res[k] = b;
        }
    }

    for (int k = 1; k <= n; ++k) {
        for (auto [i, idx]: quer[k]) {
            ans[idx] = res[k][i];
        }
    }

    for (auto x: ans) {
        cout << x + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
