#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


vector<vector<int>> g;
bool checkd(pll a, pll b, ll r) {
    return (a.first-b.first)*(a.first-b.first) + (a.second-b.second)*(a.second-b.second) <= r*r;
}

vector<bool> used;
vector<int> maybe;
vector<bool> bad;
void dfs(int v) {
    used[v] = 1;
    maybe.push_back(v);
    for (int nxt:g[v]) {
        if (bad[nxt]) continue;
        if (used[nxt]==0) dfs(nxt);
    }
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n; ll r;
    cin >> n >> r;
    vector<pii> nums(n);
    for (int i=0; i<n; i++) {
        int a, b; cin >> a >> b;
        nums[i] = {a, i};
    }
    sort(nums.begin(), nums.end(), [&](pii a, pii b) {
        return a.first < b.first;
    });

    vector<bool> good(n);
    for (int i=2; i<n; i++) {
        if (nums[i].first-nums[i-2].first <= r) {
            good[i] = 1; good[i-1] = 1; good[i-2] = 1;
        }
    }

    vector<bool> answer(n);
    for (int i=0; i<n; i++) {
        if (good[i]) answer[nums[i].second] = 1;
        else if (i>0) {
            if (good[i-1] && nums[i].first-nums[i-1].first <= r) answer[nums[i].second] = 1;
        }
    }
    for (int i=n-1; i>=0; i--) {
        if (good[i]) answer[nums[i].second] = 1;
        else if (i+1<n) {
            if (good[i+1] && nums[i+1].first-nums[i].first <= r) answer[nums[i].second] = 1;
        }
    }

    for (int i:answer) cout << i;



    return 0;
}