#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<bool> solo(n);
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') continue;
        solo[i] = true;
        if (i > 0 && s[i - 1] == '1') {
            solo[i] = false;
        }
        if (i < n - 1 && s[i + 1] == '1') {
            solo[i] = false;
        }
    }
    set<array<int, 2>> st;
    int c0 = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') continue;
        c0++;
        int cs = 0;
        if (i > 0) {
            cs += solo[i - 1];
        }
        if (i < n - 1) {
            cs += solo[i + 1];
        }
        st.insert({cs, i});
    }
    map<int, vector<int>> idxs;
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        idxs[x].push_back(i);
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1' && !solo[i]) {
            cur++;
        }
    }
    vector<int> ans(q);
    for (int i = 0; i <= c0; i++) {
        for (auto e : idxs[i]) {
            ans[e] = cur;
        }
        while (!st.empty()) {
            auto [cnt, idx] = *st.rbegin();
            st.erase({cnt, idx});
            int cs = 0, c1 = 0;
            if (idx > 0) {
                cs += solo[idx - 1];
                c1 += s[idx - 1] == '1';
            }
            if (idx < n - 1) {
                cs += solo[idx + 1];
                c1 += s[idx + 1] == '1';
            }
            if (cs == cnt) {
                s[idx] = '1';
                if (c1 == 0) {
                    solo[idx] = true;
                    if (idx > 0) {
                        st.erase({0, idx - 1});
                        st.insert({1, idx - 1});
                    }
                    if (idx < n - 1) {
                        st.erase({0, idx + 1});
                        st.insert({1, idx + 1});
                    }
                } else {
                    cur++;
                }
                cur += cs;
                if (idx > 0) {
                    solo[idx - 1] = false;
                }
                if (idx < n - 1) {
                    solo[idx + 1] = false;
                }
                break;
            } else {
                st.insert({cs, idx});
            }
        }
    }
    for (auto e : ans) {
        cout << e << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
