#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<int> col;
bool bad = false;
vector<int> ncomp;
vector<array<int, 2>> pts;
int n;
int r;

vector<array<int, 3>> srt;
vector<array<int, 2>> check;

void dfs(int u, int cl) {
    col[u] = cl;
    ncomp.push_back(u);
    int x = pts[u][0], y = pts[u][1];
    for (auto [dx, dy] : check) {
        array<int, 3> ar = {x + dx, y + dy, -1};
        auto it = lower_bound(srt.begin(), srt.end(), ar);
        if (it != srt.end()) {
            auto [nx, ny, v] = *it;
            if (v == u) continue;
            if (nx != ar[0]) {
                continue;
            }
            if (ny != ar[1]) {
                continue;
            }
            if (col[v] == -1) {
                dfs(v, cl ^ 1);
            }
            if (col[v] == col[u]) {
                bad = true;
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = -r; dy <= r; dy++) {
            if (1ll * dx * dx + 1ll * dy * dy <= 1ll * r * r) {
                check.push_back({dx, dy});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts.push_back({x, y});
        srt.push_back({x, y, i});
    }
    sort(srt.begin(), srt.end());
    col.resize(n, -1);
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            bad = false;
            ncomp.clear();
            dfs(i, 0);
            if (bad) {
                for (auto e : ncomp) {
                    ans[e] = 1;
                }
            }
        }
    }
    for (auto e : ans) {
        cout << e;
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
