#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <cmath>

using namespace std;

typedef int ll;
typedef long long ll1;

const ll inf = 1e9;

ll n, r, ok1 = 0;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;
vector<ll> was1;
vector<ll> ok;
vector<ll> h;
vector<ll> now;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    was.assign(n, 0);
    g.assign(n, {});
    c.assign(n, 0);
    h.assign(n, 0);
    ok.assign(n, 0);
    vector<pair<ll, ll>> v(n);
    map<ll1, ll> mapa;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        mapa[ll1(v[i].first) * ll1(1e9) + v[i].second] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j1 = -r; j1 <= r; j1++) {
            ll1 x1 = v[i].first + j1;
            ll col = ll(sqrt(ll1(r) * ll1(r) - ll1(x1) * ll1(x1)));
            for (int j2 = -col; j2 <= col; j2++) {
                ll1 y1 = v[i].second + j2;
                if (j1 == 0 && j2 == 0) continue;
                if (mapa.find(x1 * ll1(1e9) + y1) == mapa.end()) continue;
                ll1 res = ll1(v[i].first - x1) * ll1(v[i].first - x1) + ll1(v[i].second - y1) * ll1(v[i].second - y1);
                if (res <= ll1(r) * ll1(r)) {
                    g[i].push_back(mapa[x1 * ll1(1e9) + y1]);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (was[i] == 0) {
            ok1 = 0;
            now.clear();
            vector<ll> q;
            q.push_back(i);
            while (!q.empty()) {
                ll v = q.back();
                q.pop_back();
                now.push_back(v);
                for (ll to : g[v]) {
                    if (was[to] == 0) {
                        was[to] = 1;
                        c[to] = (c[v] ^ 1);
                        q.push_back(to);
                    } else if (c[v] == c[to]) {
                        ok1 = 1;
                    }
                }
            }
            for (ll el : now) ok[el] = ok1;
        }
    }
    for (ll el : ok) cout << el;
    return 0;
}