#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, q; cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    map<ll, vector<ll>> mapa;
    for (int i1 = 0; i1 < q; i1++) {
        ll k, i; cin >> k >> i;
        if (k < n - 100) k = i + 10;
        if (mapa.find(k) != mapa.end()) {
            cout << mapa[k][i - 1] << "\n";
            continue;
        }
        ll now = a[0], col = 1, j = 1;
        pair<ll, ll> mn = {inf, inf};
        vector<ll> v;
        while (1) {
            if (j == n) break;
            ll was = now;
            now = max(now, a[j]);
            mn = min(mn, {a[j], j});
            ll ost = n - j - 1;
            if (col != k && (k - col > ost || now != was)) {
                v.push_back(was);
                if (v.size() >= 3) break;
                col++;
                if (col != k) j = mn.second;
                if (j == n) break;
                mn = {inf, inf};
                now = a[j];
            }
            j++;
        }
        v.push_back(now);
        mapa[k] = v;
        cout << v[i - 1] << "\n";
    }
    return 0;
}