#include <bits/stdc++.h>
#pragma GCC optimze("Ofast")
using namespace std;
#define ll long long
const int N = 1e5;
struct p {ll x, y, i;};
ll n, r;
const int C = 10;
bool edge(p a, p b)
{
	ll r2 = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return r2 <= r * r;
}
vector<vector<int>> g(N);
vector<p> v;
vector<bool> ans;
vector<int> cl;
bool dfs(int u, int c)
{
	bool an = 1;
	cl[u] = c;
	for (auto i : g[u])
		if (ans[i] == 1) return 0;
		else if (cl[i] == -1)
			an = an && dfs(i, !c);
		else if (cl[i] == c)
			return 0;
	return an;
}
void dfs_mark(int u)
{
	ans[v[u].i] = 1;
	for (auto i : g[u])
		if (ans[v[i].i] == 0)
			dfs_mark(i);
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> r;
	v.resize(n);ans.assign(n, 0);
	cl.assign(n, -1);
	for (int i = 0; i < n; i++)
		cin >> v[i].x >> v[i].y, v[i].i = i;
	sort(v.begin(), v.end(), [] (p a, p b) {return a.x < b.x;});
	int k = 0;
	set<pair<int, int>> st;
	for (int i = 0; i < n; i++)
	{
		while (v[k].x < v[i].x - r)
			st.erase({v[k].y, k}), k++;
		for (auto it = st.lower_bound({v[i].y - r, -1}); it != st.end() && it -> first <= v[i].y + r; it++)
		{
			int j = it -> second;
			if (edge(v[i], v[j]))
			{
				if (g[j].size() < C)
					g[j].push_back(i);
				else ans[j] = 1;
				if (g[i].size() < C)
					g[i].push_back(j);
				else ans[i] = 1;
			}
		}
		st.insert({v[i].y, i});
	}
	for (int i = 0; i < n; i++)
		if (cl[i] == -1 && ans[i] == 0)
			if (!dfs(i, 0))
				dfs_mark(i);
	for (int i = 0; i < n; i++)
		cout << ans[i];
	cout << '\n';
	return 0;
}
int main1()
{
	cin >> n >> r;
	vector<p> t(n);
	ll tmp;
	for (int i = 0; i < n; i++)
		cin >> t[i].x >> tmp, t[i].y = i;
	sort(t.begin(), t.end(), [] (p a, p b) {return a.x < b.x;});
	vector<bool> ans(n);
	for (int i = 0; i < n; i++)
	{
		if (i >= 2)
			if (t[i - 2].x >= t[i].x - r)
				ans[t[i].y] = ans[t[i - 1].y] = ans[t[i - 2].y] = 1;
	}
	for (int i = 0; i < n; i++)
		cout << ans[i];
	cout << '\n';


}
