
#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N = 1e5;
struct p {ll x, y;};
ll n, r;
bool edge(p a, p b)
{
	ll r2 = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return r2 <= r * r;
}
vector<vector<int>> g(N);
vector<p> v;
vector<bool> ans;
vector<int> cl;
bool dfs(int u, int c)
{
	bool ans = 1;
	cl[u] = c;
	for (auto i : g[u])
		if (cl[i] == -1)
			ans = ans && dfs(i, !c);
		else if (cl[i] == c)
			return 0;
	return ans;
}
void dfs_mark(int u)
{
	ans[u] = 1;
	for (auto i : g[u])
		if (ans[i] == 0)
			dfs_mark(i);
}
int main()
{
	cin >> n >> r;
	v.resize(n);ans.assign(n, 0);
	cl.assign(n, -1);
	for (auto& [x, y] : v)
		cin >> x >> y;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			if (edge(v[i], v[j]))
				g[i].push_back(j),
				g[j].push_back(i);
	for (int i = 0; i < n; i++)
		if (cl[i] == -1)
			if (!dfs(i, 0))
				dfs_mark(i);
	for (int i = 0; i < n; i++)
		cout << ans[i];
	cout << '\n';
	

}
