#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector<ll> x(n);
    vector<set<pair<int, int>>> st(2);
    vector<vector<int>> used(n, vector<int>(2));
    for (int i = 0; i < n; ++i) {
        int y;
        cin >> x[i] >> y;
        st[0].insert({x[i], i});
        st[1].insert({x[i], i});
    }
    for (int v = 0; v < n; ++v) {
        queue<pair<ll, int>> q;
        int clr = v + 1;
        if (!used[v][0]) {
            q.push({x[v], 0});
            used[v][0] = clr;
        }
        while (siz(q)) {
            auto [a, bit] = q.front(); q.pop();
            auto it = st[bit ^ 1].lower_bound({a - r, -INF});
            vector<int> tos;
            while (it != st[bit ^ 1].end() && it->first <= a + r) {
                int to = it->second;
                if (it->first != a) tos.push_back(to);
                it++;
            }
            for (int to : tos) {
                st[bit ^ 1].erase({x[to], to});
                used[to][bit ^ 1] = clr;
                q.push({x[to], bit ^ 1});
            }
        }
    }
    for (int v = 0; v < n; ++v) cout << (used[v][0] == used[v][1]);
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}