#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const int mxN = 1e5 + 10;

vector<int> g[mxN];
int used[mxN][2];

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    unordered_map<ll, int> mp;
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        a[i] = {x, y};
        for (int dx = -r; dx <= r; ++dx) {
            ll dist = dx * dx + r * r;
            for (int dy = -r; dy <= r; ++dy) {
                if (dist <= r * r && mp.find(((x + dx) << 32) + (y + dy)) != mp.end()) {
                    int j = mp[((x + dx) << 32) + (y + dy)];
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
                dist += 2 * dy + 1;
            }
        }
        mp[(x << 32) + y] = i;
    }
    int clr = 0;
    queue<pair<int, int>> q;
    for (int s = 0; s < n; ++s) {
        clr++;
        if (!used[s][0]) {
            used[s][0] = clr;
            q.push({s, 0});
        }
        while (siz(q)) {
            auto [v, bit] = q.front(); q.pop();
            for (int to : g[v]) {
                if (!used[to][bit ^ 1]) {
                    used[to][bit ^ 1] = clr;
                    q.push({to, bit ^ 1});
                }
            }
        }
    }
    for (int s = 0; s < n; ++s) {
        cout << (used[s][0] == used[s][1]);
    }
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}