#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const int mxN = 3e3 + 10;
const int mxK = 5;

int dp[mxN][mxK], pr[mxN][mxK];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int mx = -INF;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j <= n; ++j) {
            fill(dp[i], dp[i] + mxK, 0);
            fill(pr[i], pr[i] + mxK, -1);
        }
        mx = max(mx, a[i]);
        dp[i][1] = mx;
    }
    for (int k = 2; k <= mxK; ++k) {
        for (int i = 0; i < n; ++i) {
            int opt = -1;
            mx = a[i];
            for (int j = i + 1; j < n; ++j) {
                if (dp[j][k - 1] && (opt == -1 || dp[j][k - 1] < dp[opt][k - 1])) opt = j;
                if (a[j] > mx && opt != -1) break;
                mx = max(mx, a[j]);
            }
            if (opt != -1) {
                dp[i][k] = mx;
                pr[i][k] = opt;
            }
        }
    }
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i, i--;
        int cur = 0;
        while (i--) {
            cur = pr[cur][k];
            k--;
        }
        cout << dp[cur][k] << '\n';
    }
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}