#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

ll len(pii &a, pii &b) {
    return (ll) (a.first - b.first) * (a.first - b.first) + (ll) (a.second - b.second) * (a.second - b.second);
}

const int MAXN = 1e5;
vector<int> g[MAXN];
unordered_map<ll, int> ind;
int used[MAXN];
int h[MAXN];
vector<int> e;
bool f = 0;
vector<int> ans;

void dfs(int &v, const int &p) {
    used[v] = 1;
    e.push_back(v);
    for (auto &u: g[v]) {
        if (!used[u]) {
            h[u] = h[v] + 1;
            dfs(u, v);
        } else if (!f && u != p) {
            if ((h[v] - h[u]) % 2 == 0) {
                f = 1;
            }
            if (ans[u]) f = 1;
        }
    }
}

ll hsh(pii a) {
    return (ll) a.first * 1e9 + a.second;
}

mt19937 rnd(time(0));

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    int R = r;
    r *= r;
    vector<pii> a(n);
    ans.resize(n);
    int mxx = 0, mxy = 0;
    int mnx = 1e9, mny = 1e9;
    for (auto &[x, y]: a) {
        cin >> x >> y;
        mxx = max(mxx, (int) x);
        mxy = max(mxy, (int) y);
        mnx = min(mnx, x);
        mny = min(mny, y);
    }
    for (int i = 0; i < n; i++) ind[hsh(a[i])] = i;
    int x, y;
    pii tmp;
    for (int i = 0; i < n; i++) {
        if (n <= 10000) {
            int cnt = 0;
            for (int j = 0; j < n && cnt <= 5; j++) {
                if (i == j) continue;
                if (len(a[j], a[i]) <= r) {
                    g[i].push_back(j);
                    cnt++;
                }
            }
            if (cnt > 5) {
                ans[i] = 1;
                used[i] = 1;
            }
        } else {
            int cnt = 0;
            for (x = max(mnx, a[i].first - R); x <= min((int) a[i].first + (int) R, mxx); x++) {
                if (cnt >= 6) break;
                for (y = max(mny, a[i].second - R); y <= min((int) a[i].second + (int) R, mxy); y++) {
                    if (cnt >= 6) break;
                    tmp = {x, y};
                    if (tmp == a[i]) continue;
                    if (len(tmp, a[i]) <= r) {
                        if (ind.find(hsh(tmp)) != ind.end()) {
                            int j = ind[hsh(tmp)];
                            g[i].push_back(j);
                            cnt++;
                        }
                    } else {
                        if (y > a[i].second) break;
                    }
                }
            }
            if (cnt >= 6) {
                ans[i] = 1;
                used[i] = 1;
            }
        }
    }
    const int MINUSODIN = -1;
    for (int i = 0; i < n; i++) {
        if (!used[i] && !ans[i]) {
            f = 0;
            e.clear();
            e.shrink_to_fit();
            dfs(i, MINUSODIN);
            if (f) {
                for (auto &v: e)
                    ans[v] = 1;
            }
        }
    }
    for (auto &x: ans) cout << x;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
