#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

ll len(pii &a, pii &b) {
    return (ll) (a.first - b.first) * (a.first - b.first) + (ll) (a.second - b.second) * (a.second - b.second);
}

const int MAXN = 1e5 + 52;
vector<int> g[MAXN];
map<pii, int> ind;
int used[MAXN];
int h[MAXN];
vector<int> e;
bool f = 0;

void dfs(int v, int p) {
    used[v] = 1;
    e.push_back(v);
    for (auto &u: g[v]) {
        if (!used[u]) {
            h[u] = h[v] + 1;
            dfs(u, v);
        } else if (u != v) {
            if ((h[v] - h[u]) % 2 == 0) {
                f = 1;
            }
        }
    }
}

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector<pii> a(n);
    int mxx = 0, mxy = 0;
    for (auto &[x, y]: a) {
        cin >> x >> y;
        mxx = max(mxx, (int) x);
        mxy = max(mxy, (int) y);
    }
    for (int i = 0; i < n; i++) ind[a[i]] = i;
    for (int i = 0; i < n; i++) {
        if (r > 10) {
            for (int j = 0; j < i; j++) {
                if (len(a[j], a[i]) <= r * r) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        } else {
            for (int x = max(0ll, a[i].first - r); x <= min((int) a[i].first + (int) r, mxx); x++) {
                for (int y = max(0ll, a[i].second - r); y <= min((int) a[i].second + (int) r, mxy); y++) {
                    pii tmp = {x, y};
                    if (len(tmp, a[i]) <= r * r) {
                        if (ind.find({x, y}) != ind.end()) {
                            int j = ind[{x, y}];
                            g[i].push_back(j);
                            g[j].push_back(i);
                        }
                    } else {
                        if (y > a[i].second) break;
                    }
                }
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            f = 0;
            e.clear();
            e.shrink_to_fit();
            dfs(i, -1);
            if (f) {
                for (auto &v: e) ans[v] = 1;
            }
        }
    }
    for (auto &x: ans) cout << x;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
