#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    cin >> a;
    int ans = inf;
    for (int mask = 0; mask < (1 << (n + m)); ++mask) {
        vector<int> b;
        int x = 0, y = 0;
        for (int i = 0; i < n + m && (int) b.size() < n * m; ++i) {
            if ((mask >> i) & 1) {
                for (int j = y; j < m; ++j) {
                    b.push_back(a[x][j]);
                }
                ++x;
            } else {
                for (int j = x; j < n; ++j) {
                    b.push_back(a[j][y]);
                }
                ++y;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n * m; ++i) {
            for (int j = 0; j < i; ++j) {
                if (b[j] > b[i]) {
                    ++cnt;
                }
            }
        }
        ans = min(ans, cnt);
    }
    cout << ans << "\n";
    return 0;
}