#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;

//#define int long long

const int N = 100002;

int xs[N], ys[N], used[N];
bitset<N> ans;

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, r;
    cin>>n>>r;
    for (int i = 0; i < n; ++i) {
        cin>>xs[i]>>ys[i];
    }
    auto dist = [&](int i, int j) -> long long {
        return (xs[i]-xs[j])*1ll*(xs[i]-xs[j]) + (ys[i]-ys[j])*1ll*(ys[i]-ys[j]);
    };
    queue<int> q;
    vector<int> cur;
    auto hs = [&](pair<int,int> f) -> long long {
        return f.first * (long long)6e8 + f.second;
    };

    gp_hash_table<long long, vector<int> > gg;
    int st = (1<<30);
    while (st > 2 * r) {
        st>>=1;
    }
    for (int i = 0; i < n; ++i) {
        gg[hs(make_pair(xs[i]/st, ys[i]/st))].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cur.clear();
            q.push(i);
            used[i] = 1;
            bool nc = false;
            while (!q.empty()) {
                int f = q.front(); q.pop();
                cur.push_back(f);
                int NX = xs[f]/st, NY = ys[f]/st;
                for (int dx = -1; dx <= 1; ++dx) {
                    for (int dy = -1; dy <= 1; ++dy) {
                        for (int u:gg[hs(make_pair(NX+dx, NY+dy))]) {
                            if (u == f || dist(f, u) > r *1ll* r) continue;
                            if (!used[u]) {
                                used[u] = 3 - used[f];
                                q.push(u);
                            }
                            else if (used[u] == used[f]) {
                                nc = true;
                            }
                        }
                    }
                }
            }
            for (auto &x:cur) {
                ans[x] = nc;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout<<ans[i];
    }
    return 0;
}