#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>>v(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> v[i][j];
		}
	}
	vector<vector<ll>>ans(r+1, vector<ll>(c+1,1e18));
	ans[0][0] = 0;
	vector<vector<vector<int>>>lol(r+1, vector<vector<int>>(c+1));
	for (int i = 0; i <= r; ++i) {
		for (int j = 0; j <= c; ++j) {
			if (i == 0 && j == 0) {
				continue;
			}
			
			if (i > 0) {
				//lol[i][j] = lol[i - 1][j];
				//ans[i][j] = min(ans[i][j], ans[i - 1][j]);
				int cnt = 0;
				for (int o = j; o < c; ++o) {
					int l = -1;
					int r = lol[i - 1][j].size();
					while (l + 1 < r) {
						int m = (l + r) / 2;
						if (lol[i - 1][j][m] <= v[i - 1][o]) {
							l = m;
						}
						else {
							r = m;
						}
					}
					cnt += lol[i - 1][j].size() - r;
					for (int o1 = j; o1 < o; ++o1) {
						if (v[i - 1][o1] > v[i - 1][o]) {
							cnt++;
						}
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i - 1][j]);
			}
			if (j > 0) {
				//lol[i][j] = lol[i][j - 1];
				//ans[i][j] = min(ans[i][j], ans[i][j - 1]);
				int cnt = 0;
				for (int o = i; o < r; ++o) {
					int l = -1;
					int r = lol[i][j - 1].size();
					while (l + 1 < r) {
						int m = (l + r) / 2;
						if (lol[i][j - 1][m] <= v[o][j - 1]) {
							l = m;
						}
						else {
							r = m;
						}
					}
					cnt += lol[i][j - 1].size() - r;
					for (int o1 = i; o1 < o; ++o1) {
						if (v[o1][j - 1] > v[o][j - 1]) {
							cnt++;
						}
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i ][j-1]);
			}
			if (i > 0) {
				lol[i][j] = lol[i - 1][j];
				for (int o = j; o < c; ++o) {
					lol[i][j].push_back(v[i - 1][o]);
				}
			}
			else if (j > 0) {
				lol[i][j] = lol[i][j-1];
				for (int o = i; o < r; ++o) {
					lol[i][j].push_back(v[o][j-1]);
				}
			}
			sort(lol[i][j].begin(), lol[i][j].end());
		}
	}
	cout << ans[r ][c];
	return 0;
}