#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
using namespace std;
using i64 = int64_t;
using u64 = uint64_t;

int n;
vector<int> a, ind, hide;

void solvek(int k, vector<int>& blocks, int s = 0) {
    if (k == 1) {
        blocks.push_back(*max_element(a.begin() + s, a.end()));
        return;
    }
    if (k == 2) {
        int j = min(s + hide[s] + 1, n - 1);
        blocks.push_back(a[s]);
        solvek(k-1, blocks, j);
        return;
    }
    if (hide[s] == 0 || n - s == k) {
        blocks.push_back(a[s]);
        solvek(k-1, blocks, s + 1);
        return;
    }
    int j = min_element(a.begin() + s + 1, a.begin() + min(s + hide[s], n - k + 1) + 1) - a.begin();
    blocks.push_back(a[s]);
    solvek(k - 1, blocks, j);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> n >> q;
    a.resize(n);
    ind.resize(n);
    hide.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        ind[a[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        while (i + hide[i] + 1 < n && a[i + hide[i] + 1] < a[i]) {
            hide[i]++;
        }
    }

    vector<vector<int>> ans(n + 1);
    for (int k = 1; k <= n; ++k) {
        solvek(k, ans[k]);
    }

    for (int i = 0; i < q; ++i) {
        int k, j;
        cin >> k >> j;
        j--;
        cout << ans[k][j] + 1 << "\n";
    }
}

/*

7 4
6 4 2 3 1 7 5
7 4
1 1
4 2
5 3

 */