#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<int>> g;
vector<int> col, used;
int cur_us = 1, dv = 1;

void pnt(int v) {
    if (col[v] == -1) {
        col[v] = 0;
    }
    if (col[v] == 2) return;
    for (auto i : g[v]) {
        if (col[i] == col[v]) {
            dv = 0;
            return;
        }
        if (col[i] == -1) {
            col[i] = !col[v];
            pnt(i);
        }
    }
}

void upd(int v) {
    used[v] = cur_us;
    col[v] = 2;
    for (auto i : g[v]) {
        if (used[i] != cur_us) {
            upd(i);
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    col.resize(n, -1);
    used.resize(n, 0);
    vector<pair<ll, ll>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            auto [x1, y1] = p[i];
            auto [x2, y2] = p[j];
            if ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            dv = 1;
            pnt(i);
            if (!dv) upd(i);
        }
        cout << (col[i] == 2? 1 : 0);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
}