#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)

signed main() noexcept {
    fastio;
    int r, c;
    cin >> r >> c;
    vector<vector<int>> mtr(r, vector<int>(c));
    for (auto& i : mtr) for (auto& j : i) cin >> j, j = r * c - j;
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, 1e18));
    for (int i = 0; i <= r; ++i) {
        dp[i][c] = 0;
    }
    for (int i = 0; i <= c; ++i) {
        dp[r][i] = 0;
    }
    vector<pair<int, int>> vp(r * c);
    for (int i = 0; i < r; ++i) for (int j = 0; j < c; ++j) vp[mtr[i][j]] = {i, j};
    vector<vector<int>> downi(r, vector<int>(c));
    vector<vector<int>> righti(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = c - 2; j >= 0; --j) {
            righti[i][j] = righti[i][j + 1];
            for (int k = j + 1; k < c; ++k) {
                if (mtr[i][j] < mtr[i][k]) righti[i][j]++;
            }
        }
    }
    for (int j = 0; j < c; ++j) {
        for (int i = r - 2; i >= 0; --i) {
            downi[i][j] = downi[i + 1][j];
            for (int k = i + 1; k < r; ++k) {
                if (mtr[i][j] < mtr[k][j]) downi[i][j]++;
            }
        }
    }
    vector<vector<int>> prec(c);
    auto calcinversions = [&](vector<int>& cur, int i, int j, int prec) {
        int addinv = prec;
        int cp = 0;
        int cpe = 0;
        for (int k = 0; k < r * c; ++k) {
            if (cp == cur.size()) break;
            if (cur[cp] == k) {
                addinv += cpe;
                cp++;
            } else if (vp[k].first < i || vp[k].second < j) {
                cpe++;
            }
        }
        return addinv;
    };
    for (int i = r - 1; i >= 0; --i) {
        vector<int> cpe;
        for (int j = c - 1; j >= 0; --j) {
            {
                int cp = 0;
                while (cp < cpe.size() && cpe[cp] < mtr[i][j]) cp++;
                cpe.insert(cpe.begin() + cp, mtr[i][j]);
            }
            {
                int cp = 0;
                while (cp < prec[j].size() && prec[j][cp] < mtr[i][j]) cp++;
                prec[j].insert(prec[j].begin() + cp, mtr[i][j]);
            }
            // right
            int inv = calcinversions(cpe, i, j, righti[i][j]);
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + inv);
            // down
            inv = calcinversions(prec[j], i, j, downi[i][j]);
            dp[i][j] = min(dp[i][j], dp[i][j + 1] + inv);
        }
    }
    cout << dp[0][0];
}