#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#pragma GCC optimize("Ofast")
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll INF = 1e2;

inline void solve() {
	ll r, c;
	cin >> r >> c;
	vector<vector<ll>> a(r, vector<ll>(c));
	for (ll i = 0; i < r; i++) {
		for (ll j = 0; j < c; j++) {
			cin >> a[i][j];
		}
	}
	ll ans = INF;
	vector<vector<vector<ll>>> dp(r + c - 1, vector<vector<ll>>(r + 1, vector<ll>(c + 1, INF)));
	for (ll it = 0; it < r + c - 1; it++) {
		for (ll i = 0; i <= min(r, it + 1); i++) {
			ll j = (it + 1 - i);
			if (j > c) continue;
			if (i && j != c) {
				vector<ll> temp;
				for (ll i1 = 0; i1 < r; i1++) {
					for (ll j1 = 0; j1 < c; j1++) {
						if (i1 >= i - 1 && j1 >= j) continue;
						temp.push_back(a[i1][j1]);
					}
				}
				sort(all(temp));
				ll cnt = 0;
				for (ll in = j; in < c; in++) {
					cnt += temp.end() - upper_bound(all(temp), a[i - 1][in]);
				}
				temp = {};
				for (ll in = j; in < c; in++) {
					cnt += temp.end() - upper_bound(all(temp), a[i - 1][in]);
					temp.push_back(a[i - 1][in]);
					sort(all(temp));
				}
				if (it) dp[it][i][j] = min(dp[it][i][j], dp[it - 1][i - 1][j] + cnt);
				else dp[it][i][j] = min(dp[it][i][j], cnt);
			}
			if (j && i != r) {
				vector<ll> temp;
				for (ll i1 = 0; i1 < r; i1++) {
					for (ll j1 = 0; j1 < c; j1++) {
						if (i1 >= i && j1 >= j - 1) continue;
						temp.push_back(a[i1][j1]);
					}
				}
				sort(all(temp));
				ll cnt = 0;
				for (ll in = i; in < r; in++) {
					cnt += temp.end() - upper_bound(all(temp), a[in][j - 1]);
				}
				temp = {};
				for (ll in = i; in < r; in++) {
					cnt += temp.end() - upper_bound(all(temp), a[in][j - 1]);
					temp.push_back(a[in][j - 1]);
					sort(all(temp));
				}
				if (it) dp[it][i][j] = min(dp[it][i][j], dp[it - 1][i][j - 1] + cnt);
				else dp[it][i][j] = min(dp[it][i][j], cnt);
			}
		}
	}
	cout << min(min(dp[r - 1][r][0], dp[c - 1][0][c]), min(dp[r + c - 2][r - 1][c], dp[r + c - 2][r][c - 1])) << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}