#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct V {
    ll x{};
    ll y{};
    int i;
};

ll dist(V a, V b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector <V> vec(n);
    r *= r;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].x >> vec[i].y;
        vec[i].i = i;
    }

    vector <vector <int>> cnt(2 * n);
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dist(vec[i], vec[j]) <= r) {
                cnt[i * 2].push_back(2 * j + 1);
                cnt[i * 2 + 1].push_back(2 * j);
                cnt[j * 2].push_back(2 * i + 1);
                cnt[j * 2 + 1].push_back(2 * i);
            }
        }
    }
    vector <int> used(2 * n);
    int col = 1;
    int need = 0;
    int we = 0;
    auto dfs = [&](auto self, int v)-> void {
        used[v] = col;
        for (auto u : cnt[v]) {
            if (!used[u]) {
                self(self, u);
            }
        }
    };
    for (int i = 0; i < 2 * n; ++i) {
        if (!used[i]) {
            dfs(dfs, i);
            ++col;
        }
    }

    vector <int> ok(n);
    deque <int> d;
    for (int i = 0; i < n; ++i) {
        if (used[2 * i] == used[2 * i + 1]) {
            ok[i] = 1;
            d.push_back(i);
        }
    }

    while (d.size()) {
        int v = d.front();
        d.pop_front();
        for (auto u : cnt[v]) {
            if (!ok[u / 2]) {
                ok[u / 2] = 1;
                d.push_back(u);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ok[i];
    }
}

int main() {
    int tt = 1;
    //cin >> tt;

    while (tt--) solve();

    return 0;
}