#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    const int logn = __lg(n) + 1;
    vector mn(logn, vector<pair<int, int>>(n));
    for (int i = 0; i < n; ++i) {
        mn[0][i] = {a[i], i};
    }
    for (int l = 1; l < logn; ++l) {
        mn[l].resize(n - (1 << l) + 1);
        for (int i = 0; i < mn[l].size(); ++i) {
            mn[l][i] = min(mn[l - 1][i], mn[l - 1][i + (1 << l - 1)]);
        }
    }
    auto rangeMin = [&](int l, int r) {
        int b = __lg(r - l);
        return min(mn[b][l], mn[b][r - (1 << b)]).second;
    };

    vector<int> R(n, n), stk, sufmax(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        sufmax[i] = max(a[i], sufmax[i + 1]);
        while (!stk.empty() && a[stk.back()] < a[i]) {
            stk.pop_back();
        }
        R[i] = stk.empty() ? n : stk.back();
        stk.push_back(i);
    }
    stk.clear();
    auto nxt = [&](int i, int k) {
        int t = rangeMin(i, R[i]);
        if (t == i) {
            return i + 1;
        }
        if (t + k - 1 <= n) {
            return t;
        } else {
            return rangeMin(i + 1, n - (k - 1) + 1);
        }
    };
    vector<vector<int>> ar(n + 1);
    auto query = [&](int k, int x) {
        if (ar[k].empty()) {
            int t = k, i = 0;
            while (t > 1) {
                ar[k].push_back(i);
                i = nxt(i, t);
                t -= 1;
            }
            ar[k].push_back(i);
        }
        return x == k ? sufmax[ar[k][x - 1]] : a[ar[k][x - 1]];
    };

    while (q--) {
        int k, x;
        cin >> k >> x;
        cout << query(k, x) << '\n';
    }

    return 0;
}