#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<vector<int>> spt;
vector<int> a;

int req(int l, int r) {
    int k = __lg(r - l + 1);
    int v1 = spt[k][l], v2 = spt[k][r - (1 << k) + 1];
    return (a[v1] < a[v2] ? v1 : v2);
}

void solve() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    vector<int> suf(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int lg = 0, x = 1;
    while (x <= n) {
        x *= 2;
        lg++;
    }
    spt.assign(lg, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        spt[0][i] = i;
    }
    for (int k = 0; k + 1 < lg; ++k) {
        for (int i = 0; i + (2 << k) - 1 < n; ++i) {
            int v1 = spt[k][i], v2 = spt[k][i + (1 << k)];
            spt[k + 1][i] = (a[v1] < a[v2] ? v1 : v2);
        }
    }
    suf[n - 1] = a[n - 1];
    vector<int> nxt(n, n);
    for (int i = n - 2; i > -1; --i) {
        nxt[i] = nxt[i + 1];
        suf[i] = max(a[i], suf[i + 1]);
        if (a[i] > a[i + 1]) {
            nxt[i] = i;
        }
    }
    vector<int> rght(n, n);
    vector<int> st;
    st.push_back(n - 1);
    for (int i = n - 2; i > -1; --i) {
        while (st.size() && a[st.back()] < a[i]) {
            st.pop_back();
        }
        if (st.size()) rght[i] = st.back();
        st.push_back(i);
    }
    set<int> ks;
    vector<pair<int, int>> reqs(q);
    for (int i = 0; i < q; ++i) {
        int k, pos;
        cin >> k >> pos;
        reqs[i] = {k, pos};
        if (k != n) ks.insert(k);
    }
    //map<int, vector<int>> b;
    map<int, set<pair<int, int>>> b;
    set<pair<int, int>> cur = {{1, 0}};
    b[1] = cur;
    for (int k : ks) {
        cur.clear();
        int l = 0;
        int ind = 1;
        int left = k - 1;
        while (l < n) {
            if (left < 0) break;
            int mr = rght[l] - 1;
            mr = min(mr, n - left - 1);
            cur.insert({ind, l});
            if (left == 0) {
                break;
            }
            if (left == 1) {
                ind++;
                left--;
                if (rght[l] == n) {
                    l = n - 1;
                }
                else {
                    l = rght[l];
                }
                continue;
            }
            if (nxt[l] > l) {
                ind += (nxt[l] - l);
                left -= (nxt[l] - l);
                l = nxt[l];
                continue;
            }
            int mpos = req(l + 1, mr + 1);
            l = mpos;
            ind++;
            left--;
        }
        b[k] = cur;
    }
    for (int i = 0; i < q; ++i) {
        int k = reqs[i].first, pos = reqs[i].second;
        if (k == n) cout << a[pos - 1] << "\n";
        else {
            auto p = *(b[k].lower_bound({pos, 0}));
            if (pos == k) {
                cout << suf[p.second] << "\n";
                continue;
            }
            if (p.first == pos) {
                cout << a[p.second] << "\n";
            }
            else {
                int ind = p.second + pos - p.first;
                cout << a[ind] << "\n";
            }
        }
    }
}
 
int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}