#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second


ll sqrt_dist(pii a, pii b) {
    return ll(a.fi - b.fi) * ll(a.fi - b.fi) + ll(a.se - b.se) * ll(a.se - b.se);
}

vector<vector<int>> g;
vector<int> used;

vector<int> answer;

bool dfs(int v, int num) {
    used[v] = num;
    for (auto now : g[v]) {
        if (used[now] == num) return true;
        else if (used[now]) continue;
        int num2;
        if (num == 2) num2 = 1;
        if (num == 1) num2 = 2;
        if (dfs(now, num2)) return true;
    }
    return false;
}

void dfs2(int v, int z) {
    answer[v] = z;
    used[v] = 1;
    for (auto now : g[v]) {
        if (used[now]) continue;
        dfs2(now, z);
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    g.resize(n + 1);
    vector<pii> a(n + 1);
    answer.resize(n + 1);

    map<pii, int> mp;

    for (int i = 1; i <= n; i++) {
        cin >> a[i].fi >> a[i].se;
        mp[a[i]] = i;
    }
    pii dr;
    for (int i = 1; i <= n; i++) {
        for (int x = a[i].fi - r; x <= a[i].fi + r; x++) {
            for (int y = a[i].se - r; y <= a[i].se + r; y++) {
                if (x == a[i].fi && y == a[i].se) continue;
                dr = {x, y};
                if (sqrt_dist(a[i], dr) > r * r) continue;
                if (mp.find({x, y}) != mp.end()) {
                    int num = mp[{x, y}];
                    g[i].push_back(num);
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        if (answer[i] != 0) continue;
        used.assign(n + 1, 0);
        if (dfs(i, 1)) {
            used.assign(n + 1, 0);
            dfs2(i, 1);
        } else {
            used.assign(n + 1, 0);
            dfs2(i, 2);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (answer[i] == 1) cout << 1;
        else cout << 0;
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
