#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>

mt19937 rnd(1000-7);

vector<int> f;

ll n, m;

ll calc(int x) {
    ll res = 0;
    while (x) {
        res += f[x];
        x -= (x & -x);
    }
    return res;
}

void update(int x) {
    while (x <= m) {
        f[x]++;
        x += (x & -x);
    }
}

void solve() {

    cin >> n >> m;
    vector<int> a(m + 1);
    f.resize(m + 1);
    for (int i = 1; i <= m; i++) cin >> a[i];
    ll ans = 0;
    for (int i = m; i >= 1; i--) {
        ans += calc(a[i]);
        update(a[i]);
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
