#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using str = string;

const int INF = 1e9 + 239;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> mx(n);
	mx[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		mx[i] = max(mx[i + 1], a[i]);
	}
	int now = 0;
	pair<int, int> p = { INF, INF };
	for (int i = 0; i < n - 1; i++) {
		now = max(now, a[i]);
		p = min(p, { now, mx[i + 1] });
	}
	while (q--) {
		int k, i;
		cin >> k >> i;
		if (i == 1) {
			cout << p.first;
		}
		else {
			cout << p.second;
		}
		cout << '\n';
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}