#include <bits/stdc++.h>
#define ll long long
//#define int long long
#define F first
#define S second
using namespace std;

struct Vector {
    ll x, y;

    void in() {
        cin >> x >> y;
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    ll len2() {
        return x * x + y * y;
    }
};

const int inf = 1e9;
vector<int> col;
vector<vector<int> > gr;
int C = 0;

void dfs(int v) {
    col[v] = C;
    for (int i: gr[v]) {
        if (col[i] == -1) {
            dfs(i);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    vector<Vector> a(n);
    map<pair<ll,ll>, int> mp;
    for (int i = 0; i < n; ++i) {
        a[i].in();
        mp[{a[i].x, a[i].y}] = i;
    }
    gr.resize(n);
    col.resize(n, -1);
    vector<bool> good(n);
    for (int i = 0; i < n; ++i) {
        vector<Vector> g;
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (dx == 0 && dy == 0) {
                    continue;
                }
                if (dx * dx + dy * dy > r * r) {
                    continue;
                }
                if (!mp.count({a[i].x + dx, a[i].y + dy})) {
                    continue;
                }
                int id = mp[{a[i].x + dx, a[i].y + dy}];
                g.push_back(a[id]);
                gr[i].push_back(id);
            }
        }
        if (g.size() >= 6) {
            good[i] = 1;
        } else {
            for (int j = 0; j < g.size(); ++j) {
                for (int k = j + 1; k < g.size(); ++k) {
                    if ((g[j] - g[k]).len2() <= r * r) {
                        good[i] = 1;
                        break;
                    }
                }
                if (good[i]) {
                    break;
                }
            }
        }
    }
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            st.push_back(i);
            dfs(i);
            C++;
        }
    }
    vector<int> dist(n * 2, inf);
    queue<int> q;
    for (int i: st) {
        q.push(i);
        dist[i] = 0;
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        int normv = v % n;
        for (int i: gr[normv]) {
            if (v == normv) {
                if (dist[i + n] > dist[v] + 1) {
                    dist[i + n] = dist[v] + 1;
                    q.push(i + n);
                }
            } else {
                if (dist[i] > dist[v] + 1) {
                    dist[i] = dist[v] + 1;
                    q.push(i);
                }
            }
        }
    }
    vector<bool> gg(C);
    for (int i = 0; i < n; ++i) {
        if (dist[i] != inf && dist[i + n] != inf) {
            gg[col[i]] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << gg[col[i]];
    }
    return 0;
}
