#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lll = __int128;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    vector<vector<vector<int>>> t1(n, vector<vector<int>>(m, vector<int>(m)));
    vector<vector<vector<int>>> t2(n, vector<vector<int>>(m, vector<int>(n)));
    vector<int> cnt(n * m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int e = a[i][j] + 1; e < n * m; e++) {
                cur += cnt[e];
            }
            t1[i][j][0] = cur;
            for (int e = 0; e < j; e++) {
                for (int x = i + 1; x < n; x++) {
                    cur += a[x][e] > a[i][j];
                }
                t1[i][j][e + 1] = cur;
            }
            cnt[a[i][j]]++;
        }
    }
    fill(cnt.begin(), cnt.end(), 0);
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int e = a[i][j] + 1; e < n * m; e++) {
                cur += cnt[e];
            }
            t2[i][j][0] = cur;
            for (int e = 0; e < i; e++) {
                for (int y = j + 1; y <= m; y++) {
                    cur += a[e][y] > a[i][j];
                }
                t2[i][j][e + 1] = cur;
            }
            cnt[a[i][j]]++;
        }
    }
    vector<vector<int>> d(n + 1, vector<int>(m + 1, mod));
    d[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int e = j; e < m; e++) {
                for (ll x = 0; x < i; x++) {
                    for (ll y = 0; y < m; y++) {
                        cur += (a[x][y] > a[i][e]);
                    }
                }
                for (ll y = 0; y < j; y++) {
                    for (ll x = i; x < n; x++) {
                        cur += (a[x][y] > a[i][e]);
                    }
                }
                for (ll y = j; y < e; y++) {
                    cur += a[i][y] > a[i][e];
                }
            }
            d[i + 1][j] = min(d[i + 1][j], d[i][j] + cur);
            cur = 0;
            for (int e = i; e < n; e++) {
                for (ll x = 0; x < i; x++) {
                    for (ll y = 0; y < m; y++) {
                        cur += (a[x][y] > a[e][j]);
                    }
                }
                for (ll y = 0; y < j; y++) {
                    for (ll x = i; x < n; x++) {
                        cur += (a[x][y] > a[e][j]);
                    }
                }
                for (ll x = i; x < e; x++) {
                    cur += a[x][j] > a[e][j];
                }
            }
            d[i][j + 1] = min(d[i][j + 1], d[i][j] + cur);
        }
    }
    int ans = mod;
    for (ll i = 0; i <= n; i++) {
        ans = min(ans, d[i][m]);
    }
    for (ll j = 0; j <= m; j++) {
        ans = min(ans, d[n][j]);
    }
    cout << ans;
    return 0;
}