#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lll = __int128;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

vector<ll> t;

void update(ll v, ll l, ll r, ll p) {
    if (r - l < 2) {
        t[v] = 1;
        return;
    }
    ll m = (l + r) / 2;
    if (p < m) {
        update(v * 2 + 1, l, m, p);
    } else {
        update(v * 2 + 2, m, r, p);
    }
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (r <= ql || qr <= l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    ll m = (l + r) / 2;
    return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &it: a) {
        cin >> it;
    }
    vector<ll> sf(n);
    for (ll i = n - 1; i >= 0; i--) {
        sf[i] = max((i < n - 1 ? sf[i + 1] : 0), a[i]);
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        if (k == i) {
            i--;
            cout << sf[i] << '\n';
        } else {
            cout << a[i - 1] << '\n';
        }
    }
    return 0;
}