// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")

#include<bits/stdc++.h>
using namespace std;
#define int long long

struct frog {
    int x, y, i;
};

void solve() {
    int n, r;
    cin >> n >> r;
    vector<frog> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].i = i;
    }
    sort(a.begin(), a.end(), [&](frog f1, frog f2) {
        return f1.x < f2.x || (f1.x == f2.x && f1.i  < f2.i);
    });

    vector<vector<int>> g(2 * n);
    for (int v = 0; v < n; ++v) {
        for (int u = max(0ll, v - 2); u < min(v + 3, n); ++u) {
            if (v != u && (a[v].x - a[u].x) * (a[v].x - a[u].x) + (a[v].y - a[u].y) * (a[v].y - a[u].y) <= r * r) {
                g[2 * v].push_back(2 * u + 1);
                g[2 * v + 1].push_back(2 * u);
            }
        }
    }

    vector<bool> ans(n);
    for (int start = 0; start < n; ++start) {
        if (ans[start]) continue;
        queue<int> q;
        q.push(2 * start);
        vector<bool> used(2 * n);
        used[2 * start] = true;

        while (!q.empty()) {
            int v = q.front();
            q.pop();

            for (int u : g[v]) {
                if (!used[u]) {
                    q.push(u);
                    used[u] = true;
                }
            }
        }

        for (int v = 0; v < n; ++v) {
            if (used[2 * v] && used[2 * v + 1]) {
                ans[v] = true;
            }
        }

        //ans[start] = used[2 * start + 1];
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

/*
6 5
4 1
4 4
1 5
5 9
9 6
10 2
111000
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}