// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")

#include<bits/stdc++.h>
using namespace std;
//#define int long long

void solve() {
    int n;
    long long r;
    cin >> n >> r;
    vector<int> x(n), y(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        mp[{x[i], y[i]}] = i;
    }

    vector<bool> ans(n);
    for (int start = 0; start < n; ++start) {
        if (ans[start]) continue;
        queue<int> q;
        q.push(2 * start);
        vector<bool> used(2 * n);
        used[2 * start] = true;

        while (!q.empty()) {
            int v = q.front();
            q.pop();

            int real_v = v / 2;
            int c = v % 2;
            c = !c;

            for (int dx = -r; dx <= r; ++dx) {
                for (int dy = -r; dy <= r; ++dy) {
                    if (mp.count({x[real_v] + dx, y[real_v] + dy})) {
                        int u = mp[{x[real_v] + dx, y[real_v] + dy}];
                        if (!used[2 * u + c] && real_v != u && (long long)(x[real_v] - x[u]) * (x[real_v] - x[u]) + (long long)(y[real_v] - y[u]) * (y[real_v] - y[u]) <= r * r) {
                            used[2 * u + c] = true;
                            q.push(2 * u + c);
                        }
                    }
                }
            }
        }

        for (int v = 0; v < n; ++v) {
            if (used[2 * v] && used[2 * v + 1]) {
                ans[v] = true;
            }
        }

        //ans[start] = used[2 * start + 1];
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

/*
6 5
4 1
4 4
1 5
5 9
9 6
10 2
111000
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}