// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")
//#define _GLIBCXX_DEBUG 1
#include<bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    cin >> a;
    vector<int> suf(n);
    suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }

    while (q--) {
        int k, j;
        cin >> k >> j;
        if (j < k) {
            cout << a[j - 1] << "\n";
        } else {
            cout << suf[k - 1] << "\n";
        }
    }
}

/*
6 0
1 6 2 5 3 4

7 0
6 4 2 3 1 5 7

6 1
1 6 2 5 3 4
6 3

7 4
6 4 2 3 1 7 5
7 4
1 1
4 2
5 3
3
7
1
3
3 1
2 3 1
2 2
3

*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}