#include "bits/stdc++.h"
using namespace std;
#define int int64_t

struct pt {
    int x, y;
    int index = 0;
    int sqdist(const pt &p) const {
        return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
    }
};

istream &operator>>(istream &in, pt &p) {
    in >> p.x >> p.y;
    return in;
}

vector<vector<int> > g;

vector<int> used;
vector<int> col;
bool good = true;

void dfs(vector<int> &incomp, int x, int c) {
    used[x] = 1;
    incomp.push_back(x);
    col[x] = c;
    for (int u: g[x]) {
        if (!good) return;
        if (!used[u]) {
            dfs(incomp, u, 1 - c);
        }
        if (col[u] == c) {
            good = false;
            break;
        }
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    used.assign(n, {});
    g.assign(n, {});
    col.assign(n, -1);
    int sqr = r * r;
    vector<pt> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        p[i].index = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (p[i].sqdist(p[j]) <= sqr) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    // for (int i = 0; i < n; ++i) {
    //     for (int u: g[i]) {
    //         if (i < u) {
    //             cout << i << ' ' << u << endl;
    //         }
    //     }
    // }
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            vector<int> incomp;
            good = true;
            dfs(incomp, i, 0);
            if (!good) {
                // cout << "GRAPHERITO POPITO: \n";
                for (int j: incomp) {
                    // cout << j << ' ';
                    ans[j] = 1;
                }
                // cout << endl;
            }
        }
    }
    for (int i: ans) cout << i;
}

signed main() {
#ifdef SEREGA
    freopen("/home/roi/work/proj/input.txt", "r", stdin);
    freopen("/home/roi/work/proj/output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}
