#include <iostream>
#include<map>
#include<vector>
#include<algorithm>
#pragma GCC optimize("Ofast", "unroll-loops")
using namespace std;

long long cnt;
void dfs(long long v, vector<vector<long long>> &g, vector<pair<long long, long long>>&dist, long long &cur_col, long long p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first+1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long n, r;
    cin >> n >> r;
    vector<vector<long long>> g(n);
    vector<pair<long long, long long>> P;
    map<pair<long long,long long>, long long> d;
    for (long long i = 0; i < n; ++i) {
        long long x, y;
        cin >> x >> y;
        P.push_back({x, y});
        d[{x, y}] = i;
    }
    for (long long _ = 0; _ < n; ++_) {
        pair<long long, long long> wer = P[_];
        long long x = wer.first;
        long long y = wer.second;
        for (long long i = y + r; i >= y - r; --i) {
            for (long long j = 0; j *j <= r * r - (y - i) * (y - i); ++j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
            for (long long j = -1; j *j <= r * r - (y - i) * (y - i); --j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
        }
    }
    long long cur_color = 1;
    vector<long long> ans;
    vector<pair<long long, long long>> dist(n);
    for (long long i = 0; i < n; ++i) {
        if (dist[i].first == 0) {
            cnt = 0;
            dfs(i, g, dist, cur_color);
            ans.push_back(cnt);
            cur_color++;
        }
    }
    for (long long i = 0;i < n; ++i) {
        cout<<ans[dist[i].second - 1];
    }
}