#include <iostream>
#include<map>
#include<vector>
#include<random>
#pragma GCC optimize("Ofast", "unroll-loops", "O3")
using namespace std;
mt19937 rnd(18);
long long cnt;
void dfs(long long v, vector<vector<long long>> &g, vector<pair<long long, long long>>&dist, long long &cur_col, long long p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first + 1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}
//
// string solve_b(int n, int r, vector<pair<long long, long long>> &P) {
//     vector<vector<long long>> g(n);
//     for (long long i = 0; i < n; ++i) {
//         for (long long j = i + 1; j < n; ++j) {
//             if ((P[i].first - P[j].first) * (P[i].first - P[j].first) + (P[i].second - P[j].second) * (P[i].second - P[j].second) <= r * r) {
//                 g[i].push_back(j);
//                 g[j].push_back(i);
//             }
//         }
//     }
//     long long cur_color = 1;
//     vector<long long> ans;
//     vector<pair<long long, long long>> dist(n);
//     for (long long i = 0; i < n; ++i) {
//         if (dist[i].first == 0) {
//             cnt = 0;
//             dfs(i, g, dist, cur_color);
//             ans.push_back(cnt);
//             cur_color++;
//         }
//     }
//     string s;
//     for (long long i = 0;i < n; ++i) {
//         if (ans[dist[i].second - 1]==1) {
//             s += '1';
//         }
//         else {
//             s+= '0';
//         }
//     }
//     return s;
// }

string real_solve(int n, int r, vector<pair<long long, long long>> &P) {
    vector<vector<long long>> g(n);
    map<pair<long long,long long>, long long> d;
    for (long long i = 0; i < n; ++i) {
        pair<int, int> qye = P[i];
        long long x = qye.first;
        long long y = qye.second;
        d[{x, y}] = i;
    }
    for (long long _ = 0; _ < n; ++_) {
        pair<long long, long long> wer = P[_];
        long long x = wer.first;
        long long y = wer.second;
        for (long long i = y + r; i >= y - r; --i) {
            for (long long j = 0; j *j <= r * r - (y - i) * (y - i); ++j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
            for (long long j = -1; j *j <= r * r - (y - i) * (y - i); --j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
        }
    }
    long long cur_color = 1;
    vector<long long> ans;
    vector<pair<long long, long long>> dist(n);
    for (long long i = 0; i < n; ++i) {
        if (dist[i].first == 0) {
            cnt = 0;
            dfs(i, g, dist, cur_color);
            ans.push_back(cnt);
            cur_color++;
        }
    }
    string s;
    for (long long i = 0;i < n; ++i) {
        s += ans[dist[i].second - 1] + '0';
    }
    return s;
}

void solve_d() {
    int n;
    int q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n ;++i) {
        cin >> a[i];
    }
    vector<int> b;
    b.push_back(a[0]);
    int max_ = 0;
    int last = 0;
    for (int i = 1; i < n - 1; ++i) {
        if (last == i - 1 && a[i] < a[0]) {
            last++;
        }
        else {
            max_ = max(a[i], max_);
        }
    }
    b.push_back(max(max_, a[n - 1]));
    for (int i = 0; i < q; ++i) {
        int k, ind;
        cin >> k >> ind;
        cout << b[ind - 1] << '\n';
    }
    return;
    int i = 1;
    int min_ = -1;
    while (a[i] < a[0]) {
        if (min_ == -1 || a[min_] > a[i]) {
            min_ = i;;
        }
        i++;
    }
    if (min_ == -1) {
        b.push_back(a[1]);
    }
    else {
        b.push_back(0);
    }

    for (int _ = 0; _ < q; ++_) {
        int k, ind;
        cin >> k >> ind;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve_d();
    return 0;
    cnt = 0;
    vector<pair<long long, long long>> P;
    for (int i = 0; i < 100000; ++i) {
        int x = rnd() %(100000000);
        int y = rnd()%(100000000);
        cout << x << ' ' << y << '\n';
        P.push_back({x, y});
    }
    cout << real_solve(100000, 2, P);
    return 0;
    while (cnt == 0) {
        cnt = 1;
        int n;
        cin >> n;
        int r;
        cin >> r;
        vector<pair<long long, long long>> P;
        for (long long i = 0; i < n; ++i) {
            long long x, y;
            cin >> x >> y;
            // x = rnd() % (5 * 100000000);
            // y = rnd() % (5 * 100000000);
            P.push_back({x, y});
        }
        cout << real_solve(n, r, P);
        return 0;
        // if (solve_b(n, r, P) != real_solve(n, r, P)) {
        //     cout << n << ' ' <<r << '\n';
        //     for (auto [x, y]:P) {
        //         cout << x << ' ' << y;
        //         cout << '\n';
        //     }
        //     cout << solve_b(n, r, P) << ' ' << real_solve(n, r, P) << '\n';
        //     break;
        // }
        // else {
        //     cout << "OK\n";
        // }
    }


    //
    // return 0;
    // long long n, r;
    // cin >> n >> r;
    // vector<vector<long long>> g(n);
    // vector<pair<long long, long long>> P;
    // map<pair<long long,long long>, long long> d;
    // for (long long i = 0; i < n; ++i) {
    //     long long x, y;
    //     cin >> x >> y;
    //     P.push_back({x, y});
    //     d[{x, y}] = i;
    // }
    // for (long long _ = 0; _ < n; ++_) {
    //     pair<long long, long long> wer = P[_];
    //     long long x = wer.first;
    //     long long y = wer.second;
    //     for (long long i = y + r; i >= y - r; --i) {
    //         for (long long j = 0; j *j <= r * r - (y - i) * (y - i); ++j) {
    //             if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
    //                 g[_].push_back(d[{j + x, i}]);
    //             }
    //         }
    //         for (long long j = -1; j *j <= r * r - (y - i) * (y - i); --j) {
    //             if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
    //                 g[_].push_back(d[{j + x, i}]);
    //             }
    //         }
    //     }
    // }
    // long long cur_color = 1;
    // vector<long long> ans;
    // vector<pair<long long, long long>> dist(n);
    // for (long long i = 0; i < n; ++i) {
    //     if (dist[i].first == 0) {
    //         cnt = 0;
    //         dfs(i, g, dist, cur_color);
    //         ans.push_back(cnt);
    //         cur_color++;
    //     }
    // }
    // for (long long i = 0;i < n; ++i) {
    //     cout<<ans[dist[i].second - 1];
    // }
}