#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int r, c;
    cin >> r >> c;

    vector<vector<int>> table(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> table[i][j];
        }
    }

    int best = INF;
    
    int res = 0;
    ordered_set s;
    for (int i = 0; i < r * c; ++i) {
        res += s.size() - s.order_of_key(table[0][i]);
        s.insert(table[0][i]);
    }
    best = min(best, res);

    cout << best;

    return 0;
}