#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll r, c;
    cin >> r >> c;

    vector<vector<ll>> table(r, vector<ll>(c));
    for (ll i = 0; i < r; ++i) {
        for (ll j = 0; j < c; ++j) {
            cin >> table[i][j];
        }
    }

    ll best = INF;
    
    ll res = 0;
    ordered_set s;
    for (ll i = 0; i < r * c; ++i) {
        res += s.size() - s.order_of_key(table[0][i]);
        s.insert(table[0][i]);
    }
    best = min(best, res);

    cout << best;

    return 0;
}