#include<bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> sparse;

void build(vector<pair<int, int>>& a) {
    sparse.push_back(a);
    for (int i = 1; (1 << i) < a.size(); i++) {
        sparse.push_back({});
        for (int j = 0; j + (1 << i-1) < sparse[i-1].size(); j++) {
            sparse[i].push_back(min(sparse[i-1][j], sparse[i-1][j + (1<<i-1)]));
        }
    }
}

vector<int> lg;

pair<int, int> get(int l, int r) {
    int s = lg[r-l];
    return min(sparse[s][l], sparse[s][r - (1 << s)]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int&i : a)
        cin >> i;

    vector<int> right(n);
    vector<int> st = {n};
    for (int i = n-1; i > -1; i--) {
        while (st.size() > 1 && a[st.back()] < a[i])
            st.pop_back();
        right[i] = st.back();
        st.push_back(i);
    }

    vector<pair<int, int>> argmin(n);
    for (int i = 0; i < n; i++) {
        argmin[i] = {a[i], i};
    }
    build(argmin);
    lg = vector<int>(n + 1);
    for (int i = 2; i < n + 1; i++)
        lg[i] = lg[i/2] + 1;

    vector<int> suffmax(n+1);
    for (int i = n-1; i > -1; i--) {
        suffmax[i] = max(suffmax[i+1], a[i]);
    }

    for (int _ = 0; _ < q; _++) {
        int k, i;
        cin >> k >> i;
        int ans = 0;
        int l = 0;
        for (int it = 1; it <= i; it++) {
            if (it == k) {
                ans = suffmax[l];
                break;
            }
            int r = min(right[l], n - (k-it));
            int topmini = get(l+1, r+1).second;
            // if (a[r] < a[topmini]) {
            //     ans = r;
            //     l = r;
            // }
            {
                ans = a[l];
                l = topmini;
            }
        }
        cout << ans << '\n';
    }
}

void solve4() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int&i : a)
        cin >> i;

    vector<int> right(n);
    vector<int> st = {n};
    for (int i = n-1; i > -1; i--) {
        while (st.size() > 1 && a[st.back()] < a[i])
            st.pop_back();
        right[i] = st.back();
        st.push_back(i);
    }

    vector<pair<int, int>> argmin(n);
    for (int i = 0; i < n; i++) {
        argmin[i] = {a[i], i};
    }
    build(argmin);
    lg = vector<int>(n + 1);
    for (int i = 2; i < n + 1; i++)
        lg[i] = lg[i/2] + 1;

    vector<int> suffmax(n+1);
    for (int i = n-1; i > -1; i--) {
        suffmax[i] = max(suffmax[i+1], a[i]);
    }

    for (int _ = 0; _ < q; _++) {
        int k, i;
        cin >> k >> i;
        if (i == k)
            cout << suffmax[i-1] << '\n';
        else
            cout << a[i-1] << '\n';
    }


}

void stress() {

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    cin >> t;
#endif
    while (t--) {
        solve4();
        cout << '\n';
    }
}