#include <bits/stdc++.h>

using namespace std;

struct fenw {
    int n;
    vector<int> vec, used;
    fenw(int _n): n(_n), vec(_n + 1) {}
    void change(int x, int add) {
        for (; x <= n; x += x & -x) {
            if (vec[x] == 0) used.push_back(x);
            vec[x] += add;
        }
    }
    int get(int x) {
        int ans = 0;
        for (; x; x -= x & -x) {
            ans += vec[x];
        }
        return ans;
    }
    void clear() {
        for (auto elem : used)
            vec[elem] = 0;
        used.clear();
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> vec(n, vector<int> (m)), dp(n + 1, vector<int> (m + 1));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> vec[i][j];
    fenw f(n * m);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            int am1 = dp[i + 1][j];
            for (int ii = i + 1; ii < n; ii++)
                for (int jj = j; jj < m; jj++)
                    f.change(vec[ii][jj], 1);
            for (int jj = m - 1; jj >= j; jj--) {
                am1 += f.get(vec[i][jj]);
                f.change(vec[i][jj], 1);
            }
            f.clear();
            int am2 = dp[i][j + 1];
            for (int ii = i; ii < n; ii++)
                for (int jj = j + 1; jj < m; jj++)
                    f.change(vec[ii][jj], 1);
            for (int ii = n - 1; ii >= i; ii--) {
                am2 += f.get(vec[ii][j]);
                f.change(vec[ii][j], 1);
            }
            f.clear();
            dp[i][j] = min(am1, am2);
        }
    }
    cout << dp[0][0] << '\n';
}