#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()
#define REP(x) for(int i = 0 ; i < x ; i ++)

struct duo {
	ll x;
	ll ind;
	bool operator< (const duo& Other)const {
		return x < Other.x;
	}
};

vector<int> used;
vector<duo> arr;

void bfs(ll curr,ll lst,ll r,ll n) {
	used[curr] = 1;
	if (curr > 0 && curr - 1 != lst && arr[curr].x - arr[curr - 1].x <= r&& used[curr-1] != 1) {
		bfs(curr-1,curr,r,n);
	}

	if (curr < n-1 && curr + 1 != lst && arr[curr+1].x - arr[curr].x <= r && used[curr + 1] != 1) {
		bfs(curr - 1, curr, r,n);
	}
}

int main()
{
	ll n,r,x,y;
	cin >> n >> r;

	
	REP(n) {
		cin >> x >> y;
		arr.push_back({x,i});
	}

	vector<bool> ans_arr(n);
	
	sort(all(arr));
	used.resize(n, -1);
	for (int i = 0; i < n; i++) {
		ll curr = i;
		if (curr + 2 < n && arr[curr + 2].x - arr[curr].x <= r) {
			used[curr] = 1;
		}
		if (curr - 2 >= 0 && -arr[curr - 2].x + arr[curr].x <= r) {
			used[curr] = 1;
		}
	}

	for (int i = 0; i < n; i++) {
		if (used[i] == 1) {
			bfs(i,-1,r,n);
		}
	}

	for (int i = 0; i < n; i++) {
		if (used[i] == 1) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}

