#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<vector>
#include<string>
#include<algorithm>

using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

#pragma GCC optimize("Ofast, O3")
#pragma GCC target("avx2")

vector<vector<int>> g;
vector<int> t;
bool f = 0;

void dfs(int v, int c) {
	if (f) return;
	if (t[v] != -1) {
		if (t[v] == c) return;
		f = 1;
		return;
	}
	t[v] = c;

	for (int u : g[v])
		dfs(u, c ^ 1);

}

int dist(pair<int, int> a, pair<int, int> b) {
	int x = a.first - b.first;
	int y = a.second - b.second;
	return x * x + y * y;
}

void solve() {
	int n; cin >> n;
	g.resize(n);

	int r; cin >> r;
	vector<pair<int, int>> p(n);
	for (auto& [x, y] : p) cin >> x >> y;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (dist(p[i], p[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		f = 0;
		t.assign(n, -1);
		dfs(i, 0);
		if (f) cout << 1;
		else cout << 0;
	}
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG
	int t = 1;
	while (t--) solve();
}