#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<unordered_map>
#include<map>

using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

#pragma GCC optimize("Ofast, O3")
#pragma GCC target("avx2")


vector<int> t(2e6);
void add(int v, int x) {
	for (; v < t.size(); v += v & -v)
		t[v] += x;
}

int sm(int l) {
	int s = 0;
	for (; l; l -= l & -l)
		s += t[l];
	return s;
}


int r, c;
int cur = 0;
int ans = 1e18;
vector<vector<int>> a;

void f(int i, int j, int d) {
	if (cur >= ans) return;

	if (i >= r || j >= c) {
		ans = min(ans, cur);
		return;
	}
	
	
	if (i < r) {
		for (int v = j; v < c; ++v) {
			cur += d - sm(a[i][v]);
			add(a[i][v], 1);
			++d;
		}
		f(i + 1, j, d);

		for (int v = c - 1; v >= j; --v) {
			--d;
			add(a[i][v], -1);

			cur -= d - sm(a[i][v]);

		}
		if (i == r - 1) return;
	}

	if (j < c) {
		for (int v = i; v < r; ++v) {
			cur += d - sm(a[v][j]);
			++d;
			add(a[v][j], 1);
		}
		f(i, j + 1, d);

		for (int v = r - 1; v >= i; --v) {
			--d;
			add(a[v][j], -1);
			cur -= d - sm(a[v][j]);
		}
	}
	
}
void solve() {

	 cin >> r >> c;
	a.resize(r, vector<int>(c));
	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			cin >> a[i][j];

	f(0, 0, 0);
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG
	int t = 1;
	while (t--) solve();
}