#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<unordered_map>
#include<map>

using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

#pragma GCC optimize("Ofast, O3")
#pragma GCC target("avx2")



vector<int> t, a;

void build(int v, int l, int r) {
	if (r - l == 1) {
		t[v] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int x, int y) {
	if (y <= l || r <= x) return -1;
	if (x <= l && r <= y) {
		return t[v];
	}
	int m = (l + r) / 2;
	return max(get(2 * v + 1, l, m, x, y),
		get(2 * v + 2, m, r, x, y));
}

void solve() {
	int n, q; cin >> n >> q;
	a.resize(n);
	for (int& i : a) cin >> i;
	vector<int> ans(3, -1);

	int c = 0;

	for (int i = 0; i < n; ++i) {
		if (i == 0) {
			ans[0] = a[i];
		}
		else {
			if (ans[c] >= a[i]) continue;
			if (c < 2) ans[++c] = a[i];
			else ans[c] = a[i];
		}
	}

	if (ans[1] == -1) {
		ans[1] = a[n - 2];
	}
	if (ans[2] == -1) {
		ans[2] = a[n - 1];
	}

	while (q--) {
		int k, i; cin >> k >> i;
		cout << ans[i - 1] << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG
	int t = 1;
	while (t--) solve();
}