#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(x) (int)(x).size()

signed main() {
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif

    int n, q; cin >> n >> q;
    string s; cin >> s;

    vector<pair<int, int>> blocks;
    int l = -1;
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (l != -1) blocks.pb({l, i - 1});
            l = -1;
        } else {
            if (l == -1) l = i;
        }
    }
    if (l != -1) blocks.pb({l, n - 1});
    int sm = 0;
    for (auto u : blocks) sm += u.first - u.second + 1;

    int cnt2 = 0, cnt1 = 0, sm2 = 0;
    for (int i = 0; i < sz(blocks); i++) {
        if (blocks[i].second == blocks[i].first) {
            if (i + 1 < sz(blocks) && blocks[i + 1].second == blocks[i + 1].first && blocks[i + 1].first -blocks[i].first == 2) {
                cnt2++; i++;
            } else {
                cnt1++;
            }
        } else {
            sm2 += blocks[i].second - blocks[i].first + 1;
        }
    }

    while (q--) {
        int C; cin >> C;
        if (C + sm >= n) {
            cout << (n > 1 ? n : 0) << '\n';
            continue;
        }  
        if (sm == 0) {
            cout << (C > 1 ? C : 0) << '\n';
            continue;
        }  
        int ans = sm2 + C;
        int pick2 = min(C, cnt2);
        ans += 2 * pick2;
        C -= pick2;
        int pick1 = min(C, cnt1);
        ans += pick1;
        cout << ans << '\n';
    }

    return 0;
}