#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
 
#define pb push_back
#define sz(x) (int)(x).size()
#define int ll 

signed main() {
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
 
    int n, r; cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;

    string ans;
    for (int i = 0; i < n; i++) ans += '0';

    if (r == 1) {
        map<pair<int, int>, int> pos;
        for (int i = 0; i < n; i++) pos[a[i]] = i;
        vector<vector<int>> g(n);
        vector<pair<int, int>> D = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
        for(int i = 0; i < n; i++) {
            for (auto u : D) {
                if (pos.find({a[i].first + u.first, a[i].second + u.second}) != pos.end()) {
                    g[i].pb(pos[{a[i].first + u.first, a[i].second + u.second}]);
                }
            }
        }
        vector<int> col(n, -1);
        bool bad = 0;
        vector<int> cmp;
        auto dfs = [&](int v, auto&&self) -> void {
            cmp.pb(v);
            for (int u : g[v]) {
                if(col[u] == -1) {
                    col[u] = 1 - col[v];
                    self(u, self);
                } else if (col[u] == col[v]) {
                    bad = 1;
                }
            }
        };  
        for (int i = 0; i < n; i++) {
            if (col[i] == -1) {
                cmp.clear();
                bad = 0;
                col[i] = 0;
                dfs(i, dfs);
                if(bad) {
                    for (auto u : cmp) ans[u] = '1';
                }
            }
        }
        cout << ans << '\n';
        return 0;
    }

    int L = 0, R = 1e9;
    while (R - L > 1) {
        int M = (L + R) / 2;
        if (2 * M * M <= r * r) L = M;
        else R = M;
    }
    auto check = [&](int i, int j) {
        return (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r;
    };

    map<pair<int, int>, vector<int>> ptbs;
    map<pair<int, int>, int> ID;
    for (int i = 0; i < n; i++) {
        int si = a[i].first / L, sj = a[i].second / L;
        ptbs[{si, sj}].pb(i);
    }
    vector<vector<int>> g2(sz(ptbs));
    vector<int> is_good(sz(ptbs)), pt_id(sz(ptbs), -1);
    vector<int> vert_id(n, -1);
    int id = -1;
    for (auto u : ptbs) {
        id++;
        ID[u.first] = id;
        if (sz(u.second) >= 3) {
            is_good[id] = 1;
            continue;
        }
        for (int i : u.second) {
            is_good.pb(0); pt_id.pb(i); g2.pb({}); vert_id[i] = sz(g2) - 1;
        }
        if (u.second.size() == 2) {
            g2[sz(g2) - 1].pb(sz(g2) - 2); g2[sz(g2) - 2].pb(sz(g2) - 1);
        }
    }
    id = -1;
    for (auto u : ptbs) {
        id++;
        if (sz(u.second) >= 3) {
            continue;
        }
        for (int dx = -2; dx <= 2; dx++) {
            for (int dy = -2; dy <= 2; dy++) {
                if (dx == 0 && dy == 0) continue;
                if (ptbs.find({u.first.first + dx, u.first.second + dy}) != ptbs.end()) {
                    bool big = (sz(ptbs[make_pair(u.first.first + dx, u.first.second + dy)]) >= 3);
                    int iddd = ID[make_pair(u.first.first + dx, u.first.second + dy)];
                    for (auto pid : ptbs[{u.first.first + dx, u.first.second + dy}]) {
                        for (int j = 0; j < sz(u.second); j++) {
                            if (check(pid, u.second[j])) {
                                if (big) {
                                    g2[iddd].pb(vert_id[u.second[j]]);
                                    g2[vert_id[u.second[j]]].pb(iddd);
                                } else {
                                    g2[vert_id[pid]].pb(vert_id[u.second[j]]);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    vector<int> cmp, col(sz(g2), -1);
    bool isgood = 0;
    auto dfs = [&](int v, auto&&self) -> void {
        cmp.pb(v);
        if (is_good[v]) isgood = 1;
        for (int u : g2[v]) {
            if (col[u] == -1) {
                col[u] = 1 - col[v];
                self(u, self);
            } else if (col[u] == col[v]) isgood = 1;
        }
    };
    for (int i = 0; i < sz(g2); i++) {
        if (col[i] == -1) {
            col[i] = 0; cmp.clear(); isgood = 0;
            dfs(i, dfs);
            for (int u : cmp) {
                if (pt_id[u] != -1 && isgood) ans[pt_id[u]] = '1';
            }
        }
    }
    cout << ans << '\n';
 
    return 0;
}