#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
 
#define pb push_back
#define sz(x) (int)(x).size()

const int MAXN = 300010;
int sp[19][MAXN], spmx[19][MAXN];

void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> nxt(n, -1);
    stack<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && a[st.top()] < a[i]) st.pop();
        nxt[i] = (st.empty() ? n : st.top());
        st.push(i);
    }

    for (int i = 0; i < n; i++) sp[0][i] = spmx[0][i] = i;
    auto cmp = [&](int i, int j) {
        return (a[i] < a[j] ? i : j);
    };
    auto cmp2 = [&](int i, int j) {
        return (a[i] > a[j] ? i : j);
    };
    for (int i = 1; i < 19; i++) {
        for (int j = 0; j + (1 << i) - 1 < n; j++) {
            sp[i][j] = cmp(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
            spmx[i][j] = cmp2(spmx[i - 1][j], spmx[i - 1][j + (1 << (i - 1))]);
        }
    }
    auto get = [&](int l, int r) {
        int lg = 31 - __builtin_clz(r - l + 1);
        //cout << l << ' ' << r << ' ' << 
        return cmp(sp[lg][l], sp[lg][r - (1 << lg) + 1]);
    };
    auto getmx = [&](int l, int r) {
        int lg = 31 - __builtin_clz(r - l + 1);
        //cout << l << ' ' << r << ' ' << 
        return cmp2(spmx[lg][l], spmx[lg][r - (1 << lg) + 1]);
    };

    vector<vector<pair<int, int>>> qrs(n + 1);
    for (int i = 0; i < q; i++) {
        int k, id; cin >> k >> id; id--; qrs[k].pb({id, i});
    }

    auto build = [&](int K) -> vector<int> {
        if (K == 1) return {n};
        int cur = 0;
        vector<int> ans = {a[0]};
        for (int i = 1; i < K - 1; i++) {
            int rest = K - i - 1;
            int newpos = (nxt[cur] < n - rest ? get(cur + 1, nxt[cur]) : get(cur + 1, n - rest - 1));
            ans.pb(a[newpos]); cur = newpos;
        }
        int maxr = (nxt[cur] == n ? n - 2 : nxt[cur] - 1);
        ans.pb(a[getmx(maxr + 1, n - 1)]);
        return ans;
    };
    vector<int> ans(q);
    for (int K = 1; K <= n; K++) {
        if (!qrs[K].empty()) {
            auto result = build(K);
            // cout << K << ' ';
            // for (int u : result) cout << u << ' ';
            // cout << '\n';
            for (auto [pos, qi] : qrs[K]) ans[qi] = result[pos];
        }   
    }
    for (auto u : ans) cout << u << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (tt--) {
        solve();
    }

    return 0;
}