//#define __GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
#define ll int64_t
#define int ll

ll r;

vector<pair<ll,vector<ll>>> cmp;

void dfs(ll u, vector<pair<ll,ll>>&t, vector<int8_t>& used, bool& fl, vector<bool>& c) {
    used[u] = 1;
    cmp.back().second.push_back(u);
    for (int i = 0;i < t.size(); ++i) {
        if (i != u) {
            ll xr = t[i].first - t[u].first, yr = t[i].second - t[u].second;
            if (xr * xr + yr * yr <= r * r) {
                if (!used[i]) {
                    c[i] = !c[u];
                    dfs(i, t, used, fl, c);
                } else if (used[i] && c[i] != !c[u]) {
                    fl = 1;
                }
            }
        }
    }
    used[u] = 2;
}

ll dist(pair<ll,ll> a, pair<ll,ll> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    ll n;
    cin >> n;
    cin >> r;
    vector<pair<pair<ll,ll>,ll>> t(n);
    for (int i = 0;i < n; ++i) {
        cin >> t[i].first.first >> t[i].first.second;
        t[i].second = i;
    }
    sort(t.begin(), t.end());
vector<ll> c(n);
    for (int i = 0;i < n; ++i) {
        bool fl = 0;
        if (i -1 > -1 && i + 1 < n && ((dist(t[i - 1].first, t[i].first) <= r * r && dist(t[i].first, t[i + 1].first) <= r * r && dist(t[i - 1].first, t[i + 1].first) <= r * r))) {
            fl = 1;
        }
        if (i > 1) {
            if (dist(t[i - 2].first, t[i - 1].first) <= r * r && dist(t[i - 1].first, t[i].first) <= r * r && dist(t[i - 2].first, t[i].first) <= r * r) {
                fl = 1;
            }
        }
        if (i + 2 < n) {
            if (dist(t[i +2].first, t[i + 1].first) <= r * r && dist(t[i + 1].first, t[i].first) <= r * r && dist(t[i + 2].first, t[i].first) <= r * r) {
                fl = 1;
            }
        }
        c[t[i].second] = fl;
    }
    for (auto el:c) {
        cout << el;
    }
}