#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(v) (v).begin(), (v).end()
typedef pair<int, int> pii;
const int N = 2e5;
const int mod = 1e9 + 7;

int r, c;
vector<vector<int>> a;

int n;
int t[N];
void upd(int p, int x)
{
	p += n;
	t[p] = x;
	while (p > 1)
		p /= 2, t[p] = t[p*2] + t[p*2+1];
}
int getsum(int l, int r)
{
	l += n, r += n;
	int res = 0;
	while (l < r)
	{
		if (l&1) res += t[l++];
		if (r&1) res += t[--r];
		l /= 2, r /= 2;
	}
	return res;
}

int32_t main()
{
	cin >> r >> c;
	a.resize(r);
	for (int i = 0; i < r; i++)
	{
		a[i].resize(c);
		for (int j = 0; j < c; j++)
			cin >> a[i][j], a[i][j]--;
	}

	int ans = LONG_MAX;

	mt19937 rnd(39);

	for (int tt = 0; tt < 500; tt++)
	{
		int dr, dc;
		dr = dc = 0;
		vector<int> b;
		int mask = 0;

		for (int bit = 0; bit < r+c-1; bit++)
			mask |= (rnd()%2) << bit;
		
		if (__builtin_popcount(mask) > c ||
				r+c-1 - __builtin_popcount(mask) > r)
			continue;
		
		for (int bit = 0; bit < r+c-1; bit++)
		{
			if (mask & (1 << bit))
			{
				for (int i = dr; i < r; i++)
					b.push_back(a[i][dc]);
				dc++;
			}
			else
			{
				for (int i = dc; i < c; i++)
					b.push_back(a[dr][i]);
				dr++;
			}
		}
		int inv = 0;
		fill_n(t, r*c*4 + 10, 0);
		n = r*c;
		for (int i = 0; i < r*c; i++)
		{
			inv += getsum(b[i], r*c);
			upd(b[i], 1);
		}
		ans = min(ans, inv);
	}
	cout << ans << '\n';
}

