#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 250005;
int tree[N * 4] = {0}, tree1[N * 4] = {0};
int rt, ct;

void update(int v, int i, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (i < lx or rx <= i) return;
    if (rx - lx == 1) {
        tree[x] += v;
        return;
    }
    int mx = (lx + rx) / 2;
    update(v, i, x * 2 + 1, lx, mx);
    update(v, i, x * 2 + 2, mx, rx);
    tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
}

int get(int l, int r, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (r <= lx or rx <= l) return 0;
    if (l <= lx and rx <= r) return tree[x];
    int mx = (lx + rx) / 2;
    return get(l, r, x * 2 + 1, lx, mx) + get(l, r, x * 2 + 2, mx, rx);
}

void update1(int v, int i, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (i < lx or rx <= i) return;
    if (rx - lx == 1) {
        tree1[x] += v;
        return;
    }
    int mx = (lx + rx) / 2;
    update1(v, i, x * 2 + 1, lx, mx);
    update1(v, i, x * 2 + 2, mx, rx);
    tree1[x] = tree1[x * 2 + 1] + tree1[x * 2 + 2];
}

int get1(int l, int r, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (r <= lx or rx <= l) return 0;
    if (l <= lx and rx <= r) return tree1[x];
    int mx = (lx + rx) / 2;
    return get1(l, r, x * 2 + 1, lx, mx) + get1(l, r, x * 2 + 2, mx, rx);
}

// int check(vector<int> &a) {
//     for (int i = 0; i < rt * ct * 4 + 4; i++) tree[i] = 0;
//     int ans = 0;
//     for (int i = 0; i < a.size(); i++) {
//         ans += get(a[i] + 1, rt * ct + 1);
//         update(1, a[i]);
//     }
//     return ans;
// }


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> rt >> ct;
    vector<vector<int>>a(rt, vector<int> (ct));
    for (int i = 0; i < rt; i++) {
        for (int j = 0; j < ct; j++)
            cin >> a[i][j];
    }
    int dp[ct + 1] = {0};
    dp[ct] = 0;
    for (int i = ct - 1; i >= 0; i--) {
        dp[i] = (a[0][i] > a[1][i]) + dp[i + 1] + get(0, a[0][i]) + get(0, a[1][i]) + get1(0, a[0][i]) + get1(0, a[1][i]);
        dp[i] = min(dp[i], (a[0][i] > a[1][i]) + dp[i + 1] + get(0, a[0][i]) + get1(0, a[1][i]) + get1(0, a[0][i]));
        update(1, a[0][i]);
        update1(1, a[1][i]);
    }

    cout << dp[0];

    return 0;
}