#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <numeric>
#include <set>

using namespace std;
using ll = long long;

void solve5() {
	ll n, q;
	cin >> n >> q;
	vector<bool> a(n + 1);
	vector<ll> p(n + 1, 0);
	ll cnth = 0;
	ll id = 1;
	bool lst = 0;
	for (ll i = 1; i <= n; i++)
	{
		char c;
		cin >> c;
		a[i] = (c == '1');
		if (a[i])
			p[i] = p[i - 1] + 1;
		else
			p[i] = 0;
	}
	ll cnt0 = 0;
	ll mn = n + 1;
	vector<ll> c0;
	for (ll i = 1; i <= n; i++)
	{
		while (i + 1 <= n && p[i + 1] > 1) {
			i++;
		}
		if (p[i] > 1) {
			cnth += p[i];
		}
		else {
			if (!p[i])
				c0.push_back(id);
			a[id] = (p[i] > 0);
			id++;
		}
	}
	a.resize(id);
	vector<ll> ans(n + 1);
	ans[0] = cnth;
	ll m = c0.size();
	vector<vector<pair<ll, ll>>> dp(m + 1, vector<pair<ll, ll>>(2, { -1e9, -1e9 }));
	if (m) {
		dp[0][0].first = 0;
		if (c0[0] > 1) {
			dp[1][1].first = 2;
		}
		if (c0[0] + 1 < id && a[c0[0] + 1]) {
			dp[1][1].first = max(2ll, dp[1][1].first + 1);
		}
		if (dp[1][1].first < 2)
			dp[1][1].second = 1;
	}
	for (ll i = 1; i < m; i++)
	{
		for (ll j = m; j >= 0; j--)
		{
			dp[j][0].first = max(dp[j][0].first, dp[j][1].first);
			if (j == 0)
				continue;
			dp[j][1].first = dp[j - 1][0].first;
			ll pr = 0;
			if (c0[i - 1] + 1 != c0[i])
				pr = 2;
			if (c0[i] + 1 < id && a[c0[i] + 1])
				pr = max(2ll, pr + 1);
			if (pr)
				dp[j][1].first += pr;
			else
				dp[j][1].second = dp[j - 1][0].first + 1;

			if (c0[i] + 1 < id && a[c0[i] + 1]) {
				dp[j][1].first = max(dp[j][1].first, dp[j - 1][1].first + 2);
			}
			dp[j][1].first = max(dp[j][1].first, dp[j - 1][1].first + 1);
			dp[j][1].first = max(dp[j][1].first, dp[j - 1][1].second + 1);

		}
	}
	while (q--) {
		ll k; cin >> k;
		cout << cnth + max(dp[k][0].first, dp[k][1].first) << "\n";
	}
}

struct pt {
	ll x, y;
};

ll dist(pt& a, pt& b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
vector<vector<bool>> d;
vector<bool> used;
vector<ll> ord;
vector<vector<ll>>g;

void dfs(ll v) {
	used[v] = 1;
	ord.push_back(v);
	for (auto u : g[v])
	{
		if (d[v][1])
			d[u][0] = d[v][1];
		if (d[v][0])
			d[u][1] = d[v][0];
		if (!used[u]) {
			dfs(u);
		}
	}
}
void solve6() {
	ll n, r;
	cin >> n >> r;
	vector<pt> a(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> a[i].x >> a[i].y;
	}
	g.resize(n);
	for (ll i = 0; i < n; i++)
	{
		for (ll j = i + 1; j < n; j++)
		{
			if (dist(a[i], a[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	d.resize(n, vector<bool>(2, false));
	used.resize(n, 0);
	ll c = 0;
	vector<bool> ans(n, 0);
	for (ll i = 0; i < n; i++)
	{
		if (!used[i]) {
			d[i][0] = true;
			ord.clear();
			ord.resize(0);
			dfs(i);
			ll f = false;
			for (ll ii = 0; ii < ord.size(); ii++)
			{
				if (d[ord[ii]][0] && d[ord[ii]][1]) {
					f = true;
					break;
				}
			}
			if (f) {
				for (ll ii = 0; ii < ord.size(); ii++)
				{
					ans[ord[ii]] = 1;
				}
			}
		}
	}
	for (ll i = 0; i < n; i++)
	{
		if (ans[i]) {
			cout << 1;
		}
		else
			cout << 0;
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solve5();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
