#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()

using namespace std;

const int N = 1e5 + 5;

struct Point {
    ll x, y;
};

Point p[N];
int ans[N], col[N], used[N], ff;
vector <int> g[N];

void dfs_col(int i, int c) {
    used[i] = 1;
    col[i] = c;
    for (auto j:g[i]) {
        if (col[j] == c)
            ff = 1;
        if (!used[j])
            dfs_col(j, 3 - c);
    }
}

void dfs_ans(int i) {
    used[i] = 2;
    ans[i] = 1;
    for (auto j:g[i]) {
        if (used[j] != 2)
            dfs_ans(j);
    }
}

void solve() {
    int n, i, j, k, x, y;
    ll r;
    cin >> n >> r;
    map <int, vector<pair<ld, int>>> mp;
    set <int> xx;
    for (i = 0; i < n; i++) {
        cin >> x >> y;
        mp[x].pb({y, i});
        p[i] = {x, y};
        xx.insert(x);
    }
    for (auto x:xx) {
        sort(all(mp[x]));
    }
    for (i = 0; i < n; i++) {
        vector <int> v;
        for (x = p[i].x - r; x <= p[i].x + r; x++) {
            if (!mp[x].empty()) {
                ld y1 = p[i].y - sqrt(r * r - (p[i].x - x) * (p[i].x - x));
                ld y2 = p[i].y + sqrt(r * r - (p[i].x - x) * (p[i].x - x));
                j = lower_bound(all(mp[x]), make_pair(y1, -1)) - mp[x].begin();
                while (j < size(mp[x]) && mp[x][j].first <= y2) {
                    if (mp[x][j].second != i)
                        v.pb(mp[x][j].second);
                    j ++;
                }
            }
        }
        for (auto j:v) {
            g[i].pb(j);
        }
    }
    for (i = 0; i < n; i++) {
        if (!used[i]) {
            ff = 0;
            dfs_col(i, 1);
            if (ff)
                dfs_ans(i);
        }
    }
    for (i = 0; i < n; i++) {
        cout << ans[i];
    }
}

main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

