#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()

using namespace std;

const int N = 5e5 + 5;

vector <int> a[N];
vector <ll> dp[N];
int f[N], n;

int get(int r) {
    int ans = 0;
    for (int i = r; i >= 1; i -= (i & -i)) {
        ans += f[i];
    }
    return ans;
}

void update(int p, int x) {
    for (int i = p; i <= n; i += (i & -i)) {
        f[i] += x;
    }
}

void solve() {
    int r, c, i, j, k;
    cin >> r >> c;
    n = r * c;
    for (i = 0; i < r; i++) {
        a[i].resize(c + 1);
        dp[i].resize(c + 1, (ll)n * n);
        for (j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    dp[r].resize(c + 1, (ll)n * n);
    dp[0][0] = 0;
    for (i = 0; i < r; i++) {
        for (j = 0; j < c; j++) {
            int cur1 = 0, cur2 = 0;
            for (k = j; k < c; k++) {
                cur2 += get(n) - get(a[i][k]);
                update(a[i][k], 1);
            }
            for (k = j; k < c; k++) {
                update(a[i][k], -1);
            }
            for (k = i; k < r; k++) {
                cur1 += get(n) - get(a[k][j]);
                update(a[k][j], 1);
            }
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + cur2);
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + cur1);
        }
        for (j = 0; j < c; j++) {
            for (k = i + 1; k < r; k++) {
                update(a[k][j], -1);
            }
        }
    }
    ll ans = (ll)n * n;
    for (i = 0; i < r; i++) {
        ans = min(ans, dp[i][c]);
    }
    for (j = 0; j < c; j++) {
        ans = min(ans, dp[r][j]);
    }
    cout << ans;
}

main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

