#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        a[i] = (c - '0');
    }


    if (*max_element(a.begin(), a.end()) == 0) {
        for (int i = 0; i < q; i++) {
            int k;
            cin >> k;
            if (k == 1) {
                cout << 0 << "\n";
            } else {
                cout << k << "\n";
            }
        }
        exit(0);
    }


    vector<int> ans(n + 1, 0);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (cnt >= 2) {
                ans[0] += cnt;
            }
            cnt = 0;
        } else {
            cnt++;
        }
    }
    if (cnt >= 2) {
        ans[0] += cnt;
    }

    int k = 0;
    for (int i = 0; i + 2 < n; i++) {
        if (a[i] == 1 && a[i + 1] == 0 && a[i + 2] == 1) {
            bool ok = true;
            if (i != 0 && a[i - 1] != 0) ok = false;
            if (i + 2 != n - 1 && a[i + 3] != 0) ok = false;
            if (!ok) continue;
            a[i + 1] = 1;
            k++;
            ans[k] = ans[k - 1] + 3;
        }
    }

    for (int i = 0; i < n; i++) {
        if (a[i] == 1) {
            bool ok = true;
            if (i != 0 && a[i - 1] != 0) ok = false;
            if (i != n - 1 && a[i + 1] != 0) ok = false;
            if (!ok) continue;
            k++;
            ans[k] = ans[k - 1] + 2;
        }
    }

    for (int i = k + 1; i <= n; i++) {
        ans[i] = min(n, ans[i - 1] + 1);
    }


    for (int i = 0; i < q; i++) {
        cin >> k;
        cout << ans[k] << "\n";
    }
}
