#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pii = pair<int, int>;


struct point {
    int x, y;
};


int r;
vector<point> p;

bool check(int i, int j) {
    int x = p[i].x - p[j].x;
    int y = p[i].y - p[j].y;
    return (1ll * r * r >= 1ll * x * x + 1ll * y * y);
}

int n;
vector<int> col;
vector<int> tops;
map<pii, vector<int>> m;
bool have;

void dfs(int v, int c) {
    tops.push_back(v);
    col[v] = c;
    int bl_x = p[v].x / r, bl_y = p[v].y / r;
    for (int x = -1; x <= 1; x++) {
        for (int y = -1; y <= 1; y++) {
            for (auto u : m[{bl_x + x, bl_y + y}]) {
                if (u == v) continue;
                if (!check(v, u)) continue;
                if (col[u] == -1) dfs(u, c ^ 1);
                if (col[u] == col[v]) have = true;
            }
        }
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    cin >> n >> r;
    p.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        m[{p[i].x / r, p[i].y / r}].push_back(i);
    }


    for (auto [k, _] : m) {
        shuffle(m[k].begin(), m[k].end(), rnd);
        while (m[k].size() > 500) {
            m[k].pop_back();
        }
    }


    col.assign(n, -1);
    vector<bool> ans(n, false);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            have = false;
            tops.clear();
            dfs(i, 0);
            if (have) {
                for (auto &j : tops) ans[j] = true;
            }
        }
    }


    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}