#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;


struct point {
    int x, y;
};


int r;
vector<point> p;

bool check(int i, int j) {
    int x = p[i].x - p[j].x;
    int y = p[i].y - p[j].y;
    return (1ll * r * r >= 1ll * x * x + 1ll * y * y);
}

int n;
vector<int> col;
vector<int> tops;
bool have;

void dfs(int v, int c) {
    tops.push_back(v);
    col[v] = c;
    for (int u = 0; u < n; u++) {
        if (u == v) continue;
        if (!check(v, u)) continue;
        if (col[u] == -1) dfs(u, c ^ 1);
        if (col[u] == col[v]) have = true;
        if (have) break;
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    cin >> n >> r;
    p.resize(n);
    for (auto &i : p) {
        cin >> i.x >> i.y;
    }


    col.assign(n, -1);
    vector<bool> ans(n, false);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            have = false;
            tops.clear();
            dfs(i, 0);
            if (have) {
                for (auto &j : tops) ans[j] = true;
            }
        }
    }


    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
