#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;


ll solve(vector<int> &a) {
    ordered_set os;
    ll ans = 0;
    for (int i = 0; i < a.size(); i++) {
        int x = os.order_of_key(*os.upper_bound(a[i]));
        ans += (i - x);
        os.insert(a[i]);
    }
    return ans;
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (auto &i : a) {
        cin >> i;
    }


    cout << solve(a);
}
