#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using dd = double;

struct point {
    ll x, y;

    bool operator< (const point& other) const {
        return x < other.x;
    }
};

int n, r;
vector <vector <int>> g;
vector <int> dist, ans;
set <int> in_s;

dd get_dist(point a, point b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

int att = 0;

void bfs1(int s) {
    if (ans[s] != 1) {
        return;
    }
    queue <int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto u : g[v]) {
            q.push(u);
            ans[u] = 2;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> r;
    g.resize(n);
    dist.assign(n, 2e9);
    ans.resize(n);
    vector <point> a(n);
    vector <int> b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].x;
        a[i].y = i;

        b[i] = a[i].x;
    }

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());


    for (int i = 0; i < n; i++) {
        int to = upper_bound(b.begin(), b.end(), a[i].x + r) - b.begin() - 1;
        int from = lower_bound(b.begin(), b.end(), a[i].x - r) - b.begin();

        if (to - from >= 2) {
            ans[a[i].y] = 1;
        }
    }

    for (int v = 0; v < n; v++) {
        bfs1(v);
    }

    for (auto& i : ans) {
        if (i == 2) {
            i = 1;
        }
        cout << i;
    }

    cout << '\n';
}