#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, r;
struct e{
    int x;
    int y;
};

vector<e> lst;
vector<vector<bool>> can_reach;

int dist(e a, e b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

signed main(){
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        lst.push_back({a, b});
    }
    for (int i = 0; i < n; i++) {
        can_reach = vector<vector<bool>>(n, vector<bool>(2, false));
        vector<pair<int, int>> order;
        can_reach[i][0] = true;
        order.push_back({i, 0});
        int ind = 0;
        while (!can_reach[i][1] && ind < order.size()) {
            int a = order[ind].first;
            int b = order[ind].second;
            int c = (b + 1) % 2;
            for (int j = 0; j < n; j++) {
                if (j != a && !can_reach[j][c] && dist(lst[a], lst[j]) <= r * r) {
                    can_reach[j][c] = true;
                    order.push_back({j, c});
                }
            }
            ind++;
        }
        if (can_reach[i][1]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
