#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, r;
struct e{
    int x;
    int y;
    int ans;
};

const int maxn = 1e5 + 100;
const int inf = 1e9 + 7;

vector<e> lst;

bool comp1(e a, e b) {
    return a.x < b.x;
}

bool comp2(e a, e b) {
    return a.y < b.y;
}

signed main(){
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        lst.push_back({a, i});
        lst[i] = {a, b};
    }
    sort(lst.begin(), lst.end(), comp1);
    for (int i = 0; i + 2 < n; i++) {
        if (lst[i + 2].x - lst[i].x <= r) {
            lst[i].ans = true;
            lst[i + 1].ans = true;
            lst[i + 2].ans = true;
        }
    }
    vector<int> bfs;
    for (int i = 0; i < n; i++) {
        if (lst[i].ans) {
            bfs.push_back(i);
        }
    }
    int ind = 0;
    while (ind < bfs.size()) {
        int i = bfs[ind];
        ind++;
        if (i - 1 >= 0 && !lst[i - 1].ans && lst[i].x - lst[i - 1].x <= r) {
            lst[i - 1].ans = true;
            bfs.push_back(i - 1);
        }
        if (i + 1 < n && !lst[i + 1].ans && lst[i + 1].x - lst[i].x <= r) {
            lst[i + 1].ans = true;
            bfs.push_back(i + 1);
        }
    }
    sort(lst.begin(), lst.end(), comp2);
    for (int i = 0; i < n; i++) {
        cout << lst[i].ans;
    }
    cout << endl;
}
