#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;
using ordered_set = tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto el : a) out << el << " "; return out; }

struct fen_tree {
    int n;
    vector<int> t;
    fen_tree(int _n) {
        n = _n;
        t.resize(n + 1);
    }

    void insert(int x) {
        if (x < 0)
            x += n + 1;
        for (; x <= n; x += x & -x)
            t[x] += 1;
    }

    void erase(int x) {
        if (x < 0)
            x += n + 1;
        for (; x <= n; x += x & -x)
            t[x] -= 1;
    }

    int order_of_key(int x) {
        if (x < 0)
            x += n + 1;
        int res = 0;
        for (; x > 0; x -= x & -x)
            res += t[x];
        return res;
    }
};

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));

    for (auto &el : a) for (auto &x : el) cin >> x;

    cout << 0 << '\n';

    // if (n > m) {
    //     vector<vector<int>> b(m, vector<int>(n));
    //     for (int i = 0; i < n; ++i)
    //        for (int j = 0; j < m; ++j)
    //             b[j][i] = a[i][j];
    //     swap(a, b);
    //     swap(n, m);
    // }

    // vector<vector<int>> dp(n + 1, vector<int>(m + 1, (n * m + 1) * (n * m + 1) + 1));

    // fen_tree prec(n * m + 5);
    // vector<vector<int>> suf_col(n, vector<int>(m + 1));
    // for (int i = 0; i < n; ++i) {
    //     for (int j = m - 1; j >= 0; --j) {
    //         suf_col[i][j] = suf_col[i][j + 1] + prec.order_of_key(a[i][j]);
    //         prec.insert(a[i][j]);
    //     }
    //     for (int j = m - 1; j >= 0; --j) {
    //         prec.erase(a[i][j]);
    //     }
    // }
    // vector<vector<int>> suf_row(n + 1, vector<int>(m));
    // for (int j = 0; j < m; ++j) {
    //     for (int i = n - 1; i >= 0; --i) {
    //         suf_row[i][j] = suf_row[i + 1][j] + prec.order_of_key(a[i][j]);
    //         prec.insert(a[i][j]);
    //     }
    //     for (int i = n - 1; i >= 0; --i) {
    //         prec.erase(a[i][j]);
    //     }
    // }

    // dp[0][0] = 0;

    // fen_tree lol(n * m + 5), kek(n * m + 5);
    // vector<int> NUM(m + 1);
    // vector<int> NUM2(m + 1);
    // for (int i = 0; i < n; ++i) {
    //     for (int j = m - 1; j >= 0; --j) {
    //         NUM[j] = NUM[j + 1];
    //         NUM[j] += kek.order_of_key(a[i][j]);
    //         lol.insert(-a[i][j]);
    //         for (int k = i + 1; k < n; ++k) {
    //             NUM[j] += lol.order_of_key(-a[k][j]);
    //             kek.insert(a[k][j]);
    //         }
    //     }
    //     for (int j = m - 1; j >= 0; --j) {
    //         lol.erase(-a[i][j]);
    //         for (int k = i + 1; k < n; ++k)
    //             kek.erase(a[k][j]);
    //     }

    //     for (int j = m - 1; j >= 0; --j) {
    //         NUM2[j] = 0;
    //         for (int k = i; k < n; ++k)
    //             NUM2[j] += kek.order_of_key(a[k][j]);
    //         for (int k = i; k < n; ++k)
    //             kek.insert(a[k][j]);
    //     }
    //     for (int j = m - 1; j >= 0; --j)
    //         for (int k = i; k < n; ++k)
    //             kek.erase(a[k][j]);

    //     for (int j = 0; j < m; ++j) {
    //         int num = NUM[j];
    //         num += suf_col[i][j];

    //         dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + num);

    //         num = NUM2[j];
    //         num += suf_row[i][j];

    //         dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + num);
    //     }
    // }

    // cout << min(dp[n][m - 1], dp[n - 1][m]) << '\n';

    return 0;
}