#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;
using ordered_set = tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto el : a) out << el << " "; return out; }

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (auto &el : a) cin >> el;

    vector<int> right(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i])
            right[st.back()] = i;
        st.pb(i);
    }

    for (int _i = 0; _i < q; ++_i) {
        int k, i;
        cin >> k >> i;
        --i;
        cout << a[i] << '\n';
    }

    return 0;
}