#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
   
using namespace std;

vector<int> suf;
  
int solve(vector<int> &v, int k, int id) {
    if (id < k) {
        return v[id - 1];
    } else {
        if (k % 2 == 1 && k != 1) {
            return v[v.size() - 1];
        }
        return suf[k - 1];
    }
}
   
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];                                                                                    
    }
    suf.resize(n);
    suf[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0;i--) {
        suf[i] = max(suf[i + 1], v[i]);
    }
    for (int i = 0; i < q; i++) {
        int k, id;
        cin >> k >> id;
        cout << solve(v, k, id) << '\n';
    }
    return 0;
}