#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

vector<int> t;

int get(int u)
{
    if (t[u] == u)
        return u;
    return t[u] = get(t[u]);
}

void unite(int u, int v)
{
    int pu = t[u];
    int pv = t[v];
    t[pu] = pv;
}

void solve()
{
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto& i : a) {
        char x;
        cin >> x;
        i = x - '0';
    }
    vector<pair<int, int>> qs(q);
    for (int i = 0; i < q; i++) {
        cin >> qs[i].X;
        qs[i].Y = i;
    }
    sort(qs.begin(), qs.end());
    vector<int> ans(q, 0);
    t.resize(n);
    iota(t.begin(), t.end(), 0);
    for (int i = 0; i < n - 1; i++)
        if (a[i] == a[i + 1] && a[i] == 1)
            unite(a[i + 1], a[i]);
    set<pair<int, int>, greater<>> st;
    vector<int> val(n, 0);
    if (n >= 4) {
        if (a[0] == 1 && a[1] == 0 && a[2] == 1 && a[3] == 0) {
            val[1] = 3;
        }
        if (a[n - 1] == 1 && a[n - 2] == 0 && a[n - 3] == 1 && a[n - 4] == 0) {
            val[n - 2] = 3;
        }
    }
    for (int i = 1; i + 3 < n; i++) {
        if (a[i - 1] == 0 && a[i] == 1 && a[i + 1] == 0 && a[i + 2] == 1 && a[i + 3] == 0)
            val[i + 1] = 3;
    }
    for (int i = 0; i + 2 < n; i++)
        if (a[i] == 0 && a[i + 1] == 1 && a[i + 2] == 0) {
            val[i] = max(val[i], 2);
            val[i + 2] = max(val[i + 2], 2);
        }
    if (a[0] == 1 && a[1] == 0)
        val[1] = max(val[1], 2);
    if (a[n - 1] == 1 && a[n - 2] == 0)
        val[n - 2] = max(val[n - 2], 2);
    for (int i = 0; i < n; i++)
        if (a[i] == 0 && val[i])
            st.insert({ val[i], i });
    if (st.size() == 0) {
        int nx = 0;
        int cur = 0;
        for (int i = 0; i <= qs.back().X; i++) {
            if (i >= qs[nx].X) {
                ans[qs[nx].Y] = cur;
                nx++;
                if (nx == q)
                    break;
            }
            if (i == 1)
                cur = 2;
            else
                cur += (cur > 0);
        }
        for (int i : ans)
            cout << i << '\n';
        return;
    }
    int nx = 0;
    int cur = 0;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] == 1 && a[i + 1] == 1) {
            cur += 1;
            if (i == 0 || a[i - 1] == 0)
                cur += 1;
        }
    }
    int i = 0;
    for (; i <= n; i++) {
        if (i >= qs[nx].X) {
            ans[qs[nx].Y] = cur;
            nx++;
            if (nx == q)
                break;
        }
        if (st.size() == 0)
            break;
        auto [vl, j] = *st.begin();
        st.erase(st.begin());
        cur += vl;
        if (j > 0 && a[j - 1] == 1)
            unite(j - 1, j);
        if (j < n - 1 && a[j + 1] == 1)
            unite(j + 1, j);
        val[j] = 0;
        if (vl == 3) {
            if (j > 1 && a[j - 2] == 0) {
                st.erase({ val[j - 2], j - 2 });
                val[j - 2] = max(0, val[j - 2] - 1);
                if (val[j - 2] > 1)
                    st.insert({ val[j - 2], j - 2 });
            }
            if (j < n - 2 && a[j + 2] == 0) {
                st.erase({ val[j + 2], j + 2 });
                val[j + 2] = max(0, val[j + 2] - 1);
                if (val[j + 2] > 1)
                    st.insert({ val[j + 2], j + 2 });
            }
        } else {
            if (j > 1 && a[j - 2] == 0) {
                st.erase({ val[j - 2], j - 2 });
                val[j - 2] = max(0, val[j - 2] - 1);
                if (val[j - 2] > 1)
                    st.insert({ val[j - 2], j - 2 });
            }
            if (j < n - 2 && a[j + 2] == 0) {
                st.erase({ val[j + 2], j + 2 });
                val[j + 2] = max(0, val[j + 2] - 1);
                if (val[j - 2] > 1)
                    st.insert({ val[j - 2], j - 2 });
            }
        }
    }
    if (nx != q)
        for (; i <= qs.back().X; i++) {
            if (i >= qs[nx].X) {
                ans[qs[nx].Y] = cur;
                nx++;
                if (nx == q)
                    break;
            }
            cur += 1;
        }
    for (int i : ans)
        cout << i << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
