#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;
namespace rng = ranges;
#define int int64_t

int Sq(int x) {
    return x * x;
}

int DistSq(pair<int, int> a, pair<int, int> b) {
    return Sq(a.first - b.first) + Sq(a.second - b.second);
}

signed main() {
    int n, r;
    cin >> n >> r;
    int maxsh = r;
    r *= r;
    vector<pair<int, int>> xy(n);
    for (auto &[x, y] : xy) {
        cin >> x >> y;
    }
    map<pair<int, int>, int> indof;
    for (int i = 0; i < n; ++i) {
        indof[xy[i]] = i;
    }
    vector<bool> used(n, false);
    vector<bool> ev_st(n);
    vector<bool> can(n, false);
    auto dfs = [&] (auto &&self, int fr, bool ev = true) -> void {
        if (used[fr]) {
            if (ev_st[fr] != ev) {
                can[fr] = true;
            }
            return;
        }
        used[fr] = true;
        ev_st[fr] = ev;
        for (int xj = xy[fr].first - maxsh; xj <= xy[fr].first + maxsh; ++xj) {
            for (int yj = xy[fr].second; yj <= xy[fr].second + maxsh; ++yj) {
                if (DistSq(xy[fr], { xj, yj }) > r) break;
                if (indof.contains({ xj, yj }) && pair{ xj, yj } != xy[fr]) {
                    int j = indof[{ xj, yj }];
                    self(self, j, !ev);
                }
            }
            for (int yj = xy[fr].second - 1; yj >= xy[fr].second - maxsh; --yj) {
                if (DistSq(xy[fr], { xj, yj }) > r) break;
                if (indof.contains({ xj, yj }) && pair{ xj, yj } != xy[fr]) {
                    int j = indof[{ xj, yj }];
                    self(self, j, !ev);
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(dfs, i);
        }
    }
    used.assign(n, false);
    auto dfs1 = [&] (auto &&self, int fr) -> void {
        if (used[fr]) {
            return;
        }
        used[fr] = true;
        can[fr] = true;
        for (int xj = xy[fr].first - maxsh; xj <= xy[fr].first + maxsh; ++xj) {
            for (int yj = xy[fr].second; yj <= xy[fr].second + maxsh; ++yj) {
                if (DistSq(xy[fr], { xj, yj }) > r) break;
                if (indof.contains({ xj, yj }) && pair{ xj, yj } != xy[fr]) {
                    int j = indof[{ xj, yj }];
                    self(self, j);
                }
            }
            for (int yj = xy[fr].second - 1; yj >= xy[fr].second - maxsh; --yj) {
                if (DistSq(xy[fr], { xj, yj }) > r) break;
                if (indof.contains({ xj, yj }) && pair{ xj, yj } != xy[fr]) {
                    int j = indof[{ xj, yj }];
                    self(self, j);
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (can[i]) {
            dfs1(dfs1, i);
        }
    }
    for (bool i : can) {
        cout << (i ? '1' : '0');
    }
    cout << endl;

    return 0;
}