#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
using namespace std;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, r, x, y;
	cin >> n >> r;
	vector<pair<int, int>> dots(n);
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		dots[i] = { x, i };
	}
	vector<int> ans(n, 0);
	sort(dots.begin(), dots.end());
	for (int i = 0; i < n - 2; i++) {
		if (dots[i + 2].first - dots[i].first <= r) {
			ans[dots[i].second] = 1;
			ans[dots[i + 1].second] = 1;
			ans[dots[i + 2].second] = 1;
		}
	}
	for (int i = 1; i < n; i++) {
		if (ans[dots[i - 1].second] == 1 && dots[i].first - dots[i - 1].first <= r)
			ans[dots[i].second] = 1;
	}
	for (int i = n - 2; i >= 0; i--) {
		if (ans[dots[i + 1].second] == 1 && dots[i + 1].first - dots[i].first <= r)
			ans[dots[i].second] = 1;
	}
	for (int i = 0; i < n; i++)
		cout << ans[i];
	cout << '\n';
}

