#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
// #define int ll
#define all(x) x.begin(), x.end()

const int INF = 1e9;

int n, m;
vector<vector<int>> a;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >> n >> m;
    a = vector<vector<int>>(n, vector<int>(m));
    for (auto& i : a)
        for (auto& j : i)
            cin >> j;

    vector<vector<int>> h_price(n, vector<int>(m)), v_price(n, vector<int>(m));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            if (i + 1 < n)
                v_price[i][j] = v_price[i + 1][j];
            for (int i2 = i; i2 < n; i2++) {
                for (int j2 = j; j2 < m; j2++) {
                    if (a[i2][j2] < a[i][j])
                        v_price[i][j]++;
                }
            }
            for (int i2 = i + 1; i2 < n; i2++) {
                for (int j2 = j + 1; j2 < m; j2++) {
                    if (a[i][j2] < a[j][i2])
                        v_price[i][j]++;
                }
            }
        }
    }
    for (int j = m - 1; j >= 0; j--) {
        for (int i = 0; i < n; i++) {
            if (j + 1 < m)
                h_price[i][j] = h_price[i][j + 1];
            for (int i2 = i; i2 < n; i2++) {
                for (int j2 = j; j2 < m; j2++) {
                    if (a[i2][j2] < a[i][j])
                        h_price[i][j]++;
                }
            }
            for (int j2 = j + 1; j2 < m; j2++) {
                for (int i2 = i + 1; i2 < n; i2++) {
                    if (a[i][j2] > a[j][i2])
                        h_price[i][j]++;
                }
            }
        }
    }

    vector<vector<int>> dp(n, vector<int>(m, INF));
    dp.back().back() = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i + 1 < n)
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + h_price[i][j]);
            if (j + 1 < m)
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + v_price[i][j]);
        }
    }

    cout << dp[0][0];
}