#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

vector<array<ll, 3> > v;
ll r;

void dfs(int s, vector<vector<int> > &g, vector<int> &u, vector<int> &is) {
    u[s] = 1;
    for (int i = 0; i < g.size(); i++) {
        if ((v[i][0] - v[s][0]) * (v[i][0] - v[s][0])
            + ((v[i][1] - v[s][1])) * ((v[i][1] - v[s][1])) <= r * r && i != s) {
            if (!u[i]) {
                is[i] = 1;
                dfs(i, g, u, is);
            }
        }
    }
}

void dfs1(int s, vector<vector<int> > &g, vector<int> &u, vector<int> &is) {
    for (int i = 0; i < g.size(); i++) {
        if ((v[i][0] - v[s][0]) * (v[i][0] - v[s][0])
            + ((v[i][1] - v[s][1])) * ((v[i][1] - v[s][1])) <= r * r && i != s) {
            if (u[i] == 0) {
                u[i] = 3 - u[s];
                dfs1(i, g, u, is);
            } else if (u[i] == u[s]) {
                is[s] = 1;
            }
        }
    }
}

void solve() {
    ll n;
    cin >> n >> r;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i][0] >> v[i][1];
        v[i][2] = i;
    }
    auto v1 = v;
    sort(all(v));
    vector<vector<int> > g(n);
    vector<int> is(n);
    v = v1;
    vector<int> u(n);
    for (int i = 0; i < n; i++) {
        if (u[i] == 0) {
            u[i] = 1;
            dfs1(i, g, u, is);
        }
    }
    u.clear();
    u.resize(n);
    for (int i = 0; i < n; i++) {
        if (!u[i] && is[i]) {
            dfs(i, g, u, is);
        }
    }
    for (int i: is)
        cout << i;
    cout << '\n';
}
