#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int MAXN = 3e5;
pair<int, int> dp[20][MAXN];
int l2[MAXN + 1];

pair<int, int> get(int l, int r) {
    int len = l2[r - l + 1];
    return min(dp[len][l], dp[len][r - (1 << len) + 1]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), a1(n);
    for (int &i: a)
        cin >> i;
    a1 = a;
    for (int i = n - 2; i >= 0; i--)
        a1[i] = max(a1[i + 1], a[i]);
    for (int i = 0; i < n; i++)
        dp[0][i] = {a[i], i};
    for (int i = 1; i < 20; i++) {
        for (int j = 0; j + (1 << i) <= n; j++) {
            dp[i][j] = min(dp[i - 1][j], dp[i - 1][j + (1 << (i - 1))]);
        }
    }
    for (int i = 2; i <= n; i++)
        l2[i] = l2[i / 2] + 1;
    vector<int> nxt(n, n);
    deque<int> d;
    for (int i = 0; i < n; i++) {
        while (d.size() && a[d.back()] < a[i]) {
            nxt[d.back()] = i;
            d.pop_back();
        }
        d.push_back(i);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        int p = 0;
        int ans = 0;
        for (int j = 0; j < i; j++) {
            if (k > 2) {
                int r = min(n - k + 1, nxt[p]);
                auto x = get(p + 1, r);
                ans = a[p];
                p = x.second;
            } else if (k == 1) {
                ans = a1[p];
            } else {
                ans = a[p];
                p = min(nxt[p], n - 1);
            }
            k--;
        }
        cout << ans << '\n';
    }
}
