#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int MAXN = 800 * 800 + 1;
int F[MAXN];

int get(int x) {
    int s = 0;
    while (x) {
        s += F[x];
        x -= x & (-x);
    }
    return s;
}

void add(int x) {
    while (x < MAXN) {
        F[x]++;
        x += x & (-x);
    }
}

const int D = 800 + 1;
int sum[D], sum1[MAXN], sum2[D], sum3[MAXN];

int gets1(int x) {
    return sum[x / D] + sum1[x];
}

void adds1(int x) {
    for (int i = x / D + 1; i < D; i++)
        sum[i]++;
    for (int i = x; i != ((x / D) + 1) * D; i++)
        sum1[i]++;
}

int get1(int x) {
    int s = 0;
    for (int i = 0; i < x / D; i++)
        s += sum2[i];
    for (int i = x / D * D; i <= x; i++)
        s += sum3[i];
    return s;
}

void add1(int x) {
    sum2[x / D]++;
    sum3[x]++;
}

int getx(int x) {
    return sum[x / D] + sum1[x];
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll> > a(r, vector<ll>(c));
    for (auto &i: a) {
        for (auto &j: i)
            cin >> j;
    }
    vector<vector<ll> > go(r, vector<ll>(c)), go1(r, vector<ll>(c));
    for (ll i = 0; i < r; i++) {
        ll s = 0;
        fill(sum, sum + D, 0);
        fill(sum1, sum1 + MAXN, 0);
        fill(sum2, sum2 + D, 0);
        fill(sum3, sum3 + MAXN, 0);
        for (ll j = c - 1; j >= 0; j--) {
            s += get1(a[i][j]);
            add1(a[i][j]);
            adds1(a[i][j]);
            for (ll k = i + 1; k < r; k++) {
                s += (c - j) - gets1(a[k][j]);
                add1(a[k][j]);
            }
            go[i][j] = s;
        }
    }
    vector<vector<ll> > pr(r + 1, vector<ll>(c));
    for (int j = 0; j < c; j++) {
        fill(F, F + MAXN, 0);
        for (int i = r - 1; i >= 0; i--) {
            pr[i][j] = pr[i + 1][j] + get(a[i][j]);
            add(a[i][j]);
        }
    }
    vector<vector<ll> > a1(c, vector<ll>(r));
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++)
            a1[j][i] = a[i][j];
    }
    swap(a, a1);
    swap(r, c);
    for (ll i = 0; i < r; i++) {
        ll s = 0;
        fill(sum, sum + D, 0);
        fill(sum1, sum1 + MAXN, 0);
        fill(sum2, sum2 + D, 0);
        fill(sum3, sum3 + MAXN, 0);
        for (ll j = c - 1; j >= 0; j--) {
            s += get1(a[i][j]);
            add1(a[i][j]);
            adds1(a[i][j]);
            for (ll k = i + 1; k < r; k++) {
                s += (c - j) - gets1(a[k][j]);
                add1(a[k][j]);
            }
            go1[j][i] = s;
        }
    }
    swap(r, c);
    vector<vector<ll> > dp(r + 1, vector<ll>(c + 1, 1e18));
    dp[0][0] = 0;
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            dp[i][j + 1] = min(dp[i][j + 1], go1[i][j] + dp[i][j]);
            dp[i + 1][j] = min(dp[i + 1][j], go[i][j] + dp[i][j]);
        }
    }
    ll ans = 1e18;
    for (ll i = 0; i < r; i++)
        ans = min(ans, dp[i][c]);
    for (ll j = 0; j < c; j++)
        ans = min(ans, dp[r][j]);
    cout << ans << '\n';
}
