#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll> > a;
    for (ll i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        a.emplace_back(x, i);
    }
    ranges::sort(a);
    ll last = -INF;
    ll prelast = -INF;
    vector<ll> ans(n, false);
    for (ll i = 0; i < n; ++i) {
        if (prelast >= a[i].first - r) {
            ans[a[i].second] = true;
        }
        prelast = last;
        last = a[i].first;
    }

    for (ll i = 1; i < n; ++i) {
        if (a[i].first - a[i - 1].first <= r && ans[a[i - 1].second]) {
            ans[a[i].second] = true;
        }
    }
    for (ll i = n - 2; i >= 0; --i) {
        if (a[i + 1].first - a[i].first <= r && ans[a[i + 1].second]) {
            ans[a[i].second] = true;
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << (ans[i] ? 1 : 0);
    }


    return 0;
}
