#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<vector<int>>graph;
vector<int>used; int n; int inf = 1e9;
vector<int>dist; vector<int>color;
vector<int>cmp; vector<bool>good; int c = 0; unordered_map<ll, int>ind;
vector<ll>x, y; ll r;
void bfs(int start) {
    deque<int>d;
    d.push_back(start); dist[start] = 0;
    while (!d.empty()) {
        auto q = d.front(); cmp[q] = c; d.pop_front();
        for (ll xs = x[q] - 10; xs <= x[q] + 10; xs++) {
            for (ll ys = y[q] - 10; ys <= y[q] + 10; ys++) {
                if (xs == x[q] && ys == y[q] || (xs - x[q]) * (xs - x[q]) + (ys - y[q]) * (ys - y[q]) > r * r) continue;
                if (ind.find(xs * 1e9 + ys) != ind.end()) {
                    auto val = ind[xs * 1e9 + ys];
                    if (dist[val] == inf) {
                        dist[val] = dist[q] + 1; color[val] = 1 - color[q];
                        d.push_back(val);
                    }else {
                        if (color[val] == color[q]) {
                            good[c] = true;
                        }
                    }
                }
            }
        }
    }
}
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> r;
    x.resize(n); y.resize(n); graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i]; ind[x[i] * 1e9 + y[i]] = i;
    }
    dist.resize(n, inf); color.resize(n); cmp.resize(n, -1); good.resize(n);
    for (int i = 0; i < n; i++) {
        if (cmp[i] == -1) {
            bfs(i); c++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (good[cmp[i]]) {
            cout << 1;
        }else cout << 0;
    }
}