#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<int>tree;
void update(int i, int l, int r, int ind, int add) {
    if (ind < l || ind >= r) return;
    if (l + 1 == r) {
        tree[i] += add; return;
    }
    update(2 * i + 1, l, (l + r) / 2, ind, add);
    update(2 * i + 2, (l + r) / 2, r, ind, add);
    tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}
int get(int i, int l, int r, int tl, int tr) {
    if (l >= tl && r <= tr) return tree[i];
    if (l >= tr || r <= tl) return 0;
    return get(2 * i + 1, l, (l + r) / 2, tl, tr) + get(2 * i + 2, (l + r) / 2, r, tl, tr);
}
int inf = 1e9;
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int r, c; cin >> r >> c;
    vector<vector<int>>a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j]; a[i][j]--;
        }
    }
    int n = r * c ;
    vector<vector<int>>dp(r + 1, vector<int>(c + 1, inf)); dp[0][0] = 0;
    for (int sum = 1; sum < r + c; sum++) {
        for (int x = 0; x <= min(sum, r); x++) {
            int y = sum - x; if (y > c) continue;
            tree.assign(4 * n, 0);
            if (x == 0) {
                for (int k = 0; k < y - 1; k++) {
                    for (int j = 0; j < r; j++) {
                        update(0, 0, n, a[j][k], 1);
                    }
                }
                int ans = 0;
                for (int j = 0; j < r; j++) {
                    ans += get(0, 0, n, a[j][y - 1], n);
                    update(0, 0, n, a[j][y - 1], 1);
                }
                dp[x][y] = min(dp[x][y], dp[x][y - 1] + ans);
            }else if (y == 0){
                for (int k = 0; k < x - 1; k++) {
                    for (int j = 0; j < c; j++) {
                        update(0, 0, n, a[k][j], 1);
                    }
                }
                int ans = 0;
                for (int j = 0; j < c; j++) {
                    ans += get(0, 0, n, a[x - 1][j], n);
                    update(0, 0, n, a[x - 1][j], 1);
                }
                dp[x][y] = min(dp[x][y], dp[x - 1][y] + ans);
            }else {
                if (x != r) {
                    for (int i = 0; i < x; i++) {
                        for (int j = 0; j < c; j++) {
                            update(0, 0, n, a[i][j], 1);
                        }
                    }
                    for (int i = x; i < r; i++) {
                        for (int j = 0; j < y - 1; j++) {
                            update(0, 0, n, a[i][j], 1);
                        }
                    }
                    int ans = 0;
                    for (int j = x; j < r; j++) {
                        ans += get(0, 0, n, a[j][y - 1], n);
                        update(0, 0, n, a[j][y - 1], 1);
                    }
                    dp[x][y] = min(dp[x][y], dp[x][y - 1] + ans);
                }
                if (y != c) {
                    tree.assign(4 * n, 0);
                    for (int i = 0; i < r; i++) {
                        for (int j = 0; j < y; j++) {
                            update(0, 0, n, a[i][j], 1);
                        }
                    }
                    for (int i = 0; i < x - 1; i++) {
                        for (int j = y; j < c; j++) {
                            update(0, 0, n, a[i][j], 1);
                        }
                    }
                    int ans = 0;
                    for (int j = y; j < c; j++) {
                        ans += get(0, 0, n, a[x - 1][j], n);
                        update(0, 0, n, a[x - 1][j], 1);
                    }
                    dp[x][y] = min(dp[x][y], dp[x - 1][y] + ans);
                }
            }
        }
    }
    int ans = 1e9;
    for (int i = 0; i <= r; i++) {
        ans = min(ans, dp[i][c]);
    }
    for (int i = 0; i <= c; i++) {
        ans = min(ans, dp[r][i]);
    }
    cout << ans;
}