#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
// struct Node {
//     int l, r; int val;
//     Node() : l(-1), r(-1), val(0) {};
// };
// vector<Node>tree{Node()}; vector<int>root; int sz;
// int update(int i, int l, int r, int ind, int add) {
//     if (ind < l || ind >= r) return i;
//     if (l + 1 == r) {
//         auto val = tree[i];
//         val.val += add; tree.push_back(val);
//         return sz++;
//     }
//     update(tree[i].l, l, (l + r) / 2, ind, add);
//     update(tree[i].r, (l + r) / 2, r, ind, add);
//     tree.push_back(tree[i]); tree[sz++].val = tree[tree[i].l].val + tree[tree[i].r].val;
// }
// int get(int i, int l, int r, int tl, int tr) {
//     if (l >= tl && r <= tr) return tree[i].val;
//     if (l >= tr || r <= tl) return 0;
//     return get(tree[i].l, l, (l + r) / 2, tl, tr) + get(tree[i].r, (l + r) / 2, r, tl, tr);
// }
// int inf = 1e9;
struct SegTree {
    vector<int>tree;
    void update(int i, int l, int r, int ind, int add) {
        if (ind < l || ind >= r) return;
        if (l + 1 == r) {
            tree[i] += add; return;
        }
        update(2 * i + 1, l, (l + r) / 2, ind, add);
        update(2 * i + 2, (l + r) / 2, r, ind, add);
        tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
    }
    int get(int i, int l, int r, int tl, int tr) {
        if (tl >= tr) return 0;
        if (l >= tl && r <= tr) return tree[i];
        if (l >= tr || r <= tl) return 0;
        return get(2 * i + 1, l, (l + r) / 2, tl, tr) + get(2 * i + 2, (l + r) / 2, r, tl, tr);
    }
};
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int r, c; cin >> r >> c;
    vector<vector<int>>a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j]; a[i][j]--;
        }
    }
    if (r == 1) {
        ll ans = 0; SegTree t; t.tree.resize(4 * r * c, 0);
        for (int i = 0; i < c; i++) {
            ans += t.get(0, 0, r * c, a[0][i], r * c);
            t.update(0, 0, r * c, a[0][i], 1);
        }
        cout << ans; return 0;
    }
    int n = r * c; SegTree t1, t2; t1.tree.resize(4 * n); t2.tree.resize(4 * n);
    vector<ll>ans(c); ll cur = 0;
    SegTree t3; t3.tree.resize(4 * n);
    vector<ll>pref(c); ll num = 0;
    for (int i = 0; i < c; i++) {
        num += t3.get(0, 0, n, a[0][i], n); t3.update(0, 0, n, a[0][i], 1);
        num += t3.get(0, 0, n, a[1][i], n); t3.update(0, 0, n, a[1][i], 1);
        pref[i] = num;
    }
    for (int i = 0; i < c; i++) {
        cur += t1.get(0, 0, n, a[0][i], n);
        t1.update(0, 0, n, a[0][i], 1);
    }
    for (int i = 0; i < c; i++) {
        cur += t2.get(0, 0, n, a[1][i], n) + t1.get(0, 0, n, a[1][i], n);
        t2.update(0, 0, n, a[1][i], 1);
    }
    ll best = cur;
    for (int i = 0; i < c; i++) {
        ans[i] = cur;
        cur = cur - t1.get(0, 0, n, 0, a[0][i]) - t2.get(0, 0, n, 0, a[0][i]);
        t1.update(0, 0, n, a[0][i], -1);
        cur = cur - t1.get(0, 0, n, a[1][i], n) - t2.get(0, 0, n, 0, a[1][i]);
        t2.update(0, 0, n, a[1][i], -1);
        cur += t1.get(0, 0, n, 0, a[0][i]) + t1.get(0, 0, n, 0, a[1][i])
            + t2.get(0, 0, n, 0, a[0][i]) + t2.get(0, 0, n, 0, a[1][i]);
        best = min(best, cur + pref[i]);
    }
    cout << best;
}