#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
//#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll,ll>>

struct DSU {
    vi p, s;

    DSU(ll n) {
        p.resize(n);
        s.resize(n);
        iota(all(p), 0);
    }

    ll leader(ll v) {
        if (p[v] == v) return v;
        p[v] = leader(p[v]);
        return p[v];
    }

    void unite(ll a, ll b) {
        a = leader(a);
        b = leader(b);
        if (a == b)
            return;
        if (s[a] > s[b])
            swap(a, b);
        s[b] += s[a];
        p[a] = b;
    }
};

void upd(ll pos, set<pair<ll,ll> > &s, DSU &DSU) {
    if (pos < 0 || pos >= DSU.s.size()) return;
    ll szl = 0, szr = 0;
    if (pos > 0) {
        szl = DSU.s[DSU.leader(pos - 1)];
    }
    if (pos + 1 < DSU.s.size()) {
        szr = DSU.s[DSU.leader(pos + 1)];
    }
    s.erase({0, pos});
    s.erase({1, pos});
    s.erase({2, pos});
    s.erase({3, pos});
    if (szl == 1 && szr == 1) {
        s.insert({0, pos});
    } else if (szl == 1) {
        s.insert({1, pos});
    } else if (szr == 1) {
        s.insert({1, pos});
    } else if (szl > 0 || szr > 0) {
        s.insert({2, pos});
    } else {
        s.insert({3, pos});
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    set<pair<ll,ll> > st;
    vip a;
    DSU DSU(n);
    for (ll i = 0; i < n; i++) {
        if (i == 0 || (s[i] != s[i - 1]) || s[i] == '0') {
            a.pb({s[i] - '0', 1});
            if (s[i] == '1') {
                DSU.s[i] = 1;
            }
        } else {
            DSU.s[i] = 1;
            DSU.unite(i, i - 1);
            a.back().second++;
        }
    }
    ll cn = 0;
    ll sz = a.size();
    vi ans(n + 1);
    for (ll i = 0; i < sz; i++) {
        if (a[i].first == 0) {
            if (i > 0 && i < sz - 1 && a[i - 1].first == 1 && a[i + 1].first == 1 && a[i - 1].second == 1 && a[i + 1].
                second == 1) {
                st.insert({0, cn});
            } else if ((i > 0 && a[i - 1].second == 1 && a[i - 1].first == 1) || (
                           i < sz - 1 && a[i + 1].second == 1 && a[i + 1].first == 1)) {
                st.insert({1, cn});
            } else if ((i > 0 && a[i - 1].second >= 1 && a[i - 1].first == 1) || (
                           i < sz - 1 && a[i + 1].second >= 1 && a[i + 1].first == 1)) {
                st.insert({2, cn});
            } else {
                st.insert({3, cn});
            }
        } else if (a[i].second > 1) {
            ans[0] += a[i].second;
        }
        cn += a[i].second;
    }
    ll c = 1;
    while (st.size()) {
        auto [tp, pos] = *st.begin();
        st.erase(st.begin());
        DSU.s[pos] = 1;
        ans[c] = ans[c - 1];
        //cout << tp << " " << pos << endl;
        if (tp == 0) {
            DSU.unite(pos, pos - 1);
            DSU.unite(pos, pos + 1);
            if (pos + 2 < n) {
                upd(pos + 2, st, DSU);
            }
            if (pos - 2 >= 0) {
                upd(pos - 2, st, DSU);
            }
            ans[c] += 3;
        } else if (tp == 1) {
            ll szl = 0, szr = 0;
            if (pos > 0) {
                szl = DSU.s[DSU.leader(pos - 1)];
                DSU.unite(pos, pos - 1);
            }
            if (pos < n - 1) {
                szr = DSU.s[DSU.leader(pos + 1)];
                DSU.unite(pos, pos + 1);
            }
            if (pos - szl - 1 >= 0) {
                upd(pos - szl - 1, st, DSU);
            }
            if (pos + 1 + szr < n) {
                upd(pos + szr + 1, st, DSU);
            }
            ans[c] += 2;
        } else if (tp == 2) {
            if (pos > 0) {
                DSU.unite(pos, pos - 1);
            }
            if (pos < n - 1) {
                DSU.unite(pos, pos + 1);
            }
            ans[c]++;
        } else if (tp == 3) {
            if (pos > 0) {
                upd(pos - 1, st, DSU);
            }
            if (pos < n - 1) {
                upd(pos + 1, st, DSU);
            }
        }
        c++;
    }
    while (c < n) {
        c++;
        ans[c] = ans[c - 1];
    }
    while (q--) {
        ll f;
        cin >> f;
        cout << ans[f] << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
