#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll,ll>>

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

vi color;
vi is;
vi cmp;
ll n, r;
vi x, y;
vip id;

void dfs(ll v, ll last, ll comp) {
    color[v] = 3 - last;
    cmp[v] = comp;
    ll i = v;
    for (ll xj = x[i] - r; xj <= x[i] + r; xj++) {
        ll mx = sqrt(r * r - (xj - x[i]) * (xj - x[i]));
        for (ll yj = y[i] - mx; yj <= y[i] + mx; yj++) {
            auto jk = lower_bound(all(id), make_pair(xj * (ll) 1e9 + yj, 0ll)) - id.begin();
            if (jk == id.size()) continue;
            ll j = id[jk].second;
            if (i != j) {
                ll to = j;
                if ((x[v] - x[to]) * (x[v] - x[to]) + (y[v] - y[to]) * (y[v] - y[to]) <= r * r) {
                    if (color[to] == 0) {
                        dfs(to, color[v], comp);
                    } else if (color[v] == color[to]) {
                        is[comp] = 1;
                    }
                }
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    color.assign(n, 0);
    cmp.assign(n, 0);
    is.assign(n, 0);
    x.assign(n, 0);
    y.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        id.pb({x[i] * (ll) 1e9 + y[i], i});
    }
    sort(all(id));
    ll c = 0;
    for (ll i = 0; i < n; i++) {
        if (color[i] == 0) {
            dfs(i, 1, c);
            c++;
        }
    }
    for (ll i = 0; i < n; i++) {
        cout << is[cmp[i]];
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}