#pragma GCC optimize("O3, unroll-loops)
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e9;

struct node {
    ll x, y;
};
ll n, r, rr;

vector<ll> ans;
bool ok = 0;
vector<ll> ts;
void dfs(ll v, ll col, vector<ll> &used, vector<node> &p, vector<vector<int>> &g) {
    used[v] = col;
    //cout << v << ' ' << used[v] << ":";
    ts.push_back(v);
    for (auto u : g[v]) {
        if (u == v) continue;
        if (used[u] == col) {
            ok = 1;
        } else if (!used[u]) {
            dfs(u, 3 - col, used, p, g);
        }
    }
}
unordered_map<ll, int> mp;
void solve() {
    cin >> n >> r;
    rr = r * r;
    vector<node> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
        ll gg = p[i].x * inf + p[i].y;
        mp[gg] = i + 1;
    }
    vector<vector<int>> g(n);
    vector<pair<int, int>> dx;

    for (int i = 0; i < n; ++i) {
        for (int ax = -r; ax <= r; ++ax) {
            for (int ay = -r; ay <= r; ++ay) {
                if ((ax * ax + ay * ay) > rr) {
                    continue;
                }
                ll nx = p[i].x + ax, ny = p[i].y + ay;
                ll gg = nx * inf + ny;
                if (mp.count(gg)) {
                    //cout << i << ' ' << nx << ' ' << ny << '\n';
                    g[i].push_back(mp[gg] - 1);
                }
            }

        }
    }
    ans.resize(n);
    vector<ll> used(n);
    for (int i = 0; i < n; ++i) {
        //cout << i << ":";
        if (!used[i]) {
            ok = 0;
            ts.clear();
            dfs(i, 1, used, p, g);
            if (ok) {
                for (auto it : ts) {
                    ans[it] = 1;
                }
            }
        }
        //cout << endl;
    }
    for (auto it : ans) {
        cout << it;
    }
}

signed main() {
    ll T = 1;
    //cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}