#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e18;

struct node {
    ll x, y, pos;
};
ll n, r, rr;

vector<ll> ans;
bool ok = 0;
vector<ll> ts;
void dfs(ll v, ll col, vector<ll> &used, vector<node> &p) {
    used[v] = col;
    //cout << v << ' ' << used[v] << ":";
    ts.push_back(v);
    for (int u = 0; u < n; ++u) {
        if (u == v) continue;
        ll have = (p[u].x - p[v].x) * (p[u].x - p[v].x) + (p[u].y - p[v].y) * (p[u].y - p[v].y);

        if (have <= rr) {
            //cout << u << ' ' << v << ' ' << have << ' ' << rr << '\n';
            if (used[u] == col) {
                ok = 1;
            } else if (!used[u]) {
                dfs(u, 3 - col, used, p);
            }
        }
    }
}

bool cmp(node a, node b) {

    return a.x < b.x;
}

void solve() {

    cin >> n >> r;
    rr = r * r;
    vector<node> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
        p[i].pos = i;
    }
    sort(p.begin(), p.end(), cmp);
    ans.resize(n);
    queue<ll> q;
    vector<ll> used(n);
    for (int i = 0; i < n; ++i) {
        if (i - 2 >= 0) {
            if (p[i].x - p[i - 2].x <= r) {
                ans[i - 2] = 1;
                ans[i - 1] = 1;
                ans[i] = 1;
                q.push(i - 1);
                used[i - 1] = 1;
            }
        }
        if (i + 2 < n) {
            if (p[i + 2].x - p[i].x <= r) {
                ans[i + 2] = 1;
                ans[i + 1] = 1;
                ans[i] = 1;
                q.push(i + 1);
                used[i + 1] = 1;
            }
        }
    }
    while (!q.empty()) {
        ll f = q.front();
        q.pop();
        if (f - 1 >= 0 && !used[f - 1] && p[f].x - p[f - 1].x <= r) {
            ans[f - 1] = 1;
            used[f - 1] = 1;
            q.push(f - 1);
        }
        if (f + 1 >= 0 && !used[f + 1] && p[f + 1].x - p[f].x <= r) {
            ans[f + 1] = 1;
            used[f + 1] = 1;
            q.push(f + 1);
        }
    }
    vector<ll> real(n);
    for (int i = 0; i < n; ++i) {
        real[p[i].pos] = ans[i];
    }
    for (auto it : real) {
        cout << it;
    }
}

signed main() {
    ll T = 1;
    //cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}
