#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    ll res1 = 0;
    ordered_set<ll> cur1;
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
            res1 += (cur1.size() - cur1.order_of_key(j));
            cur1.insert(j);
        }
    }
    if (r == 1) {
        cout << res1;
        return 0;
    }
    vector<ll> suf(c + 1, 0), pref(c + 1, 0);
    ordered_set<ll> up, down;
    for (ll i = c - 1; i >= 0; i--) {
        suf[i] = suf[i + 1];
        suf[i] += up.order_of_key(a[0][i]);
        suf[i] += down.order_of_key(a[0][i]);
        suf[i] += down.order_of_key(a[1][i]);
        suf[i] += (a[0][i] > a[1][i]);
        up.insert(a[0][i]);
        down.insert(a[1][i]);
    }
    up.clear();
    down.clear();
    for (auto &i : a) {
        for (auto &j : i) {
            down.insert(j);
        }
    }
    ll res = suf[0];
    down.erase(a[0][0]);
    down.erase(a[1][0]);
    ll tmp = 0;
    for (ll i = 1; i <= c; i++) {
        pref[i] = pref[i - 1];
        pref[i] += up.size() - up.order_of_key(a[0][i - 1]);
        up.insert(a[0][i - 1]);
        pref[i] += up.size() - up.order_of_key(a[1][i - 1]);
        up.insert(a[1][i - 1]);
        tmp += down.order_of_key(a[0][i - 1]) + down.order_of_key(a[1][i - 1]);
        res = min(res, pref[i] + suf[i] + tmp);
        if (i < c) {
            tmp -= (up.size() - up.order_of_key(a[0][i])) + (up.size() - up.order_of_key(a[1][i]));
            down.erase(a[0][i]);
            down.erase(a[1][i]);
        }
    }
    cout << res;
}