#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

int main() {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
        }
    }
    vector<vector<ordered_set<ll>>> base(r + 1, vector<ordered_set<ll>> (c + 1));
    for (ll i = r - 1; i >= 0; i--) {
        for (ll j = c - 1; j >= 0; j--) {
            if (j + 1 != c) base[i][j] = base[i][j + 1];
            for (ll k = i; k < r; k++) base[i][j].insert(a[k][j]);
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll> (c + 1, 1e18));
    dp[0][0] = 0;
    for (ll sum = 0; sum <= r + c - 1; sum++) {
        for (ll i = 0; i <= min(sum, r); i++) {
            ll j = sum - i;
            if (j > c) continue;
            if (i + 1 <= r) {
                ll cur = dp[i][j];
                ordered_set<ll> hp;
                for (ll col = j; col < c; col++) {
                    cur += (r * c - a[i][col]) - (base[i][j].size() - base[i][j].order_of_key(a[i][col]) - 1) + (hp.size() - hp.order_of_key(a[i][col]));
                    hp.insert(a[i][col]);
                }
                dp[i + 1][j] = min(dp[i + 1][j], cur);
            }
            if (j + 1 <= c) {
                ll cur = dp[i][j];
                ordered_set<ll> hp;
                for (ll row = i; row < r; row++) {
                    cur += (r * c - a[row][j]) - (base[i][j].size() - base[i][j].order_of_key(a[row][j]) - 1) + (hp.size() - hp.order_of_key(a[row][j]));
                    hp.insert(a[row][j]);
                }
                dp[i][j + 1] = min(dp[i][j + 1], cur);
            }
            // cout << i << " " << j << '\n';
        }
    }
    ll res = 1e18;
    for (ll i = 0; i <= r; i++) res = min(res, dp[i][c]);
    for (ll i = 0; i <= c; i++) res = min(res, dp[r][i]);
    cout << res;
}