#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    vector<ll> suf(n + 1, -1e18);
    for (ll i = n - 1; i >= 0; i--) suf[i] = max(suf[i + 1], a[i]);
    while (q--) {
        ll k, p;
        cin >> k >> p;
        if (p <= k - 1) {
            cout << a[p - 1];
        } else {
            cout << suf[k - 1];
        }
        cout << '\n';
    }
}