#include <bits/stdc++.h>
using namespace std;

// #define FILE
#define int long long

const int N = 1e5;
int n, r;
vector<pair<int, int>> a;
vector<int> used(N, -1);
vector<int> path;
bool flag = false; // есть ли нечетный цикл
map<pair<int, int>, vector<int>> mp;

bool check(int i, int j) {
    auto [x1, y1] = a[i];
    auto [x2, y2] = a[j];
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}

void dfs(int v, int c) {
    path.push_back(v);
    used[v] = c;
    auto [x, y] = a[v];
    x /= r;
    y /= r;
    for (int i1 = -1; i1 < 2; ++i1) {
        for (int j1 = -1; j1 < 2; ++j1) {
            int x1 = x + i1, y1 = y + j1;
            for (auto raw : mp[{x1, y1}]) {
                if (raw != v && check(v, raw) && used[raw] == used[v]) {
                    flag = true;
                }
                if (used[raw] != -1 || !check(v, raw)) continue;
                dfs(raw, (c ^ 1));
            }
        }
    }
}

const int K = 10;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> r;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        mp[{x / r, y / r}].push_back(i);
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            path.clear();
            flag = false;
            dfs(i, 0);
            if (flag) {
                for (auto x : path) ans[x] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}