#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
 
// #define FILE
#define int long long

const int N = 3e5;
vector<int> f(N);


int sum(int x) {
    int ans = 0;
    for (; x > 0; x -= x & -x) {
        ans += f[x];
    }
    return ans;
}

int get(int l, int r) {
    if (l > r) return 0;
    return sum(r) - sum(l - 1);
}

void upd(int x, int val) {
    for (; x < N; x += x & -x) {
        f[x] += val;
    }
}

 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        int val = a[0][i];
        cnt += get(val, N - 1);
        upd(val, 1);
    }
    cout << cnt;
}