#include <bits/stdc++.h>

using ll = long long;

#define pb push_back
#define all(obj) obj.begin(), obj.end()
#define pii pair<int, int>
#define int ll

const int inf = 1000000000;

using namespace std;

vector<int>t;

void build (int v, int tl, int tr, vector<int>&a) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }

    int tm = (tl+tr)/2;
    build(2*v, tl, tm, a);
    build(2*v+1, tm+1, tr, a);
    t[v] = t[2*v]+t[2*v+1];
}

int get(int v, int tl, int tr, int l, int r) {
    if (l == tl and r == tr) {
        return t[v];
    }
    if (l > r) {
        return 0;
    }

    int tm = (tl+tr)/2;
    return get(2*v, tl, tm, l, min(r, tm)) + get(2*v+1, tm+1, tr, max(l, tm+1), r);
}

void update(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t[v] = x;
        return;
    }

    int tm = (tl+tr)/2;
    if (pos <= tm) {
        update(2*v, tl, tm, pos, x);
    }
    else {
        update(2*v+1, tm+1, tr, pos, x);
    }
    t[v] = t[2*v] + t[2*v+1];
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int r, c;
    cin >> r >> c;
    vector<vector<int>>a(r, vector<int>(c));
    for (int i=0; i<r; i++) {
        for (int j=0; j<c; j++) {
            cin >> a[i][j];
        }
    }

    vector<int>h(c, 0);
    t.resize(4*c);
    build(1, 0, c-1, h);
    
    int ans = 0;
    for (int i=0; i<c; i++) {
        ans += get(1, 0, c-1, a[0][i], c-1);
        update(1, 0, c-1, a[0][i]-1, 1);
    }
    cout << ans;
}