#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
 
#define aint(x) x.begin(), x.end()
#define ff first
#define ss second
 
using namespace std;
using namespace __gnu_pbds;
 
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pint = pair<int, int>;
 
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
 
// constexpr int MAXSZ = 102;
// constexpr int MAXPROD = 10005;
// int a[MAXSZ][MAXSZ];
// int dp[MAXSZ][MAXSZ];
// int cnt[MAXPROD][MAXSZ][MAXSZ];
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    int r, c;
    cin >> r >> c;
 
    vector<vector<int>> a(r, vector<int>(c));
    vector<vector<int>> dp(r, vector<int>(c, INT_MAX));
    vector<vector<vector<int>>> cnt(r * c + 1, vector<vector<int>>(r, vector<int>(c)));
 
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    for (int val = 1; val <= r * c; ++val) {
        if (a[0][0] > val) {
            cnt[val][0][0] = 1;
        }
        for (int i = 1; i < r; ++i) {
            cnt[val][i][0] = cnt[val][i - 1][0];
            if (a[i][0] > val) {
                ++cnt[val][i][0];
            }
        }
        for (int j = 1; j < c; ++j) {
            cnt[val][0][j] = cnt[val][0][j - 1];
            if (a[0][j] > val) {
                ++cnt[val][0][j];
            }
        }
        for (int i = 1; i < r; ++i) {
            for (int j = 1; j < c; ++j) {
                cnt[val][i][j] += cnt[val][i - 1][j];
                cnt[val][i][j] += cnt[val][i][j - 1];
                cnt[val][i][j] -= cnt[val][i - 1][j - 1];
                if (a[i][j] > val) {
                    ++cnt[val][i][j];
                }
            }
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            if (i > 0) {
                int cand = dp[i - 1][j];
                ordered_set<int> s;
                for (int k = j; k < c; ++k) {
                    cand += s.size() - s.order_of_key(a[i - 1][k]);
                    s.insert(a[i - 1][k]);
                    if (j > 0) cand += cnt[a[i - 1][k]][r - 1][j - 1];
                    if (i > 1) {
                        cand += cnt[a[i - 1][k]][i - 2][c - 1];
                        if (j > 0) cand -= cnt[a[i - 1][k]][i - 2][j - 1];
                    }
                }
                dp[i][j] = min(dp[i][j], cand);
            }
            if (j > 0) {
                int cand = dp[i][j - 1];
                ordered_set<int> s;
                for (int k = i; k < r; ++k) {
                    cand += s.size() - s.order_of_key(a[k][j - 1]);
                    s.insert(a[k][j - 1]);
                    if (i > 0) cand += cnt[a[k][j - 1]][i - 1][c - 1];
                    if (j > 1) {
                        cand += cnt[a[k][j - 1]][r - 1][j - 2];
                        if (i > 0) cand -= cnt[a[k][j - 1]][i - 1][j - 2];
                    }
                }
                dp[i][j] = min(dp[i][j], cand);
            }
        }
    }
    int ans = dp[r - 1][c - 1];
    for (int y = 0; y < r; ++y) {
        for (int x = 0; x < c; ++x) {
            if (y < r - 1 || x < c - 1) {
                if (a[y][x] > a[r - 1][c - 1]) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
}
