#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll LNF = 1.1e18;
int INF = 1.1e9;




vector<vector<int>> g;
vector<int> used;
void dfs_used(ll u) {
    for (ll v : g[u]) {
        if (!used[v]) {
            used[v] = (used[u] == 1 ? 2 : 1);
            dfs_used(v);
        } else {
            if (used[u] == used[v]) {
                used[u] = 3;
                used[v] = 3;
                return;
            }
        }
    }
}

vector<int> good;
void dfs_good(ll u) {
    good[u] = 1;
    for (ll v : g[u]) {
        if (!good[v]) dfs_good(v);
    }
}

ll BP(ll a, ll n, ll M) {
    if (n == 0) return 1;
    if (n % 2 == 1) return a * BP(a, n - 1, M) % M;
    ll x = BP(a, n / 2, M);
    return x * x % M;
}

void CASE() {
    ll n, r;
    cin >> n >> r;
    vector<vector<int>> a(n, vector<int>(3));
    for (ll i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
        a[i][2] = i;
    }
    sort(a.begin(), a.end());
    // for (ll i = 0; i < n; ++i) {
        // cout << a[i][0] << ' ' << a[i][1] << ' ' << a[i][2] << '\n';
    // }

    if (n < 3) {
        cout << string(n, '0');
        return;
    }

    g.assign(n, {});
    for (ll u = 0; u < n; ++u) {
        int x = a[u][0], y = a[u][1];
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (!(dx == x && dy == y) && dx * dx + dy * dy <= r * r) {
                    ll v = lower_bound(a.begin(), a.end(), vector<int>{x + dx, y + dy, -INF}) - a.begin();
                    if (v == n) continue;
                    // cout << a[u][0] << ' ' << a[u][1] << ' ' << a[v][0] << ' ' << a[v][1] << '\n';
                    if (v != u && a[v][0] == x + dx && a[v][1] == y + dy) {
                        g[u].push_back(v);
                    }
                }
            }
        }
        // cout << u << ": ";
        // for (ll v : g[u]) cout << v << ' ';
        // cout << '\n';
    }

    used.assign(n, 0);
    for (ll u = 0; u < n; ++u) {
        if (!used[u]) {
            used[u] = 1;
            dfs_used(u);
        }
    }
    for (ll u = 0; u < n; ++u) {
        for (ll v : g[u]) {
            if (used[u] == used[v]) {
                used[u] = 3;
                used[v] = 3;
            }
        }
    }

    good.assign(n, 0);
    for (ll u = 0; u < n; ++u) {
        if (good[u] == 0 && used[u] == 3) {
            dfs_good(u);
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[a[i][2]] = good[i];
    }
    for (ll i = 0; i < n; ++i) {
        cout << ans[i];
    }
}




signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    CASE();
}
