#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll LNF = 1.1e18;
int INF = 1.1e9;




vector<vector<int>> g;
vector<int> used;
void dfs_used(ll u) {
    for (ll v : g[u]) {
        if (!used[v]) {
            used[v] = (used[u] == 1 ? 2 : 1);
            dfs_used(v);
        } else {
            if (used[u] == used[v]) {
                used[u] = 3;
                used[v] = 3;
                return;
            }
        }
    }
}

vector<int> good;
void dfs_good(ll u) {
    good[u] = 1;
    for (ll v : g[u]) {
        if (!good[v]) dfs_good(v);
    }
}

ll BP(ll a, ll n, ll M) {
    if (n == 0) return 1;
    if (n % 2 == 1) return a * BP(a, n - 1, M) % M;
    ll x = BP(a, n / 2, M);
    return x * x % M;
}

void CASE() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<ll> smax(n + 1);
    smax[n] = 0;
    for (ll i = n - 1; i >= 0; --i) {
        smax[i] = max(a[i], smax[i + 1]);
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        if (i < k) {
            cout << a[i - 1] << '\n';
        } else {
            cout << smax[n - (k - 1)] << '\n';
        }
    }
}




signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    CASE();
}
