#include <iostream>
#include<vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#pragma GCC target("avx2")

using namespace std;
typedef long long ll;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	ll r;
	cin >> n >> r;
	vector<pair<ll, int>> v;
	for (int i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		v.push_back({ x, i });
	}
	sort(v.begin(), v.end());
	vector<int> ans(n, 0);
	queue<int> q;
	for (int i = 0; i < n; i++) {
		if (i - 2 >= 0 && v[i].first - v[i - 2].first <= r) {
			ans[v[i].second] = 1;
			q.push(i);
		}
		else if (i + 2 < n && v[i + 2].first - v[i].first <= r) {
			ans[v[i].second] = 1;
			q.push(i);
		}
		else if (i + 1 < n && i - 1 >= 0 && v[i + 1].first - v[i - 1].first <= r) {
			ans[v[i].second] = 1;
			q.push(i);
		}
	}
	while (!q.empty()) {
		int cur = q.front();
		q.pop();
		if (cur - 1 >= 0 && v[cur].first - v[cur - 1].first <= r && ans[v[cur - 1].second] == 0) {
			ans[v[cur - 1].second] = 1;
			q.push(cur - 1);
		}
		if (cur + 1 < n && v[cur + 1].first - v[cur].first <= r && ans[v[cur + 1].second] == 0) {
			ans[v[cur + 1].second] = 1;
			q.push(cur + 1);
		}
	}
	for (auto i : ans)
		cout << i;
}