#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")

using namespace std;
typedef long long ll;

vector<vector<int>> g;
vector<int> col;
vector<int> vis;
bool flag = 0;

void dfs(int v, int c) {
	col[v] = c;
	vis.push_back(v);
	for (auto i : g[v]) {
		if (col[i] == c) {
			flag = 1;
		}
		if (col[i] == -1)
			dfs(i, 1 - c);
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	vector<int> opt(n);
	if (v[0] == n) {
		opt[0] = n;
		opt[1] = v.back();
	}
	else {
		int idx = 0;
		for (int i = 0; i < n; i++) {
			if (v[i] > v[0])
				break;
			idx = i;
		}
		opt[0] = v[0];
		int maxi = 0;
		for (int i = idx + 1; i < n; i++)
			maxi = max(maxi, v[i]);
		opt[1] = maxi;
	}
	while (q--) {
		int k, i;
		cin >> k >> i;
		cout << opt[i - 1] << '\n';
	}
}

