#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")

using namespace std;
typedef long long ll;

vector<vector<int>> g;
vector<int> col;
vector<int> vis;
bool flag = 0;

void dfs(int v, int c) {
	col[v] = c;
	vis.push_back(v);
	for (auto i : g[v]) {
		if (col[i] == c) {
			flag = 1;
		}
		if (col[i] == -1)
			dfs(i, 1 - c);
	}
}

bool cmp(vector<int>& a, vector<int>& b) {
	for (int i = 0; i < a.size(); i++) {
		if (a[i] != b[i])
			return a[i] < b[i];
	}
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	if (n % 2 == 0) {
		exit(1);
		while (q--) {
			int k, i;
			cin >> k >> i;
			i--;
			if (i == 0) {
				cout << 1 << '\n';
				continue;
			}
			if (i % 2 == 0 && i == k - 1) {
				cout << v.back() << '\n';
				continue;
			}
			cout << v[i] << '\n';
		}
	}
	else {
		while (q--) {
			int k, i;
			cin >> k >> i;
			i--;
			if (i == 0) {
				cout << 1 << '\n';
				continue;
			}
			if (i % 2 == 0 && i == k - 1) {
				cout << v[n - 2] << '\n';
				continue;
			}
			cout << v[i] << '\n';
		}
	}
	return 0;
	vector<vector<int>> ans(n + 1);
	ans[n] = v;
	for (int i = n - 1; i >= 1; i--) {
		vector<vector<int>> bank;
		for (int j = 0; j + 1 < ans[i + 1].size(); j++) {
			vector<int> cur;
			for (int h = 0; h < j; h++)
				cur.push_back(ans[i + 1][h]);
			cur.push_back(max(ans[i + 1][j], ans[i + 1][j + 1]));
			for (int h = j + 2; h < ans[i + 1].size(); h++)
				cur.push_back(ans[i + 1][h]);
			bank.push_back(cur);
		}
		sort(bank.begin(), bank.end());
		ans[i] = bank[0];
	}
	for (auto i : ans) {
		for (auto j : i)
			cout << j << " ";
		cout << endl;
	}
	while (q--) {
		int k, i;
		cin >> k >> i;
		cout << ans[k][i - 1] << '\n';
	}
}