#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll sq(ll x) {
    return x * x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll R;
    cin >> n >> R;
    vector<array<ll, 2>> a(n);
    for (auto& [x, y] : a) cin >> x >> y;
    auto dst = [&](int i, int j) {
        return sq(a[i][0] - a[j][0]) + sq(a[i][1] - a[j][1]);
    };
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i] < a[j];
    });
    R = sq(R);
    vector<int> ex(n + 1, 0);
    for (int l = 0, r = 0; l < n; ++l) {
        while (r < n && dst(ord[l], ord[r]) <= R) r++;
        if (r - l > 2) {
            ex[l]++;
            ex[r]--;
        }
    }
    vector<int> res(n);
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        int id = ord[i];
        bal += ex[i];
        res[id] = bool(bal);
    }
    for (auto x : res) cout << x;
}