#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19, lg = 19;

int go[lg][R];

int mx[R * 2], mn[R * 2];

void build() {
    for (int i = R - 1; i > 0; --i) {
        mx[i] = max(mx[i * 2], mx[i * 2 + 1]);
        mn[i] = min(mn[i * 2], mn[i * 2 + 1]);
    }
}

int get_mx(int l, int r) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans = max(ans, mx[l++]);
        }
        if (r & 1) {
            ans = max(ans, mx[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

int get_mn(int l, int r) {
    l += R;
    r += R;
    int ans = R;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        mn[i + R] = mx[i + R] = a[i];
        pos[a[i]] = i;
    }
    build();
    vector<int> nxt(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            nxt[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    vector<int> nxt_interesting(n, n);
    for (int i = n - 1; i >= 0; --i) {
        if (i == n - 1 || a[i] > a[i + 1]) {
            nxt_interesting[i] = i;
        } else {
            nxt_interesting[i] = nxt_interesting[i + 1];
        }
    }
    go[0][n - 1] = n;
    go[0][n] = n;
    for (int i = 0; i + 1 < n; ++i) {
        if (nxt[i] == i + 1) {
            go[0][i] = i + 1;
        } else {
            go[0][i] = pos[get_mn(i + 1, nxt[i])];
        }
    }
    for (int i = 1; i < lg; ++i) {
        for (int j = 0; j < n; ++j) {
            go[i][j] = go[i - 1][go[i - 1][j]];
        }
    }
    vector<vector<int>> ans(n + 1);
    auto get_ans = [&](int k, int i) -> int {
        int pos_nw = 0, cnt_nw = 0, val_prv = -1;
        while (cnt_nw <= i && cnt_nw + 2 < k) {
            if (k - cnt_nw == n - pos_nw) {
                return a[pos_nw + (i - cnt_nw)];
            }
            for (int j = lg - 1; j >= 0; --j) {
                if (cnt_nw + (1 << j) + 2 < k && cnt_nw + (1 << j) < i && n - go[j][pos_nw] >= k - (cnt_nw + (1 << j))) {
                    cnt_nw += (1 << j);
                    pos_nw = go[j][pos_nw];
                }
            }
            if (nxt_interesting[pos_nw] != pos_nw) {
                int mx_add = min(i - cnt_nw + 1, min(k - 2 - cnt_nw, nxt_interesting[pos_nw] - pos_nw));
                cnt_nw += mx_add;
                pos_nw += mx_add;
                val_prv = a[pos_nw - 1];
            } else {
                int r = min(nxt[pos_nw], n - (k - cnt_nw - 1) + 1);
                int pos_nxt = pos[get_mn(pos_nw + 1, r)];
                val_prv = a[pos_nw];
                cnt_nw++;
                pos_nw = pos_nxt;
            }
        }
        if (cnt_nw == i + 1) {
            return val_prv;
        }
        if (k > 1) {
            cnt_nw++;
            val_prv = a[pos_nw];
            pos_nw = nxt[pos_nw];
            if (pos_nw == n) {
                pos_nw--;
            }
        }
        if (cnt_nw == i + 1) {
            return val_prv;
        }
        return get_mx(pos_nw, n);
    };
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << get_ans(k, i) + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
