#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

mt19937 gen(596);
const ll INF = 1e18;

int in(pair<ll, ll>  a, pair<ll, ll> b, ll r) {
    ll dist = (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second); //d^2;
    return (dist <= r * r);
}

void solve() {
    ll n, r; cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    vector<vector<int>> g(n);
    map<pair<ll, ll>, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        mp[a[i]] = i + 1;
    }
    vector<vector<int>> dp(n, vector<int>(2));
    for (int i = 0; i < n; i++) {

        vector<pair<int, int>> buf;
        buf.push_back({i, 0});

        dp[i][0] = 1;
        queue<pair<int, int>> q;
        q.push({i, 0});
        while (q.size()) {
            auto v = q.front();
            q.pop();
            int j = v.first;
            for (int dx = a[j].first - r; dx <= a[j].first + r; dx++) {
                for (int dy = a[j].second - r; dy <= a[j].second + r; dy++) {
                    if (mp[{dx, dy}] && in(a[j], {dx, dy}, r)) {
                        int to = mp[{dx, dy}] - 1;
                        if (j != to) {
                            int c = v.second ^ 1;
                            if (!dp[to][c]) {
                                dp[to][c] = 1;
                                q.push({to, c});
                                buf.push_back({to, c});
                                if (dp[i][1]) {
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
        cout << dp[i][1];
        for (auto e : buf) {
            dp[e.first][e.second] = 0;
        }
    }
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}