#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <deque>
using namespace std;

int n;
long double r;

long double len;


bool comp(vector <int> a, vector <int> b) {
    if (a[0] == b[0]) {
        return a[1] < b[1];
    }
    return a[0] < b[0];
}

vector <pair<int, int>> a;
vector <pair<int, int>> cord;
vector <pair<int, int>> block;
vector <pair<int, int>> gran;
int cnt = 0;
unordered_map<long long, int> id;
vector <bool> mas(4);
unordered_map<long long, int> :: iterator it;
vector <int> pbl;

vector <bool> bad;
vector <bool> used;
vector <vector <int>> gr;
bool checkdist(pair<long long, long long> a, pair<long long, long long> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second) <= r * r; //long double?
}

vector <int> col;

void dfs2(int v) {
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (!bad[to]) {
            bad[to] = true;
            dfs2(to);
        }
    }
}

bool dfs3(int v) {
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (col[to] == -1) {
            col[to] = 1 - col[v];
            if (!dfs3(to)) {
                bad[v] = true;
                return false;
            }
    }   else if (col[to] == col[v]) {
            bad[v] = true;
            bad[to] = true;
            return false;
    }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    a.resize(n);
    pbl.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        //a[i].first = i;
        //a[i].second = 0;
    }
    len = r / sqrt(2) - 0.02;
    vector <vector <int>> my_mas(n, vector <int> (3));
    for (int i = 0; i < n; i++) {
        int numx = floor(a[i].first / len);
        int numy = floor(a[i].second / len);
        my_mas[i][0] = numx;
        my_mas[i][1] = numy;
        my_mas[i][2] = i;
    }
    sort(my_mas.begin(), my_mas.end(), comp);
    int st = 0;
    for (int i = 0; i < n; i++) {
        if (i != 0 && (my_mas[i - 1][0] != my_mas[i][0] || my_mas[i - 1][1] != my_mas[i][1])) {
            long long zn = ((long long)(my_mas[i - 1][0])) * 2000000000 + ((long long)my_mas[i - 1][1]);
            id[zn] = cnt;
            cord.push_back(make_pair(my_mas[i - 1][0], my_mas[i - 1][1]));
            cnt++;
            gran.push_back(make_pair(st, i - 1));
            st = block.size();

        }
        block.push_back(a[my_mas[i][2]]);
        pbl[my_mas[i][2]] = cnt;

    }
    long long zn = ((long long)(my_mas[n - 1][0])) * 2000000000 + ((long long)my_mas[n - 1][1]);
    id[zn] = cnt;
    cord.push_back(make_pair(my_mas[n - 1][0], my_mas[n - 1][1]));
    cnt++;
    gran.push_back(make_pair(st, n - 1));
    int m = cord.size();
    //for (int i = 0; i < m; i++) {
    //    cout << cord[i].first << " " << cord[i].second << "\n";
    //    cout << block[i].size() << "\n";
    //}
    used.resize(m);
    bad.resize(m);
    gr.resize(m);
    deque<int> qu;
    for (int i = 0; i < m; i++) {
        qu.push_back(i);
    }
    while (!qu.empty()) {
        int bl_id = qu[qu.size() - 1];
        qu.pop_front();
        if (!used[bl_id]) {

    used[bl_id] = true;
    if (gran[bl_id].second - gran[bl_id].first + 1 >= 3) {
        bad[bl_id] = true;
}   else {
    int x = cord[bl_id].first, y = cord[bl_id].second;
    for (int z = 0; z < 25; z++) {
            int i = (z / 5) - 2;
            int j = z % 5 - 2;
            if (i == 0 && j == 0) {
                continue;
            }
            long long zn = ((long long)(x + i)) * 2000000000 + ((long long)(y + j));
            //cout << zn << "\n";
            it = id.find(zn);
            if (it != id.end()) {
                int to = (*it).second;
                //if (!used[to] || block[to].size() >= 3) {
                    bool fl = false;
                    int q = 0;
                    bool fl_try = (gran[to].second - gran[to].first + 1);
                    mas[0] = 0;
                    mas[1] = 0;
                    mas[2] = 0;
                    mas[3] = 0;
                    for (int z = gran[bl_id].first; z <= gran[bl_id].second; z++) {
                        if (!fl || fl_try) {
                        for (int y = gran[to].first; y <= gran[to].second; y++) {
                            bool fl2 = checkdist(block[z], block[y]);
                            fl |= fl2;
                            if (fl_try && fl2) {
                                mas[(z - gran[bl_id].first) * 2 + y - gran[to].first] = true;
                                q++;
                            }
                        }
                        }
                    }
                   // cout << bl_id << " " << to << " " << fl << "\n";
                    if (q >= 3 || (q == 2 && (!mas[0] || !mas[3]) && (!mas[1] || !mas[2]))) {
                        bad[bl_id] = true;
                        bad[to] = true;
                    }
                    if (fl) {
                        gr[bl_id].push_back(to);
                        gr[to].push_back(bl_id);
                        if (!used[to]) {
                            qu.push_back(to);
                        }
                    }
                //}
            }
    }
        }
        }
    }
    col.resize(m, -1);
    for (int i = 0; i < m; i++) {
        if (col[i] == -1) {
            col[i] = 0;
            dfs3(i);
        }
    }
    for (int i = 0; i < m; i++) {
        if (bad[i]) { //time bad
            //col[i] = 0;
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (bad[pbl[i]]) {
            cout << 1;
    }   else {
            cout << 0;
    }
    }
    return 0;
}

