#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(v) (v).begin(), (v).end()

ll dist(pair<int, int> a, pair<int, int> b) {
	return (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second);
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<int, int>> v(n);
	for (auto& [a, b] : v) cin >> a >> b;

	vector<vector<int>> g(n);
	vector<bool> gd(2 * n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			if (dist(v[i], v[j]) <= r * r) {
				g[i].push_back(j);
			}
			if (g[i].size() >= n) break;
		}
		if (g[i].size() >= n) {
			g[i].clear();
			gd[i] = gd[i + n] = true;
		}
	}

	vector<vector<int>> gp(2 * n);
	for (int i = 0; i < n; i++) {
		if (gd[i]) {
			gp[i].push_back(i + n);
			gp[i + n].push_back(i);
		} else {
			for (int to : g[i]) {
				gp[i].push_back(to + n);
				gp[i + n].push_back(to);
			}
		}
	}

	// for (int i = 0; i < 2 * n; i++) {
	// 	cout << i << ": ";
	// 	for (int to : gp[i]) cout << to << " ";
	// 	cout << "\n";
	// }
	// for (auto x : gd) {
	// 	cout << x << " ";
	// }
	// cout << "\n";

	vector<int> cp(2 * n, -1);
	vector<bool> gc;
	auto dfs = [&](auto dfs, int v, int c) -> bool {
		bool is = gd[v];
		cp[v] = c;
		for (int to : gp[v]) {
			if (cp[to] == -1) {
				if (dfs(dfs, to, c)) is = true;
			}
		}
		// cout << v << ": " << is << "\n";
		return is;
	};

	int cnt = 0;
	for (int i = 0; i < 2 * n; i++) {
		if (cp[i] == -1) {
			bool is = dfs(dfs, i, cnt++);
			gc.push_back(is);
		}
	}

	// for (int x : cp) cout << x << " ";
	// cout << "\n";
	// for (int x : gc) cout << x << " ";
	// cout << "\n";

	for (int i = 0; i < n; i++) {
		if (cp[i] == cp[i + n] || gc[cp[i]]) cout << "1";
		else cout << "0";
	}
}

int32_t main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}