#include <bits/stdc++.h>
#define int long long
using namespace std;

struct point {
    long long x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    long long sqrLen() {
        return x * x + y * y;
    }
};

bool cmp(point a, point b) {
    return a.x < b.x;
}

vector<vector<int> > g;
vector<int> col;
bool bi;
vector<int> z;

void dfs(int v, int c) {
    col[v] = c;
    z.push_back(v);
    for (int to: g[v]) {
        if (!col[to])dfs(to, 3 - c);
        else if (col[to] == c) {
            bi = true;
        }
    }
}

signed main() {
    int n;
    long long r;
    cin >> n >> r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    map<pair<int, int>, vector<int> > mp;
    for (int i = 0; i < n; ++i) {
        mp[{a[i].x / r, a[i].y / r}].push_back(i);
    }
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        int x1 = a[i].x / r, y1 = a[i].y / r;
        for (int j = max(0ll, x1 - 1); j <= x1 + 1; ++j) {
            for (int k = max(0ll, y1 - 1); k <= y1 + 1; ++k) {
                for (int to: mp[{j, k}]) {
                    if (to != i && (a[i] - a[to]).sqrLen() <= r * r) {
                        g[i].push_back(to);
                    }
                }
            }
        }
    }
    vector<int> ans(n, 0);
    col.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!col[i]) {
            bi = false;
            z.clear();
            dfs(i, 1);
            if (bi) {
                for (int to: z) {
                    ans[to] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
