#include <bits/stdc++.h>
using namespace std;

struct point {
    long long x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    long long sqrLen() {
        return x * x + y * y;
    }
};

bool cmp(pair<int, point> a, pair<int, point> b) {
    return a.second.x < b.second.x;
}

vector<vector<int> > g;
vector<int> col;
bool bi;
vector<int> z;

void dfs(int v, int c) {
    col[v] = c;
    z.push_back(v);
    for (int to: g[v]) {
        if (!col[to])dfs(to, 3 - c);
        else if (col[to] == c) {
            bi = true;
        }
    }
}

signed main() {
    int n;
    long long r;
    cin >> n >> r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    vector<pair<int, point> > b(n);
    for (int i = 0; i < n; ++i) {
        b[i] = {i, a[i]};
    }
    sort(b.begin(), b.end(), cmp);
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < min(n, i + 2001); ++j) {
            if ((b[i].second - b[j].second).sqrLen() <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(n, 0);
    col.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!col[i]) {
            bi = false;
            z.clear();
            dfs(i, 1);
            if (bi) {
                for (int to: z) {
                    ans[b[to].first] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
