#include <bits/stdc++.h>
#define int long long
using namespace std;

struct point {
    int x, y;

    void in() {
        cin >> x >> y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }

    int sqrLen() {
        return x * x + y * y;
    }
};

bool cmp(point a, point b) {
    return a.x < b.x;
}

vector<vector<int> > g;
vector<int> col;
bool bi;
vector<int> z;

void dfs(int v, int c) {
    col[v] = c;
    z.push_back(v);
    for (int to: g[v]) {
        if (!col[to])dfs(to, 3 - c);
        else if (col[to] == c) {
            bi = true;
        }
    }
}

signed main() {
    int n, r;
    cin >> n >> r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    sort(a.begin(), a.end(), cmp);
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < min(n, i + 30); ++j) {
            if ((a[i] - a[j]).sqrLen() <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(n, 0);
    col.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!col[i]) {
            bi = false;
            z.clear();
            dfs(i, 1);
            if (bi) {
                for (int to: z) {
                    ans[to] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
