// semenInRussia 2025
#pragma GCC optimize("O3")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <queue>
#include <set>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

const int N = 1e6;
int p[N];
bool ans[N];

using ll = long long;

int main() {
  int n, r;
  cin >> n >> r;

  for (int i = 0; i < n; i++) {
    int y;
    cin >> p[i] >> y;
    assert(y == 0);
  }

  sort(p, p + n);

  for (int i = 1; i + 1 < n; i++) {
    int d = abs(p[i - 1] - p[i]);
    if (d > r || ans[i]) {
      continue;
    }
    for (int j = i + 1; j < n && abs(p[j - 1] - p[j]) <= r; j++) {
      ans[j] = true;
    }
    for (int j = i - 1; j >= 0 && abs(p[j + 1] - p[j]) <= r; j--) {
      ans[j] = true;
    }
    ans[i] = true;
  }
  for (int i = 0; i < n; i++) {
    cout << ans[i];
  }
}