    #include <bits/stdc++.h>

    using namespace std;
    #define ll long long
    #define ldb long double

    #define ve vector
    #define pb push_back
    #define x first
    #define y second


    ve<ve<ll> > edges;

    ll dist(pair<ll, ll> b, pair<ll, ll> a) {
        ldb res = hypot(a.x - b.x, a.y - b.y);
        return ceil(res);
    }

    ll const max_n = 10000;

    bool allowed[max_n];
    ll col[max_n];

    void makin_al(ll v) {
        allowed[v] = true;
        col[v] = 1;
        for (auto it: edges[v]) {
            if (!allowed[it]) {
                makin_al(it);
            }
        }
    }

    void dfs(ll v, ll cur, bool &br) {
        if (col[v] == -1) {
            col[v] = cur;
        } else {
            col[v] = cur;
            makin_al(v);
            br = true;
            return;
        }
        for (auto it: edges[v]) {
            if (br)
                return;
            if (col[it] != 1 - cur)
                dfs(it, 1 - cur, br);
        }
    }

    int main() {
    #ifdef DEBUG_Q
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
        ll n, r;
        cin >> n >> r;
        pair<ll, ll> cor[n];
        edges.resize(n);
        for (ll i = 0; i < n; i++)
            edges[i].reserve(n);
        for (ll i = 0; i < max_n; i++) {
            allowed[i] = false;
            col[i] = -1;
        }
        ll i, j;
        for (i = 0; i < n; i++) {
            cin >> cor[i].first >> cor[i].second;
        }
        for (i = 0; i < n; i++) {
            for (j = i + 1; j < n; j++) {
                if (dist(cor[i], cor[j]) <= r) {
                    edges[i].pb(j);
                    edges[j].pb(i);
                }
            }
        }
        bool br = false;
        for (i = 0; i < n; i++) {
            br = false;
            if (col[i] == -1)
                dfs(i, 0, br);
        }
        for (i = 0; i < n; i++) {
            cout << allowed[i] - 0;
        }
    }
