#include <bits/stdc++.h>
using namespace std;
#define int long long
vector<vector<int>> g;
vector<int> h;

bool dfs(int v, int p) {
    h[v] = h[p] + 1;
    for (int u: g[v]) {
        if (h[u] == 0) {
            dfs(u, v);
        } else if (u != p && h[u] % 2 == h[v] % 2) {
            return true;
        }
    }
    return false;
}

vector<int> ans;

void dfs1(int v) {
    ans[v] = 1;
    for (int u: g[v]) {
        if (ans[u] == 0) {
            dfs1(u);
        }
    }
}

signed main() {
    int n, r;
    cin >> n >> r;
    g.resize(n, {});
    h.resize(n, 0);
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        for (int j = 0; j < i; j++) {
            if ((a[j].first - x) * (a[j].first - x) + (a[j].second - y) * (a[j].second - y) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    ans.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (h[i] == 0) {
            int x = dfs(i, i);
            if (x) {
                dfs1(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
}