/*
#include <bits/stdc++.h>
using namespace std;

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    vector<vector<vector<int> > > pref(n * m, vector<vector<int> >(n + 1, vector<int>(m + 1)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    for (int num = 0; num < n * m; num++) {
        int f = 0;
        for (int i = 1; i <= n; i++) {
            int summ = 0;
            for (int j = 1; j <= m; j++) {
                if (a[i - 1][j - 1] == num) {
                    f = true;
                }
                if (a[i - 1][j - 1] < num && f) {
                    summ++;
                }
                else if (a[i - 1][j - 1] > num && (!f)) {
                    summ++;
                }
                pref[num][i][j] = pref[num][i - 1][j] + summ;
            }
        }
    }
    vector<vector<int> > ans(n + 1, vector<int>(m + 1, n * m + 2));
    ans[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cur = ans[i][j];
            for (int x = 0; x <= m; x++) {
                int num = a[i][x];
                int pix = pref[num][i + 1][x + 1] + pref[num][i][j] - pref[num][i][x + 1];
                cur += pix;
            }
            ans[i + 1][j] = min(ans[i + 1][j], cur);
            cur = ans[i][j];
            for (int x = 0; x <= i; x++) {
                int num = a[x][j];
                int pix = pref[num][x + 1][j + 1] + (i - x) * j - (pref[num][i][j] - pref[num][x][j]);
                cur += pix;
            }
            ans[i][j + 1] = min(ans[i][j + 1], cur);
        }
    }
    int cnt = ans[n - 1][m - 1];
    cout << cnt << endl;
    for (int i = 0; i < m; i++) {
        cnt = min(cnt, ans[n][i]);
    }
    for (int i = 0; i < n; i++) {
        cnt = min(cnt, ans[i][m]);
    }
    cout << cnt << endl;
}
*/


#include <bits/stdc++.h>
using namespace std;

vector<int> t;

void upd(int v, int tl, int tr, int x) {
    if (tl == tr - 1) {
        t[v] = 1;
        return;
    }
    int tm = (tl + tr) / 2;
    if (tm < x) {
        upd(v * 2 + 1, tl, tm, x);
    }
    else {
        upd(v * 2 + 2, tm, tr, x);
    }
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

int summ (int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return t[v];
    }
    if (l >= tr || tl >= r) {
        return 0;
    }
    int tm = (tl + tr) / 2;
    return summ(v * 2 + 1, tl, tm, l, r) + summ(v * 2 + 2, tm, tr, l, r);
}


signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    int ans = 0;
    t.resize(m);
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        upd(0, 0, m, x);
        ans += summ(0, 0, m, x + 1, n);
    }
    cout << ans << endl;
}
