#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;

constexpr int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector z(n, vector<vector<int>>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int ii = 0; ii <= i; ii++) {
                for (int jj = 0; jj <= j; jj++) {
                    z[i][j].push_back(a[ii][jj]);
                }
            }
            sort(z[i][j].begin(), z[i][j].end());
        }
    }
    auto get = [&](int i, int j, int x) -> int {
        if (i < 0 || j < 0) {
            return 0;
        }
      return (int)(z[i][j].size()) - (int)(upper_bound(z[i][j].begin(), z[i][j].end(), x) - z[i][j].begin());
    };
    vector dp(n, vector<int>(m, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i + 1 < n) {
                int val = dp[i][j];
                for (int jj = j; jj < m; jj++) {
                    int x = a[i][jj];
                    val += get(i - 1, m - 1, x) + get(n - 1, j - 1, x) - get(i - 1, j - 1, x);
                    for (int jj2 = j; jj2 < jj; jj2++) {
                        if (a[i][jj2] > x) {
                            val++;
                        }
                    }
                }
                // if (i + 1 == n - 1 && j == m - 1) {
                //     cerr << "??? " << val << '\n';
                // }
                dp[i + 1][j] = min(dp[i + 1][j], val);
            }
            if (j + 1 < m) {
                int val = dp[i][j];
                for (int ii = i; ii < n; ii++) {
                    int x = a[ii][j];
                    val += get(i - 1, m - 1, x) + get(n - 1, j - 1, x) - get(i - 1, j - 1, x);
                    for (int ii2 = i; ii2 < ii; ii2++) {
                        if (a[ii2][j] > x) {
                            val++;
                        }
                    }
                }
                // if (i == n - 1 && j + 1 == m - 1) {
                //     cerr << "??? " << val << '\n';
                // }
                dp[i][j + 1] = min(dp[i][j + 1], val);
            }
        }
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++) {
    //         cerr << dp[i][j] << " \n"[j == m - 1];
    //     }
    // }
    // cerr << "!!!!!!!! " << get(n - 1, m - 1, a[n - 1][m - 1]) << '\n';
    cout << dp[n - 1][m - 1] + get(n - 1, m - 1, a[n - 1][m - 1]) << '\n';
    return 0;
}
