#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;

constexpr int INF = 1e9;

struct fenw {
    vector<int> t;
    void init(int n) {
        t.assign(n, 0);
    }
    void upd(int i, int x) {
        while ( i < t.size()) {
            t[i] += x;
            i |= i + 1;
        }
    }
    int get(int i) {
        int s = 0;
        while (i >= 0) {
            s += t[i];
            --(i &= i + 1);
        }
        return s;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i], a[i]--;
    }
    fenw f;
    f.init(m);
    long long ans = 0;
    for (int i = 0; i < m; i++) {
        int z = f.get(m - 1) - f.get(a[i]);
        ans += (long long)z;
        f.upd(a[i], 1);
    }
    cout << ans << '\n';
    return 0;
}
