// #pragma GCC optimize("Ofast, unroll-loops, no-stack-protector, inline")
// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
 
using namespace std;
 
#define endl "\n"

vector<int> tree, tree1, arr;
int cur_ind1;

int merge(int a, int b) {
    if (arr[a] < arr[b]) {
        return a;
    } else {
        return b;
    }
}

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        tree1[v] = l;
    } else {
        int m = (r + l) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
        tree1[v] = merge(tree1[v * 2 + 1], tree1[v * 2 + 2]);
    }
}

int get1(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return 0;
    } else if (ql <= l && r <= qr) {
        return tree[v];
    } else {
        int m = (r + l) / 2;
        return max(get1(v * 2 + 1, l, m, ql, qr), get1(v * 2 + 2, m, r, ql, qr));
    }
}

void get2(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return;
    } else if (ql <= l && r <= qr) {
        if (arr[cur_ind1] > arr[tree1[v]]) {
            cur_ind1 = tree1[v];
        }
    } else {
        int m = (r + l) / 2;
        get2(v * 2 + 1, l, m, ql, qr);
        get2(v * 2 + 2, m, r, ql, qr);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
    // freopen("input.txt", "r", stdin);
    int n, q;
    cin >> n >> q;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    vector<int> nx1(n, n), nx2(n, n), st1, st2;
    for (int i = 0; i < n; i++) {
        while (!st1.empty() && arr[st1.back()] > arr[i]) {
            nx1[st1.back()] = i;
            st1.pop_back();
        }
        while (!st2.empty() && arr[st2.back()] < arr[i]) {
            nx2[st2.back()] = i;
            st2.pop_back();
        }
        st1.push_back(i);
        st2.push_back(i);
    }
    vector<vector<int>> ans(n + 1);
    for (int t = 0; t < q; t++) {
        int a, b;
        cin >> a >> b;
        b--;
        if (ans[a].size() != 0) {
            cout << ans[a][b] << endl;
            continue;
        }
        int i = a;
        int cur_ind = 0;
        for (int j = 0; j < i; j++) {
            if (i == j + 2) {
                int r = nx2[cur_ind];
                r = min(r, n - (i - j - 1));
                ans[i].push_back(arr[cur_ind]);
                cur_ind = r;
            } else if (i == j + 1) {
                ans[i].push_back(get1(0, 0, n, cur_ind, n));
            } else {
                int r = nx2[cur_ind];
                r = min(r, n - (i - j - 2));
                cur_ind1 = cur_ind + 1;
                get2(0, 0, n, cur_ind + 1, r);
                ans[i].push_back(arr[cur_ind]);
                cur_ind = cur_ind1;
            }
        }
        cout << ans[a][b] << endl;
    }
}