#include <bits/stdc++.h>

using namespace std;

// #define int long long

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> fb(n, n - 1);
    {
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            while (sz(st) && a[st.back()] < a[i]) {
                fb[st.back()] = i;
                st.pop_back();
            }
            st.push_back(i);
        }
    }
    const int L = __lg(n) + 1;
    vector<vector<pair<int, int>>> t(L, vector<pair<int, int>>(n));
    for (int i = 0; i < n; ++i) {
        t[0][i] = {a[i], i};
    }
    for (int l = 1; l < L; ++l) {
        for (int i = 0; i + (1 << l) <= n; ++i) {
            t[l][i] = min(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
        }
    }
    auto get = [&](int l, int r) {
        int x = __lg(r - l + 1);
        return min(t[x][l], t[x][r - (1 << x) + 1]);
    };
    vector<vector<int>> b(n + 1);
    // for (int k = 1; k <= n; ++k) {
    //     for (int j : b[k]) {
    //         cout << j << ' ';
    //     }
    //     cout << '\n';
    // }
    vector<int> sf(n + 1);
    for (int i = n - 1; ~i; --i) {
        sf[i] = max(sf[i + 1], a[i]);
    }
    vector<int> bpos(n + 1, n + 1);
    vector<int> blast(n + 1, n + 1);
    vector<bool> ok(n + 1);
    for (int i = 0; i < q; ++i) {
        int k, x;
        cin >> k >> x;
        --x;
        if (!ok[k]) {
            ok[k] = true;
            int j = k;
            int i = 0;
            for (; j != 1;) {
                if (n - i == j)
                    break;
                --j;
                b[k].push_back(a[i]);
                if (j != 1) {
                    int mx = fb[i];
                    mx = min(mx, n - j);
                    i = get(i + 1, mx).second;
                } else {
                    i = fb[i];
                }
            }
            if (n - i == j) {
                bpos[k] = sz(b[k]);
                blast[k] = i;
            } else {
                b[k].push_back(sf[i]);
            }
        }
        if (x >= bpos[k]) {
            cout << a[x - bpos[k] + blast[k]] << '\n';
        } else {
            cout << b[k][x] << '\n';
        }
    }
}

signed main() {
#ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}