#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve_z(int q) {
    while (q--) {
        int k;
        cin >> k;
        if (k >= 2) {
            cout << k << "\n";
        } else {
            cout << 0 << "\n";
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    bool flag = true;
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        a[i] = c == '1';
        if (a[i] == 1) {
            flag = false;
        }
    }
    if (flag) {
        // assert(n != 1);
        solve_z(q);
        return;
    }
    vector<int> t;
    int zeros = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            zeros++;
            continue;
        }
        bool flag = true;
        if (i > 0 && a[i - 1] == 1) {
            flag = false;
        }
        if (i < n - 1 && a[i + 1] == 1) {
            flag = false;
        }
        if (flag) {
            t.push_back(i);
        }
    }
    vector<int> z;
    z.push_back(n - (int)t.size() - zeros);
    int r = 0;
    while (r < (int)t.size()) {
        if (r + 1 >= (int)t.size()) {
            z.push_back(2);
            r++;
            continue;
        }
        if (t[r] + 2 == t[r + 1]) {
            z.push_back(3);
            r += 2;
        } else {
            z.push_back(2);
            r++;
        }
    }
    sort(z.begin() + 1, z.end(), greater<int>());
    vector<int> pref((int)z.size());
    for (int i = 0; i < (int)z.size(); i++) {
        if (i == 0) {
            pref[i] = z[i];
        } else {
            pref[i] = pref[i - 1] + z[i];
        }
    }
    int m = (int)z.size();
    while (q--) {
        int k;
        cin >> k;
        k = min(k, zeros);
        if (k >= m) {
            cout << pref.back() + k - m + 1 << "\n";
        } else {
            cout << pref[k] << "\n";
        }
    }
}

signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}