#include <vector>
std::vector<int> g[10004] = {};
#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
  
// #define int long long
  
using namespace std;

pair<int, int> a[10004];

long long sq_dist(const pair<int, int> &v, const pair<int, int> &u) {
    int dx = v.first - u.first;
    int dy = v.second - u.second;
    return (long long)dx * dx + (long long)dy * dy;
}
 
bool used[10004] = {};
bool is_good[10004] = {};
int color[10004];
 
bool dfs(int v, int c, int p) {
    vector<vector<int>> st;
    st.push_back({v, c, p});
    while (!st.empty()) {
        int v = st.back()[0];
        int c = st.back()[1];
        int p = st.back()[2];
        st.pop_back();
        color[v] = c;
        for (int u : g[v]) {
            if (u == p) {
                continue;
            }
            if (color[u] == c) {
                return true;
            }
            if (color[u] == -1) {
                st.push_back({u, c ^ 1, v});
            }
        }
    }
    return false;
}
 
void paint(int v, bool flag) {
    vector<int> st;
    st.push_back(v);
    while (!st.empty()) {
        int v = st.back();
        st.pop_back();
        is_good[v] = flag;
        used[v] = true;
        for (int u : g[v]) {
            if (used[u]) {
                continue;
            }
            st.push_back(u);
        }
    }
}
 
void solve() {
    for (int i = 0; i < 10004; i++) {
        color[i] = -1;
    }
    int n, r;
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    long long R =(long long) r * r;
    for (int i = 0; i < n; i++) {
        g[i].reserve(10004);
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (sq_dist(a[i], a[j]) <= R) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bool flag = dfs(i, 0, -1);
            paint(i, flag);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << is_good[i];
    }
    cout << "\n";
}
  
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}