#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>

#define int long long
 
using namespace std;

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, i});
    }
    sort(a.begin(), a.end());
    vector<bool> is_good(n);
    for (int i = 2; i < n; i++) {
        if (a[i].first - a[i - 2].first <= r) {
            is_good[i] = is_good[i - 1] = is_good[i - 2] = true;
        }
    }
    for (int i = 0; i < n; i++) {
        if (is_good[i] || i == 0) {
            continue;
        }
        if (is_good[i - 1] && a[i].first - a[i - 1].first <= r) {
            is_good[i] = true;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        if (is_good[i] || i == n - 1) {
            continue;
        }
        if (is_good[i + 1] && a[i + 1].first - a[i].first <= r) {
            is_good[i] = true;
        }
    }
    for (int i = 0; i < n; i++) {
        if (is_good[i] || i == 0) {
            continue;
        }
        if (is_good[i - 1] && a[i].first - a[i - 1].first <= r) {
            is_good[i] = true;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        if (is_good[i] || i == n - 1) {
            continue;
        }
        if (is_good[i + 1] && a[i + 1].first - a[i].first <= r) {
            is_good[i] = true;
        }
    }
    vector<bool> res(n);
    for (int i = 0; i < n; i++) {
        int z = a[i].second;
        if (is_good[i]) {
            res[z] = true;
        }
    }
    for (bool i : res) {
        cout << i;
    }
    cout << "\n";
}
 
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}