#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(69);

const int INF = 1e9, MOD = 1e9 + 7;

vector<int> dp[3005][3005];
const vector<int> EMP = { INF };

void solve()
{
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
		v[i]--;
	}
	for (long long i = 0; i < n + 1; i++)
	{
		for (long long j = 0; j < n + 1; j++)
		{
			dp[i][j] = EMP;
		}
	}
	dp[n][0] = {};

	for (int i = n - 1; i > -1; i--)
	{
		for (int k = 1; k <= n - i; k++)
		{
			dp[i][k] = EMP;

			int b = 0;
			for (int j = i; j < n; j++)
			{
				b = max(b, v[j]);
				if (dp[j + 1][k - 1] == EMP)
				{
					continue;
				}

				vector<int> res = { b };
				for (auto& elem : dp[j + 1][k - 1])
				{
					res.push_back(elem);
				}
				dp[i][k] = min(dp[i][k], res);
			}
		}
	}
	while (q--)
	{
		int k, idx;
		cin >> k >> idx;
		idx--;
		cout << dp[0][k][idx] + 1 << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
