//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long n, m;
vector<vector<long long>> v1;

long long f(vector<long long>& v) {
	if (v.size() <= 1)
		return 0;

	vector<long long> v22, v33;

	for (long long i = 0; i < (long long)v.size(); ++i) {
		if (i < (long long)v.size() / 2)
			v22.push_back(v[i]);
		else
			v33.push_back(v[i]);
	}
	long long x3 = 0;
	x3 += f(v22);
	x3 += f(v33);

	long long l1 = 0, l2 = 0;
	v.clear();

	for (long long i = 0; i < v22.size() + v33.size(); ++i) {
		if (l1 == (long long)v22.size()) {
			v.push_back(v33[l2]);
			++l2;
			continue;
		}
		if (l2 == (long long)v33.size()) {
			v.push_back(v22[l1]);
			++l1;
			x3 += v33.size();
			continue;
		}
		if (v22[l1] > v33[l2]) {
			v.push_back(v33[l2]);
			++l2;
		}
		else {
			v.push_back(v22[l1]);
			++l1;
			x3 += l2;
		}
	}

	return x3;
}

void to2(string& s1, long long x, long long len) {
	while (s1.size() < len) {
		s1 += x % 2 + '0';
		x /= 2;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	v1.resize(n, vector<long long>(m));

	for (long long i = 0; i < n; ++i)
		for (long long j = 0; j < m; ++j)
			cin >> v1[i][j];

	long long ans = 1e18;

	for (long long h = 0; h < (1 << (n + m)); ++h) {
		string s1 = "";
		to2(s1, h, n + m);
		long long l1 = 0, l2 = 0;
		vector<long long> v3;
		for (long long i = 0; i < n + m; ++i) {
			if (s1[i] == '0') {
				for (long long j = l2; j < m; ++j)
					v3.push_back(v1[l1][j]);
				++l1;
			}
			else {
				for (long long j = l1; j < n; ++j)
					v3.push_back(v1[j][l2]);
				++l2;
			}
			if (l1 == n || l2 == m)
				break;
		}
		ans = min(ans, f(v3));
	}

	cout << ans;
	
	return 0;
}
