//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long n, q;

vector<long long> v1;

void to2(string& s1, long long x, long long len) {
	while (s1.size() < len) {
		s1 += x % 2 + '0';
		x /= 2;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> q;
	v1.resize(n + 1, 0);

	for (long long i = 0; i < n; ++i)
		cin >> v1[i];
	
	vector<vector<long long>> v5(n + 1, { -1 });

	if (n > 1)
		for (long long h = 0; h < (1ll << (n - 1)); ++h) {
			string s1;
			to2(s1, h, n - 1);
			s1 += '1';
			long long mx = 0, k = 0;
			vector<long long> v4;
			for (long long i = 0; i < n; ++i) {
				mx = max(mx, v1[i]);
				if (s1[i] == '1') {
					++k;
					v4.push_back(mx);
					mx = 0;
				}
			}
			if (v5[k][0] == -1)
				v5[k] = v4;
			else
				if (v4 < v5[k])
					v5[k] = v4;
		}

	for (long long i = 0; i < q; ++i) {
		long long k, a;
		cin >> k >> a;
		if (n == 1) {
			cout << v1[0] << '\n';
			continue;
		}
		cout << v5[k][a - 1] << '\n';
	}

	return 0;
}
