#pragma GCC optimize("O3","unroll-loops")
#include<bits/stdc++.h>

using namespace std;

#define int long long

struct fen {
    vector<int> t;

    void sz(int n) {
        t.resize(n,0);
    }

    void upd(int i,int x) {
        while (i < (int) t.size()) {
            t[i] += x;
            i |= (i + 1);
        }
    }

    int get(int r) {
        int x = 0;
        while (r >= 0) {
            x += t[r];
            r = (r & (r + 1)) - 1;
        }
        return x;
    }
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int r, c;
    cin >> r >> c;
    vector<vector<int> > a(r, vector<int>(c));
    auto c1 = a, c2 = a;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];

            a[i][j]--;
        }
    }
    fen tg;
    tg.sz(r * c);
    int ans = 0;
    for (int i = c - 1;i>=0;--i) {
        ans+=tg.get(a[0][i]);
        tg.upd(a[0][i],1);
    }
    cout << ans << '\n';
}
