#include <bits/stdc++.h>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

template<typename T>
istream &operator <<(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator >>(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << nl;
    return out;
}

vector<vector<ll>> g;
vector<ll> used, color;

bool dfs(ll u, ll c) {
    used[u] = c;
    for (auto v : g[u]) {
        if (used[v] != -1) {
            if (used[u] == used[v]) {
                return true;
            }
            continue;
        }
        if (dfs(v, 1 - c)) {
            return true;
        }
    }
    return false;
}

void col(ll u, ll c) {
    color[u] = c;
    for (auto v : g[u]) {
        if (color[v] == -1) {
            col(v, c);
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    vector<pll> a(n);
    g.resize(n);
    used.resize(n, -1);
    color.resize(n, -1);
    bool fl = false;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].ff >> a[i].ss;
        fl = max(fl, a[i].ss != 0);
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            if (i == j) continue;
            if ((a[i].ff - a[j].ff) * (a[i].ff - a[j].ff) + (a[i].ss - a[j].ss) * (a[i].ss - a[j].ss) <= r * r) {
                g[i].emp(j);
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (color[i] == -1) {
            col(i, dfs(i, 0));
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << color[i];
    }
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}