#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx")
// #pragma GCC target("avx2")
#define ll long long
#define nl '\n'
#define emp emplace_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

const ll INF = 1e18;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << nl;
    return out;
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    cin >> a;
    vector<vector<ll>> ans(n + 1);
    for (ll i = 1; i <= n; ++i) {
        vector<ll> v(i, INF);
        ans[i] = v;
    }
    for (ll mask = 0; mask < (1 << n); ++mask) {
        if (!((mask >> 0) & 1)) continue;
        ll k = __builtin_popcountll(mask);
        vector<ll> v;
        for (ll i = 0; i < n;) {
            ll j = i + 1;
            ll mx = a[i];
            while (j < n && (!((mask >> j) & 1))) {
                mx = max(mx, a[j]);
                ++j;
            }
            v.emp(mx);
            i = j;
        }
        ans[k] = min(ans[k], v);
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        cout << ans[k][i - 1] << nl;
    }
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}