#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx")
// #pragma GCC target("avx2")
#define ll long long
#define nl '\n'
#define emp emplace_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

const ll INF = 1e18;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << nl;
    return out;
}

mt19937 rnd(time(nullptr));

ll solve2(ll n, vector<ll> a, ll k, ll i) {
    vector<vector<ll>> ans(n + 1);
    for (ll i = 1; i <= n; ++i) {
        vector<ll> v(i, INF);
        ans[i] = v;
    }
    for (ll mask = 0; mask < (1 << n); ++mask) {
        if (!((mask >> 0) & 1)) continue;
        ll k = __builtin_popcountll(mask);
        vector<ll> v;
        for (ll i = 0; i < n;) {
            ll j = i + 1;
            ll mx = a[i];
            while (j < n && (!((mask >> j) & 1))) {
                mx = max(mx, a[j]);
                ++j;
            }
            v.emp(mx);
            i = j;
        }
        ans[k] = min(ans[k], v);
    }
    return ans[k][i - 1];
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    cin >> a;
    vector<vector<pll>> qr(n + 1);
    vector<ll> cur2;
    for (ll ind = 0; ind < q; ++ind) {
        ll k, i;
        k = 1 + rnd() % n;
        i = 1 + rnd() % k;
        cin >> k >> i;
        // cout << k << ' ' << i << nl;
        qr[k].emp(i, ind);
        //cur2.emp(solve2(n, a, k, i));
    }
    vector<ll> cur(q);
    vector<ll> ans = a;
    for (ll i = n; i >= 1; --i) {
        for (auto [j, ind] : qr[i]) {
            if (i % 2 == 1 && i != 1 && j == i) {
                cur[ind] = a.back();
                continue;
            }
            cur[ind] = ans[j - 1];
        }
        if (i != 1) {
            ll mx = max(ans[i - 1], ans[i - 2]);
            ans.pop_back();
            ans.pop_back();
            ans.emp(mx);
        }
    }
    cout << cur;
    //cout << cur2;
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}