//#pragma GCC optimize("O3, unroll-loops")

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    int kol = 0;
    int cnt = 0, last = 0;
    bool zero = true;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1')zero = false;
        if (s[i] == '1') {
            cnt++;
        } else {
            if (last + 1 < i) {
                kol += cnt;
            }
            cnt = 0;
            last = i + 1;
        }
    }
    vector<int> ans(n);
    if (zero) {
        ans[0] = 0;
        if (n >= 2)ans[1] = 0;
        if (n >= 3)ans[2] = 2;
        for (int i = 3; i <= n; i++) {
            ans[i] = min(n, ans[i - 1] + 1);
        }
    } else {
        vector<int> act(n);
        vector<bool> used(n, 1);
        for (int i = 0; i < n; i++) {
            if (s[i] == '0')continue;
            if (i - 1 >= 0 && s[i - 1] == '1')continue;
            if (i + 1 < n && s[i + 1] == '1')continue;
            used[i] = 0;
            if (i - 1 >= 0)act[i - 1]++;
            if (i + 1 < n)act[i + 1]++;
        }
        set<pair<int, int> > queue;
        for (int i = 0; i < n; i++) {
            if (act[i] != 0) {
                queue.insert({act[i], i});
            }
        }
        ans[0] = kol;
        for (int i = 1; i <= n; i++) {
            if (queue.empty()) {
                ans[i] = min(n, ans[i - 1] + 1);
            } else {
                pair<int, int> cur = *queue.rbegin();
                queue.erase(*queue.rbegin());
                int v = cur.second;
                ans[i] = ans[i - 1] + cur.first + 1;
                act[v] = 0;
                if (v - 2 >= 0) {
                    if (act[v - 2] > 0) {
                        queue.erase({act[v - 2], v - 2});
                        act[v - 2]--;
                        queue.insert({act[v - 2], v - 2});
                    }
                }
                if (v + 2 < n) {
                    if (act[v + 2] > 0) {
                        queue.erase({act[v + 2], v + 2});
                        act[v + 2]--;
                        queue.insert({act[v + 2], v + 2});
                    }
                }
            }
        }
    }
    int x;
    for (int i = 0; i < q; i++) {
        cin >> x;
        cout << ans[x] << '\n';
    }
    return 0;
}
