#pragma GCC optimize("Ofast, unroll-loops")
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int r, c;
    cin >> r >> c;
    vector<deque<int>>a(r);
    int x;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> x;
            a[i].push_back(x);
        }
    }
    reverse(a.begin(), a.end());
    int sz = r + c;
    int ans = 1e9;
    for (int mask = 0; mask < (1 << sz); mask++) {
        vector<deque<int>>new_a = a;
        vector<int>b;
        bool ok = true;
        for (int i = 0; i < sz; i++) {
            if (mask & (1 << i)) {
                if (new_a.empty()) {
                    ok = false;
                    break;
                }
                for (int val : new_a.back()) {
                    b.push_back(val);
                }
                new_a.pop_back();
            } else {
                for (int j = 0; j < new_a.size(); j++) {
                    if (new_a[j].empty()) {
                        ok=false;
                        break;
                    }
                    b.push_back(new_a[j].front());
                    new_a[j].pop_front();
                }
            }
            if (!ok)break;
        }
        if (!ok)continue;
        int cur = 0;
        for (int i = 0; i < b.size(); i++) {
            for (int j = i + 1; j < b.size(); j++) {
                if (b[i] > b[j])cur++;
            }
        }

        ans = min(ans, cur);
    }
    cout << ans;
    return 0;
}
