#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define all(v) v.begin(), v.end()
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll N = 250000;

class tree {
public:
	ll n;
	ll tr[2 * N + 1];

	void update(ll p) {
		p += n;
		tr[p] = 1; p >>= 1;
		while (p > 0) {
			tr[p] = tr[p << 1] + tr[p << 1 | 1];
			p >>= 1;
		}
	}
	ll sum(ll l, ll r) {
		ll res = 0;
		l += n; r += n;
		while (l < r) {
			if (l & 1)
				res += tr[l++];
			if (r & 1)
				res += tr[--r];
			l >>= 1; r >>= 1;
		}
		return res;
	}
	void cl() {
		for0(i, 2 * N + 1)
			tr[i] = 0;
	}
};

ll r, c, sw = 0, ans = 1e18;
ll mat[N + 1], ansv[N + 1];
tree tr;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> r >> c;
	tr.n = c;
	for1(i, c)
		cin >> mat[i];
	for (ll i = c; i >= 1; --i) {
		sw += tr.sum(0, mat[i]);
		tr.update(mat[i] - 1);
		ansv[i - 1] = sw;
	}
	cout << sw << "\n";
}