#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define all(v) v.begin(), v.end()
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll N = 3e5;

ll n, q, k, t;
ll arr[N + 1], pref[N + 1], suf[N + 2];
pll ans;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> n >> q;
	for1(i, n)
		cin >> arr[i];
	for1(i, n)
		pref[i] = max(pref[i - 1], arr[i]);
	for (ll i = n; i >= 1; --i)
		suf[i] = max(suf[i + 1], arr[i]);
	ans = { arr[1], n + 1 };
	for1(i, n - 1) {
		if (pref[i] != arr[1])
			break;
		ans.second = min(ans.second, suf[i + 1]);
	}
	while (q--) {
		cin >> k >> t;
		if (t == 1)
			cout << ans.first << "\n";
		else
			cout << ans.second << "\n";
	}
}