#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 1e5 + 5;

vector<ll> g[N];

pair<ll, ll> p[N];

ll used[2][N];
ll ans[N];
unordered_map<ll, ll> qp;
ll n, r;

void dfs(ll v, ll x, ll &pr, vector<ll> &gg) {
    gg.push_back(v);
    used[x][v] = 2;
    auto len2 = [&](pair<ll, ll> &a, pair<ll, ll> &b) {
        return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
    };
    for (int w = -10; w <= 10; ++w) {
        for (int h = -10; h <= 10; ++h) {
            auto [x1, y1] = p[v];
            x1 += w;
            y1 += h;
            if (qp.count(x1 + y1 * N)) {
                ll j = qp[x1 + y1 * N];
                if (v != j && len2(p[v], p[j]) <= r * r) {
                    ll u = j;
                    if (used[x][u] == 2) {
                        pr = 1;
                    }
                    if (used[x ^ 1][u] == 0) {
                        dfs(u, x ^ 1, pr, gg);
                    }
                }
            }
        }
    }
    used[x][v] = 1;
}

void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        qp[p[i].first + p[i].second * N] = i;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[0][i]) {
            ll pr = 0;
            vector<ll> gg;
            dfs(i, 0, pr, gg);
            if (pr) {
                for (ll u: gg) {
                    ans[u] = 1;
                }
            }
        }
        cout << ans[i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
