#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << setprecision(20) << fixed;
    int t = 1; //cin >> t;
    while (t--) solve();
}

ll dist2(pair<ll, ll> a, pair<ll, ll> b) {
    return (a.F - b.F) * (a.F - b.F) + (a.S - b.S) * (a.S - b.S);
}

vector<vector<int> > g;
vector<int> used, ans;
int cycle = 0;

void dfs(int v, int c = 1, int p = -1) {
    used[v] = c;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u, c + 1, v);
        } else if (u != p) {
            if (used[u] % 2 == used[v] % 2) cycle = 1;
        }
    }
}

void color(int v) {
    ans[v] = 1;
    for (auto u : g[v]) {
        if (!ans[u]) {
            color(u);
        }
    }
}

void solve() {
    ll n, r; cin >> n >> r;
    vector<pair<ll, ll> > p(n);
    int checkY = 1;
    for (int i = 0; i < n; i++) {
        cin >> p[i].F >> p[i].S;
        if (p[i].S != 0) checkY = 0;
    }

    if (checkY) {
        vector<pair<int, int> > a(n);
        for (int i = 0; i < n; i++) a[i].F = p[i].F, a[i].S = i;
        sort(all(a));

        ans.assign(n, 0);
        vector<int> cur;
        int ok = 0;
        for (int i = 0; i < n; i++) {
            if (i > 0 && a[i].F - a[i - 1].F > r) {
                if (ok) {
                    for (auto v : cur) ans[v] = 1;
                }
                cur.clear();
                ok = 0;
            }
            cur.push_back(a[i].S);
            if (i >= 2 && a[i].F - a[i - 2].F <= r) ok = 1;
        }
        if (ok) {
            for (auto v : cur) ans[v] = 1;
        }
        for (int i = 0; i < n; i++) cout << ans[i];
        return;
    }

    g.assign(n, vector<int> (0));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (dist2(p[i], p[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    used.assign(n, 0);
    ans.assign(n,0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cycle = 0;
            dfs(i);
            if (cycle) color(i);
        }
    }

    for (int i = 0; i < n; i++) cout << ans[i];
}