#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<int>> graph;
vector<vector<bool>> used;

vector<pair<ll, ll>> points;
ll n, r;
ll st;
bool found;

void dfs(int v, int c=0) {
    used[v][c] = true;
    if (c == 1 && st == v) {
        found = true;
    }
    if (found) return;

    for (int i = 0; i < n; ++i) {
        if (used[i][1 - c]) continue;
        if (i == v) continue;

        if ((points[i].first - points[v].first) * (points[i].first - points[v].first) + (points[i].second - points[v].second) * (points[i].second - points[v].second) <= r * r) {
            dfs(i, 1 - c);
        }
    }
}

void solve() {
    cin >> n >> r;
    points.resize(n);
    for (auto &x : points) {
        cin >> x.first >> x.second;
    }
    for (int i = 0; i < n; ++i) {
        used.assign(n, vector<bool>(2, false));
        st = i;
        found = false;
        dfs(i);
        if (used[i][1]) cout << 1;
        else cout << 0;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}