#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int ans1 = 0;
vector<int> st(vector<int> arr) {
    if (arr.size() <= 1) {
        return arr;
    }

    int m = arr.size() / 2 - 1;
    vector<int> a1;
    vector<int> b1;
    for (int i = 0; i < arr.size(); ++i) {
        if (i <= m) {
            a1.push_back(arr[i]);
        } else {
            b1.push_back(arr[i]);
        }
    }
    auto a = st(a1);
    auto b = st(b1);

    vector<int> res;
    int i = 0;
    int j = 0;
    while (i < a.size() || j < b.size()) {
        if (i >= a.size()) {
            res.push_back(b[j]);
            ++j;
        } else if (j >= b.size()) {
            ans1 += j;
            res.push_back(a[i]);
            ++i;
        } else if (a[i] < b[j]) {
            ans1 += j;
            res.push_back(a[i]);
            ++i;
        } else {
            res.push_back(b[j]);
            ++j;
        }
    }

    return res;
}


void solve() {
    vector<vector<int>> arr;
    int r, c;
    cin >> r >> c;
    arr.assign(r, vector<int>(c));
    for (auto &x : arr) {
        for (auto &y : x) {
            cin >> y;
        }
    }

    vector<vector<int>> dp(r + 1, vector<int>(c + 1, INT_MAX));
    dp[r][c] = 0;
    for (int summ = r + c; summ >= 2; --summ) {
        for (int r_ost = min(summ - 1, r); r_ost >= 1 && summ - r_ost <= c; r_ost--) {
            int c_ost = summ - r_ost;
            vector<int> d;
            for (int i = 0; i < r - r_ost; ++i) {
                for (int j = 0; j < c; ++j) {
                    d.push_back(arr[i][j]);
                }
            }

            for (int i = r - r_ost; i < r; ++i) {
                for (int j = 0; j < c - c_ost; ++j) {
                    d.push_back(arr[i][j]);
                }
            }

            // delete row
            int inv = 0;
            vector<int> d2;
            for (int j = c - c_ost; j < c; ++j) {
                d2.push_back(arr[r - r_ost][j]);
            }
            ans1 = 0;
            st(d);
            inv += ans1;
            sort(d.begin(), d.end());
            for (int i : d2) {
                auto it = lower_bound(d.begin(), d.end(), i);
                if (it != d.end()) {
                    inv += d.end() - it;
                }
            }
            dp[r_ost - 1][c_ost] = min(dp[r_ost - 1][c_ost], dp[r_ost][c_ost] + inv);

            // delete column
            inv = 0;
            d2.clear();
            for (int i = r - r_ost; i < r; ++i) {
                d2.push_back(arr[i][c - c_ost]);
            }
            inv += ans1;
            sort(d.begin(), d.end());
            for (int i : d2) {
                auto it = lower_bound(d.begin(), d.end(), i);
                if (it != d.end()) {
                    inv += d.end() - it;
                }
            }
            dp[r_ost][c_ost - 1] = min(dp[r_ost][c_ost - 1], dp[r_ost][c_ost] + inv);
        }
    }

    int ans = INT_MAX;
    for (int i = 0; i <= r; ++i) {
        ans = min(ans, dp[i][0]);
    }
    for (int i = 0; i <= c; ++i) {
        ans = min(ans, dp[0][i]);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}