#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve() {
    vector<vector<int>> arr;
    int r, c;
    cin >> r >> c;
    arr.assign(r, vector<int>(c));
    for (auto &x : arr) {
        for (auto &y : x) {
            cin >> y;
        }
    }

    vector<vector<int>> dp(r + 1, vector<int>(c + 1, INT_MAX));
    dp[r][c] = 0;
    for (int summ = r + c; summ >= 0; --summ) {
        for (int r_ost = min(summ - 1, r); r_ost >= 1; r_ost--) {
            int c_ost = summ - r_ost;
            vector<int> d;
            for (int i = 0; i < r - r_ost; ++i) {
                for (int j = 0; j < c; ++j) {
                    d.push_back(arr[i][j]);
                }
            }

            for (int i = r - r_ost; i < r; ++i) {
                for (int j = 0; j < c - c_ost; ++j) {
                    d.push_back(arr[i][j]);
                }
            }

            // delete row
            int inv = 0;
            vector<int> d2;
            for (int j = c - c_ost; j < c; ++j) {
                d2.push_back(arr[r - r_ost][j]);
            }
            for (int i = 0; i < d2.size(); ++i) {
                for (int j = 0; j < i; ++j) {
                    if (d2[j] > d2[i]) {
                        ++inv;
                    }
                }
            }
            for (int i : d2) {
                for (int j : d) {
                    if (j > i) {
                        ++inv;
                    }
                }
            }
            dp[r_ost - 1][c_ost] = min(dp[r_ost - 1][c_ost], dp[r_ost][c_ost] + inv);

            // delete column
            inv = 0;
            d2.clear();
            for (int i = r - r_ost; i < r; ++i) {
                d2.push_back(arr[i][c - c_ost]);
            }
            for (int i = 0; i < d2.size(); ++i) {
                for (int j = 0; j < i; ++j) {
                    if (d2[j] > d2[i]) {
                        ++inv;
                    }
                }
            }
            for (int i : d2) {
                for (int j : d) {
                    if (j > i) {
                        ++inv;
                    }
                }
            }
            dp[r_ost][c_ost - 1] = min(dp[r_ost][c_ost - 1], dp[r_ost][c_ost] + inv);
        }
    }

    int ans = INT_MAX;
    for (int i = 0; i <= r; ++i) {
        ans = min(ans, dp[i][0]);
    }
    for (int i = 0; i <= c; ++i) {
        ans = min(ans, dp[0][i]);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}