#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int n;
vector<int> arr;
const int INF = 1e9;

vector<int> calc_dp(int k) {
    vector<int> res;

    int start = 0;
    for (int g = 1; g < k - 1; ++g) {
        int mx = start + 1;
        for (int i = start + 1; i < n - (k - g) + 1; ++i) {
            if (arr[i] < arr[mx]) {
                mx = i;
            }
            if (arr[i] > arr[start]) break;
        }

        res.push_back(arr[start]);
        start = mx;
    }

    if (k == 1) {
        int mn = arr[start];
        for (int i = start; i < n; ++i) {
            mn = max(mn, arr[i]);
        }
        res.push_back(mn);
    } else if (k >= 2) {
        vector<int> pref_maxx(n);
        pref_maxx[start] = arr[start];
        for (int i = start + 1; i < n; ++i) {
            pref_maxx[i] = max(pref_maxx[i - 1], arr[i]);
        }
        vector<int> suff_maxx(n);
        suff_maxx[n - 1] = arr[n - 1];
        for (int i = n - 2; i >= 0; --i) {
            suff_maxx[i] = max(suff_maxx[i + 1], arr[i]);
        }

        pair<int, int> now = {INT_MAX, INT_MAX};
        for (int i = start; i < n - 1; ++i) {
            pair<int, int> now1 = {pref_maxx[i], suff_maxx[i + 1]};
            if (now > now1) {
                now = now1;
            }
        }

        res.push_back(now.first);
        res.push_back(now.second);
    }

    return res;
}

void solve() {
    int q;
    cin >> n >> q;

    arr.resize(n);
    for (auto &x : arr) {
        cin >> x;
    }

    vector<vector<int>> res(n + 1);

    while (q--) {
        int k, i;
        cin >> k >> i;

        if (res[k].empty()) {
            res[k] = calc_dp(k);
        }

        cout << res[k][i - 1] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}