#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int n;
vector<int> arr;
const int INF = 1e9;

struct Tree {
    vector<pair<int, int>> tree;
    void upd(int v, int i, int x, int tl, int tr) {
        if (tl == tr) {
            tree[v] = {x, i};
            return;
        }

        int tm = (tl + tr) / 2;
        if (i <= tm) {
            upd(v * 2, i, x, tl, tm);
        } else {
            upd(v * 2 + 1, i, x, tm + 1, tr);
        }

        if (tree[v * 2].first < tree[v * 2 + 1].first) {
            tree[v] = tree[v * 2];
        } else {
            tree[v] = tree[v * 2 + 1];
        }
    }

    pair<int, int> get_(int v, int l, int r, int tl, int tr) {
        if (l <= tl && tr <= r) {
            return tree[v];
        }

        pair<int, int> now = {INT_MAX, INT_MAX};
        int tm = (tl + tr) / 2;
        if (l <= tm) {
            auto res = get_(v * 2, l, min(r, tm), tl, tm);
            if (res.first < now.first) {
                now = res;
            }
        }
        if (r >= tm + 1) {
            auto res = get_(v * 2 + 1, max(l, tm + 1), r, tm + 1, tr);
            if (res.first < now.first) {
                now = res;
            }
        }

        return now;
    }
};

Tree t;
vector<int> mxx;

vector<int> calc_dp(int k) {
    vector<int> res;

    int start = 0;
    for (int g = 1; g < min(4, k - 1); ++g) {
        int r = min(n - (k - g), mxx[start]);
        auto d = t.get_(1, start + 1, r, 0, n - 1);
        int mx = d.second;

        res.push_back(arr[start]);
        start = mx;
    }

    if (k == 1) {
        int mn = arr[start];
        for (int i = start; i < n; ++i) {
            mn = max(mn, arr[i]);
        }
        res.push_back(mn);
    } else if (k >= 2 && k <= 5) {
        vector<int> pref_maxx(n);
        pref_maxx[start] = arr[start];
        for (int i = start + 1; i < n; ++i) {
            pref_maxx[i] = max(pref_maxx[i - 1], arr[i]);
        }
        vector<int> suff_maxx(n);
        suff_maxx[n - 1] = arr[n - 1];
        for (int i = n - 2; i >= 0; --i) {
            suff_maxx[i] = max(suff_maxx[i + 1], arr[i]);
        }

        pair<int, int> now = {INT_MAX, INT_MAX};
        for (int i = start; i < n - 1; ++i) {
            pair<int, int> now1 = {pref_maxx[i], suff_maxx[i + 1]};
            if (now > now1) {
                now = now1;
            }
        }

        res.push_back(now.first);
        res.push_back(now.second);
    }

    return res;
}

void solve() {
    int q;
    cin >> n >> q;

    arr.resize(n);
    for (auto &x : arr) {
        cin >> x;
    }

    vector<int> suff_maxx(n);
    suff_maxx[n - 1] = arr[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suff_maxx[i] = max(suff_maxx[i + 1], arr[i]);
    }

    while (q--) {
        int k, i;
        cin >> k >> i;

        if (i != k) {
            if (i % 2 == 0) {
                cout << n - i / 2 + 1 << "\n";
            } else {
                cout << i / 2 + 1 << "\n";
            }
        } else if (i == k) {
            cout << suff_maxx[n - (n - k) - 1] << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}