#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

int d(pair<int, int> a, pair<int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector<vector<int>> g;
vector<bool> used;
vector<bool> ans;

void dfs(int v) {
    ans[v] = true;
    used[v] = true;
    for (auto i : g[v]) {
        if (used[v]) continue;
        dfs(i);
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    g.resize(n);
    used.resize(n, false);
    ans.resize(n, false);
    vector<pair<int, int>> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i].first >> x[i].second;
    }
    // sort(all(x));
    for (int i = 0; i < n; i++) {
        bool cnt = false;
        for (int j = 0; j < n && !cnt; j++) {

            for (int k = 0; k < n && !cnt; k++) {
                if (i == j || i == k || j == k) continue;
                cnt |= (d(x[i], x[j]) <= r * r && d(x[i], x[k]) <= r * r && d(x[j], x[k]) <= r * r);
            }
        }
        ans[i] = cnt;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (d(x[i], x[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            dfs(i);
        }
        // cout << ans[i];
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}