#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,O3")
#define vl vector<long long>
#define pb push_back
#define pl pair<long long, long long>
#define F first
#define S second
#define vvl vector<vector<long long>>
#define rep(i, a, b) for (long long i = a; i < b; ++i)
typedef long long ll;
using namespace std;
const ll INF = 1e18;
ll n, r;
vector<array<ll, 3>> p;
vvl g;
vl used, dist, ans;
queue<ll> q;

bool check(ll i, ll j) {
    if (j < 0 || j >= n) return 0;
    return (abs(p[j][0] - p[i][0]) <= r);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> r;
    p.resize(n);
    rep(i, 0, n) {
        cin >> p[i][0] >> p[i][1];
        p[i][2] = i;
    }
    if (n <= 2) {
        rep(i, 0, n) cout << 0;
        return 0;
    }
    sort(p.begin(), p.end());
    g.resize(n);
    used.resize(n, 0);
    rep(i, 0, n) {
        if (check(i, i + 2) || check(i, i - 2) || (check(i, i + 1) && check(i, i - 1))) {
            used[i] = 1;
            continue;
        }
        if (check(i, i + 1)) {
            g[i].pb(i + 1);
            g[i + 1].pb(i);
        }
        if (check(i, i - 1)) {
            g[i].pb(i - 1);
            g[i - 1].pb(i);
        }
    }
    dist.resize(n, INF);
    rep(i, 0, n) {
        if (!used[i]) continue;
        dist[i] = 0;
        q.push(i);
    }
    while (q.size()) {
        ll v = q.front();
        q.pop();
        if (used[v]) continue;
        used[v] = 1;
        for (ll u : g[v]) {
            if (dist[v] + 1 < dist[u]) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    ans.resize(n, 0);
    rep(i, 0, n) {
        if (used[i]) {
            ans[p[i][2]] = 1;
        }
    }
    rep(i, 0, n) cout << ans[i];
    return 0;
}
