#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 1e5 + 1;
const ll INF = 1e18;

ll n, r;


void solve() {
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    vector<ll> xs;
    map<ll, ll> rev;
    for (int i = 0; i < n; i++) {
        ll x, y; cin >> x >> y;
        a[i] = {x, i};
        xs.push_back(x);
    }
    sort(a.begin(), a.end());
    sort(xs.begin(), xs.end());
    for (int i = 0; i < n; i++) {
        rev[i] = a[i].second;
    }
    vector<ll> evs(n + 1);
    for (int i = 0; i < n; i++) {
        vector<ll> can;
        for (int j = i - 1; j >= max(0, i - 9); j--) {
            if (abs(a[i].first - a[j].first) <= r) {
                can.push_back(j);
            } else {
                break;
            }
        }
        for (int j = i + 1; j < min(n, i + 10ll); j++) {
            if (abs(a[i].first - a[j].first) <= r) {
                can.push_back(j);
            } else {
                break;
            }
        }
        bool ok = false;
        for (int j1 = 0; j1 < can.size(); j1++) {
            for (int j2 = j1 + 1; j2 < can.size(); j2++) {
                if (abs(a[can[j1]].first - a[can[j2]].first) <= r) {
                    ok = true;
                }
            }
        }
        if (ok) {
            ll L = lower_bound(xs.begin(), xs.end(), a[i].first - r) - xs.begin();
            ll R = upper_bound(xs.begin(), xs.end(), a[i].first + r) - xs.begin() - 1;
            // cout << L << " " << R << '\n';
            evs[L]++;
            evs[R + 1]--;
        }
    }
    vector<bool> ans(n);
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt += evs[i];
        if (cnt > 0) {
            ans[rev[i]] = true;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}