#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 1e5 + 1;
const ll INF = 1e18;

vector<ll> g[N];
pair<ll, ll> a[N];
ll n, r;

bool reach(ll i, ll j) {
    if (i == j) return false;
    return ((a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r);
}

void solve() {
    map<pair<ll, ll>, ll> here;
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        here[a[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        for (ll x = a[i].first - r; x <= a[i].first + r; x++) {
            for (ll y = a[i].second - r; y <= a[i].second + r; y++) {
                if (here[{x, y}] != 0 && reach(i, here[{x, y}] - 1)) {
                    g[i].push_back(here[{x, y}] - 1);
                }
            }
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (g[i].size() >= 9) {
            ans[i] = true;
            for (auto v : g[i]) {
                ans[v] = true;
            }
            continue;
        }
        bool ok = false;
        for (int v1 = 0; v1 < g[i].size(); v1++) {
            for (int v2 = v1 + 1; v2 < g[i].size(); v2++) {
                if (reach(g[i][v1], g[i][v2])) {
                    ok = true;
                }
            }
        }
        if (ok) {
            ans[i] = true;
            for (auto v : g[i]) {
                ans[v] = true;
            }
        }
    }
    queue<ll> q;
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            q.push(i);
        }
    }
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (!ans[to]) {
                ans[to] = true;
                q.push(to);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}