#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 2e5 + 1;
const ll INF = 1e18;

vector<ll> g[N];
pair<ll, ll> a[N];
ll n, r;
ll used[N], ans[N];

bool reach(ll i, ll j) {
    return ((a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r);
}

bool gg;
vector<ll> cmp;
void dfs(ll v, ll c = 1) {
    used[v] = c;
    cmp.push_back(v);
    for (auto to : g[v]) {
        if (used[to] == 0) {
            dfs(to, 3 - c);
        } else if (used[to] == c) {
            gg = true;
        }
    }
}

void solve() {
    map<pair<ll, ll>, ll> here;
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        here[a[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        ll X = a[i].first, Y = a[i].second;
        for (ll x = X - r; x <= X + r; x++) {
            for (ll y = Y - r; y <= Y + r; y++) {
                ll idx = here[{x, y}];
                if (idx == 0) continue;
                idx--;
                if (i == idx) continue;
                if (reach(i, idx)) {
                    g[i].push_back(idx);
                }
            }
        }
        // sort(g[i].begin(), g[i].end());
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            cmp.clear();
            gg = false;
            dfs(i);
            if (gg) {
                for (auto v : cmp) {
                    ans[v] = 1;
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}