#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
using namespace std;
using ll = long long;
const ll LINF = 1e18 + 7;
vector<int>seg_tree;
int gt(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql)return 0;
	if (ql <= l and r <= qr)return seg_tree[v];
	int md = (r + l) / 2;
	return gt(2 * v + 1, l, md, ql, qr) + gt(2 * v + 2, md, r, ql, qr);
}
void modify(int v, int l, int r, int i, int x) {
	if (r - l == 1) {
		seg_tree[v] = x;
		return;
	}
	int md = (r + l) / 2;
	if (i < md)modify(2 * v + 1, l, md, i, x);
	else modify(2 * v + 2, md, r, i, x);
	seg_tree[v] = seg_tree[2 * v + 1] + seg_tree[2 * v + 2];
}
void build(int v, int l, int r) {
	if (r - l == 1) {
		seg_tree[v] = 0;
		return;
	}
	int md = (r + l) / 2;
	build(2 * v + 1, l, md);
	build(2 * v + 2, md, r);
	seg_tree[v] = seg_tree[2 * v + 1] + seg_tree[2 * v + 2];
}
vector<vector<int>>a;
int gt_less_than(int i1, int i2, int j1, int j2, int k) {
	int cnt = 0;
	for (int i = i1; i < i2; ++i) {
		for (int j = j1; j < j2; ++j) {
			if (a[i][j] < k)cnt++;
		}
	}
	return cnt;
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int n, q; cin >> n >> q;
	vector<int>a(n);
	for (int i = 0; i < n; ++i)cin >> a[i];
	vector<int>p(n + 1), s(n + 1);
	for (int i = 0; i < n; ++i)p[i + 1] = max(p[i], a[i]);
	for (int i = n - 1; i >= 0; --i)s[i] = max(s[i + 1], a[i]);
	pair<int, int>ans = { n,n };
	for (int i = 1; i < n; ++i) {
		pair<int, int>cr = { p[i],s[i] };
		if (cr.first < ans.first or cr.first == ans.first && cr.second < ans.second) {
			ans = cr;
		}
	}
	for (int _ = 0; _ < q; ++_) {
		int k, i; cin >> k >> i;
		if (k == 1) {
			cout << p[n] << '\n';
		}
		else {
			if (i == 1)cout << ans.first << "\n";
			else cout << ans.second << "\n";
		}
	}
}

