#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 2e5 + 10;

int n, r;
bool good[N];
pii a[N];

int dst(pii p1, pii p2) {
    return (p1.X - p2.X) * (p1.X - p2.X) + (p1.Y - p2.Y) * (p1.Y - p2.Y);
}

bool can(int i, int j) {
    return dst(a[i], a[j]) <= r * r;
}

void solve() {
    cin >> n >> r;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
    }

    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int k = j + 1; k <= n; ++k) {
                if (can(i, j) && can(i, k) && can(j, k)) {
                    good[i] = true;
                    good[j] = true;
                    good[k] = true;
                }
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        bool f = false;
        for (int j = 1; j <= n; ++j) {
            if (can(i, j)) {
                if (good[j]) {
                    f = true;
                    break;
                }
            }
        }
        if (f) cout << 1;
        else cout << 0;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}