#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 2e5 + 10;

int n, r;
bool ans[N];
pii a[N];

int dst(pii p1, pii p2)  {
    return (p1.X - p2.X) * (p1.X - p2.X) + (p1.Y - p2.Y) * (p1.Y - p2.Y);
}

bool can(int i, int j)  {
    return dst(a[i], a[j]) <= r * r;
}



int usd[N], tmr = 0;
int col[N];

bool dfs(int v) {
    bool f = false;
    usd[v] = tmr;
    for (int to = 1; to <= n; ++to) {
        if (to == v || !can(v, to)) continue;
        if (usd[to] == tmr) {
            if (col[to] == col[v]) f = true;
        }
        else if (usd[to] == 0) {
            col[to] = col[v] ^ 1;
            f |= dfs(to);
        }
    }
    return f;
}

void solve() {
    cin >> n >> r;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
    }

    for (int i = 1; i <= n; ++i) {
        if (usd[i]) continue;
        ++tmr;
        col[i] = 0;
        bool f = dfs(i);
        for (int j = 1; j <= n; ++j) {
            if (usd[j] == tmr) ans[j] = f;
        }
    }

    for (int i = 1; i <= n; ++i) cout << ans[i];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}