#include <bits/stdc++.h>

using namespace std;

#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pll = pair<int, int>;
#define int ll

template<class A>
istream &operator >> (istream &in, ve<A> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}

template<class A>
ostream &operator << (ostream &out, ve<A> &a) {
    for (auto &x : a)
        out << x << ' ';
    return out << '\n';
}

struct mst {
    ve<ve<int>> t;
    int n;
    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r)/2;
        build(2*v+1, l, m, a);
        build(2*v+2,m, r, a);
        merge(all(t[2*v+1]), all(t[2*v+2]), back_inserter(t[v]));
    }
    int get(int v, int l, int r, int ql, int qr, int x) {
        if (l >= qr || ql >= r)
            return 0;
        if (ql <= l && r <= qr)
            return lower_bound(all(t[v]), x) - t[v].begin();
        int m = (l + r)/2;
        return get(2*v+1, l, m, ql, qr, x) + get(2*v+2, m, r, ql, qr, x);
    }
    int get(int l, int r, int x) {
        return get(0, 0, n, l, r, x);
    }
    int get2(int v, int l, int r, int ql, int qr, int x) {
        if (l >= qr || ql >= r)
            return 0;
        if (ql <= l && r <= qr)
            return (int)t[v].size() - (lower_bound(all(t[v]), x) - t[v].begin());
        int m = (l + r)/2;
        return get2(2*v+1, l, m, ql, qr, x) + get2(2*v+2, m, r, ql, qr, x);
    }
    int get2(int l, int r, int x) {
        return get2(0, 0, n, l, r, x);
    }
    mst (ve<int> &a) {
        n = a.size();
        t.resize(4*n);
        build(0, 0, n, a);
    }
};

int32_t main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    ve<ve<int>> a(n, ve<int>(m));
    cin >> a;
    ve<mst> t;
    for (int i = 0; i < n; ++i)
        t.pb(mst(a[i]));
    ve<mst> t2;
    for (int j = 0; j < m; ++j) {
        ve<int> q;
        for (int i = 0; i < n; ++i)
            q.pb(a[i][j]);
        t2.pb(mst(q));
    }

    ve<ve<int>> dp(n+1, ve<int>(m+1, 1e18));
    ve<ve<int>> cnt1(n+1, ve<int>(m+1, 0)), cnt2(n+1, ve<int>(m+1, 0));

    dp[n-1][m-1] = 0;
    for (int i = 0; i < m; ++i)
        dp[n][i] = 0;
    for (int i = 0; i < n; ++i)
        dp[i][m] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            int nw = cnt1[i][j+1] + t[i].get(j+1, m, a[i][j]);
            if ((m - j) >= (n - i)) {
                for (int k = i+1; k < n; ++k) {
                    nw += t[i].get2(j, m, a[k][j]);
                }
            } else {
                for (int k = j; k < m; ++k) {
                    nw += t2[j].get(i+1, n, a[i][k]);
                }
            }
            for (int k = i + 1; k < n; ++k)
                nw += t[k].get(j+1, m, a[i][j]);
            cnt1[i][j] = nw;
            if (j != m - 1) {
                dp[i][j] = min(dp[i][j], cnt1[i][j]+dp[i+1][j]);
            }
            nw = cnt2[i+1][j] + t2[j].get(i+1, n, a[i][j]);
            if ((m - j) >= (n - i)) {
                for (int k = i; k < n; ++k) {
                    nw += t[i].get(j+1, m, a[k][j]);
                }
            } else {
                for (int k = j+1; k < m; ++k) {
                    nw += t2[j].get2(i, n, a[i][k]);
                }
            }
            for (int k = i + 1; k < n; ++k)
                nw += t[k].get(j+1, m, a[i][j]);
            cnt2[i][j] = nw;
            if (i != n - 1) {
                dp[i][j] = min(dp[i][j], cnt2[i][j] + dp[i][j+1]);
            }
        }
    }
    // cout << cnt1 << cnt2 << dp;
    cout << dp[0][0];
}
