#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
// #define int ll

struct Kocka {
    int x;
    int y;
    int i;
};

int n;
ll r;

ll dist(Kocka a, Kocka b) {
    return ll(a.x - b.x) * (a.x - b.x) + ll(a.y - b.y) * (a.y - b.y);
}

vector<vector<int> > g;
vector<int> ans;
vector<int> pos;
vector<vector<bool> > used;

void ok(int s) {
    vector<pair<int, int> > tm;
    tm.emplace_back(s, 0);
    used[0][s] = 1;
    int flag = 0;
    vector<int> kek;
    while (!tm.empty()) {
        auto [v, p] = tm.back();
        kek.push_back(v);
        tm.pop_back();
        if (v == s && p == 1) {
            flag = 1;
        }
        for (auto u: g[v]) {
            if (!used[p ^ 1][u]) {
                used[p ^ 1][u] = 1;
                tm.emplace_back(u, p ^ 1);
            }
        }
    }
    for (auto v: kek)
        ans[v] = flag;
}

void solve() {
    cin >> n >> r;
    g.resize(n);
    ans.resize(n);
    used.resize(2, vector<bool>(n));
    r *= r;
    vector<Kocka> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].i = i;
        for (int j = 0; j < i && g[i].size() < 100; j++) {
            if (dist(a[i], a[j]) <= r) {
                g[i].emplace_back(j);
                g[j].emplace_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[0][i] && !used[1][i])
            ok(i);
        cout << ans[i];
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    solve();
}
