#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, q; cin >> n >> q;
    vector <pair<int, int>> a;
    {
        char c; cin >> c;
        a.emplace_back(c == '1', 1);
        for (int i = 1; i < n; ++i) {
            cin >> c;
            int x = (c == '1');
            if (x == a.back().first) ++a.back().second;
            else a.emplace_back(x, 1);
        }
    }
    int cnt0 = 0;
    int cnt1 = 0;
    for (auto [c, cnt]: a) if (!c) cnt0 += cnt;
    for (auto [c, cnt]: a) if (c && cnt > 1) cnt1 += cnt;
    int A = 0;
    vector <pair<int, int>> stack;
    for (auto [c, cnt]: a) {
        if (c == 1) {
            if (!stack.empty() && cnt == 1 && stack.back().first == 2) {
                // ...0101<- 0...
                stack.pop_back();
                assert(!stack.empty());
                stack.back() = make_pair(1, 3);
                ++A;
            }
            else {
                stack.emplace_back(c, cnt);
            }
        }
        else {
            // c == 0
            const int t = (!stack.empty() && cnt == 1 && stack.back().second == 1);
            // ...010
            stack.emplace_back(c + 2 * t, cnt);
        }
        // for (auto [cc, cntcnt]: stack) cout << cc << " " << cntcnt << '\t'; cout << endl;
    }
    int B = count(stack.begin(), stack.end(), make_pair(1, 1));
    // cout << A << " " << B << " " << cnt0 << " " << cnt1 << endl;
    while (q--) {
        int k; cin >> k;
        if (cnt0 == n && k < 2) k = 0; // less than 1 block
        if (!k) {
            cout << cnt1 << "\n";
            continue;
        }
        if (k >= cnt0) {
            cout << n;
        }
        else if (k <= A) {
            cout << 3 * k + cnt1;
        }
        else if (k <= A + B) {
            cout << 3 * A + (k - A) * 2 + cnt1;
        }
        else {
            cout << 3 * A + 2 * B + (k - A - B) + cnt1;
        }
        cout << "\n";
    }
    return 0;
}