#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll MAXN = 1e6;
const ll MOD = 1e9 + 7;
const ll INF = 1e9;
mt19937 rnd(3);
vector<vector<int> > used;
vector<vector<int> > graph;

void dfs(ll v, ll p) {
    used[v][p] = 1;
    for (auto u: graph[v]) {
        if (used[u][(p + 1) % 2] == 0) {
            dfs(u, (p + 1) % 2);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, r, a, b;
    cin >> n >> r;
    vector<pair<ll, ll> > arr;
    used.resize(n, {0, 0});
    graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        arr.push_back({a, b});
    }
    sort(arr.begin(),arr.end());
    ll vl = 0;
    ll vr = 1;
    for (int i = 0;i<n;i++) {
        while (true) {
            if (vr < n) {
                if (arr[vr].first - arr[i].first <= r) {
                    vr ++;
                }
                else {
                    break;
                }
            }
            else {
                break;
            }
        }
        while (true) {
            if (vl < i) {
                if (arr[i].first - arr[vl].first > r) {
                    vl ++;
                }
                else {
                    break;
                }
            }
            else {
                break;
            }
        }
        for (int j = vl;j<vr;j++) {
            if (j != i && (arr[j].first - arr[i].first)*(arr[j].first - arr[i].first) + (arr[j].second - arr[i].second)*(arr[j].second - arr[i].second) <= r*r) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][0] == 0 && used[i][1] == 0) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][1] == 1 && used[i][0] == 1) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    return 0;
}
