#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll MAXN = 1e6;
const ll MOD = 1e9 + 7;
const ll INF = 1e9;
mt19937 rnd(3);
vector<vector<int> > used;
vector<vector<int> > graph;

void dfs(ll v, ll p) {
    used[v][p] = 1;
    for (auto u: graph[v]) {
        if (used[u][(p + 1) % 2] == 0) {
            dfs(u, (p + 1) % 2);
        }
    }
}

unordered_map<ll, int> per;

int main() {
    ll n, r, a, b;
    cin >> n >> r;
    vector<pair<ll, ll> > arr;
    used.resize(n, {0, 0});
    graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        arr.push_back({a, b});
        per[a * INF + b] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        for (ll x = max(ll(0), arr[i].first - 10); x <= arr[i].first + 10; x++) {
            for (ll y = max(ll(0), arr[i].second - 10); y <= arr[i].second + 10; y++) {
                if ((x != arr[i].first || y != arr[i].second) &&((x-arr[i].first)*(x-arr[i].first) + (y-arr[i].second)*(y-arr[i].second) <= r*r) && per.find(x*INF+y) != per.end()) {
                    graph[i].push_back(per[x * INF + y] - 1);
                    graph[per[x * INF + y] - 1].push_back(i);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][0] == 0 && used[i][1] == 0) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][1] == 1 && used[i][0] == 1) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    return 0;
}