#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll MAXN = 1e6;
const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 7;
mt19937 rnd(1);
ll tree[MAXN * 4];

void update(ll v, ll vl, ll vr, ll i, ll val) {
    if (i < vl || i >= vr) {
        return;
    }
    if (vl + 1 == vr) {
        tree[v] += val;
        return;
    }
    ll vm = (vl + vr) / 2;
    update(v * 2, vl, vm, i, val);
    update(v * 2+1, vm, vr, i, val);
    tree[v] = tree[v*2] + tree[v*2+1];
}
ll get(ll v,ll vl,ll vr,ll l,ll r) {
    if (l >= vr || r <= vl) {
        return 0;
    }
    if (l <= vl && vr <= r) {
        return tree[v];
    }
    ll vm = (vl + vr) / 2;
    return get(v*2,vl,vm,l,r) + get(v*2+1,vm,vr,l,r);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, a, cnt1, cnt2;
    cin >> n >> m;
    ll arr[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> arr[i][j];
        }
    }
    ll res = 0;
    for (int i = 0; i < m; i++) {
        res += get(1,0,n*m+1,arr[0][i],n*m+1);
        update(1,0,n*m+1,arr[0][i],1);
    }
    cout << res << "\n";
    return 0;
}
