#include <bits/stdc++.h>
using namespace std;
const int N = 100001;
int vst[2][N];
int r;
vector<int> x, y;
map<pair<int, int>, set<int>> n0, n1;
bool check(int i, int j) {
    if (i == j) return false;
    return (long long)(x[i] - x[j]) * (x[i] - x[j]) + (long long)(y[i] - y[j]) * (y[i] - y[j]) <= (long long)r * r;
}
void dfs(int v, int p) {
    vst[p][v] = 1;

    if (p == 0) {
        int qx = x[v] / r;
        int qy = y[v] / r;
        while (true) {
            int q = -1;
            for (int x = -1; x <= 1; x++) {
                for (int y = -1; y <= 1; y++) {
                    set<int>& ans = n1[{qx + x, qy + y}];
                    for (auto z : ans) {
                        if (check(z, v)) {
                            ans.erase(z);
                            q = z;
                            break;
                        }
                    }
                    if (q != -1) break;
                }
                if (q != -1) break;
            }
            if (q == -1) break;
            dfs(q, 1);
        }
    } else {
        int qx = x[v] / r;
        int qy = y[v] / r;
        while (true) {
            int q = -1;
            for (int x = -1; x <= 1; x++) {
                for (int y = -1; y <= 1; y++) {
                    set<int>& ans = n0[{qx + x, qy + y}];
                    for (auto z : ans) {
                        if (check(z, v)) {
                            ans.erase(z);
                            q = z;
                            break;
                        }
                    }
                    if (q != -1) break;
                }
                if (q != -1) break;
            }
            if (q == -1) break;
            dfs(q, 0);
        }
    }
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n >> r;
    x.resize(n); y.resize(n);
    for (int i = 0; i < n; i++) {
        n0[{x[i] / r, y[i] / r}].insert(i);
        n1[{x[i] / r, y[i] / r}].insert(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; i++) {
        if (!vst[0][i] && !vst[1][i]) {
            n0[{x[i] / r, y[i] / r}].erase(i);
           // n1[{x[i] / r, y[i] / r}].erase(i);
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (vst[0][i] && vst[1][i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}