#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

struct Point {
	int x, y, id;
};

bool cmp(Point& a, Point& b) {
	return a.x < b.x;
}

vector<Point> p;
int n, r;

vector<int> ans;

void solve() {
	cin >> n >> r;
	p.resize(n);

	for (int i = 0; i < n; ++i) {
		cin >> p[i].x >> p[i].y;
		p[i].id = i;
	}

	sort(all(p), cmp);

	ans.resize(n);
	for (int i = 0; i < n - 2; ++i) {
		if (p[i + 2].x - p[i].x <= r)
			ans[i] = ans[i + 1] = ans[i + 2] = 1;
	}

	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			int j = i - 1;
			while (j >= 0 and ans[j] != 1 and p[j + 1].x - p[j].x <= r) {
				ans[j] = true;
				j--;
			}
			j = i + 1;
			while (j < n and ans[j] != 1 and p[j].x - p[j - 1].x <= r) {
				ans[j] = true;
				j++;
			}
		}
	}

	vector<bool> anss(n);
	for (int i = 0; i < n; ++i) {
		if (ans[i])
			anss[p[i].id] = true;
	}

	for (auto i : anss) {
		if (i)
			cout << '1';
		else 
			cout << '0';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}