#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

void solve() {
	int r, c;
	cin >> r >> c;
	vector<vector<int>> a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}

	int ans = 1e9;
	
	for (int l = 0; l < (1 << r + c - 2); ++l) {
		int i = 0, j = 0;
		int cnt = 0;
		for (int ll = 0; ll < r + c; ++ll) {
			cnt = ((l >> ll) & 1 ? cnt + 1 : cnt);
		}
		if (cnt != r - 1)
			continue;

		int tmp_ans = 0;
		for (int ll = 0; ll < r + c; ++ll) {
			if ((l >> ll) & 1) {
				for (int q = j; q < c; ++q) {
					for (int w = q + 1; w < c; ++w) {
						if (a[i][q] > a[i][w])
							tmp_ans++;
					}
				}
				for (int q = i + 1; q < r; ++q) {
					for (int w = j; w < c; ++w) {
						for (int l = j; l < c; ++l) {
							if (a[q][w] < a[i][l])
								tmp_ans++;
						}
					}
				}
				i++;
			}
			else {
				for (int q = i; q < r; ++q) {
					for (int w = q + 1; w < r; ++w) {
						if (a[q][j] > a[w][j])
							tmp_ans++;
					}
				}
				for (int q = i; q < r; ++q) {
					for (int w = j + 1; w < c; ++w) {
						for (int l = i; l < r; ++l) {
							if (a[q][w] < a[l][j])
								tmp_ans++;
						}
					}
				}
				j++;
			}
		}

		ans = min(ans, tmp_ans);
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}