#include "bits/stdc++.h"

using namespace std;
using ll = long long;

struct HashPair {
    ll operator()(pair<ll, ll> a) const {
        return (a.first << 30) + a.second;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, r;
    cin >> n >> r;

    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    unordered_map<pair<int, int>, int, HashPair> id;
    for (int i = 0; i < n; ++i) {
        id[a[i]] = i;
    }

    vector<int> comp(n, -1);
    int good = 0;
    vector<int> can(n);
    vector<int> col(n);
    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) continue;
        deque<int> q = {i};
        col[i] = 1;
        comp[i] = i;
        bool flag = false;

        function<void(int)> dfs = [&](int v) {
            for (int di = -2; di <= 2; ++di) {
                for (int dj = -2; dj <= 2; ++dj) {
                    if (!id.contains({a[i].first + di, a[i].second + dj})) continue;
                    int u = id[{a[i].first + di, a[i].second + dj}];
                    if (u == v) continue;
                    ll dist = (a[u].first - a[v].first) * (a[u].first - a[v].first) +
                              (a[u].second - a[v].second) * (a[u].second - a[v].second);
                    if (dist > r * r) continue;
                    if (comp[u] != -1) {
                        flag |= col[u] == col[v];
                        continue;
                    }

                    col[u] = 3 - col[v];
                    comp[u] = comp[v];
                    dfs(u);
                }
            }

        };
        dfs(i);

        if (flag) {
            for (int j = 0; j < n; ++j) {
                if (comp[j] == comp[i]) can[j] = flag;
            }
        }
    }


    for (int i = 0; i < n; ++i) {
        cout << can[i];
    }
}

