#include <bits/stdc++.h>
#define ll long long
using namespace std;

int n, m;
vector<int> fen;

void add(int i)
{
    for(++i; i <= n*m; i = (i|(i - 1)) + 1){
        fen[i]++;
    }
}

int get(int i)
{
    int ans = 0;
    for(; i > 0; i = (i&(i - 1))){
        ans += fen[i];
    }
    return ans;
}

int main()
{
    cin >> n >> m;
    vector<vector<int>> a(n);
    vector<vector<ll>> bx(n), by(n), dp(n);
    for(int i = 0; i < n; ++i){
        a[i].resize(m);
        bx[i].resize(m);
        by[i].resize(m);
        dp[i].resize(m);
        for(int &x : a[i]){
            cin >> x;
            --x;
        }
    }
    fen.resize(n*m + 1);
    for(int h = 0; h < n; ++h){
        for(int i = 1; i <= n*m; ++i) fen[i] = 0;
        for(int j = m - 1; j >= 0; --j){
            ll inv = 0;
            for(int i = n - 1; i >= h; --i){
                inv += get(a[i][j]);
                add(a[i][j]);
            }
            bx[h][j] = inv;
        }
    }
    for(int w = 0; w < m; ++w){
        for(int i = 1; i <= n*m; ++i) fen[i] = 0;
        for(int i = n - 1; i >= 0; --i){
            ll inv = 0;
            for(int j = m - 1; j >= w; --j){
                inv += get(a[i][j]);
                add(a[i][j]);
            }
            by[i][w] = inv;
        }
    }
    for(int i = n - 1; i >= 0; --i) for(int j = m - 1; j >= 0; --j){
        if(i == n - 1 && j == m - 1) continue;
        dp[i][j] = 1e18;
        if(i < n - 1){
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + by[i][j]);
        }
        if(j < m - 1){
            dp[i][j] = min(dp[i][j], dp[i][j + 1] + bx[i][j]);
        }
    }
    cout << dp[0][0] << endl;
}