#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>
 
#include <functional>
 
// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
 
 
void solve() {
    int n, q;
    cin >> n >> q;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vi ans_g(3, n + 1);
    int cur = 0;
    vi suf(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    for (int i = 0; i < n - 2; ++i) {
        cur = max(cur, a[i]);
        vi ans;
        ans.pb(cur);
        if (a[i + 1] == suf[i + 1]) {
            ans.pb(a[i + 1]);
            ans.pb(a.back());
        } else {
            ans.pb(a[i + 1]);
            ans.pb(suf[i + 1]);
        }
        for (int j = 0; j < 3; ++j) {
            if (ans[j] < ans_g[j]) {
                ans_g = ans;
                break;
            } else if (ans[j] > ans_g[j]) {
                break;
            }
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans_g[i - 1] << '\n';
    }
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}