#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#endif

using namespace std;

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr),ios_base::sync_with_stdio(false);
#endif
    int r,c;
    cin >> r >> c;
    vector <vector <int>> a(r, vector <int> (c));
    for (int i = 0; i < r; i++)
        for (int j = 0; j < c; j++)
            cin >> a[i][j];
    vector <int> order;
    for (int i = 0; i < r; i++) order.push_back(0);
    for (int i = 0; i < c; i++) order.push_back(1);
    vector <int> b;
    vector <vector <int>> used(r, vector<int> (c));
    int ans = INT_MAX;
    do {
        b.clear();
        used.assign(r, vector <int> (c,0));
        int pr = 0,pc = 0;
        for (int tp : order) {
            if (tp == 0) {
                for (int j = 0; j < c; j++) {
                    if (!used[pr][j]) {
                        b.push_back(a[pr][j]);
                        used[pr][j] = 1;
                    }
                }
                pr++;
            }else {
                for (int i = 0; i < r; i++) {
                    if (!used[i][pc]) {
                        b.push_back(a[i][pc]);
                        used[i][pc] = 1;
                    }
                }
                pc++;
            }
        }
        int cnt = 0;
        for (int i = 0; i < b.size(); i++) {
            for (int j = 0; j < i; j++)
                if (b[j] > b[i])
                    cnt++;
        }
        ans = min(ans, cnt);
    }while (next_permutation(all(order)));
    cout << ans;
    return 0;
}
