#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("bmi,bmi2,avx2,lzcnt,popcnt")

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) a.size()
#define ce cout<<'\n'

struct point{
    int x,y;
};

int dist(point a,point b){
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

void dfs(int ps,int d,vector<char>&used,vector<int>&deep,vector<int>&ans,vector<vector<int>>&G){
    used[ps]=1;
    deep[ps]=d;
    for(auto to:G[ps]){
        if(ans[ps]==1){
            ans[to]=1;
        }
        if(used[to]==0){
            dfs(to,d+1,used,deep,ans,G);
        }
        if(ans[to]==1){
            ans[ps]=1;
        }
        else{
            if(deep[to]!=-1 && (deep[to]-deep[ps])%2==0){
                ans[ps]=1;
            }
        }
    }
}

void solve(){
    int n,r;
    cin>>n>>r;
    vector<point>v(n);
    for(int i=0;i<n;i++){
        cin>>v[i].x>>v[i].y;
    }
    map<int,int>t;
    for(int i=0;i<n;i++){
        t[v[i].x+v[i].y*1e9]=i+1;
    }
    vector<vector<int>>G(n);
    vector<int>ans(n);
    vector<int>deep(n,-1);
    for(int i=0;i<n;i++){
        int s=0;
        for(int x=v[i].x-r;x<=v[i].x+r;x++){
            if(sz(G[i])>=6){
                break;
            }
            for(int y=v[i].y-r;y<=v[i].y+r;y++){
                if(sz(G[i])>=6){
                    break;
                }
                if(dist(v[i],{x,y})<=r*r && !(v[i].x==x && v[i].y==y)){
                    if(t[x+y*1e9]>0){
                        G[i].pb(t[x+y*1e9]-1);
                    }
                }
            }
        }
        if(sz(G[i])>=6){
            ans[i]=1;
        }
    }
    vector<char>used(n,0);
    for(int i=0;i<n;i++){
        if(used[i]==0){
            dfs(i,0,used,deep,ans,G);
        }
    }
    for(int i=0;i<n;i++){
        used[i]=0;
        deep[i]=-1;
    }
    for(int i=0;i<n;i++){
        if(used[i]==0 && ans[i]==1){
            dfs(i,0,used,deep,ans,G);
        }
    }
    for(int i=0;i<n;i++){
        cout<<ans[i];
    }
}

signed main(){
    ios::sync_with_stdio(0);cout.tie(0);cin.tie(0);
    solve();
}
/*
7 2
0 0
0 2
0 4
2 0
2 4
2 2
1 3


*/
