#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("bmi,bmi2,avx2,lzcnt,popcnt")

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) a.size()
#define ce cout<<'\n'


int LG=21;
int N=(1<<(LG));
vector<int>t(2*N,1e9);
vector<pair<int,int>>tmn(2*N,{1e9,1e9});
vector<int>tmx(2*N,-1);


void upd(int pos,int val){
    pos+=N;
    t[pos]=val;
    pos/=2;
    while(pos){
        t[pos]=min(t[pos*2],t[pos*2+1]);
        pos/=2;
    }
}


int get(int l,int r){
    l+=N;
    r+=N;
    int rec=1e9;
    while(l<=r){
        if(l%2){
            rec=min(rec,t[l]);
        }
        if(!(r%2)){
            rec=min(rec,t[r]);
        }
        l=(l+1)/2;
        r=(r-1)/2;
    }
    return rec;
}


void updmn(int pos,pair<int,int> val){
    pos+=N;
    tmn[pos]=val;
    pos/=2;
    while(pos){
        tmn[pos]=min(tmn[pos*2],tmn[pos*2+1]);
        pos/=2;
    }
}


pair<int,int> getmn(int l,int r){
    l+=N;
    r+=N;
    pair<int,int> rec={1e9,1e9};
    while(l<=r){
        if(l%2){
            rec=min(rec,tmn[l]);
        }
        if(!(r%2)){
            rec=min(rec,tmn[r]);
        }
        l=(l+1)/2;
        r=(r-1)/2;
    }
    return rec;
}


void updmx(int pos,int val){
    pos+=N;
    tmx[pos]=val;
    pos/=2;
    while(pos){
        tmx[pos]=max(tmx[pos*2],tmx[pos*2+1]);
        pos/=2;
    }
}


int getmx(int l,int r){
    l+=N;
    r+=N;
    int rec=-1;
    while(l<=r){
        if(l%2){
            rec=max(rec,tmx[l]);
        }
        if(!(r%2)){
            rec=max(rec,tmx[r]);
        }
        l=(l+1)/2;
        r=(r-1)/2;
    }
    return rec;
}


void get_ans(int n,int k,int pos,int ind,vector<int>&v,vector<int>&last,int stk,int stpos,map<int,vector<int>>&ans){
//    cout<<n<<" "<<k<<" "<<pos<<" "<<ind;ce;
    if(pos==1){
        if(k==1){
            ans[stk][stpos]=getmx(ind,n);
            return;
        }
        else{
            ans[stk][stpos]=v[ind];
            return;
        }
    }
    if(k==2){
        if(last[ind]<n){
            ans[stk][stpos]=getmx(ind,n);
            ans[stk][stpos-1]=v[ind];
            return;
        }
        else{
            ans[stk][stpos]=v[n-1];
            ans[stk][stpos-1]=v[ind];
            return;
        }
    }
    ans[stk][stpos-pos+1]=v[ind];
    if(v[ind]<v[ind+1]){
        get_ans(n,k-1,pos-1,ind+1,v,last,stk,stpos,ans);
        return;
    }
    if(ind+k>=n){
        get_ans(n,k-1,pos-1,ind+1,v,last,stk,stpos,ans);
        return;
    }
    int l=ind+1,r=min(last[ind],n-k+1);
    pair<int,int>t=getmn(l,r);
    get_ans(n,k-1,pos-1,t.second,v,last,stk,stpos,ans);
}


struct zap{
    int k,pos,ind;
};


bool operator< (zap a,zap b){
    if(a.k<b.k){
        return true;
    }
    if(a.k>b.k){
        return false;
    }
    if(a.pos<b.pos){
        return true;
    }
    return false;
}


void solve(){
    int n,q;
    cin>>n>>q;
    vector<int>v(n);
    for(int i=0;i<n;i++){
        cin>>v[i];
        updmn(i,{v[i],i});
        updmx(i,v[i]);
    }
    vector<int>last(n);
    map<int,vector<int>>ans;
    for(int i=n-1;i>=0;i--){
        last[i]=min(get(v[i],n),n);
        upd(v[i],i);
    }
    vector<zap>qua(q);
    for(int i=0;i<q;i++){
        cin>>qua[i].k>>qua[i].pos;
        qua[i].ind=i;
        if(sz(ans[qua[i].k])==0){
            ans[qua[i].k].resize(n+1);
        }
    }
    sort(all(qua));
    reverse(all(qua));
    vector<int>ct(q);
    for(int i=0;i<q;i++){
        if(ans[qua[i].k][qua[i].pos]==0){
            get_ans(n,qua[i].k,qua[i].pos,0,v,last,qua[i].k,qua[i].pos,ans);
        }
        ct[qua[i].ind]=ans[qua[i].k][qua[i].pos];
    }
    for(int i=0;i<q;i++){
        cout<<ct[i];ce;
    }
}

signed main(){
    ios::sync_with_stdio(0);cout.tie(0);cin.tie(0);
    solve();
}
/*
7 1
6 4 2 3 1 7 5
4 2


*/
