#pragma GCC optimize("O2")

#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1e4 + 31;

long long xs[MAXN];
long long ys[MAXN];
int was[MAXN];

vector<short> g[MAXN];

bool OK = 1;

int h[MAXN];
int col[MAXN];
int ans[MAXN];

void dfs(int v, int p = -1){
    was[v] = 1;
    for(auto to : g[v]){
        if(p == to) continue;
        if(was[to]){
            if(abs(h[to] - h[v]) % 2 == 0){
                OK = 1;
            }
            continue;
        }
        h[to] = h[v]+1;
        col[to] = col[v];
        dfs(to, v);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n, r;
    cin >> n >> r;
    for(int i = 0; i < n; i++){
        cin >> xs[i] >> ys[i];
    }
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            if((xs[i] - xs[j]) * (xs[i] - xs[j]) + (ys[i] - ys[j]) * (ys[i] - ys[j]) <= r*r){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(!was[i]){
            col[i] = i;
            OK = 0;
            dfs(i);
            ans[i] = OK;
        }
    }
    for(int i = 0; i < n; i++) cout << ans[col[i]];
}
