#pragma GCC optimize("O2")

#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 31;


long long xs[MAXN];
long long ys[MAXN];
int was[MAXN];

vector<int> g[MAXN];

bool OK = 1;

int h[MAXN];
int col[MAXN];
int ans[MAXN];

map<int, vector<pair<int, int>>> ord;



void dfs(int v, int p = -1){
    was[v] = 1;
    for(auto to : g[v]){
        if(p == to) continue;
        if(was[to]){
            if(abs(h[to] - h[v]) % 2 == 0){
                OK = 1;
            }
            continue;
        }
        h[to] = h[v]+1;
        col[to] = col[v];
        dfs(to, v);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n, r;
    cin >> n >> r;
    set<int> hx;
    for(int i = 0; i < n; i++){
        cin >> xs[i] >> ys[i];
        hx.insert(xs[i]);
        ord[xs[i]].push_back({ys[i], i});
    }
    for(auto x : hx){
        sort(ord[x].begin(), ord[x].end());
    }
    for(int i = 0; i < n; i++){
        for(int nx = xs[i] - r; nx <= xs[i] + r; nx++){
            int spos = lower_bound(ord[nx].begin(), ord[nx].end(), make_pair(ys[i], -1ll)) - ord[nx].begin();
            int pos = spos;
            while(pos < ord[nx].size()){
                int j = ord[nx][pos].second;
                if((xs[i] - xs[j]) * (xs[i] - xs[j]) + (ys[i] - ys[j]) * (ys[i] - ys[j]) <= r*r){
                    if(i != j) g[i].push_back(j);
                }
                else break;
                pos++;
            }
            pos = spos - 1;
            while(pos > -1){
                int j = ord[nx][pos].second;
                if((xs[i] - xs[j]) * (xs[i] - xs[j]) + (ys[i] - ys[j]) * (ys[i] - ys[j]) <= r*r){
                    if(i != j) g[i].push_back(j);
                }
                else break;
                pos--;
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(!was[i]){
            col[i] = i;
            OK = 0;
            dfs(i);
            ans[i] = OK;
        }
    }
    for(int i = 0; i < n; i++) cout << ans[col[i]];
}
