#include <bits/stdc++.h>
#define int long long
using namespace std;

void dfs_c(int v, vector<vector<int>> gr, int x, vector<int> &color, vector<int> &used) {
    color[v] = x;
    used[v] = true;
    for (auto u : gr[v]) {
        if (!used[u]) dfs_c(u, gr, x, color, used);
    }
}

bool ans = false;
void dfs(int v, vector<vector<int>> gr, vector<int> &in, int tek) {
    in[v] = tek;
    for (auto u : gr[v]) {
        if (in[u] == -1) dfs(u, gr, in, tek + 1);
        else {
            if ((in[v] + in[u]) % 2 == 0) ans = true;
        }
    }
}


void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
    }

    vector<vector<int>> gr(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int x1 = a[i].first;
            int y1 = a[i].second;
            int x2 = a[j].first;
            int y2 = a[j].second;
            if (abs(x2 - x1) * abs(x2 - x1) + abs(y2 - y1) * abs(y2 - y1) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    // for (int i = 0; i < n; i++) {
    //     cout << i << ": ";
    //     for (auto el : gr[i]) cout << el << ' ';
    //     cout << '\n';
    // }
    vector<int> color(n, -1);
    int tek = 0;
    for (int i = 0; i < n; i++) {
        if (color[i] == -1) {
            vector<int> used(n, 0);
            dfs_c(i, gr, tek, color, used);
            tek++;
        }
    }
    // cout << "colors:\n";
    // for (auto el : color) {
    //     cout << el << ' ';
    // }
    // cout << '\n';
    vector<int> checked(tek, -1);
    for (int i = 0; i < n; i++) {
        if (checked[color[i]] == -1) {
            vector<int> in(n, -1);
            dfs(i, gr, in, 0);
            if (ans) {
                checked[color[i]] = 1;
            }
            else {
                checked[color[i]] = 0;
            }
            ans = false;
        }

    }
    // for (auto el : checked) {
    //     cout << el << ' ';
    // }
    // cout << '\n';
    for (auto el : color) {
        cout << checked[el];
    }
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    while (t--) {
        solve();
    }
}
