#include <bits/stdc++.h>

using namespace std;

struct point {
    long long x, y;
    long long dist(const point& other) const {
        return (x - other.x) * (x - other.x) + (y - other.y) * (y - other.y);
    }
};

vector<int> col;
vector<vector<int>> v;
vector<int> used;
int f = 0;
void dfs(int x) {
    used.push_back(x);
    for (auto j : v[x]) {
        if (col[j] == -1) {
            col[j] = col[x] ^ 1;
            dfs(j);
        } else if (col[j] == col[x]) {
            f = 1;
        }
    }
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    long long n, r;
    cin >> n >> r;
    r *= r;
    vector<point> p;
    v.resize(n);
    col.resize(n, -1);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        p.push_back({x, y});
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (p[j].dist(p[i]) <= r) {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            col[i] = 0;
            dfs(i);
            for (auto j : used) {
                ans[j] = f;
            }
            used.clear();
            f = 0;
        }
    }
    for (auto i : ans) {
        cout << i;
    }
}