#include <bits/stdc++.h>

using namespace std;

struct cor {
    long long x;
    long long y;
    int ind;
};


bool comp(cor a, cor b) {
    return a.x < b.x;
}

bool check(long long r, int i, int j, vector <cor> v) {
    return (v[i].x - v[j].x) * (v[i].x - v[j].x) + (v[i].y - v[j].y) * (v[i].y - v[j].y) <= r * r;
}

bool dfs(vector <vector <int>>& g, long long r, int u, vector <cor>& v, vector <int>& used, int cnt, int col, vector <int>& colour) {
    used[u] = cnt;
    colour[u] = col;
    bool ans = false;
    for (int i : g[u]) {
        if (used[i] == 0) {
            col *= -1;
            if (dfs(g, r, i, v, used, cnt, col, colour)) {
                ans = true;
            }
            col *= -1;
        } else {
            if (colour[i] == colour[u] && i != u) {
                ans = true;
            }
        }
    }
    return ans;
}
int main()
{
    int n;
    long long r;
    cin >> n >> r;
    vector <cor> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].x >> v[i].y;
        v[i].ind = i;
    }
    sort(v.begin(), v.end(), comp);
    vector <vector <int>> g(n);
    for (int i = 0; i < n; ++i) {
        if (i > 1 && check(r, i, i - 2, v)) {
            g[v[i].ind].push_back(v[i - 2].ind);
            g[v[i - 2].ind].push_back(v[i].ind);
        }
        if (i > 0 && check(r, i, i - 1, v)) {
            g[v[i].ind].push_back(v[i - 1].ind);
            g[v[i - 1].ind].push_back(v[i].ind);
        }
        if (i < n - 1 && check(r, i, i + 1, v)) {
            g[v[i].ind].push_back(v[i + 1].ind);
            g[v[i + 1].ind].push_back(v[i].ind);
        }
        if (i < n - 2 && check(r, i, i + 2, v)) {
            g[v[i].ind].push_back(v[i + 2].ind);
            g[v[i + 2].ind].push_back(v[i].ind);
        }
    }
    vector <int> used(n);
    vector <int> c(n + 1);
    vector <int> colour(n);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            ++cnt;
            int col = 1;
            if (dfs(g, r, i, v, used, cnt, col, colour)) {
                c[cnt] = 1;
            } else {
                c[cnt] = 0;
            }
        }
    }
    string s;
    for (int i = 0; i < n; ++i) {
        s.push_back(char(c[used[i]] + 48));
    }
    cout << s;
    return 0;
}
