#include <bits/stdc++.h>

using namespace std;

long long sum_pref(int l, vector <long long>& t) {
    long long sum = 0;
    for (int i = l; i > 0; i -= (i & -i)) {
        sum += t[i];
    }
    return sum;
}
long long sum(int l, int r, vector <long long>& t) {
    return sum_pref(r, t) - sum_pref(l - 1, t);
}
void upd(long long x, int k, vector <long long>& t) {
    for (int i = k; i < t.size(); i += (i & -i)) {
        t[i] += x;
    }
}

long long inv(int r, int c, vector <int>& v) {
    vector <long long> t(r * c + 1);
    long long ans = 0;
    for (int j = 0; j < v.size(); ++j) {
        upd(1, v[j], t);
        ans += sum(v[j] + 1, r * c, t);
    }
    return ans;
}
int main()
{
    int r, c;
    cin >> r >> c;
    vector <vector <int>> v(r, vector <int> (c));
    vector <vector <int>> s(r, vector <int> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> v[i][j];
        }
    }
    vector <vector <pair <long long, vector <int>>>> dp(r + 1, vector <pair <long long, vector <int>>> (c + 1));
    for (int i = 0; i <= r; ++i) {
        for (int j = 0; j <= c; ++j) {
            if (i == 0 && j == 0) {
                dp[i][j].first = 0;
                continue;
            }
            long long a = 1e18, b = 1e18;
            vector <int> p1, p2;
            if (i != 0) {
                for (int o : dp[i - 1][j].second) {
                    p1.push_back(o);
                }
                for (int t = j; t < c; ++t) {
                    p1.push_back(v[i - 1][t]);
                }
                a = inv(r, c, p1);
            }
            if (j != 0) {
                for (int o : dp[i][j - 1].second) {
                    p2.push_back(o);
                }
                for (int t = i; t < r; ++t) {
                    p2.push_back(v[t][j - 1]);
                }
                b = inv(r, c, p2);
            }
            if (a < b) {
                dp[i][j].first = a;
                for (int o : p1) {
                    dp[i][j].second.push_back(o);
                }
            } else {
                dp[i][j].first = b;
                for (int o : p2) {
                    dp[i][j].second.push_back(o);
                }
            }
        }
    }
    long long min_iv = 1e18;
    for (int i = 0; i <= r; ++i) {
        min_iv = min(min_iv, dp[i][c].first);
    }
    for (int j = 0; j <= c; ++j) {
        min_iv = min(min_iv, dp[r][j].first);
    }
    cout << min_iv;
}
