#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll inf = 1e9;

struct node{
    ll x, k;
    node() {}
    node(ll x, ll k) : x(x), k(k) {}
};

vector<node> tree;
vector<ll> a;

node merge(node a, node b){
    node x;
    x.x = max(a.x, b.x);
    if (x.x == a.x){
        x.k = a.k;
    }
    else {
        x.k = b.k;
    }
    return x;
}

void build(ll v, ll l, ll r){
    if (l == r - 1){
        tree[v].x = a[l];
        tree[v].k = l;
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
}

node ask(ll v, ll l, ll r, ll askl, ll askr){
    //cout << l << " " << r << " " << '\n';
    if (l >= askr || r <= askl){
        return {-inf, -1};
    }
    if (l >= askl && r <= askr){
        return tree[v];
    }
    ll m = (l + r) / 2;
    return merge(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll n, q, cnt, k, x, y;
    cin >> n >> q;
    a.resize(n);
    tree.resize(4 * n);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
    //build(0, 0, n);
    vector<vector<ll>> b(n);
    b[0].resize(1);
    b[0][0] = n;
    for (int i = 1; i < min(n, 2ll); ++i){
        b[i].resize(i + 1);
        //b[0][0] = ask(0, 0, n, 0, n);
        if (i == 1){
            for (int j = 0; j < n - 1; ++j){
                if (b[i][0] > ask(0, 0, n, 0, j + 1).x || (b[i][0] == ask(0, 0, n, 0, j + 1).x && b[i][1] > ask(0, 0, n, j + 1, n).x)){
                    b[i][0] = ask(0, 0, n, 0, j + 1).x;
                    b[i][1] = ask(0, 0, n, j + 1, n).x;
                }
            }
        }
        //cout << i << " :::::::::: " << endl;
        /*cnt = 0;
        k = a[0];
        x = -1;
        for (int j = 1; j < n; ++j){
            //cout << cnt << " " << k << " " << x << " " << j << '\n';
            if (i - cnt == 0){
                k = max(k, a[j]);
                continue;
            }
            if (x == -1 || a[x] > a[j]){
                x = j;
            }
            if (i - cnt == n - j){
                cnt += 1;
                b[i][cnt - 1] = k;
                j = x;
                k = a[x];
                x = -1;
                continue;
            }
            if (k < a[j]){
                cnt += 1;
                b[i][cnt - 1] = k;
                j = x;
                k = a[x];
                x = -1;
            }
            //cout << cnt << " " << k << " " << x << " " << j << '\n';
        }
        b[i][i] = k;*/
    }
    for (int i = 0; i < q; ++i){
        /*for (int j = 0; j < i + 1; ++j){
            cout << i << " " << j << '\n';
            cout << b[i][j] << '\n';
        }*/
        cin >> k >> x;
        x -= 1;
        k -= 1;
        /*if (x != k){
            cout << a[x] << '\n';
        }
        else {
            //cout << " aaa " << " " << x << " " << n << '\n';
            cout << ask(0, 0, n, x, n).x << '\n';
        }*/
        cout << b[k][x] << '\n';
    }
    return 0;
}
