#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<pair<ll, ll>> a1;
    for (ll i = 0; i < n; i++) {
        a1.push_back({a[i].first, i});
    }
    sort(a1.begin(), a1.end());
    vector<ll> answer(n);
    for (ll i = 0; i < n; i++) {
        ll l1 = i;
        ll r1 = n;
        while (r1 - l1 > 1) {
            ll m = (l1 + r1) / 2;
            if (a1[m].first <= a1[i].first + r) {
                l1 = m;
            } else {
                r1 = m;
            }
        }
        if (l1 - i > 1) {
            answer[a1[i].second] = 1;
            continue;
        }
        l1 = 0;
        r1 = i;
        while (r1 - l1 > 1) {
            ll m = (l1 + r1) / 2;
            if (a1[m].first >= a1[i].first - r) {
                r1 = m;
            } else {
                l1 = m;
            }
        }
        if (i - r1 > 1) {
            answer[a1[i].second] = 1;
            continue;
        }
    }
    for (auto elem : answer) {
        cout << elem;
    }
}