#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

const ll maxn = 3 * 1e5;
ll t[4 * maxn];

void f(ll v, ll l, ll r, ll ind, ll x) {
    if (l == r - 1) {
        t[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    if (ind < m) {
        f(2 * v + 1, l, m, ind, x);
    } else {
        f(2 * v + 2, m, r, ind, x);
    }
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}

ll sum(ll v, ll l, ll r, ll l1, ll r1) {
    if (l >= r1 || r <= l1) {
        return 0;
    }
    if (l >= l1 && r <= r1) {
        return t[v];
    }
    ll m = (l + r) / 2;
    return sum(2 * v + 1, l, m, l1, r1) + sum(2 * v + 2, m, r, l1, r1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    ll answer = 0;
    for (ll i = 0; i < c; i++) {
        answer += sum(0, 0, maxn, a[0][i], maxn);
        f(0, 0, maxn, a[0][i], 1);
    }
    cout << answer;
}