#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll maxn = 1e5+5;
struct point {
    ll x= 0,y  = 0;
    point(){}
    point(ll x_, ll y_) : x(x_), y(y_){}
    ll len2() {
        return x*x + y*y;
    }
};

point operator - (point&a, point&b) {
    return point(a.x - b.x, a.y-b.y);
}
point operator + (point& a, point& b) {
    return point(a.x+b.x, a.y+b.y);
}


vector<vector<ll>> graph(maxn);
vector<bool> used(maxn);
vector<ll> col(maxn);
vector<ll> d(maxn);
vector<ll> gc(maxn, 0);
void dfs(ll v, ll c) {
    used[v] = 1;
    col[v] = c;
    for (auto e : graph[v]) {
        if (!used[e]) {
            d[e] = d[v]+1;
            dfs(e, c);
        } else {
            if ((d[v] - d[e]) % 2 == 0) {
                gc[c] = 1;
            }
        }
    }
}
bool cmp(pair<point, ll>& a, pair<point, ll>& b) {
    if(a.first.x == b.first.x) {
        return a.first.y < b.first.y;
    } else {
        return a.first.x < b.first.x;
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    vector<pair<point, ll>> a(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        a[i] = {point(x, y), i};
    }
    sort(a.begin(), a.end(), cmp);
    ll l = 0;
    vector<ll> pr(n);
    vector<bool> good(n);
    for (int i = 0; i < n; ++i) {
        while ((a[l].first-a[i].first).len2() > r*r) {
            l++;
        }
        if (l == i) {
            pr[i] = l;
        } else {
            pr[i] = pr[l];
        }
        if (i - l > 1) {
            good[pr[i]] = 1;
        }
    }
    vector<char> s(n);
    for (int i = 0; i < n; ++i) {
        s[a[i].second] = good[pr[i]] + '0';
    }
    for (auto e : s) {
        cout<<e;
    }

}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    // freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--){}
    solve();
    cout << '\n';

}

