#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
using namespace std;
#define ld long long
const int maxn = 1e5 + 1;
struct Point {
    int x,y;
    Point() {

    }
    Point (int x,int y):x(x),y(y){}
    Point operator-(Point a) {
        Point b(x,y);
        b.x -= a.x;
        b.y -= a.y;
        return b;
    }
    ld len2() {
        ld x2 = x;
        x2 *= x2;
        ld y2 = y;
        y2 *= y2;
        return x2 + y2;
    }
};
bool flag = 0;
vector <int>g[maxn];
vector <int> all_vert_now;
void check(int u,int color_now,vector <int> &color) {
    all_vert_now.push_back(u);
    color[u] = color_now;
    color_now = (1 + color_now)%2;
    for (auto el : g[u]) {
        if (color[el] == -1) {
            check(el,color_now,color);
        }else if (color[el] == color[u])flag = 1;
    }
}
bool cmp(pair<Point,int> &a,pair<Point,int> &b) {
    return a.first.x < b.first.x;
}
int bin(vector <pair<int,int>> &vec,int  need) {
    int l = -1,r = vec.size();
    while (r - l > 1) {
        int mid = (r+l)/2;
        if (vec[mid].first >= need)r = mid;
        else l = mid;
    }
    return r;
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    ld r;
    cin >> r;
    ld r2 = r * r;
    vector <pair<Point,int>> vec(n);
    unordered_map< int,vector <pair<int,int>>>m;
    for (int i = 0;i < n;i++) {
        cin >> vec[i].first.x >> vec[i].first.y;
        vec[i].second = i;
        m[vec[i].first.x].push_back({vec[i].first.y,vec[i].second});
    }
    for (auto el : m) {
        sort(el.second.begin(),el.second.end());
    }
    for (auto el : m) {
        for (int i = 0;i < el.second.size();i++) {
            for (int j = i + 1;j <(int)el.second.size();j++) {
                if (abs(el.second[i].first - el.second[j].first) <= r) {
                    g[el.second[i].second].push_back(el.second[j].second);
                    g[el.second[j].second].push_back(el.second[i].second);
                }else {
                    break;
                }
            }
        }
        for (int j = el.first - r;j - el.first <= r;j++) {
            if (m.find(j) == m.end() || j == el.first)continue;
            int pos = 0;
            for (auto dot : el.second) {
                int pos1 = pos;

                while (pos < m[j].size()) {
                    pair<int,int> no = m[j][pos];
                    Point c(el.first,dot.first);
                    Point b(j,no.first);
                    c = c - b;
                    if (c.len2() <= r2) {
                        g[dot.second].push_back(no.second);
                        g[no.second].push_back(dot.second);
                    }else if (no.first < dot.first) {
                        pos1 = pos;
                    }else if (no.first > dot.first)break;
                    pos++;
                }
                pos = pos1;
            }
        }

    }
    vector <int> color(n,-1);
    vector <bool> ans(n,0);
    for (int i = 0;i < n;i++) {
        if (color[i] == -1) {
            flag = 0;
            all_vert_now.clear();
            check(i,0,color);
            if (flag) {
                for (auto el : all_vert_now)ans[el] = 1;
            }
        }
    }
    for (auto el : ans)cout << el;
}