#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
using namespace std;
#define int long long

int ans = 1e9;
vector <int> buf;
int give_cnt_inv(int r,int c,vector <vector <int>> &matr) {
    int i = 0,j = 0;
    vector <int> vec;
    for(auto el : buf) {
        if (el == 1) {
            for (int k = j;k < c;k++)vec.push_back(matr[i][k]);
            i++;
        }else {
            for (int k = i;k < r;k++) {
                vec.push_back(matr[k][j]);
            }
            j++;
        }
    }
    int cnt = 0;
    for (int i = 0;i < r * c;i++) {
        for (int j = i + 1;j < r * c;j++) {
            if (vec[i] > vec[j]) {
                cnt++;
            }
        }
    }
    return cnt;
}
void bt(int cnt1,int cnt2,int r,int c,vector <vector <int>> &matr) {
    if (cnt1 == r || cnt2 == c) {
        ans = min(ans,give_cnt_inv(r,c,matr));
        return;
    }
    buf.push_back(1);
    bt(cnt1+1,cnt2,r,c,matr);
    buf.pop_back();
    buf.push_back(2);
    bt(cnt1,cnt2+1,r,c,matr);
    buf.pop_back();
}
struct node {
    vector <int> tree;
    node (int n) {
        tree = vector <int> (4 * n);
    }
    void upd(int u,int l,int r,int pos) {
        if (r - l == 1) {
            tree[u]++;
            return;
        }
        int mid = (r+l)/2;
        if (mid <= pos) {
            upd(u*2+2,mid,r,pos);
        }else {
            upd(u*2+1,l,mid,pos);
        }
        tree[u] = tree[u*2+1] + tree[u*2+2];
    }
    int get(int u,int l,int r,int pos) {
        if (r - l == 1)return 0;
        int mid = (r+l)/2;
        if (mid <= pos) {
            return get(u*2+2,mid,r,pos);
        }else {
            return get(u*2+1,l,mid,pos) + tree[u*2+2];
        }
    }
};
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int r,c;
    cin >> r >> c;
    vector <int> vec(c);
    for (int i = 0;i < c;i++)cin >> vec[i];
    int cnt = 0;
    node seg(c+1);
    for (int i = 0;i < c;i++) {
        cnt += seg.get(0,0,c+1,vec[i]);
        seg.upd(0,0,c+1,vec[i]);
    }

    cout << cnt;
}