#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define ld long long
const int maxn = 1e5 + 1;
struct Point {
    int x,y;
    Point() {

    }
    Point (int x,int y):x(x),y(y){}
    Point operator-(Point a) {
        Point b(x,y);
        b.x -= a.x;
        b.y -= a.y;
        return b;
    }
    ld len2() {
        ld x2 = x;
        x2 *= x2;
        ld y2 = y;
        y2 *= y2;
        return x2 + y2;
    }
};
bool flag = 0;
vector <int>g[maxn];
vector <int> all_vert_now;
void check(int u,int color_now,vector <int> &color) {
    all_vert_now.push_back(u);
    color[u] = color_now;
    color_now = (1 + color_now)%2;
    for (auto el : g[u]) {
        if (color[el] == -1) {
            check(el,color_now,color);
        }else if (color[el] == color[u])flag = 1;
    }
}
bool cmp(pair<Point,int> &a,pair<Point,int> &b) {
    return a.first.x < b.first.x;
}
pair<int,int> solve(int n,vector <int> &vec) {
    int v1 = vec[0];
    int pos = 1;
    while (pos < n - 1 && vec[pos] < vec[0])pos++;
    int v2 = vec[pos++];
    while (pos < n) {
        v2 = max(v2,vec[pos++]);
    }
    return {v1,v2};
}
signed main() {
    int n,q;
    cin >> n >> q;
    vector <int> vec(n);
    for (int i = 0;i < n;i++)cin >> vec[i];
    int v1 = vec[0],v2,v3;
    int pos = 1;
    while (pos < n - 1 && vec[pos] < vec[0])pos++;
    if (pos == 1) {
        vector <int> newvec ;
        for (int i = 1;i < n;i++) {
            newvec.push_back((vec[i]));
        }
        auto ans = solve(n-1,newvec);
        v2 = ans.first;
        v3 = ans.second;
    }else {
        int pos1 = pos;
        v3 = vec[pos++];
        while (pos < n) {
            v3 = max(v3,vec[pos++]);
        }
        pos1--;
        v2 = vec[pos1];
        while (pos1 > 1 && vec[pos1] < v3) {
            pos1--;
            v2 = min(vec[pos1],v2);
        }
    }

    while (q--) {
        int k,i;
        cin >> k >> i;
        if (i == 1) {
            cout << v1 << "\n";
        }else if (i == 2){
            cout << v2 << "\n";
        }else {
            cout << v3 << "\n";
        }
    }
}