#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define ff first 
#define ss second
 
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
 
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}

ll n;
vector<pair<ll, ll>> a;
vector<vector<ll>> g;
vector<ll> colors;
void dfs(ll v, ll color) {
    colors[v] = color;
    for (ll u : g[v]) {
        if (colors[u] == -1) dfs(u, color);
    }
}
 
void Solve() {
    ll n, r;
    cin >> n >> r;
    a.resize(n);
    vector<pair<pair<ll, ll>, ll>> b(n);
    for (auto &x : a) cin >> x.ff >> x.ss;
    if (n == 2) {
        cout << "00\n";
        return;
    }
    for (int i = 0; i < n; ++i) b[i] = {a[i], i};
    sort(all(b));
    vector<pair<ll, ll>> c;
    for (ll x = -r; x <= r; ++x) {
        for (ll y = -r; y <= r; ++y) {
            if (!x && !y) continue;
            if (x * x + y * y > r * r) continue;
            c.push_back({x, y});
        }
    }
    g.resize(n * 2);
    for (int i = 0; i < n; ++i) {
        for (auto &[x, y] : c) {
            ll z = lower_bound(all(b), make_pair(make_pair(a[i].ff + x, a[i].ss + y), 0ll)) - b.begin();
            if (z == n) continue;
            if (b[z].ff.ff == x + a[i].ff && b[z].ff.ss == a[i].ss + y) {
                g[i].push_back(b[z].ss + n);
                g[b[z].ss + n].push_back(i);
            }
        }
    }
    colors.resize(n * 2, -1);
    ll color = 0;
    for (int i = 0; i < n * 2; ++i) {
        if (colors[i] == -1) dfs(i, ++color);
    }
    //cout<<colors<<'\n';
    for (int i = 0; i < n; ++i) {
        cout << (colors[i] == colors[i + n]);
    }
    
}
 
 
int main() {
    Solve();
}