#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define ff first 
#define ss second

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}

void Solve() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    for (auto &x : a) cin >> x.ff >> x.ss;
    if (n == 2) {
        cout << "00\n";
        return;
    }
    vector<pair<ll, ll>> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = {a[i].ff, i};
    }
    sort(all(p));
    vector<bool> ans(n, 0);
    for (int i = 0; i < n; ++i) {
        if (i >= 2) {
            if (p[i].ff - p[i - 2].ff <= r) ans[p[i].ss] = 1;
        }
        if (i < n - 2) {
            if (p[i + 2].ff - p[i].ff <= r) ans[p[i].ss] = 1;
        }
        if (i >= 1 && i < n - 1) {
            if (p[i + 1].ff - p[i - 1].ff <= r) ans[p[i].ss] = 1;
        }
    }
    for (int i = 0; i < n; ++i) cout << ans[i];
}


int main() {
    Solve();
}