#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define ff first 
#define ss second
 
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
 
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
   for (T &x : a) in >> x;
   return in;
}
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
   for (T &x : a) out << x << ' ';
   return out;
}

void Solve() {
   ll n, q;
   cin >> n >> q;
   vector<ll> a(n);
   cin >> a;
   vector<ll> m(n);
   m[n - 1] = a[n - 1];
   for (int i = n - 2; i >= 0; --i) m[i] = max(a[i], m[i + 1]);
   while (q--) {
      ll k, i;
      cin >> k >> i;
      --i;
      if (i < k - 1) cout << a[i] << '\n';
      else {
         cout << m[i] << '\n';
      }
   }
}
 
 
int main() {
   Solve();
}