#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

const int inf = 1'000'000'000;

using ll = long long;

struct zzz{
    int x;
    int y;
    int ind;
};

int r;

bool check(zzz a, zzz b){
    return ((((ll)a.x - b.x) * (a.x - b.x) + ((ll)a.y - b.y) * (a.y - b.y)) <= (ll)r * r);
}

bool operator<(zzz a, zzz b){
    if(a.y != b.y){
        return (a.y < b.y);
    }else{
        return (a.x < b.x);
    }
}

bool cmp(zzz a, zzz b){
    if(a.x != b.x){
        return (a.x < b.x);
    }else{
        return (a.y < b.y);
    }
}

vector<set<int>> v;

vector<int> c;
vector<int> used;
int cc = 0;

void dfs1(int u){
    used[u] = 1;
    c[u] = cc;
    for(auto i : v[u]){
        if(!used[i]){
            dfs1(i);
        }
    }
}

vector<int> col;

void dfs2(int u){
    used[u] = 1;
    for(auto i : v[u]){
        if(!used[i]){
            col[i] = 1 - col[u];
            dfs2(i);
        }
    }
}

void solve(){
    int n;
    cin >> n >> r;
    vector<zzz> a(n); 
    c.resize(n);
    col.resize(n);
    v.resize(n);
    for(int i = 0; i < n; i++){
        cin >> a[i].x >> a[i].y;
        a[i].ind = i;
    }
    sort(a.begin(), a.end(), cmp);
    int now = 0;
    set<zzz> s;
    vector<pair<int, int>> reb;
    for(auto [x, y, ind] : a){
        while(a[now].x + r < x){
            s.erase(a[now]);
            now++;
        }
        auto it = s.lower_bound({-1, y - r, -1});
        while((it != s.end()) && (it->y <= y + r) && (v[ind].size() < 6)){
            if(check(*it, {x, y, ind})){
                v[it->ind].insert(ind);
                v[ind].insert(it->ind);
                reb.emplace_back(ind, it->ind);
            }
            it++;
        }
        s.insert({x, y, ind});
    }
    reverse(a.begin(), a.end());
    now = 0;
    s.clear();
    for(auto [x, y, ind] : a){
        while(a[now].x + r < x){
            s.erase(a[now]);
            now++;
        }
        auto it = s.lower_bound({-1, y - r, -1});
        while((it != s.end()) && (it->y <= y + r) && (v[ind].size() < 6)){
            if(check(*it, {x, y, ind})){
                v[it->ind].insert(ind);
                v[ind].insert(it->ind);
                reb.emplace_back(ind, it->ind);
            }
            it++;
        }
        s.insert({x, y, ind});
    }
    used.clear();
    used.resize(n);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs1(i);
            cc++;
        }
    }
    used.clear();
    used.resize(n);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs2(i);
        }
    }
    vector<int> ci(cc);
    for(int i = 0; i < n; i++){
        if(v[i].size() >= 6){
            ci[c[i]] = 1;
        }
    }
    for(auto [x, y] : reb){
        //cout << x << " " << y << endl;
        if(col[x] == col[y]){
            ci[c[x]] = 1;
        }
    }
    for(int i = 0; i < n; i++){
        cout << ci[c[i]];
    }
    cout << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}