#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

struct P {
    int x, y;
};

int n, r;
vector<int> used;
vector<P> cord;
vector<vector<int>> g;

bool dfs(int v, int c) {
    used[v] = c;
    bool f = false;
    for (auto & i : g[v]) {
        if (i == v) continue;
        if (!used[i]) {
            if (c % 2 == 1) c++;
            else c--;
            f = f | dfs(i, c);
            if (c % 2 == 1) c++;
            else c--;
        } else if (used[i] == c) {
            f = true;
        }
    }
    return f;
}

signed main() {
    cin >> n >> r;
    r *= r;
    map<pair<int, int>, int> ist;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        cord.push_back({x, y});
        ist[{x, y}] = i + 1;
    }
    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = -10; j <= 10; j++) {
            for (int k = -10; k <= 10; k++) {
                if (j * j + k * k > r) continue;
                int ind = ist[{cord[i].x + j, cord[i].y + k}];
                if (ind > 0 && ind != i) {
                    g[i].push_back(ind - 1);
                }
            }
        }
    }
    used.resize(n, 0);
    int c = 1;
    vector<int> ans(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bool f = dfs(i, c);
            if (f) {
                for (int j = 0; j < n; j++) {
                    if (used[j] == c || used[j] == c + 1) {
                        ans[j] = 1;
                    }
                }
            }
            c += 2;
        }
    }
    for (auto & el : ans) {
        cout << el;
    }
}