#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

struct P {
    int x, y;
};

int n, r;
vector<int> used;
vector<P> cord;
vector<pair<int, int>> d;
set<array<int, 3>> s;

bool dfs(int v, int c) {
    used[v] = c;
    bool f = false;
    for (auto & [j, k] : d) {
        auto it = s.lower_bound({cord[v].x + j, cord[v].y + k, -1});
        if (it == s.end()) continue;
        array<int, 3> b = *it;
        if (b[0] != cord[v].x + j || b[1] != cord[v].y + k || b[2] == v) continue;
        int i = b[2];
        if (!used[i]) {
            if (c % 2 == 1) c++;
            else c--;
            f = f | dfs(i, c);
            if (c % 2 == 1) c++;
            else c--;
        } else if (used[i] == c) {
            f = true;
        }
    }
    return f;
}

signed main() {
    cin >> n >> r;
    r *= r;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        cord.push_back({x, y});
        s.insert({x, y, i});
    }
    for (int i = -10; i <= 10; i++) {
        for (int j = -10; j <= 10; j++) {
            if (i * i + j * j <= r) d.push_back({i, j});
        }
    }
    used.resize(n, 0);
    int c = 1;
    vector<int> ans(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bool f = dfs(i, c);
            if (f) {
                for (int j = 0; j < n; j++) {
                    if (used[j] == c || used[j] == c + 1) {
                        ans[j] = 1;
                    }
                }
            }
            c += 2;
        }
    }
    for (auto & el : ans) {
        cout << el;
    }
}