#include <bits/stdc++.h>

using namespace std;

#pragma optimize("O3,avx,avx2,bmi,bmi2,unroll-loops")

//#define int long long

int inf = 1000 * 1000 * 1000;

struct st {
    vector <int> t;

    void build(vector <int> &a) {
        int n = a.size();
        t.resize(4 * n);
        build2(0, 0, n - 1, a);
    }

    void build2(int v, int l, int r, vector <int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build2(v * 2 + 1, l, m, a);
        build2(v * 2 + 2, m + 1, r, a);
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return -inf;
        }
        if (l == ll && r == rr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return max(get(v * 2 + 1, l, m, ll, min(m, rr)), get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr));
    }

    int get(int l, int r) {
        return get(0, 0, t.size() / 4 - 1, l, r);
    }
};

struct st2 {
    int c = 13;
    vector <int> p;
    vector <vector <int>> t;
    vector <int> a2;

    int merge(int i, int j) {
        if (a2[i] > a2[j]) {
            return j;
        }
        return i;
    }

    void build(vector <int> a) {
        p.resize(1000 * 4 + 1);
        p[1] = 0;
        for (int i = 2; i < p.size(); i ++) {
            p[i] = p[i / 2] + 1;
        }
        int n = a.size();
        t.resize(c, vector <int> (n));
        for (int i = 0; i < n; i ++) {
            t[0][i] = i;
        }

        a2 = a;

        for (int i = 1; i < c; i ++) {
            for (int j = 0; j < n; j ++) {
                if (j + (1 << (i - 1)) >= n) {
                    t[i][j] = t[i - 1][j];
                }
                else {
                    t[i][j] = merge(t[i - 1][j], t[i - 1][j + (1 << (i - 1))]);
                }
            }
        }
    }

    int get(int l, int r) {
        int k = p[r - l + 1];
        return merge(t[k][l], t[k][r - (1 << k) + 1]);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    for (int i = 0; i < n; i ++) {
        cin >> a[i];
    }

    vector <int> pref_mx(n);
    pref_mx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i --) {
        pref_mx[i] = max(pref_mx[i + 1], a[i]);
    }

    for (int i = 0; i < q; i ++) {
        int k, ind;
        cin >> k >> ind;
        ind --;

        if (ind == k - 1) {
            if (k % 2 == 0) {
                cout << pref_mx[k - 1] << '\n';
            }
            else {
                cout << a[n - 1] << '\n';
            }
        }
        else {
            cout << a[ind] << '\n';
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}