#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

// #define int long long
using namespace std;
using pii = pair<int, int>;
using ll = long long;

struct Point {
    ll x, y;
};

ll dist(Point a, Point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<int> used;
vector<vector<int>> g;
vector<bool> res;

bool dfs(int v, int cnt=0) {
    used[v] = cnt;

    bool flag = false;
    for (auto u : g[v]) {
        if (!used[u]) {
            if (dfs(u, cnt + 1)) {
                flag = true;
            }
        } else if (used[u] % 2 == used[v] % 2) {
            flag = true;
        }
    }

    if (flag) {
        res[v - 1] = true;
    }
    return flag;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    ll n, r;
    cin >> n >> r;
    ll R = r * r;
    vector<Point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }

    g.resize(n + 1);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (dist(a[i], a[j]) <= R) {
                g[i + 1].push_back(j + 1);
                g[j + 1].push_back(i + 1);
            }
        }
    }

    used.resize(n + 1);
    res.resize(n);
    for (int i = 0; i < n; i++) {
        if (res[i]) continue;
        used.clear();
        used.resize(n + 1);
        if (dfs(i + 1)) {
            res[i] = true;
        } else {
            res[i] = false;
        }
    }

    for (auto i : res) cout << i;
}
