#include <bits/stdc++.h>
using namespace std;
#define int long long

struct dot {
    int x,y;
};

int dist(const dot &a, const dot &b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

const int MAXN=1e5+5;
int n,r,ans[MAXN];
dot dots[MAXN];
vector<int> g[MAXN];
vector<int> visited;
char used[MAXN];

void dfs(int v) {
    used[v]=true;
    visited.push_back(v);
    for (auto u : g[v]) {
        if (used[u]) {
            vector<int> cycle;
            for (int i=visited.size()-1;i>=0;--i) {
                if (visited[i]!=u) cycle.push_back(visited[i]);
                else {
                    cycle.push_back(u);
                    break;
                }
            }
            if (cycle.size()%2==1 && cycle.size()>1) {
                for (auto vert : cycle) ans[vert]=1;
            }
            continue;
        }
        dfs(u);
    }
    visited.pop_back();
}

void solve() {
    cin>>n>>r;
    fill(ans, ans+n, 0);
    fill(used, used+n, false);
    for (int i=0;i<n;++i) cin>>dots[i].x>>dots[i].y;
    for (int i=0;i<n;++i) {
        for (int j=i+1;j<n;++j) {
            if (dist(dots[i],dots[j])<=r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    // int edg; cin>>edg;
    // while (edg--) {
    //     int u,v; cin>>u>>v; u--; v--;
    //     g[u].push_back(v);
    //     g[v].push_back(u);
    // }
    for (int i=0;i<n;++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (int i=0;i<n;++i) cout<<ans[i];
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}