#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+5;
int ans[MAXN];

struct dsu {
    vector<int> p,rank;
    vector<char> good;
    void build(int n) {
        p.assign(n,0);
        rank.assign(n,1);
        good.assign(n,false);
        for (int i=0;i<n;++i) {
            p[i]=i;
        }
    }
    int find(int x) {
        int r=x;
        while (p[r]!=r) r=p[r];
        int i=x;
        while (p[i]!=r) {
            int j=p[i];
            p[i]=r;
            i=j;
        }
        return r;
    }
    void unite(int x, int y) {
        x=find(x);
        y=find(y);
        if (x==y) return;
        if (rank[x]>rank[y]) {
            p[y]=x;
            rank[x]+=rank[y];
        }
        else {
            p[x]=y;
            rank[y]+=rank[x];
        }
    }
    bool is_good(int x) {
        return good[find(x)];
    }
    void set_good(int x) {
        good[find(x)]=true;
    }
};

int n,r;
pair<int,int> a[MAXN];
void solve() {
    cin>>n>>r;
    for (int i=0;i<n;++i) {
        cin>>a[i].first;
        int temp; cin>>temp;
        a[i].second=i;
    }
    sort(a, a+n);
    dsu D; D.build(n);
    for (int i=0;i<n-1;++i) {
        if (a[i+1].first-a[i].first<=r) D.unite(i, i+1);
    }
    for (int i=0;i+2<n;++i) {
        if (a[i+2].first-a[i].first<=r) D.set_good(i);
    }
    for (int i=0;i<n;++i) {
        ans[a[i].second]=D.is_good(i);
    }
    for (int i=0;i<n;++i) {
        cout<<ans[i];
    }
}
//Превышено ограничение по времени, тест 151

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}