#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using pii = pair<int, int>;
 
const int inf = 1e9 + 52;

struct Point {
    int x, y;
};
 
ll r2;
 
bool check(Point a, Point b) {
    ll rst = (a.x - b.x) * 1ll * (a.x - b.x);
    rst += (b.y - a.y) * 1ll * (b.y - a.y);
    return rst <= r2;
}
vector<vector<int>> gr;
 
int ans = 1;
vector<int> clr;
 
void dfs(int v, int c) {
    //cout << v << endl;
    clr[v] = c;
    for (int u: gr[v]) {
        if (!clr[u]) {
            dfs(u, 3 - c);
        }
        else if (clr[v] == clr[u]) {
            ans = 0;
        }
    }
}
 
vector<int> used;
 
void bld(int v, int c) {
    used[v] = c;
    for (int u: gr[v]) {
        if (!used[u])
            bld(u, c);
    }
}

ll hsh(Point a) {
    return a.x * 1ll * inf + a.y;
}

Point unhsh(ll hs) {
    return {(hs / inf), (hs % inf)};
}
 
signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n, r;
    cin >> n >> r;
    r2 = r * 1ll * r;
    unordered_set<ll> a;
    map<ll, int> g;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.insert(hsh({x, y}));
        g[hsh({x, y})] = i;
    }
    gr.resize(n);
    for (ll i: a) {
        Point nw = unhsh(i);
        for (int x = -10; x <= 10; x++) {
            for (int y = 1; y <= 10; y++) {
                if (a.count(hsh({nw.x + x, nw.y + y}))) {
                    if (check(nw, {nw.x + x, nw.y + y})) {
                        gr[g[i]].push_back(g[hsh({nw.x + x, nw.y + y})]);
                        gr[g[hsh({nw.x + x, nw.y + y})]].push_back(g[i]);
                        //cout << g[i] << " " << g[hsh({nw.x + x, nw.y + y})] << endl;
                    }
                }

            }
        }
        for (int x = 1; x <= 10; x++) {
            if (a.count(hsh({nw.x + x, nw.y}))) {
                if (check(nw, {nw.x + x, nw.y })) {
                    gr[g[i]].push_back(g[hsh({nw.x + x, nw.y })]);
                    gr[g[hsh({nw.x + x, nw.y})]].push_back(g[i]);
                   // cout << g[i] << " " << g[hsh({nw.x + x, nw.y })] << endl;
                }
            }
        }
    }
 
    clr.assign(n, 0);
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!clr[i]) {
            ans = 1;
            dfs(i, 1);
            bld(i, 2 - ans);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << used[i] - 1;
    }
    cout << endl;
}