#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;


signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(n, vector<int>(m, 0));
    // dp[n - 1][i]
    for (int i = 0; i < m; i++) {
        for (int p1 = m - 1; p1 >= i; p1--) {
            for (int p2 = m - 1; p2 > p1; p2--) {
                if (a[n - 1][p2] < a[n - 1][p1])
                    dp[n - 1][i]++;
            }
        }
    }
    //dp[i][m - 1]
    for (int i = 0; i < n; i++) {
        for (int p1 = n - 1; p1 >= i; p1--) {
            for (int p2 = n - 1; p2 > p1; p2--) {
                if (a[p2][m - 1] < a[p1][m - 1])
                    dp[i][m - 1]++;
            }
        }
    }
    //dp[i][j]
    for (int i = n - 2; i >= 0; i--) {
        for (int j = m - 2; j >= 0; j--) {
            int cnt1 = 0;
            //dp[i]
            for (int p1 = n - 1; p1 >= i; p1--) {
                for (int p2 = n - 1; p2 > p1; p2--) {
                    if (a[p2][j] < a[p1][j])
                        cnt1++;
                }
            }

            for (int p1 = n - 1; p1 >= i; p1--) {
                for (int x = n - 1; x >= i; x--) {
                    for (int y = m - 1; y > j; y--) {
                        if (a[p1][j] > a[x][y])
                            cnt1++;
                    }
                }
            }

            int cnt2 = 0;
            //dp[i]
            for (int p1 = m - 1; p1 >= j; p1--) {
                for (int p2 = m - 1; p2 >= p1; p2--) {
                    if (a[i][p2] < a[i][p1])
                        cnt2++;
                }
            }

            for (int p1 = m - 1; p1 >= j; p1--) {
                for (int x = n - 1; x > i; x--) {
                    for (int y = m - 1; y >= j; y--) {
                        if (a[i][p1] > a[x][y])
                            cnt2++;
                    }
                }
            }
            // if (j == 1) {
            //     cout << cnt1 << " " << dp[i + 1][j] << " " << cnt2 << " " << dp[i][j + 1] << endl;
            // }
            dp[i][j] = min(dp[i + 1][j] + cnt1, dp[i][j + 1] + cnt2);
        }
    }
    //cout << dp[0][1] << " " << dp[0][2] << endl;
    cout << dp[0][0] << endl;
}
