#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

ll dist2(pair<ll, ll> p1, pair<ll, ll> p2) {
    return (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second);
}

int n;
ll r;
pair<ll, ll> p[10000];
pair<int, int> used[10000];

int dfs(int cur, int start, int col) {
    used[cur] = {col, start};

    int a = 0;
    for (int v = 0; v < n; ++v) {
        if (v == cur) continue;
        if (dist2(p[v], p[cur]) > r * r) continue;
        if (used[v].first == 0) {
            a += dfs(v, start, col ^ 1);
        } else if (used[v].first == col) {
            a += 1;
        }
    }
    return a > 0;
}

void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    int ans[n];

    for (int i = 0; i < n; ++i) {
        if (used[i].first == 0) {
            ans[i] = dfs(i, i, 3);
            cout << ans[i];
        } else {
            cout << ans[used[i].second];
        }
    }
}
