#include <bits/stdc++.h>

using namespace std;
//#define int long long

bool flag = false;
vector<char> ans;
vector<int> nw;

void dfs(int v, int c, vector<int>& used, vector<vector<bool>>& g) {
    nw.push_back(v);
    used[v] = c;
    for (auto u : g[v]) {
        if (used[u] == 3 - c) {
            continue;
        }
        if (used[u] == c) {
            flag = true;
            continue;
        }
        dfs(u, 3 - c, used, g);
    }
    if (flag) {
        ans[v] = '1';
    }
}

void solve() {
    long long n, r;
    cin >> n >> r;
    vector<pair<long long, long long>> coords(n);
    vector<vector<bool>> g(10000, vector<bool>(10000));
    for (int i = 0; i < n; i++) {
        cin >> coords[i].first >> coords[i].second;
        for (int j = 0; j < i; j++) {
            if ((coords[i].first - coords[j].first) * (coords[i].first - coords[j].first) + (coords[i].second - coords[j].second) * (coords[i].second - coords[j].second) <= r * r) {
                g[i][j] = true;
                g[j][i] = true;
            }
        }
    }
    ans.resize(n, '0');
    vector<int> used(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, 1, used, g);
            if (flag) {
                for (auto e : nw) {
                    ans[e] = '1';
                }
            }
            flag = false;
            nw.clear();
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
