#define _CRT_SECURE_NO_WARNINGS



#include <iostream>
#include <cmath>
#include <algorithm>
#include<string>
#include<vector>
#include<set>

using namespace std;
using ll=long long;
const ll inf = 1e18;



ll a[300001];

struct segtree {
	ll lb, rb;
	ll sum = 0;
	segtree* l = 0, *r = 0;
	segtree(ll lb, ll rb) :lb(lb), rb(rb) {
		if (lb < rb) {
			ll m = lb + (rb - lb) / 2;
			l = new segtree(lb, m);
			r = new segtree(m + 1, rb);
		}
	}
	void upd(ll lq, ll rq, ll val) {
		if (min(rb, rq) < max(lb, lq)) {
			return;
		}
		if (lb >= lq && rb <= rq) {
			sum += val;
			return;
		}
		l->upd(lq, rq, val);
		r->upd(lq, rq, val);
		sum = l->sum + r->sum;
	}
	ll get(ll lq, ll rq) {
		if (min(rb, rq) < max(lb, lq)) {
			return 0;
		}
		if (lb >= lq && rb <= rq) {
			return sum;
		}
		return l->get(lq, rq) + r->get(lq, rq);
	}
};
ll pos[300001];
int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pos[a[i]] = i;
	}
	if (a[1] == n) {
		ll ans1 = n;
		ll ans2 = n;
		ll ans3=0;
		if (pos[1] != n) {
			ans2 = 1;
			for (int i = pos[1] + 1; i <= n; ++i) {
				ans3 = max(ans3, a[i]);
			}
		}
		else {
			ans2 = 2;
			for (int i = pos[2] + 1; i <= n; ++i) {
				ans3 = max(ans3, a[i]);
			}
		}
		

		for (int i = 1; i <= q; ++i) {
			ll k, j;
			cin >> k >> j;
			if (j == 1) {
				cout << a[1] << "\n";
			}
			if (j == 2) {
				cout << ans2 << "\n";
			}
			if (j == 3) {
				cout << ans3 << "\n";
			}
		}
		return(0);
	}
	if (a[1] == n - 1) {
		ll ans1 = n - 1;
		ll ans2 = n;
		ll ans3 = 0;
		if (pos[n] != 2) {
			for (int i = 2; i < pos[n]; ++i) {
				ans2 = min(ans2, a[i]);
			}
			ans3 = n;
		}
		else {
			ans2 = n;
			ans3 = a[n];
		}
		for (int i = 1; i <= q; ++i) {
			ll k, j;
			cin >> k >> j;
			if (j == 1) {
				cout << a[1] << "\n";
			}
			if (j == 2) {
				cout << ans2 << "\n";
			}
			if (j == 3) {
				cout << ans3 << "\n";
			}
		}
		return(0);
	}
	ll r = 1;
	while (r < n && a[r + 1] <= a[1]) {
		++r;
	}
	ll ans1 = a[1];
	ll ans2 = 0;
	ll ans3 = 0;
	ll r2 = r + 1;
	while (r2 < n && a[r2 + 1] <= a[r+1]) {
		++r2;
	}
	ans2 = a[r + 1];
	if (r2 == n) {
		ans3 = a[n];
	}
	else {
		for (int i = r2 + 1; i <= n; ++i) {
			ans3 = max(ans3, a[i]);
		}
	}
	for (int i = 1; i <= q; ++i) {
		ll k, j;
		cin >> k >> j;
		if (j == 1) {
			cout << a[1] << "\n";
		}
		if (j == 2) {
			cout << ans2 << "\n";
		}
		if (j == 3) {
			cout << ans3 << "\n";
		}
	}
	return(0);
}