#include <bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

// #define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
const int N = 1e5;
int n, r, ans[N], used[N], dist[N];
pair<int, int> a[N];
vector<pair<int,int> > zap;
vector<int> g[N];
multiset<pair<int,int> > st;
map<int, vector<pair<int,int> > > mp;

bool d(int i, int j) {
    int x = abs(a[i].first - a[j].first), y = abs(a[i].second - a[j].second);
    return (ll) x * x + (ll) y * y <= (ll) r * r;
}

void dfs(int v) {
    used[v] = 2;
    ans[v] = 1;
    for (auto to: g[v]) {
        if (used[to] == 0) {
            dfs(to);
        }
    }
}

void bfs(int s) {
    deque<int> deq = {s};
    vector<int> vec = {s};
    dist[s] = 0;
    while (!deq.empty()) {
        int v = deq[0];
        deq.pop_front();
        for (auto to: g[v]) {
            if (dist[to] == -1) {
                dist[to] = dist[v] + 1;
                vec.emplace_back(to);
                deq.emplace_back(to);
            }
        }
    }
    int ok = 0;
    for (auto v: vec) {
        for (auto to: g[v]) {
            if (dist[v] == dist[to]) {
                ok = 1;
                break;
            }
        }
        if (ok) {
            break;
        }
    }
    if (ok) {
        dfs(s);
    } else {
        for (auto v: vec) {
            used[v] = 1;
        }
    }
}

void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        zap.emplace_back(a[i].first + r, i);
        zap.emplace_back(a[i].first, -i - 1);
    }
    sort(all(zap));
    for (auto [x1, pos]: zap) {
        while (!mp.empty() && mp.begin()->first < x1) {
            for (auto it: mp.begin()->second) {
                st.extract(it);
            }
            mp.erase(mp.begin());
        }
        if (pos < 0) {
            pos = -(pos + 1);
        }
        auto [x, y] = a[pos];
        if (x1 == x) {
            st.insert({y, pos});
            mp[x + 2 * r].emplace_back(y, pos);
        } else {
            vector<int> vec;
            for (auto it = st.lower_bound({y - r, -1}); it != st.end() && it->first <= y + r; ++it) {
                auto [y1, pos1] = *it;
                if (pos == pos1) {
                    continue;
                }
                if (d(pos, pos1)) {
                    for (auto ites: vec) {
                        if (d(ites, pos1)) {
                            ans[pos] = 1;
                            break;
                        }
                    }
                    vec.emplace_back(pos1);
                }
                if (ans[pos] == 1) {
                    break;
                }
            }
            if (ans[pos] == 0) {
                for (auto it: vec) {
                    g[it].emplace_back(pos);
                    g[pos].emplace_back(it);
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0 && ans[i] == 1) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        dist[i] = -1;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            bfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
