#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<pair<ll, ll>> q;
vector<array<ll, 2>> used;
ll n, r;

bool qwe(ll i, ll j) {
    ll s = (q[i].first - q[j].first) * (q[i].first - q[j].first) + (q[i].second - q[j].second) * (q[i].second - q[j].second);
    return s <= r * r;
}

void dfs(ll i, ll h) {
    used[i][h] = 1;
    //cout << i << " " << h << endl;
    for (int j = 0; j < n; j++) {
        if (i == j) continue;
        if (qwe(i, j) && !used[j][1 - h]) {
            dfs(j, 1 - h);
        }
    }
}

void solve() {
    cin >> n >> r;
    q.resize(n);
    used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> q[i].first >> q[i].second;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i][0] && !used[i][1]) dfs(i, 0);
    }
    for (int i = 0; i < n; i++) {
        if (used[i][0] && used[i][1]) cout << 1;
        else cout << 0;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    //cin >> t;
    while (t--) solve();
}
