#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> kol1(r, vector<ll> (c + 1));
    for (int i = 0; i < r; i++) {
        for (int j = c - 1; j > -1; j--) {
            kol1[i][j] = kol1[i][j + 1];
            for (int k = j + 1; k < c; k++) {
                if (a[i][j] > a[i][k]) kol1[i][j]++;
            }
        }
    }
    vector<vector<ll>> kol2(r + 1, vector<ll> (c));
    for (int j = 0; j < c; j++) {
        for (int i = r - 1; i > -1; i--) {
            kol2[i][j] = kol2[i + 1][j];
            for (int k = i + 1; k < r; k++) {
                if (a[i][j] > a[k][j]) kol2[i][j]++;
            }
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll> (c + 1));
    for (int i = r - 1; i > -1; i--) {
        vector<ll> q1;
        vector<ll> q2;
        for (int j = c - 1; j > -1; j--) {
            ll a1 = kol1[i][j], a2 = kol2[i][j];
            for (int i1 = i + 1; i1 < r; i1++) {
                q1.push_back(a[i1][j]);
            }
            sort(all(q1));
            for (int j1 = j; j1 < c; j1++) {
                a1 += lower_bound(all(q1), a[i][j1]) - q1.begin();
            }
            for (int i1 = i; i1 < r; i1++) {
                for (int j1 = j + 1; j1 <= min((ll)j + 1, c - 1); j1++) {
                    q2.push_back(a[i1][j1]);
                }
            }
            sort(all(q2));
            for (int i1 = i; i1 < r; i1++) {
                a2 += lower_bound(all(q2), a[i1][j]) - q2.begin();
            }
            dp[i][j] = min(a1 + dp[i + 1][j], a2 + dp[i][j + 1]);
        }
    }
    cout << dp[0][0] << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    //cin >> t;
    while (t--) solve();
}
