#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define popb pop_back
#define pf push_front
#define popf pop_front
#define ins insert
#define ers erase
#define endl '\n'
constexpr int INF = 1e18;
constexpr int mod = 1e9 + 7;

struct point {
    int x,y;
    point () {}
    point (int x,int y): x(x), y(y) {}

};

long double dist2 (point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
int n,r;
vector < point > a;
unordered_map <int ,unordered_map < int, int > > mp;
vector < int > get_j (int i) {
    vector < int > ans;
    for (int x = a[i].x - r; x <= r + a[i].x; x++) {
        for (int y = a[i].y - r; y <= r + a[i].y; y++) {
            if (dist2(a[i],point(x,y)) <= r * r) {

                if (mp[x][y] != 0) {
                    //cout << x << " " << y << endl;
                    ans.pb(mp[x][y] - 1);
                    if (ans.back() == i) ans.popb();
                }
            }
        }
    }
    return ans;
}


void solve () {
    cin >> n >> r;
    a = vector < point > (n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        mp[a[i].x][a[i].y] = i + 1;
    }
    if (n == 2) {
        cout << "00" << endl;
        return ;
    }
    // get_j(0);
    // return ;
    vector < int > deg(n);
    for (int i = 0; i < n; ++i) {
        for (auto j: get_j(i)) {
            if (dist2(a[i],a[j]) <= r * r) {
                deg[i]++;
                deg[j]++;
            }
        }
    }
    vector < list < int > > g(n);
    for (int i = 0; i < n; ++i) {
        for (auto j: get_j(i)) {
            if (dist2(a[i],a[j]) <= r * r) {
                if (deg[i] < deg[j]) {
                    g[i].pb(j);
                } else {
                    g[j].pb(i);
                }
            }
        }
    }
    vector < int > used(n);
    vector < int > type(n);
    for (int i = 0; i < n; i++) {
        for (auto j: g[i]) {
            used[j] = 1;
        }
        for (auto j: g[i]) {
            if (type[i] == 1) {
                break;
            }
            if (type[j] == 1) {
                type[i] = 1;
                break;
            }
            for (auto k: g[j]) {
                if (used[k]) {
                    type[i] = type[j] = type[k] = 1;
                    break;
                }
            }
        }
        for (auto j: g[i]) {
            used[j] = 0;
        }
    }

    list < int > q;
    for (int i = 0; i < n; ++i) {
        if (type[i]) q.pb(i);
    }

    while (!q.empty()) {
        int i = q.front();
        q.pop_front();
        for (auto j: get_j(i)) {
            if (dist2(a[i],a[j]) <= r * r && type[j] == 0) {
                type[j] = 1;
                q.pb(j);
            }
        }
    }
    for (auto i: type) {
        cout << i;
    }

    cout << endl;
}
signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve ();
    return 0;
}