#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n, q;
    cin >> n >> q;
    vector <int> v(n);
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        v[i] = c - '0';
        v[i] = (v[i] + 1) % 2;
    }

    vector <int> minsum(n + 1, n + 1);
    minsum[0] = 0;
    for (int i = 0; i < n; ++i) {
        int sum = 0;
        for (int j = i; j < n; ++j) {
            sum += v[j];
            minsum[j - i + 1] = min(minsum[j - i + 1], sum);
        }
    }

    auto f = [&] (int k) {
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (minsum[m] <= k) {
                l = m;
            } else {
                r = m;
            }
        }
        return l;
    };

    for (int i = 0; i < q; ++i) {
        int k;
        cin >> k;
        int ans = f(k);
        if (ans < 2) ans = 0;
        cout << ans << "\n";
    }
    return 0;
}
