#include <iostream>
#include <vector>

using namespace std;


long long sqr(long long a) {
    return a * a;
}
long long dist2(pair <long long, long long> a, pair <long long, long long> b) {
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

vector <vector <int>> g;
vector <int> color;
vector <int> used;
vector <int> can;

void dfs(int v, int cnt) {
    for (int u : g[v]) {
        if (used[u] == -1) {
            used[u] = cnt;
            color[u] = -color[v];
            dfs(u, cnt);
        } else if (color[u] == color[v]) {
            can[cnt] = 1;
        }
    }
}
int main()
{
    int n;
    long long r;
    cin >> n >> r;
    g.resize(n);
    vector <pair <long long, long long>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        for (int j = 0; j < i; ++j) {
            if (sqr(r) >= dist2(p[i], p[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    int cnt = 0;
    used.resize(n, -1);
    color.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            color[i] = 1;
            used[i] = cnt;
            can.push_back(0);
            dfs(i, cnt);
            cnt++;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << (can[used[i]]);
    }
    return 0;
}
