#include <bits/stdc++.h>

using namespace  std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    set<pair<ll, ll>> tec;
    ll cnt = 0;
    vector<ll> a(n);
    ll cc = 0;
    for (int i = 0; i < n; i++) {
        char x;
        cin >> x;
        if (x == '1') {
            cc++;
        }
        a[i] = x - '0';
    }

    if (cc == 0) {
        vector<ll> ans(n + 1);
        for (int i = 2; i <= n; i++) {
            ans[i] = i;
        }
        while (q--) {
            ll k;
            cin >> k;
            cout << ans[k] << '\n';
        }
        return;
    }

    vector<ll> used(n);
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            continue;
        }
        if (i - 1 >= 0 && a[i - 1] != 0) {
            cnt++;
            used[i] = 1;
            continue;
        }
        if (i + 1 < n && a[i + 1] != 0) {
            cnt++;
            used[i] = 1;
        }
    }

    vector<pair<ll, ll>> tt;
    vector<ll> ans(q);
    for (int i = 0; i < q; i++) {
        ll k;
        cin >> k;
        tt.emplace_back(k, i);
    }
    sort(tt.begin(), tt.end());

    vector<pair<ll, ll>> c;

    ll l = 0;
    vector<ll> use(n);

    while (l < n) {
        while (l < n && (a[l] == 0 || used[l])) {
            l++;
        }
        ll r = l;
        ll t = 1;
        while (r < n && a[r] == t && !used[r]) {
            r++;
            t++;
            t %= 2;
        }
        for (ll i = l + 1; i < r; i += 4) {
            ll cn = 1;
            if (i - 1 >= 0 && !used[i - 1] && a[i - 1] == 1) {
                used[i - 1] = 1;
                cn++;
            }
            if (i + 1 < n && !used[i + 1] && a[i + 1] == 1) {
                used[i + 1] = 1;
                cn++;
            }
            used[i] = 1;
            c.emplace_back(cn, i);
        }
        l = r;
    }

    for (int i = 0; i < n; i++) {
        if (a[i] != 0 || used[i]) {
            continue;
        }
        ll cn = 1;
        if (i - 1 >= 0 && !used[i - 1] && a[i - 1] == 1) {
            used[i - 1] = 1;
            cn++;
        }
        if (i + 1 < n && !used[i + 1] && a[i + 1] == 1) {
            used[i + 1] = 1;
            cn++;
        }
        if (cn == 2) {
            used[i] = 1;
            c.emplace_back(cn, i);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!used[i] && a[i] == 0) {
            c.emplace_back(1, i);
        }
    }


    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            c.emplace_back(1, i);
        }
    }

    ll ff = 0, idx = 0;
    for (auto [k, id] : tt) {
        while (ff < k && idx < c.size()) {
            cnt += c[idx].first;
            ff++;
            idx++;
        }
        ans[id] = cnt;
    }
    for (auto i : ans) {
        cout << i << '\n';
    }
}