#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> suf(n + 1);
    suf[n] = -INF;
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    vector<ll> rf(n - 1);
    vector<ll> st;
    for (int i = 0; i < n; i++) {
        while (!empty(st) && a[st.back()] < a[i]) {
            rf[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    vector<ll> b = {INF, INF, INF};
    ll mx = -INF;
    for (int i = 0; i < n - 1; i++) {
        mx = max(mx, a[i]);
        ll b1 = mx;
        ll b2 = a[i + 1];
        ll b3 = suf[rf[i + 1]];
        vector<ll> cur = {b1, b2, b3};
        b = min(b, cur);
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        cout << b[i - 1] << '\n';
    }
}
