#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937_64 rnd(52526969);

using ld = long double;

long double m_e = 2.7182818284590452354;

int calculate(vector<int> &move, vector<vector<int>> &v, int n, int m){
    int i = 0, j = 0;
    vector<int> res;
    res.reserve(n * m);
    int t = 0;
    while (t < move.size()){
        if (move[t] == 0){
            for (int jj = j; jj < m; ++jj){
                res.push_back(v[i][jj]);
            }
            ++i;
        }
        else{
            for (int ii = i; ii < n; ++ii){
                res.push_back(v[ii][j]);
            }
            ++j;
        }
        ++t;
    }
    int ans = 0;
    for (i = 0; i < res.size(); ++i){
        for (int j = i + 1; j < res.size(); ++j) {
            if (res[i] > res[j]) {
                ++ans;
            }
        }
    }
    return ans;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> v(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> v[i][j];
        }
    }
    int n1 = n, m1 = m;
    vector<int> move;
    while (n1 > 0 && m1 > 0){
        if (rnd() % 2 == 0){
            n1 -= 1;
            move.push_back(0);
        }
        else{
            m1 -= 1;
            move.push_back(1);
        }
    }
    int ans = calculate(move, v, n, m);
    int best = ans;
    for (int T = 35000; T > 0 && best != 0; T -= 1){
        int k = rnd() % (move.size());
        n1 = n, m1 = m;
        vector<int> new_move;
        int i = 0;
        while (n1 > 0 && m1 > 0){
            if (i < move.size()) {
                if ((i != k && move[i] == 0) || (i == k && move[i] == 1)){
                    n1 -= 1;
                    new_move.push_back(0);
                }
                else{
                    m1 -= 1;
                    new_move.push_back(1);
                }
                ++i;
            }
            else {
                if (rnd() % 2 == 0) {
                    n1 -= 1;
                    new_move.push_back(0);
                }
                else {
                    m1 -= 1;
                    new_move.push_back(1);
                }
            }
        }
        int ans2 = calculate(new_move, v, n, m);
        if (ans2 < ans){
            ans = ans2;
            swap(move, new_move);
        }
        best = min(ans, best);
        if (T % 1000 == 0) {
            shuffle(move.begin(), move.end(), mt19937_64(69695252));
        }
    }
    cout << best << '\n';
    return 0;
}