#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

using ll = long long;

int main() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> points(n);
    for (auto &&[x, y]: points) cin >> x >> y;
    vector<vector<ll>> g(n, vector<ll>());
    for (int i=0; i<n; ++i) {
        for (int j=i+1; j<n; ++j) {
            auto [x1, y1] = points[i];
            auto [x2, y2] = points[j];
            if ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) <= r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<ll> h(n, -1);
    vector<ll> cc(n, -1);
    vector<bool> cchol(n, false);
    ll ccn = 0;
    for (int i=0; i<n; ++i) {
        if (cc[i] != -1) continue;
        cc[i] = ++ccn;
        h[i] = 0;
        vector<ll> q;
        q.push_back(i);
        while(!q.empty()) {
            ll v = q.back();
            q.pop_back();
            for (auto u: g[v]) {
                if (h[u] == -1) {
                    h[u] = h[v]+1;
                    cc[u] = cc[v];
                    q.push_back(u);
                } else if ((h[u]+h[v])%2==0) {
                    cchol[cc[u]] = true;
                }
            }
        }
    }
    for (int i=0; i<n; ++i) {
        cout << cchol[cc[i]];
        cout.flush();
    }
    cout << endl;
}