#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> points(n);
    for (auto &&[x, y]: points) cin >> x >> y;
    bool ST5 = true;
    for (auto &&[x, y]: points) ST5 = ST5 && (y == 0);
    if (ST5) {
        vector<ll> xs;
        for (auto &&[x, y]: points) xs.push_back(x);
        sort(xs.begin(), xs.end());
        vector<bool> cool(n);
        for (int i=1; i+1<n; ++i) {
            if (cool[i]) continue;
            if (xs[i+1]-xs[i-1] <= r) {
                cool[i+1] = true;
                int j = i;
                while (j >= 0 && xs[j+1]-xs[j] <= r && !cool[j]) {
                    cool[j] = true;
                    j--;
                }
                j = i;
                while (j < n && xs[j+1] - xs[j] <= r && !cool[j]) {
                    cool[j] = true;
                    j++;
                }
            }
        }
        for (auto &&i: cool) cout << i;
        cout << endl;
        return 0;
    }
    vector<vector<ll>> g(n, vector<ll>());
    for (int i=0; i<n; ++i) {
        for (int j=i+1; j<n; ++j) {
            auto [x1, y1] = points[i];
            auto [x2, y2] = points[j];
            if ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) <= r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<ll> h(n, -1);
    vector<ll> cc(n, -1);
    vector<bool> cchol(n, false);
    ll ccn = 0;
    for (int i=0; i<n; ++i) {
        if (cc[i] != -1) continue;
        cc[i] = ++ccn;
        h[i] = 0;
        vector<ll> q;
        q.push_back(i);
        while(!q.empty()) {
            ll v = q.back();
            q.pop_back();
            for (auto u: g[v]) {
                if (h[u] == -1) {
                    h[u] = h[v]+1;
                    cc[u] = cc[v];
                    q.push_back(u);
                } else if ((h[u]+h[v])%2==0) {
                    cchol[cc[u]] = true;
                }
            }
        }
    }
    for (int i=0; i<n; ++i) {
        cout << cchol[cc[i]];
        cout.flush();
    }
    cout << endl;
}