#include<bits/stdc++.h>

using namespace std;

long long r;
long long dist(pair<int, int> a, pair<int, int> b) {
    return (long long) (a.first - b.first) * (a.first - b.first) + (long long) (a.second - b.second) * (a.second - b.second);
}

vector<vector<int>> g;
vector<int> c;
vector<bool> answers;
vector<int> comp;

bool is_good = true;

void dfs(int v) {
    comp.push_back(v);
    if (comp.size() > g.size()) {
        throw(0);
    }
    for (auto &i : g[v]) {
        if (c[i] == -1) {
            c[i] = 1 - c[v];
            dfs(i);
        } else {
            if (c[i] == c[v]) {
                is_good = false;
            }
        }
    }
}
int main() {
    int n;
    cin >> n >> r;
    c.resize(n, -1);
    g.resize(n);
    vector<pair<int, int>> a(n);
    for (auto &i : a) {
        cin >> i.first >> i.second;
    }
    vector<pair<pair<int, int>, int>> a_sorted;
    for (long long i = 0; i < n; i++) {
        a_sorted.push_back({a[i], i});
    }
    sort(a.begin(), a.end());
    answers.resize(n);
    for (long long i = 0; i < n; i++) {
        if (i - 1 >= 0 && i + 1 < n && dist(a_sorted[i - 1].first, a_sorted[i + 1].first) <= r * r) {
            answers[a_sorted[i].second] = 1;
            continue;
        }
        if (i - 2 >= 0 && dist(a_sorted[i - 2].first, a_sorted[i].first) <= r * r) {
            answers[a_sorted[i].second] = 1;
            continue;
        }
        if (i + 2 < n && dist(a_sorted[i].first, a_sorted[i + 2].first) <= r * r) {
            answers[a_sorted[i].second] = 1;
            continue;
        }
    }
    for (auto i : answers) {
        cout << i;
    }
}