#include <iostream>
#include <algorithm>
#include <vector>
#define pb push_back
// #define int long long
using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;
int timer = 0;
vector<vi> g;
vi comp;
vi bad;
vi used;
using ull = unsigned long long;
 
ull gh(pi x) {
    ull a= x.first;
    ull b= x.second;
 
    return (a << 31) | b;
}
 
void dfs(int v, int color) {
    used[v] = color;
    comp[v] = timer;
    for (int u : g[v]) {
        if ((used[u] == used[v])) {
            bad[comp[v]] = 1;
        } else if (used[u]) {
            continue;
        } else {
            dfs(u, 3 - color);
        }
    }
}
   
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
   
    ios_base::sync_with_stdio(0);
    cin.tie(0);
   
    ll n, r;
    cin >> n >> r;
     
 
    g.resize(n);
    // col.resize(n);
    used.resize(n);
    comp.resize(n);
    vector<pi> ps(n);
   
    for (int i = 0; i < n; ++i) cin >> ps[i].first >> ps[i].second;
    vector<pair<pi, int>> pss;

    for (int i = 0; i < n; ++i) pss.pb({ps[i], i});
    // map<pi, int> ids;
  
    sort(pss.begin(), pss.end());

    for (int i = 0; i < n; ++i) {
        auto [x, y] = ps[i];
  
        for (ll dx = -r; dx <= r; ++dx) {
            for (ll dy = -r; dy <= r; ++dy) {
                if (dx == dy && dx == 0) continue;
                if (dx * dx + dy * dy > r * r) continue;
                int xs = x + dx;
                int ys = y + dy;
                pi tt = {xs, ys};
                int l = -1;
                int r = n;

                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if (pss[mid].first <= tt) l = mid;
                    else r = mid;
                }
    
  
                if (l != -1 && pss[l].first == tt) {
                    int id = pss[l].second;
                    // cout << "i " << i << ' ' << id << endl;
                    g[i].pb(id);
                    // g[id].pb(i);
                } else {
                    // ids.erase(gh({xs, ys}));
                }
  
            }
        }
    }
   
    bad.assign(n, 0);
   
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 1);
            ++timer;
        }
    }
   
    for (int i = 0; i < n; ++i) {
        cout << bad[comp[i]];
    }
}