#include <iostream>
#include <vector>

using namespace std;

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n, q; cin >> n >> q;
    string s; cin >> s;
    int cnt0 = 0;
    bool otd[n] = {};
    for (int i = 1; i < n; ++i) {
        if (s[i] == '1' && s[i - 1] == '1') {
            if (!otd[i - 1]) {
                ++cnt0;
                otd[i - 1] = true;
            }
            ++cnt0;
            otd[i] = true;
        }
    }

    int used[n] = {};
    vector<int> temp;
    for (int i = 1; i < n - 1; ++i) {
        if (!used[i - 1] && !used[i] && !used[i + 1] &&
            !otd[i - 1] && !otd[i] && !otd[i + 1] &&
            s[i - 1] == '1' && s[i] == '0' && s[i + 1] == '1') {

            temp.push_back(3);
            used[i - 1] = used[i] = used[i + 1] = true;
        }
    }

    for (int i = 1; i < n; ++i) {
        if (!used[i - 1] && !used[i] &&
            !otd[i - 1] && !otd[i] &&
            ((s[i - 1] == '0' && s[i] == '1') || (s[i - 1] == '1' && s[i] == '0'))) {

            temp.push_back(2);
            used[i - 1] = used[i] = true;
        }
    }

    int prefsum[temp.size() + 1];
    prefsum[0] = 0;
    for (int i = 0; i < temp.size(); ++i)
        prefsum[i + 1] = prefsum[i] + temp[i];

    while (q--) {
        int c; cin >> c;
        if (!cnt0 && temp.empty())
            cout << (c > 1 ? c : 0) << '\n';
        else if (c > temp.size())
            cout << min(n, cnt0 + prefsum[temp.size()] + c - (int)temp.size()) << '\n';
        else
            cout << min(n, cnt0 + prefsum[c]) << '\n';
    }

    return 0;
}
