#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;
typedef long long ll;

int main() {
    int n, q; cin >> n >> q;
    int arr[n];
    for (int i = 0; i < n; ++i)
        cin >> arr[i];

    vector<int> dp[2];
    dp[0] = {*max_element(arr, arr + n)};
    dp[1] = {INT_MAX, INT_MAX};

    int pref[n + 1], suf[n + 1];
    pref[0] = suf[n] = 0;
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = max(pref[i], arr[i]);
        suf[n - i - 1] = max(suf[n - i], arr[n - i - 1]);
    }

    for (int i = 1; i < n; ++i)
        dp[1] = min(dp[1], {pref[i], suf[i]});

    while (q--) {
        int k, i; cin >> k >> i;
        cout << dp[k - 1][i - 1] << '\n';
    }

    return 0;
}
