#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

signed main() {
    int r, c;
    cin >> r >> c;
    vector<int> a(c), b(c);
    ordered_set<int> s1, s2;
    for (int i = 0; i < c; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < c; i++) {
        cin >> b[i];
    }
    int curr = 0;
    for (int i = 0; i < c; i++) {
        curr += i - s1.order_of_key(a[i]);
        s1.insert(a[i]);
    }
    for (int i = 0; i < c; i++) {
        curr += i - s2.order_of_key(b[i]);
        s2.insert(b[i]);
        curr += c - s1.order_of_key(b[i]);
    }
    int ans = curr;
    for (int i = 0; i < c; i++) {
        s1.erase(a[i]);
        curr -= sz(s1) - s1.order_of_key(b[i]);
        curr += s1.order_of_key(b[i]);
        ans = min(ans, curr);
    }
    cout << ans << endl;
    return 0;
}