#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

constexpr int inf = 1e18;

signed main() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> d(r, vector<int> (c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> d[i][j];
        }
    }
    vector<vector<int>> dp1(r, vector<int> (c, inf)), dp2(r, vector<int> (c, inf));
    dp1[0][0] = dp2[0][0] = 0;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < i; j++) {
            if (d[j][0] > d[i][0]) {
                dp1[0][0]++;
            }
        }
    }
    for (int i = 0; i < c; i++) {
        for (int j = 0; j < i; j++) {
            if (d[0][j] > d[0][i]) {
                dp2[0][0]++;
            }
        }
    }
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            if (i == 0 && j == 0) {
                continue;
            }
            if (i - 1 >= 0) {
                dp1[i][j] = dp2[i][j] = min(dp1[i][j], dp2[i - 1][j]);
            }
            if (j - 1 >= 0) {
                dp1[i][j] = dp2[i][j] = min(dp1[i][j], dp1[i][j - 1]);
            }
            for (int k = i; k < r; k++) {
                for (int z = i; z < k; z++) {
                    if (d[z][j] > d[k][j]) {
                        dp1[i][j]++;
                    }
                }
            }
            for (int k = j; k < c; k++) {
                for (int z = j; z < k; z++) {
                    if (d[i][z] > d[i][k]) {
                        dp2[i][j]++;
                    }
                }
            }
            // cout << dp1[i][j] << ' ' << dp2[i][j] << endl;
            vector<int> pref(r * c + 1);
            for (int k = 0; k < r; k++) {
                for (int z = 0; z < c; z++) {
                    if (k < i || z < j) {
                        pref[d[k][z]]++;
                    }
                }
            }
            for (int k = 1; k <= r * c; k++) {
                pref[k] += pref[k - 1];
            }
            for (int k = i; k < r; k++) {
                dp1[i][j] += pref[r * c] - pref[d[k][j]];
            }
            for (int k = j; k < c; k++) {
                dp2[i][j] += pref[r * c] - pref[d[i][k]];
            }
            // cout << i << ' ' << j << ' ' << dp1[i][j] << ' ' << dp2[i][j] << endl;
        }
    }
    cout << dp1[r - 1][c - 1] << endl;
    return 0;
}