#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int maxn = 3e5;
int a[maxn];
int nxt[maxn];

int get(int l, int r)
{
    return min_element(a + l, a + r + 1) - a;
}

void solve()
{
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = n - 1; i >= 0; --i) {
        nxt[i] = i + 1;
        while (nxt[i] < n && a[nxt[i]] <= a[i]) {
            nxt[i] = nxt[nxt[i]];
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        --i;
        int cur = 0;
        for (int j = 0; j < i; ++j) {
            int r = min(nxt[cur], n - k + j + 1);
            if (j + 2 != k)
                cur = get(cur + 1, r);
            else
                cur = r;
        }
        if (i + 1 == k) {
            cur = max_element(a + cur, a + n) - a;
        }
        cout << a[cur] << '\n';
    }
}

signed main()
{
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
#endif
    solve();
}