#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <bitset>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (auto& i : a)
	{
		cin >> i;
	}
	vector <int> mx(n);
	mx[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--)
	{
		mx[i] = max(mx[i + 1], a[i]);
	}
	for (size_t i = 0; i < q; i++)
	{
		int k, id;
		cin >> k >> id;
		if (k > id)
		{
			cout << a[id - 1] << '\n';
			continue;
		}
		if (k % 2 == 1)
			cout << a.back();
		else
			cout << mx[id - 1];
		cout << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
