#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

bool check(int x, int y, int r) {
    return (ll)x * x + (ll)y * y <= (ll)r * r;
}

const int MAXN = 1e5;

bool dp[2][MAXN];

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    map<pair<int, int>, int> d;
    vector<pair<int, int>> pt;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pt.push_back({x, i});
    }
    sort(all(pt));
    vector<bool> used(n), used2(n);
    deque<int> dq;
    for (int i = 1; i + 1 < n; i++) {
        if (pt[i + 1].first - pt[i - 1].first <= r) {
            used[i - 1] = 1;
            used[i] = 1;
            used[i + 1] = 1;
        }
    }
    while (!dq.empty()) {
        auto i = dq.front();
        dq.pop_front();
        if (i > 0 && !used[i - 1] && pt[i].first - pt[i - 1].first <= r) {
            used[i - 1] = 1;
            dq.push_back(i - 1);
        }
        if (i < n - 1 && !used[i + 1] && pt[i + 1].first - pt[i].first <= r) {
            used[i + 1] = 1;
            dq.push_back(i + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i]) used2[pt[i].second] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (used2[i]) cout << '1';
        else cout << '0';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
   //cin >> ttt;
    while (ttt--) {
        solve();
    }
}