#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

bool check(int x, int y, int r) {
    return (ll)x * x + (ll)y * y <= (ll)r * r;
}

const int MAXN = 1e5;

bool dp[2][MAXN];

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    vector<array<int, 3>> pts(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts[i] = {x, y, i};
        a[i] = {x, y};
    }
    sort(all(pts));
    vector<int> ind(n);
    for (int i = 0; i < n; i++) {
        ind[pts[i][2]] = i;
    }
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        b[i] = {pts[i][0], pts[i][1]};
    }
    // for (auto [x, y, i] : pts) {
    //     cout << x << " " << y << " " << i << endl;
    // }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        auto [x, y] = a[i];
        for (int k = 0; k <= r; k++) {
            int sq = (int)pow( r * r - k * k, 0.5);
            int it = lower_bound(all(b), make_pair(x + k, y - sq)) - b.begin();
            if (it == n) continue;
            //int it = 0;
            while (it < n && pts[it][0] == x + k && abs(pts[it][1] - y) <= sq) {
                if (i != pts[it][2]) {
                    g[i].push_back(pts[it][2]);
                    g[pts[it][2]].push_back(i);
                }
                it++;
            }
        }
    }
    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        if (dp[0][i] || dp[1][i]) continue;
        q.push({0, i});
        dp[0][i] = i;
        while (!q.empty()) {
            auto [t, v] = q.front();
            q.pop();
            for (auto to : g[v]) {
                if (!dp[1 ^ t][to]) {
                    dp[1 ^ t][to] = 1;
                    q.push({1 - t, to});
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (dp[0][i] && dp[1][i]) cout << "1";
        else cout << "0";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}