#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
const int INF = 1e9;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct Point {
    int x, y;
};

double dist(Point a, Point b) {
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

vector<vector<int> > gr;
vector<bool> used;
vector<vector<bool> > is;


void dfs(int v, int who) {
    used[v] = 1;
    is[v][who] = 1;
    for (int u: gr[v]) {
        if (!used[u]) {
            dfs(u, !who);
        } else {
            is[u][!who] = 1;
        }
    }
}

void solve1() {
    int n, r;
    cin >> n >> r;
    vector<Point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (dist(a[i], a[j]) <= r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        used.assign(n, 0);
        is.assign(n, vector<bool>(2, 0));
        dfs(i, 0);
        bool flag = false;
        for (int j = 0; j < n; j++) {
            if (is[j][0] && is[j][1]) {
                flag = true;
                break;
            }
        }
        cout << flag;
    }
}
