#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int long long
const int INF = 1e18;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

void solve1() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            if (i == 0 && j == 0) continue;
            int fir = INF, sec = INF;
            if (i != 0) {
                fir = dp[i - 1][j];
            }
            if (j != 0) {
                sec = dp[i][j - 1];
            }
            vector<int> f, s;
            if (i != 0) {
                for (int k = j + 1; k <= m; k++) {
                    f.push_back(a[i][k]);
                    for (int x = 1; x < i; x++) {
                        for (int y = 1; y <= m; y++) {
                            if (a[i][k] < a[x][y]) {
                                fir++;
                            }
                        }
                    }
                    for (int x = i; x <= n; x++) {
                        for (int y = 1; y <= j; y++) {
                            if (a[i][k] < a[x][y]) {
                                fir++;
                            }
                        }
                    }
                }
                for (int x = 0; x < f.size(); x++) {
                    for (int y = 0; y < x; y++) {
                        if (f[x] < f[y]) {
                            fir++;
                        }
                    }
                }
            }
            dp[i][j] = fir;
            if (j != 0) {
                for (int k = i + 1; k <= n; k++) {
                    s.push_back(a[k][j]);
                    for (int x = 1; x <= i; x++) {
                        for (int y = 1; y <= m; y++) {
                            if (a[k][j] < a[x][y]) {
                                sec++;
                            }
                        }
                    }
                    for (int x = i + 1; x <= n; x++) {
                        for (int y = 1; y < j; y++) {
                            if (a[k][j] < a[x][y]) {
                                sec++;
                            }
                        }
                    }
                }
                for (int x = 0; x < s.size(); x++) {
                    for (int y = 0; y < x; y++) {
                        if (s[x] < s[y]) {
                            sec++;
                        }
                    }
                }
            }
            dp[i][j] = min(dp[i][j], sec);
        }
    }
    int ans = INF;
    for (int i = 0; i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int i = 0; i <= m; i++) {
        ans = min(ans, dp[n][i]);
    }
    cout << ans;
}
