#include <bits/stdc++.h>

#define x first
#define y second

#define all(a) a.begin(),a.end()

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

ll n, r;
vector<pll> p;
vector<int> ans;
vector<int> vis;
ll dist(pll a, pll b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

bool flag;
vector<int> res;
void DFS(int i) {
    res.push_back(i);
    for (int j = max(i - 2, 0); j < min(i + 3ll, n); ++j) {
        if (i == j) continue;
        if (dist(p[i], p[j]) <= r * r) {
            if (vis[i] == vis[j]) {
                flag = 1;
            } else if (vis[j] == 0) {
                vis[j] = (vis[i] == 2 ? 1 : 2);
                DFS(j);
            }
        }
    }
}

void solve() {
    cin >> n >> r;

    p.resize(n);
    ans.resize(n);
    vis.resize(n);
    for (int i = 0, x, y; i < n; ++i) {
        cin >> x >> y;
        p[i] = {x, y};
    }

    sort(p.begin(), p.end(), [](pll a, pll b) {
        return a.x < b.x;
    });

    for (int i = 0; i < n; ++i) {
        if (!vis[i]) {
            res.clear();
            flag = 0;
            vis[i] = 2;
            DFS(i);
            if (flag) {
                for (int u : res) {
                    ans[u] = 1;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}