#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define x first
#define y second

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using pll = pair<ll, ll>;


void solve() {
    ll r, c;
    cin >> r >> c;

    vector<vector<ll>> a(r, vector<ll>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    ordered_set<ll> st;
    ll add;
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1));
    for (int i = r - 1; i >= 0; --i) {
        st.clear();
        ll v = 0, h = 0;
        for (int j = c - 1; j >= 0; --j) {
            v = 0;
            for (int i1 = r - 1; i1 > i; --i1) {
                v += st.order_of_key(a[i1][j]);
                st.insert(a[i1][j]);
            }
            add = st.order_of_key(a[i][j]);
            h += add;
            v += add;
            st.insert(a[i][j]);
            dp[i][j] = min(dp[i][j + 1] + v, dp[i + 1][j] + h);
        }
    }

    cout << dp[0][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}