#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<bitset>
#include<iomanip>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("03")
#pragma GCC target("avx,avx2")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

mt19937 mt(time(0));
const int N = 3e5 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 100;
int n, q, a[N], nxt[N], sufmx[N];
struct segtree {
	struct st {
		int mn, ind;
		st() : mn(inf), ind(-1) {}
		st(int _mn, int _ind) : mn(_mn), ind(_ind) {}
		st operator+(st a) {
			st ans;
			ans.mn = min(mn, a.mn);
			if (mn == ans.mn) ans.ind = ind;
			else
				ans.ind = a.ind;
			return ans;
		}
	};
	st t[N * 2];
	void build() {
		for (int i = 0; i < n; ++i) t[i + n] = { a[i], i };
		for (int i = n - 1; i; --i) {
			t[i] = t[i * 2] + t[i * 2 + 1];
		}
	}
	int get(int l, int r) {
		st ans;
		l += n, r += n;
		while (l < r) {
			if (l & 1) ans = ans + t[l++];
			if (r & 1) ans = ans + t[--r];
			l >>= 1, r >>= 1;
		}
		return ans.ind;
	}

};
segtree t;
vector<int> ans[N];
void build(int cnt) {
	int i = 0;
	for (int it = 0; it < cnt; ++it) {
		if (it + 1 == cnt) {
			ans[cnt].push_back(sufmx[i]);
			break;
		}
		ans[cnt].push_back(a[i]);
		if (ans[cnt].size() == 3) break;
		int r = min(nxt[i] - 1, n - (cnt - it) + 1);
		if (r == i) {
			++i;
			continue;
		}
		if (it + 2 == cnt) {
			i = r;
		}
		else {
			i = t.get(i + 1, r + 1);
		}
		
	}
}

void solve() {
	cin >> n >> q;
	for (int i = 0; i < n; ++i) cin >> a[i], --a[i];
	t.build();
	vector<int> st;
	sufmx[n] = -1;
	for (int i = n - 1; i >= 0; --i) {
		while (!st.empty() && a[st.back()] <= a[i]) st.pop_back();
		nxt[i] = st.empty() ? n : st.back();
		st.push_back(i);
		sufmx[i] = max(sufmx[i + 1], a[i]);
	}
	while (q--) {
		int k, i;
		cin >> k >> i;
		//if (ans[k].empty()) build(k);
		//cout << ans[k][--i] + 1 << '\n';
		if (k == 1) cout << n << '\n';
		else if (i < k) cout << a[i - 1] + 1 << '\n';
		else
			cout << (k % 2 == 1 ? a[n - 1] + 1 : a[i - 1] + 1) << '\n';
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}