#include<iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<random>
#include<map>
#define ll long long
using namespace std;

mt19937 gen(17969);
long long r;
vector<int>ans;
vector<char>used(1e5);

bool sm(pair<ll, ll>&p1, pair<ll, ll>&p2)
{
    return (p1.first - p2.first) * (p1.first - p2.first) + (p2.second - p1.second) * (p2.second - p1.second) <= r * r;
}

vector<pair<long long, long long>>p;
vector<vector<ll>>mp;
vector<int>way;
vector<ll>hp;
int l, r, f;
void dfs(int v, int&can, int c, int x, int y)
{
    used[v] = c;
    way.push_back(v);
    for(int dx = -1; dx < 2; dx++)
    {
        for(int dy = -1; dy < 2; dy++)
        {
            hp = {x + dx, y + dy, 0};
            l = lower_bound(mp.begin(), mp.end(), hp) - mp.begin();
            hp[2] = 1e9;
            r = upper_bound(mp.begin(), mp.end(), hp) - mp.begin();
            for(int j = l; j < r; j++)
            {
                f = mp[j][2];
                if(f == v)
                {
                    continue;
                }
                if(sm(p[v], p[f]))
                {
                    if(used[f] == c)
                    {
                        can = 1;
                    }
                    else if(used[f] == 0)
                    {
                        dfs(f, can, c % 2 + 1, x + dx, y + dy);
                    }
                }
            }
        }
    }
}

int main()
{
    int n;
    cin >> n;
    cin >> r;
    ans.assign(n, 0);
    p.assign(n, {});
    mp.assign(n, {});
    for(int i = 0; i < n; i++)
    {
        cin >> p[i].first >> p[i].second;
        mp[i] = {p[i].first/r, p[i].second/r, i};
    }
    sort(mp.begin(), mp.end());
    int can;
    for(int i = 0; i < n; i++)
    {
        if(used[i] == 0)
        {
            can = 0;
            way.clear();
            dfs(i, can, 1, p[i].first/r, p[i].second/r);
            for(auto i: way)
            {
                ans[i] = can;
            }
        }
    }
    for(int i = 0; i < n; i++)
    {
        cout << ans[i];
    }
}