#include<iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<random>
#include<map>
using namespace std;

mt19937 gen(17969);
long long r;
map<pair<int, int>, vector<int>>mp;
vector<int>ans(1e5);
vector<char>used(1e5);
struct point{
    long long x, y;
    point(long long xx = 0, long long yy = 0)
    {
        x = xx;
        y = yy;
    }
    bool sm(point p)
    {
        return ((p.x - x) * (p.x - x) + (p.y - y) * (p.y - y) <= r * r);
    }
};

vector<point>p(1e5);
vector<int>way;
void dfs(int v, int&can, int c, int x, int y)
{
    used[v] = c;
    way.push_back(v);
    for(int dx = -1; dx < 2; dx++)
    {
        for(int dy = -1; dy < 2; dy++)
        {
            for(auto i: mp[{x + dx, y + dy}])
            {
                if(i == v)
                {
                    continue;
                }
                if(p[i].sm(p[v]))
                {
                    if(used[i] == c)
                    {
                        can = 1;
                    }
                    else if(used[i] == 0)
                    {
                        dfs(i, can, c % 2 + 1, x + dx, y + dy);
                    }
                }
            }
        }
    }
}

int main()
{
    int n;
    cin >> n;
    cin >> r;
    ans.assign(n, 0);
    p.assign(n, point());
    map<pair<int, int>, int>num;
    for(int i = 0; i < n; i++)
    {
        cin >> p[i].x >> p[i].y;
        num[{p[i].x, p[i].y}] = i;
    }
    shuffle(p.begin(), p.end(), gen);
    for(int i = 0; i < n; i++)
    {
        mp[{p[i].x/r,p[i].y/r}].push_back(i);
    }
    int can;
    for(int i = 0; i < n; i++)
    {
        if(used[i] == 0)
        {
            can = 0;
            way.clear();
            dfs(i, can, 1, p[i].x/r, p[i].y/r);
            for(auto i: way)
            {
                ans[i] = can;
            }
        }
    }
    vector<int>ans2(n);
    for(int i = 0; i < n; i++)
    {
        ans2[num[{p[i].x, p[i].y}]] = ans[i];
    }
    for(int i = 0; i < n; i++)
    {
        cout << ans2[i];
    }
}