#include <iostream>
#include <iomanip>
#include <string>
#include <numeric>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <array>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#pragma gcc optimize("Ofast")
using namespace std;


bool check(vector<bool>& a, int i) {
	if (i < 0 or i >= a.size()) {
		return 1;
	}
	return !a[i];
}

bool odcpcom(vector<vector<int>>& a, vector<int>& v, int s, int p, int c, vector<int>& d) {
	bool f = 0;
	v[s] = c;
	d[s] = p;
	for (int i = 0; i < a[s].size(); i++) {
		if (v[a[s][i]] == 0) {
			f |= odcpcom(a, v, a[s][i], p + 1, c, d);
		}
		if ((d[a[s][i]] % 2) == (p % 2)) {
			f = 1;
		}
	}
	return f;
}

bool odcpcom2(vector<array<int,80>>& a, vector<int>& v, int s, int p, int c, vector<int>& d) {
	bool f = 0;
	v[s] = c;
	d[s] = p;
	for (int i = 0; i < a[s].size() and a[s][i] > 0; i++) {
		if (v[a[s][i]-1] == 0) {
			f |= odcpcom2(a, v, a[s][i]-1, p + 1, c, d);
		}
		if ((d[a[s][i]-1] % 2) == (p % 2)) {
			f = 1;
		}
	}
	return f;
}

int main()
{
	long long n, r;
	cin >> n >> r;
	vector<array<int, 2>> a;
	vector<array<int, 3>> ewq;
	map<array<long long, 2>, array<int, 2>> b;
	map<array<int, 2>, vector<array<long long, 2>>> c;
	vector<vector<int>> d(n);
	vector<int> qwer(n);
	map<array<int, 2>, int> e;
	vector<int> v(n);
	vector<int> dist(n);
	vector<int> w(n + 1);
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		array <int , 2 > qwe = { x,y };
		a.push_back(qwe);
		ewq.push_back({ x,y, i});
		e[qwe] = i + 1;
	}
	sort(ewq.begin(), ewq.end());
	int l = 0, r1 = 0, s = 0, q = 1;
	int f = 1;
	for (s = 0; s < n; s++) {
		int orv = r1;
		while (r1 + 1 < n and ewq[r1 + 1][0] <= ewq[s][0] + r) {
			r1++;
		}
		while(ewq[l][0] < ewq[s][0]-r){
			l++;
		}
		if (l > orv) {
			q++;
		}
		v[ewq[s][2]] = q;
		if (r1 - l >= 3) {
			w[q] = 1;
			f = 0;
		}
		for (int i = l; f and i <= r1; i++) {
			if (i != s) {
				d[ewq[s][2]].push_back(ewq[i][2]);
			}
		}
	}
	//for (int i = 0; i < n; i++) {
	//	for (int j = i + 1; j < n; j++) {
	//		if ((a[i][0] - a[j][0]) * (a[i][0] - a[j][0]) + (a[i][1] - a[j][1]) * (a[i][1] - a[j][1]) <= r * r) {
	//			d[i].push_back(j);
	//			d[j].push_back(i);
	//		}
	//	}
	//}
	/*for (int i = 0; i < n; i++) {
		for (int j = a[i][0] - r; j <= a[i][0] + r; j++) {
			for (int k = a[i][1] - r; k <= a[i][1] + r; k++) {
				if (j == a[i][0] and k == a[i][1]) {
					continue;
				}
				if ((long long)(a[i][0] - j) * (a[i][0] - j) + (long long)(a[i][1] - k) * (a[i][1] - k) <= r * r) {
					int l = 0;
					int r = ewq.size();
					array<int, 2> qwe = { j,k };
					while (r - l > 1) {
						int m = (l + r) / 2;
						if (qwe < ewq[m]) {
							r = m;
						}
						else {
							l = m;
						}
					}
					if (ewq[l] == qwe) {
						if (e[{j, k}] > 0) {
							d[i][qwer[i]] = e[{j, k}];
							qwer[i]++;
						}
					}
				}
			}
		}
	}*/
	vector<int> v1(n);
	for (int i = 0; i < n; i++) {
		if (w[v[i]] == 0 and v1[i] == 0) {
			if (odcpcom(d, v1, i, 0, q, dist)) {
				w[v[i]] = 1;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		cout << w[v[i]];
	}

}

