#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const int INF = 1000000000;

void precalc() {
	
}

int inv(vector<int>& b) {
	int cnt = 0;
	int n = b.size();
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (b[j] < b[i]) {
				cnt += 1;
			}
		}
	}
	return cnt;
}

void solve() {
	int r, c;
	cin >> r >> c;
	int n = r + c;
	vector<vector<int>> arr(r, vector<int>(c, 0));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++) {
			cin >> arr[i][j];
		}
	}
	int mini = INF;
	for (int mask = 0; mask < (1 << n); mask++) {
		int cur = mask;
		vector<int> b;
		int indi = 0;
		int indj = 0;
		bool flag = true;
		for (int i = 0; i < n; i++) {
			if (cur & 1) {
				for (int j = indj; j < c; j++) {
					b.push_back(arr[indi][j]);
				}
				indi += 1;
			}
			else {
				for (int i1 = indi; i1 < r; i1++) {
					b.push_back(arr[i1][indj]);
				}
				indj += 1;
			}
			if (indi >= r or indj >= c) {
				break;
			}
			cur >>= 1;
		}
	    mini = min(mini, inv(b));
	}
	cout << mini;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
}