#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<unordered_map>
#include<map>
#include<math.h>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
const ll INF = 1e18 + 7;

ll mg(vector<int>& a, vector<int>& b) {
	int i = 0, j = 0;
	ll cnt = 0;
	while (i < a.size() or j < b.size())
	{
		if (j == b.size() or (i != a.size() and a[i] < b[j])) {
			i++;
		}
		else {
			++j;
			cnt += a.size() - i;
		}
	}
	return cnt;
}
ll merg(vector<int>& a, vector<int>& b,vector<int>& c) {
	int i = 0, j = 0;
	ll cnt = 0;
	c.resize(a.size() + b.size());
	while (i < a.size() or j < b.size())
	{
		if (j == b.size() or (i != a.size() and a[i] < b[j])) {
			c[i + j] = a[i];
			i++;
		}
		else {
			c[i + j] = b[j];
			++j;
			cnt += a.size() - i;
		}
	}
	return cnt;
}


ll get(vector<int>& x) {
	ll cnt = 0;
	for (int i = 0; i < x.size(); ++i) {
		for (int j = i + 1; j < x.size(); ++j) {
			cnt += x[i] > x[j];
		}
	}
	return cnt;
}




vector<vector<int>>a;
vector<vector<ll>> dp;
vector<vector<vector<int>>> m;



int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	int r, c;
	cin >> r >> c;
	a.resize(r, vector<int>(c));
	dp.resize(r, vector<ll>(c, INF));
	m.resize(r, vector<vector<int>>(c));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++)
		{
			cin >> a[i][j];
		}
	}
	dp[0][0] = 0;
	for (int i = 0; i < r; ++i) {
		

		for (int j = (i == 0); j < c; ++j) {
			vector<int> x,y;
			
			ll vali = INF , valj = INF;
			if (i > 0) {
				for (int u = j; u < c; ++u) {
					x.push_back(a[i - 1][u]);
				}
				vali = get(x);
				sort(all(x));
				vali += mg(m[i - 1][j], x) + dp[i - 1][j] ;
			}
			if (j > 0) {
				for (int u = i; u < r; ++u) {
					y.push_back(a[u][j - 1]);
				}
				valj = get(y);
				sort(all(y));
				valj += mg(m[i][j - 1], y) + dp[i][j - 1];
			}
			dp[i][j] = min(vali, valj);
			if (i > 0) {
				
				merg(m[i - 1][j], x,m[i][j]);
			}
			else {
				merg(m[i][j - 1], y, m[i][j]);
			}
		}
	}
	vector<int> t = { a[r - 1][c - 1] };
	cout << dp[r - 1][c - 1] + mg(m[r - 1][c - 1], t) << '\n';
#ifdef _DEBUG
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cout << dp[i][j] << ' ';
		}
		cout << '\n';
	}
#endif // _DEBUG

}