#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <array>
#include <cmath>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
const ll N = 3e5 + 20;
const ll K = 19, D = 35;
array<ll, 2> sp[N][K];
ll em[N][D][K];
ll mx[N];
array<ll, 2> get(ll l, ll r) {
	ll k = mx[r - l + 1];
	return min(sp[l][k], sp[r - (1 << k) + 1][k]);
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, q;
	cin >> n >> q;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	for (ll i = 0; i < n; i++) {
		sp[i][0] = { a[i], i };
	}
	for (ll k = 1; k < K; k++) {
		for (ll i = 0; i + (1 << k) <= n; i++) {
			sp[i][k] = min(sp[i][k - 1], sp[i + (1 << k - 1)][k - 1]);
		}
	}
	mx[1] = 0;
	for (ll i = 2; i <= n; i++) mx[i] = mx[i / 2] + 1;
	vector<ll> nxt(n, n), prmx(n);
	vector<ll> stmx = { n };
	for (ll i = n - 1; i >= 0; i--) {
		while (stmx.size() > 1 && a[i] > a[stmx.back()]) stmx.pop_back();
		nxt[i] = stmx.back();
		stmx.push_back(i);
		prmx[i] = a[stmx[1]];
	}
	vector<ll> free = { 0 };
	while (free.back() + 1 < n) {
		ll j = free.back();
		free.push_back(get(j + 1, min(n - 1, nxt[j]))[1]);
	}
	vector<ll> stop(n + 2, n);
	for (ll i = 0; i + 1 < free.size(); i++) {
		ll cnt = i + 1;
		ll k = n + cnt - free[i + 1] + 1;
		k = min(k, n + 1);
		stop[k] = min(stop[k], cnt);
	}
	for (ll k = 1; k <= n; k++) {
		stop[k] = min(stop[k], stop[k - 1]);
	}
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < D; j++) {
			for (ll f = 0; f < K; f++) em[i][j][f] = -1;
		}
	}
	for (ll i = 0; i + 1 < n; i++) {
		for (ll d = 0; d < D; d++) {
			em[i][d][0] = get(i + 1, min({ n - 1, nxt[i], i + d + 1 }))[1];
		}
	}
	for (ll c = 1; c < K; c++) {
		for (ll i = 0; i + 1 < n; i++) {
			for (ll d = 0; d < D; d++) {
				if (em[i][d][c - 1] < 0) continue;
				ll nd = d - (em[i][d][c - 1] - i - (1 << c - 1));
				em[i][d][c] = em[em[i][d][c-1]][nd][c-1];
			}
		}
	}
	while (q--) {
		ll k, i;
		cin >> k >> i;
		ll f = min({ i, stop[k], k - 1 });
		if (k == 1) f = 1;
		ll j = free[f - 1], cnt = f;
		while (cnt < i) {
			ll d = n - k + cnt - j - 1;
			if (d >= D || cnt + 1 == k) {
				if (cnt + 1 < k)
					j = get(j + 1, min(nxt[j], n - k + cnt))[1];
				else
					j = min(nxt[j], n - 1);
				cnt++;
			}
			else {
				ll add = min(k - 1, i) - cnt;
				for (ll c = 0; c < K; c++) {
					if (add & (1 << c)) {
						ll nd = d - (em[j][d][c] - j - (1 << c));
						j = em[j][d][c];
						d = nd;
					}
				}
				cnt += add;
			}
		}
		if (i == k) cout << prmx[j] << "\n";
		else cout << a[j] << "\n";
	}
	return 0;
}