#include <bits/stdc++.h>
//#define int long long
#pragma GCC optimize("O3")

using namespace std;

int n;
long long r;
vector <int> used;
vector <pair <int, int>> arr;
set <pair <pair <int, int>, int>> s;
vector <pair <int, int>> d;

bool is(int v, int c) {
    used[v] = c;
    bool b = false;
    for (auto p : d) {
        p = {arr[v].first + p.first, arr[v].second + p.second};
        auto it = s.lower_bound({p, 0});
        if (it == s.end() || (*it).first.first != p.first || (*it).first.second != p.second) continue;
        int j = (*it).second;
        if (v == j) continue;
        if (used[j] == -1) {
            b = (b || is(j, !c));
        } else if (used[j] == used[v]) {
            b = true;
        }
        if (b) return true;
    }
    return b;
}

vector <int> can;

void dfs(int v) {
    can[v] = 1;
    for (auto p : d) {
        p = {arr[v].first + p.first, arr[v].second + p.second};
        auto it = s.lower_bound({p, 0});
        if (it == s.end() || (*it).first.first != p.first || (*it).first.second != p.second) continue;
        int j = (*it).second;
        if (v == j) continue;
        if (!can[j]) {
            dfs(j);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first >> arr[i].second;
        s.insert({arr[i], i});
    }
    for (long long x = -r; x <= r; ++x) {
        for (long long y = -r; y <= r; ++y) {
            if (x * x + y * y <= r * r && (x != 0 || y != 0)) {
                d.push_back({x, y});
            }
        }
    }
    used.resize(n, -1);
    can.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            if (is(i, 0)) {
                dfs(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << can[i];
    }
    return 0;
}
