#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("O3")

using namespace std;

vector <int> tree;

void update(int v, int l, int r, int pos) {
    if (r == l + 1) {
        tree[v]++;
        return;
    }
    int m = (l + r) / 2;
    if (m > pos) {
        update(2 * v, l, m, pos);
    } else {
        update(2 * v + 1, m, r, pos);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int get(int v, int l, int r, int x) {
    if (l >= x) return 0;
    if (r <= x) return tree[v];
    int m = (l + r) / 2;
    return get(2 * v, l, m, x) + get(2 * v + 1, m, r, x);
}

signed main() {
    int r, c;
    cin >> r >> c;
    vector <int> arr(c);
    for (int i = 0; i < c; ++i) {
        cin >> arr[i];
    }
    tree.resize(4 * c + 4);
    int ans = 0;
    for(int i = 0; i < c; ++i) {
        ans += get(1, 0, c, arr[i]);
        update(1, 0, c, arr[i]);
    }
    cout << ans << endl;
    return 0;
}
