#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

void solve() {
    int n, q, k;
    cin >> n >> q;
    string s;
    cin >> s;
    for (auto &e : s) e -= '0';

    int cnt = count(all(s), 0), z = 0;
    int ones = count(all(s), 1);
    int lst = -10;
    for (int i = 1; i + 1 < n; ++i) {
        if (s[i] == 0 and s[i - 1] == 1 and s[i + 1] == 1) {
            if (lst != i - 2 and (i == 1 or s[i - 2] == 0) and (i == n - 2 or s[i + 2] == 0)) {
                lst = i;
                z++;
            }
        }
    }

    if (ones == 0) {
        while (q--) {
            cin >> k;
            if (k <= 1) cout << "0\n";
            else cout << k << '\n';
        }
        return;
    }

    int good = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == 1) {
            int j = i;
            for (; j < n and s[j] == 1; ++j);
            if (j - i > 1) {
                good += j - i;
            }
            i = j;
        }
    }

    while (q--) {
        cin >> k;
        if (k <= z) {
            cout << good + k * 3 << '\n';
        } else if (k <= z + ones - good - z * 2) {
            cout << good + z * 3 + (k - z) * 2 << '\n';
        } else {
            cout << min(n, good + z * 3 + (ones - good - z * 2) * 2 + (k - (z + ones - good - z * 2))) << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}