#include<bits/stdc++.h>

#pragma GCC optmize("O3","unroll-loops")
#pragma GCC optmize("avx2")

using namespace std;

const int MAX = 1e5, K = 1000;

vector<int> g[MAX];
int used[MAX];
int used2[MAX];
int fl = 1;
int ans[MAX];
vector<int> now;

void dfs(int v, int num) {
    if (used2[v]) {
        fl = 0;
    }
    used[v] = num;
    now.push_back(v);
    for (int to : g[v]) {
        if (used[to] != 0) {
            if (used[to] == num) {
                fl = 0;
            }
        } else {
            dfs(to, ((num - 1) ^ 1) + 1);
        }
    }
}

long long dist(array<int, 3> & a, array<int, 3> &  b) {
    int x = a[0] - b[0];
    int y = a[1] - b[1];
    return 1ll * x * x + 1ll * y * y;
}

mt19937 rnd(228);

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, r;
    cin >> n >> r;
    vector<array<int, 3>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
        a[i][2] = i;
    }
    vector<array<int, 3>> b = a;
    sort(b.begin(), b.end());
    shuffle(a.begin(), a.end(), rnd);
    for (int i = 0; i < n; ++i) {
        for (int x = -r; x <= r; ++x) {
            for (int y = 0; y >= -(int)sqrtl(1ll * r * r - 1ll * x * x); --y) {
                if (x == 0 && y == 0) continue;
                if (1ll * x * x + 1ll * y * y > 1ll * r * r) continue;
                auto it = lower_bound(b.begin(), b.end(), array<int, 3>{a[i][0] + x, a[i][1] + y, -1});
                if ((*it)[0] == a[i][0] + x && (*it)[1] == a[i][1] + y) {
                    g[a[i][2]].push_back((*it)[2]);
                }
            }
            for (int y = (int)sqrtl(1ll * r * r - 1ll * x * x); y >= 0; --y) {
                if (x == 0 && y == 0) continue;
                if (1ll * x * x + 1ll * y * y > 1ll * r * r) continue;
                auto it = lower_bound(b.begin(), b.end(), array<int, 3>{a[i][0] + x, a[i][1] + y, -1});
                if ((*it)[0] == a[i][0] + x && (*it)[1] == a[i][1] + y) {
                    g[a[i][2]].push_back((*it)[2]);
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            fl = 1;
            now.clear();
            now.reserve(n);
            dfs(i, 1);
            if (fl == 0) {
                for (int x : now) {
                    ans[x] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
