#include<bits/stdc++.h>

#pragma GCC optmize("O3","unroll-loops")
#pragma GCC optmize("avx2")

using namespace std;

const int MAX = 1e5;

vector<int> g[MAX];
int used[MAX];
int fl = 1;
int ans[MAX];
vector<int> now;

void dfs(int v, int num) {
    used[v] = num;
    now.push_back(v);
    for (int to : g[v]) {
        if (used[to] != 0) {
            if (used[to] == num) {
                fl = 0;
            }
        } else {
            dfs(to, ((num - 1) ^ 1) + 1);
        }
    }
}

long long dist(pair<int, int> & a, pair<int, int> &  b) {
    int x = a.first - b.first;
    int y = a.second - b.second;
    return 1ll * x * x + 1ll * y * y;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dist(a[i], a[j]) <= 1ll * r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            fl = 1;
            now.clear();
            now.reserve(n);
            dfs(i, 1);
            if (fl == 0) {
                for (int x : now) {
                    ans[x] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
