#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	string s;
	cin >> s;
	int ok = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '1') {
			ok = 1;
			break;
		}
	}
	if (!ok) {
		while (q--) {
			int x;
			cin >> x;
			if (x <= 1) {
				cout << "0\n";
			} else {
				cout << x << '\n';
			}
		}
		return;
	}
	int st = 0;
	vector<int> can, used(n, 0);
	for (int i = 1; i < n; i++) {
		if (s[i] == '1' && s[i - 1] == '1') {
			used[i] = 1;
			used[i - 1] = 1;
		}
	}
	for (int i = 0; i < n; i++) {
		st += used[i];
	}
	for (int i = 1; i < n - 1; i++) {
		if (!used[i - 1] && !used[i + 1] && s[i - 1] == '1' && s[i + 1] == '1' && s[i] == '0') {
			can.push_back(3);
			used[i - 1] = 1;
			used[i] = 1;
			used[i + 1] = 1;
			s[i] = '1';
		}
	}
	for (int i = 1; i < n; i++) {
		if (!used[i - 1] && s[i - 1] == '1' && s[i] == '0') {
			can.push_back(2);
			used[i - 1] = 1;
			used[i] = 1;
			s[i] = '1';
		}
	}
	for (int i = 1; i < n; i++) {
		if (!used[i + 1] && s[i + 1] == '1' && s[i] == '0') {
			can.push_back(2);
			used[i + 1] = 1;
			used[i] = 1;
			s[i] = '1';
		}
	}
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') {
			can.push_back(1);
		}
	}
	vector<int> pref(can.size() + 1);
	pref[0] = st;
	for (int i = 0; i < can.size(); i++) {
		pref[i + 1] = pref[i] + can[i];
	}
	while (q--) {
		int x;
		cin >> x;
		cout << pref[x] << '\n';
	}
}