#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,fma")

using namespace std;

#define X first
#define Y second
#define all(x) begin(x), end(x)

int isz(const auto& x) {
  return x.size();
}

using ll = long long;
using ld = long double;

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

template<typename T, typename C = less<T>>
using ordered_set = tree<T, null_type, C, rb_tree_tag, tree_order_statistics_node_update>;

ll calc(deque<deque<int>> a, const vector<char>& t) {
  vector<int> b;
  for (auto it : t) {
    while (!a.empty() && a[0].empty()) a.pop_front();
    if (a.empty()) break;
    if (!it) {
      b.insert(b.end(), all(a[0]));
      a.pop_front();
    } else {
      for (int i = 0; i < isz(a); ++i) {
        b.push_back(a[i][0]);
        a[i].pop_front();
      }
    }
  }
  ordered_set<pair<int, int>, greater<>> s;
  ll ans = 0;
  for (int i = 0; i < isz(b); ++i) {
    ans += s.order_of_key(make_pair(b[i], i));
    s.insert({b[i], i});
  }
  return ans;
}

void solve() {
  int r, c;
  cin >> r >> c;
  vector<int> a(r * c);
  for (auto& it : a) cin >> it;
  ordered_set<pair<int, int>, greater<>> s;
  ll ans = 0;
  for (int i = 0; i < isz(a); ++i) {
    ans += s.order_of_key(make_pair(a[i], i));
    s.insert({a[i], i});
  }
  cout << ans << '\n';
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  solve();
}