#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,fma")

using namespace std;

#define X first
#define Y second
#define all(x) begin(x), end(x)

int isz(const auto& x) {
  return x.size();
}

using ll = long long;
using ld = long double;

auto& remin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}

struct sparse_table {
  vector<vector<int>> st;

  sparse_table(const vector<int>& a) : st(20, a) {
    for (int i = 0; i + 1 < 20; ++i) {
      for (int j = 0; j + (1 << i) < isz(a); ++j) {
        st[i + 1][j] = max(st[i][j], st[i][j + (1 << i)]);
      }
    }
  }

  int operator()(int l, int r) {
    const int p = __lg(r - l);
    return max(st[p][l], st[p][r - (1 << p)]);
  }
};

void solve() {
  int n, q;
  cin >> n >> q;
  vector<int> a(n);
  for (auto& it : a) cin >> it;
  sparse_table st(a);
  vector<int> ans = {(int)1e9, (int)1e9, (int)1e9};
  for (int i = 1; i + 1 < n; ++i) {
    remin(ans, vector<int>{st(0, i), st(i, i + 1), st(i + 1, n)});
  }
  while (q --> 0) {
    int k, i;
    cin >> k >> i;
    cout << ans[i - 1] << '\n';
  }
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  #ifdef LOCAL
    freopen("/home/roi/work/in.txt", "r", stdin);
  #endif
  solve();
}