#include <bits/stdc++.h>
using namespace std;
#define int long long
int n, r;
struct f {
    int x, y;
};
bool dist(f a, f b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}
vector <vector<int>> g;
vector <pair<bool, bool>> used;
bool dfs(int v, int u, bool c) {
    if (!c && v == u) return true;
    if (c) used[v].first = 1;
    else used[v].second = 1;
    for (int w : g[v]) {
        if ((c && !used[w].second) || (!c && !used[w].first)) {
            if (dfs(w, u, c ^ 1)) return true;
        }
    }
    return false;
}
void solve() {
    cin >> n >> r;
    vector <f> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    g = vector<vector<int>> (n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j && dist(a[i], a[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        used = vector <pair<bool, bool>>(n, {false, false});
        if (dfs(i, i, 1)) cout << 1;
        else cout << 0;
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}