#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e9 + 7;
vector <pair<int, int>> tree, tree1;
vector <int> a;
void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i] = {a[l], l};
        return;
    }
    int m = (l + r) / 2;
    build(i * 2 + 1, l, m);
    build(i * 2 + 2, m, r);
    tree[i] = min(tree[i * 2 + 1], tree[i * 2 + 2]);
}
pair<int, int> get(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return {inf, inf};
    }
    if (l >= ql && r <= qr) {
        return tree[i];
    }
    int m = (l + r ) / 2;
    return min(get(i * 2 + 1, l, m, ql, qr), get(i * 2 + 2, m, r, ql, qr));
}
void build1(int i, int l, int r) {
    if (l + 1 == r) {
        tree1[i] = {a[l], l};
        return;
    }
    int m = (l + r) / 2;
    build1(i * 2 + 1, l, m);
    build1(i * 2 + 2, m, r);
    tree1[i] = max(tree1[i * 2 + 1], tree1[i * 2 + 2]);
}
pair<int, int> get1(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return {-inf, -inf};
    }
    if (l >= ql && r <= qr) {
        return tree1[i];
    }
    int m = (l + r ) / 2;
    return max(get1(i * 2 + 1, l, m, ql, qr), get1(i * 2 + 2, m, r, ql, qr));
}
void solve() {
    int n, q;
    cin >> n >> q;
    a = vector <int> (n);
    tree = tree1 = vector <pair<int, int>> (4 * n);
    for (int& x : a) cin >> x;
    build(0, 0, n);
    build1(0, 0, n);
    vector <int> nx(n);
    set <pair<int, int>> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && (*st.begin()).first < a[i])
            st.erase(st.begin());
        nx[i] = (st.empty() ? n : (*st.begin()).second);
        st.insert({a[i], i});
    }
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        int l = 0, r;
        while (--ind) {
            r = min(nx[l], n - k + 1) + 1;
            l = get(0, 0, n, l + 1, r).second;
            k--;
        }
        cout << get1(0, 0, n, l, n - k + 1).first << endl;
    }
}
signed main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}