#include <bits/stdc++.h>
using namespace std;
#define int long long
void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    solve();
}

struct point {
    int x,y;
};

int dist2(point &a,point &b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

vector<vector<int>> g,gg;
vector<int> color,tin,tout;
vector<pair<int,int>> q;
vector<int> pr;
int timer=0;

void dfs(int v,int p) {
    pr[v]=p;
    timer++;
    tin[v]=timer;
    q.push_back({timer,-v});
    for (auto i:g[v]) {
        if (i==p) continue;
        if (tin[i]==-1) dfs(i,v);
        else {
            timer++;
            q.push_back({timer,-1e9});
            timer++;
        }
    }
    timer++;
    tout[v]=timer;
    q.push_back({timer,v});
}

void DDD(int v,int p) {
    if (p==-1) color[v]=1;
    else color[v]=3-color[p];
    for (auto i:gg[v]) {
        if (i==p) continue;
        if (color[i]==0) DDD(i,v);
        if (color[i]==color[v]) {
            color[i]=-1;
        }
    }
}

void FILL(int v,int p) {
    color[v]=-1;
    for (auto i:gg[v]) {
        if (color[i]!=-1) FILL(i,v);
    }
}

void solve() {
    int n,r;
    cin>>n>>r;
    vector<point> a(n);
    pr.resize(n);
    for (int i=0;i<n;i++) {
        cin>>a[i].x>>a[i].y;
    }
    g.resize(n);
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (dist2(a[i],a[j])<=r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i=0;i<n;i++) {
        for (auto j:g[i]) {
            cerr<<i<<' '<<j<<"\n";
        }
    }
    cerr<<"!\n";
    tin.resize(n,-1);
    tout.resize(n,-1);
    pr.resize(n,0);
    for (int i=0;i<n;i++) if (tin[i]==-1) dfs(i,-1);
    for (auto i:q) cerr<<i.first<<' '<<i.second<<"\n";
    cerr<<"!!!\n";
    int cur_sum=0;
    int z[n];
    for (int i=0;i<n;i++) z[i]=0;
    for(int i=0;i<q.size();i++) {
        if (q[i].second==-1e9) {
            cur_sum++;
        }
        else if (q[i].second>0) {
            z[q[i].second]+=cur_sum;
        }
        else {
            z[-q[i].second]-=cur_sum;
        }
    }
    gg.resize(n);
    for (int i=0;i<n;i++) {
        for (auto j:g[i]) {
            if((z[i]==0 && pr[i]==j) || (z[j]==0 && pr[j]==i)) {
                cerr<<i<<' '<<j<<"\n";
            }
            else {
                gg[i].push_back(j);
            }
        }
    }
    color.resize(n,0);
    for (int i=0;i<n;i++) if (color[i]==0) DDD(i,-1);
    for (int i=0;i<n;i++) if (color[i]==-1) FILL(i,-1);
    for (int i=0;i<n;i++) {
        if(color[i]==-1) cout<<"1";
        else cout<<"0";
    }
}