#include <bits/stdc++.h>
#define int long long

using ld = long double;
using ll = long long;
using namespace std;

const int logn = 19;

vector<int> numb;
vector<vector<int> > st(logn);
vector<int> suf_max;
vector<int> near;
vector<int> place;

int get_min(int l, int r) {
    int diff = r - l;
    int power = near[diff];
    return min(st[power][l], st[power][r - (1 << power) + 1]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, q;
    cin >> n >> q;

    numb.resize(n);
    place.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> numb[i];
        place[numb[i]] = i;
    }
    numb.push_back(n + 1);

    near.resize(n);
    near[0] = 0;
    near[1] = 0;
    for (int i = 2; i < n; ++i)
        near[i] = near[i - 1] + ((i & (i - 1)) == 0);

    vector<int> more(n);
    deque<pair<int, int> > now;
    for (int i = 0; i <= n; ++i) {
        while (!now.empty() && now[0].first < numb[i]) {
            more[now[0].second] = i;
            now.pop_front();
        }
        now.push_front({numb[i], i});
    }
    numb.pop_back();

    st[0] = numb;
    for (int i = 1; i < logn; ++i) {
        int power = 1 << (i - 1);
        st[i].resize(n);
        for (int j = 0; j < n; ++j) {
            st[i][j] = st[i - 1][j];
            if (j + power < n)
                st[i][j] = min(st[i][j], st[i - 1][j + power]);
        }
    }

    suf_max.resize(n);
    suf_max[n - 1] = numb[n - 1];
    for (int i = n - 2; i >= 0; --i)
        suf_max[i] = max(suf_max[i + 1], numb[i]);

    vector<vector<int> > ans(n);
    ans[0].push_back(n);
    for (int i = 0; i < q; ++i) {
        int k, ind;
        cin >> k >> ind;
        if (!ans[k - 1].empty()) {
            cout << ans[k - 1][ind - 1] << endl;
            continue;
        }
        ans[k - 1].push_back(numb[0]);
        int start = 0;
        for (int j = 0; j < k - 2; ++j) {
            int next = more[start];
            int mx = n - k + (j + 1);

            int gr = min(next, mx);
            int next_mn = get_min(start + 1, gr);

            ans[k - 1].push_back(next_mn);
            start = place[next_mn];
        }
        int next = more[start];
        if (next == n) {
            ans[k - 1].push_back(numb.back());
        } else
            ans[k - 1].push_back(suf_max[more[start]]);
        cout << ans[k - 1][ind - 1] << endl;
    }
}
