#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define ins insert
#define str string
#define pii pair<int, int>
#define ff first
#define ss second

const int INF = 2e9;

void upd(int ind, vector<int> &t){
    for (int i = ind; i < t.size(); i += (i & -i)){
        t[i]++;
    }
}

int get(int ind, vector<int> t){
    int res = 0;
    for (int i = ind; i > 0; i -= (i & -i)){
        res += t[i];
    }
    return res;
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> c(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> c[i][j];
        }
    }
    vector<vector<pair<int, vector<int>>>> dp(n + 1, vector<pair<int, vector<int>>>(m + 1));
    for (int i = 0; i <= n; i++){
        for (int j = 0; j <= m; j++){
            dp[i][j].ss.resize(n * m + 1);
            dp[i][j].ff = INF;
        }
    }
    dp[1][0].ff = 0;
    dp[0][1].ff = 0;
    for (int i = 0; i < m; i++){
        dp[1][0].ff += get(n * m, dp[1][0].ss) - get(c[0][i], dp[1][0].ss);
        upd(c[0][i], dp[1][0].ss);
    }
    for (int i = 0; i < n; i++){
        dp[0][1].ff += get(n * m, dp[0][1].ss) - get(c[i][0], dp[0][1].ss);
        upd(c[i][0], dp[0][1].ss);
    }
    for (int i = 1; i < n; i++){
        vector<int> t = dp[i][0].ss;
        int tec = dp[i][0].ff;
        for (int j = 0; j < m; j++){
            tec += get(n * m, t) - get(c[i][j], t);
            upd(c[i][j], t);
        }
        dp[i + 1][0] = {tec, t};
    }
    for (int j = 1; j < m; j++){
        vector<int> t = dp[0][j].ss;
        int tec = dp[0][j].ff;
        for (int i = 0; i < n; i++){
            tec += get(n * m, t) - get(c[i][j], t);
            upd(c[i][j], t);
        }
        dp[0][j + 1] = {tec, t};
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            vector<int> t = dp[i][j + 1].ss;
            int tec = dp[i][j + 1].ff;
            for (int j2 = j + 1; j2 < m; j2++){
                tec += get(n * m, t) - get(c[i][j2], t);
                upd(c[i][j2], t);
            }
            dp[i + 1][j + 1] = min(dp[i + 1][j + 1], {tec, t});
            vector<int> t2 = dp[i + 1][j].ss;
            int tec2 = dp[i + 1][j].ff;
            for (int i2 = i + 1; i2 < n; i2++){
                tec2 += get(n * m, t2) - get(c[i2][j], t2);
                upd(c[i2][j], t2);
            }
            dp[i + 1][j + 1] = min(dp[i + 1][j + 1], {tec2, t2});
        }
    }
    cout << dp[n][m].ff;
}

int32_t main(){
    cin.tie(0)->ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif // LOCAL
    int _ = 1;
    //cin >> _;
    while (_--){
        solve();
    }
}
