#include<bits/stdc++.h>
using namespace std;
#define int long long
using ll = long long;
int INF = 1e13;
int n, r;
vector<int> used;
vector<int> num;
vector<bool> res;
vector<vector<int>> gr;
  
void dfs(int v, int c, int d) {
    used[v] = d;
    num[v] = c;
    for (auto e : gr[v]) {
        //cout << v << " " << used[v] << " " << e << " " << used[e] << " " << c << " " << res[c] << endl;
        if (used[e] == used[v]) {
            res[c] = true;
        }
        if (used[e] == -1) {
            dfs(e, c, 1 - d);
        }
    }
}
  
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    map<pair<int, int>, vector<int>> target;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        target[{a[i].first / r, a[i].second / r}].push_back({i});
    }
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int dx = -1; dx <= 1; dx++) {
            for (int dy = 0 + ll(dx == -1); dy <= 1; dy++) {
                for (auto j : target[{a[i].first / r + dx, a[i].second / r + dy}]) {
                    if (i != j && (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r) {
                        gr[i].push_back(j);
                        gr[j].push_back(i);
                        //cout << i << " " << j << endl;
                    }
                }
            }
        }
    }
    used.assign(n, -1);
    num.assign(n, -1);
    res.assign(n, false);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (num[i] == -1) {
            dfs(i, cnt, 0);
            cnt += 1;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << res[num[i]];
    }
    cout << endl;
}