#include<bits/stdc++.h>
using namespace std;
#define int long long
using ll = long long;
int INF = 1e13;
int n, m;

int mergen(vector<int>& aa, int l, int r) {
    int m = (l + r) / 2;
    //cout << l << " " << m << " " << r << endl;
    vector<int> a(m - l + 1, 0);
    vector<int> b(r - (m + 1) + 1, 0);
    for (int i = 0; i < a.size(); i++) {
        a[i] = aa[l + i];
    }
    for (int i = 0; i < b.size(); i++) {
        b[i] = aa[m + 1 + i];
    }
    vector<int> c;
    int i = 0, j = 0;
    int ans = 0;
    while (i < a.size() || j < b.size()) {
        if (i == a.size()) {
            c.push_back(b[j]);
            j += 1;
        } else if (j == b.size()) {
            c.push_back(a[i]);
            i += 1;
        } else {
            if (a[i] < b[j]) {
                c.push_back(a[i]);
                i += 1;
            } else {
                ans += a.size() - i;
                c.push_back(b[j]);
                j += 1;
            }
        }
    }
    /*
    for (auto e : a) {
        cout << e << " ";
    }
    cout << "+ ";
    for (auto e : b) {
        cout << e << " ";
    }
    cout << "= ";
    for (auto e : c) {
        cout << e << " ";
    }
    cout << endl;*/
    for (int i = 0; i < c.size(); i++) {
        aa[i + l] = c[i];
    }
    return ans;
}
 
vector<int> merge(vector<int>& a, vector<int>& b) {
    vector<int> c;
    int i = 0, j = 0;
    vector<int> ans(b.size(), 0);
    while (i < a.size() || j < b.size()) {
        if (i == a.size()) {
            c.push_back(b[j]);
            j += 1;
        } else if (j == b.size()) {
            c.push_back(a[i]);
            i += 1;
        } else {
            if (a[i] < b[j]) {
                c.push_back(a[i]);
                i += 1;
            } else {
                ans[j] = a.size() - i;
                c.push_back(b[j]);
                j += 1;
            }
        }
    }
    /*
    for (auto e : a) {
        cout << e << " ";
    }
    cout << "+ ";
    for (auto e : b) {
        cout << e << " ";
    }
    cout << "= ";
    for (auto e : c) {
        cout << e << " ";
    }
    cout << endl;*/
    return ans;
}
  
int merge_sort(vector<int>& a, int l, int r) {
    if (l == r) {
        return 0;
    }
    int m = (l + r) / 2;
    int ans = 0;
    ans += merge_sort(a, l, m);
    ans += merge_sort(a, m + 1, r);
    ans += mergen(a, l, r);
    return ans;
}
  
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    vector<vector<int>> field(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
        }
    }
    if (n == 1) {
        cout <<  merge_sort(field[0], 0, m - 1) << endl;
        return 0;
    }
    swap(n, m);
    vector<int> nnn;
    for (auto e : field[0]) {
        nnn.push_back(e);
    }
    for (auto e : field[1]) {
        nnn.push_back(e);
    }
    int now = merge_sort(nnn, 0, nnn.size() - 1);
    int ans = now;
    vector<int> c(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            c[i] += ll(field[1][i] > field[0][j]);
        }
    }
    vector<int> d(n, 0);
    for (int i = 0; i < n; i++) {
        d[i] = n - i - 1 - c[i];
    }
    vector<int> p(n, 0);
    for (int i = 0; i < n; i++) {
        p[i] = c[i] - d[i];
        if (i > 0) {
            p[i] += p[i - 1];
        }
        ans = min(ans, now + p[i]);
    }
    cout << ans << endl;
}