#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(T a) {cerr << a;}
template<typename T>
void _print(vector<T> a) {
    cerr << "[";
    int f = 0;
    for (auto v : a) {
        if (f++)cerr << ", ";
        _print(v);
    }
    cerr << "]";
}
#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n'
#else
#define debug(x)
#endif


void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int &i : a)cin >> i;
    vector<int> maxi(n);
    maxi.back() = a.back();
    for (int i = n - 2; i >= 0; --i) {
        maxi[i] = max(maxi[i + 1], a[i]);
    }
    int ans = maxi[1];
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] > a[0])break;
        ans = min(ans, maxi[i + 1]);
    }
    debug(maxi);
    while (q--) {
        int k, i; cin >> k >> i;
        if (i == 1) {
            cout << a[0] << '\n';
        } else {
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    solve();
}