#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;

// #define ll __int128

vector<vector<int> > g;
vector<bool> used, res;
vector<int> c;

bool dfs(int v, int cuc) {
    used[v] = true;
    bool fl = false;
    if (c[v] != -1 && c[v] != cuc) {
        fl = true;
    }
    c[v] = cuc;
    for (auto u : g[v]) {
        if (!used[u]) {
            bool f = dfs(u, 1 - cuc);
            if (f) {
                fl = true;
            }
        } else {
            if (c[u] == cuc) {
                fl = true;
            }
        }
    }
    return fl;
}

void dfs1(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs1(u);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    ll r;
    cin >> r;
    g.resize(n);
    used.resize(n);
    res.resize(n);
    c.resize(n, -1);

    vector<pair<ll, ll> > ps;
    gp_hash_table<ll, int> se;
    ll ko = 1e9;
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        se[x + ko * y] = i;
        ps.emplace_back(x, y);
    }

    for (int i = 0; i < n; ++i) {
        for (ll j = -r; j <= r; ++j) {
            for (ll u = -(r - abs(j)); u <= (r - abs(j)); ++u) {
                if (j != 0 || u != 0) {
                    if (r * r >= j * j + u * u && se.find((ps[i].second + u) * ko + ps[i].first + j) != se.end()) {
                        g[i].push_back(se[(ps[i].second + u) * ko + ps[i].first + j]);
                    }
                }
            }
        }
    }

    vector<int> tr;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (dfs(i, 0)) {
                tr.push_back(i);
            }
        }
    }

    used.assign(n, false);
    for (auto i : tr) {
        if (!used[i]) {
            dfs1(i);
        }
    }

    for (auto u : used) {
        if (u) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int tt = 1;
    // cin >> tt;

    while (tt--) {
        solve();
    }
}