#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <random>
#include <cmath>
#include <cassert>
#include <algorithm>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        char u;
        cin >> u;
        a[i] = (u == '1');
    }
    int total = count(a.begin(), a.end(), 1);
    int streak = 0, cur = 0, cool = 0, mega = 0;
    vector<int> used(n);
    for (int i = 0; i < n; i++) {
        if (!a[i] || i == n - 1) {
            if (a[i]) streak++;
            if (streak > 1) {
                cur += streak;
            }
            streak = 0;
            if (!a[i]) {
                int coolness = 0;
                if (i - 1 >= 0 && a[i - 1]) {
                    if (i - 2 < 0 || !a[i - 2]) {
                        coolness++;
                    }
                }
                if (i + 1 < n && a[i + 1]) {
                    if (i + 2 >= n || !a[i + 2]) {
                        coolness++;
                    }
                }
                if (i - 2 >= 0 && used[i - 2]) coolness--;
                if (coolness == 2) {
                    mega++;
                    used[i] = 1;
                }
            }
        } else {
            streak++;
        }
    }

    for (int i = 0; i < n; i++) {
        if (!a[i]) {
            int coolness = 0;
            if (i - 1 >= 0 && a[i - 1]) {
                if (i - 2 < 0 || !a[i - 2]) {
                    coolness++;
                }
            }
            if (i + 1 < n && a[i + 1]) {
                if (i + 2 >= n || !a[i + 2]) {
                    coolness++;
                }
            }
            if (i - 2 >= 0 && used[i - 2]) coolness--;
            if (i + 2 < n && used[i + 2]) coolness--;
            dbg(coolness);
            if (coolness == 1 && !used[i]) cool++;
            used[i] = 1;
        }
    }
    dbg(used);
    dbg(cool, mega);
    while (q--) {
        int k;
        cin >> k;
        if (total == 0 && k <= 1) {
            cout << "0\n";
            continue;
        }
        int add = 0;
        add += min(k, mega) * 3;
        dbg(k, add, n - cur);
        add += max(0ll, min(k - mega, cool) * 2);
        k -= mega + cool;
        if (k - (total == 0) > 0) {
            add += k - (total == 0);
        }
        add = min(add, n - cur);
        cout << add + cur << '\n';
    }
}