#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <random>
#include <cmath>
#include <cassert>
#include <algorithm>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, rad;
    cin >> n >> rad;
    vector<pair<int, int>> a;
    for (int i = 0; i < n; i++) {
        int pos, kek;
        cin >> pos >> kek;
        a.emplace_back(pos, i);
    }
    sort(a.begin(), a.end());
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        if (i - 2 >= 0 && a[i].first - a[i - 2].first <= rad) {
            l[i] = 1;
        }
        if (i + 2 < n && a[i + 2].first - a[i].first <= rad) {
            r[i] = 1;
        }
    }
    int ans = 0;
    vector<int> total(n);
    for (int i = 0; i < n; i++) {
        ans |= l[i];
        total[a[i].second] |= ans;
    }
    ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        ans |= r[i];
        total[a[i].second] |= ans;
    }
    for (auto el : total) cout << el;
}