#include <bits/stdc++.h>
using namespace std;

using ll = int;
using pll = pair<ll,ll>;
using ve = vector<ll>;
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(), x.end()

const ll N=1e5+5,M=30;
ll f[N],deg[N];
ll x[N],y[N];
ll a[N],b[N];
map<pll,vector<pair<pll,ll>>> mp;
vector<ll> v[N];
set<ll> good;
ll r;

bool check(pll p1,pll p2) {
    ll af=(long long)((p1.F-p2.F)*(p1.F-p2.F)+(long long)(p1.S-p2.S)*(p1.S-p2.S));
    ll b=(ll)(r*(ll)r);
    return af<=b;
}

void calc(pll P) {
    ll p=P.F,q=P.S;
    // квадрат p,q
    set<pair<pll,ll>> s;
    // хотим чтобы размер сета всегда был максимум М, иначе есть большая вершина
    for (auto to:mp[{p,q}]) {
        if (s.size()==M) {
            for (auto &oth:s) {
                if (check(oth.F,to.F)) {
                    // Обновили расстояние
                    deg[to.S]++;
                    deg[oth.S]++;
                    //////////
                    if (deg[to.S]<=6) v[to.S].pb(oth.S);
                    if (deg[oth.S]<=6) v[oth.S].pb(to.S);
                    //////////
                    if (deg[oth.S]>=6) {
                        f[oth.S]=1;
                        good.insert(oth.S);
                    }
                }
            }
            for (auto oth:s) if (deg[oth.S]>=6) {
                s.erase(oth);
            }
        }
        s.insert(to);
    }
    for (auto to:s) {
        // Для всех оставшихся в s проверяем какая у них степень
        for (ll i=-1;i<=1;i++) for (ll j=-1;j<=1;j++) {
            // проверяем из квадрата p+i,q+j
            for (auto oth:mp[{p+i,q+j}]) {
                if (check(oth.F,to.F)) {
                    // Обновили расстояние
                    deg[to.S]++;
                    //////////
                    if (deg[to.S]<=6) v[to.S].pb(oth.S);
                    if (deg[oth.S]<=6) v[oth.S].pb(to.S);
                    //////////
                }
            }
        }
        if (deg[to.S]>=6) {
            good.insert(to.S);
            f[to.S]=1;
        }
    }
}

ve Q;
ll col[N],g[N];

void dfs(ll vx, ll c) {
    g[vx]=1; col[vx]=c;
    Q.pb(vx);
    for (ll to:v[vx]) if (g[to]==-1) {
        dfs(to,1-c);
    }
}

void sol() {
    ll i,j,n; cin >> n >> r;
    for (i=1;i<=n;i++) {
        cin >> x[i] >> y[i];
    }
    for (i=1;i<=n;i++) {
        deg[i]=f[i]=0;
    }
    set<pll> squares;
    for (i=1;i<=n;i++) {
        a[i]=x[i]/r,b[i]=y[i]/r;
        squares.insert({a[i],b[i]});
        mp[{a[i],b[i]}].pb({{x[i],y[i]},i});
    }
    for (pll to:squares) calc(to);
    deque<ll> bad;
    for (i=1;i<=n;i++) if (f[i]==0) bad.pb(i);

    bool flag=true;
    while (!bad.empty() && flag) {
        for (i=0;i<bad.size();++i) {
            bool fl=true;
            for (ll to:v[bad[i]]) if (fl) {
                if (f[to]==1) {
                    // можно вершину присоединить к хорошим
                    f[bad[i]]=1;
                    good.insert(bad[i]);
                    swap(bad[0],bad[i]);
                    bad.pop_front();
                    fl=false;
                }
            }
            if (!fl) i=n+1;
        }
        if (i<=n) {
           flag=false;
        }
    }
    if (bad.empty()) {
        for (i=0;i<n;i++) cout << 1;
        cout << "\n"; return;
    }

    for (i=1;i<=n;i++) {
     //   for (ll to:v[i]) cout << i << "   " << to << "\n";
    }
   // cout << "\n\n";

  //  return;
    for (ll to:bad) g[to]=-1;
    for (ll to:bad) {
    //    cout << "? " << to << "\n";
        if (g[to]==-1) {
            Q.clear();
            dfs(to,0);
            ///////////////
            for (i=0;i<Q.size();i++) {
                bool flag=true;

                for (ll a:v[Q[i]]) if (flag) {
                  //  cout << "????    " << Q[i] << " " << a << "   " << col[Q[i]] << " " << col[a] << "\n";
                    if (col[Q[i]]==col[a] && Q[i]!=a) {
                        for (ll to1:Q) {
                            f[to1]=1;
                     //       cout << "! " << to1 << "\n";
                        }
                        flag=false;
                    }
                }
            }
        }
    }
    for (i=1;i<=n;i++) cout << f[i];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    sol();
    return 0;
}