#include <bits/stdc++.h>

using namespace std;
const int inf = 1e9;
using ll = long long;
const ll infll = 1e18;

ll dist(pair<ll, ll> &p, pair<ll, ll> &p2) {
    return (p.first - p2.first) * (p.first - p2.first) + (p.second - p2.second) * (p.second - p2.second);
}

void solve() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, int> > xs(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        xs[i] = {x, i};
    }
    sort(xs.begin(), xs.end());
    vector<int> ans(n);
    for (int i = 1; i < n - 1; ++i) {
        if (xs[i].first - xs[i - 1].first <= r) {
            ans[xs[i].second] = 1;
        }
        if (xs[i + 1].first - xs[i].first <= r) {
            ans[xs[i].second] = 1;
        }
    }
    if (xs[1].first - xs[0].first <= r) {
        ans[xs[0].second] = 1;
    }
    if (xs[n - 1].first - xs[n - 2].first <= r) {
        ans[xs[n - 1].second] = 1;
    }
    for (auto x: ans) {
        cout << x << ' ';
    }
}

int main() {
    solve();
    return 0;
}
