#include <bits/stdc++.h>

using namespace std;
const int inf = 1e9;
using ll = long long;
const ll infll = 1e18;

vector<int> f;
int n;

void add(int i) {
    for (i; i <= n; i += (i&-i)) {
        f[i]++;
    }
}

int sum(int i) {
    int res = 0;
    for (i; i > 0; i -= (i & -i)) {
        res += f[i];
    }
    return res;
}

ll inv(vector<int> &a) {
    n = a.size();
    f.clear();
    f.resize(n + 1);
    vector<int> xs;
    for (auto x : a) {
        xs.push_back(x);
    }
    sort(xs.begin(), xs.end());
    for (auto &x : a) {
        x = (lower_bound(xs.begin(), xs.end(), x) - xs.begin()) + 1;
    }
    ll res = 0;
    for (int i = n - 1; i >= 0; --i) {
        res += sum(a[i]);
        add(a[i]);
    }
    return res;
}

void solve() {
    int r, c;
    cin >> r >> c;
    if (r == 1) {
        vector<int> a(c);
        for (auto &x : a) cin >> x;
        cout << inv(a) << '\n';
        return;
    }
    vector<vector<int>> a(r, vector<int>(c));
    for (auto &v: a) {
        for (auto &x: v) {
            cin >> x;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
