#include <bits/stdc++.h>

using namespace std;
const int inf = 1e9;

vector<int> seg;
vector<int> a;

void build(int v, int l, int r) {
    if (r - l == 1) {
        seg[v] = a[l];
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    seg[v] = max(seg[2 * v + 1], seg[2 * v + 2]);
}

int get(int ql, int qr, int v, int l, int r) {
    if (ql >= r || qr <= l) return 0;
    if (ql <= l && qr >= r) {
        return seg[v];
    }
    int m = (r + l) / 2;
    return max(get(ql, qr, 2 * v + 1, l, m), get(ql, qr, 2 * v + 2, m, r));
}

void solve() {
    int n, q;
    cin >> n >> q;
    seg.resize(4 * n);
    a.resize(n);
    for (auto &x: a) cin >> x;
    vector<int> b = {n + 1, n + 1};
    vector<int> pref(n), suf(n);
    for (int i = 0; i < n; ++i) {
        pref[i] = max((i - 1 < 0 ? 0 : pref[i - 1]), a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max((i + 1 == n ? 0 : suf[i + 1]), a[i]);
    }
    build(0, 0, n);
    for (int i = 0; i < n - 1; ++i) {
        if (pref[i] < b[0]) {
            b[0] = pref[i];
            b[1] = suf[i + 1];
        } else if (pref[i] == b[0] && suf[i + 1] < b[1]) {
            b[1] = suf[i + 1];
        }
    }
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        i--;
        if (k == 2) cout << b[i] << '\n';
        else if (k == 1) {
            cout << *max_element(a.begin(), a.end()) << '\n';
        } else {
            if (i < k) {
                cout << a[i] << '\n';
            }
            else {
                cout << suf[i] << '\n';
            }
        }
    }
}

int main() {
    solve();
    return 0;
}
