#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define vll vector<ll>
#define all(x) x.begin(), x.end()
#define speed ios::sync_with_stdio(false), cin.tie(nullptr);
#define pb push_back
#define ff first
#define ss second

const ll maxN = 1e5 + 1;

struct segtree {
    ll size; vll tree;

    void init(ll n) {
        size = 1;
        while (size < n) size *= 2;

        tree.assign(2 * size - 1, 0);
    }

    void up(int x) {
        tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
    }

    void set(int x, int lx, int rx, int i) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }

        int md = (rx + lx) / 2;

        if (i < md) {
            set(x * 2 + 1, lx, md, i);
        } else {
            set(x * 2 + 2, md, rx, i);
        }

        up(x);
    }

    void set(int i) {
        set(0, 0, size, i);
    }

    ll count(int x, int lx, int rx, int l, int r) {
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        if (rx <= l || lx >= r) {
            return 0;
        }

        int md = (rx + lx) / 2;

        ll ans = 0;

        ans += count(x * 2 + 1, lx, md, l, r);
        ans += count(x * 2 + 2, md, rx, l, r);

        return ans;
    }

    ll count(int l, int r) {
        return count(0, 0, size, l, r);
    }
};

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.ff == b.ff) {
        return a.ss < b.ss;
    }
    return a.ff < b.ff;
}


int main() {

    speed

    ll n, q; cin >> n >> q;

    vll a(n); for (auto &x : a) cin >> x;

    vll prefMax(n), suffMax(n);

    prefMax[0] = a[0];
    prefMax[n - 1] = a[n - 1];

    for (int i = 1; i < n; i++) prefMax[i] = max(a[i], prefMax[i - 1]);
    for (int i = n - 2; i >= 0; i--) suffMax[i] = max(a[i + 1], prefMax[i + 1]);

    vector<pair<ll, ll>> ans;

    for (int i = 0; i < n; i++) {
        ans.pb({prefMax[i], suffMax[i + 1]});
    }
    sort(all(ans), cmp);

    for (int i = 0; i < q; i++) {
        ll k, ind; cin >> k >> ind;

        if (ind == 1) cout << ans[0].ff << "\n";
        else cout << ans[0].ss << "\n";
    }


    return 0;
}