#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
using namespace std;
vector<int> parent;
vector<int> rang;
vector<bool> goodloop;
vector<int> used;
struct node {
    int x,y,num;
};
void make_m(int v) {
    parent[v] = v;
    rang[v] = 1;
}
int find_m(int v) {
    return parent[v] == v ? v : parent[v] = find_m(parent[v]);
}
void merge_m(int x, int y) {
    x = find_m(x);
    y = find_m(y);
    if (x != y) {
        if (rang[x]<rang[y]) {
            swap(x,y);
        }
        parent[y] = x;
        if (goodloop[y])goodloop[x] = true;
        if (rang[x] == rang[y]) {
            rang[x]++;
        }
    }
}
void dfs(int v, vector<node> & a,int c,ll &r) {
    used[v] = c;
    for (int i = 0;i<a.size();i++) {
        if (i==v)continue;
        if ((a[i].x-a[v].x) * (a[i].x-a[v].x) + (a[i].y - a[v].y) * (a[i].y - a[v].y) <= r*r) {
            if (used[i] == -1) {
                merge_m(i, v);
                dfs(i, a, c+1, r);
            }
            else {
                if ((used[v] - used[i])%2 == 0)goodloop[find_m(v)] = true;
            }
        }
    }
}
bool cmp(node a, node b) {
    if (a.x*a.x + a.y*a.y < b.x  * b.x + b.y*b.y)return true;
    return false;
}
bool cmp2(node a, node b) {
    if (a.num > b.num)return false;
    return true;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, r;
    cin>>n>>r;
    parent.resize(n);
    rang.resize(n);
    used.assign(n, -1);
    goodloop.resize(n);
    vector<node> a(n);
    for (int i=0;i<n;i++) {
        cin>>a[i].x>>a[i].y;
        a[i].num = i;
        make_m(i);
    }
    sort(a.begin(),a.end(), cmp);
    for (int i = 0;i<n;i++) {
        if (used[i] == -1)dfs(i,a,0,r);
    }
    // sort(a.begin(),a.end(), cmp2);
    for (int i = 0;i<n;i++) {
        if (goodloop[find_m(a[i].num)])cout<<1;
        else cout<<0;
    }
    return 0;

}