#include <vector>
#include <iostream>
#include <map>

using namespace std;

vector<vector<short int>> gr;
vector<short int> col;

bool det = false;
int sm = -1;

void dfs(int v) {
    for (auto u : gr[v]) {
        if (col[u] && col[u] == col[v]) {
            det = true;
            continue;
        }
        if (!col[u]) {
            col[u] = sm - col[v];
            dfs(u);
        }
    }
}

int main() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> xy(n);
    gr.resize(n);
    col.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> xy[i].first >> xy[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            long long d1 = xy[i].first - xy[j].first, d2 = xy[i].second - xy[j].second;
            if ((d1 * d1 + d2 * d2) <= ((long long)r) * ((long long)r)) {
                gr[i].push_back(j);
                gr[j].push_back(i);
                //cout << i << ' ' << j << '\n';
            }
        }
    }
    map<int, short int> mp;
    for (int i = 0; i < n; i++) {
        if (!col[i]) {
            det = false;
            sm += 4;
            col[i] = sm / 2;
            dfs(i);
            if (det) {
                mp[sm / 2] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << mp[col[i] - 1 + col[i] % 2];
    }
}