#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;


void solve() {
    ll n, q;
    cin >> n >> q;
    ll mx = 0;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
        mx = max(mx, el);
    }

    auto ps = a;
    for (ll i = n - 2; i >= 0; i--) {
        ps[i] = max(ps[i], ps[i + 1]);
    }

    while (q--) {
        ll k, i;
        cin >> k >> i;
        if (k == 1) {
            cout << ps[0] << '\n';
            continue;
        }
        if (k % 2) {
            if (i == k) {
                cout << a.back() << '\n';
            } else {
                cout << a[i - 1] << '\n';
            }
            continue;
        }

        cout << a[i - 1] << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
