#include<bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> gr;
vector<int> color;
int n;

int sq(int x){
    return x * x;
}

bool dfs(int v, int col){
    color[v] = col;
    if(col >= 99){
        for (auto u: gr[v]){
            if(color[u] != col){
                dfs(u, col);
            }
        }
        return true;
    }
    for (auto u: gr[v]){
        if(u != v && color[u] == color[v]){
            return false;
        }
        if(color[u] == 3 - color[v]){
            continue;
        }
        if(u != v){
            if(!dfs(u, 3 - col)){
               return false;
            }
        }
    }
    return true;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int r;
    cin >> n >> r;
    vector<pair<pair<int, int>, int>> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    gr.resize(n);
    for (int i = 0; i < n; i++){
        for (int j = a[i].first.first - r; j <= a[i].first.first + r; j++){
            for (int k = a[i].first.second - r; k <= a[i].first.second + r; k++){
                if(sq(j - a[i].first.first) + sq(k - a[i].first.second) <= sq(r)){
                    int l = -1, r = n;
                    while(r - l > 1){
                        int m = (l + r) / 2;
                        if(a[m].first == make_pair(j, k)){
                            gr[i].push_back(m);
                            break;
                        }
                        if(a[m].first <make_pair(j, k)){
                            l = m;
                        }else{
                            r = m;
                        }
                    }
                }
            }
        }
    }
    color.resize(n);
    for (int i = 0; i < n; i++){
        if(color[i] == 0){
            if(!dfs(i, 1)){
                dfs(i, 100);
            } else{
                dfs(i, 99);
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++){
        if(color[i] == 100){
            ans[a[i].second] = 1;
        }
    }
    for (auto u: ans){
        cout << u;
    }
}
