#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>
#include <queue>

using namespace std;
typedef long long ll;

const int maxn = 3e5, logn = 19;
int sp[logn][maxn], a[maxn], lg[maxn + 1];

int get(int l, int r) {
	int t = lg[r - l + 1];
	return min(sp[t][l], sp[t][r - (1<<t) + 1]);
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	for (int i = 2; i <= maxn; ++i) {
		lg[i] = lg[i / 2] + 1;
	}

	int n, q;
	cin >> n >> q;
	vector<int> k(q), x(q), id(n + 1), rt(n, n - 1), st;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		id[a[i]] = i;
		while (!st.empty() && a[st.back()] < a[i]) {
			rt[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
		sp[0][i] = a[i];
	}
	for (int lg = 1; lg < logn; ++lg) {
		for (int i = 0; i + (1<<lg) <= n; ++i) {
			sp[lg][i] = min(sp[lg - 1][i], sp[lg - 1][i + (1 << (lg - 1))]);
		}
	}
	vector<int> df;
	vector<vector<int>> rs(n + 1);
	vector<int> mx(n);
	for (int i = 0; i < q; ++i) {
		cin >> k[i] >> x[i];
		--x[i];
		df.push_back(k[i]);
	}
	mx[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		mx[i] = max(mx[i + 1], a[i]);
	}
	sort(df.begin(), df.end());
	df.resize(unique(df.begin(), df.end()) - df.begin());
	for (auto k : df) {
		int cr = 0;
		for (int p = 0; p < k; ++p) {
			if (p == k - 2) {
				rs[k].push_back(a[cr]);
				cr = rt[cr];
			}
			else {
				if (p == k - 1) {
					rs[k].push_back(mx[cr]);
				}
				else {
					rs[k].push_back(a[cr]);
					cr = id[get(cr + 1, min(rt[cr], n - (k - p) + 1))];
				}
			}
		}
	}

	for (int i = 0; i < q; ++i) {
		cout << rs[k[i]][x[i]] << '\n';
	}

	return 0;
}
