#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct ST {
    int sz = 1;
    vector<int> tr;
    ST(int n) {
        while (sz < n) sz *= 2;
        tr.assign(sz * 2, 0);
    }
    ll get(int v, int cl, int cr, int l, int r) {
        if (l <= cl && cr <= r) {
            return tr[v];
        } else if (cr <= l || cl >= r) {
            return 0;
        }
        int cm = (cl + cr) / 2;
        return get(v * 2, cl, cm, l, r) + get(v * 2 + 1, cm, cr, l, r);
    }
    void upd(int id) {
        tr[sz + id] = 1;
        for (int i = (sz + id) / 2; i >= 1; i /= 2) {
            tr[i] = tr[i * 2] + tr[i * 2 + 1];
        }
    }
};

ll get(vector<int> & arr) {
    //    -
    ST st((int)arr.size() + 10);
    ll ans = 0;
    for (int i = 0; i < (int)arr.size(); ++i) {
        ans += st.get(1, 0, st.sz, arr[i] + 1, st.sz);
        st.upd(arr[i]);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> arr[i][j];
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, 1e18));
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; --i) {
        ST st(n * m + 10), st2(n * m + 10);
        for (int j = m - 1; j >= 0; --j) {
            for (int k = n - 1; k > i; --k) {
                st.upd(arr[k][j]);
            }
            if (i < n - 1) {
                vector<int> b;
                ll cnt = dp[i + 1][j];
                for (int k = j; k < m; ++k) b.push_back(arr[i][k]);
                cnt += get(b);
                for (int k = j; k < m; ++k) {
                    cnt += st.get(1, 0, st.sz, 0, arr[i][k]);
                }
                if (cnt < dp[i][j]) {
                    dp[i][j] = cnt;
                }
            }
            if (j < m - 1) {
                vector<int> b;
                ll cnt = dp[i][j + 1];
                for (int k = i; k < n; ++k) b.push_back(arr[k][j]);
                cnt += get(b);
                for (int k = i; k < n; ++k) {
                    cnt += st2.get(1, 0, st2.sz, 0, arr[k][j]);
                }
                if (cnt < dp[i][j]) {
                    dp[i][j] = cnt;
                }
            }
            for (int k = i; k < n; ++k) {
                st2.upd(arr[k][j]);
            }
        }
    }
    cout << dp[0][0] << "\n";
    return 0;
}
