#include <bits/stdc++.h>
using namespace std;

struct ST {
    int sz = 1;
    vector<pair<int, int>> tr;
    ST(vector<int> & arr) {
        while (sz < (int)arr.size()) sz *= 2;
        tr.assign(sz * 2, make_pair(1e9, 1e9));
        for (int i = 0; i < (int)arr.size(); ++i) {
            tr[i + sz] = {arr[i], i};
        }
        for (int i = sz - 1; i >= 1; --i) {
            tr[i] = min(tr[i * 2], tr[i * 2 + 1]);
        }
    }
    pair<int, int> get(int v, int cl, int cr, int l, int r) {
        if (l <= cl && cr <= r) {
            return tr[v];
        } else if (cr <= l || cl >= r) {
            return {1e9, 1e9};
        }
        int cm = (cl + cr) / 2;
        return min(get(v * 2, cl, cm, l, r), get(v * 2 + 1, cm, cr, l, r));
    }
};
struct STA {
    int sz = 1;
    vector<pair<int, int>> tr;
    STA(vector<int> & arr) {
        while (sz < (int)arr.size()) sz *= 2;
        tr.assign(sz * 2, make_pair(0, 0));
        for (int i = 0; i < (int)arr.size(); ++i) {
            tr[i + sz] = {arr[i], i};
        }
        for (int i = sz - 1; i >= 1; --i) {
            tr[i] = max(tr[i * 2], tr[i * 2 + 1]);
        }
    }
    pair<int, int> get(int v, int cl, int cr, int l, int r) {
        if (l <= cl && cr <= r) {
            return tr[v];
        } else if (cr <= l || cl >= r) {
            return {0, 0};
        }
        int cm = (cl + cr) / 2;
        return max(get(v * 2, cl, cm, l, r), get(v * 2 + 1, cm, cr, l, r));
    }
};

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q; cin >> n >> q;
    vector<int> arr(n);
    for (auto & it : arr) cin >> it;
    vector<int> nxt(n);
    //  nxt
    for (int i = 0; i < n; ++i) {
        nxt[i] = n - 1;
        for (int j = i; j < n; ++j) {
            if (arr[i] < arr[j]) {
                nxt[i] = j;
                break;
            }
        }
    }
    vector<vector<int>> mem(n + 10);
    ST st(arr);
    STA sta(arr);
    for (int it = 0; it < q; ++it) {
        int k, i; cin >> k >> i;
        vector<int> ans;
        int cur = 0;
        while (k) {
            if (k == 1) {
                ans.push_back(sta.get(1, 0, sta.sz, cur, sta.sz).first);
                --k;
            } else {
                int r = st.get(1, 0, st.sz, cur + 1, min(nxt[cur] + 1, n - k + 2)).second; //   n - k 
                ans.push_back(sta.get(1, 0, sta.sz, cur, r).first);
                cur = r;
                --k;
            }
            //cout << cur << "\n";
        }
        cout << ans[i - 1] << "\n";
    }
    return 0;
}

/*



7 1
6 4 2 3 1 7 5
5 3



*/
