#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

constexpr int N = 100;
bool arr[N];
bool solo[N];
int solo_count[N];

int n, q;
int modif = 0;

void solve()
{
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
    {
        char sym;
        cin >> sym;
        arr[i] = sym == '1';
    }

    auto handle_seg = [&](int j, int len)
    {
        assert(len > 0);
        if (len == 1)
            return;

        int i = j - len + 1;
        for (int k = i; k <= j; ++k)
        {
            arr[k] = 0;
            ++modif;
        }
    };

    bool seg = false;
    int len = 0;

    for (int i = 0; i < n; ++i)
    {
        if (arr[i])
        {
            seg = true;
            ++len;
        }
        else
        {
            if (seg)
            {
                handle_seg(i - 1, len);
            }
            seg = false;
            len = 0;
        }
    }

    if (seg)
        handle_seg(n - 1, len);

    int mega = 0;
    int norm = 0;

    int i = 0;
    while (i < n)
    {
        int l = 0;
        for (; i + l < n; ++l)
        {
            bool needed = l % 2 == 0 ? true : false;
            if (arr[i + l] != needed)
                break;
        }
        int j = i + l - 1;
        if (j <= i)
        {
            ++i;
            continue;
        }
        if (arr[j] == false)
            --j;

        for (int x = i + 1; x < j; x += 4)
        {
            ++mega;
        }

        int len = j - i + 1;
        int segs = (len - 1) / 2;
        if (segs % 2 == 0)
        {
            ++norm;
        }

        for (int x = i; x <= j; ++x)
        {
            arr[x] = false;
        }

        i = j + 1;
    }

    for (int i = 0; i < n; ++i)
    {
        if (arr[i])
            ++norm;
    }

    for (int qq = 0; qq < q; ++qq)
    {
        int ans = modif;

        int k;
        cin >> k;

        ans += k;

        int d = min(k, mega);
        ans += d * 2;
        k -= d;
        int s = min(k, norm);
        ans += s;

        cout << ans << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}