#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

// vector<bool> tree;
// vector<bool> delta;

// void push(int v, int l, int r)
// {
//     if (!delta[v])
//         return;
//     tree[v] = true;
//     if (l != r - 1)
//     {
//         delta[v * 2 + 1] = true;
//         delta[v * 2 + 2] = true;
//     }
//     delta[v] = false;
// }

// void mod(int v, int l, int r, int L, int R)
// {
//     push(v, l, r);
//     if (R <= l || r <= L)
//         return;
//     if (L <= l && r <= R)
//     {
//         delta[v] = true;
//         push(v, l, r);
//         return;
//     }
//     int m = (l + r) / 2;
//     mod(v * 2 + 1, l, m, L, R);
//     mod(v * 2 + 2, m, r, L, R);
//     tree[v] = tree[v * 2 + 1] && tree[v * 2 + 2];
// }

// bool get(int v, int l, int r, int i)
// {
//     push(v, l, r);
//     if (l == r - 1)
//     {
//         assert(l == i);
//         return tree[v];
//     }
//     int m = (l + r) / 2;
//     if (i < m)
//     {
//         return get(v * 2 + 1, l, m, i);
//     }
//     return get(v * 2 + 2, m, r, i);
// }

void solve()
{
    int r;
    int n;
    cin >> n >> r;
    // coord -> (id, ans_id)
    map<int, pii> coords;
    // (coord, ans_id)
    vector<pii> arr(n);
    vector<bool> ans(n, false);

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i].first;
        arr[i].second = i;
    }

    sort(all(arr));

    for (int i = 0; i < n; ++i)
    {
        coords[arr[i].first] = {i, arr[i].second};
    }

    int p = -1;

    for (const auto [c, data] : coords)
    {
        int b = c + r;
        if (p >= c)
        {
            ans[data.second] = true;
        }
        else
        {
            auto it = coords.upper_bound(b);
            --it;
            pii r_data = it->second;
            int cnt = r_data.first - data.first + 1;
            if (cnt >= 3)
            {
                ans[data.second] = true;
            }
        }

        if (ans[data.second])
        {
            p = b;
        }
    }

    for (int i = 0; i < n; ++i)
    {
        cout << ans[i];
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}