#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int ans = 0;

vector<int> merge_sort(vector<int> arr)
{
    if (arr.size() == 1)
    {
        return arr;
    }
    int lsz = arr.size() / 2;
    int rsz = arr.size() - lsz;

    vector<int> l;
    vector<int> r;
    for (int i = 0; i < lsz; ++i)
    {
        l.push_back(arr[i]);
    }
    for (int i = lsz; i < arr.size(); ++i)
    {
        r.push_back(arr[i]);
    }

    l = merge_sort(l);
    r = merge_sort(r);

    int lp = 0, rp = 0;
    vector<int> res;
    res.reserve(arr.size());

    while (lp < lsz && rp < rsz)
    {
        if (l[lp] < r[rp])
        {
            res.push_back(l[lp]);
            ++lp;
        }
        else
        {
            res.push_back(r[rp]);
            ++rp;
            ans += lsz - lp;
        }
    }

    while (lp < lsz)
    {
        res.push_back(l[lp]);
        ++lp;
    }

    while (rp < rsz)
    {
        res.push_back(r[rp]);
        ++rp;
    }

    assert(res.size() == arr.size());

    return res;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    assert(n == 0);
    vector<int> arr(m);
    for (int i = 0; i < m; ++i)
        cin >> arr[i];

    merge_sort(arr);

    cout << ans << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}