#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#pragma optimize("unroll-loops")

vector<pair<ll, ll>> d;
vector<int> vis;
vector<ll> component;
vector<bool> h;
ll c = 1;
bool f = false;
ll n, r;

bool ch(ll i, ll j) {
    ll a = d[i].first - d[j].first;
    ll b = d[i].second - d[j].second;
    return (a * a + b * b <= r * r);
}

void dfs(ll u, ll p) {
    if (p == -1) {
        vis[u] = 1;
    } else {
        vis[u] = 3 - vis[p];
    }
    component[u] = c;
    for (ll v = 0; v < n; v++) {
        if (u != v && ch(u, v)) {
            if (vis[v] == 0) {
                dfs(v, u);
            } else if (vis[v] == vis[u]) {
                h[c - 1] = true;
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    d.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> d[i].first >> d[i].second;
    }
    vis.assign(n, 0);
    component.resize(n);
    for (ll i = 0; i < n; i++) {
        if (vis[i] == 0) {
            h.push_back(false);
            dfs(i, -1);
            c++;
        }
    }
    for (ll i = 0; i < n; i++) {
        if (h[component[i] - 1]) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}