#include <bits/stdc++.h>
#include <cmath>

using namespace std;
mt19937 rnd(time(0));

//#define int long long
//#define endl "\n"

const int maxn = 1e5 + 5;
int x[maxn], y[maxn];
vector <int> g[maxn];
bool ans[maxn], used[maxn], used1[maxn];
int clr[maxn];
map <pair <int, int>, int> mp;
bool f = false;


void paint(int v, int r) {
    used[v] = true;
    if (clr[v] == 0) clr[v] = -clr[r];
    for (auto u : g[v]) {
        if (!used[u]) paint(u, v);
    }
}


void get_ans(int v) {
    used[v] = true;
    if (ans[v]) f = true;
    for (auto u : g[v]) {
        if (used[u]) continue;
        get_ans(u);
    }
}


void push_ans(int v) {
    ans[v] = true;
    used1[v] = true;
    for (auto u : g[v]) {
        if (used1[u]) continue;
        push_ans(u);
    }
}


void solve() {
    int n, r;
    cin >> n >> r;
    vector <vector <int>> px;
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> y[i];
        mp[{x[i], y[i]}] = i;
    }
    for (int i = 1; i <= n; i++) {
        for (int x1 = x[i] - r; x1 <= x[i] + r; x1++) {
            for (int y1 = y[i] - r; y1 <= y[i] + r; y1++) {
                if (x1 == x[i] && y1 == y[i]) continue;
                if ((long long)(x[i] - x1) * (x[i] - x1) + (long long)(y[i] - y1) * (y[i] - y1) > (long long)r * r) continue;
                int ind = mp[{x1, y1}];
                if (ind != 0) {
                    g[i].push_back(ind);
                    //cout << i << ' ' << ind << endl;
                }
            }
        }
    }
    clr[0] = 1;
    for (int i = 1; i <= n; i++) {
        if (used[i]) continue;
        paint(i, 0);
    }
    for (int i = 1; i <= n; i++) {
        for (auto j : g[i]) {
            if (clr[i] == clr[j]) ans[i] = true;
        }
    }
    for (int i = 0; i <= n; i++) {
        used[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            get_ans(i);
            if (f) {
                f = false;
                push_ans(i);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!ans[i]) cout << 0;
        else cout << 1;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}