#include <bits/stdc++.h>
#include <cmath>

using namespace std;
mt19937 rnd(time(0));

#define int long long
#define endl "\n"


const int maxn = 3e5;
int a[maxn];
vector <int> tree[maxn * 4];


void upd(int v, int l, int r, int i, int x) {
    if (l == r) {
        tree[v] = {x};
        return;
    }
    if (l > i || r < i) return;
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, i, x);
    upd(2 * v + 2, m + 1, r, i, x);
    tree[v].push_back(x);
    int j = tree[v].size() - 1;
    while (j > 0 && tree[v][j] < tree[v][j - 1]) {
        swap(tree[v][j], tree[v][j - 1]);
        j--;
    }
}


int get(int v, int l, int r, int ql, int qr, int x) {
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) {
        int lt = -1, rt = tree[v].size();
        while (rt - lt > 1) {
            int md = (lt + rt) / 2;
            if (tree[v][md] < x) lt = md;
            else rt = md;
        }
        return tree[v].size() - lt - 1;
    }
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr, x) + get(2 * v + 2, m + 1, r, ql, qr, x);
}


void solve() {
    int r, c;
    cin >> r >> c;
    int C = c + 1;
    for (int i = 1; i <= c; i++) cin >> a[i];
    int ans = 0;
    for (int i = 1; i <= c; i++) {
        if (i != 1) ans += get(0, 1, c, 1, i - 1, a[i]);
        upd(0, 1, c, i, a[i]);
    }
    cout << ans;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}