#include<bits/stdc++.h>

using namespace std;
#define int long long

int get(pair<int, int> a, pair<int, int> b) {
    return abs(a.first - b.first) * abs(a.first - b.first) + abs(a.second - b.second) * abs(a.second - b.second);
}

vector<bool> used;

vector<vector<int>> g;

void dfs(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (used[u]) continue;
        dfs(u);
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    r *= r;
    g.assign(2 * n + 10, vector<int> ());
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    string ans = "";
    for (int i = 0; i < n; i++) {
        ans.push_back('0');
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (get(a[i], a[j]) <= r){
                g[i].push_back(n + j);
                g[n + j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        used.assign(2 * n + 10, false);
        dfs(i);
        if (used[n + i]) {
            ans[i] = '1';
        }
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.