#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int> > dp(n + 1);
    for (int k = 1; k <= n; ++k) {
        if (k == 1) {
            int mx = 0;
            for (int i = n - 1; i >= 0; --i) {
                mx = max(mx, a[i]);
            }
            dp[k] = {mx};
        } else if (k == 2) {
            vector<int> mx1(n), mx2(n);
            for (int i = 0; i < n; ++i) {
                if (i > 0) {
                    mx1[i] = mx1[i - 1];
                }
                mx1[i] = max(mx1[i], a[i]);
            }
            for (int i = n - 1; i >= 0; --i) {
                if (i != n - 1) {
                    mx2[i] = mx2[i + 1];
                }
                mx2[i] = max(mx2[i], a[i]);
            }
            dp[2] = {INF, INF};
            for (int i = 0; i < n - 1; ++i) {
                dp[2] = min(dp[2], {mx1[i], mx2[i + 1]});
            }
        } else {
            int k1 = k;
            int l = 0;
            while (k1 > 2) {
                int le = INF;
                for (int i = l + 1; i < n; ++i) {
                    if (a[i] > a[l]) {
                        le = i - 1;
                        break;
                    }
                }
                le = min(le, n - k1);
                int mx = INF;
                int p = -1;
                for (int i = l + 1; i <= le + 1; ++i) {
                    if (a[i] < mx) {
                        mx = a[i];
                        p = i;
                    }
                }
                dp[k].push_back(a[l]);
                l = p;
                k1--;
            }
            vector<int> mx1(n), mx2(n);
            for (int i = l; i < n; ++i) {
                if (i > l) {
                    mx1[i] = mx1[i - 1];
                }
                mx1[i] = max(mx1[i], a[i]);
            }
            for (int i = n - 1; i >= 0; --i) {
                if (i != n - 1) {
                    mx2[i] = mx2[i + 1];
                }
                mx2[i] = max(mx2[i], a[i]);
            }
            pair<int,int> d1 = {INF, INF};
            for (int i = l; i < n - 1; ++i) {
                d1 = min(d1, {mx1[i], mx2[i + 1]});
            }
            dp[k].push_back(d1.first);
            dp[k].push_back(d1.second);
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << dp[k][i - 1] << "\n";
    }
}
