#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

vector<pair<int,int> > t;
vector<int> a;

void build(int v,int l,int r) {
    if (r - l == 1) {
        t[v] = {a[l], l};
    } else {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v, m, r);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
}

pair<int,int> get(int v,int l,int r,int ql,int qr) {
    if (l == ql && qr == r) {
        return t[v];
    }
    int qm = (ql + qr) / 2;
    if (qm >= r) {
        return get(2 * v, l, r, ql, qm);
    } else if (qm <= l) {
        return get(2 * v + 1, l, r, qm, qr);
    } else {
        return min(get(2 * v, l, qm, ql, qm), get(2 * v + 1, qm, r, qm, qr));
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    t.resize(4 * n + 5);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(1, 0, n);
    vector<vector<int> > dp(n + 1);
    vector<int> le1(n);
    vector<pair<int,int> > t;
    for (int i = n - 1; i >= 0; --i) {
        while (t.size() > 0 && t.back().first < a[i]) {
            t.pop_back();
        }
        if (t.size() == 0) {
            le1[i] = n;
        } else {
            le1[i] = t.back().second;
        }
        t.push_back({a[i], i});
    }
    for (int k = 1; k <= min(n, 3ll); ++k) {
        if (k == 1) {
            int mx = 0;
            for (int i = n - 1; i >= 0; --i) {
                mx = max(mx, a[i]);
            }
            dp[k] = {mx};
        } else if (k == 2) {
            vector<int> mx1(n), mx2(n);
            for (int i = 0; i < n; ++i) {
                if (i > 0) {
                    mx1[i] = mx1[i - 1];
                }
                mx1[i] = max(mx1[i], a[i]);
            }
            for (int i = n - 1; i >= 0; --i) {
                if (i != n - 1) {
                    mx2[i] = mx2[i + 1];
                }
                mx2[i] = max(mx2[i], a[i]);
            }
            dp[2] = {INF, INF};
            for (int i = 0; i < n - 1; ++i) {
                dp[2] = min(dp[2], {mx1[i], mx2[i + 1]});
            }
        } else {
            int k1 = k;
            int l = 0;
            while (k1 > 2) {
                int le = le1[l] - 1;
                le = min(le, n - k1);
                auto [mx,p] = get(1, l + 1, le + 2, 0, n);
                dp[k].push_back(a[l]);
                l = p;
                k1--;
            }
            vector<int> mx1(n), mx2(n);
            for (int i = l; i < n; ++i) {
                if (i > l) {
                    mx1[i] = mx1[i - 1];
                }
                mx1[i] = max(mx1[i], a[i]);
            }
            for (int i = n - 1; i >= 0; --i) {
                if (i != n - 1) {
                    mx2[i] = mx2[i + 1];
                }
                mx2[i] = max(mx2[i], a[i]);
            }
            pair<int,int> d1 = {INF, INF};
            for (int i = l; i < n - 1; ++i) {
                d1 = min(d1, {mx1[i], mx2[i + 1]});
            }
            dp[k].push_back(d1.first);
            dp[k].push_back(d1.second);
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << dp[k][i - 1] << "\n";
    }
}
