#include <bits/stdc++.h>
#define int long long

using namespace std;

struct point {
    int x, y;

    int dist(point other) {
        return (x - other.x) * (x - other.x) + (y - other.y) * (y - other.y);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, r; cin >> n >> r;

    r = r * r;

    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;

        a[i] = {x, y};
    }

    vector<bool> d1(n, false), d2(n, false);
    d1[0] = true;

    queue<pair<int, int>> q;
    q.emplace(0, 1);

    while (!q.empty()) {
        auto [i, idx] = q.front(); q.pop();

        idx++;

        for (int j = 0; j < n; ++j) {
            if (i == j) continue;

            if (idx % 2) {
                if (d2[j]) continue;

                if (a[i].dist(a[j]) <= r) {
                    d2[j] = true;
                    q.emplace(j, idx);
                }
            } else {
                if (d1[j]) continue;

                if (a[i].dist(a[j]) <= r) {
                    d1[j] = true;
                    q.emplace(j, idx);
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (d2[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
}