#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

vector<vector<long long>> v;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long r, c;
	cin >> r >> c;
	v.resize(r, vector<long long>(c));
	for (long long i = 0; i < r; i++) {
		for (long long j = 0; j < c; j++) {
			cin >> v[i][j];
		}
	}
	long long mu = r + c + 1;
	long long ans = 1e18;
	for (long long mask = 0; mask <= (1 << mu); mask++) {
		deque<long long> h;
		for (auto ch : v[r - 1]) {
			h.push_back(ch);
		}
		long long i = 0, j = 0;
		for (long long k = 0; k < mu; k++) {
			if (((1 << k) & mask) != 0) {
				if (j == c) {
					break;
				}
				h.pop_front();
				for (long long ii = i; ii < r; ii++) {
					h.push_back(v[ii][j]);
				}
				j++;
			}
			else {
				if (i == r) {
					break;
				}
				for (long long jj = j; jj < c; jj++) {
					h.push_back(v[i][jj]);
				}
				i++;
			}
		}
		if (h.size() == r * c) {
			long long much = 0;
			for (long long i1 = 0; i1 < h.size(); i1++) {
				for (long long i2 = i1 + 1; i2 < h.size(); i2++) {
					if (h[i1] > h[i2]) {
						much++;
					}
				}
			}
			ans = min(much, ans);
		}
	}
	cout << ans;
}