#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    long long r;
    cin >> n >> r;
    long long h;
    vector<pair<long long, int>> p(n);
    for (int i = 0; i < n; i++) {cin >> p[i].first  >> h; p[i].second = i;}
    sort(p.begin(), p.end());
    vector<bool> ans(n);
    for (int i = 0; i < n - 2; i++) {
        if (p[i + 2].first - p[i].first <= r) ans[p[i].second] = true;
    }
    for (int i = 0; i < n; i++) {
        if (!ans[p[i].second]) continue;
        for (int j = i - 1; j >= 0; j--) {
            if (ans[p[j].second] || p[j + 1].first - p[j].first > r) break;
            ans[p[j].second] = true;
        }
        for (int j = i + 1; j < n; j++) {
            if (ans[p[j].second] || p[j].first- p[j - 1].first > r) break;
            ans[p[j].second] = true;
        }
    }
    for (auto i : ans) cout << i;


    return 0;
}