#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    long long r;
    cin >> n >> r;
    long long h;
    vector<long long> p(n);
    for (int i = 0; i < n; i++) cin >> p[i]  >> h;
    vector<bool> ans(n);
    for (int i = 0; i < n - 2; i++) {
        if (p[i + 2] - p[i] <= r) ans[i] = true, ans[i + 1] = true, ans[i + 2] = true;
    }
    for (int i = 0; i < n; i++) {
        if (!ans[i]) continue;
        for (int j = i - 1; j >= 0; j--) {
            if (ans[j] || p[j + 1] - p[j] > r) break;
            ans[j] = true;
        }
        for (int j = i + 1; j < n; j++) {
            if (ans[j] || p[j] - p[j - 1] > r) break;
            ans[j] = true;
        }
    }
    for (auto i : ans) cout << i;


    return 0;
}