#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Point {
    ll x, y;
    int i;
    Point() = default;
    Point(ll x, ll y, int i): x(x), y(y), i(i) {

    }
    ll dist(Point b) {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
};
vector<vector<ll>> g;
vector<int> us;
vector<int> bd;

void dfs(int v, int c) {
    if (us[v] == 1 - c) {
        bd[v] = 1;
        return;
    }
    if (us[v] != -1) return;
    us[v] = c;
    for (auto i : g[v]) dfs(i, 1 - c);
}
void dfsb(int v) {
    if (us[v]) {
        return;
    }
    us[v] = 1;
    bd[v] = 1;
    for (auto i : g[v]) dfsb(i);
}


int main() {
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> p;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        p.push_back(Point(x, y, i));
    }
    g.resize(n);
    us.assign(n, -1);
    bd.assign(n, 0);
    //sort(p.begin(), p.end(), [&](Point a, Point b){return a.x < b.x;});
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) if (i != j) {
            if (p[i].dist(p[j]) <= r * r) g[i].push_back(j);
        }
    }
    for (int i = 0; i < n; i++) {
        if (us[i] == -1) dfs(i, 0);
    }
    us.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (bd[i]) dfsb(i);
    }
    for (auto i : bd) cout << i;
}