#include <bits/stdc++.h>
using namespace std;
using ll = long long;
# define ff first
# define ss second
# define all(a) (a).begin(), (a).end()
# define rall(a) (a).rbegin(), (a).rend()
using ld = long double;

void Solve() {
    ll n, r;
    cin >> n >> r;
    r *= r;
    vector<pair<ll, ll>> a(n);
    unordered_map<pair<ll, ll>, ll> mp;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].ff >> a[i].ss;
        mp[a[i]] = i + 1;
    }
    auto dist = [&](pair<ll, ll> a, pair<ll, ll> b) {
        return (a.ff - b.ff) * (a.ff - b.ff) + (a.ss - b.ss) * (a.ss - b.ss);
    };
    queue<ll> q;
    ll cnt = 1;
    string ans(n, '0');
    vector<vector<ll>> used(n, vector<ll>(2));
    for (ll i = 0; i < n; ++i) {
        if (!used[i][0] && !used[i][1]) {
            cnt++;
            bool pon = false;
            queue<pair<ll, ll>> q;
            queue<ll> vis;
            q.push({i, 0});
            while (!q.empty()) {
                auto [v, c] = q.front();
                q.pop();
                vis.push(v);
                used[v][c] = 1;
                if (used[v][c] && used[v][!c]) {
                    ans[v] = '1';
                }
                for (ll xx = 0; xx * xx <= min(r, 4); ++xx) {
                    for (ll yy = 0; xx * xx + yy * yy <= min(r, 4); ++yy) {
                        ll to = mp[{a[v].ff + xx, a[v].ss + yy}];
                        if (to && !used[to - 1][!c] && v != to - 1) {
                            to--;
                            used[to][!c] = 1;
                            q.push({to, !c});
                        }
                        to = mp[{a[v].ff - xx, a[v].ss + yy}];
                        if (to && !used[to - 1][!c] && v != to - 1) {
                            to--;
                            used[to][!c] = 1;
                            q.push({to, !c});
                        }
                        to = mp[{a[v].ff + xx, a[v].ss - yy}];
                        if (to && !used[to - 1][!c] && v != to - 1) {
                            to--;
                            used[to][!c] = 1;
                            q.push({to, !c});
                        }
                        to = mp[{a[v].ff - xx, a[v].ss - yy}];
                        if (to && !used[to - 1][!c] && v != to - 1) {
                            to--;
                            used[to][!c] = 1;
                            q.push({to, !c});
                        }
                    }
                }
            }
        }
    }
    cout << ans << '\n';
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0); // для вайба
    ll tt = 1;
    // cin >> tt;
    while (tt--) Solve();
    return 0;
}