#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <unordered_set>

using namespace std;

typedef long long ll;

int getmax(vector<int>& a, int k, int i)
{
	int maxx = 0;
	for (int j = k + 1; j <= i; ++j)
		maxx = max(maxx, a[j - 1]);
	return maxx;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1));
	for (int i = 1; i < n + 1; ++i)
	{
		for (int j = 1; j < n + 1; ++j)
		{
			for (int k = j - 1; k < i; ++k)
			{
				if (dp[k][j - 1].empty())
					continue;
				vector<int> newdp = dp[k][j - 1];
				newdp.push_back(getmax(a, k, i));
				if (dp[i][j].empty())
					dp[i][j] = newdp;
				else
					dp[i][j] = min(dp[i][j], newdp);
			}
		}
	}
	for (int i = 0; i < q; ++i)
	{
		int k, x;
		cin >> k >> x;
		cout << dp[n][k][x - 1] << '\n';
	}
	return 0;
}
