#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;

vector <vector <int>> a;
int r, c;

vector <int> t;

void update(int v, int l, int r, int pos, int x) {
    if (r - l == 1) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) update(2 * v + 1, l, m, pos, x);
    else update(2 * v + 2, m, r, pos, x);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
 
int get(int v, int l, int r, int lq, int rq) {
    if (r <= lq || rq <= l) return 0;
    if (lq <= l && r <= rq) return t[v];
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, lq, rq) + get(2 * v + 2, m, r, lq, rq);
}

int check(vector <int> &p) {
    vector <int> b;
    int ans = 0;
    int i = 0, j = 0;
    for (int k = 0; k < p.size(); ++k) {
        if (p[k] == 2) {
            for (int l = i; l < r; ++l) b.push_back(a[l][j]);
            ++j;
        } else {
            for (int l = j; l < c; ++l) b.push_back(a[i][l]);
            ++i;
        }
    }
    b.push_back(a.back().back());
    for (int i = b.size() - 1; i >= 0; --i) {
        ans += get(0, 0, r * c, 0, b[i]);
        update(0, 0, r * c, b[i] - 1, 1);
    }
    for (int i = 0; i < b.size(); ++i) {
        update(0, 0, r * c, b[i] - 1, 0);
    }
    return ans;
}

int main() {
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> r >> c;
    a.resize(r, vector <int> (c));
    t.resize(4 * r * c);
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    cout << 0;
}