#include <bits/stdc++.h>

using namespace std;

mt19937 rng(141387);

float rnd() {
    return (float)rng() / rng.max();
}

bool tr(long long a, long long b, float t) {
    float p = exp((a - b) / t);
    return rnd() < p;
}

int n, m;
vector<vector<int>> mtx;

long long ff(vector<int> p) {
    int minRow = 0, minCol = 0;
    vector<int> arr;
    for(auto x : p) {
        if(x) {
            for(int i = minRow; i < n; i++) {
                arr.push_back(mtx[i][minCol]);
            }
            minCol++;
        } else {
            for(int i = minCol; i < m; i++) {
                arr.push_back(mtx[minRow][i]);
            }
            minRow++;
        }
    }
    long long ans = 0;
    for(int i = 0; i < arr.size(); i++) {
        for(int j = 0; j < i; j++) {
            if(arr[j] > arr[i]) ans++;
        }
    }
    return ans;
}

int main() {
    cin >> n >> m;
    mtx.resize(n, vector<int>(m));
    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) cin >> mtx[i][j];
    vector<int> p(n + m);
    fill(p.begin(), p.begin() + m, 1);
    clock_t stm = clock();
    clock_t maxtm = (clock_t)(CLOCKS_PER_SEC * 0.96) + stm;
    float t = 1.0f;
    long long cans = ff(p);
    long long minans = cans;
    while(clock() < maxtm) {
        t *= 0.99f;
        int a = rng() % p.size(), b = rng() % p.size();
        swap(p[a], p[b]);
        long long nans = ff(p);
        // if(nans == 0) {
        //     cout << ">>> ";
        //     for(auto i : p) cout << i + 1 << ' ';
        //     cout << '\n';
        //     break;
        // }
        minans = min(minans, nans);
        if(tr(cans, nans, t)) cans = nans;
        else swap(p[a], p[b]);
    }
    cout << minans << '\n';
}
