#include<bits/stdc++.h>

#define int long long

using namespace std;

vector<int> fenw;

void add(int pos, int val) {
    for (pos; pos > 0; pos -= pos & -pos) {
        fenw[pos] += val;
    }
}

int get(int pos) {
    int ans = 0;
    for (pos; pos < (int) fenw.size(); pos += pos & -pos) {
        ans += fenw[pos];
    }
    return ans;
}

signed main() {
    // ios_base::sync_with_stdio(false), cin.tie(nullptr);
    int r, c;
    cin >> r >> c;
    vector<vector<int> > a(r, vector<int>(c));
    fenw.resize(r * c + 1);
    for (auto &i: a) {
        for (auto &j: i) {
            cin >> j;
        }
    }
    vector<vector<int> > ra(r + 1, vector<int>(c + 1, LLONG_MAX));
    vector<vector<vector<int> > > arr(r + 1, vector<vector<int> >(c + 1));
    ra[0][0] = 0;

    function<int(int, int, int)> cost = [&](int row, int col, int mod) {
        fill(fenw.begin(), fenw.end(), 0);
        int ans = 0;
        if (!mod) {
            vector<int> cur = arr[row - 1][col];
            for (int j = col + 1; j <= c; ++j) {
                cur.push_back(a[row - 1][j - 1]);
            }
            for (int i = 0; i < cur.size(); ++i) {
                add(cur[i], 1);
                ans += get(cur[i] + 1);
            }
        } else {
            vector<int> cur = arr[row][col - 1];
            for (int j = row + 1; j <= r; ++j) {
                cur.push_back(a[j - 1][col - 1]);
            }
            for (int i = 0; i < cur.size(); ++i) {
                add(cur[i], 1);
                ans += get(cur[i] + 1);
            }
        }
        return ans;
    };
    ra[0][0] = 0;
    for (int i = 0; i <= r; ++i) {
        for (int j = 0; j <= c; ++j) {
            if (!i && !j) continue;
            int x = (i ? cost(i, j, 0) : LLONG_MAX), y = (j ? cost(i, j, 1) : LLONG_MAX);
            if (x < y) {
                ra[i][j] = x;
                arr[i][j] = arr[i - 1][j];
                for (int j1 = j + 1; j1 <= c; ++j1) {
                    arr[i][j].push_back(a[i - 1][j1 - 1]);
                }
            } else {
                ra[i][j] = y;
                arr[i][j] = arr[i][j - 1];
                for (int j1 = i + 1; j1 <= r; ++j1) {
                    arr[i][j].push_back(a[j1 - 1][j - 1]);
                }
            }
        }
    }
    cout << ra[r][c];
}
