#include <iostream>
#include <vector>

struct point
{
    long long x;
    long long y;
};

long long dist(point a, point b)
{
    return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}

long long r;

bool can(point a, point b)
{
    return (dist(a, b) <= r*r);
}

int main()
{
    int n;
    std::cin >> n >> r;
    std::vector<point> v(n);
    for (int i = 0; i < n; i++)
        std::cin >> v[i].x >> v[i].y;
    if (n < 3)
        std::cout << '0'*n;
    else if (n == 3)
    {
        if (can(v[0], v[1]) && can(v[1], v[2]) && can(v[0], v[2]))
            std::cout << "111";
        else
            std::cout << "000";
    }
}