#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> tree;

int get(int x, int l, int r, int ql, int qr)
{
    if (r <= ql || qr <= l)
    {
        return 0;
    }
    if (r <= qr && l >= ql)
    {
        return tree[x];
    }
    int m = (r + l) / 2;
    return get(2 * x + 1, l, m, ql, qr) + get(2 * x + 2, m, r, ql, qr);
}

void upd(int x, int l, int r, int pos)
{
    if (r - l == 1)
    {
        tree[x] = 1;
        return;
    }
    int m = (r + l) / 2;
    if (pos < m)
    {
        upd(2 * x + 1, l, m, pos);
    }
    else
    {
        upd(2 * x + 2, m, r, pos);
    }
    tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIRAIN
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n;
    cin >> n >> n;
    vector<int> a(n);
    for (auto &x : a)
        cin >> x;
    int sz = 1;
    while (sz < n)
    {
        sz *= 2;
    }
    sz *= 4;
    tree.assign(sz, 0);
    int res = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        // cout << get(0, 0, n, 0, a[i] - 1) << endl;
        res += get(0, 0, n, 0, a[i] - 1);
        upd(0, 0, n, a[i] - 1);
    }
    int res2 = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i+1; j < n; j++)
        {
            res2 += (a[i] > a[j]);
        }
    }
    if (res != res2)
    {
        cout << res << " " << res2 << endl;
        exit(-1);
    }
    cout << res << endl;
    return 0;
}