#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> pos;
vector<ll> gl;
vector<vector<ll> > g;

struct point {
    ll x, y;

    point() : x(0), y(0) {
    };

    point(ll x1, ll y1) : x(x1), y(y1) {
    };
};

ll rast2(point p1, point p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

bool cmp(point &p1, point &p2) {
    return (p1.x < p2.x || (p1.x == p2.x && p1.y < p2.y));
}

set<ll> st;

bool dfs(ll v) {
    st.insert(v);
    pos[v] = true;
    bool flag = false;
    for (auto u: g[v]) {
        if (!pos[u]) {
            gl[u] = gl[v] + 1;
            if (dfs(u)) {
                flag = true;
            }
        } else {
            if ((gl[v] - gl[u] + 1) % 2 == 1) {
                flag = true;
            }
        }
    }
    return flag;
}

signed main() {
    ll n, r;
    cin >> n >> r;
    pos.resize(n, false);
    gl.resize(n, 0);
    g.resize(n);

    vector<point> a;
    map<pair<int, int>, int> mp;
    for (ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        mp[{x, y}] = i;
        a.push_back(point(x, y));
    }

    for (int i = 0; i < n; i++) {
        ll x = a[i].x;
        ll y = a[i].y;
        for (ll x1 = x - r; x1 <= x + r; x1++) {
            for (ll y1 = y - r; y1 <= y + r; y1++) {
                pair<int, int> p = {x1, y1};
                if (x1 == x && y1 == y){continue;}
                if (mp.find(p)!=mp.end()) {
                    if (rast2(a[i],point(x1,y1))<=r*r) {
                        g[i].push_back(mp[p]);
                    }
                }
            }
        }
    }

    vector<ll> ans(n, 0);
    for (ll i = 0; i < n; i++) {
        if (!pos[i]) {
            st.clear();
            gl[i] = 0;
            bool flag = dfs(i);
            if (flag) {
                for (auto v: st) {
                    ans[v] = 1;
                }
            }
        }
    }
    for (auto i: ans) {
        cout << i;
    }
}
