#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int tree[400][100];
vector<vector<int>> b;
int r1,c1;

int n;

void build(int i,int l,int r,vector<int> &a) {
    // cout << i << ' ' << l << ' ' << r << endl;
    // cout << tree[i*2+1][0] << ' ' << tree[i*2+1][1] << '|';
    // for (int i3=2;i3<tree[i*2+1][0]+2;i3++) {
    //     cout << tree[i*2+1][i3] << ' ';
    // }cout << endl;
    // cout << tree[i*2+2][0] << ' ' << tree[i*2+2][1] << '|';
    // for (int i3=2;i3<tree[i*2+2][0]+2;i3++) {
    //     cout << tree[i*2+2][i3] << ' ';
    // }cout << endl;
    if (r-l==1) {
        tree[i][0] = 1;
        tree[i][1] = 0;
        tree[i][2] = a[l];
        return;
    }
    int m = (r+l)/2;
    build(i*2+1,l,m,a);
    build(i*2+2,m,r,a);
    tree[i][0] = tree[i*2+1][0] + tree[i*2+2][0];
    tree[i][1] = tree[i*2+1][1] + tree[i*2+2][1];
    int i1 = 2;
    int i2 = 2;
    int j = 2;
    int n1 = tree[i*2+1][0];
    int n2 = tree[i*2+2][0];

    while (i1 < n1+2 || i2 < n2+2) {
        if (i1 == n1+2) {
            tree[i][j] = tree[i*2+2][i2];
            i2++;
            j++;
        }else if (i2 == n2+2) {
            tree[i][j] = tree[i*2+1][i1];
            i1++;
            j++;
        }else {
            if (tree[i*2+1][i1] < tree[i*2+2][i2]) {
                tree[i][j] = tree[i*2+1][i1];
                i1++;
                j++;
            }else {
                tree[i][j] = tree[i*2+2][i2];
                i2++;
                j++;
                tree[i][1]+= n1 - (i1-2);
            }
        }
    }
    // for (int ij=0;ij<tree[i][0]+2;ij++) {
    //     cout << tree[i][ij] << ' ';
    // }cout << endl;
    // cout << '(' << tree[i][1] << ')' << endl;
}

int build(vector<int> a) {
    for (int i=0;i<400;i++) {
        for (int j=0;j<100;j++) {
            tree[i][j] = 0;
        }
    }
    build(0,0,a.size(),a);
    return tree[0][1];
}

int dfs(vector<int> v) {
    int r = b.size();
    int c = b[0].size();
    if (r1 == r || c1 == c) {
        int a11 = build(v);

        // cout << a11 << '|';
        // for (auto i : v) {
        //     cout << i << ' ';
        // }cout << endl;

        return a11;
    }
    for (int i=r1;i<r;i++) {
        v.push_back(b[i][c1]);
    }
    c1++;
    int a1 = dfs(v);
    c1--;
    for (int i=r1;i<r;i++) {
        v.pop_back();
    }
    for (int i=c1;i<c;i++) {
        v.push_back(b[r1][i]);
    }
    r1++;
    int a2 = dfs(v);
    r1--;
    for (int i=c1;i<c;i++) {
        v.pop_back();
    }
    return min(a1,a2);
}

signed main() {
    int r,c;
    cin >> r >> c;
    b.resize(r,vector<int>(c,0));
    for (int i=0;i<r;i++) {
        for (int j=0;j<c;j++) {
            cin >> b[i][j];
        }
    }

    r1 = 0;
    c1 = 0;

    int ans = dfs({});
   cout << ans << endl;
}
