// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int tree1[1200000];
int tree2[1200000];
vector<int> a;

void build(int i,int l,int r) {
    if (r-l==1) {
        tree1[i] = l;
        tree2[i] = l;
        return;
    }
    int m = (r+l)/2;
    build(i*2+1,l,m);
    build(i*2+2,m,r);
    int i1 = tree1[i*2+1];
    int i2 = tree1[i*2+2];
    int j1 = tree2[i*2+1];
    int j2 = tree2[i*2+2];
    if (a[i2] < a[i1]) {
        i1 = i2;
    }
    if (a[j2] > a[j1]) {
        j1 = j2;
    }
    tree1[i] = i1;
    tree2[i] = j1;
}

int get_min(int i,int l,int r,int q_l,int q_r) {
    if (r<=q_l || q_r <= l) {
        return a.size()-2;
    }
    if (q_l <= l && r <= q_r) {
        return tree1[i];
    }
    int m = (r+l)/2;
    int i1 = get_min(i*2+1,l,m,q_l,q_r);
    int i2 = get_min(i*2+2,m,r,q_l,q_r);
    if (a[i2] < a[i1]) {
        i1 = i2;
    }
    return i1;
}

int get_max(int i,int l,int r,int q_l,int q_r) {
    if (r<=q_l || q_r <= l) {
        return a.size()-1;
    }
    if (q_l <= l && r <= q_r) {
        return tree2[i];
    }
    int m = (r+l)/2;
    int i1 = get_max(i*2+1,l,m,q_l,q_r);
    int i2 = get_max(i*2+2,m,r,q_l,q_r);
    if (a[i2] > a[i1]) {
        i1 = i2;
    }
    return i1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin >> n >> q;
    a.resize(n);
    a.push_back(INT_MAX);
    a.push_back(-1);
    for (int i=0;i<n;i++) {
        cin >> a[i];
    }

    build(0,0,n);

    while (q--) {
        int k,d;
        cin >> k >> d;
        if (d<k) {
            cout << a[d-1] << endl;
        }else {
            cout << a[get_max(0,0,n,k,n)] << endl;
        }
    }
}
