#include <bits/stdc++.h>
#define int long long
using namespace std;

struct point {
    int x, y;
};

int sqr(int x) {return x * x;}

bool dist(point a, point b, int r) {
    return (sqr(a.x - b.x) + sqr(a.y - b.y) <= sqr(r));
}

struct p {
    int u, type;
};
int n;
vector<vector<p>> g;
vector<int> used;

void dfs(int v, int type) {
    used[v] = type;

    for (auto x : g[v]) {
        if (used[x.u] == -1) {
            dfs(x.u, type);
        }
    }
}

vector <int> bfs(int v) {

    queue<int> q;
    vector <int> d(n, 1e9);
    d[v] = 0;
    q.push(v);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto x : g[u]) {
            if (d[x.u] > d[u] + 1) {
                q.push(x.u);
                d[x.u] = d[u] + 1;
            }
        }
    }
    return d;
}
vector<bool> us;
vector<int> dd;
bool to;
void dfs(int v) {
    us[v] = true;
    for (auto x : g[v]) {
        if (dd[v] % 2 == dd[x.u] % 2) {
            to = true;
            return;
        }
        if (!us[x.u]) {
            dfs(x.u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int r; cin >> n >> r;
    vector <point> points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].x >> points[i].y;
    }
    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (dist(points[i], points[j], r)) {
                g[i].push_back({j, -1});
                g[j].push_back({i, -1});
            }
        }
    }
    points.clear();
    used.resize(n, -1);
    int cnt = 1;
    for (int i = 0; i < n; i++) {
        if (used[i] == -1) {
            dfs(i, cnt);
            cnt++;
        }
    }
    cnt = 1;
    map <int, bool> mep;
    for (int i = 0; i < n; i++) {
        if (cnt == used[i]) {
            dd.clear();
            us.clear();
            us.resize(n, false);
            dd = bfs(i);
            to = false;
            dfs(i);
            mep[cnt] = to;
            cnt++;
        }
    }
    for (auto x : used) {
        cout << mep[x];
    }
}