#include <bits/stdc++.h>
#define int long long
using namespace std;
const int maxn = 100000;
int n, r;
struct Point {
    int x;
    int y;
    Point(int x, int y): x(x), y(y){};
};
vector<Point> pts;
int dist(Point a, Point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
int color[maxn];
int c = 1;
void paint(int v) {
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            if (dist(pts[v], pts[i]) <= r * r) {
                color[i] = c;
                paint(i);
            }
        }
    }
}
int used[maxn];
bool dfs(int v, int f) {
    used[v] = f;
    for (int i = 0; i < n; ++i) {
        if (i == v) continue;
        if (dist(pts[v], pts[i]) <= r * r) {
            if (used[i] == -1) {
                dfs(i, f ^ 1);
            }
            if (used[i] == f) return true;
        }
    }
    return false;
}
void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        pts.emplace_back(x, y);
    }
    fill(color, color + n, 0);
    fill(used, used + n, -1);
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            paint(i);
            c++;
        }
    }
    vector<int> ans(n, -1);

    for (int i = 1; i < c; ++i) {
        int fl = -1;
        for (int j = 0; j < n; ++j) {
            if (color[j] == i) {
                if (fl == -1) {
                    if (dfs(j, 0)) {
                        fl = 1;
                    }
                    else {
                        fl = 0;
                    }
                }
                ans[j] = fl;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }


}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}