#include <bits/stdc++.h>
#define int long long
using namespace std;
vector<int> used;
int r, c;
void update(int ind) {
    for (int i = ind; i <= r * c; i += (i & -i)) {
        used[i]++;
    }
}
int get(int ind) {
    int res = 0;
    for (int i = ind; i > 0; i -= (i & -i)) {
        res += used[i];
    }
    return res;
}
int kolinv(vector<int> &a) {
    fill(used.begin(), used.end(), 0);
    int res = 0;
    for (int i = 0; i < r * c; ++i) {
        res += get(r * c) - get(a[i]);
        update(a[i]);
    }
    return res;
}
int req(vector<int> &a, vector<vector<int>>& inp, int lb, int ub) {
    if (lb == c || ub == r) {
        return  kolinv(a);
    }
    for (int i = ub; i < r; ++i) {
        a.push_back(inp[i][lb]);
    }
    int ans1 = req(a, inp, lb + 1, ub);
    for (int i = ub; i < r; ++i) {
        a.pop_back();
    }
    for (int j = lb; j < c; ++j) {
        a.push_back(inp[ub][j]);
    }
    int ans2 = req(a, inp, lb, ub + 1);
    for (int j = lb; j < c; ++j) {
        a.pop_back();
    }
    return min(ans1, ans2);
}
void solve() {
    cin >> r >> c;
    vector<vector<int>> inp(r, vector<int>(c));
    used.resize(r * c + 1, 0);
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> inp[i][j];
        }
    }
    vector<int> a;
    cout << req(a, inp, 0, 0);

}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}