#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#define f first
#define s second
#define pii pair<int, int>

int const INF = 1e6;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    string a;
    cin >> a;
    int ans = 0, cnt1 = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] != '1') continue;
        cnt1++;
        int f1 = 0, f2 = 0;
        if (i > 0 && a[i - 1] == '1') f1 = 1;
        if (i + 1 < n && a[i + 1] == '1') f2 = 1;
        //cout << i << " " << f1 << " " << f2 << endl;
        if (f1 + f2 > 0)
            ++ans;
    }
    if (n == 1) {
        while (q--) {
            int k;
            cin >> k;
            cout << 0 << "\n";
        }
        exit(0);
    }
    vector<vector<vector<vector<int>>>> dp(n, vector<vector<vector<int>>> (3, vector<vector<int>> (2, vector<int> (2, -INF))));
    if (a[0] == '0' && a[1] == '0') {
        dp[1][2][1][1] = 2;
        dp[1][0][0][0] = 0;
        dp[1][1][0][1] = 0;
        dp[1][1][1][0] = 0;
    } else if (a[0] == '0' && a[1] == '1') {
        dp[1][0][0][1] = 0;
        dp[1][1][1][1] = 2;
    } else if (a[0] == '1' && a[1] == '0') {
        dp[1][1][1][1] = 2;
        dp[1][0][1][0] = 0;
    } else {
        dp[1][0][1][1] = 2;
    }

    for (int i = 2; i < n; ++i) {
        for (int k = 0; k <= 2; ++k) {
            if (a[i] == '0') {
                dp[i][k][0][0] = max(dp[i - 1][k][0][0], dp[i - 1][k][1][0]);
                dp[i][k][1][0] = max(dp[i - 1][k][0][1], dp[i - 1][k][1][1]);
                if (k > 0) {
                    dp[i][k][0][1] = max(dp[i - 1][k - 1][0][0], dp[i - 1][k - 1][1][0]);
                    dp[i][k][1][1] = max(dp[i - 1][k - 1][0][1] + 2, dp[i - 1][k - 1][1][1] + 1);
                }
            } else {
                dp[i][k][0][1] = max(dp[i - 1][k][0][0], dp[i - 1][k][1][0]);
                dp[i][k][1][1] = max(dp[i - 1][k][0][1] + 2, dp[i - 1][k][1][1] + 1);
            }
        }
    }
//    for (auto el : dp) {
//        for (auto e : el) {
//            for (auto l : e)
//                cout << l << ",";
//            cout << "  ";
//        }
//        cout << endl;
//    }
    while (q--) {
        int k;
        cin >> k;
        int res = 0;
        for (int k1 = 0; k1 <= k; ++k1) {
            for (int d1 = 0; d1 <= 1; ++d1) {
                for (int d2 = 0; d2 <= 1; ++d2) {
                    res = max(res, dp[n - 1][k1][d1][d2]);
                }
            }
        }
            //res = max({res, dp[n - 1][k1][0], dp[n - 1][k1][1]});
        cout << res << "\n";
    }
//    while (q--) {
//        int k;
//        cin >> k;
//        int h = (n - cnt1 + 1) / 2;
//        //cout << h << endl;
//        if (h < k) {
//            cout << min(cnt1 + k, n) << "\n";
//        } else {
//            cout << min(3 * k, n) << "\n";
//        }
//    }
//    //cout << ans << endl;
//    vector<int> hole;
//    int last = -1;
//    for (int i = 0; i < n; ++i) {
//        if (a[i] != '1') continue;
//        int f1 = 0, f2 = 0;
//        if (i > 0 && a[i - 1] == '1') f1 = 1;
//        if (i + 1 < n && a[i + 1] == '1') f2 = 1;
//        if (f1 + f2 == 0) {
//            if (last != -1) {
//                hole.push_back(i - last - 1);
//                last = i;
//            } else {
//                last = i;
//            }
//        }
//    }
//    for (auto el : hole)
//        cout << el << " ";
//    cout << endl;
//    vector<int> res(n + 1);
//    int n1 = hole.size();
//    if (n1 == 0) {
//        while (q--) {
//            int k;
//            cin >> k;
//            if (k == 0) {
//                cout << ans << "\n";
//            }else if (k == 1) {
//                if (ans == 0)
//                    cout << 0 << "\n";
//                else {
//                    cout << min(ans + 1, n) << "\n";
//                }
//            } else {
//                cout << min(n, ans + k) << "\n";
//            }
//        }
//        exit(0);
//    }
//    vector<vector<vector<int>>> dp(n1, vector<vector<int>> (2, vector<int> (2)));
//    dp[0][0][0] = 0;
//    if (hole[0] <= 1)
//        dp[0][hole[0]][1] = 2 + hole[0];
//    for (int i = 1; i < n1; ++i) {
//        for (int k = 0; k <= 1; ++k) {
//            dp[i][k][0] = max(dp[i - 1][k][0], dp[i - 1][k][1]);
//            if (k - hole[i] >= 0)
//                dp[i][k][1] = max(dp[i - 1][k - hole[i]][0] + 2 + hole[i], dp[i - 1][k - hole[i]][1] + 1 + hole[i]);
////            if (k != 0) {
////                dp[i][k][0] = max(dp[i][k - 1][0], dp[i][k][0]);
////                dp[i][k][1] = max(dp[i][k - 1][1], dp[i][k][1]);
////            }
//        }
//    }
//    for (auto el : dp) {
//        for (auto e : el) {
//            for (auto l : e)
//                cout << l << ",";
//            cout << "  ";
//        }
//        cout << endl;
//    }
//    cout << endl;
//    while (q--) {
//        int k;
//        cin >> k;
////        if (k == 0) {
////            cout << ans << '\n';
////        } else {
////        }
//        //cout << ans << "\n";
//        int res = 0;
//        for (int i = 0; i < n1; ++i) {
//            for (int k1 = 0; k1 <= k; ++k1) {
//                res = max({res, dp[i][k1][0] + k - k1, dp[i][k1][1] + k - k1});
//            }
//        }
//        cout << min(res + ans, n) << "\n";
//    }
//    while (q--) {
//        int k;
//        int res = ans;
//        cin >> k;
//
//    }
}

