#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define f first
#define s second
#define pii pair<ld, ld>

vector<pii> pnt;

ld r;

bool dst(int i, int j) {
    ld d = sqrt((pnt[i].f - pnt[j].f) * (pnt[i].f - pnt[j].f) + (pnt[i].s - pnt[j].s) * (pnt[i].s - pnt[j].s));
    return d <= r;
}

int n;
vector<int> used;


void dfs(int v, int &res, int d, int st) {
    used[v] = 1;
    for (int i = 0; i < n; ++i) {
        if (i == v) continue;
        if (i == st && d == 0 && dst(v, i))
            res = 1;
        if (!used[i] && dst(i, v))
            dfs(i, res, d ^ 1, st);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    pnt.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> pnt[i].f >> pnt[i].s;
    }
//    for (int i = 0; i < n; ++i) {
//        fill(used.begin(), used.end(), 0);
//        int res = 0;
//        dfs(i, res, 0, i);
//        cout << res;
//    }
//    exit(0);
    vector<vector<vector<int>>> dp(n, vector<vector<int>> (n, vector<int> (2)));
    for (int i = 0; i < n; ++i) {
        dp[i][i][0] = 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dst(i, j)) {
                dp[i][j][1] = 1;
                dp[j][i][1] = 1;
            }
        }
    }
//    for (auto el : dp) {
//        for (auto e : el) {
//            for (auto l : e)
//                cout << l << ",";
//            cout <<  "  ";
//        }
//        cout << endl;
//    }
//    cout << endl;
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            if (!dst(i, k)) continue;
            for (int j = 0; j < n; ++j) {
                if (!dst(j, k)) continue;
                //if (i == j && j == k) continue;
                if ((dp[i][k][0] && dp[k][j][0]) || (dp[i][k][1] && dp[k][j][1])) {
                    //cout << i << " " << k << " " << j << endl;
                    dp[i][j][0] = 1;
                }
                if ((dp[i][k][0] && dp[k][j][1]) || (dp[i][k][1] && dp[k][j][0])) {
                    dp[i][j][1] = 1;
                }

            }
        }
    }
//    for (auto el : dp) {
//        for (auto e : el) {
//            for (auto l : e)
//                cout << l << ",";
//            cout <<  "  ";
//        }
//        cout << endl;
//    }
//    cout << endl;
    for (int i = 0; i < n; ++i)
        cout << dp[i][i][1];
}

