#include <bits/stdc++.h>
using namespace std;
struct Point{
    int x, y;
};
long long dist(Point a, Point b){
    return 1ll * (a.x - b.x) * (a.x - b.x) + 1ll * (a.y - b.y) * (a.y - b.y);
}
constexpr int MAXN = 1e5 + 5;
vector <int> g[MAXN];
int color[MAXN];
int ans[MAXN];
Point sp[MAXN];
int c = 1;
int n;
bool f = true;
void dfs(int v){
    for (auto to: g[v]){
        if (!color[to]){
            color[to] = 2 * c + (color[v] + 1) % 2;
            dfs(to);
        }
        if (color[to] == color[v]){
            f = true;
        }
    }
}
long long hsh = 1e9;
unordered_map <long long, int> dct;
signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long r;
    cin >> n >> r;
    for (int i = 0; i < n; i++){
        cin >> sp[i].x >> sp[i].y;
    }
    for (int i = 0; i < n; i++){
        dct[sp[i].x * hsh +  sp[i].y] = i;
    }
    for (int i = 0; i < n; i++){
        for (int x = -r; x <= r; x++){
            for (int y = -sqrt(r * r - x * x); y <= sqrt(r * r - x * x); y++){
                if (x * x + y * y > r * r){
                    continue;
                }
                if (x == 0 && y == 0){
                    continue;
                }
                int nx = sp[i].x + x;
                int ny = sp[i].y + y;
                if (dct.find(nx * hsh + ny) != dct.end()){
                    int j = dct[nx * hsh + ny];
                    g[i].emplace_back(j);
                }
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (!color[i]){
            color[i] = 2 * c + 1;
            f = false;
            dfs(i);
            if (f){
                ans[c] = true;
            }
            c++;
        }
    }
    for (int i = 0; i < n; i++){
        if (ans[color[i] / 2]){
            cout << 1;
        }
        else{
            cout << 0;
        }
    }
}

