#include <bits/stdc++.h>
using namespace std;
struct Point{
    int x, y;
};
long long dist(Point a, Point b){
    return 1ll * (a.x - b.x) * (a.x - b.x) + 1ll * (a.y - b.y) * (a.y - b.y);
}
constexpr int MAXN = 1e4 + 5;
vector <int> g[MAXN];
int color[MAXN];
int ans[MAXN];
int c = 1;
bool f = true;
void dfs(int v){
    for (auto to: g[v]){
        if (!color[to]){
            color[to] = 2 * c + (color[v] + 1) % 2;
            dfs(to);
        }
        if (color[to] == color[v]){
            f = true;
        }
    }
}
signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    long long r;
    cin >> n >> r;
    vector <Point> sp(n);
    for (int i = 0; i < n; i++){
        cin >> sp[i].x >> sp[i].y;
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (i == j){
                continue;
            }
            if (dist(sp[i], sp[j]) <= r * r){
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (!color[i]){
            color[i] = 2 * c + 1;
            f = false;
            dfs(i);
            if (f){
                ans[c] = true;
            }
            c++;
        }
    }
    for (int i = 0; i < n; i++){
        if (ans[color[i] / 2]){
            cout << 1;
        }
        else{
            cout << 0;
        }
    }
}
