#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const ll INF = 1e18;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    ll mn1 = a[0];
    ll mn2 = INF;
    for (int i = 1; i < n; ++i)
    {
        if (a[i] < a[0] || i == n - 1)
        {
            for (int u = i; u < n; ++u)
            {
                mn2 = min(mn2, a[u]);
            }
            break;
        }
        mn1 = min(mn1, a[i]);
    }
    for (int i = 0; i < q; ++i)
    {
        int j, k;
        cin >> j >> k;
        --j;
        if (j == 0)
        {
            cout << mn1 << '\n';
        } else
        {
            cout << mn2 << '\n';
        }
    }

    return 0;
}

