#pragma GCC optimize("O2,O3,unroll-loops")
#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, r;

bool inter(array<int, 2> a, array<int, 2> b) {
    int dx = a[0] - b[0], dy = a[1] - b[1];
    return dx * dx + dy * dy <= r * r;
}

const int maxn = 1e5 + 123;

vector<int> adj[maxn];

int col[maxn], used[maxn];

bool odd = false;

vector<int> cur;

void dfs(int v, int c) {
    used[v] = true;
    cur.push_back(v);
    col[v] = c;
    for (int i : adj[v]) {
        if (col[i] == col[v]) {
            odd = true;
        }
        if (col[i] == -1) {
            dfs(i, 1 - c);
        }
    }
}

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> r;
    vector<array<int, 2>> pts(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i][0];
        int _;
        cin >> _;
        pts[i][1] = i;
    }
    sort(pts.begin(), pts.end());
    vector<int> col(n);
    vector<bool> ans(n);
    for (int i = 1; i < n; i++) {
        col[i] = col[i - 1];
        if (pts[i][0] - pts[i - 1][0] > r) {
            col[i]++;
        }
        if (i - 2 >= 0 && pts[i][0] - pts[i - 2][0] <= r) {
            ans[col[i]] = 1;
        }
    }
    vector<int> ans2(n);
    for (int i = 0; i < n; i++) {
        ans2[pts[i][1]] = ans[col[i]];
    }
    for (int i : ans2) cout << i;
    cout << "\n";
}