#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

const int N = 3e5 + 100, L = 20;

int t[L][N];

vector<int> a;

int MIN(int l, int r) {
    if (a[l] < a[r])
        return l;
    return r;
}

int get(int l, int r) {
    int lg = __lg(r - l);
    return MIN(t[lg][l], t[lg][r-(1<<lg)]);
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, q; cin >> n >> q;
    a.assign(n, {});
    for (int &i : a)
        cin >> i;

    vector<int> nxt(n);
    vector<int> cur;

    for (int i = 0; i < n; i++)
        t[0][i] = i;
    for (int i = 0; i + 1 < L; i++)
        for (int j = 0; j + (1<<i) < n; j++)
            t[i + 1][j] = MIN(t[i][j], t[i][j + (1<<i)]);
    
    for (int i = n - 1; i >= 0; i--) {
        while (!cur.empty() && a[cur.back()] < a[i])
            cur.pop_back();

        if (cur.empty())
            nxt[i] = n;
        else
            nxt[i] = cur.back();

        cur.push_back(i);
    }

    gp_hash_table<int, vector<int>> mp;

    vector<int> suf(n);
    suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--)
        suf[i] = max(suf[i], a[i]);

    while (q--) {
        int k, i; cin >> k >> i;

        vector<int> cur_mx;
        int zavod = 1;
        int id = 0;

        while (zavod + 1 <= k) {
            if (cur_mx.size() >= i)
                break;
            cur_mx.push_back(a[id]);
            int r = min(nxt[id], n - (k - zavod)) + 1;
            if (zavod + 1 != k) id = get(id + 1, r);
            else id = r - 1;
            zavod++;
        }

        int mx = suf[id];

        cur_mx.push_back(mx);
        cout << cur_mx[i-1] << '\n';
    }
}