#include <bits/stdc++.h>
  
using namespace std;
  
  
using ll = long long;

#pragma GCC target("avx2")

#pragma GCC optimize("O3")

vector<vector<int>> g;
vector<int> good;
vector<int> lin;
  
int par(int x) {
    if (lin[x] >= 0) {
        lin[x] = par(lin[x]);
        return lin[x];
    } else {
        return x;
    }
}
  
void merg(int u, int v) {
    u = par(u);
    v = par(v);
    if (lin[u] == lin[v]) {
        lin[v] = u;
        lin[u]--;
    }
    else if (lin[u] > lin[v]) {
        lin[u] = v;
    }
    else {
        lin[v] = u;
    }
}
  
vector<int> color;
vector<int> used;
  
int t = 0;
  
void dfs(int u) {
    used[u] = t;
    for (auto v : g[u]) {
        if (!used[v]) {
            color[v] = 1 - color[u];
            dfs(v);
        }
    }
}
  
signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> ve(n);
    set<pair<int, int>> se;
    map<pair<int, int>, int> ma;
    for (int i = 0; i < n; i++) {
        cin >> ve[i].first >> ve[i].second;
        ma[ve[i]] = i;
        se.insert(ve[i]);
    }
    vector<pair<int, int>> zz;
    for (int i = 0; i <= r; i++) {
        for (int j = -r; j <= r; j++) {
            if ((i != 0 || j != 0) && i * i + j * j <= r * r) {
                zz.push_back({i, j});
            }
        }
    }
    good.resize(n);
    lin.assign(n, -1);
    g.resize(n);
    vector<pair<int, int>> ve2;
    for (int i = 0; i < n; i++) {
        for (auto [x, v] : zz) {
            if (se.find({ve[i].first + x, ve[i].second + v}) != se.end()) {
                int z = ma[{ve[i].first + x, ve[i].second + v}];
                if (par(i) != par(z)) {
                    merg(i, z);
                    g[i].push_back(z);
                    g[z].push_back(i);
                } else {
                    ve2.push_back({i, z});
                }
            }
        }
    }
    used.assign(n, 0);
    color.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            t++;
            dfs(i);
        }
    }
    vector<int> bad(t + 1);
    for (auto [z, i] : ve2) {
        if (color[z] == color[i]) {
            bad[used[z]] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << bad[used[i]];
    }
}