#include <bits/stdc++.h>
 
using namespace std;
 
 
using ll = long long;

vector<int> get(vector<int> & a, int k) {
    int n = (int)a.size();
    vector<vector<vector<int>>> dp(n, vector<vector<int>> (3, vector<int> (3, 1e9)));
    dp[0][0].assign(k, 0);
    dp[0][0][0] = a[0];
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < min(k, i + 1); j++) {
            vector<int> ve;
            if (j != 0) {
                ve = dp[i - 1][j - 1];
                ve[j] = a[i];
                dp[i][j] = min(dp[i][j], ve);
            }
            if (i != j) {
                ve = dp[i - 1][j];
                ve[j] = max(ve[j], a[i]);
                dp[i][j] = min(dp[i][j], ve);
            }
        }
    }
    return dp[n - 1][k - 1];
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<vector<int>> ans(1);
    for (int i = 0; i < n; i++) {
        ans[0] = get(a, 3);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << ans[0][i] << endl;
    }
}