#include<bits/stdc++.h>

using namespace std;

// #define int long long
const int MAX = 1e4 + 1;


vector<int> g[MAX];
vector<int> p, deep, used, ans, pl, mn;

void dfs(int v, int par) {
    p[v] = par;
    used[v] = true;
    deep[v] = deep[par] + 1;
    for (auto u : g[v]) {
        if (u != par) {
            if (!used[u]) {
                dfs(u, v);
            } else {
                if (deep[v] > deep[u] && !((deep[v] - deep[u]) % 2)) {
                    // int v_ = v;
                    // while (v_ != u) {
                    //     ans[v_] = 1;
                    //     v_ = p[v_];
                    // }
                    // ans[u] = 1;
                    // add[v]
                    pl[v]++;
                    mn[u]--;
                }
            }
        }
    }
}
int cur = 0;

void calc(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            calc(u);
        }
    }
    cur += pl[v];
    ans[v] |= (cur > 0);
    cur += mn[v];
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    long long n, r;
    cin >> n >> r;
    p.resize(n);
    deep.resize(n);
    used.resize(n, false);
    ans.resize(n);
    pl.resize(n);
    mn.resize(n);
    vector<array<long long, 2>> v(n);
    for (int i = 0;  i < n; i++) {
        cin >> v[i][0] >> v[i][1];
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((v[i][0] - v[j][0]) * (v[i][0] - v[j][0]) + (v[i][1] - v[j][1]) * (v[i][1] - v[j][1]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> perm(n);
    for (int i = 0; i < n; i++) {
        perm[i] = i;
    }
    for (int i = 0; i < n; i++) {
        if (!used[perm[i]]) {
            dfs(perm[i], perm[i]);
        }
    }
    fill(used.begin(), used.end(), 0);
    for (int i = 0; i < n; i++) {
        if (!used[perm[i]]) {
            calc(perm[i]);
        }
    }
    queue<int> q;
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            q.push(i);
        }
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!ans[u]) {
                ans[u] = 1;
                q.push(u);
            }
        }
    }
    for (auto u : ans) {
        cout << u;
    }
    cout << '\n';
}