#include <bits/stdc++.h>

using ll = long long;
using pll = std::pair<long long, long long>;

long long r, dx, dy;
std::vector<std::pair<pll, ll>> a;
std::vector<std::vector<ll> > G;

bool check(pll x, pll y) {
    dx = x.first - y.first;
    dy = x.second - y.second;
    dx *= dx;
    dy *= dy;
    if (dx + dy <= r * r) {
        return true;
    }
    return false;
}

std::vector<ll> cmptnum;
std::vector<ll> used;


void dfs(ll v, ll cmp) {
    used[v] = 1;
    cmptnum[v] = cmp;
    for (auto u: G[v]) {
        if (!used[u]) {
            dfs(u, cmp);
        }
    }
}

void solve() {
    ll n;
    std::cin >> n >> r;
    G.resize(2 * n);
    a.resize(n);
    used.resize(2 * n);
    cmptnum.resize(2 * n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    std::sort(a.begin(), a.end());
    for (int i = 0; i < n - 1; ++i) {
        ll j = i + 1;
        if (check(a[i].first, a[i + 1].first)) {
            G[2 * i].push_back(2 * j + 1);
            G[2 * j + 1].push_back(2 * i);
            G[2 * i + 1].push_back(2 * j);
            G[2 * j].push_back(2 * i + 1);
        }
        j = i + 2;
        if (j < n && check(a[i].first, a[j].first)) {
            G[2 * i].push_back(2 * j + 1);
            G[2 * j + 1].push_back(2 * i);
            G[2 * i + 1].push_back(2 * j);
            G[2 * j].push_back(2 * i + 1);
        }
    }
    ll cntt = 0;
    for (int i = 0; i < 2 * n; ++i) {
        if (!used[i]) {
            dfs(i, cntt++);
        }
    }
    std::string anss(2 * n, '0')
    for (int i = 0; i < n; ++i) {
        if (cmptnum[2 * i] == cmptnum[2 * i + 1]) {
            anss[a[i].second] = '1';
        }
    }
    std::cout << anss;
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}
