#include <bits/stdc++.h>

using ll = short;
using pll = std::pair<long long, long long>;

long long r, dx, dy;
std::vector<pll> a;
std::vector<std::vector<ll> > G;

bool check(pll x, pll y) {
    dx = x.first - y.first;
    dy = x.second - y.second;
    dx *= dx;
    dy *= dy;
    if (dx + dy <= r * r) {
        return true;
    }
    return false;
}

std::vector<ll> cmptnum;
std::vector<ll> used;


void dfs(ll v, ll cmp) {
    used[v] = 1;
    cmptnum[v] = cmp;
    for (int j = !(v % 2); j < 2 * a.size(); j += 2) {
        if (!used[j] && check(a[v / 2], a[j / 2]) && v / 2 != j / 2) {
            dfs(j, cmp);
        }
    }
}

void solve() {
    ll n;
    std::cin >> n >> r;
    a.resize(n);
    used.resize(2 * n);
    cmptnum.resize(2 * n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i].first >> a[i].second;
    }
    ll cntt = 0;
    for (int i = 0; i < 2 * n; ++i) {
        if (!used[i]) {
            dfs(i, cntt++);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (cmptnum[2 * i] == cmptnum[2 * i + 1]) {
            std::cout << 1;
        } else {
            std::cout << 0;
        }
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}
