#include <bits/stdc++.h>

using ll = long long;
using pll = std::pair<ll, ll>;

struct ST {
    struct Node {
        ll l = -1, r = -1;
        ll val = 0;
    };

    std::vector<Node> tr = {Node()};

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (l >= qr || ql >= r) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tr[v].val;
        }
        ll sm = 0;
        ll m = (l + r) / 2;
        if (tr[v].l != -1) {
            sm += get(tr[v].l, l, m, ql, qr);
        }
        if (tr[v].r != -1) {
            sm += get(tr[v].r, m, r, ql, qr);
        }
        return sm;
    }

    void upd(ll v, ll l, ll r, ll i, ll x) {
        tr[v].val += x;
        ll m = (l + r) / 2;
        if (l + 1 == r) {
            return;
        }
        if (i < m) {
            if (tr[v].l == -1) {
                tr[v].l = tr.size();
                tr.push_back(Node());
            }
            upd(tr[v].l, l, m, i, x);
        }
        else {
            if (tr[v].r == -1) {
                tr[v].r = tr.size();
                tr.push_back(Node());
            }
            upd(tr[v].r, m, r, i, x);
        }
    }
};

struct Node {
    ll l = -1, r = -1;
    ll val = 0;
};

std::vector<Node> tr = {Node()};
std::vector<std::vector<ll>> podpr;

void upd(ll v, ll l, ll r, ll i, ll x) {
    tr[v].val += x;
    if (l + 1 == r) {
        return;
    }
    ll m = (l + r) / 2;
    if (i < m) {
        tr.push_back(Node());
        if (tr[v].l != -1) {
            tr.back() = tr[tr[v].l];
        }
        tr[v].l = tr.size() - 1;
    }
    else {
        tr.push_back(Node());
        if (tr[v].r != -1) {
            tr.back() = tr[tr[v].r];
        }
        tr[v].r = tr.size() - 1;
    }
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || ql >= r) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tr[v].val;
    }
    ll sm = 0;
    ll m = (l + r) / 2;
    if (tr[v].l != -1) {
        sm += get(tr[v].l, l, m, ql, qr);
    }
    if (tr[v].r != -1) {
        sm += get(tr[v].r, m, r, ql, qr);
    }
    return sm;
}

void solve() {
    ll r, c;
    std::cin >> r >> c;
    std::vector<std::vector<ll> > dp(r + 1, std::vector<ll>(c + 1, 1e18));
    std::vector<std::vector<ll> > a(r, std::vector<ll>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            std::cin >> a[i][j];
            --a[i][j];
        }
    }
    if (r == 1) {
        ll ans = 0;
        ST cx;
        for (int i = 0; i < r; ++i) {
            for (int j = 0; j < c; ++j) {
                ans += cx.get(0, 0, r * c, a[i][j] + 1, r * c);
                cx.upd(0, 0, r * c, a[i][j], 1);
            }
        }
        std::cout << ans;
    }
    else {
        ST cx;
        ll cnt = 0;
        ll ans = 1e9;
        for (int i = 0; i < c; ++i) {
            cx.upd(0, 0, r * c, a[0][i], 1);
            cnt += cx.get(0, 0, r * c, a[0][i] + 1, r * c);
            cx.upd(0, 0, r * c, a[1][i], 1);
            cnt += cx.get(0, 0, r * c, a[1][i] + 1, r * c);
        }
        ans = cnt;
        ST cx1;
        for (int i = c - 1; i >= 0; --i) {
            cnt -= cx1.get(0, 0, r * c, 0, a[1][i]);
            cnt += cx1.get(0, 0, r * c, a[1][i] + 1, r * c);
            cx1.upd(0, 0, r * c, a[0][i], 1);
            ans = std::min(ans, cnt);
        }
        std::cout << ans;
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
