#include <bits/stdc++.h>
using namespace std;
#define int int64_t

vector<vector<int> > a;
vector<bool> used;
vector<int> c;
vector<int> g;
vector<pair<int,int> > d;
int n;
int r;

int dist(pair<int,int> a, pair<int,int> b) {
    int x = a.first - b.first;
    int y = a.second - b.second;
    return (x * x + y * y);
}

void dfs(int v) {
    used[v] = true;
    for (int i = 1; i <= n; i++) {
        if (i == v) {
            continue;
        }
        if (dist(d[i], d[v]) <= r * r) {
            if (used[i] == true) {
                if (c[v] == c[i]) {
                    g[v] = 1;
                }
                continue;
            }
            c[i] = 1 - c[v];
            dfs(i);
        }
    }
}

void get_ans(int v) {
    used[v] = true;
    g[v] = 1;
    for (int i = 1; i <= n; i++) {
        if (i == v) {
            continue;
        }
        if (dist(d[i], d[v]) <= r * r) {
            if (used[i] == true) {
                continue;
            }
            get_ans(i);
        }
    }
}


void solve() {
    cin >> n >> r;
    d = vector<pair<int,int> >(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i].first >> d[i].second;
    }
    used = vector<bool> (n + 1, false);
    g = vector<int> (n + 1, 0);
    c = vector<int> (n + 1, 0);
    for (int i = 1; i <= n; i++) {
        if (used[i] == false) {
            dfs(i);
        }
    }
    for (int i = 1; i <= n; i++) {
        used[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        if (g[i] == 1 && used[i] == false) {
            get_ans(i);
        }
    }
    for (int i = 1; i <= n; i++) {
        cout << g[i];
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
