#include <bits/stdc++.h>
using namespace std;
#define int int64_t

vector<int> tree;
void update(int v, int l, int r, int i) {
    if (l > i || i >= r) {
        return;
    }
    if (l + 1 == r) {
        tree[v]++;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, i);
    update(2 * v + 2, m, r, i);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr){
        return tree[v];
    }
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

void solve() {
    int r, c;
    cin >> r >> c;
    vector<int> a(c + 1);
    for (int i = 1; i <= c; i++) {
        cin >> a[i];
    }
    tree = vector<int> (4 * (c + 1), 0);
    int ans = 0;
    for (int i = c; i >= 1; i++) {
        ans += get(0, 1, c + 1, 1, a[i]);
        update(0, 1, c + 1, a[i]);
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

