#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rev reverse
#define vec vector
#define str string
#define ld long double
#define umap unordered_map

vec<vec<int> > g;
vec<bool> used;
vec<int> d, order;
vec<pair<ll, ll>> a;

ll r;

bool flag = false;

umap<ll, int> mp;

int in(ll x, ll y) {
    ll cor = x * (1e9) + y;
    if (mp.find(cor) != mp.end()) return mp[cor];
    return -1;
}

void dfs(int v, int cur) {
    order.pb(v);
    d[v] = cur;
    used[v] = true;
    auto [x, y] = a[v];
    for (ll mn1 = 0; mn1 <= 100; mn1++) {
        for (ll mn2 = 0; mn2 <= 100 && mn2 * mn2 + mn1 * mn1 <= r * r; mn2++) {
            int pos1 = in(x + mn1, y + mn2);
            int pos2 = in(x - mn1, y + mn2);
            int pos3 = in(x + mn1, y - mn2);
            int pos4 = in(x - mn1, y - mn2);
            if (pos1 != -1 && pos1 != v) {
                if (!used[pos1]) dfs(pos1, cur + 1);
                else if ((d[v] - d[pos1] + 1) % 2 == 1) flag = true;
            }
            if (pos2 != -1 && pos2 != v) {
                if (!used[pos2]) dfs(pos2, cur + 1);
                else if ((d[v] - d[pos2] + 1) % 2 == 1) flag = true;
            }
            if (pos3 != -1 && pos3 != v) {
                if (!used[pos3]) dfs(pos3, cur + 1);
                else if ((d[v] - d[pos3] + 1) % 2 == 1) flag = true;
            }
            if (pos4 != -1 && pos4 != v) {
                if (!used[pos4]) dfs(pos4, cur + 1);
                else if ((d[v] - d[pos4] + 1) % 2 == 1) flag = true;
            }
        }
    }
}

void init(int n) {
    d.resize(n), g.resize(n), used.assign(n, false);
}

ld dist(pair<ld, ld> &a, pair<ld, ld> &b) {
    ld p1 = a.ff - b.ff, p2 = a.ss - b.ss;
    return sqrt(p1 * p1 + p2 * p2);
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> r;
    init(n);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        mp[x * (1e9) + y] = i;
        a[i] = {x, y};
    }
    vec<bool> ans(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            order.clear(), flag = false;
            dfs(i, 0);
            if (flag) {
                for (int v: order) ans[v] = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) cout << '1';
        else cout << '0';
    }
}
