#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
using namespace std;
// #define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

void solution() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int ans = 1e9;
    for (int mask = 0; mask < 1 << (n + m); ++mask) {
        int cnt = 0;
        for (int i = 0; i < n + m; ++i) {
            if (mask >> i & 1) cnt++;
        }
        if (cnt != n) continue;
        
        vector<int> b;
        int i = 0, j = 0;
        for (int k = 0; k < 1 << (n + m); ++k) {
            if (mask >> k & 1) {
                for (int j1 = j; j1 < m; ++j1) {
                    b.push_back(a[i][j1]);
                }
                i++;
            } else {
                for (int i1 = i; i1 < n; ++i1) {
                    b.push_back(a[i1][j]);
                }
                j++;
            }
        }
        int num = 0;
        for (int i1 = 0; i1 < n * m; ++i1) {
            for (int j1 = 0; j1 < i1; ++j1) {
                if (b[i1] < b[j1]) num++;
            }
        }
        ans = min(ans, num);
    }

    cout << ans << '\n';
}