#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

void solution() {
    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (auto &x : a) {
        cin >> x;
    }

    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, {(int)1e9}));
    dp[0][0] = {};
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            int mx = 0;
            for (int j1 = 1; j1 <= i - j + 1; ++j1) {
                if (i - j1 > 0 && j - 1 == 0) {
                    mx = max(mx, a[i - j1]);
                    continue;
                }
                auto nres = dp[i - j1][j - 1];
                mx = max(mx, a[i - j1]);
                nres.push_back(mx);
                dp[i][j] = min(dp[i][j], nres);
            }
        }
    }

    while (q--) {
        int k, i;
        cin >> k >> i;

        cout << dp[n][k][i - 1] << '\n';
    }
}