#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}
#define int long long

struct Point {
    int x,y;
    Point () {}
};

bool isok(Point a, Point b, int r) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}



void solve(){
    int n;
    int r;
    cin >> n >> r;
    vector<Point> a(n);
    for (int i  = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    vector<vector<pair<bool,bool>>>dp(n, vector<pair<bool,bool>>(n, {0,0}));
    for (int i = 0; i < n; i++) {
        dp[i][i].first = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (isok(a[i], a[j], r)) {
                dp[i][j].second=1;
            }
        }
    }
    for (int i= 0; i < n; i++) {
        for (int k = 0; k < n; k++) {
            for (int j = 0; j < n; j++) {
                if (dp[i][k].first && dp[k][j].first) {
                    dp[i][j].first = 1;
                }
                if (dp[i][k].first && dp[k][j].second) {
                    dp[i][j].second=1;
                }
                if (dp[i][k].second && dp[k][j].first) {
                    dp[i][j].second=1;
                }
                if (dp[i][k].second && dp[k][j].second) {
                    dp[i][j].first=1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (dp[i][i].second) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}