#include <bits/stdc++.h>

using namespace std;
//--//
//#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--//

const int N = 1e5 + 10;

vector<int> G[N];
int color[N];

bool oddC[N];

bool used[N];


void dfs(int v, int parent = -1, int c = 1) {
    color[v] = c;
    for (auto u : G[v]) {
        if (u != parent) {
            if (color[u] == 0) {
                dfs(u, v, -c);
                oddC[v] |= oddC[u];
            } else if (color[u] == c) {
                oddC[v] = true;
            }
        }
    }
}

void dfs_true(int v, int parent = -1) {
    oddC[v] = true;
    used[v] = true;
    for (auto u : G[v]) {
        if (u != parent && !used[u]) {
            dfs_true(u, v);
        }
    }
}

signed main() {
    int n;
    cin >> n;
    ll r;
    cin >> r;
    vector<ll> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    map<pii, int> used;
    for (int i = 0; i < n; ++i) {
        pii pr = {x[i], y[i]};
        used[pr] = i + 1;
    }
    for (int i = 0; i < n; ++i) {
        int total_connects = 0;
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (dx * dx + dy * dy <= r * r && (dx != 0 || dy != 0)) {
                    pii pr = {x[i] + dx, y[i] + dy};
                    if (used[pr]) {
                        ++total_connects;
                    }
                }
            }
        }
        if (total_connects >= 6) {
            oddC[i] = true;
        } else {
            for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (dx * dx + dy * dy <= r * r && (dx != 0 || dy != 0)) {
                    pii pr = {x[i] + dx, y[i] + dy};
                    if (used[pr]) {
                        int j = used[pr] - 1;
                        G[i].push_back(j);
                        G[j].push_back(i);
                    }
                }
            }
        }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            dfs(i);
            if (oddC[i]) {
                dfs_true(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (oddC[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    cout << "\n";
    return 0;
}
