#include <bits/stdc++.h>

using namespace std;
//--//
#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--//

const int MAXN = 3e5 + 10;
const int Lg = 20;

int Log2[MAXN];
int st[Lg][MAXN];

int get_max(int L, int R) {
    int Len = R - L + 1;
    int LogL = Log2[Len];
    return max(st[LogL][L], st[LogL][R - (1 << LogL) + 1]);
}

signed main() {
    fast;
    for (int i = 0; i < Lg - 1; ++i) {
        for (int p = (1 << i); p < (1 << (i + 1)); ++p) {
            if (p < MAXN) {
                Log2[p] = i;
            }
        }
    }
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i) {
        st[0][i] = a[i];
    }
    for (int row = 1; row < Lg; ++row) {
        for (int i = 0; i <= n - (1 << row); ++i) {
            st[row][i] = max(st[row - 1][i], st[row - 1][i + (1 << (row - 1))]);
        }
    }

    vector<int> next_big(n);
    for (int i = n - 1; i >= 0; --i) {
        //searching for first bigger than i
        if (i == n - 1 || get_max(i, n - 1) == a[i]) {
            next_big[i] = n;
        } else {
            int L = i, R = n - 1;
            while (R - L > 1) {
                int mid = (L + R) / 2;
                if (get_max(i, mid) == a[i]) {
                    L = mid;
                } else {
                    R = mid;
                }
            }
            next_big[i] = R;
        }
    }

    int want_pref = a[0];
    int right_edge = next_big[0] - 1;
    if (right_edge == n - 1) --right_edge;
    int suf_max = get_max(right_edge + 1, n - 1);


    while (q--) {
        int k, i;
        cin >> k >> i;
        --i;
        if (k == 1) {
            cout << n << "\n";
        } else if (k == 2) {
            if (i == 0) {
                cout << a[0] << "\n";
            } else {
                cout << suf_max << "\n";
            }
        }
    }
    return 0;
}
