#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;
struct vec {
    ld x;
    ld y;
};
vec operator-(vec a,vec b) {
    return {a.x-b.x,a.y-b.y};
}
ld abso(vec a) {
    return sqrt(a.x*a.x+a.y*a.y);
}
ld inf = 1e9;
ld eps = 0.00000001;
vector<vector<int>> g;
vector<bool> ans;
vector<bool> used;
vector<int> col;
bool dfs(int v,int c) {
    if (ans[v]) {
        return true;
    }
    col[v] = c;
    used[v] = true;
    for (auto to:g[v]) {
        if (used[to] and col[to]==col[v]) return true;
        if (!used[to] and dfs(to,3-c)) {
            return true;
        }
    }
    return false;
}
vector<bool> used2;
void dfs2(int v) {
    ans[v] = true;
    used2[v] = true;
    for (auto to:g[v]) {
        if (!used2[to]) {
            dfs2(to);
        }
    }
}
int main()
{
    cin.tie(nullptr);
    ios::sync_with_stdio(0);
    int n;
    ld r;
    cin >> n >> r;
    vector<vec> a(n);
    for (int i = 0;i < n;i++) {
        cin >> a[i].x >> a[i].y;
    }
    ld d = r/sqrt(2);
    map<ll,vector<int>> m;
    ll num = ceil(inf/d);
    for (int i = 0;i < n;i++) {
        ll xx = floor(a[i].x/d);
        ll yy = floor(a[i].y/d);
        ll ind = xx*num+yy;
        m[ind].push_back(i);
    }
    ans.resize(n);
    for (auto [ind,vec]:m) {
        if (vec.size()>=6) {
            for (auto i:vec) {
                ans[i] = true;
            }
        }
    }
    g.resize(n);
    used.resize(n);
    col.resize(n);
    vector<int> t;
    for (auto [ind,vec]:m) {
        if (vec.size()<6) {
            vector<ll> poss = {ind-num-1,ind-num,ind-num+1,ind-1,ind+1,ind+num-1,ind+num,ind+num+1};
            for (auto i:vec) {
                t.push_back(i);
                for (auto j:poss) {
                    for (auto k:m[j]) {
                        if (abso(a[i]-a[k])<=r+eps and ans[k]) {
                            ans[i] = true;
                        }
                        if (m[j].size()<6 and abso(a[i]-a[k])<=r+eps) {
                            g[i].push_back(k);
                            g[k].push_back(i);
                        }
                    }
                }
            }
        }
    }
    /*for (auto x:g) {
        for (auto y:x) {
            cout << y << ' ';
        }
        cout << '\n';
    }*/
    used2.resize(n);
    for (auto i:t) {
        if (!used[i]) {
            if (dfs(i,1)) {
                dfs2(i);
            }
        }
    }
    for (auto x:ans) {
        cout << x;
    }
    return 0;
}
