#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, r;
bool ans = false;
string anss;
vector<ll> op;
vector<pair<ll, ll>> c, rnds, x, y;
vector<bool> used, color;
vector<vector<long double>> dists;

void input() {
    cin >> n >> r;
    c.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> c[i].first >> c[i].second;
    }
}

vector<ll> find_near(ll u) {
    vector<ll> v;
    ll tekx = c[u].first, teky = c[u].second;
    ll l1 = -1, r1 = n;
    while (r1 - l1 > 1) {
        ll f = (l1 + r1) / 2;
        if (x[f].first >= tekx - r) {
            r1 = f;
        } else {
            l1 = f;
        }
    }
    ll l2 = -1, r2 = n;
    while (r2 - l2 > 1) {
        ll f = (l2 + r2) / 2;
        if (x[f].first > tekx + r) {
            r2 = f;
        } else {
            l2 = f;
        }
    }
    ll l3 = -1, r3 = n;
    while (r3 - l3 > 1) {
        ll f = (l3 + r3) / 2;
        if (y[f].first >= teky - r) {
            r3 = f;
        } else {
            l3 = f;
        }
    }
    ll l4 = -1, r4 = n;
    while (r4 - l4 > 1) {
        ll f = (l4 + r4) / 2;
        if (y[f].first > teky + r) {
            r4 = f;
        } else {
            l4 = f;
        }
    }
    if (r2 - r1 > r4 - r3) {
        for (ll i = r3; i <= l4; i++) {
            if ((tekx - c[y[i].second].first) * (tekx - c[y[i].second].first) + (teky - y[i].first) * (teky - y[i].first) <= r * r) {
                v.push_back(y[i].second);
            }
        }
    } else {
        for (ll i = r1; i <= l2; i++) {
            if ((tekx - x[i].first) * (tekx - x[i].first) + (teky - c[x[i].second].second) * (teky - c[x[i].second].second) <= r * r) {
                v.push_back(x[i].second);
            }
        }
    }
    return v;
}

void dfs(ll u) {
    op.push_back(u);
    used[u] = true;
    vector<ll> tek = find_near(u);
    for (ll i = 0; i < tek.size(); i++) {
        if (tek[i] == u) {
            continue;
        }
        if (!used[tek[i]]) {
            color[tek[i]] = 1 - color[u];
            dfs(tek[i]);
        } else if (color[tek[i]] == color[u]) {
            ans = true;
        }
    }
}

void solve() {
    anss.resize(n);
    for (ll i = 0; i < n; i++) {
        x.push_back({c[i].first, i});
        y.push_back({c[i].second, i});
    }
    sort(x.begin(), x.end());
    sort(y.begin(), y.end());
    /*rnds = {{0, 0}, {1e9, 1e9}, {-1e9, 1e9}, {-1e9, -1e9}, {1e9, -1e9}};
    for (ll i = 0; i < 5; i++) {
        rnds.push_back({r(), r()});
    }
    for (ll i = 0; i < rnds.size(); i++) {

    }*/
    color.assign(n, false);
    used.assign(n, false);
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            ans = false;
            dfs(i);
            for (ll i = 0; i < op.size(); i++) {
                if (ans) {
                    anss[op[i]] = '1';
                } else {
                    anss[op[i]] = '0';
                }
            }
            op = {};
        }
    }
    cout << anss;
}

void output() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
