#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int r, c;
    cin >> r >> c;

    vector a(r, vector<int>(c));
    for (int i = 0; i < r; i++)
    {
        for (int j = 0; j < c; j++)
        {
            cin >> a[i][j];
            --a[i][j];
        }
    }

    vector dp(r + 1, vector<int>(c + 1));
    for (int i = r - 1; i >= 0; i--)
    {
        vector<int> cnt(r * c);
        for (int j = c - 1; j >= 0; j--)
        {
            for (int k = i; k < r; k++)
                ++cnt[a[k][j]];
            
            int inv1 = dp[i + 1][j];
            for (int k = j; k < c; k++)
            {
                for (int l = 0; l < a[i][k]; l++)
                    inv1 += cnt[l];
                --cnt[a[i][k]];
            }
            for (int k = j; k < c; k++)
                ++cnt[a[i][k]];
            
            int inv2 = dp[i][j + 1];
            for (int k = i; k < r; k++)
            {
                for (int l = 0; l < a[k][j]; l++)
                    inv2 += cnt[l];
                --cnt[a[k][j]];
            }
            for (int k = i; k < r; k++)
                ++cnt[a[k][j]];
            
            dp[i][j] = min(inv1, inv2);
        }
    }

    cout << dp[0][0] << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}