#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    
    vector<int> gr_r(n, n);
    vector<int> stack;

    for (int i = 0; i < n; i++)
    {
        while (!stack.empty() && a[i] > a[stack.back()])
        {
            gr_r[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }

    for (int it = 0; it < q; it++)
    {
        int k, i;
        cin >> k >> i;

        int cur = 0;
        for (int t = 0; t < i - 1; t++)
        {

            int r = gr_r[cur];
            int nxt = -1;
            for (int j = cur + 1; j < min(r, n - k + 2); j++)
            {
                if (nxt == -1 || a[j] < a[nxt])
                    nxt = j;
            }
            if (k == 2 && r == n)
            {
                cur = n - 1;
                continue;
            }
            if (nxt == -1)
                cur = r;
            else
                cur = nxt;
            --k;
        }
        if (k == 1)
        {
            for (int j = cur; j < n; j++)
            {
                if (a[j] > a[cur])
                    cur = j;
            }
        }

        cout << a[cur] << '\n';
    }
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}