#include <bits/stdc++.h>

using namespace std;

#define int long long

struct fenw{
    vector<vector<int>> ans;
    fenw(int n, int m) {
        ans.resize(n + 1, vector<int> (m + 1));
    }
    void upd(int i, int j) {
        i++;
        j++;
        int oj = j;
        while (i < ans.size()) {
            while (j < ans[i].size()) {
                ans[i][j]++;
                j += ((-j) & j);
            }
            j = oj;
            i += ((-i) & i);
        }
    }
    int get(int i, int j) {
        i++;
        j++;
        int oj = j;
        int lans = 0;
        while (i > 0) {
            while (j > 0) {
                lans += ans[i][j];
                j -= ((-j) & j);
            }
            j = oj;
            i -= ((-i) & i);
        }
        return lans;
    }
};

int lans(vector<vector<int>> &v) {
    int n = v.size();
    int ans = 0;
    vector<pair<int, int>> ord(v.size() * v[0].size());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < v[i].size(); j++) {
            ord[v[i][j] - 1] = {i, j};
        }
    }
    reverse(ord.begin(), ord.end());
    fenw f(n, v[0].size());
    for (auto &i : ord) {
        ans += f.get(i.first, i.second);
        f.upd(i.first, i.second);
    }
    return ans;
}

main() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> v(r, vector<int> (c));
    for (auto &i : v) for (auto &j : i) cin >> j;
    cout << lans(v);
}