#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

bool operator<(vector<ll>&a, vector<ll>& b) {
	for (ll i = 0; i < min(a.size(), b.size()); ++i) {
		if (a[i] != b[i]) return a[i] < b[i];
	}
	return false;
}

void solve() {
	ll n, q; cin >> n >> q;
	vector<ll>v(n);
	for (auto& i : v) cin >> i;
	vector<vector<ll>>ans(n, vector<ll>(2 * n, INF));
	for (ll mask = 0; mask < (1 << n); ++mask) {
		ll k = 0;
		for (ll i = 0; i < n; ++i) {
			if ((mask >> i) & 1) k++;
		}
		if ((mask >> (n - 1)) & 1) k--;
		vector<ll>cur(k + 1, 1);
		ll pntr = 0;
		for (ll i = 0; i < n; ++i) {
			cur[pntr] = max(cur[pntr], v[i]);
			if ((mask >> i) & 1 && i != n - 1) pntr++;
		}

		if (cur < ans[k]) ans[k] = cur;
	}
	
	while (q--) {
		ll k, i; cin >> k >> i;
		k--; i--;
		cout << ans[k][i] << '\n';
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}