#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> suf_max(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf_max[i] = max(suf_max[i + 1], a[i]);
    }
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        if (ind != k) {
            cout << a[ind - 1] << endl;
        } else {
            if (k % 2 == 1) {
                cout << a[n - 1] << endl;
            } else {
                cout << suf_max[k - 2] << endl;
            }
        }
    }
    return 0;
}