#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
typedef long long ll;
 
int min(int a, int b) {
    return (a < b ? a : b);
}
 
 
const int MAXN = 1e5;
vector<int> g[MAXN];
 
 
ll pow2(ll a) {
    return a * a;
}
 
 
vector<int> comp;
int used[MAXN];
bool f = false;
 
 
void dfs(int v, int p, int c) {
    comp.pb(v);
    used[v] = c;
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        if (used[u]) {
            if (used[u] == used[v]) {
                f = true;
            }
        } else {
            dfs(u, v, 3 - c);
        }
    }
}

struct event{
    int first, second, idx;
};



bool cmp(event &a, event &b) {
    return a.first < b.first;
}


bool cmp2(event &a, event &b) {
    return a.second < b.second;
}

signed main() {
    fast;
 
 
    int n; ll r;
    cin >> n >> r;
    vector<event> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
        arr[i].idx = i;
    }
    sort(all(arr), cmp);
    int c = 750;
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - c); j < min(n, i + c); j++) {
            if (i == j) {
                continue;
            }
            if (pow2((ll) arr[i].first - arr[j].first) + pow2((ll) arr[i].second - arr[j].second) <= r * r) {
                g[arr[i].idx].pb(arr[j].idx);
                g[arr[j].idx].pb(arr[i].idx);
            }
        }
    }
    sort(all(arr), cmp2);
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - c); j < min(n, i + c); j++) {
            if (i == j) {
                continue;
            }
            if (pow2((ll) arr[i].first - arr[j].first) + pow2((ll) arr[i].second - arr[j].second) <= r * r) {
                g[arr[i].idx].pb(arr[j].idx);
                g[arr[j].idx].pb(arr[i].idx);
            }
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i, 1);
            if (f) {
                for (auto &u : comp) {
                    ans[u] = true;
                }
            }
            f = false;
            comp.clear();
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    line;
}