#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define int long long
#define all(a) a.begin(), a.end()
typedef long long ll;


signed main() {
    fast;


    int r, c;
    cin >> r >> c;
    vector<vector<int>> arr(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> arr[i][j];
        }
    }
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, 1e18));
    for (int i = 0; i <= r; i++) {
        dp[i][c] = 0;
    }
    for (int i = 0; i <= c; i++) {
        dp[r][i] = 0;
    }
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            // column
            int calc = 0;
            for (int x = i; x <= r - 1; x++) {
                for (int y = x + 1; y <= r - 1; y++) {
                    calc += (arr[x][j] > arr[y][j]);
                }
            }
            for (int x = i; x <= r - 1; x++) {
                for (int y = i; y <= r - 1; y++) {
                    for (int t = j + 1; t <= c - 1; t++) {
                        calc += (arr[x][j] > arr[y][t]);
                    }
                }
            }
            dp[i][j] = min(dp[i][j], dp[i][j + 1] + calc);
            // line
            calc = 0;
            for (int x = j; x <= c - 1; x++) {
                for (int y = x + 1; y <= c - 1; y++) {
                    calc += (arr[i][x] > arr[i][y]);
                }
            }
            for (int x = j; x <= c - 1; x++) {
                for (int y = j; y <= c - 1; y++) {
                    for (int t = i + 1; t <= r - 1; t++) {
                        calc += (arr[i][x] > arr[t][y]);
                    }
                }
            }
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + calc);
        }
    }
    cout << dp[0][0]; line;
}