#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
typedef long long ll;
vector<ll> tree;
 
 
ll get(int v, int tl, int tr, int l, int r) {
    if (tl > r || l > tr) {
        return 0;
    }
    if (l <= tl && tr <= r) {
        return tree[v];
    }
    int mid = (tl + tr) / 2;
    return get(v * 2, tl, mid, l, r) + get(v * 2 + 1, mid + 1, tr, l, r);
}
 
 
void upd(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        tree[v] += x;
        return;
    }
    int mid = (tl + tr) / 2;
    if (pos <= mid) {
        upd(v * 2, tl, mid, pos, x);
    } else {
        upd(v * 2 + 1, mid + 1, tr, pos, x);
    }
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}
 
signed main() {
    fast;
 
 
    int r, c;
    cin >> r >> c;
    vector<vector<int>> arr(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> arr[i][j];
        }
    }
    int N = r * c;
    if (r == 1) {
        ll ans = 0;
        tree.assign(4 * N, 0);
        for (int i = c - 1; i >= 0; i--) {
            ans += get(1, 1, N, 1, arr[0][i]);
            upd(1, 1, N, arr[0][i], 1);
        }
        cout << ans; line;
        return 0;
    }
    vector<int> t1, t2;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            t1.pb(arr[i][j]);
        }
    }
    for (int j = 0; j < c; j++) {
        for (int i = 0; i < r; i++) {
            t2.pb(arr[i][j]);
        }
    }
    ll ans1 = 0;
    tree.assign(4 * N, 0);
    for (int i = sz(t1); i >= 0; i--) {
        ans1 += get(1, 1, N, 1, t1[i]);
        upd(1, 1, N, t1[i], 1);
    }
    ll ans2 = 0;
    tree.assign(4 * N, 0);
    for (int i = sz(t2); i >= 0; i--) {
        ans2 += get(1, 1, N, 1, t2[i]);
        upd(1, 1, N, t2[i], 1);
    }
    cout << min(ans1, ans2); line;
}