//#define _GLIBCXX_DEBUG
#include<iostream>
#include <vector>
#include <bitset>
#include <map>
using namespace std;

vector<vector<int>>G;
vector<int>tim;
int m;
  
vector<int>c;
bitset<100'001>ans;
int col;
void dfs(int v) {
    c.push_back(v);
    tim[v]=col;
    for (auto j : G[v]) {
        if (tim[j] == tim[v]) {
            ans[m] = 1;
        } else if (!tim[j]) {
            col=3-col;
            dfs(j);
            col=tim[v];
        }
    }
}
 
  
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    long long r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    G.resize(n);

    map<int, vector<vector<int>>>x;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        x[a[i].first].push_back({a[i].second, i});
    }
  
  
    for (int i=0;i<n;++i) {
        int cx = a[i].first, cy = a[i].second;
        for (int j = cx - r; j <= cx + r; ++j) {
            if (x.contains(j)) {
                vector<int>need = {cy - (int)r, -1};
                int st = lower_bound(x[j].begin(), x[j].end(), need)-x[j].begin();
                for (int k=st;k<x[j].size();++k) {
                    int d1=(cx-j)*(cx-j)+(cy-x[j][st][0])*(cy-x[j][st][0]);
                    if (d1<=r*r) {
                        if (i==x[j][st][1]) continue;
                        //cout << i << ' ' << x[j][st][1] << "\n";
                        G[i].push_back(x[j][st][1]);
                        G[x[j][st][1]].push_back(i);
                    } else {
                        break;
                    }
                }
            }
        }
    }
    a.clear();
    tim.resize(n,0);
    for (int i=0;i<n;++i) {
        if (!tim[i]) {
            m=i;
            col=1;
            dfs(i);
            int x = ans[i];
            for (auto &j : c) {
                ans[j]=x;
            }c.clear();
            //cout<<"\n";
        }
        cout<<ans[i];
    }
}