#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main(){
	int n, q;
	cin >> n >> q;

	vector<bool> a(n), b(n);

	for (int i = 0; i < n; ++i) {
		char x;
		cin >> x;
		a[i] = (x == '1');
	}
	
	vector<int> ans(n + 1);

	int res = 0;
	for (int i = 0; i < n; ++i) {
		b[i] = (((i > 0 && a[i - 1]) || (i < n - 1 && a[i + 1])) && a[i]);
		res += b[i];
	}

	ans[0] = res;

	int cr = 1;
	for (int i = 1; i < n - 1; ++i) {
		if (!b[i - 1] && !b[i + 1] && a[i - 1] && a[i + 1]) {
			a[i] = b[i] = b[i - 1] = b[i + 1] = true;
			ans[cr++] = (res += 3);
		}
	}

	for (int i = 0; i < n - 1; ++i) {
		if (!b[i + 1] && a[i + 1]){
			a[i] = b[i] = b[i + 1] = true;
			ans[cr++] = (res += 2);
		}
		if (!b[i] && a[i]) {
			a[i + 1] = b[i + 1] = b[i] = true;
			ans[cr++] = (res += 2);
		}
	}

	bool fl = false;
	for (int i = 0; i < n; ++i) {
		fl = fl || a[i];
	}

	if (!fl) {
		ans[0] = ans[1] = 0;
		for (int j = 2; j <= n; ++j) {
			ans[j] = j;
		}
	}
	else {
		for (int j = cr; j <= n; ++j) {
			ans[j] = min(ans[j - 1] + 1, n);
		}
	}

	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		cout << ans[x] << '\n';
	}
}
