#include <bits/stdc++.h>

using ld = double;
using namespace std;

void solve();

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

struct node {
    int x, y, i, flag;
};

ld rast(node a, node b) {
    return sqrt((ld) (a.x - b.x) * (a.x - b.x) + (ld) (a.y - b.y) * (a.y - b.y));
}

bool cmp(node a, node b) {
    return a.x + a.y < b.x + b.y;
}

bool cmp1(node a, node b) {
    return a.i < b.i;
}

vector<vector<int> > g;

void solve() {
    int n, r;
    cin >> n >> r;
    g.resize(n);
    vector<node> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].y;
        arr[i].i = i;
    }
    sort(arr.begin(), arr.end(), cmp);
    vector<vector<int> > dp(n, vector<int>(2));
    deque<pair<int, int> > d;
    int color = 0;
    vector<int> mp(n + 1);
    for (int u = 0; u < n; u++) {
        if (arr[u].flag != 0) {
            continue;
        }
        color++;
        d.emplace_back(u, 0);
        while (!d.empty()) {
            auto [u, a] = d.front();
            arr[u].flag = color;
            d.pop_front();
            int cnt = 0;
            for (int j = 1; j < 10000; j++) {
                int v1 = u - j, v2 = u + j;
                if (v1 >= 0) {
                    if (dp[v1][(a + 1) % 2] == 1) {
                        continue;
                    }
                    ld r1 = rast(arr[u], arr[v1]);
                    if (r1 <= r) {
                        dp[v1][(a + 1) % 2] = 1;
                        d.emplace_back(v1, (a + 1) % 2);
                    }
                }
                if (v2 <= n - 1) {
                    if (dp[v2][(a + 1) % 2] == 1) {
                        continue;
                    }
                    ld r1 = rast(arr[u], arr[v2]);
                    if (r1 <= r) {
                        dp[v2][(a + 1) % 2] = 1;
                        d.emplace_back(v2, (a + 1) % 2);
                    }
                }
            }
        }
        if (dp[u][1] == 1) {
            mp[color] = 1;
        }
    }
    sort(arr.begin(), arr.end(), cmp1);
    for (int i = 0; i < n; i++) {
        if (mp[arr[i].flag] == 1) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
