#include <bits/stdc++.h>

using ld = double;
using namespace std;

const int INF = 1e18;

void solve();

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

struct node {
    int x, y;
};

ld rast(node a, node b) {
    return sqrt((ld)(a.x - b.x) * (a.x - b.x) + (ld)(a.y - b.y) * (a.y - b.y));
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<node> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].y;
    }
    vector<int> used(n);
    int color = 0;
    map<int, int> mp;
    for (int u = 0; u < n; u++) {
        if (used[u] != 0) {
            continue;
        }
        color++;
        vector<vector<int> > dp(n, vector<int>(2));
        dp[u][0] = 1;
        deque<pair<int,int> > d;
        d.emplace_back(u, 0);

        while (!d.empty()) {
            auto [u, a] = d.front();
            used[u] = color;
            d.pop_front();
            for (int v = 0; v < n; v++) {
                if (u == v) {
                    continue;
                }
                if (dp[v][(a + 1) % 2] == 1) {
                    continue;
                }
                ld r1 = rast(arr[u], arr[v]);
                if (r1 <= r) {
                    dp[v][(a + 1) % 2] = 1;
                    d.emplace_back(v, (a + 1) % 2);
                }
            }
        }
        if (dp[u][1] == 1) {
            mp[color] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        if (mp[used[i]] == 1) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
