#include <bits/stdc++.h>

using ld = double;
using namespace std;

void solve();

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

struct node {
    int x, y, i, flag;
};

ld rast(node a, node b) {
    return sqrt((ld) (a.x - b.x) * (a.x - b.x) + (ld) (a.y - b.y) * (a.y - b.y));
}

bool cmp(node a, node b) {
    return a.x < b.x;
}

bool cmp1(node a, node b) {
    return a.i < b.i;
}

const int INF = 1e9;

void solve() {
    int n, r;
    cin >> n >> r;
    vector<node> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].y;
        arr[i].i = i;
    }
    sort(arr.begin(), arr.end(), cmp);
    for (int i = 0; i + 2 < n; i++) {
        ld r1 = rast(arr[i], arr[i + 2]);
        if (r1 <= r) {
            arr[i].flag = 1;
            arr[i + 1].flag = 1;
        }
    }
    node a = {-INF, 0};
    for (int i = 0; i < n; i++) {
        if (arr[i].flag == 1) {
            a = arr[i];
            continue;
        }
        int r1 = rast(a, arr[i]);
        if (r1 <= r) {
            a = arr[i];
            arr[i].flag = 1;
        }
    }
    a = {INF, 0};
    for (int i = n - 1; i >= 0; i--) {
        if (arr[i].flag == 1) {
            a = arr[i];
            continue;
        }
        int r1 = rast(a, arr[i]);
        if (r1 <= r) {
            a = arr[i];
            arr[i].flag = 1;
        }
    }
    sort(arr.begin(), arr.end(), cmp1);

    for (int i = 0; i < n; i++) {
        cout << arr[i].flag;
    }
}
