#include <bits/stdc++.h>

using namespace std;
void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t=1;
    //cin>>t;
    while (t--) {
        solve();
    }
}

#define int __int16
#define intl long long
#define endl '\n'
const int N=2e4+10,MOD=1e9+7,INF=2e18;

int p[N];
int r[N];
int get(int v) {
    if (v==p[v])return v;
    return p[v]=get(p[v]);
}
void unite(int f,int s) {
    f=get(f),s=get(s);
    if (f!=s) {
        if (r[f]==r[s]) {
            p[f]=s;
            r[s]++;
        }else if (r[f]>r[s]) {
            p[s]=f;
        }else {
            p[f]=s;
        }
    }
}

struct point {
    intl x,y;
};
intl dist(point a,point b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}
void solve() {
    iota(p,p+N,0);
    intl n,r;
    cin>>n>>r;
    intl kr=r*r;
    vector<point> a(n);
    for (int i=0;i<n;i++) {
        cin>>a[i].x>>a[i].y;
    }
    vector<int> ans(n,-1);
    for (int i=0;i<n;i++) {
        if (ans[i]!=-1)continue;
        vector<int> val;
        for (int j=0;j<n;j++) {
            if (j!=i && dist(a[i],a[j])<=kr) {
                unite(i,j+n);
                unite(j,i+n);
            }
        }
    }
    for (int i=0;i<n;i++) {
        if (ans[i]==1 || get(i)==get(i+n)) {
            cout<<1;
        }else {
            cout<<0;
        }
    }
    cout<<endl;
}