#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
}

#define int long long
#define endl '\n'
const int N = 2e5 + 10, MOD = 1e9 + 7, INF = 2e18;

int p[N];
int r[N];
int get(int v) {
    if (v == p[v])return v;
    return p[v] = get(p[v]);
}

void unite(int f,int s) {
    f = get(f), s = get(s);
    if (f != s) {
        if (r[f] == r[s]) {
            p[f] = s;
            r[s]++;
        } else if (r[f] > r[s]) {
            p[s] = f;
        } else {
            p[f] = s;
        }
    }
}

struct point {
    int x, y;
};

int dist(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve() {
    auto cp=&p;
    iota(p, p + N, 0);
    int n, r;
    cin >> n >> r;
    int kr = r * r;
    vector<point> a(n);
    map<int,vector<pair<int,int>>> mp;
    vector<pair<int,int>> v;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        v.emplace_back(a[i].x,i);
    }
    sort(v.begin(),v.end());
    for (int i=0;i<n;i++) {
        pair<int,int> check={a[i].x-r,-1};
        int pos=lower_bound(v.begin(),v.end(),check)-v.begin();
        if (pos!=i) {
            unite(i,pos+n);
            unite(pos,i+n);
        }
    }
    for (int i=0;i<n;i++) {
        if (ans[i]==1 || get(i)==get(i+n)) {
            cout<<1;
        }else {
            cout<<0;
        }
    }
    cout<<endl;
}
