#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
}

#define int long long
#define endl '\n'
const int N = 3e5 + 10, MOD = 1e9 + 7, INF = 2e18;

struct seg_tree {
    vector<int> t[4*N];
    void build(int v,int l,int r,vector<int> &a) {
        if (l==r) {
            t[v].push_back(a[l]);
            return;
        }
        int m=(l+r)/2;
        build(v*2,l,m,a);
        build(v*2+1,m+1,r,a);
        t[v]=t[v*2];
        for (auto c:t[v*2+1])t[v].push_back(c);
        sort(t[v].begin(),t[v].end());
    }
    int get(int v,int l,int r,int tl,int tr,int val) {
        if (l>=tl && r<=tr) {
            int pos=upper_bound(t[v].begin(),t[v].end(),val)-t[v].begin();
            return t[v].size()-pos;
        }
        if (l>tr || r<tl) {
            return 0;
        }
        int m=(l+r)/2;
        int lv=get(v*2,l,m,tl,tr,val);
        int rv=get(v*2+1,m+1,r,tl,tr,val);
        return lv+rv;
    }
};

seg_tree t;
void solve() {
    int r,c;
    cin>>r>>c;
    vector<vector<int>> a(r,vector<int>(c));
    vector<int> b;
    for (int i=0;i<r;i++) {
        for (int j=0;j<c;j++) {
            cin>>a[i][j];
        }
        b.push_back(a[i][0]);
    }
    int ans=0;
    t.build(1,0,c-1,b);
    for (int i=0;i<c;i++) {
        ans+=t.get(1,0,c-1,0,i-1,b[i]);
    }
    cout<<ans<<endl;
}
