#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, q;
    cin >> n >> q;

    vector <int> s;

    char c;
    bool f = true;
    for (int i=0; i<n; i++)
    {
        cin >> c;
        s.push_back(c-'0');
        if (i && s[i] && s[i-1])
        {
            s[i] = 2;
            s[i-1] = 2;
        }
        if (s[i]) f = false;
    }

    if (f)
    {
        int x;
        for (int i=0; i<q; i++)
        {
            cin >> x;
            if (x > 1) cout << x << '\n';
            else cout << 0 << '\n';
        }
        return;
    }

    int ans=0;
    for (int i=0; i<n; i++)
    {
        if (s[i] == 2) ans++;
        if (i && i<n-1 && s[i] == 0 && s[i-1] == 1 && s[i+1] == 1)
        {
            s[i] = 3;
            if (i < n-2) s[i+2] = 4;
            if (i > 2 && s[i-2] == 4) s[i-2] = 0;
        }
    }

    for (int i=0; i<n; i++)
    {
        if (((i && i<n-1 && s[i-1] + s[i+1] == 3) || i == n-1) && (s[i] == 0 || s[i] == 4))
        {
            s[i] = 4-s[i];
        }
    }
    
    int plus1=0, plus2=0, plus3=0;

    for (int i=0; i<n; i++)
    {
        if (s[i] == 0) plus1++;
        if (s[i] == 4) plus2++;
        if (s[i] == 3) plus3++;
    }

    int x;
    for (int i=0; i<q; i++)
    {
        cin >> x;
        int ans1=ans;
        if (x) ans1 += 3*min(x, plus3);
        x -= min(x, plus3);
        if (x) ans1 += 2*min(x, plus2);
        x -= min(x, plus2);
        if (x) ans1 += min(x, plus1);
        cout << ans1 << '\n';
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;

    // cin >> t;

    for (int i=0; i<t; i++)
    {
        solve();
        cout << endl;
    }

    return 0;
}