#include <bits/stdc++.h>

using namespace std;

vector<vector<long long>> g;
vector<long long> mark;
vector<long long> c1, c2;

void dfs(long long v, long long col) {
    mark[v] = col;
    if (col == 0) c1.push_back(v);
    else c2.push_back(v);
    for (long long u : g[v]) {
        if (mark[u] == -1) dfs(u, (col + 1) % 2);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    long long n, d, a, b;
    cin >> n >> d;
    g.resize(n);
    mark.resize(n, -1);
    for (long long i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    cout << min(c1.size(), c2.size()) << endl;
    for (long long i = 0; i < min(c1.size(), c2.size()) ; i++) {
        cout << c1[i] + 1 << " " << c2[i] + 1 << endl;
    }
    return 0;
}
