#include <bits/stdc++.h>

using namespace std;

vector<vector<long long>> g;
vector<long long> mark, used, mt;
vector<long long> c1, c2;
long long cnt = 0, d;
vector<vector<long long>> g1;

void dfs(long long v, long long col) {
    mark[v] = col;
    if (col == 0) c1.push_back(v);
    else c2.push_back(v);
    for (long long u : g[v]) {
        if (mark[u] == -1) dfs(u, (col + 1) % 2);
    }
}

void dfs1(long long v, long long r, long long s) {
    used[v] = cnt;
    if (r % 2 == 1) g1[s].push_back(v);
    for (long long u : g[v]) {
        if (used[u] != cnt && r + 1 <= d) dfs1(u, r + 1, s);
    }
}

bool try1(long long v) {
    used[v] = cnt;
    for (long long u : g1[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return true;
        }
        if (used[mt[u]] != cnt && try1(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    long long n, a, b;
    cin >> n >> d;
    g.resize(n);
    mark.resize(n, -1);
    used.resize(n, 0);
    for (long long i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    g1.resize(n);
    mt.resize(n, -1);
    for (long long u : c1) {
        cnt++;
        dfs1(u, 0, u);
    }
    //cout << endl;
    //for (long long i = 0; i < n; i++) {
    //    for (long long u : g1[i]) cout << u << " ";
    //    cout << endl;
    //}
    //cout << endl;
    long long ans = 0;
    for (long long u : c1) {
        cnt++;
        if (try1(u)) ans++;
    }
    cout << ans << endl;
    for (long long i = 0; i < n; i++) {
        if (mt[i] != -1) cout << mt[i] + 1 << " " << i + 1 << endl;
    }
    return 0;
}
