#include <bits/stdc++.h>
#define int long long

using namespace std;

using ll = __int128_t;

const __int128_t INF = 1e36;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& el : x)
        cin >> el;
    sort(x.begin(), x.end());
    ll mxx = *max_element(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    mxx = max(mxx, (ll)x0);
    vector<ll> rsqsum(n + 1), rsum(n + 1);
    for (int i = n - 1;i >= 0; --i) {
        rsqsum[i] = (i == n - 1 ? (ll)0 : rsqsum[i + 1]) + (ll)x[i] * x[i];
        rsum[i] = (i == n - 1 ? (ll)0 : rsum[i + 1]) + (ll)x[i];
    }
    auto eval = [&](ll curx, ll t) {
        ll ans = curx * t;
        auto it = upper_bound(x.begin(), x.end(), curx) - x.begin();
        if (it == x.size())
            return ans;
        ans += rsqsum[it];
        ans += curx * curx * (x.size() - it);
        ans -= 2 * curx * rsum[it];
        return ans;
        };
    auto get1 = [&](ll t) {
        ll l = -mxx - 1, r = mxx + 1;
        while (l + 2 < r) {
            ll m1 = l + (r - l) / 3;
            ll m2 = l + (r - l) / 3 * 2;
            ll val1 = eval(m1, t);
            ll val2 = eval(m2, t);
            if (val1 < val2)
                r = m2;
            else
                l = m1;
        }
        ll best = INF;
        for (int i = l; i <= r; ++i) {
            ll val = eval(i, t);
            best = min(val, best);
        }
        return best;
        };
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        cout << (int)get1(t) << '\n';
    }
}