#include <bits/stdc++.h>

using namespace std;

using ll = __int128_t;

const __int128_t INF = 1e36;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& el : x)
        cin >> el;
    sort(x.begin(), x.end());
    ll mxx = *max_element(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    mxx = max(mxx, (ll)x0);
    vector<int> rx, lx;
    for (auto el : x) {
        if (el > x0)
            rx.push_back(el);
        else
            lx.push_back(el);
    }
    vector<ll> rsqsum(rx.size() + 1), rsum(rx.size() + 1);
    for (int i = rx.size() - 1;i >= 0; --i) {
        rsqsum[i] = (i == n - 1 ? (ll)0 : rsqsum[i + 1]) + (ll)rx[i] * rx[i];
        rsum[i] = (i == n - 1 ? (ll)0 : rsum[i + 1]) + (ll)rx[i];
    }
    auto evalr = [&](ll curx, ll t) {
        ll ans = (ll)abs((int)curx - x0) * t;
        auto it = upper_bound(rx.begin(), rx.end(), curx) - rx.begin();
        if (it == rx.size())
            return ans;
        ans += rsqsum[it];
        ans += curx * curx * (rx.size() - it);
        ans -= 2 * curx * rsum[it];
        return ans;
        };
    vector<ll> lsqsum(lx.size() + 1), lsum(lx.size() + 1);
    for (int i = 0; i < lx.size(); ++i) {
        lsqsum[i] = (i == 0 ? (ll)0 : lsqsum[i - 1]) + (ll)lx[i] * lx[i];
        lsum[i] = (i == 0 ? (ll)0 : lsum[i - 1]) + (ll)lx[i];
    }
    auto evall = [&](ll curx, ll t) {
        ll ans = (ll)abs((int)curx - x0) * t;
        auto it = lower_bound(lx.begin(), lx.end(), curx) - lx.begin() - 1;
        if (it == -1)
            return ans;
        ans += lsqsum[it];
        ans += curx * curx * (it + 1);
        ans -= 2 * curx * lsum[it];
        return ans;
        };
    auto getr = [&](ll t) {
        ll l = -mxx - 1, r = mxx + 1;
        while (l + 2 < r) {
            ll m1 = l + (r - l) / 3;
            ll m2 = l + (r - l) / 3 * 2;
            ll val1 = evalr(x0 + m1 * d, t);
            ll val2 = evalr(x0 + m2 * d, t);
            if (val1 < val2)
                r = m2;
            else
                l = m1;
        }
        ll best = INF;
        for (int i = l; i <= r; ++i) {
            ll val = evalr(x0 + i * d, t);
            best = min(val, best);
        }
        return best;
        };
    auto getl = [&](ll t) {
        ll l = -mxx - 1, r = mxx + 1;
        while (l + 2 < r) {
            ll m1 = l + (r - l) / 3;
            ll m2 = l + (r - l) / 3 * 2;
            ll val1 = evall(x0 + m1 * d, t);
            ll val2 = evall(x0 + m2 * d, t);
            if (val1 < val2)
                r = m2;
            else
                l = m1;
        }
        ll best = INF;
        for (int i = l; i <= r; ++i) {
            ll val = evall(x0 + i * d, t);
            best = min(val, best);
        }
        return best;
        };
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        ll var1 = getl(2 * t) + getr(t);
        ll var2 = getl(t) + getr(2 * t);
        cout << (int)min(var1, var2) << '\n';
    }
}