#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
using ll = long long;
using namespace std;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> v(n);
	for (int i = 0; i < n; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		v[i] = { l, m, r };
	}
	sort(v.begin(), v.end());
	vector<bool> dp(n);
	for (int i = 0; i < n; i++) {
		if (get<0>(v[i]) == 1) dp[i] = 1;
	}
	for (int i = 0; i < n; i++) {
		if (dp[i]) {
			for (int j = i + 1; j < n; j++) {
				if (get<1>(v[i]) < get<1>(v[j]) && get<2>(v[i]) < get<2>(v[j])) {
					dp[j] = 1;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (get<2>(v[i]) == n) {
			cout << "YES\n";
			return;
		}
	}
	cout << "NO\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
