#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
using ll = long long;
using namespace std;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> v(k);
	for (int i = 0; i < k; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		v[i] = { l, m, r };
	}
	sort(v.begin(), v.end());
	vector<bool> dp(k);
	for (int i = 0; i < k; i++) {
		if (get<0>(v[i]) == 1) dp[i] = 1;
	}
	for (int j = 0; j < k; j++) {
		for (int i = 0; i < j; i++) {
			if (get<0>(v[j]) - 1 <= get<2>(v[i]) && get<2>(v[i]) < get<1>(v[j])) {
				dp[j] = dp[j] || dp[i];
			}
			if (get<0>(v[j]) - 1 <= get<2>(v[i]) && get<1>(v[i]) < get<0>(v[j])) {
				dp[j] = dp[j] || dp[i];
			}
		}
	}
	for (int i = 0; i < k; i++) {
		if (dp[i] && get<2>(v[i]) == n) {
			cout << "YES\n";
			return;
		}
	}
	cout << "NO\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
