#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<vector<bool>> arr(h, vector<bool>(w, false));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char c; cin >> c; arr[i][j] = (c == '1');
        }
    }
    vector<vector<int>> maxright(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        if (arr[i].back()) maxright[i].back() = w - 1;
        else maxright[i].back() = w - 2;
        for (int j = w - 2; j >= 0; --j) {
            if (!arr[i][j]) maxright[i][j] = j - 1;
            if (arr[i][j]) maxright[i][j] = maxright[i][j + 1];
        }
    }
    int answer = 0;
    for (int j = 0; j < w; ++j) {
        vector<pair<int, int>> st;
        int now = 0;
        for (int i = 0; i < h; ++i) {
            if (!arr[i][j]) {
                now = 0;
                st.clear();
                continue;
            }
            int maxi = maxright[i][j] - j + 1;
            now += maxi;
            int cnt = 1;
            while (!st.empty() && st.back().first >= maxi) {
                now -= st.back().second * (st.back().first - maxi);
                cnt += st.back().second;
                st.pop_back();
            }
            st.push_back({maxi, cnt});
            answer = max(answer, now);
        }
    }
    cout << answer << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}