#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
// typedef __int128 lll;

ll get(ll dist, ll d, ll t, ll k) {
    return (dist - k * d) * (dist - k * d) + t * k;
}

ll solve1(ll dist, ll d, ll t) {
    ll l = -1, r = dist / d + 2;
    while (r - l > 2) {
        ll ml = (r + l) / 2, mr = (r + l) / 2 + 1;
        if (get(dist, d, t, ml) < get(dist, d, t, mr)) r = mr;
        else l = ml;
    }
    ll answer = get(dist, d, t, l);
    for (ll i = l + 1; i <= r; ++i) answer = min(answer, get(dist, d, t, i));
    return answer;
}


void solve() {
    ll n;
    cin >> n;
    vector<ll> x(n);
    for (ll i = 0; i < n; ++i) cin >> x[i];
    ll x0, d;
    cin >> x0 >> d;
    ll m;
    cin >> m;
    while (m--) {
        int t; cin >> t;
        ll ans1 = solve1(abs(x0 - x[0]), d, t) + solve1(abs(x0 - x[1]), d, t * 2);
        ll ans2 = solve1(abs(x0 - x[0]), d, t * 2) + solve1(abs(x0 - x[1]), d, t);
        cout << min(ans1, ans2) << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}