#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// #define tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int h, w;
    cin >> h >> w;
    vector<string> m(h);
    for (int i = 0; i < h; ++i) {
        cin >> m[i];
    }
    vector<int> a(w);
    vector<int> hi(w);
    int ans = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (m[i][j] == '1') {
                a[j]++;
            } else {
                a[j] = 0;
            }
        }
        vector<int> st;

        for (int j = w - 1; j >= 0; --j) {
            while (!st.empty() && a[st.back()] >= a[j]) {
                st.pop_back();
            }
            if (st.empty()) {
                hi[j] = w;
            } else {
                hi[j] = st.back();
            }
            st.push_back(j);
        }

        int res = 0;
        vector<bool> used(w, false);
        for (int j = 0; j < w; ++j) {
            if (used[j] || a[j] == 0) continue;
            int sum = 0;
            int cur = j;
            do {
                sum += a[cur] * (hi[cur] - cur);
                used[cur] = true;
                cur = hi[cur];
            } while (cur != w && a[cur] != 0);
            res = max(res, sum);
        }
        ans = max(ans, res);
    }
    cout << ans;
}