#include <bits/stdc++.h>
using namespace std;

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int n, k;
    cin >> n >> k;
    vector<int> L(k), M(k), R(k);
    for (int i = 0; i < k; i++) {
      cin >> L[i] >> M[i] >> R[i];
      --L[i], --M[i];
    }
    vector<int> ord(k);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int x, int y) {
      return L[x] < L[y];
    });
    vector<bool> dp(k); // dp[i] = whether it is possible to cover all guys before given segment
    for (int i = 0; i < k; i++) {
      if (L[i] == 0) {
        dp[i] = true;
      }
    }
    for (int i = 0; i < k; i++) {
      for (int j = 0; j < i; j++) {
        if (R[ord[j]] >= L[ord[i]] && R[ord[j]] < R[ord[i]] && dp[ord[j]]) {
          bool cycle = M[ord[j]] >= L[ord[i]] && M[ord[i]] <= R[ord[j]];
          if (!cycle) {
            dp[ord[i]] = true;
          }
        }
      }
    }
    bool answer = false;
    for (int i = 0; i < k; i++) {
      if (R[i] == n) {
        answer |= dp[i];
      }
    }
    cout << (answer ? "YES\n" : "NO\n");
  }
}
