#include<bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, sz;
        cin >> n >> sz;
        vector<vector<pair<int, int>>> occ(n + 1);
        for (int i = 0; i < sz; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            occ[r].emplace_back(l, m);
        }
        int tsz = n + 1;
        vector<int> tr(2 * tsz, tsz);
        auto upd = [&](int k, int x) -> void {
            for (tr[k += tsz] = x; k > 1; k >>= 1, tr[k] = min(tr[k << 1], tr[k << 1 | 1]));
        };
        auto get = [&](int l, int r) -> int {
            int ret = tsz;
            for (l += tsz, r += tsz; l <= r; l >>= 1, r >>= 1) {
                if (l & 1) ret = min(ret, tr[l++]);
                if (~r & 1) ret = min(ret, tr[r--]);
            }
            return ret;
        };
        upd(0, 0);
        for (int i = 1; i <= n; ++i) {
            int val = tsz;
            for (auto [l, m] : occ[i]) {
                if (get(l - 1, i - 1) < l) val = min(val, m);
                if (get(l - 1, m - 1) < tsz) val = min(val, m);
            }
            upd(i, val);
        }
        if (get(n, n) < tsz) cout << "YES\n";
        else cout << "NO\n";
    }
}