#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, D;
    cin >> n >> D;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<bool> depth(n);
    {
        auto dfs = [&](auto dfs, int u, int p) -> void {
            for (auto to : g[u]) {
                if (to != p) {
                    depth[to] = !depth[u];
                    dfs(dfs, to, u);
                }
            }
        };
        dfs(dfs, 0, -1);
    }
    // vector<vector<pair<int, int>>> par(n);
    // vector<vector<pair<int, int>>> all(n);
    // vector<int> ndel(n, 0), nused(n, 0);
    // {
    //     vector<int> sz(n);
    //     vector<bool> del(n, false);
    //     auto dc = [&](auto dc, int c) -> void {
    //         auto sizes = [&](auto sizes, int u, int p) -> int {
    //             sz[u] = 1;
    //             for (auto to : g[u]) {
    //                 if (to != p && !del[to]) sz[u] += sizes(sizes, to, u);
    //             }
    //             return sz[u];
    //         };
    //         int m = sizes(sizes, c, -1);
    //         while (true) {
    //             bool fnd = false;
    //             for (auto to : g[c]) {
    //                 if (!del[to] && sz[to] < sz[c] && sz[to] > m / 2) {
    //                     c = to;
    //                     fnd = true;
    //                     break;
    //                 }
    //             }
    //             if (!fnd) break;
    //         }
    //         auto dfs = [&](auto dfs, int u, int p, int d) -> void {
    //             if (depth[u]) all[c].emplace_back(d, u);
    //             else par[u].emplace_back(c, d);
    //             for (auto to : g[u]) {
    //                 if (to != p && !del[to]) dfs(dfs, to, u, d + 1);
    //             }
    //         };
    //         dfs(dfs, c, -1, 0);
    //         del[c] = true;
    //         sort(all[c].begin(), all[c].end());
    //         for (auto to : g[c]) {
    //             if (!del[to]) dc(dc, to);
    //         }
    //     };
    //     dc(dc, 0);
    // }
    // vector<int> tim(n, 0);
    vector<int> mt(n, -1), used(n, 0);
    int timer = 0;
    auto try_kuhn = [&](auto try_kuhn, int u) -> bool {
        used[u] = timer;
        for (auto to : g[u]) {
            if (mt[to] == -1) {
                mt[to] = u;
                return true;
            }
        }
        for (auto to : g[u]) {
            if (used[mt[to]] != timer && try_kuhn(try_kuhn, mt[to])) {
                mt[to] = u;
                return true;
            }
        }
        return false;
        // for (auto [c, d] : par[u]) {
        //     if (tim[c] != timer) {
        //         tim[c] = timer;
        //         nused[c] = 0;
        //     }
        //     int bound = D - d;
        //     if (bound < 0) continue;
        //     auto& ndl = ndel[c];
        //     auto& vert = all[c];
        //     while (ndl < vert.size() && mt[vert[ndl].second] != -1) ++ndl;
        //     if (ndl < vert.size() && vert[ndl].first <= bound) {
        //         mt[vert[ndl].second] = u;
        //         return true;
        //     }
        // }
        // for (auto [c, d] : par[u]) {
        //     if (tim[c] != timer) {
        //         tim[c] = timer;
        //         nused[c] = 0;
        //     }
        //     int bound = D - d;
        //     if (bound < 0) continue;
        //     auto& vert = all[c];
        //     auto& nusd = nused[c];
        //     while (true) {
        //         while (nusd < vert.size() && vert[nusd].first <= bound && used[mt[vert[nusd].second]] == timer) ++nusd;
        //         if (nusd >= vert.size() || vert[nusd].first > bound) break;
        //         if (try_kuhn(try_kuhn, mt[vert[nusd].second])) {
        //             mt[vert[nusd].second] = u;
        //             return true;
        //         }
        //     }
        // }
        // return false;
    };
    for (int i = 0; i < n; ++i) {
        if (depth[i]) continue;
        timer++;
        try_kuhn(try_kuhn, i);
    }
    vector<pair<int, int>> ret;
    for (int i = 0; i < n; ++i) {
        if (mt[i] != -1) {
            ret.emplace_back(i, mt[i]);
        }
    }
    cout << ret.size() << '\n';
    for (auto [x, y] : ret) cout << x + 1 << ' ' << y + 1 << '\n';
}