#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<array<vector<int>, 4>> cnt(n);
    vector<pair<int, int>> ret;
    auto dfs = [&](auto dfs, int u, int p) -> void {
        cnt[u][0] = {u};
        for (auto to : g[u]) {
            if (to != p) {
                dfs(dfs, to, u);
                for (int i = 0; i < 3; ++i) {
                    if (cnt[u][i + 1].size() < cnt[to][i].size()) swap(cnt[u][i + 1], cnt[to][i]);
                    for (auto x : cnt[to][i]) cnt[u][i + 1].push_back(x);
                }
                for (int i = 0; i < 4; ++i) {
                    cnt[to][i].clear();
                }
            }
        }
        for (int i = 3; i >= 0; --i) {
            for (int j = 3; j >= 0; --j) {
                if (i + j <= d && (i + j) % 2 == 1) {
                    while (cnt[u][i].size() && cnt[u][j].size()) {
                        ret.emplace_back(cnt[u][i].back(), cnt[u][j].back());
                        cnt[u][i].pop_back();
                        cnt[u][j].pop_back();
                    }
                }
            }
        }
    };
    dfs(dfs, 0, -1);
    cout << ret.size() << '\n';
    for (auto [x, y] : ret) cout << x + 1 << ' ' << y + 1 << '\n';
}