#include <bits/stdc++.h>

using namespace std;
// #define int long long
struct node {
    int val = 0;
    int push = 0;
};
vector<node> tree;
void push(int v) {
    tree[2 * v].val += tree[v].push;
    tree[2 * v + 1].val += tree[v].push;
    tree[2 * v].push += tree[v].push;
    tree[2 * v + 1].push += tree[v].push;
    tree[v].push = 0;
}
void upd(int v, int vl, int vr, int ql, int qr) {
    if (vl >= qr || vr <= ql) {
        return;
    }
    if (vl >= ql && vr <= qr) {
        tree[v].val++;
        tree[v].push++;
        return;
    }
    int m = (vl + vr) / 2;
    upd(2 * v, vl, m, ql, qr);
    upd(2 * v + 1, m, vr, ql, qr);
    tree[v].val = tree[2 * v].val + tree[2 * v + 1].val;
}
int get(int v, int vl, int vr, int x) {
    if (vr - vl == 1) {
        return tree[v].val;
    }
    push(v);
    int m = (vl + vr) / 2;
    if (x >= m) {
        return get(2 * v + 1, m, vr, x);
    }
    return get(2 * v, vl, m, x);
}
signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<vector<int> > a(k, vector<int>(3));
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < 3; j++) {
                cin >> a[i][j];
            }
        }
        sort(a.begin(), a.end());
        reverse(a.begin(), a.end());
        tree.resize(4 * n);
        for (int i = 0; i < k; i++) {
            if (get(1, 0, n, a[i][1] - 1) == 0) {
                upd(1, 0, n, a[i][0] - 1, a[i][2]);
            }
        }
        bool flag = true;
        for (int i = 0; i < n; i++) {
            if (get(1, 0, n, i) == 0) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES";
        } else {
            cout << "NO";
        }
        cout << endl;
    }
    return 0;
}
