#include<bits/stdc++.h>
using ll = __int128_t;
#define int long long
using namespace std;
ll inf = 8e30;
ll zer = 0;
ll one = 1;
struct line {
    ll k, b;
    line(ll k_ = 0, ll b_ = inf) {
        k = k_, b = b_;
    }
    ll get(ll x) {
        return k*x+b;
    }
};
struct LiTree {
    vector<line> t;
    vector<int> quer;
    ll sz;
    LiTree(vector<int> val = {1}) {
        sz = val.size();
        quer = val;
        sort(quer.begin(), quer.end());
        t.assign(4*sz, line());
    }
    void add(ll k, ll b) {
        _add(1, 0, sz, line(k, b));
    }
    void _add(ll v, ll l, ll r, line a) {
        ll m = (r+l)/2;
        if (t[v].get(quer[m])>a.get(quer[m])) {
            swap(a, t[v]);
        }
        if (r==l+1) {
            return;
        }
        if (a.k>t[v].k) {
            _add(2*v, l, m, a);
        }
        else {
            _add(2*v+1, m, r, a);
        }
    }
    ll get(ll x) {
        return _get(1, 0, sz, x);
    }
    ll _get(ll v, ll l, ll r, ll x) {
        if (l+1==r) {
            return t[v].get(x);
        }
        ll m = (r+l)/2;
        if (x>=quer[m]) {
            return min(t[v].get(x), _get(2*v+1, m, r, x));
        }
        return min(t[v].get(x), _get(2*v, l, m, x));
    }
};
void solve() {
    int n;
    cin>>n;
    vector<int> v(n);

    for (auto &x: v)cin>>x;
    sort(v.begin(), v.end());
    int x0, d;
    cin>>x0>>d;
    int m;
    cin>>m;
    vector<int> v1(m);
    for (auto &x: v1)cin>>x;
    for (int i = 0; i<n; i++) {
        v[i]-=x0;
    }
    LiTree lt = v1;
    auto v2 = v;
    for (int i = 0; i<n; i++) {
        v2[i]=min(v[i]%d, d-v[i]%d);
        v2[i]*=v2[i];
    }
    vector<ll> pref(n+1), suf(n+1), suf1(n+1);
    for (int i = 0; i<n; i++) {
        pref[i+1]=pref[i]+v2[i];
    }
    for (int i = n-1; i>-1; i--) {
        suf[i]=suf[i+1]+v[i]*v[i];
        suf1[i]=suf1[i+1]+v[i];
    }
    ll cur = 0;
    for (int k = 0; k*d<=1e6+1000; k++) {
        if (cur==n) {
            break;
        }
        while (cur<n&&v[cur]<=k*d) {
            cur++;
        }
        lt.add(k, pref[cur]+suf[cur]+one*(n-cur)*k*k*d*d-one*2*suf1[cur]*k*d);
        // cout<<k<<" "<<pref[cur]+suf[cur]+(n-cur)*k*k*d*d-2*suf1[cur]*k*d<<"\n";
        // cout<<cur<<"\n";
    }
    for (int i = 0; i<m; i++) {
        cout<<(int)lt.get(v1[i])<<"\n";
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while (AnyaSamsonovaGoSex--)solve();
}