#include <bits/stdc++.h>
using namespace std;


const int N = 4e6 + 1;

struct Node {
    int x, type, m;
};


bool cmp (Node a, Node b) {
    return (a.x != b.x ? a.x < b.x : a.type < b.type);
}
void solve() {
    int n, k;
    cin >> n >> k;

    vector<Node> cur;
    vector<Node> events;
    vector<int> was(k);
    vector<int> last_l(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        last_l[i] = l;
        cur.push_back({l, r, m});
        was[i] = m;
        events.push_back({l, -1, i});
        events.push_back({r, 1, i});
    }
    sort(events.begin(), events.end(), cmp);
    // for (auto &[x, type, ind] : events) {
    //     cout << x << ' ' << type << ' ' << ind << '\n';
    // }
    // cout << '\n';
    vector<int> help;
    multiset<int> st_l, st_r, st_m;
    vector<int> dp(k);
    for (auto &[x, type, ind] : events) {
        if (x == 1 && type == -1) {
            int r = cur[ind].type;
            if (r == n) {
                cout << "YES\n";
                return;
            }
            dp[ind] = 1;
            st_l.insert(x);
            st_m.insert(was[ind]);
            st_r.insert(cur[ind].type);
        }
        else if (type == -1) {
            bool fl = false;
            int cur_l = x, cur_r = cur[ind].type;
            if (!st_l.empty()) {
                int mn = *(--st_l.end());
                if (mn > was[ind]) {
                    fl = true;
                    st_l.insert(x);
                    st_r.insert(cur[ind].type);
                }
            }

            if (!st_r.empty()) {
                int mx = *(st_r.begin());
                if (was[ind] > mx) {
                    fl = true;
                }

            }
            if (!st_m.empty()) {

                int mn_m = *(st_m.begin());
                int mx_m = *(--st_m.end());
                if (mn_m < cur_l || mx_m > cur_r) {
                    fl = true;
                }
            }
            if (fl) {
                st_l.insert(cur_l);
                st_r.insert(cur_r);
                st_m.insert(was[ind]);
                dp[ind] = 1;
            }
        }
        else if (type == 1) {
            int cur_l = last_l[ind], cur_r = x, cur_m = was[ind];
            if (dp[ind]) {
            //    cout << cur_l << ' ' << cur_r << ' ' << cur_m << '\n';
                st_l.erase(st_l.find(cur_l));
                st_r.erase(st_r.find(cur_r));
                st_m.erase(st_m.find(cur_m));
            }

        }

    }
    for (int i = 0; i < k; ++i) {
        if (cur[i].type == n && dp[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";



}

signed main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
}