#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<string> f(n);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }
    vector<int> cur(m);
    ll ans = 0;
    for (int j = 0; j < n; j++) {
        for (int i = 0; i < m; i++) {
            cur[i] = f[j][i] == '1' ? cur[i] + 1 : 0;
        }
        vector<int> lp(m, m);
        stack<int> s;
        for (int i = m - 1; i >= 0; i--) {
            while (!s.empty() && cur[s.top()] >= cur[i]) {
                s.pop();
            }
            lp[i] = s.empty() ? m : s.top();
            s.emplace(i);
        }
        vector<ll> dp(m + 1, 0);
        for (int i = 0; i < m; i++) {
            int cls = lp[i];
            dp[cls] = max(dp[cls], dp[i] + 1ll * (cls - i) * cur[i]);
        }
        ans = max(ans, *ranges::max_element(dp));
    }
    cout << ans << '\n';
    return 0;
}
