#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i64 = __int128_t;

constexpr int inf = (int) (1e9) + 52;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0, d;
    cin >> x0 >> d;
    ranges::sort(x);
    vector<i64> sqr(n + 1);
    vector<i64> pred(n + 1);
    vector<ll> sum(n + 1);
    for (int i = 0; i < n; i++) {
        ll here = abs(x0 % d - x[i] % d);
        here = min(here, d - here);
        sqr[i + 1] = sqr[i] + 1ll * x[i] * x[i];
        pred[i + 1] = pred[i] + 1ll * here * here;
        sum[i + 1] = sum[i] + x[i];
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int l = -1, r = inf;
        auto calc = [&](int k) -> i64 {
            ll y = 1ll * k * d;
            int i = (int) (ranges::lower_bound(x, y) - x.begin());
            return 1ll * k * t + pred[i] + (sqr[n] - sqr[i]) + 1ll * (n - i) * y * y - 2 * y * (sum[n] - sum[i]);
        };
        while (r - l > 1) {
            int mid = (l + r) >> 1;
            (calc(mid + 1) < calc(mid) ? l : r) = mid;
        }
        cout << (ll) (calc(r)) << '\n';
    }
    return 0;
}
