#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const ll inf = 1e15;

void solve() {
    ll h, w;
    cin >> h >> w;
    bool a[h][w];
    for (ll i=0;i<h;i++) for (ll j=0;j<w;j++) {
        char x;
        cin >> x;
        a[i][j] = x-'0';
    }

    ll t[h][w];
    ll n = h, m = w;
    for (ll i=0;i<n;i++) for (ll j=0;j<m;j++) {
        if (!a[i][j]) t[i][j] = inf;
        else if (i) t[i][j] = (t[i-1][j] == inf?0:t[i-1][j]) + 1;
        else t[i][j] = 1;
    }
    ll ans = 0;
    ll dp[n][m];
    ll fst[n][m];
    ll nxt[n][m];
    for (ll i=0;i<n;i++) {
        stack<pll> s;
        for (ll j=m-1;j>=0;j--) {
            if (t[i][j] == inf) {
                while (s.size()) s.pop();
                nxt[i][j] = 0;
                continue;
            }
            if (j != m-1) nxt[i][j] = nxt[i][j+1] + 1;
            else nxt[i][j] = 1;
            while (s.size() && s.top().second >= t[i][j]) {
                s.pop();
            }
            if (s.empty()) fst[i][j] = m;
            else fst[i][j] = s.top().first;
            s.push({j, t[i][j]});
        }
    }
    for (ll i=0;i<n;i++) {
        for (ll j=m-1;j>=0;j--) {
            ll cur = t[i][j];
            // cout << i << ' ' << j << ' '  << cur << ' ' << nxt[i][j] << ' ' << fst[i][j] << endl;
            if (cur == inf) continue;
            if (fst[i][j] == m) {
                dp[i][j] = cur * nxt[i][j];
                ans = max(ans, dp[i][j]);
            }
            else {
                dp[i][j] = cur * (fst[i][j]-j) + dp[i][fst[i][j]];
                ans = max(ans, dp[i][j]);
            }
        }
    }
    cout << ans << endl;

}
int main() {
    int test = 1;
    // cin >> test;
    while (test--) solve();
}
/*
6 4
0011
1101
0111
1110
0111
0100

8
*/
