#include <bits/stdc++.h>
using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<bool>> mp(h, vector<bool> (w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char c; cin >> c;
            mp[i][j] = (c == '1');
        }
    }

    vector<vector<int>> cntr(h, vector<int> (w, 0));
    for (int i = 0; i < h; i++) {
        int cnt = 0;
        for (int j = w - 1; j >= 0; j--) {
            if (mp[i][j])
                cnt++;
            else
                cnt = 0;
            cntr[i][j] = cnt;
        }
    }

    int ans = 0;
    for (int j = 0; j < w; j++) {
        int curCnt = 0;
        vector<pair<int, int>> st;
        for (int i = 0; i < h; i++) {
            int k = 0;
            while (!st.empty() && st.back().first > cntr[i][j]) {
                curCnt -= st.back().second * st.back().first;
                k += st.back().second;
                st.pop_back();
            }
            k++;
            curCnt += k * cntr[i][j];
            ans = max(ans, curCnt);
            st.push_back({cntr[i][j], k});
        }
    }

    cout << ans;
}