#include <bits/stdc++.h>

using ll = long long;

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

void solve() {
    int h, w;
    cin >> h >> w;
    string v[h];
    for (int i = 0; i < h; i++) {
        cin >> v[i];
    }
    int a[h][w];
    for (int i = 0; i < w; i++) {
        if (v[0][i] == '1') {
            a[0][i] = 1;
        } else {
            a[0][i] = 0;
        }
    }
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (v[i][j] == '1') {
                a[i][j] = a[i - 1][j] + 1;
            } else {
                a[i][j] = 0;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < h; i++) {
        int maxx = 0;
        int c[w];
        for (int j = w - 1; j >= 0; j--) {
            maxx += a[i][j];
            c[j] = a[i][j];
            int ind = j + 1;
            while (ind < w && c[ind] > a[i][j]) {
                maxx -= c[ind] - a[i][j];
                c[ind] = a[i][j];
                ind++;
            }
            ans = max(ans, maxx);
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 0;

    #ifdef egg
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}