#include <bits/stdc++.h>

using ll = long long;

const ll INF = 2e9;

using namespace std;

struct worker {
    ll l, m, r;
};

bool cmp(worker a, worker b) {
    if (a.m >= b.l && a.m <= b.r){
        return 1;
    }
    return 0;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> l(k), m(k), r(k);
    vector<worker> v;
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        v.push_back({l[i], m[i], r[i]});
    }
    sort(v.begin(), v.end(), cmp);
    set<pair<ll, ll>> s;
    for (int i = 0; i < k; i++) {
        auto it = s.end();
        if (i != 0) {
            it = s.upper_bound({v[i].m, INF});
            if (it == s.begin()) {
                s.insert({v[i].l, v[i].r});
                continue;
            }
            it--;
        }
        if (i != 0 && it->second >= v[i].m) {
            cout << "NO" << '\n';
            return;
        }
        s.insert({v[i].l, v[i].r});
    }
    for (int i = 1; i <= n; i++) {
        auto it = s.end();
        it = s.upper_bound({i, INF});
        if (it == s.begin()) {
            cout << "NO" << '\n';
            return;
        }
        it--;
        if (it->second < i) {
            cout << "NO" << '\n';
            return;
        }
    }
    cout << "YES" << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 1;

    #ifdef egg
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}