#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <math.h>
#include <algorithm>
#include <string>
using namespace std;

#define ll long long
#define vc vector
#define str string
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(),(a).rend()
#define sz(a) (a).size()
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m; cin >> n >> m;
	vc<str> mat(n);
	for (auto& i : mat) cin >> i;


	vc<vc<ll>> lng(n, vc<ll>(m));
	for (int i = 0; i < n; ++i) {
		lng[i][m-1] = mat[i][m-1] == '1';
		for (int j = m - 2; j >= 0; --j) {
			if (mat[i][j] == '0') lng[i][j] = 0;
			else lng[i][j] = lng[i][j+1] + 1;
		}
	}
	ll ans = 0;
	for (int j = 0; j < m; ++j) {
		vc<ll> d;
		for (int i = 0; i < n; ++i) d.push_back(lng[i][j]);
		d.push_back(0);
		unordered_map<ll,ll> cnt;
		vc<ll> st;
		vc<ll> nxt(n, n);
		for (int i = 0; i < n; ++i) {
			while (sz(st) and d[st.back()] > d[i]) {
				nxt[st.back()] = i;
				st.pop_back();
			}
			st.push_back(i);
		}
		vc<vc<pair<ll, ll>>> inst(n + 1);
		for (int i = 0; i < n; ++i) {
			inst[nxt[i]].push_back({ d[i], d[nxt[i]] });
		}
		ll cur = 0;
		for (int i = 0; i < n; ++i) {
			++cnt[d[i]];
			cur += d[i];
			for (auto [u, to] : inst[i]) {
				cur -= cnt[u] * u;
				cur += cnt[u] * to;
				cnt[to] += cnt[u];
				cnt[u] = 0;
			}
			ans = max(ans, cur);
		}
	}
	cout << ans;
}
