#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
using ii = __int128; //long long; // __int128;
const ll INF = 2 * 1e18;

ii get_dist(ii x1, ii x2) {
	return (x1 - x2) * (x1 - x2);
}
ii get(ii x, ii x0, ii d) {
	ii k = (x - x0) / d;
	if (x < x0) k--;
	ii var1 = x0 + k * d;
	ii var2 = x0 + (k + 1) * d;
	//cout << "  " << x << " " << var1 << " " << var2 << "\n";
	return min(get_dist(x, var1), get_dist(x, var2));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ii> x(n);
	for (int i = 0; i < n; ++i) {
		ll x1; cin >> x1; x[i] = x1;
	}
	sort(x.begin(), x.end());
	ll x0_1, d_1;
	cin >> x0_1 >> d_1;
	ii x0 = x0_1, d = d_1;
	
	int m; 
	cin >> m;
	for (int _ = 0; _ < m; ++_) {
		ll t; cin >> t;
		ii ans;
		if (x[0] >= x0) {
			ii var1 = get((x[0] * 2 - t) / 2, x0, d);
			ii var2 = get(var1 + d, x0, d);
			ii var3 = get(x0, var1 - d, d);
			ans = min(get_dist(var1, x[0]) + t * ((var1 - x0) / d), get_dist(var2, x[0]) + t * ((var2 - x0) / d));
			ans = min(ans, get_dist(var3, x[0]) + t * ((var3 - x0) / d));
		}
		else {
			ii var1 = get((x[0] * 2 + t) / 2, x0, d);
			ii var2 = get(var1 + d, x0, d);
			ii var3 = get(var1 - d, x0, d);
			ans = min(get_dist(var1, x[0]) + t * ((var1 - x0) / d), get_dist(var2, x[0]) + t * ((var2 - x0) / d));
			ans = min(ans, get_dist(var3, x[0]) + t * ((var3 - x0) / d));
		}
		cout << "   " <<  (ll)(ans) << "\n";
	}

	return 0;
}