#include <bits/stdc++.h>
#define int long long
using namespace std;

struct ch {
    int l, m, r;
};
void solve() {
    int n, k;
    cin >> n >> k;
    vector<ch> a(k);
    for (int i = 0; i < k; i++) cin >> a[i].l >> a[i].m >> a[i].r, a[i].l--, a[i].m--, a[i].r--;
    sort(a.begin(), a.end(), [&](ch x, ch y) {
        return x.l < y.l;
    });
    vector<int> dp(k + 1);
    for (int j = 0; j <= k; j++) {
        for (int ii = 0; ii < k; ii++) {
            auto [l, m, r] = a[ii];
            int jj = (j == k ? n - 1: a[j].m - 1);
            int i = (j == k ? n - 1: a[j].l - 1);
            if (l <= i && r >= i && (m <= i || r <= jj)) {
                if (l == 0) {
                    dp[j] = 1;
                } else {
                    dp[j] |= dp[ii];
                }
            }
        }
    }
    /*
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            for (auto [l, m, r] : a) {
                if (l <= i && r >= i && (m <= i || r <= j)) {
                    if (l == 0) {
                        dp[i][j] = 1;
                    } else {
                        dp[i][j] |= dp[l - 1][m - 1];
                    }
                }
            }
        }
    }
    */
    if (dp[k]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}