#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;
template<typename T>
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

int reps = 1;

struct Var {
        int l, m, r;
};

void solve() {
        int n, k; cin >> n >> k;
        ve<Var> a(k);
        for (int i = 0; i < k; i++) {
                cin >> a[i].l >> a[i].m >> a[i].r;
        }
        ve<vi> els(n + 1);
        for (int i = 0; i < k; i++) {
                els[a[i].r].push_back(i);
        }
        ve<vi> dp(n + 1, vi(n + 1));
        dp[0][0] = true;
        for (int i = 1; i <= n; i++) {
                for (const auto ind : els[i]) {
                        for (int j = a[ind].l - 1; j < a[ind].m; j++) {
                                for (int k = 0; k <= j; k++) {
                                       dp[i][a[ind].m] |= dp[j][k];
                                }
                        }
                        for (int j = a[ind].l - 1; j < i; j++) {
                                for (int k = 0; k < a[ind].l; k++) {
                                        dp[i][a[ind].m] |= dp[j][k];
                                }
                        }
                }
        }
        bool f = false;
        for (int i = 0; i <= n; i++) {
                f |= dp[n][i];
        }
        (f) ? cout << "YES\n" : cout << "NO\n";
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL 
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        #endif
        cin >> reps;

        for (int i = 1; i <= reps; i++) {
                solve();
        }

        return 0;
}
