#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
template<typename T>
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

int reps = 1;

__int128_t count(__int128_t xi, __int128_t x0, __int128_t d, __int128_t mid, __int128_t t) {
        __int128_t d1 = xi - x0;
        if (d1 < 0) d1 = -d1;
        return (d1 - d * mid) * ((d1 - d * mid)) + t * mid;
}

void solve() {
        int n; cin >> n;
        vi a(n);
        for (int i = 0; i < n; i++) cin >> a[i];
        int x0, d; cin >> x0 >> d;
        int m; cin >> m;
        for (int i = 0; i < m; i++) {
                int t; cin >> t;
                __int128_t ans = (a[0] - x0) * (a[0] - x0);
                int tl = 1, tr = INF;
                while (tr - tl > 1) {
                        int mid1 = (tr + tl) / 2;
                        int mid2 = mid1 - 1;
                        if (count(a[0], x0, d, mid1, t) <= count(a[0], x0, d, mid2, t)) {
                                tl = mid1;
                        } else {
                                tr = mid1;
                        }
                }
                ans = min(ans, count(a[0], x0, d, tl, t));
                vi nums;
                while (ans) {
                        nums.push_back(ans % 10);
                        ans /= 10;
                }
                reverse(all(nums));
                for (auto el : nums) cout << el;
                cout << '\n';
        }
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL 
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                solve();
        }

        return 0;
}
