#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#ifdef LOCAL:
#define deb(x) cout << #x << " = " << x << '\n';
#else:
#define deb(x) 52;
#endif
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> l(k), m(k), r(k);
    for (ll i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<ll> p(k);
    for (ll i = 0; i < k; ++i) {
        p[i] = i;
    }
    sort(all(p), [&](ll i, ll j) {
        return l[i] < l[j] || (l[i] == l[j] && m[i] < m[j]);
    });
    vector<bool> dp(n + 1);
    dp[0] = true;
    for (ll ii = 0; ii < k; ++ii) {
        ll i = p[ii];
        bool f = false;
        for (ll j = l[i] - 1; j < m[i]; ++j) {
            f = f || dp[j];
        }
        dp[r[i]] = f;
    }
    cout << (dp[n] ? "YES" : "NO");
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 1;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}