#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#ifdef LOCAL:
#define deb(x) cout << #x << " = " << x << '\n';
#else:
#define deb(x) 52;
#endif
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


vector<ll> get_css(vector<vector<ll>> graph) {
    ll n = (ll)graph.size();
    vector<bool> used(n);
    vector<ll> top;
    auto get_topsort = [&](auto &dfs, ll v) -> void {
        used[v] = true;
        for (ll u : graph[v]) {
            if (!used[u]) {
                dfs(dfs, u);
            }
        }
        top.pb(v);
    };
    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            get_topsort(get_topsort, i);
        }
    }
    reverse(all(top));
    vector<vector<ll>> rg(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j : graph[i]) {
            rg[j].pb(i);
        }
    }
    vector<ll> comp(n, -1);
    ll cur = 0;
    auto dfs = [&](auto &dfs, ll v) -> void {
        comp[v] = cur;
        for (ll u : rg[v]) {
            if (comp[u] == -1) {
                dfs(dfs, u);
            }
        }
    };
    for (ll v : top) {
        if (comp[v] == -1) {
            dfs(dfs, v);
            ++cur;
        }
    }
    return comp;
}


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> l(k), m(k), r(k);
    for (ll i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<ll> p(k);
    for (ll i = 0; i < k; ++i) {
        p[i] = i;
    }
    sort(all(p), [&](ll i, ll j) {
        return l[i] > l[j] || (l[i] == l[j] && r[i] > r[j]);
    });
    vector<bool> used(n + 1);
    set<ll> bad;
    for (ll i = 1; i <= n; ++i) {
        bad.insert(i);
    }
    for (ll i : p) {
        if (bad.find(l[i]) != bad.end()) {
            while (true) {
                auto it = bad.lower_bound(l[i]);
                if (it == bad.end() || *it > r[i]) {
                    break;
                } else {
                    bad.erase(it);
                }
            }
        }
    }
    cout << (bad.empty() ? "YES" : "NO");
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 1;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}