#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
using ll = long long;
//using ll = __int128;
using ld = long double;
using ull = unsigned long long;
#ifdef LOCAL:
#define deb(x) cout << #x << " = " << x << '\n';
#else:
#define deb(x) 52;
#endif
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


const ll N = 5e5;
vector<ll> graph[N];
ll dep[N], sz[N];
ll jump[N], par[N];

void dfs0(ll v, ll p) {
    sz[v] = 1;
    for (ll u : graph[v]) {
        if (u != p) {
            dep[u] = dep[v] + 1;
            dfs0(u, v);
            sz[v] += sz[u];
        }
    }
}


vector<pair<ll, ll>> ans;
bool used[N];
ll n, d;


void dfs1(ll v, ll p, ll cur, vector<ll> &good) {
    if (cur % 2 == 1 && !used[v]) {
        good.pb(v);
    }
    if (cur == d) {
        return;
    }
    for (ll u : graph[v]) {
        if (u != p) {
            dfs1(u, v, cur + 1, good);
        }
    }
}


vector<ll> tmp;


void dfs(ll v, ll p) {
    for (ll u : graph[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tmp.clear();
    dfs1(v, p, 0, tmp);
    ll u = -1;
    for (ll k : tmp) {
        if (u == -1 || dep[k] > dep[u]) {
            u = k;
        }
    }
    if (u != -1) {
        used[v] = true;
        used[u] = true;
        ans.eb(v, u);
    }
}


void solve() {
    cin >> n;
    cin >> d;
    ll x, y;
    for (ll i = 0; i < n - 1; ++i) {
        cin >> x >> y;
        --x, --y;
        graph[x].pb(y);
        graph[y].pb(x);
    }
    dfs0(0, -1);
    dfs(0, -1);
    cout << (ll)ans.size() << '\n';
    for (pair<ll, ll> p : ans) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}