#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
using ll = long long;
//using ll = __int128;
using ld = long double;
using ull = unsigned long long;
#ifdef LOCAL:
#define deb(x) cout << #x << " = " << x << '\n';
#else:
#define deb(x) 52;
#endif
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


const ll N = 5e5;
vector<ll> graph[N];
ll dep[N];
ll jump[N], par[N];

void dfs(ll v, ll p) {
    for (ll u : graph[v]) {
        if (u != p) {
            par[u] = v;
            dep[u] = dep[v] + 1;
            if (dep[v] - dep[jump[v]] == dep[jump[v]] - dep[jump[jump[v]]]) {
                jump[u] = jump[jump[v]];
            }  else {
                jump[u] = v;
            }
            dfs(u, v);
        }
    }
}


ll la(ll v, ll k ) {
    while (k > 0) {
        --k;
        v = par[v];
    }
    return v;
}


ll lca(ll v, ll u) {
    if (dep[v] > dep[u]) {
        swap(v, u);
    }
    u = la(u, dep[u] - dep[v]);
    while (v != u ) {
        if (jump[v] != jump[u] && 0) {
            v = jump[v], u = jump[u];
        } else {
            v= par[v], u = par[u];
        }
    }
    return v;
}


ll dist(ll v, ll u) {
    return dep[v] + dep[u] - 2 * dep[lca(v, u)];
}


bool used[N];
vector<pair<ll, ll>> cur;
ll n, d;
vector<pair<ll, ll>> best;


void rec(ll i) {
    if (i == n) {
        if (cur.size() > best.size()) {
             best = cur;
        }
        return;
    }
    if (!used[i]) {
        for (ll j = i + 1; j < n; ++j) {
            if (!used[j] && dist(i, j) <= d && dist(i, j) % 2 == 1) {
                cur.eb(i, j);
                used[i] = used[j] = true;
                rec(i + 1);
                used[i] = used[j] = false;
                cur.pop_back();
            }
        }
    }
    rec(i + 1);
}


void solve() {
    cin >> n;
    cin >> d;
    ll x, y;
    for (ll i = 0; i < n - 1; ++i) {
        cin >> x >> y;
        --x, --y;
        graph[x].pb(y);
        graph[y].pb(x);
    }
    dfs(0, -1);
    rec(0);
    cout << (ll)best.size() << '\n';
    for (pair<ll, ll> p : best) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}