// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

typedef tree<pdd, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<dgt>> g;
vector<bool> used;
queue<dgt> qu;

void solve() {
    dgt n, k;
    cin >> n >> k;
    vector<dgt> l(k + 1), m(k + 1), r(k + 1);
    for (dgt i = 1; i <= k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        if (l[i] == 1 && r[i] == n) {
            cout << "YES\n";
            return;
        }
    }
    g.clear();
    g.resize(k + 1);
    for (dgt i = 1; i <= k; ++i) {
        for (dgt j = 1; j <= k; ++j) {
            if (i == j)
                continue;
            if (l[j] <= m[i] && m[i] <= r[j])
                g[i].push_back(j);
        }
    }
    for (dgt i = 1; i <= k; ++i) {
        used.assign(k, false);
        qu.push(i);
        while (qu.size()) {
            dgt v = qu.front();
            qu.pop();
            used[v] = true;
            for (dgt u: g[v]) {
                if (used[u]) {
                    cout << "NO\n";
                    return;
                } else {
                    qu.push(u);
                }
            }
        }
    }
    cout << "YES\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    
#endif
    cin >> reps;
    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " =======================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===========================\n";
#endif
    }

    return 0;
}
