#include <bits/stdc++.h>

using ll = long long;
using namespace std;
#define int long long
using bint = __int128;
class tree {
    int n;
    vector <vector <int>> gr;
    vector <int> v1, v2;
    void dfs(int num, int last, int d) {
        if (d & 1) {
            v1.push_back(num);
        } else {
            v2.push_back(num);
        }
        for (int next : gr[num]) {
            if (next != last) {
                dfs(next, num, d + 1);
            }
        }
    }
public:
    void init() {
        cin >> n;
        gr.resize(n);
        int d;
        cin >> d;
        for (int i = 0; i < n - 1; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            gr[a].push_back(b);
            gr[b].push_back(a);
        }
    }
    void get_ans() {
        dfs(0, - 1, 0);
        cout << min(v1.size(), v2.size()) << '\n';
        while (!v1.empty() && !v2.empty()) {
            cout << v1.back() + 1 << " " << v2.back() + 1 << '\n';
            v1.pop_back();
            v2.pop_back();
        }

    }
};
void solve() {
    tree now;
    now.init();
    now.get_ans();
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
