#include <iostream>

using namespace std;

int main() {
    int h, w;
    cin >> h >> w;
    string arr[h];
    long long dp[h][w], o1[h][w], o2[h][w], ans = 0;
    for (int i = 0; i < h; ++i) {
        cin >> arr[i];
        for (int j = 0; j < w; ++j) {
            dp[i][j] = o1[i][j] = o2[i][j] = 0;
            arr[i][j] -= '0';
        }
    }
    dp[0][w - 1] = o1[0][w - 1] = o2[0][w - 1] = ans = arr[0][w - 1];
    for (int j = w - 2; j > -1; --j) {
        dp[0][j] = (arr[0][j] ? dp[0][j + 1] + 1 : 0);
        o1[0][j] = (arr[0][j] ? o1[0][j + 1] + 1 : 0);
        o2[0][j] = arr[0][j];
        ans = max(ans, dp[0][j]);
    }
    for (int i = 1; i < h; ++i) {
        dp[i][w - 1] = (arr[i][w - 1] ? dp[i - 1][w - 1] + 1 : 0);
        o1[i][w - 1] = arr[i][w - 1];
        o2[i][w - 1] = (arr[i][w - 1] ? o2[i - 1][w - 1] + 1 : 0);
        ans = max(ans, dp[i][w - 1]);
        for (int j = w - 2; j > -1; --j) {
            if (arr[i][j]) {
                o1[i][j] = o1[i][j + 1] + 1;
                o2[i][j] = o2[i - 1][j] + 1;
                if (!arr[i - 1][j] && !arr[i][j + 1])
                    dp[i][j] = 1;
                else if (!arr[i - 1][j])
                    dp[i][j] = o1[i][j];
                else if (!arr[i][j + 1])
                    dp[i][j] = o2[i][j];
                else if (o1[i][j + 1] >= o1[i - 1][j + 1] || o2[i - 1][j] >= o2[i - 1][j + 1])
                    dp[i][j] = dp[i - 1][j] + dp[i][j + 1] - dp[i - 1][j + 1] + 1;
                else
                    dp[i][j] = o1[i][j] * o2[i][j];
                ans = max(ans, dp[i][j]);
            }
        }
    }
    cout << ans << endl;
}
