#include <iostream>
#include <algorithm>
#include <set>

using namespace std;

struct seg {
    int l, r, m;
};

bool operator<(seg a, seg b) {
    return a.l < b.l;
}

int main() {
    int t;
    cin >> t;
    while (t --> 0) {
        int n, k;
        cin >> n >> k;
        seg arr[k];
        set <pair <int, int>> lr, lm;
        for (int i = 0; i < k; ++i) {
            cin >> arr[i].l >> arr[i].m >> arr[i].r;
            --arr[i].l;
        }
        sort(arr, arr + k);
        if (arr[0].l) {
            cout << "NO\n";
            continue;
        }
        lr.insert({0, 0});
        lm.insert({0, 0});
        lr.insert({arr[0].r, arr[0].r});
        lm.insert({arr[0].r, arr[0].m});
        string ans = "YES\n";
        for (int i = 1; i < k; ++i) {
            auto itr = lr.lower_bound({arr[i].l, -1}), itm = lm.lower_bound({arr[i].l, -1});
            if (itr == lr.end()) {
                ans = "NO\n";
                break;
            }
            auto clr = itr->second, clm = itm->second;
            if (clr < arr[i].m || clm <= arr[i].l) {
                auto itrr = lr.upper_bound({arr[i].r, 100000000}), itmr = lm.upper_bound({arr[i].r, 100000000});
                auto itrl = itrr, itml = itmr;
                if (itrl != lr.begin()) {
                    --itrl;
                    while (itrl != lr.begin() && itrl->second >= arr[i].r)
                        --itrl;
                    if (itrl->second < arr[i].r)
                        ++itrl;
                    lr.erase(itrl, itrr);
                }
                lr.insert({arr[i].r, arr[i].r});
                if (itml != lm.begin()) {
                    --itml;
                    while (itml != lm.begin() && itml->second >= arr[i].m)
                        --itml;
                    if (itml->second < arr[i].m)
                        ++itml;
                    lm.erase(itml, itmr);
                    lm.insert({arr[i].r, arr[i].m});
                }
            }
        }
        if (lr.lower_bound({n, -1}) == lr.end())
            ans = "NO\n";
        cout << ans;
    }
}

// кто прочитал тот ............. не следите пж короче
