#include<bits/stdc++.h>
using namespace std;

int n, d;
vector<array<int, 2>> ans;
vector<int> h, sz0, sz1;
vector<vector<int>> g, b0, b1;

void dfs(int v, int p = -1) {
    vector<array<int, 2>> b0n, b1n;
    b0n.push_back({h[v], v});
    sz0[v] = 1;
    for (auto u: g[v]) {
        if (u == p) continue;
        h[u] = h[v] + 1;
        dfs(u, v);
        for (auto u2: b1[u]) {
            if (h[u2] - h[v] <= d) b0n.push_back({h[u2], u2});
        }
        for (auto u2: b0[u]) {
            if (h[u2] - h[v] <= d) b1n.push_back({h[u2], u2});
        }
    }
    sort(b0n.rbegin(), b0n.rend());
    sort(b1n.rbegin(), b1n.rend());
    vector<int> st;
    for (auto [hu1, u1]: b1n) {
        while (!b0n.empty() && b0n.back()[0] + hu1 - 2 * h[v] <= d) {
            st.push_back(b0n.back()[1]);
            b0n.pop_back();
        }
        if (st.empty()) {
            b1[v].push_back(u1);
        }
        else {
            ans.push_back({u1, st.back()});
            st.pop_back();
        }
    }
    while (!st.empty()) {
        b0[v].push_back(st.back());
        st.pop_back();
    }
    while (!b0n.empty()) {
        b0[v].push_back(b0n.back()[1]);
        b0n.pop_back();
    }
}

void solve() {
    cin >> n >> d;
    h.assign(n + 1, 0);
    g.assign(n + 1, {});
    b0.assign(n + 1, {});
    b1.assign(n + 1, {});
    sz0.assign(n + 1, 0);
    sz1.assign(n + 1, 0);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(1, -1);
    cout << ans.size() << '\n';
    for (auto [v, u]: ans) cout << v << ' ' << u << '\n';
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
