#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <numeric>
#include <set>
#include <map>
#include <array>
#include <limits.h>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		int n, k; cin >> n >> k;
		vector<std::array<int, 3>> segs(k);
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < 3; j++) {
				cin >> segs[i][j];
				segs[i][j]--;
			}
		}

		sort(all(segs), [](std::array<int, 3> & l, std::array<int, 3> & r) {return l[1] < r[1]; });
		vector<int> dp(n + 1);
		dp[0] = 1;
		for (auto [l, m, r] : segs) {
			bool f = 0;
			for (int i = l; i <= m; i++) {
				f = f || dp[i];
			}
			dp[r + 1] = dp[r + 1] || f;
		}
		cout << (dp[n] ? "YES" : "NO") << '\n';
	}

	return 0;
}