#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

#define int long long

vector <vector <int>> sp;
vector <int> C;
vector <int> C0, C1;


void BFS() {
	queue <int> Q;
	Q.push(0);
	C[0] = 0;
	C0.push_back(0);

	while (!Q.empty()) {
		int v = Q.front();
		Q.pop();
		for (auto t : sp[v]) {
			if (C[t] == -1) {
				C[t] = 1 - C[v];
				if (C[t]) C1.push_back(t);
				if (!C[t]) C0.push_back(t);

				Q.push(t);
			}
		}
	}
}


void solve() {
	int n, d;
	cin >> n >> d;

	sp.resize(n);
	C.resize(n, -1);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;

		sp[u - 1].push_back(v - 1);
		sp[v - 1].push_back(u - 1);
	}

	BFS();

	if (C0.size() > C1.size()) swap(C0, C1);

	cout << C0.size() << "\n";
	for (int i = 0; i < (int)C0.size(); i++) {
		cout << C0[i] + 1 << " " << C1[i] + 1 << "\n";
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
