#include <iostream>
#include <vector>
using namespace std;


int main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto& i: a) cin >> i;
    if (n > m) {
        vector<string> t(m, string(n, '0'));
        for (int i = 0; i < m; i ++) for (int j = 0; j < n; j ++) t[i][j] = a[n - 1 - j][m - 1 - i];
        a = t;
        swap(n, m);
    }
    int ans = 0;
    vector<int> u(m, 0);
    for (int i = 0; i < n; i ++) {
        vector<int> dp(i + 3, 0);
        for (int j = 0; j < m; j ++) {
            if (a[i][j] == '1') u[j] ++;
            else u[j] = 0;
            for (int k = u[j] + 1; k <= i + 1; k ++) dp[k] = 0;
            for (int k = u[j]; k >= 0; k --) {
                dp[k] = max(dp[k + 1], dp[k] + k);
                ans = max(ans, dp[k]);
            }
        }
    }
    cout << ans << "\n";
}
