#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

vector<int> cnt(1000 + 1, 0), sum(1000 + 1);

int get_cnt(int l, int r) {
    if (l < 0 || r < l || r > 1000) return 0;
    if (l == 0) return cnt[r];
    else return cnt[r] - cnt[l - 1];
}

int get_sum(int l, int r) {
    if (l < 0 || r < l || r > 1000) return 0;
    if (l == 0) return sum[r];
    else return sum[r] - sum[l - 1];
}

void solve() {
    int n; cin >> n;
    vector<int> xs(1000 + 1, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        xs[x] = 1;
    }
    int x0, d; cin >> x0 >> d;
    int m; cin >> m;
    vector<pair<int, int>> ts;
    for (int i = 0; i < m; i++) {
        int t; cin >> t;
        ts.pb({t, i});
    }
    sort(ts.rbegin(), ts.rend());
    for (int i = 0; i <= 1000; i++) {
        if (i != 0) {
            cnt[i] = cnt[i - 1];
            sum[i] = sum[i - 1];
        }
        cnt[i] += xs[i];
        if (xs[i] == 1) {
            sum[i] += i;
        }
    }
    vector<int> ans(m, 0);
    int l1 = x0, r1 = x0, l2 = x0, r2 = x0;
    __int128 sum1 = 0, sum2 = 0;
    for (int x = 0; x <= 1000; x++) {
        if (xs[x] == 1) {
            sum1 += __int128(x - x0) * (x - x0);
            sum2 += __int128(x - x0) * (x - x0);
        }
    }
    bool f;
    int l, r;
    int csum, ccnt;
    __int128 diff;
    for (auto [t, ind] : ts) {
        int cnt_l = (x0 - l1) / d, cnt_r = (r1 - x0) / d;
        sum1 += __int128(cnt_l) * t * 2 + cnt_r * t;
        cnt_l = (x0 - l2) / d; cnt_r = (r2 - x0) / d;
        sum2 += __int128(cnt_l) * t + cnt_r * t * 2; 
        f = 1;
        while (f) {
            diff = 0;
            if (d % 2 == 0) r = l1 - d / 2;
            else r = l1 - (d + 1) / 2;
            l = 0;
            ccnt = get_cnt(l, r);
            csum = get_sum(l, r);
            diff += __int128(ccnt) * (d * d - 2 * l1 * d);
            diff += __int128(d) * 2 * csum;
            diff += __int128(2) * t;
            if (diff < 0) {
                sum1 += diff;
                l1 = l1 - d;
            } else f = 0;
        }

        f = 1;
        while (f) {
            diff = 0;
            if (d % 2 == 0) r = l2 - d / 2;
            else r = l2 - (d + 1) / 2;
            l = 0;
            ccnt = get_cnt(l, r);
            csum = get_sum(l, r);
            diff += __int128(ccnt) * (d * d - 2 * l2 * d);
            diff += __int128(d) * 2 * csum;
            diff += __int128(t);
            if (diff < 0) {
                sum2 += diff;
                l2 = l2 - d;
            } else f = 0;
        }

        f = 1;
        while (f) {
            diff = 0;
            if (d % 2 == 0) l = r1 + d / 2;
            else l = r1 + (d + 1) / 2;
            r = 1000;
            ccnt = get_cnt(l, r);
            csum = get_sum(l, r);
            diff += __int128(ccnt) * (d * d + 2 * r1 * d);
            diff += __int128(-2) * csum * d;
            diff += __int128(t);
            if (diff < 0) {
                sum1 += diff;
                r1 = r1 + d;
            } else f = 0;
        }

        f = 1;
        while (f) {
            diff = 0;
            if (d % 2 == 0) l = r2 + d / 2;
            else l = r2 + (d + 1) / 2;
            r = 1000;
            ccnt = get_cnt(l, r);
            csum = get_sum(l, r);
            diff += __int128(ccnt) * (d * d + 2 * r2 * d);
            diff += __int128(-2) * csum * d;
            diff += __int128(2) * t;
            if (diff < 0) {
                sum2 += diff;
                r2 = r2 + d;
            } else f = 0;
        }

        ans[ind] = min(sum1, sum2);

        cnt_l = (x0 - l1) / d; cnt_r = (r1 - x0) / d;
        sum1 -= __int128(cnt_l) * t * 2 + cnt_r * t;
        cnt_l = (x0 - l2) / d; cnt_r = (r2 - x0) / d;
        sum2 -= __int128(cnt_l) * t + cnt_r * t * 2;
    }
    for (auto i : ans) cout << i << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}