#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

// #define int ll;

using vi = vector<int>;
using pii = pair<int, int>;
using vv = vector<vi>;

bool coll(array<int, 3> &a, array<int, 3> &b) {
    return a[0] <= b[1] && b[1] <= a[2];
}

vi ts;
vi used;

void dfs1(int v, vv &g, vi &used) {
    used[v] = 1;
    for (int u: g[v]) {
        if (used[u]) {
            dfs1(u, g, used);
        }
    }
    ts.push_back(v);
}

vi clr;

void dfs2(int v, vv &g, int c) {
    clr[v] = c;
    for (int u: g[v]) {
        if (clr[u] == -1) {
            dfs2(u, g, c);
        }
    }
}

int mx = 0;

vector<set<int> *> st;

void merge(set<int> * &a, set<int> *&b) {
    if (a->size() < b->size()) {
        swap(a, b);
    }
    for (int i: b) {
        a->insert(i);
    }
    b = a;
}

vector<array<int, 3> > p;

void dfs3(int v, vv &g, vi &dp, vv &ver) {
    for (int u: g[v]) {
        if (dp[u] == -1) {
            merge(st[v], st[u]);
            dfs3(u, g, dp, ver);
        }
    }
    int nw = *st[v]->rbegin();
    for (int i: ver[v]) {
        auto [l,m,r] = p[i];
        int p = *--st[v]->lower_bound(m);
        if (p>=l-1) {
            nw = max(nw, )
        }
    }
}

void solve() {
    int sz, n;
    cin >> sz >> n;
    p.clear();
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        int l, r, m;
        cin >> l >> m >> r;
        p[i] = {l, m, r};
    }
    vv g(n);
    vv gr(n);
    for (int v = 0; v < n; ++v) {
        for (int u = 0; u < n; ++u) {
            if (coll(p[u], p[v])) {
                g[u].push_back(v);
                gr[v].push_back(u);
            }
        }
    }
    ts.clear();
    used.clear();
    used.resize(n);

    clr.clear();
    clr.resize(n, -1);

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i, g, used);
        }
    }
    int c = 0;
    for (int i: ts) {
        if (clr[c] == -1) {
            dfs2(i, gr, c++);
        }
    }
    vv g2(n);
    for (int v = 0; v < n; ++v) {
        for (int u = 0; u < n; ++u) {
            if (clr[u] != clr[v] && coll(p[u], p[v])) {
                g2[clr[u]].push_back([v]);
            }
        }
    }
    vv ver(n);
    for (int i = 0; i < n; ++i) {
        ver[clr[i]].push_back(i);
        st[clr[i]] = new set<int>;
        st[clr[i]]->insert(0);
    }
    vi dp(n);
    mx = 0;
    for (int i = 0; i < n; ++i) {
        if (dp[i] == -1) {
            dfs3(i, g, dp, ver);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);

#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    cin >> t_;
    while (t_--) {
        solve();
    }
}
