#include <iostream>
#include <vector>

using namespace std;

int n, a, b;
vector <vector <int>> g;
vector <pair <int, int>> ans;
vector <int> a1, a2;
vector <bool> lag;
bool checked[500000];
int d;

void dfs(int v, bool h, int p) {
    //cout << v + 1 << " start" << endl;
    if (h) a1.push_back(v);
    else a2.push_back(v);
    checked[v] = true;
    int cnt = 0;
    for (auto i : g[v]) {
        if (checked[i]) continue;
        dfs(i, !h, v);
        if (lag[i]) ++cnt;
    }
    if (cnt == 0 && lag[v]) {
        if (p != -1 && lag[p]) {
            ans.push_back({v, p});
            lag[p] = false;
            lag[v] = false;
        }
    }
    //cout << v + 1 << " end" << endl;
}

int main() {
    cin >> n;
    g.resize(n);
    cin >> d;
    lag.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
        lag[i] = true;
    }
    lag[0] = true;
    dfs(0, false, -1);
    if (d == n - 1) {
        cout << min(int(a1.size()), int(a2.size())) << endl;
        for (int i = 0; i < min(int(a1.size()), int(a2.size())); ++i) {
            cout << a1[i] + 1 << " " << a2[i] + 1 << endl;
        }
    } else {
        cout << int(ans.size()) << endl;
        for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << endl;
    }
}
