#include <vector>
#include <iostream>
#include <algorithm>
#define int long long
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

using namespace std;

struct node {
    int l;
    int r;
    int m;
};

vector<int> c;

int get_mx(int v, int ql, int qr, int vl, int vr) {
    if (vr <= ql || qr <= vl) {
        return 0;
    }
    if (vl <= ql && qr <= vr) {
        return c[v];
    }
    return max(get_mx(2 * v, ql, (ql + qr) / 2, vl, vr), get_mx(2 * v + 1, (ql +qr) / 2, qr, vl, vr));
}

void set_on(int v, int pos, int ql, int qr) {
    if (qr - ql == 1) {
        c[v] = 1;
        return;
    }
    int m = (ql + qr) / 2;
    if (pos < m) {
        set_on(2 * v, pos, ql, (ql + qr) / 2);
    } else {
        set_on(2 * v + 1, pos, (ql + qr) / 2, qr);
    }
    c[v] = max(c[2 * v], c[2 * v + 1]);
}

signed main() {
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, k;
        cin >> n >> k;
        int n1, now = 1;
        while (true) {
            if (now >= n) {
                n1 = now;
                break;
            }
            now *= 2;
        }
        c.clear();
        c.resize(2 * n1);
        vector<node> a(k);
        vector<vector<node>> b(n + 1);
        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            a[i].l = l - 1;
            a[i].r = r - 1;
            a[i].m = m - 1;
            b[r - 1].push_back(a[i]);
        }
        vector<int> dp(n);
        for (int i = 0; i < n; ++i) {
            for (auto x : b[i]) {
                if (x.l == 0) {
                    dp[i] = 1;
                } else {
                    for (int h = x.l - 1; h < m; ++h) {
                        if (dp[h] == 1) {
                            dp[i] = 1;
                        }
                    }
                }
            }
        }
        if (dp[i] == 1) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}


/*
1
5 3
1 2 4
2 4 5
3 3 3*/
