#include <bits/stdc++.h>


using namespace std;


using ll = long long;


const int inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
T kv(T a) {
    return a * a;
}


ll distprev(ll s, ll t, ll d) {
    ll dist = abs(s - t);
    if (s < t) {
        return (dist / d * d);
    }
    return -(dist / d * d);
}


ll distnext(ll s, ll t, ll d) {
    ll dist = abs(s - t);
    if (s < t) {
        return ((dist + d - 1) / d * d);
    }
    return -((dist + d - 1) / d * d);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x.at(i);
    }
    ll x0, d;
    cin >> x0 >> d;
    int m, t1;
    cin >> m >> t1;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll pos1 = x0 + distprev(x0, x.at(i), d), pos2 = x0 + distnext(x0, x.at(i), d);
        ans += min(kv(x.at(i) - pos1), kv(x.at(i) - pos2));
    }
    cout << ans;
    return 0;
}
