#include <bits/stdc++.h>
using namespace std;

vector<vector<int> > graph;
int cnt[2];

void dfs(int v, int prv, int col) {
    cnt[col]++;
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        dfs(to, v, 1 - col);
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    graph.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(0, -1, 0);
    cout << min(cnt[0], cnt[1]) << "\n-1";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
