#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

//#define int long long
#define all(a) a.begin(), a.end()

vector<vector<int>> g;

vector<int> col;

vector<vector<int>> g2;
vector<int> in_m;
vector<int> used;
vector<int> p;
int cnt = 0;


void coldfs(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            col[u] = 1 - col[v];
            coldfs(u, v);
        }
    }
}

bool kundfs(int v) {
    used[v] = cnt;
    for (int u : g2[v]) {
        if (p[u] == -1) {
            in_m[v] = u;
            p[u] = v;
            return true;
        }
        if (used[p[u]] == cnt) continue;
        if (kundfs(p[u])) {
            in_m[v] = u;
            p[u] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    col.resize(n, 0);
    coldfs(0, 0);
    vector<int> bl, wh;
    for (int i = 0; i < n; i++) {
        if (col[i] == 0) {
            bl.push_back(i);
        } else {
            wh.push_back(i);
        }
    }
    vector<vector<int>> dist(n, vector<int> (n, -1));
    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
        queue<int> q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u : g[v]) {
                if (dist[i][u] == -1) {
                    dist[i][u] = dist[i][v] + 1;
                    q.push(u);
                }
            }
        }
    }

    // for (auto el : dist) {
    //     for (auto el2 : el) {
    //         cout << el2 << ' ';
    //     }
    //     cout << endl;
    // }
    g2.resize(wh.size());
    int n2 = wh.size();
    int m2 = bl.size();
    for (int i = 0; i < wh.size(); i++) {
        for (int j = 0; j < bl.size(); j++) {
            if (dist[wh[i]][bl[j]] <= d) {
                g2[i].push_back(j);
            }
        }
    }
    // for (auto el : g2) {
    //     for (auto el2 : el) {
    //         cout << el2 << ' ';
    //     }
    //     cout << endl;
    // }

    p.resize(m2, -1);
    in_m.resize(n2, -1);
    used.resize(n2, 0);
    bool found = true;
    while (found) {
        cnt++;
        found = false;
        int i = 0;
        while (i < n2) {
            if (used[i] != cnt && in_m[i] == -1) {
                found |= kundfs(i);
            }
            i++;
        }
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n2; i++) {
        if (in_m[i] != -1) {
            ans.push_back({i, in_m[i]});
        }
    }
    cout << ans.size() << '\n';
    for (auto [f, s] : ans) {
        cout << wh[f] + 1 << ' ' << bl[s] + 1 << '\n';
    }
    // cout << min(bl.size(), wh.size()) << '\n';
    // for (int i = 0; i < min(bl.size(), wh.size()); i++) {
    //     cout << wh[i] + 1 << ' ' << bl[i] + 1 << '\n';
    // }
}