#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

//#define int long long
#define all(a) a.begin(), a.end()

vector<vector<int>> g;
vector<pair<int, int>> dp;
vector<int> inm;

void dfs(int v, int p) {
    int mind = 1e9;
    int ind = -1;
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v].first += max(dp[u].first, dp[u].second);
            if (max(dp[u].first, dp[u].second) - dp[u].first < mind) {
                mind = max(dp[u].first, dp[u].second) - dp[u].first;
                ind = u;
            }
        }
    }
    dp[v].second = dp[v].first - mind + 1;
    inm[v] = ind;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp.resize(n, {0, 0});
    inm.resize(n, -1);
    dfs(0, 0);
    cout << max(dp[0].first, dp[0].second) << '\n';
    queue<pair<int, int>> q;
    if (dp[0].first > dp[0].second) {
        q.push({0, 0});
    } else {
        q.push({0, 1});
    }
    vector<int> used(n, 0);
    vector<pair<int, int>> ans;
    while (!q.empty()) {
        auto [v, t] = q.front();
        q.pop();
        used[v] = 1;
        if (t == 1) {
            int u2 = inm[v];
            ans.push_back({u2, v});
            used[u2] = 1;
            q.push({u2,0});
        }
        for (int u : g[v]) {
            if (!used[u]) {
                if (dp[u].first > dp[u].second) {
                    q.push({u, 0});
                } else {
                    q.push({u, 1});
                }
            }
        }
    }
    for (auto [f, s] : ans) {
        cout << f + 1 << ' ' << s + 1 << '\n';
    }
}