#include <bits/stdc++.h>


using namespace std;

#define int int64_t
#define pb push_back

int const inf = 1e18;
int const maxn = 5e5;


int t[maxn * 4];

void build(int v, int tl, int tr) {
    t[v] = inf;
    if (tl + 1 == tr) return;
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
}

int get(int v,int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) return inf;
    if (l <= tl && tr <= r) return t[v];

    int tm = (tl + tr) / 2;
    return min(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm, tr, l, r));
}

void upd(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        t[v] = min(t[v], val);
    } else {
        int tm = (tl + tr) / 2;
        if (pos < tm) {
            upd(v * 2 + 1, tl, tm, pos, val);
        } else {
            upd(v * 2 + 2, tm, tr, pos, val);
        }
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), r(k), m(k);
    vector<vector<pair<int, int> > > w(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        w[m[i]].pb({l[i], r[i]});
    }
    build(0, 0, n + 1);
    upd(0, 0, n + 1, 0, 0);
    for (int i = 1; i <= n; i++) {
        for (auto [L, R]: w[i]) {
            int x = get(0, 0, n + 1, L - 1, i);
            if (x != inf) {
                upd(0, 0, n + 1, R, i);
                continue;
            }
            x = get(0, 0, n + 1, i, R + 1);
            if (x < L) {
                upd(0, 0, n + 1, R, i);
            }
        }
    }
    if (get(0, 0, n + 1, n, n + 1) < n + 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
