#pragma GCC target("Ofast")

#include <bits/stdc++.h>


using namespace std;

#define int __int128
#define ll int64_t
#define pb push_back
#define all(a) a.begin(), a.end()


int const inf = 1e18;
int const maxn = 5e5;

int pr[maxn], kv[maxn], vl[maxn];


ll n;
vector<ll> x;

int f(int j, int d, int t) {
    int l = -1, r = n;

    int v = j * d;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (x[m] > v) r = m;
        else l = m;
    }
    return j * t + vl[l + 1] + (kv[n] - kv[l + 1]) - 2 * (pr[n] - pr[l + 1]) * v + v * v * (n - l - 1);
}

void solve() {
    cin >> n;
    x.resize(n);
    for (ll &i: x) cin >> i;
    sort(all(x));

    ll x0, d;
    cin >> x0 >> d;

    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + x[i];
        kv[i + 1] = kv[i] + x[i] * x[i];
        vl[i + 1] = vl[i] + min(x[i] % d, d - x[i] % d) * min(x[i] % d, d - x[i] % d);
    }

    ll m;
    cin >> m;

    for (int i = 0; i < m; i++) {
        ll t;
        cin >> t;

        int l = 0, r = (int) 1e9;


        while (l + 2 < r) {
            int m1 = l + (r - l) / 3, m2 = l + ((r - l) / 3) * 2;
            if (f(m1, d, t) < f(m2, d, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        cout << (ll)min({(int) f(l, d, t), (int) f(l + 1, d, t), (int) f(l + 2, d, t)}) << '\n';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}