#include <bits/stdc++.h>


using namespace std;

#define int int64_t
#define pb push_back

int const inf = 1e18;
int const maxn = 5e5;

__int128 f(int j, int d, int t, vector<int> &x) {
    __int128 res = j * t;
    for (int c: x) {
        if (c <= j * d) {
            res += min(c % d, d - c % d) * min(c % d, d - c % d);
        } else {
            res += abs(j * d - c) * abs(j * d - c);
        }
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i: x) cin >> i;
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;

    for (int i = 0; i < m; i++) {
        int t;
        cin >> t;

        int l = 0, r = (int)1e6 / d + 1;


        while (l + 2 < r) {
            int m1 = l + (r - l) / 3, m2 = l + ((r - l) / 3) * 2;
            if (f(m1, d, t, x) < f(m2, d, t, x)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        cout << min({(int)f(l, d, t, x), (int)f(l + 1, d, t, x), (int)f(l + 2, d, t, x)}) << '\n';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
