#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

const ll inf = 3e18;

ll div_floor(ll a, ll b) {
	if (b < 0) {
		a = -a;
		b = -b;
	}
	if (a % b == 0 || a >= 0)
		return a / b;
	return a / b - 1;
}

ll sq(ll a) {
	return a * a;
}

inline void solve() {
	int n;
	cin >> n;
	vector<ll> x(n);
	for (int i = 0; i < n; i++)
		cin >> x[i];
	ll x0, d;
	cin >> x0 >> d;
	int m;
	cin >> m;
	vector<ll> t(m);
	for (int i = 0; i < m; i++)
		cin >> t[i];
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		ll k = div_floor(x[i] - x0, d);
		ll tmp = inf;
		tmp = min(tmp, sq(x[i] - x0 - k * d));
		tmp = min(tmp, sq(x[i] - x0 - (k + 1) * d));
		ans += tmp;
	}
	cout << ans << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}