#include <iostream>

#include <vector>

using namespace std;

vector <pair <int, int>> xx;

void dfs(int v, vector <vector <int>>& a, vector <int>& used, int pred, vector <int>& usedd) {
    used[v] = 1;
    for (int i : a[v]) {
        if (used[i] == 0) {
            dfs(i, a, used, v, usedd);
        }
    }
    if (usedd[v] == 0 && pred != -1 && usedd[pred] == 0) {
        usedd[v] = 1;
        usedd[pred] = 1;
        xx.push_back({v + 1, pred + 1});
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, d, u, v;
    cin >> n >> d;
    vector <vector <int>> a(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        a[u - 1].push_back(v - 1);
        a[v - 1].push_back(u - 1);
    }
    vector <int> usedd(n, 0);
    vector <int> used(n, 0);
    dfs(0, a, used, -1, usedd);
    cout << xx.size() << '\n';
    for (pair <int, int> i : xx) {
        cout << i.first << ' ' << i.second << '\n';
    }
    return 0;
}