#include <bits/extc++.h>
using namespace std;
#define int long long
mt19937 rng(6969);
struct seg{
    int l, m, r;
    seg(int l, int m, int r): l(l), m(m), r(r){}
};
bool comp(seg& a, seg& b){
    return a.l < b.l || a.l == b.l && a.r < b.r;
}
void solve(){
    int n, k;
    cin>>n>>k;
    vector <vector <int> > dp(n + 1, vector <int> (k + 1, 1e9));
    dp[0][0] = 0;
    vector <seg> q;
    for (int i = 0, l, m, r; i < k; i++){
        cin>>l>>m>>r;
        seg a(l, m, r);
        q.push_back(a);
    }
    sort(q.begin(), q.end(), comp);
    for (int it = 0; it < k * k * k * k * k; it++){
        vector <bool> check(n + 1, 0);
        bool flag = false;
        shuffle(q.begin(), q.end(), rng);
        for (int i = 0; i < k; i++){
                if (check[q[i].m]){
                    break;
                }
                else{
                    for (int j = q[i].l; j <= q[i].r; j++){
                        check[j] = true;
                    }
                }
        }
        for (int i = 1; i <= n; i++){
            if (!check[i]){
                flag = false;
                break;
            }
        }
        if (flag){
            cout<<"YES\n";
            return;
        }
    }
    cout<<"NO\n";
}
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test;
    cin>>test;
    while(test--){
        solve();
    }
    
}