#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lll = __int128;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

ll n;
lll x0, d;
vector<lll> pos, neg;
vector<lll> prefPos, sufPos, sufSqPos, optPos;
vector<lll> prefNeg, sufNeg, sufSqNeg, optNeg;

ll fPos(lll r, lll t) {
    ll idx = upper_bound(all(optPos), r) - optPos.begin() - 1;
    lll res = 0;
    if (idx >= 0)
        res = prefPos[idx];
    if (idx < pos.size() - 1) {
        res += r * r * (pos.size() - idx - 1);
        res -= r * sufPos[idx + 1] * 2;
        res += sufSqPos[idx + 1];
    }
    return (ll)(res + t * (r / d));
}

ll fNeg(lll r, lll t) {
    ll idx = upper_bound(all(optNeg), r) - optNeg.begin() - 1;
    lll res = 0;
    if (idx >= 0)
        res = prefNeg[idx];
    if (idx < neg.size() - 1) {
        res += r * r * (neg.size() - idx - 1);
        res -= r * sufNeg[idx + 1] * 2;
        res += sufSqNeg[idx + 1];
    }
    return (ll)(res + t * (r / d));
}


ll f(lll posDir, lll t) {
    if (neg.empty())
        return fPos(posDir, t);
    lll l = 0, r = optNeg.back() / d + 2;
    while (r - l > 1) {
        //cout << (ll)l << " " << (ll)r << endl;
        lll m = (l + r) / 2;
        lll x = fNeg(m * d, t);
        lll x1 = fNeg((m - 1) * d, t);
        //cout << x1 << " " << x << endl;
        if (x + t * min(posDir / d, m) > x1 + t * min(posDir / d, m - 1))
            r = m;
        else
            l = m;
    }
    return fNeg(l, t) + fPos(posDir, t) + min(posDir / d, l) * t;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<lll> x(n);
    for (ll i = 0; i < n; ++i) {
        ll y;
        cin >> y;
        x[i] = y;
    }
    sort(all(x));
    ll biba, boba;
    cin >> biba >> boba;
    x0 = biba, d = boba;
    for (int i = 0; i < n; ++i) {
        if (x[i] > x0)
            pos.push_back(x[i] - x0);
    }
    for (int i = n - 1; i >= 0; --i) {
        if (x[i] < x0)
            neg.push_back(x0 - x[i]);
    }
    prefPos.resize(pos.size());
    sufPos.resize(pos.size());
    sufSqPos.resize(pos.size());
    optPos.resize(pos.size());
    for (ll i = 0; i < pos.size(); ++i) {
        lll optL = pos[i] / d * d;
        lll optR = (pos[i] + d - 1) / d * d;
        lll distL = (pos[i] - optL) * (pos[i] - optL);
        lll distR = (pos[i] - optR) * (pos[i] - optR);
        if (distL <= distR) {
            optPos[i] = optL;
        } else {
            optPos[i] = optR;
        }
        if (i > 0)
            prefPos[i] = prefPos[i - 1];
        prefPos[i] += (pos[i] - optPos[i]) * (pos[i] - optPos[i]);
    }
    if (!pos.empty()) {
        sufPos[pos.size() - 1] = pos[pos.size() - 1];
        sufSqPos[pos.size() - 1] = pos[pos.size() - 1] * pos[pos.size() - 1];
        for (ll i = pos.size() - 2; i >= 0; --i) {
            sufPos[i] = sufPos[i + 1] + pos[i];
            sufSqPos[i] = sufSqPos[i + 1] + pos[i] * pos[i];
        }
    }
    prefNeg.resize(neg.size());
    sufNeg.resize(neg.size());
    sufSqNeg.resize(neg.size());
    optNeg.resize(neg.size());
    for (ll i = 0; i < neg.size(); ++i) {
        lll optL = neg[i] / d * d;
        lll optR = (neg[i] + d - 1) / d * d;
        lll distL = (neg[i] - optL) * (neg[i] - optL);
        lll distR = (neg[i] - optR) * (neg[i] - optR);
        if (distL <= distR) {
            optNeg[i] = optL;
        } else {
            optNeg[i] = optR;
        }
        if (i > 0)
            prefNeg[i] = prefNeg[i - 1];
        prefNeg[i] += (neg[i] - optNeg[i]) * (neg[i] - optNeg[i]);
    }
    if (!neg.empty()) {
        sufNeg[neg.size() - 1] = neg[neg.size() - 1];
        sufSqNeg[neg.size() - 1] = neg[neg.size() - 1] * neg[neg.size() - 1];
        for (ll i = neg.size() - 2; i >= 0; --i) {
            sufNeg[i] = sufNeg[i + 1] + neg[i];
            sufSqNeg[i] = sufSqNeg[i + 1] + neg[i] * neg[i];
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        lll t;
        ll t0;
        cin >> t0;
        t = t0;
//        for (ll i = 0; i <= opt[n - 1] / d + 1; ++i) {
//            cout << f(i * d, t) << " ";
//        }
//        cout << "\n";
        if (!pos.empty()) {
            lll l = 0, r = optPos.back() / d + 2;
            while (r - l > 1) {
                lll m = (l + r) / 2;
                lll x = f(m * d, t);
                lll x1 = f((m - 1) * d, t);
                //cout << x1 << " " << x << endl;
                if (x > x1)
                    r = m;
                else
                    l = m;
            }
            cout << f(l * d, t) << "\n";
        } else {
            cout << f(0, t) << "\n";
        }
    }
}
