#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

vector<vector<int>> g;
vector<int> mt, used, col;
int timer = 0;

void dfs(int v, int p, int c) {
    col[v] = c;
    for (auto to : g[v]) if (to != p) {
        dfs(to, v, 1 - c);
    }
}

bool kuhn(int v) {
    used[v] = timer;
    for (auto to : g[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
    }
    for (auto to : g[v]) if (used[mt[to]] != timer){
        if (kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    used.resize(n, -1);
    mt.resize(n, -1);
    col.resize(n);
    dfs(0, -1, 0);
    int ans = 0;
    for (int i = 0; i < n; ++i) if (col[i]) {
        if (kuhn(i))
            ++ans;
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) if (mt[i] != -1) {
        cout << i + 1 << " " << mt[i] + 1 << "\n";
    }
}
