#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long int;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl = vector <vl>;
using vb = vector <bool>;
using vvb = vector <vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

int main(){
	ll n, m;

	cin >> n >> m;

	vector <string> mas(n, string(m, '0'));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> mas[i][j];
		}
	}

	vvl decay(n, vl(m));

	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (mas[i][j] == '1') {
				if (j == m - 1) decay[i][j] = 1;
				else decay[i][j] = decay[i][j + 1] + 1;
			}
		}
	}

	ll res = 0;

	for (int j = 0; j < m; j++) {
		auto cmp = [](ll a, ll b) {return a > b; };
		map<ll, ll, decltype(cmp)> mp(cmp);
		ll cnt = 0;
		for (int i = 0; i < n; i++) {
			if (mas[i][j] == '0') {
				cnt = 0;
				mp.clear();
			}
			else {
				ll a = decay[i][j];
				mp[a] += 1;
				cnt += a;

				while (mp.size() && (*mp.begin()).first > a) {
					mp[a] += (*mp.begin()).second;
					cnt -= ((*mp.begin()).first - a) * (*mp.begin()).second;
					mp.erase(mp.begin());
				}

				res = max(res, cnt);
			}
		}
	}

	cout << res << "\n";
}
