#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long int;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl = vector <vl>;
using vb = vector <bool>;
using vvb = vector <vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

using lls = __int128;

struct thing {
	ll sum, cnt, sum2;
};

vector <thing> sufsum;

lls OK(ll x, vl& prefsum, vl& mas) {
	ll l = -1, r = mas.size();

	while (r - l > 1) {
		ll m = l + (r - l) / 2;

		if (mas[m] <= x) l = m;
		else r = m;
	}

	lls res = 0;

	if (l >= 0) {
		res = prefsum[l];
	}

	if (r != mas.size()) {
		lls cu = sufsum[r].sum2 - (2 * x * sufsum[r].sum) + x * x * sufsum[r].cnt;

		res += cu;
	}

	return res;
}

ll binf(ll l, ll r, vl& mas, vl& prefsum, ll cost, ll d) {
	while (r - l > 1) {
		ll m1 = l + (r - l) / 3;
		ll m2 = r - (r - l) / 3;
		if (m1 == l) ++m1;
		if (m2 == r) --m2;


		lls cu1 = OK(m1 * d, prefsum, mas) + m1 * cost;
		lls cu2 = OK(m2 * d, prefsum, mas) + m2 * cost;

		if (cu1 > cu2) l = m1;
		else r = m2;
	}

	lls cu1 = OK(l * d, prefsum, mas) + l * cost;
	lls cu2 = OK(r * d, prefsum, mas) + r * cost;

	return min(cu1, cu2);
}

void solut() {
	ll n;

	cin >> n;

	vl mas(n);

	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}

	sort(mas.begin(), mas.end());

	ll x0, d;

	cin >> x0 >> d;

	vl prefsum(n);

	for (int i = 0; i < n; i++) {
		ll lastx = (mas[i] - x0) / d * d + x0;
		ll nextx = lastx + d;

		prefsum[i] = min((mas[i] - lastx) * (mas[i] - lastx), (nextx - mas[i]) * (nextx - mas[i]));
		if (i != 0) prefsum[i] += prefsum[i - 1];
	}

	sufsum.assign(n, {});

	for (int i = n - 1; i >= 0; i--) {
		sufsum[i].sum += mas[i];
		sufsum[i].sum2 += mas[i] * mas[i];
		sufsum[i].cnt += 1;

		if (i != n - 1) {
			sufsum[i].sum += sufsum[i + 1].sum;
			sufsum[i].sum2 += sufsum[i + 1].sum2;
			sufsum[i].cnt += sufsum[i + 1].cnt;
		}
	}

	ll m;

	cin >> m;

	while (m--) {
		ll cost;

		cin >> cost;

		ll l = 0, r = 1e9;

		ll res = binf(l, r, mas, prefsum, cost, d);

		cout << res << "\n";
	}
}

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;

	while (t--) {
		solut();
	}
}