#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long int;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl = vector <vl>;
using vb = vector <bool>;
using vvb = vector <vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

vpl resst;
vb mark;
vl havs;

ll dfs(ll v, ll p, vvl &g) {
	ll res = 0;
	ll d = 0;
	vl st;

	for (auto u : g[v]) {
		if (u == p) continue;

		res += dfs(u, v, g);
		if (!mark[u]) {
			++d;
			st.push_back(u);
		}
	}

	res += d / 2;
	for (int i = 1; i < st.size(); i += 2) {
		resst.push_back({ st[i - 1], st[i] });
	}

	bool ex = 0;
	for (auto u : g[v]) {
		if (u == p) continue;

		if (havs[u] != -1) {
			++res;
			resst.push_back({ havs[u], v });
			mark[v] = 1;
			ex = 1;
			break;
		}
	}

	if (!ex) {
		havs[p] = v;
	}

	return res;
}

void solut() {
	ll n, k;

	cin >> n >> k;

	vvl g(n);
	havs.assign(n, -1);
	mark.assign(n, 0);

	for (int i = 0; i < n - 1; i++) {
		ll v, u;
		cin >> v >> u;
		--v; --u;

		g[v].push_back(u);
		g[u].push_back(v);
	}

	dfs(0, 0, g);

	cout << resst.size() << "\n";
	for (auto now : resst) cout << now.first + 1 << " " << now.second + 1 << "\n";
}

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;

	while (t--) {
		solut();
	}
}