#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<ll>> g;
vector<ll> dp, sp;

ll dfs(ll v, ll p) {
    for (ll i : g[v]) if (i != p) {
        if (i != p) {
            dfs(i, v);
            sp[v] += dp[i];
        }
    }
    dp[v] = sp[v];
    for (ll i : g[v]) {
        if (i == p) continue;
        dp[v] = max(dp[v], sp[v] - dp[i] + sp[i] + 1);
    }
    return dp[v];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n, d;
    cin >> n >> d;
    assert(d == 1);
    g.resize(n);
    dp.resize(n);
    sp.resize(n);
    for (ll i = 1; i < n; ++i) {
        ll a, b;
        cin >> a >>b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    cout << dfs(0, 0) << '\n';
    cout << "-1\n";
}
