#include <bits/stdc++.h>
using namespace std;

vector<int> ls, ms, rs;
int n, m;

void solvets1() {
    set<int> not_yet;
    for (int i = 0; i < m; ++i) {
        not_yet.insert(i);
    }
    not_yet.insert(m + 5);
    for (int i = 0; i < n; ++i) {
        while (*not_yet.lower_bound(ls[i]) < rs[i]) {
            not_yet.erase(not_yet.lower_bound(ls[i]));
        }
    }
    cout << (not_yet.size() == 1 ? "YES\n" : "NO\n");
}

set<pair<int, int>> byM;
vector<int> used;
bool allGood = true;

void dfs(int u) {
    if (!allGood) {
        return;
    }
    used[u] = 1;
    pair<int, int> pr = {ls[u], -1};
    for (pr = *byM.lower_bound(pr); pr.first < rs[u]; pr = *byM.upper_bound(pr)) {
        if (pr.second == u) {
            continue;
        }
        if (used[pr.second] == 1) {
            allGood = false;
            return;
        }
        dfs(pr.second);
    }
    used[u] = 2;
    byM.erase({ms[u], u});
}

void solvets8() {
    allGood = true;
    byM.clear();
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        byM.emplace(ms[i], i);
    }
    byM.emplace(m + 1, -1);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    cout << (allGood ? "YES\n" : "NO\n");
}


void solve() {
    cin >> m >> n;
    ls.assign(n, 0);
    ms.assign(n, 0);
    rs.assign(n, 0);
    bool isSubtask1 = true;
    for (int i = 0; i < n; ++i) {
        cin >> ls[i] >> ms[i] >> rs[i];
        ls[i]--; ms[i]--;
        isSubtask1 = isSubtask1 && ls[i] == ms[i];
    }
    if (isSubtask1) {
        solvets1();
    } else {
        solvets8();
    }
}

int main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        solve();
    }
}