#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> gr;
vector<int> dep;
vector<int> dpY, dpN;

pair<int, int> dfs(int u, int p, int d) {
    dep[u] = d;
    vector<pair<int, int>> chs;
    int allDpy = 0;
    for (int v : gr[u]) {
        if (v != p) {
            auto [dpy, dpn] = dfs(v, u, d + 1);
            allDpy += dpy;
            chs.emplace_back(dpy, dpn);
        }
    }
    int mxAns = allDpy;
    for (int i = 0; i < (int) chs.size(); ++i) {
        mxAns = max(mxAns, chs[i].second + 1 + allDpy - chs[i].first);
    }
    dpY[u] = mxAns;
    dpN[u] = allDpy;
    return {mxAns, allDpy};
}

void recover(int u, int p, bool used) {
    if (used || dpY[u] == dpN[u]) {
        for (int v : gr[u]) {
            if (v != p) {
                recover(v, u, false);
            }
        }
        return;
    }
    int allDpy = 0;
    vector<pair<int, int>> chs;
    vector<int> vertChs;
    for (int v : gr[u]) {
        if (v != p) {
            // auto [dpy, dpn] = dfs(v, u, d + 1);
            allDpy += dpY[v];
            vertChs.push_back(v);
            chs.emplace_back(dpY[v], dpN[v]);
        }
    }
    for (int i = 0; i < (int) chs.size(); ++i) {
        if (dpY[u] == chs[i].second + 1 + allDpy - chs[i].first) {
            cout << u + 1 << " " << vertChs[i] + 1 << "\n";
            for (int v : vertChs) {
                recover(v, u, v == vertChs[i]);
            }
            break;
        }
    }
}

int main() {
    int n, d;
    cin >> n >> d;
    // d == 1
    dep.resize(n);
    gr.resize(n);
    dpY.resize(n);
    dpN.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }
    cout << dfs(0, -1, 0).first << "\n";
    recover(0, -1, false);
}