// Author: Boris_Ber
#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int tmp;

struct seg {
    int l, r, m;
};

vector<vector<int> > g;
vector<int> c;
bool fnd;

void dfs(int v) {
    c[v] = 1;
    for (int u: g[v]) {
        if (c[u] == 1) fnd = true;
        else if (c[u] == 0) dfs(u);
    }
    c[v] = 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    fnd = false;
    g.assign(k, {});
    c.assign(k, 0);
    bool flag = false;
    for (auto &[l, r, m]: s) {
        cin >> l >> m >> r;
        if (l == 1 && r == n) {
            flag = true;
        }
        --l;
        --m;
        --r;
    }
    if (flag) {
        cout << "YES";
        return;
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) continue;
            if (s[i].l <= s[j].m && s[j].m <= s[i].r) {
                g[i].pb(j);
            }
        }
    }
    for (int i = 0; i < k; ++i) {
        if (c[i] == 0) dfs(i);
    }
    cout << (fnd ? "NO" : "YES");
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
#endif
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
