// Author: Boris_Ber
#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int tmp;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    sort(all(a));
    int x0, d;
    cin >> x0 >> d;
    int p = a[0], p2 = a[1];
    if (p < x0) {
        swap(p, p2);
    }
    int mx = (abs(p - x0) + d - 1) / d,
            mx2 = (abs(p2 - x0) + d - 1) / d;
    int m, t;
    cin >> m;
    while (m--) {
        cin >> t;
        int l = 0, r = mx + 2, ans1 = 1e18;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int f1 = (x0 + d * m - p), f2 = (x0 + d * (m + 1) - p);
            if (f1 * f1 + t * m > f2 * f2 + t * (m + 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        for (int i = l - 10; i <= r + 10; ++i) {
            int f = (x0 + d * i - p);
            ans1 = min(ans1, t * i + f * f);
        }

        l = 0, r = mx + 2;
        int ans2 = 1e18;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int f1 = (x0 - d * m - p2), f2 = (x0 - d * (m + 1) - p2);
            if (f1 * f1 + t * m > f2 * f2 + t * (m + 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        for (int i = l - 10; i <= r + 10; ++i) {
            int f = (x0 - d * i - p2);
            ans2 = min(ans2, t * i + f * f);
        }

        l = 0, r = mx + 2;
        int ans3 = 1e18;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int f1 = (x0 + d * m - p), f2 = (x0 + d * (m + 1) - p);
            if (f1 * f1 + 2 * t * m > f2 * f2 + 2 * t * (m + 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        for (int i = l - 10; i <= r + 10; ++i) {
            int f = (x0 + d * i - p);
            ans3 = min(ans3, 2 * t * i + f * f);
        }

        l = 0, r = mx + 2;
        int ans4 = 1e18;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int f1 = (x0 - d * m - p2), f2 = (x0 - d * (m + 1) - p2);
            if (f1 * f1 + 2 * t * m > f2 * f2 + 2 * t * (m + 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        for (int i = l - 10; i <= r + 10; ++i) {
            int f = (x0 - d * i - p2);
            ans4 = min(ans4, 2 * t * i + f * f);
        }

        cout << min(ans1 + ans4, ans2 + ans3) << '\n';
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
