#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

int n, d, timer = 0;
vector<int> h, mt, used, pr;
vector<vector<int>> g, g0, dp;

void dfs(int v = 0, int p = -1) {
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);  

        int cur = max(dp[u][0], dp[u][1]);
        dp[v][1] += max(dp[u][0], dp[u][1]);
        
        if (dp[u][1] + 1 - cur >= dp[v][0]) {
            dp[v][0] = dp[u][1] + 1 - cur;
            pr[v] = u;
        }
    }

    dp[v][0] += dp[v][1];

    // debug(v);
    // cout << dp[v][0] << " " << dp[v][1] << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> d;

    g.resize(n);
    h.resize(n);
    dp.assign(n, vector<int>(2));
    pr.resize(n);
    g0.resize(n);
    mt.assign(n, -1);
    used.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }

    dfs();

    cout << max(dp[0][0], dp[0][1]) << endl;
    cout << -1 << endl;
}
