#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0); 

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef __int128_t lll;

vector<vector<int>> g;

vector<char> color;

vector<int> as;
vector<int> bs;

pair<int, int> dfs(int v, int p) {
	pair<int, int> res{1, 0};
	color[v] = (v == p ? 1 : (1^color[p]));
	if (color[v]) as.emplace_back(v);
	else bs.emplace_back(v);
	for (auto u : g[v]) {
		if (u == p) continue;
		auto tmp = dfs(u, v);
		res.first += tmp.second;
		res.second += tmp.first;
	}
	return res; 
}

int dist(int v, int f, int p=-1) {
	for (auto &u : g[v]) {
		if (u == p) continue;
		int tmp = dist(u, f, v);
		if (tmp == -1) continue;
		else return tmp + 1;
	}
	return -1;
}

signed main() {
	FastIO;
	int n;
	cin >> n;
	int d;
	cin >> d;
	g.resize(n, vector<int>());
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[v - 1].emplace_back(u - 1);
		g[u - 1].emplace_back(v - 1);
	}
	color.resize(n, -1);
	dfs(0, 0);

	int asz = as.size();
	int bsz = bs.size();

	if (asz > bsz) {
		swap(asz, bsz);
		swap(as, bs);
	}

	vector<int> p(min(asz, bsz));
	vector<pair<int, int>> res;
	iota(all(p), 0);
	do {
		vector<pair<int, int>> tmp;
		for (int i = 0; i < asz; ++i) {
			int u = bs[i];
			int v = as[p[i]];
			if (dist(u, v) <= d) tmp.emplace_back(u, v);
		}
		if (res.size() < tmp.size()) res = tmp;
	} while (next_permutation(all(p)));
	cout << res.size() << '\n';
	for (auto &[u, v]: res) cout << u + 1 << ' ' << v + 1 << '\n';
	return 0;
}

