#include <bits/stdc++.h>

struct Man
{
  int l, m, r;

  Man(int l, int m, int r) : l(l), r(r), m(m) {}
};

void solve()
{
  int n, k;
  std::cin >> n >> k;
  std::vector<Man> man;
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    std::cin >> l >> m >> r;
    l--, m--, r--;
    man.emplace_back(l, m, r);
  }
  std::sort(man.begin(), man.end(), [&](const Man& l, const Man &r) {
    return l.m > r.m;
  });
  int last = n;
  for (int i = 0; i < k; ++i) {
    if (man[i].r >= last - 1)
      last = man[i].m;
  }
  if (last == 0)
    std::cout << "YES\n";
  else
    std::cout << "NO\n";
}

int main()
{
  int t;
#ifdef LOCAL
  freopen("in/b.txt", "r", stdin);
  freopen("out/b1.txt", "w", stdout);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  std::cin >> t;
  for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}