#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

const int N = 5e5 + 10;

vector<int> g[N];
int h[N], par[N];

void dfs(int v, int p) {
    h[v] = (p == -1 ? 0 : h[p] + 1);
    par[v] = p;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
    }
}

void solve_case() {
    int n, d; cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, -1);
    set<pair<int, int>> q;
    for (int i = 1; i <= n; i++) {
        q.insert({h[i], i});
    }
    vector<pair<int, int>> ans;
    vector<bool> used(n + 1);
    while (!q.empty()) {
        int v = q.rbegin()->second;
        q.erase(--q.end());
        if (used[v]) {
            continue;
        }
        int p = par[v];
        if (p != -1 && !used[p]) {
            used[v] = used[p] = true;
            ans.push_back({v, p});
        }
    }
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u << ' ' << v << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve_case();
    }
}