#include <bits/stdc++.h>
#define int long long
using namespace std;

struct seg {
    int l, r, m;
    seg(int l_ = 0, int r_ = 0, int m_ = 0) {
        l = l_;
        r = r_;
        m = m_;
    }
};

bool cmp(seg a, seg b) {
    if (a.l == b.l) {
        if (a.r == b.r) {
            return a.m < b.m;
        }
        return a.r < b.r;
    }
    return a.l < b.l;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> W;
    vector<int> DP(k, -1);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        W.push_back({l, r, m});
    }
    sort(W.begin(), W.end(), cmp);
    for (int i = 0; i < k; ++i) {
        if (W[i].l == 1) {
            DP[i] = W[i].r;
        }
        for (int j = 0; j < i; ++j) {
            if (DP[j] != -1 && DP[j] >= W[i].l - 1) {
                if (W[j].r < W[i].m || W[j].m < W[i].l) {
                    DP[i] = W[i].r;
                }
            }
        }
        if (DP[i] >= n) {
            cout << "YES";
            return;
        }
    }
    cout << "NO";
    return;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int a, b;
    cin >> a;
    for (int i = 0; i < a; ++i) {
        solve();
        cout << '\n';
    }
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.