#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 228;

vector<int> tr;

int ask(int v, int l, int r, int askl, int askr) {
    if (l >= askr || r <= askl) {
        return inf;
    }
    if (l >= askl && r <= askr) {
        return tr[v];
    }
    int m = (r + l) / 2;
    return min(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}

void st(int v, int l, int r, int pos, int val) {
    if (l == r - 1) {
        tr[v] = min(tr[v], val);
        return;
    }
    int m = (r + l) / 2;
    if (pos < m) {
        st(2 * v + 1, l, m, pos, val);
    } else {
        st(2 * v + 2, m, r, pos, val);
    }
    tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pair<int, int>, pair<int, int>>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].second.first >> a[i].first.first >> a[i].second.second;
        a[i].second.first--;
        a[i].first.first--;
        a[i].second.second--;
        a[i].first.second = i;
    }
    sort(a.begin(), a.end());
    tr.assign(4 * n, inf);
    vector<int> t(k);
    for (int i = 0; i < k; ++i) {
        st(0, 0, n, a[i].second.second, a[i].second.first);
        t[i] = min(a[i].second.first, ask(0, 0, n, 0, a[i].first.first));
    }
    vector<int> mr(k, -1);
    if (a[0].second.first == 0) {
        mr[0] = a[0].second.second;
    }
    for (int i = 1; i < k; ++i) {
        int l = -1, r = i;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (a[m].first.first < a[i].second.first) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l == -1) {
            if (t[i] == 0) {
                mr[i] = a[i].second.second;
            }
        } else if (mr[l] >= t[i]) {
            mr[i] = max(mr[l], a[i].second.second);
        }
    }
    string ans = "NO";
    for (int i = 0; i < k; ++i) {
        if (mr[i] == n - 1) {
            ans = "YES";
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}