//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
//#define int long long
int inf = 1e9;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

bool slow(int n, int k, vector<vector<int>> &v) {
    vector<int> ord(k);
    for (int i = 0; i < k; ++i) {
        ord[i] = i;
    }
    vector<int> used(n+1);
    for (int i= 0; i < k; ++i) {
        if (used[v[ord[i]][1]]) {
            continue;
        }
        for (int x = v[ord[i]][0]; x <= v[ord[i]][2]; ++x) {
            used[x] = 1;
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i+1]) {
            cnt++;
        }
    }
    if (cnt == n) {
        return 1;
    }
    while (next_permutation(all(ord))) {
        vector<int> used(n+1);
        for (int i= 0; i < k; ++i) {
            if (used[v[ord[i]][1]]) {
                continue;
            }
            for (int x = v[ord[i]][0]; x <= v[ord[i]][2]; ++x) {
                used[x] = 1;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (used[i+1]) {
                cnt++;
            }
        }
        if (cnt == n) {
            return 1;
        }
    }
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> v(k);
    for (int i =0 ; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        v[i] = {l, m , r};
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) {
                if (v[i][0] == 1 && v[i][2] == n) {
                    cout << "YES";
                    return;
                }
                continue;
            }
            if (v[j][1] >= v[i][0] && v[i][2] >= v[j][1]) {
                continue;
            }
            if (v[i][0] == 1 && v[j][2] == n) {
                if (v[i][2] >= v[j][0]-1) {
                    cout << "YES";
                    return;
                }
            }
            if (v[i][2] == n && v[j][0] == 1) {
                if (v[j][2] >= v[i][0]-1) {
                    cout << "YES";
                    return;
                }
            }
        }
    }
    cout << "NO";
    return;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}