#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int nMax = 5e5 + 228;
int d;
vector<int> g[nMax],g2[nMax];
int mt[nMax], used[nMax];
void dfs1(int v,int p, int pp,int dist) {
    if (dist%2 && dist <=d) {
        g2[pp].push_back(v);
    }
    if (dist == d)return;
    for (auto u : g[v]) {
        if (u==p)continue;
        dfs1(u,v,pp,dist+1);
    }
}

int it=1;
bool kuhn(int v) {
    if (used[v]==it) return false;
    used[v]=it;
    for (auto u : g2[v]) {
        if (mt[u]==-1 || kuhn(mt[u])) {
            mt[u]=v;
            return true;
        }
    }
    return false;
}
int h[nMax];
int p[nMax];
void solve() {
    ll n;

    cin >> n;

    cin >> d;
    for (int i=1;i<n;i++) {
        int u,v;
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> q;
    q.push_back(1);
    while (q.size()) {
        auto u = q.back();
        q.pop_back();
        for (auto v : g[u]) {
            if (v == p[u])continue;
            p[v] = u;
            h[v] = h[u]+1;
            q.push_back(v);
        }
    }
    for (int i=1;i<=n;i++)if (h[i]%2==1)dfs1(i,i,i,0);
    memset(mt,-1,sizeof mt);
    memset(used,0,sizeof used);
    for (int i =1;i<=n;i++) {
        if (h[i]%2==1)
        it+=kuhn(i);
    }
    vector<pair<int,int>> aaa;
    for (int i=1;i<=n;i++)if ( mt[i]!=-1)aaa.push_back({i,mt[i]});
    cout << aaa.size() << '\n';
    for (int i=1;i<=n;i++) {
        if (h[i]%2==0 && mt[i]!=-1)
            cout << i << ' ' << mt[i] << '\n';

    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}