#include <bits/stdc++.h>
using namespace std;
struct node {
    int l,m,r;
};
bool dfs(vector<vector<int>> &g, vector<int> &colors, int u) {
    colors[u] = 1;
    for (auto v : g[u]) {
        if (colors[v] == 1) return true;
        if (colors[v] == 2) continue;
        bool ch = dfs(g, colors, v);
        if (ch) return true;
    }
    colors[u] = 2;
    return false;
}
bool comp(node &n1, node &n2) {
    if (n1.l == n2.l) {
        return n1.r > n2.r;
    }
    return n1.l > n2.l;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int q;
    cin >> q;
    while (q--) {
        int n,k;
        cin >> n >> k;
        vector<node>a(k);
        vector<int> add(n + 2);
        for (int i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            add[a[i].l]++;
            add[a[i].r + 1]--;
        }
        int nw = 0;
        bool ans = false;
        for (int i = 1; i <= n; i++) {
            nw += add[i];
            if (nw <= 0) {
                ans = true;
                break;
            }
        }
        if (ans) {
            cout << "NO\n";
            continue;
        }
        sort(a.begin(), a.end(), comp);
        int lst = n + 1;
        int sm = 0;
        for (int i = 0; i < n; i++) {
            if (a[i].l >= lst) continue;
            if (a[i].r + 1 < lst) {
                ans = true;
                break;
            }
            sm += lst - a[i].l;
            lst = a[i].l;
        }
        if (ans or sm != n) {
            cout << "NO\n";
        }else {
            cout << "YES\n";
        }
    }
}
