#pragma GCC optimize("03")
#include <bits/stdc++.h>
#pragma GCC target("avx2")
using namespace std;
#define int long long
const int INF = 9e18;
int get_ans(int x, int d, int tp, vector<int> &xx, vector<__int128> &ssuf, vector<__int128> &suf) {
    __int128 cur = x / d * tp;
    int id = upper_bound(xx.begin(), xx.end(), x) - xx.begin();
    if (id == xx.size()) {
        return cur;
    }
    __int128 smm1 = ssuf[id];
    __int128 smm2 = x * x * (xx.size() - id);
    __int128 ans = smm1 + smm2;
    __int128 sm3 = 2 * suf[id] * x;
    ans -= sm3;
    if (cur + ans > INF) return INF;
    return cur + ans;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    vector<__int128> ssuf(n);
    vector<__int128> suf(n);
    ssuf[n - 1] = x[n - 1] * x[n - 1];
    suf[n - 1] = x[n - 1];
    for (int i = n - 2; i > -1; i--) {
        ssuf[i] = x[i] * x[i];
        suf[i] = x[i];
        ssuf[i] += ssuf[i + 1];
        suf[i] += suf[i - 1];
    }
    int x0,d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int tp;
        cin >> tp;
        int answer = INF;
        int l = 0, r = 1e9 + 5;
        while (l + 2 < r) {
            int mid1 = l + (r - l) / 3;
            int mid2 = r - (r - l) / 3;
            int ans1 = get_ans(mid1 * d, d, tp, x, ssuf, suf);
            int ans2 = get_ans(mid2 * d, d, tp, x, ssuf, suf);
            answer = min({answer, ans1, ans2});
            if (ans1 < ans2) {
                r = mid2;
            }else {
                l = mid1;
            }
        }
        for (int j = l - 5; j < r + 5; j++) {
            if (j < 0) continue;
            answer = min(answer, get_ans(j * d, d, tp, x, ssuf, suf));
        }
        cout << answer << '\n';
    }
}