#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 1e18;

mt19937 rng(52);
void dfs(vector<vector<int>> &g, vector<pair<int, int>> &dp, vector<int> &w, int u, int p) {
    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(g, dp, w, v, u);
    }
    int cur = 0;
    for (auto v : g[u]) {
        if (v == p) continue;
        cur += dp[v].second;
    }
    dp[u].first = cur;
    int best = -1;
    int id = -1;
    for (auto v : g[u]) {
        if (v == p) continue;
        int nw = cur - dp[u].second + dp[u].first + 1;
        if (nw > best) {
            best = nw;
            id = v;
        }
    }
    dp[u].second = best;
    w[u] = id;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u,v;
        cin >> u >> v;
        u--,v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<pair<int, int>> dp(n);
    vector<int> w(n, -1);
    dfs(g, dp, w, 0, 0);
    cout << max(dp[0].first, dp[0].second) << '\n' << -1 << '\n';
}