#include <bits/stdc++.h>
using namespace std;
vector<int> dis;

void dfs(int v, vector<vector<int> > &g, int cur) {
    dis[v] = cur;
    for (auto u: g[v]) {
        if (dis[u] == -1) {
            dfs(u, g, cur + 1);
        }
    }
}

vector<vector<int> > dp;
vector<vector<int> > pred;
const int inf = 1'000'000'000;

void dfs1(int v, vector<vector<int> > &g) {
    vector<int> ch;
    for (auto u: g[v]) {
        if (dis[u] > dis[v]) {
            dfs1(u, g);
            ch.push_back(u);
        }
    }
    if (ch.empty()) {
        dp[v][1] = 0;
        dp[v][0] = 0;
        return;
    }
    int sm = 0;
    int max = -inf;
    int ind = -1;
    for (int i = 0; i < (int) ch.size(); i++) {
        sm += dp[ch[i]][0];
        if (max < dp[ch[i]][1] - dp[ch[i]][0]) {
            ind = i;
            max = dp[ch[i]][1] - dp[ch[i]][0];
        }
    }
    dp[v][1] = sm;
    if (ind == -1) {
        pred[v][0] = -1;
        dp[v][0] = sm;
    } else {
        dp[v][0] = sm + max + 1;
        pred[v][0] = ch[ind];
    }
}

vector<pair<int, int>> ans;
int fff;

void dfsdfs(int v, vector<vector<int>> & g, int cur) {
    if (cur == 1 || pred[v][0] == -1) {
        for (auto u: g[v]) {
            if (dis[u] > dis[v]) {
                dfsdfs(u, g, 0);
            }
        }
    } else {
        for (auto u: g[v]) {
            if (u == pred[v][0]) {
                if (fff > (int)ans.size()) {
                    return;
                }
                ans[fff] = {u, v};
                fff++;
                dfsdfs(u, g, 1);
            } else if (dis[u] > dis[v]) {
                dfsdfs(u, g, 0);
            }
        }
    }
}

int glob = 0;
vector<pair<int, int>> bst;

void rec(vector<pair<int, int>> & prs, deque<int> & svob, vector<vector<int>> & dp, int d) {
    if (prs.size() > glob) {
        glob = prs.size();
        bst = prs;
    }
    for (int i = 1; i < (int)svob.size(); i++) {
        int cur = dp[svob[0]][svob[i]];
        if (cur % 2 == 1) {
            if (cur <= d) {
                int a, b;
                a = svob[0];
                b = svob[i];
                prs.push_back({svob[0], svob[i]});
                swap(svob[i], svob.back());
                svob.pop_back();
                svob.pop_front();
                rec(prs, svob, dp, d);
                svob.push_front(a);
                svob.push_back(b);
                swap(svob.back(), svob[i]);
                prs.pop_back();
            }
        }
    }
}

signed main() {
    fff = 0;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, d;
    cin >> n >> d;
    vector<vector<int>> dp(n, vector<int>(n, inf));
    for (int i = 0; i < n; i++) {
        dp[i][i] = 0;
    }
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        dp[x][y] = 1;
        dp[y][x] = 1;
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][j]);
            }
        }
    }
    vector<pair<int, int>> prs;
    deque<int> svob(n);
    for (int i = 0; i < (int)svob.size(); i++) {
        svob[i] = i;
    }
    rec(prs, svob, dp, d);
    cout << glob << "\n";
    cout << "-1\n";
    /*for (auto u : bst) {
        cout << u.first + 1 << " " << u.second + 1 << "\n";
    }*/
}
