#include <bits/stdc++.h>
using namespace std;
vector<int> dis;
void dfs(int v, vector<vector<int>> & g, int cur) {
    dis[v] = cur;
    for (auto u : g[v]) {
        if (dis[u] == -1) {
            dfs(u, g, cur + 1);
        }
    }
}
vector<vector<int>> dp;
vector<vector<int>> pred;
const int inf = 1'000'000'000;
void dfs1(int v, vector<vector<int>> & g) {
    vector<int> ch;
    for (auto u : g[v]) {
        if (dis[u] > dis[v]) {
            dfs1(u, g);
            ch.push_back(u);
        }
    }
    if (ch.empty()) {
        dp[v][1] = 0;
        dp[v][0] = 0;
        return;
    }
    int sm = 0;
    int max = -inf;
    int ind = -1;
    for (int i = 0; i < (int)ch.size(); i++) {
        sm += dp[ch[i]][0];
        if (max < dp[ch[i]][1] - dp[ch[i]][0]) {
            ind = i;
            max = dp[ch[i]][1] - dp[ch[i]][0];
        }
    }
    dp[v][1] = sm;
    if (ind == -1) {
        dp[v][0] = sm;
    } else {
        dp[v][0] = sm + max + 1;
        pred[v][1] = ind;
    }
}
signed main() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dis.resize(n, -1);
    dfs(0, g, 0);
    dp.resize(n, vector<int>(2));
    pred.resize(n, vector<int>(2));
    dfs1(0, g);
    cout << max(dp[0][0], dp[0][1]) << "\n";
    cout << "-1\n";
}