#include <bits/stdc++.h>
using namespace std;
vector<int> dis;

void dfs(int v, vector<vector<int> > &g, int cur) {
    dis[v] = cur;
    for (auto u: g[v]) {
        if (dis[u] == -1) {
            dfs(u, g, cur + 1);
        }
    }
}

vector<vector<int> > dp;
vector<vector<int> > pred;
const int inf = 1'000'000'000;

void dfs1(int v, vector<vector<int> > &g) {
    vector<int> ch;
    for (auto u: g[v]) {
        if (dis[u] > dis[v]) {
            dfs1(u, g);
            ch.push_back(u);
        }
    }
    if (ch.empty()) {
        dp[v][1] = 0;
        dp[v][0] = 0;
        return;
    }
    int sm = 0;
    int max = -inf;
    int ind = -1;
    for (int i = 0; i < (int) ch.size(); i++) {
        sm += dp[ch[i]][0];
        if (max < dp[ch[i]][1] - dp[ch[i]][0]) {
            ind = i;
            max = dp[ch[i]][1] - dp[ch[i]][0];
        }
    }
    dp[v][1] = sm;
    if (ind == -1) {
        pred[v][0] = -1;
        dp[v][0] = sm;
    } else {
        dp[v][0] = sm + max + 1;
        pred[v][0] = ch[ind];
    }
}

vector<pair<int, int> > ans;

void dfsdfs(int v, vector<vector<int> > &g, int cur) {
    if (cur == 1 || pred[v][0] == -1) {
        for (auto u: g[v]) {
            if (dis[u] > dis[v]) {
                dfsdfs(u, g, 0);
            }
        }
    } else {
        for (auto u: g[v]) {
            if (u == pred[v][0]) {
                ans.push_back({u, v});
                dfsdfs(u, g, 1);
            } else if (dis[u] > dis[v]) {
                dfsdfs(u, g, 0);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, d;
    cin >> n >> d;
    vector<vector<int> > g(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dis.resize(n, -1);
    dfs(0, g, 0);
    dp.resize(n, vector<int>(2));
    pred.resize(n, vector<int>(2, 0));
    dfs1(0, g);
    cout << max(dp[0][0], dp[0][1]) << "\n";
    if (dp[0][0] > dp[0][1]) {
        dfsdfs(0, g, 0);
    } else {
        dfsdfs(0, g, 1);
    }
    for (auto u: ans) {
        cout << u.first + 1 << " " << u.second + 1 << "\n";
    }
}
