#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #pragma GCC optimize("unroll-loops")
// #define LOCAL

vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> pr;
void dfs2(int v, int p=-1) {
    dp[v][0] = 0;
    dp[v][1] = -1;
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs2(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        if (dp[v][1] == -1) {
            dp[v][1] = dp[u][0] - max(dp[u][0], dp[u][1]);
            pr[v] = u;
        } else {
            if (dp[v][1] < dp[u][0] - max(dp[u][0], dp[u][1])) {
                dp[v][1] = dp[u][0] - max(dp[u][0], dp[u][1]);
                pr[v] = u;
            }
        }
    }
    dp[v][1] += dp[v][0] + 1;
}
vector<pair<int, int>> ans;
void find_ans(int v, int flag, int p=-1) {
    int couple = -1;
    if (flag == 1) {
        ans.emplace_back(v, pr[v]);
        couple = pr[v];
    }
    if (flag == 0) {
        if (dp[v][0] < dp[v][1]) {
            couple = pr[v];
            ans.emplace_back(v, pr[v]);
        }
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        if (u == couple) {
            find_ans(u, -1, v);
        } else {
            find_ans(u, 0, v);
        }
    }
}
void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dp.assign(n, vector<int>(2));
    pr.assign(n, -1);
    dfs2(0);
    if (dp[0][0] > dp[0][1]) {
        find_ans(0, -1);
    } else {
        find_ans(0, 1);
    }
    cout << sz(ans) << '\n';
    for (auto [u, v] : ans) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}