#include <bits/stdc++.h>
#define For(i,n) for(ll i=0;i<n;++i)
#define Forr(i,n) for(ll i=n-1;i>=0;--i)
using namespace std;
using ll=long long;
using vl=vector<long long>;
struct segtree {
    vl tree;
    ll sz;
    void set(ll lx,ll rx,ll x,ll i,ll v) {
        if (rx-lx==1) {
            tree[x]=v;
            return;
        }
        ll mx=(lx+rx)/2;
        if (i<mx) {
            set(lx,mx,2*x+1,i,v);
        }else {
            set(mx,rx,2*x+2,i,v);
        }
    }
    void set(ll i,ll v) {
        set(0,sz,0,i,v);
    }
    ll min(ll lx,ll rx,ll x,ll l,ll r) {
        if (lx>=r || rx<=l) {
            return 1e9;
        }
        if (lx>=l & rx<=r) {
            return tree[x];
        }
        ll mx=(lx+rx)/2;
        return std::min(min(lx,mx,2*x+1,l,r),min(mx,rx,2*x+2,l,r));
    }
    ll min(ll l,ll r) {
        return min(0,sz,0,l,r);
    }
    segtree(ll n) {
        sz=1;
        while (sz<n) {
            sz*=2;
        }
        tree.assign(2*sz-1,1e9);
    }
};
void solve() {
    ll n,k;
    cin>>n>>k;
    segtree dp(n);
    vector<tuple<ll,ll,ll>> p;
    For(i,k) {
        ll l,r,m;
        cin>>l>>m>>r;
        --l;
        --r;
        --m;
        p.push_back({l,r,m});
    }
    sort(p.begin(),p.end(),[](tuple<ll,ll,ll> &a,tuple<ll,ll,ll> &b) {
        if (get<0>(a)<get<0>(b)) {
            return get<1>(a)<get<1>(b);
        }
        return get<0>(a)<get<0>(b);
    });
    auto get=[&](ll i) {
        return dp.min(i,i+1);
    };
    for (auto [l,r,m]:p) {
        if (l==0 || dp.min(l,m)!=1e9 || dp.min(m,r)<l) {
            if (get(r)>m) {
                dp.set(r,m);
            }
        }
    }
    if (get(n-1)!=1e9) {
        cout<<"YES\n";
    }else {
        cout<<"NO\n";
    }
}
int main() {
    //freopen("C:/work/CLionProjects/untitled/input.txt","r",stdin);
    ll t;
    cin>>t;
    while (t--)
        solve();
    return 0;
}