#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}
void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

__int128 sq(__int128 n) {return n * n;}

int n;
vector<int> x;
int x0, d;

__int128 fl2(int m, int t) {
    m = max(0ll, m);
    __int128 res = t * m * 2;
    for (int i = 0; i < n && x[i] < x0; i++) {
        if (x[i] <= x0 - m * d) {
            res += sq(x0 - m * d - x[i]);
        }
        else {
            int lp = ((x[i] - x0 % d) / d) * d + x0 % d;
            int rp = divup(x[i] - x0 % d, d) * d + x0 % d;
            res += min(sq(lp - x[i]), sq(rp - x[i]));
        }
    }
    return res;
}

__int128 fl1(int m, int t) {
    m = max(0ll, m);
    __int128 res = t * m;
    for (int i = 0; i < n && x[i] < x0; i++) {
        if (x[i] <= x0 - m * d) {
            res += sq(x0 - m * d - x[i]);
        }
        else {
            int lp = ((x[i] - x0 % d) / d) * d + x0 % d;
            int rp = divup(x[i] - x0 % d, d) * d + x0 % d;
            res += min(sq(lp - x[i]), sq(rp - x[i]));
        }
    }
    return res;
}

__int128 fr1(int m, int t) {
    m = max(0ll, m);
    __int128 res = t * m;
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) continue;
        if (x[i] >= x0 + m * d) {
            res += sq(x0 + m * d - x[i]);
        }
        else {
            int lp = ((x[i] - x0 % d) / d) * d + x0 % d;
            int rp = divup(x[i] - x0 % d, d) * d + x0 % d;
            res += min(sq(lp - x[i]), sq(rp - x[i]));
        }
    }
    return res;
}

__int128 fr2(int m, int t) {
    m = max(0ll, m);
    __int128 res = t * m * 2;
    for (int i = 0; i < n; i++) {
        if (x[i] < x0) continue;
        if (x[i] >= x0 + m * d) {
            res += sq(x0 + m * d - x[i]);
        }
        else {
            int lp = ((x[i] - x0 % d) / d) * d + x0 % d;
            int rp = divup(x[i] - x0 % d, d) * d + x0 % d;
            res += min(sq(lp - x[i]), sq(rp - x[i]));
        }
    }
    return res;
}

void solve() {
    cin >> n;
    x.resize(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    cin >> x0 >> d;
    sort(all(x));
    for (int &i : x) i += 2 * d;
    x0 += 2 * d;


    int q = 0; cin >> q;
    vector<int> t(q);
    for (int &i : t) cin >> i;
    vector<pii> buf(q);
    for (int i = 0; i < q; i++) buf[i] = {t[i], i};
    sort(all(buf));
    vector<int> ind(q);
    for (int i = 0; i < q; i++) {
        ind[i] = buf[i].second;
        t[i] = buf[i].first;
    }

    int l1 = max(0ll, divup(x0 - x[0], d)) + 2;
    int l2 = l1;
    int r1 = max(0ll, divup(x[n - 1] - x0, d)) + 2;
    int r2 = r1;
    vector<int> ansf(q);

    for (int c = 0; c < q; c++) {
        __int128 ans = INF;

        //cout << t << ":\n";

        __int128 resl = 0, resr = 0;
        int l, r;
        if (x0 >= x[0]) {
            l = -1, r = l2;
            while (r - l > 1) {
                int m1 = l + max(1ll, (r - l) / 3);
                int m2 = r - max(1ll, (r - l) / 3);

                __int128 rs1 = fl2(m1, t[c]);
                __int128 rs2 = fl2(m2, t[c]);
                if (rs1 <= rs2) r = m2;
                else l = m1;
            }
            resl = min(fl2(l, t[c]), fl2(r, t[c]));
            l2 = r + 1;
        }

        l = -1, r = r1;
        while (r - l > 1) {
            int m1 = l + max(1ll, (r - l) / 3);
            int m2 = r - max(1ll, (r - l) / 3);

            __int128 rs1 = fr1(m1, t[c]);
            __int128 rs2 = fr1(m2, t[c]);
            if (rs1 <= rs2) r = m2;
            else l = m1;
        }
        resr = min(fr1(l, t[c]), fr1(r, t[c]));
        r1 = r + 1;

        ans = min(ans, resl + resr);
        //cout << l << ' ' << r << '\n';
        // << resl << ' ' << resr << '\n';

        resl = 0, resr = 0;
        if (x0 >= x[0]) {
            l = -1, r = l1;
            while (r - l > 1) {
                int m1 = l + max(1ll, (r - l) / 3);
                int m2 = r - max(1ll, (r - l) / 3);

                __int128 rs1 = fl1(m1, t[c]);
                __int128 rs2 = fl1(m2, t[c]);
                if (rs1 <= rs2) r = m2;
                else l = m1;
            }
            resl = min(fl1(l, t[c]), fl1(r, t[c]));
            l1 = r + 1;
        }

        l = -1, r = r2;
        while (r - l > 1) {
            int m1 = l + max(1ll, (r - l) / 3);
            int m2 = r - max(1ll, (r - l) / 3);

            __int128 rs1 = fr2(m1, t[c]);
            __int128 rs2 = fr2(m2, t[c]);
            if (rs1 <= rs2) r = m2;
            else l = m1;
        }
        resr = min(fr2(l, t[c]), fr2(r, t[c]));
        r2 = r + 1;

        ans = min(ans, resl + resr);
        //cout << resl << ' ' << resr << '\n';

        ansf[ind[c]] = ans;
    }
    for (int i : ansf) cout << i << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1; //cin >> tt;
    while (tt--) solve();
}