#pragma GCC optimize("Ofast, unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <algorithm>
#pragma GCC target("avx2")

using namespace std;
#define int long long
mt19937 rnd(42);

bool comp(vector<int> a, vector<int> b) {
	if (a[0] != b[0]) return a[0] < b[0];
	else return a[2] > b[2];
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		int n, k;
		cin >> n >> k;
		vector<vector<int>> l(k, vector<int>(3));
		for (int i = 0; i < k; i++) {
			cin >> l[i][0] >> l[i][1] >> l[i][2];
			l[i][0]--;
			l[i][1]--;
			l[i][2]--;
		}
		vector<vector<bool>> dp(n, vector<bool>(n + 1));
		dp[0][n] = true;
		bool ans = false;
		for (int j2 = n; j2 >= 1; j2--) {
			for (int i = 0; i < n - j2 + 1; i++) {
				int j = i + j2 - 1;
				if (!dp[i][j2]) continue;
				//cout << i << " " << j << " ehhee\n";
				for (int q = 0; q < k; q++) {
					if (l[q][1] >= i and l[q][1] <= j) {
						if (l[q][0] <= i and l[q][2] >= j) {
							ans = true;
							continue;
						}
						if (l[q][0] <= i and l[q][2] >= i) {
							dp[l[q][2] + 1][j - (l[q][2] + 1) + 1] = true;
						}
						if (l[q][2] >= j and l[q][0] <= j) {
							dp[i][(l[q][0] - 1) - i + 1] = true;
						}
					}
				}
			}
		}
		if (ans) cout << "YES\n";
		else cout << "NO\n";
	}


}

/*

1
4 3
1 1 1
2 2 2
3 3 4


*/