#pragma GCC optimize("Ofast, unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <algorithm>
#pragma GCC target("avx2")

using namespace std;
#define int long long
mt19937 rnd(42);

int n, d;
vector<vector<int>> l;
vector<int> u1;
vector<int> u2;
vector<pair<int, int>> ans;
vector<vector<int>> dist;

void dfs0(int now, int pred, int start, int d) {
	dist[start][now] = d;
	for (int i : l[now]) {
		if (i == pred) continue;
		dfs0(i, now, start, d + 1);
	}
}

pair<vector<pair<int, int>>, vector<pair<int, int>>> dfs(int now, int pred) {
	vector<pair<int, int>> a;
	vector<pair<int, int>> b;
	for (int i : l[now]) {
		if (i == pred) continue;
		auto u = dfs(i, now);
		for (auto i : u.second) {
			if (i.first + 1 > d) continue;
			a.push_back({i.first + 1, i.second});
		}
		for (auto i : u.first) {
			if (i.first + 1 > d) continue;
			b.push_back({ i.first + 1, i.second });
		}
	}
	a.push_back({0, now});
	int now2 = 0;
	while (now2 < a.size()) {
		bool did = false;
		for (int i = 0; i < b.size(); i++) {
			int u = dist[a[now2].second][b[i].second];
			//cout << now2 << " " << i << " " << u << " ehhee\n";
			if (u % 2 == 1 and u <= d) {
				ans.push_back({ a[now2].second, b[i].second });
				a.erase(a.begin() + now2);
				b.erase(b.begin() + i);
				did = true;
				//cout << "DID\n";
				break;
			}
		}
		if (!did) now2++;
	}
	return { a, b };
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	cin >> n >> d;
	l = vector<vector<int>>(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		l[a].push_back(b);
		l[b].push_back(a);
	}
	dist = vector<vector<int>>(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		dfs0(i, i, i, 0);
	}
	dfs(0, 0);
	cout << ans.size() << "\n";
	for (auto i : ans) {
		cout << i.first + 1 << " " << i.second + 1 << "\n";
	}


}

/*

11
3
1 2
2 3
3 4
3 5
3 6
3 7
1 8
8 9
8 10
8 11


*/