// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define vc vector
#define all(v) v.begin(), v.end()
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
#define endl "\n"

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}

vc<vc<ll>> cnt;

ll n, d;
vc<vc<ll>> g;

void dfs(ll u, ll from, ll type)
{
    cnt[type].push_back(u);
    for (ll v : g[u])
        if (v != from)
            dfs(v, u, type ^ 1);
}

void solve()
{
    cin >> n >> d;

    g = vc<vc<ll>>(n);
    for (ll i = 0; i < n - 1; ++i)
    {
        ll u, v;
        cin >> u >> v;
        u--, v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    cnt = vc<vc<ll>>(2);

    dfs(0, -1, 0);

    cout << min(cnt[0].size(), cnt[1].size()) << endl;

    for (ll i = 0; i < min(cnt[0].size(), cnt[1].size()); ++i)
        cout << cnt[0][i] + 1 << " " << cnt[1][i] + 1 << endl;
}