// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll inf = 1e15;

#define vc vector
#define all(v) v.begin(), v.end()
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
#define endl "\n"

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}

ll n, d;
vc<vc<ll>> g;
vc<vc<ll>> dist;

void dfs(ll u, ll from, ll dist, vc<ll> &d)
{
    d[u] = dist;

    for (ll v : g[u])
        if (v != from)
            dfs(v, u, dist + 1, d);
}

void solve()
{
    cin >> n >> d;

    g = vc<vc<ll>>(n);
    dist = vc<vc<ll>>(n, vc<ll>(n));
    for (ll i = 0; i < n - 1; ++i)
    {
        ll u, v;
        cin >> u >> v;
        u--, v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (ll u = 0; u < n; ++u)
        dfs(u, -1, 0, dist[u]);

    vc<ll> dp(1 << n, -inf);
    dp[0] = 0;
    vc<pll> from(1 << n);

    for (ll mask = 0; mask < (1 << n); ++mask)
    {
        for (ll u = 0; u < n; ++u)
            for (ll v = u + 1; v < n; ++v)
            {
                if (!(dist[u][v] & 1))
                    continue;
                if (dist[u][v] > d)
                    continue;
                if ((mask >> u) & 1)
                    continue;
                if ((mask >> v) & 1)
                    continue;

                remax(dp[mask ^ (1ll << u) ^ (1ll << v)], dp[mask] + 1);
                if (dp[mask ^ (1ll << u) ^ (1ll << v)] == dp[mask] + 1)
                    from[mask ^ (1ll << u) ^ (1ll << v)] = {u, v};
            }
    }

    ll curmask = 0;

    for (ll mask = 0; mask < (1ll << n); ++mask)
        if (dp[mask] > dp[curmask])
            curmask = mask;

    vc<pll> ans{};

    cout << bitset<15>(curmask) << endl;

    while (__popcount(curmask) > 1)
    {
        auto [u, v] = from[curmask];
        ans.push_back({u, v});

        curmask ^= 1ll << u;
        curmask ^= 1ll << v;
    }
    cout << ans.size() << endl;
    for (auto [u, v] : ans)
        cout << u + 1 << " " << v + 1 << endl;
}

/*

8
7
1 2
2 3
3 4
3 5
1 6
6 7
3 8

*/