#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int INF = 1e9 + 69;

struct segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<segment> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
    }
    vector<int> num_sb(k, 0);
    vector<int> cur_active = {};
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            num_sb[i] += (a[i].l <= a[j].m && a[j].m <= a[i].r);
        }
        if (num_sb[i] == 0) {
            cur_active.push_back(i);
        }
    }
    while (cur_active.size()) {
        int cur_elem = cur_active.back();
        cur_active.pop_back();
        for (int i = 0; i < k; i++) {
            if (num_sb[i] <= 0) {
                continue;
            }
            num_sb[i] -= (a[i].l <= a[cur_elem].m && a[cur_elem].m <= a[i].r);
            if (num_sb[i] == 0) {
                cur_active.push_back(i);
            }
        }
    }
    for (auto num : num_sb) {
        if (num > 0) {
            cout << "NO" << "\n";
            return;
        }
    }
    cout << "YES" << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
