#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int INF = 1e9 + 69;

struct segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<segment> a(k);
    vector<int> max_r(k, -1);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        max_r[a[i].l] = max(max_r[a[i].l], a[i].r);
    }
    vector<pair<int, int>> cur_scanline = {};
    for (int i = 0; i < n; i++) {
        if (max_r[i] != -1) {
            cur_scanline.push_back({i, max_r[i]});
        }
    }
    int prev_r = 0;
    sort(all(cur_scanline));
    for (auto [l, r] : cur_scanline) {
        if (l > prev_r + 1) {
            cout << "NO" << endl;
            return;
        }
        prev_r = max(prev_r, r);
    }
    if (prev_r != n - 1) {
        cout << "NO" << endl;
        return;
    }
    cout << "YES" << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
