#include <bits/stdc++.h>
#define pb push_back
#define int long long
#define endl "\n"
using namespace std;
typedef pair<int, int> pii;
const int maxk = 1e4 + 10;
vector<int> g[maxk];
bool ok = 1;
int used[maxk];

struct node {
    int l, m, r;
};

void dfs(int u) {
    used[u] = 1;
    for (int v : g[u]) {
        if (used[v] == 0) dfs(v);
        else if (used[v] == 1) ok = 0;
    }
    used[u] = 2;
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector<node> a;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; m--; r--;
        a.pb({l, m, r});
    }
    vector<pii> events;
    for (auto [l, m, r] : a) {
        events.pb({l, 0});
        events.pb({r, 2});
    }
    for (int i = 0; i < n; ++i) {
        events.pb({i, 1});
    }
    sort(events.begin(), events.end());
    int cnt = 0;
    ok = 1;
    for (auto [x, t] : events) {
        if (t == 0) {
            cnt++;
        } else if (t == 1) {
            if (cnt == 0) ok = 0;
        } else {
            cnt--;
        }
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    for (int i = 0; i < k; ++i) g[i].clear();
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) continue;
            if (a[i].m >= a[j].l && a[i].m <= a[j].r) g[i].pb(j);
        }
    }
    fill(used, used + k, 0);
    for (int i = 0; i < k; ++i) {
        if (used[i] == 0) dfs(i);
    }
    if (1) {
        cout << "YES" << endl;
        return;
    }

}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}