#include <bits/stdc++.h>
#define pb push_back
#define int long long
#define endl "\n"
using namespace std;
typedef pair<int, int> pii;
const int maxk = 1e4 + 10;
bool ok = 1;

struct node {
    int l, m, r;
};



void solve() {
    ok = 1;
    int n, k;
    cin >> n >> k;
    vector<node> a;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; m--; r--;
        a.pb({l, m, r});
    }
    vector<pii> events;
    for (auto [l, m, r] : a) {
        events.pb({l, 0});
        events.pb({r, 2});
    }
    for (int i = 0; i < n; ++i) {
        events.pb({i, 1});
    }
    sort(events.begin(), events.end());
    int cnt = 0;

    for (auto [x, t] : events) {
        if (t == 0) {
            cnt++;
        } else if (t == 1) {
            if (cnt == 0) ok = 0;
        } else {
            cnt--;
        }
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    for (int i = 0; i < k; ++i) {
        for (int j = i + 1; j < k; ++j) {
            if (a[i].m >= a[j].l && a[i].m <= a[j].r && a[j].m >= a[i].l && a[j].m <= a[i].r) ok = 0;
        }
    }
    if (ok) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}