#include <bits/stdc++.h>

using namespace std;
using ll = __int128;
using ll_c = long long;

void my_cin(ll &x) {
    ll_c xc;
    cin >> xc;
    x = xc;
}

void my_cout(ll x) {
    ll_c xc = x;
    cout << xc;
}

void change_sum(ll &sum, ll &d1, ll &l, vector<ll> &x, ll &ind, ll d, ll t) {
    sum = sum - t + d * d * (x.size() - 1 - ind) + 2 * d * d1;
    d1 += (x.size() - 1 - ind) * d;
    l--;
    while (ind >= 0 && x[ind] >= l * d) {
        ll near = x[ind] % d, cur1 = near * near, cur2 = (d - near) * (d - near);
        if (cur1 > cur2) {
            sum -= cur2;
            sum += cur1;
        }
        d1 += near;
        --ind;
    }
}

void calc_one(vector<ll> &x, ll &l, ll &sum, ll &d1, ll &ind, ll d, ll t) {
    while (l > 0) {
        ll l1 = l, sum1 = sum, d11 = d1, ind1 = ind;
        change_sum(sum, d1, l, x, ind, d, t);
        if (sum > sum1) {
            l = l1;
            sum = sum1;
            d1 = d11;
            ind = ind1;
            break;
        }
    }
}

ll calc_sum_pos(vector<ll> &x, ll l, ll d, ll t) {
    ll ans = l * t;
    for (ll xi : x) {
        if (xi > l * d) {
            ans += (l * d - xi) + (l * d - xi);
        } else {
            ll near = xi % d;
            ans += min(near * near, (d - near) * (d - near));
        }
    }
    return ans;
}

void calc_all(vector<ll> &x, vector<pair<ll, ll>> t, ll d, vector<ll> &ans) {
    ll n = x.size(), m = t.size();
    ans.resize(m);
    if (n == 0) {
        for (ll i = 0; i < m; ++i) {
            ans[i] = 0;
        }
        return;
    }
    ll l = x.back() / d + 1, sum = calc_sum_pos(x, l, d, t[0].first), d1 = 0, ind = n - 1;
    calc_one(x, l, sum, d1, ind, d, t[0].first);
    ans[t[0].second] = sum;
    for (ll i = 1; i < m; ++i) {
        sum += l * (t[i].first - t[i - 1].first);
        calc_one(x, l, sum, d1, ind, d, t[i].first);
        ans[t[i].second] = sum;
    }
}

void solve() {
    ll n;
    my_cin(n);
    vector<ll> x(n);
    for (ll i = 0; i < n; ++i) {
        my_cin(x[i]);
    }
    ll x0, d;
    my_cin(x0);
    my_cin(d);
    ll m;
    my_cin(m);
    vector<pair<ll, ll>> t(m);
    for (ll i = 0; i < m; ++i) {
        my_cin(t[i].first);
        t[i].second = i;
    }

    vector<ll> left, right;
    for (ll i = 0; i < n; ++i) {
        if (x[i] > x0) {
            left.push_back(x[i] - x0);
        } else {
            right.push_back(x0 - x[i]);
        }
    }
    sort(left.begin(), left.end());
    sort(right.begin(), right.end());
    sort(t.begin(), t.end());

    vector<ll> ansl1, ansl2, ansr1, ansr2;
    calc_all(left, t, d, ansl1);
    calc_all(right, t, d, ansr1);
    for (ll i = 0; i < m; ++i) {
        t[i].first *= 2;
    }
    calc_all(left, t, d, ansl2);
    calc_all(right, t, d, ansr2);

    for (ll i = 0; i < m; ++i) {
        my_cout(min(ansl1[i] + ansr2[i], ansl2[i] + ansr1[i]));
        cout << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}