#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>

using namespace std;

// #define int long long

using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18;

struct el {
    int l, m, r;
    explicit el(int l_ = 0, int m_ = 0, int r_ = 0) {
        l = l_, m = m_, r = r_;
    }
};

void yes() {
    cout << "YES\n";
}

void no() {
    cout << "NO\n";
}

void solve() {
    int n, k; cin >> n >> k;
    vector<el> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--, a[i].m--;
    }
    if (1) {
        int bal = 0;
        vector<pii> act;
        int sum = 0;
        for (auto e : a) {
            act.emplace_back(e.l, -1);
            act.emplace_back(e.r, 1);
        }
        sort(act.begin(), act.end());
        int prev = -1;
        for (auto e : act) {
           // cout << e.first << " " << e.second << endl;
            if (prev != -1 && bal > 0) {
                sum += (e.first - prev);
            }
            bal -= e.second;
            prev = e.first;
        }
        if (sum < n) {
            no();
            return;
        }
    }
    vector<int> deg(k, 0);
    vector<bool> used(k, false);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (a[i].l <= a[j].m && a[j].m < a[i].r) {
                deg[j]++;
                // cout << i << " " << j << endl;
            }
        }
    }
    stack<int> st;
    for (int i = 0; i < k; i++) {
        if (deg[i] == 0) {
            st.push(i);
        }
    }
    while (!st.empty()) {
        auto id = st.top();
        st.pop();
        used[id] = true;
        for (int i = 0; i < k; i++) {
            if (a[id].l <= a[i].m && a[i].m < a[id].r) {
                deg[i]--;
                if (!used[i] && deg[i] == 0) {
                    st.push(i);
                    used[i] = true;
                }
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (!used[i]) {
            no();
            return;
        }
    }
    yes();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
