#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>

using namespace std;

using ll = __int128;

long long d;

ll div1 = 1;

ll get(ll p, ll b) {
	if (b > p) return (b - p) * (b - p);
	ll prev = b % (d / div1);
	prev = min(prev, (d / div1) - prev);
	return prev * prev;
}

struct state {
	ll cnt = 0;
	ll minall = 0;
	ll id = 0;
	ll sum = 0;

	state(ll cnt, ll minall, ll id, ll sum) : cnt(cnt), minall(minall), id(id), sum(sum) {}
};

vector<state> statesl, statesr;


ll get(vector<ll>& balls, ll t, vector<ll>& precalc, vector<state>& states) {
	if (balls.empty()) return 0;
	ll l = 0, r = balls.back() / d + 2;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		ll dd = precalc[m - 1] - precalc[m];
		if (dd >= t * div1) l = m;
		else r = m;
	}
	return precalc[l] + l * d * div1 * t;
	if (l > 0) l--;
	state s0 = states[l];
	ll sum = precalc[l];
	ll ans = -1;
	for (int i = 0; i < div1 * 2; i++) {
		ll lans = sum + t * (l * div1 + i);
		if (ans == -1 || lans < ans) ans = lans;
		while (s0.id < balls.size() && balls[s0.id] <= (i + l * div1) * (d / div1)) {
			sum -= (balls[s0.id] - s0.minall) * (balls[s0.id] - s0.minall);
			s0.cnt--;
			s0.sum -= (balls[s0.id] - s0.minall);

			sum += get((i + l * div1) * (d / div1), balls[s0.id]);

			s0.id++;
		}
		ll delta = ((d / div1) * (d / div1)) * s0.cnt - 2 * (d / div1) * s0.sum;

		s0.sum -= s0.cnt * (d / div1);
		s0.minall += (d / div1);

		sum += delta;
	}
	return ans;
}

vector<ll> precalc(vector<ll>& balls, vector<state>& states) {
	sort(balls.begin(), balls.end());
	ll s0 = 0;
	for (auto p : balls) s0 += p * p;
	vector<ll> ans(1, s0);
	ll sum = 0;
	for (auto p : balls) sum += p;
	ll cnt = balls.size();
	ll minall = 0;
	ll id = 0;
	states.push_back(state(cnt, minall, id, sum));
	for (int i = 1; cnt > 0; i++) {
		while (id < balls.size() && balls[id] <= i * d) {
			s0 -= (balls[id] - minall) * (balls[id] - minall);
			cnt--;
			sum -= (balls[id] - minall);

			s0 += get(i * d, balls[id]);

			id++;
		}
		ll delta = (d * d) * cnt - 2 * d * sum;

		sum -= cnt * d;
		minall += d;

		s0 += delta;
		ans.push_back(s0);
		states.push_back(state(cnt, minall, id, sum));
	}
	ans.push_back(ans.back());
	states.push_back(states.back());
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	long long n; cin >> n;
	vector<long long> vec(n);
	for (int i = 0; i < n; i++) cin >> vec[i];
	long long x; cin >> x >> d;

	d *= div1;

	vector<ll> left, right;
	for (auto p : vec) {
		if (p > x) right.push_back(p - x);
		if (p < x) left.push_back(x - p);
	}

	sort(left.begin(), left.end());
	sort(right.begin(), right.end());

	auto precalcL = precalc(left, statesl), precalcR = precalc(right, statesr);

	long long m; cin >> m;
	while (m--) {
		long long t; cin >> t;
		ll l1 = get(left, t, precalcL, statesl);
		ll l2 = get(left, t * 2, precalcL, statesl);
		ll r1 = get(right, t, precalcR, statesr);
		ll r2 = get(right, t * 2, precalcR, statesr);
		ll ans = min(
			l2 + r1,
			r2 + l1
		);
		cout << (long long)ans << endl;
	}
}