#pragma GNU optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define rs resize
#define pb push_back
#define pf push_front
#define inf 1'000'000'000'000
#define N 300'000

__int128 abs1(__int128 a){
    if(a < 0) return -a;
    return a;
}

int n, x[N], x0, d, pos;

struct ps{
    __int128 sum, res, c;
    int cnt;
    ps(__int128 sum, __int128 res, int cnt, int c): sum(sum), res(res), cnt(cnt), c(c){}

    void new_crd(int y){
        __int128 dif = abs1(c - y);
        res -= ((2 * sum - cnt) * dif - cnt * dif * (dif - 1));
        sum -= cnt * dif;
        c = y;
    }

    void del_pos(int u, __int128 nc){
        cnt--;
        res -= (c - x[u]) * (c - x[u]);
        res += min((c - x[u]) * (c - x[u]), (nc - x[u]) * (nc - x[u]));
        sum -= abs1(c - x[u]);
    }
};
vector<ps> lft, rt;


void built_left(){
    int u = pos, crd = x0;
    ps pr(0, 0, 0, x0);
    for(int i = 0; i <= pos; i++){
        if(x[i] == x0){
            u = i - 1;
            break;
        }
        pr.sum += x0 - x[i];
        pr.res += (x0 - x[i]) * (x0 - x[i]);
        pr.cnt++;
    }
    lft.pb(pr);
    while(u != -1){
        int nc = x[u] - (d + (x[u] - x0) % d) % d;
        pr.new_crd(nc + d);
        while(u != -1 && x[u] >= nc){
            pr.del_pos(u, nc);
            u--;
        }
        pr.new_crd(nc);
        lft.pb(pr);
    }
}

void built_right(){
    int u = pos + 1, crd = x0;
    ps pr(0, 0, 0, x0);
    for(int i = pos + 1; i < n; i++){
        pr.sum += abs(x0 - x[i]);
        pr.res += (x0 - x[i]) * (x0 - x[i]);
        pr.cnt++;
    }
    rt.pb(pr);
    while(u != n){
        int nc = x[u] + (d - (x[u] - x0) % d) % d;
        pr.new_crd(nc - d);
        while(u != n && x[u] <= nc){
            pr.del_pos(u, nc);
            u++;
        }
        pr.new_crd(nc);
        rt.pb(pr);
    }
}

int lf(int y){
    int l = 0, r = lft.size();
    while(r - l > 1){
        int m = (r + l) / 2;
        if(lft[m].c >= y) l = m;
        else r = m;
    }
    return l;
}

int rf(int y){
    int l = 0, r = rt.size();
    while(r - l > 1){
        int m = (r + l) / 2;
        if(rt[m].c <= y) l = m;
        else r = m;
    }
    return l;
}


__int128 bin_left(int t, int k){
    int l = -1, r = (x0 - lft[lft.size() - 1].c) / d + 10;
    __int128 res = lft[0].res;
//    cout << "F: " << (int)res << ' ';
//    for(int i = 0; i <= r; i++){
//        int nc = x0 - i * d;
//        ps p = lft[lf(nc)];
//        p.new_crd(nc);
//        res = min(res, p.res + t * i * k);
//        cout << (int)res << ' ';
//    }
//    cout << endl;
    while(r - l != 1){
        int m = (r + l) / 2;
        int nc = x0 - m * d;
        ps p1 = lft[lf(nc)], p2 = lft[lf(nc - d)];
        p1.new_crd(nc); p2.new_crd(nc + d);
        if(p1.res + t * m * k <= p2.res + t * (m + 1) * k){ r = m; res = min(res, p1.res + t * m * k); }
        else{ l = m; res = min(res, p2.res + t * (m + 1) * k); }
    }
    return res;
}

__int128 bin_right(__int128 t, int k){
    int l = -1, r = abs1(x0 - rt[rt.size() - 1].c) / d + 10;
    __int128 res = rt[0].res;
//    cout << "G: " << (int)res << ' ';
//    for(int i = 0; i <= r; i++){
//        int nc = x0 + i * d;
//        ps p = rt[rf(nc)];
//        p.new_crd(nc);
//        res = min(res, p.res + t * i * k);
//        cout << (int)res << ' ';
//    }
//    cout << endl;
    while(r - l != 1){
        int m = (r + l) / 2;
        int nc = x0 + m * d;
        ps p1 = rt[rf(nc)], p2 = rt[rf(nc + d)];
        p1.new_crd(nc); p2.new_crd(nc + d);
        if(p1.res + t * m * k <= p2.res + t * (m + 1) * k){ r = m; res = min(res, p1.res + t * m * k); }
        else{ l = m; res = min(res, p2.res + t * (m + 1) * k); }
    }
    return res;
}

void tup(){
    cin >> n;
    for(int i = 0; i < n; i++) cin >> x[i];
    sort(x, x + n);
    cin >> x0 >> d;
    int l = -1, r = n;
    while(r - l != 1){
        int m = (r + l) / 2;
        if(x[m] <= x0) l = m;
        else r = m;
    }
    pos = l;
    built_left();
    built_right();
//    cout << "D: ";
//    for(ps i: lft) cout << (int)i.sum << ' '<< i.cnt << ' ' << (int)i.res << ' ' << (int)i.c << endl;
//    for(ps i: rt) cout << (int)i.sum << ' '<< i.cnt << ' ' << (int)i.res << ' ' << (int)i.c << endl;


    int m; cin >> m;
//    cout << "W:" << endl;
    while(m--){
        int t; cin >> t;
        __int128 l1 = bin_left(t, 1),
            l2 = bin_left(t, 2),
            r1 = bin_right(t, 1),
            r2 = bin_right(t, 2);
        cout << (int)min(l1 + r2, l2 + r1) << '\n';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    tup();
}
