#include <bits/stdc++.h> 

using ll = long long;
using namespace std;

#define all(a) a.begin() a.end()

void solve();
void prec();

int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    solve();
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXtimeXXX: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}

void prec() {

}

void solve() {
    ll h, w;
    cin >> h >> w;
    vector<vector<ll>> a(h, vector<ll>(w));
    for(int i = 0; i < h; i++) {
        for(int j = 0; j < w; j++) {
            char ch;
            cin >> ch;
            a[i][j] = ch - '0';
        }
    }
    vector<vector<ll>> suf(h, vector<ll>(w, 0));
    for(int j = w - 1; j >= 0; j--) {
        for(int i = h - 1; i >= 0; i--) {
            if(j == w - 1) {
                if(a[i][j] == 1) {
                    suf[i][j] = 1;
                } else {
                    suf[i][j] = 0;
                }
            } else {
                if(a[i][j] == 1) {
                    suf[i][j] = suf[i][j + 1] + 1;
                } else {
                    suf[i][j] = 0;
                }
            }
        }
    }
    ll ans = 0;
    for(int j = 0; j < w; j++) {
        vector<ll> dp(h, 0);
        vector<pair<ll, ll>> last;
        last.push_back({0, -1});
        for(int i = 0; i < h; i++) {
            while(last.size() > 0 && last.back().first >= suf[i][j]) {
                last.pop_back();
            }
            last.push_back({suf[i][j], i});
            if(last.size() > 1) {
                if(last[last.size() - 2].second == -1) {
                    ans = max(ans, suf[i][j] * (i - last[last.size() - 2].second));
                    dp[i] = suf[i][j] * (i - last[last.size() - 2].second);
                } else {
                    ans = max(ans, dp[last[last.size() - 2].second] + suf[i][j] * (i - last[last.size() - 2].second));
                    dp[i] = dp[last[last.size() - 2].second] + suf[i][j] * (i - last[last.size() - 2].second);
                }
            }
        }
    }
    cout << ans;
}