#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

struct dsu {
    vector<int> p, h, r;
    int cnt;
    vector<pair<int&, int>> mem;
    dsu(int n) {
        p.assign(n, 0);
        r.assign(n, 0);
        iota(all(p), 0);
        iota(all(r), 0);
        h.assign(n, 1);
        cnt = n;
    }
    int find(int v) {
        return v == p[v] ? v : p[v] = find(p[v]);
    }
    void join(int v, int u) {
        v = find(v), u = find(u);
        if (v == u) {
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            return;
        }
        if (h[v] < h[u]) swap(v, u);
        // mem.emplace_back(p[u], p[u]);
        // mem.emplace_back(r[v], r[v]);
        // mem.emplace_back(h[v], h[v]);
        // mem.emplace_back(cnt, cnt);
        --cnt;
        p[u] = v;
        r[v] = max(r[v], r[u]);
        h[v] += (h[u] == h[v]);
    }
    void rev() {
        for (int i = 0; i < 4; ++i) {
            mem.back().first = mem.back().second;
            mem.pop_back();
        }
    }
};

struct seg {
    int l, m, r;
};
void solve() {
    int n, k;
    cin >> n >> k;
    const int MAXK = 10;
    // vector<bitset<MAXK>> g(k);
    vector<seg> a(k);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l, --m, --r;
    }
    vector<int> ord(k);
    iota(all(ord), 0);
    do {
        vector<int> used(n);
        dsu d(n);
        for (auto i : ord) {
            if (!used[a[i].m]) {
                used[a[i].m] = 1;
                for (int j = a[i].l; j < a[i].r;) {
                    used[j] = 1;
                    used[j + 1] = 1;
                    d.join(j, j + 1);
                    j = d.r[d.find(j)];
                }
                // for (int j = a[i].l; j <= a[i].r; ++j) {
                //     used[j] = 1;
                // }
            }
            //     used[a[i].m] = 1;
            //     for (int j = a[i].l; j < a[i].r;) {
            //         used[j] = 1;
            //         used[j + 1] = 1;
            //         d.join(j, j + 1);
            //         j = d.r[d.find(j)];
            //     }
            // }
        }
        int sum = 0;
        for (auto i : used) sum += i;
        if (d.cnt == 1) {
            cout << "YES\n";
            return;
        }
    }while (next_permutation(all(ord)));
    cout << "NO\n";

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}