#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<int> h(n);
    vector<vector<int>> cnt(2);
    auto dfs = [&](auto &&self, int v) ->void {
        cnt[h[v]].push_back(v);
        for (auto u : g[v]) {
            g[u].erase(find(all(g[u]), v));
            h[u] = h[v] ^ 1;
            self(self, u);
        }
    };
    dfs(dfs, 0);
    vector<pair<int, int>> ans;
    while (!cnt[0].empty() && !cnt[1].empty()) {
        ans.emplace_back(cnt[0].back() + 1, cnt[1].back() + 1);
        cnt[0].pop_back();
        cnt[1].pop_back();
    }
    cout << ans.size() << '\n';
    for (auto [i, j]  : ans) {
        cout << i << ' ' << j << '\n';
    }
    return 0;
}