#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (auto &v: a) {
        string x;
        cin >> x;
        for (int i = 0; i < m; ++i) {
            v[i] = x[i] - '0';
        }
    }

    vector<vector<int>> lng(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (j == m - 1) {
                lng[i][j] = a[i][j];
            } else if (a[i][j]) {
                lng[i][j] = 1 + lng[i][j+1];
            }
        }
    }

    vector<vector<int>> ls(n, vector<int>(m, -1));
    for (int j = 0; j < m; ++j) {
        stack<int> st;
        for (int i = 0; i < n; ++i) {
            while (len(st) && lng[st.top()][j] >= lng[i][j]) {
                st.pop();
            }
            if (len(st)) {
                ls[i][j] = st.top();
            }
            st.push(i);
        }
    }

    ll ans = -INF;
    vector<vector<ll>> dp(n, vector<ll>(m));
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            if (ls[i][j] == -1) {
                dp[i][j] = 1ll * (i + 1) * lng[i][j];
            } else {
                dp[i][j] = 1ll * lng[i][j] * (i - ls[i][j]) + dp[ls[i][j]][j];
            }
            ans = max(ans, dp[i][j]);
        }
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}