#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> l(k),r(k),m(k);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }

    vector<int> ord(k);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
       return r[i] < r[j];
    });

    vector<int> dp(n+1);
    dp[0] = 1;
    for (auto i: ord) {
        if (l[i] == 1) {
            // for (int x = l[i]; x <= r[i]; ++x) {
            //     dp[x] = 1;
            // }
            dp[r[i]] = 1;
        } else {
             for (int j = 0; j < k; ++j) {
                 if (r[j] >= l[i] - 1 && r[j] < m[i] && dp[r[j]] == 1) {
                     // for (int x = l[i]; x <= r[i]; ++x) {
                     //     dp[x] = 1;
                     // }
                     dp[r[i]] = 1;
                     break;
                 }
             }
        }
    }
    cout << (dp[n]? "YES": "NO") << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}