#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}



int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int h, w;
    cin >> h >> w;
    vector<vector<int>> nums(h, vector<int>(w));
    for (int i=0; i<h; i++) {
        string s; cin >> s;
        for (int j=0; j<w; j++) nums[i][j] = (s[j]-'0');
    }

    vector<vector<int>> hs(h, vector<int>(w));
    for (int i=0; i<h; i++) {
        for (int j=w-1; j>=0; j--) {
            if (nums[i][j]==0) hs[i][j] = 0;
            else {
                int x = (j+1<w ? hs[i][j+1] : 0);
                hs[i][j] = x + 1;
            }
        }
    }


    ll gol = 0;
    for (int j=0; j<w; j++) {
        vector<ll> vals(h);
        for (int i=0; i<h; i++) vals[i] = hs[i][j];

        vector<int> lefts(h, -1);
        vector<int> q;
        for (int i=0; i<h; i++) {
            while (sz(q) && vals[i]<=vals[q.back()]) q.pop_back();
            if (sz(q)) lefts[i] = q.back();
            q.push_back(i);
        }

        vector<ll> anses(h, 0);
        for (int i=0; i<h; i++) {
            if (vals[i]==0) anses[i] = 0;
            else {
                int pred = lefts[i];
                if (i==0) anses[i] = vals[i];
                else if (vals[i] < vals[i-1]) {
                    if (pred==-1 || vals[pred]==0) anses[i] = (i-(pred+1)+1) * vals[i];
                    else anses[i] = (i - (pred+1) + 1) * vals[i] + anses[pred];
                }
                else {
                    anses[i] = anses[i-1] + vals[i];
                }
            }
        }
        gol = max(gol, *max_element(anses.begin(), anses.end()));
    }

    cout << gol;


    return 0;
}