// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}

__int128 inf = 1;

ll nearest(ll st, ll x, ll d) {
    if (st==x) return x;
    if (st<x) {
        st = ((x-st)/d) * d + st;
        if (abs(x-st) > abs(x-(st+d))) st = st+d;
    }
    else {
        st = - ((st-x)/d) * d + st;
        if (abs(x-st) > abs(x-(st-d))) st = st-d;
    }
    return st;
}


ll from;
vector<ll> cords;
ll getotr(int l, int r, ll d, ll t) {
    ll asdf = 1e18;
    for (int x=from; x<=cords[r]; x+=d) {
        ll now = abs(x)/d * t;
        for (int i=l; i<=r; i++) now += (cords[i]-x)*(cords[i]-x);
        asdf = min(asdf, now);
    }
    return asdf;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    for (int i=0; i<36; i++) inf *= 10;

    int n;
    cin >> n;
    cords.resize(n);
    for (int i=0; i<n; i++) cin >> cords[i];
    sort(cords.begin(), cords.end());
    ll st, d;
    cin >> st >> d;
    for (int i=0; i<n; i++) cords[i] -= st;
    st = 0;
    from = nearest(0, cords.front(), d) - d;

    int q;
    cin >> q;
    while (q--) {
        ll t; cin >> t;

        vector<ll> dp(n, 1e18);
        for (int i=0; i<n; i++) {
            for (int j=-1; j<i; j++) {
                ll a = (j==-1 ? 0 : dp[j]);
                dp[i] = min(dp[i], a + getotr(j+1, i, d, t));
            }
        }

        cout << dp.back() << '\n';
    }


    return 0;
}