#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
    }

    sort(all(a), [&](const array<int, 3>& x, const array<int, 3>& y) {return x[2] < y[2];});

    vector<int> dp(k);
    bool ok = false;
    for (int i = 0; i < k; i++) {
        auto [l, m, r] = a[i];
        if (l == 1) {
            dp[i] = 1;
        } else {
            for (int j = 0; j < i; j++) {
                if (a[j][2] < a[i][0] - 1) continue;
                if (a[i][0] <= a[j][1] && a[j][1] <= a[i][2]) {
                    if (a[j][0] <= a[i][1] && a[i][1] <= a[j][2]) {
                        continue;
                    }
                }

                if (a[j][2] < a[i][2] && dp[j]) dp[i] = 1;
            }
        }

        if (dp[i] && r == n) ok = true;
    }

    cout << (ok ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}