#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9 + 10;

vector<vector<int>> g;

struct mmp {
    map<int, int> od, ev;

    int tadd = 0;

    void add(int e, int cnt) {
        if (e % 2) {
            od[e - tadd] += cnt;
        } else {
            ev[e - tadd] += cnt;
        }
    }

    void inc() {
        tadd++;
        od.swap(ev);
    }

    int gsz() {
        return (int) (od.size() + ev.size());
    }

    vector<array<int, 2>> gall() {
        vector<array<int, 2>> fin;
        for (auto [k, v] : od) {
            fin.push_back({k + tadd, v});
        }
        for (auto [k, v] : ev) {
            fin.push_back({k + tadd, v});
        }
        return fin;
    }
};

vector<mmp> mmps;
vector<int> mymp;

int ans = 0;

void dfs(int u, int p, int d) {
    vector<array<int, 2>> szs;
    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(v, u, d);
        mmps[mymp[v]].inc();
        szs.push_back({mmps[mymp[v]].gsz(), mymp[v]});
    }
    sort(szs.rbegin(), szs.rend());
    mymp[u] = u;
    if (!szs.empty()) {
        mymp[u] = szs[0][1];
    }
    mmps[mymp[u]].add(0, 1);
    for (int i = 1; i < (int)szs.size(); i++) {
        for (auto [k, v] : mmps[szs[i][1]].gall()) {
            mmps[mymp[u]].add(k, v);
        }
    }
    auto ito = mmps[mymp[u]].od.end();
    while (true) {
        if (ito == mmps[mymp[u]].od.begin()) break;
        ito--;
        auto [k, v] = *ito;
        int rk = k + mmps[mymp[u]].tadd;
        while (true) {
            auto nit = mmps[mymp[u]].ev.upper_bound(d - rk - mmps[mymp[u]].tadd);
            if (nit == mmps[mymp[u]].ev.begin() || v == 0) break;
            while (true) {
                if (nit == mmps[mymp[u]].ev.begin() || v == 0) break;
                nit--;
                auto [kn, vn] = *nit;
                int mn = min(v, vn);
                ans += mn;
                if (mn == vn) {
                    nit = mmps[mymp[u]].ev.erase(nit);
                } else {
                    mmps[mymp[u]].ev[kn] -= mn;
                }
                if (mn == v) {
                    ito = mmps[mymp[u]].od.erase(ito);
                    v = 0;
                } else {
                    mmps[mymp[u]].od[k] -= mn;
                    v -= mn;
                }
            }
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    mmps.resize(n);
    mymp.resize(n);
    dfs(0, 0, d);
    cout << ans << '\n';
    cout << -1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) solve();
}
