#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <random>

using namespace std;

mt19937 rnd(14);

typedef long long ll;

const ll inf = 1e18;

ll cmp(vector<ll> v1, vector<ll> v2) {
    return v1[1] < v2[1];
}

ll n, k;
vector<vector<ll>> v;
vector<ll> ind;
ll was1 = 0;

void f(ll i) {
    if (i == k) {
        vector<ll> ok(n + 1);
        for (int j = 0; j < ind.size(); j++) {
            ll pos = ind[j];
            for (int k = v[pos][0]; k <= v[pos][2]; k++) ok[k] = 1;
        }
        ll sum = 0;
        for (int j = 0; j < n + 1; j++) sum += ok[j];
        ll ok1 = 0;
        for (int j1 = 0; j1 < ind.size(); j1++) {
            ll l1 = v[ind[j1]][0], m1 = v[ind[j1]][1], r1 = v[ind[j1]][2];
            for (int j2 = 0; j2 < ind.size(); j2++) {
                ll l2 = v[ind[j2]][0], m2 = v[ind[j2]][1], r2 = v[ind[j2]][2];
                if (l1 <= l2) {
                    if (r1 >= r2) continue;
                } else {
                    continue;
                }
                if (m1 < l2 || m2 > r1) continue;
                ok1 = 1;
            }
        }
        if (sum == n && ok1 == 0) {
            was1 = 1;
        }
        return;
    }
    ind.push_back(i);
    f(i + 1);
    ind.pop_back();
    f(i + 1);
}

void solve() {
    // cin >> n >> k;
    n = rnd() % 3 + 1;
    k = rnd() % 3 + 1;
    v.assign(k, vector<ll>(3, 0));
    ind.clear();
    for (int i = 0; i < k; i++) {
        // for (int j = 0; j < 3; j++) {
        //     cin >> v[i][j];
        // }
        v[i][0] = rnd() % n + 1;
        v[i][2] = rnd() % n + 1;
        if (v[i][0] > v[i][2]) swap(v[i][0], v[i][2]);
        ll r1 = (v[i][2] - v[i][0] + 1);
        v[i][1] = v[i][0] + (rnd() % r1);
    }
    was1 = 0;
    f(0);
    sort(v.begin(), v.end(), cmp);
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1));
    for (int i = 0; i < k; i++) {
        ll l = v[i][0], m = v[i][1], r = v[i][2];
        for (int r_l = 0; r_l <= n; r_l++) {
            for (int m_l = 0; m_l <= n; m_l++) {
                if (dp[r_l][m_l] && r >= r_l && m > m_l && l <= r_l && (m > r_l || m_l < l)) dp[r][m] = 1;
            }
        }
        if (l == 1) dp[r][m] = 1;
    }
    ll ok = 0;
    for (int j1 = 0; j1 <= n; j1++) {
        for (int j2 = 0; j2 <= n; j2++) {
            if (dp[j1][j2] && j1 == n) ok = 1;
        }
    }
    if (was1 != ok) {
        cout << "WA\n";
        cout << n << " " << k << "\n";
        for (int i = 0; i < k; i++) {
            cout << v[i][0] << " " << v[i][1] << " " << v[i][2] << "\n";
        }
        exit(0);
    }
    // if (ok) {
    //     cout << "YES\n";
    // } else {
    //     cout << "NO\n";
    // }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 100000;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
