#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

void solve() {
    ll n, k; cin >> n >> k;
    vector<vector<ll>> v(k, vector<ll>(3));
    vector<vector<ll>> ind(n + 1);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < 3; j++) {
            cin >> v[i][j];
        }
        ind[v[i][1]].push_back(i);
    }
    sort(v.begin(), v.end());
    vector<ll> dp(k);
    for (int i = 0; i < k; i++) {
        ll l2 = v[i][0], m2 = v[i][1], r2 = v[i][2];
        if (l2 == 1) dp[i] = 1;
        for (int j = 0; j < i; j++) {
            ll l1 = v[j][0], m1 = v[j][1], r1 = v[j][2];
            if (m1 < l2 || m2 > r1) {
                if (dp[j] && r1 >= l2) dp[i] = 1;
            }
        }
    }
    ll ok = 0;
    for (int i = 0; i < k; i++) {
        if (v[i][2] == n & dp[i] == 1) ok = 1;
    }
    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    // vector<ll> dp(n + 1);
    // dp[0] = 1;
    // for (int i = 0; i <= n; i++) {
    //     for (int j = 0; j < ind[i].size(); j++) {
    //         ll pos = ind[i][j];
    //         ll l = v[pos][0], m = v[pos][1], r = v[pos][2];
    //         ll l1 = l - 1, r1 = m - 1;
    //         for (int k1 = l1; k1 <= r1; k1++) {
    //             if (dp[k1] == 1) {
    //                 dp[i] = 1;
    //             }
    //         }
    //     }
    // }
    // if (dp[n]) {
    //     cout << "YES\n";
    // } else {
    //     cout << "NO\n";
    // }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
