#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i8 = __int128;
using vi = vector<int>;
using vl = vector<ll>;
using v8 = vector<i8>;
using vc = vector<char>;
using vvi = vector<vi>;
using vvc = vector<vc>;
using pii = pair<int, int>;
constexpr char nl = '\n';

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);

    int n;
    cin >> n;
    vl x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int x0, d, m;
    cin >> x0 >> d >> m;

    sort(x.begin(), x.end());
    v8 dpl(n + 1), smr(n + 1), smr2(n + 1);
    for (int i = 0; i < n; ++i) {
        i8 z = (x[i] - x0) / d;
        i8 r1 = z * d + x0;
        i8 r2 = r1 + d;
        dpl[i + 1] = dpl[i] + min((r1 - x[i]) * (r1 - x[i]), (r2 - x[i]) * (r2 - x[i]));
    }
    for (int i = n - 1; i >= 0; --i) {
        smr[i] = smr[i + 1] + x[i];
        smr2[i] = smr2[i + 1] + x[i] * x[i];
    }

    vi t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    auto calc = [&](ll k, i8 ct) {
        i8 xz = k * d + x0;
        int j = upper_bound(x.begin(), x.end(), xz) - x.begin();
        i8 ans = ct * k + dpl[j] + smr2[j] + xz * xz * (n - j) - xz * 2 * smr[j];
        return ans;
    };
    for (int qi = 0; qi < m; ++qi) {
        i8 ct = t[qi];
        ll l = 0, r = 1e9 + 5;
        while (l != r) {
            ll k1 = l + (r - l) / 3;
            ll k2 = r - (r - l) / 3;
            if (calc(k1, ct) < calc(k2, ct)) {
                r = k2 - 1;
            } else {
                l = k1 + 1;
            }
        }
        cout << (ll) calc(l, ct) << nl;
    }
}
