#include <iostream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <iostream>
#include <vector>
#include <iostream>
#include <array>

using namespace std;

typedef long long ll;

void dfs(int v, int p, vector<int> &dist, vector<vector<int>> &g) {
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dist[u] = dist[v] + 1;
        dfs(u, v, dist, g);
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    bool subtask1 = (n <= 14);
    bool subtask3 = (d == 1);
    if (subtask1 && !subtask3) {
        vector<vector<int>> dist(n, vector<int> (n));
        for (int v = 0; v < n; ++v) {
            dfs(v, -1, dist[v], g);
        }
        vector<int> dp(1 << n, 0);
        vector<pair<int, int>> pst(1 << n, {-1, -1});
        int ans_mask = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int v = 0; v < n; ++v) {
                if ((mask >> v) & 1) {
                    continue;
                }
                for (int u = v + 1; u < n; ++u) {
                    if ((mask >> u) & 1) {
                        continue;
                    }
                    if (dist[v][u] % 2 == 1 && dist[v][u] <= d && dp[mask | (1 << u) | (1 << v)] < dp[mask] + 1) {
                        dp[mask | (1 << u) | (1 << v)] = dp[mask] + 1;
                        pst[mask | (1 << u) | (1 << v)] = {v, u};
                    }
                }
            }
            if (dp[ans_mask] < dp[mask]) {
                ans_mask = mask;
            }
        }
        cout << dp[ans_mask] << '\n';
        int mask = ans_mask;
        while (mask > 0) {
            auto [v, u] = pst[mask];
            cout << v + 1 << ' ' << u + 1 << '\n';
            mask ^= (1 << v) | (1 << u);
        }
    } else if (subtask3) {
        vector<vector<int>> dp(n, vector<int> (2)), pst(n, vector<int> (2, -1));
        auto calc = [&] (auto &&self, int v, int p = -1) -> void {
            for (auto u : g[v]) {
                if (u == p) {
                    continue;
                }
                self(self, u, v);
                dp[v][0] += max(dp[u][0], dp[u][1]);
            }
            for (int u : g[v]) {
                if (u == p) {
                    continue;
                }
                if (dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1 > dp[v][1]) {
                    pst[v][1] = u;
                    dp[v][1] = dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1;
                }
            }
        };
        calc(calc, 0);
        cout << max(dp[0][0], dp[0][1]) << '\n';
        auto ans = [&] (auto &self, int v, int type, int p) -> void {
            //cout << "! " << v << ' ' << type << endl;
            if (type && pst[v][1] != -1) {
                cout << v + 1 << ' ' << pst[v][1] + 1 << '\n';
                self(self, pst[v][1], 0, v);
            }
            for (int u : g[v]) {
                if (u == p || u == pst[v][type]) {
                    continue;
                }
                self(self, u, max(dp[u][0], dp[u][1]) == dp[u][1], v);
            }
        };
        ans(ans, 0, max(dp[0][0], dp[0][1]) == dp[0][1], -1);
    }
    return 0;
}
