#include<bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

__int128 get(vector<int> &a, vector<int> &pref, vector<pii> &suf, int x, int d, int t) {
    int l = upper_bound(all(a), x * d) - a.begin();
    int ans = (__int128) x * t + pref[l] - (__int128) 2 * suf[l].first * x * d + (__int128) suf[l].second + (__int128) (
                  x * x * d * d) * (a.size() - l);
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x: a) cin >> x;
    sort(all(a));
    int x0, d;
    cin >> x0 >> d;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i];
        int l = a[i] / d * d, r = (a[i] / d + 1) * d;
        int s = min((a[i] - l), r - a[i]);
        s = s * s;
        pref[i + 1] += s;
    }
    vector<pii> suf(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1];
        suf[i].first += a[i];
        suf[i].second += a[i] * a[i];
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        // for (int i = 0; i < 100; i++) {
        //     cout << get(a, pref, suf, i, d, t) << "\n";
        // }
        // continue;
        int l = 0, r = 1e9;
        while (r - l > 2) {
            int del = (r - l) / 3;
            int m1 = l + del, m2 = l + 2 * del;
            __int128 res1 = get(a, pref, suf, m1, d, t);
            __int128 res2 = get(a, pref, suf, m2, d, t);
            if (res1 > res2) l = m1;
            else r = m2;
        }

        __int128 ans = 7e18;
        for (; l <= r; l++) ans = min(ans, get(a, pref, suf, l, d, t));
        cout << (ll) ans << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
