#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int x0, d;
    cin >> x0 >> d;
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        auto f = [&](int k) {
            ll x = x0 + k * 1ll * d;
            return abs(k) * 1ll * t + (x - a[0]) * 1ll * (x - a[0]);
        };
        int l = -1e9 - 228, r = 1e9 + 228;
        while (r - l > 1) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (f(m1) < f(m2)) {
                l = m2;
            } else {
                r = m1;
            }
        }
        ll ans = infll;
        for (int k = l - 228; k <= r + 228; ++k) {
            ans = min(ans, f(k));
        }
        cout << ans << "\n";
    }
    return 0;
}