#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<int>> g;
vector<int> dp, par;

void dfs(int v, int p = -1) {
    par[v] = p;
    for (auto u : g[v]) {
        if (u != p) {
            dp[u] = dp[v] + 1;
            dfs(u, v);
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp.resize(n);
    par.resize(n);
    dfs(0);
    auto dist = [&](int u, int v) {
        int ans = inf;
        int w = u;
        while (w != -1) {
            ans = min(ans, dp[u] + dp[v] - 2 * dp[w]);
            w = par[w];
        }
        return ans;
    };
    vector<int> dp(1 << n);
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (((mask >> i) & 1) && ((mask >> j) & 1)) {
                    if (dist(i, j) % 2 == 1) {
                        dp[mask] = max(dp[mask], dp[mask ^ (1 << i) ^ (1 << j)] + 1);
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ans = max(ans, dp[mask]);
    }
    cout << ans << "\n";
    cout << -1 << "\n";
    return 0;
}