#include <iostream>
#include <vector>
#include <algorithm>
 
#define endl '\n'
#define int long long
using namespace std;
using ll = long long;
int n, m, k;
 
vector<int> a;
vector<int> pref, pref2;
int x0, d;
 
int get(int l, int r) {
    return pref[r] - pref[l] + a[l];
}
int get2(int l, int r) {
    return pref2[r] - pref2[l] + a[l] * a[l];
}
 
vector<int> pref3;
int get3(int l, int r) {
    if (r < l) return 0;
    if (l == 0) return pref3[r];
    return pref3[r] - pref3[l - 1];
}
 
int calc(int l, int r) {
    int l0 = lower_bound(a.begin(), a.end(), l) - a.begin() - 1;
    int r0 = upper_bound(a.begin(), a.end(), r) - a.begin();
    int ans = 0;
    if (l0 >= 0) {
        ans -= 2 * l * pref[l0];
        ans += (l0 + 1) * l * l;
        ans += pref2[l0];
    }
    if (r0 < n) {
        ans -= 2 * get(r0, n - 1) * r;
        ans += (n - r0) * r * r;
        ans += get2(r0, n - 1);
    }
    return ans + get3(l0 + 1, r0 - 1);
}





//#define LOCAL
void solve() {
    cin >> n;
    a.resize(n);
    for (auto &x: a) cin >> x;
    sort(a.begin(), a.end());


    cin >> x0 >> d;
    

    cin >> m;
    while (m--) {
        int t = 0;
        cin >> t;
        int ans = 1e18;
        
        long double D = (long double)(t + (x0 - a[0]) * 2 * d) / (long double)2 / (long double)d / (long double)d;
        D *= D;
        int xx = ((int)D) / d * d;
        for (int xy = xx - d; xy <= xx + d; xx += d) {
        ans = min(ans, (xy - x0) * (xy - x0) + abs(xy - x0) / d * t);
        }
        cout << ans << endl;
    }
 
}
 
signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}