#include <iostream>
#include <vector>
#include <algorithm>
 
#define endl '\n'
#define int long long
using namespace std;
using ll = long long;
int n, m, k;
 
vector<int> a;
vector<int> pref, pref2;
int x0, d;
 
int get(int l, int r) {
    return pref[r] - pref[l] + a[l];
}
int get2(int l, int r) {
    return pref2[r] - pref2[l] + a[l] * a[l];
}
 
vector<int> pref3;
int get3(int l, int r) {
    if (r < l) return 0;
    if (l == 0) return pref3[r];
    return pref3[r] - pref3[l - 1];
}
 
int calc(int l, int r) {
    int l0 = lower_bound(a.begin(), a.end(), l) - a.begin() - 1;
    int r0 = upper_bound(a.begin(), a.end(), r) - a.begin();
    int ans = 0;
    if (l0 >= 0) {
        ans -= 2 * l * pref[l0];
        ans += (l0 + 1) * l * l;
        ans += pref2[l0];
    }
    if (r0 < n) {
        ans -= 2 * get(r0, n - 1) * r;
        ans += (n - r0) * r * r;
        ans += get2(r0, n - 1);
    }
    return ans + get3(l0 + 1, r0 - 1);
}
//#define LOCAL
void solve() {
    cin >> n;
    a.resize(n);
    for (auto &x: a) cin >> x;
    sort(a.begin(), a.end());
    pref.resize(n);
    pref2.resize(n);
    for (int i = 0; i < n; i++) {
        pref[i] = a[i];
        pref2[i] = a[i] * a[i];
        if (i) pref[i] += pref[i - 1];
        if (i) pref2[i] += pref2[i - 1];
    }
    cin >> x0 >> d;
    pref3.resize(n);
    for (int i = 0; i < n; i++) {
        int dx = (a[i] / d) * d, dx2 = dx + d;
        pref3[i] = min((dx - a[i]) * (dx - a[i]), (dx2 - a[i]) * (dx2 - a[i]));
        if (i) pref3[i] += pref3[i - 1];
    }
 
    cin >> m;
    while (m--) {
        int t = 0;
        cin >> t;
        int l = 0, r = (d - 1 + a[n - 1]) / d, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            int c1 = calc(x0, x0 + d * mid) + mid * t,c2 = calc(x0, x0 + d * (mid + 1)) + (1 + mid) * t;
            if (c1 < c2) r = mid;
            else l = mid + 1;
        }
        cout << min(calc(x0, x0 + d * l) + l * t, calc(x0, x0 + d * r) + r * t) << endl;
    }
 
}
 
signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}