#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define ff first
#define ss second

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<vector<bool>> vec(n, vector<bool>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			vec[i][j] = (s[j] - '0');
		}
	}
	int ans = 0;

	vvi len(n + 1, vi(m + 1, 0));
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (i) {
				if (vec[i][j]) len[i][j] = len[i - 1][j] + 1;
			}
			else {
				len[i][j] = vec[i][j];
			}
		}
	}

	for (int i = 0; i < n; i++) {
		vi cr(m, m);
		vi st;
		for (int j = 0; j < m; j++) {
			while (st.size() && len[i][st.back()] >= len[i][j]) {
				cr[st.back()] = j;
				st.pop_back();
			}
			st.push_back(j);
		}
		vi dp(m + 1, 0);
		for (int j = m - 1; j > -1; j--) {
			int del = cr[j] - j;
			dp[j] = len[i][j] * del + dp[cr[j]];
			ans = max(ans, dp[j]);
		}
	}

	cout << ans;
}