#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
struct seg {
    int l, m, r;
};

char te[10000][10000];
bool visited[10000];
int n;
vector<int> ts;

void dfs(int v) {
    visited[v] = true;
    for (int j = 0; j < n; ++j) {
        if (te[v][j] && !visited[j]) {
            dfs(j);
        }
    }
    ts.push_back(v);
}


void solve() noexcept {
    int k;
    cin >> n >> k;
    swap(n, k);
    vector<seg> vs(n);
    for (int i = 0; i < vs.size(); ++i) cin >> vs[i].l >> vs[i].m >> vs[i].r, vs[i].l--, vs[i].m--, vs[i].r--;
    {
        auto ccm = vs;
        sort(all(ccm), [](auto a, auto b) {
           return a.l < b.l;
        });
        int cm = 0;
        for (auto [l, m, r] : ccm) {
            if (cm < l) {
                cout << "NO\n";
                return;
            }
            cm = max(r + 1, cm);
        }
        if (cm < k) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (vs[i].l == 0 && vs[i].r == k - 1) {
            cout << "YES\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            te[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if (vs[i].l <= vs[j].m && vs[i].r >= vs[j].m) {
                te[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) visited[i] = false;
    for (int i = 0; i < n; ++i) {
        if (!visited[i]) dfs(i);
    }
    reverse(all(ts));
    {
        vector<seg> ns(n);
        for (int i = 0; i < n; ++i) {
            ns[i] = vs[ts[i]];
        }
        swap(ns, vs);
    }
    mt19937 mt(1781283);
    for (int iter = 0; iter < 20; ++iter) {
        if (iter == 0) {
            ;
        } else if (iter == 1) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.l > b.l;
            });
        } else if (iter == 2) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.l < b.l;
            });
        } else if (iter == 3) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.r < b.r;
            });
        } else if (iter == 4) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.r > b.r;
            });
        } else if (iter == 5) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.m > b.m;
            });
        } else if (iter == 6) {
            sort(all(vs), [](auto& a, auto& b) {
               return a.m < b.m;
            });
        } else if (iter > 6) {
            shuffle(all(vs), mt);
        }
        set<int> act;
        for (int i = 0; i < k; ++i) act.insert(i);
        for (auto& [l, m, r] : vs) {
            if (act.find(m) != act.end()) {
                while (true) {
                    auto it = act.lower_bound(l);
                    if (it == act.end() || *it > r) break;
                    act.erase(it);
                }
            }
        }
        if (act.empty()) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

auto main() -> signed {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}