//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
#define int long long
vector<vector<int>> g;
vector<bool> isfirst;
vector<int> v1, v2;
void dfs(int v, int c, int p) {
    isfirst[v] = (c % 2) == 0;
    if (c == 0) v1.push_back(v);
    else v2.push_back(v);
    for (auto w : g[v]) {
        if (w == p) continue;
        dfs(w, c ^ 1, v);
    }
}

vector<vector<int>> newg;
vector<int> mt;
vector<int> ti;
int ct = 0;
bool kuhn(int v) {
    if (ti[v] == ct) return false;
    ti[v] = ct;
    for (auto w : newg[v]) {
        if (mt[w] == -1) {
            mt[w] = v;
            return true;
        }
    }
    for (auto w : newg[v]) {
        if (kuhn(mt[w])) {
            mt[w] = v;
            return true;
        }
    }
    return false;
}


auto main() -> signed {
    fastio;
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    isfirst.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, w;
        cin >> v >> w;
        v--, w--;
        g[v].push_back(w);
        g[w].push_back(v);
    }
    dfs(0, 0, -1);
    while (v1.size() > v2.size()) v1.pop_back();
    while (v2.size() > v1.size()) v2.pop_back();
    cout << v1.size() << '\n';
    for (int i = 0; i < n; ++i) {
        cout << v1[i] + 1 << ' ' << v2[i] + 1 << '\n';
    }
    exit(0);    
    newg.resize(n);
    vector<int> visited(n, -1);
    for (int i = 0; i < n; ++i) {
        if (!isfirst[i]) continue;
        queue<pair<int, int>> qr;
        qr.push({0, i});
        visited[i] = i;
        while (!qr.empty()) {
            auto [cd, v] = qr.front();
            qr.pop();
            if (cd % 2 == 1) newg[i].push_back(v);
            if (cd == d) continue;
            for (auto w : g[v]) {
                if (visited[w] != i) {
                    visited[w] = i;
                    qr.push({cd + 1, w});
                }
            }
        }
    }
    ti.resize(n, -1);
    mt.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (kuhn(i)) ct++;
    }
    vector<pair<int, int>> ans;
    for (int w = 0; w < n; ++w) {
        if (mt[w] != -1) {
            ans.push_back({w, mt[w]});
        }
    }
    cout << ans.size() << '\n';
    for (auto pr : ans) {
        cout << pr.first + 1 << ' ' << pr.second + 1 << '\n';
    }
}