#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll MAXN = (1 << 22);

void solve() {
	ll n, m, t;
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) cin >> x[i];
	ll x0, d;
	cin >> x0 >> d;
	cin >> m;
	ll time = abs(x0 - x[0]) / d;
	ll x1, x2, t1, t2;
	if (x0 < x[0]) {
		x1 = x0 + d * time;
		x2 = x0 + d * (time + 1);
	}
	else {
		x1 = x0 - d * time;
		x2 = x0 - d * (time + 1);
	}
	t1 = abs(x1 - x0) / d;
	t2 = abs(x2 - x0) / d;
	ll dist0 = (x0 - x[0]) * (x0 - x[0]);
	ll dist1 = (x1 - x[0]) * (x1 - x[0]), dist2 = (x2 - x[0]) * (x2 - x[0]);
	for (ll i = 0; i < m; i++) {
		cin >> t;
		cout << min(min(t1 * t + dist1, t2 * t + dist2), dist1) << '\n';
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}