#include <bits/stdc++.h>
using namespace std;
using ll = int;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll h, w;
    cin >> h >> w;

    vector<string> a(h);
    for (auto &u : a) {
        cin >> u;
    }

    vector<vector<ll>> cnt(h, vector<ll>(w, 0));
    vector<vector<ll>> pref(h, vector<ll>(w + 1, 0));
    for (ll i = 0; i < h; ++i) {
        for (ll j = 1; j <= w; ++j) {
            pref[i][j] = pref[i][j - 1] + (a[i][j - 1] == '1');
        }
    }
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            ll l = 0, r = w - j + 1;
            while (l + 1 < r) {
                ll m = (l + r) / 2;
                if (pref[i][j + m] - pref[i][j] == m) {
                    l = m;
                } else {
                    r = m;
                }
            }
            cnt[i][j] = l;
        }
    }

    ll ans = 0;
    for (ll j = 0; j < w; ++j) {
        ll k = 0, sum = 0;
        vector<pair<ll, ll>> st;
        st = { make_pair(0, k - 1) };
        for (ll i = 0; i < h; ++i) {
            if (cnt[i][j] == 0) {
                k = i + 1;
                st = { make_pair(0, k - 1) };
                continue;
            }
            while (cnt[i][j] <= st.back().first) {
                sum -= st.back().first * (st.back().second - st[st.size() - 2].second);
                st.pop_back();
            }
            st.emplace_back(cnt[i][j], i);
            sum += st.back().first * (st.back().second - st[st.size() - 2].second);
            ans = max(ans, sum);
        }
    }

    cout << ans << endl;
}