#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#pragma GCC target("avx2")
using namespace std;
using ll = int;

struct wk {
    ll l, r, m;
};

vector<vector<ll>> g;

vector<wk> a;


ll n, k;

vector<ll> color, used;

bool f = true;

void dfs(ll v, ll col) {
    if (used[v]) {
        return;
    }
    color[v] = col;
    used[v] = 1;
    for (auto &u : g[v]) {
        if (!used[u]) {
            dfs(u, (col + 1) % 2);
        } else {
            if (color[u] == color[v]) {
                f = false;
            }
        }
    }
}

void solve() {
    cin >> n >> k;

    g.assign(k + n + 1, {});
    color.assign(k + n + 1, 0);
    used.assign(k + n + 1, 0);
    a.resize(k);
    f = true;

    for (auto &u : a) {
        cin >> u.l >> u.m >> u.r;
    }

    for (ll i = 0; i < k; ++i) {
        for (ll j = i + 1; j < k; ++j) {
            if (a[i].m >= a[j].l && a[i].m <= a[j].r && a[j].m >= a[i].l && a[j].m <= a[i].r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (ll i = 1; i <= n; ++i) {
        for (ll j = 0; j < k; ++j) {
            if (a[j].l <= i && a[j].r >= i) {
                g[i + k - 1].push_back(j);
                g[j].push_back(i + k - 1);
            }
        }
    }
    dfs(0, 0);

    if (!f) {
        cout << "NO" << '\n';
    } else {
        cout << "YES" << '\n';
    }


}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}