#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#pragma GCC target("avx2")
using namespace std;
using ll = int;

struct wk {
    ll l, r, m;
};

vector<vector<ll>> g;

vector<wk> a;

vector<bool> used;

ll n, k;

bool dfs(ll r) {
    if (r == n) {
        return true;
    }
    ll ind = -1;
    for (ll i = 0; i < k; ++i) {
        if (used[i]) {
            continue;
        }
        bool f = true;
        for (auto &e : g[i]) {
            if (used[e]) {
                f = false;
                break;
            }
        }
        if (f && r + 1 >= a[i].l && a[i].r > r) {
            if (ind == -1 || a[i].r > a[ind].r) {
                ind = i;
            }
        }
    }
    if (ind != -1) {
        used[ind] = true;
        if (dfs(a[ind].r)) {
            return true;
        }
        used[ind] = false;
    }
    return false;
}

void solve() {
    cin >> n >> k;

    g.assign(k + 1, {});
    a.resize(k);
    used.assign(k + 1, 0);

    for (auto &u : a) {
        cin >> u.l >> u.m >> u.r;
    }

    for (ll i = 0; i < k; ++i) {
        for (ll j = i + 1; j < k; ++j) {
            if (a[i].m >= a[j].l && a[i].m <= a[j].r && a[j].m >= a[i].l && a[j].m <= a[i].r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    if (dfs(0)) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}