#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct Node {
    int l;
    int m;
    int r;
};

bool comp(Node a, Node b) {
    return a.l < b.l;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <Node> v(k);
    for (auto& [l, m, r] : v) cin >> l >> m >> r;
    sort(all(v), comp);
    int r = 0;
    for (int i = 0; i < k; ++i) {
        if (v[i].l - 1 > r) {
            cout << "NO\n";
            return;
        }
        r = max(r, v[i].r);
    }
    vector <vector <int>> g(k);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < i; ++j) {
            if (v[j].l <= v[i].m && v[i].m <= v[j].r) {
                g[i].push_back(j);
            }
            if (v[i].l <= v[j].m && v[j].m <= v[i].r) {
                g[j].push_back(i);
            }
        }
    }
    int mn = n, mx = 0;
    for (int i = 0; i < k; ++i) {
        mn = min(mn, v[i].l);
        mx = max(mx, v[i].r);
    }

    bool ok = 1;
    vector <int> used(k);
    auto dfs = [&](auto self, int v)->void {
        used[v] = 1;
        for (auto el : g[v]) {
            if (used[el] == 1) {
                ok = 0;
                return;
            }
            if (used[el] == 2) continue;
            self(self, el);
        }
        used[v] = 2;
    };
    for (int i = 0; i < k; ++i) if (!used[i]) dfs(dfs, i);

    cout << (ok? "YES\n" : "NO\n");
}

int main() {
    int tt = 1;
    cin >> tt;

    while (tt--) solve();
    return 0;
}