#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct Node {
    int l;
    int m;
    int r;
};

bool comp(Node a, Node b) {
    return a.r - a.l < b.r - b.l;
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector <Node> v(k);
    for (auto& [l, m, r] : v) cin >> l >> m >> r;

    // vector <vector <int>> pref_can(n + 1);
    // for (int i = 0; i <= n; ++i) pref_can.resize(i);
    // vector <vector <int>> suf_can(n + 1);
    // for (int i = 0; i <= n; ++i) suf_can.resize(i);
    set <pair <int, int>> st;
    for (auto [l, m, r] : v) st.insert({l, r});
    for (int c = 2; c <= k; ++c) {
        set <pair <int, int>> nw;
        for (int i = 0; i < k; ++i) {
            for (auto [l, r] : st) {
                if (!(r + 1 < v[i].l || v[i].r < l - 1)) {
                    if (l <= v[i].m && v[i].m <= r) nw.insert({l, r});
                    else nw.insert({min(l, v[i].l), max(r, v[i].r)});
                }
            }
        }
        st = nw;
    }

    for (auto [l, r] : st) {
        if (l == 1 && r == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    int tt = 1;
    cin >> tt;

    while (tt--) solve();
    return 0;
}
