#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<vector<int>> g;
vector<vector<int>> dist;
int A = 0, B = 0;
vector<int> av;
vector<int> bv;

void dfs(int v, int p, int d, int r) {
    dist[r][v] = d;
    for (int u : g[v]) {
        if (u == p) continue;
        dfs(u, v, d + 1, r);
    }
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    dist.assign(n, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, -1, 0, i);
    }
    int max_cnt = 0;
    vector<pair<int, int>> max_res;
    int mx = (1 << n);
    for (int mask = 1; mask < mx; ++mask) {
        int tm = mask;
        A = 0; B = 0;
        av.clear();
        bv.clear();
        for (int i = 0; i < n; ++i) {
            if (tm & 1) {
                A++; av.push_back(i);
            }
            else { B++; bv.push_back(i); }
            tm >>= 1;
        }
        int k = 0;
        vector<pair<int, int>> cur_res;
        bool ch = false;
        vector<bool> used(n, false);
        while (k < min(A, B)) {
            ch = false;
            for (int i = 0; i < A; ++i) {
                if (used[av[i]]) continue;
                for (int j = 0; j < B; ++j) {
                    if (used[bv[j]]) continue;
                    int a = av[i], b = bv[j];
                    if (dist[a][b] <= d) {
                        k++;
                        cur_res.push_back({a, b});
                        used[a] = true;
                        used[b] = true;
                        ch = true;
                        break;
                    }
                }
                if (ch) break;
            }
            if (!ch) break;
        }
        if (k > max_cnt) {
            max_cnt = k;
            max_res = cur_res;
        }
    }
    cout << max_cnt << "\n";
    for (auto p : max_res) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
}
 
int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}