//#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
 
using namespace std;
 
const int maxn = 5e5 + 5;

vector<int> g[maxn];
vector<multiset<int>> dt[maxn];
int ans = 0;
int al = 0;

int gtMxUnd(multiset<int>& a, int mx) {
    auto it = a.upper_bound(mx);
    if(it == a.begin())
        return -1;
    return *(--it);
}

void dfs(int u, int p, int d = 0) {
    dt[u].resize(2);
    dt[u][d%2].insert(d);
    for(auto v : g[u]) {
        if(v != p) {
            dfs(v, u, d + 1);
            for(auto wh : dt[v][0])
                dt[u][0].insert(wh);
            for(auto bl : dt[v][1])
                dt[u][1].insert(bl);
            dt[v].clear();
        }
    }
    while(!dt[u][0].empty() && *(--dt[u][0].end()) > al + d) dt[u][0].erase(--dt[u][0].end());
    while(!dt[u][1].empty() && *(--dt[u][1].end()) > al + d) dt[u][1].erase(--dt[u][1].end());
    while(!dt[u][0].empty() && !dt[u][1].empty() && (*dt[u][0].begin()) + (*dt[u][1].begin()) <= al) {
        int whmn = *dt[u][0].begin();
        int blmn = *dt[u][1].begin();
        int mxBlAl = gtMxUnd(dt[u][1], 2*d + al - whmn);
        int mxWhAl = gtMxUnd(dt[u][0], 2*d + al - blmn);
        int blMX = -1;
        int whMX = -1;
        int ansW = -1, ansB = -1;
        if(mxBlAl != -1) {
            whMX = gtMxUnd(dt[u][0], 2*d + al - mxBlAl);
            ansW = whMX + mxBlAl;
        }
        if(mxWhAl != -1) {
            blMX = gtMxUnd(dt[u][1], 2*d + al - mxWhAl);
            ansB = blMX + mxWhAl;
        }
        if(ansW == -1 && ansB == -1)
            break;
        
        if(ansW < ansB) {
            dt[u][1].erase(dt[u][1].find(blMX));
            dt[u][0].erase(dt[u][0].find(mxWhAl));
            ++ans;
        } else {
            dt[u][1].erase(dt[u][1].find(mxBlAl));
            dt[u][0].erase(dt[u][0].find(whMX));
            ++ans;
        }
    }
}

void solve() {
    int n;
    cin >> n >> al;
    for(int i = 1; i<n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0, 0);
    cout << ans << '\n' << -1 << '\n';
}
 
signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}