#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pll pair<ll, ll>

struct rb {
    ll l, r, m;
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<rb> a(k);
    vector<int> used(n + 2);
    vector<vector<int>> g(n + 2);
    for (auto &[l, r, m] : a) {
        cin >> l >> m >> r;
        g[l].push_back(r);
    }
    queue<ll> q;
    q.push(1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto now : g[v]) {
            if (used[now]) continue;
            used[now] = 1;
            q.push(now + 1);
        }
    }
    if (used[n]) {
        cout << "YES\n";
    } else cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
