#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using i128 = __int128;

#define pll pair<ll, ll>
#define all(vec) vec.begin(), vec.end()

vector<vector<ll>> g;
vector<ll> used;

vector<ll> f;
vector<ll> s;

void dfs(int v, int num) {
    used[v] = 1;
    if (num == 0) f.push_back(v);
    else s.push_back(v);
    for (auto now : g[v]) {
        if (!used[now]) {
            dfs(now, (num + 1) % 2);
        }
    }
}

void solve() {
    ll n, d;
    cin >> n >> d;
    g.resize(n + 1);
    used.resize(n + 1);
    for (ll i = 1; i <= n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0);

    vector<pll> ans;

    while (!f.empty() && !s.empty()) {
        ans.push_back({f.back(), s.back()});
        f.pop_back();
        s.pop_back();
    }

    cout << ans.size() << "\n";

    for (auto [ff, ss] : ans) cout << ff << " " << ss << "\n";

}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
