#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define forn(i, n) for(decltype(n) i= 0; i < n; i++)
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<ll> target(n);
    forn(i, n) cin >> target[i];
    sort(all(target));

    vector<ll> p(n + 1);
    vector<__int128> p2(n + 1);
    forn(i, n) p[i + 1] = p[i] + target[i], p2[i + 1] = p2[i] + 1ll * target[i] * target[i];

    auto get = [&](__int128 l, __int128 r, __int128 x1) -> __int128 {
        return (r - l + 1) * x1 * x1 - 2 * x1 * (p[r + 1] - p[l]) + p2[r + 1] - p2[l];
    };

    ll x0, d;
    cin >> x0 >> d;

    vector<ll> best_p(n);
    forn(i, n) {
        best_p[i] = (target[i] - x0) / d * d;
        if (abs(best_p[i] - target[i]) > abs(best_p[i] - d - target[i])) best_p[i] -= d;
        if (abs(best_p[i] - target[i]) > abs(best_p[i] + d - target[i])) best_p[i] += d;
    }

    vector<__int128> pref_best(n + 1);
    forn(i, n) pref_best[i + 1] = pref_best[i] + 1ll * (target[i] - best_p[i]) * (target[i] - best_p[i]);

    int m;
    cin >> m;
    vector<pair<int, int>> q(m);
    forn(i, m) cin >> q[i].first, q[i].second = i;
    sort(rall(q));

    vector<ll> ans(m);

    for (auto &[t, id]: q) {
        ll l = -1, r = 1e9;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            int tid1 = upper_bound(all(best_p), mid * d) - best_p.begin();
            int tid2 = upper_bound(all(best_p), (mid + 1) * d) - best_p.begin();
            if (t * mid + pref_best[tid1] + get(tid1, n - 1, x0 + mid * d) > t * (mid + 1) + pref_best[tid2] + get(tid2, n - 1, x0 + (mid + 1) * d)) {
                l = mid;
            }  else {
                r = mid;
            }
        }
        int tid = upper_bound(all(best_p), x0 + r * d) - best_p.begin();
        ans[id] = t * r + pref_best[tid] + get(tid, n - 1, x0 + r * d);
    }
    forn(i, m) cout << ans[i] << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:/work/IO/in.txt", "r", stdin);
    freopen("C:/work/IO/out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}
