#include <iostream>
#include <vector>
#include <algorithm>
#include <array>

using namespace std;
using ll = long long;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int, 3>> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i][0] >> a[i][2] >> a[i][1];
	}
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		p[i] = i;
	}
	do {
		vector<int> ok(n + 1, false);
		for (int i = 0; i < k; i++) {
			int l = a[p[i]][0];
			int r = a[p[i]][1];
			int m = a[p[i]][2];
			if (!ok[m]) {
				for (int j = l; j <= r; j++) {
					ok[j] = true;
				}
			}
		}
		bool fl = true;
		for (int j = 1; j <= n; j++) {
			if (!ok[j]) {
				fl = false;
			}
		}
		if (fl) {
			cout << "YES";
			return;
		}
	} while(next_permutation(p.begin(), p.end()));
	cout << "NO";
}

int main() {
	fastw();
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}