#include <bits/stdc++.h>
#define int long long
#define F first
#define S second
using namespace std;

struct seg {
    int l, m, r;

    void in() {
        cin >> l >> m >> r;
        l--;
        r--;
        m--;
    }
};

bool cmp(seg a, seg b) {
    if (a.r == b.r) {
        return a.l < b.l;
    }
    return a.r > b.r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _;
    cin >> _;
    while (_--) {
        int n, k;
        cin >> n >> k;
        vector<seg> a(k);
        for (int i = 0; i < k; ++i) {
            a[i].in();
        }
        sort(a.begin(), a.end(), cmp);
        int last = n - 1;
        bool bad = 0;
        for (int i = 0; i < n && last >= 0; ++i) {
            if (a[i].r < last) {
                bad = 1;
                break;
            }
            if (a[i].l > last) {
                continue;
            }
            last = a[i].l - 1;
        }
        if (bad || last != -1) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
        }
    }
    return 0;
}
