#include <bits/stdc++.h>
#define int long long
#define F first
#define S second
using namespace std;

struct seg {
    int l, m, r;

    void in() {
        cin >> l >> m >> r;
        l--;
        r--;
        m--;
    }
};

bool cmp(seg a, seg b) {
    if (a.r == b.r) {
        return a.l < b.l;
    }
    return a.r > b.r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _;
    cin >> _;
    while (_--) {
        int n, k;
        cin >> n >> k;
        vector<seg> a(k);
        bool e = 0;
        for (int i = 0; i < k; ++i) {
            a[i].in();
            if (a[i].l == 0 && a[i].r == n - 1) {
                e = 1;
            }
        }
        if (e) {
            cout << "YES\n";
            continue;
        }
        vector<pair<int,int> > beg, end;
        for (int i = 0; i < k; ++i) {
            if (a[i].l == 0) {
                beg.push_back({a[i].r, a[i].m});
            } else {
                end.push_back({a[i].l, a[i].m});
            }
        }
        vector<int> cnt(n + 1);
        for (auto [l,m]: end) {
            cnt[l]++;
        }
        for (int i = 1; i < n + 1; ++i) {
            cnt[i] += cnt[i - 1];
        }
        for (auto [r,m]: beg) {
            int c = cnt[r + 1] - cnt[m];
            if (c) {
                e = 1;
                break;
            }
        }
        cnt.assign(n + 1, 0);
        for (auto [r,m]: beg) {
            cnt[r]++;
        }
        for (int i = 1; i < n + 1; ++i) {
            cnt[i] += cnt[i - 1];
        }
        for (auto [l,m]: end) {
            int c = cnt[m - 1];
            if (l >= 2) {
                c -= cnt[l - 2];
            }
            if (c) {
                e = 1;
                break;
            }
        }
        if (e) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
