#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int INF = 9e18;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << "\n";
    }
    return out;
}


void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    cin >> x;
    sort(all(x));

    int x0, d;
    cin >> x0 >> d;

    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        int ans = INF;

        for (int k1 = 0; ; ++k1) {
            if (k1 * d > 50) {
                break;
            }
            for (int k2 = 0; ; ++k2) {
                if (k2 * d > 50) {
                    break;
                }
                vector<int> mn_res(n, INF);
                for (int i = x0 - k1 * d; i <= x0 + k2 * d; i += d) {
                    for (int j = 0; j < n; ++j) {
                        mn_res[j] = min(mn_res[j], (i - x[j]) * (i - x[j]));
                    }
                }
                int res = (k1 + k2 + min(k1, k2)) * t;
                for (int i : mn_res) {
                    res += i;
                }
                //cout << k1 << " " << k2 << " " << res << "\n";
                ans = min(ans, res);
            }
        }
        cout << ans << "\n";
    }
    //
    // int ans = 0;
    // for (int i = 0; i < n; ++i) {
    //     int k = (x[i] - x0) / d;
    //     ans += min(min((x[i] - k * d - x0) * (x[i] - k * d - x0), (x[i] - (k - 1) * d - x0) * (x[i] - (k - 1) * d - x0)),
    //         (x[i] - (k + 1) * d - x0) * (x[i] - (k + 1) * d - x0));
    //     //cout << k * d + x0 << " ";
    // }
}

/*
3
4 0 7
2 3
7
0
1
2
3
4
23
25

3
4 0 7
2 3
1 1


3
7
10
12
13
32
33
4
30 239 57 179
0 7
5
1
10
15
100
100000
49
355
525
3378
93311
4
100 2 101 666
9 10
5
777
1
2
15
10
49597
91
159
1043
703
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}