#include <iostream>
#include <vector>
#include <algorithm>
#include<cmath>
#include<string>
#include<iomanip>

using namespace std;
int max(int &a, int &b) {
    if (a > b) {
        return a;
    }
    return b;
}

signed main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char c;
            cin >> c;
            a[i][j] = (c - '0');
        }
    }
    vector<vector<int>> max_linde_start_from(h, vector<int>(w, 0));
    for (int i = 0; i < h; ++i) {
        for (int j = w - 1; j >= 0; --j) {
            if (j == w - 1 && a[i][j] == 1) {
                max_linde_start_from[i][j] = 1;
            }
            else if (j != w - 1) {
                if (a[i][j] == 1) {
                    max_linde_start_from[i][j] = max_linde_start_from[i][j + 1] + 1;
                }
                else {
                    max_linde_start_from[i][j] = 0;
                }
            }
        }
    }
    int best = 0;
    vector<pair<int, int>> stacky;
    for (int j = 0; j < w; ++j) {
        int cur = 0;
        int cur_len = 0;
        stacky.clear();
        for (int i = 0; i < h; ++i) {
            if (max_linde_start_from[i][j] >= cur_len) {
                cur += max_linde_start_from[i][j];
                cur_len = max_linde_start_from[i][j];
                stacky.emplace_back(max_linde_start_from[i][j], 1);
                // change(1, 0, w + 1, max_linde_start_from[i][j], 1);
            }
            else {
                int new_= max_linde_start_from[i][j];
                int x = 0;
                while (!(stacky.empty()) && stacky.back().first > new_) {
                    x += stacky.back().second;
                    cur -= stacky.back().first * stacky.back().second;
                    stacky.pop_back();
                }
                cur += (x + 1) * new_;
                stacky.emplace_back(new_, x + 1);
                cur_len = new_;
            }
            best = max(cur, best);
        }
        best = max(cur, best);
    }
    cout << best;
}