#include <iostream>
#include <vector>
#include <queue>

using namespace std;

#define int long long

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> A(n + 2, vector<int>(m + 2));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x;
            cin >> x;
            if (x == '1') {
                A[i + 1][j + 1] = 1;
            }
        }
    }
    vector<vector<int>> nxt(n + 2, vector<int>(m + 2));
    for (int i = 0; i < n + 2; i++) {
        int st = m + 1;
        for (int j = m + 1; j >= 0; j--) {
            if (A[i][j] == 0) {
                st = j;
            }
            nxt[i][j] = st - j;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (A[i][j] == 1) {
                int cur = nxt[i][j];
                queue<pair<int, int>> q;
                q.push({nxt[i][j], i});
                ans = max(ans, cur);
                for (int k = i + 1; k <= n; k++) {
                    if (nxt[k][j] == 0) {
                        break;
                    }
                    int pr = k;
                    while (!q.empty() and q.back().first >= nxt[k][j]) {
                        cur -= (pr - q.back().second) * q.back().first;
                        pr = q.back().second;
                        q.pop();
                    }
                    cur += (k - pr + 1) * nxt[k][j];
                    ans = max(ans, cur);
                    q.push({nxt[k][j], pr});
                }
            }
        }
    }
    cout << ans;
}