#pragma GCC optmize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    multiset<vector<int>> A;
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        A.insert({l, m, r});
    }
    vector<int> dp(n + 2, 1e9);
    dp[1] = 0;
    for (int i = 1; i <= n; i++) {
        if (dp[i] < i) {
            auto it = A.begin();
            while(it != A.end()){
                auto elem = *it;
                if (elem[0] > i) {
                    break;
                }
                if (elem[0] > dp[i] and elem[2] >= i and elem[0] <= i) {
                    dp[elem[2] + 1] = min(dp[elem[2] + 1], elem[1]);
                    auto it1 = it;
                    it++;
                    A.erase(it1);
                }else if (elem[1] >= i and elem[0] <= i) {
                    dp[elem[2] + 1] = min(dp[elem[2] + 1], elem[1]);
                    auto it1 = it;
                    it++;
                    A.erase(it1);
                }else {
                    it++;
                }
            }
        }
    }
    if (dp[n + 1] == 1e9) {
        cout << "NO\n";
    }else {
        cout << "YES\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}