#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>

using namespace std;

#define ll __int128
#define int long long

int st, d, n;
vector<int> A, summ, func;
vector<ll> sq;

ll check(int c, int step) {
    if (step < 0) {
        return 1e36;
    }
    int ind = lower_bound(A.begin(), A.end(), d * step) - A.begin();
    ll ans = 0, x = d * step;
    ans += func[ind];
    ans += sq[n] - sq[ind];
    ans -= 2 * (summ[n] - summ[ind]) * x;
    ans += x * x * (n - ind);
    return ans + step * c;
}

signed main() {
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    sort(A.begin(), A.end());
    func.resize(n + 1);
    summ.resize(n + 1);
    sq.resize(n + 1);
    cin >> st >> d;
    for (int i = 0; i < n; i++) {
        int t =  min(A[i] % d, d - A[i] % d);
        func[i + 1] = func[i] + t * t;
        summ[i + 1] = summ[i] + A[i];
        sq[i + 1] = sq[i] + A[i] * A[i];
    }
    int max_coord = *max_element(A.begin(), A.end());
    int m;
    cin >> m;
    for (int _ = 0; _ < m; _++) {
        int c;
        cin >> c;
        int l = 0, r = max_coord / d + 2;
        while (r - l > 1) {
            int m1 = l + (r - l + 1) / 3, m2 = r - (r - l + 1) / 3;
            if (check(c, m1) < check(c, m2)) {
                r = m2;
            }else {
                l = m1;
            }
        }
        cout << (int)min({check(c, l), check(c, l - 1), check(c,  r), check(c, r + 1)}) << '\n';
    }
}