#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <unordered_set>

using namespace std;

vector<pair<int, int>> temp;
vector<pair<vector<int>, vector<int>>> val;

void dfs(int v, int p, int dep, vector<vector<int>>& gr) {
    if (dep % 2 == 1) {
        val[v].first.push_back(v);
    }
    else {
        val[v].second.push_back(v);
    }
    for (int u : gr[v]) {
        if (u != p) {
            dfs(u, v, dep + 1, gr);
            if (val[v].first < val[u].first) {
                swap(val[v].first, val[u].first);
            }
            if (val[v].second < val[u].second) {
                swap(val[v].second, val[u].second);
            }
            for (int elem: val[u].first) {
                val[v].first.push_back(elem);
            }
            for (int elem: val[u].second) {
                val[v].second.push_back(elem);
            }
        }
    }
    while (not val[v].first.empty() and not val[v].second.empty()) {
        temp.push_back({val[v].first.back(), val[v].second.back()});
        val[v].first.pop_back();
        val[v].second.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, d;
    cin >> n >> d;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    val.resize(n);
    dfs(0, -1, 0, gr);
    cout << temp.size() << '\n';
    for (auto e: temp) {
        cout <<e.first + 1 << ' ' << e.second + 1 << '\n';
    }
}