#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <unordered_set>

using namespace std;

int cnt = 0;

pair<int, int> dfs(int v, int p, int dep, vector<vector<int>>& gr) {
    pair<int, int> ans;
    if (dep % 2 == 1) {
        ans.first++;
    }
    else {
        ans.second++;
    }
    for (int u : gr[v]) {
        if (u != p) {
            auto t = dfs(u, v, dep + 1, gr);
            ans.first += t.first;
            ans.second += t.second;
        }
    }
    int sd = min(ans.first, ans.second);
    ans.first -= sd;
    ans.second -= sd;
    cnt += sd;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, d;
    cin >> n >> d;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    dfs(0, -1, 0, gr);
    cout << cnt << '\n';
}