#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);



	int n, m;
	cin >> n >> m;
	bool swapped = 0;
	if (m > n) {
		swapped = 1;
		swap(n, m);
	}
	
	vector <vector <bool>> a(n, vector <bool>(m));
	if (swapped) {
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				char x;
				cin >> x;
				a[n - 1 - j][m - 1 - i] = x == '1';
			}
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				char x;
				cin >> x;
				a[i][j] = x == '1';
			}
		}
	}

	

	int answer = 0;
	vector <int> streak(n);
	vector <int> inds(n);
	for (int i = 0; i < n; i++) {
		inds[i] = i;
	}
	for (int l = m - 1; l >= 0; l--) {
		for (int i = 0; i < n; i++) {
			if (a[i][l] == 0) {
				streak[i] = 0;
			}
			else {
				streak[i]++;
			}
		}
		sort(inds.begin(), inds.end(), [&](int i, int j) {
			return make_pair(-streak[i], -i) < make_pair(-streak[j], -j);
			});

		vector <int> val(n);
		vector <int> lft(n);
		vector <int> rgh(n);
		for (int i = 0; i < n; i++) {
			lft[i] = rgh[i] = i;
		}

		for (auto i : inds) {
			int k = streak[i];
			if (k == 0) break;

			val[i] = k;
			if (i < n - 1 && val[i + 1]) {
				rgh[i] = rgh[i + 1];
				lft[rgh[i]] = i;
				val[i] = val[i + 1] + k;
			}
			if (0 < i && val[i - 1]) {
				lft[i] = lft[i - 1];
				rgh[lft[i]] = i;
				int d = max(0ll, val[i] + k - val[i - 1]);
				val[lft[i]] = max(val[lft[i]], val[i] + (i - lft[i]) * k);
			}
			answer = max(answer, val[lft[i]]);
		}
	}

	cout << answer;
}