#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
vector <vector <int>> g;

vector <int> dep(n);

int cnt0 = 0;
int cnt1 = 0;

void dfs(int v, int p) {
	cnt0 += dep[v] % 2 == 0;
	cnt1 += dep[v] % 2 == 1;
	for (auto u : g[v]) {
		if (u == p) continue;
		dep[u] = dep[v] + 1;
		dfs(u, v);
	}
}

int main() {
	int d;
	cin >> n >> d;

	g.resize(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dep.resize(n);
	dfs(0, 0);

	cout << min(cnt0, cnt1) << '\n';
}