#include<bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> color;

inline void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;

    g = vector<vector<int>>(n);
    for (int i = 0; i < n-1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> used(n);
    int c = 0;

    vector<int> ord(n);
    for (int i = 0; i < n; i++)
        ord[i] = i;
    sort(ord.begin(), ord.end(), [&](int a, int b){return g[a].size() < g[b].size();});

    for (int i = 0; i < n; i++) {
        if (used[ord[i]])
            continue;
        sort(g[ord[i]].begin(), g[ord[i]].end(), [&](int a, int b) {return g[a].size() < g[b].size();});
        for (int u : g[ord[i]]) {
            if (!used[u]) {
                c++;
                used[u] = true;
                used[ord[i]] = true;
                break;
            }
        }
    }
    cout << c << '\n';
    cout << -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    cin >> t;
#endif

    while (t--) {
        solve();
        cout << '\n';
    }
}