#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<vector<ll>> p;
void f(ll n, ll m, vector<ll> z, vector<ll> u) {
    if ((ll)z.size() == n) {
        p.push_back(z);
        return;
    }
    for (ll i = 0; i < m; ++i) {
        if (u[i]) continue;
        u[i] = 1;
        z.push_back(i);
        f(n, m, z, u);
        z.pop_back();
        u[i] = 0;
    }
}
vector<vector<ll>> g;
vector<ll> h, dp1, dp2;
void dfs(ll v, ll p) {
    for (auto to : g[v]) {
        if (to != p) {
            h[to] = h[v] + 1;
            dfs(to, v);
            dp1[v] += max(dp1[to], dp2[to]);
        }
    }
    for (auto to : g[v]) {
        if (to != p) {
            dp2[v] = max(dp2[v], dp1[v] - max(dp1[to], dp2[to]) + dp1[to] + 1);
        }
    }
}
void dfs1(ll v, ll ans, ll p) {
    if (ans == dp1[v]) {
        for (auto to : g[v]) {
            if (to != p) dfs1(to, max(dp1[to], dp2[to]), v);
        }
    } else {
        ll u = -1;
        for (auto to : g[v]) {
            if (to != p && ans == dp1[v] - max(dp1[to], dp2[to]) + dp1[to] + 1) {
                u = to;
                break;
            }
        }
        cout << v + 1 << " " << u + 1 << "\n";
        for (auto to : g[v]) {
            if (to != p) {
                if (to != u) dfs1(to, max(dp1[to], dp2[to]), v);
                else dfs1(to, dp1[to], v);
            }
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, d;
    cin >> n >> d;
    g.resize(n);
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
        g[v].push_back(u);
    }
    h.assign(n, 0);
    dp1.assign(n, 0);
    dp2.assign(n, 0);
    dfs(0, -1);
    if (d == n - 1) {
        vector<ll> a, b;
        for (ll i = 0; i < n; ++i) {
            if (h[i] % 2) a.push_back(i);
            else b.push_back(i);
        }
        cout << min((ll)a.size(), (ll)b.size()) << "\n";
        for (ll i = 0; i < (ll)a.size() && i < (ll)b.size(); ++i) cout << a[i] + 1 << " " << b[i] + 1 << "\n";
    } else if (d == 1) {
        ll ans = max(dp1[0], dp2[0]);
        cout << ans << "\n";
        dfs1(0, ans, -1);
    } else {
        vector<ll> z, u(n - n / 2, 0);
        f(n / 2, n - n / 2, z, u);
        vector<vector<ll>> D(n, vector<ll>(n, n));
        for (ll i = 0; i < n; ++i) {
            vector<ll> q = {i};
            D[i][i] = 0;
            for (ll j = 0; j < n; ++j) {
                for (auto to : g[q[j]]) {
                    if (D[i][to] == n) D[i][to] = D[i][q[j]] + 1, q.push_back(to);
                }
            }
        }
        vector<pair<ll, ll>> ans;
        for (ll i = 0; i < (1 << n); ++i) {
            ll c = 0;
            for (ll j = 0; j < n; ++j) c += ((i & (1 << j)) > 0);
            if (c != n / 2) continue;
            vector<ll> a, b;
            for (ll j = 0; j < n; ++j) {
                if (i & (1 << j)) a.push_back(j);
                else b.push_back(j);
            }
            for (ll j = 0; j < (ll)p.size(); ++j) {
                vector<pair<ll, ll>> x;
                for (ll k = 0; k < n / 2; ++k) {
                    if (D[a[k]][b[p[j][k]]] % 2 && D[a[k]][b[p[j][k]]] <= d) x.push_back({a[k], b[p[j][k]]});
                }
                if ((ll)x.size() > (ll)ans.size()) ans = x;
            }
        }
        cout << (ll)ans.size() << "\n";
        for (ll i = 0; i < (ll)ans.size(); ++i) cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
    }
    cout << endl;
    return 0;
}