#include <vector>
#include <iostream>
#include <map>
#include <algorithm>

using namespace std;

#define ll long long
#define all(x) x.begin(),x.end()

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll n, m;
	cin >> n >> m;

	vector<vector<ll>> arr(n, vector<ll>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			if (s[j] == '1') {
				arr[i][j] = 1;
			}
			if (s[j] == '0') {
				arr[i][j] = 0;
			}
		}
	}

	for (int j = 0; j < m; j++) {
		ll start = 0;
		for (int i = 0; i < n; i++) {
			if (arr[i][j] == 1) {
				start++;
			}
			else {
				start = 0;
			}
			arr[i][j] = start;
		}
	}

	ll tot_ans = 0;

	for (int i = 0; i < n; i++) {
		for (int st = 0; st < m; st++) {
			ll start = arr[i][st];
			ll curr_ans = start;
			for (int j = st + 1; j < m; j++) {
				curr_ans += min(arr[i][j], start);
				start = min(arr[i][j], start);
			}
			tot_ans = max(tot_ans, curr_ans);
		}
	}

	cout << tot_ans << '\n';
}

