#include <vector>
#include <iostream>
#include <map>
#include <algorithm>
#include <deque>
#include <random>
#include <chrono>
#include <unordered_map>

using namespace std;

#define ll long long
#define all(x) x.begin(),x.end()
#define REP(a) for(int i = 0 ; i < a ; i ++)

mt19937 rnd(time(0));

struct duo {
	ll l;
	ll r;
};

struct dd {
	ll ind;
	int opened;
};

bool comp(dd& a,dd& b) {
	if (a.ind == b.ind) {
		return a.opened > b.opened;
	}
	else {
		return a.ind < b.ind;
	}
}

void solve() {
	ll n, k, l, m, r;
	cin >> n >> k;
	vector<duo> arr;
	unordered_map<ll, bool> mapic;

	vector<dd> sk;
	bool ch = 0;
	vector<bool> used(n,0); 
	REP(k) {
		cin >> l >> m >> r;
		if (mapic[m] == 1) {
			ch = 1;
		}
		else {
			mapic[m] = 1;
		}
		for (int i = l - 1; i < r; i++) {
			used[i] = 1;
		}
	}
	if (ch) { cout << "NO" << '\n'; return; }
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			cout << "NO" << '\n'; return;
		}
	}
	cout << "YES" << '\n'; return;
	////cout << "YES" << '\n'; return;
	//sort(all(sk),comp);
	//if (sk[0].ind == 1 && sk.back().ind == n) {
	//	ll crr = 0;
	//	for (int i = 0; i < sk.size(); i++){
	//		crr += sk[i].opened;
	//		if (crr == 0) {
	//			if (i+1 < sk.size() && sk[i + 1].ind - sk[i].ind > 1) {
	//				cout << "NO" << '\n'; return;
	//			}
	//		}
	//	}
	//	cout << "YES" << '\n'; return;
	//}
	//else {
	//	cout << "NO" << '\n'; return;
	//}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll t;
	cin >> t;
	while (t--){
		solve();
	}
}

