#include <vector>
#include <iostream>
#include <map>
#include <algorithm>
#include <deque>
#include <random>
#include <chrono>
#include <unordered_map>

using namespace std;

#define ll long long
#define all(x) x.begin(),x.end()
#define REP(a) for(int i = 0 ; i < a ; i ++)

mt19937 rnd(time(0));

struct duo {
	ll l;
	ll r;
	bool operator< (const duo& Other)const {
		return r < Other.r;
	}
};

vector<ll> ms;
map<ll, vector<duo>> mapic;

bool next(ll curr, ll mi,ll n) {
	if (curr == n) { return 1; }
	
	bool tot_ans = 0;
	for (auto& ch : mapic[mi]) {
		if (ch.l <= curr) {
			ll l = 0, r = ms.size();
			while (r - l > 1) {
				ll m = (l + r) / 2;
				if (ms[m] > ch.r) {
					r = m;
				}
				else {
					l = m;
				}
			}
			if (r != ms.size()) {
				tot_ans |= next(ch.r, ms[r], n);
			}
			else {
				if (ch.r == n) { return 1; }
				else { return 0; }
			}
		}
	}

	return tot_ans;
}

void solve() {
	ll n, k, l, m, r;
	cin >> n >> k;
	
	
	REP(k) {
		cin >> l >> m >> r;
		mapic[m].push_back({l,r});
		ms.push_back(m);
	}
	sort(all(ms));
	bool ans = next(1, ms[0],n);
	if (ans) {
		cout << "YES" << '\n';
	}
	else { cout << "NO" << '\n'; }
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}