#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define int long long
const int inf = 2e18;


void solve() {
	int n; cin >> n;
	int k; cin >> k;
	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].first >> a[i].second;
	}
	sort(rall(a));

	vector<bool> dp(k);
	for (int i = 0; i < k; ++i) {
		if (a[i].second == n) dp[i] = 1;
		for (int j = 0; j < i && !dp[i]; ++j) {
			if (dp[j] && a[i].first < a[j].first) dp[i] = 1;
		}
	}
	for (int i = 0; i < k; ++i) {
		if (dp[i] && a[i].first == 1) {
			cout << "YES\n"; return;
		}
	}
	cout << "NO\n"; return;
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t = 1; cin >> t;
	while (t--) solve();

}