#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long
const int inf = 2e18;


void solve() {
	int n; cin >> n;
	vector<int> x(n);
	for (int i = 0; i < n; ++i) cin >> x[i];
	sort(all(x));

	int x0, d; cin >> x0 >> d;

	int m; cin >> m;
	while (m--) {
		int t; cin >> t;
		int ans = inf;

		vector<int> pos;
		for (int l = 0; l < x.back() + d; l += d) {
			int cur = l / d * t;
			pos.push_back(l);

			for (int X : x) {
				int id = lower_bound(all(pos), X) - pos.begin();
				int A = inf, B = inf;
				if (id < pos.size()) B = (pos[id] - X) * (pos[id] - X);
				if (id > 0) A = (pos[id - 1] - X) * (pos[id - 1] - X);
				cur += min(A, B);
			}
			ans = min(ans, cur);
		}
		cout << ans << '\n';
	}
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t = 1; //cin >> t;
	while (t--) solve();

}