#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

#define all(x) x.begin(), x.end()

const ll INF = (ll) 1e18;

void solve() {
    int n;
    cin >> n;
    vll a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll x, d;
    cin >> x >> d;
    int m;
    cin >> m;

    auto f = [&](ll a, ll b) {
        return (a - b) * (a - b);
    };


    auto get_opt = [&](ll p) {
        ll left = (ll) -1e9 - 100;
        ll right = (ll) 1e9 + 100;
        while (left + 1 != right) {
            ll mid = (left + right) / 2;
            if (p < x + d * mid) {
                right = mid;
            } else {
                left = mid;
            }
        }
        if ((p - (x + d * left)) * (p - (x + d * left)) < (x + d * right - p) * (x + d * right - p)) {
            return left;
        } else {
            return right;
        }
    };
    vector<ll> opt(n);
    for (int i = 0; i < n; ++i) {
        opt[i] = get_opt(a[i]);
    }

    vector<pair<ll, ll>> q;
    for (int i = 0; i < m; ++i) {
        ll t;
        cin >> t;
        q.push_back({t, i});
    }
    sort(all(q));
    vll ans(m);
    for (auto [t, ind] : q) {
        for (int i = 0; i < n; ++i) {
            if (x < a[i]) {
                while (f(x + d * (opt[i] - 1)) + t * abs(opt[i] - 1) < f(x + d * opt[i]) + t * abs(opt[i])) {
                    opt[i]--;
                }
            }
            ans[ind] += f(x + d * opt[i], a[i]);
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}