#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(v) (v).begin(), (v).end()
typedef pair<int, int> pii;
const int N = 5e5 + 100;
const int mod = 1e9 + 7;

#define ST int v, int tl, int tr
#define ME v, tl, tr
#define STL v*2, tl, (tl+tr)/2
#define STR v*2+1, (tl+tr)/2, tr

int t[N];
int prom[N];
int isprom[N];


struct otr
{
	int l, r, m;
};
bool operator < (const otr &l, const otr& o)
{
	return (o.l < l.l);
}
int n, k;
otr a[N];


void push(ST)
{
	if (isprom[v])
	{
		t[v] = prom[v]*(tr-tl);
		if (tl + 1 != tr)
		{
			prom[v*2  ] = prom[v], isprom[v*2  ] = 1;
			prom[v*2+1] = prom[v], isprom[v*2+1] = 1;
		}
	}
	isprom[v] = 0;
}

void upd(ST, int ql, int qr, int val)
{
	push(ME);
	if (ql <= tl && tr <= qr)
	{
		t[v] = val*(tr-tl);
		prom[v] = val;
		isprom[v] = 1;
		return ;
	}
	if (qr <= tl || tr <= ql)
		return;
	upd(STL, ql, qr, val); push(STL);
	upd(STR, ql, qr, val); push(STR);
	t[v] = t[2*v] + t[2*v+1];
}

void tupd(int ql, int qr, int val)
{
	upd(1, 0, n+2, ql, qr, val);
}

int getsum(ST, int ql, int qr)
{
	push(ME);
	if (ql <= tl && tr <= qr)
		return t[v];
	if (qr <= tl || tr <= ql)
		return 0;
	return getsum(STL, ql, qr) + getsum(STR, ql, qr);
}

int tgetsum(int ql, int qr)
{
	return getsum(1, 0, n+2, ql, qr);
}

int dp[N];
set<otr> mp[N];

void solve()
{
	cin >> n >> k;
	for (int i = 0; i < k; i++)
	{
		otr x;
		cin >> x.l >> x.m >> x.r;
		mp[x.r].insert(x);
	}

	dp[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		for (otr x : mp[i])
		{
			for (int j = x.l-1; j < x.m; j++)
				dp[i] |= dp[j];
		}
	}
	if (dp[n])
		cout << "YES\n";
	else
		cout << "NO\n";

	fill_n(t, min(N, 4*n), 0);
	fill_n(isprom, min(N, 4*n), 0);
	fill_n(dp, min(N, 4*n), 0);
	for (int i = 0; i <= n; i++)
		mp[i].clear();
}

int32_t main()
{
	int t; cin >> t;
	while (t--)
		solve();
}


