#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(v) (v).begin(), (v).end()
typedef pair<int, int> pii;
const int N = 4e6;
const int mod = 1e9 + 7;

#define SQR(x) ((x)*(x))
#define num __int128

int n;
int x[N];
int x0, d;
int m;

num suf[N];
num sqrsuf[N];
num bestpref[N];

num best(int x)
{
	num d0 = x/d*d;
	return min({SQR(d0-x), SQR(d0+d-x), SQR(d0-d - x)});
}

int t;

num mabs(num x)
{
	if (x < 0)
		return -x;
	return x;
}

num getans1(num z, num z0)
{
	return SQR(z*d - x[1]) + t*mabs(z-z0);
}

num getans(num z)
{
	num s = SQR(z*d - x[0]) + t*mabs(z);
	num ans = LONG_MAX;
	num l = -1e9, r = 1e9;
	while (l + 3 < r)
	{
		int m1 = (2*l+r)/3;
		int m2 = (l+2*r)/3;
		if (getans1(m1, z) > getans1(m2, z))
			l = m1;
		else
			r = m2;
	}
	for (int i = l-30; i <= r+30; i++)
		ans = min(ans, getans1(i, z));
	return ans + s;
}

int32_t main()
{
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> x[i];
	cin >> x0 >> d;
	for (int i = 0; i < n; i++)
		x[i] -= x0;
	sort(x, x+n);
	bestpref[0] = best(x[0]);
	for (int i = 1; i < n; i++)
		bestpref[i] = bestpref[i-1] + best(x[i]);
	suf[n-1] = x[n-1];
	for (int i = n-2; i >= 0; i--)
		suf[i] = suf[i+1] + x[i];
	sqrsuf[n-1] = SQR(x[n-1]);
	for (int i = n-2; i >= 0; i--)
		sqrsuf[i] = sqrsuf[i+1] + SQR(x[i]);

	cin >> m;

	while (m--)
	{
		cin >> t;
		num ans = LONG_MAX;
		num l = -1e9, r = 1e9;
		while (l + 3 < r)
		{
			num m1 = (2*l+r)/3;
			num m2 = (l+2*r)/3;
			if (getans(m1) < getans(m2))
				l = m1;
			else
				r = m2;
		}
		for (num i = l-30; i <= r+30; i++)
			ans = min(ans, getans(i));
		l = -1e9, r = 1e9;
		while (l + 3 < r)
		{
			int m1 = (2*l+r)/3;
			int m2 = (l+2*r)/3;
			if (getans(m2) < getans(m1))
				l = m1;
			else
				r = m2;
		}
		for (int i = l-30; i <= r+30; i++)
			ans = min(ans, getans(i));

		cout << ((int)ans) << '\n';
	}
}


