#include <iostream>
#include <cmath>
#include <vector>

using namespace std;
using ll = long long;

ll cnt(ll i, ll r, ll l, vector<vector<ll>>& a, ll pr) {
	ll ans = 0;
	ll mx = pr - r;
	while (i>=0&&a[i][l] +l -1 >= r ) {
		ll cur = a[i][l] + l - r;
		if (cur > mx) {
			cur = mx;
		}
		else
			mx = cur;
		ans += cur;
		i--;
	}
	return ans;
}

ll solve1() {
	ll h, w;
	cin >> h >> w;
	vector<vector<ll>> a(h, vector<ll>(w));
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			char c;
			cin >> c;
			a[i][j] = (ll)(c - '0');
		}
	}
	for (ll i = h - 1; i >= 0; i--)
	{
		for (ll j = w - 1; j >= 0; j--)
		{
			if (a[i][j] == 0) {
				a[i][j] = 0;
				continue;
			}
			a[i][j] = 1;
			if (j + 1 < w)
				a[i][j] += a[i][j + 1];
		}
	}
	vector<vector<ll> > dp(h, vector<ll>(w, 0));
	ll ans = 0;
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			dp[i][j] = a[i][j];
			if (a[i][j] == 0)
				continue;
			if (i - 1 >= 0) {
				if (a[i - 1][j] <= a[i][j])
					dp[i][j] += dp[i - 1][j];
				else {
					dp[i][j] += dp[i - 1][j];
					dp[i][j] -= cnt(i - 1, j + a[i][j], j, a, j+a[i-1][j]);
				}
			}
			if (dp[i][j] > ans)
				ans = dp[i][j];
		}
	}
	cout << ans;
	return 0;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve1();
}
