#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()

using namespace std;

const int N = 5e5 + 5;

int l[N], r[N], m[N];
int ok[N];

bool cmp(int i, int j) {
    if (r[i] != r[j])
        return r[i] < r[j];
    return m[i] < m[j];
}

void solve() {
    int n, k, i, j;
    cin >> n >> k;
    for (i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        if (l[i] == 1) {
            ok[i] = 1;
        }
        else {
            ok[i] = 0;
        }
    }
    vector <int> v(k);
    iota(all(v), 0);
    sort(all(v), cmp);
    for (i = 0; i < k; i++) {
        if (ok[v[i]])
            continue;
        for (j = i - 1; j >= 0; j--) {
            if (r[v[j]] < l[v[i]] - 1)
                break;
            if (!(m[v[j]] >= l[v[i]] && m[v[i]] <= r[v[j]]) && ok[v[j]]) {
                ok[v[i]] = 1;
                break;
            }
        }
    }
    for (i = 0; i < k; i++) {
        if (r[i] == n && ok[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

