#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("popcnt,avx,avx2")

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;

#define int ll


vector<int> a;
int d;

__int128 get(int k, int t) {
    __int128 res = abs(k) * t;
    for (auto &x : a) {
        __int128 add = (__int128) (x - 1ll * k * d) * (x - 1ll * k * d);
        for (int k_ = max(0, x / d - 10); k_ <= min(k, x / d + 10); k_++) {
            add = min(add, (__int128) (x - 1ll * k_ * d) * (x - 1ll * k_ * d));
        }
        res += add;
    }
    return res;
}

ll solve(int t) {
    ll l = -1e9 - 1, r = 1e9 + 1;
    while (r - l > 1) {
        ll m1 = (l + r) / 2;
        ll m2 = m1 + 1;
        __int128 x1 = get(m1, t);
        __int128 x2 = get(m2, t);
        if (x1 > x2) l = m2;
        else r = m1;
    }
    ll x1 = get(l, t);
    ll x2 = get(r, t);
    return min(x1, x2);
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n;
    cin >> n;
    a.resize(n);
    for (auto &i : a) cin >> i;
    int x0;
    cin >> x0 >> d;
    for (auto &x : a) x -= x0;


    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int t;
        cin >> t;
        cout << solve(t) << "\n";
    }
}