#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("popcnt,avx,avx2")

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pii = pair<int, int>;

// #define int ll


vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> par;

void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        int new_val = dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1;
        if (dp[v][1] < new_val) {
            dp[v][1] = new_val;
            par[v] = u;
        }
    }
}

vector<pii> ans;
void find_ans(int v, int p, int t) {
    if (t == 0) {
        for (auto u : g[v]) {
            if (u == p) continue;
            if (dp[u][0] >= dp[u][1]) {
                find_ans(u, v, 0);
            } else {
                find_ans(u, v, 1);
            }
        }
    } else {
        ans.push_back({v, par[v]});
        for (auto u : g[v]) {
            if (u == p || u == par[v]) continue;
            if (dp[u][0] >= dp[u][1]) {
                find_ans(u, v, 0);
            } else {
                find_ans(u, v, 1);
            }
        }
        find_ans(par[v], v, 0);
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n, _;
    cin >> n >> _;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }


    par.resize(n);
    dp.resize(n, vector<int>(2, 0));
    dfs(0, -1);


    if (dp[0][0] >= dp[0][1]) {
        find_ans(0, -1, 0);
    } else {
        find_ans(0, -1, 1);
    }
    cout << max(dp[0][0], dp[0][1]) << "\n";
    cout << -1;
    for (auto &i : ans) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}