#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct str {
    int l, m, r;
};


void solve() {
    int n, k;
    cin >> n >> k;

    vector <str> a(k);
    vector <int> cov(n + 2), used(n + 2);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    bool ok = 1;

    sort(a.begin(), a.end(), [](auto i, auto j) {
        if (i.l == j.l) {
            return i.r > j.r;
        }
        return i.l < j.r;
    });

    for (int i = 0; i < k; i++) {
        if (i == 0 || a[i].l != a[i-1].l) {
            cov[a[i].l]++;
            cov[a[i].r + 1]--;
        }
    }

    for (int i = 1; i <= n; i++) {
        cov[i] += cov[i-1];

        if (cov[i] == 0) {
            ok = 0;
        }
    }

    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}