#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 7;

struct e{
    int l;
    int start;
    int r;
};

int n, k;
vector<e> lst;

bool comp(e a, e b) {
    return a.l < b.l;
}

bool can_all() {
    sort(lst.begin(), lst.end(), comp);
    int r = 0;
    for (auto v : lst) {
        if (r + 1 < v.l) {
            return false;
        }
        r = max(r, v.r);
    }
    return (r == n);
}

bool final_ans;

void perebor(vector<bool> used) {
    if (final_ans) {
        return;
    }
    int cou = 0;
    for (int i = 1; i <= n; i++) {
        if (used[i]) {
            cou++;
        }
    }
    if (cou == 0) {
        final_ans = true;
        return;
    }
    for (auto v : lst) {
        if (used[v.start]) {
            vector<bool> new_used = used;
            for (int i = v.l; i <= v.r; i++) {
                new_used[i] = false;
            }
            perebor(new_used);
        }
    }
}

pair<int, int> merg(pair<int, int> a, pair<int, int> b) {
    return {min(a.first, b.first), max(a.second, b.second)};
}

void make_norm(vector<pair<int, int>> & some) {
    sort(some.begin(), some.end());
    vector<pair<int, int>> new_some;
    for (int i = 0; i < some.size(); i++) {
        if (i == 0 || some[i] != some[i - 1]) {
            new_some.push_back(some[i]);
        }
    }
    some = new_some;
}


void sol() {
    cin >> n >> k;
    vector<e> one, two;
    for (int i = 0; i < k; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        lst.push_back({a, b, c});
    }
    vector<vector<vector<pair<int, int>>>> dp(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>()));
    for (int siz = 1; siz <= n; siz++) {
        for (int l = 1; l + siz - 1 <= n; l++) {
            int r = l + siz - 1;
            for (int i = 0; i < k; i++) {
                if (l <= lst[i].start && lst[i].start <= r) {
                    if (lst[i].l <= l && r <= lst[i].r) {
                        dp[l][r].push_back({lst[i].l, lst[i].r});
                    } else if (lst[i].l <= l) {
                        for (auto pai : dp[lst[i].r + 1][r]) {
                            dp[l][r].push_back(merg({lst[i].l, lst[i].r}, pai));
                        }
                    } else if (r <= lst[i].r) {
                        for (auto pai : dp[l][lst[i].l - 1]) {
                            dp[l][r].push_back(merg(pai, {lst[i].l, lst[i].r}));
                        }
                    } else {
                        for (auto pai1 : dp[l][lst[i].l - 1]) {
                            int a = max(lst[i].r + 1, pai1.second + 1);
                            if (a >= r) {
                                dp[l][r].push_back(pai1);
                            } else {
                                for (auto pai2 : dp[a][r]) {
                                    dp[l][r].push_back(merg(pai1, pai2));
                                }
                            }
                        }
                        for (auto pai1 : dp[lst[i].r + 1][r]) {
                            int b = min(lst[i].l - 1, pai1.first - 1);
                            if (b <= l) {
                                dp[l][r].push_back(pai1);
                            } else {
                                for (auto pai2 : dp[l][b]) {
                                    dp[l][r].push_back(merg(pai1, pai2));
                                }
                            }
                        }
                    }
                }
            }
        make_norm(dp[l][r]);
        //cout << l << " " << r << " " << dp[l][r].size() << endl;
        for (auto pai : dp[l][r]) {
            //cout << pai.first << " " << pai.second << endl;
        }
        }
    }
    if (dp[1][n].size() != 0) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
    lst.clear();
}



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
