#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e11 + 7;
const int real_inf = 1e18 + 100;
int n, d;
const int maxn = 5e5 + 100;
vector<vector<int>> edges(maxn, vector<int>());
vector<vector<int>> lst(2, vector<int>());

void dfs(int v, int p, int c) {
    lst[c].push_back(v);
    for (auto u : edges[v]) {
        if (u != p) {
            dfs(u, v, (c + 1) % 2);
        }
    }
}





signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    dfs(1, -1, 0);
    if (lst[0].size() >= lst[1].size()) {
        swap(lst[0], lst[1]);
    }
    cout << lst[0].size() << endl;
    for (int i = 0; i < lst[0].size(); i++) {
        cout << lst[0][i] << " " << lst[1][i] << endl;
    }
}
