#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e11 + 7;
const int real_inf = 1e18 + 100;
int n, d;
const int maxn = 20;
vector<vector<int>> edges(maxn, vector<int>());
vector<vector<bool>> used(maxn, vector<bool>(maxn, false));

void dfs(int start, int v, int p, int c) {
    if (c % 2 == 1 && c <= d) {
        used[start][v] = true;
    }
    for (auto u : edges[v]) {
        if (u != p) {
            dfs(start, u, v, c + 1);
        }
    }
}





signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        dfs(i, i, -1, 0);
    }
    vector<int> ans((1 << n), 0);
    vector<pair<int, int>> perehod((1 << n), {0, 0});
    for (int mask = 0; mask < (1 << n); mask++) {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if ((mask >> i) & 1) {
                    if ((mask >> j) & 1) {
                        if (used[i][j]) {
                            int new_mask = mask - (1 << i) - (1 << j);
                            if (ans[new_mask] + 1 > ans[mask]) {
                                ans[mask] = ans[new_mask] + 1;
                                perehod[mask] = {i, j};
                            }
                        }
                    }
                }
            }
        }
    }
    cout << ans[(1 << n) - 1] << endl;
    int mask = (1 << n) - 1;
    while (ans[mask] != 0) {
        cout << perehod[mask].first + 1 << " " << perehod[mask].second + 1 << endl;
        mask -= (1 << perehod[mask].first) + (1 << perehod[mask].second);
    }
}
