#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>
 
using namespace std;

long long solve0(long long x, long long d, vector<long long> &v) {
    long long ans = 0;
    for (auto i : v) {
        long long dst1 = i % d;
        long long dst2 = d - dst1;
        dst1 *= dst1;
        dst2 *= dst2;
        ans += min(dst1, dst2);
    }
    return ans;
}

long long solve(long long x, long long d, vector<long long> &v, long long t) {
    if (t == 0) {
        return solve0(x, d, v);
    }
    long long mx = 0;
    for (auto i : v) {
        mx = max(mx, i);
    }
    long long mn = 1e18;
    for (int i = x; i > - 2 * d; i -= d) {
        for (int j = x; j <= mx + 2 * d; j += d) {
            long long sum = (x - i) / d * t + (j - x) / d * t;
            sum += min((x - i) / d * t,  (j - x) / d * t);
            for (auto p : v) {
                long long dst1 = p % d;
                long long dst2 = d - dst1;
                long long to1 = p - dst1, to2 = p - dst2;
                long long to = to1;
                if (dst2 < dst1) {
                    to = to2;
                    swap(dst1, dst2);
                }
                if (i <= to && to <= j) {
                    sum += dst1 * dst1;
                } else {
                    sum += min((i - p) * (i - p), (j - p) * (j - p));
                }
            }
            mn = min(mn, sum);
        }
    }
    return mn;    
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    long long x, d;
    cin >> x >> d;

    long long mv = d - (x % d);
    x += mv;
    for (auto &i : v) {
        i += mv;
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        long long t;
        cin >>t;
        cout << solve(x, d, v, t) << '\n';
    }
    
    
    return 0; 
}