#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>
 
using namespace std;

int n, d;
vector<vector<int>> gr;

vector<pair<int, int>> dp;

int ans = 0;

void dfs(int v, int pr) {
    int s1 = 0, s2 = 0;
    for (auto u : gr[v]) {
        if (u == pr) {
            continue;
        }
        dfs(u, v);
        s1 += dp[u].first;
        s2 += dp[u].second;
    }
    ans += min(s1, s2);
    int t = min(s1, s2);
    s1 -= t;
    s2 -= t;
    if (s2 != 0) {
        s2--;
        swap(s1,s2);
        ans++;
    } else {
        swap(s1, s2);
        s2++;
    }
    dp[v] = {s1, s2};
}
 
int main()
{
    cin >> n >> d;
    gr.resize(n);
    dp.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    dfs(0, -1);
    cout << ans << endl << "-1" << endl;
    return 0; 
}