#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>
 
using namespace std;

int n, d;
vector<vector<int>> gr;

vector<pair<int, int>> dp;

vector<pair<int, int>> ans;

pair<vector<int>, vector<int>> dfs(int v, int pr) {
    int s1 = 0, s2 = 0;
    vector<int> vs1;
    vector<int> vs2;
    for (auto u : gr[v]) {
        if (u == pr) {
            continue;
        }
        auto [v1, v2] = dfs(u, v);
        if (v1.size() > vs1.size()) {
            swap(v1, vs1);
        }
        if (v2.size() > vs2.size()) {
            swap(v2, vs2);
        }
        for (auto i : v1) {
            vs1.push_back(i);
        }
        for (auto i : v2) {
            vs2.push_back(i);
        }
    }
    while (vs1.size() != 0 && vs2.size() != 0) {
        ans.push_back({vs1[vs1.size() - 1], vs2[vs2.size() - 1]});
        vs1.pop_back();
        vs2.pop_back();
    }
    if (vs2.size() != 0) {
        ans.push_back({v, vs2[vs2.size() - 1]});
        vs2.pop_back();
        swap(vs1, vs2);
    } else {
        swap(vs1, vs2);
        vs2.push_back(v);
    }
    return {vs1, vs2};
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    cin >> n >> d;
    gr.resize(n);
    dp.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    dfs(0, -1);
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << '\n';
    }
    return 0; 
}