#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <unordered_map>
 
using namespace std;

int n, d;

vector<vector<int>> gr;
vector<pair<int, int>> ans;

bool dfs(int v, int pr) {
    bool fl = false;
    for (auto u : gr[v]) {
        if (u == pr) {
            continue;
        }
        bool fl2 = dfs(u, v);
        if (!fl && !fl2) {
            ans.push_back({v, u});
            fl = true;
        }
    } 
    return fl;
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    cin >> n >> d;
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    dfs(0, -1);
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << '\n';
    }
    return 0; 
}