#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

#define int long long

void solve()
{
    int n, m;
    cin >> n >> m;
    vector a(n, vector<int>(m));
    for (auto& i : a)
        for (auto& j : i) {
            char x;
            cin >> x;
            j = x - '0';
        }
    vector col(n, vector(m, 0));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            if (i == 0)
                col[i][j] = a[i][j];
            else if (a[i][j])
                col[i][j] = col[i - 1][j] + 1;
            else
                col[i][j] = 0;
        }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        vector<pair<int, pair<int, int>>> st;
        int cur = 0;
        for (int j = m - 1; j >= 0; j--) {
            while (st.size() && st.back().X > col[i][j]) {
                cur -= st.back().X * st.back().Y.X;
                st.pop_back();
            }
            if (st.size()) {
                cur += (st.back().Y.Y - j) * col[i][j];
                st.push_back({ col[i][j], { st.back().Y.Y - j, j } });
            } else {
                cur += col[i][j];
                st.push_back({ col[i][j], { 1, j } });
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
