#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
// #define int ll
#define all(x) x.begin(), x.end()

const int INF = 1e18;

struct Worker {
    int l, m, r, id;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<Worker> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].id = i;
    }

    sort(all(a), [](Worker& w1, Worker& w2) {
        return w1.r < w2.r;
    });

    vector<int> ok(k);
    for (int i = 0; i < k; i++) {
        if (a[i].l == 1) {
            ok.push_back(i);
            continue;
        }
        for (int j = ok.size() - 1; j >= 0; j--) {
            if (a[i].l - 1 <= a[ok[j]].r and (a[ok[j]].m < a[i].l or a[i].m > a[ok[j]].r)) {
                ok.push_back(i);
                break;
            }
        }
    }

    if (a[ok.back()].r == n)
        cout << "YES" << '\n';
    else
        cout << "NO" << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    int t;
    cin >> t;
    while (t--)
        solve();
}