#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

void print(vector<int> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

void print(vector<ll> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

//#define int ll
#define mtask

void solve() {
    int n, k;
    cin >> n >> k;
    vector<bool> dp(n + 1);
    vector<array<int, 3>> otrs(k);
    dp[0] = true;
    for (int i = 0; i < k; ++i) {
        int l, r, m;
        cin >> l >> m >> r;
        --l;
        --m;
        otrs[i] = {l, r, m};
    }

    auto cmp = [](array<int, 3> &a, array<int, 3> &b) {
        if (a[0] != b[0]) return a[0] < b[0];
        return a[2] < b[2];
    };

    sort(all(otrs), cmp);

    for (auto [l, r, m] : otrs) {
        for (int i = l; i <= m; ++i) {
            if (dp[i]) {
                dp[r] = true;
                break;
            }
        }
    }
    if (dp[n]) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int t;
    cin >> t;
    while (t--)
#endif
    solve();
}