#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

void print(vector<int> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

void print(vector<ll> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

//#define int ll
#define mtask

void solve() {
    int n, k;
    cin >> n >> k;
    vector<bool> dp(n);
    vector<array<int, 3>> otrs(k);
    for (int i = 0; i < k; ++i) {
        int l, r, m;
        cin >> l >> m >> r;
        --l;
        --m;
        otrs[i] = {l, r, m};
    }

    auto cmp = [](array<int, 3> &a, array<int, 3> &b) {
        return a[0] < b[0];
    };

    // sort(all(otrs), cmp);
    // reverse(all(otrs));

    for (int i = 1; i < k; ++i) {
        for (int j = 0; j < i; ++j) {
            int l = max(otrs[i][0], otrs[j][0]);
            int r = min(otrs[i][1], otrs[j][1]);
            if (l >= r) continue;
            if (l <= otrs[i][2] && otrs[i][2] < r && l <= otrs[j][2] && otrs[j][2] < r) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (int i = 0; i < k; ++i) {
        for (int j = otrs[i][0]; j < otrs[i][1]; ++j) {
            dp[j] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!dp[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int t;
    cin >> t;
    while (t--)
#endif
    solve();
}