#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

void print(vector<int> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

void print(vector<ll> &a) {
    for (auto &x : a) cout << x << ' ';
    cout << '\n';
}

//#define int ll
// #define mtask

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int x0, d;
    cin >> x0 >> d;
    int q;
    cin >> q;
    x[0] = abs(x[0] - x0);

    while (q--) {
        ll t;
        cin >> t;

        auto get = [&](ll cnt) {
            return t * cnt + (x[0] - d * cnt) * (x[0] - d * cnt);
        };

        ll l = 0, r = (x[0] + d - 1) / d;

        while (l + 2 < r) {
            ll mid1 = l + (r - l) / 3;
            ll mid2 = r - (r - l) / 3;
            if (get(mid1) < get(mid2)) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }

        ll ans = 1e18;
        for (ll i = l; i <= r; ++i) {
            ans = min(ans, get(i));
        }

        cout << ans << '\n';

    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int t;
    cin >> t;
    while (t--)
#endif
    solve();
}