#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

mt19937 rnd(time(0));

void dfs(int s, int p, vector<vector<int> > &g, vector<int> &u) {
    for (int i: g[s]) {
        if (i != p) {
            u[i] = 1 - u[s];
            dfs(i, s, g, u);
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int> > g(n);
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> u(n);
    dfs(0, 0, g, u);
    vector<int> a, b;
    for (int i = 0; i < n; i++) {
        if (u[i])
            a.push_back(i);
        else
            b.push_back(i);
    }
    cout << min(a.size(), b.size()) << '\n';
    for (int i = 0; i < min(a.size(), b.size()); i++) {
        cout << a[i] + 1 << ' ' << b[i] + 1 << '\n';
    }
}
