#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

mt19937 rnd(time(0));

void dfs(int s, int p, int d, int d1, int r, vector<vector<int> > &g, vector<vector<int> > &g1) {
    if (d1 > d)
        return;
    if (d1 % 2) {
        g1[r].push_back(s);
    }
    for (int i: g[s]) {
        if (i != p) {
            dfs(i, s, d, d1 + 1, r, g, g1);
        }
    }
}

void dfs(int s, int p, vector<vector<int> > &g, vector<int> &u) {
    for (int i: g[s]) {
        if (i != p) {
            u[i] = 1 - u[s];
            dfs(i, s, g, u);
        }
    }
}

int T = 0;

bool dfs(int s, vector<vector<int> > &g, vector<int> &p, vector<int> &t) {
    for (int i: g[s]) {
        if (p[i] == -1) {
            p[i] = s;
            return 1;
        }
    }
    for (int i: g[s]) {
        if (t[p[i]] < T) {
            t[p[i]] = T;
            if (dfs(p[i], g, p, t)) {
                p[i] = s;
                return 1;
            }
        }
    }
    return 0;
}

void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int> > g(n);
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> u1(n);
    dfs(0, 0, g, u1);
    vector<vector<int> > g1(n);
    for (int i = 0; i < n; i++)
        dfs(i, i, d, 0, i, g, g1);
    vector<int> p(n, -1);
    vector<int> u(n), t(n);
    while (1) {
        bool is = 0;
        for (int i = 0; i < n; i++) {
            if (u1[i])
                continue;
            if (!u[i]) {
                if (dfs(i, g1, p, t)) {
                    is = 1;
                    u[i] = 1;
                    T++;
                }
            }
        }
        if (!is)
            break;
    }
    vector<pair<int, int> > ans;
    for (int i = 0; i < n; i++) {
        if (p[i] != -1) {
            ans.push_back({p[i], i});
        }
    }
    cout << ans.size() << '\n';
    for (auto [a, b]: ans)
        cout << a + 1 << ' ' << b + 1 << '\n';
}
