#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll T;
    cin >> T;
    while (T--) {
        ll n, k;
        cin >> n >> k;
        vector<ll> dpr(n + 1, 0);
        vector<ll> dpm(n + 1, 0);
        vector<tuple<ll, ll, ll> > q(k);
        for (auto &[l, m, r]: q) {
            cin >> l >> m >> r;
            l--;
            m--;
            r--;
        }
        dpr[0] = 1;
        sort(q.begin(), q.end());
        for (ll x = 0; x < 2 * k; ++x) {
            for (auto [l, m, r]: q) {
                ll sum = 0;
                for (ll j = l; j <= m; ++j) {
                    sum += dpr[j];
                }
                if (sum > 0) {
                    dpr[r + 1] = 1;
                    dpm[m] = r + 1;
                }

                for (ll j = 0; j < l; ++j) {
                    if (dpm[j] > m && dpm[j] < r + 1) {
                        dpr[r + 1] = 1;
                        dpm[m] = r + 1;
                    }
                }
            }
        }
        cout << (dpr[n] > 0 ? "YES" : "NO") << "\n";
    }

    return 0;
}
