#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e9;

vector<vector<ll>> g;
ll d;
ll n;
vector<array<ll, 2>> dp;
vector<ll> go;

void dfs(ll v, ll p = -1) {
    go[v] = -1;
    dp[v] = {0, 0};
    ll best = -1;
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        if (best == -1 || dp[to][1] - dp[to][0] < dp[best][1] - dp[best][0]) {
            best = to;
        }
        dp[v][0] += max(dp[to][0], dp[to][1]);
    }
    if (best != -1) {
        dp[v][1] = dp[v][0] - (dp[best][1] - dp[best][0]) + 1;
        go[v] = best;
    }
}

void answer(ll v, ll t, ll p = -1) {
    if (t == 1) {
        cout << v + 1 << " " << go[v] + 1 << "\n";
    }
    for (auto to : g[v]) {
        if (to == p) continue;
        if (to == go[v] && t == 1) {
            answer(to, 0, v);
        } else {
            if (dp[to][0] >= dp[to][1]) {
                answer(to, 0, v);
            } else {
                answer(to, 1, v);
            }
        }
    }
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    cin >> n;
    g.resize(n);
    dp.resize(n);
    go.resize(n);
    cin >> d;
    for (ll i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);
    cout << max(dp[0][0], dp[0][1]);
    cout << "\n";
    if (dp[0][0] >= dp[0][1]) {
        answer(0, 0);
    } else {
        answer(0, 1);
    }

    return 0;
}