#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();
}

void solve() {
    int h, w;
    std::cin >> h >> w;

    std::vector <std::string> table(h);
    for (int i = 0; i < h; ++i) {
        std::cin >> table[i];
    }

    std::vector <int> maxSeg(w, 0);

    int res = 0;

    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (table[i][j] == '1') {
                if (j) maxSeg[j] += 1;
                else maxSeg[j] = 1;
            } else {
                maxSeg[j] = 0;
            }
        }
        std::vector <int> lower(w, w);
        std::vector <int> stack;
        for (int j = w - 1; 0 <= j; --j) {
            while (!stack.empty() && maxSeg[stack.back()] > maxSeg[j]) {
                stack.pop_back();
            }
            if (!stack.empty()) lower[j] = stack.back();
            stack.push_back(j);
        }
        std::vector <int> curRes(w, 0);
        for (int j = w - 1; 0 <= j; --j) {
            if (maxSeg[j] == 0) continue;
            if (j == w - 1) {
                curRes[j] = maxSeg[j];
            } else {
                if (maxSeg[j] >= maxSeg[j + 1]) {
                    curRes[j] = maxSeg[j] + curRes[j + 1];
                } else {
                    curRes[j] = maxSeg[j] * (j - lower[j]);
                    if (lower[j] + 1 < w) curRes[j] += curRes[lower[j]];
                }
            }
        }
        for (int j = 0; j < w; ++j) {
            res = std::max(res, curRes[j]);
        }
    }

    std::cout << res;
}