#include <bits/stdc++.h>
#define int long long

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();
}

void solve() {
    int n;
    std::cin >> n;

    std::vector <int> x(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> x[i];
    }

    std::sort(x.begin(), x.end());

    int x0, d;
    std::cin >> x0 >> d;

    int m;
    std::cin >> m;

    std::vector <long long> minimum(n, 0);
    for (int i = 0; i < n; ++i) {
        x[i] -= x0;
        x[i] = abs(x[i]);

        long long a = (x[i] / d) * d;
        long long b = (x[i] / d + 1) * d;

        long long min = std::min(abs(x[i] - a), abs(x[i] - b));
        minimum[i] = min * min;
    }

    long long res = 0;
    for (auto i : minimum) {
        res += i;
    }

    std::cout << res;
}