#include <bits/stdc++.h>
#define int long long

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();
}

void solve() {
    int n;
    std::cin >> n;

    std::vector <int> x(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> x[i];
    }

    std::sort(x.begin(), x.end());

    int x0, d;
    std::cin >> x0 >> d;

    int m;
    std::cin >> m;

    std::vector <int> points;
    for (int j = -200; j <= 200; ++j) {
        if ((j - x[0]) % d == 0) points.push_back(j);
    }

    for (int i = 0; i < m; ++i) {
        int t;
        std::cin >> t;

        long long minR = LLONG_MAX;

        for (int l : points) {
            for (int r : points) {
                if (l <= x0 && x0 <= r) {

                    long long res = std::min((x0 - l) / d * 2 * t + (r - x0) / d * t, (x0 - l) / d * t + (r - x0) / d * 2 * t);
                    for (auto x : points) {
                        long long m = LLONG_MAX;
                        for (int dx = l; dx <= r; dx += d) {
                            m = std::min(m, (x - dx) * (x - dx));
                        }
                        res += m;
                    }

                    minR = std::min(minR, res);

                }
            }
        }

        std::cout << minR << '\n';
    }
}