#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld =long double;

bool ok(ll n, ll k, vector<vector<ll>> &a) {
    vector<ll> suf(n + 1, 1e18);
    for (auto &e : a) {
        if (e[2] != n -1) continue;
        suf[e[1]] = min(suf[e[1]], e[0]);
    }
    for (ll i = n - 1; i >= 0; i--) suf[i] = min(suf[i + 1], suf[i]);
    for (auto &e : a) {
        if (e[2] == n - 1) continue;
        if (suf[e[2] + 1] <= e[2] + 1) {
            return true;
        }
    }
    return false;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    set<ll> last;
    for (ll i = 0; i < n; i++) last.insert(i);
    vector<vector<ll>> a(k, vector<ll> (3, 0));
    ll fm = -1e18;
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
            j--;
        }
        while (last.lower_bound(i[0]) != last.end() && *last.lower_bound(i[0]) <= i[2]) {
            last.erase(last.lower_bound(i[0]));
        }
        fm = max(fm, i[2] - i[0] + 1);
    }
    if (!last.empty()) {
        cout << "NO";
        return;
    }
    if (fm == n) {
        cout << "YES";
        return;
    }
    if (ok(n, k, a)) {
        cout << "YES";
        return;
    }
    for (auto &e : a) {
       for (auto &i : e) i = n - 1 - i;
    }
    if (ok(n, k, a)) {
        cout << "YES";
        return;
    }
    cout << "NO";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12;
    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}