#include <bits/stdc++.h>
 
using namespace std;
 
#pragma GCC optimize("Ofast")

struct sp {
    vector<vector<int>> t;
    sp(vector<int> &a) {
        int n = a.size();
        t.resize(__lg(n) + 1);
        for(int i = 0; i < __lg(n) + 1; ++i) {
            t[i].resize(n);
        }
        t[0] = a;
        for(int i = 0; i < __lg(n); ++i) {
            for(int j = 0; j + (2 << i) <= n; ++j) {
                t[i+1][j] = min(t[i][j], t[i][j + (1 << i)]);
            }
        }
    }
    int query(int l, int r) {
        if(l == r) {
            return t[0][l];
        }
        int x = __lg(r - l );
        return min(t[x][l], t[x][r - (1 << x)]);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m;
    cin >> n >> m;
    vector<string> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> b(n,vector<int>(m));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            if(a[i][j] == '1') {
                b[i][j] = 1;
            }
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = m-2; j >= 0; --j) {
            if(a[i][j] != '0') {
                b[i][j] += b[i][j+1];
            }
        }
    }
    vector<int> val(n);
    int res = 0;
    for(int i = 0; i < m; ++i) {       
        vector<int> bb(n);
        for(int j = 0; j < n; ++j) {
            bb[j] = b[j][i];
        } 
        sp x(bb);
        vector<int> dp(n);
        dp[0] = b[0][i];
        for(int j = 1; j < n; ++j) {
            int pos = -1;
            int l = -1, r = j;
            while(r - l > 1) {
                int middle = (l + r) / 2;
                // bool ok = false;
                // for(int k = middle; k < j; ++k) {
                //     if(b[k][i] < b[j][i]) {
                //         ok = true;
                //     }
                // }
                if(x.query(middle, j) < b[j][i]) {
                    l = middle;
                } else {
                    r = middle;
                }
            }
            pos = l;
            dp[j] = (j - pos) * b[j][i];
            if(pos != -1) {
                dp[j] += dp[pos];
            }
            res = max(res, dp[j]);
        }
        res = max(res, dp[0]);
    }
    cout << res << '\n';
    return 0;
}