#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()
#define ff first
#define ss second

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using pll = pair<ll, ll>;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// constexpr ll MAXN = 5e5 + 17;
// ll mem[4 * MAXN];

// struct Segtree {
//     ll* st;
//     ll n;
//     Segtree(ll* mem, ll n) : st(mem), n(n) {
//     }

//     void add(ll i, ll l, ll r, ll j, ll x) {
//         if (j >= l && j < r) {
//             st[i] += x;
//         } else {
//             return;
//         }
//         if (r - l == 1) {
//             return;
//         }
//         ll m = l + r >> 1;
//         add(i * 2 + 1, l, m, j, x);
//         add(i * 2 + 2, m, r, j, x);
//     }

//     void add(ll j, ll x) {
//         add(0, 0, n, j, x);
//     }

//     ll sum(ll i, ll l, ll r, ll ql, ll qr) {
//         if (l >= ql && r <= qr) {
//             return st[i];
//         }
//         if (l >= qr || r <= ql) {
//             return 0;
//         }
//         ll m = l + r >> 1;
//         return sum(i * 2 + 1, l, m, ql, qr) + sum(i * 2 + 2, m, r, ql, qr);
//     }

//     ll sum(ll l, ll r) {
//         return sum(0, 0, n, l, r);
//     }
// };

struct Seg {
    ll l, m, r;
    
    bool operator<(Seg& other) {
        return r < other.r;
    }
};

void solve() {
    ll n, k;
    cin >> n >> k;
    // Segtree st(mem, n + 1);
    vector<Seg> segs(k + 1);
    vector<pll> ev;
    for (ll i = 1; i <= k; ++i) {
        cin >> segs[i].l >> segs[i].m >> segs[i].r;
    }
    sort(all(segs));
    vector<bool> dp(k + 1);
    dp[0] = true;
    for (ll i = 1; i <= k; ++i) {
        for (ll j = 0; j <= k; ++j) {
            if (segs[j].r < segs[i].r && segs[i].l - segs[j].r <= 1 && !(segs[i].m <= segs[j].r && segs[j].m >= segs[i].l && segs[j].m <= segs[i].r)) {
                if (dp[j]) {
                    dp[i] = true;
                    break;
                }
            }
        }
    }
    for (ll i = 1; i <= k; ++i) {
        if (segs[i].r == n) {
            if (dp[i]) {
                cout << "YES" << endl;
                return;
            }
        }
    }
    cout << "NO" << endl;
}

signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
