#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;
	vector<ll> x(n);
	for (int i = 0; i < n; i++)
		cin >> x[i];
	sort(x.begin(), x.end());
	ll x0, d;
	cin >> x0 >> d;
	vector<ll> mini(n);
	for (int i = 0; i < n; i++) {
		ll d1 = x[i] % d;
		ll d2 = d - d1;
		mini[i] = min(d1 * d1, d2 * d2);
	}
	vector<ll> psmini(n);
	psmini[0] = mini[0];
	for (int i = 1; i < n; i++)
		psmini[i] = psmini[i - 1] + mini[i];
	vector<ll> sufsq(n, 0), sufsum(n, 0);
	sufsq.back() = x.back() * x.back();
	sufsum.back() = x.back();
	for (int i = n - 2; i >= 0; i--) {
		sufsq[i] = sufsq[i + 1] + x[i] * x[i];
		sufsum[i] = sufsum[i + 1] + x[i];
	}
	/*for (auto i : mini)
		cout << i << " ";
	cout << endl;*/
	int m;
	cin >> m;
	while (m--) {
		ll t;
		cin >> t;
		ll ans = 8e18;
		ll behind = n;
		int p = 0;
		for (ll fin = 0; fin - d <= x.back(); fin += d) {
			while (p < n && x[p] <= fin) {
				behind--;
				p++;
			}
			ll cur = 0;
			if (p > 0)
				cur += psmini[p - 1];
			if (p < n) {
				cur += sufsq[p];
				cur -= 2 * fin * sufsum[p];
				cur += behind * fin * fin;
			}
			/*for (int i = p; i < n; i++) {
				cur += (x[i] - fin) * (x[i] - fin);
			}*/
			//cout << cur << endl;
			cur += fin * t / d;
			ans = min(ans, cur);
		}
		cout << ans << '\n';
	}
}
