#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int _x0, _d;
    cin >> _x0 >> _d;
    __int128_t x0 = _x0, d = _d;
    // int x0, d;
    // cin >> x0 >> d;
    vector<__int128_t> x_l, x_r;
    for (int i = 0; i < n; ++i) {
        if (x[i] < x0) {
            x_l.push_back(x[i]);
        } else if (x[i] > x0) {
            x_r.push_back(x[i]);
        }
    }
    auto get_ans_x = [&](__int128_t x_nw) -> __int128_t {
        __int128_t pos_l, pos_r;
        if (x_nw % d == x0 % d) {
            pos_l = pos_r = x_nw;
        } else {
            if (x_nw % d > x0 % d) {
                pos_l = x_nw - (x_nw % d - x0 % d);
                pos_r = pos_l + d;
            } else {
                pos_r = x_nw + (x0 % d - x_nw % d);
                pos_l = pos_r - d;
            }
        }
        return min((x_nw - pos_l) * (x_nw - pos_l), (x_nw - pos_r) * (x_nw - pos_r));
    };
    vector<__int128_t> pr_sum_l(x_l.size() + 1), pr_sum_l2(x_l.size() + 1), pr_sum_l_ans(x_l.size() + 1);
    for (int i = 0; i < (int)x_l.size(); ++i) {
        pr_sum_l[i + 1] = pr_sum_l[i] + x_l[i];
        pr_sum_l2[i + 1] = pr_sum_l2[i] + x_l[i] * 1LL * x_l[i];
        pr_sum_l_ans[i + 1] = pr_sum_l_ans[i] + get_ans_x(x_l[i]);
    }
    vector<__int128_t> pr_sum_r(x_r.size() + 1), pr_sum_r2(x_r.size() + 1), pr_sum_r_ans(x_r.size() + 1);
    for (int i = 0; i < (int)x_r.size(); ++i) {
        pr_sum_r[i + 1] = pr_sum_r[i] + x_r[i];
        pr_sum_r2[i + 1] = pr_sum_r2[i] + x_r[i] * 1LL * x_r[i];
        pr_sum_r_ans[i + 1] = pr_sum_r_ans[i] + get_ans_x(x_r[i]);
    }
    auto get_ans_nw = [&](__int128_t t, __int128_t l, __int128_t r) -> __int128_t {
        __int128_t ans_nw = min(x0 - l, r - x0) / d * 2LL * t + max(x0 - l, r - x0) / d * 1LL * t;
        __int128_t pos_l = lower_bound(x_l.begin(), x_l.end(), l) - x_l.begin();
        __int128_t pos_r = upper_bound(x_r.begin(), x_r.end(), r) - x_r.begin();
        ans_nw += pr_sum_l_ans.back() - pr_sum_l_ans[pos_l];
        ans_nw += pr_sum_r_ans[pos_r];
        ans_nw += pr_sum_l2[pos_l];
        ans_nw += pr_sum_r2.back() - pr_sum_r2[pos_r];
        __int128_t l_nw = l, r_nw = r;
        ans_nw += l_nw * l_nw * pos_l;
        ans_nw += r_nw * r_nw * ((int)x_r.size() - pos_r);
        ans_nw -= l_nw * 2 * pr_sum_l[pos_l];
        ans_nw -= r_nw * 2 * (pr_sum_r.back() - pr_sum_r[pos_r]);
        return ans_nw;
    };
    auto get_ans_l = [&](__int128_t t, __int128_t l) -> __int128_t {
        __int128_t ans = get_ans_nw(t, l, x0);
        __int128_t l_add = 0, r_add = x.back();
        while (l_add < r_add - 1) {
            __int128_t m_add = (l_add + r_add) / 2;
            if (x0 + m_add * 1LL * d >= x.back() + d) {
                r_add = m_add;
                continue;
            }
            __int128_t ans1 = get_ans_nw(t, l, x0 + m_add * d), ans2 = get_ans_nw(t, l, x0 + (m_add + 1) * d);
            if (ans1 > ans2) {
                l_add = m_add;
            } else {
                r_add = m_add;
            }
        }
        ans = min(ans, get_ans_nw(t, l, x0 + l_add * d));
        ans = min(ans, get_ans_nw(t, l, x0 + r_add * d));
        return ans;
    };
    auto get_ans = [&](__int128_t t) -> __int128_t {
        __int128_t ans = get_ans_nw(t, x0, x0);
        __int128_t l_add = 0, r_add = x0 / d + 10;
        while (l_add < r_add - 1) {
            __int128_t m_add = (l_add + r_add) / 2;
            __int128_t ans1 = get_ans_l(t, x0 - m_add * d), ans2 = get_ans_l(t, x0 - (m_add + 1) * d);
            if (ans1 > ans2) {
                l_add = m_add;
            } else {
                r_add = m_add;
            }
        }
        ans = min(ans, get_ans_l(t, x0 - l_add * d));
        ans = min(ans, get_ans_l(t, x0 - r_add * d));
        return ans;
    };
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        cout << (unsigned long long)get_ans(t) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
