#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll calc(vector<ll> h) {
    int n = h.size();
    vector<ll> low(n, n);
    deque<pair<ll, ll>> d;
    d.push_back({h[0], 0});
    for (ll i = 1; i < n; i++) {
        while (d.size() && h[i] <= d.back().first) {
            low[d.back().second] = i;
            d.pop_back();
        }
        d.push_back({h[i], i});
    }
    vector<ll> dp(n);
    dp[n - 1] = h[n - 1];
    for (ll i = n - 2; i >= 0; i--) {
        ll id = low[i];
        dp[i] = (id - i) * h[i];
        if (id < n) {
            dp[i] += dp[id];
        }
    }
    return *max_element(dp.begin(), dp.end());
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        for (int j = 0; j < m; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    ll ans = 0;
    vector<ll> h(m);
    for (int j = 0; j < m; j++) {
        h[j] = a[0][j];
    }
    ans = calc(h);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j]) {
                h[j] += 1;
            }
            else {
                h[j] = 0;
            }
        }
        ans = max(ans, calc(h));
    }
    cout << ans << '\n';
}

int main() {
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}