#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using LL = __int128_t;
const ll INF = 3e18;

ll check(ll x0, ll x1, ll cnt, ll d, ll t) {
    if (x1 > x0) {
        ll cur = x0 + cnt * d;
        ll cost = cnt * t;
        cost += (x1 - cur) * (x1 - cur);
        return cost;
    }
    else {
        ll cur = x0 - cnt * d;
        ll cost = cnt * t;
        cost += (x1 - cur) * (x1 - cur);
        return cost;
    }
}

void solve() {
    ll n; cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    ll x0, d; cin >> x0 >> d;
    ll q; cin >> q;
    while (q--) {
        ll t; cin >> t;
        ll x1 = a[0], x2 = a[1];
        ll lb = 0, rb = abs(x1 - x0) / d + 1;
        while (rb - lb > 2) {
            ll mid1 = lb + (rb - lb) / 3;
            ll mid2 = rb - (rb - lb) / 3;
            if (check(x0, x1, mid1, d, t) > check(x0, x1, mid2, d, t)) {
                lb = mid1;
            }
            else {
                rb = mid2;
            }
        }
        ll ans = INF;
        for (ll y = lb - 3; y <= rb + 3; y++) {
            ans = min(ans, check(x0, x1, y, d, t) + (x2 - y) * (x2 - y));
        }

        lb = 0, rb = abs(x2 - x0) / d + 1;
        while (rb - lb > 2) {
            ll mid1 = lb + (rb - lb) / 3;
            ll mid2 = rb - (rb - lb) / 3;
            if (check(x0, x2, mid1, d, t) > check(x0, x2, mid2, d, t)) {
                lb = mid1;
            }
            else {
                rb = mid2;
            }
        }
        for (ll y = lb - 3; y <= rb + 3; y++) {
            ans = min(ans, check(x0, x2, y, d, t) + (x1 - y) * (x1 - y));
        }
        cout << ans << '\n';
    }
}

int main() {
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}