#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <algorithm>

using namespace std;

mt19937 rng(time(0));

bool comp(vector <int> a, vector <int> b) {
    if (a[0] == b[0]) {
        return a[1] > b[1];
    }
    return a[0] > b[0];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qtest;
    cin >> qtest;
    for (int _ = 0; _ < qtest; _++) {
        int n, k;
        cin >> n >> k;
        vector <vector <int>> seg(k, vector <int> (3));
        bool fl1 = true;
        for (int i = 0; i < k; i++) {
            cin >> seg[i][0] >> seg[i][2] >> seg[i][1];
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
            if (seg[i][2] != seg[i][0]) {
                fl1 = false;
            }
        }
        if (fl1) {
            sort(seg.begin(), seg.end(), comp);
            bool fl = true;
            int maxr = n - 1;
            for (int i = 0; i < k; i++) {
                int l = seg[i][0], r = seg[i][1];
                if (maxr <= r && maxr >= l) {
                    maxr = l - 1;
                }
            }
            if (maxr >= 0) {
                fl = false;
            }
            if (fl) {
                cout << "YES\n";

        }   else {
                cout << "NO\n";
        }
    }
    }

}

