#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    int n, d;

    cin >> n >> d;

    vector<vector<int>> g(n + 1);

    for (int i = 1; i < n; ++i) {
        int a, b;

        cin >> a >> b;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    int ans1 = 0;
    auto dfs = [&](auto self, int v, int p, int d)->void {
        for (int u : g[v]) {
            if (u == p)
                continue;

            if (d)
                self(self, u, v, 0);
            else {
                ans1++;
                self(self, u, v, 1);
            }
        }
    };

    int ans = 0;
    dfs(dfs, 1, 0, 0);
    ans = ans1;
    ans1 = 0;

    dfs(dfs, 1, 0, 1);

    cout << max(ans, ans1) << '\n' << -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}