#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> v(n);
	for (auto& x : v) cin >> x;

	vector<vector<array<int, 3>>> len(m);
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int l = 0;
		for (int j = m - 1; j >= 0; j--) {
			if (v[i][j] == '0') {
				len[j].clear();
				l = 0;
			} else {
				l++;
				int last = i;
				while (!len[j].empty() && len[j].back()[0] > l) {
					last = len[j].back()[2];
					len[j].pop_back();
				}
				len[j].push_back({l, (len[j].empty() ? 0 : len[j].back()[1]) + (i - last + 1) * l, last});
				ans = max(ans, len[j].back()[1]);
				// cout << i << " " << j << ": ";
				// for (auto x : len[j]) {
				// 	for (auto y : x) cout << y << " ";
				// 	cout << ", ";
				// }
				// cout << "\n";
			}
		}
	}

	cout << ans;
}

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}