#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int, 3>> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i][0] >> v[i][1] >> v[i][2];
	}
	sort(all(v), [&](array<int, 3> a, array<int, 3> b) {
		return a[2] < b[2];
	});

	vector<int> dp(k);
	bool ans = false;
	for (int i = 0; i < k; i++) {
		if (v[i][0] == 1) dp[i] = 1;
		for (int j = i - 1; j >= 0; j--) {
			if (v[j][2] + 1 < v[i][0]) break;
			if (!dp[j]) continue;
			int l = v[i][0], r = v[j][2];
			if (!(l <= v[i][1] && v[i][1] <= r && l <= v[j][1] && v[j][1] <= r)) {
				dp[i] = 1;
				break;
			}
		}
		if (v[i][2] == n && dp[i]) ans = true;
	}

	if (ans) cout << "YES\n";
	else cout << "NO\n";
}

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int t = 1;
	cin >> t;
	while (t--) solve();
}