#include <bits/stdc++.h>
#define int long long
using namespace std;
const int inf = 8e18;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i) {
        x[i] -= x0;
    }
    for (int i = 0; i < n; ++i) {
        x[i] = abs(x[i]);
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        __int128 T = t;
        __int128 ans = inf;
        __int128 l = -1;
        __int128 r = 1e9;
        while (l + 1 < r) {
            __int128 mid = (l + r) / 2;
            __int128 ans1 = mid * T + ((__int128) x[0] - mid * d) * ((__int128) x[0] - mid * d);
            __int128 ans2 = (mid + 1) * T + ((__int128) x[0] - (mid + 1) * d) * ((__int128) x[0] - (mid + 1) * d);
            if (ans1 > ans2) {
                l = mid;
            } else {
                r = mid;
            }
        }
        for (__int128 i = max((__int128) 0, l - 3); i < r + 3; ++i) {
            ans = min(ans, i * T + ((__int128) x[0] - i * d) * ((__int128) x[0] - i * d));
        }
        cout << (int) ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
