#include <bits/stdc++.h>
#define int long long
using namespace std;
vector<vector<int> > g;
vector<vector<int> > dp;
vector<int> dist;

void dfs(int v, int p, int d) {
    dist[v] = d;
    for (int to: g[v]) {
        if (to == p)continue;
        dfs(to, v, d + 1);
    }
    int sm = 0;
    for (int to: g[v]) {
        if (to == p)continue;
        sm += max(dp[to][0], dp[to][1]);
    }
    dp[v][0] = sm;
    int mx = 0;
    for (int to: g[v]) {
        if (to == p)continue;
        mx = max(mx, sm - max(dp[to][0], dp[to][1]) + 2 + dp[to][0]);
    }
    dp[v][1] = mx;
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp.assign(n, {0, 0});
    dist.assign(n, 0);
    dfs(0, 0, 0);
    int cn0 = 0, cn1 = 0;
    vector<int> c0, c1;
    for (int i = 0; i < n; ++i) {
        if (dist[i] % 2 == 0) {
            cn0++;
            c0.push_back(i);
        } else {
            cn1++;
            c1.push_back(i);
        }
    }
    cout << min(cn1, cn0) << "\n";
    for (int i = 0; i < min(cn1, cn0); ++i) {
        cout << c0[i] + 1 << " " << c1[i] + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
