#include <bits/stdc++.h>
#define int long long
using namespace std;
vector<vector<int> > g, g1;
vector<vector<int> > dist;

void dfs(int V,int v, int p, int d) {
    dist[V][v] = d;
    for (int to: g[v]) {
        if (to == p)continue;
        dfs(V, to, v, d + 1);
    }
}

vector<int> mt;
vector<int> used;

bool kuhn(int v) {
    if (used[v])return false;
    for (int to: g1[v]) {
        if (mt[to] == -1) {
            used[v] = true;
            mt[to] = v;
            return true;
        }
    }
    for (int to: g1[v]) {
        if (kuhn(mt[to])) {
            used[v] = true;
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    g1.assign(n, {});
    dist.assign(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        dfs(i, i, i, 0);
    }
    vector<int> l, r;
    for (int i = 0; i < n; ++i) {
        if (dist[0][i] % 2 == 0)l.push_back(i);
        else r.push_back(i);
    }
    for (int i: l) {
        for (int j: r) {
            if (dist[i][j] <= 2 * d - 1) {
                g1[i].push_back(j);
            }
        }
    }
    mt.assign(n, -1);
    used.assign(n, 0);
    int cnt = 0;
    for (int i: l) {
        cnt += kuhn(i);
    }
    cout << cnt << "\n";
    cout << -1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
