// semenInRussia 2025
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  // dp[i][j] - maximum the size of stairway
  // dp[i][j] = min(dp[i+1][j], row)
  int n, m;
  cin >> n >> m;

  vector<string> t(n);

  for (auto &row : t) {
    cin >> row;
  }

  // build nxt

  vector<vector<int>> len(n, vector<int>(m + 1, 0));

  for (int i = 0; i < n; i++) {
    int x = m;
    for (int j = m - 1; j >= 0; j--) {
      if (t[i][j] == '1') {
        len[i][j] = len[i][j + 1] + 1;
      }
    }
  }

  int ans = 0;

  for (int j = 0; j < m; j++) {
    vector<int> dp(m + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
      int x = len[i][j];
      if (x == 0) {
        fill(dp.begin(), dp.end(), 0);
      }
      for (int j = 0; j < x; j++) {
        dp[j] += j;
      }
      int suf = 0;
      for (int j = x; j <= m; j++) {
        suf = max(suf, dp[j]);
      }
      dp[x] = x + suf;
      ans = max(ans, dp[x]);
    }
  }

  cout << ans;
}