#include <iostream>
#include <vector>
using namespace std;

int min(int a, int b) {
    if (a < b) return a;
    return b;
}

int max(int a, int b) {
    if (a > b) return a;
    return b;
}

int main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> t(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char c;
            cin >> c;
            if (c == '1') {
                t[i][j] = 1;
            }
        }
    }
    int l = 0;
    vector<vector<int>> cnt(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        int c = 0;
        for (int j = w - 1; j >= 0; j--) {
            if (t[i][j] == 1) {
                c++;
                cnt[i][j] = c;
            } else {
                c = 0;
                cnt[i][j] = 0;
            }
        }
    }
    int res = 0;
    for (int st = 0; st < w; st++) {
        //vector<int> ans(h);
        for (int i = 0; i < h; i++) {
            int cur = 0;
            int len = cnt[i][st];
            for (int i1 = i; i1 >= 0 && len > 0; i1--) {
                len = min(len, cnt[i1][st]);
                cur += len;
            }
            res = max(res, cur);
        }
    }
    cout << res << "\n";
}