#include <iostream>

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ve vector
#define pb push_back

struct emp {
    ll m, l, r;
};

bool cmp(emp a, emp b) {
    if (a.m < b.m)
        return true;
    if (a.m > b.m)
        return false;
    if (a.l < b.l)
        return true;
    if (a.l > b.l)
        return false;
    if (a.r <= b.r)
        return true;
    return false;
}


int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        set<ll> alowed;
        ll i, j;
        emp em[k];
        for (i = 0; i < k; i++) {
            cin >> em[i].l >> em[i].m >> em[i].r;
            em[i].l--;
            em[i].m--;
            em[i].r--;
        }
        sort(em, em + k, cmp);
        ll dp[k];
        for (i = 0; i < k; i++) {
            dp[i] = -1;
        }
        if (em[0].l == 0) {
            dp[0] = em[i].r;
            alowed.insert(em[i].r);
        }
        for (i = 1; i < k; i++) {
            ll l = -1;
            ll r = i;
            while (r - l > 1) {
                ll m = (l + r) / 2;
                if (em[m].m < em[i].l)
                    l = m;
                else
                    r = m;
            }
            // if (l == -1) {
            //     if (em[i].l == 0) {
            //         dp[i] = max(em[i].r, dp[i - 1]);
            //         alowed.insert(em[i].r);
            //         continue;
            //     } else {
            //         dp[i] = dp[i - 1];
            //         continue;
            //     }
            // }
            if (dp[l] >= em[i].l - 1) {
                dp[i] = max(em[i].r, dp[i - 1]);
                alowed.insert(em[i].r);
                continue;
            }
            auto pos = lower_bound(alowed.begin(), alowed.end(), em[i].l - 1);
            if (pos == alowed.end() || *pos >= em[i].m) {
                dp[i] = dp[i - 1];
            } else {
                dp[i] = max(em[i].r, dp[i - 1]);
                alowed.insert(em[i].r);
                continue;
            }
        }
        if (dp[k - 1] == n - 1) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}
