#include <iostream>

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define LL __int128
#define ve vector
#define pb push_back

struct part {
    ll t;
    ll id;
};

bool cmp(part a, part b) {
    if (a.t < b.t)
        return true;
    if (a.t > b.t)
        return false;
    if (a.id < b.id)
        return true;
    if (a.id > b.id)
        return false;
    return true;
}

ll alp = 100;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    ll i, j;
    cin >> n;
    ll d;
    cin >> d;
    ve<ve<ll>> edges(n);
    for (i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        edges[x].pb(y);
        edges[y].pb(x);
    }
    ll chet[n];
    bool used[n];
    for (i = 0; i < n; i++) {
        used[i] = false;
    }
    chet[0] = 0;
    queue<ll> q;
    q.push(0);

    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto it: edges[v]) {
            if (!used[it]) {
                used[it] = true;
                q.push(it);
                chet[it] = 1 - chet[v];
            }
        }
    }
    ve<ll> ch(0);
    ve<ll> nch(0);
    for (i = 0; i < n; i++) {
        if (chet[i] == 1)
            ch.pb(i);
        else
            nch.pb(i);

    }
    cout << min(ch.size(), nch.size()) << endl;
    for (i = 0; i < min(ch.size(), nch.size()); i++) {
        cout << ch[i] + 1<< " " << nch[i] + 1<< '\n';
    }
}
