#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> a[i][j];
		}
	}
	vector<int> len(n);
	ll ans = 0;
	vector<pair<int,int>> st;
	st.reserve(n + 1);
	for (int j = m - 1; j >= 0; j--)
	{
		ll cur = 0;
		for (int i = 0; i < n; i++)
		{
			if (a[i][j] == '1') len[i]++;
			else len[i] = 0;
			int cnt = 1;
			while (!st.empty() && st.back().first >= len[i])
			{
				cnt += st.back().second;
				cur -= (ll)st.back().first * st.back().second;
				st.pop_back();
			}
			st.push_back({ len[i],cnt });
			cur += (ll)cnt * len[i];
			ans = max(ans, cur);
		}
	}
	cout << ans << '\n';
}