#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<tuple<ll, ll, ll>> segs(k);
	for (auto&[m, r, l] : segs) {
		cin >> l >> m >> r;
		l--;
	}
	sort(segs.begin(), segs.end());
	vector<ll> mmp(n + 1, INF);
	mmp[0] = 0;
	for (auto[m, r, l] : segs) {
		for (ll j = l; j < m; j++) {
			if (mmp[j] < INF) {
				assign_min(mmp[r], m);
			}
		}
		for (ll j = l; j < r; j++) {
			if (mmp[j] <= l) {
				assign_min(mmp[r], m);
			}
		}
	}
	cout << (mmp.back() == INF ? "NO" : "YES") << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
