#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

pair<ll, vector<ll>> dfs(ll v, ll p, ll d, vector<vector<ll>>& tree) {
	vector<ll> nc(d, 0);
	nc[0] = 1;
	ll ans = 0;
	for (auto i : tree[v]) {
		if (i != p) {
			auto[na, ncs] = dfs(i, v, d, tree);
			ans += na;
			ll mi = min(ncs[0], ncs[1]);
			ans += mi;
			ncs[1] -= mi;
			ncs[0] -= mi;
			mi = min(ncs[1], nc[0]);
			nc[0] -= mi;
			ncs[1] -= mi;
			ans += mi;
			nc[1] += ncs[0];
		}
	}
	return make_pair(ans, nc);
}

void solve() {
	ll n;
	cin >> n;
	ll d;
	cin >> d;
	vector<vector<ll>> to(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		to[a].push_back(b);
		to[b].push_back(a);
	}
	if (d % 2 == 0) {
		d--;
	}
	auto[ans, nc] = dfs(0, 0, d, to);
	cout << ans + min(nc[0], nc[1]) << '\n' << -1 << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
