#include <bits/extc++.h>

using namespace std;

vector<vector<int>> g, dp;
vector<int> mt;

void dfs(int v, int p) {
  int s = 0;
  pair<int, int> best = {-1e9, -1};
  for (int u : g[v]) {
    if (u != p) {
      dfs(u, v);
      dp[v][0] += max(dp[u][0], dp[u][1]);
      s += dp[u][1];
      best = max(best, make_pair(dp[u][0] - dp[u][1], u));
    }
  }
  mt[v] = best.second + 1;
  dp[v][v] = s + best.first;
}

void dfs2(int v, int p, int kek) {
  if (kek || dp[v][0] >= dp[v][1]) {
    for (int u : g[v]) {
      if (u != p) {
        dfs2(u, v, 0);
      }
    }
  } else {
    cout << v + 1 << ' ' << mt[v] + 1 << '\n';
    for (int u : g[v]) {
      if (u != p) {
        if (u == mt[v]) {
          dfs2(u, v, 1);
        } else {
          dfs2(u, v, 0);
        }
      }
    }
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, d;
  cin >> n >> d;
  g.resize(n);
  dp.resize(n, vector<int>(2));
  mt.resize(n);
  for (int i = 1; i < n; i++) {
    int v , u;
    cin >> v >> u, v--, u--;
    g[v].push_back(u);
    g[u].push_back(v);
  }
  dfs(0, -1);
  cout << max(dp[0][0], dp[0][1]) << '\n';
  dfs2(0, -1, 0);
  return 0;
}
