#include <bits/extc++.h>

using namespace std;

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, d;
  cin >> n >> d;
  vector<vector<int>> g(n);
  for (int i = 1; i < n; i++) {
    int v, u;
    cin >> v >> u, v--, u--;
    g[v].push_back(u);
    g[u].push_back(v);
  }
  auto D = [&](int st) -> vector<int> {
    vector<int> d(n, n + 52);
    d[st] = 0;
    queue<int> q;
    q.push(st);
    while (!q.empty()) {
      int v = q.front();
      q.pop();
      for (int u : g[v]) {
        if (d[u] > d[v] + 1) {
          d[u] = d[v] + 1;
          q.push(u);
        }
      }
    }
    return d;
  };
  auto z = D(0);
  vector<int> a, b;
  for (int v = 0; v < n; v++) {
    if (z[v] % 2 == 0) {
      a.push_back(v);
    } else {
      b.push_back(v);
    }
  }
  cout << min(a.size(), b.size()) << '\n';
  while (!a.empty() && !b.empty()) {
    int v = a.back();
    a.pop_back();
    int u = b.back();
    b.pop_back();
    cout << v  + 1 << ' ' << u + 1 << '\n';
  }
  return 0;
}
