// #pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull = unsigned long long;

const ll INF = 2e18;

template <typename T> inline void chmin(T &a, T b) {
    if (b < a) {
        a = b;
    }
}

using B = __int128;
void solve() {
    int n, d;
    cin >> n >> d;
    // vector c(n, 0);
    // int ans = 0;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int>> res;
    vector<vector<int>> c0(n), c1(n), c2(n);
    function<void(int)> dfs = [&](int v) {
        if (sz(g[v]) == 0) {
            c0[v] = {v};
        } else {
            int ff = -1;
            for (int &u : g[v]) {
                erase(g[u], v);

                dfs(u);
                if (sz(c1[u]) + sz(c0[u]) > sz(c1[g[v][0]]) + sz(c0[g[v][0]])) {
                    swap(u, g[v][0]);
                }
                if (sz(c2[u])) {
                    ff = c2[u][0];
                }
            }
            c0[v] = {v};
            c1[v].swap(c0[g[v][0]]);
            c2[v].swap(c1[g[v][0]]);
            g[v].erase(g[v].begin());
            for (int u : g[v]) {
                int mn = min(sz(c1[v]), sz(c1[u]));
                for (int j = 0; j < mn; ++j) {
                    res.push_back({c1[v].back(), c1[u].back()});
                    c1[v].pop_back();
                    c1[u].pop_back();
                }
                mn = min(sz(c2[v]), sz(c0[u]));
                for (int j = 0; j < mn; ++j) {
                    res.push_back({c2[v].back(), c0[u].back()});
                    c2[v].pop_back();
                    c0[u].pop_back();
                }
                for (int x : c0[u]) {
                    c1[v].push_back(x);
                }
                for (int x : c1[u]) {
                    c2[v].push_back(x);
                }
            }
            if (ff != -1) {
                res.push_back({ff, v});
                c0[v].pop_back();
            } else if (sz(c1[v])) {
                res.push_back({v, c1[v].back()});
                c0[v].pop_back();
                c1[v].pop_back();
            }
        }
    };
    dfs(0);
    cout << sz(res) << '\n';
    for (auto [x, y] : res) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
    // cout << -1 << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    cout << fixed;
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}