#include <bits/stdc++.h>

#define int long long

using namespace std;

int n;
vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> p;
vector<bool> used;

void dfs_dp(int v) {
    used[v] = true;
    vector<int> childs;
    for (int u : g[v]) {
        if (used[u]) {
            continue;
        }
        childs.push_back(u);
        dfs_dp(u);
    }
    for (int u : childs) {
        dp[v][0] += dp[u][1];
    }
    dp[v][1] = dp[v][0];
    for (int u : childs) {
        int cur_res = dp[v][0] - dp[u][1] + dp[u][0] + 1;
        if (cur_res > dp[v][1]) {
            dp[v][1] = cur_res;
            p[v] = u;
        }
    }
}

vector<pair<int, int>> res;

void dfs_get(int v, int use) {
    used[v] = true;
    for (int u : g[v]) {
        if (used[u]) {
            continue;
        }
        if (use == 0) {
            dfs_get(u, 1);
        } else {
            if (p[v] == u) {
                res.push_back({v, u});
                dfs_get(u, 0);
            } else {
                dfs_get(u, 1);
            }
        }
    }
}

void solve() {
    cin >> n;
    g.resize(n);
    p.resize(n, -1);
    dp.resize(n, vector<int>(2));
    used.resize(n);
    int _d;
    cin >> _d;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs_dp(0);
    used.assign(n, false);
    dfs_get(0, 1);
    cout << (int)res.size() << "\n";
    for (auto [v, u] : res) {
        cout << v + 1 << " " << u + 1 << "\n";
    }
}

signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}