
#include <bits/stdc++.h>
using namespace std;
mt19937_64 rnd(time(NULL));
 
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt")
  
const long long INF = 1e18, MOD = 1e9 + 7;
  
long long divl(long long a, long long b)
{
    if (a >= 0)
    {
        return a / b;
    }
    return -((-a + b - 1) / b);
}
  
long long divr(long long a, long long b)
{
    if (a >= 0)
    {
        return (a + b - 1) / b;
    }
    return a / b;
}
  
void solve()
{
    long long n;
    cin >> n;
    vector<long long> v(n);
    for (long long i = 0; i < n; i++)
    {
        cin >> v[i];
    }
    long long s, d;
    cin >> s >> d;
    long long q;
    cin >> q;
    sort(v.begin(), v.end());
    vector<long long> best(n);
  
    auto get_thr = [&](long long a, long long b) -> long long
    {
        return (a - b) * (a - b);
    };
  
    for (long long i = 0; i < n; i++)
    {
        long long k = divl(v[i] - s, d);
        best[i] = get_thr(s + k * d, v[i]);
        k = divr(v[i] - s, d);
        best[i] = min(best[i], get_thr(s + k * d, v[i]));
    }
    vector<long long> pbest(n + 1);
    for (long long i = 0; i < n; i++)
    {
        pbest[i + 1] = pbest[i] + best[i];
    }
    vector<__int128> suff_sq2(n + 1), suff_sum(n + 1);
    vector<__int128> pref_sq2(n + 1), pref_sum(n + 1);
    for (long long i = n - 1; i > -1; i--)
    {
        suff_sq2[i] = suff_sq2[i + 1] + v[i] * v[i];
        suff_sum[i] = suff_sum[i + 1] + v[i];
    }
    for (long long i = 0; i < n; i++)
    {
        pref_sq2[i + 1] = pref_sq2[i] + v[i] * v[i];
        pref_sum[i + 1] = pref_sum[i] + v[i];
    }
     
    auto calcccc = [&](__int128 r, long long t) -> __int128
    {
        __int128 res = (r / d) * t;
        long long idx = upper_bound(v.begin(), v.end(), r) - v.begin();
        res += pbest[idx];
        __int128 cnt_throw = n - idx;
        res += r * r * cnt_throw;
        res -= r * 2 * suff_sum[idx];
        res += suff_sq2[idx];
        return res;
    };
 
    auto calc = [&](__int128 l, __int128 r, __int128 t) -> __int128
    {
        __int128 tol = (s - l) / d, tor = (r - s) / d;
        __int128 res = (tol + tor + min(tol, tor)) * t;
        long long idxl = lower_bound(v.begin(), v.end(), l) - v.begin();
        long long idxr = upper_bound(v.begin(), v.end(), r) - v.begin();
        res += pbest[idxr] - pbest[idxl];
        res += l * l * idxl;
        res -= l * 2 * pref_sum[idxl];
        res += pref_sq2[idxl];
        res += r * r * (n - idxr);
        res -= r * 2 * suff_sum[idxr];
        res += suff_sq2[idxr];
        return res;
    };
 
    auto check1 = [&](__int128 all_move, __int128 t) -> __int128
    {
        __int128 left = all_move, right = (v.back() + d - 1) / d + 2;
        while (right - left > 1)
        {
            __int128 mid = (left + right) / 2;
            __int128 res1 = calc(s - mid * d, s + all_move * d, t), res2 = calc(s - (mid + 1) * d, s + all_move * d, t);
            if (res1 >= res2)
            {
                left = mid;
            }
            else
            {
                right = mid;
            }
        }
        __int128 res = min(calc(s - left * d, s + all_move * d, t), calc(s - (left + 1) * d, s + all_move * d, t));
        left = all_move, right = (v.back() + d - 1) / d + 3;
        while (right - left > 1)
        {
            __int128 mid = (left + right) / 2;
            __int128 res1 = calc(s - all_move * d, s + mid * d, t), res2 = calc(s - all_move * d, s + (mid + 1) * d, t);
            if (res1 >= res2)
            {
                left = mid;
            }
            else
            {
                right = mid;
            }
        }
        __int128 res2 = min(calc(s - all_move * d, s + left * d, t), calc(s - all_move * d, s + (left + 1) * d, t));
        return min(res, res2);
    };
  
    while (q--)
    {
        long long t;
        cin >> t;
 
        long long all_left = 0, all_right = (v.back() + d - 1) / d + 2;
 
        /*
        for (long long i = 0; i <= all_right; i++)
        {
            long long res = check1(i, t);
            cout << res << " ";
        }
        cout << "\n";
        continue;
        */
         
        while (all_right - all_left > 1)
        {
            long long all_mid = (all_left + all_right) / 2;
            __int128 res1 = check1(all_mid, t), res2 = check1(all_mid + 1, t);
            if (res1 >= res2)
            {
                all_left = all_mid;
            }
            else
            {
                all_right = all_mid;
            }
        }
        long long ans = min(check1(all_left, t), check1(all_left + 1, t));
        cout << ans << "\n";
    }
}
 
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
  
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
  
    return 0;
}
  
/*
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
*/
