//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long t, n, m;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> t;

	for (long long h = 0; h < t; ++h) {
		cin >> n >> m;

		vector<pair<pair<long long, long long>, long long>> v1(m);
		vector<long long> v2(n + 1, 0);

		for (long long i = 0; i < m; ++i) {
			cin >> v1[i].first.first >> v1[i].second >> v1[i].first.second;
			--v1[i].first.first;
			--v1[i].first.second;
			--v1[i].second;
			++v2[v1[i].first.first];
			--v2[v1[i].first.second + 1];
		}

		long long x3 = 0, x4 = 0;

		for (long long i = 0; i < n; ++i) {
			x3 += v2[i];
			if (x3 <= 0)
				x4 = 1;
		}

		if (x4 == 1)
			cout << "NO\n";
		else
			cout << "YES\n";
	}

	return 0;
}
