//#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using ll = long long;
using ld = long double;
using namespace std;

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0), cout.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<char>> a(h, vector<char>(w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<vector<int>>>dp(h, vector<vector<int>>(w, vector<int>(w)));
    for (int j = 0; j < w; j++) {
        int kol = 0;
        bool flag = true;
        for (int k = j; k < w; k++) {
            if (a[0][k] == '0') {
                flag = false;
            } else if (flag){
                kol++;
            }
            dp[0][j][k] = kol;
        }
    }

    int ans = 0;
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < w; j++) {
            int kol = 0;
            bool flag = true;
            for (int k = j; k < w; k++) {
                if (a[i][k] == '0') {
                    flag = false;
                } else if (flag) {
                    kol++;
                }
                if (a[i][j] == '0') {
                    dp[i][j][k] = 0;
                } else {
                    dp[i][j][k] = dp[i-1][j][j + kol-1] + kol;
                }
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans << '\n';
    return 0;
}
