#include <bits/stdc++.h>
using namespace std;

using ll = __int128;

void solve() {
    int n;
    cin >> n;
    vector<long long> xx(n);
    for (int i = 0; i < n; ++i) {
        cin >> xx[i];
    }
    long long x0, d;
    cin >> x0 >> d;
    vector<pair<ll, ll>> x1, x2;
    for (int i = 0; i * d <= (ll) 50 + d; ++i) {
        x1.push_back({i * d, 0});
        x2.push_back({i * d, 0});
    }
    for (auto x: xx) {
        if (x < x0) {
            x1.push_back({x0 - x,  1});
        } else if (x > x0) {
            x2.push_back({x - x0, 1});
        }
    }
    sort(x1.begin(), x1.end());
    sort(x2.begin(), x2.end());
    vector<ll> dp1((ll) x1.size()), dp2((ll) x2.size());
    auto build = [&](vector<pair<ll, ll>> &x, vector<ll> &dp) {
        ll sz = (ll) x.size();
        ll sum = 0;
        for (int i = 0; i < sz; ++i) {
            ll l = x[i].first / d * d;
            ll r = l;
            if (r < x[i].first) {
                r += d;
            }
           if (x[i].second) sum += min((x[i].first - l) * (x[i].first - l), (r - x[i].first) * (r - x[i].first));
            dp[i] += sum;
        }
        sum = 0;
        ll gg = 0;
        ll ff = 0;
        ll hh = 0;
        for (int i = sz - 1; i >= 0; --i) {
            ll l = x[i].first / d * d;
            ll r = l;
            if (r < x[i].first) {
                r += d;
            }
            dp[i] += gg + ff * r + r * r * (hh);
            if (x[i].second) {
                hh++;
                gg += x[i].first * x[i].first;
                ff -= 2 * x[i].first;
            }
        }
    };
    build(x1, dp1), build(x2, dp2);
    int m;
    cin >> m;
    while (m--) {
        long long t;
        cin >> t;
        auto f = [&](vector<pair<ll, ll>> &x, vector<ll> &dp) -> pair<ll, ll> {
            ll mn1 = (ll) 4e18;
            ll mn2 = (ll) 4e18;
            for (int i = 0; i < (ll) x.size(); ++i) {
                ll l = x[i].first / d * d;
                ll r = l;
                if (r < x[i].first) {
                    r += d;
                }
                mn1 = min(mn1, dp[i] + r / d * t);
                mn2 = min(mn2, dp[i] + r / d * t * 2);
            }
            return {mn1, mn2};
        };
        auto [l1, l2] = f(x1, dp1);
        auto [r1, r2] = f(x2, dp2);
        cout << (long long)min(l1 + r2, r1 + l2) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}