#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

//#define int long long

#define x first
#define y second

int inf = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for (auto& i : v) {
        cin >> i;
    }
    vector<vector<int>> suf(n, vector<int>(m, -inf));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == '1') {
                suf[i][j] = j;
                if (j + 1 < m) {
                    suf[i][j] = max(suf[i][j], suf[i][j + 1]);
                }
            }
        }
    }
    int ans = 0;
    int sum = 0;
    multiset<int> me;
    for (int j = 0; j < m; j++) {
        sum = 0;
        me.clear();
        for (int i = 0; i < n; i++) {
            if (suf[i][j] >= j) {
                while (!me.empty() && *me.begin() < -(suf[i][j] - j + 1)) {
                    sum += *me.begin();
                    me.erase(me.begin());
                    me.insert(-(suf[i][j] - j + 1));
                    sum -= -(suf[i][j] - j + 1);
                }
                me.insert(-(suf[i][j] - j + 1));
                sum -= -(suf[i][j] - j + 1);
            }else {
                sum = 0;
                me.clear();
            }
            ans = max(ans, sum);
        }
    }
    cout << ans;
}

signed main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}