#include <bits/stdc++.h>
#define int long long

using namespace std;

int get_dist(int x, int y) {
    return (x - y) * (x - y);
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) cin >> x[i];
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    vector<int> best(n);
    for (int i = 0; i < n; ++i) {
        int k = (x0 - x[i]) / d;
        best[i] = x0 + k * d;
        for (int j = k - 1; j <= k + 1; ++j) {
            if (get_dist(best[i], x[i]) > get_dist(x0 + j * d, x[i])) {
                best[i] = x0 + j * d;
            }
        }
    }
    int mini = best[0], maxi = best[0];
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        mini = min(mini, best[i]);
        maxi = max(maxi, best[i]);
        sum += get_dist(x[i], best[i]);
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int ans = min(abs(x0 - mini) + maxi - mini, abs(x0 - maxi) + maxi - mini) * t;
        ans += sum;
        cout << ans << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
