#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Person {
    int l, m, r;
};

const ll INF = 1e18;

ll near_left(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x + d - 1) / d);
    } else {
        return x0 + d * ((x - x0) / d);
    }
}

ll near_right(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x) / d);
    } else {
        return x0 + d * ((x - x0 + d - 1) / d);
    }
}


void solve() {
    int n;
    cin >> n;
    vector<ll> targets(n);
    for (auto &x : targets) {
        cin >> x;
    }
    ll x0, d;
    cin >> x0 >> d;

    int m;
    cin >> m;

    sort(targets.begin(), targets.end());
    // coords.push_back(x0);
    // sort(coords.begin(), coords.end());
    // coords.erase(unique(coords.begin(), coords.end()), coords.end());

    while (m--) {
        ll t;
        cin >> t;

        ll l1 = near_left(x0, d, targets[0]);
        ll r1 = near_right(x0, d, targets[0]);

        ll l2 = near_left(x0, d, targets[1]);
        ll r2 = near_right(x0, d, targets[1]);

        vector<ll> c = {l1, r1, x0, l2, r2};
        ll ans = LLONG_MAX;

        for (auto x : c) {
            for (auto y : c) {
                ans = min(ans, abs(x - x0) / d * t + abs(x - y) / d * t + (x - targets[0]) * (x - targets[0]) + (y - targets[1]) * (y - targets[1]));
            }
        }
        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}