#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Person {
    int l, m, r;
};

const ll INF = 1e18;

ll near_left(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x) / d);
    } else {
        return x0 + d * ((x - x0) / d);
    }
}

ll near_right(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x + d - 1) / d);
    } else {
        return x0 + d * ((x - x0 + d - 1) / d);
    }
}


void solve() {
    int n;
    cin >> n;
    vector<ll> targets(n);
    for (auto &x : targets) {
        cin >> x;
    }
    ll x0, d;
    cin >> x0 >> d;

    int m;
    cin >> m;
    vector<ll> coords;
    ll ans = INF;
    for (auto x : targets) {
        ll left = near_left(x0, d, x);
        ll right = near_right(x0, d, x);

        ans = min(ans, (left - x) * (left - x));
        ans = min(ans, (right - x) * (right - x));
        ans = min(ans, (x0 - x) * (x0 - x));
    }
    cout << ans << "\n";
    // coords.push_back(x0);
    // sort(coords.begin(), coords.end());
    // coords.erase(unique(coords.begin(), coords.end()), coords.end());

    // while (m--) {
    //     ll t;
    //     cin >> t;
        // vector<vector<ll>> dp(n + 1, vector<ll>(coords.size(), INF));
        // dp[0][0] = 0;
        //
        // for (ll i = 1; i <= n; ++i) {
        //     for (ll j = 0; i < coords.size(); ++j) {
        //         for (ll k = 0; k < coords.size(); ++k) {
        //
        //         }
        //     }
        // }
    // }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}