#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 0, INF = 1e6;
#else
const int MAXN = 0, INF = 1e9 + 228 * 1e4;
#endif

vector<string> t;
vector<int> hs[2];
vector<int> r_lt;
vector<int> dp;
signed main() {
    int hn, w; cin >> hn >> w;
    t.resize(hn);
    for (string &s : t) cin >> s;
    hs[1].resize(w, 0);
    int ans = 0;
    vector<int> stck;
    for (int i = 0; i < hn; i++) {
        hs[i&1].resize(w);
        for (int j = 0; j < w; j++) {
            hs[i&1][j] = (t[i][j] == '0' ? 0 : 1 + hs[i&1^1][j]);
        }
        r_lt.clear();
        r_lt.resize(w, w);
        stck.clear();
        for (int j = 0; j < w; j++) {
            while (!stck.empty() && hs[i&1][stck.back()] > hs[i&1][j]) {
                r_lt[stck.back()] = j;
                stck.pop_back();
            }
            stck.push_back(j);
        }
        dp.clear();
        dp.resize(w + 1, 0);
        for (int j = w - 1; j >= 0; j--) {
            dp[j] = hs[i&1][j] * (r_lt[j] - j) + dp[r_lt[j]];
            smax(ans, dp[j]);
        }
    }
    cout << ans << '\n';
    return 0;
}
