#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#include <cassert>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 0, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 0, INF = 1e9 + 228 * 1e4;
#endif

inline ll sq(ll x) { return x * x; }
vector<__int128> pref1, pref2, pref_mn;
ll n;


__int128 sum_sq(ll x, ll l, ll r) {
    return (pref2[r] - pref2[l]) + (__int128)(r - l) * sq(x) - 2 * x * (pref1[r] - pref1[l]);
}


signed main() {
    int n;
    cin >> n;
    vector<ll> xs(n);
    for (ll &i : xs) cin >> i;
    sort(allv(xs));
    ll x0, d; cin >> x0 >> d;
    pref_mn.resize(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref_mn[i + 1] = pref_mn[i] + sq(min(abs(xs[i] - x0) % d, d - abs(xs[i] - x0) % d));
    }
    cout << (ll)pref_mn[n] << '\n';
    return 0;
}
