#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
    }     
    sort(a.begin(), a.end(), [&](auto lft, auto rght){
        return lft[2] < rght[2];
    });
    vector<vector<int>> dp(k + 1, vector<int>(k + 1, 0));
    dp[0][0] = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= i; ++j) {
            int tmp = 0;
            if (j != 0) tmp = a[j - 1][1];
            dp[i + 1][j] = max(dp[i + 1][j], dp[i][j]);
            if (a[i][0] <= dp[i][j] + 1 && (a[i][1] > dp[i][j] || a[i][0] > tmp)) {
                int mx = j;
                if (tmp < a[i][1]) {
                    mx = i + 1;
                }
                dp[i + 1][mx] = max(dp[i + 1][mx], a[i][2]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= k; ++i) {
        ans = max(ans, dp[k][i]);
    }
    if (ans == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
   
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}