#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
    }     
    sort(a.begin(), a.end(), [&](auto lft, auto rght){
        return lft[1] < rght[1];
    });
    vector<vector<int>> dp(k + 1, vector<int>(n + 1, 0));
    dp[0][0] = 0;
    for (int i = 0; i < k; ++i) {
        for (int mx = 0; mx <= n; ++mx) {
            dp[i + 1][mx] = max(dp[i + 1][mx], dp[i][mx]);
            if (a[i][0] <= dp[i][mx] + 1 && (a[i][1] > dp[i][mx] || a[i][0] > mx)) {
                dp[i + 1][max(mx, a[i][1])] = max(dp[i + 1][max(mx, a[i][1])], a[i][2]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dp[k][i]);
    }
    if (ans == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
   
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}