#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    int dist = abs(x[0] - x0);
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        int res = dist * dist;
        int l = 0, r = (dist + d - 1) / d;
        while (r - l > 2) {
            int m1 = (r + 2 * l) / 3;
            int m2 = (2 * r + l) / 3;
            int val1 = t * m1 + abs(dist - m1 * d) * abs(dist - m1 * d);
            int val2 = t * m2 + abs(dist - m2 * d) * abs(dist - m2 * d);
            res = min(res, min(val1, val2));
            if (val1 < val2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        for (int mid = l; mid <= r; ++mid) {
            int val = t * mid + abs(dist - mid * d) * abs(dist - mid * d);
            res = min(res, val);
        }
        cout << res << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }
}