#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

int n;
vector<vector<int>> g;
vector<vector<pair<int, int>>> vec;

pair<int, int> dfs(int v, int p = -1) {
    pair<int, int> res = {vec.size(), vec.size() + 1};
    vec.push_back({});
    vec.push_back({});
    for (auto to : g[v]) {
        if (to != p) {
            auto x = dfs(to, v);
            if (vec[x.second].size() > vec[res.first].size()) {
                res.first = x.second;
            }
            if (vec[x.first].size() > vec[res.first].size()) {
                res.first = x.first;
            }
            if (vec[x.first].size() + 1 > vec[res.second].size()) {
                res.second = x.first;
                vec[res.second].push_back({v, to});
            }
        }
    }
    return res;
}


void solve() {
    int d;
    cin >> n >> d;
    g.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    auto res = dfs(0);
    if (vec[res.first].size() > vec[res.second].size()) {
        swap(res.first, res.second);
    }
    cout << vec[res.second].size() << "\n";
    for (auto el : vec[res.second]) {
        cout << el.first + 1 << " " << el.second + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }
}