#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define f first
#define s second

using namespace std;

const int MAXN = 14;
int h[MAXN], was[MAXN];
vector<int> g[MAXN];
vector<int> even, odd;
vector<pii> ans;
int dist[MAXN][MAXN];
int d;

void dfs(int v, int p)
{
    if(h[v]%2 == 0) even.push_back(v);
    else odd.push_back(v);

    for(auto u:g[v])
    {
        if(u == p) continue;
        h[u] = h[v] + 1;
        dfs(u, v);
    }
    return;
}

void get_dist(int v, int p, int x)
{
    for(auto u:g[v])
    {
        if(u == p) continue;
        dist[x][u] = dist[x][v] + 1;
        get_dist(u, v, x);
    }
    return;
}

void recurs(int ind, int n, vector<pii>&cur)
{
    if(ind == n)
    {
        if(cur.size() > ans.size()) ans = cur;
        return;
    }
    int v = even[ind];
    for(int i = 0; i<odd.size(); ++i)
    {
        int u = odd[i];
        if(!(was[u] || dist[v][u] > d))
        {
            cur.push_back({u, v});
            was[u] = 1;
            recurs(ind+1, n, cur);
            was[u] = 0;
            cur.pop_back();
        }
        else
            recurs(ind+1, n, cur);
    }
    return;
}

void solve()
{
    int n; cin >> n >> d;
    int u, v;
    for(int i = 0; i<n-1; ++i)
    {
        cin >> u >> v; --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    h[0] = 0;
    dfs(0, -1);
    if(even.size()>odd.size()) swap(even, odd);
    for(auto i:even)
    {
        dist[i][i] = 0;
        get_dist(i, -1, i);
    }
    vector<pii> cur;
    recurs(0, even.size(), cur);
    cout << ans.size() << "\n";
    for(auto i:ans)
    {
        cout << i.f+1 << " " << i.s+1 << "\n";
    }

    for(int i = 0; i<n; ++i)
        g[i].clear();
    even.clear();
    odd.clear();
    ans.clear();
    return;
}

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); int t = 1;
    //freopen("in.txt", "r", stdin); int t; cin >> t;
    while(t--)
        solve();
    return 0;
}
