#include <bits/stdc++.h>

using namespace std;
#define ll long long

ll INF = 1e18;


bool norm(vector<pair<ll, pair<ll,ll> > > &s,ll n) {
    vector<ll> z(n + 2, 0);
    for (ll j = 0; j < s.size(); j++) {
        z[s[j].second.second + 1]--;
        z[s[j].second.first]++;
    }
    ll cnt = 0;
    for (ll i = 1; i <= n; i++) {
        cnt += z[i];
        if (cnt == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll tt;
    cin >> tt;
    for (ll ij = 0; ij < tt; ij++) {
        ll n, k;
        cin >> n >> k;
        vector<pair<ll, pair<ll,ll> > > s;
        for (ll i = 0; i < k; i++) {
            ll a, b, c;
            cin >> a >> b >> c;
            s.push_back({a, {b, c}});
        }
        sort(s.rbegin(), s.rend());
        for (ll i = 0; i < s.size(); i++) {
            swap(s[i].first, s[i].second.first);
        }
        vector<pair<ll, pair<ll,ll> > > z;
        for (ll i = 0; i < s.size(); i++) {
            z.push_back(s[i]);
            ll j = i + 1;
            while (j < s.size() && s[j].second.first == s[i].second.first) {
                j++;
            }
            i = j - 1;
        }
        if (norm(z, n)) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
}
