#include<bits/stdc++.h>
using namespace std;
#define int long long
const int inf_ = 1e18 + 7;
const int inf = 1e9 + 7;

struct Fast {
    __int128 f(int st, int to, int w, int d) {
        __int128 l = 0, r = inf;
        __int128 ans = abs(to - st) * abs(to - st);
        while (r - l > 2) {
            __int128 mid1 = l + (r - l + 1) / 3;
            __int128 mid2 = r - (r - l + 1) / 3;
            __int128 x = abs(st - to) - mid1 * d;
            if (x < 0) x = -x;
            int c1 = mid1 * w + x * x;
            x = abs(st - to) - mid2 * d;
            if (x < 0) x = -x;
            int c2 = mid2 * w + x * x;
            if (c1 > c2) {
                l = mid1;
                ans = min(ans, c2);
            } else {
                r = mid2;
                ans = min(ans, c1);
            }
        }
        return ans;
    }

    void solve() {
        int n;
        cin >> n;
        int mx = 0;
        vector<int> x(n);
        for (auto &i: x) cin >> i, mx = max(mx, i);
        int x0, d;
        cin >> x0 >> d;
        int m;
        cin >> m;
        vector<pair<int, int> > t;
        for (int i = 0; i < m; i++) {
            int c;
            cin >> c;
            t.emplace_back(c, i);
        }
        sort(t.begin(), t.end());
        vector<__int128> an(m);
        int r = n - 1;
        __int128 sum = mx * t[0].first;
        for (auto [c, i]: t) {
            an[i] = f(x0, x[0], c, d);
        }
        for (auto ans: an) {
            string anss;
            if (ans == 0) anss = "0";
            else
                while (ans) {
                    anss += char('0' + ans % 10);
                    ans /= 10;
                }
            reverse(anss.begin(), anss.end());
            cout << anss << '\n';
        }
    }
};

signed main() {
    int __ = 1;
    //cin >> __;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
        cout << '\n';
    }
}
