#include<bits/stdc++.h>
using namespace std;
#define int long long
const int inf_ = 1e18 + 7;
const int inf = 1e9 + 7;

struct Fast {
    __int128 f(int st, int w, int d, int s, int sk, int n) {
        __int128 l = 0, r = inf;
        __int128 A = n * d * d;
        __int128 B = w + 2 * d * n * st - 2 * n * s * d;
        __int128 C = sk * 2 * n - 2 * n * s * st;
        __int128 X = 0;
        __int128 ans = C;
        while (r - l > 2) {
            __int128 mid1 = l + (r - l + 1) / 3;
            __int128 mid2 = r - (r - l + 1) / 3;
            __int128 x1 = A * mid1 * mid1 + B * mid1 + C;
            __int128 x2 = A * mid2 * mid2 + B * mid2 + C;
            if (x1 > x2) {
                l = mid1;
                ans = min(ans, x2);
            } else {
                r = mid2;
                ans = min(x1, ans);
            }
        }
        return ans;
    }

    void solve() {
        int n;
        cin >> n;
        int mx = 0;
        vector<int> x(n);
        for (auto &i: x) cin >> i, mx = max(mx, i);
        sort(x.begin(), x.end());
        int x0, d;
        cin >> x0 >> d;
        int m;
        cin >> m;
        vector<pair<int, int> > t;
        for (int i = 0; i < m; i++) {
            int c;
            cin >> c;
            t.emplace_back(c, i);
        }
        sort(t.begin(), t.end());
        vector<__int128> an(m, -1);
        vector<int> q;
        for (int i = 0; i < n; i++) {
            int c = abs(x0 - x[i]);
            q.push_back(min(c % d, d - c % d) * min(c % d, d - c % d));
        }
        for (auto [c, j]: t) {
            __int128 sum = 0;
            int st = x0;
            __int128 s = 0, sk = 0;
            for (int i = 0; i < n; i++)
                s += x[i], sk += x[i] * x[i];
            for (int i = 0; i < n; i++) {
                if (an[j] == -1) an[j] = f(st, c, d, s, sk, n - i);
                else an[j] = min(an[j], f(st, c, d, s, sk, n - i));
                sum += q[i];
                st = (x[i] + d - 1) / d * d;
            }
            if (an[j] == -1) an[j] = f(st, c, d, s, sk, 0);
            else an[j] = min(an[j], f(st, c, d, s, sk, 0));
        }
        for (auto ans: an) {
            string anss;
            if (ans == 0) anss = "0";
            else
                while (ans) {
                    anss += char('0' + ans % 10);
                    ans /= 10;
                }
            reverse(anss.begin(), anss.end());
            cout << anss << '\n';
        }
    }
};

signed main() {
    int __ = 1;
    //cin >> __;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
        cout << '\n';
    }
}
