#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()

using ll = long long;

const ll maxn = 3e5 + 9;

ll x[maxn], n, x0, d, t;
__int128 su[maxn], pref[maxn], kv[maxn];

__int128 func(ll k) {
    __int128 cur = x0 + k * d;
    __int128 ans = t * k;
    __int128 ind = upper_bound(x, x + n, cur) - x;
    ans += su[ind];
    __int128 cnt = n - (ind + 1) + 1;
    ans += (kv[n] - kv[ind]) + cur * cur * cnt - 2 * cur * (pref[n] - pref[ind]);
    return ans;
}

void solve() {
    ll q;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> x[i];
    }
    sort(x, x + n);
    cin >> x0 >> d >> q;
    for (ll i = 0; i < n; i++) {
        ll ost = x[i] % d;
        su[i + 1] = min(ost * ost, (d - ost) * (d - ost)) + su[i];
        pref[i + 1] = x[i] + pref[i];
        kv[i + 1] = x[i] * x[i] + kv[i];
    }
    while (q--) {
        cin >> t;
        ll lef = 0, rig = (ll)1e9 / d + 1;
        while (lef + 2 < rig) {
            ll r = (rig - lef) / 3;
            if (func(lef + r) > func(rig - r)) {
                lef += r;
            }
            else {
                rig -= r;
            }
        }
        ll ans = 2e18;
        for (ll k = lef; k <= rig; k++) {
            ans = min(ans, (ll)func(k));
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
}
