#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, m;
    cin >> n >> m;
    vector a(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char x;
            cin >> x;
            a[i][j] = x == '1';
        }
    }
    vector<ll> h(n);
    ll ans = 0;
    for (ll e = m - 1; e >= 0; e--) {
        for (ll i = 0; i < n; i++) {
            if (a[i][e]) {
                h[i]++;
            } else {
                h[i] = 0;
            }
        }
        vector<ll> prv(n, -1);
        vector<pair<ll, ll> > st;
        for (ll i = 0; i < n; i++) {
            while (!st.empty() && st.back().first >= h[i]) {
                st.pop_back();
            }
            if (!st.empty()) {
                prv[i] = st.back().second;
            }
            st.emplace_back(h[i], i);
        }
        vector<ll> dp(n, 0);
        for (ll i = 0; i < n; i++) {
            if (prv[i] == -1) {
                dp[i] = h[i] * (i + 1);
            } else {
                dp[i] = dp[prv[i]] + h[i] * (i - prv[i]);
            }
        }
        for (ll i = 0; i < n; i++) {
            ans = max(ans, dp[i]);
        }
    }
    cout << ans;
}
