#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
vector<vector<int>>g, dp;
vector<vector<vector<int>>>ns;
void dfs(int v, int rt) {
	int df_ind = -1, mn_df = INF;
	for (int ind = 0; ind < g[v].size();ind++) {
		int u = g[v][ind];
		ns[v][0].push_back(0);
		ns[v][1].push_back(0);
		if (u == rt)continue;
		dfs(u, v);
		if (dp[u][1] > dp[u][0]) {
			dp[v][0] += dp[u][1];
			ns[v][0].back() = 1;
		}
		else {
			dp[v][0] += dp[u][0];
		}
		if (dp[u][1] - dp[u][0] < mn_df) {
			mn_df = dp[u][1] - dp[u][0];
			df_ind = ind;
		}
	}
	dp[v][1] = dp[v][0];
	ns[v][1] = ns[v][0];
	//cout << "dp[" << v << "] mn_df=" << mn_df << " mn_ind=" << df_ind << "\n";
	if (mn_df < INF) {
		ns[v][1][df_ind] = 0;
		dp[v][1] += 1;
		if (mn_df >= 0)dp[v][1] -= mn_df;
	}
	//cout << "dp[" << v << "]={" << dp[v][0] << ", "<<dp[v][1]<<"}\n";

}
void output(int v,int rt, int st){
	//cout << v << " " << rt << " " << st << "\n";
	//for (auto c : ns[v][st])cout << c << " "; cout << "\n\n";
	for (int ind = 0; ind < g[v].size();++ind) {
		int u = g[v][ind];
		if (rt == u)continue;
		if (st == 1) {
			if (ns[v][st][ind] == 1)
			{
				output(u, v, 1);
			}
			else {
				cout << v+1 << " " << u+1 << "\n";
				output(u, v, 0);
				st = 0;
			}
		}
		else {
			output(u, v, ns[v][st][ind]);
		}
	}
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	int n, d; cin >> n >> d;
	g.resize(n);
	ns.resize(n, vector<vector<int>>(2));
	dp.resize(n, vector<int>(2));
	for (int i = 1; i < n; ++i) {
		int v, u; cin >> v >> u; --v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0, -1);
	//for (auto c : dp)cout << c[0] << " " << c[1] << "\n";

	if (dp[0][0] > dp[0][1]) {
		cout << dp[0][0] << "\n";
		output(0, -1, 0);
	}
	else {
		cout << dp[0][1] << "\n";
		output(0, -1, 1);
	}
}