#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 5e5 + 10;

int n, k, m[N];
pii otr[N];
vector<int> by_end[N];
int dp[N];

bool solve() {
    fill(dp, dp + n + 1, INF);
    for (int i = 0; i <= n; ++i) by_end[i].clear();
    for (int i = 1; i <= k; ++i) by_end[otr[i].Y].pb(i);

    dp[0] = 0;

    for (int i = 1; i <= n; ++i) {
        for (int j : by_end[i]) {
            for (int i1 = otr[j].X - 1; i1 < otr[j].Y; ++i1) {
                if (dp[i1] == INF) continue;
                if (dp[i1] < otr[j].X || i1 < m[j]) {
                    dp[i] = min(dp[i], m[j]);
                }
            }
        }
    }
    return (dp[n] != INF);
}

bool solve1() {
    vector<int> inds(k);
    iota(all(inds), 1);
    do {
        vector<bool> usd(n + 1, false);
        for (int i : inds) {
            if (usd[m[i]]) continue;
            for (int j = otr[i].X; j <= otr[i].Y; ++j) usd[j] = true;
        }
        bool f = true;
        for (int i = 1; i <= n; ++i) {
            if (!usd[i]) f = false;
        }
        if (f) {
            return true;
        }
    } while (next_permutation(all(inds)));
    return false;
}


mt19937 rnd(777);

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 0;
    cin >> ttt;
    while (ttt--) {
        cin >> n >> k;
        for (int i = 1; i <= k; ++i) cin >> otr[i].X >> m[i] >> otr[i].Y;
        bool my = solve();
        if (my) cout << "YES\n";
        else cout << "NO\n";
        continue;
        /*
        n = rnd() % 20; k = (rnd() % 8) + 1;
        for (int i = 1; i <= k; ++i) {
            otr[i].X = (rnd() % n) + 1;
            otr[i].Y = (rnd() % n) + 1;
            if (otr[i].Y < otr[i].X) swap(otr[i].X, otr[i].Y);
            m[i] = otr[i].X + (rnd() % (otr[i].Y - otr[i].X + 1));
        }*/
        bool correct = solve1();
        if (my != correct) {
            cout << "!!!\n";
            cout << n << ' ' << k << '\n';
            for (int i = 1; i <= k; ++i) {
                cout << otr[i].X << ' ' << m[i] << ' ' << otr[i].Y << '\n';
            }
            cout << "my: " << my << '\n';
            cout << "correct: " << correct << '\n';
            return 0;
        }
    }
    return 0;
}