#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 5e5 + 10;

int tree[N * 4];

void upd(int tind, int l, int r, int qind, int x) {
    if (r - l == 1) {
        tree[tind] = min(tree[tind], x);
        return;
    }
    int m = (r + l) >> 1;
    if (qind < m) upd(tind * 2 + 1, l, m, qind, x);
    else upd(tind * 2 + 2, m, r, qind, x);
    tree[tind] = min(tree[tind * 2 + 1], tree[tind * 2 + 2]);
}

int get(int tind, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) return tree[tind];
    if (ql >= r || l >= qr) return INF;
    int m =(r + l) >> 1;
    return min(get(tind * 2 + 1, l, m, ql, qr) , get(tind * 2 + 2, m, r, ql, qr));
}

int n, k, m[N];
pii otr[N];
vector<int> by_end[N];

bool solve() {
    for (int i = 0; i <= n; ++i) by_end[i].clear();
    for (int i = 1; i <= k; ++i) by_end[otr[i].Y].pb(i);
    fill(tree, tree + (n + 10) * 4, INF);

    upd(0, 0, n + 1, 0, 0);

    for (int i = 1; i <= n; ++i) {
        for (int j : by_end[i]) {
            int mn1 = get(0, 0, n + 1, otr[j].X - 1, m[j]);
            int mn2 = get(0, 0, n + 1, otr[j].X - 1, otr[j].Y);
            if (mn1 != INF || mn2 < otr[j].X) {
                upd(0, 0, n + 1, i, m[j]);
            }
        }
    }
    return (get(0, 0, n + 1, n, n + 1) != INF);
}

bool solve1() {
    vector<int> inds(k);
    iota(all(inds), 1);
    do {
        vector<bool> usd(n + 1, false);
        for (int i : inds) {
            if (usd[m[i]]) continue;
            for (int j = otr[i].X; j <= otr[i].Y; ++j) usd[j] = true;
        }
        bool f = true;
        for (int i = 1; i <= n; ++i) {
            if (!usd[i]) f = false;
        }
        if (f) {
            return true;
        }
    } while (next_permutation(all(inds)));
    return false;
}


mt19937 rnd(777);

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 0;
    cin >> ttt;
    while (ttt--) {
        cin >> n >> k;
        for (int i = 1; i <= k; ++i) cin >> otr[i].X >> m[i] >> otr[i].Y;
        bool my = solve();
        if (my) cout << "YES\n";
        else cout << "NO\n";
        continue;
        /*
        n = rnd() % 20; k = (rnd() % 8) + 1;
        for (int i = 1; i <= k; ++i) {
            otr[i].X = (rnd() % n) + 1;
            otr[i].Y = (rnd() % n) + 1;
            if (otr[i].Y < otr[i].X) swap(otr[i].X, otr[i].Y);
            m[i] = otr[i].X + (rnd() % (otr[i].Y - otr[i].X + 1));
        }*/
        bool correct = solve1();
        if (my != correct) {
            cout << "!!!\n";
            cout << n << ' ' << k << '\n';
            for (int i = 1; i <= k; ++i) {
                cout << otr[i].X << ' ' << m[i] << ' ' << otr[i].Y << '\n';
            }
            cout << "my: " << my << '\n';
            cout << "correct: " << correct << '\n';
            return 0;
        }
    }
    return 0;
}