#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//#define ordered_set tree<int, nullptr, less<int>, rb_tree_tag, tree_order_statistics_node_update>

using namespace std;

typedef long long ll;

void solve() {

    ll h, w;
    cin >> h >> w;

    vector<vector<ll>> a(h, vector<ll> (w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char x;
            cin >> x;
            a[i][j] = x - '0';
        }
    }

    ll mx = 0;
    for (int i = 0; i < w; i++) {

        vector<vector<ll>> dp(h, vector<ll> (w, 0));
        ll last = -1;
        for (int x = 0; x < h; x++) {
            ll cnt = 0;
            for (int y = i; y < w; y++) {

                if (a[x][y] == 0) {
                    last = y;
                    break;
                }
                ++cnt;

                if (y <= last) {
                    dp[x][y] = dp[x - 1][y] + cnt;
                } else {
                    if (y > 0) {
                        dp[x][y] = dp[x][y - 1] + 1;
                    } else {
                        dp[x][y] = 1;
                    }
                }
                mx = max(dp[x][y], mx);
            }
        }
    }
    cout << mx;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}