#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//#define ordered_set tree<int, nullptr, less<int>, rb_tree_tag, tree_order_statistics_node_update>

using namespace std;

typedef long long ll;

void solve() {

    ll h, w;
    cin >> h >> w;

    vector<vector<ll>> a(h, vector<ll> (w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char x;
            cin >> x;
            a[i][j] = x - '0';
        }
    }

    vector<vector<ll>> dp(h, vector<ll> (w, 0)), l(h, vector<ll> (w, 0));
    ll mx = a[0][0];
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            dp[i][j] = a[i][j];
            l[i][j] = j;
            if (i == 0 && j == 0) {
                continue;
            }

            if (a[i][j] == 1) {

                if (i == 0 || a[i - 1][j] == 0) {
                    dp[i][j] = (j > 0 ? dp[i][j - 1] : 0) + 1;
                    if (j > 0 && a[i][j - 1] == 1) {
                        l[i][j] = l[i][j - 1];
                    }

                } else if (j == 0 || a[i][j - 1] == 0) {
                    dp[i][j] = dp[i - 1][j] + 1;
                    if (j > 0) {
                        dp[i][j] -= dp[i - 1][j - 1];
                    }
                } else {
                    if (dp[i][j - 1] + 1 >= dp[i - 1][j] + 1 - dp[i - 1][j - 1]) {
                        dp[i][j] = dp[i][j - 1] + 1;
                        l[i][j] = l[i][j - 1];
                    } else {
                        dp[i][j] = dp[i - 1][j] + 1 - dp[i - 1][j - 1];
                        l[i][j] = l[i - 1][j];
                    }

                    ll mxl = max(l[i - 1][j], l[i][j - 1]);
                    ll s = dp[i - 1][j] + (j - l[i][j - 1] + 1);

                    if (mxl > 0 && l[i - 1][j] < l[i][j - 1]) {
                        s -= dp[i - 1][mxl - 1];
                    } else if (mxl > 0 && l[i - 1][j] > l[i][j - 1]) {
                        s -= mxl - l[i][j - 1];
                    }
                    if (s > dp[i][j]) {
                        dp[i][j] = max(dp[i][j], s);
                        l[i][j] = mxl;
                    }
                }
            }
            mx = max(mx, dp[i][j]);
        }
    }

    cout << mx;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}