#include <bits/stdc++.h>

using namespace std;

#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using i128 = __int128;
#define int ll

template<class A>
istream & operator >> (istream &in, ve<A> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}

template<class A>
ostream &operator << (ostream &out, ve<A> a) {
    for (auto &x : a)
        out << x << ' ';
    return out << '\n';
}

int32_t main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

     int n, m;
    cin >> n >> m;
    ve<ve<char>> a(n, ve<char>(m));
    cin >> a;
    ve<ve<int>> left(n, ve<int>(m+1, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == '1')
                left[i][j] = left[i][j+1] + 1;
        }
    }
    ve<ve<int>> pred(n, ve<int>(m, -1));
    for (int j = 0; j < m; ++j) {
        pred[0][j] = -1;
        ve<int> st = {0};
        for (int i = 1; i < n; ++i) {
            while (!st.empty() && left[st.back()][j] > left[i][j])
                st.pop_back();
            if (!st.empty())
                pred[i][j] = st.back();
            st.push_back(i);
        }
    }
    ve<ve<int>> dp(n, ve<int>(m, 0));
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '0')
                continue;
            if (pred[i][j] != -1)
                dp[i][j] = dp[pred[i][j]][j] + left[i][j] * (i - pred[i][j]);
            else
                dp[i][j] = (i+1) * left[i][j];
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}
