#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define int ll
int n, d;

vector<vector<int> > g;
vector<int> deep;
vector<int> nc, c;
vector<vector<int>> dp;
vector<int> opt;

void dfs(int v, int p) {
    deep[v] = deep[p] + 1;
    if (deep[v] % 2)
        nc.push_back(v);
    else
        c.push_back(v);
    for (auto u: g[v]) {
        if (!deep[u])
            dfs(u, v);
    }
}

void dpfs(int v, int p) {
    int s = 0;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        dpfs(u, v);
        s += dp[u][1];
    }
    dp[v][0] = s;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        s += dp[u][0] - dp[u][1];
        if (s + 1 > dp[v][1]) {
            dp[v][1] = s + 1;
            opt[v] = u;
        }
        s -= dp[u][0] - dp[u][1];
    }
}

void solve() {
    cin >> n >> d;
    g.resize(n + 1);
    deep.resize(n + 1);
    dp.resize(n + 1, vector<int>(2));
    opt.resize(n + 1);
    for (int i = 1, a, b; i < n; i++) {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 1);
    dpfs(1, 1);
    cout << max(dp[1][0], dp[1][1]) << "\n-1\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
