#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector <pair<int, int>> lr(k);
    vector <int> m(k);
    for (int i = 0; i < k; ++i) {
        cin >> lr[i].first >> m[i] >> lr[i].second;
        --m[i];
        --lr[i].first;
    }
    vector <bool> a(n, false);
    bool res = false;
    for (auto [l, r]: lr) res = res || (l == 0 && r == n);
    vector <array<int, 3>> left, right;
    for (int i = 0; i < k; ++i) {
        if (lr[i].first == 0) left.push_back({lr[i].first, lr[i].second, m[i]});
        if (lr[i].second == n) right.push_back({lr[i].first, lr[i].second, m[i]});
    }
    for (auto [l0, r0, m0]: left) for (auto [l1, r1, m1]: right) {
        // first right
        if (m0 < l1 && r0 >= l1) res = true;
        if (m1 >= r0 && l1 <= r0) res = true;
    }
    cout << (res ? "YES" : "NO") << "\n";
}

int main() {
    int T;
    for (cin >> T; T--; solve()) {}
    return 0;
}