#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<Node> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
	}

	for (int i = 0; i < k; ++i) {
		if (a[i].l == 1 and a[i].r == n) {
			cout << "YES\n";
			return;
		}
		for (int j = 0; j < k; ++j) {
			if (a[i].l == 1 and a[j].r == n) {
				if (a[j].l - 1 <= a[i].r and (a[i].r < a[j].m or a[i].m < a[j].l)) {
					cout << "YES\n";
					return;
				}
			}
		}
	}
	cout << "NO\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
