#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<Node> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
	}

	int mn = n + 1, mx = 0;
	for (int i = 0; i < k; ++i) {
		if (a[i].l == 1 and a[i].r == n) {
			cout << "YES\n";
			return;
		}
		if (a[i].m == 1)
			mx = max(mx, a[i].r);
		else
			mn = min(mn, a[i].l);
	}
	if (mn <= mx) 
		cout << "YES\n";
	else
		cout << "NO\n";
	
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
