#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e18;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

bool check(vector<bool>& a) {
	for (auto i : a)
		if (!i)
			return false;
	return true;
}

void solve() {
	int n;
	cin >> n;

	vector<int> x(n);
	for (auto& xi : x)
		cin >> xi;

	int x0, d;
	cin >> x0 >> d;

	int m;
	cin >> m;

	for (int i = 0; i < m; ++i) {
		int t;
		cin >> t;

		int ans = 0;
		int mn = INF;
		for (int xi : x) {
			
			for (int k = -1e6; k < 1e6; ++k) {
				int a = xi - (x0 + k * d);
				mn = min(mn, (a * a + k * t));
			}
		}
		cout << mn << '\n';
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}
