#include <bits/stdc++.h>
using namespace std;

struct s{
    int l, m, r;
};

bool operator<(s a, s b)
{
    return a.r < b.r;
}

int n;
vector<int> fen;

void fset(int i, int x) // v[i] = x
{
    for(++i; i <= n; i = (i|(i - 1)) + 1){
        fen[i] = max(fen[i], x);
    }
}

int fget(int i) // max(v[0], ... , v[i - 1])
{
    int ans = -1;
    for(; i > 0; i = (i&(i - 1))){
        ans = max(ans, fen[i]);
    }
    return ans;
}

void solve()
{
    int k;
    cin >> n >> k;
    vector<s> a(k);
    for(int i = 0; i < k; ++i){
        cin >> a[i].l >> a[i].m >> a[i].r;
        --a[i].l; --a[i].m; --a[i].r;
    }
    sort(a.begin(), a.end());
    fen.assign(n + 1, -1);
    vector<vector<int>> ind(k);
    for(int i = 0; i < k; ++i){
        int j = lower_bound(a.begin(), a.end(), (s){0, 0, a[i].m}) - a.begin();
        if(j != k) ind[j].push_back(i);
    }
    vector<bool> dp(k);
    for(int i = 0; i < k; ++i){
        int x = fget(n);
        for(int j : ind[i]){
            if(a[j].l - 1 <= x) dp[j] = 1;
        }
        if(!dp[i]){
            x = fget(a[i].l);
            if(a[i].m <= x) dp[i] = 1;
        }
        if(dp[i]){
            fset(a[i].m, a[i].r);
        }
    }
    if(fget(n) == n - 1) cout << "YES" << endl;
    else cout << "NO" << endl;
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; ++i) solve();
}