#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>

#include <functional>
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vb vc<bool>
 
struct P {
    int l, r, m;
};
 
void solve() {
    int n, k;
    cin >> n >> k;
    vc<P> p(k);
    for (int i = 0; i < k; ++i) {
        cin >> p[i].l >> p[i].m >> p[i].r;
        // --p[i].l; --p[i].r;
    }
    vi cur(k);
    for (int i = 0; i < k; ++i) cur[i] = i;
    function<bool()> check = [&]() {
        vb is(n);
        for (int id : cur) {
            P el = p[id];
            if (!is[el.m - 1]) {
                for (int i = el.l - 1; i < el.r; ++i) {
                    is[i] = 1;
                }
            }
        }
        for (bool el : is) {
            if (!el) {
                return 0;
            }
        }
        return 1;
    };

    if (check()) {
        cout << "YES\n";
        return;
    }
    while (next_permutation(all(cur))) {
        if (check()) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
    return;
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}