#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>

#include <functional>

using namespace std;

#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vb vc<bool>
#define pb push_back

struct P {
    int l, r, m;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vc<P> p(k);
    vvi g(n + 1);
    for (int i = 0; i < k; ++i) {
        cin >> p[i].l >> p[i].r >> p[i].m;
        --p[i].l; --p[i].r;
        g[p[i].l].pb(p[i].r + 1);
    }
    vb used(n + 1);
    function<void(int)> dfs = [&](int v) {
        used[v] = 1;
        for (int u : g[v]) {
            if (!used[u]) {
                dfs(u);
            }
        }
    };
    dfs(0);
    cout << (used[n] ? "YES\n" : "NO\n");
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}