#include  <bits/extc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-lopps")
#endif

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr), ios_base::sync_with_stdio(false);
#endif
    int h,w;
    cin >> h >> w;
    vector <vector <int>> a(h, vector <int> (w));
    for (int i = 0; i < h; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < w; j++)
            a[i][j] = s[j] - '0';
    }
    vector <vector <int>> dp(h, vector <int> (w,0));
    for (int j = 0; j < w; j++) {
        if (a[h - 1][j])
            dp[h - 1][j] = 1;
    }
    for (int i = h - 2; i >= 0; i--) {
        if (a[i][0]) {
            dp[i][0] = 1;
            if (a[i + 1][0])
                dp[i][0] += dp[i + 1][0];
        }
        for (int j = 1; j < w; j++) {
            if (a[i][j]) {
                dp[i][j] = 1;
                dp[i][j] += max(dp[i + 1][j], dp[i][j - 1]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            ans = max(ans, dp[i][j]);
    cout << ans;
    return 0;
}