#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;
void solve() {
    int h, w;
    cin >> h >> w;
    vector<string> t(h);
    for (int i = 0; i < h; ++i) {
        cin >> t[i];
    }
    vector<vector<int>> a(h, vector<int>(w, 0));
    for (int i = 0; i < h; ++i) {
        int cur = 0;
        for (int j = w - 1; j >= 0; --j) {
            if (t[i][j] == '1') {
                cur++;
            } else {
                cur = 0;
            }
            a[i][j] = cur;
        }
    }
    int mn = INF;
    int ans = 0;
    for (int i = h - 1; i >= 0; --i) {
        for (int j = 0; j < w; ++j) {
            int cur = 0;
            mn = INF;
            for (int k = i; k >= 0; --k) {
                cur += min(mn, a[k][j]);
                mn = min(mn, a[k][j]);
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
