#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    for (auto &[l, m, r]: s) {
        cin >> l >> m >> r;
    }
    sort(all(s), [&](const seg p1, const seg p2) {
        return p1.l < p2.l;
    });
    int mx = 1;
    for (int i = 0; i < k; ++i) {
        if (s[i].l <= mx) {
            mx = max(mx, s[i].r);
        }
    }
    if (mx == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
