#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    for (auto &[l, m, r]: s) {
        cin >> l >> m >> r;
    }
    sort(all(s), [&](const seg p1, const seg p2) {
        return p1.m < p2.m;
    });
    vector<int> dpl(k, 0);
    vector<int> dpr(k, 0);
    if (s[0].l != 1) {
        cout << "NO\n";
        return;
    }
    dpl[0] = 1;
    for (int i = 1; i < k; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dpl[j] && s[j].r >= s[i].l - 1 && s[j].r <= s[i].m) {
                dpl[i] = 1;
                break;
            }
        }
    }
    if (s[k - 1].r != n) {
        cout << "NO\n";
        return;
    }
    dpr[k - 1] = 1;
    for (int i = k - 2; i >= 0; --i) {
        for (int j = k - 1; j > i; --j) {
            if (dpr[j] && s[j].l >= s[i].m && s[j].l <= s[i].r + 1) {
                dpr[i] = 1;
                break;
            }
        }
    }
    for (int i = 0; i < k; ++i) {
        if (dpl[i] && dpr[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
