#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    for (auto &[l, m, r]: s) cin >> l >> m >> r;
    vector<int> used(n + 1, 0);
    for (auto [l, m, r]: s) {
        used[l]++;
        if (r != n) {
            used[r + 1]--;
        }
    }
    for (int i = 1; i <= n; ++i) {
        used[i] += used[i - 1];
        if (used[i] < 1) {
            cout << "NO\n";
            return;
        }
    }
    vector<seg> cur;
    while (!s.empty()) {
        vector<seg> next;
        used.assign(n + 1, 0);
        for (auto [l, m, r]: s) {
            used[l]++;
            if (r != n) {
                used[r + 1]--;
            }
        }
        for (int i = 1; i <= n; ++i) {
            used[i] += used[i - 1];
        }
        for (int i = 0; i < (int) s.size(); ++i) {
            if (used[s[i].m] == 1) {
                cur.push_back(s[i]);
                continue;
            }
            next.push_back(s[i]);
        }
        if (next.size() == s.size()) {
            break;
        }
        s = next;
        next.clear();
    }
    used.assign(n + 1, 0);
    for (auto [l, m, r]: cur) {
        used[l]++;
        if (r != n) {
            used[r + 1]--;
        }
    }
    for (int i = 1; i <= n; ++i) {
        used[i] += used[i - 1];
        if (used[i] < 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}