#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int) x.size()
#define all(x) x.begin(), x.end()
#define int long long

vector<pair<int, int>> ans;
vector<vector<int>> g, dp;
vector<int> h, e, o;
int n, d;

struct triple {
    int ind, h, c;

    triple() {}

    triple(int ind1, int h1, int c1) {
        ind = ind1, h = h1, c = c1;
    }
};

bool comp(triple x, triple y) {
    return x.h > y.h;
}

void dfss1(int v, int pred) {
    h[v] = h[pred] + 1;
    for (int i: g[v]) {
        if (i == pred) {
            continue;
        }
        dfss1(i, v);
    }
}

void dfss(int v, int pred) {
    vector<triple> order = {{v, h[v], v}};
    for (int i: g[v]) {
        if (i == pred) {
            continue;
        }
        dfss(i, v);
        for (auto it: dp[i]) {
            order.pb({it, h[it], i});
        }
    }
    sort(all(order), comp);
    vector<int> used(sz(order));
    for (int i = 0; i < sz(order); ++i) {
        if (used[i]) {
            continue;
        }
        for (int j = i + 1; j < sz(order); ++j) {
            if (!used[j] && order[i].c != order[j].c && order[i].h % 2 != order[j].h % 2 &&
                order[i].h + order[j].h - 2 * h[v] <= d) {
                ans.pb({order[i].ind, order[j].ind});
                used[i] = 1;
                used[j] = 1;
                break;
            }
        }
    }
    for (int i = 0; i < sz(order); ++i) {
        if (!used[i] && order[i].h - h[v] <= d - 1) {
            dp[v].pb(order[i].ind);
        }
    }
}

int dfs(int v, int pred) {
    bool was = false;
    for (int i : g[v]) {
        if (i == pred) {
            continue;
        }
        int x = dfs(i, v);
        if (x && !was) {
            was = true;
            ans.pb({i, v});
        }
    }
    if (!was) {
        return 1;
    }
    return 0;
}

void dfs1(int v, int pred) {
    h[v] = h[pred] + 1;
    if (h[v] & 1) {
        o.pb(v);
    } else {
        e.pb(v);
    }
    for (int i : g[v]) {
        if (i == pred) {
            continue;
        }
        dfs1(i, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d;
    h.resize(n + 1);
    g.resize(n + 1);
    dp.resize(n + 1);
    for (int i = 1; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        g[l].pb(r);
        g[r].pb(l);
    }
    if (d == 1) {
        dfs(1, 1);
    } else if (d == n - 1) {
        dfs1(1, 1);
        if (sz(e) > sz(o)) {
            swap(o, e);
        }
        for (int i = 0; i < sz(e); ++i) {
            ans.pb({e[i], o[i]});
        }
    } else {
        dfss1(1, 1);
        dfss(1, 1);
    }
    cout << sz(ans) << "\n";
    for (auto it: ans) {
        cout << it.first << " " << it.second << "\n";
    }
    return 0;
}