#include <bits/stdc++.h>

using namespace std;

vector<int> tree, modif;

void change(int x, int l, int r, int ql, int qr, int val) {
    if (l == ql && r == qr) {
        tree[x] = val;
        modif[x] = val;
        return;
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (qr <= m) {
        change(2 * x + 1, l, m, ql, qr, val);
        return;
    }
    if (ql >= m) {
        change(2 * x + 2, m, r, ql, qr, val);
        return;
    }
    change(2 * x + 1, l, m, ql, m, val);
    change(2 * x + 2, m, r, m, qr, val);
}

int get(int x, int l, int r, int id) {
    if (r - l == 1) {
        return tree[x];
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (id < m) {
        return get(2 * x + 1, l, m, id);
    } else {
        return get(2 * x + 2, m, r, id);
    }
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int sz = m + 2;
    tree.resize(4 * sz -1);
    modif.resize(4 * sz, -2);
    vector<vector<int>> v(n, vector<int> (m)), near(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            v[i][j] = c - '0';
        }
    }
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j]) {
                cnt++;
            } else {
                cnt = 0;
            }
            near[i][j] = cnt;
        }
    }
    int ans = 0;
    for (int j = 0; j < m; j++) {
        int id = 0;
        vector<int> sm;
        change(0, 0, sz, 0, sz, -1);
        for (int i = 0; i < n; i++) {
            if (v[i][j]) {
                int id_2 = get(0, 0, sz,  near[i][j]);
                if (id_2 == -1) {
                    sm.push_back((id - id_2) * near[i][j]);
                } else {
                    sm.push_back(sm[id_2] + (id - id_2) * near[i][j]);
                }
                change(0, 0, sz, near[i][j] + 1, sz, id);
                ans = max(ans, sm.back());
                id++;
            } else {
                sm.clear();
                id = 0;
                change(0, 0, sz, 0, sz, -1);
            }
        }
    }
    cout << ans;
}
