#include <bits/stdc++.h>

using namespace std;

struct node {
    int l, m, r;
};

vector<int> tree, modif;

void change(int x, int l, int r, int ql, int qr, int val) {
    if (l == ql && r == qr) {
        tree[x] += val;
        modif[x] += val;
        return;
    }
    if (modif[x] != 0) {
        tree[2 * x + 1] += modif[x];
        tree[2 * x + 2] += modif[x];
        modif[2 * x + 1] += modif[x];
        modif[2 * x + 2] += modif[x];
        modif[x] = 0;
    }
    int m = (l + r) / 2;
    if (qr <= m) {
        change(2 * x + 1, l, m, ql, qr, val);
        return;
    }
    if (ql >= m) {
        change(2 * x + 2, m, r, ql, qr, val);
        return;
    }
    change(2 * x + 1, l, m, ql, m, val);
    change(2 * x + 2, m, r, m, qr, val);
}

int get(int x, int l, int r, int id) {
    if (r - l == 1) {
        return tree[x];
    }
    if (modif[x] != 0) {
        tree[2 * x + 1] += modif[x];
        tree[2 * x + 2] += modif[x];
        modif[2 * x + 1] += modif[x];
        modif[2 * x + 2] += modif[x];
        modif[x] = 0;
    }
    int m = (l + r) / 2;
    if (id < m) {
        return get(2 * x + 1, l, m, id);
    } else {
        return get(2 * x + 2, m, r, id);
    }
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k, f = 1;
        cin >> n >> k;
        tree.resize(4 * n);
        modif.resize(4 * n);
        set<int> s;
        vector<int> cnt(k), m(k), l(k), r(k);
        for (int i = 0; i < k; i++) {
            cin >> l[i] >> m[i] >> r[i];
            m[i]--;
            l[i]--;
            change(0, 0, n, l[i], r[i], 1);
        }
        for (int i = 0; i < n; i++) {
            if (!get(0, 0, n, i)) {
                f = 0;
            }
        }
        for (int i = 0; i < k; i++) {
            cnt[i] = get(0, 0, n, m[i]);
        }
        for (int i = 0; i < k; i++) {
            int id = -1;
            for (int j = 0; j < k; j++) {
                if (cnt[j] == 1) {
                    id = j;
                }
            }
            if (id == -1) {
                f = 0;
                break;
            }
            for (int j = 0; j < k; j++) {
                if (m[j] >= l[id] && m[j] <= r[id]) {
                    cnt[j]--;
                }
            }
        }
        if (f) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}