#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> dp;
vector<vector<int>> v;
vector<pair<int, int>> ans;

void dfs(int x, int p) {
    int mx = -1;
    for (auto j : v[x]) {
        if (j != p) {
            dfs(j, x);
            dp[0][x] += max(dp[1][j], dp[0][j]);
            if (mx == -1 || dp[0][j] - dp[1][j] >= dp[0][mx] - dp[1][mx]) {
                mx = j;
            }
        }
    }
    dp[1][x] = dp[0][x];
    if (mx == -1) {
        return;
    }
    if (dp[0][mx] < dp[1][mx]) {
        dp[1][x] -= dp[1][mx];
        dp[1][x] += dp[0][mx];
    }
    dp[1][x] += 1;
}

void get(int x, int p, int t) {
    if (t == 0) {
        for (auto j : v[x]) {
            if (j != p) {
                t = 0;
                if (dp[1][j] > dp[0][j]) {
                    t = 1;
                }
                get(j, x, t);
            }
        }
    } else {
        int mx = -1;
        for (auto j : v[x]) {
            if (j != p) {
                if (mx == -1 || dp[0][j] - dp[1][j] >= dp[0][mx] - dp[1][mx]) {
                    mx = j;
                }
            }
        }
        ans.emplace_back(x, mx);
        for (auto j : v[x]) {
            if (j != p) {
                t = 0;
                if (dp[1][j] > dp[0][j] && mx != j) {
                    t = 1;
                }
                get(j, x, t);
            }
        }
    }
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int n, d;
    cin >> n >> d;
    v.resize(n);
    dp.resize(2, vector<int> (n));
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    dfs(0, 0);
    int t = 0;
    if (dp[1][0] > dp[0][0]) {
        t = 1;
    }
    get(0, 0, t);
    cout << max(dp[0][0], dp[1][0]) << '\n';
    for (auto [a, b] : ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}
