#include <bits/stdc++.h>
#define all(x) x.begin(),x.end()

using namespace std;

int n , k;
struct node {
    int l , m , r;
};
bool cmp(node &a , node &b) {
    return (a.r == b.r ? a.l < b.l : a.r < b.r);
}

node get(node a , node b) {
    return {max(a.l , b.l) , 0 , min(a.r , b.r)};
}

void solve() {
    cin >> n >> k;
    vector<node> a(k);
    for(int i = 0 ; i < k ; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    sort(all(a) , cmp);
    vector<int> dp(k);
    for (int i = 0 ; i < k ; i++) {
        if (a[i].l == 1) {
            dp[i] = 1;
            continue;
        }
        for (int j = i - 1 ; j >= 0 ; j--) {
            if (dp[j] && a[j].r >= a[i].l && !(a[j].m >= a[i].l && a[i].m <= a[j].r) || dp[j] && a[j].r + 1 == a[i].l) {
                dp[i] = 1;
                break;
            }
        }
    }
    for(int i = 0 ; i < k ; i++) {
        if(dp[i] && a[i].r == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
