#include <bits/stdc++.h>;

using namespace std;

using ll = long long;

ll n;
ll d;

vector<vector<ll>> g;

vector<ll> pred;
vector<vector<ll>> deti;

vector<ll> glub;

vector<bool> used;

void build_deti(ll now) {
    used[now] = true;
    for (ll to : g[now]) {
        if (!used[to]) {
            pred[to] = now;
            deti[now].push_back(to);
            glub[to] = glub[now] + 1;
            build_deti(to);
        }
    }
}

void solve() {
    cin >> n;

    cin >> d;

    g.clear();
    g.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--; v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    pred.clear();
    pred.resize(n);
    pred[0] = -1;
    deti.clear();
    deti.resize(n);
    glub.clear();
    glub.resize(n);
    glub[0] = 0;

    used.clear();
    used.resize(n, false);

    build_deti(0);

    vector<ll> ver_with_chet_glub;
    vector<ll> ver_with_nechet_glub;
    for (ll i = 0; i < n; i++) {
        if (glub[i] % 2 == 0) {
            ver_with_chet_glub.push_back(i);
        } else {
            ver_with_nechet_glub.push_back(i);
        }
    }

    ll ans = min(ver_with_chet_glub.size(), ver_with_nechet_glub.size());

    cout << ans << '\n';
    for (ll i = 0; i < ans; i++) {
        cout << ver_with_chet_glub[i] + 1 << ' ' << ver_with_nechet_glub[i] + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    solve();
    cout << endl;
    return 0;
}
