#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (ll i = 0; i < h; i++) {
        cin >> a[i];
    }
    vector<vector<ll>> b(h, vector<ll>(w));
    for (ll i = 0; i < h; i++) {
        for (ll j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                b[i][j] = 0;
            } else {
                if (j == w - 1) {
                    b[i][j] = 1;
                } else {
                    b[i][j] = b[i][j + 1] + 1;
                }
            }
        }
    }
    ll answer = 0;
    for (ll i = 0; i < h; i++) {
        for (ll j = 0; j < w; j++) {
            if (a[i][j] == '0') {
                continue;
            }
            ll k1 = b[i][j];
            ll x = b[i][j];
            for (ll i1 = i - 1; i1 >= 0; i1--) {
                if (b[i1][j] != 0) {
                    k1 += min(x, b[i1][j]);
                    x = min(x, b[i1][j]);
                } else {
                    break;
                }
            }
            answer = max(answer, k1);
        }
    }
    cout << answer;
}