#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <array>
#include <set>
#include <queue>
#include <bitset>
#define all(v) v.begin(), v.end()
using namespace std;

vector<vector<int>> g;
vector<int> col;
void dfs(int s, int pred) {
	for (auto to : g[s]) {
		if (to != pred) {
			col[to] = col[s] ^ 1;
			dfs(to, s);
		}
	}
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	int d;
	cin >> d;
	int s = 0;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	col.resize(n);
	dfs(0, -1);
	int cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; i++) {
		if (col[i] == 0) {
			cnt1++;
		}
		else {
			cnt2++;
		}
	}
	cout << min(cnt1, cnt1) << " " << -1;


}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}