#include <bits/stdc++.h>

using namespace std;
int cnt = 0, now = 0;

void dfs(int v, vector<vector<int>> &gr, vector<int> &used, vector<int> &e) {
    used[v] = 1;
    ++now;
    for (int u: gr[v]) {
        if (!used[u]) {
            dfs(u, gr, used, e);
            if (e[u] == -1 && e[v] == -1) {
                e[u] = v;
                e[v] = u;
            }
        }
    }
    --now;
}

void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }

    vector<int> used(n, 0), e(n, -1);
    dfs(0, gr, used, e);

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (e[i] != -1)
            ++ans;
    }
    cout << ans / 2 << '\n';
    for (int i = 0; i < n; ++i) {
        if (e[i] != -1) {
            cout << i + 1 << ' ' << e[i] + 1 << '\n';
            e[e[i]] = -1;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout << '\n';
    }
}