#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;


void solve() {
    ll w, h;
    cin >> w >> h;
    vector<vector<int>> a(w, vector<int>(h));
    vector<vector<int>> nxt(w, vector<int>(h, -1));
    for (int i = 0; i < w; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < h; ++j) {
            a[i][j] = s[j]-'0';
        }
    }

    for (int i = 0; i < w; ++i) {
        nxt[i][h-1] = h;
        for (int j = h-2; j >=0; --j) {
            if (a[i][j] == 1 && a[i][j+1] != a[i][j]) {
                nxt[i][j] = j+1;
            } else if (a[i][j] == 1) {
                nxt[i][j] = nxt[i][j+1];
            } else {
                nxt[i][j] = j;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < h; ++i) {
        vector<int> cnt(w);
        for (int j = 0; j < w; ++j) {
            cnt[j] = nxt[j][i]-i;
        }
        vector<int> lf(w);
        vector<pair<int, int>> st;
        st.push_back({-1, -1});
        for (int j = 0; j < w; ++j) {
            while (st.back().first >= cnt[j]) {
                st.pop_back();
            }
            lf[j] = st.back().second;
            st.push_back({cnt[j],j} );
        }
        vector<int> dp(w);
        for (int j = 0; j < w; ++j) {
            if (lf[j] == -1) {
                dp[j] = cnt[j] * (j+1);
            } else {
                dp[j] = cnt[j] * (j-lf[j]) + dp[lf[j]];
            }
            ans = max(ans, dp[j]);
        }
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    // freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while(tt--) {
        solve();
        cout << '\n';
    }
}