

#include <bits/stdc++.h>
#define int long long

struct Node
{
    int l, r, m;
    Node(int l, int r, int m) : l(l), r(r), m(m) {};
    Node() = default;
};

bool was = false;

void dfs(int v, std::vector<Node> &all, std::vector<bool> &used)
{
    if (used[v])
    {
        was = true;
        return;
    }
    used[v] = true;

    for (int i = 0; i < all.size(); i++)
    {
        if (all[i].l <= all[v].m && all[v].m <= all[i].r)
        {
            dfs(i, all, used);
        }
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int t;
    std::cin >> t;

    while (t--)
    {
        was = false;
        int n, k;
        std::cin >> n >> k;

        std::vector<Node> all(k);
        for (int i = 0; i < k; i++)
        {
            int l, m, r;
            std::cin >> l >> m >> r;

            all[i] = Node(l, r, m);
        }

        std::vector<bool> used(k, false);
        for (int i = 0; i < k; i++)
        {
            if (!used[i])
            {
                dfs(i, all, used);
            }
        }

        if (was)
        {
            std::cout << "NO" << std::endl;
        }
        else
        {
            std::cout << "YES" << std::endl;
        }
    }
}