

#include <bits/stdc++.h>
#define int long long

const int MAXN = 4 * 1e5;
int dp[MAXN][2];
int prev[MAXN][2];

void dfs(int v, std::vector<std::vector<int>> &g, int pred = -1)
{
    int ind = 0;
    int max = -1e18;
    int sum = 0;
    int cnt = 0;
    for (int u : g[v])
    {
        if (u != pred)
        {
            cnt++;
            dfs(u, g, v);
            if (dp[u][0] - dp[u][1] > max)
            {
                max = dp[u][0] - dp[u][1];
                ind = u;
            }
            sum += dp[u][1];
        }
    }

    if (cnt == 0)
    {
        dp[v][1] = 0;
        dp[v][0] = 0;
        return;
    }

    dp[v][1] = sum + max + 1;
    dp[v][0] = sum;
    prev[v][1] = ind;
}

std::vector<std::pair<int, int>> ans;

void upd(int v, int now, std::vector<std::vector<int>> &g, int pred = -1)
{
    if (now == 1)
    {
        ans.push_back({v, prev[v][now]});
        for (int u : g[v])
        {
            if (u == pred)
            {
                continue;
            }
            if (u == prev[v][now])
            {
                upd(u, 0, g, v);
            }
            else
            {
                upd(u, 1, g, v);
            }
        }
    }
    else
    {
        for (int u : g[v])
        {
            if (u == pred)
            {
                continue;
            }
            upd(u, 1, g, v);
        }
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n;
    std::cin >> n;
    int d;
    std::cin >> d;

    std::vector<std::vector<int>> g(n);

    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        std::cin >> a >> b;

        a--, b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs(0, g);
    // std::cout << "dfjg" << std::endl;

    if (dp[0][1] > dp[0][0])
    {
        std::cout << dp[0][1] << std::endl;
        upd(0, 1, g);
    }
    else
    {

        std::cout << dp[0][0] << std::endl;
        upd(0, 0, g);
    }
    std::cout < -1 << std::endl;
    return 0;
    for (int i = 0; i < ans.size(); i++)
    {
        std::cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << std::endl;
    }
}