#include <iostream>
#include <vector>
#include <algorithm>

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using namespace std;
using ll = long long;
using pii = pair<int, int>;

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<string> a(n);
    for(auto& e : a) cin >> e;
    vector<vector<int>> sz(n, vector<int>(m));
    for(int i = 0; i < n; i++) {
        int cnt = 0;
        for(int j = m - 1; j >= 0; j--) {
            if(a[i][j] == '0') cnt = 0;
            else cnt++;
            sz[i][j] = cnt;
        }
    }
    // for(int i = 0; i < n; i++) {
    //     for(int j = 0; j < m; j++) {
    //         cout << sz[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    // cout << endl;
    int ans = 0;
    for(int j = 0; j < m; j++) {
        vector<pii> col;
        int cur = 0;
        for(int i = 0; i < n; i++) {
            // int k = lower_bound(col.begin(), col.end(), sz[i][j]) - col.begin();
            // if(k < col.size()) {
            //     for(int l = k; l < col.size(); l++) {
            //         cur -= col[l] - sz[i][j];
            //         col[l] = sz[i][j];
            //     }
            // }
            // cur += sz[i][j];
            // col.push_back(sz[i][j]);
            // ans = max(ans, cur);
            int k = lower_bound(col.begin(), col.end(), make_pair(sz[i][j], 0)) - col.begin();
            if(k < col.size()) {
                int cnt = 0;
                for(int l = k; l < col.size(); l++) {
                    cur -= col[l].first * col[l].second;
                    cnt += col[l].second;
                }
                for(int l = col.size() - 1; l >= k; l--) col.pop_back();
                col.push_back(make_pair(sz[i][j], cnt + 1));
                cur += cnt * sz[i][j];
                cur += sz[i][j];
            } else {
                col.push_back(make_pair(sz[i][j], 1));
                cur += sz[i][j];
            }
            //cout << cur << ' ';
            ans = max(cur, ans);
        }
        //cout << '\n';
    }
    cout << ans << endl;
}