#include <iostream>
#include <vector>
#include <algorithm>
 
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
using namespace std;
using ll = long long;

void run1();
 
int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int tst; cin >> tst;
    while(tst--) run1();
}

struct pers {
    int l, r, m;
    pers(){}
    pers(int _l, int _m, int _r): l(_l), r(_r), m(_m){}
};

bool operator<(pers a, pers b) {
    return a.l < b.l;
}

void run1() {
    int n, k; cin >> n >> k;
    vector<pers> a(k);
    for(int i = 0; i < k; i++) {
        int _l, _r, _m; cin >> _l >> _m >> _r;
        a[i] = pers(_l, _m, _r);
    }
    sort(a.begin(), a.end());
    vector<bool> dp(n + 1);
    dp[0] = 1;
    for(int i = 0; i < k; i++) {
        if(dp[a[i].l - 1]) dp[a[i].r] = 1;
    }
    cout << (dp[n] ? "YES" : "NO") << '\n';
}