#include <iostream>
#include <vector>
using namespace std;
int give_ans(vector<pair<int,int>> &vec,int last_h) {
    if (vec.size() == 0)return 0;
    int l = -1,r = vec.size();
    while (r - l > 1) {
        int mid = (r+l)/2;
        if (vec[mid].first >= last_h) {
            r = mid;
        }else {
            l = mid;
        }
    }
    return r;
}
signed main() {
    int h,w;
    cin >> h >> w;
    vector <vector <int>> matr(h,vector <int> (w)),f_l(h,vector <int> (w,1e9)),dp = matr,f_up = matr;
    for (int i = 0;i < h;i++) {
        string s;
        cin >> s;
        for (int j = 0;j < w;j++) {
            matr[i][j] = s[j] - '0';
        }
    }
    for (int i = 0;i < h;i++) {
        for (int j = w - 1;j >= 0;j--) {
            if (!matr[i][j])continue;
            if (matr[i][j]) {
                f_up[i][j] = i;
            }
            if (i- 1 >= 0 && matr[i-1][j]) {
                f_up[i][j] = f_up[i-1][j];
            }
        }
    }
    for (int i = 0;i < h;i++) {
        vector <pair<int,int>> stack;
        for (int j = w - 1;j >= 0;j--) {
            if (!matr[i][j])continue;
            int hh = i - f_up[i][j] + 1;
            int pos = give_ans(stack,hh);
            if (pos == stack.size()) {
                f_l[i][j] = j;
            }else {
                f_l[i][j] = stack[pos].second;
            }
            while (!stack.empty() && stack.back().first > hh) {
                stack.pop_back();
            }
            if (stack.empty() || stack.back().first != hh) {
                stack.push_back({hh,j});
            }
        }
    }
    int max_cnt = 0;
    for (int i = 0;i < h;i++) {
        for (int j = w-1;j >= 0;j--) {
            int max_len = 1e9,cnt = 0;
            if (matr[i][j] == 0)continue;
            int r =  f_l[i][j];
            max_len = i - f_up[i][j] + 1;

            cnt = i - f_up[i][j] + 1;
            cnt *= (r - j + 1);
            if (r + 1 < w && matr[i][r+1])cnt += dp[i][r+1];
            dp[i][j] = cnt;
            max_cnt = max(max_cnt,cnt);
        }
    }

    cout << max_cnt;
}