#include <iostream>
#include <vector>
#include <set>
using namespace std;
void dfs(int u,vector <vector <int>> &g,vector <pair<int,int>> &dp,int p,vector <int> &pr) {
    int sum = 0;
    for (auto el : g[u]) {
        if (el == p)continue;
        dfs(el,g,dp,u,pr);
        sum += max(dp[el].first,dp[el].second);
    }
    int pred = -1,maxsum = 0;
    for (auto el : g[u]) {
        if (el == p)continue;
        int val_now =  sum - max(dp[el].first,dp[el].second) + dp[el].first + 1;
        if (val_now > maxsum) {
            maxsum = val_now;
            pred = el;
        }
    }
    pr[u] = pred;
    dp[u].second = maxsum;
    dp[u].first = sum;
}
vector <pair<int,int>> ans;
signed main() {
    int n,d;
    cin >> n >> d;
    vector <vector <int>> g(n);
    for (int i = 0;i < n - 1;i++) {
        int u,v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back((v));
        g[v].push_back((u));
    }
    vector <pair<int,int>> dp(n);
    vector <int> pr(n,-1);
    vector <bool> fl(n,0);
    dfs(0,g,dp,-1,pr);
    cout << max(dp[0].first,dp[0].second) << "\n-1" ;
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.