#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, m; cin >> n >> m;
    vector<vector<char> >a(n+1, vector<char>(m));
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int> >pref(n+1, vector<int>(m+1));
    for (int i = 1; i <= n; i++) {
        for (int j = m-1; j >= 0; j--) {
            if (a[i][j] == '1') {
                pref[i][j] = pref[i][j+1]+1;
            }
        }
    }
    for (int j = 0; j < m; j++) pref[0][j] = -1;
    vector<vector<int> >min_up(n+1, vector<int>(m));
    for (int j = 0; j < m; j++) {
        stack<int>bb;
        for (int i = n; i >= 0; i--) {
            while (!bb.empty() && pref[bb.top()][j] >= pref[i][j]) {
                min_up[bb.top()][j] = i;
                bb.pop();
            }
            bb.push(i);
        }
    }
    vector<vector<int> >ans(n+1, vector<int>(m, 0));
    for (int j = 0; j < m; j++) {
        for (int i = 1; i <= n; i++) {
            ans[i][j] = ans[min_up[i][j]][j] + (i-min_up[i][j])*pref[i][j];
        }
    }
    int ans_max = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < m; j++) {
            ans_max = max(ans_max, ans[i][j]);
        }
    }
    cout << ans_max << endl;
    return 0;
}