#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> s(n);

    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r; l--; m--; r--;
        s[m].emplace_back(l, r);
    }

    vector<int> dp(n + 1, -1);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        for (auto [l, r] : s[i - 1]) {
            // cout << "l: " << l << '\n';
            for (int j = i - 1; j >= l; j--) {
                // cout << "j: " << j << '\n';
                if (dp[j] != -1) {
                    if (j + dp[j] <= i - 1) {
                        dp[i] = max(dp[i], r - (i - 1));
                        // cout << "dp[i]: " << dp[i] << '\n';
                    }
                }
            }
        }
        for (int j = i - 1; j >= 0; j--) {
            if (dp[j] != -1) {
                if (j + dp[j] - 1 >= i - 1) {
                    int t = (j + dp[j] - 1) - (i - 1);
                    assert(t >= 0);
                    if (dp[i] == -1) dp[i] = t;
                    else dp[i] = min(dp[i], t);
                }
            }
        }
    }
    // for (int e : dp) cout << e << ' ';
    // cout << '\n';
    if (dp[n] == -1) cout << "NO\n";
    else cout << "YES\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
}