#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> s(n);

    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r; l--; m--; r;
        s[m].emplace_back(l, r);
    }

    vector<int> dp(n + 1, -1);
    dp[0] = 0;

    for (int i = 1; i <= n; i++) {
        int current = i - 1;
        for (auto [l, r] : s[current]) {
            // cout << "l: " << l << '\n';
            for (int j = i - 1; j >= l; j--) {  // FIXME
                // cout << "j: " << j << '\n';
                if (dp[j] != -1) {
                    if (dp[j] <= current) {
                        dp[i] = max(dp[i], r);
                        // cout << "dp[i]: " << dp[i] << '\n';
                    }
                }
            }
        }
        for (int j = i - 1; j >= 0; j--) {
            if (dp[j] != -1) {
                if (dp[j] > current) {
                    if (dp[i] == -1) dp[i] = dp[j];
                    else dp[i] = min(dp[i], dp[j]);
                }
            }
        }
    }
    // for (int e : dp) cout << e << ' ';
    // cout << '\n';
    if (dp[n] == -1) cout << "NO\n";
    else cout << "YES\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
}