#include <algorithm>
#include <iostream>
#include <vector>
  
using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
  
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}
void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (auto &x : a) {
        for (auto &y : x) {
            char c;
            cin >> c;
            y = c - '0';
        }
    }
    vector<vector<ll>> ct(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        ct[i][m - 1] = a[i][m - 1];
        for (int j = m - 2; j >= 0; --j) {
            ct[i][j] = (ct[i][j + 1] + 1) * a[i][j];
        }
    }
    ll mx = 0;
    for (int i = 0; i < n; ++i) {
        for (int j  = 0; j < m; ++j) {
            ll x = 0, z = 0;
            for (int k = j; k < m; ++k) {
                if (!a[i][k]) break;
                ++x;
            }
            for (int k = i; k >= 0; --k) {
                z += (x = min(x, ct[k][j]));
            }
            mx = max(mx, z);
        } 
    }
    cout << mx;
}
int main() {
  Solve();
}