#include <algorithm>
#include <iostream>
#include <vector>
  
using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
#define ff first
#define ss second
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}

bool is1(vector<pair<pair<ll, ll>, ll>> &a) {
    for (auto &x : a) if (x.ss != x.ff.ff) return 0;
    return 1;
}

void Solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<pair<ll, ll>, ll>> a(k);
    for (int i = 0; i < k; ++i) cin >> a[i].ff.ff >> a[i].ss >> a[i].ff.ss;
    if (is1(a)) {
        sort(all(a), [](pair<pair<ll, ll>, ll> &a, pair<pair<ll, ll>, ll> &b){
            return (a.ff.ff == b.ff.ff ? a.ff.ss < b.ff.ss : a.ff > b.ff);
        });
        for (int i = 1; i < k; ++i) {
            if (a[i].ff.ss < a[i - 1].ff.ff - 1) {
                cout << "NO\n";
                return;
            }
        }
        cout << "YES\n";
        return;
    }
}
int main() {
    ll t;
    cin >> t;
    while(t--) Solve();
}