#include <algorithm>
#include <iostream>
#include <vector>
  
using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
#define ff first
#define ss second
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}

struct SegTree {
    vector<ll> t;
    vector<ll> p;
    void upd(ll v, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            ++t[v];
            ++p[v];
            return;
        }
        if (lx > r || l > rx) return;
        ll mid = lx + rx >> 1;
        upd(v * 2, lx, mid, l, r);
        upd(v * 2 + 1, mid + 1, rx, l, r);
        t[v] = min(t[v * 2], t[v * 2 + 1]) + p[v];
    }
    ll ans() {
        return t[1];
    }
    SegTree (ll n) : t(4 * n, 0), p(4 * n, 0) {}
};

void Solve() {
    ll n;
    cin >> n;
    vector<ll> x(n);
    cin >> x;
    ll x0, d, m;
    cin >> x0 >> d >> m;
    vector<ll> a(m);
    cin >> a;
    ll z = 0;
    for (ll k : x) {
        z += min(abs(k - x0) % d, abs(k - x0) % d + d) * min(abs(k - x0) % d, abs(k - x0) % d + d);
    }
    cout << z;
}
int main() {
    Solve();
}