#include <bits/stdc++.h>
 
using namespace std;

void solve1(int n, int m) { // m n ^ 2;
    vector<vector<char>> p(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> p[i][j];
        }
    }
    vector<vector<int>>suf(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        suf[i][m-1] = (p[i][m-1] == '1' ? 1 : 0);
        for (int j = m - 2; j >= 0; --j) {
            if (p[i][j]=='1') {
                suf[i][j] = suf[i][j + 1] + 1;
            }
            else {
                suf[i][j] = 0;
            }
        }
    }
    int res = 0;
    for (int j = 0; j < m; ++j) {
        for (int iz = n-1; iz >= 0; --iz) {
            int base = suf[iz][j];
            int loc_res = base;
            for (int i = iz; i > 0; --i) {
                if (base == 0)break;
                else {
                    if (suf[i-1][j] > base) {
                        loc_res += base;
                    }
                    else {
                        base = suf[i-1][j];
                        loc_res += base;
                    }
                }
                if (loc_res > res)res = loc_res;
            }
            if (loc_res > res) res = loc_res;
        }
    }
    cout << res;
}

void solve2(int n, int m) { // n m ^ 2
    vector<vector<char>> p(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> p[i][j];
        }
    }
    vector<vector<int>> ver(n, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        ver[0][i] = (p[0][i] == '1' ? 1 : 0);
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m;++j) {
            if (p[i][j]=='1') {
                ver[i][j] = ver[i-1][j] + 1;
            }
            else {
                ver[i][j] = 0;
            }
        }
    }
    int res = 0;
    for (int j = 0; j < n; ++j) {
        for (int iz = 0; iz < m; ++iz) {
            int base = ver[j][iz];
            int loc_res = base;
            for (int i = iz + 1; i < m; ++i) {
                if (base == 0)break;
                else {
                    if (ver[j][i] > base) {
                        loc_res += base;
                    }
                    else {
                        base = ver[j][i];
                        loc_res += base;
                    }
                }
                if (loc_res > res)res = loc_res;
            }
            if (loc_res > res) res = loc_res;
        }
    }
    cout << res;
}
 
int main() {
    int n, m;
    cin >> n >> m;
    if (n > m) {
        solve2(n, m);
    }
    else solve1(n , m);
}