#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int get(int a, int b, int c, int l, int r) {
    int mn = inf;
    for (int x = l; x <= r; x ++) {
        mn = min(mn, a * x * x + b * x + c);
    }
    return mn;
}

struct st {
    vector <int> pref;

    void build(vector <int> &a) {
        int n = a.size();
        pref.resize(n + 1);
        pref[0] = 0;
        for (int i = 0; i < n; i ++) {
            pref[i + 1] = pref[i] + a[i];
        }
    }

    int get(int l, int r) {
        return pref[r + 1] - pref[l];
    }
};

int f(int a) {
    return a * a;
}

void solve() {
    int n;
    cin >> n;
    vector <int> x(n);
    for (int i = 0; i < n; i ++)
    {
        cin >> x[i];
    }

    sort(x.begin(), x.end());

    st pref;
    pref.build(x);

    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;

    int ans = 0;

    for (int i = 0; i < n; i ++) {
        ans += min(f(x[i] % d), f(d - x[i] % d));
    }

    cout << ans << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --) {
        solve();
    }
}