#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000;

vector <int> dp0;
vector <int> dp1;
vector <bool> used;
vector <vector <int>> g;

void dfs(int v) {
    used[v] = true;
    dp1[v] = 1;
    int mx = -inf;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
            dp0[v] += max(dp0[u], dp1[u]);
            dp1[v] += max(dp0[u], dp1[u]);
            mx = max(mx, dp0[u] - max(dp0[u], dp1[u]));
        }
    }
    dp1[v] += mx;
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    used.resize(n, false);
    dp0.resize(n, 0);
    dp1.resize(n, 0);

    dfs(0);

    cout << max(dp0[0], dp1[0]) << '\n';
    cout << -1 << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --) {
        solve();
    }
}