#include <bits/stdc++.h>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000;

vector <int> dp0;
vector <int> dp1;
vector <bool> used;
vector <vector <int>> g;

vector <int> f;
vector <pair <int, int>> ans;

void dfs(int v) {
    used[v] = true;
    dp1[v] = 1;
    int mx = -inf;
    int tek = -1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
            dp0[v] += max(dp0[u], dp1[u]);
            dp1[v] += max(dp0[u], dp1[u]);
            if (mx < dp0[u] - max(dp0[u], dp1[u])) {
                mx = dp0[u] - max(dp0[u], dp1[u]);
                tek = u;
            }
            //mx = max(mx, dp0[u] - max(dp0[u], dp1[u]));
        }
    }
    f[v] = tek;
    dp1[v] += mx;
}

void dfs2(int v, bool flag) {
    used[v] = true;
    if (!flag) {
        for (auto u : g[v]) {
            if (!used[u]) {
                dfs2(u, true);
            }
        }
        return;
    }

    if (f[v] == -1) {
        return;
    }
    ans.push_back({v, f[v]});
    for (auto u : g[v]) {
        if (!used[u]) {
            if (u == f[v]) {
                dfs2(u, false);
            }
            else {
                dfs2(u, true);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    used.resize(n, false);
    dp0.resize(n, 0);
    dp1.resize(n, 0);
    f.resize(n, -1);

    dfs(0);

    cout << max(dp0[0], dp1[0]) << '\n';

    used.clear();
    used.resize(n, false);
    dfs2(0, true);

    for (auto [v, u] : ans) {
        cout << v + 1 << " " << u + 1 << '\n';
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_ --) {
        solve();
    }
}