// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct Man {
    int l, m, r;
};

bool comp(Man m1, Man m2) {
    return m1.r < m2.r;
}

void test() {
    int n, k;
    cin >> n >> k;

    vector<Man> d(k);
    for (int i = 0; i < k; i++) {
        cin >> d[i].l >> d[i].m >> d[i].r;
    }

    for (int i = 0; i < k; i++) {
        if (d[i].l == 1 && d[i].r == n) {
            cout << "YES\n";
            return;
        }
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j || (d[i].l != 1) || d[j].r != n) continue;

            if (d[i].r + 1 >= d[j].l && (d[j].m > d[i].r || d[i].m < d[j].l)) {
                cout << "YES\n";
                return;
            }
        }
    }

    cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int T;
    cin >> T;
    while (T--) {
        test();
    }
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/
