// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct Man {
    int l, m, r;
};

bool comp(Man m1, Man m2) {
    return m1.r < m2.r;
}

void test() {
    int n, k;
    cin >> n >> k;

    vector<Man> d(k);
    for (int i = 0; i < k; i++) {
        cin >> d[i].l >> d[i].m >> d[i].r;
    }

    vector<int> nums(k);
    for (int i = 0; i < k; i++) nums[i] = i;

    do {
        vector<bool> f(n, false);
        bool flag = true;
        for (int i : nums) {
            if (f[d[i].m - 1]) {
                continue;
            }
            for (int j = d[i].l - 1; j < d[i].r; j++) {
                f[j] = true;
            }
        }
        for (int i = 0; i < n; i++) {
            if (!f[i]) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(nums.begin(), nums.end()));

    cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int T;
    cin >> T;
    while (T--) {
        test();
    }
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/
