// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

vector<bool> used;

vector<vector<int>> g;
int d;
int n;

vector<pii> res;

vector<bool> taken;

set<int> chet;
set<int> nechet;

void dfs(int v, int cnt=0) {
    used[v] = true;

    if (cnt % 2 == 0) {
        chet.insert(v);
    } else {
        nechet.insert(v);
    }

    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u, cnt + 1);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int n;
    cin >> n;
    cin >> d;
    g.resize(n + 1);
    used.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(1);

    for (auto u : chet) {
        if (!nechet.empty()) {
            int v = *nechet.begin();
            res.emplace_back(u, v);
            nechet.erase(nechet.begin());
        }
    }
    cout << res.size() << '\n';
    for (auto [u, v] : res) {
        cout << u << ' ' << v << "\n";
    }
}
