#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
using pii = pair<int, int>;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int f(vector<int> &a) {
    vector<pii> curr;
    vector<int> pref = {0};
    int res = 0;
    for (int i = 0; i < a.size(); i++) {
        int c = 1;
        while (!curr.empty() && curr.back().first > a[i]) {
            c += curr.back().second;
            curr.pop_back();
            pref.pop_back();
        }
        pref.push_back(pref.back() + c * a[i]);
        curr.push_back({a[i], c});
        res = max(res, pref.back());
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mtx(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            mtx[i][j] = c - '0';
        }
    }
    vector<vector<int>> right(n, vector<int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (mtx[i][j]) {
                if (j + 1 < m)
                    right[i][j] = right[i][j + 1] + 1;
                else {
                    right[i][j] = 1;
                }
            } else {
                right[i][j] = 0;
            }
        }
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++) {
    //         cout << right[i][j] << " ";
    //     }
    //     cout << '\n';
    // }
    int ans = 0;
    for (int j = 0; j < m; j++) {
        vector<int> a;
        for (int i = 0; i < n; i++) {
            if (mtx[i][j] == 1) {
                a.push_back(right[i][j]);
            } else {
                ans = max(ans, f(a));
                a.clear();
            }
        }
        ans = max(ans, f(a));
    }

    cout << ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;

// #ifdef LOCAL
//     freopen("in.txt", "r", stdin);
//     freopen("out.txt", "w", stdout);
// #endif

    // cin >> t;
    while (t--) {
        solve();
    }
}
