#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using pii = pair<int, int>;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct q {
    int l, m, r;
    q() = default;
};

bool comp1(q a, q b) {
    return a.l < b.l || a.l == b.l && a.m < b.m;
}
bool comp2(q a, q b) {
    return a.r < b.r || a.r == b.r && a.m < b.m;
} 

bool check(vector<int> &perm, vector<q> &a, int n) {
    vector<q> used;
    for (auto i : perm) {
        bool ok = true;
        for (int j = 0; j < used.size(); j++) {
            if (a[i].m <= a[j].r && a[j].l <= a[i].m) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;
        used.push_back(a[i]);
    }
    int max_r = 0;
    for (auto q : used) {
        if (max_r + 1 < q.l) {
            return false;
        }
        max_r = max(max_r, q.r);
    }
    return max_r == n;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<q> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    sort(all(a), comp2);
    vector<vector<bool>> dp(n + 2, vector<bool> (n + 2));
    dp[0][0] = true;
    for (auto otr : a) {
        for (int l = otr.l - 1; l <= otr.r; l++) {
            if (otr.m > l) {
                for (int m = 0; m <= l; m++) {
                    if (dp[l][m])
                        dp[otr.r][max(m, otr.m)] = true;
                }
            } else {
                for (int m = 0; m < otr.l; m++) {
                    if (dp[l][m])
                        dp[otr.r][max(m, otr.m)] = true;
                }
            }
        }
    }
    bool ans = false;
    for (int m = 0; m <= n + 1; m++) {
        ans |= dp[n][m];
    }
    cout << (ans ? "YES" : "NO") << "\n";
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    // ios_base::sync_with_stdio(false);
    int t = 1;

// #ifdef LOCAL
//     freopen("in.txt", "r", stdin);
//     freopen("out.txt", "w", stdout);
// #endif

    cin >> t;
    while (t--) {
        solve();
    }
}
