#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using pii = pair<int, int>;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct q {
    int l, m, r;
    q() = default;
};

bool comp1(q a, q b) {
    return a.l < b.l || a.l == b.l && a.m > b.m;
}
bool comp2(q a, q b) {
    return a.r < b.r || a.r == b.r && a.m > b.m;
} 

bool check(vector<int> &perm, vector<q> &a, int n) {
    vector<int> pref(n + 1);
    vector<q> used;
    for (int i = 0; i < a.size(); i++) {
        bool ok = true;
        for (int j = 0; j < used.size(); j++) {
            if (a[i].m <= a[j].r && a[j].l <= a[i].m) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;
        used.push_back(a[i]);
        pref[a[i].l - 1]++;
        pref[a[i].r]--;
    }
    for (int i = 1; i < n; i++) {
        pref[i] += pref[i - 1];
        if (pref[i] == 0) return false;
    }
    return true;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<q> a(k);
    vector<int> pref(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        pref[a[i].l - 1]++;
        pref[a[i].r]--;
    }
    for (int i = 1; i < n; i++) {
        pref[i] += pref[i - 1];
    }
    for (int i = 0; i < n; i++) {
        if (pref[i] == 0) {
            cout << "NO\n";
            return;
        }
    }

    vector<int> perm(k);
    for (int i = 0; i < k; i++){
        perm[i] = i;
    }   
    if (check(perm, a, n)) {
        cout << "YES\n";
        return;
    }
    while (next_permutation(all(perm))) {
        if (check(perm, a, n)) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";



    // vector<q> left;
    // vector<q> right;
    // for (auto q : a) {
    //     if (q.l == 1 && q.r == n) {
    //         cout << "YES\n";
    //         return;
    //     } else if (q.l == 1) {
    //         left.push_back(q);
    //     } else {
    //         right.push_back(q);
    //     }
    // }
    // sort(all(right), comp1);
    // sort(all(left), comp2);

    // int j = 0;
    // multiset<int> ll, mm;
    // for (int i = 0; i < left.size(); i++) {
    //     while (j < right.size() && right[j].l - 1 <= left[i].r) {
    //         ll.insert(right[j].l);
    //         mm.insert(right[j].m);
    //         j++;
    //     }
    //     if (!ll.empty() && *(--ll.end()) > right[i].m) {
    //         cout << "YES\n";
    //         return;
    //     } if (!mm.empty() && *(mm.begin()) > right[i].r) {
    //         cout << "YES\n";
    //         return;
    //     }
    // }
    // cout << "NO\n";

    // sort(all(a), comp);
    // set<pii> curr;
    // int j = 0;
    // for (int i = 0; i < k; i++) {
    //     while (j < i && a[j].m < a[i].l) {
    //         curr.erase({a[j].r, j});
    //         j++;
    //     }
    //     if (!curr.empty() && (--curr.end())->first >= a[i].m) {
    //         cout << "NO\n";
    //         return;
    //     }
    //     curr.insert({a[i].r, i});
    // }
    // cout << "YES\n";
    
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;

// #ifdef LOCAL
//     freopen("in.txt", "r", stdin);
//     freopen("out.txt", "w", stdout);
// #endif

    cin >> t;
    while (t--) {
        solve();
    }
}
