#include <bits//stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

struct lad {
    int h = 0, w = 0, sz = 0;

    lad() = default;
    lad(int x, int y, int z) : h(x), w(y), sz(z) {}
};

void solve() {
    int h, w;
    cin >> h >> w;

    vector<string> t(h);
    for (auto &i: t) cin >> i;

    vector<vector<int>> vert(h, vector<int>(w));
    for (int j = 0; j < w; ++j) {
        int cur = -1;
        for (int i = 0; i < h; ++i) {
            if (t[i][j] == '0') {
                cur = -1;
                vert[i][j] = -1;
                continue;
            }
            if (cur == -1) cur = i;
            vert[i][j] = cur;
        }
    }
    vector<vector<lad>> dp(h, vector<lad>(w));
    for (int j = 0; j < w; ++j) {
        for (int i = 0; i < h; ++i) {
            if (t[i][j] == '0') {
                dp[i][j] = {-1, 0, 0};
                continue;
            }
            int x = vert[i][j];
            if (j == 0) {
                dp[x][j] = {i, 1, i - x + 1};
            } else {
                int y = vert[i][j - 1];
                if (x >= y) {
                    if (vert[x][j - 1] >= 0) {
                        auto L = dp[vert[x][j - 1]][j - 1];
                        if (L.h >= i) {
                            int sz1 = i - x + 1 + L.sz - L.w * (L.h - i);
                            if (sz1 > dp[x][j].sz) dp[x][j] = {i, L.w + 1, sz1};
                        }
                    }
                }
                else if (y >= 0) {
                    auto L = dp[y][j - 1];
                    if (L.h >= i) {
                        int sz1 = i - y + 1 + L.sz - L.w * (L.h - i);
                        if (sz1 > dp[x][j].sz) dp[y][j] = {i, L.w + 1, sz1};
                    }
                }
                int sz = i - x + 1;
                if (sz > dp[x][j].sz) dp[x][j] = {i, 1, sz};
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            ans = max(ans, dp[i][j].sz);
        }
    }
    cout << ans << "\n";
}
