#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()

struct seg {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    bool f = false;
    set<int> not_used;
    vector<seg> arr(k);
    multiset<int> fixik;
    for (int i = 0; i < k; i++) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        if (fixik.find(arr[i].m) != fixik.end()) {
            f = true;
        }
        fixik.insert(arr[i].m);
        not_used.insert(i);
    }
    if (f) {
        cout << "NO";
        return;
    }
    for (int j = 0; j < k; j++) {
        int tmp = -1;
        for (auto e : not_used) {
            fixik.erase(fixik.find(arr[e].m));
            if (fixik.lower_bound(arr[e].l) == fixik.upper_bound(arr[e].r)) {
                tmp = e;
            }
            fixik.insert(arr[e].m);
        }
        if (tmp == -1) {
            cout << "NO";
            return;
        }
        fixik.erase(fixik.find(arr[tmp].m));
        not_used.erase(tmp);
    }
    cout << "YES";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}