#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()

struct seg {
    int l, m, r;
};

int optimal(int x, int x0, int d) {
    int t = 0;
    if (x > x0) {
        t = 1;
    }
    if (x < x0) {
        t = -1;
    }
    int x1 = (x - x0) / d * d + x0, x2 = (x - x0  + d * t) / d * d + x0;
    return min((x1 - x) * (x1 - x), (x2 - x) * (x2 - x));
}

__int128 left_f(__int128 mid, vector<int> arr, __int128 x0, __int128 d) {
    __int128 x = x0 - d * mid;
    __int128 ans = 0;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i] > x0) {
            continue;
        }
        if (arr[i] < x) {
            ans += (x - arr[i]) * (x - arr[i]);
        } else {
            ans += optimal(arr[i], x0, d);
        }
    }
    return ans;
}

__int128 right_f(__int128 mid, vector<int> arr, __int128 x0, __int128 d) {
    __int128 x = x0 + d * mid;
    __int128 ans = 0;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i] < x0) {
            continue;
        }
        if (arr[i] > x) {
            ans += (x - arr[i]) * (x - arr[i]);
        } else {
            ans += optimal(arr[i], x0, d);
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    sort(all(arr));
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        __int128 a;
        if (arr[0] < x0 && x0 < arr.back()) {
            {
                __int128 tmp = 1e30;
                for (int i = 0; arr[0] - d < x0 - i * d; i++) {
                    tmp = min(tmp, left_f(i, arr, x0, d) + 2 * i * t);
                }
                __int128 tmp2 = 1e30;
                for (int i = 0; arr.back() + d > x0 + i * d; i++) {
                    tmp2 = min(tmp2, right_f(i, arr, x0, d) + i * t);
                }
                a = tmp + tmp2;
            }
            {
                __int128 tmp = 1e30;
                for (int i = 0; arr[0] - d < x0 - i * d; i++) {
                    tmp = min(tmp, left_f(i, arr, x0, d) + i * t);
                }
                __int128 tmp2 = 1e30;
                for (int i = 0; arr.back() + d > x0 + i * d; i++) {
                    tmp2 = min(tmp2, right_f(i, arr, x0, d) + 2 * i * t);
                }
                a = min(a, tmp + tmp2);
            }
        } else if (arr.back() < x0) {
            __int128 tmp = 1e30;
            for (int i = 0; arr[0] - d < x0 - i * d; i++) {
                tmp = min(tmp, left_f(i, arr, x0, d) + i * t);
            }
            a = tmp;
        } else {
            __int128 tmp2 = 1e30;
            for (int i = 0; arr.back() + d > x0 + i * d; i++) {
                tmp2 = min(tmp2, right_f(i, arr, x0, d) + i * t);
            }
            a = tmp2;
        }
        int ans = a;
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
