#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

vl used;
vvl answ;
vvl graph;

void dfs(int node, int pr){
	if(pr != -1){
		answ.push_back({pr, node});
	}
	used[node] = 1;
	for(auto &i:graph[node]){
		if(used[i])continue;
		if(pr == -1)dfs(i, node);
		else dfs(i, -1);
		pr = 1;
	}
}

void solve(){
	ll n,d;
	cin>>n>>d;
	int m = n-1;
	graph.assign(n,vl());
	used.assign(n,0);
	while(m--){
		int a,b;
		cin>>a>>b;
		graph[a-1].push_back(b-1);
		graph[b-1].push_back(a-1);
	}
	for(int i = 0;i<n;i++){
		if(graph[i].size() == 1){
			dfs(i,-1);
			break;
		}
	}
	cout<<answ.size()<<"\n";
	for(auto &i:answ){
		cout<<i[0]+1<<" "<<i[1]+1<<"\n";
	}
	
	return;
}

int main(){
	ios_base::sync_with_stdio();
	cin.tie(0),cout.tie(0);

	/*freopen("in.txt","r",stdin);
	freopen("out.txt","w",stdout);/* */
	
	solve();

	return 0;
}