#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>

using namespace std;
using ll=long long;


int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll h, w;
	cin >> h >> w;
	vector<char>aaa(w + 1);
	vector<ll>lll(w + 1);
	vector<vector<char>>a(h + 1,aaa);
	vector<vector<ll>>len(h + 1, lll);
	for (int i = 1; i <= h; ++i) {
		for (int j = 1; j <= w; ++j) {
			cin >> a[i][j];
		}
	}
	for (int i = 1; i <= h; ++i) {
		ll last = 0;
		for (int j = 1; j <= w; ++j) {
			if (a[i][j] == '0') {
				last = 0;
				len[i][j] = 0;
			}
			else {
				if (last == 0) {
					last = j;
					while (last < w && a[i][last + 1] == '1') {
						++last;
					}
					len[i][j] = last - j + 1;
				}
				else {
					len[i][j] = last - j + 1;
				}
			}
		}
	}
	ll ans = 0;
	for (int j = 1; j <= w; ++j) {
		ll res = 0;
		vector<pair<ll,ll>> v;
		for (int i = 1; i <= h; ++i) {
			ll kol = 1;
			while (v.size() != 0 && v.back().first > len[i][j]) {
				kol+=v.back().second;
				res -= v.back().first*v.back().second;
				v.pop_back();
			}
			res += kol * len[i][j];
			v.push_back({ len[i][j],kol });
			ans = max(ans, res);
		}
	}
	cout << ans << "\n";
}