#include <bits/stdc++.h>
#define int long long

using namespace std;

istream& operator>>(istream& in, vector<auto>& v) {
    for (auto& el : v) {
        in >> el;
    }
    return in;
}

ostream& operator<<(ostream& out, vector<auto> v) {
    for (auto el : v) {
        out << el << " ";
    }
    out << "\n";
    return out;
}
ostream& operator<<(ostream& out, vector<vector<auto>> v) {
    for (auto el : v) {
        out << el;
    }
    out << "\n";
    return out;
}

int n, m;
vector<int> x;
int s, d;

int left(int k, int t) {
    int res = k * t;
    for (auto el : x) {
        if (el > s) continue;
        int r = (s - el) / d;
        int f = s - r * d;
        if ((el - f) * (el - f) > (el - (f - d)) * (el - (f - d))) {
            r++;
        }
        r = min(r, k);
        f = s - r * d;
        res += (el - f) * (el - f);
    }
    return res;
}
int right(int k, int t) {
    int res = k * t;
    for (auto el : x) {
        if (el < s) continue;
        int r = (el - s) / d;
        int f = s + r * d;
        if ((el - f) * (el - f) > (el - (f + d)) * (el - (f + d))) {
            r++;
        }
        r = min(r, k);
        f = s + r * d;
        res += (el - f) * (el - f);
    }
    return res;
}

void solve() {
    cin >> n;
    x = vector<int>(n);
    cin >> x;
    sort(x.begin(), x.end());
    cin >> s >> d;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int ans = 1e18;
        for (int i = 0; i <= 50; i++) {
            ans = min(ans, left(0, t) + right(i, t));
            ans = min(ans, left(i, t) + right(0, t));
        }
        for (int i = 0; i <= 50; i++) {
            for (int j = 0; j <= 50; j++) {
                ans = min(ans, left(i, t * 2) + right(j, t));
                ans = min(ans, left(i, t) + right(j, t * 2));
            }
        }
        cout << ans << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
4 4
1111
1011
1101
1111
*/
