#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<cmath>
#include<deque>
#include<map>
#include<time.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;
#define fst first
#define snd second
mt19937 mt(clock());

ll vers = 0, n, d;
vector <vector<ll>> g;
vector <ll> hg, u, ind, nxt;

void dfs(ll v, ll h) {
	hg[v] = h;
	u[v] = 1;
	for (auto i : g[v])
		if (!u[i])
			dfs(i, 1 + h);
}

bool check(ll v) {
	if (u[v] == vers)
		return false;
	u[v] = vers;
	for (auto i : g[v]) {
		if (nxt[i] == -1 || check(nxt[i])) {
			nxt[i] = v;
			return true;
		}
	}
	return false;
}

void solve() {
	cin >> n >> d;
	g.resize(n);
	ind.assign(n, -1);
	nxt.assign(n, -1);
	u.assign(n, 0);
	hg.assign(n, 0);
	for (ll i = 1; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	dfs(0, 0);
	u.assign(n, -1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		if (hg[i] % 2 == 0 && check(i))
			ans++;
		vers++;
	}
	cout << ans << '\n';
	cout << -1;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t12345 = 1;
	//cin >> t12345;
	while (t12345--) {
		solve();
		cout << '\n';
	}
	return 0;
}
