#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<ll>> g;
vector<ll> used;
ll f = 1;

void dfs(ll v) {
    used[v] = 1;
    for (auto to:g[v]) {
        if (used[to] == 1) f = 0;
        if (!used[to]) dfs(to);
    }
    used[v] = 2;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<array<ll, 3>> q(n);
    for (int i = 0; i < k; i++) {
        cin >> q[i][0] >> q[i][1] >> q[i][2];
    }
    g.clear();
    used.clear();
    used.resize(k);
    g.resize(k);
    f = 1;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (q[j][0] <= q[i][1] && q[i][1] <= q[j][2]) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (!used[i]) dfs(i);
    }
    if (f) cout << "YES\n";
    else cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    cin >> t;
    while (t--) solve();
}
