#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define popb pop_back
#define pf push_front
#define popf pop_front
#define ins insert
#define ers erase
#define m_p make_pair
const int INF = 1e18;


bool cross (pair < int, int > a, pair < int, int > b) {
    if (a.first <= b.first && b.first <= a.second) {
        return 1;
    }
    if (a.first <= b.second && b.second <= a.second) {
        return 1;
    }
    swap(a,b);
    if (a.first <= b.first && b.first <= a.second) {
        return 1;
    }
    if (a.first <= b.second && b.second <= a.second) {
        return 1;
    }
    return 0;
}




vector < int > tree;
int SZ;
void add (int pos,int val) {
    pos++;
    for (pos; pos <= SZ; pos += pos & -pos) {
        tree[pos] += val;
    }
}

int sum (int r) {
    r++;
    int ans = 0;
    for (r; r > 0; r -= r & -r) {
        ans += tree[r];
    }
    return ans;
}

int sum (int l,int r) {
    return sum(r) - sum(l - 1);
}
void solve () {
    int n,k;
    cin >> n >> k;

    vector < tuple < int, int, int > > a(k);
    SZ = n + 1;
    tree = vector < int > (SZ + 1);
    for (auto &[l,m,r]: a) {
        cin >> l >> m >> r;
        if (m == n) {
            add(l,1);
        }
    }
    if (n == 1) {
        cout << "YES" << endl;
        return ;
    }
    for (auto [l,m,r]: a) {
        if (l == 1 && r == n) {
            cout << "YES" << endl;
            return ;
        }
        if (m == 1) {
            if (sum(l,r) != 0) {
                cout << "YES" << endl;
                return ;
            }
        }
    }
    cout << "NO" << endl;






}
signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt","r",stdin);
    int qwerty;
    cin >> qwerty;
    while (qwerty--) {
        solve();
    }

}