#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

struct st {
    ll l, m, r;
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<st> seg;
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        l--, m--, r--;
        seg.push_back({l, m, r});
    }
    vector<vector<ll>> dp(n, vector<ll>(n));
    for (int len = 1; len <= n; len++) {
        for (int l = 0; l + len <= n; l++) {
            ll r = l + len - 1;
            for (auto [lf, mf, rf] : seg) {
                if (mf < l || mf > r) {
                    continue;
                }
                if ((lf <= l && rf >= r) || (lf <= l && dp[rf + 1][r]) || (rf >= r && dp[l][lf - 1])) {
                    dp[l][r] = 1;
                }
            }
        }
    }
    if (dp[0][n - 1]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}