#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

struct st {
    ll l, m, r;
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n, -1);
    vector<st> seg;
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        l--, r--, m--;
        seg.push_back({l, m, r});
        a[l] = max(a[l], r);
    }
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (seg[j].l <= seg[i].m && seg[i].m <= seg[j].r && seg[i].l <= seg[j].m && seg[j].m <= seg[i].r) {
                cout << "NO\n";
                return;
            }
        }
    }
    ll mx = -1;
    for (int i = 0; i < n; i++) {
        mx = max(mx, a[i]);
        if (mx < i) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}