#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}

vector<vector<ll>> tree;
ll d;
vector<ll> c;
vector<ll> num;
vector<ll> nn1, nn2;
ll n1 = 0, n2 = 0;
void dfs(ll v, ll p, ll color) {
    c[v] = color;
    if (color == 0) {
        num[v] = n1++;
        nn1.push_back(v);
    } else {
        num[v] = n2++;
        nn2.push_back(v);
    }
    for (auto u : tree[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v, (color + 1) % 2);
    }
}

vector<vector<ll>> g;

void get(ll v, ll p, ll l, ll root) {
    if (l > d) {
        return;
    }
    if (c[root] != c[v]) {
        g[num[root]].push_back(num[v]);
    }
    for (auto u : tree[v]) {
        if (u != p) {
            get(u, v, l + 1, root);
        }
    }
}

vector<ll> mt;
vector<ll> used;
ll timer = 1;
bool kun(ll v) {
    if (used[v] == timer) {
        return false;
    }
    used[v] = timer;
    for (auto u : g[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return true;
        }
    }
    for (auto u : g[v]) {
        if (kun(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    ll n;
    cin >> n >> d;
    tree.resize(n);
    for (int i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        tree[a].push_back(b);
        tree[b].push_back(a);
    }
    c.resize(n);
    num.resize(n);
    dfs(0, 0, 0);
    g.resize(n1);
    for (int i = 0; i < n; i++) {
        if (c[i] == 0) {
            get(i, -1, 0, i);
        }
    }
    mt.resize(n2, -1);
    used.resize(n2);
    ll ans = 0;
    for (int i = 0; i < n1; i++) {
        if (kun(i)) {
            ans++;
        }
        timer++;
    }
    cout << ans << '\n';
    for (int i = 0; i < n2; i++) {
        if (mt[i] != -1) {
            cout << nn1[mt[i]] + 1 << ' ' << nn2[i] + 1 << '\n';
        }
    }
}