#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}
vector<vector<ll>> g;
ll d;

vector<vector<ll>> dp;

void dfs(ll v, ll p) {
    ll sm = 0;
    ll mx = -INF;
    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        sm += max(dp[u][0], dp[u][1]);
        mx = max(mx, dp[u][0] - max(dp[u][0], dp[u][1]));
    }
    dp[v][0] = sm;
    dp[v][1] = sm + mx + 1;
}

vector<pair<ll, ll>> ans;

void get_ans(ll v, ll p, ll f) {
    if (f == 0) {
        for (auto u : g[v]) {
            if (u == p) {
                continue;
            }
            if (dp[u][0] > dp[u][1]) {
                get_ans(u, v, 0);
            } else {
                get_ans(u, v, 1);
            }
        }
    } else {
        ll next = -1, mx = -INF;
        for (auto u : g[v]) {
            if (u == p) {
                continue;
            }
            if (dp[u][0] - max(dp[u][0], dp[u][1]) > mx) {
                mx = dp[u][0] - max(dp[u][0], dp[u][1]);
                next = u;
            }
        }
        ans.emplace_back(next, v);
        for (auto u : g[v]) {
            if (u == p) {
                continue;
            }
            if (u == next) {
                get_ans(u, v, 0);
                continue;
            }
            if (dp[u][0] > dp[u][1]) {
                get_ans(u, v, 0);
            } else {
                get_ans(u, v, 1);
            }
        }
    }
}

void solve() {
    ll n;
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dp.resize(n, vector<ll>(2, -INF));
    dfs(0, -1);
    if (dp[0][0] > dp[0][1]) {
        get_ans(0, -1, 0);
    } else {
        get_ans(0, -1, 1);
    }
    cout << max(dp[0][0], dp[0][1]) << '\n';
    for (auto [a, b] : ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}