#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;

void solve() {
    int n, k;
    cin >> n >> k;

    vector<pair<pi, int>> ps(k);

    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        ps[i] = {{l, r}, m};
    }

    int ok = 1;

    for (int i = 0; i < k; ++i) {
        auto [seg1, m1] = ps[i];
        auto [l1, r1] = seg1;
        for (int j = i + 1; j < k; ++j) {
            auto [seg2, m2] = ps[j];
            auto [l2, r2] = seg2;

            if (l1 <= m2 && m2 <= r1) {
                ok = 0;
                break;
            }
            if (l2 <= m1 && m1 <= r2) {
                ok = 0;
                break;
            }
        }
    }


    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}