#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;


void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pi, int>> ps(k);

    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        ps[i] = {{l, r}, m};
    }

    vector<vi> dp(n + 2, vi(n + 2, 0));
    dp[0][n + 1] = 1;

    int ok = 0;


    for (int ls = 0; ls <= n + 1; ++ls) {
        for (int rs = n + 1; rs >= 0; --rs) {
            if (dp[ls][rs] == 0) continue;

            for (int i = 0; i < k; ++i) {
                auto [seg, m] = ps[i];
                auto [l, r] = seg;
                // cout << "l " << l << ' ' << r << endl;
                if (m <= ls || m >= rs) continue;
                
                if (l <= ls + 1) {
                    dp[r][rs] = 1;
                    if (rs - r <= 1) ok = 1;
                }
                if (r >= rs - 1) {
                    dp[ls][l] = 1;
                    if (l - ls <= 1) ok = 1;
                }
            }
        }
    }


    if (ok) cout << "YES" << endl;
    else cout << "NO" << endl;
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<pair<pi, int>> ps(k);

    vi open(n + 1);

    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        open[l] = max(open[l], r);
    }

    set<int> fs;

    for (int i = 1; i <= n; ++i) fs.insert(i);

    for (int i = n; i >= 1; --i) {
        while (!fs.empty()) {
            int v = *fs.begin();
            if (v <= open[i]) fs.erase(fs.begin());
            else break;
        }
    }


    if (fs.empty()) cout << "YES" << endl;
    else cout << "NO" << endl;
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve2();
    }
}