#include <bits/stdc++.h>
#define pb push_back
  
using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;
  
const int INF = 1e8;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pi, int>> ps(k);
    
    vector<pi> pref1, suff1, pref2, suff2;
    int ok = 0;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        if (l == 1 && r == n) {
            ok = 1;
        }
        if (l == 1) {
            pref1.pb({r, m});
            pref2.pb({m, r});
        }
        else {
            suff1.pb({l, m});
            suff2.pb({m, l});
        }
    }

    int p = pref1.size();
    int s = suff1.size();

    // int ok = 0;
  
    for (int i = 0; i < p; ++i) {
        for (int j = 0; j < s; ++j) {
            int l1 = 1;
            int r2 = n;
            auto [r1, m1] = pref1[i];
            auto [l2, m2] = suff1[j];

            if (!(l1 <= m2 && m2 <= r1)) {
                if (l2 < r1) {
                    cout << "YES\n";
                    return;
                }
            }

            if (!(l2 <= m1 && m1 <= r2)) {
                if (l2 < r1) {
                    cout << "YES\n";
                    return;
                }
            }
        }
    }
  
    if (ok) cout << "YES" << endl;
    else cout << "NO" << endl;
}
  
  
signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    // freopen("out1.txt", "w", stdout);
#endif
  
    ios_base::sync_with_stdio(0);
    cin.tie(0);
  
    int t;
    cin >> t;
  
    while (t--) {
        solve();
    }
}