#include <bits/stdc++.h>
#define pb push_back
 
using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pi, int>> ps(k);
 
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        ps[i] = {{l, r}, m};
    }
 
    vector<vi> dp(n + 2, vi(n + 2));
    vector<vi> used(n + 2, vi(n + 2));
 
    dp[0][n + 1] = 1;
 
    queue<pi> q;
 
    int ok = 0;
 
 
    q.push({0, n + 1});
 
    while (!q.empty()) {
        auto [ls, rs] = q.front();
        q.pop();
 
        if (used[ls][rs]) continue;
        used[ls][rs] = 1;
 
        
        for (int i = 0; i < k; ++i) {
            auto [seg, m] = ps[i];
            auto [l, r] = seg;
            if (m <= ls || m >= rs) continue;
              
            if (l <= ls + 1) {
                dp[r][rs] = 1;
                if (rs - r <= 1) ok = 1;
                q.push({r, rs});
            }
            if (r >= rs - 1) {
                dp[ls][l] = 1;
                if (l - ls <= 1) ok = 1;
                q.push({ls, l});
            }
        }
    }
 
     
 
    if (ok) cout << "YES\n";
    else cout << "NO\n";
 
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
 
    int t;
    cin >> t;
 
    while (t--) {
        solve();
    }
}