#include <iostream>
#include <algorithm>
#include <vector>
 
using namespace std;
 
struct s {
    int l, m, r;
 
    bool operator<(const s& a) {
        return m < a.m;
    }
};
 
void solve() {
    int n, k; cin >> n >> k;
    s arr[k];
    for (int i = 0; i < k; ++i) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        --arr[i].l; --arr[i].m; --arr[i].r;
    }
    sort(arr, arr + k);

    bool ok[k] = {};
    for (int i = 0; i < k; ++i) {
        if (arr[i].l == 0) {
            ok[i] = true;
        } else {
            for (int j = 0; j < i && !ok[i]; ++j)
                if (ok[j] && arr[j].r < arr[i].m && arr[j].r >= arr[i].l - 1)
                    ok[i] = true;
        }

        if (ok[i] && arr[i].r == n - 1) {
            cout << "YES\n";
            return;
        }
    }

    cout << "NO\n";
}
 
int main() {
    cin.tie(0)->sync_with_stdio(0);
 
    int _; cin >> _;
    while (_--) {
        solve();
    }
 
    return 0;
}