#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

struct s {
    int l, m, r;
};

void solve() {
    int n, k; cin >> n >> k;
    vector<s> vl, vr;
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> m >> r;
        if (l == 1)
            vl.push_back({l, m, r});
        else
            vr.push_back({l, m, r});
    }

    for (int i = 0; i < vl.size(); ++i) {
        for (int j = 0; j < vr.size(); ++j) {
            if (vl[i].r - vl[i].l + 1 == n || vr[j].r - vr[j].l + 1 == n ||
                (!(vl[i].m >= vr[j].l && vr[j].m <= vl[i].r) && vl[i].r >= vr[j].l - 1)) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int _; cin >> _;
    while (_--) {
        solve();
    }

    return 0;
}
