#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

struct s {
    int l, m, r;

    bool operator<(const s& a) {
        return l < a.l;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    s arr[k];
    for (int i = 0; i < k; ++i) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        --arr[i].l; --arr[i].m; --arr[i].r;
    }
    sort(arr, arr + k);

    bool ok[k] = {};
    ok[0] = true;
    for (int i = 1; i < k; ++i) {
        for (int j = 0; j < i; ++j) {
            if (!ok[j] ||
                arr[j].r < arr[i].l - 1 ||
                (arr[j].l <= arr[i].m && arr[i].m <= arr[j].r && arr[i].l <= arr[j].m && arr[j].m <= arr[i].r)) continue;
            ok[i] = true;
            break;
        }
        
        if (arr[i].r == n - 1 && ok[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int _; cin >> _;
    while (_--) {
        solve();
    }

    return 0;
}
