#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

constexpr int inf = 1e18;
constexpr int mod = 1e9 + 7;
constexpr int N = 3 * 1e5;

vector<int> t;

void upd(int i, int x, int v = 0, int l = 0, int r = N) {
    if (r - l == 1) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        upd(i, x, v * 2 + 1, l, m);
    } else {
        upd(i, x, v * 2 + 2, m, r);
    }
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int ql, int qr, int v = 0, int l = 0, int r = N) {
    if (qr <= l || r <= ql) {
        return -inf;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return max(get(ql, qr, v * 2 + 1, l, m), get(ql, qr, v * 2 + 2, m, r));
}

signed main() {
    t.assign(4 * N, -inf);
    int n, m;
    cin >> n >> m;
    vector<string> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    vector<vector<int>> mx(n, vector<int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (d[i][j] == '0') {
                continue;
            }
            mx[i][j] = 1;
            if (j + 1 < m) {
                mx[i][j] += mx[i][j + 1];
            }
        }
    }
    int ans = 0;
    for (int j = 0; j < m; j++) {
        vector<vector<int>> a;
        vector<int> curr;
        for (int i = 0; i < n; i++) {
            if (d[i][j] == '0') {
                if (!curr.empty()) {
                    a.push_back(curr);
                    curr.clear();
                }
            } else {
                curr.push_back(mx[i][j]);
            }
        }
        if (!curr.empty()) {
            a.push_back(curr);
        }
        for (auto &b : a) {
            vector<int> pref(sz(b), -1);
            for (int i = 0; i < sz(b); i++) {
                int res = get(0, b[i]);
                if (res == -inf) {
                    pref[i] = b[i] * (i + 1);
                    ans = max(ans, b[i] * (i + 1));
                } else {
                    pref[i] = pref[res] + b[i] * (i - res);
                    ans = max(ans, pref[res] + b[i] * (i - res));
                }
                upd(b[i], i);
            }
            for (auto i : b) {
                upd(i, -inf);
            }
        }
    }
    cout << ans << endl;
    return 0;
}