#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define int __int128

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using i128 = __int128;

mt19937 rnd(time(0));

vector<ll> sol(ll &n, vector<ll> &x, ll &x0, ll &d, ll &m, vector<ll> &t) {
    vector<ll> ans(m);
    if (x0 > x[0]) swap(x[0], x0);
    for (int i = 0; i < m; i++) {
        int l = -1, r = 2e9;
        while ((__int128)r - l > 1) {
            int mid = ((__int128)r + l) / 2;
            if (2 * (x[0] - x0 - (__int128)mid * d) - 1 >= t[i]) l = mid;
            else r = mid;
        }
        //cout << l << "*\n";
        ans[i] = (__int128)t[i] * r + (x0 + (__int128)r * d - x[0]) * (x0 + (__int128)r * d - x[0]);
    }
    return ans;
}

signed main() {
    ll n, x0, d, m;
    cin >> n;
    vector<ll> x(n);
    for (ll i = 0; i < n; i++) cin >> x[i];
    cin >> x0 >> d >> m;
    vector<ll> t(m);
    for (ll i = 0; i < m; i++) cin >> t[i];
    vector<ll> ans = sol(n, x, x0, d, m, t);
    for (ll i : ans) cout << i << '\n';
    return 0;
}

/*
1
1000000000
0 1000000
5
1 2 3 4 5
*/

/*
1
-4
0 1
5
1 2 3 4 5
*/

/*
1
50
10 10
5
1 2 3 4 5
*/
