#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
// #define int long long

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using i128 = __int128;

mt19937 rnd(time(0));

const ll INF = 9e18;

vector<ll> sol(int &n, vector<int> &x, int &x0, int &d, int &m, vector<int> &t) {
    vector<ll> ans(m);
    if (x0 > x[0]) swap(x[0], x0);
    for (int i = 0; i < m; i++) {
        int l = -1, r = 2e9;
        while ((ll)r - l > 1) {
            int mid = ((ll)r + l) / 2;
            if ((ll)t[i] * mid + (i128)(x0 + (ll)mid * d - x[0]) * (x0 + (ll)mid * d - x[0]) >= (ll)t[i] * (mid + 1) + (i128)(x0 + (ll)(mid + 1) * d - x[0]) * (x0 + (ll)(mid + 1) * d - x[0])) l = mid;
            else r = mid;
        }
        //cout << l << "*\n";
        ans[i] = (ll)t[i] * r + (x0 + (ll)r * d - x[0]) * (x0 + (ll)r * d - x[0]);
    }
    return ans;
}

vector<ll> sol2(int &n, vector<int> &x, int &x0, int &d, int &m, vector<int> &t) {
    vector<ll> ans(m, INF);
    for (int i = 0; i < n; i++) {
        int l = -2e9, r = 2e9;
        while (r - l > 1) {
            int mid = ((ll)r + l) / 2;
            if ((ll)mid * d + x0 <= x[i]) l = mid;
            else r = mid;
        }
        ans[0] = min(ans[0], ((ll)d * l + x0 - x[i]) * ((ll)d * l + x0 - x[i]));
        ans[0] = min(ans[0], ((ll)d * r + x0 - x[i]) * ((ll)d * r + x0 - x[i]));
    }
    return ans;
}

signed main() {
    int n, x0, d, m;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    cin >> x0 >> d >> m;
    vector<int> t(m);
    for (int i = 0; i < m; i++) cin >> t[i];
    vector<ll> ans = sol2(n, x, x0, d, m, t);
    for (ll i : ans) cout << i << '\n';
    return 0;
}

/*
1
0
1 3 3
1 2 3
*/
