#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e18;

inline ll norm(ll a, const ll mod) {
    if (a < -mod || a >= 2 * mod) {
        a %= mod;
    }
    if (a < 0) {
        a += mod;
    }
    if (a >= mod) {
        a -= mod;
    }
    return a;
}

inline ll floor(ll a, ll b) {
    if ((a < 0) ^ (b < 0)) {
        a = abs(a);
        b = abs(b);
        return -1 * (a + b - 1) / b;
    } else {
        return a / b;
    }
}

inline ll ceil(ll a, ll b) {
    if ((a < 0) ^ (b < 0)) {
        a = abs(a);
        b = abs(b);
        return -1 * a / b;
    } else {
        return (a + b - 1) / b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<ll> t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ll k1 = floor((x[i] - x0), d);
        ll k2 = ceil((x[i] - x0), d);
        ll c = min(abs(x[i] - (x0 + k1 * d)), abs(x[i] - (x0 + k2 * d)));
        ans += c * c;
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
