#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mat(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c; cin >> c;
            mat[i][j] = c - '0';
        }
    }
    vector<vector<int>> pref(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mat[i][j] == 0) pref[i][j] = 0;
            else {
                if (i > 0) pref[i][j] = pref[i - 1][j];
                pref[i][j]++;
            }
            //cout << pref[i][j] << " ";
        }
        //cout << endl;
    }
    int mx = 0;
    for (int i = 0; i < n; i++) {
        vector<array<int, 3>> st = {{-1, 0, m}};
        for (int j = m - 1; j > -1; j--) {
            while (st.back()[0] >= pref[i][j]) {
                st.pop_back();
            }
            int cnt = (st.back()[2] - j) * pref[i][j] + st.back()[1];
            mx = max(mx, cnt);
            //cout << cnt << " " << i << " " << j << endl;
            st.push_back({pref[i][j], cnt, j});
        }
    }
    cout << mx;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
