#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool check(int l1, int m1, int r1, int l2, int m2, int r2) {
    return (l1 <= m2 && m2 <= r2 && l2 <= m1 && m1 <= r2);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a = {{0, 0, 0}};
    bool fl = 0;
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a.push_back({r, l, m});
    }
    sort(all(a));
    vector<int> dp(k + 1);
    dp[0] = 1;
    for (int i = 1; i <= k; i++) {
        auto [r, l, m] = a[i];
        for (int j = 0; j < i; j++) {
            auto [r2, l2, m2] = a[j];
            if (check(l, m, r, l2, m2, r2)) continue;
            if (dp[j] && l <= r2 + 1) {
                dp[i] = 1;
                break;
            }
        }
    }
    for (int i = 0; i < k + 1; i++) {
        if (dp[i] && a[i][0] == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
