#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll INF = 1e18;

bool fl = 0;

void gen(int st, int k, int n, vector<array<int, 3>> &a, vector<bool> &used, vector<int> &ord) {
    if (st == k) {
        vector<bool> nw(n + 1);
        for (int i = 0; i < k; i++) {
            if (nw[a[ord[i]][1]]) continue;
            for (int j = a[ord[i]][0]; j <= a[ord[i]][2]; j++) {
                nw[j] = 1;
            }
        }
        for (int i = 1; i <= n; i++) {
            if (nw[i] == 0) return;
        }
        fl = 1;
        return;
    }
    for (int i = 0; i < k; i++) {
        if (!used[i]) {
            used[i] = 1;
            ord.push_back(i);
            gen(st + 1, k, n, a, used, ord);
            ord.pop_back();
            used[i] = 0;
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
    }
    vector<bool> used(k);
    vector<int> ord;
    gen(0, k, n, a, used, ord);
    if (fl) cout << "YES\n";
    else cout << "NO\n";
    fl = 0;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
