#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool check(int l1, int m1, int r1, int l2, int m2, int r2) {
    return l1 <= m2 && m2 <= r1 && l2 <= m1 && m1 <= r2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a = {{0, 0, 0}};
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a.push_back({l, m, r});
    }
    sort(all(a));
    vector<bool> dp(k + 1, 0);
    dp[0] = 1;
    for (int i = 1; i <= k; i++){
        auto [l1, m1, r1] = a[i];
        for (int j = 0; j <= k; j++) {
            auto [l2, m2, r2] = a[j];
            if ((l1 <= l2 && r2 <= r1) || check(l1, m1, r1, l2, m2, r2)) continue;
            if (dp[j] && l1 - 1 <= r2) {
                dp[i] = 1;
                break;
            }
        }
    }
    for (int i = 0; i < k + 1; i++) {
        if (dp[i] && a[i][2] == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}