#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
#define int long long

using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<vector<int> > a(k, vector<int>(3));
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l - 1, r - 1, m - 1};
    }
    vector<vector<pair<int, int> > > left(n), right(n);
    for (auto i: a) {
        left[i[0]].push_back({i[1], i[2]});
        right[i[1]].push_back({i[0], i[2]});
    }
    for (int i = 0; i < n; i++) {
        sort(left[i].begin(), left[i].end());
        sort(right[i].rbegin(), right[i].rend());
    }
    vector<vector<int> > dp(n, vector<int>(n));
    for (int len = 0; len < n; len++) {
        for (int l = 0; l + len < n; l++) {
            int r = l + len;
            for (auto i: left[l]) {
                if (i.first > r) break;
                if (i.first == r) {
                    dp[l][r] = 1;
                    break;
                }
                for (int j = i.second + 1; j <= i.first; j++) {
                    if (dp[j][r]) {
                        dp[l][r] = 1;
                        break;
                    }
                }
                if (dp[l][r]) break;
            }
            if (dp[l][r]) continue;
            for (auto i: right[r]) {
                if (i.first < l) break;
                if (i.first == l) {
                    dp[l][r] = 1;
                    break;
                }
                for (int j = i.first; j < i.second; j++) {
                    if (dp[l][j]) {
                        dp[l][r] = 1;
                        break;
                    }
                }
                if (dp[l][r]) break;
            }
        }
    }
    if (dp[0][n - 1]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
