#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
#define int long long
const int INF = 1e9;


using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

vector<vector<int> > gr;
vector<vector<int> > dp;

void dfs(int v, int p) {
    int sum = 0;
    for (int u: gr[v]) {
        if (u == p) continue;
        dfs(u, v);
        sum += max(dp[u][0], dp[u][1]);
    }
    for (int u: gr[v]) {
        if (u == p) continue;
        sum -= max(dp[u][0], dp[u][1]);
        dp[v][1] = max(dp[v][1], sum + 1);
        sum += max(dp[u][0], dp[u][1]);
    }
    dp[v][0] = sum;
}

void solve1() {
    int n, d;
    cin >> n >> d;
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dp.resize(n, vector<int>(2));
    dfs(0, -1);
    cout << max(dp[0][0], dp[0][1]) << '\n' << -1;
}
