#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;
ll get_cnt(ll i1, ll j1, ll i2, ll j2, vector<vector<ll> > &pref) {
    return pref[i2][j2] - (i1 > 0 ? pref[i1 - 1][j2] : 0ll) - (j1 > 0 ? pref[i2][j1 - 1] : 0ll) + (
               (i1 > 0 && j1 > 0) ? pref[i1 - 1][j1 - 1] : 0ll);
}

void solve() {
    ll h, w;
    cin >> h >> w;
    vector<string> f(h);
    vector<vector<ll> > pref(h, vector<ll>(w));
    vector<vector<ll> > len(h, vector<ll>(w));
    for (ll i = 0; i < h; ++i) {
        cin >> f[i];
        for (ll j = 0; j < w; ++j) {
            pref[i][j] = (f[i][j] - '0');
            pref[i][j] += (i > 0 ? pref[i - 1][j] : 0ll) + (j > 0 ? pref[i][j - 1] : 0ll) - (
                (i > 0 && j > 0) ? pref[i - 1][j - 1] : 0ll);
        }
    }
    for (ll i = 0; i < h; ++i) {
        for (ll j = w - 1; j >= 0; --j) {
            if (f[i][j] == '0') len[i][j] = 0;
            else len[i][j] = (j < w - 1 ? len[i][j + 1] : 0ll) + 1;
        }
    }
    vector<vector<pair<ll,ll> > > dp(h, vector<pair<ll,ll> >(w));
    for (ll j = 0; j < w; ++j) {
        dp[h - 1][j] = {len[h - 1][j], len[h - 1][j]};
    }
    for (ll i = h - 2; i >= 0; --i) {
        for (ll j = 0; j < w; ++j) {
            ll len_down = dp[i + 1][j].second;
            ll len_now = len[i][j];
            if (len_down == 0) {
                dp[i][j] = {len_now, len_now};
                continue;
            }
            if (len_now <= len_down) {
                dp[i][j] = {dp[i + 1][j].first + len_now, len_now};
            } else {
                ll l = -1, r = i + 1;
                while (r - l > 1) {
                    ll mid = (l + r) / 2;
                    if (get_cnt(mid, j, i, j + len_down - 1, pref) == len_down * (i - mid + 1)) {
                        r = mid;
                    } else {
                        l = mid;
                    }
                }
                ll cnt = get_cnt(r, j + len_down, i, j + len_now - 1, pref);
                if (cnt > dp[i + 1][j].first) {
                    dp[i][j] = {len_now, len_now};
                } else {
                    dp[i][j] = {dp[i + 1][j].first + len_down, len_down};
                }
            }
        }
    }
    ll mx = 0;
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            mx = max(mx, dp[i][j].first);
        }
    }
    cout << mx;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
    // cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
