#include <bits/stdc++.h>
#define ll int
#define ld long double
using namespace std;


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<unordered_set<ll> > f(k);
    vector<pair<ll, pair<ll,ll> > > g(k);
    for (ll i = 0; i < k; ++i) {
        cin >> g[i].second.first >> g[i].first >> g[i].second.second;
    }
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < k; ++j) {
            if (i == j) continue;
            if (g[j].first >= g[i].second.first && g[j].first <= g[i].second.second) {
                f[i].insert(j);
            }
        }
    }
    vector<ll> s;
    map<ll, bool> flag;
    for (ll i = 0; i < f.size(); ++i) {
        if (f[i].empty()) {
            s.push_back(i);
            flag[i] = true;
        }
    }
    if (s.empty()) {
        cout << "NO\n";
        return;
    }
    while (!s.empty()) {
        ll b = s.back();
        flag[b] = true;
        s.pop_back();
        for (ll j = 0; j < k; ++j) {
            if (f[j].contains(b)) {
                f[j].erase(b);
            }
            if (f[j].empty() && !flag[j]) {
                s.push_back(j);
            }
        }
    }
    bool r = false;
    for (ll i = 0; i < n; ++i) {
        if (!flag[i]) {
            r = true;
            break;
        }
    }
    if (r) cout<<"NO\n";
    else cout<<"YES\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
