#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int h, w;
    cin >> h >> w;

    vector<vector<char>> t(h, vector<char>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> t[i][j];
        }
    }

    vector<pair<int, int>> st;
    vector<vector<int>> vis(h, vector<int>(w));
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        int pos = -1;
        for (int j = w - 1; j >= 0; --j) {
            if (t[i][j] == '0') pos = -1;
            else {
                if (pos == -1) pos = j;
                a[i][j] = pos - j + 1;
            }
        }
    }

    ll ans = 0, cnt;
    for (int i1 = 0; i1 < h; ++i1) {
        for (int j = 0; j < w; ++j) {
            if (t[i1][j] == '0' || vis[i1][j]) continue;
            st.clear();
            ll sum = 0;
            for (int i = i1; i < h; ++i) {
                vis[i][j] = 1;
                cnt = 1;
                while (!st.empty() && st.back().first > a[i][j]) {
                    sum -= (st.back().first);
                    cnt += st.back().second;
                    st.pop_back();
                }
                sum += a[i][j] * cnt;
                st.push_back({a[i][j], cnt});
                ans = max(ans, sum);
            }
        }
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}