#include <bits/stdc++.h>

#define int long long

using namespace std;

using ll = long long;

const int inf = 1e9;

vector<vector<int>> arr;
vector<vector<int>> g;

vector<int> vis;
vector<int> vis1;
int n, d;

vector<pair<int, int>> ans;
void DFS(int v) {
    vis[v] = 1;
    for (int u : g[v]) {
        if (!vis[u]) {
            DFS(u);
            if (!vis1[u] && !vis1[v]) {
                vis1[u] = 1;
                vis1[v] = 1;
                ans.push_back({v, u});
            }
        }
    }
}

void solve() {
    cin >> n >> d;

    g.resize(n);
    arr.resize(n);
    vis.resize(n);
    vis1.resize(n);
    for (int i = 0, v, u; i < n - 1; ++i) {
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    DFS(0);

    cout << ans.size() << '\n';
    for (auto val : ans) {
        cout << val.first + 1 << ' ' << val.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}