#include <bits/stdc++.h>

#define int long long

using namespace std;

using ll = long long;

const int inf = 1e9;

vector<vector<int>> arr;
vector<vector<int>> g;

vector<int> vis;
vector<int> vis1;
int n, d;

vector<int> st;
vector<vector<int>> dist3;
vector<vector<int>> dist2;
vector<pair<int, int>> ans;
void DFS(int v, int p) {
    st.push_back(v);
    vis[v] = 1;
    for (int u : g[v]) {
        if (!vis[u]) {
            DFS(u, v);
        }
    }
    for (int u : dist3[v]) {
        if (vis1[u]) continue;
        vis1[v] = 1;
        vis1[u] = 1;
        ans.push_back({u, v});
        break;
    }
    for (int u : g[v]) {
        if (u == p) continue;
        if (vis1[u]) continue;
        while (!dist2[v].empty() && vis1[dist2[v].back()]) {
            dist2[v].pop_back();
        }
        if (dist2[v].empty()) break;
        vis1[u] = 1;
        vis1[dist2[v].back()] = 1;
        dist2[v].pop_back();
        ans.push_back({u, dist2[v].back()});
    }
    if (!vis1[v]) {
        if (st.size() >= 4) dist3[st[st.size() - 4]].push_back(v);
        if (st.size() >= 3) dist2[st[st.size() - 3]].push_back(v);
    }
    st.pop_back();
}

void solve() {
    cin >> n >> d;

    g.resize(n);
    arr.resize(n);
    vis.resize(n);
    vis1.resize(n);
    dist2.resize(n);
    dist3.resize(n);
    for (int i = 0, v, u; i < n - 1; ++i) {
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    DFS(0, 0);

    cout << ans.size() << '\n';
    for (auto val : ans) {
        cout << val.first + 1 << ' ' << val.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}