#include <bits/stdc++.h>

using namespace std;


#define int long long


vector<pair<int,int> > tree;


void push(int v) {
    int x = tree[v].second;
    tree[v].second = 0;
    tree[v * 2].first += x;
    tree[v * 2 + 1].first += x;
    tree[v * 2].second += x;
    tree[v * 2 + 1].second += x;
}

void upd(int v,int tl,int tr,int l,int r) {
    if (tl > r | tr < l) {
        return;
    } else if (tl >= l && tr <= r) {
        tree[v].first++;
        tree[v].second++;
        return;
    }
    push(v);
    int m = (tl + tr) / 2;
    upd(v * 2, tl, m, l, r);
    upd(v * 2 + 1, m + 1, tr, l, r);
    tree[v].first = min(tree[v * 2].first, tree[v * 2 + 1].first);
}

int fnd(int v,int tl,int tr,int pos) {
    if (tl == tr) {
        return tree[v].first;
    }
    int m = (tl + tr) / 2;
    if (pos <= m) {
        return fnd(v * 2, tl, m, pos);
    } else {
        return fnd(v * 2 + 1, m + 1, tr, pos);
    }
}

struct calls {
    int l, m, r;
};

bool cmp(calls a, calls b) {
    if (b.m < a.l || b.m > a.r) {
        return true;
    }
    return false;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        tree.clear();
        tree.resize(n * 4);
        vector<calls> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].l--;
            a[i].m--;
            a[i].r--;
        }
        vector<int> p(k);
        iota(p.begin(), p.end(), 0);
        bool g = false;
        do {
            tree.clear();
            tree.resize(n*4);
            for (auto i: p) {
                int l = a[i].l, m = a[i].m, r = a[i].r;
                int x = fnd(1, 0, n - 1, m);
                if (!x) {
                    upd(1, 0, n - 1, l, r);
                }     
            }
            if (tree[1].first) {
                g = true;
                break;
            }
        } while (next_permutation(p.begin(), p.end()));
        if (g) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
