#include <bits/stdc++.h>

using namespace std;


#define int long long
#define ld long double

struct node {
    int mn, mod, cnt;
};

vector<node> tree;

mt19937 rnd(time(0));


void build(int v,int tl,int tr) {
    if (tl == tr) {
        tree[v].cnt = 1;
    } else {
        int m = (tl + tr) / 2;
        build(v * 2, tl, m);
        build(v * 2 + 1, m + 1, tr);
        tree[v].cnt = tree[v * 2].cnt + tree[v * 2 + 1].cnt;
    }
}

void push(int v) {
    int x = tree[v].mod;
    tree[v].mod = 0;
    tree[v * 2].mn += x;
    tree[v * 2 + 1].mn += x;
    tree[v * 2].mod += x;
    tree[v * 2 + 1].mod += x;
    if (tree[v * 2].mn) {
        tree[v * 2].cnt = 0;
    }
    if (tree[v * 2 + 1].mn) {
        tree[v * 2 + 1].cnt = 0;
    }
}

void upd(int v,int tl,int tr,int l,int r) {
    if (tl > r | tr < l) {
        return;
    } else if (tl >= l && tr <= r) {
        tree[v].mn++;
        tree[v].mod++;
        if (tree[v].mn) {
            tree[v].cnt = 0;
        }
        return;
    }
    push(v);
    int m = (tl + tr) / 2;
    upd(v * 2, tl, m, l, r);
    upd(v * 2 + 1, m + 1, tr, l, r);
    tree[v].mn = min(tree[v * 2].mn, tree[v * 2 + 1].mn);
    tree[v].cnt = tree[v * 2].cnt + tree[v * 2 + 1].cnt;
}

int fnd(int v,int tl,int tr,int pos) {
    if (tl == tr) {
        return tree[v].mn;
    }
    push(v);
    int m = (tl + tr) / 2;
    if (pos <= m) {
        return fnd(v * 2, tl, m, pos);
    } else {
        return fnd(v * 2 + 1, m + 1, tr, pos);
    }
}

struct calls {
    int l, m, r;
};

bool cmp(calls a, calls b) {
    if (b.m < a.l || b.m > a.r) {
        return true;
    }
    return false;
}

signed main() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int e, d;
    cin >> e >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        int ans = 0;
        for (auto it: x) {
            int f = (it - e) / d, s = f + 1;
            f = e + f * d;
            s = e + s * d;
            ans += min((it - f) * (it - f), (it - s) * (it - s));
        }
        cout << ans << "\n";
    }
    return 0;
}
