#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)
#define fj(from, to) for(int j = from; j <= to; j++)

using namespace std;
int h, w;
vector <vector <int>> s;

int main() {
    cin >> h >> w;
    s.resize(h + 1, vector <int> (w + 1));
    fi(1, h) {
		string a;
		cin >> a;
		fj(1, w) {
			s[i][j] = a[j - 1] - '0';
		}
	}
    vector <vector <pair <int, int>>> dp(h + 1, vector <pair <int, int>>(w + 1)); // ans, lenght
    fi(1, h) {
        int len = 0;
        fj(1, w) {
            if (s[i][j] == 0) {len = 0; continue;}
            len++;
            if (s[i][j - 1] == 1 && dp[i][j - 1].first + 1 > dp[i][j].first) {
                dp[i][j].first = dp[i][j - 1].first + 1;
                dp[i][j].second = dp[i][j - 1].second + 1;
            }
            if (s[i - 1][j] == 1 && len >= dp[i - 1][j].second - 1 && dp[i - 1][j].first + dp[i - 1][j].second > dp[i][j].first) {
                dp[i][j].first = dp[i - 1][j].first + dp[i - 1][j].second;
                dp[i][j].second = dp[i - 1][j].second;
            }
        }
    }
    int ans = 0;
    fi(1, h) {
        fj(1, w) {
            ans = max(ans, dp[i][j].first);
        }
    }
    cout << ans;
}