#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<deque>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<ctime>
#include<random>
#include<unordered_set>
#include<unordered_map>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

const int N = 5e5 + 2, inf = 1e9 + 100;
const ll llinf = 4e18 + 1000;
int n, d, dist[N], pr[N], used[N], timer = 1;
vector<int> g[N], gp[N];
void dfs_dist(int v, int p) {
	for (auto to : g[v]) {
		if (to == p) continue;
		dist[to] = dist[v] + 1;
		dfs_dist(to, v);
	}
}
bool dfs(int v) {
	if (used[v] == timer) return false;
	used[v] = timer;
	for (auto to : gp[v]) {
		if (pr[to] == -1) {
			pr[to] = v;
			pr[v] = to;
			return true;
		}
	}
	for (auto to : gp[v]) {
		if (dfs(pr[to])) {
			pr[to] = v;
			pr[v] = to;
			return true;
		}
	}
	return false;
}

void solve() {
	cin >> n >> d;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for (int v = 0; v < n; ++v) {
		dist[v] = 0;
		dfs_dist(v, -1);
		for (int to = 0; to < n; ++to) {
			if (dist[to] <= d && dist[to] % 2) gp[v].push_back(to);
		}
	}
	dfs_dist(0, -1);
	fill(pr, pr + n, -1);
	for (int v = 0; v < n; ++v) {
		if (dist[v] % 2 == 1) continue;
		if (dfs(v)) {
			++timer;
		}
	}
	vector<pair<int, int>> ans;
	for (int v = 0; v < n; ++v) {
		if (dist[v] % 2 == 0 && pr[v] != -1) ans.push_back({ v, pr[v] });
	}
	cout << ans.size() << '\n';
	for (auto i : ans) cout << i.first + 1 << ' ' << i.second + 1 << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}