#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
#define all(a) a.begin(), a.end() 
 
vector<int>usd;
vector<int>matches;
 
void dfs(int v, vector<vector<int>>&gr, int p, vector<int>&dist)
{
    for(auto u: gr[v])
    {
        if(u != p)
        {
            dist[u] = dist[v] + 1;
            dfs(u, gr, v, dist);
        }
    }
    return;
}
 
bool kun(int v, vector<vector<int>>&gr)
{
    if(usd[v])
    {
        return false;
    }
    usd[v] = 1;
    for(auto u: gr[v])
    {
        if(matches[u] == -1 || kun(matches[u], gr))
        {
            matches[u] = v;
            return true;
        }
    }
    return false;
}
 
int main()
{
    int n;
    cin >> n;
    vector<vector<int>>gr(n);
    int d;
    cin >> d;
    int u, v;
    for(int i = 0; i < n - 1; i++)
    {
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    vector<vector<int>>gr2(n);
    vector<int>dist(n);
    dist.assign(n, 1e9);
    dist[0] = 0;
    dfs(0, gr, -1, dist);
    vector<int>nech;
    vector<int>ch;
    int c1 = 0, c2 = 0;
    for(int j = 0; j < n; j++)
    {
        if(dist[j] % 2 == 1)
        {
            nech.push_back(j + 1);
            c1++;
        }
        else
        {
            c2++;
            ch.push_back(j + 1);
        }
    }
    cout << min(c2, c1) << endl;
    cout << -1 << endl;
    return 0;
}