#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;
using ll = long long;



int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	int h, w;
	cin >> h >> w;
	vector<vector<bool>> a(h,vector<bool>(w + 1,0));
	vector<vector<int>> z(h,vector<int>(w + 1,0)), up(h,vector<int>(w + 1,0)),dp(h, vector<int>(w + 1, 0));
	for (int i = 0; i < h; i++)
	{
		for (int j = 0; j < w; j++)
		{
			char h;
			cin >> h;
			a[i][j] = (h == '1');
		}
	}
	vector<int> st;
	for (int i = 0; i < h; i++)
	{
		for (int j = 0; j < w + 1; j++)
		{
			if (a[i][j]) {
				st.push_back(j);
			}
			else {
				z[i][j] = j;
				while (!st.empty())
				{
					z[i][st.back()] = j;
					st.pop_back();
				}
			}
		}
	}
	for (int j = 0; j < w; ++j) {
		st.clear();
		for (int i = h - 1; i >= 0; i--)
		{
			while (!st.empty() and z[st.back()][j] >= z[i][j])
			{
				up[st.back()][j] = i;
				st.pop_back();
			}
			st.push_back(i);
		}
		while (!st.empty())
		{
			up[st.back()][j] = -1;
			st.pop_back();
		}
	}
	int ans = 0;
	for (int i = 0; i < h; i++)
	{
		for (int j = 0; j < w; j++)
		{
			if (!a[i][j])continue;
			int val = 0;
			if (up[i][j] != -1) {
				val = dp[up[i][j]][j];
			}
			dp[i][j] = val + (i - up[i][j]) * (z[i][j] - j);
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans;
}