#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
int n, d;
vector<int> cur;
vector<pair<int, int>> curans;
bool f = false;

void dfs(int v, int u, int c = 0, int p = -1) {
    if (f) return;
    if (v == u && c % 2 == 1 && c <= d) {
        f = true;
        return;
    }
    if (v == u) return;
    for (auto to : g[v]) {
        if (f) return;
        if (to == p) continue;
        dfs(to, u, c + 1, v);
    }
}

void gen(int i) {
    if (i == n) {
        int ind = 0;
        bool flag = true;
        int cnt = 0;
        for (auto j : cur) {
            if (ind < j) {
                cnt++;
                f = false;
                dfs(ind, j);
                if (!f) flag = false;
            }
            ind++;
        }
        if (flag && cnt > int(curans.size())) {
            ind = 0;
            curans.clear();
            for (auto j : cur) {
                if (ind < j) {
                    curans.emplace_back(ind, j);
                }
                ind++;
            }
        }
        return;
    }
    if (cur[i] != -1) {
        gen(i + 1);
    } else {
        for (int j = 0; j < n; j++) {
            if (cur[j] == -1) {
                cur[i] = j;
                cur[j] = i;
                gen(i + 1);
                cur[j] = -1;
                cur[i] = -1;
            }
        }
    }
}

void solve() {
    cin >> n >> d;
    cur.resize(n, -1);
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    gen(0);
    int cnt = (int) curans.size();;
    cout << cnt << '\n';
    for (auto [i, j] : curans) {
        cout << i + 1 << ' ' << j + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}