#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
#pragma GCC target("avx2,tune=native")
//#define int long long
void dfs(vector<vector<int>>& g, vector<int>& used, int v, vector<pair<int, int>>& gl) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (used[i] == 0) {
            gl[i].first = gl[v].first + 1;
            gl[i].second = i;
            dfs(g, used, i, gl);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    vector<pair<int, int>> gl(n);
    vector<int> used(n);
    dfs(g, used, 0, gl);
    vector<vector<int>> dr(n, vector<int>(n, 1e9));
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            dr[i][j] = 1;
        }
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (dr[i][j] > dr[i][k] + dr[k][j]) {
                    dr[i][j] = dr[i][k] + dr[k][j];
                }
            }
        }
    }
    vector<pair<int, int>> ans;
    vector<int> y(n);
    sort(gl.begin(), gl.end());
    for (int i = n - 1; i >= 0; --i) {
        int u = i;
        if (y[u] == 0) {
            for (int j = 0; j < n; ++j) {
                if (y[j] == 0 && dr[u][j] % 2 == 1 && dr[u][j] <= d) {
                    ans.push_back({u + 1, j + 1});
                    y[j] = 1;
                    y[u] = 1;
                    break;
                }
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << endl;
    }
    return 0;
}
