#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<vector<int>> nxth(n, vector<int>(m, m));
    vector<vector<int>> nxtv(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        int last = m;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '0') last = j;
            nxth[i][j] = last;
        }
    }
    for (int j = 0; j < m; j++) {
        int last = -1;
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '0') last = i;
            nxtv[i][j] = last;
        }
    }
    int ans = 0;
    vector<int> go(n, -1);
    for (int j = m - 1; j >= 0; j--) {
        vector<int> dp(n + 1);
        dp[0] = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '0') {
                go[i] = -1;
            } else {
                go[i] = max(go[i], nxtv[i][j]);
            }
        }
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '0') {
                dp[i + 1] = 0;
                continue;
            }
            int nx = nxth[i][j];
            int up = go[i];
            dp[i + 1] = dp[up + 1] + (nx - j) * (i - up);
            ans = max(ans, dp[i + 1]);
        }
    }
    cout << ans << '\n';
}