#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long;
 
# define all(x) x.begin(), x.end()
 
void solve();
 
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
 
void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v; u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> depth(n), up(n);
    {
        auto dfs {[&](auto dfs, int s, int p) -> void {
            if (p == -1) depth[s] = 0;
            else depth[s] = depth[p] + 1;
            up[s] = p;
            for (int i : g[s]) {
                if (i != p) {
                    dfs(dfs, i, s);
                }
            }
        }};
        dfs(dfs, 0, -1);
    }
    auto calc_dist {[&](int u, int v) -> int {
        int res = 0;
        while (u != v) {
            if (depth[u] > depth[v]) {
                u = up[u];
                res++;
            } else {
                v = up[v];
                res++;
            }
        }
        return res;
    }};
    vector<int> odd, even;
    for (int i = 0; i < n; i++) {
        if (depth[i] & 1) {
            odd.push_back(i);
        } else {
            even.push_back(i);
        }
    }
    vector<int> pr(n, -1);
    vector<vector<int>> h(n);
    for (int i : odd) {
        for (int j : even) {
            if (calc_dist(i, j) <= d) {
                h[i].push_back(j);
            }
        }
    }
    vector<int> used(n, 0);
    int timer = 1;
    auto try_kun {[&](auto try_kun, int s) -> bool {
        used[s] = timer;
        for (int i : h[s]) {
            if (pr[i] == -1) {
                pr[i] = s;
                pr[s] = i;
                return true;
            }
        }
        for (int i : h[s]) {
            if (used[pr[i]] < timer) {
                if (try_kun(try_kun, pr[i])) {
                    pr[s] = i;
                    pr[i] = s;
                    return true;
                }
            }
        }
        return false;
    }};
    int ans = 0;
    for (int i : odd) {
        ans += try_kun(try_kun, i);
        timer++;
    }
    cout << ans << '\n';
    for (int i : odd) {
        if (pr[i] != -1) {
            cout << i + 1 << ' ' << pr[i] + 1 << '\n';
        }
    }
    // cout << min(odd.size(), even.size()) << '\n';
    // for (int i = 0; i < min(odd.size(), even.size()); i++) {
    //     cout << odd[i] + 1 << ' ' << even[i] + 1 << '\n';
    // }
}