#ifndef LOCAL
  // #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  // #pragma GCC target("avx2,fma")
#endif

using namespace std;

using ll = long long;

auto& setmax(auto& a, const auto& b) {
  return a = a > b ? a : b;
}

auto& setmin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}

int isz(const auto& c) {
  return c.size();
}
#define int ll
const int group_size = sqrt(2e5);
// const int group_size = 1;
const int inf = 1e9;

struct sqrt_dec {
  vector<int> a, mn;

  sqrt_dec(int n) : a(n), mn((n + group_size - 1) / group_size, inf) {}

  void set(int i, int v) {
    a[i] = v;
    const int g = i / group_size;
    setmin(mn[g], v);
  }

  int group_begin(int g) {
    return g * group_size;
  }

  int group_end(int g) {
    return min<int>(isz(a), group_begin(g + 1));
  }

  int get_first_smaller(int l, int r, int val) {
    --r;
    const int lg = l / group_size;
    const int rg = r / group_size;
    if (lg == rg) {
      for (int i = r; i >= l; --i) {
        if (a[i] < val) return i;
      }
    } else {
      for (int i = r; i >= group_begin(rg); --i) {
        if (a[i] < val) return i;
      }
      for (int g = rg - 1; g > lg; --g) {
        if (mn[g] < val) {
          for (int i = group_end(g) - 1; i >= group_begin(g); --i) {
            if (a[i] < val) return i;
          }
          assert(false);
        }
      }
      for (int i = group_end(lg) - 1; i >= l; --i) {
        if (a[i] < val) return i;
      }
    }
    return l - 1;
  }
};

void solve() {
  int n, m;
  cin >> n >> m;
  vector a(n, vector<int>(m));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      char c;
      cin >> c;
      a[i][j] = c - '0';
    }
  }
  int ans = 0;
  vector val_cnt(n, vector<int>(m));
  vector dp(n, vector<int>(m));
  vector<sqrt_dec> sd(m, n);
  for (int j = m - 1; j >= 0; --j) {
    if (a[0][j]) {
      val_cnt[0][j] = (j == m - 1 ? 0 : val_cnt[0][j + 1]) + 1;
      dp[0][j] = val_cnt[0][j];
      setmax(ans, dp[0][j]);
      sd[j].set(0, val_cnt[0][j]);
    }
  }
  for (int i = 1; i < n; ++i) {
    for (int j = m - 1; j >= 0; --j) {
      if (!a[i][j]) continue;
      val_cnt[i][j] = (j == m - 1 ? 0 : val_cnt[i][j + 1]) + 1;
      // int cur = val_cnt[i][j];
      // for (int i2 = i - 1; i2 >= 0; --i2) {
      //   setmin(cur, val_cnt[i2][j]);
      //   if (!cur) break;
      //   dp[i][j] += cur;
      // }
      int k = sd[j].get_first_smaller(0, i, val_cnt[i][j]);
      dp[i][j] = val_cnt[i][j] * (i - k) + (k >= 0 ? dp[k][j] : 0);
      setmax(ans, dp[i][j]);
      sd[j].set(i, val_cnt[i][j]);
    }
  }
  cout << ans << '\n';
}

signed main() {
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  cin.tie(0)->sync_with_stdio(0);
  solve();
}