#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  #pragma GCC target("avx2,fma")
#endif

using namespace std;

using ll = long long;

auto& setmax(auto& a, const auto& b) {
  return a = a > b ? a : b;
}

auto& setmin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}

int isz(const auto& c) {
  return c.size();
}

#define all(x) begin(x), end(x)

struct man {
  int l, m, r;
};

void solve() {
  int n, k;
  cin >> n >> k;
  // vector<man> a(k);
  // for (auto& [l, m, r] : a) cin >> l >> m >> r;
  vector<vector<pair<int, int>>> b(n + 1);
  // for (auto [l, m, r] : a) {
    // b[l].push_back({m, r});
  // }
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    cin >> l >> m >> r;
    b[l].emplace_back(m, r);
  }
  // for (int i = 1; i <= n; ++i) {
    // sort(all(b[i]));
  // }
  vector<char> dp(n + 2, 0);
  dp[n + 1] = 1;
  for (int i = n; i > 0; --i) {
    for (auto [m, r] : b[i]) {
      for (int j = m + 1; j <= r + 1; ++j) {
        dp[i] |= dp[j];
        if (dp[i]) break;
      }
      for (int j = i + 1; j <= r; ++j) {
        for (auto [m2, r2] : b[j]) {
          if (m2 <= r) continue;
          dp[i] |= dp[j];
          if (dp[i]) break;
        }
      }
    }
  }
  if (dp[1]) {
    cout << "YES\n";
    return;
  }
  cout << "NO\n";
}

signed main() {
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  cin >> t;
  while (t --> 0) {
    solve();
  }
}