#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>

using namespace std;

template<typename T>
void print(T x) {
    cout << x;
}

template<typename T>
void print(vector<T> &a) {
    for (auto x : a) {
        print(x);
        cout << ' ';
    }
    cout << '\n';
}


struct node{
    int l, r, m;
    node() {}
    node(int l, int m, int r) : l{l}, r{r}, m{m} {}
};
vector<vector<int>> g;
vector<int> used;

bool dfs(int u) {
    used[u] = 1;
    for (int to : g[u]) {
        if (used[to] == 1) return 1;
        if (used[to] == 2) continue;
        if (dfs(to)) return 1;
    }
    used[u] = 2;
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<node> p(k);
    vector<int> cnt(n + 1, 0);
    vector<int> a(n + 2, 0);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        ++a[l];
        --a[r + 1];
        p[i] = {l, m, r};
        ++cnt[m];
    }
    for (int i = 1; i <= n; ++i) {
        a[i] += a[i - 1];
        //cout << a[i] << ' ';
        if (a[i] == 0) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (cnt[i] > 1) {
            cout << "NO\n";
            return;
        }
    }
    // g.resize(k);
    // used.resize(k);
    // for (int i = 0; i < k; ++i) {
    //     used[i] = 0;
    //     for (int j = 0; j < k; ++j) {
    //         if (j == i) continue;
    //         if (p[i].l <= p[j].m && p[j].m <= p[i].r) {
    //             g[i].push_back(j);
    //         }
    //     }
    // }
    // //print(g);
    // for (int i = 0; i < k; ++i) {
    //     if (used[i]) continue;
    //     //cout << i << '\n';
    //     //print(used);
    //     if (dfs(i)) {
    //         cout << "NO\n";
    //         return;
    //     }
    // }
    cout << "YES\n";
}




int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}