#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<int> > field(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] == '1')
                field[i][j] = 1;
        }
    }

    vector<vector<int> > high(n, vector<int>(m, 0));
    vector<vector<int> > len(n, vector<int>(m, 0));
    high[0] = field[0];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (field[i][j] == 0)
                continue;

            high[i][j] = high[i - 1][j] + 1;
        }
    }

    for (int i = 0; i < n; ++i)
        len[i][m - 1] = field[i][m - 1];
    for (int i = 0; i < n; ++i) {
        for (int j = m - 2; j >= 0; --j) {
            if (field[i][j] == 0)
                continue;

            len[i][j] = len[i][j + 1] + 1;
        }
    }

    vector<vector<int> > ans(n, vector<int>(m, 0));

    ans[0][m - 1] = field[0][m - 1];
    int maxim = ans[0][m - 1];
    for (int j = m - 2; j >= 0; --j) {
        if (field[0][j] == 0)
            continue;

        ans[0][j] = ans[0][j + 1] + 1;
        maxim = max(maxim, ans[0][j]);
    }

    for (int i = 1; i < n; ++i) {
        if (field[i][m - 1] == 0)
            continue;

        ans[i][m - 1] = ans[i - 1][m - 1] + 1;
        maxim = max(maxim, ans[i][m - 1]);
    }

    for (int i = 1; i < n; ++i) {
        for (int j = m - 2; j >= 0; --j) {
            if (field[i][j] == 0)
                continue;

            ans[i][j] = max(ans[i - 1][j] + ans[i][j + 1] - ans[i - 1][j + 1] + 1, max(high[i][j], len[i][j]));
            maxim = max(maxim, ans[i][j]);
        }
    }
    cout << maxim << endl;
}
