#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

vector<vector<int> > graph;
vector<int> colour;

void dfs(int v, int c) {
    colour[v] = c;
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        if (colour[u] == 0)
            dfs(u, 3 - c);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, d;
    cin >> n >> d;

    graph.resize(n);
    colour.assign(n, 0);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    dfs(0, 1);

    vector<int> first, second;
    for (int i = 0; i < n; ++i)
        if (colour[i] == 1)
            first.push_back(i);
        else
            second.push_back(i);

    int am = min(first.size(), second.size());
    cout << am << endl;
    for (int i = 0; i < am; ++i) {
        cout << first[i] + 1 << " " << second[i] + 1 << endl;
    }
}
