#include<iostream>
#include<vector>
#include<string>
#include<fstream>
#include<sstream>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>

#define ll long long
#define ld long double

using namespace std;

const int INF = 1e9 + 7;
const ll INFL = (ll) 1e18 + 7;

ll func(int n, vector<int> &x, int d, ll cnt, int t) {
    ll f = cnt * t;
    for (int i = 0; i < n; i++) {
        if (x[i] <= cnt * d) {
            ll k = min(x[i] % d, d - x[i] % d);
            f += k * k;
        } else {
            ll k = x[i] - d * cnt;
            f += k * k;
        }
    }
    return f;
}


int solve(int cnt_test) {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0, d, m;
    cin >> x0 >> d >> m;
    for (int m1 = 0; m1 < m; m1++) {
        int t;
        cin >> t;
        int l = -1, r = INF / d + 1;
        ll f = INFL;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            ll f1 = func(n, x, d, mid, t);
            ll f2 = func(n, x, d, mid + 1, t);
            if (f1 > f2) l = mid;
            else r = mid;
            f = min({f, f1, f2});
        }
        cout << f << '\n';
    }

    return 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while (!cin.eof()) {
        solve(cnt++);
    }
#else
    solve(0);
#endif
}