#include <bits/stdc++.h>
#define ll long long

using namespace std;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll> > field(n, vector<ll>(m, 0));
    for (ll i = 0; i < n; i++) {
        string t;
        cin >> t;
        for (ll j = 0; j < m; j++) {
            if (t[j] == '0') {
                field[i][j] = 0;
            } else {
                field[i][j] = 1;
            }
        }
    }

    vector<vector<ll> > precalc(n, vector<ll>(m, 0));

    for (ll i = n - 1; i >= 0; i--) {
        for (ll j = m - 1; j >= 0; j--) {
            if (field[i][j] == 0) {
                continue;
            }

            if (j == m - 1) {
                precalc[i][j] = field[i][j];
            } else {
                precalc[i][j] = precalc[i][j + 1] + field[i][j];
            }
        }
    }


    vector<vector<pair<ll, ll> > > dp(n, vector<pair<ll, ll> >(m, {0, 0}));

    for (ll i = n - 1; i >= 0; i--) {
        for (ll j = m - 1; j >= 0; j--) {
            if (field[i][j] == 0) {
                continue;
            }

            if (i == n - 1) {
                dp[i][j] = {precalc[i][j], precalc[i][j]};
                continue;
            }

            // max this line
            if (precalc[i][j] <= dp[i + 1][j].second) {
                dp[i][j] = {precalc[i][j] + dp[i + 1][j].first, precalc[i][j]};
            } else {
                dp[i][j] = {precalc[i][j], precalc[i][j]};
            }

            // min this line
            ll cur_value = min(precalc[i][j], dp[i + 1][j].second);
            if (cur_value + dp[i + 1][j].first >= dp[i][j].first) {
                dp[i][j] = {cur_value + dp[i + 1][j].first, cur_value};
            }
        }
    }

    ll max_value = 0;

    for (auto c : dp) {
        for (auto d : c) {
            // cout << d.first << ' ';
            max_value = max(max_value, d.first);
        }
        // cout << '\n';
    }

    cout << max_value;
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    ll tt;
    cin >> tt;

#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
}
