#include <bits/stdc++.h>
using namespace std;
using ll = long long;
template<typename T>
void _print(T a) {cerr << a;}
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(vector<T> a) {cerr << "[";int f = 0;for (auto v : a) {if (f++)cerr << ", ";_print(v);}cerr << "]";}

#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n';
#else
#define debug(x)
#endif

struct empl {
    int l, m, r;
};

void solve() {
    int n, k; cin >> n >> k;
    vector<empl> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    sort(a.begin(), a.end(), [](empl a, empl b) {
        return a.l < b.l;
    });
    vector<bool> used(n + 1);
    int maxi = 0;
    for (int i = 0; i < k; ++i) {
        if (used[a[i].m])continue;
        maxi = max(maxi, a[i].r);
        used[a[i].l] = true;
    }
    if (maxi == n) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}
int main() {
    std::ios_base::sync_with_stdio(false);std::cin.tie(nullptr);std::cout.tie(nullptr);

    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}