#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using oset = tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
void sort(T &s) {
    sort(s.begin(), s.end());
}

int n, m, uk0;
__int128 x0, d, uk;
vector<__int128> x, pref, prefs, prefc, opt, c;
vector<pair<__int128, int> > t;


pair<__int128, int> check(__int128 nuk, int i) {
    int nuk0 = uk0;
    while (nuk0 < n && opt[nuk0] <= nuk) {
        nuk0++;
    }

    __int128 nres;
    if (nuk0 == 0) {
        nres = t[i].first * (nuk - x0) / d + nuk * nuk * n - 2 * nuk * pref[n - 1] + prefs[n - 1];
    } else {
        nres = t[i].first * (nuk - x0) / d + prefc[nuk0 - 1] + nuk * nuk * (n - nuk0) - 2 * nuk * (pref[n - 1] - pref[nuk0 - 1]) + prefs[n - 1] - prefs[nuk0 - 1];
    }

    return {nres, nuk0};
}

void solve() {
    cin >> n;

    x.resize(n);
    for (auto &i : x) {
        ll cf;
        cin >> cf;
        i = cf;
    }
    sort(x);

    ll xx0, dd;
    cin >> xx0 >> dd;
    x0 = xx0;
    d = dd;

    cin >> m;

    t.resize(m);
    for (int i = 0; i < m; ++i) {
        ll cf;
        cin >> cf;
        t[i].first = cf;
        t[i].second = i;
    }
    sort(t.rbegin(), t.rend());

    opt.resize(n);
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        opt[i] = x0 + __int128(floor(ld(x[i] - x0) / d)) * d;
        if ((x[i] - opt[i]) * (x[i] - opt[i]) > (x[i] - (opt[i] + d)) * (x[i] - (opt[i] + d))) {
            opt[i] += d;
        }
        c[i] = (x[i] - opt[i]) * (x[i] - opt[i]);
    }

    pref.resize(n);
    prefs.resize(n);
    prefc.resize(n);
    pref[0] = x[0];
    prefs[0] = x[0] * x[0];
    prefc[0] = c[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + x[i];
        prefc[i] = prefc[i - 1] + c[i];
        prefs[i] = prefs[i - 1] + x[i] * x[i];
    }

    vector<__int128> r(m), r2(m);
    uk = x0;
    uk0 = 0;

    for (int i = 0; i < m; ++i) {
        __int128 res;
        if (uk0 == 0) {
            res = t[i].first * (uk - x0) / d + uk * uk * n - 2 * uk * pref[n - 1] + prefs[n - 1];
        } else {
            res = t[i].first * (uk - x0) / d + prefc[uk0 - 1] + uk * uk * (n - uk0) - 2 * uk * (pref[n - 1] - pref[uk0 - 1]) + prefs[n - 1] - prefs[uk0 - 1];
        }
        __int128 lu = (uk - x0) / d;
        __int128 ru = (opt.back() - x0) / d + 1;

        while (ru - lu > 2) {
            __int128 d1 = (2 * lu + ru) / 3;
            __int128 d2 = (lu + ru * 2) / 3;
            auto [r1, u1] = check(d1 * d, i);
            auto [r2, u2] = check(d2 * d, i);

            if (r1 >= r2) {
                lu = d1;
                uk0 = u1;
            } else {
                ru = d2;
            }
        }

        auto [r1, u1] = check(lu * d, i);
        auto [r2, u2] = check((ru - 1) * d, i);

        if (r2 < r1) {
            swap(r1, r2);
            swap(u1, u2);
            lu = ru - 1;
        }

        res = r1;
        uk0 = u1;
        uk = lu * d;
        r[i] = res;
    }

    vector<__int128> ans(m);
    for (int i = 0; i < m; ++i) {
        ans[t[i].second] = r[i];
    }

    for (auto i : ans) {
        auto j = i;
        __int128 mod = 10;
        string s;
        if (j == 0) {
            s += '0';
        }
        while (j != 0) {
            s += to_string(ll(j % mod));
            j /= mod;
        }
        reverse(s.begin(), s.end());
        cout << s << "\n";
    }
}



signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
