#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <bitset>
#include <cmath>
 
using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
 
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif
 
int n, m;
vector<vector<int>> a, pref;
 
int bin(int line, int ql, int qr) {
    int l = ql, r = qr;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (pref[line][mid] - pref[line][ql] == mid - ql) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}
 
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
 
    cin >> n >> m;
    a = vector<vector<int>> (n, vector<int> (m));
    pref = vector<vector<int>> (n, vector<int> (m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
            pref[i][j + 1] = pref[i][j] + a[i][j];
        }
    }
    int ans = 0;
    for (int sj = 0; sj < m; sj++) {
        for (int ei = n - 1; ei >= 0; ei--) {
            int startlen = bin(ei, sj, m + 1);
            int cur = startlen - sj;
            dbg(ei, cur);
            for (int si = ei - 1; si >= 0; si--) {
                while (startlen > sj && pref[si][startlen] - pref[si][sj] != startlen - sj) {
                    startlen--;
                }
                cur += startlen - sj;
                if (startlen - sj <= 0 || si == 0) {
                    break;
                }
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << '\n';
}