#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <bitset>
#include <cmath>
 
using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
 
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif
 
int n, m;
vector<vector<int>> a, pref;
 
int bin(int line, int ql, int qr) {
    int l = ql, r = qr;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (pref[line][mid] - pref[line][ql] == mid - ql) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}
 
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
 
    cin >> n >> m;
    a = vector<vector<int>> (n, vector<int> (m));
    pref = vector<vector<int>> (n, vector<int> (m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
            pref[i][j + 1] = pref[i][j] + a[i][j];
        }
    }
    int ans = 0;
    for (int sj = 0; sj < m; sj++) {
        vector<int> h(n);
        for (int i = 0; i < n; i++) {
            h[i] = bin(i, sj, m + 1) - sj;
        }
        vector<int> pref2(n);
        vector<pair<int, int>> cur;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            while (!cur.empty() && cur.back().first > h[i]) {
                pair<int, int> kek = cur.back();
                cur.pop_back();
                sum -= kek.first * kek.second;
                if (!cur.empty() && cur.back().first == kek.first - 1) {
                    cur[cur.size() - 1].second += kek.second;
                    sum += cur.back().first * kek.second;
                } else {
                    cur.emplace_back(kek.first - 1, kek.second);
                    sum += (kek.first - 1) * kek.second;
                }
            }
            if (!cur.empty() && cur.back().first == h[i]) {
                cur[cur.size() - 1].second++;
            } else {
                cur.emplace_back(h[i], 1);
            }
            sum += h[i];
            ans = max(ans, sum);
        }
    }
    cout << ans << '\n';
}