#include <bits/stdc++.h>
using namespace std;

using ll = int;
using pll = pair<ll,ll>;
using ve = vector<ll>;
#define pb push_back
#define all(x) x.begin(),x.end()
#define F first
#define S second

const ll N=5e5+5,inf=1e9;
ll sl[2*N],sm[2*N];
ll l[N],r[N],m[N];
pair<ll,pll> P[N];

void build_l(ll v, ll l, ll r) {
    sl[v]=0;
    if (l==r) return;
    ll mid=l+(r-l)/2;
    build_l(2*v,l,mid);
    build_l(2*v+1,mid+1,r);
}
ll sum_l(ll v, ll l, ll r, ll lx, ll rx) {
    if (lx>rx || lx>r || rx<l) return 0;
    if (lx<=l && rx>=r) return sl[v];
    ll mid=l+(r-l)/2;
    return sum_l(2*v,l,mid,lx,rx)+sum_l(2*v+1,mid+1,r,lx,rx);
}
void upd_l(ll v, ll l, ll r, ll pos) {
    if (l==r) {
        sl[v]=1;
        return;
    }
    ll mid=l+(r-l)/2;
    if (pos<=mid) {
        upd_l(2*v,l,mid,pos);
    } else {
        upd_l(2*v+1,mid+1,r,pos);
    }
    sl[v]=sl[2*v]+sl[2*v+1];
}
//////////////////////////////////////////////
///
void build_m(ll v, ll l, ll r) {
    sm[v]=inf;
    if (l==r) return;
    ll mid=l+(r-l)/2;
    build_m(2*v,l,mid);
    build_m(2*v+1,mid+1,r);
}
ll min_m(ll v, ll l, ll r, ll lx, ll rx) {
    if (lx>rx || lx>r || rx<l) return inf;
    if (lx<=l && rx>=r) return sm[v];
    ll mid=l+(r-l)/2;
    return min(min_m(2*v,l,mid,lx,rx),min_m(2*v+1,mid+1,r,lx,rx));
}
void upd_m(ll v, ll l, ll r, ll pos, ll nw) {
    if (l==r) {
        sm[v]=min(sm[v],nw);
      //  cout << "! " << v << " " << nw << "\n";
        return;
    }
    ll mid=l+(r-l)/2;
    if (pos<=mid) {
        upd_m(2*v,l,mid,pos,nw);
    } else {
        upd_m(2*v+1,mid+1,r,pos,nw);
    }
    sm[v]=min(sm[2*v],sm[2*v+1]);
}

void sol() {
    ll i,j,n,k; cin >> n >> k;
    for (i=1;i<=k;i++) cin >> l[i] >> m[i] >> r[i];
    P[0]={0,{0,0}};
    for (i=1;i<=k;i++) {
        P[i]={l[i],{m[i],r[i]}};
    }
    sort(P,P+k+1);
    for (i=1;i<=k;i++) {
        l[i]=P[i].F;
        m[i]=P[i].S.F;
        r[i]=P[i].S.S;
    }
    // xl[i] - можно ли дойти до n, если самая левая граница - i
    // xm[i] - можно ли дойти до n, если самый маленький m = i, если можно, то хранится самая левая возможная граница с этим условием
    build_l(1,1,n);
    build_m(1,1,n);
    for (i=k;i>=1;i--) {
   //     cout << l[i] << " " << m[i] << " " << r[i] << "\n";
        if (r[i]==n) {
            upd_l(1,1,n,l[i]);
            upd_m(1,1,n,m[i],l[i]);
         //   cout << min_m(1,1,n,m[i],n) << "\n";

        } else {
            if (sum_l(1,1,n,m[i]+1,r[i]+1)>0) {
                upd_l(1,1,n,l[i]);
                upd_m(1,1,n,m[i],l[i]);
             //   cout << min_m(1,1,n,m[i],n) << "\n";

                // если m[i] не покрывается
            } else {
          //      cout << min_m(1,1,n,r[i]+1,n) << "\n";
                if (min_m(1,1,n,r[i]+1,n)<=(r[i]+1)) {
                    upd_l(1,1,n,l[i]);
                    upd_m(1,1,n,m[i],l[i]);
                    // если следующие m[j] все большие
                }
            }
        }
    }
    if (sum_l(1,1,n,1,1)>0) cout << "YES\n"; else cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t; cin >> t; while (t--) sol();
    return 0;
}