#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll,ll>;
using ve = vector<ll>;
#define pb push_back
#define all(x) x.begin(),x.end()
#define F first
#define S second

const ll N=6e5+5,inf=1e12;
ll x[N],f[N],pref[N];
vector<pll> vl0,vl1,vr0,vr11;
ll c2[N],c1[N],c0[N];

ll divide(ll A, ll B) {
    long double d = (long double)A/(long double)B;
    ll c=(ll)d;
    return c;
}
ll intersectX(pll l1, pll l2) {
    return divide(l1.S-l2.S,l2.F-l1.F);
}
struct cht {
    deque<pair<pll,ll>> d;
    void add_line(pll l) {
        while (d.size()>=2) {
            if (intersectX(l,d[d.size()-1].F)<=(d[d.size()-2].S)) {
                d.pop_back();
            } else {
                break;
            }
        }
        if (d.empty()) {
            d.pb({l,inf});
        } else {
            d[d.size()-1].S=intersectX(l,d[d.size()-1].F);
            d.pb({l,inf});
        }
    }
    ll query(ll xx) {
        ll l=-1,r=d.size()-1;
        while (r-l>1) {
            ll m=l+(r-l)/2;
            if (d[m].S>=xx) r=m; else l=m;
        }
        return d[r].F.F*xx+d[r].F.S;
        // eval
    }
};

void sol() {
    ll l,r,m;
    ll i,j,n,x0,d;
    cin >> n;
    for (i=1;i<=n;i++) cin >> x[i];
    cin >> x0 >> d;
    x[0]=-1; x[n+1]=1e9;
    sort(x,x+n+1);
    pref[0]=0;
    for (i=1;i<=n;i++) {
        ll r=x0+inf*d-x[i];
        r%=d;
        ll xx=min(r,d-r); xx*=xx;
        pref[i]=pref[i-1]+xx;

    }


    // найти все прямые левые
    c2[0]=c1[0]=c0[0]=0;
    for (i=1;i<=n;i++) {
        c2[i]=c2[i-1];
        c1[i]=c1[i-1];
        c0[i]=c0[i-1];
        c2[i]+=1;
        c1[i]-=2*x[i];
        c0[i]+=x[i]*x[i];
    }
    // ///////////
    for (i=x0;i>=-d;i=i-d) {
        ll L,R;
        // найти все точки от i до x0
        l=0,r=n+1;
        while (r-l>1) {
            m=l+(r-l)/2;
            if (x[m]>=i) r=m; else l=m;
        }
        L=r;
        //////////
        l=0,r=n+1;
        while (r-l>1) {
            m=l+(r-l)/2;
            if (x[m]<=x0) l=m; else r=m;
        }
        R=l;
        //////////
        ll sum=0;
        if (L<=R) sum=pref[R]-pref[L-1];
        ll K=0,B=sum;
        B+=c2[L-1]*i*i+c1[L-1]*i+c0[i-1];
        // для последних L-1 прямых
        K=(x0-i)/d;
        vl0.pb({-K,-B});
        // налево, не возвращаемся
        K*=2;
        vl1.pb({-K,-B});
    }
    //////////// cчитаем все правые прямые
    c2[n+1]=c1[n+1]=c0[n+1]=0;
    for (i=n;i>=1;i--) {
        c2[i]=c2[i+1];
        c1[i]=c1[i+1];
        c0[i]=c0[i+1];
        c2[i]+=1;
        c1[i]-=2*x[i];
        c0[i]+=x[i]*x[i];
    }
  //  return;
    // коэффициенты
    for (i=x0;i<=1000000+d; i=i+d) {
        ll L,R;
        l=0,r=n+1;
        while (r-l>1) {
            m=l+(r-l)/2;
            if (x[m]>=x0) r=m; else l=m;
        }
        L=r;
        // //////////
        l=0,r=n+1;
        while (r-l>1) {
            m=l+(r-l)/2;
            if (x[m]<=i) l=m; else r=m;
        }
        R=l;
        ll sum=0;
        if (R>=L) sum=pref[R]-pref[L-1];
        //   для точек, для которых мы максимально близко можем подойти
        ll K=0,B=sum;
        B+=c2[R+1]*i*i+c1[R+1]*i+c0[R+1];
        K=(i-x0)/d;
        vr0.pb({-K,-B});
        // // если направо, возвращаемся
        K*=2;
        vr11.pb({-K,-B});
        // // если направо, возвращаемся
    }
  //  return;
    sort(all(vl0));
    sort(all(vl1));
    sort(all(vr0));
    sort(all(vr11));
  //  return;
    // сделать кхт
    cht sl0,sl1,sr0,sr1;
  //  return;
    for (auto to:vl0) sl0.add_line(to);
    for (auto to:vl1) sl1.add_line(to);
    for (auto to:vr0) sr0.add_line(to);
    for (auto to:vr11) sr1.add_line(to);
  //  for (auto to:vl1) cout << to.F << " " << to.S << "\n";
 //  cout << "\n";
   //  for (auto to:vr11) cout << to.F << " " << to.S << "\n";
   // return;
     cin >> m;
    while (m--) {
        ll t; cin >> t;
        ll ans=(ll)1e18;
        ll x1=sl0.query(t)+sr1.query(t);
        ll x2=sl1.query(t)+sr0.query(t);
        x1*=-1;
        x2*=-1;
        ans=min(x1,x2);
        cout << ans << "\n";
    }
  //  cout << sl1.query(2) << ".\n";
    // for (auto to:sl1) {
    //     cout << to.S << "\n";
    // }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // cht s;
    // s.add_line({-1,7});
    // s.add_line({1,-1});
    // cout << s.query(3) << "\n";
    // return 0;
    sol();
    return 0;
}