#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e9;
struct node {
    ll l, m, r;
};
void solve() {
    ll n,k;
    cin>>n>>k;
    vector<node> v(k);
    vector<ll> sl(n + 2);
    for (ll i = 0; i < k; ++i) {
        cin>>v[i].l >> v[i].m >> v[i].r;
        sl[v[i].l]++;
        sl[v[i].r + 1]--;
    }
    // if (n == 5 && k == 3) {
    //     cout << "NO\n";
    //     return;
    // }
    ll sum = 0;
    for (ll i = 1; i <= n; ++i) {
        sum += sl[i];
        if (sum <= 0) {
            cout << "NO\n";
            return;
        }
    }
    sort(v.begin(), v.end(), [] (node &f, node &s) {
       if (f.l == s.l)
           return f.r > s.r;
        return f.l < s.l;
    });
    vector<ll> dp(n + 1, INF);
    dp[0] = 0;
    for (ll i = 0; i < k; ++i) {
        bool can = false;
        for (ll j = v[i].l - 1; j <= v[i].r; ++j) {
            if (dp[j] != INF && dp[j] < v[i].l) {
                can = true;
                break;
            }
            if (dp[j] != INF && j < v[i].m) {
                can = true;
                break;
            }
        }
        if (can) {
            dp[v[i].r] = min(dp[v[i].r], v[i].m);
        }
    }
    if (dp[n] != INF)
        cout << "YES\n";
    else
        cout<<"NO\n";

}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}