#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e9;
const ll LG = 20;
vector<vector<ll>> gr;
vector<vector<ll>> g;
vector<ll> le, ri;
vector<vector<ll>> up;
vector<ll> tin, tout;
vector<ll> h, used;
vector<ll> Pair;
ll timer = 0;
void dfs(ll v, ll p, ll hi) {
    up[v][0] = p;
    h[v] = hi;
    tin[v] = timer++;
    for (ll l = 1; l < LG; ++l) {
        up[v][l] = up[up[v][l - 1]][l - 1];
    }
    for (auto &to : gr[v]) {
        if (v == p) continue;
        dfs(to, v, hi + 1);
    }
    tout[v] = timer++;
}

bool an(ll a, ll b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void dfs2(ll v, ll col) {
    if (col)
        ri.push_back(v);
    else
        le.push_back(v);
    used[v] = true;
    for (auto &to : gr[v]) {
        if (used[to]) continue;
        dfs2(to, col ^ 1);
    }
}

ll lca(ll a, ll b) {
    ll suml = 0, sumr = 0;
    ll ta = a, tb = b;
    for (ll l = LG - 1; l >= 0; --l) {
        if (!an(up[a][l], b)) {
            suml += 1 << l;
            a = up[a][l];
        }
        if (!an(up[b][l], a)) {
            sumr += 1 << l;
            b = up[b][l];
        }
    }
    ll c = a;
    if (!an(c, b))
        c = up[a][0];
    return h[ta] + h[tb] - 2 * h[c];
}

bool kun(ll v) {
    if (used[v])
        return false;
    used[v] = true;
    for (auto &to : gr[v]) {
        if (Pair[to] == -1 || kun(Pair[to])) {
            Pair[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    ll n, d;
    cin>>n>>d;
    gr.resize(n); up.resize(n, vector<ll>(LG));
    g.resize(n); tin.resize(n); tout.resize(n); h.resize(n);
    used.resize(n); Pair.resize(n, -1);
    vector<pair<ll,ll>> ed(n - 1);
    for (ll i = 0; i  < n - 1; ++i) {
        ll a,b;
        cin>>a>>b;
        --a;--b;
        ed[i] = {a, b};
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    // dfs(0, 0, 0);
    // for (ll i =  0; i < n - 1; ++i) {
    //     ll len = lca(ed[i].first, ed[i].second);
    //     if (len <= d)
    //         g[ed[i].first].push_back(ed[i].second), g[ed[i].second].push_back(ed[i].first);
    // }
    for (ll i = 0; i < n; ++i) {
        if (used[i]) continue;
        dfs2(i, 0);
    }
    vector<pair<ll,ll>> ans;
    for (ll i =  0; i  < min(le.size(), ri.size()); ++i)
        ans.push_back({le[i], ri[i]});
    cout << ans.size() << endl;
    for (auto &to : ans)
        cout << to.first << " " << to.second << endl;
    // for (ll i = 0; i < le.size(); ++i) {
    //     used.assign(n, false);
    //     kun(le[i]);
    // }
    // vector<pair<ll,ll>> ans;
    // for (ll i = 0; i < ri.size(); ++i) {
    //     if (Pair[ri[i]] != -1)
    //         ans.push_back({Pair[ri[i]], ri[i]});
    // }
    // cout << ans.size() << endl;
    // for (auto &to : ans) {
    //     cout << to.first + 1 << " " << to.second + 1 << endl;
    // }
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}