#include <bits/stdc++.h>
using namespace std;

void solve() {
    int h,w;
    cin >> h >> w;
    vector<string> a(h);
    for (auto &s : a) cin >> s;
    int ans = 0;
    vector<vector<int>> dp(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        vector<int> pref(w+1);
        for (int j = 1; j <= w; ++j) {
            pref[j] = pref[j-1] + (a[i][j-1]=='1');
        }
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == '1') {
                int l = 0, r = w - j;
                while (r-l>1) {
                    int m = (r + l) / 2;
                    if (pref[m+j] - pref[j] == (m - j + 1)) {
                        l = m;
                    }
                    else {
                        r = m;
                    }
                }
                dp[i][j] = l;
            }
        }
    }
    vector<int> pos(w);
    for (int i = 0; i < w; ++i) {
        for (int j = 0; j < h; ++j) {
            if (a[j][i] == '1') {
                pos[i] = j;
                break;
            }
        }
    }
    for (int j = 0; j < w; ++j) {
        int i = pos[j];
        if (a[i][j] == '1') {
            int d = dp[i][j];
            int cur = d;
            vector<int> c(w - j +1);
            for (int k = 1; k <= d; ++k) {
                c[k] = 1;
            }
            for (int k = i+1; k < h; ++k) {
                ans = max(ans, cur);
                if (dp[k][j] < d) {
                    for (int b = d; b > dp[k][j]; --b) {
                        cur -= c[b];
                        c[b] = 0;
                    }
                }
                d = dp[k][j];
                for (int b = 1; b <= d; ++b) {
                    c[b]++;
                    cur++;
                }
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}