#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define all(x) x.begin(), x.end()
#define speed ios::sync_with_stdio(false), cin.tie(nullptr);
#define pb push_back

// 0 - white
// 1 - gray
// 2 - black
void dfs(vector<vll>& g, vll& state, ll curr, bool& bad) {
    state[curr] = 1;

    for (auto next : g[curr]) {
        if (state[next] == 1) {
            bad = true;
            break;
        }
        if (state[next] == 0) {
            dfs(g, state, next, bad);
        }
    }

    state[curr] = 2;
}

bool check(vector<vll>& meet, ll n, vll& perm) {
    vll count(n + 1, 0);

    for (auto x : perm) {
        if (count[meet[x][1]] == 0) {
            for (ll i = meet[x][0]; i <= meet[x][2]; i++) {
                count[i]++;
            }
        }
    }
    ll has = 0;

    for (int i = 1; i <= n; i++) {
        if (count[i] > 0) has++;
    }

    return has == n;
}

int main() {

    speed

    ll _; cin >> _;

    while (_--) {
        ll n, k, c1 = 0; cin >> n >> k;

        vector<vll> come(k + 1, vll(3)), meet(n + 1), g(k + 1);
        vll canGo(n + 1);

        for (int i = 1; i <= k; i++) {
            cin >> come[i][0] >> come[i][1] >> come[i][2];
            meet[come[i][1]].pb(i);
            if (come[i][0] == come[i][1]) c1++;

        }

        if (c1 == k) {
            bool bad = false;
            vll scan(n + 2, 0);
            for (int i = 1; i <= k; i++) {
                scan[come[i][0]]++;
                scan[come[i][2] + 1]--;
            }

            for (int i = 1; i <= n; i++) {
                scan[i] += scan[i - 1];
                if (scan[i] == 0) bad = true;
            }

            cout << (bad ? "NO" : "YES") << "\n";
            continue;
        }

        if (k <= 8) {
            vll perm; bool found = false;
            for (int i = 1; i <= k; i++) perm.pb(i);

            do {
                if (check(come, n, perm)) {
                    found = true;
                }
            } while (next_permutation(all(perm)));

            cout << (found ? "YES" : "NO") << "\n";
            continue;
        }

        if (n <= 18) {
            vector<bool> dp(1LL << n, false);
            dp[0] = true;

            for (ll i = 1; i <= k; i++) {
                for (ll mask = 0; mask < (1LL << n); mask++) {
                    if (!dp[mask]) {
                        continue;
                    }
                    if ((mask & (1LL << (come[i][1] - 1LL))) > 0) {
                        continue;
                    }
                    ll also = 0;

                    for (ll j = come[i][0] - 1; j < come[i][2]; j++) {
                        also |= (1LL << j);
                    }

                    ll go = mask | also;

                    dp[go] = true;
                }
            }

            cout << (dp[(1LL << n) - 1LL] ? "YES" : "NO") <<"\n";
            continue;
        }


        for (int i = 1; i <= k; i++) {
            for (int l = come[i][0]; l <= come[i][2]; l++) {
                for (auto haveTo : meet[l]) {
                    if (haveTo != i) {
                        g[haveTo].pb(i);
                    }
                }
                canGo[l]++;
            }
        }

        vll state(k + 1, 0);
        bool bad = false;

        for (int i = 1; i <= k; i++) {
            if (state[i] == 0) {
                dfs(g, state, i, bad);
            }
        }

        for (int i = 1; i <= n; i++) {
            if (canGo[i] == 0) bad = true;
        }

        cout << (bad ? "NO" : "YES") << "\n";
    }
    return 0;
}