#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<numeric>
#include<functional>
#include<cstdint>
#include<deque>
#include<chrono>
#include<ctime>

using namespace std;
using namespace chrono;

#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmax(a, b) a = max(a, b)
#define chmin(a, b) a = min(a, b)
#define pii pair<int, int>
#define tiii tuple<int, int, int>
#define tiiii tuple<int, int, int,int>


bool is(tiii t1, tiii t2) {
	auto [li, ri, mi] = t1;
	auto [lj, rj, mj] = t2;
	return li <= mj && mj <= ri && lj <= mi && mi <= rj;
}
void solve() {
	int n, k; cin >> n >> k;
	vector<tiii> qs(k);
	for (int i = 0; i < k; ++i) {
		int li, mi, ri; cin >> li >> mi >> ri; --li; --mi; --ri;
		qs[i] = { li, ri, mi };
	}
	auto start = high_resolution_clock::now();
	sort(all(qs));
	vector<int> dp(k + 1, -1);
	dp[0] = 0;
	vector<int> lb(n + 2);
	int tk = 0;
	for (int i = 0; i < n + 2; ++i) {
		while (tk < k && get<0>(qs[tk]) < i) ++tk;
		lb[i] = tk;
	}
	bool f = 0;
	for (int i = 0; i < k; ++i) {
		duration<double, milli> nd = high_resolution_clock::now() - start;
		if (nd.count() > 900) {
			f = 1;  break;
		}
		if (dp[i] == -1) continue;
		if (i == 0) {
			for (int j = 0; j < qs.size(); ++j) {
				auto [l, r, m] = qs[j];
				if (l != 0) break;
				dp[j + 1] = 1;
			}
		}
		else {
			auto [l, r, m] = qs[i - 1];
			int l1 = lb[dp[i]];
			int r1 = lb[r + 2] - 1;
			for (int j = l1; j <= r1; ++j) {
				auto [lj, rj, mj] = qs[j];
				if (rj <= r) continue;
				if (!is(qs[i - 1], qs[j])) {
					if (dp[j + 1] == -1) dp[j + 1] = r + 2;
					else chmax(dp[j + 1], r + 2);
				}
			}
		}
	}
	if (f) cout << "YES\n";
	for (int i = 1; i <= k; ++i) {
		auto [l, r, m] = qs[i - 1];
		if (dp[i] != -1 && r == n - 1) {
			cout << "YES\n"; return;
		}
	}
	
	cout << "NO\n";
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}