#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char> (m));
    for (auto &el : a) {
        for (auto &x : el) {
            cin >> x;
        }
    }

    vector<vector<ll>> ln(n, vector<ll> (m));
    for (ll i = 0; i < n; i++) {
        for (ll j = m - 1; j >= 0; j--) {
            if (a[i][j] == '0') continue;
            ln[i][j] = 1;
            if (j < m - 1) {
                ln[i][j] += ln[i][j + 1];
            }
        }
    }

    ll mx = 0;
    for (ll j = 0; j < m; j++) {
        ll s = 0;
        vector<pii> st;
        for (ll i = 0; i < n; i++) {
            ll cn = 1;
            while (!st.empty() && st.back().first > ln[i][j]) {
                cn += st.back().second;
                s -= (st.back().first * st.back().second);
                st.pop_back();
            }
            st.push_back({ln[i][j], cn});
            s += (st.back().first * st.back().second);
            mx = max(mx, s);
        }
    }
    cout << mx << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}