#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;


void solve() {
    ll n, k;
    cin >> n >> k;

    vector<tup> sg(k);
    for (auto &[l, m, r] : sg) {
        cin >> l >> m >> r;
        --l; --m; --r;
    }
    sort(sg.begin(), sg.end());

    vector<ll> can(k, -1);
    for (ll i = 0; i < k; i++) {
        if (get<0>(sg[i]) == 0) {
            can[i] = 1;
            continue;
        }

        for (ll j = 0; j < i; j++) {
            /*if (get<2>(sg[j]) >= get<2>(sg[i])) {
                continue;
            }
            if (get<1>(sg[i]) <= get<2>(sg[j]) && get<2>(sg[j]) >= get<0>(sg[i])) {
                continue;
            }*/
            if (get<2>(sg[j]) >= get<0>(sg[i])) {
                continue;
            }
            if (can[j] == -1 || get<2>(sg[j]) < get<0>(sg[i]) - 1) {
                continue;
            }
            can[i] = 1;
        }
    }

    for (ll i = 0; i < k; i++) {
        if (get<2>(sg[i]) == n - 1 && can[i] == 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}


int main() {
    bool IS_MULTITEST = 1;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}