#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define szof(x) ((ll) x.size())

ostream &operator<<(ostream &out, __int128 a) {
    if (a == 0) {
        return out << 0;
    }
    string s;
    while (a > 0) {
        s += a % 10 + '0';
        a /= 10;
    }
    reverse(s.begin(), s.end());
    return out << s;
}

istream &operator>>(istream &in, __int128 &a) {
    ll b;
    in >> b;
    a = b;
    return in;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    ll ans = 0, x0, d;
    cin >> x0 >> d;

    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        ll t; cin >> t;
        ll k = abs(x[0] - x0);

        ll ans = k * k, nx = k + (d - k % d) % d;
        ans = nx / d * t + (nx - k) * (nx - k);

        auto get = [&](ll c) {
            return c * t + (k - c * t) * (k - c * t);
        };

        int l = 0, r = k / d;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            if (get(mid) > get(mid + 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans = min(ans, get(r));
        cout << ans << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}