#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define szof(x) ((ll) x.size())

const int MAXN = 3e5 + 1;
vector<int> g[MAXN];
ll dp[MAXN][2], id[MAXN];

void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v][0] += max(dp[u][1], dp[u][0]);
        }
    }
    dp[v][1] = 0;
    for (auto u : g[v]) {
        if (u != p) {
            if (dp[v][1] < dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1) {
                dp[v][1] = dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1;
                id[v] = u;
            }
        }
    }
}

void print(int v, int p, int t) {
    if (t == 1) {
        cout << v << ' ' << id[v] << '\n';
        for (auto u : g[v]) {
            if (u != p) {
                if (u == id[v]) {
                    print(u, v, 0);
                } else {
                    print(u, v, dp[u][1] > dp[u][0]);
                }
            }
        }
    } else {
        for (auto u : g[v]) {
            if (u != p) {
                print(u, v, dp[u][1] > dp[u][0]);
            }
        }
    }
}

void solve() {
    ll n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cout << n / 2 << '\n' << -1;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}