#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define szof(x) ((ll) x.size())

const int MAXN = 3e5 + 1;
vector<int> g[MAXN];
ll dp[MAXN][2][2], id[MAXN];

void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v][1][0] += dp[u][0][0];
            dp[v][1][1] += dp[u][1][0];
        }
    }
    dp[v][0][0] = 0;
    dp[v][0][1] = 0;
    for (auto u : g[v]) {
        if (u != p) {
            dp[v][0][0] = max(dp[v][0][0], dp[u][1][0] + 2);
            dp[v][0][1] = max(dp[v][0][1], dp[u][1][1] + 2);
        }
    }
}

void solve() {
    ll n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 1);
    cout << *max_element(dp[1][0], dp[1][0] + 4) << '\n';
    // cout << n / 2 << '\n' << -1;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}