#include<bits/stdc++.h>
using namespace std;

int get_dist(const vector<vector<bool>> &m, const vector<vector<int>> &dist, int y, int x) {
    if (dist[y][x] != -1) {
        return dist[y][x];
    }
    if (y == 0 && m[y][x] == 1) {
        return 0;
    }
    if (m[y][x] == 0) {
        return -1;
    }
    return get_dist(m, dist, y-1, x) + 1;

}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("main.in", "r", stdin);
    freopen("main.out", "w", stdout);
#endif

    int h, w;
    cin >> h >> w;
    vector<vector<bool>> m(h, vector<bool>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char c;
            cin >> c;
            int t = c - '0';
            m[i][j] = t;
        }
    }
    vector<vector<int>> dist(h, vector<int>(w, -1));
    for (int y = 0; y < h; ++y) {
        for (int x = 0; x < w; ++x) {
            if (m[y][x] == 1) {

            dist[y][x] = get_dist(m, dist, y, x);
            }
        }
    }
    int max_res = 0;
    for (int y = 0; y < h; ++y) {
        for (int x = 0; x < w; ++x) {
            int mx = dist[y][x];
            int sm = mx + 1;
            for (int xi = x+1; xi < w && m[y][xi]; ++xi) {
                mx = min(mx, dist[y][xi]);
                sm += mx + 1;
            }
            max_res = max(max_res, sm);
        }
    }
    cout << max_res;

}

