#include <bits/stdc++.h>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; i++)
#define rfor0(i, n) for (ll i = n - 1; i >= 0; i--)
#define pb push_back
#define ub upper_bound
#define be(x) x.begin()
#define en(x) x.end()
#define all(x) be(x), en(x)
#define sz(x) x.size()
#define con continue
#define ba(x) x.back()
#define pob pop_back
#define ret return
#define endl '\n'
#define rep(i, a, n) for (ll i = a; i < n; i++)
#define co count
#define lb lower_bound
#define ins insert


#ifdef LOCAL
bool local = 1;
#else
bool local = 0;
#endif

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef long double ld;
typedef set<ll> sll;

void solve();

ld getTime() {
    ret clock() / CLOCKS_PER_SEC;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    if (local) {
        freopen("input.txt", "r", stdin);
    }

    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    if (local) {
        cout << endl << getTime();
    }
}

const ll N = 5e5 + 5;

ll n, k, l[N], m[N], r[N], p[N], used[N];
vll g[N], ts;

bool check(vll d) {
    sll s;
    for0(i, n) s.ins(i);
    for (auto x: d) {
        if (s.find(m[x]) == en(s))
            ret 0;
        auto it = s.lb(l[x]);
        while (it != en(s) && *it < r[x]) {
            s.erase(it);
            it = s.lb(l[x]);
        }
    }
    ret 1;
}

bool checkans(vll d) {
    sll s;
    for0(i, n) s.ins(i);
    for (auto x: d) {
        if (s.find(m[x]) == en(s))
            con;
        auto it = s.lb(l[x]);
        while (it != en(s) && *it < r[x]) {
            s.erase(it);
            it = s.lb(l[x]);
        }
    }
    ret sz(s) == 0;
}

void top(ll v) {
    used[v] = 1;
    for (auto x: g[v]) if (!used[x]) top(x);
    ts.pb(v);
}

void solve() {
    cin >> n >> k;
    for0(i, k) cin >> l[i] >> m[i] >> r[i], l[i]--, m[i]--;
    iota(p, p + n, 0);
    do {
        vll d;
        for0(_, n) {
            d.pb(p[_]);
        }
        if (checkans(d)) {
            cout << "YES" << endl;
            ret;
        }
    } while (next_permutation(p, p + n));
    cout << "NO" << endl;
}
