#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

int main()
{
	cin.tie(0);
	int h, w; cin >> h >> w;
	char a;
	vector<vector<bool>> ci(h, vector<bool>(w, false));
	for (int i = 0; i < h; i++) {
		for (int r = 0; r < w; r++) {
			cin >> a;
			ci[i][r] = (a == '1');
		}
	}
	int res = -1;
	vector<int> cnt(w, 0);
	for (int i = 0; i < h; i++) {
		stack<pair<int, int>> prew;
		vector<int> ans(w, 0);
		for (int r = w - 1; r >= 0; r--) {
			if (ci[i][r]) {
				cnt[r]++;
			}
			else {
				cnt[r] = 0;
			}
			while (prew.size() > 0 && prew.top().first >= cnt[r]) {
				prew.pop();
			}
			if (prew.size() != 0) {
				ans[r] = (prew.top().second - r) * cnt[r] + ans[prew.top().second];
			}
			else {
				ans[r] = cnt[r] * (w - r);
			}
			prew.push({ cnt[r], r });
			res = max(res, ans[r]);
		}
	}
	cout << res;
}

