#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <unordered_map>
#include<set>
#pragma GCC optimize("O3")

using namespace std;

vector < vector<int>> g;
vector<pair<int, int>> ans;
int n, d;

vector<vector<int>> dfs(int u, int parent) {
	vector<vector<int>> v(d + 1);
	for (auto i : g[u]) {
		if (i != parent) {
			auto vec = dfs(i, u);
			for (int it = 0; it < d; it++) {
				for (auto r : vec[it]) {
					v[it + 1].push_back(r);
				}
			}
		}
	}
	v[0].push_back(u);
	for (int i = d; i > d / 2; i--) {
		for (int r = int(min(v[i].size(), v[d - i].size())) - 1; r >= 0; r--) {
			ans.push_back({ v[i].back(), v[d - i].back() });
			v[i].pop_back();
			v[d - i].pop_back();
		}
	}
	return v;
}

vector<int> h;

void dfs2(int u, int parent) {
	h[u] = h[parent] + 1;
	for (auto i : g[u]) {
		if (i != parent) {
			dfs2(i, u);
		}
	}
}

int main() {//52
	cin >> n >> d;
	if (d % 2 == 0) {
		d--;
	}
	g.resize(n);
	int u, w;
	for (int i = 1; i < n; i++) {
		cin >> u >> w;
		u--;
		w--;
		g[u].push_back(w);
		g[w].push_back(u);
	}
	vector<vector<int> > v(d + 1);
	if (d != n - 1) {
		v = dfs(0, 0);
	}
	else {
		h.assign(n, -1);
		dfs2(0, 0);
		for (int i = 0; i < n; i++) {
			v[h[i]].push_back(i);
		}
	}
	vector<pair<int, int>> ch, nech;
	for (int i = 0; i <= d; i++) {
		for (auto r : v[i]) {
			if (i % 2 == 0) {
				ch.push_back({ i, r });
			}
			else {
				nech.push_back({ i, r });
			}
		}
	}
	sort(ch.begin(), ch.end());
	sort(nech.rbegin(), nech.rend());
	int l = 0;
	for (auto i : nech) {
		if (l < ch.size()) {
			if (ch[l].first + i.first <= d) {
				ans.push_back({ ch[l].second, i.second });
				l++;
			}
		}
		else {
			break;
		}
	}
	cout << ans.size();
	for (auto i : ans) {
		cout << '\n' << i.first + 1 << ' ' << i.second + 1;
	}
}

