#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

const int maxn = 3e5;
vector<int> g[maxn];
bool pr[maxn];
vector<pair<int, int>> vc;

void dfs(int v, int p = -1) {
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v);
			if (!pr[v] && !pr[u]) {
				pr[v] = 1;
				pr[u] = 1;
				vc.push_back({ u + 1, v + 1 });
			}
		}
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, d;
	cin >> n >> d;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	cout << vc.size() << '\n';
	for (auto i : vc) {
		cout << i.first << ' ' << i.second << '\n';
	}

	return 0;
}
