#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int n, D;
vector<vector<int>> g;
vector<vector<int>> t;
vector<int> h;
vector<int> v0, v1;

void h_dfs(int v, int p)
{
    if (h[v] % 2 == 0)
    {
        v0.push_back(v);
    }
    else
    {
        v1.push_back(v);
    }
    for (const auto &u : g[v])
    {
        if (u == p)
            continue;
        h[u] = h[v] + 1;
        h_dfs(u, v);
    }
}

void solve()
{
    cin >> n;
    g.resize(n);
    t.resize(n);
    h.resize(n);

    cin >> D;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    h[0] = 0;
    h_dfs(0, -1);

    cout << min(v0.size(), v1.size()) << '\n';

    for (int i = 0; i < v0.size() && i < v1.size(); ++i)
    {
        cout << v0[i] + 1 << " " << v1[i] + 1 << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}