#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int n, D;
vector<vector<int>> g;
vector<vector<int>> t;
vector<int> h;
vector<bool> used;
set<pii> se;
vector<int> par;

void h_dfs(int v, int p)
{
    se.insert({-1 * h[v], v});
    par[v] = p;
    for (const auto &u : g[v])
    {
        if (u == p)
            continue;
        h[u] = h[v] + 1;
        h_dfs(u, v);
    }
}

void solve()
{
    cin >> n;
    g.resize(n);
    t.resize(n);
    h.resize(n);
    used.resize(n, false);
    par.resize(n, -1);

    cin >> D;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    h[0] = 0;
    h_dfs(0, -1);

    vector<pii> ans;

    while (se.size() > 0)
    {
        const auto [_, v] = *se.begin();
        se.erase(se.begin());
        int p = par[v];
        if (p == -1 || used[v] || used[p])
            continue;
        used[v] = true;
        used[p] = true;
        ans.push_back({v, p});
    }
    cout << ans.size() << '\n';
    for (const auto &el : ans)
    {
        cout << el.first + 1 << " " << el.second + 1 << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}