#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<int>> g(h, vector<int>(w));
    vector<vector<int>> up(h + 1, vector<int>(w + 1, 0));
    vector<vector<int>> left(h + 1, vector<int>(w + 1, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char a;
            cin >> a;
            g[i][j] = a - '0';
            if (g[i][j] == 0)
                continue;
            up[i + 1][j + 1] = up[i][j + 1] + 1;
            left[i + 1][j + 1] = left[i + 1][j] + 1;
        }
    }
    vector<vector<int>> dp(h + 1, vector<int>(w + 1, 0));
    vector<vector<int>> dp_up(h + 1, vector<int>(w + 1, 0));
    vector<vector<int>> dp_left(h + 1, vector<int>(w + 1, 0));
    int ans = 0;
    for (int i = 1; i <= h; i++) {
        for (int j = 1; j <= w; j++) {
            if (g[i - 1][j - 1] == 0)
                continue;
            if (i <= 1 || g[i - 2][j - 1] == 0) {
                if (j <= 1 || g[i - 1][j - 2] == 0) {
                    dp[i][j] = 1;
                    dp_up[i][j] = 1;
                    dp_left[i][j] = 1;
                } else {
                    dp[i][j] = dp[i][j - 1] + 1;
                    dp_up[i][j] = 1;
                    dp_left[i][j] = dp_left[i][j - 1] + 1;
                }
            } else if (j <= 1 || g[i - 1][j - 2] == 0) {
                dp[i][j] = up[i][j];
                dp_up[i][j] = up[i][j];
                dp_left[i][j] = 1;
            } else if (dp[i][j - 1] + min(up[i][j], dp_up[i][j - 1]) > dp[i - 1][j] + dp_left[i - 1][j] || dp_left[i - 1][j] > left[i][j]) {
                dp[i][j] = dp[i][j - 1] + min(up[i][j], dp_up[i][j - 1]);
                dp_up[i][j] = min(up[i][j], dp_up[i][j - 1]);
                dp_left[i][j] = dp_left[i][j - 1] + 1;
            } else {
                dp[i][j] = dp[i - 1][j] + dp_left[i - 1][j];
                dp_up[i][j] = dp_up[i - 1][j] + 1;
                dp_left[i][j] = dp_left[i - 1][j];
            }
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
    return 0;
}
