#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#pragma optimize("unroll-loops")

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<bool>> ls(n, vector<bool>(m));
    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (ll j = 0; j < m; j++) {
            ls[i][j] = (s[j] == '1');
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, 0));
    for (ll i = 0; i < n; i++) {
        if (ls[i][m - 1]) {
            dp[i][m - 1] = 1;
        }
        for (ll j = m - 2; j > -1; j--) {
            if (ls[i][j]) {
                dp[i][j] = dp[i][j + 1] + 1;
            }
        }
    }
    ll ansq = 0;
    for (ll i = m - 1; i > -1; i--) {
        ll j = n - 1;
        while (j >= 0 && !ls[j][i]) {
            j--;
        }
        while (j >= 0 && ls[j][i]) {
            ll y = j;
            while (y >= 0 && ls[y][i]) {
                y--;
            }
            y++;
            ll last_ans = 0;
            ll last = 0;
            for (ll e = j; e >= y; e--) {
                if (e == j) {
                    last = dp[j][i];
                    last_ans = last;
                    continue;
                }
                if (last >= dp[e][i]) {
                    last = dp[e][i];
                    last_ans += dp[e][i];
                    continue;
                }
                if (last_ans + last >= dp[e][i]) {
                    last_ans += last;
                } else {
                    last = dp[e][i];
                    last_ans = dp[e][i];
                }
            }
            ansq = max(ansq, last_ans);
            j = y - 1;
            while (j >= 0 && !ls[j][i]) {
                j--;
            }
        }
    }
    cout << ansq;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}