#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

vector<vector<ll>> g;
vector<pair<ll, ll>> ans;

bool dfs(ll u, ll p) {
    bool f = true;
    for (auto v : g[u]) {
        if  (v != p) {
            bool fl = dfs(v, u);
            if (fl && f) {
                ans.push_back({u, v});
                f = false;
            }
        }
    }
    return f;
}

void solve() {
    ll n, d;
    cin >> n >> d;
    g.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    dfs(0, -1);
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i + 1 << " " << j + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}