#include <bits/stdc++.h>
using namespace std;
const int MAXN = int(3e5) + 1;
vector<int> g[MAXN];
vector<int> col(MAXN);
void dfs(int u, int p, int cur) {
    col[u] = cur;
    for (auto to : g[u]) {
        if (to != p) {
            dfs(to, u,(cur + 1) % 2);
        }
    }
}
int dp[MAXN][2];
void dfs2(int u, int p) {
    dp[u][0] = 0;
    dp[u][1] = 0;
    int gg = -int(1e9);
    for (auto to : g[u]) {
        if (to != p) {
            dfs2(to, u);
            dp[u][0] += max(dp[to][0], dp[to][1]);
            gg = max(gg, dp[to][0] - max(dp[to][0], dp[to][1]));
        }
    }
    dp[u][1] = max(dp[u][0], dp[u][0] + gg + 1);
}
void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, -1, 0);
    dfs2(1, -1);
    cout << max(dp[1][0], dp[1][1]) << '\n';
    cout << -1;
}
int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}