#include <bits/stdc++.h>
#include <cmath>

using namespace std;

mt19937 rnd(time(0));

#define int long long
#define endl '\n'

const int maxm = 6e5 + 5, maxn = 3e5 + 5, inf = 1e9 + 5;
int ans[maxm], pref[maxn];

void solve() {
    int n;
    cin >> n;
    vector <int> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    int x0, d;
    cin >> x0 >> d;
    int X = x0;
    int m;
    cin >> m;
    vector <pair <int, int>> t(m);
    for (int i = 0; i < m; i++) {
        cin >> t[i].first;
        t[i].second = i;
    }
    sort(x.begin(), x.end());
    if (x0 > x[0]) {
        swap(x0, x[0]);
    }

    for (int i = 0; i < m; i++) {
        int l = -1, r = inf;
        while (r - l > 1) {
            int md = (l + r) / 2;
            int xx = md * d + x0;
            int dlt = (xx + d - x[0]) * (xx + d - x[0]) + t[i].first - (xx - x[0]) * (xx - x[0]);
            if (dlt > 0) r = md;
            else l = md;
        }
        int ans = inf * inf;
        for (int x1 = min(x0, x0 + (l - 100) * d); x1 <= x0 + (l + 100) * d; x1 += d) {
            int dd = (x1 - x[0]) * (x1 - x[0]) + ((x1 - x0) / d) * t[i].first;
            ans = min(ans, dd);
        }
        cout << ans << endl;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}