#include<bits/stdc++.h>
using namespace std;

struct st {
    int l, m, r;
    st(int x, int y, int z) {
        l = z;
        m = y;
        r = z;
    }
    st() = default;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<st> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }
    vector<int> tmp(n + 1);
    for (int i = 0; i < k; i++) {
        tmp[a[i].m]++;
    }
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + tmp[i];
    }
    sort(a.begin(), a.end(), [&](st a, st b) {
       int sum1 = pref[a.r] - pref[a.l - 1];
        int sum2 = pref[b.r] - pref[b.l - 1];
        return sum1 < sum2;
    });
    vector<int> vec(n + 1);
    vector<bool> used(k + 1, false);
    while (true) {
        int ind = -1;
        for (int i = 0; i < k; i++) {
            if (!used[i] && vec[a[i].m] == 0) {
                ind = i;
                break;
            }
        }
        if (ind == -1) break;
        used[ind] = true;
        for (int i = a[ind].l; i <= a[ind].r; i++) {
            vec[i] = 1;
        }
    }
    bool t = true;
    for (int i = 1; i <= n; i++) {
        if (vec[i] == 0) t = false;
    }
    if (t) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}