#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long

struct st {
    int l, m, r;
    st(int a, int b, int c) {
        l = a;
        m = b;
        r = c;
    }
    st() = default;
};

bool f(vector<st>& a, int l, int r) {
    if (a.empty()) {
        return false;
    }
    if (a.size() == 1) {
        if (a[0].l <= l && a[0].r >= r) {
            return true;
        }
        return false;
    }
    int n = a.size();
    bool tt = false;
    for (int i = 0; i < n; i++) {
        if (a[i].l <= l && a[i].r >= r) return true;
        vector<st> vec1, vec2;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (a[j].r < a[i].m) {
                vec1.push_back(a[j]);
            }
            if (a[j].l > a[i].m) {
                vec2.push_back(a[j]);
            }
        }
        bool t = false, t1 = false;
        if (a[i].l > l) {
            t = f(vec1, l, a[i].l - 1);
        }
        else {
            t = true;
        }
        if (a[i].r < r) {
            t1 = f(vec2, a[i].r + 1, r);
        }
        else {
            t1 = true;
        }
        if (t && t1) {
            tt = true;
            break;
        }
    }
    return tt;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<st> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        if (a[i].l == 1 && a[i].r == n) {
            cout << "YES\n";
            return;
        }
    }
    sort(a.begin(), a.end(), [&](st a, st b) {
        if (a.l == b.l) {
            return a.r > b.r;
        }
        return a.l < b.l;
    });
    gp_hash_table<int, bool> mp;
    vector<bool> used(n + 1);
    for (int i = 0; i < k; i++) {
        if (!mp[a[i].l]) {
            for (int j = a[i].l; j <= a[i].r; j++) {
                used[j] = true;
            }
            mp[a[i].l] = true;
        }
    }
    bool t = true;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) t = false;
    }
    if (t) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}