#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;

const int INF = 1e9;

// struct El
// {
//     int l, m, r;
// };

int x0, d;

ll bs_left(int x)
{
    int l = -INF, r = INF;
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        __int128 now = 1ll * m * d + x0;
        if (now > x)
            r = m;
        else
            l = m;
    }
    return 1ll * l * d + x0;
}

ll bs_right(int x)
{
    int l = -INF, r = INF;
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        __int128 now = 1ll * m * d + x0;
        if (now < x)
            l = r;
        else
            r = m;
    }
    return 1ll * r * d + x0;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // int t;
    // cin >> t;
    // while (t--)
    // {
    //     int n, k;
    //     cin >> n >> k;
    //     vector<El> a(n);
    //     for (El &i : a)
    //         cin >> i.l >> i.m >> i.r;
    //     int f = 1;
    //     for (int i = 0; i < n; i++)
    //         for (int j = 0; j < i; j++)
    //             if (a[i].l <= a[j].m && a[j].m <= a[i].r && a[j].l <= a[i].m && a[i].m <= a[j].r)
    //                 f = 0;
    //     if (f)
    //         cout << "YES\n";
    //     else
    //         cout << "NO\n";
    // }
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i : x)
        cin >> i;
    cin >> x0 >> d;
    int m, t;
    cin >> m >> t;
    ll ans = 0;
    for (int i : x)
    {
        ll left = bs_left(i), right = bs_right(i);
        __int128 l = (i - left) * (i - left), r = (i - right) * (i - right);
        ans += min(l, r);
    }
    cout << ans;
}