#include <bits/stdc++.h>
#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m; cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int ans = 0;

    vector<vector<int>> cnt(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == '0') {
                cnt[i][j] = 0;
            } else {
                cnt[i][j] = 1;

                if (j < m - 1) {
                    cnt[i][j] += cnt[i][j + 1];
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '0') continue;

            int cur_ans = cnt[i][j];
            ans = max(ans, cur_ans);

            map<int, int> mp; mp[cur_ans]++;
            for (int k = i + 1; k < n; ++k) {
                if (a[k][j] == '0') break;

                auto it = mp.upper_bound(cnt[k][j]);
                int cur = 1;
                vector<int> dlt;
                while (it != mp.end()) {
                    cur_ans -= it->first * it->second;
                    cur += it->second;
                    dlt.push_back(it->first);
                    ++it;
                }

                for (auto el : dlt) {
                    mp.erase(el);
                }

                mp[cnt[k][j]] += cur;
                cur_ans += cur * cnt[k][j];

                ans = max(ans, cur_ans);
            }
        }
    }

    cout << ans;
}