#include <bits/stdc++.h>
#define int long long

using namespace std;

struct zxc {
    int l, m, r;
};

void solve() {
    int n, k; cin >> n >> k;

    vector<zxc> a(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> r >> m;
        a[i] = {l, r, m};
    }

    sort(a.begin(), a.end(), [](zxc a, zxc b) {
        if (a.r == b.r) return a.l < b.l;

        return a.r < b.r;
    });

    vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(k + 1, vector<bool>(n + 1, false)));
    queue<tuple<int, int, int>> q;
    dp[0][0][0] = true;

    q.push({0, 0, 0});
    while (!q.empty()) {
        auto [r, i, m] = q.front(); q.pop();

        if (i != k && !dp[r][i + 1][m]) {
            dp[r][i + 1][m] = true;
            q.push({r, i + 1, m});
        }

        if (r == n) {
            cout << "YES";
            return;
        }

        if (a[i].l > r + 1) continue;

        bool f1 = true, f2 = true;
        if (a[i].m <= r) f1 = false;
        if (a[i].l <= m && a[i].r >= m) f2 = false;

        if ((f1 || f2) && !dp[a[i].r][i + 1][a[i].m]) {
            dp[a[i].r][i + 1][a[i].m] = true;
            q.push({a[i].r, i + 1, a[i].m});
        }
    }

    cout << "NO";
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt; cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
}