#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> v(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char ch;
			cin >> ch;
			v[i][j] = int(ch - '0');
		}
	}
	vector<vector<int>> len(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		len[i][m - 1] = v[i][m - 1];
	}
	for (int j = m - 2; j >= 0; j--) {
		for (int i = 0; i < n; i++) {
			if (v[i][j] == 0) {
				len[i][j] = 0;
			}
			else {
				len[i][j] = len[i][j + 1] + 1;
			}
		}
	}
	int maxs = 0;
	for (int j = 0; j < m; j++) {
		vector<pair<int, int>> have = {}; //what, much;
		int sum = 0;
		for (int i = 0; i < n; i++) {
			if (have.size() == 0) {
				have.push_back({ len[i][j], 1 });
				sum += len[i][j];
			}
			else if (have.back().first == len[i][j]) {
				have.back().second++;
				sum += len[i][j];
			}
			else if (have.back().first < len[i][j]) {
				have.push_back({ len[i][j], 1 });
				sum += len[i][j];
			}
			else {
				long long much = 0;
				while (have.size() > 0 && have.back().first >= len[i][j]) {
					much += have.back().second;
					sum -= have.back().first * have.back().second;
					have.pop_back();
				}
				sum += (much + 1) * len[i][j];
				have.push_back({ len[i][j], much + 1 });
			}
			maxs = max(maxs, sum);
		}
	}
	cout << maxs;
}