#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int gh = 0; gh < t; gh++) {
		int n, k;
		cin >> n >> k;
		vector<tuple<int, int, int>> v(k);
		for (int i = 0; i < k; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			v[i] = { l, r, m };
		}
		sort(v.begin(), v.end());
		vector<bool> dp(v.size(), false);
		for (int gh = 0; gh < v.size(); gh++) {
			auto [l11, r11, m11] = v[gh];
			if (l11 == 1) {
				dp[gh] = true;
			}
		}
		for (int gh = 1; gh < v.size(); gh++) {
			auto [l1, r1, m1] = v[gh];
			for (int fg = 0; fg < gh; fg++) {
				auto [l2, r2, m2] = v[fg];
				if (r2 < m1 || (r2 >= m1 && m2 < l1)) {
					if (dp[fg] && r2 >= l1 - 1 && r2 < r1) {
						dp[gh] = true;
					}
				}
			}
		}
		bool ans = false;
		for (int gh = 0; gh < v.size(); gh++) {
			auto [l1, r1, m1] = v[gh];
			if (r1 == n && dp[gh]) {
				ans = true;
			}
		}
		if (ans) {
			cout << "YES" << '\n';
		}
		else {
			cout << "NO" << '\n';
		}
	}
}