#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

long long d, x0;
long long y;

__int128 znach(__int128 k, long long t) {
	return (k * (__int128)d + (__int128)x0 - (__int128)y) * (k * (__int128)d + (__int128)x0 - (__int128)y) + k * (__int128)t;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<long long> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	cin >> x0 >> d;
	y = v[0];
	long long m;
	cin >> m;
	for (int gh = 0; gh < m; gh++) {
		long long t;
		cin >> t;
		__int128 l = -1e18, r = 1e18;
		while (l + 2 < r) {
			__int128 lm = l + (r - l) / 3;
			__int128 rm = r - (r - l) / 3;
			if (znach(lm, t) < znach(rm, t)) {
				r = rm;
			}
			else {
				l = lm;
			}
		}
		long long ans1 = znach(l, t);
		long long ans2 = znach(l + 1, t);
		long long ans3 = znach(r, t);
		cout << min(ans1, min(ans2, ans3)) << '\n';
	}
}