#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

vector<vector<int>> g;
vector<int> c;
int col = 0;

void color(int v) {
	c[v] = col;
	for (auto u : g[v]) {
		if (c[u] == -1) {
			col = 1 - col;
			color(u);
			col = 1 - col;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int gh = 0; gh < n - 1; gh++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	if (d >= n - 1) {
		c.resize(n, -1);
		color(0);
		int much0 = 0, much1 = 0;
		vector<int> v0, v1;
		for (int i = 0; i < c.size(); i++) {
			int cc = c[i];
			int cc = c[i];
			if (cc == 0) {
				much0++;
				v0.push_back(i + 1);
			}
			else {
				much1++;
				v1.push_back(i + 1);
			}
		}
		cout << min(much0, much1) << '\n';
		for (int i = 0; i < min(much0, much1); i++) {
			cout << v0[i] << " " << v1[i] << '\n';
		}
	}
}