#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

vector<vector<int>> g;
vector<vector<int>> dp;
vector<int> sumkids;

void dfs(int v, int p) {
	for (auto u : g[v]) {
		if (u == p) {
			continue;
		}
		dfs(u, v);
		sumkids[v] += max(dp[u][0], dp[u][1]);
	}
	dp[v][1] = sumkids[v];
	for (auto u : g[v]) {
		if (u == p) {
			continue;
		}
		int cc = sumkids[v] - max(dp[u][0], dp[u][1]);
		cc += dp[u][1] + 1;
		dp[v][0] = max(dp[v][0], cc);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int gh = 0; gh < n - 1; gh++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dp.resize(n, vector<int>(2));
	sumkids.resize(n);
	dfs(0, 0);
	cout << max(dp[0][0], dp[0][1]);
}