#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout<<#x<<" = "<<x<<endl;
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using ll = __int128_t;

const ll C = 1e9;

void solve() {
    long long n;
    cin >> n;
    vector<long long> a(n);
    for (auto& i : a) cin >> i;
    sort(all(a));
    
    long long s, d;
    cin >> s >> d;
    long long m;
    cin >> m;
    
    
    
    
    vector<ll> px(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        ll ps = a[i] / d * d;
        ll p1 = ps + d;
        px[i + 1] += px[i] + min((ps - a[i]) * (ps - a[i]), (p1 - a[i]) * (p1 - a[i]));  
        // debug((int)px[i + 1]);
    }
    
    vector<ll> sx(n + 1, 0);
    vector<ll> sxsq(n + 1, 0);
    sx[n - 1] = a[n - 1];
    sxsq[n - 1] = a[n - 1] * a[n - 1];
        
    for (ll i = n - 2; i >= 0; --i) {
        sx[i] = sx[i + 1] + a[i];
        sxsq[i] = sxsq[i + 1] + a[i] * a[i];
    }

    auto get = [&](ll i, ll t) {
        ll ind = upper_bound(all(a), i * d) - a.begin();
        return px[ind] + sxsq[ind] - 2 * sx[ind] * i * d + (n - ind) * (i * d) * (i * d) + t * i;
    };
    
    for (ll i = 0; i < m; ++i) {
        long long t;
        cin >> t;
        ll L = s;
        ll R = C;

        

        while (L + 1 < R) {
            ll mid = (L + R) / 2;
            // debug(long(mid))
            if (get(mid, t) < get(mid + 1, t)) {
                R = mid;
            } else {
                L = mid;
            }
        }

        // debug(long(L) << " " << long(R));

        // debug(int(get(20, 1)));

        cout << (long long)min(get(L, t), get(R, t)) << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    long long t = 1;
    $(cin >> t;)

    for (ll i = 0; i < t; ++i) {
        solve();
        $(cout << endl;)
    }
}