#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
int** arr;
bool* visited;
bool dfs(int k) {
	if (k == n-1) return true;
	if (visited[k]) return false;
	visited[k] = true;
	for (int i = 0; i < n; i++)
	{
		if (arr[k][i] == 1) {
			if (dfs(i)) return true;
		}
	}
	return false;
}
int main() {
	int t;
	cin >> t;
	int k, l, m, r;
	for (int i = 0; i < t; i++)
	{
		cin >> n >> k;
		n += 1;
		arr = new int* [n];
		visited = new bool[n];
		for (int j = 0; j < n; j++) {
			arr[j] = new int[n];
			visited[j] = false;
		}
		for (int j = 0; j < n; j++)
			for (int jj = 0; jj < n; jj++)
				arr[j][jj] = 0;
		for (int j = 0; j < k; j++)
		{
			cin >> l >> m >> r;
			l -= 1; m -= 1; r -= 1;
			arr[l][r + 1] = 1;
		}
		if (dfs(0)) cout << "YES";
		else cout << "NO";
		
	}
}