#include <bits/stdc++.h>

using namespace std;
typedef long long lint;
typedef vector<lint> vi;



void solve() {
    lint n, m; cin >> n >> m;
    vector<string> v(n);
    for (auto& i: v) {
        cin >> i;
    }
    vector<vi> up(n, vi(m));
    vector<vi> big(n, vi(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j] == '0')
                up[i][j] = 0;
            else if (i !=  0 && up[i-1][j])
                up[i][j] = up[i-1][j] + 1;
            else
                up[i][j] = 1;
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int l = 0, r = 0; r < m; l = r+1, r++) {
            if (!up[i][l])
                continue;
            while (r + 1 < m && up[i][r+1]) r++;
            map<lint, lint> sz;
            int la = 0;
            int resr = r;
            for (; r >= l; --r) {
                while (sz.size() && sz.rbegin()->first > up[i][r]) {
                    la -= sz.rbegin()->second * (sz.rbegin()->first - up[i][r]);
                    sz[up[i][r]] += sz.rbegin()->second;
                    sz.erase(sz.rbegin()->first);
                }
                la += up[i][r];
                sz[up[i][r]]++;
                ans = max(la, ans);
            }
            r = resr;
        }
    }
        cout << ans << "\n";
}

signed main() {
    solve();
    return 0;
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.