#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
struct seg {
    int x, t;
};
bool operator <(seg a, seg b) {
    if (a.x == b.x) return a.t > b.t;
    return a.x < b.x;
}
int l[1000002], r[1000002], m[1000002], p[1000002];
seg a[3000002];
bool cmp(int a, int b) {
    return r[a] > r[b];
}
bool cmp2(int a, int b) {
    return r[a] > r[b];
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector<int>L, R, PL;
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        r[i]--;
        if (l[i] == 0 && r[i] == n - 1) {
            cout << "YES\n";
            return;
        }
        if (l[i] == 0) {
            L.push_back(i);
        }
        if (r[i] == n - 1) {
            R.push_back(i);
        }
        p[i] = i;
    }
    sort(L.begin(), L.end(), cmp);
    PL.resize(L.size());
    for (int i = 0; i < (int)L.size(); ++i) {
        if (i == 0) {
            PL[i] = m[L[i]];
        }
        else {
            PL[i] = min(PL[i - 1], m[L[i]]);
        }
    }
    for (int i = 0; i < (int)R.size(); ++i) {
        int ll = -1, rr = L.size();
        while (rr - ll > 1) {
            int mid = (ll + rr) / 2;
            if (r[L[mid]] >= l[R[i]] - 1) {
                ll = mid;
            }
            else {
                rr = mid;
            }
        }
        int j = ll;
        //cout << l[R[i]] << ' ' << L[0] << ' ' << r[L[0]] << "!" << endl;
        //cout << i << ' ' << j << endl;
        if (j == -1) continue;
        if (PL[j] < l[R[i]] || m[R[i]] > r[L[j]]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}
vector<vector<int>>g;
int vis[10002];
bool ans = true;
void dfs(int u) {
    vis[u] = 1;
    for (auto v : g[u]) {
        if (vis[v] == 1) {
            ans = false;
        }
        if (vis[v] == 0) {
            dfs(v);
        }
    }
}
void solve2() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (l[i] <= m[j] && m[j] <= r[i]) {
                g[j].push_back(i);
            }
        }
    }
    ans = true;
    for (int i = 0; i < n; ++i) {
        if (!vis[i]) dfs(i);
    }
}
int main()
{
    #ifdef LOCAL
    freopen("input", "r", stdin);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
