#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define int long long

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    vector<vector<int>> dpotv(h, vector<int> (w, 0));
    vector<vector<int>> dpotg(h, vector<int> (w, 0));
    vector<vector<int>> dplg(h, vector<int> (w, 0)), dplv(h, vector<int> (w, 0));
    vector<vector<int>> dphg(h, vector<int> (w, 0)), dphv(h, vector<int> (w, 0));
    vector<vector<int>> dpg(h, vector<int> (w, 0)), dpv(h, vector<int> (w, 0));
    for (int i = 0; i < h; i++) {
        cin >> a[i];
    }
    for (int i = h - 1; i > -1; i--) {
        for (int j = w - 1; j > -1; j--) {
            if (a[i][j] == '1') {
                if (i == h - 1 && j == w - 1) {
                    dpotv[i][j] = 1;
                    dpotg[i][j] = 1;
                    dpv[i][j] = 1;
                    dpg[i][j] = 1;
                    dplg[i][j] = 1;
                    dplv[i][j] = 1;
                    dphg[i][j] = 1;
                    dphv[i][j] = 1;
                }
                else if (i == h - 1) {
                    if (a[i][j + 1] == '1') {
                        dpotg[i][j] = dpotg[i][j + 1] + 1;
                        dpotv[i][j] = 1;
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dplg[i][j] = dplg[i][j + 1] + 1;
                        dplv[i][j] = 1;
                        dpv[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = 1;
                    }
                    else {
                        dpotg[i][j] = 1;
                        dpotv[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dplg[i][j] = 1;
                        dplv[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = 1;
                    }
                } else if (j == w - 1) {
                    if (a[i + 1][j] == '1') {
                        dpotg[i][j] = 1;
                        dpotv[i][j] = dpotv[i + 1][j] + 1;
                        dpv[i][j] = dpv[i][j + 1] + 1;
                        dpg[i][j] = 1;
                        dplg[i][j] = 1;
                        dplv[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = dphv[i + 1][j] + 1;
                    }
                    else {
                        dpotg[i][j] = 1;
                        dpotv[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dplv[i][j] = 1;
                        dplg[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = 1;
                    }
                } else {
                    if (a[i + 1][j] == '0' && a[i][j + 1] == '0') {
                        dpotg[i][j] = 1;
                        dpotv[i][j] = 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = 1;
                        dplv[i][j] = 1;
                        dplg[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = 1;
                    } else if (a[i + 1][j] == '0') {
                        dpotv[i][j] = 1;
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dplv[i][j] = 1;
                        dplg[i][j] = dpg[i][j + 1] + 1;
                        dpv[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = 1;
                        dpotg[i][j] = dpg[i][j];
                    } else if (a[i][j + 1] == '0') {
                        dpotv[i][j] = dpotv[i + 1][j] + 1;
                        dpg[i][j] = 1;
                        dpv[i][j] = dpv[i + 1][j] + 1;
                        dplv[i][j] = 1;
                        dplg[i][j] = 1;
                        dphg[i][j] = 1;
                        dphv[i][j] = dphv[i + 1][j] + 1;
                    } else {
                        dpg[i][j] = dpg[i][j + 1] + 1;
                        dpv[i][j] = dpv[i + 1][j] + 1;
                        if (dpotv[i + 1][j] <= dpotg[i + 1][j]) {
                            dpotv[i][j] = dpotg[i + 1][j] + min(dplg[i + 1][j], dpg[i][j]);
                            dplv[i][j] = min(dplg[i + 1][j], dpg[i][j]);
                            dphv[i][j] = dphg[i + 1][j] + 1;
                        } else {
                            dpotv[i][j] = dpotv[i + 1][j] + min(dplv[i + 1][j], dpg[i][j]);
                            dplv[i][j] = min(dplv[i + 1][j], dpg[i][j]);
                            dphv[i][j] = dphv[i + 1][j] + 1;
                        }
                        if (dpotv[i][j + 1] <= dpotg[i][j + 1] && dpv[i][j] >= dphg[i][j + 1]) {
                            dpotg[i][j] = dpotg[i][j + 1] + dphg[i][j + 1];
                            dplg[i][j] = dplg[i][j + 1] + 1;
                            dphg[i][j] = dphg[i][j + 1];
                        } else if (dpv[i][j] >= dphv[i][j + 1]) {
                            dpotg[i][j] = dpotv[i][j + 1] + dphv[i][j + 1];
                            dplg[i][j] = dplv[i][j + 1] + 1;
                            dphg[i][j] = dphv[i][j + 1];
                        } else {
                            dpotg[i][j] = dpg[i][j];
                            dplg[i][j] = dpg[i][j];
                            dphg[i][j] = 1;
                        }
                    }
                }
            }
        }
    }
    int res = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            //cout << dpotv[i][j] << '|' << dpotg[i][j] << ' ';
            res = max(res, max(dpotv[i][j], dpotg[i][j]));
        }
        //cout << endl;
    }
    cout << res << endl;
}