#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;

int inf = 1e9;

template <typename T>
void Debug(vector <T> &a) {
    for (auto el : a) cout << el << " ";
    cout << "\n";
}

template <typename T>
void Debug(vector <vector <T>> &a) {
    for (auto &b : a) Debug(b);
    cout << "\n";
}

vector <vector <int>> g;

int sum = 0;
vector <pair <int, int>> ans;
vector <int> used;

void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
    }
    if (!used[v]) {
        for (auto u : g[v]) {
            if (!used[u] && u != p) {
                ans.push_back({v, u});
                used[u] = used[v] = 1;
                break;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    dfs(0, -1);
    cout << ans.size() << "\n";
    for (auto el : ans) cout << el.first + 1 << " " << el.second + 1 << "\n";
}