#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a1(n, vector<int> (m));
	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		for (int j = 0; j < m; j++)
			a1[i][j] = s[j] - '0';
	}
	vector<vector<int>> a;
	if (n > m)
	{
		swap(n, m);
		a.resize(n);
		for (int i = n - 1; i > -1; i--)
		{
			for (int j = m - 1; j > -1; j--)
			{
				a[n - 1 - i].push_back(a1[j][i]);
			}
		}
	}
	else
	{
		a = a1;
	}
	vector<vector<int>> b(n, vector<int>(m));
	vector<vector<int>> v(n, vector<int>(m));
	vector<vector<int>> pr(n, vector<int>(m));
	for (int j = 0; j < m; j++)
	{
		int c = 0;
		for (int i = n - 1; i > -1; i--)
		{
			if (a[i][j])
			{
				c += 1;
				b[i][j] = c;
			}
			else
			{
				c = 0;
				b[i][j] = 0;
			}
		}
		c = -1;
		for (int i = n - 1; i > -1; i--)
		{
			if (a[i][j] == 0)
				pr[i][j] = c;
			else
			{
				c = i;
				pr[i][j] = c;
			}
		}
		c = 0;
		for (int i = 0; i < n; i++)
		{
			if (a[i][j])
			{
				c += 1;
				v[i][j] = c;
			}
			else
			{
				c = 0;
				v[i][j] = 0;
			}
		}
	}
	
	int ans = 0;
	vector<vector<vector<int>>> dp(m, vector<vector<int>>(n, vector<int> (n, 0)));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= i; j++)
		{
			if (a[i][m - 1] && i - v[i][m - 1] + 1 <= j)
				dp[m - 1][i][j] = i - j + 1;
			ans = max(ans, dp[m - 1][i][j]);
		}
		
	}
	for (int k = m - 2; k > -1; k--)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j <= i; j++)
			{
				if (a[i][k] && i - v[i][k] + 1 <= j)
				{
					dp[k][i][j] = (i - j + 1);
					if (a[i][k + 1])
					{

						dp[k][i][j] += dp[k + 1][i][max(j, i - v[i][k + 1] + 1)];
					}
					ans = max(ans, dp[k][i][j]);
				}
				
			}
		}
	}
	cout << ans;
}
