#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> arr(k);
    for(int i = 0; i < k; i++) {
        int l, r, t;
        cin >> l >> t >> r;
        l--; r--; t--;
        arr[i] = {l, r, t};
    }
    for(int i = 0; i < k; i++) {
        auto [l1, r1, t1] = arr[i];
        if(l1 == 0 && r1 == n - 1) {
            cout << "YES\n";
            return;
        }
    }
    for(int i = 0; i < k; i++) {
        for(int j = 0; j < k; j++) {
            auto [l1, r1, t1] = arr[i];
            auto [l2, r2, t2] = arr[j];
            if(l1 != 0 || r2 != n - 1) continue;
            if(r1 < l2 - 1) continue;
            if(!(l1 <= t2 && t2 <= r1) || !(l2 <= t1 && t1 <= r2)) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
