// #define _GLIBCXX_DEBUG 1
 
#include <bits/stdc++.h>
 
using namespace std;
 
int n, k;
vector<vector<int>> g;
vector<int> topsort;
vector<bool> used;
 
void dfs(int v) {
    used[v] = true;
    for(auto t : g[v]) {
        if(used[t]) continue;
        dfs(t);
    }
    topsort.push_back(v);
}

vector<int> pr;

int get(int v) {
    if(pr[v] == v) return v;
    return (pr[v] = get(pr[v]));
}

void unite(int a, int v) {
    a = get(a);
    v = get(v);
    p[a] = v;
}
 
void solve() {
    cin >> n >> k;
    vector<array<int, 4>> arr(k);
    for(int i = 0; i < k; i++) {
        int l, r, t;
        cin >> l >> t >> r;
        l--; r--; t--;
        arr[i] = {l, r, t, i};
    }
    // sort(arr.begin(), arr.end(), [&](array<int, 4> a, array<int, 4> b) {
    //     return a[2] < b[2];
    // });
    topsort.clear();
    used.assign(k, false);
    g.clear();
    g.resize(k);
    pr.clear();
    pr.resize(n + 1);
    iota(pr.begin(), pr.end(), 0);
    set<pair<int, int>> tt;
    for(auto [l, r, t, ii] : arr) {
        tt.insert({t, ii});
    }
    for(auto [l, r, t, ii] : arr) {
        auto it1 = tt.lower_bound({l, INT32_MIN});
        int iters = 10;
        while(iters--) {
            if(it1 == tt.end()) break;
            if(it1->first > r) break;
            g[ii].push_back(it1->second);
            it1++;
        }
    }
    for(auto [l, r, t, ii] : arr) {
        auto it1 = tt.lower_bound({r, INT32_MAX});
        if(it1 == tt.begin()) continue;
        it1--;
        int iters = 10;
        while(iters--) {
            if(it1 == tt.begin()) break;
            if(it1->first < l) break;
            g[ii].push_back(it1->second);
            it1--;
        }
    }
    for(int i = 0; i < k; i++) {
        if(used[i]) continue;
        dfs(i);
    }
    vector<int> ca(n, 1);
    for(auto ii : topsort) {
        auto [l, r, t, iii] = arr[ii];
        if(get(t) != t) continue;
        int cur = l;
        while(cur < r) {
            cur = get(cur);
            if(cur >= r) break;
            unite(cur, cur + 1);
        }
    }
    if(*max_element(ca.begin(), ca.end()) == 0) {
        cout << "YES\n";
        return;
    }
    cout << "NO\n";
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
