#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
 
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> l(k), m(k), r(k);
	for (int i = 0; i < k; ++i) {
		cin >> l[i] >> m[i] >> r[i];
		--l[i]; --r[i]; --m[i];
	}
	vector<pair<int, int>> left;
	vector<pair<int, int>> right;
	for (int i = 0; i < k; ++i) {
		if (l[i] == 0 && r[i] == n - 1) {
			cout << "YES\n";
			return;
		}
		if (l[i] == 0) {
			left.emplace_back(r[i], m[i]);
		}
		if (r[i] == n - 1) {
			right.emplace_back(l[i], m[i]);
		}
	}
	// right[i] <= x + 1 and right[i] > m
	sort(left.begin(), left.end());
	sort(right.begin(), right.end());
	if (right.empty() || left.empty()) {
		cout << "NO\n";
		return;
	}
	for (auto &[x, t] : left) {
		if (right.front().first <= x + 1) {
			auto it = *(--upper_bound(right.begin(), right.end(), make_pair((int)x + 1, (int)1e9)));
			if (it.first > t) {
				cout << "YES\n";
				return;
			}
		}
	}
	for (auto &[x, t] : right) {
		if (left.back().first >= x - 1) {
			auto it = *lower_bound(left.begin(), left.end(), make_pair((int)x - 1, -1));
			if (it.first < t) {
				cout << "YES\n";
				return;
			}
		}
	}
	cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
 
    int tests;
    cin >> tests;
    while (tests--) {
    	solve();
    }
}
