#include <bits/stdc++.h>

using namespace std;

long long sq(long long x) {
    return x * x;
}

struct ray {
    int n, d;
    vector <int> v;
    __int128 s = 0;
    // vector <__int128> p, q;
    __int128 p[300001] = {};
    long long q[300001] = {};
    int z = 1000000000;

    ray(int n, int d, vector <int> &u): n(n), d(d) {
        for (int x : u) v.push_back(x);
        sort(v.begin(), v.end());
        for (int x : v) s += sq(x);
        // p.resize(1 + n); q.resize(1 + n);
        for (int i = 0; i < n; ++i) {
            q[i + 1] = v[i];
            p[i + 1] = sq(v[i]) - mins(i);
        }
        for (int i = 0; i < n; ++i) {
            q[i + 1] += q[i];
            p[i + 1] += p[i];
        }
        if (!v.empty()) z = (v.back() + d) / d;
    }

    long long mins(int k) {
        return min(sq(v[k] % d), sq(d - v[k] % d));
    }

    __int128 one(int k, int t) {
        int h = k * d;
        int i = upper_bound(v.begin(), v.end(), h) - v.begin() - 1;
        return (__int128) k * t - p[i + 1] - (__int128) 2 * (q[n] - q[i + 1]) * h + (__int128) (n - i - 1) * sq(h);
    }

    __int128 ans(int t) {
        if (s == 0) return 0;
        register int l = 0, r = z;

        while (r - l > 2) {
            register int a = (l + r) / 2, b = (l + r) / 2 + 1;
            if (one(a, t) >= one(b, t)) l = a;
            else r = b;
        }
        z = min(z, r + 2);
        return s + min(min(one(l, t), one(l + 1, t)), min(one(l + 2, t), (__int128) 0));
    }
};

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr);

    int n;
    cin >> n;

    vector <int> w(n), u, v;
    for (int i = 0; i < n; ++i) cin >> w[i];

    int s, d;
    cin >> s >> d;

    for (int x : w) {
        if (x >= s) v.push_back(x - s);
        else u.push_back(s - x);
    }
    ray x(u.size(), d, u), y(v.size(), d, v);

    int m;
    cin >> m;

    vector <pair <int, int>> g(m);
    for (int i = 0; i < m; ++i) {
        cin >> g[i].first;
        g[i].second = i;
    }
    sort(g.begin(), g.end());

    vector <pair <__int128, __int128>> p(m), q(m);
    int i = 0, j = 0;
    while (i < m && j < m) {
        if (g[i].first < g[j].first * 2) {
            p[i] = {x.ans(g[i].first), y.ans(g[i].first)}; ++i;
        } else {
            q[j] = {x.ans(g[j].first * 2), y.ans(g[j].first * 2)}; ++j;
        }
    }
    while (i < m) p[i] = {x.ans(g[i].first), y.ans(g[i].first)}, ++i;
    // return 0;
    while (j < m) q[j] = {x.ans(g[j].first * 2), y.ans(g[j].first * 2)}, ++j;

    vector <long long> t(m);
    for (int i = 0; i < m; ++i) {
        t[g[i].second] = min(p[i].first + q[i].second, p[i].second + q[i].first);
    }
    for (long long x : t) cout << x << '\n';

    return 0;
}
