#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
using ll = long long;
using lll = __int128;

lll cntx(ll x, ll x0, lll ml, ll d)
{
    lll k1 = (x - x0) / d;
    lll k2 = k1 + 1;
    k1 = min(k1, ml);
    k2 = min(k2, ml);
    return min((x - x0 - k1 * d) * (x - x0 - k1 * d), (x - x0 - k2 * d) * (x - x0 - k2 * d));
}
ll cntres(vector<lll> a, lll x0, lll d, lll T, int Q)
{
    int n = a.size();
    lll l = 0, r = 2e9 / d + d;
    while (r - l > 3)
    {
        lll ml = (2 * l + r) / 3, mr = (2 * r + l) / 3;
        lll resl = 0;
        lll resr = 0;
        for (auto x : a)
        {
            resl += cntx(x, x0, ml, d);
            resr += cntx(x, x0, mr, d);
        }
        resl += Q*ml * T;
        resr += Q*mr * T;
        if (resl < resr)
        {
            r = mr;
        }
        else
        {
            l = ml;
        }
    }
    lll ans = 1e18;
    for (lll ml = l; ml <= r; ml++)
    {
        lll resl = 0;
        for (auto x : a)
        {
            resl += cntx(x, x0, ml, d);
        }
        resl +=Q* ml * T;
        ans = min(ans, resl);
    }
    return ans;
}
void solve(int n, vector<ll> a, lll x0, lll d)
{
    ll T;
    cin >> T;
    vector<lll> p1;
    vector<lll> p2;
    for (auto x : a)
    {
        if (x > x0)
        {
            p1.push_back(x);
        }
        else
        {
            p2.push_back(2 * x0 - x);
        }
    }
    cout << min(cntres(p1, x0, d, T, 1) + cntres(p2, x0, d, T, 2), cntres(p1, x0, d, T, 2) + cntres(p2, x0, d, T, 1)) << endl;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIMISHA
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<ll> a(n);
    for (auto &x : a)
        cin >> x;
    ll x0, d;
    cin >> x0 >> d;
    int tt;
    cin >> tt;
    while (tt--)
    {
        solve(n, a, x0, d);
    }
    return 0;
}