#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
using ll = long long;

int maxn = 5e5;
vector<vector<int>> g(maxn);
vector<int> used(maxn, 0);

int ans = 0;
bool dist(int n, int s, int t, int D)
{
    vector<int> d(n, -1);
    queue<int> q;
    d[s] = 0;
    q.push(s);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (auto to : g[v])
        {
            if (d[to] != -1)
                continue;
            d[to] = d[v] + 1;
            q.push(to);
        }
    }
    return d[t] % 2 == 1 && d[t] <= D;
}
void qwe(int n, int mask, int D)
{
    for (int i = 0; i < n; i++)
    {
        if ((mask >> i) & 1)
            continue;
        for (int j = i + 1; j < n; j++)
        {
            if ((mask >> j) & 1)
                continue;
            if (dist(n, i, j, D))
                qwe(n, (mask | (1 << i) | (1 << j)), D);
        }
    }
    ans = max(ans, __popcount(mask) / 2);
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIMISHA
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++)
    {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    qwe(n, 0, d);
    cout << ans << endl;
    cout << -1 << endl;
    return 0;
}