#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
using ll = long long;

int maxn = 5e5;
vector<vector<int>> g(maxn);
vector<int> used(maxn, 0);
vector<int> match(maxn, -1);
int T = 1;
bool dfs(int v)
{
    if (used[v] == T)
        return false;
    for (auto to : g[v])
    {
        if (match[to] == -1)
        {
            match[to] = v;
            return true;
        }
    }
    for (auto to : g[v])
    {
        if (dfs(to))
        {
            match[to] = v;
            return true;
        }
    }
    return false;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIMISHA
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    vector<char> col(n, 0);
    for (int i = 0; i < n - 1; i++)
    {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if (col[u] == col[v])
        {
            col[u] = 1;
            col[v] = 2;
        }
        else if (col[u] != 0)
        {
            col[v] = 3 - col[u];
        }
        else
        {
            col[u] = 3 - col[v];
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (col[i] == 1 && dfs(i))
        {
            ans++;
        }
    }
    cout << ans << endl;
    return 0;
}