#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
using ll = long long;

int maxn = 5e5;
vector<vector<int>> g(maxn);
vector<int> used(maxn, 0);
vector<int> match(maxn, -1);
vector<int> col(maxn, 0);
void to_col(int v, int p, int c)
{
    col[v] = c;
    for (auto to : g[v])
    {
        if (to == p)
            continue;
        to_col(to, v, 3 - c);
    }
}
int T = 1;
bool dfs(int v)
{
    if (used[v] == T)
        return false;
    used[v] = T;
    for (auto to : g[v])
    {
        if (match[to] == -1)
        {
            match[to] = v;
            return true;
        }
    }
    for (auto to : g[v])
    {
        if (dfs(match[to]))
        {
            match[to] = v;
            return true;
        }
    }
    return false;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIMISHA
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++)
    {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    to_col(0, -1, 1);
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        // cout << col[i] << endl;
        if (col[i] == 2 && dfs(i))
        {
            ans++;
        }
        T++;
    }
    cout << ans << endl;
    for (int i = 0; i < n; i++)
    {
        // cout << col[i] << endl;
        if (col[i] == 1 && match[i] != -1)
        {
            cout << i + 1 << " " << match[i] + 1 << endl;
        }
    }
    return 0;
}