#include <bits/stdc++.h>

using namespace std;

int N = 2e5 + 1;
vector<int> tree(4 * N);
vector<int> tree1(4 * N);

void upd(int i, int x, int u, int l, int r) {
    if (l + 1 == r) {
        tree[u] = x;
        return;
    }
    int mid = (l + r) / 2;
    if (i < mid) {
        upd(i, x, 2 * u, l, mid);
    } else {
        upd(i, x, 2 * u + 1, mid, r);
    }
    tree[u] = tree[2 * u] + tree[2 * u + 1];
}

int get(int ql, int qr, int u, int l, int r) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[u];
    }
    int mid = (l + r) / 2;
    return get(ql, qr, 2 * u, l, mid) + get(ql, qr, 2 * u + 1, mid, r);
}

void upd1(int i, int x, int u, int l, int r) {
    if (l + 1 == r) {
        tree1[u] = x;
        return;
    }
    int mid = (l + r) / 2;
    if (i < mid) {
        upd1(i, x, 2 * u, l, mid);
    } else {
        upd1(i, x, 2 * u + 1, mid, r);
    }
    tree1[u] = tree1[2 * u] + tree1[2 * u + 1];
}

int get1(int ql, int qr, int u, int l, int r) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree1[u];
    }
    int mid = (l + r) / 2;
    return get1(ql, qr, 2 * u, l, mid) + get1(ql, qr, 2 * u + 1, mid, r);
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            a[i][j] = (s[j] - '0');
        }
    }
    vector<vector<int>> hp(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        vector<int> cur(m);
        int cr = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == 1) {
                cr++;
            } else {
                cr = 0;
            }
            hp[i][j] = cr;
        }
    }
    int ans = 0;
    for (int j = 0; j < m; j++) {
        vector<int> ps;
        int sm = 0;
        int tec = 1e9;
        tree.assign(N, 0);
        tree1.assign(N, 0);
        for (int i = 0; i < n; i++) {
            if (i == 0) {
                sm += hp[i][j];
                tec = hp[i][j];
                ans = max(ans, sm);
                upd(hp[i][j], hp[i][j], 1, 0, N);
                upd1(hp[i][j], 1, 1, 0, N);
                continue;
            }
            if (hp[i][j] < tec) {
                tec = hp[i][j];
            }
            int cl = get(tec + 1, m + 1, 1, 0, N);
            int cl1 = get1(tec + 1, m + 1, 1, 0, N);
            int sm1 = sm;
            sm1 -= cl;
            sm1 += cl1 * tec;
            sm1 += hp[i][j];
            ans = max(ans, sm1);
            upd(hp[i][j], hp[i][j], 1, 0, N);
            upd1(hp[i][j], 1, 1, 0, N);
            ps.push_back(hp[i][j]);
            sm += hp[i][j];
            tec = hp[i][j];
        }
    }
    cout << ans;
}

