#include <bits/stdc++.h>

using namespace std;

int N = 2e5 + 1;
vector<int> tree(4 * N);

void upd(int i, int x, int u, int l, int r) {
    if (l + 1 == r) {
        tree[u] += x;
        return;
    }
    int mid = (l + r) / 2;
    if (i < mid) {
        upd(i, x, 2 * u, l, mid);
    } else {
        upd(i, x, 2 * u + 1, mid, r);
    }
    tree[u] = tree[2 * u] + tree[2 * u + 1];
}

int get(int ql, int qr, int u, int l, int r) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[u];
    }
    int mid = (l + r) / 2;
    return get(ql, qr, 2 * u, l, mid) + get(ql, qr, 2 * u + 1, mid, r);
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<pair<pair<int, int>, int>> a;
        int mx = -1e9, mn = 1e9;
        for (int i = 0; i < k; i++) {
            int l, r, m;
            cin >> l >> m >> r;
            a.push_back({{l, r}, m});
            if (l == 1) {
                mx = max(mx, r);
            }
            if (r == n) {
                mn = min(mn, l);
            }
        }
        if (mn == 1 || mx == n) {
            cout << "YES\n";
            continue;
        }
        bool f = false;
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if (a[i].first.first == 1 && a[j].first.second == n) {
                    if (a[i].first.second >= a[j].first.first) {
                        if (a[i].second < a[j].first.first || a[i].second > a[j].first.second) {
                            f = true;
                            break;
                        }
                        if (a[j].second < a[i].first.first || a[j].second > a[i].first.second) {
                            f = true;
                            break;
                        }
                    }
                }
            }
        }
        if (f) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
}