#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream &operator >> (istream &in, pair<T, T1> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T, typename T1>
ostream &operator << (ostream &in, pair<T, T1> &a) {
    in << a.ff << a.ss;
    return in;
}

template<typename T>
istream &operator >> (istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator << (ostream &in, vector<T> &a) {
    for (auto i : a) in << a << " ";
    return in;
}

void solve() {
    int n; cin >> n;
    vector<int> s(n); cin >> s;
    int x0, d; cin >> x0 >> d;
    int m; cin >> m;
    vector<int> t(m); cin >> t;


    int ans = 0;
    for (int i = 0; i < n; i++) {
        int k = abs(s[i] - x0) / d;
        int t1 = k * d, t2 = (k + 1) * d;
        if (s[i] < k) t1 = k - t1, t2 = k - t2;
        else t1 += k, t2 += k;

        ans += min((s[i] - t1) * (s[i] - t1), (s[i] - t2) * (s[i] - t2));
    }

    cout << ans << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}