#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream &operator >> (istream &in, pair<T, T1> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T, typename T1>
ostream &operator << (ostream &in, pair<T, T1> &a) {
    in << a.ff << a.ss;
    return in;
}

template<typename T>
istream &operator >> (istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator << (ostream &in, vector<T> &a) {
    for (auto i : a) in << a << " ";
    return in;
}

const int maxn = 20;

int dst[maxn][maxn], dp[1 << maxn], pr[1 << maxn];
void solve() {
    int n, d; cin >> n >> d;

    for (int i = 0; i < n; i++) fill(dst[i], dst[i] + n, (ll)1e9);
    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b;
        a--; b--;

        dst[a][b] = dst[b][a] = 1;
    }


    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (i != j && i != k && j != k) dst[j][i] = dst[i][j] = min(dst[i][j], dst[i][k] + dst[k][j]);
                //cout << i << " " << j << " " << k << " " << dst[i][k] << " " << dst[]dst[0][5] << "\n";
            }
        }
    }

    dp[0] = 0;
    int mask = 0;
    for (int msk = 0; msk < (1 << n); msk++) {
        if (__builtin_popcount(msk) % 2 != 0) continue;

        for (int i = 0; i < n; i++) {
            if ((msk >> i) & 1) continue;

            for (int j = 0; j < n; j++) {
                if ((msk >> j) & 1) continue;
                if (i == j || dst[i][j] > d || dst[i][j] % 2 != 1) continue;

                if (dp[msk + (1 << i) + (1 << j)] < dp[msk] + 1) {
                    dp[msk + (1 << i) + (1 << j)] = dp[msk] + 1;
                    pr[msk + (1 << i) + (1 << j)] = msk;
                }
            }
        }
        if (dp[mask] < dp[msk]) mask = msk;
    }

    cout << dp[mask] << "\n-1";

    // int p = mask;
    // while (p != 0) {
    //     int xr = p ^ pr[p];
    //
    //     for (int i = 0; i < n; i++) {
    //         if ((xr >> i) & 1) cout << i + 1 << " ";
    //     }
    //     cout << "\n";
    //     p = pr[p];
    // }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}