#include <bits/stdc++.h>
#define int long long
using namespace std;


struct xyz {
    int x, y, z;
};

struct event {
    int x, t, ind;
};

bool cmp (const event &a, const event &b) {
    return a.x < b.x || a.x == b.x && a.t > b.t;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) {

        int n, k; cin >> n >> k;
        vector <xyz> vec(k);
        vector <event> events(2 * k);
        bool allLeft = true;
        for (int  i = 0; i < k; i++) {
            cin >> vec[i].x >> vec[i].y >> vec[i].z;
            if (vec[i].y != vec[i].x) {
                allLeft = false;
            }
            vec[i].x--;
            events[2 * i] = {vec[i].x, 1, i};
            events[2 * i + 1] = {vec[i].z, -1, i};
        }
        ranges::sort(events, cmp);
        int bal = 0;
        bool ans = events[0].x == 0;
        for (const auto x : events) {
            bal += x.t;
            if (bal == 0 && x.x != n) {
                ans = false;
            }
        }
        if (!allLeft) {
            bool toEnd = false;
            for (int i = 0; i < k; i++) {
                if (toEnd) break;
                for (int j = 0; j < k; j++) {
                    if (i == j) continue;
                    if (vec[i].x != 0) continue;
                    if (vec[j].z != n) continue;

                    if (vec[i].y < vec[j].x || vec[i].z < vec[j].y) {
                        toEnd = true;
                        break;
                    }

                }
            }
            if (toEnd) {
                cout << "YES" << '\n';
            }
            else {
                cout << "NO" << '\n';
            }
        }
        else {
            cout << (ans ? "YES" : "NO") << '\n';
        }
    }

}