#include <bits/stdc++.h>
using namespace std;
using ll = int;
ll n, m, i, j, cnt, s[800002], kol[800002], cl[800002], ans;

void build(ll v, ll l, ll r) {
    s[v] = 0;
    kol[v] = 0;
    cl[v] = 0;
    if (l == r) {
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

void pushcl(ll v) {
    if (cl[v]) {
        cl[v] = 0;
        s[v] = 0;
        kol[v] = 0;
        cl[2 * v] = 1;
        cl[2 * v + 1] = 1;
    }
}

void updcl(ll v, ll l, ll r, ll a, ll b) {
    if (cl[v]) {
        pushcl(v);
        return;
    }
    if (l == a && r == b) {
        cl[v] = 1;
        pushcl(v);
        return;
    }
    ll m = (l + r) / 2;
    if (b <= m) {
        updcl(2 * v, l, m, a, b);
    } else if (a > m) {
        updcl(2 * v + 1, m + 1, r, a, b);
    } else {
        updcl(2 * v, l, m, a, m);
        updcl(2 * v + 1, m + 1, r, m + 1, b);
    }
    pushcl(2 * v);
    pushcl(2 * v + 1);
    s[v] = s[2 * v] + s[2 * v + 1];
    kol[v] = kol[2 * v] + kol[2 * v + 1];
}

void upd(ll v, ll l, ll r, ll p, ll x) {
    pushcl(v);
    if (l == r) {
        s[v] += l * x;
        kol[v] += x;
        return;
    }
    ll m = (l + r) / 2;
    if (p <= m) {
        upd(2 * v, l, m, p, x);
    } else {
        upd(2 * v + 1, m + 1, r, p, x);
    }
    pushcl(2 * v);
    pushcl(2 * v + 1);
    s[v] = s[2 * v] + s[2 * v + 1];
    kol[v] = kol[2 * v] + kol[2 * v + 1];
}

pair<ll, ll> get(ll v, ll l, ll r, ll a, ll b) {
    if (cl[v]) {
        pushcl(v);
        return {s[v], kol[v]};
    }
    if (l == a && r == b) {
        return {s[v], kol[v]};
    }
    ll m = (l + r) / 2;
    if (b <= m) {
        return get(2 * v, l, m, a, b);
    } else if (a > m) {
        return get(2 * v + 1, m + 1, r, a, b);
    } else {
        auto ans1 = get(2 * v, l, m, a, m);
        auto ans2 = get(2 * v + 1, m + 1, r, m + 1, b);
        return {ans1.first + ans2.first, ans1.second + ans2.second};
    }
}

signed main() {
    cin >> n >> m;
    char c;
    ll a[n + 10][m + 10], u[n + 10][m + 10];
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= m; j++) {
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    for (j = 1; j <= m; j++) {
        cnt = 0;
        for (i = 1; i <= n; i++) {
            if (a[i][j]) {
                cnt++;
            } else {
                cnt = 0;
            }
            u[i][j] = cnt;
        }
    }
    for (i = 1; i <= n; i++) {
        updcl(1, 1, n + 1, 1, i + 1);
        for (j = m; j >= 1; j--) {
            auto res = get(1, 1, i + 1, u[i][j] + 1, i + 1);
            updcl(1, 1, i + 1, u[i][j] + 1, i + 1);
            if (a[i][j]) {
                upd(1, 1, i + 1, u[i][j], res.second + 1);
            }
            ans = max(ans, get(1, 1, i + 1, 1, i + 1).first);
        }
    }
    cout << ans;
    return 0;
}
