#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
using namespace std;

int main(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> w(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        for (int j = 0; j < m; j++){
            w[i][j] = s[j] - '0';
        }
    }

    vector<vector<int>> ones(n, vector<int>(m));

    for (int i = 0; i < n; i++){
        int cur = 0;
        for (int j = m - 1; j >= 0; j--){
            if (w[i][j] == 0){
                cur = 0;
            }
            else{
                cur++;
            }
            ones[i][j] = cur;
        }
    }

    vector<vector<int>> mn(n, vector<int>(m));
    for (int j = 0; j < m; j++){
        stack<int> st;
        for (int i = 0; i < n; i++){
            while (!st.empty() && ones[st.top()][j] >= ones[i][j]){
                st.pop();
            }

            if (st.empty()){
                mn[i][j] = -1;
            }
            else{
                mn[i][j] = st.top();
            }
            st.push(i);
        }
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));

    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            dp[i][j] = dp[mn[i - 1][j - 1] + 1][j] + ones[i - 1][j - 1] * (i - mn[i - 1][j - 1] - 1);
            // cout << dp[mn[i - 1][j - 1] + 1][j] << ' ' << ones[i - 1][j - 1] << ' ' << (i - mn[i - 1][j - 1] - 1) << endl;
        }
    }

    int ans = -1;
    for (int i = 0; i <= n; i++){
        for (int j = 0; j <= m; j++){
            ans = max(ans, dp[i][j]);
        }
    }

    cout << ans << endl;

    // for (auto k: dp){
    //     for (auto kk: k){
    //         cout << kk << ' ';
    //     }
    //     cout << endl;
    // }
}