#include "iostream"
#include "stack"
#include "vector"
#include "numeric"
#include "algorithm"
using namespace std;
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")
#define int __int128_t
#define all(arr) arr.begin(), arr.end()

vector<int> points;
inline int d(int x) { return x * x; };
inline int gt() {
    long long a; cin >> a; return a;
}
void solve() {
    int n = gt();
    points.resize(n);
    for (int i = 0; i < n; i++) {
        points[i] = gt();
    }
    int x0 = gt(), dist = gt();
    int ans = 0;
    for (int i = 0; i < n; i++) {
        points[i] = abs(x0 - points[i]);
        ans += min(d(points[i] - (points[i] / dist * dist)), d(((points[i] / dist + 1) * dist) - points[i]));
    }
    if (ans == 0) {
        cout << 0;
        return;
    }
    string s;
    while (ans) {
        s.push_back('0' + ans % 10);
        ans /= 10;
    }
    reverse(all(s));
    cout << s;
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}