#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

int main()
{
    //cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mtx(n, vector<int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char c;
            cin >> c;
            mtx[i][j] = c - '0';
        }
    }
    vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(m, vector<ll>(m + 1, 0)));
    ll ans = 0;
    for (int i = n - 1; i >= 0; --i)
    {
        for (int j = m - 1; j >= 0; --j)
        {
            for (int k = 1; j + k <= m; ++k)
            {
                if (mtx[i][j + k - 1] == 0) break;
                //cout << i << ' ' << j << ' ' << k << '\n';
                dp[i][j][k] = k;
                if (i == n - 1) continue;
                ll mx = 0;
                for (int u = k; u <= m; ++u)
                {
                    mx = max(mx, dp[i + 1][j][u]);
                }
                //cout << i << ' ' << j << ' ' << k << '\n';
                dp[i][j][k] += mx;
            }
        }
    }
    for (int i = n - 1; i >= 0; --i)
    {
        for (int j = m - 1; j >= 0; --j)
        {
            for (int k = 1; j + k <= m; ++k)
            {
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans;

    return 0;
}
