#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct obj
{
    ll l, m, r;
};

bool operator<(obj x, obj y)
{
    //if (x.l != y.l) return x.l > y.l;
    return x.r > y.r;
}

int n, k;
vector<obj> a;
ll ans = 0;

void make(int pos, vector<int> &arr)
{
    if (pos == k)
    {
        vector<obj> b;
        for (int i = 0; i < k; ++i)
        {
            if (arr[i])
            {
                b.push_back(a[i]);
            }
        }
        sort(all(b));
        int k1 = len(b);
        int lt = n;
        for (int i = 0; i < k1; ++i)
        {
            if (b[i].l >= lt) continue;
            if (b[i].r + 1 < lt)
            {
                return;
            }
            lt = b[i].l;
        }
        if (lt != 0) return;
        for (int i = 0; i < k1; ++i)
        {
            for (int j = 0; j < k1; ++j)
            {
                if (i == j) continue;
                int l = max(b[i].l, b[j].l);
                int r = min(b[i].r, b[j].r);
                bool cond1 = (l <= b[i].m && b[i].m <= r);
                bool cond2 = (l <= b[j].m && b[j].m <= r);
                if (cond1 && cond2)
                {
                    return;
                }
            }
        }
        ans = 1;
        return;
    }
    arr[pos] = 0;
    make(pos + 1, arr);
    arr[pos] = 1;
    make(pos + 1, arr);
}

void solve()
{
    cin >> n >> k;
    a.assign(k, {0, 0, 0});
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].l >> a[i].m >> a[i].r;
        --a[i].l;
        --a[i].m;
        --a[i].r;
    }
    if (k <= 8)
    {
        ans = 0;
        vector<int> arr(k);
        make(0, arr);
        if (ans)
        {
            cout << "YES\n";
        } else
        {
            cout << "NO\n";
        }
        return;
    }
    sort(all(a));
    int lt = n;
    for (int i = 0; i < k; ++i)
    {
        if (a[i].l >= lt) continue;
        if (a[i].r + 1 < lt)
        {
            cout << "NO\n";
            return;
        }
        lt = a[i].l;
    }
    if (lt != 0)
    {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

