#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const ll INF = 4e18;

ll sq(ll x)
{
    return x * x;
}

ll dist(ll l, ll r, ll x)
{
    if (x < l)
    {
        return l;
    }
    if (x > r)
    {
        return r;
    }
    return x;
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> x[i];
    }
    ll x0, d;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i)
    {
        x[i] -= x0;
    }
    int m;
    cin >> m;
    vector<ll> t(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i)
    {
        ll ans = INF;
        for (ll l = -n; l <= n; l += 1)
        {
            for (ll r = l; r <= n; r += 1)
            {
                ll cur = (abs(l) + abs(r) + min(abs(l), abs(r))) * t[i];
                for (int j = 0; j < n; ++j)
                {
                    /*ll l1 = x[j] / d;
                    ll r1 = l1 + 1;
                    if (x[j] < 0)
                    {
                        r1 = l1 - 1;
                    }
                    cur += min(sq(x[j] - dist(l, r, r1) * d), sq(x[j] - dist(l, r, l1) * d));*/
                    ll mn = INF;
                    for (ll u = l; u <= r; ++u)
                    {
                        mn = min(mn, sq(x[j] - u * d));
                    }
                    cur += mn;
                }
                ans = min(ans, cur);
            }
        }
        cout << ans << '\n';
    }

    return 0;
}

