#include <bits/stdc++.h>
#define int int64_t
#define all(a) a.begin(), a.end()
using namespace std;

const int N = 5e5 + 100, INF = 1e9;

struct SEX {
    vector<int> t = vector<int>(2*N, INF);

    void upd(int id, int x) {
        id += N;
        t[id] = min(t[id], x);
        id /= 2;

        while (id)
            t[id] = min(t[2*id], t[2*id+1]), id/=2;
    }

    int get(int l, int r) {
        l += N, r += N;
        int res = INF;

        while (r > l) {
            if (l & 1)
                res = min(res, t[l++]);
            if (r & 1)
                res = min(res, t[--r]);
            l/=2, r/=2;
        }

        return res;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<array<int, 3>> a(k);

    SEX t1, t2;


    for (auto &[l, m, r] : a)
        cin >> l >> m >> r;

    sort(all(a), [&](auto i, auto j) {
        return i[1] < j[1];
    });

    vector<int> mx(k);

    for (int i = 0; i < k; i++) {
        if (a[i][0] == 1)
            mx[i] = a[i][2], t1.upd(mx[i], a[i][1]), t2.upd(mx[i], mx[i]);
        else {

            bool fl = false;

            if (t1.get(a[i][0] - 1, a[i][2]) < a[i][0])
                fl = true;
            if (t2.get(a[i][0] - 1, a[i][2]) < a[i][1])
                fl = true;
            if (fl) {
                mx[i] = a[i][2], t1.upd(mx[i], a[i][1]), t2.upd(mx[i], mx[i]);


            }
            // for (int j = 0; j < i; j++) {
            //     if ((a[j][1] < a[i][0] || mx[j] < a[i][1]) && mx[j] >= a[i][0] - 1) {
            //         mx[i] = max(a[i][2], mx[j]);
            //         break;
            //     }
            // }
        }
    }

    bool fl = false;

    for (int i = 0; i < k; i++) {
        if (mx[i] == n) {
            fl = true;
        }
    }


    if (fl)
        cout << "YES";
    else
        cout << "NO";
}
signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt; cin >> tt;

    while (tt--) {
        solve();
        cout << '\n';
    }
}