#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using lll = __int128;

vector<int> color;

void dfs(int u, vector<vector<int>> & g, int p = -1) {
    for (auto v : g[u]) {
        if (p != v) {
            color[v] = 1 - color[u];
            dfs(v, g, u);
        }
    }
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll n, k;
    cin >> n >> k;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    color.resize(n);
    dfs(0, g);
    int c0 = 0;
    int c1 = 0;
    vector<int> v1;
    vector<int> v2;
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) {
            c0++;
            v1.push_back(i);
        } else {
            c1++;
            v2.push_back(i);
        }
    }
    cout << min(c1, c0) << endl;
    for (int i = 0; i < min(c1, c0); i++) {
        cout << v1[i] << " " << v2[i] << endl;
    }
}