#include <bits/stdc++.h>

using namespace std;
#define rep(x) for (int rep_i = 0; rep_i < x; rep_i++)
#define all(x) x.begin(), x.end()
#define int long long

using pii = pair<int, int>;
using ll = long long;
const int maxn = 500010;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int n, k;
int t;
int used[maxn + 10];

void solve() {
    cin >> n >> k;
    vector<vector<int> > s;
    rep(k) {
        int l, r, m;
        cin >> l >> m >> r;
        s.push_back({l, r, m});
    }

    if (n <= 150 || k <= 8) {
        vector<int> p(k, 0);
        iota(all(p), 1);

        rep(10000) {
            shuffle(all(p), rng);
            fill(used, used + n + 10, 0);
            for (auto el: p) {
                el--;
                if (!used[s[el][2]]) {
                    used[s[el][2]] = 1;
                    for (int i = s[el][0]; i <= s[el][1]; i++)
                        used[i] = 1;
                }
            }
            bool flag = true;
            for (int i = 1; i <= n; i++) {
                if (!used[i])
                    flag = false;
            }
            if (flag) {
                cout << "YES" << endl;
                return;
            }
        }
        cout << "NO" << endl;
        return;
    } else {
        for (int i = 0; i < k; i++) {
            for (int j = i + 1; j < k; j++) {
                vector <int> el1 = s[i], el2 = s[j];
                if (el1[0] > el2[0])
                    swap(el1, el2);
                if (el1[0] == 1 && el2[1] == n && el1[1] >= el2[0]) {
                    cout << "YES" << endl;
                    return;
                }
            }
        }
        cout << "NO" << endl;
        return;
    }
}

signed main() {
    cin >> t;
    rep(t)
        solve();
    cerr << "ULYANOVSK IS THE BEST" << ' ' << clock() << endl;
}
