#include <bits/stdc++.h>
using namespace std;

#define li __int128
using ll = long long;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rev reverse
#define ff first
#define ss second
#define prl pair<ll, ll>
#define pri pair<int, int>
#define vec vector
#define len(a) a.size()

const int mod = 1e9 + 7;
const li inf = 1e18;
vec<vec<int> > g;
vec<vec<int> > dp;

void dfs(int v, int pr) {
    int sum = 0;
    for (int u: g[v]) {
        if (u != pr) dfs(u, v), sum += dp[u][0];
    }
    for (int u: g[v]) {
        if (u != pr) {
            dp[v][0] = max(dp[v][0], sum - dp[u][0] + dp[u][1] + 1);
        }
    }
    dp[v][1] = sum;
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    dp.resize(n, vec<int>(2));
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].pb(v - 1);
        g[v - 1].pb(u - 1);
    }
    dfs(0, -1);
    cout << max(dp[0][0], dp[0][1]) << "\n" << -1;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
