#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long
 
void solution();
 
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif
 
    solution();
}
 
int f(int s, int x, int t, int d) {
    return t * s + (x - s * d) * (x - s * d);
}

int calc(int t, int x, int d) {
    int l = 0, r = x / d + 3;
    while (l + 1 < r) {
        int s = (l + r) / 2;
        int cur = f(s, x, t, d);
        int next = f(s + 1, x, t, d);
        if (next < cur) l = s;
        else r = s;
    }
        
   return min(f(l, x, t, d), f(l + 1, x, t, d));
}
 
void solution() {
    int n;
    cin >> n;
 
    int x1, x2;
    cin >> x1 >> x2;
     
    int x0, d;
    cin >> x0 >> d;
 
    x1 -= x0;
    x2 -= x0;
    x1 = -x1;
 
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
 
        int l = 0, r = x1 / d + 3;
        while (l + 1 < r) {
            int s = (l + r) / 2;
            int cur = f(s, x1, t, d) + calc(t, x2 + s * d, d);
            int next = f(s + 1, x1, t, d) + calc(t, x2 + s * d + d, d);
            if (next < cur) l = s;
            else r = s;
        }
         
        int res1 = f(l, x1, t, d) + calc(t, x2 + l * d, d);
        int res2 = f(l + 1, x1, t, d) + calc(t, x2 + l * d + d, d);
        cout << min(res1, res2) << '\n';
    }
}