#include <bits/stdc++.h>

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t=1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
//#define int long long
const int MAXN = 5e5;
const int INF = 2e9;

int n,d;
vector<int> gr[MAXN];


void solve() {
    cin >> n >> d;

    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    vector<int> d(n, INF);
    d[0]=0;
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : gr[v]) {
            if (d[i] > d[v] + 1) {
                d[i] = d[v] + 1;
                q.push(i);
            }
        }
    }
    int ans = 0;
    vector<pair<int,int>> an;
    int last1=-1, last2=-1;
    for (int i = 0; i < n; i++) {
        if (d[i] % 2==0) {
            if (last1 == -1) {
                last1=i;
            } else {
                an.push_back({last1, i});
                last1 = -1;
            }
        } else {
            if (last2 == -1) {
                last2=i;
            } else {
                an.push_back({last2, i});
                last2 = -1;
            }
        }
    }
    cout << an.size() << '\n';
    for (auto i : an) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}