#include <bits/stdc++.h>

using namespace std;
//-------------------------------------//
#define int long long
//-------------------------------------//
#pragma GCC optimize("O3")
//------------------------------------//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//---------------------------------------//

const int N = 3e5 + 10;

vector<int> G[N];
int color[N];
vector<int> lag[3];

int optN[N];
int opt[N];
vector<bool> picked(N);
int target[N];

void dfs(int v, int parent = 0) {
    optN[v] = opt[v] = 0;
    for (auto u : G[v]) {
        if (u != parent) {
            dfs(u, v);
            optN[v] += opt[u];
            if (opt[u] == optN[u]) {
                picked[v] = true;
                target[v] = u;
            }
        }
    }
    if (picked[v]) {
        opt[v] = optN[v] + 1;
    } else {
        opt[v] = optN[v];
    }
}

vector<pii> pairs;

void dfs_out(int v, int parent = 0) {
    if (picked[v]) {
        pairs.push_back({v, target[v]});
    }
    for (auto u : G[v]) {
        if (u != parent) {
            dfs(u, v);
        }
    }
}

signed main() {
    fast;

    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }
    dfs(1);
    int m = opt[1];
    dfs_out(1);
    cout << m << "\n";
    for (auto p : pairs) {
        cout << p.ft << " " << p.sd << "\n";
    }
    return 0;
}
