#include<bits/stdc++.h>
#define ll long long

using namespace std;

struct sob {
    ll l, m, r;
};

ll n, k;
vector<ll> l, m, r, tree;

void update(ll ind, ll l, ll r, ll q_ind) {
    if (q_ind >= r || q_ind < l) {
        return;
    }
    if (l + 1 == r) {
        tree[ind] = 1;
        return;
    }
    update(ind * 2 + 1, l, (l + r) / 2, q_ind);
    update(ind * 2 + 2, (l + r) / 2, r, q_ind);
    tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 2]);
}

ll gett(ll ind, ll l, ll r, ll q_l, ll q_r) {
    if (l >= q_r || r <= q_l) {
        return 0;
    }
    if (l >= q_l && r <= q_r) {
        return tree[ind];
    }
    return max(gett(ind * 2 + 1, l, (l + r) / 2, q_l, q_r), gett(ind * 2 + 2, (l + r) / 2, r, q_l, q_r));
}

bool check(ll ind, ll l, ll r) {
    if (l + 1 == r) {
        return tree[ind];
    } else {
        return check(ind * 2 + 2, (l + r) / 2, r);
    }
}

void input() {
    cin >> n >> k;
    l.resize(k);
    m.resize(k);
    r.resize(k);
    for (ll i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
    }
}

bool cmp(sob &a, sob &b) {
    return a.r < b.r;
}

void solve() {
    tree.assign(4 * (n + 1), 0);
    vector<sob> s;
    for (ll i = 0; i < k; i++) {
        sob new_sob;
        new_sob.l = l[i];
        new_sob.r = r[i];
        new_sob.m = m[i];
        s.push_back(new_sob);
    }
    sort(s.begin(), s.end(), cmp);
    update(0, 0, n + 1, 0);
    for (ll i = 0; i < k; i++) {
        if (gett(0, 0, n + 1, s[i].l - 1, s[i].m)) {
            update(0, 0, n + 1, s[i].r);
        }
    }
    if (check(0, 0, n + 1)) {
        cout << "YES" << "\n";
    } else {
        cout << "NO" << "\n";
    }
}

void output() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        input();
        solve();
        output();
    }
    return 0;
}
