#include<bits/stdc++.h>
#define ll long long

using namespace std;

struct sob {
    ll l, m, r;
};

ll n, k;
bool ans;
vector<ll> l, m, r, tree;
vector<vector<ll>> g;
vector<bool> used;

void dfs(ll u, ll p) {
    used[u] = 1;
    for (ll i = 0; i < g[u].size(); i++) {
        if (!ans) {
            return;
        }
        if (used[g[u][i]] == 0) {
            dfs(g[u][i], u);
        } else if (used[g[u][i]] && p != g[u][i]) {
            ans = false;
            return;
        }
    }
    used[u] = 2;
}

void input() {
    cin >> n >> k;
    l.resize(k);
    m.resize(k);
    r.resize(k);
    for (ll i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
    }
}

bool cmp(sob &a, sob &b) {
    return a.l > b.l;
}

void solve() {
    g.clear();
    g.resize(k);
    for (ll i = 0; i < k; i++) {
        for (ll j = 0; j < k; j++) {
            if (j >= i) {
                continue;
            }
            if (m[j] >= l[i] && m[j] <= r[i]) {
                g[i].push_back(j);
                //cout << i << " " << j << endl;
            }
            if (m[i] >= l[j] && m[i] <= r[j]) {
                g[j].push_back(i);
                //cout << j << " " << i << endl;
            }
        }
    }
    ans = true;
    used.assign(k, false);
    for (ll i = 0; i < k; i++) {
        if (!used[i]) {
            dfs(i, -1);
            if (!ans) {
                break;
            }
        }
    }
    if (ans) {
        cout << "YES" << "\n";
    } else {
        cout << "NO" << "\n";
    }
}

void output() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        input();
        solve();
        output();
    }
    return 0;
}
