#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int h, w;
    cin >> h >> w;

    vector<string> t(h);
    for (int i = 0; i < h; i++)
    {
        cin >> t[i];
    }

    vector len(h, vector<int>(w));
    for (int i = 0; i < h; i++)
    {
        int r = 0;
        for (int j = 0; j < w; j++)
        {
            r = max(j, r);
            while (r < w && t[i][r] == '1')
                ++r;
            len[i][j] = r - j;
        }
    }
    int ans = 0;
    for (int it = 0; it < w; it++)
    {
        vector<int> a(h);
        for (int i = 0; i < h; i++)
            a[i] = len[i][it];
        vector dp(h + 1, vector<int>(w + 1));
        for (int i = 1; i <= h; i++)
        {
            for (int j = 1; j <= w; j++)
            {
                if (j <= a[i - 1])
                {
                    dp[i][j] = max(dp[i][j - 1], j + dp[i - 1][j]);
                }
                else
                {
                    dp[i][j] = max(dp[i][j - 1], dp[i - 1][j]);
                }
            }
        }
        ans = max(ans, dp[h][w]);
    }
    cout << ans << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}