#include <iostream>
#include <vector>
#include <stack>
#include <set>

using namespace std;

const int inf = 1e9;

typedef long long ll;

int main() {
    int n, m;
    cin >> n >> m;
    char c;
    vector<vector<ll>> a(n, vector<ll> (m));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            cin >> c;
            a[i][j] = c - '0';
            if (i != 0 && a[i][j] == 1) {
                a[i][j] = a[i - 1][j] + 1;
            }
        }
    }
    ll ma = 0;
    for (int i = 0; i < n; i++) {
        stack<pair<int, int>> s;
        s.push({0, -1});
        ll sum = 0;
        for (int j = 0; j < m; j++) {
            ll pr = j;
            while (s.top().first > a[i][j]) {
                int x = s.top().first;
                int y = s.top().second;
                s.pop();
                sum -= (pr - 1 - y) * x;
                pr = y;
            }
            int k = s.top().second;
            s.push({a[i][j], j});
            sum += a[i][j] * (j - k);
            ma = max(ma, sum);
        }
    }
    cout << ma;
    return 0;
}