#include <bits/stdc++.h>

using namespace std;

void dfs(int i, int p, int c, vector<int> &col, vector<vector<int>> &gr) {
    col[i] = c;
    for (auto &j : gr[i]) {
        if (j == p) continue;
        dfs(j, i, (c + 1) % 2, col, gr);
    }
}

int dist(int i, int p, int to, vector<vector<int>> &gr) {
    if (i == to) return 0;
    int ans = gr.size() + 1;
    for (auto &j : gr[i]) {
        if (j == p) continue;
        ans = min(ans, dist(j, i, to, gr) + 1);
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<vector<int>> gr(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    vector<int> col(n);
    dfs(0, -1, 0, col, gr);
    vector<int> c0, c1;
    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            c1.push_back(i);
        } else {
            c0.push_back(i);
        }
    }
    if (c0.size() < c1.size()) swap(c1, c0);
    /*cout << min(c0.size(), c1.size()) << endl;
    for (int i = 0; i < min(c0.size(), c1.size()); i++) {
        cout << c0[i] + 1 << " " << c1[i] + 1 << "\n";
    }*/
    vector<pair<int, int>> max_ans;
    do {
        vector<pair<int, int>> lans;
        for (int i = 0; i < min(c0.size(), c1.size()); i++) {
            if (dist(c0[i], -1, c1[i], gr) <= d) {
                lans.push_back({c0[i], c1[i]});
            }
        }
        if (max_ans.size() < lans.size()) {
            swap(max_ans, lans);
        }
    } while (next_permutation(c0.begin(), c0.end()));
    cout << max_ans.size() << endl;
    for (auto &i : max_ans) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}