#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

pii nst(ll x, ll x0, ll d) {
	if (x % d == x0 % d) return { x, x };
	if (x0 < x) {
		ll k = (x - x0) / d;
		return { x0 + k * d, x0 + (k + 1) * d };
	}
	ll k = (x0 - x) / d;
	return { x0 - (k + 1) * d), x0 - k * d };
}

void solve() {
	ll n; cin >> n;
	vector<ll>x(n);
	for (auto& i : x) cin >> i;
	sort(all(x));
	ll x0, d; cin >> x0 >> d;
	ll m; cin >> m;
	ll t; cin >> t;
	ll ans = 0;
	for (ll i = 0; i < n; ++i) {
		pii s = nst(x[i], x0, d);
		ll a = (s.first - x[i]) * (s.first - x[i]);
		ll b = (s.second - x[i]) * (s.second - x[i]);
		ans += min(a, b);
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}