#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = __int128;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

__int128 read() {
    string s; cin >> s;
    ll f = 1, x = 0;
    for (auto c: s) {
        if (c == '-') f *= -1;
        else {
            x *= 10;
            x += c - '0';
        }
    }
    return x * f;
}

void print(__int128 x, bool z = true) {
    if (x < 0) {
        cout << '-';
        x *= -1;
    }
    if (x == 0) {
        if (z) cout << 0;
        return;
    }
    print(x / 10, false);
    cout << (int)(x % 10);
}

pii nst(ll x, ll d) {
    if (x >= 0) {
        return {x / d * d, (x + d - 1) / d * d};
    }
    return {-((-x + d - 1) / d * d), -(-x / d * d)};
}

void solve() {
    ll n = read();
    vector<ll>x(n);
    for (auto& i : x) i = read();
    ll x0 = read(), d = read();
    for (auto &i : x) i -= x0;
    ll m = read();
    for (ll it = 1; it <= m; ++it){
        ll t = read();
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            ll l = 0, r = (x[i] + d - 1) / d;
            while (r - l > 2) {
                ll lm = l + (r - l) / 3, rm = r - (r - l) / 3;
                ll fa = t * lm * d + (lm * d - x[i]) * (lm * d - x[i]);
                ll fb = t * rm * d + (rm * d - x[i]) * (rm * d - x[i]);
                if (fa <= fb) r = rm;
                if (fa >= fb) l = lm;
            }
            ll best = 1e18;
            for (ll k = l; k <= r; ++k) {
                ll X = t * k * d + (k * d - x[i]) * (k * d - x[i]);
                best = min(best, X);
            }
            ans += best;
        }
        print(ans);
        cout << '\n';
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t = 1;

    while (t--) {
        solve();
        cout << '\n';
    }
}