#include <iostream>
#include <vector>

using namespace std;

struct person {
    int l, m, r;
};

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<int> dp(n + 1, 0);
        vector<person> people;
        for (int i = 0; i < k; i++) {
            int l, m, r;
            cin >> l >> m >> r;
            l--;
            m--;
            r--;
            people.emplace_back(l, m, r);
        }
        vector<vector<person>> finish(n);
        for (int i = 0; i < k; i++) {
            finish[people[i].r].push_back(people[i]);
        }
        dp[0] = 1;
        for (int i = 0; i < n; i++) {
            int res = 0;
            for (auto p : finish[i]) {
                int cnt = 0;
                for (int j = p.l - 1; j < p.m; j++) {
                    cnt |= dp[j + 1];
                }
                if (cnt) {
                    res = 1;
                }
            }
            dp[i + 1] = res;
        }
        if (dp[n]) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
    return 0;
}