#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> dp;
constexpr int INF = 1e15;

void dfs(int v, int p = -1) {
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    int ans1 = 0;
    int res = 0;
    int min_dif = INF;
    for (int u : g[v]) {
        ans1 += max(dp[u].first, dp[u].second);
        if (dp[u].first > dp[u].second) {
            res = 1;
        }
        min_dif = min(min_dif, dp[u].second - dp[u].first);
    }
    dp[v].first = ans1;
    if (res) {
        dp[v].second = ans1 + 1;
    } else {
        dp[v].second = ans1 + 1 - min_dif;
    }
}


signed main() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp.resize(n, {0, 0});
    dfs(0);
    cout << max(dp[0].first, dp[0].second);
    cout << -1 << endl;
    return 0;
}