#include <iostream>
#include <vector>
using namespace std;
#define int long long


int max(int a, int b) {
    return (a > b ? a : b);
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            arr[i][j] = c - '0';
        }
    }
    vector<vector<int>> left(n, vector<int>(m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (arr[i][j] == 0) {
                left[i][j] = 0;
            } else {
                left[i][j] = left[i][j + 1] + 1;
            }
        }
    }
    vector<vector<int>> dp(n, vector<int>(m));
    int ans = 0;
    for (int j = 0; j < m; j++) {
        dp[0][j] = left[0][j];
    }
    for (int i = 1; i < n; i++) {
        int j = 0;
        while (1) {
            while (j < m && arr[i][j] == 0) {
                j++;
            }
            if (j == m) {
                break;
            }
            int r = j;
            while (r < m && arr[i][r] == 1) {
                r++;
            }
            for (int l = j; l < r; l++) {
                int minus = max(0ll, (l + left[i - 1][l] - 1) - (r - 1));
                dp[i][l] = dp[i - 1][l] + r - l - minus;
            }
            j = r;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}