#include <iostream>
#include <vector>
using namespace std;
#define int long long


int max(int a, int b) {
    return (a > b ? a : b);
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            arr[i][j] = c - '0';
        }
    }
    vector<vector<int>> left(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (arr[i][j] == 0) {
                left[i][j] = 0;
            } else {
                if (i == 0) {
                    left[i][j] = 1;
                    continue;
                }
                left[i][j] = left[i - 1][j] + 1;
            }
        }
    }
    vector<vector<int>> dp(n, vector<int>(m));
    int ans = 0;
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> st;
        int calc = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (arr[i][j] == 0) {
                calc = 0;
                st.clear();
                continue;
            }
            int cnt = 1;
            calc += left[i][j];
            while (!st.empty() && st.back().first > left[i][j]) {
                calc -= (st.back().first - left[i][j]) * st.back().second;
                st.pop_back();
            }
            st.push_back({left[i][j], cnt});
            ans = max(ans, calc);
        }
    }
    cout << ans;
}