#include <iostream>
#include <cassert>
#include <vector>
using namespace std;
#define int long long
#define line cout << "\n"
#define pii pair<int, int>
#define all(a) a.begin(), a.end()


int max(int a, int b) {
    return (a > b ? a : b);
}

int min(int a, int b) {
    return (a < b ? a : b);
}


struct event{
    int l, m, r;
};


bool between(int a, int b, int c) {
    return a <= b && b <= c;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<event> arr(k);
    for (int i = 0; i < k; i++) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
    }
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (between(arr[i].l, arr[j].m, arr[i].r) && between(arr[j].l, arr[i].m, arr[j].r)) {
                cout << "NO"; line;
                return;
            }
        }
    }
    cout << "YES"; line;
}


signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}