#include <iostream>
#include <cassert>
#include <vector>
using namespace std;
#define line cout << "\n"
#define pii pair<int, int>
#define pb push_back
#define all(a) a.begin(), a.end()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(a) (int) a.size()
  
  
int max(int a, int b) {
    return (a > b ? a : b);
}
  
int min(int a, int b) {
    return (a < b ? a : b);
}
const int MAXN = 5e5 + 10;
vector<vector<int>> g(MAXN);
vector<pii> dp(MAXN);

void dfs(int v, int p) {
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        int x = dp[u].first + dp[u].second;
        dp[v].second += max(dp[u].first, dp[u].second);
    }
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        dp[v].first = max(dp[v].first, dp[v].second - max(dp[u].first, dp[u].second) + dp[u].second + 1);
    }
}
  
void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(0, 0);
    cout << max(dp[0].first, dp[0].second); line;
    cout << -1; line;
}
  
  
signed main() {
    fast;
 
 
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}