#include <bits/stdc++.h>
using namespace std;
#define int ll
typedef long long ll;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (const auto &i: a)out << i;
    return out;
}


struct Test {
    int n{};
    vector<int> x;
    int x0{};
    int d{};
    int m{};
    vector<int> t;

    ll dist(int x1) {
        ll dst = (x1 - x0) / d * d + x0 -x1;
        ll dst2 = dst + d;
        ll dst3 = dst - d;
        return min({dst * dst, dst2 * dst2, dst3 * dst3});
    }

    Test() {
        cin >> n;
        x.resize(n);
        cin >> x;
        cin >> x0 >> d >> m;
        t.resize(m);
        cin >> t;
        sort(x.begin(), x.end());

        ll ans = 0;
        for (auto x1: x) {
            ans += dist(x1);
        }
        cout << ans << '\n';
    }
};

signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(20);
    int t = 1;
    //cin>>t;
    while (t--) Test();
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << "ms\n";
#endif
}
