//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
vector<vector<int>>G;
vector<int>dp_used, dp_unused;

void dfs(int v, int pr) {
    if (G[v].size()==1) {
        dp_used[v]=0;
        dp_unused[v]=0;
        return;
    }
    for (auto j : G[v]) {
        if (j!=pr) {
            dfs(j, v);
        }
    }

    int s = 0;
    for (auto j : G[v]) {
        if (j != pr) {
            s += max(dp_unused[j],dp_used[j]);
        }
    }
    dp_unused[v] = s;
    for (auto j : G[v]) {
        if (j != pr) {
            dp_used[v]=max(dp_used[v], s-max(dp_used[j], dp_unused[j])+dp_unused[j]);
        }
    }
    dp_used[v]++;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, d;
    cin >> n >> d;
    G.resize(n+1);
    dp_unused.resize(n + 1, 0);
    dp_used.resize(n + 1, 0);
    for (int i=0;i<n-1;++i) {
        int v, u;
        cin >> v >> u;
        G[v].push_back(u);
        G[u].push_back(v);
    }

    dfs(1, 0);
    cout<<max(dp_used[1], dp_unused[1])<<"\n-1";
}