#include <bits/stdc++.h>

using ll = __int128;
#define int long long
using namespace std;

void solve();

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}

vector<vector<int> > g;
vector<deque<pair<int,int> > > r, b;
vector<int> used;
vector<pair<int,int> > ans;
int d;

void dfs(int u) {
    used[u] = 1;
    deque<pair<int,int> > all_r, all_b;
    for (auto v: g[u]) {
        if (used[v] == 0) {
            dfs(v);
        }
        if (used[v] == 2) {
            for (int i = 0; i < r[v].size(); i++) {
                all_r.push_back(r[v][i]);
            }
            for (int i = 0; i < b[v].size(); i++) {
                all_b.push_back(b[v][i]);
            }
        }
    }
    for (int i = 0; i < all_r.size(); i++) {
        all_r[i].second++;
    }
    for (int i = 0; i < all_b.size(); i++) {
        all_b[i].second++;
    }
    while (!all_r.empty() && all_r.front().second == d) {
        all_r.pop_front();
    }
    while (!all_b.empty() && all_b.front().second == d) {
        all_b.pop_front();
    }
    swap(all_r, all_b);
    all_r.push_back({u, 0});
    while (!all_r.empty() && !all_b.empty()) {
        ans.push_back({all_r.front().first, all_b.front().first});
        all_r.pop_front();
        all_b.pop_front();
    }
    r[u] = all_r;
    b[u] = all_b;
    used[u] = 2;
}

void solve() {
    int n;
    cin >> n;
    cin >> d;
    g.resize(n);
    used.resize(n);
    r.resize(n);
    b.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);
    cout << ans.size() << "\n";
    for (auto [a, b]: ans) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}
