#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 300005;

ll x[2][maxn];
ll sum[2][maxn];
pair<__int128,ll> suff[2][maxn];
int sz[2];

inline __int128 find_ans_pos(int k,int d,int t,int v)
{
    int pos = upper_bound(x[v],x[v]+sz[v],k * d) - x[v] - 1;
    __int128 ans = sum[v][pos+1];
    ans += suff[v][pos+1].first - __int128(2) * suff[v][pos+1].second * k * d + __int128(k * d) * (k * d) * (sz[v]-pos-1);
    ans += ll(t) * k;
    return ans;
}

__int128 find_ans(int d,int t,int v)
{
    int lg = 0,rg = (1e9+d-1)/d;
    while(lg < rg)
    {
        int mg = (lg+rg)/2;
        __int128 ans1 = find_ans_pos(mg,d,t,v);
        __int128 ans2 = find_ans_pos(mg+1,d,t,v);
        if(ans2 < ans1)
        {
            lg = mg + 1;
        }
        else
        {
            rg = mg;
        }
    }
  //  cout << lg << ' ' << ll(find_ans_pos(lg+1,x,sum,suff,d,t)) << endl;
    return find_ans_pos(lg,d,t,v);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    ll xx[n];
    for(int i = 0;i < n;++i)
    {
        cin >> xx[i];
        //cin >> xx[i];
    }
    int x0,d;
    cin >> x0 >> d;
   // cin >> x0 >> d;
    //cout << "!" << endl;
    for(int j = 0;j < n;++j)
    {
        if(xx[j] < x0)
        {
            x[0][sz[0]++]= x0-xx[j];
        }
        else if(xx[j] > x0)
        {
            x[1][sz[1]++] = xx[j]-x0;
        }
    }
 //   cout << "!" << endl;
    sort(x[0],x[0] + sz[0]);
    sort(x[1],x[1] + sz[1]);
    sum[0][0] = 0;
    sum[1][0] = 0;
    for(int j = 0;j < sz[0];++j)
    {
        ll dd = min(d-x[0][j]%d,x[0][j]%d);
        sum[0][j+1] = sum[0][j] + dd * dd;
    }
    for(int j = 0;j < sz[1];++j)
    {
        ll dd = min(d-x[1][j]%d,x[1][j]%d);
        sum[1][j+1] = sum[1][j] + dd * dd;
    }
  //  cout << "!" << endl;
    suff[0][sz[0]] = {0,0};
    suff[1][sz[1]] = {0,0};
    for(int j = sz[0]-1;j >= 0;--j)
    {
        suff[0][j] = {suff[0][j+1].first + x[0][j] * x[0][j],suff[0][j+1].second + x[0][j]};
    }
    for(int j = sz[1]-1;j >= 0;--j)
    {
        suff[1][j] = {suff[1][j+1].first + x[1][j] * x[1][j],suff[1][j+1].second + x[1][j]};
    }
    int q;
    cin >> q;
    while(q--)
    {
        ll t;
        cin >> t;
        __int128 l1 = find_ans(d,t,0),l2 = find_ans(d,2*t,0),r1 = find_ans(d,t,1),r2 = find_ans(d,2*t,1);
        cout << ll(min(l1 + r2,r1 + l2)) << "\n";
    }
    return 0;
}