#include <bits/stdc++.h>

using namespace std;
void solve();
int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define endl '\n'
const int N=2e5+10,MOD=1e9+7,INF=2e18;
struct seg {
    int l,r,m;
};
bool comp(seg a,seg b) {
    if (a.l==b.l) {
        return a.r<b.r;
    }
    return a.l<b.l;
}
void solve() {
    int n,k;
    cin>>n>>k;
    vector<seg> a(k+1);
    for (int i=1;i<=k;i++) {
        cin>>a[i].l>>a[i].m>>a[i].r;
    }
    a[0]={0,0,0};
    sort(a.begin(),a.end(),comp);
    vector<bool> dp(k+1,false);
    dp[0]=true;
    multiset<pair<int,int>> st;
    multiset<int> rg;
    rg.insert({0});
    st.insert({0,0});

    for (int i=1;i<=k;i++) {
        while (!rg.empty() && *rg.begin()<a[i].l-1) {
            rg.erase(rg.begin());
        }
        while (!st.empty() && st.begin()->second<a[i].l-1) {
            st.erase(st.begin());
        }
        if (!rg.empty()) {
            int mnr=*rg.begin();
            if (a[i].m>mnr) {
                dp[i]=true;
            }
        }
        if (!st.empty()) {
            int mnm=st.begin()->first;
            if (a[i].l>mnm) {
                dp[i]=true;
            }
        }
        if (dp[i]) {
            rg.insert(a[i].r);
            st.insert({a[i].m,a[i].r});
        }
    }
    for (int i=1;i<=k;i++) {
        if (dp[i] && a[i].r==n) {
            cout<<"YES"<<endl;
            return;
        }
    }
    cout<<"NO"<<endl;
}