#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
struct P
{
    int l, m, r;
};

vector <vector <int>> g;

void solve()
{
    int n, k;
    cin >> n >> k;
 
    vector <P> v (k);
    
    int l, m, r;
    for (int i=0; i<k; i++)
    {
        cin >> l >> m >> r;
        l--; m--; r--;
        v[i].l = l; v[i].m = m; v[i].r = r;
    }

    // for (int i=0; i<k; i++)
    // {
    //     for (int j=0; j<k; j++)
    //     {
    //         if (v[i].l <= v[j].m && v[j].m <= v[i].r)
    //         {
    //             g[i].push_back(j);
    //         }
    //     }
    // }

    vector <pair <int, int>> ot;

    ot.push_back({0, n-1});

    bool f = false;
    for (int i=0; i<k; i++)
    {
        for (int j=0; j<k; j++)
        {
            l = v[j].l;
            m = v[j].m;
            r = v[j].r;
            for (int t=ot.size()-1; t>=0; t--)
            {
                auto [l1, r1] = ot[t];
                if (l1 >= l && r1 <= r && l1 <= m && m <= r1) f = true;
                else if (l1 >= l && m >= l1) ot.push_back({r+1, r1});
                else if (r1 <= r && m <= r1) ot.push_back({l1, l-1});
                if (f) break;
            }
            if (f) break;
        }
        if (f) break;
    }

    if (f) cout << "YES";
    else cout << "NO";

    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    int tests = 1;
 
    cin >> tests;
 
    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}