#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
#define endl '\n'
#define cin(v) for (auto& el : v) { cin >> el;}
#define cout(v) for (auto& el : v) { cout << el << " ";} cout << "\n";

using namespace std;
using ll = long long;
const ll MOD1 = 1e9 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> dp(n + 1);
    dp.back() = 1;
    vector<vector<pair<int, int>>> qs(n);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; r--;
        m--;
        qs[l].push_back({m, r});
    }
    for (int i = n - 1; i >= 0; i--) {
        for (auto p : qs[i]) {
            int m = p.first, r = p.second;
            for (int j = m + 1; j <= r + 1; j++) {
                dp[i] |= dp[j];
            }
        }
    }
    if (dp[0]) {
        cout << "YES\n";
    }else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}