#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
using namespace std;
long long rast(pair <long long, long long> a, pair <long long, long long> b) {
    long long x = a.first - b.first, y = a.second - b.second;
    return x * x + y * y;
}
int cnt = 1;
int used[100'000];
//pair <int, int> v[100'000];
vector <int> gr[100'000];
//vector <vector <int>> gr;
//vector <int> used;
bool dfs(int e) {
    int fl = 1;
    for (auto i : gr[e]) {
        if (used[i] == 0) {
            used[i] = 4 * cnt + 1 - used[e];
            if (!dfs(i)) {
                fl = 0;
            }
        } else if (used[i] == used[e]) {
            fl = 0;
        }
    }
    return fl;
}
vector <pair <long long, long long>> v;
bool comp(pair <long long, long long> a, pair <long long, long long> b) {
    return rast(a, v[0]) < rast(b, v[0]);
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    double r;
    cin >> n >> r;
    v.resize(n);
    map <pair <long long, long long>, int> m;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        m[v[i]] = i;
    }
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    //random_shuffle(v.begin(), v.end());
    sort(v.begin(), v.end(), comp);
    //gr.resize(n);
    for (int i = 0; i < n; i++) {
        int c = 0;
        for (int j = i + 1; j < n && c < 10; j++) {
            if (rast(v[i], v[j]) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
                c++;
            }
            if (sqrt(rast(v[i], v[0])) + r < sqrt(rast(v[j], v[0]))) {
                break;
            }
            //c++;
        }
        //cout << rast(v[i], v[0]) << endl;
    }
    //used.resize(n);
    vector <int> us(2 * n + 10);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            used[i] = 2 * cnt;
            int x = dfs(i);
            us[2 * cnt] = x;
            us[2 * cnt + 1] = x;
            cnt++;
        }
    }
    vector <int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[m[v[i]]] = 1 - us[used[i]];
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    return 0;
}
