#include <bits/stdc++.h>

using namespace std;

struct lol {
    long long mn, ind;
};

vector<lol> t;

void upd(long long v, long long vl, long long vr, long long i, long long x) {
    if (vl == vr) {
        t[v].mn = x;
        t[v].ind = i - 1;
        return;
    }
    long long m = (vl + vr) / 2;
    if (m >= i) upd(2 * v, vl, m, i, x);
    else upd(2 * v + 1, m + 1, vr, i, x);
    if (t[2 * v].mn > t[2 * v + 1].mn) t[v] = t[2 * v + 1];
    else t[v] = t[2 * v];
}

lol get(long long v, long long vl, long long vr, long long l, long long r) {
    if (vl > r || vr < l) return {(long long)1e18, -1};
    if (vl >= l && vr <= r) return t[v];
    long long m = (vl + vr) / 2;
    lol a = get(2 * v, vl, m, l, r);
    lol b = get(2 * v + 1, m + 1, vr, l, r);
    if (a.mn > b.mn) return b;
    else return a;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    long long n, q, k, ind;
    cin >> n >> q;
    vector<long long> a(n), mx(n, n - 1), suf(n);
    t.resize(4 * n, {(long long)1e18, -1});
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
        upd(1, 1, n, i + 1, a[i]);
    }
    for (long long i = n - 1; i >= 0; i--) {
        if (i == n - 1) suf[i] = a[i];
        else suf[i] = max(suf[i + 1], a[i]);
    }
    vector<pair<long long, long long>> vec;
    for (long long i = n - 1; i >= 0; i--) {
        while (vec.size() > 0 && vec.back().first < a[i]) vec.pop_back();
        if (vec.size() == 0) mx[i] = n - 1;
        else mx[i] = vec.back().second;
        vec.push_back({a[i], i});
    }
    while (q--) {
        cin >> k >> ind;
        long long ans = 0;
        if (k == ind) {
            for (long long i = 1; i < ind; i++) {
                ans = get(1, 1, n, ans + 2, min(mx[ans] + 1, n - k + i + 1)).ind;
            }
            cout << suf[ans] << endl;
            continue;
        }
        for (long long i = 1; i < ind; i++) {
            ans = get(1, 1, n, ans + 2, min(mx[ans] + 1, n - k + i + 1)).ind;
        }
        cout << a[ans] << endl;
    }
    return 0;
}
