#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/stdc++.h>

#pragma GCC target("bmi2")

using namespace std;

// #define int long long
#define all(a) a.begin(), a.end()

struct st {
    vector<vector<pair<int, int>>> m;

    st(vector<int> &a) {
        int n = a.size();
        m.resize(__lg(n) + 1, vector<pair<int, int>>(n));
        for (int i = 0; i < n; ++i)
            m[0][i] = {a[i], i};
        for (int i = 1; i <= __lg(n); ++i)
            for (int j = 0; j + (1 << (i - 1)) < n; ++j)
                m[i][j] = max(m[i - 1][j], m[i - 1][j + (1 << (i - 1))]);
    }

    pair<int, int> get(int l, int r) {
        ++r;
        int t = __lg(r - l);
        return max(m[t][l], m[t][r - (1 << t)]);
    }
};
struct st2 {
    vector<vector<pair<int, int>>> m;

    st2(vector<int> &a) {
        int n = a.size();
        m.resize(__lg(n) + 1, vector<pair<int, int>>(n));
        for (int i = 0; i < n; ++i)
            m[0][i] = {a[i], i};
        for (int i = 1; i <= __lg(n); ++i)
            for (int j = 0; j + (1 << (i - 1)) < n; ++j)
                m[i][j] = min(m[i - 1][j], m[i - 1][j + (1 << (i - 1))]);
    }

    pair<int, int> get(int l, int r) {
        ++r;
        int t = __lg(r - l);
        return min(m[t][l], m[t][r - (1 << t)]);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    vector<vector<int>> ans(n);
    st mx(a);
    st2 mn(a);
    while (q--) {
        int k, i;
        cin >> k >> i;
        if (i != k)
            cout << a[i - 1] << '\n';
        else
            cout << mx.get(k - 1, n - 1).first << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}