#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

int n, q;
int prof(string& s, int i) {
	if (0 < i && i < n - 1 && s[i] == '0' && s[i - 1] == '1' && s[i + 1] == '1') {
		if (i == 1 || s[i - 2] == '0') {
			if (i + 2 == n || s[i + 2] == '0') {
				return 3;
			}
		}
	}
	if (0 < i && s[i] == '0' && s[i - 1] == '1') {
		if (i == 1 || s[i - 2] == '0') {
			return 2;
		}
	}
	if (i < n - 1 && s[i] == '0' && s[i + 1] == '1') {
		if (i + 2 == n || s[i + 2] == '0') {
			return 2;
		}
	}
	if (s[i] == '0') {
		return 1;
	}
	return 0;
}

int get(string s) {
	int base = 0;
	int last = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') {
			base += (i - last == 1 ? 0 : i - last);
			last = i + 1;
		}
	}
	base += (n - last == 1 ? 0 : n - last);
	return base;
}

int main() {
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif
	string s;
	cin >> n >> q >> s;
	vector<int> dp(1 << n, 1e9);
	int m0 = 0;
	for (int i = 0; i < n; i++) {
		m0 += (s[i] - '0') << i;
	}
	dp[m0] = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		string t;
		for (int i = 0; i < n; i++) {
			t += char('0' + ((mask >> i) & 1));
		}
		for (int nx = 0; nx < n; nx++) {
			string t1 = t;
			t1[nx] = '1';

			int m = 0;
			for (int i = 0; i < n; i++) {
				m += (t1[i] - '0') << i;
			}
			dp[m] = min(dp[m], dp[mask] + 1);
		}
	}
	while (q--) {
		int k;
		cin >> k;
		int ans = 0;
		for (int mask = 0; mask < (1 << n); mask++) {
			string t;
			for (int i = 0; i < n; i++) {
				t += char('0' + ((mask >> i) & 1));
			}
			if (dp[mask] <= k) {
				ans = max(ans, get(t));
			}
		}
		cout << ans << '\n';
	}
}
