#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> t;

void add(int i, int val) {
	for (; i < t.size(); i += i & (~(i - 1))) {
		t[i] += val;
	}
}

int get(int i) {
	int s = 0;
	for (; i > 0; i -= i & (~(i - 1))) {
		s += t[i];
	}
	return s;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	t.resize(n * m + 1);
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<int> b1, b2;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			b1.push_back(a[i][j]);
		}
	}
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			b2.push_back(a[i][j]);
		}
	}
	ll i1 = 0;
	for (int i = n * m - 1; i >= 0; i--) {
		i1 += get(b1[i]);
		add(b1[i], 1);
	}
	fill(all(t), 0);
	ll i2 = 0;
	for (int i = n * m - 1; i >= 0; i--) {
		i2 += get(b2[i]);
		add(b2[i], 1);
	}
	fill(all(t), 0);
	cout << min(i1, i2);

}