#include <bits/stdc++.h>
using namespace std;
#define int long long
#pragma GCC optimize("O3,unroll-loops")

const int maxf = 1000005;
int fenw[maxf];

void add(int i, int x) {
    for (; i < maxf; i += i & -i)
        fenw[i] += x;
}

int get(int i) {
    int res = 0;
    for (; i; i -= i & -i)
        res += fenw[i];
    return res;
}

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (auto& v : a)
        for (int& i : v) cin >> i;

    vector<vector<int>> dp(r + 1, vector<int>(c + 1, 2e9));
    dp[0][0] = 0;

    int tot = r * c;

    for (int i = 0; i <= r; i++) {
        for (int j = 0; j < c && i; j++) {
            add(a[i-1][j], 1);
        }

        for (int j = 0; j <= c; j++) {
            for (int k = i; k < r && j; k++) {
                add(a[k][j-1], 1);
            }

            if (i != r) {
                int cnt = 0;
                for (int k = j; k < c; k++) {
                    cnt += get(tot) - get(a[i][k]);
                    add(a[i][k], 1);
                }

                dp[i+1][j] = min(dp[i+1][j], dp[i][j] + cnt);

                for (int k = j; k < c; k++) {
                    add(a[i][k], -1);
                }
            }

            if (j != c) {
                int cnt = 0;

                for (int k = i; k < r; k++) {
                    cnt += get(tot) - get(a[k][j]);
                    add(a[k][j], 1);
                }

                for (int k = i; k < r; k++) {
                    add(a[k][j], -1);
                }

                dp[i][j+1] = min(dp[i][j+1], dp[i][j] + cnt);
            }
        }

        for (int k = i; k < r; k++) {
            for (int l = 0; l < c - 1; l++)
                add(a[k][l], -1);
        }
    }

    cout << dp[r][c];
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}