#include<bits/stdc++.h>
using ll = long long;
using namespace std;
struct SegTree {
    vector<ll> t;
    ll sz;
    SegTree(ll n = 1) {
        sz = n;
        t.resize(sz+1);
    }
    ll _get(ll l) {
        ll ans = 0;
        for (; l>0; l-=l&(-l)) {
            //cout<<l<<endl;
            ans+=t[l];
        }
        return ans;
    }
    void _update(ll l, ll x) {
        for (; l<=sz; l+=l&(-l)) {
            //cout<<l<<endl;
            //cout<<t.size()<<endl;
            t[l]+=x;
        }
    }
    ll get(ll l, ll r) {
        if (l==r) {
            return 0;
        }
        return _get(r)-_get(l);
    }
    void update(ll l,ll val) {
        _update(l+1, val);
    }

};
void solve() {
    ll n, m;
    cin>>n>>m;
    vector<vector<ll>> v(n, vector<ll>(m));
    for (int i = 0; i<n; i++) {
        for (int j = 0; j<m; j++) {
            cin>>v[i][j];
            v[i][j]--;
        }
    }
    vector<vector<ll>> dp(n+1, vector<ll> (m+1, 0));
    SegTree sg = n*m, sg1 = n*m;
    for (int i = n-1; i>-1; i--) {
        sg = n*m;
        ll cur = 0;
        for (int j = m-1; j>-1; j--) {
            ll ans2 = 0;
            sg1.update(v[i][j], 1);
            cur+=sg.get(0, v[i][j]);

            for (int i1 = n-1; i1>=i; i1--) {
                cur+=sg1.get(v[i1][j]+1, n*m);
                sg.update(v[i1][j],1);
                ans2+=sg.get(0, v[i1][j]);
            }
            dp[i][j]=min(dp[i+1][j]+cur, dp[i][j+1]+ans2);
        }
        for (int j = m-1; j>-1; j--) {
            sg1.update(v[i][j], -1);
        }
    }
    // for (int i = 0; i<n; i++) {
    //     for (int j = 0; j<m; j++) {
    //         cout<<dp[i][j]<<" ";
    //     }
    //     cout<<"\n";
    // }
    cout<<dp[0][0]<<"\n";
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while (AnyaSamsonovaGoSex--)solve();
}