#include <bits/stdc++.h>

// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// #define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

#define ll long long
#define ull unsigned long long
#define vll vector<ll>
#define all(v) v.begin(), v.end()
#define fi(n) for (int i = 0; i < n; i++)
#define fj(n) for (int j = 0; j < n; j++)
#define debug(x) cout << #x << ": " << x << "\n"

using namespace std;

vector<bool> a;
int n;

void solve(int q) {
    vector<vector<vector<int>>> dp(2, vector<vector<int>>(3, vector<int>(n+1, -INT_MAX)));
    // dp[i][0/1/2][c] - максимальный ответ, который можно набрать на префиксе длины i, заканчивая паттерном и потратя с.
    // паттерны 0 - 0, 1 - 01, 2 - 11
    fi(n) {
        if (i == 0) {
            if (a[i]) dp[1][1][0] = 0;
            else {
                dp[1][0][0] = 0;
                dp[1][1][1] = 0;
            }
            swap(dp[0], dp[1]);
            continue;
        }
        if (a[i]) {
            for (int c = 0; c <= i+1; c++) {
                dp[1][2][c] = max(dp[0][2][c] + 1, dp[0][1][c] + 2);
                dp[1][1][c] = dp[0][0][c];
            }
        } else {
            dp[1][0][n] = max(dp[0][0][n], dp[0][1][n]);
            dp[1][0][n] = max(dp[0][2][n], dp[1][0][n]);
            for (int c = 0; c < i+1; c++) {
                dp[1][2][c+1] = max(dp[0][1][c] + 2, dp[0][2][c] + 1);
                dp[1][1][c+1] = dp[0][0][c];
                dp[1][0][c] = max(dp[0][0][c], dp[0][1][c]);
                dp[1][0][c] = max(dp[1][0][c], dp[0][2][c]);
            }
        }
        swap(dp[0], dp[1]);
        dp[1].assign(3, vector<int>(n+1, -INT_MAX));
    }
    fj(q) {
        int k; cin >> k;
        int mx = 0;
        fi(3) {
            mx = max(dp[0][i][k], mx);
        }
        cout << mx << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q; cin >> n >> q;
    a.assign(n, false);
    fi(n) {
        char c; cin >> c;
        a[i] = c - '0';
    }
    solve(q);
    return 0;
}