#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct r {
    int x, y;

    r(const int x = 0, const int y = 0) : x(x), y(y) {
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<r> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    vector<vector<int> > g(n);
    for (int v = 0; v < n; v++) {
        for (int u = v + 1; u < n; u++) {
            int dx = a[v].x - a[u].x, dy = a[v].y - a[u].y;
            if (1ll * dx * dx + 1ll * dy * dy <= 1ll * k * k) {
                g[v].emplace_back(u);
                g[u].emplace_back(v);
            }
        }
    }
    vector<vector<int> > color(n, vector<int>(2, -1));
    int cur = 0;
    for (int v = 0; v < n; v++) {
        if (color[v][0] == -1 && color[v][1] == -1) {
            vector<pair<int, int> > q;
            q.emplace_back(v, 0);
            color[v][0] = cur;
            while (!q.empty()) {
                auto [v, c] = q.back();
                q.pop_back();
                for (auto u: g[v]) {
                    if (color[u][c ^ 1] == -1) {
                        color[u][c ^ 1] = cur;
                        q.emplace_back(u, c ^ 1);
                    }
                }
            }
            cur++;
        }
        cout << (color[v][0] == color[v][1]);
    }
    return 0;
}
