#include <bits/stdc++.h>

using ll = long long;

const ll INF = 2e9;

using namespace std;

ll n;

bool check(ll x, ll mid, string s, vector<ll>& p) {
    for (int i = 0; i <= n - mid; i++) {
        ll k = p[i + mid - 1];
        if (i > 0) {
            k -= p[i - 1];
        }
        if (k >= mid - x) {
            return 1;
        }
    }
    return 0;
}

void solve() {
    ll q;
    cin >> n >> q;
    vector<ll> p(n);
    string s;
    cin >> s;
    p[0] = s[0] - '0';
    for (int i = 1; i < n; i++) {
        p[i] = p[i - 1] + s[i] - '0';
    }
    for (int i = 0; i < q; i++) {
        ll x;
        cin >> x;
        ll l = x, r = INF;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (check(x, mid, s, p)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (l < 2) {
            l = 0;
        }
        cout << l << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 0;

    #ifdef egg 
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}
