#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 3e5 + 2;
const int inf = 1e9 + 1;

int a[maxn], rt[maxn], suff[maxn];

int tree[maxn * 4];

void build(int v, int l, int r) {
    if (l == r) {
        tree[v] = r;
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    if (a[tree[2 * v]] <= a[tree[2 * v + 1]]) {
        tree[v] = tree[2 * v];
    } else {
        tree[v] = tree[2 * v + 1];
    }
}

int get(int v, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int mid = (l + r) / 2;
    int k1 = get(2 * v, l, mid, ql, qr);
    int k2 = get(2 * v + 1, mid + 1, r, ql, qr);
    if (a[k1] <= a[k2]) {
        return k1;
    } else {
        return k2;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q; cin >> n >> q;
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
    }
    vector<int> st = {0};
    a[0] = a[n + 1] = inf;
    for (int i = 1; i < n + 2; i++) {
        while (a[i] > a[st.back()]) {
            rt[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    a[n + 1] = -inf;
    for (int i = n; i >= 1; i--) {
        suff[i] = max(suff[i + 1], a[i]);
    }
    build(1, 1, n);
    while (q--) {
        int k, i; cin >> k >> i;
        int cur = 1;
        for (int j = 1; j < i; j++) {
            if (j + 1 == k) {
                cur = min(n, rt[cur]);
                break;
            }
            int p = min(n - k + j + 1, rt[cur]);
            cur = get(1, 1, n, cur + 1, p);
        }
        if (i == k) {
            cout << suff[cur] << "\n";
            continue;
        }
        cout << a[cur] << "\n";
    }
}

/*
7 4
6 4 2 3 1 7 5
7 4
1 1
4 2
5 3
*/

/*
3 1
2 3 1
2 2
*/
