#include<bits/stdc++.h>

using namespace std;

using ll = long long;
const ll INF = 1e18;

#define int ll

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int> > v(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> v[i][j];
        }
    }
    vector<vector<int> > delete_row(r, vector<int>(c));
    vector<vector<int> > delete_stolb(r, vector<int>(c));
    for (int i = 0; i + 1 < r; ++i) {
        for (int j = 0; j < c; ++j) {
            for (int k = j; k < c; ++k) {
                for (int I = i + 1; I < r; ++I) {
                    for (int J = j; J < c; ++J) {
                        if (v[i][k] > v[I][J]) {
                            delete_row[i][j]++;
                        }
                    }
                }
                for (int J = k + 1; J < c; ++J) {
                    if (v[i][k] > v[i][J]) {
                        delete_row[i][j]++;
                    }
                }
            }
        }
    }
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j + 1 < c; ++j) {
            for (int k = i; k < r; ++k) {
                for (int I = i; I < r; ++I) {
                    for (int J = j + 1; J < c; ++J) {
                        if (v[k][j] > v[I][J]) {
                            delete_stolb[i][j]++;
                        }
                    }
                }
                for (int I = i + 1; I < r; ++I) {
                    if (v[k][j] > v[I][j]) {
                        delete_stolb[i][j]++;
                    }
                }
            }
        }
    }
    vector<vector<int> > dp(r, vector<int>(c, INF));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            if (i == r - 1 && j == c - 1) dp[i][j] = 0;
            if (i + 1 < r) dp[i][j] = min(dp[i][j], dp[i + 1][j] + delete_row[i][j]);
            if (j + 1 < c) dp[i][j] = min(dp[i][j], dp[i][j + 1] + delete_stolb[i][j]);
        }
    }
    cout << dp[0][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
