#include<bits/stdc++.h>

using namespace std;

using ll = long long;
const ll INF = 1e18;
const int maxn = 3e5;
#define int ll

pair<int, int> st[4 * maxn];

void build(int v, int l, int r, vector<int> &a) {
    if (l + 1 == r) {
        st[v] = {a[l], l};
        return;
    }
    int m = (r + l) / 2;
    build(v * 2 + 1, l, m, a);
    build(v * 2 + 2, m, r, a);
    st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
}

pair<int,int> get(int v, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) return {INF, INF};
    if (lq <= l && r <= rq) return st[v];
    int m = (r + l) / 2;
    return min(get(v * 2 + 1, l, m, lq, rq), get(v * 2 + 2, m, r, lq, rq));
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i];
    vector<int> mx(n);
    for (int i = n - 1; i >= 0; --i) {
        mx[i] = v[i];
        if (i + 1 < n) mx[i] = max(mx[i], mx[i + 1]);
    }
    vector<int> next(n, n-1);
    vector<int> a;
    for (int i = n - 1; i >= 0; --i) {
        while (!a.empty() && v[a.back()] < v[i]) {
            a.pop_back();
        }
        if (!a.empty()) next[i] = a.back();
        a.push_back(i);
    }
    build(0, 0, n, v);
    map<int, vector<int> > mp;
    for (int i = 0; i < n; ++i) mp[i+1] = {};
    while (q--) {
        int I, K;
        cin >> K >> I;
        I--;
        if (mp[K].empty()) {
            int k = K;
            vector<int> b;
            int curr = 0;
            while (k > 2) {
                b.push_back(v[curr]);
                k--;
                curr = get(0, 0, n, curr + 1, min(next[curr],  n - k) + 1).second;
            }
            b.push_back(v[curr]);
            b.push_back(mx[next[curr]]);
            mp[K] = b;
        }
        cout << mp[K][I] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
