#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
using namespace std;
using ll = long long;

vector<int> llogg;
vector<vector<int>> bp;
vector<int> a;

int get_min(int l, int r) {
	int len = r - l + 1;
	int k = llogg[len];
	int i1 = bp[l][k], i2 = bp[r - (1 << k) + 1][k];

	int ans;
	if (a[i1] < a[i2]) {
		ans = i1;
	}
	else {
		ans = i2;
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	a.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	llogg.resize(n + 1, 0);
	for (int i = 2; i <= n; ++i) {
		llogg[i] = llogg[i / 2] + 1;
	}
	bp.resize(n, vector<int>(llogg[n] + 1));
	for (int i = 0; i < n; ++i) {
		bp[i][0] = i;
	}
	for (int k = 1; k <= llogg[n]; ++k) {
		for (int i = 0; i + (1 << (k - 1)) < n; ++i) {
			int l = bp[i][k - 1], r = bp[i + (1 << (k - 1))][k - 1];
			if (a[l] < a[r])
				bp[i][k] = l;
			else
				bp[i][k] = r;
		}
	}
	vector<int> suf(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		suf[i] = max(suf[i + 1], a[i]);
	}
	vector<int> more(n, n);
	vector<int> st;
	for (int i = 0; i < n; ++i) {
		while (!st.empty() && a[st.back()] < a[i]) {
			more[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	vector<pair<int, int>> ques(q);
	for (int j = 0; j < q; ++j) {
		int k, i;
		cin >> k >> i;
		i--;
		ques[j] = { k, i };
	}

	for (int j = 0; j < q; ++j) {
		int k = ques[j].first, i = ques[j].second;

		vector<int> ans;
		int curi = 0;
		bool f = false;

		for (int j = 1; j <= i + 1; ++j) {
			if (n - curi == k - (j - 1)) {
				cout << "   " << a[curi + i - (j - 1)] << "\n";
				f = true;
				break;
			}
			if (j != k) {
				ans.push_back(a[curi]);
				if (j != k - 1) {
					curi = get_min(curi + 1, min(more[curi], n - (k - j)));
				}
				else {
					if (more[curi] == n) curi = n - 1;
					else curi = more[curi];
				}
			}
			else {
				ans.push_back(suf[curi]);
			}
		}
		if (!f) cout << "    " << ans[i] << "\n";
	}

	return 0;
}