#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;
using ll = long long;

constexpr int maxn = 3e5 + 10;

int n, q;
int arr[maxn];

// void rec_sol(int pos, int bc, int k) {
//     if (pos == n) {
//         if (bc == k) {
//         }
//         return;
//     }
// }

void solve() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) cin >> arr[i];
    vector<int> sfm(n + 1);
    sfm[n] = 0;
    for (int i = n - 1; i >= 0; --i) sfm[i] = std::max(arr[i], sfm[i + 1]);
    vector<pair<int, int> > ish(n);
    for (int i = 1; i + 1 < n; ++i) {
        ish[i] = {arr[i], (arr[i] == sfm[i] ? arr[n - 1] : sfm[i])};
    }
    pair<int, int> bp(n + 1, n + 1);
    for (int i = 1; i + 1 < n; ++i) {
        if (arr[i - 1] > arr[0]) break;
        bp = std::min(bp, ish[i]);
    }
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        if (i == 1) cout << arr[0] << "\n";
        else if (i == 2) cout << bp.first << "\n";
        else cout << bp.second << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
