#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vii = vector<pair<int, int>>;
using pii = pair<long long, long long>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

ve<vi> g;

long long count_dist(pii &a, pii &b) {
        return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

ve<vi> used;

bool dfs(int v, int d, int c) {
        used[v][d & 1] = c;
        for (auto u : g[v]) {
                if (used[u][0] == c) {
                        if (d % 2 == 0) {
                                return true;
                        }
                        continue;
                }
                if (used[u][1] == c) {
                        if (d % 2 == 1) {
                                return true;
                        }
                        continue;
                }
                if (dfs(u, d + 1, c)) return true;
        }
        return false;
}

void solve() {
        int n; long long r; cin >> n >> r;
        ve<pii> pts(n);
        used.resize(n, vi(2));
        for (int i = 0; i < n; i++) {
                cin >> pts[i].first >> pts[i].second;
        }
        g.clear();
        g.resize(n);
        map<pair<int, int>, int> pts_on;
        for (int i = 0; i < n; i++) {
                pts_on[{pts[i].first, pts[i].second}] = i + 1;
        }
        for (int i = 0; i < n; i++) {
                for (int d1 = 0; d1 <= r; d1++) {
                        for (int  d2 = 0; d2 <= r; d2++) {
                                if (d1 + d2 == 0) continue;
                                if (d1 * d1 + d2 * d2 > r * r) break;
                                int p1 = pts_on[{pts[i].first - d1, pts[i].second - d2}];
                                int p2 = pts_on[{pts[i].first - d1, pts[i].second + d2}];
                                int p3 = pts_on[{pts[i].first + d1, pts[i].second - d2}];
                                int p4 = pts_on[{pts[i].first + d1, pts[i].second + d2}];
                                if (p1) g[i].push_back(p1 - 1);
                                if (p2) g[i].push_back(p2 - 1);
                                if (p3) g[i].push_back(p3 - 1);
                                if (p4) g[i].push_back(p4 - 1);
                        }
                }
        }
        int c = 1;
        for (int i = 0; i < n; i++) {
                (dfs(i, 0, c)) ? cout << 1 : cout << 0;
                c++;
        }
        cout << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test =========\n\n";
                #endif
        }

        return 0;
}