#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    auto cnt_less = [&](ll l1, ll r1, ll l2, ll r2, ll x) -> ll {
        ll ans = 0;
        for (ll i = l1; i < r1; ++i) {
            for (ll j = l2; j < r2; ++j) {
                ans += a[i][j] < x;
            }
        }
        return ans;
    };
    auto cnt_inv = [&](ll l1, ll r1, ll l2, ll r2) -> ll {
        ll ans = 0;
        vector<ll> vec;
        for (ll i = l1; i < r1; ++i) {
            for (ll j = l2; j < r2; ++j) {
                vec.pb(a[i][j]);
            }
        }
        for (ll i = 0; i < (ll)vec.size(); ++i) {
            for (ll j = i + 1; j < (ll)vec.size(); ++j) {
                ans += vec[j] < vec[i];
            }
        }
        return ans;
    };
    vector<vector<ll>> dp(n, vector<ll>(m));
    map<ll, vector<pair<ll, ll>>> mp;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            mp[-i - j].eb(i, j);
        }
    }
    for (pair<ll, vector<pair<ll, ll>>> p : mp) {
        for (pair<ll, ll> pp : p.second) {
            ll i = pp.first, j = pp.second;
            if (i == n - 1) {
                dp[i][j] = cnt_inv(i, i + 1, j, m);
            } else if (j == m - 1) {
                dp[i][j] = cnt_inv(i, n, j, j + 1);
            } else {
                ll val = cnt_inv(i, i + 1, j, m);
                for (ll k = j; k < m; ++k) {
                    val += cnt_less(i + 1, n, j, m, a[i][k]);
                }
                val += dp[i + 1][j];
                dp[i][j] = val;
                val = cnt_inv(i, n, j, j + 1);
                for (ll k = i; k < n; ++k) {
                    val += cnt_less(i, n, j + 1, m, a[k][j]);
                }
                val += dp[i][j + 1];
                dp[i][j] = min(dp[i][j], val);
            }
        }
    }
    ll ans = dp[0][0];
    cout << ans;
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}