#include <bits/stdc++.h>

using ll = long long;
using namespace std;
#define int long long
int sq(int a) {
    return a * a;
}
int dist(pair <int, int> &a, pair <int, int> &b) {
    return sq(a.first - b.first) + sq(a.second - b.second);
}
bool dfs(int num, vector <int> &vis, int col, vector <vector <int>> &gr) {
    vis[num] = col;
    for (int next : gr[num]) {
        if (vis[next] == - 1) {
            if (!dfs(next, vis, 1 - col, gr)) {
                return false;
            }
        } else if (vis[num] == vis[next]) {
            return false;
        }
    }
    return true;
}
void dfs1(int num, vector <int> &is, bool flag, vector <vector <int>> &gr, vector <int> &ans) {
    is[num] = 3;
    ans[num] = flag;
    for (int next : gr[num]) {
        if (is[next] != 3) {
            dfs1(next, is, flag, gr, ans);
        }
    }
}
void solve() {
    int n;
    cin >> n;
    int r;
    cin >> r;
    vector <pair <int, int>> val(n);
    for (int i = 0; i < n; ++i) {
        cin >> val[i].first >> val[i].second;
    }
    map <pair <int, int>, int> num;
    for (int i = 0; i < n; ++i) {
        num[val[i]] = i;
    }
    vector <vector <int>> gr(n);
    for (int i = 0; i < n; ++i) {
        for (int j = - r; j <= r; ++j) {
            for (int f = r; f <= r; ++f) {
                if ((j || f) && (j * j + f * f <= r * r)) {
                    if (num.count({val[i].first + j, val[i].second + f})) {
                        gr[i].push_back(num[{val[i].first + j, val[i].second + f}]);
                    }
                }
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        for (int next : gr[i]) {
//            cout << next << ' ';
//        }
//        cout << '\n';
//    }
    vector <int> is(n, - 1), comp;
    vector <int> ans(n);
    for (int i = 0; i < n; ++i) {
        if (is[i] == - 1) {
            bool flag = true;
            flag = dfs(i, is, 0, gr);
            dfs1(i, is, !flag, gr, ans);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    cout << '\n';
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
