#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define ff first
#define ss second

struct node {
    int mn;
    int pos;
};

struct sparce_table {
    int n;
    int LOG = 20;
    vector<vector<node>> st;
    node merge(node a, node b) {
        if (a.mn < b.mn) {
            return a;
        } return b;
    }
    sparce_table(int N, vector<int>&a) : n(N) {
        st.resize(LOG, vector<node>(n));
        for (int i = 0; i< n; ++i) st[0][i] = {a[i], i};

        for (int i = 1; i < LOG ; ++i) {
            for (int j = 0; j <= n - (1 << i); ++j) {
                st[i][j] = merge(st[i-1][j], st[i-1][j + (1 << (i-1))]);
            }
        }
    }
    int get_log(int p) {
        int l1 = 0, r1 = LOG, mid;
        while (r1 - l1 > 1) {
            mid = ((r1 + l1)>>1);
            if ((1 << mid) > p) r1 = mid;
            else l1 = mid;
        }
        return l1;
    }

    node get_ans(int l, int r) {
        int lg = get_log(r - l + 1);
        return merge(st[lg][l], st[lg][r - (1 << lg) + 1]);
    }
};

int n, Q;
vector<int> a, r, mx;
vector<pair<int, int>> queries;

void solve() {
    cin >> n >> Q;
    a.resize(n);
    r.resize(n, n-1);
    mx.resize(n);
    queries.resize(Q);
    vector<vector<int>> answers;
    vector<int> ks;
    int sz = 0;
    unordered_map<int, int> mp;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < Q; ++i) {
        int k, id; cin >> k >> id;
        queries[i] = {k, id};
        if (mp[k] == 0) {
            sz++;
            ks.push_back(k);
            answers.push_back({});
            mp[k] = sz;
        }
    }

    stack<int> sta;
    for (int i = n-1; i >= 0; --i) {
        while(!sta.empty() && a[sta.top()] <= a[i]) {
            sta.pop();
        }
        if (!sta.empty()) r[i] = sta.top();
        sta.push(i);
    }
    /*
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[j] > a[i]) {
                r[i] = j;
                break;
            }
        }
    }
    */

    mx[n-1] = a[n-1];
    for (int i = n-2; i >= 0; --i) {
        mx[i] = max(mx[i+1], a[i]);
    }

    sparce_table st(n, a);

    for (int j = 0; j < sz; ++j) {
        int q = ks[j];
        answers.resize(min(3, q));
        //cout << q << '\n';
        if (q == 1) {
            answers[j][0] = n;
            continue;
        }
        answers[j][0] = a[0];
        int cur = 0;
        int qq = 1;
        int rr = n - q;
        while (qq < min(q-1, 3)) {
            node nxt = st.get_ans(cur + 1, min(cur + rr + 1, r[cur]));
            //cout << cur + 1 << ' ' << cur + rr + 1 << ' ' << r[cur] << '\n';
            rr -= (nxt.pos - cur) - 1;
            answers[j][qq] = nxt.mn;
            cur = nxt.pos;
            //cout << nxt.mn << ' ';
            qq++;
        }
        //cout << '\n';
        if (q <= 3) {
            answers[j][q-1] = n;
            for (int i = cur + 1; i <= r[cur]; ++i) {
                answers[j][q-1] = min(answers[j][q-1], mx[i]);
            }
        }
    }

    for (int i = 0; i < Q; ++i) {
            auto [k, id] = queries[i];
        cout << answers[mp[k]-1][id-1] << '\n';
    }
}

int main()
{
/*
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
*/
    int ttt = 1;
    // cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
