#include<bits/stdc++.h>
#define int long long
#define db long double
using namespace std;

struct Point{
    int x, y, ind;

    int len2() {
        return x * x + y * y;
    }

    db len() {
        return sqrt(len2());
    }
};

Point operator+(const Point& a, const Point& b) {
    return {a.x + b.x, a.y + b.y};
}

Point operator-(const Point& a, const Point& b) {
    return {a.x - b.x, a.y - b.y};
}

bool cmp(const Point& a, const Point& b) {
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<Point> a;
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y, i});
    }
    sort(a.begin(), a.end(), cmp);
    for (int i = 0, j = 0; j < n; i = j + 1, j = i) {
        while (j + 1 < n && (a[j + 1] - a[j]).len2() <= r * r) {
            j++;
        }
        int flag = 0;
        for (int i2 = i; i2 <= j - 2; i2++) {
            if ((a[i2 + 2] - a[i2]).len2() <= r * r) {
                flag = 1;
                break;
            }
        }
        for (int i2 = i; i2 <= j; i2++) ans[a[i2].ind] = flag;
    }
    for (auto x: ans) cout << x;
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
