#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 5;

vector<pair<int, int>> v;

vector<int> g[MAXN];

bool used[MAXN];

bool ans[MAXN];

int sqr(int x)
{
    return x * x;
}

int dist(pair<int, int> a, pair<int, int> b)
{
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

bool h[MAXN];

bool ban = false;

vector<int> cmp;

void dfs(int x, bool deep)
{
    used[x] = 1;
    cmp.push_back(x);
    h[x] = deep;
    for (auto i : g[x])
    {
        if (!used[i])
        {
            dfs(i, deep ^ 1);
        }
        else
        {
            if (h[i] == deep)
            {
                ban = true;
            }
        }
    }
}

void solve()
{
    int n, r;
    cin >> n >> r;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        v.push_back({x, y});
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (dist(v[i], v[j]) <= r * r)
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            cmp.clear();
            ban = false;
            dfs(i, 0);
            if (ban)
            {
                for (auto i : cmp)
                {
                    ans[i] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        cout << ans[i];
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}