#include <iostream>
#include <vector>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

int main() {
	int n = 100, q = 0;
	cin >> n >> q;
	string s; cin >> s;
	if (count(all(s), '0') == n) {
		while (q--) {
			int x; cin >> x;
			cout << (x == 1 ? 0 : x) << '\n';
		}
		exit(0);
	}
	int cnt_bad = 0;
	int cnt3 = 0;
	int prev = -5;
	vector<bool> bad(n);
	for (int i = 0; i < n; i++) {
		if (s[i] == '1' && (i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
			cnt_bad++;
			bad[i] = true;
		}
	}
	for (int i = 0; i < n; i++) {
		if (s[i] == '0' && (i != 0 && bad[i - 1]) && (i != n - 1 && bad[i + 1])) {
			if (prev + 2 != i) {
				prev = i;
				cnt3++;
			}
		}
	}
	int cnt[4]{};
	cnt[3] = cnt3;
	cnt[2] = cnt_bad - 2 * cnt3;
	cnt[1] = count(all(s), '0') - cnt[2] - cnt[3];
	vector<int> ans(count(all(s), '0') + 1);
	ans[0] = count(all(s), '1') - cnt_bad;
	if (cnt[1] + cnt[2] + cnt[3] != count(all(s), '0')) {
		exit(0);
	}
	int j = 1;
	for (int i = 3; i >= 1; i--) {
		while (cnt[i]--) {
			ans[j] = ans[j - 1] + i;
			j++;
		}
	}
	while (q--) {
		int x; cin >> x;
		if (x >= ans.size()) {
			exit(0);
		}
		cout << ans[x] << '\n';
	}

	return 0;
}