#include <iostream>
#include <vector>
#include <random>
#include <array>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int n, q; cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<vector<int>> precalc(n + 1);
	for (int i = 1; i <= n; i++) {
		
	}

	auto calc_layer = [&](int i) {
		int ptr = 0;
		for (int j = 1; j < i; j++) {
			int mn_ind = ptr + 1;
			int cur = a[ptr++];
			for (; ptr <= n - (i - j) && cur > a[ptr]; ptr++) {
				if (a[ptr] < a[mn_ind]) {
					mn_ind = ptr;
				}
			}
			precalc[i].push_back(cur);
			ptr = mn_ind;
		}
		precalc[i].push_back(*max_element(a.begin() + ptr, a.end()));
	};
	while (q--) {
		int k, i; cin >> k >> i; i--;
		if (precalc[k].size() == 0) {
			calc_layer(k);
		}
		cout << precalc[k][i] << '\n';
	}

	return 0;
}