#include <iostream>
#include <vector>
using namespace std;


int n;
long long r;
vector<pair<int, int>> a;
vector<int> c, vis;

long long sqr(long long x) {
    return x * x;
}

bool dfs(int v, int clr) {
    c[v] = clr;
    bool res = false;
    vis.push_back(v);
    for (int u = 0; u < n; u ++) {
        if (sqr(a[v].first - a[u].first) + sqr(a[u].second - a[v].second) <= r) {
            if (c[u] == -1 and dfs(u, 1 - clr)) res = true;
            else if (u != v and c[u] == clr) res = true;
        }
    }
    return res;
}


int main() {
    cin >> n >> r;
    r *= r;
    a = vector<pair<int, int>>(n);
    for (auto& [x, y]: a) cin >> x >> y;
    string ans(n, '0');
    c = vector<int>(n, -1);
    for (int i = 0; i < n; i ++)
        if (c[i] == -1) {
            vis.clear();
            if (dfs(i, 0))
                for (auto v: vis) ans[v] = '1';
        }
    cout << ans << "\n";
}
