#include <iostream>
#include <vector>
using namespace std;


int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& i: a) for (auto& j: i) cin >> j;
    vector<vector<long long>> dp(n + 1, vector<long long>(m + 1, 0));
    vector<vector<long long>> h(n + 1, vector<long long>(m + 1, 0)), v(n + 1, vector<long long>(m + 1, 0));
    for (int i = n - 1; i >= 0; i --)
        for (int j = m - 1; j >= 0; j --) {
            h[i][j] = h[i][j + 1];
            v[i][j] = v[i + 1][j];
            for (int k = i; k < n; k ++)
                for (int l = j; l < m; l ++)
                    if (a[i][j] > a[k][l]) h[i][j] ++, v[i][j] ++;
            for (int k = j + 1; k < m; k ++)
                for (int l = i + 1; l < n; l ++)
                    if (a[i][k] > a[l][j]) h[i][j] ++;
                    else v[i][j] ++;
        }
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; i --)
        for (int j = m - 1; j >= 0; j --)
            dp[i][j] = min(h[i][j] + dp[i + 1][j], v[i][j] + dp[i][j + 1]);
    cout << dp[0][0] << "\n";
}
