#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,bmi")

// #define int long long
#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, r;
    cin >> n >> r;

    vector<int> a(n);

    map<int, int> match;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        int sht;
        cin >> sht;
        match[a[i]] = i;
    }

    sort(all(a));

    vector<int> good(n, 0);

    for (int i = 0; i < n - 2; i++) {
        if (a[i + 1] - a[i] <= r && a[i + 2] - a[i] <= r) {
            good[i] = 1;
        }
    }

    for (int i = 1; i < n; i++) {
        if (a[i] - a[i - 1] <= r) {
            good[i] |= good[i - 1];
        }
    }

    for (int i = n - 2; i >= 0; i--) {
        if (a[i + 1] - a[i] <= r) {
            good[i] |= good[i + 1];
        }
    }

    vector<int> ans(n);

    for (int i = 0; i < n; i++) {
        ans[match[a[i]]] = good[i];
    }

    for (auto it: ans) {
        cout << it;
    }
}
