#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

int gtperm(vector<int> &a) {
    int ans = 0;
    ordered_set st;
    for (int i = 0; i < a.size(); i++) {
        ans += st.size() - st.order_of_key(a[i]);
        st.insert(a[i]);
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int> > a(n, vector<int>(m, 0));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    vector<vector<int> > dp(n, vector<int>(m, 0));

    for (int i = n - 1; i >= 0; i--) {
        ordered_set wv, wh;
        for (int j = m - 1; j >= 0; j--) {
            if (j != m - 1) {
                for (int ki = i; ki < n; ki++) {
                    wv.insert(a[ki][j + 1]);
                }
            }
            if (i != n - 1) {
                for (int ki = i + 1; ki < n; ki++) {
                    wh.insert(a[ki][j]);
                }
            }
            // cerr << "done" << endl;
            vector<int> vert;
            for (int k = i; k < n; k++) {
                vert.push_back(a[k][j]);
            }
            vector<int> horiz;
            for (int k = j; k < m; k++) {
                horiz.push_back(a[i][k]);
            }
            if (i == n - 1) {
                dp[i][j] = gtperm(horiz);
                continue;
            }
            if (j == m - 1) {
                dp[i][j] = gtperm(vert);
                continue;
            }
            int ans_v = gtperm(vert) + dp[i][j + 1];
            for (auto it: vert) {
                ans_v += wv.order_of_key(it);
            }
            int ans_h = gtperm(horiz) + dp[i + 1][j];
            for (auto it: horiz) {
                ans_h += wh.order_of_key(it);
            }
            dp[i][j] = min(ans_v, ans_h);
        }
    }

    cout << dp[0][0] << endl;
}
