#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define f first
#define s second

using namespace std;

struct Point {
    int x, y;
};

int dist2(Point a, Point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<int> used;
vector<int> col;

vector<set<int>> g;
vector<bool> god;

bool dfs(int v) {
    used[v] = 1;
    bool ans = 0;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            col[u] = (col[v] + 1) % 2;
            ans = (ans | dfs(u));
            if (ans == true) return true;
        } else if (used[u] == 2) continue;
        else if (used[u] == 1) {
            if (col[u] == col[v]) return true;
            continue;
        }
    }
    used[v] = 2;
    return ans;
}

void dfs1(int v) {
    used[v] = 1;
    god[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) dfs1(u);
    }
}

void solve() {
    int n, r; cin >> n >> r;
    vector<Point> p(n);
    for (int i = 0; i < n; i++) { 
        cin >> p[i].x >> p[i].y;
    }
    god.assign(n, 0);
    g.resize(n);
    vector<int> fn;
    for (int i = 0; i < n; i++) {
        vector<int> fn;
        for (int j = 0; j < n; j++) {
                if (i == j) continue;
                Point np = p[j];
                if (dist2(np, p[i]) <= r * r) {
                    fn.pb(j);
                }
        }
        for (int j = 0; j < (int) fn.size(); j++) {
            if (god[i]) break;
            for (int k = j + 1; k < (int) fn.size(); k++) {
                if (fn[j] != fn[k] && dist2(p[fn[k]], p[fn[j]]) <= r * r) {
                    god[i] = 1;
                    break;
                }
            }
        }
        if (!god[i]) {
            for (auto j : fn) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }

    }
    col.assign(n, 0);
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) god[i] = dfs(i);
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i] && god[i]) dfs1(i);
    }
    for (auto i : god) cout << i;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; // cin >> t;
    while (t--) solve();
}