#include <iostream>
#include <vector>
#include <map>

using namespace std;

int mx[(1 << 20)], mn[(1 << 20)];
int a[300000], k, n, s = 0;
map <int, int> ans[300001];

void build(int v, int l, int r) {
    if (r - l == 1) {
        mx[v] = min(n - 1, l);
        mn[v] = min(n - 1, l);
        return;
    }
    build(v * 2, l, (l + r) / 2);
    build(v * 2 + 1, (l + r) / 2, r);
    if (a[mx[v * 2]] > a[mx[v * 2 + 1]]) {
        mx[v] = mx[v * 2];
    } else {
        mx[v] = mx[v * 2 + 1];
    }
    if (a[mn[v * 2]] < a[mn[v * 2 + 1]]) {
        mn[v] = mn[v * 2];
    } else {
        mn[v] = mn[v * 2 + 1];
    }
    //cout << v << "; " << mx[v] << endl;
}
int fnd_mx(int v, int x, int y, int l, int r) {
    if (x >= r || y <= l) return l;
    if (x >= l && y <= r) return mx[v];
    if (a[fnd_mx(v * 2, x, (x + y) / 2, l, r)] > a[fnd_mx(v * 2 + 1, (x + y) / 2, y, l, r)]) return fnd_mx(v * 2, x, (x + y) / 2, l, r);
    return fnd_mx(v * 2 + 1, (x + y) / 2, y, l, r);
}
int fnd_mn(int v, int x, int y, int l, int r) {
    //cout << x << " " << y << endl;
    if (x >= r || y <= l) return l;
    if (x >= l && y <= r) return mn[v];
    if (a[fnd_mn(v * 2, x, (x + y) / 2, l, r)] < a[fnd_mn(v * 2 + 1, (x + y) / 2, y, l, r)]) return fnd_mn(v * 2, x, (x + y) / 2, l, r);
    return fnd_mn(v * 2 + 1, (x + y) / 2, y, l, r);
}
//void go(int i, int m, int t) {
//    if (i + k - t > n) return;
//    if (t == k - 1) {
//        ans[t] = m;
//        for (int j = i + 1; j < n; ++j) {
//            ans[t] = max(ans[t], a[j]);
//        }
//        return;
//    }
//    if (ans[t] > m) {
//        ans[t] = m;
//        for (int j = t + 1; j < k; ++j) ans[j] = n;
//    }
//    if (ans[t] < m) return;
//    if (a[i + 1] < m) {
//        go(i + 1, m, t);
//      }
//    go(i + 1, a[i + 1], t + 1);
//}
void deal(int i, int j) {
    if (i == k - 1) {
        ans[k][i] = a[fnd_mx(1, 0, (1 << s), j, n)];
        return;
    }
    //cout << k << " " << i << " " << j << endl;
    ans[k][i] = a[j];
    int l = j, r = n - k + i + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        //cout << l << " " << r << "->";
        if (fnd_mx(1, 0, (1 << s), j, m) > a[j]) {
            r = m;
        } else {
            l = m;
        }
        //cout << l << " " << r << endl;
    }
    //if (j + 1 == r) {
    //    deal(i + 1, j + 1);
    //}
    //cout << fnd_mn(1, 0, (1 << s), j + 1, r + 1) << endl;
    deal(i + 1, fnd_mn(1, 0, (1 << s), j + 1, r + 1));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n;
    int q, j;
    cin >> q;
    for (int i = 0; i < n; ++i) cin >> a[i];
    while ((1 << s) < n) ++s;
    build(1, 0, (1 << s));
    for (int i = 0; i < q; ++i) {
        cin >> k >> j;
        if (ans[k][0] == 0) {
            deal(0, 0);
        }
        cout << ans[k][j - 1] << endl;
    }
    cout << endl;
}
