#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
using namespace std;
typedef long long ll;
ll dist(pair<int, int>& a, pair<int, int>& b) {
	ll d = (ll)(a.first - b.first) * (a.first - b.first);
	d += (ll)(a.second - b.second) * (a.second - b.second);
	return d;
}
vector<vector<int>>g;
vector<int>color; bool f = 0;
vector<int>d; int cnt = 0;
vector<pair<int, int>>okr;
vector<pair<int, int>>coor;
map<pair<int, int>, int>pole;
ll n, r;
void dfs(int v) {
	color[v] = cnt;
	for (auto para : okr) {
		ll x = coor[v].first + para.first;
		ll y = coor[v].second + para.second;
		pair<int, int>pr = { x, y };
		if (dist(pr, coor[v]) <= r * r && pr != coor[v]) {
			ll ind = pole[{x, y}];
			if (ind != 0) {
				ll u = ind-1;
				if (color[u] == -1) {
					d[u] = d[v] + 1;
					dfs(u);
				}
				else if ((d[v] - d[u]) % 2 == 0)
					f = 1;
			}
		}
	}
};
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> r;
	
	
	for (int i = 0; i < n; i++) {
		int x, y; cin >> x >> y;
		coor.push_back({ x, y });
		pole[{x, y}] = i+1;
	}
	g.resize(n);
	pair<int, int>C = { r, r };
	
	for (int i = 0; i <= 2 * r; i++) {
		for (int j = 0; j <= 2 * r; j++) {
			pair<int, int>pr = { i, j };
			if (dist(C, pr) <= r * r) {
				okr.push_back({i - r, j - r});
			}
		}
	}
	color = vector<int>(n, -1);
	d.assign(n, -1);
	vector<bool>res;
	for (int i = 0; i < n; i++) {
		if (color[i] == -1) {
			f = 0; d[i] = 0; dfs(i);
			res.push_back(f); cnt++;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << res[color[i]];
	}
}