#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
using namespace std;
typedef long long ll;
ll dist(pair<int, int>& a, pair<int, int>& b) {
	ll d = (ll)(a.first - b.first) * (a.first - b.first);
	d += (ll)(a.second - b.second) * (a.second - b.second);
	return d;
}
vector<vector<int>>g;
vector<int>color; bool f = 0;
vector<int>d; int cnt = 0;
void dfs(int v) {
	color[v] = cnt;
	for (auto u : g[v]) {
		if (color[u] == -1) {
			d[u] = d[v] + 1;
			dfs(u);
		}
		else if ((d[v] - d[u]) % 2 == 0)
			f = 1;
	}
};
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll n, r; cin >> n >> r;
	vector<pair<int, int>>coor;
	map<pair<int, int>, int>pole;
	for (int i = 0; i < n; i++) {
		int x, y; cin >> x >> y;
		coor.push_back({ x, y });
		pole[{x, y}] = i+1;
	}
	g.resize(n);
	for (int i = 0; i < n; i++) {
		for (int x = coor[i].first - r; x <= coor[i].first + r; x++) {
			for (int y = coor[i].second - r; y <= coor[i].second + r; y++) {
				pair<int, int>pr = { x, y };
				if (dist(pr, coor[i]) <= r * r && pr!=coor[i]) {
					ll ind = pole[{x, y}];
					if (ind != 0)
						g[i].push_back(ind - 1);
				}
			}
		}
	}
	color = vector<int>(n, -1);
	d.assign(n, -1);
	vector<bool>res;
	for (int i = 0; i < n; i++) {
		if (color[i] == -1) {
			f = 0; d[i] = 0; dfs(i);
			res.push_back(f); cnt++;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << res[color[i]];
	}
}