#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<long long, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> inv(r, vector<int> (c));
    for (int i = 0; i < r; ++i) {
        ordered_set k;
        int sz = 0;
        for (int j = c - 1; j >= 0; --j) {
            k.insert(a[i][j]);
            inv[i][j] = k.order_of_key(a[i][j]);
            if (j != c - 1) {
                inv[i][j] += inv[i][j + 1];
            }
        }
    }
    vector<vector<int>> inv1(r, vector<int> (c));
    for (int j = 0; j < c; ++j) {
        ordered_set k;
        int sz = 0;
        for (int i = r - 1; i >= 0; --i) {
            k.insert(a[i][j]);
            inv1[i][j] = k.order_of_key(a[i][j]);
            if (i != r - 1) {
                inv1[i][j] += inv1[i + 1][j];
            }
        }
    }
    ordered_set b;
    vector<vector<int>> col(r, vector<int> (c));
    for (int j = 0; j < c; ++j) {
        ordered_set d = b;
        for (int i = 0; i < r; ++i) {
            for (int h = j; h < c; ++h) {
                d.insert(a[i][h]);
                col[i][j] += (d.size() - 1 - d.order_of_key(a[i][h]));
                d.erase(a[i][h]);
            }
            for (int h = j; h < c; ++h) {
                d.insert(a[i][h]);
            }
        }
        for (int i = 0; i < r; ++i) {
            b.insert(a[i][j]);
        }
    }

    ordered_set b1;
    vector<vector<int>> col1(r, vector<int> (c));
    for (int i = 0; i < r; ++i) {
        ordered_set d = b1;
        for (int j = 0; j < c; ++j) {
            for (int h = i; h < r; ++h) {
                d.insert(a[h][j]);
                col1[i][j] += (d.size() - 1 - d.order_of_key(a[h][j]));
                d.erase(a[h][j]);
            }
            for (int h = i; h < r; ++h) {
                d.insert(a[h][j]);
            }
        }
        for (int j = 0; j < c; ++j) {
            b1.insert(a[i][j]);
        }
    }
    vector<vector<int>> dp(r + 1, vector<int> (c + 1, 1e9));
    dp[0][0] = 0;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + col1[i][j] + inv1[i][j]);
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + col[i][j] + inv[i][j]);
        }
    }
    int mn = 1e9;
    for (int i = 0; i <= r; ++i) {
        mn = min(mn, dp[i][c]);
    }
    for (int j = 0; j <= c; ++j) {
        mn = min(mn, dp[r][j]);
    }
    cout << mn;
}


/*
9 1
100101001
1*/
