#include <bits/stdc++.h>


using namespace std;


using ll = long long;


const ll inf = 1e18 + 7;


int F(int x) {
    return (x & (-x));
}


void upd(vector<int> &f, int pos, int x) {
    for (int i = pos; i < int(f.size()); i += F(i)) {
        f.at(i) += x;
    }
}


int getpref(const vector<int> &f, int pos) {
    int res = 0;
    for (int i = pos; i > 0; i -= F(i)) {
        res += f.at(i);
    }
    return res;
}


ll funcRow(int r, int c, const vector<vector<int>> &a) {
    vector<int> f(int(a.size()) * int(a.at(0).size()) + 1, 0);
    for (int i = 0; i < int(a.size()); i++) {
        for (int j = 0; j < int(a.at(i).size()) && (i < r || j < c); j++) {
            upd(f, a.at(i).at(j), 1);
        }
    }
    ll ans = 0;
    for (int i = c; i < int(a.at(r).size()); i++) {
        ll all = a.at(r).at(i) - 1;
        ll have = ll(getpref(f, a.at(r).at(i) - 1));
        ans += (all - have);
        upd(f, a.at(r).at(i), 1);
    }
    return ans;
}


ll funcCol(int r, int c, const vector<vector<int>> &a) {
    vector<int> f(int(a.size()) * int(a.at(0).size()) + 1, 0);
    for (int i = 0; i < int(a.size()); i++) {
        for (int j = 0; j < int(a.at(i).size()) && (i < r || j < c); j++) {
            upd(f, a.at(i).at(j), 1);
        }
    }
    ll ans = 0;
    for (int i = r; i < int(a.size()); i++) {
        ll all = a.at(i).at(c) - 1;
        ll have = ll(getpref(f, a.at(i).at(c) - 1));
        ans += (all - have);
        upd(f, a.at(i).at(c), 1);
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a.at(i).at(j);
        }
    }
    vector<vector<ll>> dp(r, vector<ll>(c, 0));
    for (int i = 1; i < r; i++) {
        dp.at(i).at(0) = dp.at(i - 1).at(0) + funcRow(i - 1, 0, a);
    }
    for (int j = 1; j < c; j++) {
        dp.at(0).at(j) = dp.at(0).at(j - 1) + funcCol(0, j - 1, a);
    }
    for (int i = 1; i < r; i++) {
        for (int j = 1; j < c; j++) {
            dp.at(i).at(j) = min(dp.at(i - 1).at(j) + funcRow(i - 1, j, a), dp.at(i).at(j - 1) + funcCol(i, j - 1, a));
        }
    }
    ll ans = inf;
    for (int i = 0; i < r; i++) {
        ans = min(ans, dp.at(i).at(c - 1) + funcCol(i, c - 1, a));
    }
    for (int j = 0; j < c; j++) {
        ans = min(ans, dp.at(r - 1).at(j) + funcRow(r - 1, j, a));
    }
    cout << ans;
    return 0;
}
