#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pp = pair<ll, ll>;

map<pp, ll> polls;
vector<pp> polls_l;
vector<ll> col;
ll n;
ll R;

bool is_bp = true;

void rec(ll v, ll cl, vector<ll> &lst) {
    col[v] = cl;
    lst.push_back(v);
    ll x = polls_l[v].first, y = polls_l[v].second;
    for (ll x_ = x - R; x_ <= x + R; x_++) {
        for (ll y_ = y - R; y_ <= y + R; y_++) {
            if ((x - x_) * (x - x_) + (y - y_) * (y - y_) <= R * R && polls.find(make_pair(x_, y_)) != polls.end()) {
                ll j = polls[make_pair(x_, y_)];
                if (j == v) {
                    continue;
                }
                if (col[j] == -1) {
                    rec(j, 1 - cl, lst);
                } else if (col[j] != 1 - col[v]) {
                    is_bp = false;
                }
            }
        }
    }
}

void solve() {
    cin >> n >> R;
    col.assign(n, -1);
    polls_l.assign(n, {-1, -1});
    for (ll i = 0; i < n; i++) {
        pp curr;
        cin >> curr.first >> curr.second;
        polls[curr] = i;
        polls_l[i] = curr;
    }
    vector<bool> ans(n);
    for (ll i = 0; i < n; i++) {
        if (col[i] == -1) {
            vector<ll> lst;
            is_bp = true;
            rec(i, 0, lst);
            if (!is_bp) {
                for (ll el: lst) {
                    ans[el] = true;
                }
            }
        }
    }
    for (ll el: ans) {
        cout << el;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
