#include <bits/stdc++.h>
using namespace std;

using pp = pair<int, int>;
using ll = long long; //use it!

const int inf = 1e9;
const int maxval = 250'011;
int tree[maxval];
int tot = 0;


void add(int pos) {
    tot++;
    for (; pos < maxval; pos = (pos | (pos + 1))) {
        tree[pos]++;
    }
}

void del(int pos) {
    tot--;
    for (; pos < maxval; pos = (pos | (pos + 1))) {
        tree[pos]--;
    }
}

int get_pref(int x) {
    int ans = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) {
        ans += tree[x];
    }
    return ans;
}

int get_bigger(int x) {
    return tot - get_pref(x);
}


void solve() {
    int r, c;
    cin >> r >> c;
    vector<int> arr(c);
    for (int &el: arr) {
        cin >> el;
    }
    ll ans = 0;
    for (int el: arr) {
        ans += get_bigger(el);
        add(el);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
