#include <bits/stdc++.h>
using namespace std;

using pp = pair<int, int>;
using ll = long long;

const int inf = 1e9;

const int maxn = 3011, maxlog = 20;
int sparse[maxlog][maxn];

int get(int l, int r) {
    if (l > r) {
        return -1;
    }
    int lg = r - l + 1;
    return max(sparse[__lg(lg)][l], sparse[__lg(lg)][r - (1 << __lg(lg)) + 1]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> arr(n), pos(n + 1);
    for (int &el: arr) {
        cin >> el;
    }
    for (int i = 0; i < n; i++) {
        sparse[0][i] = arr[i];
    }
    for (int bt = 1; bt < maxlog; bt++) {
        for (int i = 0; i + (1 << bt) - 1 < n; i++) {
            sparse[bt][i] = max(sparse[bt - 1][i], sparse[bt - 1][i + (1 << (bt - 1))]);
        }
    }
    for (int i = 0; i < n; i++) {
        pos[arr[i]] = i;
    }
    vector<vector<int> > ans(n + 1);
    for (int k = 1; k <= n; k++) {
        if (k == 1) {
            ans[k].push_back(get(0, n - 1));
            continue;
        }
        ans[k].push_back(arr[0]);
        for (int i = 0; i < k - 1; i++) {
            for (int j = 1; j <= n; j++) {
                if (i == k - 2) {
                    if (get(pos[j], n - 1) != j) {
                        continue;
                    }
                }
                if (pos[j] + (k - 2 - i) < n && pos[ans[k].back()] < pos[j] && get(
                        pos[ans[k].back()] + 1, pos[j] - 1) < max(ans[k].back(), j)) {
                    ans[k].push_back(j);
                    break;
                }
            }
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k][i - 1] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
