#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ll int64_t

#define pb push_back
#define all(a) a.begin(), a.end()
#define F first
#define S second

int const maxn = 3e5;
int const inf = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i: a) cin >> i;

    vector<int> pr(n + 1), sf(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = max(pr[i], a[i]);
        sf[n - i - 1] = max(sf[n - i], a[n - i - 1]);
    }

    pair<int, int> ans = {inf, inf};
    for (int i = 0; i + 1 < n; i++) {
        ans = min(ans, {pr[i + 1], sf[i + 1]});
    }

    while (m--) {
        int k, x;
        cin >> k >> x;
        if (x == 1) {
            cout << ans.F << '\n';
        } else {
            cout << ans.S << '\n';
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
    return 0;
}
