#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <vector>
#include <fstream>
#include <string>
#include <cmath>
#include <climits>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

inline void solve() {
	int n, q;
	cin >> n >> q;
	string s;
	cin >> s;
	vector<bool> a(n);
	for (int i = 0; i < n; i++)
		a[i] = s[i] == '1';
	vector<int> ans(n + 1);
	for (int mask = 0; mask < (1 << n); mask++) {
		int bits = 0;
		for (int i = 0; i < n; i++)
			if ((mask >> i) & 1)
				bits++;
		vector<bool> b = a;
		for (int i = 0; i < n; i++)
			if ((mask >> i) & 1)
				b[i] = 1;
		int cur = 0;
		for (int i = 0; i < n; i++) {
			if (b[i]) {
				bool good = false;
				if (i && b[i - 1])
					good = true;
				if (i < n - 1 && b[i + 1])
					good = true;
				if (good)
					cur++;
			}
			ans[bits] = max(ans[bits], cur);
		}
	}
	while (q--) {
		int k;
		cin >> k;
		cout << ans[k] << '\n';
	}
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << '\n';
#endif
		solve();
	}
	return 0;
}