#include <iostream>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
long long n, r;
vector <long long> x, y;
vector <int> g[100001];
vector <int> color, order, answer;
int ok = 1;
void dfs(int v, int col) {
	color[v] = col;
	order.push_back(v);
	for (auto elem : g[v]) {
		if (color[elem] == 0) {
			dfs(elem, 3 - col);
		}
		else if (color[v] == color[elem]) {
			ok = 0;
		}
	}
}
int main() {
	cin >> n >> r;
	x.resize(n); y.resize(n);
	for (int i = 0; i < n; i++) { cin >> x[i] >> y[i]; }
	//
	vector <pair <long long, long long>> pars;
	for (int i = 0; i < n; i++) {
		pars.push_back(make_pair(x[i], i));
	}
	sort(pars.begin(), pars.end());
	for (int i = 0; i < n; i++) {
		for (int dx = -2; dx <= 2; dx++) {
			if (dx == 0 || i + dx >= n || i + dx < 0) {
				continue;
			}
			if (abs(pars[i].first - pars[i + dx].first)<= r){
				int ind1 = pars[i].second, ind2 = pars[i + dx].second;
				g[ind1].push_back(ind2);
				g[ind2].push_back(ind1);
			}
		}
	}

	//
	color.resize(n); order.resize(n); answer.resize(n);
	for (int i = 0; i < n; i++) {
		if (color[i] == 0) {
			ok = 1; order.clear();
			dfs(i, 1);
			for (auto elem : order) { answer[elem] = 1 - ok; }
		}
	}
	for (int i = 0; i < n; i++) {
		cout << answer[i];
	}
	return 0;
}