#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    map<int, vector<int>> mem;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int j= 0; j < q; j++) {
        int k, ix;
        cin >> k >> ix;
        ix--;
        if (mem.find(k) != mem.end()) {
            cout << mem[k][ix] << '\n';
            continue;
        }
        int ans = 0, cur = 0;
        vector<int> b;
        for (int i = 0; i < k; i++) {
            b.push_back(a[cur]);
            int best = cur+1;
            for (int j = cur+1; n-j >= k-i-1; j++) {
                if (a[best] > a[j] || i == k-2) {
                    best = j;
                }
                if (a[j] > b[i]) {
                    break;
                }
            }
            if (i == k-1) {
                for (int j = cur+1; j < n; j++) {
                    b[i] = max(b[i], a[j]);
                }
            }
            if (i == ix) {
                cout << b[i] << '\n';
            }
            cur = best;
        }
        mem[k] = b;
    }
    return 0;
}