#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

vector<vector<int>> g;
vector<int> used;
int color = 0;

void dfs(int v) {
    used[v] = color;
    for (auto to : g[v]) if (used[to] == -1) {
        dfs(to);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, r;
    cin >> n >> r;
    g.resize(n + n);
    vector<pii> pts(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].first >> pts[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ll dx = (pts[i].first - pts[j].first);
            ll dy = (pts[i].second - pts[j].second);
            if (dx * dx + dy * dy <= 1ll * r * r) {
                g[i].push_back(n + j);
                g[j].push_back(n + i);
                g[n + i].push_back(j);
                g[n + j].push_back(i);
            }
        }
    }
    used.resize(n + n, -1);
    for (int i = 0; i < n; ++i) if (used[i] == -1) {
        dfs(i);
        ++color;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == used[i + n]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

