#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

int main() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        order[a[i]] = i;
    }
    vector<vector<int>> st(__lg(n) + 1, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        st[0][i] = i;
    }
    auto cmp = [&a](int i, int j) {
        return a[i] > a[j];
    };
    for (int i = 1; i <= __lg(n); ++i) {
        for (int v = 0; v + (1 << i) <= n; ++v) {
            int j1 = st[i - 1][v];
            int j2 = st[i - 1][v + (1 << (i - 1))];
            if (cmp(j1, j2)) {
                st[i][v] = j1;
            } else {
                st[i][v] = j2;
            }
        }
    }
    auto query = [&st, &a](int l, int r) {
        int x = __lg(r - l);
        int j1 = st[x][l];
        int j2 = st[x][r - (1 << x)];
        if (a[j1] > a[j2])
            return j1;
        return j2;
    };
    vector<vector<int>> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i].assign(i + 1, n);
    }
    for (int mask = 0; mask < (1 << n); ++mask) if (mask & 1) {
        vector<int> res;
        int last = 0;
        for (int i = 1; i < n; ++i) {
            if ((mask >> i) & 1) {
                res.push_back(a[query(last, i)]);
                last = i;
            }
        }
        res.push_back(a[query(last, n)]);
        ans[res.size() - 1] = min(ans[res.size() - 1], res);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k - 1][i - 1] + 1 << "\n";
    }
}
