#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
#include <algorithm>
#pragma GCC target("avx2")

using namespace std;
#define int long long
#define all(v) (v).begin(),(v).end()
#define pb(v) push_back((v))
#define f first
#define s second
const int INF = 1e11;
int r;
struct p {
    int x, y, nx, ny;
    bool ti(p p2) {
        int len = (x - p2.x) * (x - p2.x) + ((y - p2.y) * (y - p2.y));
        if (len <= r * r) {
            return true;
        }
        return false;
    }
};
vector<vector<int>> g;
vector<int> us, d, cic;
vector<int> xval;
vector<p> ps;
unordered_map<int, vector<pair<int,int>>> yval;
int t = 0;
int dfs1(int v, int td) {
    us[v] = 1;
    d[v] = td % 2;
    int xst = lower_bound(all(xval), ps[v].x - r) - xval.begin();
    while (xst < xval.size() && xval[xst] <= ps[v].x + r) {
        int yst = lower_bound(all(yval[xval[xst]]), make_pair(ps[v].y - r, 0ll)) - yval[xval[xst]].begin();
        while (yst != yval[xval[xst]].size() && yval[xval[xst]][yst].f <= ps[v].y + r) {
            int i = yval[xval[xst]][yst].s;
            if (ps[v].ti(ps[i]) == 0 || i == v) {
                yst++;
                continue;
            }
            if (us[i]) {
                if (d[i] == d[v]) {
                    // cout << v << " " << i << "\n";
                    cic[v] = 1;
                    return 1;
                }
            } else {
                int ge = dfs1(i, td + 1);
                // cout << v << " " << i << " " << ge << "\n";
                if (ge) {
                    cic[v] = 1;
                    return 1;
                }
            }
            yst++;
        }
        xst++;
    }
    return 0;
}
int dfs2(int v) {
    us[v] = 1;
    cic[v] = 1;
    int xst = lower_bound(all(xval), ps[v].x - r) - xval.begin();
    while (xst < xval.size() && xval[xst] <= ps[v].x + r) {
        auto yst = lower_bound(all(yval[xval[xst]]), make_pair(ps[v].y - r, 0ll)) - yval[xval[xst]].begin();
        while (yst != yval[xval[xst]].size() && yval[xval[xst]][yst].f <= ps[v].y + r) {
            int i = yval[xval[xst]][yst].s;
            if (!ps[v].ti(ps[i])) {
                yst++;
                continue;
            }
            if (!us[i]) {
                dfs2(i);
            }
            yst++;
        }
        xst++;
    }

    return 0;
}
int solve() {
    int n;
    cin >> n >> r;
    g.resize(n); us.resize(n); cic.resize(n); d.resize(n); ps.resize(n);
    vector<int> xval0;
    int f5 = 1;
    for (int i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
        if (ps[i].y != 0) {
            f5 = 0;
        }
        xval0.pb(ps[i].x);
        yval[ps[i].x].pb(make_pair(ps[i].y, i));
    }
    if (f5 == 1) {
        vector<pair<int,int>>xval2;
        for (int i = 0; i < n; i++) {
            xval2.pb(make_pair(ps[i].x, i));
        }
        sort(all(xval2));
        for (int i = 0; i < n - 2; i++) {
            if (xval2[i + 2].f - xval2[i].f <= r) {
                cic[xval2[i + 2].s] = 1; cic[xval2[i + 1].s] = 1; cic[xval2[i].s] = 1;
                for (int j = i - 1; j >= 0; j--) {
                    if (xval2[j + 1].f - xval2[j].f >= r || cic[xval2[j].s] == 1) {
                        break;
                    }
                    cic[xval2[j].s] = 1;
                }
                for (int j = i + 3; j < n; j++) {
                    if (xval2[j].f - xval2[j - 1].f >= r || cic[xval2[j].s] == 1) {
                        break;
                    }
                    cic[xval2[j].s] = 1;
                    i = j;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            cout << cic[i];
        }
        return 0;
    }
    sort(all(xval0));
    for (int i = 0; i < xval0.size(); i++) {
        if (i == 0 || xval0[i] != xval0[i - 1]) {
            xval.pb(xval0[i]);
        }
    }
    for (int i : xval) {
        vector<pair<int, int>> nv;
        sort(all(yval[i]));
        for (int j = 0; j < yval[i].size(); j++) {
            if (j == 0 || yval[i][j] != yval[i][j - 1]) {
                nv.pb(yval[i][j]);
            }
        }
        yval[i] = nv;
    }
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            dfs1(i, 0);
        }
    }
    us.clear(); us.resize(n);
    for (int i = 0; i < n; i++) {
        if (!us[i] & cic[i]) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << cic[i];
    }
    return 0;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    int t = 1;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}