#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<ll> v, par, r;

ll get(ll a) {
    if (par[a] != a) par[a] = get(par[a]);
    return par[a];
}

ll vall(ll a) {
    a = get(a);
    if (v[a] > 1) return v[a];
    return 0;
}

void unite(ll a, ll b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    if (r[a] > r[b]) swap(a, b);
    if (r[a] == r[b]) ++r[b];
    v[b] += v[a];
    par[a] = b;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<bool> alone(n);
    for (ll i = 0; i < n; ++i) {
        if (s[i] == '1' && (i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) alone[i] = true;
    }
    vector<ll> fp, sp, tp;
    for (ll i = 0; i < n; ++i) {
        if (s[i] == '1') continue;
        if (i > 0 && alone[i - 1] && i < n - 1 && alone[i + 1]) fp.push_back(i);
        else if (i > 0 && alone[i - 1] || i < n - 1 && alone[i + 1]) sp.push_back(i);
        else tp.push_back(i);
    }
    vector<ll> dp(fp.size() + sp.size() + tp.size() + 1);
    ll ss = 0;
    for (ll i = 0; i < n; ++i) {
        if (!alone[i]) ss += s[i] - '0';
    }
    dp[0] = ss;
    ll i = 1;
    while (i < dp.size()) {
        if (!fp.empty()) {
            ll x = fp.back();
            fp.pop_back();
            if (!alone[x - 1] || !alone[x + 1]) {
                sp.push_back(x);
                continue;
            }
            ss += 3;
            alone[x - 1] = false;
            alone[x + 1] = false;
        } else if (!sp.empty()) {
            ll x = sp.back();
            sp.pop_back();
            if (!alone[x - 1] && !alone[x + 1]) {
                tp.push_back(x);
                continue;
            }
            ss += 2;
            alone[x - 1] = false;
            alone[x + 1] = false;
        } else {
            ss += 1;
        }
        dp[i] = ss;
        ++i;
    }
    for (ll i = 0; i < q; ++i) {
        ll b;
        cin >> b;
        cout << dp[b] << '\n';
    }
}