#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<pair<ll, ll> > v;
unordered_map<ll, unordered_map<ll, vector<ll> > > m;
ll r;
vector<int> us;
vector<bool> ans;

ll dist(ll a, ll b) {
    return (v[a].first - v[b].first) * (v[a].first - v[b].first) + (v[a].second - v[b].second) * (
               v[a].second - v[b].second);
}

bool dfs(ll a, int c) {
    us[a] = c;
    ll xx = v[a].first / r;
    ll yy = v[a].second / r;
    vector<ll> sos;
    for (ll x = xx - 1; x <= xx + 1; ++x)
        for (ll y = yy - 1; y <= yy + 1; ++y)
            for (ll i: m[x][y]) {
                if (i == a) continue;
                ll d = dist(a, i);
                if (d > r) continue;
                sos.push_back(i);
            }
    if (sos.size() > 6) return true;
    for (ll i : sos) {
        if (!us[i]) {
            if (dfs(i, (c % 2) + 1)) return true;
        } else if (us[i] == us[a]) return true;
    }
    return false;
}

void dfs2(ll a) {
    ans[a] = true;
    ll xx = v[a].first / r;
    ll yy = v[a].second / r;
    for (ll x = xx - 1; x <= xx + 1; ++x)
        for (ll y = yy - 1; y <= yy + 1; ++y)
            for (ll i: m[x][y]) {
                ll d = dist(a, i);
                if (d > r) continue;
                if (!ans[i]) dfs2(i);
            }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n >> r;
    r *= r;
    v.resize(n);
    for (auto &i: v) cin >> i.first >> i.second;
    for (ll i = 0; i < n; ++i) {
        m[v[i].first / r][v[i].second / r].push_back(i);
    }
    us.resize(n);
    ans.resize(n);
    for (ll i = 0; i < n; ++i) {
        if (!us[i]) {
            if (dfs(i, 1)) dfs2(i);
        }
    }
    for (bool i: ans) cout << i;
}