// Author: Boris_Ber
// #pragma GCC target("avx2")

#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

// #define int long long
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int tmp;

map<int, set<pii> > d;
int n, r;
vector<pii> a;

ld dist(const pii &a, const pii &b) {
    const ll x = a.ff - b.ff, y = a.ss - b.ss;
    return sqrtl(x * x + y * y);
}

vector<int> c;
int fnd;

void dfs(int v, int col) {
    vector<int> nxt;
    for (auto it = d.lower_bound(a[v].ff - r); it != d.end(); ++it) {
        if (it->ff > a[v].ff + r) break;
        for (auto it2 = (it->ss).lower_bound({a[v].ss - r, 0}); it2 != (it->ss).end(); ++it2) {
            if (it2->ff > a[v].ss + r) break;
            if (v != it2->ss && dist(a[v], {it->ff, it2->ff}) <= r) {
                int u = it2->ss;
                if (c[u] == -1) {
                    c[u] = col;
                    nxt.pb(u);
                    if (sz(nxt) >= 6) {
                        fnd = v;
                        return;
                    }
                } else if (c[u] != col) {
                    fnd = u;
                    return;
                }
            }
        }
    }
    for (int u: nxt) {
        dfs(u, 1 - col);
        if (fnd != -1) return;
    }
}

vector<bool> used;

void mark(int v, bool st) {
    used[v] = true;
    for (auto it = d.lower_bound(a[v].ff - r); it != d.end(); ++it) {
        if (it->ff > a[v].ff + r) break;
        vector<pii> er;
        for (auto it2 = (it->ss).lower_bound({a[v].ss - r, 0}); it2 != (it->ss).end(); ++it2) {
            if (it2->ff > a[v].ss + r) break;
            if (v != it2->ss && dist(a[v], {it->ff, it2->ff}) <= r) {
                if (st) er.pb(*it2);
                int u = it2->ss;
                if (!used[u])
                    mark(u, false);
            }
        }
        if (st) for (auto e: er) it->ss.erase(e);
    }
}

void solve() {
    cin >> n >> r;
    a.assign(n, {});
    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].ff >> a[i].ss;
        d[a[i].ff].emplace(a[i].ss, i);
    }
    if (r == 1) {
        for (int i = 0; i < n; ++i) {
            cout << '0';
        }
        return;
    }
    c.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        if (c[i] == -1 && !used[i]) {
            fnd = -1;
            if (c[i] == -1)
                c[i] = 0;
            dfs(i, 1 - c[i]);
            if (fnd != -1) {
                mark(i, true);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << (used[i] ? '1' : '0');
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
