// Author: Boris_Ber
// #pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

using namespace std;

#define int long long
typedef pair<int,int> pii;
typedef long long ll;
typedef long double ld;

int tmp;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    vector<int> pref(n), suf(n);
    pref[0] = a[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = max(pref[i - 1], a[i]);
    }
    suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    set<pii> best;
    for (int i = 0; i < n - 1; ++i) {
        best.emplace(pref[i], suf[i + 1]);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        if (i == 0) {
            cout << best.begin()->ff;
        } else {
            cout << best.begin()->ss;
        }
        cout << '\n';
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
