#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, q; cin >> n >> q;

    vector<int> lst(n);
    for (int i = 0; i < n; i++) {
        char c; cin >> c;
        lst[i] = c - '0';
    }

    debug(lst);

    int a = 0, b = 0, c = 0;

    int i = 0;
    while (i < n) {
        if (i < n - 2 && lst[i] == 1 && lst[i + 1] == 0 && lst[i + 2] == 1 && (i == 0 || lst[i - 1] == 0) && (i + 3 == n || lst[i + 3] == 0)) {
            // cout << "1 0 1 | " << i << endl;
            a++;
            i += 3;
        } else if (lst[i] == 1 && (i + 1 == n || lst[i + 1] == 0) && (i == 0 || lst[i - 1] == 0)) {
            // cout << "0 1 0 | " << i << endl;
            b++;
            i += 1;
        } else {
            i++;
        }
    }

    for (int i = 0; i < n; i++) {
        if (lst[i] == 0) continue;
        if ((i && lst[i - 1] == 1) || (i < n - 1 && lst[i + 1] == 1)) {
            c++;
        }
    }

    // cout << a << " " << b << " " << c << endl;

    while (q--) {
        int k; cin >> k;

        if (k <= a) {
            cout << c + 3 * k << endl;
        } else if (k <= a + b) {
            cout << c + 3 * a + 2 * (k - a) << endl;
        } else if (a + b + c == 0 && k == 1) {
            cout << 0 << endl;
        } else {
            cout << c + 3 * a + 2 * b + (k - a - b) << endl;
        }
    }
}
