#include <bits/stdc++.h>
  
#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif
  
using namespace std;
using ll = long long;
 
const int INF = 1e9 + 7, MAXK = 20 + 1;
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}
 
int n, q;
vector<int> lst, rght, stk;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> q;

    lst.resize(n);
    rght.assign(n, n);

    for (int i = 0; i < n; i++) cin >> lst[i];

    vector<vector<int>> dp(MAXK, vector<int>(MAXK));

    for (int i = n - 1; i >= 0; i--) {
        while (!stk.empty() && lst[stk.back()] <= lst[i]) stk.pop_back();
        if (!stk.empty()) rght[i] = stk.back();
        stk.emplace_back(i);
    }

    for (int mask = 0; mask < (1 << (n - 1)); mask++) {
        int k = 1 + __builtin_popcount(mask);
        vector<pair<int, int>> seg;
        int prev = 0;
        for (int i = 1; i < n; i++) {
            if ((mask >> (i - 1)) & 1) {
                seg.emplace_back(prev, i - 1);
                prev = i;
            }
        }
        seg.emplace_back(prev, n - 1);

        vector<int> mns;
        for (auto &[l, r] : seg) {
            int mn = INF;
            for (int j = l; j <= r; j++) {
                mn = min(mn, lst[j]);
            }
            mns.emplace_back(mn);
        }

        if (mns < dp[k]) {
            dp[k] = mns;
        }
    }

    while (q--) {
        int k, i; cin >> k >> i;
        cout << dp[k][i] << endl;
    }
}