#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define int ll
#define endl "\n"
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct quest {
    int i, k, ind;
};

const int MAX_N = (1<<19);

pii T[MAX_N * 2];

void build(vector<int> &a) {
    for (int i = 0; i < a.size(); ++i) {
        T[i + MAX_N] = mp(a[i], i);
    }
    for (int i = a.size(); i < MAX_N; ++i) {
        T[i + MAX_N] = mp(1e9, -1);
    }
    for (int i = MAX_N - 1; i > 0; --i) {
        T[i] = min(T[i * 2], T[i * 2 + 1]);
    }
}

pii get(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return mp(1e9, -1);
    }
    if (ql <= l && r <= qr) {
        return T[i];
    } else {
        int m = (l + r) / 2;
        return min(get(i * 2, l, m, ql, qr), get(i * 2 + 1, m, r, ql, qr));
    }
}

mt19937 rnd(time(0));

vector<int> get(vector<int> a, int k) {
    int n = a.size();
    vector<int> ans = {n + 1};
    for (int M = 0; M < (1<<(n-1)); ++M) {
        vector<int> b;
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            mx = max(mx, a[i]);
            if (M&(1<<i)) {
                b.pb(mx);
                mx = 0;
            }
        }
        b.pb(mx);
        if (b.size() == k) {
            ans = min(ans, b);
        }
    }
    // for (auto &x : ans) {
    //     cout << x << ' ';
    // }
    // cout << endl;
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int t;
    t = 1;
    while (t--) {
        int n, q;
        cin >> n >> q;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        build(a);
        vector<quest> queries(q);
        for (int i = 0; i < q; ++i) {
            cin >> queries[i].k >> queries[i].i;
            --queries[i].i;
            queries[i].ind = i;
        }
        sort(all(queries), [&](quest a, quest b) {
            return a.k < b.k;
        });
        vector<int> RU(n, n);
        vector<int> st;
        for (int i = n - 1; i >= 0; --i) {
            while (!st.empty() && a[i] > a[st.back()]) {
                st.pop_back();
            }
            if (!st.empty()) {
                RU[i] = st.back();
            }
            st.pb(i);
        }
        vector<int> suff(n + 1, 0);
        for (int i = n - 1; i >= 0; --i) {
            suff[i] = max(suff[i + 1], a[i]);
        }
        vector<int> ans(q), res;
        int lask = -1;
        for (auto &qq : queries) {
            if (qq.k != lask) {
                lask = qq.k;
                if (qq.k == 1) {
                    res = {n};
                } else {
                    res.clear();
                    int ind = 0;
                    for (int x = 0; x < qq.k - 1; ++x) {
                        res.pb(a[ind]);
                        int r = min(RU[ind], n - (qq.k - x) + 1);
                        if (x == qq.k - 2) {
                            if (RU[ind] == n) {
                                res.pb(a.back());
                            } else {
                                res.pb(suff[RU[ind]]);
                            }
                        } else {
                            pii p = get(1, 0, MAX_N, ind + 1, r + 1);
                            ind = p.s;
                        }
                    }
                }
            }
            ans[qq.ind] = res[qq.i];
        }
        for (int i = 0; i < q; ++i) {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
}