#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t lll;

int n, m;

vector<vector<int>> a;

int inv(const vector<int> &vec) {
	int n = vec.size();
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (vec[j] > vec[i]) ++cnt;
		}
	}
	return cnt;
}

vector<int> gen(int mask) {
	vector<int> res;

	int i = 0;
	int j = 0;
	
	for (int c = 0; c < (n + m); ++c) {
		int t = (mask & 1); mask >>= 1;
		if (t) {
			for (int x = j; x < m; ++x) res.emplace_back(a[i][x]);
			++i;
			if (i == n) break;
		} else {
			for (int x = i; x < n; ++x) res.emplace_back(a[x][j]);
			++j;
			if (j == m) break;
		}
	}

// 	cerr << "here10" << endl;
	return res;
}

signed main() {
	FastIO;
	cin >> n >> m;
	a.resize(n, vector<int>(m));
	for (auto &it : a) {
		for (auto &itt : it) cin >> itt;
	}
// 	cerr << "here1" << endl;
	int best = INT_MAX;
	for (int mask = 0; mask < (1 << (n + m)); ++mask) {
		best = min(best, inv(gen(mask)));
	}
	cout << best;
	return 0;
}

