#include <iostream>
#include <vector>

int main()
{
  int n, q;
  std::cin >> n >> q;
  std::vector<int> a(n);
  for (int i = 0; i < n; ++i)
    std::cin >> a[i];
  std::vector<int> nxt(n, n), stack;
  for (int i = 0; i < n; ++i) {
    while (!stack.empty() && a[stack.back()] < a[i]) {
      nxt[stack.back()] = i;
      stack.pop_back();
    }
    stack.push_back(i);
  }
  stack.clear();
  int res1 = -1;
  for (int i = 0; i < nxt[0]; ++i) {
    res1 = std::max(res1, a[i]);
  }
  int res2 = -1;
  for (int i = nxt[0]; i < n; ++i) {
    res2 = std::max(res2, a[i]);
  }
  for (; q > 0; --q) {
    int k, i;
    std::cin >> k >> i;
    if (i == 1)
      std::cout << res1 << '\n';
    else
      std::cout << res2 << '\n';
  }
  return 0;
}