#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<int>> G;
vector<int> used, col;
long long r, t;

bool cr(pair<long long, long long> A, pair<long long, long long> B) {
    return r * r >= (A.first - B.first) * (A.first - B.first) + (A.second - B.second) * (A.second - B.second);
}

bool co = 1;

void dfs(int v, int c) {
    if (used[v] != -1) {
        if (c != col[v]) {
            co = 0;
        }
        return;
    }
    used[v] = t;
    col[v] = c;
    for (auto i : G[v]) {
        dfs(i, c ^ 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> r;
    vector<pair<long long, long long>> A(n);
    for (int i = 0; i < n; ++i) {
        cin >> A[i].first >> A[i].second;
    }
    G.resize(n);
    used.resize(n, -1);
    col.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (cr(A[i], A[j])) {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            t = i;
            co = 1;
            dfs(i, 0);
            ans[i] = 1 ^ co;
        }
        ans[i] = ans[used[i]];
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << endl;
}