#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
template <typename T, size_t U>
using ar = array<T, U>;
const int Inf = 0x3f3f3f3f;
const ll inf = 0x3f3f3f3f3f3f3f3f;
auto chmax(auto& x, auto&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}
auto chmin(auto& x, auto&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}

// ya pokakal
// ponos lutiy

struct Vec {
    ll x, y;
    Vec(ll x_ = 0, ll y_ = 0): x(x_), y(y_) {}
    Vec(const Vec& a_, const Vec& b_) {
        x = b_.x - a_.x;
        y = b_.y - a_.y;
    }
    ll dot(const Vec& other) const {
        return x * other.x + y * other.y;
    }
};

void pook() {
    int n; ll r;
    cin >> n >> r;
    vector<vector<int>> g(n);
    vector<Vec> a(n); 
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y; 
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (Vec(a[i], a[j]).dot(Vec(a[i], a[j])) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    } 
    bool bad = false;
    vector<int> used(n);
    const auto dfs = [&](auto&& self, int v, int col) -> bool {
        used[v] = col;
        for (int u : g[v]) {
            if (used[u] == 0) {
                if (self(self, u, col ^ 3)) {
                    return true;
                }
            } else if (col == used[u]) {
                bad = true;
                return true;
            }
        }
        return false;
    };
    const auto prop = [&](auto&& self, int v) -> void {
        used[v] = 3;
        for (int u : g[v]) {
            if (used[u] != 3) {
                self(self, u);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            bad = false;
            dfs(dfs, i, 1);
            if (bad) {
                prop(prop, i);
            }
        }
    }
    for (int x : used) {
        cout << (x == 3);
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef xnor
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
#endif

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        pook();
        cout << '\n';
    }

    return 0;
}