#include <bits/stdc++.h>
using namespace std;
const int nMax=1<<17;
bool used[nMax*2];
using ll = long long;
struct pt {
    ll x;
    ll y;
    ll id;
    bool operator<(pt oth) const{
        return tie(x,y,id) < tie(oth.x,oth.y,oth.id);
    }
    pt fs() const{
        return pt{y,x,id};
    }
    ll dist(pt oth) const {
        return (x-oth.x)*(x-oth.x) + (y-oth.y)*(y-oth.y);
    }
};
pt pts[nMax];
pt ptsor[nMax];
vector<int> g[nMax*4];
int cmp[nMax*2];
bool goodCmp[nMax*2];
int cmpCnt=1;
bool great[nMax*2];
void dfs(int v) {
    cmp[v]=cmp[v^nMax]=cmpCnt;
    if (used[v^nMax] || great[v])
        goodCmp[cmpCnt]=true;
    used[v] =true;
    for (auto u : g[v]) {
        if (used[u])continue;
        dfs(u);
    }

}
void dfs2(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (used[u])continue;
        dfs2(u);
    }
}
int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("ouput.txt","w",stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    ll n,r;
    cin >> n >> r;
    for (int i=0;i<n;i++) {
        cin>>pts[i].x >> pts[i].y;
        pts[i].id = i;
        ptsor[i]=pts[i];
    }
    sort(pts,pts+n);
    int i=0,j=0;
    set<pt> cur;
    cur.insert(pts[0].fs());
    for (int k =0;k<n;k++) {
        while (pts[i].x<pts[k].x-r) {
            cur.erase(pts[i].fs());
            i++;
        }
        while (j+1 <n && pts[j+1].x<=pts[k].x+r) {
            cur.insert(pts[++j].fs());
        }
        vector<pt> curr;
        {
            auto it = cur.find(pts[k].fs());
            for (;  it !=cur.begin();) {
                --it;
                if (it->y<pts[k].y-r)break;
                if (it->dist(pts[k])>r*r)continue;
                curr.push_back(it->fs());

            }
        }
        {
            auto it = ++cur.find(pts[k].fs());
            for (int i =0;i<20 && it !=cur.end();i++) {
                if (it->y>pts[k].y+r)break;
                if (it->dist(pts[k])>r*r)continue;
                curr.push_back((it++)->fs());
            }
        }

        for (int j=0; j < curr.size();j++) {
            g[curr[j].id].push_back(pts[k].id^nMax);
            g[curr[j].id^nMax].push_back(pts[k].id);
            for (int kk = 0;kk<j;kk++) {
                if (curr[j].dist(curr[kk]) > r*r)continue;
                great[pts[k].id]=great[pts[k].id^nMax]=true;
            }
        }
    }
    for (int i =0;i<n;i++) {
        if (cmp[i])continue;
        cmpCnt++;
        dfs(i);
    }
    for (int i=0;i<n;i++) {
        cout << (goodCmp[cmp[i]] ? 1 : 0);
    }
}