#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

// #define LOCAL
vector<int> cur_cc;
vector<int> dist;
vector<pair<int, int>> points;
set<int> have;
bool mark = false;
vector<bool> used;
vector<bool> marked;
int n, r;
void dfs(int v) {
    auto [x, y] = points[v];
    used[v] = true;
    cur_cc.push_back(v);
    for (auto u : have) {
        if (u == v) continue;
        auto [x1, y1] = points[u];
        if ((ll)(x - x1) * (x - x1) + (ll)(y - y1) * (y - y1) <= (ll)r * r) {
            if (used[u]) {
                if (dist[v] % 2 == dist[u] % 2) {
                    mark = true;
                }
                continue;
            }
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}
void solve() {
    cin >> n >> r;
    points.resize(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;

        points[i] = make_pair(x, y);
        have.insert(i);
    }
    used.resize(n);
    dist.resize(n);
    marked.resize(n);
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        cur_cc.clear();
        mark = false;
        dfs(i);
        for (auto el : cur_cc) {
            marked[el] = mark;
            have.erase(el);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (marked[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}