#include <bits/stdc++.h>
#define For(i,n) for(ll i=0;i<n;++i)
#define all(x) x.begin(),x.end()
using namespace std;
using ll=long long;
using vl=vector<ll>;
long long dist(pair<ll,ll> a,pair<ll,ll> b) {
    ll xd=a.first-b.first;
    ll yd=a.second-b.second;
    return xd*xd+yd*yd;
}
void dfsc(ll v,vector<vl> &g,vl &col) {
    for (ll u:g[v]) {
        if (col[u]!=-1) {
            continue;
        }
        col[u]=col[v];
        dfsc(u,g,col);
    }
}
void dfsd(ll v,vector<vl> &g,vl &d) {
    for (ll u:g[v]) {
        if (d[u]!=-1) {
            continue;
        }
        d[u]=d[v]+1;
        dfsd(u,g,d);
    }
}
void solve() {
    ll n,r;
    cin>>n>>r;
    vector<pair<ll,ll>> p(n);
    vl xp;
    ll yzero=1;
    For(i,n) {
        cin>>p[i].first>>p[i].second;
        xp.push_back(p[i].first);
        if (p[i].second!=0) {
            yzero=0;
        }
    }
    if (yzero){
        sort(all(xp));
        map<ll,ll> res;
        For(i,n) {
            ll x=xp[i];
            ll cnt=upper_bound(all(xp),x+r)-lower_bound(all(xp),x)-1;
            res[i]=cnt>=2;
        }
        for (ll i=0;i<n-1;++i) {
            if (res[xp[i]]==1 && abs(xp[i+1]-xp[i])<=r) {
                res[xp[i+1]]=1;
            }
        }
        for (ll i=n-1;i>=1;--i) {
            if (res[xp[i]]==1 && abs(xp[i-1]-xp[i])<=r) {
                res[xp[i-1]]=1;
            }
        }
        For(i,n) {
            cout<<res[p[i].first];
        }
        cout<<'\n';
    }else if (n<=10000) {
        vector<vl> g(n);
        vector<pair<ll,ll>> e;
        For(i,n) {
            For(j,i) {
                if (dist(p[i],p[j])<=r*r) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                    e.push_back({i,j});
                }
            }
        }
        vl col(n,-1);
        ll t=0;
        For(i,n) {
            if (col[i]!=-1) {
                continue;
            }
            col[i]=t++;
            dfsc(i,g,col);
        }
        vl d(n,-1);
        vl res(t);
        For(i,n) {
            if (d[i]!=-1) {
                continue;
            }
            dfsd(i,g,d);
        }
        for (auto [v,u]:e) {
            if (d[u]%2==d[v]%2) {
                res[col[u]]=1;
            }
        }
        For(i,n) {
            cout<<res[col[i]];
        }
        cout<<'\n';
    }else if (r<=10) {
        map<pair<ll,ll>,ll> id;
        For(i,n) {
            id[p[i]]=i;
        }
        vector<vl> g(n);
        vector<pair<ll,ll>> e;
        For(i,n) {
            auto [X,Y]=p[i];
            for (ll x=X-r;x<=X+r;++x) {
                for (ll y=Y-r;y<=Y+r;++y) {
                    if (X==x && Y==y) {
                        continue;
                    }
                    if (dist({x,y},{X,Y})<=r*r && id.count({x,y})) {
                        ll j=id.at({x,y});
                        g[i].push_back(j);
                        g[j].push_back(i);
                        e.push_back({i,j});
                    }
                }
            }
        }
        /*For(i,n) {
            For(j,i) {
                if (dist(p[i],p[j])<=r*r) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                    e.push_back({i,j});
                }
            }
        }*/
        vl col(n,-1);
        ll t=0;
        For(i,n) {
            if (col[i]!=-1) {
                continue;
            }
            col[i]=t++;
            dfsc(i,g,col);
        }
        vl d(n,-1);
        vl res(t);
        For(i,n) {
            if (d[i]!=-1) {
                continue;
            }
            dfsd(i,g,d);
        }
        for (auto [v,u]:e) {
            if (d[u]%2==d[v]%2) {
                res[col[u]]=1;
            }
        }
        For(i,n) {
            cout<<res[col[i]];
        }
        cout<<'\n';
    }
}
int main() {
    //freopen("C:/work/CLionProjects/untitled/input.txt","r",stdin);
    solve();
    return 0;
}