#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <algorithm>
#include <random>

using namespace std;
mt19937 rnd(42);
#define int long long

int n, m;
int nm;

vector<int> t(3000000);
vector<vector<int>> l;

void add(int ind, int d) {
	for (int i = ind; i <= nm; i += (i & (-i))) {
		t[i] += d;
	}
}

int get(int ind) {
	int u = 0;
	for (int i = ind; i > 0; i -= (i & (-i))) {
		u += t[i];
	}
	return u;
}

int solve(int cnt) {
	int x = 0;
	int y = 0;
	int ans = 0;
	int step = -1;
	while (x < n and y < m) {
		step++;
		int u1 = 0;
		for (int j = y; j < m; j++) {
			u1 += get(n * m) - get(l[x][j]);
			add(l[x][j], 1);
		}
		for (int j = y; j < m; j++) {
			add(l[x][j], -1);
		}
		int u2 = 0;
		for (int i = x; i < n; i++) {
			u2 += get(n * m) - get(l[i][y]);
			add(l[i][y], 1);
		}

		for (int i = x; i < n; i++) {
			add(l[i][y], -1);
		}
		ans += min(u1, u2);
		if (cnt & (1ll << step)) {
			ans += u1;
			for (int j = y; j < m; j++) {
				add(l[x][j], 1);
			}
			x++;
		}
		else {
			ans += u2;
			for (int i = x; i < n; i++) {
				add(l[i][y], 1);
			}
			y++;
		}
	}
	for (int i = 0; i < n * m; i++) {
		add(i + 1, -1);
	}
	return ans;
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	cin >> n >> m;
	nm = n * m;
	l = vector<vector<int>>(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> l[i][j];
		}
	}
	int ans = 1e15;
	for (int i = 0; i < (1ll << (n + m)); i++) {
		ans = min(ans, solve(i));
		//cout << i << " " << ans << " ehhee\n";
	}
	
	cout << ans;



}
/*

5 3
0 0
2 0
3 0
5 0
8 0

  
  :
   ,  0  
 1  

׸  ,    ,        8 
    
:    ,   ,     

      

     .  ?


*/