// #define GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

long long dist(pair<int, int> p1, pair<int, int> p2) {
    return (1ll * (p1.first - p2.first) * (p1.first - p2.first) + 1ll *(p1.second - p2.second) * (p1.second - p2.second));
}

vector<vector<int>> graph;
vector<int> num_con;
vector<pair<bool, bool>> used;
vector<bool> is_ans_con;
vector<pair<int, int>> a;
map<pair<int, int>, int> ind_point;
int cur_con;

long long n, r;

void dfs_con(int v) {
    num_con[v] = cur_con;
    if (used[v].first && used[v].second) {
        is_ans_con[num_con[v]] = true;
    }
    int u;
    for (int dif1 = -r; dif1 <= r; dif1++) {
        for (int dif2 = -r; dif2 <= r; dif2++) {
            pair<int, int> new_point = a[v];
            new_point.first += dif1;
            new_point.second += dif2;
            if ((dif1 || dif2) && (dist(a[v], new_point) <= r && ind_point.find(new_point) != ind_point.end())) {
                u = ind_point[new_point] - 1;
            } else {
                continue;
            }
            if (used[v].first && !used[u].second) {
                used[u].second = true;
                num_con[u] = cur_con;
                dfs_con(u);
            }
            if (used[v].second && !used[u].first) {
                used[u].first = true;
                num_con[u] = cur_con;
                dfs_con(u);
            }
        }
    }
}

signed main()
{
    cin >> n >> r;
    r *= r;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        ind_point[a[i]] = i + 1;
    }
    graph.resize(n, {});
    used.resize(n, {false, false});
    num_con.resize(n, -1);
    cur_con = -1;
    is_ans_con.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (num_con[i] == -1) {
            cur_con++;
            used[i].first = true;
            dfs_con(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << is_ans_con[num_con[i]];
    }
    return 0;
}
