// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int MAXN = 2e6 + 19;
#define int long long

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, k, ind;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> next_bigger(n, n - 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> cur_stack = {};
    for (int i = n - 1; i >= 0; i--) {
        while (cur_stack.size() && a[cur_stack.back()] < a[i]) {
            cur_stack.pop_back();
        }
        if (cur_stack.size()) {
            next_bigger[i] = cur_stack.back();
        }
        cur_stack.push_back(i);
    }
    set<int> all_k;
    vector<pair<int, int>> queries;
    for (int i = 0; i < q; i++) {
        cin >> k >> ind;
        ind--;
        queries.push_back({k, ind});
        all_k.insert(k);
    }
    map<pair<int, int>, int> ans_query;
    for (auto cur_k : all_k) {
        int ind_begin = 0;
        int cur_ind = 0;
        while (cur_ind != cur_k) {
            int cur_ind_min = ind_begin + 1;
            for (int next_ind = ind_begin + 1; next_ind <= next_bigger[ind_begin] && n - next_ind >= cur_k - cur_ind - 1; next_ind++) {
                if (a[next_ind] < a[cur_ind_min]) {
                    cur_ind_min = next_ind;
                }
            }
            if (cur_ind == cur_k - 2) {
                cur_ind_min = next_bigger[ind_begin];
            }
            if (cur_ind == cur_k - 1) {
                int cur_max = 0;
                for (int next_ind = ind_begin; next_ind < n; next_ind++) {
                    cur_max = max(cur_max, a[next_ind]);
                }
                ans_query[{cur_k, cur_ind}] = cur_max;
            } else {
                ans_query[{cur_k, cur_ind}] = a[ind_begin];
            }
            cur_ind++;
            ind_begin = cur_ind_min;
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans_query[queries[i]] + 1 << endl;
    }
    return 0;
}
