#include <bits/stdc++.h>
// #define int long long
#define pb push_back
#define endl "\n"
using namespace std;
typedef long long ll;
const int maxn = 1e5 + 10;
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
map<int, map<int, vector<int>>> mp;
int color[maxn];


struct point {
    int x, y, i;
};

vector<point> p;
int r;
vector<int> per = {1, 0, -1};
int ks[maxn];
int st[maxn];

bool check(int i, int j) {
    long long dist = ((ll)p[i].x - p[j].x) * ((ll)p[i].x - p[j].x) + ((ll)p[i].y - p[j].y) * ((ll)p[i].y - p[j].y);
    return dist <= (ll)r * r;
}



void dfs(int u, int col, int kks) {
    color[u] = col;
    ks[u] = kks;
    for (int dx : per) {
        for (int dy : per) {
            int x = p[u].x / r;
            int y = p[u].y / r;
            for (int v : mp[x + dx][y + dy]) {
                if (!check(u, v)) continue;
                if (v == u) continue;
                if (color[v] == -1) {
                    dfs(v, 1 - col, kks);
                } else if (color[v] == color[u]) st[kks] = 1;
            }
        }
    }
}


void solve() {
    int n;
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        p.pb({x, y, i});
    }
    for (int i = 0; i < n; ++i) {
        mp[p[i].x / r][p[i].y / r].pb(i);
    }
    fill(color, color + n, -1);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) dfs(i, 0, cnt++);
    }
    for (int i = 0; i < n; ++i) {
        if (st[ks[i]] == 0) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    solve();
}