#include <bits/stdc++.h>
// #define int long long
#define pb push_back
#define endl "\n"
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

const int maxlog = 19;
const int maxn = 3e5 + 10;
pii mn[maxlog][maxn];
int mx[maxlog][maxn];
int lg[maxn];

void build(int n, vector<int> &a) {
    for (int i = 0; i < n; ++i) {
        mx[0][i] = a[i];
        mn[0][i].first = a[i];
        mn[0][i].second = i;
    }
    for (int j = 1; j < maxlog; ++j) {
        for (int i = 0; i < n; ++i) {
            mx[j][i] = mx[j - 1][i];
            if (i + (1 << (j - 1)) < n && mx[j][i] < mx[j - 1][i + (1 << (j - 1))]) mx[j][i] = mx[j - 1][i + (1 << (j - 1))];

            mn[j][i] = mn[j - 1][i];
            if (i + (1 << (j - 1)) < n && mn[j][i] > mn[j - 1][i + (1 << (j - 1))]) mn[j][i] = mn[j - 1][i + (1 << (j - 1))];
        }
    }
}
vector<int> a;
int n;

// pii get_min(int l, int r) {
//     int len = r - l + 1;
//     return min(mn[lg[len]][l], mn[lg[len]][r - (1 << lg[len]) + 1]);
// }
//
// int get_max(int l, int r) {
//     int len = r - l + 1;
//     return max(mx[lg[len]][l], mx[lg[len]][r - (1 << lg[len]) + 1]);
// }

pii get_min(int l, int r) {
    int res = a[l], ind = l;
    for (int i = l; i <= r; ++i) {
        if (a[i] < res) {
            res = a[i];
            ind = i;
        }
    }
    return {res, ind};
}

int get_max(int l, int r) {
    int res = a[l];
    for (int i = l; i <= r; ++i) {
        if (a[i] > res) res = a[i];
    }
    return res;
}


void solve() {
    int q;
    cin >> n >> q;
    // vector<int> a(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int mx = -1;
    bool st = 0;
    for (int i = 1; i < n; ++i) {
        // mx = max(mx, a[i]);
        if (st == 0) {
            if (a[i] > a[0]) continue;
            else {
                mx = a[i];
                st = 1;
            }
        }  else {
            mx = max(mx, a[i]);
        }
    }
    if (mx == -1) mx = a.back();
    while (q--){
        int k, i;
        cin >> k >> i;
        if (i == 1) cout << a[0] << endl;
        else cout << mx << endl;
    }
}

signed main() {
    lg[1] = 0;
    for (int i = 2; i < maxn; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
    ios_base::sync_with_stdio(0); cin.tie(0);
    solve();
}