#include <bits/stdc++.h>

using ll = long long;

using namespace std;

vector<vector<int>> g;
vector<int> color;
vector<int> used;

bool dfs(int v, int cl) {
    color[v] = cl;
    for (auto u : g[v]) {
        if (!color[u]) {
            if (!dfs(u, 3 - cl)) {
                return 0;
            }
        } else if (color[v] == color[u]) {
            return 0;
        }
    }
    return 1;
}
void dfs2(int v, int cl) {
    used[v] = cl;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs2(u, cl);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    g.resize(n);
    color.resize(n);
    used.resize(n);

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((a[i].first - a[j].first) * ll(a[i].first - a[j].first) + (a[i].second - a[j].second) * ll(a[i].second - a[j].second) <= r * ll(r)) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    int cl = 1;
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i, cl);
            ans[cl] = !dfs(i, 1);
            cl++;
        }
    }

    for (int i = 0; i < n; i++) {
        cout << ans[used[i]];
    }

    cout << "\n";
    return 0;
}