#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdint>
#include <unordered_map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

constexpr uint32_t MAXN = 100'000;

pair<int, int> pnt[MAXN];
vector<int> g[MAXN];

int64_t sq(int x)
{
	return int64_t(x) * x;
}

uint64_t pr_to_int(uint32_t x, uint32_t y)
{
	return uint64_t(x) << 32 | y;
}

void solve()
{
	int n, r;
	cin >> n >> r;
	vector<int> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
		int tr;
		cin >> tr;
	}
	sort(ALL(mas));

	vector<bool> good(n);
	for (int i = 0; i < n; i++)
	{
		bool h = false;
		if (i > 1 and mas[i] - mas[i - 2] <= r)
		{
			h = true;
		}
		if (i > 0 and i + 1 < n and mas[i + 1] - mas[i - 1] <= r)
		{
			h = true;
		}
		if (i + 2 < n and mas[i + 2] - mas[i] <= r)
		{
			h = true;
		}
		good[i] = h;
	}
	for (int i = 1; i < n; i++)
	{
		if (mas[i] - mas[i - 1] <= r and good[i - 1])
		{
			good[i] = true;
		}
	}
	for (int i = n - 2; i >= 0; i--)
	{
		if (mas[i + 1] - mas[i] <= r and good[i + 1])
		{
			good[i] = true;
		}
	}
	for (int i = 0; i < n; i++)
	{
		cout << good[i];
	}

	return;
}