#include <bits/stdc++.h>
  
using namespace std;
using ll = long long;
using ld = long double;
  
#define all(a) a.begin(), a.end()
  
void solve();
void prec();
  
int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    solve();
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXTIME: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}
  
void prec() {
  
}
  
const int N = 1e5 + 10;

pair<ll, ll> a[N];
unordered_map<ll, ll> sorted;
vector<int> g[N];
bool dp[N][2];

void solve() {
    ll n, r;
    cin >> n >> r;
    for(int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        sorted[a[i].first + a[i].second * (ll)(1e9)] = i + 1;
    }
    for(int i = 0; i < n; i++) {
        for(ll deltax = -r; deltax <= r; deltax++) {
            for(ll deltay = -r; deltay <= r; deltay++) {
                if(deltax * deltax + deltay * deltay > r * r) {
                    continue;
                }
                pair<ll, ll> need = {a[i].first + deltax, a[i].second + deltay};
                if(sorted[need.first + need.second * (ll)(1e9)] != 0) {
                    g[i].push_back(sorted[need.first + need.second * (ll)(1e9)] - 1);
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if(dp[i][0] == false && dp[i][1] == false) {
            queue<pair<ll, ll>> q;
            q.push({i, 0});
            while(q.size() > 0) {
                pair<ll, ll> t = q.front();
                q.pop();
                for(auto j : g[t.first]) {
                    if(j == t.first) {
                        continue;
                    }
                    if(dp[j][(t.second + 1) & 1] == false) {
                        dp[j][(t.second + 1) & 1] = true;
                        q.push({j, (t.second + 1) & 1});
                    }
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if(dp[i][0] && dp[i][1]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}