#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

void solve();
void prec();

int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    solve();
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXTIME: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}

void prec() {

}

void solve() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<vector<bool>> dp(n, vector<bool>(2, false));
    for(int i = 0; i < n; i++) {
        if(dp[i][0] == false && dp[i][1] == false) {
            queue<pair<ll, ll>> q;
            q.push({i, 0});
            while(q.size() > 0) {
                pair<ll, ll> t = q.front();
                q.pop();
                for(int j = max(0LL, (ll)i - 500); j < min(n, (ll)i + 500); j++) {
                    if(j == t.first) {
                        continue;
                    }
                    ll dist = (a[t.first].first - a[j].first) * (a[t.first].first - a[j].first) + (a[t.first].second - a[j].second) * (a[t.first].second - a[j].second);
                    if(dist > r * r) {
                        continue;
                    }
                    if(dp[j][(t.second + 1) & 1] == false) {
                        dp[j][(t.second + 1) & 1] = true;
                        q.push({j, (t.second + 1) & 1});
                    }
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if(dp[i][0] && dp[i][1]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}