#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
using ld = long double;
 
#define all(a) a.begin(), a.end()
 
void solve();
void prec();
 
int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    solve();
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXTIME: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}
 
void prec() {
 
}
 
void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    while(q--) {
        ll i, k;
        cin >> k >> i;
        vector<ll> iters;
        iters.push_back(0);

        ll iter = 0;
        ll can = 1;
        for(int cur_day = 1; cur_day < k; cur_day++) {
            for(int j = iter + 1; j < n; j++) {
                if((n - j) < (k - cur_day)) {
                    break;
                }
                if(a[j] < a[can]) {
                    can = j;
                }
                if(a[j] > a[iter]) {
                    break;
                }
            }
            iters.push_back(can);
            iter = can;
            can = iter + 1;
        }
        if(i == k) {
            ll ans = 0;
            for(int j = iters[i - 1]; j < n; j++) {
                ans = max(ans, a[j]);
            }
            cout << ans << "\n";
        } else {
            ll ans = 0;
            for(int j = iters[i - 1]; j < iters[i]; j++) {
                ans = max(ans, a[j]);
            }
            cout << ans << "\n";
        }
    }
}
