#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

using ll = long long;

vector<vector<int>> gr;
vector<int> us;

void dfs(int v, int C = 1) {
	us[v] = C;
	for (int u : gr[v]) {
		if (!us[u]) dfs(u, 3 - C);
	}
	for (int u : gr[v]) {
		if (us[u] != 3 - C) {
			us[v] = 10;
			break;
		}
	}
	if (us[v] == 10) {
		for (int u : gr[v]) {
			if (us[u]!=10) dfs(u, 3 - C);
		}
	}
}

ll foo(pair<ll, ll> a) {
	return a.first * 1e9 + a.second;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
	gr.resize(n);
	us.resize(n);
	vector<pair<pair<ll, ll>, int>> v;
	for (int i = 0; i < n; i++) v.push_back({ a[i], i });
	sort(v.begin(), v.end());
	for (int I = 0; I < n;I++) {
		int i = v[I].second;
		for (int J = I + 1; J < n; J++) {
			if ((v[I].first.first - v[J].first.first) * (v[I].first.first - v[J].first.first) +
				(v[I].first.second - v[J].first.second) * (v[I].first.second - v[J].first.second) > r*r) break;
			int j = v[J].second;
			gr[i].push_back(j);
			if (int(gr[i].size()) > 6) {
				us[i] = 10;
				break;
			}
		}
		for (int J = I - 1; J >-1; J--) {
			if ((v[I].first.first - v[J].first.first) * (v[I].first.first - v[J].first.first) +
				(v[I].first.second - v[J].first.second) * (v[I].first.second - v[J].first.second) > r*r) break;
			int j = v[J].second;
			gr[i].push_back(j);
			if (int(gr[i].size()) > 6) {
				us[i] = 10;
				break;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!us[i]) dfs(i);
	}
	for (int i = 0; i < n; i++) {
		if (us[i] == 10) cout << 1;
		else cout << 0;
	}
}