#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3,Ofast")
#include "bits/stdc++.h";
// #pragma GCC target("avx2")
using namespace std;
# define all(a) a.begin(), a.end()

inline long long d2(const pair<int, int> &a, const pair<int, int> &b) {
    return  (long long)(a.first - b.first) * (a.first - b.first) + (long long)(a.second - b.second) * (a.second - b.second);
}
vector<int> used;
long long n, r;
vector<pair<int, int>> a;
unordered_map<int, vector<int>> y;
int my_upper_bound(const vector<int> &arr, int x) {
    int l = 0, r = arr.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[arr[m]].second <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}
int my_lower_bound(const vector<int> &arr, int x) {
    int l = -1, r = arr.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[arr[m]].second >= x) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}
 void dfs(int i) {
    used[i] = 1;
    for (int l = a[i].first - r; l <= a[i].first + r; ++l) {
        if (y.count(l)) {
            int end = my_upper_bound(y[l], a[i].second + r + 1);
            for (int j = my_lower_bound(y[l], a[i].second - r); j < end; ++j) {
                auto ind = y[l][j];
                if (ind != i && d2(a[i], a[ind]) <= r * r) {
                    if (!used[ind]) {
                        dfs(ind);
                    }
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin >> n >> r;
     used.assign(n, 0);
    a.resize(n);

    for (int i = 0; i < n; ++i) {
        auto &[x0, y0] = a[i];
        cin >> x0 >> y0;
        y[x0].emplace_back(i);
    }
    for (auto &[i, j] : y) {
        sort(all(j), [&](int i1, int i2) {
            return a[i1].second < a[i2].second;
        });
    }
    vector<int> q;
    vector<int> d(2 * n, - 1);

    for (int p = 0; p < n; ++p) {
        if (!used[p]) {
            dfs(p);
            q.clear();
            q.push_back(2 * p);
            for (int ind_of_q = 0; ind_of_q < q.size(); ++ind_of_q) {
                int i = q[ind_of_q] / 2, v = q[ind_of_q];
                for (int l = a[i].first - r; l <= a[i].first + r; ++l) {
                    if (y.count(l)) {
                        int end = my_upper_bound(y[l], a[i].second + r + 1);
                        for (int j = my_lower_bound(y[l], a[i].second - r); j < end; ++j) {
                            auto ind = y[l][j];
                            if (ind != i &&  d2(a[i], a[ind]) <= r * r) {
                                int u = 2 * ind + ((1 + v) & 1);
                                if (d[u] == -1) {
                                    d[u] = d[i] + 1;
                                    q.push_back(u);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[2 * i] != -1 && d[2 * i + 1] != -1) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    return 0;
}