#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h";
using namespace std;
// # define int long long
# define all(a) a.begin(), a.end()



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
    const int K = n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    vector<int> next(n, n);
    vector<pair<int, int>> st;
    for (int i = n - 1; i>= 0;--i) {
        while (!st.empty() && st.back().first <= a[i]) {
            st.pop_back();
        }
        if (!st.empty()) {
            next[i] = st.back().second;
        }
        st.emplace_back(a[i], i);
    }
    const int LOG = 24;
    vector<vector<pair<int, int>>> t(LOG, vector<pair<int, int>>(n)), mx(LOG, vector<pair<int, int>>(n));
    for (int i = 0; i < n; ++i) {
        t[0][i] = {a[i], i};
        mx[0][i] = t[0][i];
    }
    for (int k = 1; k < LOG; ++k) {
        for (int i = 0; i + (1 << k) <= n; ++i) {
            t[k][i] = min(t[k - 1][i], t[k - 1][i + (1 << (k - 1))]);
            mx[k][i] = max(mx[k - 1][i], mx[k - 1][i + (1 << (k - 1))]);
        }
    }
    auto get = [&](int l, int r) {
        if (l >= r) return make_pair(n, n);
        int lg = __lg(r - l);
        return min(t[lg][l], t[lg][r - (1 << lg)]);
    };
    auto gmx = [&](int l, int r) {
        if (l >= r) return make_pair(n, n);
        int lg = __lg(r - l);
        return max(mx[lg][l], mx[lg][r - (1 << lg)]);
    };
    while (q--) {
        int cur_k, ind;
        cin >> cur_k >> ind;
        int pref = 0;
        vector<int> ans;
        for (int i = 0; i < cur_k - 1; ++i) {
            auto res = get(pref + 1, min(next[pref], pref + n - (cur_k - i - 1)) + 1);
            ans.push_back(a[pref]);
            pref = res.second;
        }
        ans.push_back(gmx(pref, n).first);
        cout << ans[ind - 1] << '\n';
    }
    // vector<pair<int, int>> st;
    // vector<int> pref(n + 1, 0);
    // for (int i = 0; i < n; ++i) {
    //     while (!st.empty() && st.back().first <= a[i]) {
    //         st.pop_back();
    //     }
    //     if (!st.empty()) {
    //         pref[i + 1] = st.back().second;
    //     }
    //     st.emplace_back(a[i], i + 1);
    // }
    // vector<vector<int>> t(LOG, vector<int>(n));
    // t[0] = a;
    // for (int k = 1; k < LOG; ++k) {
    //     for (int i = 0; i + (1 << k) <= n; ++i) {
    //         t[k][i] = max(t[k - 1][i], t[k - 1][i + (1 << (k - 1))]);
    //     }
    // }
    // vector<vector<int>> dp(n + 1, vector<int>(K + 1)), p(n + 1, vector<int>(K + 1, -1));
    // dp[0][0] = 1;
    // for (int k = 1; k <= K; ++k) {
    //     for (int i = 1; i <= n; ++i) {
    //         int j = pref[i];
    //         do {
    //             dp[i][k] = dp[j][k - 1];
    //             if (dp[i][k]) {
    //                 p[i][k] = j;
    //                 break;
    //             }
    //             j = pref[j];
    //         }while (j != 0);
    //     }
    // }
    return 0;
}