#include<bits/stdc++.h>
using namespace std;
#define int long long
vector<int> t;
int get(int v, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) {
        return t[v];
    }
    if (rq <= l || r <= lq) return 0;
    int m = (l + r) / 2;
    int q1 = get(2 * v + 1, l, m, lq, rq);
    int q2 = get(2 * v + 2, m, r, lq, rq);
    return q1 + q2;
}
void update(int v, int l, int r, int ind, int x) {
    if (l + 1 == r) {
        t[v] += x;
        return;
    }
    int m = (l + r) / 2;
    if (ind < m) update(2 * v + 1, l, m, ind, x);
    else update(2 * v + 2, m, r, ind, x);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int r, c;
    cin >> r >> c;
    int n = r * c;
    vector<vector<int>> a(r, vector<int>(c, 0));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    int ans = 1e18 + 1;
    for (int mask = 0; mask < (1 << (r + c)); mask++) {
        int starti = 0;
        int startj = 0;
        vector<int> b;
        for (int q = 0; q < (r + c); q++) {
            int w = (mask >> q) & 1;
            if (starti > r - 1 || startj > c - 1) break;
            if (starti == r - 1) w = 0;
            if (startj == c - 1) w = 1;
            if (w == 0) {
                for (int j = startj; j < c; j++) b.push_back(a[starti][j]);
                starti++;
            }
            else {
                for (int i = starti; i < r; i++) b.push_back(a[i][startj]);
                startj++;
            }
        }
        t.assign(4 * n + 4, 0);
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += get(0, 0, n, b[i], n);
            update(0, 0, n, b[i], 1);
        }
        ans = min(ans, cnt);
    }
    cout << ans << '\n';
    return 0;
}