#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

#ifndef  LOCAL
const int N = 1e5 + 10;
#else
const int N = 6;
#endif

ll x[N], y[N];
vector<int> g[N];
int can[N][2];
bool fl = false;

void solve() {
    int n; ll r;
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            can[j][0] = can[j][1] = 0;
        }
        can[i][0] = 1;
        queue<pair<int, int>> q;
        q.emplace(i, 0);
        while (!q.empty()) {
            auto [v, clr] = q.front();
            q.pop();

            for (int to: g[v]) {
                int nc = clr ^ 1;
                if (!can[to][nc]) {
                    can[to][nc] = 1;
                    q.emplace(to, nc);
                }
            }
        }

        bool ans = can[i][0] && can[i][1];
        // for (int j = 0; j < n; ++j) {
        //     ans = ans | (can[j][0] && can[j][1]);
        // }

        if (ans) cout << 1;
        else cout << 0;
    }

    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
