#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto &x: a) {
        cin >> x;
    }

    vector<int> suf(n+1, -INFi);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(a[i], suf[i+1]);
    }

    for (int i = 0; i < q; ++i) {
        int k, j;
        cin >> k >> j;
        if (j <= k - 1) {
            cout << a[j-1] << '\n';
        } else {
            // int idx = n - k - 1;
            cout << suf[k-1] << '\n';
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
