#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}

using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
vector<vector<int>> mat;

ll count(int a, int b, int r, int c, oset& x) {
    ll ans = 0;
    for (int i=a; i<r; i++) {
        for (int j=b; j<c; j++) {
            ans += sz(x) - x.order_of_key(mat[i][j]);
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int r, c;
    cin >> r >> c;
    mat.assign(r, vector<int>(c));
    for (int i=0; i<r; i++) {
        for (int j=0; j<c; j++) cin >> mat[i][j];
    }

    vector<vector<ll>> cntrow(r, vector<ll>(c));
    for (int i=0; i<r; i++) {
        oset x;
        for (int j=c-1; j>=0; j--) {
            int a = x.order_of_key(mat[i][j]);
            cntrow[i][j] = a;
            x.insert(mat[i][j]);
            if (j+1<c) cntrow[i][j] += cntrow[i][j+1];
        }
    }

    cout << cntrow[0][0];



    return 0;
}