// #include <bits/stdc++.h>
//
// using namespace std;
//
// using ll = long long;
// using pii = pair<int, int>;
// using pll = pair<ll, ll>;
// using ld = long double;
// template <typename T>
// ll sz(T& a) {
//     return (ll)a.size();
// }
//
//
// vector<vector<int>> g;
// bool checkd(pll a, pll b, ll r) {
//     return (a.first-b.first)*(a.first-b.first) + (a.second-b.second)*(a.second-b.second) <= r*r;
// }
//
// vector<bool> used;
// vector<int> maybe;
// vector<bool> bad;
// void dfs(int v) {
//     used[v] = 1;
//     maybe.push_back(v);
//     for (int nxt:g[v]) {
//         if (bad[nxt]) continue;
//         if (used[nxt]==0) dfs(nxt);
//     }
// }
//
//
// int main() {
//     ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
// #ifdef manix888
//     freopen("input.txt", "r", stdin);
//     freopen("output.txt", "w", stdout);
// #endif
//
//
//     int n; ll r;
//     cin >> n >> r;
//     vector<pll> nums(n);
//     vector<ll> cordsy;
//     for (int i=0; i<n; i++) {
//         cin >> nums[i].first >> nums[i].second;
//         cordsy.push_back(nums[i].second);
//     }
//     sort(cordsy.begin(), cordsy.end());
//     cordsy.resize(unique(cordsy.begin(), cordsy.end()) - cordsy.begin());
//     int M = sz(cordsy);
//     unordered_map<int, int> ids1(M);
//     for (int i=0; i<M; i++) ids1[cordsy[i]] = i;
//     for (int i=0; i<n; i++) {
//         nums[i].second = ids1[nums[i].second];
//     }
//
//     vector<vector<int>> mat(M);
//     for (int i=0; i<n; i++) {
//         mat[nums[i].second].push_back(i);
//     }
//     for (int i=0; i<M; i++) {
//         sort(mat[i].begin(), mat[i].end(), [&](int a, int b) {
//             return nums[a].first < nums[b].first;
//         });
//     }
//
//
//     vector<pii> edges;
//     for (int i=0; i<n; i++) {
//         for (int j=0; j<i; j++) {
//             if (checkd(nums[i], nums[j], r)) edges.push_back({i, j});
//         }
//     }
//
//     g.resize(n*2); used.resize(n*2); bad.resize(n*2);
//     for (auto [a, b] : edges) {
//         g[a].push_back(b+n);
//         g[a+n].push_back(b);
//         g[b].push_back(a+n);
//         g[b+n].push_back(a);
//     }
//
//     vector<bool> good(n);
//     for (int i=0; i<n; i++) {
//         if (used[i]==0 && used[i+n]==0) {
//             dfs(i);
//             while (sz(maybe)) {
//                 int v = maybe.back();
//                 maybe.pop_back();
//                 if (v>=n) v-=n;
//                 if (used[v] && used[v+n]) good[v] = 1;
//                 else bad[v] = 1;
//             }
//         }
//     }
//
//     used.assign(n*2, 0);
//     queue<int> q;
//     for (int i=0; i<n; i++) {
//         if (good[i]) {
//             q.push(i);
//             used[i] = 1;
//         }
//     }
//     while (sz(q)) {
//         int v = q.front();
//         q.pop();
//         for (int nxt:g[v]) {
//             if (used[nxt]==0) {
//                 used[nxt] = 1;
//                 q.push(nxt);
//             }
//         }
//     }
//
//
//     vector<int> answer(n);
//     for (int i=0; i<n; i++) {
//         if (good[i]) answer[i] = 1;
//         else if (used[i]) answer[i] = 1;
//     }
//
//     for (int i:answer) cout << i;
//
//
//
//     return 0;
// }






#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


vector<int> ans;
vector<int> now;
void gen(int i, int n, int ost, vector<int>& nums) {
    if (ost==1) {
        int mx = 0;
        for (int x=i; x<n; x++) mx = max(mx, nums[x]);
        now.push_back(mx);
        if (now < ans) ans = now;
        now.pop_back();
        return;
    }
    for (int len=1; len<=n; len++) {
        int nxt = i+len;
        if (n-nxt < (ost-1)) break;

        int mx = 0;
        for (int x=i; x<=i+len-1; x++) mx = max(mx, nums[x]);
        now.push_back(mx);
        gen(nxt, n, ost-1, nums);
        now.pop_back();
    }
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n, q;
    cin >> n >> q;
    vector<int> nums(n);
    for (int i=0; i<n; i++) cin >> nums[i];

    // for (int k=1; k<=n; k++) {
    //     ans.assign(k, 1e9);
    //     gen(0, n, k, nums);
    //     for (int i:ans) cout << i << ' ';
    //     cout << '\n';
    // }

    vector<vector<int>> anses(n+1);
    for (int k=1; k<=n; k++) {
        int st = 0;
        int ost = k;
        while (1) {
            if (ost==1) {
                int maxv = 0;
                for (int i=st; i<n; i++) maxv = max(maxv, nums[i]);
                anses[k].push_back(maxv);
                break;
            }
            if (ost == 2) {
                vector<int> maxr(n);
                maxr[n-1] = nums[n-1];
                for (int i=n-2; i>=0; i--) maxr[i] = max(maxr[i+1], nums[i]);

                int mxl = 0;
                pii ans = {1e9, 1e9};
                for (int i=st; i<n-1; i++) {
                    mxl = max(mxl, nums[i]);
                    pii now = {mxl, maxr[i+1]};
                    ans = min(ans, now);
                }
                anses[k].push_back(ans.first);
                anses[k].push_back(ans.second);
                break;
            }

            int mn = nums[st];
            int lastst = n-(ost-1);
            int nxt = st+1;
            for (int i=st+1; i<=lastst; i++) {
                if (nums[i]>nums[st]) break;
                if (nums[i]<mn) {
                    mn = nums[i];
                    nxt = i;
                }
            }

            anses[k].push_back(nums[st]);
            ost--; st = nxt;
        }
    }

    // for (int k=1; k<=n; k++) {
    //     for (int i:anses[k]) cout << i << ' ';
    //     cout << '\n';
    // }

    while (q--) {
        int a, b; cin >> a >> b;
        b--;
        cout << anses[a][b] << '\n';
    }


    return 0;
}