#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<bool> solo(n);
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') continue;
        solo[i] = true;
        if (i > 0 && s[i - 1] == '1') {
            solo[i] = false;
        }
        if (i < n - 1 && s[i + 1] == '1') {
            solo[i] = false;
        }
    }
    vector<int> g1, g2, g3;
    int c0 = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') continue;
        c0++;
        int cs = 0;
        if (i > 0) {
            cs += solo[i - 1];
        }
        if (i < n - 1) {
            cs += solo[i + 1];
        }
        if (cs == 2) {
            g1.push_back(i);
        }
        if (cs == 1) {
            g2.push_back(i);
        }
        if (cs == 0) {
            g3.push_back(i);
        }
    }
    map<int, vector<int>> idxs;
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        idxs[x].push_back(i);
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1' && !solo[i]) {
            cur++;
        }
    }
    vector<int> ans(q);
    if (c0 == n) {
        for (auto e : idxs[0]) {
            ans[e] = 0;
        }
        for (auto e : idxs[1]) {
            ans[e] = 0;
        }
        for (int i = 2; i <= n; i++) {
            for (auto e : idxs[i]) {
                ans[e] = i;
            }
        }
        for (auto e : ans) {
            cout << e << '\n';
        }
        return;
    }
    for (int i = 0; i <= c0; i++) {
        for (auto e : idxs[i]) {
            ans[e] = cur;
        }
        bool go = false;
        while (!g1.empty() && !go) {
            int j = g1.back();
            g1.pop_back();
            int cs = 0;
            if (j > 0) {
                cs += solo[j - 1];
            }
            if (j < n - 1) {
                cs += solo[j + 1];
            }
            if (cs == 1) {
                g2.push_back(j);
            } else if (cs == 0) {
                g3.push_back(j);
            } else {
                cur += 3;
                go = true;
                if (j > 0) {
                    solo[j - 1] = false;
                }
                if (j < n - 1) {
                    solo[j + 1] = false;
                }
            }
        }
        while (!g2.empty() && !go) {
            int j = g2.back();
            g2.pop_back();
            int cs = 0;
            if (j > 0) {
                cs += solo[j - 1];
            }
            if (j < n - 1) {
                cs += solo[j + 1];
            }
            if (cs == 0) {
                g3.push_back(j);
            } else {
                cur += 2;
                go = true;
                if (j > 0) {
                    solo[j - 1] = false;
                }
                if (j < n - 1) {
                    solo[j + 1] = false;
                }
            }
        }
        while (!g3.empty() && !go) {
            g3.pop_back();
            cur++;
            go = true;
        }
    }
    for (auto e : ans) {
        cout << e << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
