#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<int> col;
bool bad = false;
vector<int> ncomp;
vector<array<ll, 2>> pts;
int n;
ll r;

map<array<ll, 2>, int> ex;

void dfs(int u, int cl) {
    col[u] = cl;
    ncomp.push_back(u);
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = -r; dy <= r; dy++) {
            if (dx == 0 && dy == 0) continue;
            if (dx * dx + dy * dy <= r * r) {
                if (ex.count({pts[u][0] + dx, pts[u][1] + dy})) {
                    int v = ex[{pts[u][0] + dx, pts[u][1] + dy}];
                    if (col[v] == -1) {
                        dfs(v, cl ^ 1);
                    }
                    if (col[v] == col[u]) {
                        bad = true;
                    }
                }
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        pts.push_back({x, y});
        ex[{x, y}] = i;
    }
    col.resize(n, -1);
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            bad = false;
            ncomp.clear();
            dfs(i, 0);
            if (bad) {
                for (auto e : ncomp) {
                    ans[e] = 1;
                }
            }
        }
    }
    for (auto e : ans) {
        cout << e;
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
