#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<vector<int>> ans(n + 1);
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (!((mask >> 0) & 1)) {
            continue;
        }
        vector<int> c(n);
        int pst = 0;
        vector<int> b;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                pst = a[i];
                b.emplace_back(a[i]);
            }
            c[i] |= (a[i] <= pst);
        }
        pst = 0;
        for (int i = n - 1; i >= 0; --i) {
            if ((mask >> i) & 1) {
                pst = a[i];
            }
            c[i] |= (a[i] <= pst);
        }
        bool can = true;
        for (auto i : c) {
            can &= i;
        }
        int k = (int) b.size();
        if (can && (ans[k].empty() || ans[k] > b)) {
            ans[k] = b;
        }
    }
    ans[1] = {n};
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << ans[k][i] << '\n';
    }
    return 0;
}
