#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<int>> g;
vector<bool> used;
vector<int> comp;
vector<int> dp;
vector<bool> ans;
bool cycle = false;

void dfs(int v, int p = -1) {
    used[v] = true;
    comp.push_back(v);
    for (auto u : g[v]) {
        if (!used[u]) {
            dp[u] = dp[v] + 1;
            dfs(u, v);
        } else if (u != p) {
            if (dp[u] < dp[v] && dp[u] % 2 == dp[v] % 2) {
                cycle = true;
            }
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
    }
    auto dist = [&](int i, int j) {
        return (a[i].first - a[j].first) * 1ll * (a[i].first - a[j].first) + (a[i].second - a[j].second) * 1ll * (a[i].second - a[j].second);
    };
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                if (dist(i, j) <= r * 1ll * r) {
                    g[i].push_back(j);
                }
            }
        }
    }
    used.resize(n);
    dp.resize(n);
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.clear();
            cycle = false;
            dfs(i);
            if (cycle) {
                for (auto j : comp) {
                    ans[j] = true;
                }
            }
        }
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << "\n";
    return 0;
}