#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    cin >> a;
    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        --i;
        if (i < k - 1) {
            cout << a[i] << "\n";
        } else {
            cout << suf[i] << "\n";
        }
    }
    return 0;
}