#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define pi pair<int, int>
#define ff first
#define vb vector<bool>
#define ss second

struct pt {
	int x, y;
	pt() {
		x = 0;
		y = 0;
	}
	pt(int x, int y) : x(x), y(y) {

	}
	int len2() {
		return x * x + y * y;
	}
	
};

bool operator<(pt a, pt b) {
	if (a.x != b.x) return a.x < b.x;
	return a.y < b.y;
}

pt operator+(pt a, pt b) {
	return pt(a.x + b.x, a.y + b.y);
}
pt operator-(pt a, pt b) {
	return pt(a.x - b.x, a.y - b.y);
}

#define vpt vector<pt>

int n, rad;
vpt vec;

vvi graph;
bool ok = 0;
vb h;
vb used;
vi abob;
void dfs(int u) {
	abob.push_back(u);
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v]) {
			if (h[v] == h[u]) {
				ok = 1;
			}
		}
		else {
			h[v] = !h[u];
			dfs(v);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> rad;
	vec.assign(n, pt());
	graph.assign(n, vi());
	map<pt, int> id;
	for (int i = 0; i < n; i++) {
		cin >> vec[i].x >> vec[i].y;
		id[vec[i]] = i;
	}

	for (int i = 0; i < n; i++) {
		for (int dx = -rad; dx <= rad; dx++) {
			for (int dy = -rad; dy <= rad; dy++) {
				pt del(dx, dy);
				if (del.len2() > rad * rad || (!dx && !dy)) continue;
				pt t = vec[i] + del;
				if (id.count(t)) {
					int j = id[t];
					graph[i].push_back(j);
				}
			}
		}
	}

	used.assign(n, 0);
	h.assign(n, 0);
	vb tok(n);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			abob.clear();
			ok = 0;
			dfs(i);
			if (ok) {
				for (int a : abob) tok[a] = 1;
			}
		}
	}
	for (int el : tok) cout << el;
}