#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
struct vect {
    int x, y;

    vect() {

    }

    vect(int x, int y) : x(x), y(y) {

    }

};

inline int getdist(const vect& a, const vect& b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<short> g[10000];
vector<int> cd;
vector<bool> good;

void spread(int v) {
    good[v] = true;
    cd[v] = 0;
    for (auto w : g[v]) {
        if (!good[w]) {
            spread(w);
        }
    }
}

void dfs1(int v, int curc) {
    cd[v] = curc;
    for (auto w : g[v]) {
        if (cd[w] == -1) {
            dfs1(w, curc ^ 1);
            if (good[v]) return;
        }
    }
    for (auto w : g[v]) {
        if (cd[w] == cd[v]) {
            spread(v);
            return;
        }
    }
}

signed main() {
    fastio;
    int n, r;
    cin >> n >> r;
    vector<vect> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i].x >> v[i].y;
    g.resize(n);
    // build
    r *= r;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (getdist(v[i], v[j]) <= r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    // check
    cd.resize(n, -1);
    good.resize(n);
    for (int i = 0; i < n; ++i) {
        if (cd[i] == -1) {
            dfs1(i, 0);
        }
    }
    // output
    for (int i = 0; i < n; ++i) {
        if (!good[i]) cout << "0";
        else cout << "1";
    }
}
