#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)

signed main() {
    fastio;
    int r, c;
    cin >> r >> c;
    vector<vector<int>> mtr(r, vector<int>(c));
    for (auto& i : mtr) for (auto& j : i) cin >> j, j = r * c - j;
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, 1e18));
    for (int i = 0; i <= r; ++i) {
        dp[i][c] = 0;
    }
    for (int i = 0; i <= c; ++i) {
        dp[r][i] = 0;
    }
    vector<pair<int, int>> vp(r * c);
    for (int i = 0; i < r; ++i) for (int j = 0; j < c; ++j) vp[mtr[i][j]] = {i, j};
    auto calcinversions = [&](vector<int>& cur, int i, int j) {
        int addinv = 0;
        for (int i = 0; i < cur.size(); ++i) {
            for (int j = i + 1; j < cur.size(); ++j) {
                if (cur[i] < cur[j]) addinv++;
            }
        }
        sort(all(cur));
        int cp = 0;
        int cpe = 0;
        for (int k = 0; k < r * c; ++k) {
            if (cp == cur.size()) break;
            if (cur[cp] == k) {
                addinv += cpe;
                cp++;
            } else if (vp[k].first < i || vp[k].second < j) {
                cpe++;
            }
        }
        return addinv;
    };
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            // right
            vector<int> cur;
            for (int cj = j; cj < c; ++cj) cur.push_back(mtr[i][cj]);
            int inv = calcinversions(cur, i, j);
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + inv);
            // down
            cur.clear();
            for (int ci = i; ci < r; ++ci) cur.push_back(mtr[ci][j]);
            inv = calcinversions(cur, i, j);
            dp[i][j] = min(dp[i][j], dp[i][j + 1] + inv);
        }
    }
    cout << dp[0][0];
}