#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
constexpr int N = 3000000;
struct ft {
    int t[N];
    ft() {
        for (auto& i : t) i = 0;
    }

    void upd(int pos, int x) {
        pos++;
        while (pos < N) {
            t[pos] += x;
            pos += (pos & -pos);
        }
    }

    int get(int pos) {
        int res = 0;
        while (pos > 0) {
            res += t[pos];
            pos -= (pos & -pos);
        }
        return res;
    }

    int get(int l, int r) {
        return get(r + 1) - get(l);
    }

} t, t2;
signed main() {
    fastio;
    int r, c;
    cin >> r >> c;
    vector<vector<int>> mtr(r, vector<int>(c));
    for (auto& i : mtr) for (auto& j : i) cin >> j;
    if (r == 1) {
        vector<int> curord;
        int cc = 0, cr = 0;
        while (cr + 1 < r && cc + 1 < c) {
            if (mtr[cr + 1][cc] > mtr[cr][cc + 1]) {
                for (int j = cc; j < c; ++j) {
                    curord.push_back(mtr[cr][j]);
                }
                cr++;
            } else {
                for (int i = cr; i < r; ++i) {
                    curord.push_back(mtr[i][cc]);
                }
                cc++;
            }
        }
        if (cr + 1 == r) {
            for (int j = cc; j < c; ++j) curord.push_back(mtr[cr][j]);
        } else {
            for (int i = cr; i < r; ++i) curord.push_back(mtr[i][cc]);
        }
        int res = 0;
        for (auto x : curord) {
            res += t.get(r * c - x + 1);
            t.upd(r * c - x + 1, 1);
        }
        cout << res;
        exit(0);
    }
    int baseinv = 0;
    for (int i = 0; i < r; ++i) {
        if (mtr[i][0] > mtr[i][1]) baseinv++;
    }
    for (int cj = 0; cj < 2; ++cj) {
        t = ft();
        for (int i = 0; i < r; ++i) {
            baseinv += t.get(mtr[i][cj] + 1, c * r + 1);
            t.upd(mtr[i][cj], 1);
        }
    }
    t = ft();
    vector<int> rem(c);
    for (int i = r - 1; i >= 0; --i) {
        rem[i] = t.get(0, mtr[i][1]);
        t.upd(mtr[i][0], 1);
    }
    vector<int> dp2(r);
    t = ft();
    t2 = ft();
    int cres = 0;
    for (int i = r - 1; i >= 0; --i) {
        cres += t.get(mtr[i][1] + 1, c * r + 1);
        cres += t2.get(0, mtr[i][0] - 1);
        t.upd(mtr[i][0], 1);
        t2.upd(mtr[i][1], 1);
        dp2[i] = cres;
    }
    int bestans = 1e18;
    int sumrem = 0;
    for (int i = 0; i < r; ++i) {
        bestans = min(bestans, sumrem + dp2[i]);
        sumrem += rem[i];
    }
    bestans = min(bestans, sumrem);
    cout << bestans + baseinv;
}