#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll SZ = 1e5;
vector<ll> g[SZ];
ll used[SZ];
bool f;

void dfs(ll v, ll c) {
	used[v] = c;
	for (auto u : g[v]) {
		if (!used[u]) dfs(u, 3 - c);
		else if (used[u] == used[v]) {
			f = true;
			return;
		}
	}
	used[v] = 0;
}

void solve() {
	ll n, r, x, y;
	cin >> n >> r;
	vector<pii> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].fi >> a[i].se;
	}
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			ll dx = (a[i].fi - a[j].fi) * (a[i].fi - a[j].fi);
			ll dy = (a[i].se - a[j].se) * (a[i].se - a[j].se);
			if (dx + dy <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	for (ll i = 0; i < n; i++) {
		f = false;
		dfs(i, 1);
		if (f) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}