#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e18;

int sum(int r, vector <int>& tf) {
	r++;
	int ans = 0;
	while (r > 0) {
		ans += tf[r];
		r = (r & (r - 1));
	}
	return ans;
}

void add(int ind, int x, vector <int>& tf) {
	ind++;
	while (ind < tf.size()) {
		tf[ind] += x;
		ind = (ind | (ind - 1)) + 1;
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	vector <vector <int>> arr(n, vector <int>(m, 0));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j];
			arr[i][j]--;
		}
	}
	vector <vector <int>> dp(n + 1, vector <int>(m + 1, INF));
	dp[0][0] = 0;
	vector <int> tf(n * m + 1, 0);
	for (int i = 0; i <= n; i++) {
		tf.assign(n * m + 1, 0);
		for (int j = 0; j < i; j++) {
			for (int k = 0; k < m; k++) {
				add(arr[j][k], 1, tf);
			}
		}
		int all = m * i;
		for (int j = 0; j <= m; j++) {
			if (j != 0) {
				for (int k = i; k < n; k++) {
					add(arr[k][j - 1], 1, tf);
				}
				all += n - i;
			}
			if (i != n) {
				int cnt = 0;
				for (int k = j; k < m; k++) {
					cnt += all - sum(arr[i][k], tf);
				}
				for (int ii = j; ii < m; ii++) {
					for (int jj = ii + 1; jj < m; jj++) {
						if (arr[i][ii] > arr[i][jj]) {
							cnt++;
						}
					}
				}
				dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + cnt);
			}
			if (j != m) {
				int cnt = 0;
				for (int k = i; k < n; k++) {
					cnt += all - sum(arr[k][j], tf);
				}
				for (int ii = i; ii < n; ii++) {
					for (int jj = ii + 1; jj < n; jj++) {
						if (arr[ii][j] > arr[jj][j]) {
							cnt++;
						}
					}
				}
				dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + cnt);
			}
		}
	}
	int ans = min(dp[n][0], dp[0][m]);
	for (int i = 0; i < n; i++) {
		ans = min(ans, dp[i][m]);
	}
	for (int i = 0; i < m; i++) {
		ans = min(ans, dp[n][i]);
	}
	cout << ans << '\n';
}
