#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e18;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector <int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector <int> suf(n);
	for (int i = n - 1; i >= 0; i--) {
		if (i == n - 1) {
			suf[i] = arr[i];
		}
		else {
			suf[i] = max(suf[i + 1], arr[i]);
		}
	}
	for (int i = 0; i < q; i++) {
		int k, ind;
		cin >> k >> ind;
		if (ind < k) {
			cout << arr[ind - 1] << '\n';
		}
		else {
			cout << suf[k - 1] << '\n';
		}
	}
}
