#include <bits/stdc++.h>
using namespace std;
using ll = int64_t;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for (auto &u : a) {
        for (auto &e : u) {
            cin >> e;
        }
    }

    ll ans = 1e9;

    ll len = r + c;

    for (ll mask = 0; mask < (1 << len); ++mask) {
        vector<ll> tmp;

        bool f = true;

        ll ind = 0, jnd = 0;
        for (ll k = 0; k < len; ++k) {
            if (mask & (1 << k)) {
                if (ind >= r) {
                    f = false;
                    break;
                }
                for (ll i = jnd; i < c; ++i) {
                    tmp.push_back(a[ind][i]);
                }
                ++ind;
            } else {
                if (jnd >= c) {
                    f = false;
                    break;
                }
                for (ll i = ind; i < r; ++i) {
                    tmp.push_back(a[i][jnd]);
                }
                ++jnd;
            }
        }
        if (f) {
            ll cnt = 0;
            for (ll i = 0; i < tmp.size(); ++i) {
                for (ll j = i - 1; j >= 0; --j) {
                    cnt += (tmp[i] < tmp[j]);
                }
            }
            ans = min(ans, cnt);
        }
    }

    cout << ans << endl;
}