#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct V {
    ll x{};
    ll y{};
    int i;
};

ll dist(V a, V b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve() {
    int n;
    ll R;
    cin >> n >> R;
    vector <pair <int, int>> vec(n);
    //R *= R;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
        vec[i].second = i;
    }
    sort(all(vec));
    vector <int> ok(n);
    int l = 0, r = 0;
    for (int i = 0; i < n; ++i) {
        while (vec[i].first - vec[l].first > R) ++l;
        while (r < n && vec[r].first - vec[i].first <= R) ++r;
        if (r - l >= 3) ok[vec[i].second] = 1;
    }

    for (int i = 0; i < n; ++i) {
        if (ok[vec[i].second] == 0) {
            if (i > 0 && ok[vec[i - 1].second] && vec[i].first - vec[i - 1].first <= r) ok[vec[i].second] = 1;
        }
        if (ok[vec[i].second]) {
            if (i + 1 < n && vec[i + 1].first - vec[i].first <= r) ok[vec[i + 1].second] = 1;
        }
    }
    for (auto el : ok) cout << el;
}

int main() {
    int tt = 1;
    //cin >> tt;

    while (tt--) solve();

    return 0;
}
