#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct V {
    ll x{};
    ll y{};
    int i;
};

ll dist(V a, V b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve() {
    int n;
    ll R;
    cin >> n >> R;
    vector <pair <int, int>> vec(n);
    //R *= R;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
        vec[i].second = i;
    }
    sort(all(vec));
    vector <int> ok(n);
    int l = 0, r = 0;
    deque <int> d;
    for (int i = 0; i < n; ++i) {
        while (vec[i].first - vec[l].first > R) ++l;
        while (r < n && vec[r].first - vec[i].first <= R) ++r;
        if (r - l >= 3) ok[vec[i].second] = 1, d.push_back(i);
    }

    while (d.size()) {
        int v = d.front();
        d.pop_front();
        for (int u = v - 1; u >= 0; --u) {
            if (vec[v].first - vec[u].first > r || ok[u]) break;
            ok[u] = 1;
            d.push_back(u);
        }
        for (int u = v + 1; u < n; ++u) {
            if (vec[u].first - vec[v].first > r || ok[u]) break;
            ok[u] = 1;
            d.push_back(u);
        }
    }

    for (auto el : ok) cout << el;
}

int main() {
    int tt = 1;
    //cin >> tt;

    while (tt--) solve();

    return 0;
}
