#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

struct V {
    ll x{};
    ll y{};
    int i;
};

ll dist(V a, V b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector <V> vec(n);
    r *= r;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].x >> vec[i].y;
        vec[i].i = i;
    }

    /*vector <vector <int>> cnt(2 * n);
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dist(vec[i], vec[j]) <= r) {
                cnt[i * 2].push_back(2 * j + 1);
                cnt[i * 2 + 1].push_back(2 * j);
                cnt[j * 2].push_back(2 * i + 1);
                cnt[j * 2 + 1].push_back(2 * i);
            }
        }
    }*/
    vector <int> used(2 * n);
    vector <int> ok(n);
    int col = 1;
    bool ret = 0;
    int ve = 0;
    auto dfs = [&](auto self, int v)-> void {
        if (ret) return;
        if (ok[v / 2]) return;
        used[v] = col;
        int j = v / 2;
        if (used[2 * j] == used[2 * j + 1]) {
            ret = 1;
            ve = v;
            ok[j] = 1;
            return;
        }
        for (int i = 0; i < n; ++i) {
            int u = 2 * i + (v % 2 == 0);
            if (i == v / 2) continue;
            if (dist(vec[u / 2], vec[v / 2]) > r) continue;
            if (!used[u]) {
                self(self, u);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[2 * i]) {
            dfs(dfs, 2 * i);
            ++col;
            if (ret) {
                deque <int> d;
                d.push_back(ve);
                while (d.size()) {
                    int v = d.front();
                    d.pop_front();
                    for (int j = 0; j < n; ++j) {
                        int u = 2 * j + (v % 2 == 0);
                        if (j == v / 2) continue;
                        if (dist(vec[u / 2], vec[v / 2]) > r) continue;
                        if (used[u] != col) {
                            used[u] = col;
                            ok[u / 2] = 1;
                            d.push_back(u - 1);
                        }
                    }
                }
            }
            ++col;
            ret = 0;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ok[i];
    }
}

int main() {
    int tt = 1;
    //cin >> tt;

    while (tt--) solve();

    return 0;
}
