#include <bits/stdc++.h>

using namespace std;
using ll = long long;

using pt = array<ll, 2>;

ll dist(const pt &l, const pt &r) {
    return (l[0] - r[0]) * (l[0] - r[0]) + (r[1] - l[1]) * (r[1] - l[1]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll R;
    cin >> n >> R;
    vector<pt> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i] < a[j];
    });
    vector<set<int>> adj(n);
    constexpr int A = 4;
    for (int _ = 0; _ < 4; ++_) {
        set<pair<ll, int>> st; // {y, id}, remove when needed
        ll D = (R + 1) / 2; // be careful here
        if (_ >= 2) {
            D = R;
        }
        for (int x : ord) {
            auto [X, Y] = a[x];
            if (_ >= 2 || adj[x].size() < A) {
                auto it = st.lower_bound({Y - D, -1});
                while (true) {
                    if (it == st.end() || it->first > Y + D || _ < 2 && adj[x].size() >= A) {
                        break;
                    }
                    auto [y, j] = *it;
                    if (abs(a[j][0] - X) > D) {
                        it = st.erase(it);
                    } else {
                        if (dist(a[x], a[j]) <= R * R) {
                            adj[x].insert(j);
                            adj[j].insert(x);
                        } else {
                            assert(_ < 2);
                        }
                        ++it;
                    }
                }
            }
            if (_ < 2 || adj[x].size() < A) {
                st.insert({Y, x});
            }
        }
        reverse(ord.begin(), ord.end());
    }

    vector<int> col(n, -1);
    bool yay = true;
    vector<int> vis;
    vector<int> answer(n);
    auto dfs = [&](auto self, int v) -> void {
        vis.push_back(v);
        for (int to : adj[v]) {
            if (col[to] != -1) {
                if (col[to] == col[v]) {
                    yay = false;
                }
            } else {
                col[to] = col[v] ^ 1;
                self(self, to);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            vis.clear();
            yay = true;
            dfs(dfs, i);
            if (!yay) {
                for (int x : vis) {
                    answer[x] = true;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << answer[i];
    }
    cout << '\n';


    return 0;
}