#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> 

vector<vector<int>> tbl;
ordered_set st;
vector<vector<int>> precalc;

int addRow(int x, int y) {
    int res = 0;
    for(int i = 0; i+y<tbl[x].size(); ++i) {
        res += st.size()-st.order_of_key(tbl[x][i + y]);
        st.insert(tbl[x][i+y]);
    }
    return res;
}

void removeRow(int x, int y) {
    for(int i = 0; i+y<tbl[x].size(); ++i) {
        st.erase(tbl[x][i+y]);
    }
}

int addCol(int x, int y) {
    int res = 0;
    for(int i = 0; i+x<tbl.size(); ++i) {
        res += st.size()-st.order_of_key(tbl[i+x][y]);
        st.insert(tbl[i+x][y]);
    }
    return res;
}

void removeCol(int x, int y) {
    for(int i = 0; i+x<tbl.size(); ++i) {
        st.erase(tbl[i+x][y]);
    }
}

int gn(int x, int y) {
    int cntR = 0;
    int cntC = 0;
    if(x == tbl.size() - 1) {
        cntR = addRow(x, y);
        removeRow(x, y);
        return cntR;
    }
    if(y == tbl[x].size() - 1) {
        cntC = addCol(x, y);
        removeCol(x, y);
        return cntC;
    }
    cntR = addRow(x, y);
    cntR += gn(x + 1, y);
    removeRow(x, y);
    cntC = addCol(x, y);
    cntC += gn(x, y + 1);
    removeCol(x, y);
    return min(cntC, cntR);
}

signed main() {
    int n, m;
    cin >> n >> m;
    tbl.resize(n, vector<int>(m));
    for(auto& v : tbl) {
        for(auto& i : v) {
            cin >> i;
        }
    }
    cout << gn(0, 0);
    return 0;
}