#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>


struct pt {
    int x, y;

    pt() {
        x = 0;
        y = 0;
    }
};

ll sqrt_dist(pt a, pt b) {
    return ll(a.x - b.x) * ll(a.x - b.x) + ll(a.y - b.y) * ll(a.y - b.y);
}

vector<vector<int>> g;
vector<int> used;

vector<int> answer;

bool dfs(int v, int num) {
    used[v] = num;
    for (auto now : g[v]) {
        if (used[now] == num) return true;
        else if (used[now]) continue;
        int num2;
        if (num == 2) num2 = 1;
        if (num == 1) num2 = 2;
        if (dfs(now, num2)) return true;
    }
    return false;
}

void dfs2(int v, int z) {
    answer[v] = z;
    used[v] = 1;
    for (auto now : g[v]) {
        if (used[now]) continue;
        dfs2(now, z);
    }
}

void solve() {
    ll n, R;
    cin >> n >> R;
    g.resize(n + 1);
    vector<pt> a(n + 1);
    answer.resize(n + 1);
    vector<pii> z;
    for (int i = 1; i <= n; i++) {
        cin >> a[i].x >> a[i].y;
        z.push_back({a[i].x, i});
    }

    sort(all(z));

    vector<int> zn(n + 1);
    int l = 0, r = 0;
    while (r < n) {
        while (z[r].first - z[l].first > R) l++;
        if (r - l >= 2) {
            zn[l]++;
            zn[r + 1]--;
        }
        r++;
    }
    if (zn[0] > 0) {
        answer[z[0].second] = 1;
    }
    for (int i = 1; i < n; i++) {
        zn[i] += zn[i - 1];
        if (zn[i] > 0) {
            answer[z[i].second] = 1;
        }
    }
    for (int i = 1; i <= n; i++) cout << answer[i];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
