#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define int ll

ll INF = 1e9;

ll n, m;

void add(int x, vector<int> &f) {
    while (x <= (n * m)) {
        f[x]++;
        x += (x & -x);
    }
}

int calc(int x, vector<int> &f) {
    int res = 0;
    while (x) {
        res += f[x];
        x -= (x & -x);
    }
    return res;
}

void solve() {
    cin >> n >> m;
    vector<vector<int>> a(n + 1);
    vector<vector<int>> dp(n + 1);
    vector<vector<int>> right(n + 1);
    vector<vector<int>> down(n + 1);
    vector<vector<vector<int>>> f(n + 1);
    for (int i = 1; i <= n; i++) {
        a[i].resize(m + 1);
        f[i].resize(m + 1);
        dp[i].resize(m + 1, INF);
        right[i].resize(m + 1);
        down[i].resize(m + 1);
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            if (i == n && j == m) {
                dp[i][j] = 0;
                f[i][j].resize(n * m + 1);
                add(a[i][j], f[i][j]);
            } else if (i == n) {
                f[i][j] = f[i][j + 1];
                dp[i][j] = dp[i][j + 1] + calc(a[i][j], f[i][j]);
                add(a[i][j], f[i][j]);
            } else if (j == m) {
                f[i][j] = f[i + 1][j];
                dp[i][j] = dp[i + 1][j] + calc(a[i][j], f[i][j]);
                add(a[i][j], f[i][j]);
            } else {
                right[i][j] = right[i][j + 1];
                for (int h = j + 1; h <= m; h++) {
                    if (a[i][j] > a[i][h]) right[i][j]++;
                }

                down[i][j] = down[i + 1][j];
                for (int h = i + 1; h <= n; h++) {
                    if (a[i][j] > a[h][j]) down[i][j]++;
                }

                ll var1 = dp[i + 1][j] + right[i][j];
                ll var2 = dp[i][j + 1] + down[i][j];

                for (int h = j; h <= m; h++) {
                    var1 += calc(a[i][h], f[i + 1][j]);
                }

                for (int h = i; h <= n; h++) {
                    var2 += calc(a[h][j], f[i][j + 1]);
                }

                if (m - j <= n - i) {
                    f[i][j] = f[i + 1][j];
                    for (int h = j; h <= m; h++) {
                        add(a[i][h], f[i][j]);
                    }
                } else {
                    f[i][j] = f[i][j + 1];
                    for (int h = i; h <= n; h++) {
                        add(a[h][j], f[i][j]);
                    }
                }

                dp[i][j] = min(var1, var2);
            }
        }
    }
    cout << dp[1][1] << "\n";
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
