#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second

ll INF = 1e9;

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vector<int> pref(n + 2);
    vector<int> suf(n + 2);
    for (int i = 1; i <= n; i++) {
        pref[i] = max(pref[i - 1], a[i]);
    }
    for (int i = n; i >= 1; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        if (i < k) {
            cout << a[i] << "\n";
        } else {
            cout << suf[k] << "\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
