#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif


#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin,x.end()
#define rall(x) x.rbegin,x.rend()
#define ll long long
#define _ <<" "<<
#define forn(i, n) for (decltype(n) i = 0; i < n; i++)

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<vector<int> > st(__lg(n) + 1, vector<int>(n));
    forn(i, n) st[0][i] = a[i];
    for (int k = 1; k <= __lg(n); k++) {
        for (int i = 0; i + (1 << (k - 1)) < n; i++) {
            st[k][i] = max(st[k - 1][i], st[k - 1][i + (1 << (k - 1))]);
        }
    }

    auto get = [&](int l, int r) {
        int k = __lg(r - l + 1);
        return max(st[k][l], st[k][r - (1 << k) + 1]);
    };

    vector<int> ans(2, INT_MAX);
    for (int i = 0; i < n - 1; i++) {
        ans = min(ans, {get(0, i), get(i + 1, n - 1)});
    }

    forn(it, q) {
        int k, i;
        cin >> k >> i;
        cout << ans[i - 1] << nl;
    }
}

signed main() {
#ifdef LOCAL
    freopen("C:/work/IO/in.txt", "r", stdin);
    freopen("C:/work/IO/out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}
