#include <bits/stdc++.h>
#define ll long long
#define int long long
#define F first
#define S second
using namespace std;

struct Vector {
    ll x, y;

    void in() {
        cin >> x >> y;
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    ll len2() {
        return x * x + y * y;
    }
};

bool cmp(Vector a, Vector b) {
    return a.x < b.x;
}

const int inf = 1e9;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    vector<Vector> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    sort(a.begin(), a.end(), cmp);
    vector<bool> good(n);
    for (int i = 0; i < n - 2; ++i) {
        if ((a[i] - a[i + 2]).len2() <= r * r) {
            good[i] = good[i + 1] = good[i + 2] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        if ((good[i])) {
            continue;
        }
        if (i != 0 && good[i - 1] && (a[i] - a[i - 1]).len2() <= r * r) {
            good[i] = 1;
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        if ((good[i])) {
            continue;
        }
        if (i != 0 && good[i + 1] && (a[i] - a[i + 1]).len2() <= r * r) {
            good[i] = 1;
        }
    }
    for (bool i: good) {
        cout << i;
    }
    return 0;
}
