#include <iostream>
#include<map>
#include<vector>
#include<algorithm>
#pragma GCC optimize("Ofast", "unroll-loops")
using namespace std;

int cnt;
void dfs(int v, vector<vector<int>> &g, vector<pair<int, int>>&dist, int &cur_col, int p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first+1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, r;
    cin >> n >> r;
    vector<vector<int>> g(n);
    vector<pair<int, int>> P;
    map<pair<int,int>, int> d;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        P.push_back({x, y});
        d[{x, y}] = i;
    }
    for (int _ = 0; _ < n; ++_) {
        pair<int, int> wer = P[_];
        int x = wer.first;
        int y = wer.second;
        for (int i = y + r; i >= y - r; --i) {
            for (int j = 0; j *j <= r * r - (y - i) * (y - i); ++j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
            for (int j = -1; j *j <= r * r - (y - i) * (y - i); --j) {
                if (d.find({j + x, i}) != d.end() && d[{j + x, i}] != _) {
                    g[_].push_back(d[{j + x, i}]);
                }
            }
        }
    }
    int cur_color = 1;
    vector<int> ans;
    vector<pair<int, int>> dist(n);
    for (int i = 0; i < n; ++i) {
        if (dist[i].first == 0) {
            cnt = 0;
            dfs(i, g, dist, cur_color);
            ans.push_back(cnt);
            cur_color++;
        }
    }
    for (int i = 0;i < n; ++i) {
        cout<<ans[dist[i].second - 1];
    }
}