#include <iostream>
#include<set>
#include<vector>
#include<algorithm>
using namespace std;

int cnt;
int cc = 1;
vector<int>color;
void dfs(int v, vector<vector<int>> &g, vector<pair<int, int>>&dist, int cur_col, int p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first+1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}

signed main() {
    long long n, r;
    cin >> n >> r;
    vector<vector<int>> g(n);
    vector<pair<int, int>> P;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        P.push_back({x, y});
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((P[i].first - P[j].first) * (P[i].first - P[j].first) + (P[i].second - P[j].second) * (P[i].second - P[j].second) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    int cur_color = 1;
    vector<int> ans(n + 1);
    vector<pair<int, int>> dist(n);
    color.resize(n);
    for (int i = 0; i < n; ++i) {
        if (dist[i].second == 0) {
            cnt = 0;
            cc = cur_color;
            dfs(i, g, dist, cur_color);
            ans[cur_color] = cnt;
            cur_color++;

        }
    }
    for (int i = 0;i < n; ++i) {
        if (ans[dist[i].second]==1) {
            cout << 1;
        }
        else {
            cout << 0;
        }
    }
}