#include <iostream>
#include<set>
#include<vector>
#include<algorithm>
#pragma GCC optimize("Ofast")
using namespace std;

long long cnt;
void dfs(long long v, vector<vector<long long>> &g, vector<pair<long long, long long>>&dist, long long cur_col, long long p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first+1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, r;
    cin >> n >> r;
    vector<vector<long long>> g(n);
    vector<pair<long long, long long>> P;
    for (long long i = 0; i < n; ++i) {
        long long x, y;
        cin >> x >> y;
        P.push_back({x, y});
    }
    for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            if ((P[i].first - P[j].first) * (P[i].first - P[j].first) + (P[i].second - P[j].second) * (P[i].second - P[j].second) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    long long cur_color = 1;
    vector<long long> ans(n + 1);
    vector<pair<long long, long long>> dist(n);
    for (long long i = 0; i < n; ++i) {
        if (dist[i].first == 0) {
            cnt = 0;
            dfs(i, g, dist, cur_color);
            ans[cur_color] = cnt;
            cur_color++;
        }
    }
    for (long long i = 0;i < n; ++i) {
        if (ans[dist[i].second]==1) {
            cout << 1;
        }
        else {
            cout << 0;
        }
    }
}