#include <iostream>
#include<set>
#include<vector>
#include<algorithm>
#pragma GCC optimize("Ofast")
using namespace std;

long long cnt;
void dfs(long long v, vector<vector<long long>> &g, vector<pair<long long, long long>>&dist, long long &cur_col, long long p = -1) {

    if (p == -1) {
        dist[v].first = 1;
        dist[v].second = cur_col;
    }
    else {
        dist[v].first = dist[p].first+1;
        dist[v].second = cur_col;
    }
    for (auto u : g[v]) {
        if (dist[u].first == 0) {
            dfs(u, g, dist,cur_col, v);
        }
        else {
            if (dist[u].first % 2 == dist[v].first % 2) {
                cnt = 1;
            }
        }
    }
}

vector<long long> tree;

void change(long long v, long long l, long long r, long long ind, long long val) {
    if (r - l == 1) {
        tree[v]+=val;
        return;
    }
    long long m = r + l;
    m/=2;
    if (ind >= m) {
        change(2 * v + 1, m, r, ind, val);
    }
    else {
        change(2 * v, l, m, ind, val);
    }
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

long long f(long long v, long long l, long long r, long long need_l, long long need_r) {
    if (l >= need_l && r <= need_r) {
        return tree[v];
    }
    if (l >= need_r || r <= need_l) {
        return 0;
    }
    long long m = r + l;
    m /=2;
    return f(2 * v, l, m, need_l, need_r) + f(2 * v + 1, m, r, need_l, need_r);
}
long long ans= 1000000000;

long long calc_INV(vector<long long> &a) {
    long long inv = 0;
    tree.resize(4 * a.size());
    for (long long i = 0; i < a.size(); ++i) {
        inv += a[i] - 1 - f(1, 0, a.size(), 0, a[i]);
        change(1, 0, a.size(), a[i], 1);
    }
    return inv;
}

void find_ans(long long i, long long j, vector<vector<long long>> &a, vector<long long> &b) {
    if (i == a.size() || j == a[0].size()) {
        ans = min(ans, calc_INV(b));
        return;
    }
    for (long long q = j; q < a[0].size(); ++q) {
        b.push_back(a[i][q]);
    }
    find_ans(i + 1, j, a, b);
    for (long long q = j; q < a[0].size(); ++q) {
        b.pop_back();
    }
    for (long long q = i; q < a.size(); ++q) {
        b.push_back(a[q][j]);
    }
    find_ans(i, j + 1, a, b);
    for (long long q = i; q < a.size(); ++q) {
        b.pop_back();
    }
}
void solve_c() {
    long long r, c;
    cin >> r >> c;
    vector<vector<long long>> a(r, vector<long long>(c));
    for (long long i = 0; i < r; ++i) {
        for (long long j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    cout << calc_INV(a[0]);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve_c();
    return 0;
    long long n, r;
    cin >> n >> r;
    vector<vector<long long>> g(n);
    vector<pair<long long, long long>> P;
    for (long long i = 0; i < n; ++i) {
        long long x, y;
        cin >> x >> y;
        P.push_back({x, i});
    }

    sort(P.begin(), P.end());
    vector<long long> color(n);
    vector<long long> ans(n);
    long long current = 0;
    color[0] = 0;
    for (long long i = 0; i < P.size()- 1; ++i) {
        if (P[i + 1].first - P[i].first <= r) {
            color[i + 1] = current;
        }
        else {
            current++;
            color[i + 1] = current;
        }
    }
    for (long long i = 0; i < P.size() - 2; ++i) {
        if (P[i + 2].first - P[i].first <= r) {
            ans[color[i]] = 1;
        }
    }
    vector<long long> real(n);
    for (auto qwe:real) {
        cout<<qwe;
    }
    return 0;
    // for (long long i = 0; i < n; ++i) {
    //     for (long long j = i + 1; j < n; ++j) {
    //         if ((P[i].first - P[j].first) * (P[i].first - P[j].first) + (P[i].second - P[j].second) * (P[i].second - P[j].second) <= r * r) {
    //             g[i].push_back(j);
    //             g[j].push_back(i);
    //         }
    //     }
    // }
    // long long cur_color = 1;
    // vector<long long> ans;
    // vector<pair<long long, long long>> dist(n);
    // for (long long i = 0; i < n; ++i) {
    //     if (dist[i].first == 0) {
    //         cnt = 0;
    //         dfs(i, g, dist, cur_color);
    //         ans.push_back(cnt);
    //         cur_color++;
    //     }
    // }
    // for (long long i = 0;i < n; ++i) {
    //     if (ans[dist[i].second - 1]==1) {
    //         cout << 1;
    //     }
    //     else {
    //         cout << 0;
    //     }
    // }
}