#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int r, c;
    cin >> r >> c;

    vector<vector<int>> table(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> table[i][j];
        }
    }

    int best = INF;
    for (int mask = 0; mask < (1 << (r + c)); ++mask) {
        int cur_r = 0, cur_c = 0;
        vector<int> arr;
        for (int i = 0; i < r + c; ++i) {
            if ((mask >> i) & 1 && cur_r < r) {
                for (int p = cur_c; p < c; ++p) {
                    arr.push_back(table[cur_r][p]);
                }
                ++cur_r;
            } else if (cur_c < c) {
                for (int p = cur_r; p < r; ++p) {
                    arr.push_back(table[p][cur_c]);
                }
                ++cur_c;
            }
        }

        int res = 0;
        ordered_set s;
        for (int i = 0; i < r * c; ++i) {
            res += s.size() - s.order_of_key(arr[i]);
            s.insert(arr[i]);
        }
        best = min(best, res);
    }

    cout << best;

    return 0;
}