#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define ll long long
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> A(n, vector<int>(m));
    for (int i =0 ; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> A[i][j];
        }
    }
    vector<vector<int>> cnt1(n, vector<int>(m));
    vector<vector<int>> cnt2(n, vector<int>(m));
    vector<vector<int>> cnt3(n, vector<int>(m));
    vector<vector<int>> cnt4(n, vector<int>(m));
    vector<vector<int>> dp(n, vector<int>(m));
    for (int i = n - 1; i >= 0; i--){
        ordered_set temp;
        for (int j = m - 1; j >= 0; j--) {
            for (int k = i + 1; k < n; k++) {
                cnt2[i][j] += temp.size() - temp.order_of_key(A[k][j]);
            }
            int sd = temp.order_of_key(A[i][j]);
            cnt1[i][j] += sd;
            if (j != m - 1) {
                cnt3[i][j] = cnt3[i][j + 1];
            }
            cnt3[i][j] += sd;
            temp.insert(A[i][j]);
            for (int k = 0; k < i; k++) {
                cnt1[k][j] += temp.order_of_key(A[k][j]);
            }
        }
    }
    for (int j = m - 1; j >= 0; j--){
        ordered_set temp;
        for (int i = n - 1; i >= 0; i--) {
            int sd = temp.order_of_key(A[i][j]);
            temp.insert(A[i][j]);
            if (i != n - 1) {
                cnt4[i][j] = cnt4[i + 1][j];
            }
            cnt4[i][j] += sd;
        }
    }
    vector<vector<int>> cnt5(n, vector<int>(m));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (j == m - 1) {
                cnt5[i][j] = cnt1[i][j];
            }else {
                cnt5[i][j] = cnt5[i][j + 1] + cnt1[i][j] + cnt2[i][j];
            }
        }
    }
    vector<vector<int>> cnt6(n, vector<int>(m));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i == n - 1) {
                cnt6[i][j] = cnt1[i][j];
            }else {
                cnt6[i][j] = cnt6[i + 1][j] + cnt1[i][j] + (n - i - 1) * (m - i - 1) - cnt2[i][j];
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i == n - 1) {
                dp[i][j] = cnt3[i][j];
            }else if (j == m - 1) {
                dp[i][j] = cnt4[i][j];
            }else {
                dp[i][j] = min(dp[i + 1][j] + cnt5[i][j], dp[i][j + 1] + cnt6[i][j]);
            }
        }
    }
    cout << dp[0][0];
}//dp[i][j + 1] + cnt4[i][j] + cnt1[i][j] + (n - i - 1) * (m - i - 1) - cnt2[i + 1][j]);