#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Query {
	int k, ti, ind;
};

bool operator<(Query a, Query b) {
	if (a.k == b.k) return a.ti < b.ti;
	return a.k > b.k;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector <int> suffmax(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		suffmax[i] = max(suffmax[i + 1], a[i]);
	}

	vector <pair <int, int>> qs;
	vector <int> diffk;
	for (int i = 0; i < q; i++) {
		int k, ti;
		cin >> k >> ti;
		ti--;
		qs.push_back({ k, ti });
		diffk.push_back(k);
	}

	sort(diffk.begin(), diffk.end());
	diffk.resize(unique(diffk.begin(), diffk.end()) - diffk.begin());

	vector <vector <int>> ans(n + 1);
	for (auto ck : diffk) {
		vector <int> cres;
		int rst = n - ck;
		int i = 0;
		cres.push_back(a[i]);
		while (i < n - 1) {
			int mnval = a[i];
			int mnj = i + 1;
			if (cres.size() + 1 < ck) {
				for (int j = i + 1; j < min(n, i + rst + 2); j++) {
					if (a[j] > a[i]) break;
					if (a[j] < mnval) {
						mnval = a[j];
						mnj = j;
					}
				}
				rst -= mnj - i - 1;
				i = mnj;
				cres.push_back(a[i]);
			}
			else {
				for (int j = i + 1; j < min(n, i + rst + 2); j++) {
					if (a[j] > a[i]) break;
					int caj = suffmax[j];
					if (caj < mnval) {
						mnval = caj;
						mnj = j;
					}
				}
				rst -= mnj - i - 1;
				i = mnj;
				cres.push_back(suffmax[mnj]);
			}
		}
		i = cres.size();
		while (i > ck) {
			cres[i - 2] = max(cres[i - 2], cres[i - 1]);
			i--;
		}
		ans[ck] = cres;
	}

	for (auto [k, ti] : qs) {
		cout << ans[k][ti] << '\n';
	}
}
