#include <bits/stdc++.h>

using namespace std;

struct fenw {
    int n;
    vector<int> vec, used;
    fenw(int _n): n(_n), vec(_n + 1) {}
    void change(int x, int add) {
        for (; x <= n; x += x & -x) {
            if (vec[x] == 0) used.push_back(x);
            vec[x] += add;
        }
    }
    int get(int x) {
        int ans = 0;
        for (; x; x -= x & -x) {
            ans += vec[x];
        }
        return ans;
    }
    void clear() {
        for (auto elem : used)
            vec[elem] = 0;
        used.clear();
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    vector vec(n, vector<int> (m));
    vector dp(n + 1, vector<long long> (m + 1, 1e18));
    for (int i = 0; i < n; i++)
        dp[i][m] = 0;
    for (int j = 0; j < m; j++)
        dp[n][j] = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> vec[i][j];
    fenw f(n * m);
    for (int i = n - 1; i >= 0; i--) {
        dp[i][m - 1] = dp[i + 1][m - 1] + f.get(vec[i][m - 1]);
        f.change(vec[i][m - 1], 1);
    }
    f.clear();
    for (int j = m - 1; j >= 0; j--) {
        dp[n - 1][j] = dp[n - 1][j + 1] + f.get(vec[n - 1][j]);
        f.change(vec[n - 1][j], 1);
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++)
    //         cout << dp[i][j] << ' ';
    //     cout << '\n';
    // }
    for (int i = n - 1; i >= 0; i--) {
        f.clear();
        for (int j = m - 1; j >= 0; j--) {
            for (int ii = i; ii < n; ii++)
                f.change(vec[ii][j], 1);
            if (i) {
                long long res1 = dp[i][j];
                for (int jj = m - 1; jj >= j; jj--) {
                    res1 += f.get(vec[i - 1][jj]);
                    f.change(vec[i - 1][jj], 1);
                }
                dp[i - 1][j] = min(dp[i - 1][j], res1);
                for (int jj = m - 1; jj >= j; jj--) {
                    f.change(vec[i - 1][jj], -1);
                }
            }
            if (j) {
                long long res2 = dp[i][j];
                for (int ii = n - 1; ii >= i; ii--) {
                    res2 += f.get(vec[ii][j - 1]);
                    f.change(vec[ii][j - 1], 1);
                }
                dp[i][j - 1] = min(dp[i][j - 1], res2);
                for (int ii = n - 1; ii >= i; ii--)
                    f.change(vec[ii][j - 1], -1);
            }
        }
    }
    cout << dp[0][0] << '\n';
}