#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<ll>> g;
vector<ll> p, sz;
ll find(ll v) {
    if (p[v] == v) return v;
    return p[v] = find(p[v]);
}
void un(ll x, ll y) {
    x = find(x), y = find(y);
    if (x == y) return;
    if (sz[x] < sz[y]) swap(x, y);
    p[y] = x;
    sz[x] += sz[y];
}
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
struct node {
    ld x, y;
    ll pr, n;
    node *l, *r, *mn, *mx;
    node(ld x, ld y, ll n) : x(x), y(y), n(n), pr(rnd()), l(nullptr), r(nullptr), mn(this), mx(this) {}
};
node* gmin(node* root) {
    if (!root) return nullptr;
    return root->mn;
}
node* gmax(node* root) {
    if (!root) return nullptr;
    return root->mx;
}
node* Min(node* a, node* b) {
    if (!a) return b;
    if (!b) return a;
    if (a->y < b->y) return a;
    return b;
}
node* Max(node* a, node* b) {
    if (!a) return b;
    if (!b) return a;
    if (a->y > b->y) return a;
    return b;
}
void rec(node* root) {
    if (!root) return;
    root->mn = Min(Min(gmin(root->l), gmin(root->r)), root);
    root->mx = Max(Max(gmax(root->l), gmax(root->r)), root);
}
void split(node* root, node*& l, node*& r, ld x, ld y) {
    if (!root) l = r = nullptr;
    else if (pair<ld, ld>{root->x, root->y} < pair<ld, ld>{x, y}) split(root->r, root->r, r, x, y), l = root;
    else split(root->l, l, root->l, x, y), r = root;
    rec(root);
}
void merge(node*& root, node* l, node* r) {
    if (!l) root = r;
    else if (!r) root = l;
    else if (l -> pr < r -> pr) merge(l->r, l->r, r), root = l;
    else merge(r->l, l, r->l), root = r;
    rec(root);
}
void insert(node*& root, ld x, ld y, ll n) {
    node *t1 = nullptr, *t2 = nullptr;
    split(root, t1, t2, x, y);
    node *v = new node(x, y, n);
    merge(t1, t1, v);
    merge(root, t1, t2);
}
void erase(node*& root, ld x, ld y) {
    node *t1 = nullptr, *t2 = nullptr, *t3 = nullptr;
    split(root, t1, t2, x, y);
    split(t2, t2, t3, x, y + 0.1);
    merge(root, t1, t3);
}
vector<ll> ans, c;
void dfs(ll v) {
    for (auto to : g[v]) {
        if (c[to] == -1) c[to] = 1 - c[v], dfs(to);
        else if (c[to] == c[v]) ans[find(v)] = 1;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, r;
    cin >> n >> r;
    vector<ll> x(n), y(n);
    vector<ld> x1(n), y1(n), x2(n), y2(n), x3(n), y3(n);
    vector<pair<pair<ld, ld>, ll>> p1, p2, p3;
    for (ll i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        ld a1 = sqrtl(3), a2 = 2;
        x1[i] = x[i];
        y1[i] = y[i];
        x2[i] = (y1[i] * a1 - x1[i]) / a2;
        y2[i] = (x1[i] * a1 + y1[i]) / a2;
        x3[i] = (y1[i] * a1 + x1[i]) / a2;
        y3[i] = (x1[i] * a1 - y1[i]) / a2;
        p1.push_back({{x1[i], y1[i]}, i});
        p2.push_back({{-x2[i], y2[i]}, i});
        p3.push_back({{-x3[i], y3[i]}, i});
    }
    sort(p1.begin(), p1.end());
    sort(p2.begin(), p2.end());
    sort(p3.begin(), p3.end());
    g.resize(n);
    p.resize(n);
    sz.assign(n, 1);
    for (ll i = 0; i < n; ++i) p[i] = i;
    node* root = nullptr;
    for (auto v : p1) {
        ll i = v.second;
        vector<ll> a;
        node *t1 = nullptr, *t2 = nullptr;
        split(root, t1, t2, x2[i], 1e12);
        ll c = 0;
        while (t1) {
            node *mx = gmax(t1);
            if (mx->y + r < x3[i]) break;
            ll j = mx->n;
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                un(i, j);
                g[i].push_back(j);
                g[j].push_back(i);
                ++c;
            }
            if (c == 2) break;
            a.push_back(j);
            erase(t1, mx->x, mx->y);
        }
        for (auto j : a) insert(t1, x2[j], x3[j], j);
        merge(root, t1, t2);
        insert(root, x2[i], x3[i], i);
    }
    for (ll i = 0; i < n; ++i) erase(root, x2[i], x3[i]);
    root = nullptr;
    for (auto v : p2) {
        ll i = v.second;
        vector<ll> a;
        node *t1 = nullptr, *t2 = nullptr;
        split(root, t1, t2, x3[i], 1e12);
        ll c = 0;
        while (t1) {
            node *mx = gmax(t1);
            if (mx->y + r < x1[i]) break;
            ll j = mx->n;
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                un(i, j);
                g[i].push_back(j);
                g[j].push_back(i);
                ++c;
            }
            if (c == 2) break;
            a.push_back(j);
            erase(t1, mx->x, mx->y);
        }
        for (auto j : a) insert(t1, x3[j], x1[j], j);
        merge(root, t1, t2);
        insert(root, x3[i], x1[i], i);
    }
    for (ll i = 0; i < n; ++i) erase(root, x3[i], x1[i]);
    root = nullptr;
    for (auto v : p3) {
        ll i = v.second;
        vector<ll> a;
        node *t1 = nullptr, *t2 = nullptr;
        split(root, t1, t2, x1[i], -1e12);
        ll c = 0;
        while (t1) {
            node *mx = gmax(t1);
            if (mx->y + r < -x2[i]) break;
            ll j = mx->n;
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                un(i, j);
                g[i].push_back(j);
                g[j].push_back(i);
                ++c;
            }
            if (c == 2) break;
            a.push_back(j);
            erase(t1, mx->x, mx->y);
        }
        for (auto j : a) insert(t1, x1[j], -x2[j], j);
        merge(root, t1, t2);
        insert(root, x1[i], -x2[i], i);
    }
    ans.assign(n, 0);
    c.assign(n, -1);
    for (ll i = 0; i < n; ++i) {
        if (c[i] == -1) c[i] = 0, dfs(i);
    }
    for (ll i = 0; i < n; ++i) cout << ans[find(i)];
    cout << endl;
    return 0;
}