#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<unordered_map>
#include<map>

using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

#pragma GCC optimize("Ofast, O3")
#pragma GCC target("avx2")



void solve() {
	int n, q; cin >> n >> q;
	vector<int> a(n);
	for (int& i : a) cin >> i;
	vector<int> p(n), s(n);
	p[0] = a[0];
	for (int i = 1; i < n; ++i) {
		p[i] = max(a[i], p[i - 1]);
	}
	s[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		s[i] = max(a[i], s[i + 1]);
	}
	pair<int, int> ans = { n + 1, n + 1 };
	for (int i = 1; i < n; ++i) {
		pair<int, int> cur = { p[i - 1], s[i] };
		ans = min(ans, cur);
	}
	while (q--) {
		int k, i; cin >> k >> i;
		if (i == 1) cout << ans.first << '\n';
		else cout << ans.second << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG
	int t = 1;
	while (t--) solve();
}