#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;


template<typename T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& el : a) {
        out << el << " ";
    }
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& el : a) {
        in >> el;
    }
    return in;
}

#define all(x) x.begin(), x.end()

void solve() {
    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vll a;
    ll now = 0;
    ll cnt0 = 0;
    map<int, int> where;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            where[cnt0] = i;
            a.push_back(now);
            now = 0;
            cnt0++;
        } else {
            now++;
        }
    }
    a.push_back(now);
    int sz = a.size();
    vll add(n, 0);
    vll used(n, false);
    ll start = 0;
    for (int i = 0; i < sz; ++i) {
        if (a[i] >= 2) {
            start += a[i];
        }
    }
    // for (int i = 0; i < sz - 1; ++i) {
    //     if (a[i] == 1 && a[i + 1] == 1 && !used[i + 1]) {
    //         add[i] = 3;
    //         used[i] = 1;
    //         used[i + 1] = 1;
    //         add[i + 1] = 1;
    //     }
    // }
    vll left(n), right(n);
    for (int i = 0; i < sz; ++i) {
        if (i >= cnt0) {
            break;
        }
        left[where[i]] = a[i];

        right[where[i]] = 0;
        if (i + 1 < sz) {
            right[where[i]] = a[i + 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            continue;
        }
        used[i] = 1;
        ll radd = 1;
        if (left[i] == 1 && !used[i - 1]) {
            radd++;
            // used[i - 1] = 1;
        }
        if (right[i] == 1 && !used[i + 1]) {
            radd++;
            // used[i + 1] = 1;
        }
        if (radd == 3) {
            used[i] = 1;
            used[i - 1] = 1;
            used[i + 1] = 1;
            add[i] = radd;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1' || add[i] != 0) {
            continue;
        }
        // used[i] = 1;
        ll radd = 1;
        if (left[i] == 1 && !used[i - 1]) {
            radd++;
            used[i - 1] = 1;
        }
        if (right[i] == 1 && !used[i + 1]) {
            radd++;
            used[i + 1] = 1;
        }
        // if (radd == 3) {
        //     used[i - 1] = 1;
        //     used[i + 1] = 1;
        // }
        add[i] = radd;
    }
    // cout << add << endl;
    sort(add.rbegin(), add.rend());
    vll ps(n + 1);
    for (int i = 1; i <= n; ++i) {
        ps[i] = ps[i - 1] + add[i - 1];
    }
    while (q--) {
        ll k;
        cin >> k;
        cout << start + ps[k] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    solve();

    return 0;
}