#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;


template<typename T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& el : a) {
        out << el << " ";
    }
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& el : a) {
        in >> el;
    }
    return in;
}

#define all(x) x.begin(), x.end()

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vll a;
    ll now = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            a.push_back(now);
            now = 0;
        } else {
            now++;
        }
    }
    if (now != 0) {
        a.push_back(now);
    }
    // cout << a << endl;
    int sz = a.size();
    vll ps(sz + 1);
    for (int i = 1; i <= sz; ++i) {
        ps[i] = ps[i - 1] + a[i - 1];
    }
    // cout << ps << endl;
    while (q--) {
        ll k;
        cin >> k;
        if (k == 0) {
            ll ans = 0;
            for (int i = 0; i < sz; ++i) {
                if (a[i] >= 2) {
                    ans += a[i];
                }
            }
            if (ans >= 1) {
                cout << ans << "\n";
            } else {
                cout << 0 << "\n";
            }
        } else if (k == 1) {
            ll mx = *max_element(all(a));
            for (int i = 1; i < sz; ++i) {
                mx = max(mx, a[i] + a[i - 1] + 1);
            }
            if (mx > 1) {
                cout << mx << "\n";
            } else {
                cout << 0 << "\n";
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    solve();

    return 0;
}