#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using vll = vector<ll>;


template<typename T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& el : a) {
        out << el << " ";
    }
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& el : a) {
        in >> el;
    }
    return in;
}

#define all(x) x.begin(), x.end()

const ll INF = 1e18;

void solve() {
    ll n, q;
    cin >> n >> q;
    vll a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vll mxS(n);
    mxS[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        mxS[i] = max(mxS[i + 1], a[i]);
    }
    vll bOpt = {a[0], mxS[1]};
    ll mxP = a[0];
    for (int i = 0; i < n - 1; ++i) {
        mxP = max(mxP, a[i]);
        vll nxt = {mxP, mxS[i + 1]};
        if (nxt < bOpt) {
            bOpt = nxt;
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << bOpt[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    solve();

    return 0;
}