#include<bits/stdc++.h>
//#pragma GCC optimise("O3")
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define endl '\n'
typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;


const ll INF = 1e18;
const int N = 2e6;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<ll>> dp(m, vector<ll> (n, INF));
    vector<vector<int>> a(n, vector<int> (m));

    //vector<vector<ordered_set>> st(n, vector<ordered_set> (m));

    ll base = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];

            dp[i][j] = INF;

            for (int x1 = 0; x1 <= i; x1++) {
                for (int y1 = 0; y1 <= j; y1++) {
                    if (a[x1][y1] > a[i][j]) base++;
                }
            }
        }
    }

    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {

            for (int x = i; x < n; x++) {
                for (int y = j; y < m; y++) {
                    st[i][j].insert(a[x][y]);
                }
            }

            dp[j][i] = INF;
        }
    }*/

    ll ans = INF;
    dp[0][0] = 0;

    for (int v = 0; v < m; v++) {
        for (int g = 0; g < n; g++) {
            ll b = dp[v][g];

            int x = g, y = v;

            //cout << x << " " << y << " " << b << endl;

            ll w1 = 0;
            ordered_set s;
            for (int j = x; j < n; j++) {
                w1 += s.order_of_key(a[j][y]);

                for (int y1 = y + 1; y1 < m; y1++) s.insert(a[j][y1]);
            }

            if (v == m - 1) ans = min(ans, b + w1 + base);
            else dp[v + 1][g] = min(dp[v + 1][g], b + w1);


            ll w2 = 0;
            s.clear();
            for (int i = y; i < m; i++) {
                w2 += s.order_of_key(a[x][i]);

                for (int x1 = x + 1; x1 < n; x1++) s.insert(a[x1][i]);
            }

            if (g == n - 1) ans = min(ans, b + w2 + base);
            else dp[v][g + 1] = min(dp[v][g + 1], b + w2);

            //cout << w1 << " " << w2 << endl;
        }
    }

    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
