#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()

using namespace std;

const int N = 1e5 + 5;

struct Point {
    ll x, y;
};

Point p[N];
int ans[N], col[N], used[N], ff;
vector <int> g[N];
vector <pair<int, int>> mp[N];

void dfs_col(int i, int c) {
    used[i] = 1;
    col[i] = c;
    for (auto j:g[i]) {
        if (col[j] == c)
            ff = 1;
        if (!used[j])
            dfs_col(j, 3 - c);
    }
}

void dfs_ans(int i) {
    used[i] = 2;
    ans[i] = 1;
    for (auto j:g[i]) {
        if (used[j] != 2)
            dfs_ans(j);
    }
}

mt19937 rnd(time(0));

void solve() {
    int n, i, j, k, x, xx, y;
    ll r;
    cin >> n >> r;
    vector <int> u;
    for (i = 0; i < n; i++) {
        cin >> x >> y;
        p[i] = {x, y};
        u.pb(x);
    }
    sort(all(u));
    u.erase(unique(all(u)), u.end());
    map <int, int> re;
    for (i = 0; i < size(u); i++) {
        re[u[i]] = i + 1;
    }
    for (i = 0; i < n; i++) {
        mp[re[p[i].x]].pb({p[i].y, i});
    }
    for (i = 1; i <= size(u); i++) {
        sort(all(mp[i]));
    }
    for (i = 0; i < n; i++) {
        vector <int> v;
        vector <int> vv(r * 2 + 1);
        iota(all(vv), p[i].x - r);
        shuffle(all(vv), rnd);
        for (auto xx:vv) {
            if (re[xx] != 0) {
                x = re[xx];
                ld y1 = p[i].y - sqrt(r * r - (p[i].x - xx) * (p[i].x - xx));
                ld y2 = p[i].y + sqrt(r * r - (p[i].x - xx) * (p[i].x - xx));
                if (y1 == (int)y1)
                    j = lower_bound(all(mp[x]), make_pair((int)y1, -1)) - mp[x].begin();
                else
                    j = lower_bound(all(mp[x]), make_pair((int)y1 + 1, -1)) - mp[x].begin();
                while (j < size(mp[x]) && mp[x][j].first <= y2) {
                    if (mp[x][j].second != i)
                        v.pb(mp[x][j].second);
                    if (size(v) == 100)
                        break;
                    j ++;
                }
                if (size(v) == 100)
                    break;
            }
        }
        for (auto j:v) {
            g[i].pb(j);
        }
    }
    for (i = 0; i < n; i++) {
        if (!used[i]) {
            ff = 0;
            dfs_col(i, 1);
            if (ff)
                dfs_ans(i);
        }
    }
    for (i = 0; i < n; i++) {
        cout << ans[i];
    }
}

main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

