#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = int;
using pii = pair<int, int>;


#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,bmi,fma")


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
        }
    }


    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
    for (int i = 0; i < n; i++) {
        dp[i][m] = 0;
    }
    for (int j = 0; j < m; j++) {
        dp[n][j] = 0;
    }
    for (int cnti = n - 1; cnti >= 0; cnti--) {
        ordered_set os1;
        int mx1 = 0;
        for (int i = cnti + 1; i < n; i++) {
            os1.insert(a[i][m - 1]);
            mx1 = max(mx1, a[i][m - 1]);
        }
        ordered_set os2;
        int mx2 = 0;
        for (int cntj = m - 1; cntj >= 0; cntj--) {
            ll ans = 1e18;

            ll new_ans = 0;
            ordered_set os;
            int mx = 0;
            for (int j = cntj; j < m; j++) {
                if (a[cnti][j] < mx) {
                    int x = os.order_of_key(*os.upper_bound(a[cnti][j]));
                    new_ans += (j - cntj - x);
                }
                os.insert(a[cnti][j]);
                mx = max(a[cnti][j], mx);

                if (a[cnti][j] < mx1) {
                    new_ans += os1.order_of_key(*os1.upper_bound(a[cnti][j]));
                } else {
                    new_ans += os1.size();
                }
            }
            new_ans += dp[cnti + 1][cntj];
            ans = min(ans, new_ans);

            new_ans = 0;
            os.clear();
            mx = 0;
            for (int i = cnti; i < n; i++) {
                if (a[i][cntj] < mx) {
                    int x = os.order_of_key(*os.upper_bound(a[i][cntj]));
                    new_ans += (i - cnti - x);
                }
                os.insert(a[i][cntj]);
                mx = max(a[i][cntj], mx);

                if (a[i][cntj] < mx2) {
                    new_ans += os2.order_of_key(*os2.upper_bound(a[i][cntj]));
                } else {
                    new_ans += os2.size();
                }
            }
            new_ans += dp[cnti][cntj + 1];
            ans = min(ans, new_ans);

            dp[cnti][cntj] = ans;

            if (cntj != 0) {
                for (int i = cnti + 1; i < n; i++) {
                    os1.insert(a[i][cntj - 1]);
                    mx1 = max(mx1, a[i][cntj - 1]);
                }
            }
            for (int i = cnti; i < n; i++) {
                os2.insert(a[i][cntj]);
                mx2 = max(mx2, a[i][cntj]);
            }
        }
    }


    cout << dp[0][0];
}