#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;


int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	string s;
	cin >> s;
	set<pair<int, int>>pq;
	vector<int>added(n, -1);
	int cur = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			added[i] = 0;
			if (i > 0 && s[i - 1] == '1') {
				added[i] = 1;
				++cur;
			}
			else if (i + 1 < n && s[i + 1] == '1') {
				added[i] = 1;
				++cur;
			}
		}
	}
	vector<pair<int, int>>a;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') continue;
		int cnt_not_added = 0;
		if (i > 0 && added[i - 1] == 0) {
			++cnt_not_added;
		}
		if (i + 1 < n && added[i + 1] == 0) {
			++cnt_not_added;
		}
		a.push_back({ cnt_not_added, i });
	}
	sort(a.rbegin(), a.rend());
	vector<int>ans(n + 1);
	ans[0] = cur;
	int ind = 1;
	for (auto [x, i] : a) {
		x = 0;
		added[i] = 0;
		if (i > 0 && added[i - 1] != -1 || i < n - 1 && added[i + 1] != -1) {
			++x;
			added[i] = 1;
		}
		
		if (i > 0 && added[i - 1] == 0) {
			added[i - 1] = 1;
			++x;
		}
		if (i < n - 1 && added[i + 1] == 0) {
			added[i + 1] = 1;
			++x;
		}
		cur += x;
		ans[ind++] = cur;
	}
	while (q--) {
		int x;
		cin >> x;
		cout << ans[x] << "\n";
	}

	

	
}
