#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;


int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	string s;
	cin >> s;
	vector<int>added(n, -1);
	int cur = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			added[i] = 0;
			if (i > 0 && s[i - 1] == '1') {
				added[i] = 1;
				++cur;
			}
			else if (i + 1 < n && s[i + 1] == '1') {
				added[i] = 1;
				++cur;
			}
		}
	}
	vector<pair<int, int>>a(n);
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') continue;
		int cnt_not_added = 0;
		if (i > 0 && added[i - 1] == 0) {
			++cnt_not_added;
		}
		if (i + 1 < n && added[i + 1] == 0) {
			++cnt_not_added;
		}
		int res = -1;
		if (cnt_not_added > 0)res = cnt_not_added;
		else if (i > 0 && added[i - 1] > -1 || i + 1 < n && added[i + 1] > -1) res = 0;
		a[i] = { res, i };
	}
	set<pair<int, int>>pq;
	for (int i = 0; i < a.size(); ++i) {
		if (s[i] == '0')pq.insert(a[i]);
	}
	vector<int>ans(n + 1);
	ans[0] = cur;
	int ind = 1;
	while (!pq.empty()){
		auto [x, i] = *pq.rbegin();
		pq.erase({ x, i });
		x = 0;
		added[i] = 0;
		if (i > 0 && added[i - 1] != -1 || i < n - 1 && added[i + 1] != -1) {
			++x;
			added[i] = 1;
		}
		
		if (i > 0 && added[i - 1] == 0) {
			added[i - 1] = 1;
			++x;
		}
		if (i < n - 1 && added[i + 1] == 0) {
			added[i + 1] = 1;
			++x;
		}

		if (i > 0 && added[i - 1] == -1 && a[i - 1].first == -1) {
			pq.erase(a[i - 1]);
			a[i - 1].first = 0;
			pq.insert(a[i - 1]);
		}
		if (i < n - 1 && added[i + 1] == -1 && a[i + 1].first == -1) {
			pq.erase(a[i + 1]);
			a[i + 1].first = 1;
			pq.insert(a[i + 1]);
		}
		cur += x;
		ans[ind++] = cur;
	}
	while (q--) {
		int x;
		cin >> x;
		cout << ans[x] << "\n";
	}

	

	
}
