#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e4;

vector<int>fenv;

void add(int i, int x) {
	for (; i < fenv.size(); i += (i & (-i))) {
		fenv[i] += x;
	}
}

ll getsum(int i) {
	ll res = 0;
	for (; i > 0; i -= (i & (-i))) {
		res += fenv[i];
	}
	return res;
}

vector<vector<int>>b;
vector<int>mxsuf;

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	mxsuf.resize(n + 1);
	for (int i = n - 1; i >= 0; --i) {
		mxsuf[i] = max(mxsuf[i + 1], a[i]);
	}
	b.resize(n + 1, vector<int>(n));
	for (int k = 1; k <= n; ++k) {
		b[k].assign(k, n);
		for (int mask = 0; mask < (1 << n); ++mask) {
			int cnt = 0;
			for (int i = 0; i < n; ++i) {
				cnt += (mask >> i) & 1;
			}
			if (cnt != k) continue;
			if (!((mask >> (n - 1))&1)) continue;
			vector<int>b1(k);
			int mx = 0;
			int cur = 0;
			for (int i = 0; i < n; ++i) {
				mx = max(mx, a[i]);
				if ((mask >> i) & 1) {
					b1[cur] = mx;
					++cur;
					mx = 0;
				}
			}
			b[k] = min(b[k], b1);
		}
	}
	while (q--) {
		int k, i;
		cin >> k >> i;
		--i;
		cout << b[k][i] << "\n";
	}
}
