#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using dd = double;

struct point {
    ll x, y;

    bool operator< (const point& other) const {
        return x < other.x;
    }
};

int n, r;
vector <int> ans;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> r;
    ans.resize(n);
    vector <point> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].x;
        a[i].y = i;
    }

    sort(a.begin(), a.end());

    for (int i = 0; i < n - 2; i++) {
        if (a[i+2].x - a[i].x <= r) {
            ans[a[i].y] = 1;
            ans[a[i+1].y] = 1;
            ans[a[i+2].y] = 1;
        }
    }


    for (int i = n - 2; i >= 0; i--) {
        if (ans[a[i+1].y] && a[i+1].x - a[i].x <= r) {
            ans[a[i].y] = 1;
        }
    }

    for (int i = 1; i < n; i++) {
        if (ans[a[i-1].y] && a[i].x - a[i-1].x <= r) {
            ans[a[i].y] = 1;
        }
    }

    for (auto& i : ans) {
        cout << i;
    }

    cout << '\n';
}