#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;

int cur = 0;

vector<int> p;
vector<int> sz;

int get(int v) { return v == p[v] ? v : p[v] = get(p[v]); }
int siz(int v) { return (v < 0 || v >= sz(p) ? 0 : sz[get(v)]); }
void unite(int a, int b) {
    if (a < 0 || b < 0 || a >= sz(p) || b >= sz(p)) return;
    a = get(a), b = get(b);
    if (a == b) return;
    if (sz[b] <= 1) {
        sz[b] = 1;
        ++cur;
    }
    if (sz[a] <= 1) {
        sz[a] = 1;
        ++cur;
    }
    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    p[b] = a;
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, q;
    cin >> n >> q;
    str s;
    cin >> s;

    vector<int> ans(n + 1);

    p.resize(n);
    iota(all(p), 0);
    sz.resize(n);
    for (int i = 0; i < n; ++i) sz[i] = (s[i] == '1');

    vector<int> ord(n);
    iota(all(ord), 0);

    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') continue;
        bool bad = 1;
        if (i != 0 && s[i - 1] == '1') {
            unite(i, i - 1);
            bad = 0;
        }
        if (i != n - 1 && s[i + 1] == '1') {
            unite(i, i + 1);
            bad = 0;
        }
        ans[0] += !bad;
    }

    cur = ans[0];

    int id = 1;

    for (int k = 0; k < n; ++k) {
        if (s[ord[k]] == '0' && siz(ord[k] - 1) == 1 && siz(ord[k] + 1) == 1) {
            s[ord[k]] = '1';
            unite(ord[k] - 1, ord[k]);
            unite(ord[k], ord[k] + 1);
            ans[id++] = cur;
        }
    }

    for (int k = 0; k < n; ++k) {
        if (s[ord[k]] == '0' && (siz(ord[k] - 1) == 1 || siz(ord[k] + 1) == 1)) {
            s[ord[k]] = '1';
            if (siz(ord[k] - 1) != 0)
                unite(ord[k] - 1, ord[k]);
            if (siz(ord[k] + 1) != 0)
                unite(ord[k], ord[k] + 1);
            ans[id++] = cur;
        }
    }

    while (id <= n) {
        ans[id] = ans[id - 1] + 1;
        ++id;
    }

    bool flag = 1;
    for (auto el : s) if (el == '1') flag = 0;
    if (flag) ans[1] = 0;

    for (int _i = 0; _i < q; ++_i) {
        int k;
        cin >> k;
        cout << ans[k] << '\n';
    }

    return 0;
}