#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;

struct vec {
    int x, y;
    vec() { x = y = 0; }
    vec(int _x, int _y) { x = _x; y = _y; }
    vec operator-(vec a) { return vec(x - a.x, y - a.y); }    
    int operator*(vec a) { return x * a.x + y * a.y; }
    int operator%(vec a) { return x * a.y - y * a.x; }
};

int len2(vec a) { return a * a; }
int dist2(vec a, vec b) { return len2(b - a); }

int n, r;
vector<int> col, ans;
vector<vec> a;

bool dfs(int v, int c, bool fnd) {
    col[v] = c;
    for (int to = 0; to < n; ++to) {
        if (to == v) continue;
        if (dist2(a[v], a[to]) > r * r) continue;
        if (col[to] == col[v]) fnd = 1;
        if (col[to] == -1)
            fnd |= dfs(to, c ^ 1, fnd);
    }
    ans[v] = fnd;
    return fnd;
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    cin >> n >> r;
    a.resize(n);
    for (auto &el : a) cin >> el.x >> el.y;

    col.resize(n, -1);
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            dfs(i, 0, 0);
        }
    }

    for (auto el : ans) cout << el;

    return 0;
}