#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int getpr(string &s, int i, int n) {
    if (s[i] == '1') {
        return 100;
    }
    if (s[i + 1] == '0' && s[i - 1] == '0') {
        return 2;
    }
    if (i - 2 >= 0 && i + 2 < s.size() && s[i - 1] == '1' && s[i - 2] == '0' && s[i + 1] == '1' && s[i + 2] == '0') {
        return 0;
    }
    if (i - 2 >= 0 && s[i - 1] == '1' && s[i - 2] == '0') {
        return 1;
    }
    if (i + 2 < s.size() && s[i + 1] == '1' && s[i + 2] == '0') {
        return 1;
    }
    return 2;
}

int upd(string &s, int i) {
    if (i < 0 || i >= s.size()) {
        return 0;
    }
    if (s[i] == '0') {
        return 0;
    }
    if (i != 0 && s[i - 1] == '1') {
        return 1;
    }
    if (i + 1 < s.size() && s[i + 1] == '1') {
        return 1;
    }
    return 0;
}

int main()
{
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    s = "0" + s + "0";
    vector<pair<int, int>> qs(m);
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        qs[i] = {x, i};
    }
    sort(qs.begin(), qs.end());
    if (n == 1) {
        for (int i = 0; i < m; i++) {
            cout << "0" << '\n';
        }
        return 0;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (s[i] == '1' && (s[i - 1] == '1' || s[i + 1] == '1')) {
            ans++;
        }
    }
    int cur = 0;
    vector<int> res(m);
    vector<int> prts(n + 2, 100);
    for (int i =1; i <= n; i++) {
        prts[i] = getpr(s, i, n);
    }
    for (auto [x, id] : qs) {
        while (cur < x) {
            cur++;
            int pr = 10000, it = -1;
            for (int i = 1; i <= n; i++) {
                if (prts[i] < pr) {
                    pr = prts[i];
                    it = i;
                }
            }
            ans -= upd(s, it - 1);
            ans -= upd(s, it);
            ans -= upd(s, it + 1);
            s[it] = '1';
            ans += upd(s, it - 1);
            ans += upd(s, it);
            ans += upd(s, it + 1);
            for (int i = -2; i <= 2; i++) {
                if (it + i >= 0 && it + i < s.size()) {
                    prts[it + i] = getpr(s, it + i, n);
                }
            }
        }
        res[id] = ans;
    }
    for (auto i : res) {
        cout << i << '\n';
    }

    return 0;
}