#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, r, dr;
vector<pair<int, int>> f;
vector<signed char> can;
map<pair<int, int>, vector<int>> d;
vector<bool> used;
map<int, int> tim;

bool jump(int a, int b)
{
    return (f[a].first - f[b].first) * (f[a].first - f[b].first) + (f[a].second - f[b].second) * (f[a].second - f[b].second) <= r * r;
}

bool dfs_A(int v, int depth, int start)
{
//    cout << "V=" << v << '\n';
    used[v] = 1;
    tim[v] = depth;
    if (can[v] != 0)
    {
//        exit(179);
        return can[v];
    }
    pair<int, int> p = {f[v].first / dr, f[v].second / dr};
    for (auto [dx, dy] : vector<pair<int, int>>({
        {-2,-2},{-2,-1},{-2,0},{-2,1},{-2,2},{-1,-2},{-1,-1},{-1,0},{-1,1},{-1,2},{0,-2},{0,-1},{0,0},{0,1},{0,2},{1,-2},{1,-1},{1,0},{1,1},{1,2},{2,-2},{2,-1},{2,0},{2,1},{2,2}
    }))
    {
        pair<int, int> q = {p.first + dx, p.second + dy};
//        if (d[q].size() > 2)
//        {
////            cout << "A\n";
//            return true;
//        }
        for (int to : d[q])
        {
            if (!jump(v, to))
            {
                continue;
            }
            if (can[to] != 0)
            {
//                cout << "TO=" << to << ' ' << "CAN=" << can[to] << '\n';
//                exit(57);
                return can[to];
            }
            if (tim.find(to) != tim.end() &&
                v != to &&
                (depth + 1 - tim[to]) % 2 == 1)
            {
//                cout << to << '\n';
//                cout << "B\n";
                return true;
            }
            if (!used[to] && jump(v, to))
            {
                if (dfs_A(to, depth + 1, start))
                {
                    return true;
                }
            }
        }
    }
    return false;
}
void dfs_B(int v, int value)
{
    assert(value != 0);
    can[v] = value;
    pair<int, int> p = {f[v].first / dr, f[v].second / dr};
    for (auto [dx, dy] : vector<pair<int, int>>({
        {-2,-2},{-2,-1},{-2,0},{-2,1},{-2,2},{-1,-2},{-1,-1},{-1,0},{-1,1},{-1,2},{0,-2},{0,-1},{0,0},{0,1},{0,2},{1,-2},{1,-1},{1,0},{1,1},{1,2},{2,-2},{2,-1},{2,0},{2,1},{2,2}
    }))
    {
        pair<int, int> q = {p.first + dx, p.second + dy};
//        if (d[q].size() <= 2)
        {
            for (int to : d[q])
            {
                if (can[to] == 0 && jump(v, to))
                {
                    dfs_B(to, value);
                }
            }
        }
    }
}


signed main()
{
    cin.tie(NULL);
    cin.sync_with_stdio(false);
    cin >> n >> r;
    dr = 5*r ;//r / 1.9;
    if (r == 1)
    {
        dr = 1;
    }
    f.resize(n);
    can.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> f[i].first >> f[i].second;
        can[i] = 0;
        d[{f[i].first / dr, f[i].second / dr}].push_back(i);
    }

//    if (r != 1)
//    {
//        for (auto &i : d)
//        {
//            if (i.second.size() > 2)
//            {
//                for (auto x : i.second)
//                {
//                    can[x] = 1;
//                    used[x] = 1;
//                }
//            }
//        }
//    }

    for (int i = 0; i < n; ++i)
    {
        if (can[i] == 0)
        {
            bool res = dfs_A(i, 0, i);
//            cout << "I=" << i << " Can=" << res << '\n';
            dfs_B(i, res * 2 - 1);
        }
    }

    for (int i = 0; i < n; ++i)
    {
        assert(can[i] != 0);
        cout << (can[i] + 1) / 2;
    }
    cout << '\n';

    return 0;
}
