#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

struct Point {
    ll x, y;

    Point() { }

    Point(ll x, ll y)
        : x(x)
        , y(y)
    {
    }
};

ll qlen(Point a, Point b)
{
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

int n;
ll qr;
vector<vector<int>> g;
vector<Point> a;
vector<int> mark, h;
bool flag;
vector<int> cur;

void dfs(int u, int p, int l)
{
    h[u] = l;
    mark[u] = 1;
    cur.push_back(u);
    for (int v : g[u]) {
        if (v == p)
            continue;
        if (mark[v] == 1 && ((h[u] - h[v]) & 1) == 0)
            flag = true;
        if (!mark[v])
            dfs(v, u, l + 1);
    }
    mark[u] = 2;
}

void solve()
{
    int r;
    cin >> n >> r;
    qr = (ll)r * r;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
    g.resize(n);
    mark.resize(n, 0);
    h.resize(n);
    for (int i = 0; i < n - 1; i++)
        for (int j = i + 1; j < n; j++)
            if (qlen(a[i], a[j]) <= qr) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (!mark[i]) {
            cur.resize(0);
            flag = false;
            dfs(i, i, 0);
            for (int j : cur)
                ans[j] = flag;
        }
    }
    for (int i : ans)
        cout << i;
    cout << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
