#include <bits/stdc++.h>
#define len(x) (int)x.size()
#define ll long long
#define all(x) x.begin(), x.end()
#define ld long double

using namespace std;

void print(vector<int> &a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

struct pnt {

    ll x, y;

    pnt() {

    }

    pnt(ll x_, ll y_) {
        x = x_;
        y = y_;
    }

    pnt operator-(const pnt &oth) {
        return {x - oth.x, y - oth.y};
    }

    ll getdist2() {
        return x * x + y * y;
    }

};

vector<vector<int>> g;
vector<int> col;
vector<bool> good;
vector<int> vis;
bool fl = false;

void dfs(int cur, int curcol) {
    fl |= good[cur];
    vis.push_back(cur);
    col[cur] = curcol;
    for (auto x : g[cur]) {
        if (col[x] == -1) {
            dfs(x, curcol ^ 1);
        }
        else if (col[x] == curcol) {
            fl = true;
        }
    }
}

void solve() {
    // cout << (pnt(7, 3) - pnt(2, 2)).getdist2() << '\n';
    int n;
    ll r;
    cin >> n >> r;
    vector<pnt> a(n);
    map<pair<int, int>, vector<int>> mp;
    map<pair<int, int>, int> ind;
    int nr = max(1, (int)(r / (ld)sqrt(2)));
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        mp[{a[i].x / nr, a[i].y / nr}].push_back(i);
    }
    if (r == 1 || n <= 2) {
        cout << string(n, '0') << '\n';
        return;
    }
    for (auto &[x, inds] : mp) {
        ind[x] = len(ind);
    }

    auto check = [&](pnt x, pnt y) {
        return (x - y).getdist2() <= r * r;
    };

    col.resize(n, -1);
    g.resize(n);
    good.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (check(a[i], a[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    // for (auto x : g) {
        // print(x);
    // }
    // cout << '\n';
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            fl = false;
            vis.clear();
            dfs(i, 0);
            if (fl) {
                for (auto x : vis) {
                    good[x] = true;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (good[i]) {
            cout << '1';
        }
        else {
            cout << '0';
        }
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}