#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int MAXN = 1e5, INF = 1e9;
vector<pair<int, int> > Tr[MAXN * 4];

void build(vector<pair<int, int> > &a, int l, int r, int ndx) {
    if (l + 1 == r) {
        Tr[ndx] = {a[l]};
        return;
    }
    build(a, l, (r + l) / 2, ndx * 2 + 1);
    build(a, (r + l) / 2, r, ndx * 2 + 2);
    Tr[ndx].resize(r - l);
    merge(all(Tr[ndx * 2 + 1]), all(Tr[ndx * 2 + 2]), Tr[ndx].begin());
}

int get(int L, int R, int lx, int rx, int l, int r, int ndx) {
    if (L >= r || l >= R)
        return 0;
    if (L <= l && r <= R) {
        return upper_bound(all(Tr[ndx]), make_pair(rx, INF))
               - lower_bound(all(Tr[ndx]), make_pair(lx, 0));
    }
    return get(L, R, lx, rx, l, (r + l) / 2, ndx * 2 + 1)
           + get(L, R, lx, rx, (r + l) / 2, r, ndx * 2 + 2);
}


void get1(int L, int R, int lx, int rx, int l, int r, int ndx, vector<int> &a) {
    if (L >= r || l >= R)
        return;
    if (L <= l && r <= R) {
        auto it = lower_bound(all(Tr[ndx]), make_pair(lx, 0));
        auto it1 = upper_bound(all(Tr[ndx]), make_pair(rx, INF));
        while (it != it1) {
            a.push_back(it->second);
            it++;
        }
        return;
    }
    get1(L, R, lx, rx, l, (r + l) / 2, ndx * 2 + 1, a);
    get1(L, R, lx, rx, (r + l) / 2, r, ndx * 2 + 2, a);
}

void dfs(int s, vector<vector<int> > &g, vector<int> &u, vector<int> &is) {
    u[s] = 1;
    for (int i: g[s]) {
        if (!u[i]) {
            is[i] = 1;
            dfs(i, g, u, is);
        }
    }
}

void dfs1(int s, vector<vector<int> > &g, vector<int> &u, vector<int> &is) {
    for (int i: g[s]) {
        if (u[i] == 0) {
            u[i] = 3 - u[s];
            dfs1(i, g, u, is);
        } else if (u[i] == u[s]) {
            is[s] = 1;
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    vector<array<ll, 3> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i][0] >> v[i][1];
        v[i][2] = i;
    }
    auto v1 = v;
    sort(all(v));
    vector<pair<int, int> > a;
    for (auto [x, y, ind]: v)
        a.push_back({y, ind});

    build(a, 0, n, 0);
    vector<vector<int> > g(n), g1(n);
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < n; j++)
    //         g1[i].push_back(j);
    // }
    vector<int> is(n);
    int p = 0, p1 = 0;
    for (auto [x, y, ind]: v) {
        while (v[p][0] < x - r)
            p++;
        while (p1 < n && v[p1][0] <= x + r)
            p1++;
        if (get(p, p1, y - r, y + r, 0, n, 0) >= 50)
            is[ind] = 1;
        else {
            get1(p, p1, y - r, y + r, 0, n, 0, g1[ind]);
        }
    }
    v = v1;
    for (int i = 0; i < n; i++) {
        for (int j: g1[i]) {
            if ((v[i][0] - v[j][0]) * (v[i][0] - v[j][0])
                + ((v[i][1] - v[j][1])) * ((v[i][1] - v[j][1])) <= r * r && i != j) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> u(n);
    for (int i = 0; i < n; i++) {
        if (!u[i] && is[i]) {
            dfs(i, g, u, is);
        }
    }
    u.clear();
    u.resize(n);
    for (int i = 0; i < n; i++) {
        if (u[i] == 0) {
            u[i] = 1;
            dfs1(i, g, u, is);
        }
    }
    u.clear();
    u.resize(n);
    for (int i = 0; i < n; i++) {
        if (!u[i] && is[i]) {
            dfs(i, g, u, is);
        }
    }
    for (int i: is)
        cout << i;
    cout << '\n';
}
