#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {

    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int MAXN = 2e6 + 1;
int F[MAXN];

int get(int x) {
    int s = 0;
    while (x) {
        s += F[x];
        x -= x & (-x);
    }
    return s;
}

void add(int x) {
    while (x < MAXN) {
        F[x]++;
        x += x & (-x);
    }
}

int F1[MAXN];

int get1(int x) {
    int s = 0;
    while (x) {
        s += F1[x];
        x -= x & (-x);
    }
    return s;
}

void add1(int x) {
    while (x < MAXN) {
        F1[x]++;
        x += x & (-x);
    }
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll> > a(r, vector<ll>(c));
    for (auto &i: a) {
        for (auto &j: i)
            cin >> j;
    }
    if (r > c) {
        vector<vector<ll> > a1(c, vector<ll>(r));
        for (ll i = 0; i < r; i++) {
            for (ll j = 0; j < c; j++)
                a1[j][i] = a[i][j];
        }
        swap(a, a1);
        swap(r, c);
    }
    vector<vector<ll> > dp(r + 1, vector<ll>(c + 1, 1e18));
    vector<vector<ll> > go(r, vector<ll>(c)), go1(r, vector<ll>(c));
    for (ll i = 0; i < r; i++) {
        ll s = 0;
        fill(F, F + MAXN, 0);
        fill(F1, F1 + MAXN, 0);
        for (ll j = c - 1; j >= 0; j--) {
            s += get1(a[i][j]);
            add1(a[i][j]);
            add(a[i][j]);
            for (ll k = i + 1; k < r; k++) {
                s += (c - j) - get(a[k][j]);
                add1(a[k][j]);
            }
            go[i][j] = s;
        }
    }
    dp[0][0] = 0;
    for (ll i = 0; i < r; i++) {
        fill(F, F + MAXN, 0);
        for (ll j = c - 1; j >= 0; j--) {
            ll s = 0;
            for (ll k = r - 1; k >= i; k--) {
                s += get(a[k][j]);
                add(a[k][j]);
            }
            go1[i][j] = s;
        }
    }
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            dp[i][j + 1] = min(dp[i][j + 1], go1[i][j] + dp[i][j]);
            dp[i + 1][j] = min(dp[i + 1][j], go[i][j] + dp[i][j]);
        }
    }
    ll ans = 1e18;
    for (ll i = 0; i < r; i++)
        ans = min(ans, dp[i][c]);
    for (ll j = 0; j < c; j++)
        ans = min(ans, dp[r][j]);
    cout << ans << '\n';
}