#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int MAXN = 600 * 600 + 1;
int F[MAXN];

int get(int x) {
    int s = 0;
    while (x) {
        s += F[x];
        x -= x & (-x);
    }
    return s;
}

void add(int x) {
    while (x < MAXN) {
        F[x]++;
        x += x & (-x);
    }
}

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int> > a(r, vector<int>(c));
    for (auto &i: a) {
        for (auto &j: i)
            cin >> j;
    }
    vector<vector<ll> > dp(r + 1, vector<ll>(c + 1, 1e18));
    vector<vector<ll> > go(r, vector<ll>(c)), go1(r, vector<ll>(c));
    for (int j = 0; j < c; j++) {
        fill(F, F + MAXN, 0);
        for (int i = r - 1; i >= 0; i--) {
            int s = 0;
            for (int k = c - 1; k >= j; k--) {
                s += get(a[i][k]);
                add(a[i][k]);
            }
            go[i][j] = s;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i < r; i++) {
        fill(F, F + MAXN, 0);
        for (int j = c - 1; j >= 0; j--) {
            int s = 0;
            for (int k = r - 1; k >= i; k--) {
                s += get(a[k][j]);
                add(a[k][j]);
            }
            go1[i][j] = s;
        }
    }
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            dp[i][j + 1] = min(dp[i][j + 1], go1[i][j] + dp[i][j]);
            dp[i + 1][j] = min(dp[i + 1][j], go[i][j] + dp[i][j]);
        }
    }
    ll ans = 1e18;
    for (int i = 0; i < r; i++)
        ans = min(ans, dp[i][c]);
    for (int j = 0; j < c; j++)
        ans = min(ans, dp[r][j]);
    cout << ans << '\n';
}