#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const int D = 600 + 1;
const int MAXN = D * D + 1;
int F[MAXN];

int get(int x) {
    int s = 0;
    while (x) {
        s += F[x];
        x -= x & (-x);
    }
    return s;
}

void add(int x) {
    while (x < MAXN) {
        F[x]++;
        x += x & (-x);
    }
}

int F1[MAXN];

int get1(int x) {
    int s = 0;
    while (x) {
        s += F1[x];
        x -= x & (-x);
    }
    return s;
}

void add1(int x) {
    while (x < MAXN) {
        F1[x]++;
        x += x & (-x);
    }
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll> > a(r, vector<ll>(c));
    for (auto &i: a) {
        for (auto &j: i)
            cin >> j;
    }
    if (r > c) {
        vector<vector<ll> > a1(c, vector<ll>(r));
        for (ll i = 0; i < r; i++) {
            for (ll j = 0; j < c; j++)
                a1[j][i] = a[i][j];
        }
        swap(a, a1);
        swap(r, c);
    }
    vector<ll> x;
    int p1 = 0, p2 = 0;
    for (int i = 0; i < c; i++)
        add(a[0][i]);
    int ans = 0;
    while (p1 < r && p2 < c) {
        int s = 0;
        for (int i = p1; i < r; i++)
            s += get(a[i][p2]);
        if (s > (r - p1) * (c - p2) - s) {
            ans += (r - p1) * (c - p2) - s;
            p1++;
            fill(F, F + MAXN, 0);
            if (p1 == r)
                break;
            for (int j = p2; j < c; j++)
                add(a[p1][j]);
        } else {
            ans += s;
            p2++;
        }
    }
    cout << ans << '\n';
}
