#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <string>
#include <random>

typedef long long ll;
using namespace std;

mt19937 gen(12944);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

vector<int> t;
int ts;

void sett(int v, int l, int r, int ind) {
	if (ind > r || l > ind) {
		return;
	}
	if (l == r) {
		t[v]++;
		return;
	}
	sett(v * 2, l, (r + l) / 2, ind);
	sett(v * 2 + 1, (r + l) / 2 + 1, r, ind);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

void unsett(int v, int l, int r, int ind) {
	if (ind > r || l > ind) {
		return;
	}
	if (l == r) {
		t[v]--;
		return;
	}
	unsett(v * 2, l, (r + l) / 2, ind);
	unsett(v * 2 + 1, (r + l) / 2 + 1, r, ind);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

int gett(int v, int l, int r, int q, int w) {
	if (q <= l && r <= w) {
		return t[v];
	}
	if (q > r || w < l) return 0;
	return (gett(v * 2, l, (r + l) / 2, q, w) + gett(v * 2 + 1, (r + l) / 2 + 1, r, q, w));
}

ll f(vector<int>& pre, vector<int>& arr) {
	ll ans = 0;//0n-1
	for (int i : pre) {
		sett(1, 0, ts - 1, i - 1);
	}
	for (int i = 0; i < arr.size(); ++i) {
		ans += gett(1, 0, ts - 1, arr[i], ts - 1);
		sett(1, 0, ts - 1, arr[i] - 1);
	}
	for (int i = 0; i < arr.size(); ++i) {
		unsett(1, 0, ts - 1, arr[i] - 1);
	}
	for (int i : pre) {
		unsett(1, 0, ts - 1, i - 1);
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	t.resize(n * m * 4 + 4, 0);
	ts = n * m;
	vector<vector<int>> arr(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> arr[i][j];
		}
	}
	vector<vector<ll>> dp(n, vector<ll>(m, 2100000000000000000));
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i > 0) {
				vector<int> pre;
				for (int q = 0; q < n; ++q) {
					for (int w = 0; w < m; ++w) {
						if (q < i - 1 || w <= j - 1) {
							pre.push_back(arr[q][w]);
						}
					}
				}
				vector<int> na;
				for (int q = j; q < m; ++q) {
					na.push_back(arr[i - 1][q]);
				}
				dp[i][j] = min(dp[i][j], dp[i - 1][j] + f(pre, na));
			}
			if (j > 0) {
				vector<int> pre;
				for (int q = 0; q < n; ++q) {
					for (int w = 0; w < m; ++w) {
						if (q <= i - 1 || w < j - 1) {
							pre.push_back(arr[q][w]);
						}
					}
				}
				vector<int> na;
				for (int q = i; q < n; ++q) {
					na.push_back(arr[q][j - 1]);
				}
				dp[i][j] = min(dp[i][j], dp[i][j - 1] + f(pre, na));
			}
		}
	}
	cout << dp[n - 1][m - 1];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

4 1
1010
0

*/