#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<vector<int>>graph;
vector<int>used; int n; int inf = 1e9;
bool bfs(int start) {
    deque<int>d; vector<int>dist(n, inf); vector<int>color(n, 0);
    d.push_back(start); dist[start] = 0;
    while (!d.empty()) {
        auto q = d.front(); d.pop_front();
        for (auto val: graph[q]) {
            if (dist[val] == inf) {
                dist[val] = dist[q] + 1; color[val] = 1 - color[q];
                d.push_back(val);
            }else {
                if (color[val] == color[q]) {
                    return true;
                }
            }
        }
    }
    return false;
}
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    ll r; cin >> n >> r;
    vector<ll>x(n), y(n); graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ll dist = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
            if (dist <= r * r) {
                graph[i].push_back(j); graph[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (bfs(i)) cout << 1;
        else cout << 0;
    }
}