#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll,ll>>

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

vii g;
vi color;
vi is;
vi cmp;
ll R = 10;

void dfs(ll v, ll last, ll comp) {
    color[v] = 3 - last;
    cmp[v] = comp;
    for (ll to : g[v]) {
        if (color[to] == 0) {
            dfs(to, color[v], comp);
        } else if (color[v] == color[to]) {
            is[comp] = 1;
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    color.assign(n, 0);
    g.assign(n, vi());
    cmp.assign(n, 0);
    is.assign(n, 0);
    map<pair<ll,ll>, ll> id;
    vi x(n), y(n);
    for (ll i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        id[{x[i], y[i]}] = i + 1;
    }
    for (ll i = 0; i < n; i++) {
        for (ll xj = x[i] - R; xj <= x[i] + R; xj++) {
            for (ll yj = y[i] -R; yj <= y[i] + R; yj++) {
                ll j = id[{xj, yj}];
                if (j != 0 && i != j - 1) {
                    j--;
                    if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                        g[i].pb(j);
                        g[j].pb(i);
                    }
                }
            }
        }
    }
    ll c = 0;
    for (ll i = 0; i < n; i++) {
        if (color[i] == 0) {
            dfs(i, 1, c);
            c++;
        }
    }
    for (ll i = 0; i < n; i++) {
        cout << is[cmp[i]];
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}