#include <bits/stdc++.h>
#pragma GCC optimize("O3");
#pragma GCC target("avx2");

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();

    return 0;
}

std::vector <std::vector <std::pair <int, int>>> cmp;
std::vector <int> cmpRes;
std::map <std::pair <int, int>, int> id;
std::mt19937 rnd(time(nullptr));

std::vector <std::pair <int, int>> delts;

int r;

std::vector <int> stack;

inline void dfs(int curV, int sX, int sY, int st) {
    cmpRes[curV] = st;
    stack.push_back(curV);

    if ((int) cmp[curV].size() >= 3) {
        cmpRes[curV] = 1;
        return;
    }

    for (auto [dx, dy] : delts) {
        int nX = sX + dx;
        int nY = sY + dy;

        if (dx == 0 && dy == 0) continue;
        if (id.find({nX, nY}) == id.end()) continue;
        if (cmpRes[curV] == 1 || cmpRes[curV] == 0) return;

        int cnt = 0;

        for (auto [fx, fy] : cmp[id[{sX, sY}]]) {
            if (cmpRes[curV] == 1 || cmpRes[curV] == 0) return;

            for (auto [tx, ty] : cmp[id[{nX, nY}]]) {
                if (cmpRes[curV] == 1 || cmpRes[curV] == 0) return;

                if (1ll * (fx - tx) * (fx - tx) + 1ll * (fy - ty) * (fy - ty) <= 1ll * r * r) {
                    ++cnt;

                    if (cmpRes[id[{nX, nY}]] == -1) {
                        dfs(id[{nX, nY}], nX, nY, 5 - st);
                    }

                    if (cmpRes[id[{nX, nY}]] == 1) {
                        cmpRes[curV] = 1;
                        break;
                    }

                    if (cmpRes[id[{nX, nY}]] == 0) {
                        cmpRes[curV] = 0;
                        break;
                    }

                    if (cmpRes[id[{nX, nY}]] == cmpRes[curV]) {
                        cmpRes[curV] = 1;
                        break;
                    }

                    if (cnt == 2) {
                        cmpRes[curV] = 1;
                        break;
                    }
                }

            }
            }
    }
}
int connect(int x1, int y1, int x2, int y2) {
    return 1ll * (x1 - x2) * (x1 - x2) + 1ll * (y1 - y2) * (y1 - y2) <= 1ll * r * r;
}

void solve() {
    int n;
    std::cin >> n >> r;

    int cntComp = 0;

    int R = std::max(1, r / 5);

    std::vector <std::pair <int, int>> points;
    for (int i = 0; i < n; ++i) {
        long long x, y;
        std::cin >> x >> y;

        points.push_back({x, y});

        int sX = x / R;
        int sY = y / R;

        if (id.find({sX, sY}) == id.end()) {
            cmp.push_back({});
            id[{sX, sY}] = cntComp++;
        }

        cmp[id[{sX, sY}]].push_back({x, y});
    }

    for (auto &i : cmp) {
        std::shuffle(i.begin(), i.end(), rnd);
    }

    cmpRes.resize(cntComp, -1);

    for (int dx = -10; dx <= 10; ++dx) {
        for (int dy = -10; dy <= 10; ++dy) {

            // from
            std::vector <int> fc = {0, r};

            // to
            std::vector <int> scX = {0 + dx * R, r + dx * R};
            std::vector <int> scY = {0 + dy * R, r + dy * R};

            int rule = 0;

            for (auto x1 : fc) {
                for (auto y1 : fc) {
                    for (auto x2 : scX) {
                        for (auto y2 : scY) {
                            rule |= connect(x1, y1, x2, y2);
                        }
                    }
                }
            }

            if (rule) {
                delts.push_back({dx, dy});
            }
        }
    }

    std::shuffle(delts.begin(), delts.end(), rnd);

    for (auto [x, y] : points) {
        int sX = x / R;
        int sY = y / R;

        int curId = id[{sX, sY}];

        if (cmpRes[curId] == -1) {
            dfs(curId, sX, sY, 2);
            for (auto i : stack) {
                cmpRes[i] = cmpRes[curId];
                if (cmpRes[i] != 1) cmpRes[i] = 0;
            }
            stack.clear();
        }

        std::cout << cmpRes[curId];
    }
}