#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e18;
vector<ll> tree;
void update(ll v, ll l, ll r, ll pos) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r - l == 1) {
        tree[v]++;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m, pos);
    update(2 * v + 2, m, r, pos);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}
ll getans(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    ll m = (l + r) / 2;
    return( getans(2 * v + 1, l, m, ql, qr) + getans(2 * v + 2, m, r, ql, qr));
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    ll mxx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mxx = max(mxx, a[i]);
    }
    vector<vector<ll>> dp(n, vector<ll> (n + 1));
    vector<vector<ll>> pr(n, vector<ll> (n + 1, -1));

    dp[0][1] = 1;
    for (int i = 0; i < n; ++i) {
        // cout << i << ":";
        for (int j = 1; j < n; ++j) {
            // cout << dp[i][j] << ' ';
            if (!dp[i][j]) continue;
            for (int k = i + 1; k < n; ++k) {
                dp[k][j + 1] = dp[i][j];
                pr[k][j + 1] = i;
                if (a[k] > a[i]) {
                    break;
                }
            }

        }
        // cout << '\n';
    }
    vector<vector<ll>> ans(n + 1);
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            ans[i].push_back(inf);
        }
    }
    ans[1][0] = mxx;
    for (int i = 1; i < n; ++i) {

        ll mx = a[n - 1];
        for (int j = n - 2; j >= 0; --j) {
            if (dp[j][i]) {
                vector<ll> mas;
                mas.push_back(mx);
                ll pos = j, cnt = i;
                while (cnt) {
                    mas.push_back(a[pos]);
                    pos = pr[pos][cnt];
                    cnt--;
                }
                reverse(mas.begin(), mas.end());
                ll sz = (int)mas.size();
                for (int k = 0; k < sz; ++k) {
                    if (ans[sz][k] != mas[k]) {
                        if (ans[sz][k] > mas[k]) {
                            swap(ans[sz], mas);
                        }
                        break;
                    }
                }
            }
            mx = max(mx, a[j]);
        }
    }
    for (int i = 0; i < q; ++i) {
        ll k, pos;
        cin >> k >> pos;
        pos--;
        cout << ans[k][pos] << '\n';
    }
}

signed main() {
    ll T = 1;
    //cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}