#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e18;
vector<ll> tree;
void update(ll v, ll l, ll r, ll pos) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r - l == 1) {
        tree[v]++;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m, pos);
    update(2 * v + 2, m, r, pos);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}
ll getans(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    ll m = (l + r) / 2;
    return( getans(2 * v + 1, l, m, ql, qr) + getans(2 * v + 2, m, r, ql, qr));
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll a1 = a[0];
    ll a2 = 0, a3 = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] > a[0]) {
            if (i == 1) {
                a2 = a[1];
                for (int j = i + 1; j < n; ++j) {
                    a3 = max(a3, a[j]);
                }
            } else {
                a2 = inf;
                for (int j = 1; j < i; ++j) {
                    a2 = min(a2, a[j]);
                }
                for (int j = i; j < n; ++j) {
                    a3 = max(a3, a[j]);
                }
            }
            break;
        }
    }
    if (a2 == 0) {
        a3 = a[n - 1];
        a2 = inf;
        for (int j = 1; j < n - 1; ++j) {
            a2 = min(a2, a[j]);
        }
    }
    for (int i = 0; i < q; ++i) {
        ll k, pos;
        cin >> k >> pos;
        if (pos == 1) {
            cout << a1 << '\n';
        } else if (pos == 2) {
            cout << a2 << '\n';
        } else if (pos == 3) {
            cout << a3 << '\n';
        }
    }
}

signed main() {
    ll T = 1;
    //cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}