#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
        }
    }
    ll res = 1e18;
    for (ll mask = 0; mask < (1 << (r + c - 1)); mask++) {
        ll cntr = 0, cntc = 0;
        bool cn = true;
        ll cur = 0;
        ordered_set<ll> b;
        for (ll i = 0; i < r + c - 1 && cn; i++) {
            if (mask & (1 << i)) {
                if (cntr < r) {
                    for (ll j = cntc; j < c; j++) {
                        cur += b.size() - b.order_of_key(a[cntr][j]);
                        b.insert(a[cntr][j]);
                    }
                    cntr++;
                } else {
                    cn = false;
                }
            } else {
                if (cntc < c) {
                    for (ll j = cntr; j < r; j++) {
                        cur += b.size() - b.order_of_key(a[j][cntc]);
                        b.insert(a[j][cntc]);
                    }
                    cntc++;
                } else {
                    cn = false;
                }
            }
        }
        res = min(res, cur);
    }
    cout << res;
}