#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
 
// #define FILE
#define int long long

const int N = 250000 + 2, INF = 1e18;
int n, m;
vector<vector<int>> a;


vector<int> f(N);
 
 
int sum(int x) {
    int ans = 0;
    for (; x > 0; x -= x & -x) {
        ans += f[x];
    }
    return ans;
}
 
int get(int l, int r) {
    if (l > r) return 0;
    return sum(r) - sum(l - 1);
}
 
void upd(int x, int val) {
    for (; x < N; x += x & -x) {
        f[x] += val;
    }
}



 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int prefj[n][m][n];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < n; ++k) {
                prefj[i][j][k] = 0;
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        fill(f.begin(), f.end(), 0);
        for (int i = n - 1; i >= 0; --i) {
            for (int k = j; k < m; ++k) upd(a[i][k], 1);
            for (int i1 = i; i1 < n; ++i1) {
                prefj[i1][j][i] = get(a[i1][j] + 1, N);
            }
        }
    }
    

    int prefi[m][m][n];
    for (int j1 = 0; j1 < m; ++j1) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < n; ++k) {
                prefi[j1][j][k] = 0;
            }
        }
    }
   
    for (int i = 0; i < n; ++i) {
        fill(f.begin(), f.end(), 0);
        for (int j = m - 1; j >= 0; --j) {
            for (int k = i; k < n; ++k) {
                upd(a[k][j], 1);
            }
            for (int j1 = j; j1 < m; ++j1) {
                prefi[j1][j][i] = get(a[i][j1] + 1, N);
            }
        }
    }
    /* for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << i << " " << j << " : ";
            for (int i1 = i; i1 < n; ++i1) {
                cout << prefj[i1][j][i] << " ";
            }
            cout << endl;
        }
    } */
    fill(f.begin(), f.end(), 0);
    vector<vector<int>> dp(n + 1, vector<int>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            
            int help = 0;
            for (int i1 = i; i1 < n; ++i1) {
                int add = get(a[i1][j] + 1, N); // кол-во больших
                upd(a[i1][j], 1);
                // help.push_back(a[i1][j]);
                int all = n * m - a[i1][j];
                int add2 = prefj[i1][j][i];
                all -= add2;
                all += add;
                help += all;
            }
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + help);
            for (int i1 = i; i1 < n; ++i1) {
                upd(a[i1][j], -1);
            }
            
            

            help = 0;
            for (int j1 = j; j1 < m; ++j1) {
                int add = get(a[i][j1] + 1, N); // кол-во больших
                upd(a[i][j1], 1);
                // help.push_back(a[i][j1]);
                int all = n * m - a[i][j1];
                int add2 = prefi[j1][j][i];
                all -= add2;
                all += add;
                help += all;
            }
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + help);
            for (int j1 = j; j1 < m; ++j1) {
                upd(a[i][j1], -1);
            }
        }
    }
   /*  cout << "!! " << dp[0][1] << endl;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    } */
    int ans = 1e18;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[i][m]);
    }
    for (int j = 0; j < m; ++j) {
        ans = min(ans, dp[n][j]);
    }
    cout << ans;
}