#include <bits/stdc++.h>

using ll = long long;

#define pb push_back
#define all(obj) obj.begin(), obj.end()
#define pii pair<int, int>
#define int ll

using namespace std;

int n, r;
vector<pii>a;

int qd(pii a, pii b) {
    return (a.first-b.first)*(a.first-b.first) + (a.second-b.second)*(a.second-b.second);
}

vector<int>color;
vector<bool>ans;
void dfs (int v) {
    bool e = false;
    for (int i = 0; i < n; i++) {
        if (i == v or qd(a[v], a[i]) > r*r) continue;
        if (color[i] == color[v]) {
            ans[v] = true;
            ans[i] = true;
        }
        if (color[i] == 0) {
            color[i] = 3 - color[v];
            dfs(i);
            ans[v] = (ans[v]|ans[i]);
        }
    }
}

vector<bool>used;
void dfs_ans(int v) {
    used[v] = true;
    for (int i = 0; i < n; i++) {
        if (i == v or qd(a[v], a[i]) > r*r) continue;
        ans[i] = true;
        if (!used[i]) {
            dfs(i);
        }
    }
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    cin >> n >> r;
    a.resize(n);
    color.resize(n);
    ans.resize(n);
    
    for (int i=0; i<n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    for (int i=0; i<n; i++) {
        if (color[i] == 0) {
            color[i] = 1;
            dfs(i);
        }
    }

    used.resize(n);
    for (int i=0; i<n; i++) {
        if (ans[i]) {
            dfs_ans(i);
        }
    }

    for (int i=0; i<n; i++) {
        cout << (int)ans[i];
    }
}