#include <bits/stdc++.h>

using ll = long long;

#define pb push_back
#define all(obj) obj.begin(), obj.end()
#define pii pair<int, int>
#define int ll

using namespace std;

const int inf = 1000000000;

int n, r;
vector<pii>a;
vector<bool>ans;
vector<int>uncomp;
map<int, int>comp;
vector<vector<pii>>px;
vector<bool>used;
vector<int>color;

void dfs (int v) {
    used[v] = true;
    int cx = comp[a[v].first];
    int y = a[v].second;

    vector<int>sos;
    for (int d = 0; d < uncomp.size(); d++) {
        bool e1 = true;
        if (cx + d >= uncomp.size() or r < uncomp[cx+d] - uncomp[cx]) {
            e1 = false;
        }
        bool e2 = true;
        if (cx - d < 0 or r < uncomp[cx] - uncomp[cx-d]) {
            e2 = false;
        }
        if (!e1 and !e2) {
            break;
        }

        if (cx + d < uncomp.size()) {
            int mx = sqrt(r*r-(uncomp[cx+d] - uncomp[cx])*(uncomp[cx+d]-uncomp[cx]));
            int l = lower_bound(all(px[cx+d]), pii{y-mx, -1}) - px[cx+d].begin();
            int r = upper_bound(all(px[cx+d]), pii{y+mx, inf}) - px[cx+d].begin() - 1;
           // if (d != 0 and sos.size() + (r-l+1) >= 6) {
              //  ans[v] = true;
               // return;
           // }
            for (int i=l; i<=r; i++) {
                if (px[cx+d][i].second != v) sos.pb(px[cx+d][i].second);
            }
        }
        if (d != 0 and cx - d >= 0) {
            int mx = sqrt(r*r-(uncomp[cx]-uncomp[cx-d])*(uncomp[cx]-uncomp[cx-d]));
            int l = lower_bound(all(px[cx-d]), pii{y-mx, -1}) - px[cx-d].begin();
            int r = upper_bound(all(px[cx-d]), pii{y+mx, inf}) - px[cx-d].begin() - 1;
           // if (sos.size() + (r-l+1) >= 6) {
               // ans[v] = true;
                //return;
          //  }
            for (int i=l; i<=r; i++) {
                sos.pb(px[cx-d][i].second);
            }
        }   
    }

    if (sos.size() >= 6) {
        ans[v] = true;
    }

    for (auto i:sos) {
        if (color[i] != 0 and color[i] == color[v]) {
            ans[i] = true;
            ans[v] = true;
           // return;
        }
        if (!used[i]) {
            color[i] = 3 - color[v];
            dfs(i);
        }
    }

    for (auto i:sos) {
        if (ans[i]) {
            ans[v] = true;
        }
    }
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    cin >> n >> r;
    a.resize(n);
    color.resize(n);
    used.resize(n);
    
    for (int i=0; i<n; i++) {
        cin >> a[i].first >> a[i].second;
        uncomp.pb(a[i].first);
    }

    sort(all(uncomp));
    uncomp.erase(unique(all(uncomp)), uncomp.end());
    for (int i=0; i<uncomp.size(); i++) {
        comp[uncomp[i]] = i;
    }

    px.resize(uncomp.size());
    for (int i=0; i<n; i++) {
        px[comp[a[i].first]].pb({a[i].second, i});
    }

    ans.resize(n, false);
    for (int i=0; i<n; i++) {
        if (!used[i]) {
            color[i] = 1;
            dfs(i);
        }
    }

    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            if (r*r >= (a[i].first-a[j].first)*(a[i].first-a[j].first) + (a[i].second-a[j].second)*(a[i].second-a[j].second)) {
                if (ans[i] == 1 or ans[j] == 1) {
                    ans[i] = 1;
                    ans[j] = 1;
                }
            }
        }
    }

    for (int i=0; i<n; i++) {
        cout << (int)ans[i];
    }
}