#include <bits/stdc++.h>
using namespace std;
constexpr int MAXN = 3e5, INF = 1e9;
int A[MAXN], sufmx[MAXN];
pair<int, int> t[MAXN * 4], t2[MAXN * 4];


void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {A[l], l};
        t2[v] = {sufmx[l], l};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m + 1, r);
    t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    t2[v] = min(t2[v * 2 + 1], t2[v * 2 + 2]);
}

pair<int, int> get(int v, int l, int r, int L, int R) {
    if (L <= l && r <= R) {
        return t[v];
    }
    if (l > R || r < L) {
        return {INF, -1};
    }
    int m = (l + r) / 2;
    return min(get(v * 2 + 1, l, m, L, R), get(v * 2 + 2, m + 1, r, L, R));
}

pair<int, int> get2(int v, int l, int r, int L, int R) {
    if (L <= l && r <= R) {
        return t2[v];
    }
    if (l > R || r < L) {
        return {INF, -1};
    }
    int m = (l + r) / 2;
    return min(get2(v * 2 + 1, l, m, L, R), get2(v * 2 + 2, m + 1, r, L, R));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<int> nxt(n), st;
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    sufmx[n - 1] = A[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        sufmx[i] = max(sufmx[i + 1], A[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && A[st.back()] <= A[i]) {
            st.pop_back();
        }
        nxt[i] = (st.empty() ? n : st.back());
        st.push_back(i);
    }
    build(0, 0, n - 1);
    while (q--) {
        int k, i, p = 0, ans = A[0];
        cin >> k >> i;
        if (i == k) {
            ans = sufmx[i - 1];
        } else {
            ans = A[i - 1];
        }
        cout << ans << "\n";
    }


    return 0;
}
