#include <bits/stdc++.h>
using namespace std;

bool is_good(long long r, pair<long long, long long>& a, pair<long long, long long>& b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second) <= r * r;
}

void dfs(vector<vector<int>>& g, int x, bool& b, vector<int>& col, vector<int>& found) {
    found.push_back(x);
    for (auto i : g[x]) {
        if (col[i] == col[x]) {
            b = true;
        }
        if (col[i] == 0) {
            col[i] = 3 - col[x];
            dfs(g, i, b, col, found);
        }
    }
}

int main() {
    int n;
    long long r, q, s;
    cin >> n >> r;
    long long rsq((r / 2) + 1);
    vector<pair<long long, long long>> v{};
    map<pair<int, int>, vector<int>> m{};
    for (int i = 0; i < n; i++) {
        cin >> q >> s;
        v.push_back({q, s});
        m[{q / rsq, s / rsq}].push_back(i);
    }
    vector<vector<int>> g(n, vector<int>(0));
    for (auto i : m) {
        if (i.second.size() >= 3) {
            for (auto j : i.second) {
                g[j].push_back(j);
            }
            continue;
        }
        for (int x = -2; x <= 2; x++) {
            for (int y = -2; y <= 2; y++) {
                if (abs(x) + abs(y) > 0) {
                    if (m.count({i.first.first + x, i.first.second + y}) > 0) {
                        for (auto j : m[{i.first.first + x, i.first.second + y}]) {
                            for (auto k : i.second) {
                                if (is_good(r, v[j], v[k])) {
                                    g[j].push_back(k);
                                    g[k].push_back(j);
                                }
                            }
                        }
                    }
                }
            }
        }
        for (auto j : i.second) {
            for (auto k : i.second) {
                if (j != k) {
                    g[j].push_back(k);
                    g[k].push_back(j);
                }
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (auto j : g[i]) {
            cout << i << "," << j << endl;
        }
    }*/
    vector<bool> res(n, false);
    vector<int> col(n, 0);
    for (int i = 0; i < n; i++) {
        if (col[i]) {
            continue;
        }
        vector<int> found{};
        col[i] = 1;
        bool b(false);
        dfs(g, i, b, col, found);
        if (b) {
            for (auto j : found) {
                res[j] = true;
            }
        }
    }
    for (auto j : res) {
        cout << j;
    }
}
