#include <bits/stdc++.h>
using namespace std;

int find_st(int a, int b, vector<vector<int>>& st, vector<int>& logs) {
    int x(logs[b - a + 1]);
    return min(st[x][a], st[x][b - (1 << x) + 1]);
}

int find_antist(int a, int b, vector<vector<int>>& st, vector<int>& logs) {
    int x(logs[b - a + 1]);
    return max(st[x][a], st[x][b - (1 << x) + 1]);
}

int main() {
    int n, Q, q, r;
    cin >> n >> Q;
    vector<vector<int>> st(1, vector<int>(0)), antist(1, vector<int>(0));
    vector<int> rev_perm(n, 0);
    vector<int> u{};
    vector<int> next_larger(n, n);
    for (int i = 0; i < n; i++) {
        cin >> q;
        q--;
        while ((u.size() > 0) && (q > st[0][u.back()])) {
            next_larger[u.back()] = i;
            u.pop_back();
        }
        u.push_back(i);
        rev_perm[q] = i;
        st[0].push_back(q);
        antist[0].push_back(q);
    }
    vector<int> logs(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        while (1 << (logs[i] + 1) <= i) {
            logs[i]++;
        }
    }
    for (int i = 2; i <= n; i *= 2) {
        st.push_back(vector<int>(0));
        for (int j = 0; j < st[st.size() - 2].size() - (i / 2); j++) {
            st[st.size() - 1].push_back(min(st[st.size() - 2][j], st[st.size() - 2][j + i / 2]));
        }
    }
    for (int i = 2; i <= n; i *= 2) {
        antist.push_back(vector<int>(0));
        for (int j = 0; j < antist[antist.size() - 2].size() - (i / 2); j++) {
            antist[antist.size() - 1].push_back(max(antist[antist.size() - 2][j], antist[antist.size() - 2][j + i / 2]));
        }
    }
    vector<tuple<int, int, int>> main_sequence{{-1, 0, 0}}; //c, lmin, lmax
    int max_q(n - 1);
    vector<int> mpws(n + 1, 0);
    int lmax(0), lmin(0);
    for (int j = 0; j < n; j++) {
        if (lmax >= n) {
            break;
        }
        //cout << lmin << " " << lmax << endl;
        int c(find_st(lmin, lmax, st, logs));
        int pc(rev_perm[c]);
        int bc(next_larger[pc] - 1);
        //cout << lmin << " " << lmax << " " << c << " " << pc << " " << bc << " ";
        for (; max_q > max(-1, n + j - bc - 5); max_q--) {
            mpws[max_q] = j;
        }
        //q <= n + j - bc
        //cout << bc << endl;
        lmin = pc + 1;
        lmax = bc + 1;
        main_sequence.push_back({c, lmin, lmax});
        //cout << c << " " << lmin << " " << lmax << endl;
    }
    for (; max_q >= 0; max_q--) {
        mpws[max_q] = max(0, main_sequence.size() - 2);
    }
    /*for (auto i : mpws) {
        cout << i << " ";
    }*/
    //cout << "TEST" << endl;
    for (int i = 0; i < Q; i++) {
        cin >> q >> r;
        int init_t(min(max(0, q - 1), mpws[q]));
        if (init_t >= r) {
            cout << get<0>(main_sequence[r]) << endl;
            continue;
        } else {
            lmin = get<1>(main_sequence[init_t]);
            lmax = get<2>(main_sequence[init_t]);
        }
        //cout << init_t << " " << lmin << " " << lmax << endl;
        for (int j = init_t; j < r; j++) {
            if (j == q - 1) {
                cout << find_antist(lmax, n - 1, antist, logs) + 1 << endl;
                break;
            }
            //cout << lmin << " " << lmax << endl;
            int c(find_st(lmin, lmax, st, logs));
            if (j == r - 1) {
                cout << c + 1 << endl;
                break;
            }
            int pc(rev_perm[c]);
            int bc(next_larger[pc] - 1);
            //cout << lmin << " " << lmax << " " << c << " " << pc << " " << bc << " ";
            bc = min(bc, n - (q - j));
            if ((bc == n - (q - j)) && (pc == bc)) {
                cout << st[0][n - 1 - (q - r)] + 1 << endl;
                break;
            }
            //cout << bc << endl;
            lmin = pc + 1;
            lmax = bc + 1;
        }
    }
}
