#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll LNF = 1.1e18;
int INF = 1.1e9;




vector<vector<int>> g;
vector<int> used;
void dfs_used(ll u) {
    for (ll v : g[u]) {
        if (!used[v]) {
            used[v] = (used[u] == 1 ? 2 : 1);
            dfs_used(v);
        } else {
            if (used[u] == used[v]) {
                used[u] = 3;
                used[v] = 3;
                return;
            }
        }
    }
}

vector<int> good;
void dfs_good(ll u) {
    good[u] = 1;
    for (ll v : g[u]) {
        if (!good[v]) dfs_good(v);
    }
}

ll BP(ll a, ll n, ll M) {
    if (n == 0) return 1;
    if (n % 2 == 1) return a * BP(a, n - 1, M) % M;
    ll x = BP(a, n / 2, M);
    return x * x % M;
}

void CASE() {
    ll n, r;
    cin >> n >> r;
    vector<vector<int>> a(n, vector<int>(3));
    for (ll i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
        a[i][2] = i;
    }
    sort(a.begin(), a.end());

    if (n < 3) {
        cout << string(n, '0');
        return;
    }

    vector<vector<int>> comps;
    comps.push_back({0});
    for (int i = 1; i < n; ++i) {
        if (a[i][0] - a[i - 1][0] > r) {
            comps.push_back({i});
        } else {
            comps.back().push_back(i);
        }
    }

    ll m = (ll)comps.size();
    vector<int> good_comp(m);
    for (ll i = 0; i < m; ++i) {
        for (ll j = 2; j < (ll)comps[i].size(); ++j) {
            if (a[comps[i][j]][0] - a[comps[i][j - 2]][0] <= r) {
                good_comp[i] = 1;
                break;
            }
        }
    }

    vector<bool> ans(n);
    for (ll i = 0; i < m; ++i) {
        if (good_comp[i]) {
            for (ll j : comps[i]) {
                ans[a[j][2]] = 1;
            }
        }
    }
    for (ll i = 0; i < n; ++i) cout << ans[i];
}




signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    CASE();
}
