#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

mt19937 gen(596);
const ll INF = 1e18;

int in(pair<ll, ll>  a, pair<ll, ll> b, ll r) {
    ll dist = (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second); //d^2;
    return (dist <= r * r);
}

void solve() {
    ll n, r; cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    map<pair<ll, ll>, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        mp[a[i]] = i + 1;
    }
    vector<vector<int>> dp(n, vector<int>(2));
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> buf;
        dp[i][0] = 1;
        buf.push_back({i, 0});
        queue<pair<int, int>> q;
        q.push({i, 0});
        while (q.size()) {
            auto v = q.front();
            q.pop();
            for (int x = -r; x <= r; x++) {
                for (int y = -r; y <= r; y++) {
                    int dx = a[v.first].first + x, dy = a[v.first].second + dy;
                    if (mp[{dx, dy}] > 0) {
                        int to = mp[{dx, dy}] - 1;
                        int c = v.second ^ 1;
                        if (!dp[to][c]) {
                            dp[to][c] = 1;
                            buf.push_back({to, c});
                            q.push({to, c});
                            if (dp[i][1]) break;
                        }
                    }
                }
            }
        }
        cout << dp[i][1];
        for (auto [x, y] : buf) {
            dp[x][y] = 0;
        }
    }
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}