#include <iostream>
#include <vector>
#include <map>
#include <cmath>

using namespace std;
//#define int long long

int n;
long double r;

long double len;

vector <pair<int, int>> a;
vector <pair<int, int>> cord;
vector <vector <pair<int, int>>> block;
int cnt = 0;
map<long long, int> id;
vector <bool> mas(4);
map<long long, int> :: iterator it;
vector <int> pbl;

vector <bool> bad;
vector <bool> used;
vector <vector <int>> gr;
bool checkdist(pair<long long, long long> a, pair<long long, long long> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second) <= r * r; //long double?
}

void dfs(int bl_id) {
    used[bl_id] = true;
    if (block[bl_id].size() >= 3) {
        bad[bl_id] = true;
        return;
    }
    int x = cord[bl_id].first, y = cord[bl_id].second;
    for (int z = 0; z < 25; z++) {
            int i = (z / 5) - 2;
            int j = z % 5 - 2;
            if (i == 0 && j == 0) {
                continue;
            }
            long long zn = ((long long)(x + i)) * 2000000000 + ((long long)(y + j));
            it = id.find(zn);
            if (it != id.end()) {
                int to = (*it).second;
                //if (!used[to] || block[to].size() >= 3) {
                    bool fl = false;
                    int q = 0;
                    bool fl_try = (block[to].size() <= 2);
                    mas[0] = 0;
                    mas[1] = 0;
                    mas[2] = 0;
                    mas[3] = 0;
                    for (int z = 0; z < block[bl_id].size(); z++) {
                        if (!fl || fl_try) {
                        for (int y = 0; y < block[to].size(); y++) {
                            bool fl2 = checkdist(block[bl_id][z], block[to][y]);
                            fl |= fl2;
                            if (fl_try && fl2) {
                                mas[z * 2 + y] = true;
                                q++;
                            }
                        }
                        }
                    }
                   // cout << bl_id << " " << to << " " << fl << "\n";
                    if (q >= 3 || (q == 2 && (!mas[0] || !mas[3]) && (!mas[1] || !mas[2]))) {
                        bad[bl_id] = true;
                        bad[to] = true;
                    }
                    if (fl) {
                        gr[bl_id].push_back(to);
                        gr[to].push_back(bl_id);
                        if (!used[to]) {
                            dfs(to);
                        }
                    }
                //}
            }
    }
}

vector <int> col;

void dfs2(int v) {
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (!bad[to]) {
            bad[to] = true;
            dfs2(to);
        }
    }
}

bool dfs3(int v) {
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (col[to] == -1) {
            col[to] = 1 - col[v];
            if (!dfs3(to)) {
                bad[v] = true;
                return false;
            }
    }   else if (col[to] == col[v]) {
            bad[v] = true;
            bad[to] = true;
            return false;
    }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    //n = 10000;
   // r = 1;
    a.resize(n);
    pbl.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        //a[i].first = i;
       // a[i].second = 0;
    }
    len = r / sqrt(2) - 0.02;
    for (int i = 0; i < n; i++) {
        int numx = floor(a[i].first / len);
        int numy = floor(a[i].second / len);
        int bl_id;
         long long zn = ((long long)numx) * 2000000000 + ((long long)numy);
        if (id.find(zn) == id.end()) {
            bl_id = cnt;
            id[zn] = bl_id;
            cnt++;
            cord.push_back(make_pair(numx, numy));
            block.push_back({});

    }   else {
            bl_id = id[zn];
    }
        block[bl_id].push_back(a[i]);
        pbl[i] = bl_id;
    }
    int m = cord.size();
    //for (int i = 0; i < m; i++) {
    //    cout << cord[i].first << " " << cord[i].second << "\n";
    //    cout << block[i].size() << "\n";
    //}
    used.resize(m);
    bad.resize(m);
    gr.resize(m);
    for (int i = 0; i < m; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    col.resize(m, -1);
    for (int i = 0; i < m; i++) {
        if (col[i] == -1) {
            col[i] = 0;
            dfs3(i);
        }
    }
    for (int i = 0; i < m; i++) {
        if (bad[i]) { //time bad
            //col[i] = 0;
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (bad[pbl[i]]) {
            cout << 1;
    }   else {
            cout << 0;
    }
    }
    return 0;
}
