#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    int n, q;

    cin >> n >> q;

    vector<int> a(n);
    vector<int> pref(n + 1);
    pref[0] = 0;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = max(pref[i], a[i]);
    }

    vector<int> suff(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = max(suff[i + 1], a[i]);
    }

    int b1 = 1e9, b2 = 1e9;
    for (int i = 1; i < n; ++i) {
        if (pref[i] < b1) {
            b1 = pref[i];
            b2 = suff[i];
        }
        else if (pref[i] == b1)
            b2 = min(b2, suff[i]);
    }

    while (q--) {
        int k, i;
        cin >> k >> i;

        if (i == 1)
            cout << b1 << '\n';
        else {
            cout << b2 << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
