#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(v) (v).begin(), (v).end()

// #define int long long

inline ll dist(pair<int, int> a, pair<int, int> b) {
	return (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second);
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<int, int>> v(n);
	for (auto& [a, b] : v) cin >> a >> b;

	vector<int> ys;
	for (auto [a, b] : v) {
		ys.push_back(a);
	}
	sort(all(ys));
	ys.resize(unique(all(ys)) - ys.begin());

	vector<vector<pair<int, int>>> vv(ys.size());
	for (int i = 0; i < n; i++) {
		vv[lower_bound(all(ys), v[i].first) - ys.begin()].emplace_back(v[i].second, i);
	}
	for (int i = 0; i < ys.size(); i++) {
		sort(all(vv[i]));
	}

	vector<vector<int>> g(n);
	vector<bool> gd(2 * n);
	for (int i = 0; i < ys.size(); i++) {
		int l1 = lower_bound(all(ys), ys[i] - r) - ys.begin(), r1 = upper_bound(all(ys), ys[i] + r) - ys.begin() - 1;
		for (int j = 0; j < vv[i].size(); j++) {
			int x = ys[i], y = vv[i][j].first, ind = vv[i][j].second;

			for (int i1 = l1; i1 <= r1; i1++) {
				int l2 = lower_bound(all(vv[i1]), make_pair((int)(y - r), -1)) - vv[i1].begin();
				int r2 = lower_bound(all(vv[i1]), make_pair((int)(y + r + 1), -1)) - vv[i1].begin() - 1;
				for (int j1 = l2; j1 <= r2; j1++) {
					if (i == i1 && j == j1) continue;
					if (dist(make_pair(x, y), make_pair(ys[i1], vv[i1][j1].first)) <= r * r) {
						g[ind].push_back(vv[i1][j1].second);
					}
					if (g[ind].size() >= 6) break;
				}
				if (g[ind].size() >= 6) break;
			}

			if (g[ind].size() >= 6) {
				g[ind].clear();
				gd[ind] = gd[ind + n] = true;
			}
		}
	}

	vector<vector<int>> gp(2 * n);
	for (int i = 0; i < n; i++) {
		if (gd[i]) {
			gp[i].push_back(i + n);
			gp[i + n].push_back(i);
		} else {
			for (int to : g[i]) {
				gp[i].push_back(to + n);
				gp[i + n].push_back(to);
				if (gd[to]) {
					gp[to].push_back(i + n);
					gp[to + n].push_back(i);
				}
			}
		}
	}

	vector<int> cp(2 * n, -1);
	vector<bool> gc;
	auto dfs = [&](auto dfs, int v, int c) -> bool {
		bool is = gd[v];
		cp[v] = c;
		for (int to : gp[v]) {
			if (cp[to] == -1) {
				if (dfs(dfs, to, c)) is = true;
			}
		}
		return is;
	};

	int cnt = 0;
	for (int i = 0; i < 2 * n; i++) {
		if (cp[i] == -1) {
			bool is = dfs(dfs, i, cnt++);
			gc.push_back(is);
		}
	}

	for (int i = 0; i < n; i++) {
		if (cp[i] == cp[i + n] || gc[cp[i]]) cout << "1";
		else cout << "0";
	}
}

int32_t main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}