#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = double;

vector <vector <int>> g;
vector <int> col;
ll r, r2;
vector <pair <ll, ll>> cord;
vector <bool> ans;

ll get(int a, int b) {
    return (cord[a].first - cord[b].first) * (cord[a].first - cord[b].first) + (cord[a].second - cord[b].second) * (cord[a].second - cord[b].second);
}

bool flag;

void dfs(int v) {
    for (int to : g[v]) {
        if (flag) {
            return;
        }
        if (!col[to]) {
            col[to] = 3 - col[v];
            dfs(to);
        }
        if (col[to] == col[v]) {
            flag = true;
            return;
        }
    }
}

void flagdfs(int v) {
    for (int to : g[v]) {
        if (!ans[to]) {
            ans[to] = true;
            flagdfs(to);
        }
    }
}

void sol() {
    ll n;
    cin >> n >> r;
    r2 = r * r;
    cord.resize(n);
    vector <ll> sx;
    vector <vector <pair <ll, int>>> vsy;
    for (int i = 0; i < n; i++) {
        cin >> cord[i].first >> cord[i].second;
    }
    sort(cord.begin(), cord.end());
    for (int i = 0; i < n; i++) {
        if (i == 0 || cord[i].first != cord[i - 1].first) {
            sx.push_back(cord[i].first);
            vsy.push_back({{cord[i].second, i}});
        } else {
            vsy.back().push_back({cord[i].second, i});
        }
    }
    g.resize(n), col.resize(n);
    int cst = 10;
    if (r <= cst) {
        for (int i = 0; i < n; i++) {
            for (ll x = cord[i].first - cst; x <= cord[i].first + cst; x++) {
                int pos = lower_bound(sx.begin(), sx.end(), x) - sx.begin();
                if (pos == sx.size() || sx[pos] != x) {
                    continue;
                }
                for (ll y = cord[i].second - cst; y <= cord[i].second + cst; y++) {
                    if (x == cord[i].first && y == cord[i].second) {
                        continue;
                    }
                    pair <ll, int> tof = {y, -1};
                    int res = lower_bound(vsy[pos].begin(), vsy[pos].end(), tof) - vsy[pos].begin();
                    if (res == vsy[pos].size() || vsy[pos][res].first != y) {
                        continue;
                    }
                    if (get(i, vsy[pos][res].second) <= r2) {
                        g[i].push_back(vsy[pos][res].second);
                    }
                }
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (get(i, j) <= r2) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    }
    ans.resize(n);
    // sort(cord.begin(), cord.end());
    // int cur = 0;
    // set <pair <ll, int>> s;
    // s.insert({cord[0].second, 0});
    // for (int i = 1; i < n; i++) {
    //     while (cur < i && cord[cur].first < cord[i].first - r) {
    //         s.erase(s.find({cord[cur].second, cur}));
    //         cur++;
    //     }
    //     auto it = s.find({cord[i].second, -1});
    //     int num = it->second;
    //     int cnt = 0, uls = 0;
    //     while (cnt <)
    //
    // }

    for (int i = 0; i < n; i++) {
        if (!col[i] && !ans[i]) {
            flag = false;
            col[i] = 1;
            dfs(i);
            if (flag) {
                flagdfs(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}