// semenInRussia 2025
#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>
using namespace std;

int &setmax(int &v, int op) { return v = max(v, op); }

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, q;
  cin >> n >> q;

  string s;
  cin >> s;

  int ans = 0;

  const int inf = 1e9;

  vector<vector<int>> dp(n + 5, vector<int>(3, -inf)),
      dp2(n + 5, vector<int>(3, -inf));
  dp[0][0] = 0;

  for (int i = 0; i < n; i++) {
    for (int ad : {0, 1}) {
      if (s[i] == '1') {
        ad = 1;
      }
      bool w = false;
      if (ad && s[i] == '0') {
        w = true;
      }
      for (int c : {0, 1, 2}) {
        for (int x = 0; x <= n; x++) {
          if (ad) {
            int cur = dp[x][c];
            if (c == 1) {
              cur += 2;
            }
            if (c == 2) {
              cur += 1;
            }
            setmax(dp2[x + w][min(c + 1, 2)], cur);
          } else {
            setmax(dp2[x][0], dp[x][c]);
          }
        }
      }
    }
    swap(dp2, dp);
    for (auto &row : dp2) {
      fill(row.begin(), row.end(), -inf);
    }
  }

  while (q--) {
    int k;
    cin >> k;
    int ans = max({dp[k][0], dp[k][1], dp[k][2]});
    cout << ans << "\n";
  }
}
