// semenInRussia 2025
#pragma GCC optimize("O3")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <queue>
#include <set>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

const int N = 3e5;
int p[N];
bool used2[N];

using ll = long long;

ll dist(int a, int b) { return abs(a - b); }

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n;
  ll r;
  cin >> n >> r;

  for (int i = 0; i < n; i++) {
    int y;
    cin >> p[i];
    cin >> y;
    assert(y == 0);
  }

  sort(p, p + n);

  int v = 0;

  for (int i = 1; i + 1 < n; i++) {
    if (used2[i]) {
      continue;
    }
    if (dist(p[i - 1], p[i + 1]) > r) {
      continue;
    }
    used2[i] = true;
    for (int j = i - 1; j >= 0 && dist(p[j], p[j + 1]) <= r && !used2[j]; j--) {
      used2[j] = true;
    }
    for (int j = i + 1; j < n && dist(p[j], p[j - 1]) <= r && !used2[j]; j++) {
      used2[j] = true;
    }
  }

  for (int i = 0; i < n; i++) {
    cout << used2[i];
  }
}