// semenInRussia 2025
#pragma GCC optimize("O3")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

const int N = 5e5;
int p[N];

bool ans[N];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, r;
  cin >> n >> r;

  int y;
  for (int i = 0; i < n; i++) {
    cin >> p[i] >> y;
    assert(y == 0);
  }

  sort(p, p + n);

  for (int i = 1; i + 1 < n; i++) {
    int d = abs(p[i + 1] - p[i]);
    if (d > r || ans[i]) {
      continue;
    }
    int j = i + 1;
    while (j < n && p[j] - p[j - 1] <= r) {
      ans[j] = true;
      ++j;
    }

    j = i - 1;

    while (j >= 0 && p[j + 1] - p[j] <= r) {
      ans[j] = true;
      ++j;
    }

    ans[i] = true;
  }

  for (int i = 0; i < n; i++) {
    cout << ans[i];
  }
}