#include <bits/stdc++.h>

using namespace std;
#define ll int
#define ldb long double

#pragma GCC("O2")

ll const inf = 1e9 + 3;

#define ve vector
#define pb push_back


void merge(ve<ll> &a, ll l, ll m, ll r, long long &ans) {
    ll res[r - l];
    ll tl = l;
    ll tm = m;
    ll cnt = 0;
    while (tl < m && tm < r) {
        if (a[tl] > a[tm]) {
            res[cnt++] = a[tm];
            tm++;
        } else {
            ans += tm - m;
            res[cnt++] = a[tl];
            tl++;
        }
    }
    while (tl < m) {
        ans += tm - m;
        res[cnt++] = a[tl];
        tl++;
    }
    while (tm < r) {
        res[cnt++] = a[tm];
        tm++;
    }
    for (ll x = l; x < r; x++) {
        a[x] = res[x - l];
    }
}

void merge_sort(ve<ll> &a, ll l, ll r, long long &ans) {
    if (r - l == 1) {
        return;
    }
    ll m = (l + r) / 2;
    merge_sort(a, l, m, ans);
    merge_sort(a, m, r, ans);
    merge(a, l, m, r, ans);
}

ve<ll> merge_dif(ve<ll> &a, ve<ll> &b, long long &ans) {
    ll l = 0;
    ll r = 0;
    ve<ll> res(0);
    res.reserve(a.size() + b.size());
    while (l < a.size() && r < b.size()) {
        if (a[l] > b[r]) {
            res.pb(b[r]);
            r++;
        } else {
            ans += r;
            res.pb(a[l]);
            l++;
        }
    }
    while (l < a.size()) {
        res.pb(a[l]);
        l++;
        ans += r;
    }
    while (r < b.size()) {
        res.pb(b[r]);
        r++;
    }
    return res;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    ll q;
    cin >> n >> q;
    ll a[n];
    ll i, j;
    for (i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll pref[n];
    pref[1] = a[1];
    for (i = 2; i < n; i++) {
        pref[i] = max(pref[i - 1], a[i]);
    }
    while (q--) {
        ll k;
        cin >> k >> i;
        if (i == 1) {
            cout << 1 << endl;
        }
        if (i != 2) {
            cout << a[n - 1 - (i - 3) << endl;
        }
        if (i == 2) {
            cout << pref[n - 1 - k + 2] << endl;
        }
    }
}
