#include <bits/stdc++.h>
using namespace std;

#define itn int
#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)

int dst(pii a, pii b) {
    return (a.ff - b.ff) * (a.ff - b.ff) + (a.ss - b.ss) * (a.ss - b.ss);
}


const int N = 1e5 + 10;
int col[N];
int ans[N];
int used[N];
int timer = 1;
int cur = 0;
int n;
int r;
vector <pii> toch;

void paint(int x) {
    used[x] = 1;
    ans[x] = 1;
    for (int i = 0; i < n; ++i) {
        if (i != x) {
            if (dst(toch[i], toch[x]) <= r * r) {
                if (!used[i]) {
                    paint(i);
                }
            }
            else {
                break;
            }
        }
    }
}

void dfs(int v, int c) {
    col[v] = c;
    if (cur) {
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (i != v) {
            if (dst(toch[i], toch[v]) <= r * r) {
                if (col[i] == c) {
                    cur = 1;
                    return;
                }
                else if (!col[i]){
                    dfs(i, 3 - c);
                }
            }
            else {
                break;
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    toch.resize(n);
    for (auto &[x, y]: toch) cin >> x >> y;
    sort(all(toch));
    for (int i = 0; i < n; ++i){
        if (!col[i]) {
            cur = 0;
            dfs(i, 1);
            if (cur) paint(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    cout << '\n';

}

signed main() {
    cin.tie(nullptr) -> sync_with_stdio(false);
    cout << setprecision(20) << fixed;


#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}