#include <bits/stdc++.h>
using namespace std;

#define itn int
#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)

const int N = 3e5 + 10;

int tr[4 * N];

void build(int i, int l, int r, vector <int> &a) {
    if (r - l == 1) {
        tr[i] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(i * 2 + 1, l, m, a);
    build(i * 2 + 2, m, r, a);
    tr[i] = max(tr[i * 2 + 1], tr[i * 2 + 2]);
}

int get(int i, itn l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return 0;
    if (ql <= l && r <= qr) return tr[i];
    int m = (l + r) / 2;
    return max(get(i  *2 + 1, l, m, ql, qr), get(i * 2 + 2, m, r, ql, qr));
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    for (auto &x: a) cin >> x;

    build(0,0, n, a);

    vector <int> ans(3, 1e9 + 7);

    vector <int> st;
    vector <int> nxt(n, n);

    for (itn i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            nxt[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

    int x = 0;
    for (itn i = 0; i < n - 2; ++i) {
        x = max(x, a[i]);
        if (nxt[i + 1] == n) {
            int y = a[i + 1];
            itn z = a.back();
            if (ans[0] > x) {
                ans[0] = x;
                ans[1] = y;
                ans[2] = z;
            }
            else if (ans[0] == x) {
                if (ans[1] > y) {
                    ans[1] = y;
                    ans[2] = z;
                }
                else if (ans[1] == y) {
                    ans[2] = min(ans[2], z);
                }
            }
        }
        else {
            int y = get(0, 0, n, i + 1, nxt[i + 1]);
            int z = get(0, 0, n, nxt[i + 1], n);
            if (ans[0] > x) {
                ans[0] = x;
                ans[1] = y;
                ans[2] = z;
            }
            else if (ans[0] == x) {
                if (ans[1] > y) {
                    ans[1] = y;
                    ans[2] = z;
                }
                else if (ans[1] == y) {
                    ans[2] = min(ans[2], z);
                }
            }
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[i - 1] << '\n';
    }
}

signed main() {
    cin.tie(nullptr) -> sync_with_stdio(false);
    cout << setprecision(20) << fixed;


#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}