#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include<map>
#include <set>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const ll LINF = 1e18 + 7;
const int INF = 1e9 + 7;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<int> rmn(n, n), rmx(n, n);
	{
		vector<int> stack1; stack1.reserve(n);
		vector<int> stack2; stack2.reserve(n);
		for (int i = 0; i < n; i++)
		{
			while (!stack1.empty() && a[stack1.back()] > a[i])
			{
				rmn[stack1.back()] = i;
				stack1.pop_back();
			}
			stack1.push_back(i);
			while (!stack2.empty() && a[stack2.back()] < a[i])
			{
				rmx[stack2.back()] = i;
				stack2.pop_back();
			}
			stack2.push_back(i);
		}
	}
	map<int, vector<int>> ans;
	while (q--)
	{
		int k, ind;
		cin >> k >> ind;
		if (ans.find(k) == ans.end())
		{
			int last = 0;
			for (int i = 0; i < k-1; i++)
			{
				ans[k].push_back(a[last]);

				int maxind = rmx[last] - 1;
				int mn = last + 1;
				for(int j = last+1; j<n;j++)
				{
					if (a[j] > a[last]) break;
					if (a[j] < a[mn]) mn = j;
				}

				last = mn;
			}
			int mx = 0;
			for (int i = last; i < n; i++) mx = max(mx, a[i]);
			ans[k].push_back(mx);
		}
		cout << ans[k][ind - 1] << '\n';
	}
}
// n*m*(n+m)
//n*m*m;