#include <bits/stdc++.h>

#define int long long
#define st first
#define nd second
#define pii pair<int, int>

using namespace std;

vector<pii> a;
map<pii, pair<int, int>> M;
int ans[100'100] = {};
#define INF 1'000'000'000
int n, l, r;

int dist(pii a, pii b)
{
    return (a.st - b.st) * (a.st - b.st) + (a.nd - b.nd) * (a.nd - b.nd); 
}

pii tosq(pii x)
{
    return {x.st / l, x.nd / l};
}

int used[100'100] = {};
int col[100'100] = {};
int ans_t[100'100] = {};
int dfs(int i, int t, int c)
{
    #ifdef LOCAL
    printf("%3.1lld: %3.1lld %3.1lld\n", t, a[i].st, a[i].nd);
    #endif
    used[i] = t;
    col[i] = c;
    pii v = tosq(a[i]);
    for (int dx : {-3,-2,-1,0,+1,+2,+3})
    {
        for (int dy : {-3,-2,-1,0,+1,+2,+3})
        {
            pii u = {v.st + dx, v.nd + dy};
            if (M.find(u) != M.end())
            {
                if (M[u] == (pii){-1,-1})
                {
                    return 1;
                }
                for (int j : {M[u].st, M[u].nd})
                {
                    #ifdef LOCAL
                    printf("%3.1lld:\t\t%+1.1lld %+1.1lld %lld\n", t, dx, dy, j);
                    #endif
                    if (j != -1 && j != i)
                    {
                        if (dist(a[i], a[j]) <= r * r)
                        {
                            if (ans[j] == 1 || ans_t[used[j]]) { return 1; }
                            if (used[j] == t) {
                                if (col[j] == c) { return 1; };
                            } else {
                                if (dfs(j, t, !c)) { return 1; }
                            }
                        }
                    }
                }
            }
        }
    }
    return 0;
}


signed main()
{
    cin >> n >> r;
    a.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].st >> a[i].nd;
    }
    l = r / sqrt(2);
    l = max(l, (int)1);

    for (int i = 0; i < n; ++i)
    {
        if (M.find(tosq(a[i])) == M.end()) {
            M[tosq(a[i])] = {i, -1};
        } else {
            pair<int, int> zzz = M[tosq(a[i])];
            if (zzz == (pii){-1ll, -1ll}) { ans[i] = 1; }
            else if (zzz.nd == -1)
            { M[tosq(a[i])] = {zzz.st, i}; }
            else
            { ans[zzz.st] = ans[zzz.nd] = ans[i] = 1; M[tosq(a[i])] = {-1ll, -1ll}; }
        }
    }

#ifdef LOCAL
    printf("r l = %lld %lld\n", r, l);
    for (int i = 0; i < n; ++i)
    { printf("%9.1lld", i); } printf("\n");
    for (int i = 0; i < n; ++i)
    { printf("(%3.1lld %3.1lld)", a[i].st, a[i].nd); } printf("\n");
    for (auto e : M)
    {
        printf("[%3.1lld %3.1lld] -> (%3.1lld %3.1lld)\n", e.st.st, e.st.nd, e.nd.st, e.nd.nd);
    }
#endif

    int t = 1;
    for (int i = 0; i < n; ++i)
    {
        if (used[i] == 0)
        {
            if (dfs(i, t, 0))
            {
                ans_t[t] = 1;
            }
            ++t;
        }
    }

    for (int i = 0; i < n; ++i)
    {
        cout << (ans[i] == +1 ? 1 : (ans_t[used[i]]));
    } cout << '\n';
}