#include <bits/extc++.h>

#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> up, h;

void dfs(int v, int p) {
    // cerr << "!!!! " << v << '\n';
    up[v] = p;
    for (int u : g[v]) {
        if (u != p && h[u] == -1) {
            h[u] = h[v] + 1;
            dfs(u, v);
        }
    }
}

vector<int> ans;

void dfs2(int v) {
    for (int u : g[v]) {
        if (h[u] > h[v]) {
            if (v == up[u]) {
                dfs2(u);
            }
        } else if (u != up[v]) {
            // cerr << "!!!!!!!!!!!!! " << v << ' ' << u << '\n';
            int x = v;
            while (true) {
                ans[x] = 1;
                if (x == u) {
                    break;
                }
                x = up[x];
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    g.resize(n);
    up.resize(n, -1);
    h.resize(n, -1);
    ans.resize(n);
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int v = 0; v < n; v++) {
        for (int u = 0; u < n; u++) {
            if (v == u) {
                continue;
            }
            int xx = x[v] - x[u];
            int yy = y[v] - y[u];
            if (xx * xx + yy * yy <= r * r) {
                g[v].push_back(u);
                // if (v < u)
                // cerr << "!! " << v << ' ' << u << '\n';
            }
        }
    }
    for (int v = 0; v < n; v++) {
        if (up[v] == -1) {
            dfs(v, v);
            dfs2(v);
        }
    }
    for (int v = 0; v < n; v++) {
        cout << ans[v];
    }
    cout << '\n';
    return 0;
}
