#pragma GCC optimize("O3")

#include <bits/extc++.h>

#define ll long long

using namespace std;

vector<vector<int>> g;
vector<int> up, h;

bool flag;

void dfs(int v, int p) {
    // cerr << "!!!! " << v << '\n';
    if (flag) {
        return;
    }
    up[v] = p;
    for (int u : g[v]) {
        if (u != p && h[u] == -1) {
            h[u] = h[v] + 1;
            dfs(u, v);
        } else if (h[u] % 2 == h[v] % 2) {
            flag = true;
            break;
        }
    }
}
vector<int> ans;
void dfs2(int v) {
    // cerr << "!!!! " << v << '\n';
    ans[v] = 1;
    for (int u : g[v]) {
        if (!ans[u]) {
            dfs2(u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    g.resize(n);
    up.resize(n, -1);
    h.resize(n, -1);
    ans.resize(n);
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int v = 0; v < n; v++) {
        for (int u = 0; u < n; u++) {
            if (v == u) {
                continue;
            }
            int xx = x[v] - x[u];
            int yy = y[v] - y[u];
            if ((ll)xx * (ll)xx + (ll)yy * (ll)yy <= (ll)r * (ll)r) {
                g[v].push_back(u);
                // if (v < u)
                // cerr << "!! " << v << ' ' << u << '\n';
            }
        }
    }
    for (int v = 0; v < n; v++) {
        if (h[v] == -1) {
            h[v] = 0;
        }
        flag = false;
        dfs(v, -1);
        if (flag) {
            dfs2(v);
        }
    }
    for (int v = 0; v < n; v++) {
        cout << ans[v];
    }
    cout << '\n';
    return 0;
}
