#pragma GCC optimize("Ofast, unroll-loops, no-stack-protector, inline")
// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
 
using namespace std;

int n;
long long r;
const int MXN = 1e5;
int used[MXN], ans[MXN];
 
struct Point {
    long long x, y;
    Point operator+(Point &b) {
        return {x + b.x, y + b.y};
    }
    Point operator-(Point &b) {
        return {x - b.x, y - b.y};
    }
    int dist() {
        return x * x + y * y;
    }
};
 
 
bool operator<(const Point &a, const Point &b) {
    if (a.x < b.x) {
        return 1;
    } else if (a.x == b.x) {
        return a.y < b.y;
    } else {
        return 0;
    }
}
 
map<Point, int> used1;
 
istream& operator>>(istream &in, Point &a) {
    in >> a.x >> a.y;
    return in;
}
 
vector<Point> dv;
Point arr[MXN];
vector<vector<int>> gr;
 
bool dfs(int v, int st) {
    used[v] = st;
    bool fl = 0;
    for (int u : gr[v]) {
        if (!used[u]) {
            if (st == 1) {
                fl |= dfs(u, 2);
            } else {
                fl |= dfs(u, 1);
            }
        } else {
            if (used[u] == used[v]) {
                fl = 1;
            }
        }
    }
    return fl;
}
 
 
 
void dfs1(int v) {
    ans[v] = 1;
    for (int u : gr[v]) {
        if (!ans[u]) {
            dfs1(u);
        }
    }
}
 
signed main() {
    ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
    // freopen("input.txt", "r", stdin);
    cin >> n >> r;
    r *= r;
    for (int i = -10; i <= 10; i++) {
        for (int j = -10; j <= 10; j++) {
            if (i * i + j * j <= r) {
                dv.push_back({i, j});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        used1[arr[i]] = i;
    }
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (Point cur : dv) {
            if (used1.find(cur + arr[i]) != used1.end()) {
                int j = used1[cur + arr[i]];
                if (i != j) {
                    gr[i].push_back(j);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (dfs(i, 1)) {
                dfs1(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << endl;
}