#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define all(v) v.begin(), v.end()
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll N = 1e5;

ll n, q, k, t = 1;
ll ans[N + 1];
string st;
bitset <N + 1> bi;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> n >> q >> st;
	for0(i, n) {
		if (st[i] == '0')
			continue;
		if (i > 0 && st[i - 1] == '1')
			bi[i] = 1;
		if (i < n - 1 && st[i + 1] == '1')
			bi[i] = 1;
		ans[0] += bi[i];
	}
	for0(i, n) {
		if (i > 0 && i < n - 1 && st[i] == '0' && st[i - 1] == '1' && st[i + 1] == '1' && bi[i - 1] == 0 && bi[i + 1] == 0) {
			ans[t] = ans[t - 1] + 3; st[i] = '1'; bi[i - 1] = 1; bi[i] = 1; bi[i + 1] = 1; t++;
		}
	}
	for0(i, n) {
		if (i > 0 && st[i] == '0' && st[i - 1] == '1' && bi[i - 1] == 0) {
			ans[t] = ans[t - 1] + 2; st[i] = '1'; bi[i - 1] = 1; bi[i] = 1; t++;
		}
		else if (i < n - 1 && st[i] == '0' && st[i + 1] == '1' && bi[i + 1] == 0) {
			ans[t] = ans[t - 1] + 2; st[i] = '1'; bi[i + 1] = 1; t++;
		}
	}
	while (t <= n) {
		ans[t] = ans[t - 1] + 1; t++;
	}
	if (ans[1] == 1)
		ans[1] = 0;
	while (q--) {
		cin >> k;
		cout << ans[k] << "\n";
	}
}