#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define all(v) v.begin(), v.end()
#define ret return
#define con continue
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll N = 3e5;

class node {
public:
	ll ma, mi, in;
};
class tree {
public:
	node tr[4 * N + 1];

	void build(ll k, ll lt, ll rt, ll(&arr)[N + 1]) {
		if (lt == rt) {
			tr[k].ma = arr[lt]; tr[k].mi = arr[lt]; tr[k].in = lt;
			ret;
		}
		ll m = (lt + rt) / 2;
		build(2 * k, lt, m, arr);
		build(2 * k + 1, m + 1, rt, arr);
		tr[k].ma = max(tr[2 * k].ma, tr[2 * k + 1].ma);
		if (tr[2 * k].mi <= tr[2 * k + 1].mi) {
			tr[k].mi = tr[2 * k].mi; tr[k].in = tr[2 * k].in;
		}
		else {
			tr[k].mi = tr[2 * k + 1].mi; tr[k].in = tr[2 * k + 1].in;
		}
	}
	pll mi(ll k, ll lt, ll rt, ll l, ll r) {
		if (lt > r || rt < l)
			ret{ N + 1, 0 };
		if (l <= lt && rt <= r)
			ret { tr[k].mi, tr[k].in };
		ll m = (lt + rt) / 2;
		ret min(mi(2 * k, lt, m, l, r), mi(2 * k + 1, m + 1, rt, l, r));
	}
	ll sp(ll k, ll lt, ll rt, ll l, ll x) {
		if (rt < l || tr[k].ma <= x)
			ret N + 1;
		if (lt == rt)
			ret lt;
		ll m = (lt + rt) / 2, res;
		res = sp(2 * k, lt, m, l, x);
		if (res != N + 1)
			ret res;
		ret sp(2 * k + 1, m + 1, rt, l, x);
	}
};

ll n, q, pr, r, k, t, m, o;
ll arr[N + 1], suf[N + 2];
tree tr;

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> n >> q;
	for1(i, n)
		cin >> arr[i];
	for (ll i = n; i >= 1; --i)
		suf[i] = max(suf[i + 1], arr[i]);
	tr.build(1, 1, n, arr);
	while (q--) {
		cin >> k >> t; m = k;
		pr = 1; o = 1; k--;
		while (o < t) {
			r = min(n + 2 - k, tr.sp(1, 1, n, pr, arr[pr])); pr = tr.mi(1, 1, n, pr + 1, r + 1).second; o++; k--;
		}
		if (o < m)
			cout << arr[pr] << "\n";
		else
			cout << suf[pr] << "\n";
	}
}