#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 1e5 + 5;

vector<ll> g[N];

pair<ll, ll> p[N];

ll used[2][N];
ll ans[N];
void dfs(ll v, ll x, ll &pr, vector<ll> &gg) {
    gg.push_back(v);
    used[x][v] = 2;
    for (ll u : g[v]) {
        if (used[x][u] == 2) {
            pr = 1;
        }
        if (used[x ^ 1][u] == 0) {
            dfs(u, x ^ 1, pr, gg);
        }
    }
    used[x][v] = 1;
}
void solve() {
    ll n, r;
    cin >> n >> r;
    unordered_map<ll, ll> qp;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        qp[p[i].first + p[i].second * N] = i;
    }
    auto len2 = [&] (pair<ll, ll> &a, pair<ll, ll> &b) {
        return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
    };
    for (int i = 0; i < n; ++i) {
        for (int w = -4; w <= 4; ++w) {
            for (int h = -4; h <= 4; ++h) {
                auto[x1, y1] = p[i];
                x1 += w;
                y1 += h;
                if (qp.count(x1 + y1 * N)) {
                    ll j = qp[x1 + y1 * N];
                    if (i != j && len2(p[i], p[j]) <= r * r) {
                        g[i].push_back(j);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[0][i]) {
            ll pr = 0;
            vector<ll> gg;
            dfs(i, 0, pr, gg);
            if (pr) {
                for (ll u: gg) {
                    ans[u] = 1;
                }
            }
        }
        cout << ans[i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}