//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define int long long

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e18;

int get_max(int l, int r, vector<int> &a) {
    int ret = -INF;
    for (int i = l; i <= r; ++i) ret = max(ret, a[i]);
    return ret;
}

int get_min(int l, int r, vector<int> &a ) {
    int ret = INF;
    for (int i = l; i <= r; ++i) ret = min(ret, a[i]);
    return ret;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        --ind;
        int indq = 0;
        vector<int> all;
        for (int i = 0; i < k - 1; ++i) {
            all.push_back(a[indq]);
            int next = indq + 1;
            if (a[indq + 1] > a[indq]) {
                ++indq;
                continue;
            }
            for (int j = indq + 1; j < n; ++j) {
                if (get_max(indq + 1, j - 1, a) > a[indq]) break;
                if (j + k - i - 1 > n) break;
                if (a[j] < a[next]) next = j;
            }
            indq = next;
        }
        all.push_back(a[indq]);
        for (int i = indq; i < n; ++i) all.back() = max(all.back(), a[i]);
        cout << all[ind] << "\n";
    }
}

void slow_solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> ans(n + 1);
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> now(1);
        for (int i = 0; i < n; ++i) {
            now.back() = max(now.back(), a[i]);
            if (i != n - 1 && ((mask >> i) & 1)) {
                now.push_back(0);
            }
        }
        if (ans[now.size()].empty()) ans[now.size()] = now;
        else ans[now.size()] = min(ans[now.size()], now);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k][i - 1] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    slow_solve();
    return 0;
}
