#include <bits/stdc++.h>
#include <random>

using namespace std;
typedef long long ll;

vector<vector<bool>> used;

vector<pair<ll, ll>> points;
ll n, r;
ll st;
bool found;
vector<vector<int>> av;

void dfs(int v, int c=0) {
    used[v][c] = true;
    if (c == 1 && st == v) {
        found = true;
    }
    if (found) return;

    for (auto i : av[v]) {
        if (used[i][1 - c]) continue;
        if (i == v) continue;
        if (found) return;

        dfs(i, 1 - c);
    }
}

void solve() {
    cin >> n >> r;
    points.resize(n);
    for (auto &x : points) {
        cin >> x.first >> x.second;
    }
    av.assign(n, vector<int>());
    for (int v = 0; v < n; ++v) {
        for (int i = 0; i < n; ++i) {
            if (i == v) continue;

            if ((points[i].first - points[v].first) * (points[i].first - points[v].first) + (points[i].second - points[v].second) * (points[i].second - points[v].second) <= r * r) {
                av[v].push_back(i);
            }
        }
        shuffle(av[v].begin(), av[v].end(), std::mt19937(std::random_device()()));
    }

    vector<bool> ok(n);
    for (int i = 0; i < n; ++i) {
        if (ok[i]) {
            cout << 1;
            continue;
        }
        used.assign(n, vector<bool>(2, false));
        st = i;
        found = false;
        dfs(i);
        if (used[i][1]) cout << 1;
        else cout << 0;
        for (int j = 0; j < n; ++j) {
            if (used[j][0] && used[j][1]) {
                ok[j] = true;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}