#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int n;
vector<int> arr;
const int INF = 1e9;

vector<int> calc_dp(int k) {
    vector<vector<int>> dp(n + 1, vector<int>(k + 1, INF));
    vector<vector<int>> prev_(n + 1, vector<int>(k + 1, -1));
    dp[0][0] = 0;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= k; ++j) {
            int now = 0;
            for (int l = i; l >= 1; --l) {
                now = max(now, arr[l - 1]);
                if (prev_[i][j] == -1 || dp[l - 1][j - 1] < dp[prev_[i][j]][j - 1]) {
                    dp[i][j] = now;
                    prev_[i][j] = l - 1;
                }
                if (dp[l - 1][j - 1] == dp[prev_[i][j]][j - 1] && now < dp[i][j]) {
                    dp[i][j] = now;
                    prev_[i][j] = l - 1;
                }
            }
        }
    }

    vector<int> group_res;
    int i = n;
    int j = k;
    while (j) {
        group_res.push_back(dp[i][j]);
        i = prev_[i][j];
        --j;
    }

    reverse(group_res.begin(), group_res.end());
    return group_res;
}

void solve() {
    int q;
    cin >> n >> q;

    arr.resize(n);
    for (auto &x : arr) {
        cin >> x;
    }


    vector<vector<int>> res(n + 1);

    while (q--) {
        int k, i;
        cin >> k >> i;

        if (res[k].empty()) {
            res[k] = calc_dp(k);
        }

        cout << res[k][i - 1] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}