#include <bits/stdc++.h>
using namespace std;
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define lolset(x) memset((x), 0, sizeof (x))
#define lolfill(x, v) fill(x, x + sizeof(x) / sizeof(*(x)), v)
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
inline ll sq(ll x) { return x * x; }
ll r;
inline bool dist_ok(pii p1, pii p2) {
    return sq(p1.first - p2.first) + sq(p1.second - p2.second) <= sq(r);
}


#ifdef DEBUG
const ll MAXN = 57, MAXC = 1e3, INF = 1e6;
#else
#define cerr if (0) cerr
const ll MAXN = 1e5 + 7, MAXC = 3e9 + 10, INF = 1e9 + 228 * 1e5;
#endif

int color[MAXN];
pii pts[MAXN];
unordered_map<ll, vector<int>> pts_net;
bool cur_flag;
bool ans[MAXN];
vector<int> cur_comp;

void dfs(int i) {
    cur_comp.push_back(i);
    auto [xi, yi] = pts[i];
    int nx = xi * 2 / r, ny = yi * 2 / r;
    for (int nx2 = nx - 2; nx2 <= nx + 2; nx2++) {
        for (int ny2 = ny - 2; ny2 <= ny + 2; ny2++) {
            auto it = pts_net.find(nx2 * MAXC + ny2);
            if (it == pts_net.end()) continue;
            for (int j : it->second) {
                if (dist_ok(pts[i], pts[j]) && i != j) {
                    if (!color[j]) {
                        color[j] = -color[i];
                        dfs(j);
                    } else if (color[j] != -color[i]) {
                        cur_flag = false;
                    }
                }
            }
        }
    }
}


signed main() {
    int n;
    cin >> n >> r;
    for (int i = 0; i < n; i++) {
        cin >> pts[i].first >> pts[i].second;
        pts_net[pts[i].first * 2 / r * MAXC + pts[i].second * 2 / r].push_back(i);
    }
    for (auto &[key, cell] : pts_net) {
        if (sz(cell) >= 3) {
            for (int i : cell) {
                color[i] = 2;
                ans[i] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            color[i] = 1;
            cur_flag = true;
            cur_comp.clear();
            dfs(i);
            for (int j : cur_comp)
                ans[j] = !cur_flag;
            cur_comp.clear();
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i];
    cout << '\n';
    return 0;
}
