#include <bits/stdc++.h>
using namespace std;
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define lolset(x) memset((x), 0, sizeof (x))
#define lolfill(x, v) fill(x, x + sizeof(x) / sizeof(*(x)), v)
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


#ifdef DEBUG
const ll MAXN = 0, INF = 1e6;
#else
#define cerr if (0) cerr
const ll MAXN = 0, INF = 1e9 + 228 * 1e5;
#endif


int sort_insert(vector<int> &a, int x) {
    a.push_back(x);
    int i = sz(a) - 1, c = 0;
    while (i > 0 && a[i - 1] > a[i]) {
        swap(a[i - 1], a[i]);
        i--;
        c++;
    }
    return c;
}


signed main() {
    int r, c;
    cin >> r >> c;
    vector a(r, vector(c, 0));
    for (int i = 0; i < r; i++)
        for (int j = 0; j < c; j++)
            cin >> a[i][j];
    vector col_add(r + 1, vector(c + 1, 0ll));
    vector row_add(r + 1, vector(c + 1, 0ll));
    vector tmp_sorted_col(c, vector(0, 0));
    vector<int> tmp_sorted_row, merger;
    ll inv0 = 0;
    for (int i = r - 1; i >= 0; i--) {
        tmp_sorted_row.clear();
        for (int j = c - 1; j >= 0; j--) {
            ll cinv_row = 0, cinv_col = 0;
            int kr = 0, kc = 0;
            while (kr < sz(tmp_sorted_row) && kc < sz(tmp_sorted_col[j])) {
                if (tmp_sorted_row[kr] < tmp_sorted_col[j][kc]) {
                    cinv_row += kc;
                    kr++;
                } else {
                    cinv_col += kr;
                    kc++;
                }
            }
            while (kr < sz(tmp_sorted_row)) {
                cinv_row += kc;
                kr++;
            }
            while (kc < sz(tmp_sorted_col[j])) {
                cinv_col += kr;
                kc++;
            }
            row_add[i][j] = row_add[i][j + 1] + cinv_row;
            col_add[i][j] = col_add[i + 1][j] + cinv_col;
            sort_insert(tmp_sorted_row, a[i][j]);
        }
        for (int j = c - 1; j >= 0; j--) {
            inv0 -= sort_insert(tmp_sorted_col[j], a[i][j]);
        }
    }
    inv0 += 1ll * c * r * (r - 1) / 2;
    for (int i = 0; i < c; i++)
        tmp_sorted_col[i].clear();
    for (int i = r - 1; i >= 0; i--) {
        tmp_sorted_row.clear();
        for (int j = 0; j < c; j++) {
            int kr = 0, kc = 0;
            while (kr < sz(tmp_sorted_row) && kc < sz(tmp_sorted_col[j])) {
                if (tmp_sorted_row[kr] < tmp_sorted_col[j][kc]) {
                    inv0 += kc;
                    kr++;
                } else {
                    kc++;
                }
            }
            while (kr < sz(tmp_sorted_row)) {
                inv0 += kc;
                kr++;
            }
            inv0 += sort_insert(tmp_sorted_row, a[i][j]);
        }
        for (int j = c - 1; j >= 0; j--) {
            sort_insert(tmp_sorted_col[j], a[i][j]);
        }
    }
    vector dp(r + 1, vector(c + 1, 0ll));
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            dp[i][j] = min(dp[i + 1][j] + row_add[i][j], dp[i][j + 1] + col_add[i][j]);
        }
    }
    cout << inv0 + dp[0][0] << '\n';
    return 0;
}
