#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,O3")
#define vl vector<long long>
#define pb push_back
#define pl pair<long long, long long>
#define F first
#define S second
#define vvl vector<vector<long long>>
#define rep(i, a, b) for (long long i = a; i < b; ++i)
typedef long long ll;
using namespace std;
const ll INF = 1e9;
ll n, r;
vector<array<ll, 3>> p;
vvl g;
vl used, dist, ans;
queue<ll> q;
vector<vector<array<ll, 2>>> dp;

bool av(ll i, ll j) {
    if (abs(p[j][0] - p[i][0]) > r || abs(p[j][1] - p[i][1]) > r) return 0;
    return ((p[j][0] - p[i][0]) * (p[j][0] - p[i][0]) + (p[j][1] - p[i][1]) * (p[j][1] - p[i][1])) <= r * r;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> r;
    p.resize(n);
    rep(i, 0, n) {
        cin >> p[i][0] >> p[i][1];
        p[i][2] = i;
    }
    if (n <= 2) {
        rep(i, 0, n) cout << 0;
        return 0;
    }
    g.resize(n);
    used.resize(n, 0);
    ans.resize(n, 0);
    dist.resize(n);
    rep(i, 0, n - 1) {
        rep(j, i + 1, n) {
            if (!av(i, j)) continue;
            g[i].pb(j);
            g[j].pb(i);
        }
    }
    dp.resize(n);
    rep(i, 0, n) {
        dp[i].resize(n, {0, 0});
    }
    rep(i, 0, n) {
        q.push(i);
        rep(j, 0, n) {
            used[j] = 0;
            dist[j] = INF;
        }
        dist[i] = 0;
        dp[i][i][0] = 1;
        while (q.size()) {
            ll v = q.front();
            q.pop();
            if (used[v]) continue;
            used[v] = 1;
            for (ll j : g[v]) {
                dp[i][j][1] |= dp[i][v][0];
                dp[i][j][0] |= dp[i][v][1];
                if (dist[j] > dist[v] + 1) {
                    dist[j] = dist[v] + 1;
                    q.push(j);
                }
            }
        }
    }
    rep(i, 0, n) {
        rep(j, 0, n) {
            if (i != j && dp[i][j][0] && dp[j][i][1]) ans[i] = 1;
        }
    }

    rep(i, 0, n) cout << ans[i];
    return 0;
}
