#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 1e5 + 1;
const ll INF = 1e18;

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    vector<vector<ll>> ans(n + 1, {INF});
    for (int mask = 0; mask < (1 << (n - 1)); mask++) {
        vector<ll> v;
        ll cur = -INF;
        for (int i = 1; i <= n; i++) {
            cur = max(cur, a[i]);
            if (((mask >> (i - 1)) & 1)) {
                v.push_back(cur);
                cur = -INF;
            }
        }
        v.push_back(cur);
        ans[v.size()] = min(ans[v.size()], v);
    }
    while (q--) {
        ll k, i; cin >> k >> i;
        cout << ans[k][i - 1] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}