#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

int n, r;
map<pair<int, int>, int> mp;
vector<pair<int, int>> p;
vector<pair<int, int>> shift;
vector<int> col;
vector<int> st;
bool fl;

void dfs(int v, int pr = -1, int c = 0) {
    col[v] = c + 1;
    st.push_back(v);
    for (auto sh : shift) {
        pair<int, int> top = {p[v].first + sh.first, p[v].second + sh.second};
        if (!mp.count(top)) continue;
        int to = mp[top];
        if (to != pr && col[to] == 0) {
            dfs(to, v, c ^ 1);
        } else if (to != pr && col[to] == col[v]) {
            fl = true;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    p.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        mp[p[i]] = i;
    }
    for (int x = -r; x <= r; ++x) {
        for (int y = -r; y <= r; ++y) {
            if (x * x + y * y <= r * r && (x != 0 || y != 0)) {
                shift.push_back({x, y});
            }
        }
    }
    vector<bool> ans(n, false);
    col.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (col[i] == 0) {
            fl = false;
            dfs(i);
            for (auto el : st) {
                ans[el] = fl;
            }
            st.clear();
        }
    }

    for (int i = 0; i < n; ++i) {
        if (ans[i]) {
            cout << "1";
        } else {
            cout << '0';
        }
    }
    cout << "\n";

    return 0;
}