#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define pii pair<int, int>
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18;

void solve()
{
    int n, m; cin >> n >> m;
    int a[n][m];
    ll dp[n+1][m+1], inv[2][n][m];
    for(int i = 0; i<n; ++i)
    {
        for(int j = 0; j<m; ++j)
        {
            cin >> a[i][j];
            inv[0][i][j] = 0;
            inv[1][i][j] = 0;
        }
    }
    for(int i = 0; i<=n; ++i)
        for(int j = 0; j<=m; ++j)
            dp[i][j] = INF;
    oset st, x;
    for(int i = n-1; i>=0; --i)
    {
        for(int j = m-1; j>=0; --j)
        {
            if(j!=m-1) inv[0][i][j] = inv[0][i][j+1];
            for(int k = n-1; k>i; --k)
            {
                inv[0][i][j] += 1ll*x.size() - x.order_of_key(a[k][j]);
                st.insert(a[k][j]);
            }
            inv[0][i][j] += 1ll*x.order_of_key(a[i][j]) + 1ll*st.order_of_key(a[i][j]);
            x.insert(a[i][j]);
        }
        st.clear();
        x.clear();
    }
    for(int j = m-1; j>=0; --j)
    {
        for(int i = n-1; i>=0; --i)
        {
            if(i!=n-1) inv[1][i][j] = inv[1][i+1][j];
            for(int k = m-1; k>j; --k)
            {
                inv[1][i][j] += 1ll*x.size() - x.order_of_key(a[i][k]);
                st.insert(a[i][k]);
            }
            inv[1][i][j] += 1ll*x.order_of_key(a[i][j]) + 1ll*st.order_of_key(a[i][j]);
            x.insert(a[i][j]);
        }
        st.clear();
        x.clear();
    }

    dp[0][0] = 0;
    for(int i = 0; i<=n; ++i)
    {
        for(int j = 0; j<=m; ++j)
        {
            if((i==0 && j==0) || (i==n && j==m)) continue;
            if(i!=0)
                dp[i][j] = min(dp[i][j], dp[i-1][j]+inv[0][i-1][j]);
            if(j!=0)
                dp[i][j] = min(dp[i][j], dp[i][j-1]+inv[1][i][j-1]);
            st.clear();
        }
    }
    ll ans = INF;
    for(int r = 0; r<n; ++r)
        ans = min(ans, dp[r][m]);
    for(int c = 0; c<m; ++c)
        ans = min(ans, dp[n][c]);
    cout << ans << "\n";
    return;
}

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); int t = 1;
    //freopen("in.txt", "r", stdin); int t; cin >> t;
    while(t--)
        solve();
    return 0;
}
