#ifdef  LOCAL
#define GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl;
#else
#pragma GCC optimize("O3")
#define debug(x)
#endif

#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

struct node {
    int x = 1e9, i = -1;
    node operator+(const node b) const {
        if (x < b.x) return *this;
        return b;
    }
};

// struct SegmentTree : vector<node> {
//     int n;
//     SegmentTree(vector<int> _x) {
//         n = sz(_x);
//         for (int m = 1; m < n || !(n = m); m <<= 1);
//         while (sz(_x) < n) _x.push_back(1e9);
//         resize(2 * n);
//         for (int i = 0; i < n; i++) {
//             at(i + n) = {_x[i], i};
//         }
//         for (int i = n - 1; i > 0; i--) {
//             at(i) = at(i * 2) + at(i * 2 + 1);
//         }
//     }
//
//     node get(int p, int l, int r, int ql, int qr) {
//
//     }
// };

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> next_bigger(n, n), next_min(n, n);
    int cur_min = 1e9;
    int cur_i = n;
    for (int i = n - 1; i >= 0; i--) {
        next_min[i] = cur_i;
        if (cur_min > a[i]) {
            cur_min = a[i];
            cur_i = i;
        }
    }
    vector<int> mxses;
    for (int i = 0; i < n; i++) {
        while (mxses.size() && a[mxses.back()] < a[i]) {
            next_bigger[mxses.back()] = i;
            mxses.pop_back();
        }
        mxses.push_back(i);
    }
    vector<int> suf_mx(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        suf_mx[i] = max(suf_mx[i + 1], a[i]);
    }
    for (int _ = 0; _ < q; _++) {
        int k, i;
        cin >> k >> i;
        if (k == 1) {
            cout << n << '\n';
            continue;
        }
        vector<int> b;
        int j = 0;
        while (true) {
            int left_end = j + 1;
            int right_end = n - (k - sz(b)) + 1;
            right_end = min(right_end, next_bigger[j]);
            b.push_back(a[j]);
            if (b.size() == k - 1) {
                b.push_back(suf_mx[right_end]);
                break;
            }
            int cur_min = 1e9;
            int cur_i = j;
            for (int x = left_end; x <= right_end && a[x - 1] <= a[j]; x++) {
                if (a[x] < cur_min) {
                    cur_min = a[x];
                    cur_i = x;
                }
            }
            assert(left_end <= right_end);
            assert(cur_i != j);
            j = cur_i;
        }
        cout << b[i - 1] << '\n';
    }
}