#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll dist(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector<vector<ll> > g;
vector<ll> col;
vector<ll> col1;
vector<bool> ans;

void dfs(const ll v, const ll c, ll c1) {
    col[v] = c;
    col1[v] = c1;
    for (auto &to: g[v]) {
        if (col[to] == -1) {
            dfs(to, c, 1 - c1);
        } else if (col1[to] == c1) {
            ans[c] = true;
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll> > a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    g.assign(n, {});
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            if (dist(a[i], a[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    col.assign(n, -1);
    col1.assign(n, -1);
    ans.assign(n, false);
    ll c = 0;
    for (ll i = 0; i < n; i++) {
        if (col[i] == -1) {
            dfs(i, c++, 0);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ans[col[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
