#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll dist(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector<vector<ll> > g;
vector<bool> big;
vector<ll> col;
vector<ll> col1;
vector<bool> ans;

void dfs(const ll v, const ll c, ll c1) {
    col[v] = c;
    col1[v] = c1;
    for (auto &to: g[v]) {
        if (big[to]) {
            ans[c] = true;
        } else {
            if (col[to] == -1) {
                dfs(to, c, 1 - c1);
            } else if (col1[to] == c1) {
                ans[c] = true;
            }
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll> > a(n);
    map<pair<ll, ll>, ll> mp;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        mp[a[i]] = i;
    }
    g.assign(n, {});
    big.assign(n, false);
    for (ll i = 0; i < n; i++) {
        for (ll x = -2; x <= 2; x++) {
            for (ll y = -2; y <= 2; y++) {
                if (x == 0 && y == 0) {
                    continue;
                }
                if (x * x + y * y <= r * r) {
                    pair<ll, ll> gg(a[i].first + x, a[i].second + y);
                    if (mp.count(gg)) {
                        g[i].push_back(mp[gg]);
                    }
                }
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        if (g[i].size() >= 6) {
            big[i] = true;
        }
    }
    col.assign(n, -1);
    col1.assign(n, -1);
    ans.assign(n, false);
    ll c = 0;
    for (ll i = 0; i < n; i++) {
        if (big[i]) {
            ans[c] = true;
            col[i] = c++;
        } else if (col[i] == -1) {
            dfs(i, c++, 0);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ans[col[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
