#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 2e5 + 10;

int n, r, d[N][2];
pii a[N];

int dst(pii p1, pii p2) {
    return (p1.X - p2.X) * (p1.X - p2.X) + (p1.Y - p2.Y) * (p1.Y - p2.Y);
}

bool can(int i, int j) {
    return dst(a[i], a[j]) <= r * r;
}

void solve() {
    cin >> n >> r;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
    }

    for (int i = 1; i <= n; ++i) d[i][0] = d[i][1] = INF;

    d[1][0] = 0;
    deque<pii> q;
    q.pb({1, 0});
    while (!q.empty()) {
        auto [v, j] = q.front();
        q.pop_front();
        for (int to = 1; to <= n; ++to) {
            if (can(v, to)) {
                if (d[to][j^1] > d[v][j] + 1) {
                    d[to][j^1] = d[v][j];
                    q.pb({to, j});
                }
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        bool f = false;
        for (int j = 1; j <= n; ++j) {
            if (can(i, j)) {
                if ((d[i][0] != INF && d[j][1] != INF) || (d[i][1] != INF && d[j][0] != INF)) {
                    f = true;
                    break;
                }
            }
        }
        if (f) cout << 1;
        else cout << 0;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}