#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#pragma GCC optimie("O3")

typedef long long ll;
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 1e5 + 10;

int n, r;
bool ans[N];
pii a[N];

int dst(pii p1, pii p2)  {
    return (p1.X - p2.X) * (p1.X - p2.X) + (p1.Y - p2.Y) * (p1.Y - p2.Y);
}

bool can(int i, int j)  {
    return dst(a[i], a[j]) <= r * r;
}



int usd[N], tmr = 0;
int col[N];
vector<int> g[N], comp;
gp_hash_table<int, int> ind;

bool dfs(int v) {
    bool f = false;
    usd[v] = tmr;
    comp.pb(v);
    for (int to : g[v]) {
        if (usd[to] == tmr) {
            if (col[to] == col[v]) f = true;
        }
        else if (usd[to] == 0) {
            col[to] = col[v] ^ 1;
            f |= dfs(to);
        }
    }
    return f;
}

void solve() {
    cin >> n >> r;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
        ind[a[i].X * INF + a[i].Y] = i;
    }

    for (int i = 1; i <= n; ++i) {
        for (int x1 = a[i].X - r; x1 <= a[i].X + r; ++x1) {
            for (int y1 = a[i].Y - r; y1 <= a[i].Y + r; ++y1) {
                if (a[i].X == x1 && a[i].Y == y1) continue;
                if (dst(a[i], {x1, y1}) > r * r || ind.find(x1 * INF + y1) == ind.end()) continue;
                g[i].pb(ind[x1 * INF + y1]);
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        if (usd[i]) continue;
        ++tmr;
        comp.clear();
        col[i] = 0;
        bool f = dfs(i);
        for (int j : comp) ans[j] = f;
    }

    for (int i = 1; i <= n; ++i) cout << ans[i];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}