#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const ll INF = 1e18 + 7;
const int N = 3e5 + 10;

int n, m, sz;
vector<vector<int>> a;
vector<vector<ll>> dp;

int tree[N * 4];

void upd(int tind, int l, int r, int qind, int x) {
    if (r - l == 1) {
        tree[tind] += x;
        return;
    }
    int m = (r + l) >> 1;
    if (qind < m) upd(tind * 2 + 1, l, m, qind, x);
    else upd(tind * 2 + 2, m, r, qind, x);
    tree[tind] = tree[tind * 2 + 1] + tree[tind * 2 + 2];
}

int get(int tind, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) return tree[tind];
    if (ql >= r || l >= qr) return 0;
    int m = (r + l) >> 1;
    return get(tind * 2 + 1, l, m, ql, qr) + get(tind * 2 + 2, m, r, ql, qr);
}

ll inv(vector<int> &b) {
    ll ans = 0;
    for (int j = 0; j < (int)b.size(); ++j) {
        ans += get(0, 1, sz, b[j], sz);
        upd(0, 1, sz, b[j], 1);
    }
    for (int j = 0; j < (int)b.size(); ++j) upd(0, 1, sz, b[j], -1);
    return ans;
}

void solve() {
    int n, m; cin >> n >> m;
    sz = n * m + 1;
    a.resize(n + 1, vector<int> (m + 1));
    dp.resize(n + 2, vector<ll> (m + 2, INF));
    for(int i = 1; i <= n; ++i) for (int j = 1; j <= m; ++j) cin >> a[i][j];

    dp[1][1] = 0;
    for (int i = 1; i <= n + 1; ++i) {
        for (int j = 1; j <= m + 1; ++j) {
            //dp[i - 1][j]
            if (i - 1 >= 1 && j <= m) {
                ll cur = 0;
                for (int i1 = 1; i1 <= n; ++i1) {
                    for (int j1 = 1; j1 <= (i1 >= i - 1 ? j - 1 : m); ++j1) {
                        upd(0, 1, sz, a[i1][j1], 1);
                    }
                }
                for (int j1 = j; j1 <= m; ++j1) {
                    cur += get(0, 1, sz, a[i - 1][j1], sz);
                    upd(0, 1, sz, a[i - 1][j1], 1);
                }

                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cur);

                for (int i1 = 1; i1 <= n; ++i1) for (int j1 = 1; j1 <= (i1 >= i - 1 ? j - 1 : m); ++j1) upd(0, 1, sz, a[i1][j1], -1);
                for (int j1 = j; j1 <= m; ++j1) upd(0, 1, sz, a[i - 1][j1], -1);
            }

            //dp[i][j - 1]
            if (j - 1 >= 1 && i <= n) {
                ll cur = 0;
                for (int i1 = 1; i1 <= n; ++i1) {
                    for (int j1 = 1; j1 <= (i1 >= i ? j - 2 : m); ++j1) {
                        upd(0, 1, sz, a[i1][j1], 1);
                    }
                }
                for (int i1 = i; i1 <= n; ++i1) {
                    cur += get(0, 1, sz, a[i1][j - 1], sz);
                    upd(0, 1, sz, a[i1][j - 1], 1);
                }

                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cur);

                for (int i1 = 1; i1 <= n; ++i1) for (int j1 = 1; j1 <= (i1 >= i ? j - 2 : m); ++j1) upd(0, 1, sz, a[i1][j1], -1);
                for (int i1 = i; i1 <= n; ++i1) upd(0, 1, sz, a[i1][j - 1], -1);
            }
        }
    }

    ll ans = INF;
    for (int i = 1; i <= n; ++i) ans = min(ans, dp[i][m + 1]);
    for (int j = 1; j <= m; ++j) ans = min(ans, dp[n + 1][j]);
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}