#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 3e5 + 10;

int n, m;
vector<vector<int>> a;

int tree[N * 4];

void upd(int tind, int l, int r, int qind, int x) {
    if (r - l == 1) {
        tree[tind] += x;
        return;
    }
    int m = (r + l) >> 1;
    if (qind < m) upd(tind * 2 + 1, l, m, qind, x);
    else upd(tind * 2 + 2, m, r, qind, x);
    tree[tind] = tree[tind * 2 + 1] + tree[tind * 2 + 2];
}

int get(int tind, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) return tree[tind];
    if (ql >= r || l >= qr) return 0;
    int m = (r + l) >> 1;
    return get(tind * 2 + 1, l, m, ql, qr) + get(tind * 2 + 2, m, r, ql, qr);
}

void solve() {
    int n, m; cin >> n >> m;
    a.resize(n + 1, vector<int> (m + 1));
    for(int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> a[i][j];
        }
    }

    ll ans = 0;

    for (int j = 1; j <= m; ++j) {
        ans += get(0, 1, m + 1, a[1][j], m + 1);
        upd(0, 1, m + 1, a[1][j], 1);
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}