#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 3e5 + 10;

int n, q, a[N], lg[N];
vector<int> ans[N];

pii spt_mx[N][20], spt_mn[N][20];;

pii get_mx(int l, int r) {
    int g = lg[r - l + 1];
    return max(spt_mx[l][g], spt_mx[r - (1 << g) + 1][g]);
}

pii get_mn(int l, int r) {
    int g = lg[r - l + 1];
    return min(spt_mn[l][g], spt_mn[r - (1 << g) + 1][g]);
}

void solve() {
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        spt_mx[i][0] = {a[i], i};
        spt_mn[i][0] = {a[i], i};
    }

    for (int j = 1; j < 20; ++j) {
        for (int i = 1; i + (1 << j) - 1 <= n; ++i) {
            spt_mx[i][j] = max(spt_mx[i][j - 1], spt_mx[i + (1 << (j - 1))][j - 1]);
            spt_mn[i][j] = min(spt_mn[i][j - 1], spt_mn[i + (1 << (j - 1))][j - 1]);
        }
    }

    vector<pii> zpr;
    vector<int> ks;
    for (int i = 0; i < q; ++i) {
        int k, j; cin >> k >> j;
        zpr.pb({k, j});
        ks.pb(k);
    }

    sort(all(ks));
    ks.resize(unique(all(ks)) - ks.begin());

    for (int k : ks) {
        if (k == 1) continue;
        ans[k].resize(k + 1);
        ans[k][1] = a[1];
        int i = 2;
        for (int j = 2; j <= k - 1; ++j) {
            int l = i, r = n;
            while (r - l > 1) {
                int m = (r + l) >> 1;
                if (get_mx(i, m).X > ans[k][j - 1]) r = m;
                else l = m;
            }
            pii mn = {a[i], i};
            mn = min(mn, get_mn(i, min(l, n - (k - j))));
            ans[k][j] = mn.X;
            i = mn.Y + 1;
        }
        ans[k][k] = a[n];
        for (; i <= n; ++i) if (a[i] > ans[k][k - 1]) break;
        for (int j = n; j >= i; --j) ans[k][k] = max(ans[k][k], a[j]);
    }

    for (auto [k, j] : zpr) {
        if (k == 1) cout << n << '\n';
        else  cout << ans[k][j] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    for (int i = 2; i < N; ++i) lg[i] = lg[i / 2] + 1;

    solve();
}