#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {

    ll n, r;
    cin >> n >> r;
    r *= r;

    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    queue<pair<ll, ll>> q;
    vector<vector<ll>> d(n, vector<ll>(2, 0));

    for (int cur = 0; cur < n; cur++) {
        if (d[cur][0] == 0 && d[cur][1] == 0) {
            q.push({cur, 0});
            d[cur][0] = 1;
        }

        while (!q.empty()) {

            ll v = q.front().first;
            ll c = q.front().second;
            q.pop();

            for (int i = 0; i < n; i++) {

                if (i == v) {
                    continue;
                }

                ll dst = (a[i].first - a[v].first) * (a[i].first - a[v].first) +
                    (a[i].second - a[v].second) * (a[i].second - a[v].second);

                if (dst <= r && d[i][!c] == 0) {
                    d[i][!c] = 1;
                    q.emplace(i, !c);
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (d[i][0] == 1 && d[i][1] == 1) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}