#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;

void solve() {

    ll n, r;
    cin >> n >> r;
    r *= r;

    vector<pair<ll, ll>> a(n);
    unordered_map<ll, set<pair<ll, ll>>> st;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        st[a[i].first].insert({a[i].second, i});
    }

    queue<pair<ll, ll>> q;
    vector<vector<ll>> d(n, vector<ll>(2, 0));

    for (int cur = 0; cur < n; cur++) {
        if (d[cur][0] == 0 && d[cur][1] == 0) {
            q.push({cur, 0});
            d[cur][0] = 1;
        }

        while (!q.empty()) {

            ll v = q.front().first;
            ll c = q.front().second;
            q.pop();

            for (int i = max(0LL, a[v].first - r); i <= a[v].first + r; i++) {
                auto lb = st[i].lower_bound({a[v].second - r, 0});
                while (lb != st[i].end() && lb->first <= a[v].first + r) {

                    pair<ll, ll> ai = *lb;
                    if (ai.second == v) {
                        lb++;
                        continue;
                    }

                    ll dst = (i - a[v].first) * (i - a[v].first) +
                        (ai.first - a[v].second) * (ai.first - a[v].second);

                    if (dst <= r && d[ai.second][!c] == 0) {
                        d[ai.second][!c] = 1;
                        q.emplace(ai.second, !c);
                    }
                    lb++;
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (d[i][0] == 1 && d[i][1] == 1) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
 
int main() {
 
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
 
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
 
    return 0;
}