#include <bits/stdc++.h>

#include <random>

using namespace std;
using ll = long long;
using ld = long double;
int inf = 1e9;


int mn = inf;

int count(vector<int> &mask, vector<vector<int>> &v, int n, int m) {
    int i1 = 0;
    int j1 = 0;
    vector<int> d;
    for (int j = 0; j < n + m; j++) {
        if (mask[j] == 1) {
            for (int j2 = j1; j2 < m; j2++) {
                d.push_back(v[i1][j2]);
            }

            i1++;
        } else {
            for (int i2 = i1; i2 < n; i2++) {
                d.push_back(v[i2][j1]);
            }
            j1++;
        }
    }


    int cnt = 0;
    for (int q = 0; q < d.size(); q++) {
        for (int j = q + 1; j < d.size(); j++) {
            if (d[q] > d[j]) {
                cnt++;
            }
        }
    }

    return cnt;
}

ld rndd() {
    ld x = rand();
    ld q = x / (ld)1e9;
    return q;
}

void go() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> v(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }

    srand(3252);
    int q = 10;
    while (q--) {
        vector<int> mask;
        for (int i = 0; i < n; i++) {
            mask.push_back(1);
        }

        for (int i = 0; i < m; i++) {
            mask.push_back(0);
        }

        vector<int> x;
        vector<int> y;
        shuffle(mask.begin(), mask.end(), mt19937(random_device()()));


        for (int i = 0; i < n + m; i++) {
            if (mask[i] == 1) {
                x.push_back(i);
            } else {
                y.push_back(i);
            }
        }

        ld temp = 1.0;
        ld t = 0.9995;

        int cnt = count(mask, v, n, m);
        int p = n + m;
        int q1 = 10000;
        while (q1--) {
            int x1 = rand() % n;
            int y1 = rand() % m;
            vector<int> mask1;

            int pos = y[y1];
            int pos1 = x[x1];

            mask[pos] = 1;
            mask[pos1] = 0;
            y[y1] = pos1;
            x[x1] = pos;

            int cnt1 = count(mask, v, n, m);

            if (cnt1 < cnt) {
                cnt = cnt1;
                continue;
            } else {
                ld f = rndd();
                if (f < temp) {
                    mask = mask1;
                }
            }
        }

        mn = min(mn, cnt);
    }
    cout << mn << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        go();
    }
}