#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

typedef long long int lint;

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto &el: a) cin >> el;
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        vector <int> b(k);
        b[0] = a[0];
        int prev_ind = 0;
        for (int i = 1; i < k - 1; ++i) {
          int x = prev_ind + 1;
          while (x < n - (k - i) && a[x] <= b[i - 1]) ++x;
          int new_ind = min_element(a.begin() + prev_ind + 1, a.begin() + x + 1) - a.begin();
          b[i] = a[new_ind];
          prev_ind = new_ind;
        }
        b.back() = *max_element(a.begin() + prev_ind + 1, a.end());
        cout << b[ind - 1] << "\n";
    }
    return 0;
}
