    #include <bits/stdc++.h>

    using namespace std;

    typedef long long ll;
    //#define int long long
    #define all(x) (x).begin(), (x).end()

    int n, r;
    vector <vector <int>> g;
    vector <int> used;
    vector <int> ans;
    vector <int> h, p;
    int flag = 0;

    void dfs(int v) {
        used[v] = 1;
        for (auto x : g[v]) {
            if (x == p[v]) {
                continue;
            }
            if (used[x] && (h[v] - h[x]) % 2 == 0) {
                flag = 1;
                return;
            } else if (used[x] == 0){
                p[x] = v;
                h[x] = h[v] + 1;
                dfs(x);
            }
        }
    }

    void dfs1(int v) {
        ans[v] = 1;
        used[v] = 1;
        for (auto x : g[v]) {
            if (x == p[v]) {
                continue;
            }
            if (used[x] == 0){
                p[x] = v;
                dfs1(x);
            }
        }
    }

    signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        cin >> n >> r;
        used.resize(n, 0);
        g.resize(n);
        h.resize(n, 0);
        p.resize(n, -1);
        vector <int> x(n), y(n);
        map <pair <int, int>, int> m;
        for (int i = 0; i < n; ++i) {
            cin >> x[i] >> y[i];
            m[{x[i],y[i]}] = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            for (int k1 = x[i] - r; k1 <= x[i] + r; ++k1) {
                for (int k2 = y[i] - r; k2 <= y[i] + r; ++k2) {
                    if (m[{k1, k2}] != 0) {
                        int j = m[{k1, k2}]- 1;
                        if (j == i) {
                            continue;
                        }
                        if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                            g[i].push_back(j);
                            g[j].push_back(i);
                        }
                    }
                }
            }
        }
        vector <int> st;
        for (int i = 0; i < n; ++i) {
            if (used[i] == 0) {
                flag = 0;
                h.clear();
                h.resize(n, 0);
                dfs(i);
                if (flag) {
                    st.push_back(i);
                }
            }
        }
        used.clear();
        used.resize(n, 0);
        p.clear();
        p.resize(n, -1);
        ans.resize(n);
        for (auto x : st) {
            dfs1(x);
        }
        for (auto x : ans) {
            cout << x;
        }
        return 0;
    }