#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll MAXN = 1e6;
const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 7;
mt19937 rnd(2);
vector<vector<int> > used;
vector<vector<ll> > graph;

void dfs(ll v, ll p) {
    used[v][p] = 1;
    for (auto u: graph[v]) {
        if (used[u][(p + 1) % 2] == 0) {
            dfs(u, (p + 1) % 2);
        }
    }
}

int main() {
    ll n, r, a, b;
    cin >> n >> r;
    vector<pair<ll, ll> > arr;
    used.resize(n, {0, 0});
    graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        arr.push_back({a, b});
    }
    for (int i = 0; i < MAXN; i++) {
        ll i1 = rnd()%n;
        ll i2 = rnd()%n;
        if (i1 != i2 && (arr[i2].second - arr[i1].second) * (arr[i2].second - arr[i1].second) + (
                arr[i2].first - arr[i1].first) * (arr[i2].first - arr[i1].first) <= r * r) {
            graph[i1].push_back(i2);
            graph[i2].push_back(i1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][0] == 0 && used[i][1] == 0) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i][1] == 1 && used[i][0] == 1) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    return 0;
}
