#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ff first
#define ss second
#define mp make_pair

deque <int> q;
vector <int> c, used;
vector <pair <pair <int, int>, int>> d;
bool f;
int cl = 0, r;

int dist(int i, int j) {
    return (d[i].ff.ff - d[j].ff.ff) * (d[i].ff.ff - d[j].ff.ff) + (d[i].ff.ss - d[j].ff.ss) * (d[i].ff.ss - d[j].ff.ss);
}

void bfs() {
    while (q.size()) {
        int v = q.front();
        q.pop_front();
        int i = v + 1;
        while (i < d.size() && abs(d[i].ff.ff - d[v].ff.ff) <= r) {
            if (dist(i, v) <= r * r) {
                if (c[i] == c[v]) {
                    f = true;
                } else if (c[i] == 0) {
                    q.push_back(i);
                    used[i] = cl;
                    c[i] = 3 - c[v];
                }
            }
            ++i;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> r;
    if (n > 3 && r > 100) {
        return 1;
    }
    c.resize(n, 0);
    used.resize(n, -1);
    d.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i].ff.ff >> d[i].ff.ss;
        d[i].ss = i;
    }
    sort(d.begin(), d.end());
    vector <int> t;
    for (int i = 0; i < n; ++i) {
        if (c[i] == 0) {
            q.push_back(i);
            f = false;
            c[i] = 1;
            used[i] = cl;
            bfs();
            t.push_back(f);
            ++cl;
        }
    }
    vector <int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[d[i].ss] = t[used[i]];
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}
