#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ff first
#define ss second
#define mp make_pair

vector <pair <int, int>> tree;

void upd(int l, int r, int k, int x, int v) {
    if (l == k && k + 1 == r) {
        tree[v] = mp(x, k);
        return;
    } if (k < l || r <= k) {
        return;
    }
    upd(l, (l + r) / 2, k, x, 2 * v + 1);
    upd((l + r) / 2, r, k, x, 2 * v + 2);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

pair <int, int> get(int l, int r, int l1, int r1, int v) {
    if (l1 <= l && r <= r1) {
        return tree[v];
    } if (r1 <= l || r <= l1) {
        return mp(1e18, 1e18);
    }
    return min(get(l, (l + r) / 2, l1, r1, 2 * v + 1), get((l + r) / 2, r, l1, r1, 2 * v + 2));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    tree.resize(4 * n, mp(1e18, 1e18));
    int mx = 0;
    vector <int> a(n), nx(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mx = max(a[i], mx);
        upd(0, n, i, a[i], 0);
    }
    vector <int> c;
    for (int i = n - 1; i >= 0; --i) {
        while (c.size() && a[c.back()] < a[i]) {
            c.pop_back();
        }
        if (c.size()) {
            nx[i] = c.back();
        } else {
            nx[i] = n;
        }
        c.push_back(i);
    }
    vector <vector <int>> f(n, vector <int> (4, 0));
    vector <pair <int, int>> ans(q);
    for (int j = 0; j < q; ++j) {
        int k, i;
        cin >> k >> i;
        --k;
        --i;
        ans[j] = mp(k, i);
    }
    for (int i = 1; i <= n; ++i) {
        int s = 0;
        for (int j = 0; j < min(i - 1, 3ll); ++j) {
            f[i - 1][j] = a[s];
            if (s + 1 == min(nx[s], n - i + j + 2)) {
                ++s;
            } else {
                s = get(0, n, s + 1, min(nx[s], n - i + j + 2), 0).ss;
            }
        }
        if (i - 1 < 4) {
            int mx = 0;
            for (int j = s; j < n; ++j) {
                mx = max(mx, a[j]);
            }
            if (i != 1 && f[i - 1][i - 2] > mx) {
                f[i - 1][i - 1] = a.back();
            } else {
                f[i - 1][i - 1] = mx;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << f[ans[i].ff][ans[i].ss] << "\n";
    }
}
