#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

void solve() {
	int r, c;
	cin >> r >> c;
	vector<vector<int>> a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}

	int ans = 0;
	int i = 0, j = 0;
	while (true) {
		int ans1 = 0, ans2 = 0;
		if (i == r - 1 and j == c - 1)
			break;

		if (i == r - 1) {
			ans1 = 1e9;
		}
		if (i != r - 1) {
			for (int q = j; q < c; ++q) {
				for (int w = q + 1; w < c; ++w) {
					if (a[i][q] > a[i][w])
						ans1++;
				}
			}
			for (int q = i + 1; q < r; ++q) {
				for (int w = j; w < c; ++w) {
					for (int l = j; l < c; ++l) {
						if (a[q][w] < a[i][l])
							ans1++;
					}
				}
			}
		}
		
		if (j == c - 1) {
			ans2 = 1e9;
		}
		if (j != c - 1) {
			for (int q = i; q < r; ++q) {
				for (int w = q + 1; w < r; ++w) {
					if (a[q][j] > a[w][j])
						ans2++;
				}
			}
			for (int q = i; q < r; ++q) {
				for (int w = j + 1; w < c; ++w) {
					for (int l = i; l < r; ++l) {
						if (a[q][w] < a[l][j])
							ans2++;
					}
				}
			}
		}
		

		if (ans1 > ans2) {
			ans += ans2;
			j++;
		}
		else {
			i++;
			ans += ans1;
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}