#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
    dp[0][0] = 0;
    ordered_set sti;
    for (int del_i = 0; del_i < n; ++del_i) {
        ordered_set stj;
        for (int del_j = 0; del_j < m; ++del_j) {
            ordered_set st2;

            ll cnt_a = 0;
            ll cnt_b = 0;
            for (int j = del_j; j < m; ++j) {
                cnt_a += (ll) sti.size() - sti.order_of_key(a[del_i][j]);
                cnt_a += (ll) stj.size() - stj.order_of_key(a[del_i][j]);
                cnt_a += (ll) st2.size() - st2.order_of_key(a[del_i][j]);
                st2.insert(a[del_i][j]);
            }
            st2.clear();
            for (int i = del_i; i < n; ++i) {
                cnt_b += (ll) sti.size() - stj.order_of_key(a[i][del_j]);
                cnt_b += (ll) stj.size() - stj.order_of_key(a[i][del_j]);
                cnt_b += (ll) st2.size() - st2.order_of_key(a[i][del_j]);
                st2.insert(a[i][del_j]);
            }
            dp[del_i + 1][del_j] = min(dp[del_i + 1][del_j], dp[del_i][del_j] + cnt_a);
            dp[del_i][del_j + 1] = min(dp[del_i][del_j + 1], dp[del_i][del_j] + cnt_b);

            for (int i = del_i; i < n; ++i) {
                stj.insert(a[i][del_j]);
            }
        }
        for (int j = 0; j < m; ++j) {
            sti.insert(a[del_i][j]);
        }
    }

    ll ans = 1e18;
    for (int i = 0; i < m; ++i) {
        ans = min(ans, dp[n][i]);
    }
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[i][m]);
    }
    cout << ans << "\n";
}

