#include "bits/stdc++.h"

using namespace std;
using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> prefmin(n + 1);
    prefmin[n] = 1e9;
    for (int i = n - 1; i >= 0; --i) {
        prefmin[i] = min(prefmin[i + 1], a[i]);
    }

    while (q--) {
        int k, i;
        cin >> k >> i;

        if (i < k) {
            cout << a[i - 1] << "\n";
        } else {
            cout << prefmin[i - 1] << "\n";
        }
    }
}

