#include "bits/stdc++.h"

using namespace std;
using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> prefmax(n + 1);
    prefmax[n] = -1e9;
    for (int i = n - 1; i >= 0; --i) {
        prefmax[i] = max(prefmax[i + 1], a[i]);
    }

    vector<int> nearest(n, n);
    vector<int> que = {n - 1};
    for (int i = n - 1; i >= 0; --i) {
        while (!que.empty() && a[que.back()] <= a[i]) {
            que.pop_back();
        }
        if (!que.empty()) nearest[i] = que.back();
        que.push_back(i);
    }

    vector<vector<int>> ans(4, vector<int>(n, 1e9));
    int mx = 0;
    for (int pref = 0; pref < n - 2; ++pref) {
        mx = max(mx, a[pref]);
        int v2 = nearest[pref + 1];
        if (v2 == n) {
            ans[3] = min(ans[3], {mx, a[pref + 1], a.back()});
        } else {
            ans[3] = min(ans[3], {mx, a[pref + 1], prefmax[v2]});
        }
    }

    while (q--) {
        int k, i;
        cin >> k >> i;


        cout << ans[k][i - 1] << "\n";
    }
}

