#include "bits/stdc++.h"

using namespace std;
using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int ans = 1e9;
    for (int mask = 0; mask < (1 << (n + m)); ++mask) {
        vector<int> tmp;
        int rem_i = 0, rem_j = 0;
        for (int it = 0; it < n + m && rem_i < n && rem_j < m; ++it) {

            if ((mask >> it) & 1) {
                // vert
                for (int i = rem_i; i < n; ++i) {
                    tmp.push_back(a[i][rem_j]);
                }
                rem_j++;
            } else {
                // hor
                for (int j = rem_j; j < m; ++j) {
                    tmp.push_back(a[rem_i][j]);
                }
                rem_i++;
            }
        }
        if (tmp.size() != n * m) continue;

        int inv = 0;
        for (int i = 0; i < n * m; ++i) {
            for (int j = i + 1; j < n * m; ++j) {
                inv += tmp[i] > tmp[j];
            }
        }
        ans = min(ans, inv);
    }
    cout << ans << "\n";
}

