#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>

using namespace std;

#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vi pos;
    int start = 0;
    for (int i = 0; i < n; ++i) {
        start += (s[i] == '1');
        if ((!i || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
            pos.pb(i);
        }
    }
    int need = 0;
    start -= pos.size();
    if (start + pos.size() == 0) {
        while (q--) {
            int k;
            cin >> k;
            if (k == 1) {
                k = 0;
            }
            cout << min(n, k) << '\n';
        }
        return;
    }
    vi cnt(n + 1);
    for (int i = 0; i < pos.size();) {
        if (i != pos.size() - 1 && pos[i + 1] == pos[i] + 2) {
            ++need;
            cnt[need] = cnt[need - 1] + 2;
            i += 2;
        } else {
            ++need;
            cnt[need] = cnt[need - 1] + 1;
            i += 1;
        }
    }
    while (q--) {
        int k;
        cin >> k;
        if (k <= need) {
            cout << start + cnt[k] + k << '\n';
        } else {
            cout << min(n, start + (int)pos.size() + k) << '\n';
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}