#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>

#include <functional>

// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")

using namespace std;

#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

#define int int64_t

void solve() {
    int n, m;
    cin >> n >> m;
    vvi x(n, vi(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> x[i][j];
        }
    }
    vi fen(n * m + 1);

    function<int(int)> get = [&](int i) {
        int ans = 0;
        for (int cur = i; cur != 0; cur -= cur & -cur) {
            ans += fen[cur];
        }
        return ans;
    };

    function<void(int)> upd = [&](int i) {
        for (int cur = i; cur <= n * m; cur += cur & -cur) {
            ++fen[cur];
        }
    };
    int ans = 0;
    for (int el : x[0]) {
        ans += get(n * m - el);
        upd(n * m - el + 1);
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}