#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>

#include <functional>

// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")

using namespace std;

#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
#define all(x) x.begin(), x.end()
#define pii pair<int, int>


void solve() {
    int n, q;
    cin >> n >> q;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vvi opt(n + 1, vi(n, n + 1));
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (!(mask & 1)) {
            continue;
        }
        vi b;
        int maxx = a[0];
        for (int i = 1; i < n; ++i) {
            if (mask >> i & 1) {
                b.pb(maxx);
                maxx = a[i];
            } else {
                maxx = max(maxx, a[i]);
            }
        }
        b.pb(maxx);
        for (int i = 0; i < b.size(); ++i) {
            if (b[i] < opt[b.size()][i]) {
                opt[b.size()] = b;
                break;
            } else if (b[i] > opt[b.size()][i]) {
                break;
            }
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << opt[k][i - 1] << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}