#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>
 
#include <functional>
 
// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

bool operator<(const vi &a, const vi &b) {
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] < b[i]) {
            return 1;
        } else if (a[i] > b[i]) {
            return 0;
        }
    }
    return 0;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vi a(n);
    for (int &el : a) cin >> el;
    vvi ans(n + 1);
    for (int i = 0; i < n; ++i) {
        ans[n].pb(a[i]);
    }
    for (int j = n - 1; j >= 0; --j) {
        for (int i = 0; i < ans[j + 1].size() - 1; ++i) {
            vi nw;
            for (int h = 0; h < i; ++h) {
                nw.pb(ans[j + 1][h]);
            }
            nw.pb(max(ans[j + 1][i], ans[j + 1][i + 1]));
            for (int h = i + 2; h < ans[j + 1].size(); ++h) {
                nw.pb(ans[j + 1][h]);
            }
            if (!ans[j].size() || (nw < ans[j])) {
                ans[j] = nw;
            }
        }
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k][i - 1] << '\n';
    }
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}