#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;
using ld = long double;
vector<pair<ll, ll> > c;

ll dist(int i, int j) {
    return
            (c[i].first - c[j].first) * (c[i].first - c[j].first) + (c[i].second - c[j].second) * (
                c[i].second - c[j].second);
}

vector<vector<int> > g;
vector<int> used;
int f = 0;
vector<int> vert;

void dfs(int v, int col) {
    vert.push_back(v);
    used[v] = col;
    for (int u: g[v]) {
        if (used[u] == col) {
            f = 1;
        }
        if (!used[u]) {
            dfs(u, (col == 1 ? 2 : 1));
        }
    }
}

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    c.resize(n);
    for (auto &[x, y]: c) cin >> x >> y;
    map<pair<ll, ll>, int> mp;
    for (int i = 0; i < n; ++i) {
        mp[c[i]] = i + 1;
    }
    g.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        for (ll x1 = max(0ll, c[i].first - r); x1 <= c[i].first + r; ++x1) {
            for (ll y1 = max(0ll, c[i].second - r); y1 <= c[i].second + r; ++y1) {
                if (c[i].first == x1 && c[i].second == y1) {
                    continue;
                }
                if (mp[{x1, y1}]) {
                    int j = mp[{x1, y1}] - 1;
                    if (dist(i, j) <= r * r) {
                        g[i].push_back(j);
                    }
                }
            }
        }
    }
    string s;
    for (int i = 0; i < n; ++i) {
        s.push_back('0');
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            f = 0;
            dfs(i, 1);
            if (f) {
                for (auto u: vert) {
                    s[u] = '1';
                }
            }
            vert.clear();
        }
    }
    cout << s << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
