#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int) x.size()
#define all(x) x.begin(), x.end()
//#define int long long

const int N = 2e5;

struct sg {
    vector<int> d;

    sg() {}

    sg(int n) {
        d.resize(5 * n, 0);
    }

    void build(int v, int l, int r) {
        d[v] = 0;
        if (l == r) {
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
    }

    void update(int v, int l, int r, int pos, int zn) {
        d[v] += zn;
        if (l == r) {
            return;
        }
        int m = (l + r) / 2;
        if (pos > m) {
            update(2 * v + 1, m + 1, r, pos, zn);
        } else {
            update(2 * v, l, m, pos, zn);
        }
    }

    int find_ans(int v, int l, int r, int x, int y) {
        if (l > y || x > r) {
            return 0;
        }
        if (l >= x && r <= y) {
            return d[v];
        }
        int m = (l + r) / 2;
        return find_ans(2 * v, l, m, x, y) + find_ans(2 * v + 1, m + 1, r, x, y);
    }
};

int n, m;
vector<vector<int>> a;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int r = n * m;
    ll kol1 = 0, kol2 = 0;
    sg d1(n * m + 10), d2(n * m + 10);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            kol1 += d1.find_ans(1, 0, r, a[i][j] + 1, r);
            d1.update(1, 0, r, a[i][j], 1);
        }
    }
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            kol2 += d2.find_ans(1, 0, r, a[i][j] + 1, r);
            d2.update(1, 0, r, a[i][j], 1);
        }
    }
    cout << min(kol1, kol2);
    return 0;
}