#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("bmi,bmi2,avx2,lzcnt,popcnt")

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) a.size()
#define ce cout<<'\n'


int LG=18;
int N=(1<<(LG));
vector<int>t(2*N,0);


void upd(int pos,int val){
    pos+=N;
    t[pos]=val;
    pos/=2;
    while(pos){
        t[pos]=t[pos*2]+t[pos*2+1];
        pos/=2;
    }
}


int get(int l,int r){
    l+=N;
    r+=N;
    int rec=0;
    while(l<=r){
        if(l%2){
            rec+=t[l];
        }
        if(!(r%2)){
            rec+=t[r];
        }
        l=(l+1)/2;
        r=(r-1)/2;
    }
    return rec;
}


void solve(){
    int n,m;
    cin>>n>>m;
    vector<vector<int>>v(n,vector<int>(m));
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>v[i][j];
        }
    }
    vector<vector<int>>dp(n,vector<int>(m,1e9));
    dp[n-1][m-1]=0;
    for(int i=n-1;i>=0;i--){
        for(int j=m-1;j>=0;j--){
//            cout<<i<<" "<<j;ce;
            for(int x=i;x<n;x++){
                upd(v[x][j],1);
            }
            if(i>0){
                int ans=dp[i][j];
                for(int y=m-1;y>=j;y--){
                    ans+=get(0,v[i-1][y]);
                    upd(v[i-1][y],1);
                }
                dp[i-1][j]=min(dp[i-1][j],ans);
                for(int y=m-1;y>=j;y--){
                    upd(v[i-1][y],0);
                }
            }
            if(j>0){
                int ans=dp[i][j];
                for(int x=n-1;x>=i;x--){
                    ans+=get(0,v[x][j-1]);
                    upd(v[x][j-1],1);
                }
                dp[i][j-1]=min(dp[i][j-1],ans);
                for(int x=n-1;x>=i;x--){
                    upd(v[x][j-1],0);
                }
            }
        }
        for(int x=i;x<n;x++){
            for(int y=0;y<m;y++){
                upd(v[x][y],0);
            }
        }
    }
    cout<<dp[0][0];
}

signed main(){
    ios::sync_with_stdio(0);cout.tie(0);cin.tie(0);
    solve();
}
