#pragma GCC optimize("O2")

#include<bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 31, MXLG = __lg(MAXN) + 1;

vector<int> solve[MAXN];

int was[MAXN];
int n, qq;
int a[MAXN];

int pmx[MAXN];

int nxt[MAXN];

pair<int, int> spt[MXLG][MAXN];

void build(){
    for(int i = 0; i < n; i++){
        spt[0][i] = {a[i], i};
    }
    for(int lg = 1; lg < MXLG; lg++){
        for(int i = 0; i < n; i++){
            spt[lg][i] = spt[lg - 1][i];
            if(i + (1 << (lg - 1)) < n){
                spt[lg][i] = min(spt[lg][i], spt[lg - 1][i + (1 << (lg - 1))]);
            }
        }
    }
}

int get(int l, int r){
    int len = __lg(r - l + 1);
    return min(spt[len][l], spt[len][r - (1 << len) + 1]).second;
}

void calc(int k){
    int last = k;
        int pos = 0;
        int mx = a[pos];
        while(last > 1){
            mx = a[pos];
            solve[k].push_back(mx);
            if(solve[k].size() >= 3) break;
            int r = min(n - last + 1, nxt[pos]);
            int mn_pos = get(pos + 1, r);
            last--;
            pos = mn_pos;
        }
        if(solve[k].size() >= 3) return;
        mx = pmx[pos];
        solve[k].push_back(mx);
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> qq;
    for(int i = 0; i < n; i++) cin >> a[i];
    int tmp = 0;
    for(int i = n - 1; i >= 0; i--){
        tmp = max(tmp, a[i]);
        pmx[i] = tmp;
    }
    vector<pair<int, int>> q;
    for(int i = n - 1; i >= 0; i--){
        while(!q.empty() && q.back().first < a[i]) q.pop_back();
        if(q.empty()) nxt[i] = n - 1;
        else nxt[i] = q.back().second;
        q.push_back({a[i], i});
    }
    build();
    while(qq--){
        int k, i;
        cin >> k >> i;
        i--;
        if(!was[k]) calc(k);
        was[k] = 1;
        cout << solve[k][i] << "\n";
    }
}
