// #pragma GCC("O3")
#include <bits/stdc++.h>
#define int long long
const int INF = INT_MAX;
using namespace std;

void dfs_c(int v, vector<vector<int>> &gr, int x, vector<int> &color, vector<int> &used) {
    color[v] = x;
    used[v] = true;
    for (auto u : gr[v]) {
        if (!used[u]) dfs_c(u, gr, x, color, used);
    }
}

bool ans = false;
void dfs(int v, vector<vector<int>> &gr, vector<int> &in, int tek) {
    if (ans) return;
    in[v] = tek;
    for (auto u : gr[v]) {
        if (in[u] == -1) dfs(u, gr, in, tek + 1);
        else {
            if ((in[v] + in[u]) % 2 == 0) ans = true;
        }
    }
}


void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, i};
    }

    sort(a.begin(), a.end());
    // for (auto el : a) cout << el.first << ' ';
    // cout << '\n';

    vector<int> color(n, 0);

    for (int i = 0; i < n - 1; i++) {
        int x = a[i].first;
        int y = a[i + 1].first;
        if (x + r >= y) {
            color[i + 1] = color[i];
        }
        else {
            color[i + 1] = color[i] + 1;
        }
    }


    // cout << '\n';
    int all = color[n - 1] + 1;
    vector<int> ans(all, 0);
    for (int i = 0; i < n - 2; i++) {
        int x = a[i].first;
        int y = a[i + 1].first;
        int z = a[i + 2].first;
        // cout << x <<  ' ' << z << '\n';
        if (x + r >= z) {
            ans[color[i]] = 1;
        }
    }
    // for (auto el : color) {
    //     cout << ans[el];
    // }
    // cout << '\n';
    vector<pair<int, int>> ttt(n); //pair <i, color>

    for (int i = 0; i < n; i++) {
        ttt[i] = {a[i].second, color[i]};
    }
    sort(ttt.begin(), ttt.end());
    // for (auto el : ttt) {
    //     cout << el.first << ' ' << el.second << '\n';
    // }
    for (auto el : ttt) {
        cout << ans[el.second];
    }
    // cout << INF;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    while (t--) {
        solve();
    }
}