#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
using namespace std;
using ll = long long;
const ll maxn = 200000;
vector <ll> g[maxn];
ll used[maxn];
ll ver[maxn];
ll cnt = 1;
struct pt {
	ll x, y;
	pt(ll x1, ll y1) {
		x = x1;
		y = y1;
	}
	pt() {
		x = y = 0;
	}
};
ll r;
bool f(const pt& a, const pt& b) {
	return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r * r;
}
void dfs(ll v) {
	used[v] = 1;
	ver[v] = cnt;
	//cout << v + 1 << "\n";
	for (auto to : g[v]) {
		if (used[to] == 0) {
			dfs(to);
		}
	}
}
void solve() {
	ll n;
	cin >> n >> r;
	vector <pt >a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			if (f(a[i], a[j])) {
				g[i].push_back(j + n);
				g[j].push_back(i + n);
				g[i + n].push_back(j);
				g[j + n].push_back(i);
				//cout << i + 1 << ' ' << j + 1 << ' ' << a[i].x << ' ' << a[i].y << ' ' << a[j].x << ' ' << a[j].y << "\n";
			}
		}
	}
	vector <bool> ans(n);
	for (ll i = 0; i < n; ++i) {
		if (used[i] == 0) {
			dfs(i);
			//cout << "\n";
			for (ll j = 0; j < n; ++j) {
				if (ver[j] == cnt && ver[j + n] == cnt) {
					ans[j] = true;
				}
			}
			cnt++;
		}
	}
	for (auto c : ans) {
		cout << c;
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}