#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_set>
#include <unordered_map>
using namespace std;
using ll = long long;
const ll maxn = 200000;
vector <ll> g[maxn];
ll used[maxn];
ll ver[maxn];
vector <bool> ans(maxn);
ll cnt = 1;
struct pt {
	ll x, y;
	pt(ll x1, ll y1) {
		x = x1;
		y = y1;
	}
	pt() {
		x = y = 0;
	}
};
ll r;
bool f(const pt& a, const pt& b) {
	return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r * r;
}
ll n;
void dfs(ll v) {
	used[v] = 1;
	ver[v] = cnt;
	if (v < n) {
		if (ver[v] == cnt && ver[v + n] == cnt) {
			ans[v] = true;
		}
	}
	else {
		if (ver[v] == cnt && ver[v - n] == cnt) {
			ans[v - n] = true;
		}
	}
	//cout << v + 1 << "\n";
	for (auto to : g[v]) {
		if (used[to] == 0) {
			dfs(to);
		}
	}
}
void solve() {
	cin >> n >> r;
	vector <pt> a(n);
	unordered_map <ll, unordered_map <ll, ll>> vers;
	vector <ll> b(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		b.push_back(a[i].x);
	}
	sort(b.begin(), b.end());
	for (ll i = 0; i < n; ++i) {
		ll cnt = 0;
		for (ll j = i - 1; j > -1; --j) {
			if (b[i] - b[j] <= r) {
				cnt++;
			}
			if (cnt > 3) {
				break;
			}
		}
		ll cnt1 = 0;
		for (ll j = i + 1; j < n; ++j) {
			if (b[j] - b[i] <= r) {
				cnt1++;
			}
			if (cnt1 > 3) {
				break;
			}
		}
		if (cnt >= 2 || cnt1 >= 2) {
			ans[i] = true;
		}
		if (cnt == 1 && cnt1 == 1) {
			if (b[i + 1] - b[i - 1] <= r) {
				ans[i] = true;
			}
		}
	}
	for (ll i = 0; i < n; ++i) {
		cout << ans[i];
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}