#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
using namespace std;
using ll = int;
using lll = long long;
const ll maxn = 300000;
pair <ll, ll> t[18][maxn];
ll a[maxn];
ll logn[maxn + 5];
ll t1[18][maxn];
void init() {
	for (ll i = 2; i < maxn + 5; ++i) {
		logn[i] = logn[i / 2] + 1;
	}
}
ll n;
void build() {
	for (ll i = 0; i < n; ++i) {
		t[0][i] = { a[i], i };
	}
	for (ll i = 1; i <= logn[n]; ++i) {
		for (ll j = 0; j + (1 << (i - 1)) < n; ++j) {
			t[i][j] = min(t[i - 1][j], t[i - 1][j + (1 << (i - 1))]);
		}
	}
}
pair <ll, ll> get(ll l, ll r) {
	ll x = logn[r - l];
	return min(t[x][l], t[x][r - (1 << x) + 1]);
}
void build1() {
	for (ll i = 0; i < n; ++i) {
		t1[0][i] = a[i];
	}
	for (ll i = 1; i <= logn[n]; ++i) {
		for (ll j = 0; j + (1 << (i - 1)) < n; ++j) {
			t1[i][j] = max(t1[i - 1][j], t1[i - 1][j + (1 << (i - 1))]);
		}
	}
}
ll get1(ll l, ll r) {
	ll x = logn[r - l];
	return max(t1[x][l], t1[x][r - (1 << x) + 1]);
}
void solve() {
	ll q;
	cin >> n >> q;
	init();
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector <ll> pos(n);
	build1();
	vector <ll> st;
	for (ll i = 0; i < n; ++i) {
		while (st.size() > 0 && a[st.back()] < a[i]) {
			pos[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	while (st.size() > 0) {
		pos[st.back()] = n;
		st.pop_back();
	}
	build();
	while (q--) {
		ll k, inde;
		cin >> k >> inde;
		inde--;
		vector <ll> b;
		ll ind = 0;
		while (k > 0) {
			ll i = pos[ind];
			if (pos[ind] - 1 == ind) {
				if (k == 1) {
					b.push_back(get1(ind, n - 1));
				}
				else {
					b.push_back(a[ind]);
					ind++;
				}
				k--;
				continue;
			}
			if (k == 1) {
				b.push_back(get1(ind, n - 1));
				k--;
				continue;
			}
			if (k == 2) {
				b.push_back(a[ind]);
				b.push_back(a[n - 1]);
				k = 0;
				continue;
			}
			pair <ll, ll> x = get(ind, n - k + 1);
			b.push_back(a[ind]);
			b.push_back(x.first);
			ind = x.second + 1;
			k -= 2;
		}
		cout << b[inde] << "\n";
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}