#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18;

struct Point {
    ll x, y;
};

ll n, r;
vector<Point> points;

void solve() {
    cin >> n >> r;

    vector<ll> x(n);
    for (ll i = 0; i < n; i++) {
        ll y;
        cin >> x[i] >> y;
    }

    vector<pair<ll, ll>> x_with_ind(n);
    for (ll i = 0; i < n; i++) {
        x_with_ind[i] = {x[i], i};
    }

    sort(x_with_ind.begin(), x_with_ind.end());


    vector<bool> ans(n);

    vector<ll> used_now;
    bool is_nech_cicl_now = false;
    ll prev = -INF;
    ll prev_prev = -INF;
    for (auto [now, ind_now] : x_with_ind) {
        if (now - prev > r) {
            for (ll used_now_now : used_now) {
                ans[used_now_now] = is_nech_cicl_now;
            }

            used_now.clear();
            is_nech_cicl_now = false;

            used_now.push_back(ind_now);
            prev = now;
            prev_prev = -INF;
        } else if (now - prev_prev > r) {
            used_now.push_back(ind_now);
            prev_prev = prev;
            prev = now;
        } else {
            used_now.push_back(ind_now);
            prev_prev = prev;
            prev = now;

            is_nech_cicl_now = true;
        }
    }

    for (ll used_now_now : used_now) {
        ans[used_now_now] = is_nech_cicl_now;
    }

    for (ll now : ans) {
        cout << now;
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    solve();
    cout << endl;
    return 0;
}
