#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

struct point{
    ll x, y;
    point() {}
    point(ll x, ll y) : x(x), y(y) {}
};

vector<vector<ll>> g;
vector<ll> used, c;
vector<bool> ff;

void dfs(ll v, ll p){
    used[v] = 1;
    for (auto u : g[v]){
        if (!used[u]){
            dfs(u, v);
        }
        else if (used[u] == 1 && u != p) {
            for (int k = 0; k < c.size(); ++k){
                if (used[k] == 1){
                    ff[c[k]] = true;
                }
            }

        }
    }
    used[v] = 2;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll n, r;
    cin >> n >> r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i){
        cin >> a[i].x >> a[i].y;
    }
    ff.resize(n, false);
    map<pair<ll, ll>, vector<ll>> mp = {};
    map<pair<ll, ll>, bool> mp4 = {};
    for (int i = 0; i < n; ++i){
        mp[{a[i].x / r, a[i].y / r}].push_back(i);
    }
    for (auto i : mp){
        if (mp[i.first].size() >= 5){
            mp4[i.first] = true;
        }
        else if (mp[i.first].size() >= 3){
            bool f = false;
            c.clear();
            for (auto j : i.second){
                c.push_back(j);
            }
            g.clear();
            used.clear();
            g.resize(c.size());
            used.resize(c.size());
            for (int j = 0; j < c.size(); ++j){
                for (int k = 0; k < c.size(); ++k){
                    if (j != k && (long double)hypot(a[c[j]].x - a[c[k]].x, a[c[j]].y - a[c[k]].y) <= (long double)r){
                        g[j].push_back(k);
                    }
                }
            }
            dfs(0, -1);
            for (int j = 0; j < c.size(); ++j){
                if (ff[c[j]]){
                    f = true;
                }
            }
            mp4[i.first] = f;
        }
        else {
            mp4[i.first] = false;
        }
    }
    string res = "";
    vector<ll> dx = {-1, -1, -1, 0, 0, 0, 1, 1, 1}, dy = {-1, 0, 1, -1, 0, 1, -1, 0, 1};
    for (int i = 0; i < n; ++i){
        //cout << i << " :::: " << '\n';
        if (ff[i] || mp4[{a[i].x / r, a[i].y / r}]){
            res.push_back('1');
        }
        else {
            ll x, y, nx, ny;
            x = a[i].x / r;
            y = a[i].y / r;
            for (int j = 0; j < 9; ++j){
                nx = x + dx[j];
                ny = y + dy[j];
                if (mp4[{nx, ny}]){
                    for (auto k : mp[{nx, ny}]){
                        if ((long double)hypot(a[i].x - a[k].x, a[i].y - a[k].y) <= (long double)r){
                            ff[i] = true;
                            break;
                        }
                    }
                    if (ff[i]){
                        break;
                    }
                }
            }
            if (!ff[i]){
                g.clear();
                used.clear();
                c.clear();
                for (int j = 0; j < 9; ++j){
                    nx = x + dx[j];
                    ny = y + dy[j];
                    if (!mp4[{nx, ny}]){
                        for (auto k : mp[{nx, ny}]){
                            c.push_back(k);
                            //cout << k << " ";
                        }
                    }
                }
                //cout << '\n';
                g.resize(c.size());
                used.resize(c.size());
                for (int j = 0; j < c.size(); ++j){
                    for (int k = 0; k < c.size(); ++k){
                        if (j != k && (long double)hypot(a[c[j]].x - a[c[k]].x, a[c[j]].y - a[c[k]].y) <= (long double)r){
                            g[j].push_back(k);
                        }
                    }
                }
                dfs(0, -1);
            }
            if (ff[i]){
                res.push_back('1');
            }
            else {
                res.push_back('0');
            }
        }
    }
    cout << res << '\n';
    return 0;
}
