#include <iostream>
#include<vector>
#include<string>
#include <set>
#include <array>
using namespace std;
vector<int>par, siz, L, R;
int find(int i) {
	return par[i] = (par[i] == i ? i : find(par[i]));
}
void union_sets(int a, int b) {
	a = find(a);
	b = find(b);
	if (a == b)return;
	if (siz[a] < siz[b])swap(a, b);
	par[b] = a;
	siz[a] += siz[b];
	L[a] = min(L[a], L[b]);
	R[a] = max(R[a], R[b]);
}
int main() {
	int n, q;
	cin >> n >> q;
	string s;
	cin >> s;
	par.resize(n);
	L.resize(n);
	R.resize(n);
	siz.resize(n);
	int ans = 0;
	array <set<int>, 3> st;
	vector<int> TP(n);
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') {
			int tp = (i - 1 >= 0 && s[i - 1] == '1' && (i - 2 < 0 || s[i - 2] != '1')) +
				(i + 1 < n && s[i + 1] == '1' && (i + 2 >= n || s[i + 2] != '1'));
			st[tp].insert(i);
			TP[i] = tp;
		}
	}
	for (int i = 0; i < n; i++) {
		if (s[i] == '1') {
			par[i] = i;
			siz[i] = 1;
			L[i] = i;
			R[i] = i;
		}
	}
	for (int i = 0; i < n; i++) {
		if (s[i] == '1') {
			int j = i;
			while (j + 1 < n && s[j + 1] == '1') {
				j++;
				union_sets(i, j);
			}
			if (j - i + 1 > 1) {
				ans += j - i + 1;
			}
			i = j;
		}
	}
	vector<int> ANS(n + 1);
	ANS[0] = ans;
	for (int k = 1; k <= n; k++) {
		for (int j = 2; j >= 0; j--) {
			if (st[j].size()) {
				int i = *st[j].begin();
				st[j].erase(st[j].begin());
				//cout << i << " ";
				s[i] = '1';
				par[i] = i;
				siz[i] = 1;
				L[i] = i;
				R[i] = i;
				ans += j + (i - 1 >= 0 && s[i - 1] == '1' || i + 1 < n && s[i + 1] == '1');
				if (i - 1 >= 0 && s[i - 1] == '1') {
					union_sets(i - 1, i);
				}
				if (i + 1 < n && s[i + 1] == '1') {
					union_sets(i + 1, i);
				}
				int l = L[find(i)] - 1, r = R[find(i)] + 1;
				//cout << l << " " << r << "\n";
				if (l >= 0) {
					st[TP[l]].erase(l);
					int tp = (l - 1 >= 0 && s[l - 1] == '1' && (l - 2 < 0 || s[l - 2] != '1')) +
						(l + 1 < n && s[l + 1] == '1' && (l + 2 >= n || s[l + 2] != '1'));
					st[tp].insert(l);
					TP[l] = tp;
				}
				if (r < n) {
					st[TP[r]].erase(r);
					int tp = (r - 1 >= 0 && s[r - 1] == '1' && (r - 2 < 0 || s[r - 2] != '1')) +
						(r + 1 < n && s[r + 1] == '1' && (r + 2 >= n || s[r + 2] != '1'));
					st[tp].insert(r);
					TP[r] = tp;
				}
				break;
			}
		}
		//cout << ans << "\n";
		ANS[k] = ans;
	}
	while (q--) {
		int k;
		cin >> k;
		cout << ANS[k] << "\n";
	}
}

