#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input", "r", stdin);
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    int res = 0;
    int buf = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') buf++;
        else {
            if (buf>1) res += buf;
            buf = 0;
        }
    }
    if (buf > 1) res += buf;
    string old = s;
    int K = count(s.begin(), s.end(), '0');
    vector<int> ans(K + 1);
    ans[0] = res;
    set<int> pot1, pot2;
    for (int i = 1; i + 1 < n; i++) {
        if (s[i] == '0') {
            bool ch = true;
            if (s[i - 1] != '1' || (i > 1 && s[i - 2] == '1')) ch = false;
            if (s[i + 1] != '1' || (i+2<n && s[i + 2] == '1')) ch = false;
            if (ch) {
                pot1.insert(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') {
            bool ch = true;
            if (i>0 && s[i-1] == '1') ch = false;
            if (i+1<n && s[i+1] == '1') ch = false;
            if (ch) {
                pot2.insert(i);
            }
        }
    }
    bool all_zero = count(s.begin(), s.end(), '0') == n;
    for (int j = 1; j <= K; j++) {
        ans[j - 1] = res;
        bool f = false;
        vector<int> del;
        for (int i : pot1) {
            bool ch = true;
            if (s[i - 1] != '1' || (i > 1 && s[i - 2] == '1')) ch = false;
            if (s[i + 1] != '1' || (i+2<n && s[i + 2] == '1')) ch = false;
            if (ch) {
                res += 3;
                f = true;
                s[i] = '1';
                del.push_back(i);
                break;
            }
            del.push_back(i);
        }
        for (auto& x : del) pot1.erase(x);
        if (f) continue;
        del.clear();
        for (int i : pot2) {
            if (s[i] == '1') {
                bool ch = true;
                if (i>0 && s[i-1] == '1') ch = false;
                if (i+1<n && s[i+1] == '1') ch = false;
                if (ch) {
                    res += 2;
                    f = true;
                    if (i>0) s[i-1] = '1';
                    else if (i+1<n) s[i+1] = '1';
                    del.push_back(i);
                    break;
                }
                del.push_back(i);
            } else {
                del.push_back(i);
            }
        }
        for (auto& x : del) pot2.erase(x);
        if (f) continue;
        for (int i = 0; i < n; i++) {
            if (s[i] == '1') {
                if (i+1<n && s[i + 1] == '0') {
                    res++;
                    s[i + 1] = '1';
                    f = true;
                    break;
                }
                if (i && s[i - 1] == '0') {
                    res++;
                    s[i - 1] = '1';
                    f = true;
                    break;
                }
            }
        }
        if (f) continue;
        s[0] = '1';
    }
    ans.back() = res;
    if (all_zero) {
        ans[0] = ans[1] = 0;
        for (int i = 2; i <= K; i++) {
            ans[i] = i;
        }
    }
    while (q--) {
        int k;
        cin >> k;
        cout << ans[k] << '\n';
    }
}