#include <bits/stdc++.h>

using namespace std;
#define int long long

void solve() {
    int c, r;
    cin >> c >> r;
    vector<vector<int>> table(c, vector<int> (r, 0));
    for (int i = 0; i < c; ++i) {
        for (int j = 0; j < r; ++j)
            cin >> table[i][j];
    }

    vector<vector<int>> dp(c + 1, vector<int> (r + 1, 0));
    for (int i = 0; i < c; ++i) {
        dp[i + 1][0] = dp[i][0];
        for (int ind = 0; ind < r; ++ind) {
            for (int i1 = 0; i1 < i; ++i1) {
                for (int j1 = 0; j1 < r; ++j1) {
                    if (table[i1][j1] > table[i][ind])
                        ++dp[i + 1][0];
                }
            }
        }

        for (int ind = 0; ind < r; ++ind) {
            for (int ind2 = ind + 1; ind2 < r; ++ind2) {
                if (table[i][ind2] < table[i][ind])
                    ++dp[i + 1][0];
            }
        }
    }

    for (int j = 0; j < r; ++j) {
        dp[0][j + 1] = dp[0][j];
        for (int ind = 0; ind < c; ++ind) {
            for (int i1 = 0; i1 < c; ++i1) {
                for (int j1 = 0; j1 < j; ++j1) {
                    if (table[i1][j1] > table[ind][j])
                        ++dp[0][j + 1];
                }
            }
        }

        for (int ind = 0; ind < c; ++ind) {
            for (int ind2 = ind + 1; ind2 < c; ++ind2) {
                if (table[ind2][j] < table[ind][j])
                    ++dp[0][j + 1];
            }
        }
    }

    for (int i = 0; i < c; ++i) {
        for (int j = 0; j < r; ++j) {
            int cnt1 = dp[i][j + 1];
            for (int ind = j + 1; ind < r; ++ind) {
                for (int i1 = 0; i1 < i; ++i1) {
                    for (int j1 = 0; j1 <= j; ++j1) {
                        if (table[i1][j1] > table[i][ind])
                            ++cnt1;
                    }
                }
                for (int i1 = i; i1 < c; ++i1) {
                    for (int j1 = 0; j1 <= j; ++j1) {
                        if (table[i1][j1] > table[i][ind])
                            ++cnt1;
                    }
                }
                for (int i1 = 0; i1 < i; ++i1) {
                    for (int j1 = j + 1; j1 <= r; ++j1) {
                        if (table[i1][j1] > table[i][ind])
                            ++cnt1;
                    }
                }
            }
            for (int ind = j + 1; ind < r; ++ind) {
                for (int ind2 = ind + 1; ind2 < r; ++ind2) {
                    if (table[i][ind2] < table[i][ind])
                        ++cnt1;
                }
            }

            int cnt2 = dp[i + 1][j];
            for (int ind = i + 1; ind < c; ++ind) {
                for (int i1 = 0; i1 <= i; ++i1) {
                    for (int j1 = 0; j1 < j; ++j1) {
                        if (table[i1][j1] > table[ind][j])
                            ++cnt2;
                    }
                }
                for (int i1 = 0; i1 <= i; ++i1) {
                    for (int j1 = j; j1 < r; ++j1) {
                        if (table[i1][j1] > table[ind][j])
                            ++cnt2;
                    }
                }
                for (int i1 = i + 1; i1 < c; ++i1) {
                    for (int j1 = 0; j1 < j; ++j1) {
                        if (table[i1][j1] > table[ind][j])
                            ++cnt2;
                    }
                }
            }
            for (int ind = i + 1; ind < c; ++ind) {
                for (int ind2 = ind + 1; ind2 < c; ++ind2) {
                    if (table[ind2][j] < table[ind][j])
                        ++cnt2;
                }
            }

            dp[i + 1][j + 1] = min(cnt1, cnt2);
        }
    }

    cout << dp[c][r];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout << '\n';
    }
}
