#include <bits/stdc++.h>
using namespace std;

int inf = 1e9;

struct node {
    int mn, in;
};

int N = 1;
vector<int> lt, rt, stmx;
vector<node> st;

node merge(node a, node b) {
    if (a.mn < b.mn) return a;
    return b;
}

node get(int l, int r, int i = 1) {
    int L = lt[i], R = rt[i];
    if (L >= r || l >= R) return {inf, 0};
    if (l <= L && R <= r) return st[i];
    return merge(get(l, r, 2*i), get(l, r, 2*i+1));
}

int getmx(int l, int r, int i = 1) {
    int L = lt[i], R = rt[i];
    if (L >= r || l >= R) return -inf;
    if (l <= L && R <= r) return stmx[i];
    return max(getmx(l, r, 2*i), getmx(l, r, 2*i+1));
}

int32_t main() {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n), bl(n, n-1), stack(0), sm(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sm[n-1] = a[n-1];
    for (int i = n-2; i >= 0; i--) {
        sm[i] = max(a[i], sm[i+1]);
    }
    for (int i = 0; i < n; i++) {
        while (!stack.empty() && a[stack.back()] < a[i]) {
            bl[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }
    // for (auto c : bl) cout << c << " ";
    // cout << "\n";
    while (N < n) N<<=1;
    st.assign(2*N, {inf, 0});
    stmx.assign(2*N, -inf);
    lt.assign(2*N, 0);
    rt.assign(2*N, 0);
    for (int i = N; i < N+n; i++) {
        st[i].mn = a[i-N];
        stmx[i] = a[i-N];
    }
    for (int i = N; i < 2*N; i++) {
        st[i].in = i-N;
        lt[i] = i-N;
        rt[i] = i-N+1;
    }
    for (int i = N-1; i > 0; i--) {
        st[i] = merge(st[2*i], st[2*i+1]);
        stmx[i] = max(stmx[2*i], stmx[2*i+1]);
        lt[i] = lt[2*i];
        rt[i] = rt[2*i+1];
    }
    // for (auto c : stmx) {
    //     cout << c << " ";
    // } cout << "\n";
    // for (auto c : st) {
    //     cout << c.mn << " ";
    // // } cout << "\n";
    // for (auto c : sm) cout << c << " ";
    // cout << "\n";
    // while (q--) {
    //     int k, in;
    //     cin >> k >> in;
    //     if (in == 1) cout << a[0] << "\n";
    //     else cout << sm[bl[0]] << "\n";
    // }
    map<int, vector<int>> mp;
    while (q--) {
        int k, in, p = 0;
        cin >> k >> in;
        if (!mp.count(k)) {
            vector<int> t;
            if (in == k) t.push_back(sm[p]);
            else t.push_back(a[p]);
            for (int i = 1; i < k; i++) {
                if (i == k-1) {
                    p = bl[p];
                } else {
                    node t = get(p+1, min(n-k+i+1, bl[p]+1));
                    p = t.in;
                }
                if (in == k) t.push_back(sm[p]);
                else t.push_back(a[p]);
            }
            // for (auto c : t) cout << c << " ";
            // cout << "\n";
            mp[k] = t;
        }
        cout << mp[k][in-1] << "\n";
    }
    // while (q--) {
    //     int k, in;
    //     cin >> k >> in;
    //     if (in < k) cout << a[in-1] << "\n";
    //     else cout << sm[in-1] << "\n";
    // }
}