#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> spi;
vector<int> ans, vis;
int f;

void dfs1(int v) {
    ans[v] = -1;
    for (auto u : spi[v]) {
        if (ans[u] != -1) {
            dfs1(u);
        }
    }
}

void dfs2(int v, int col = 1) {
    vis[v] = col;
    for (auto u : spi[v]) {
        if (vis[u] == col) f = 1;
        if (!vis[u]) {
            dfs2(u, -col);
        }
    }
}

int32_t main() {
    long long n, r;
    cin >> n >> r;
    map<pair<int, int>, int> a;
    for (int i = 0; i < n; i++) {
        pair<int, int> t;
        cin >> t.first >> t.second;
        a[t] = i;
    }
    spi.assign(n, vector<int>());
    for (auto [t, in] : a) {
        for (int i = -r; i <= r; i++) {
            for (int j = -r; j <= r; j++) {
                if (a.count({t.first+i, t.second+j}) && i*i+j*j <= r*r && a[{t.first+i, t.second+j}] < in) {
                    spi[in].push_back(a[{t.first+i, t.second+j}]);
                    spi[a[{t.first+i, t.second+j}]].push_back(in);
                }
            }
        }
    }
    // for (auto c : spi) {
    //     for (auto p : c) cout << p << " ";
    //     cout << "\n";
    // } cout << "\n";
    ans.assign(n, 0);
    vis.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            f = 0;
            dfs1(i);
            dfs2(i);
            if (f) {
                for (int j = 0; j < n; j++) {
                    if (ans[j] == -1) ans[j] = 1;
                }
            } else {
                for (int j = 0; j < n; j++) {
                    if (ans[j] == -1) ans[j] = 0;
                }
            }
        }
    }
    for (auto c : ans) cout << c;
    cout << "\n";
}