
#pragma GCC optmize("O3")
#include <bits/stdc++.h>
#define int long long

struct Point
{
    int x, y;
    int ind;

    Point(int x, int y, int ind) : x(x), y(y), ind(ind) {};
    Point() = default;

    int dist(Point b)
    {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
};

const int MAXN = 1e5 + 1;
int up[MAXN];
int h[MAXN];
bool ans[MAXN];
bool was = false;

std::vector<int> tmp;

void dfs(int v, std::vector<Point> &all, std::vector<bool> &used, int r, int pred = -1, int height = 0)
{

    tmp.push_back(all[v].ind);
    used[v] = true;
    h[v] = height;

    int now = 0;

    while (now < all.size())
    {
        if (now == v)
        {
            now++;
            continue;
            ;
        }
        if (all[v].dist(all[now]) <= r * r)
        {
            if (now != pred)
            {
                if (used[now] && h[v] % 2 == h[now] % 2)
                {
                    was = true;
                    return;
                }
                else if (!used[now])
                {
                    dfs(now, all, used, r, v, height + 1);
                }
            }
        }
        now++;
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, r;
    std::cin >> n >> r;

    std::vector<Point> all(n);
    for (int i = 0; i < n; i++)
    {
        std::cin >> all[i].x >> all[i].y;
        all[i].ind = i;
    }

    std::sort(all.begin(), all.end(), [&](Point a, Point b)
              { return a.x < b.x; });

    std::vector<bool> used(n, false);
    for (int i = 0; i < n; i++)
    {
        ans[i] = false;
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            tmp.clear();
            was = false;
            dfs(i, all, used, r);
            if (was)
            {
                for (int j : tmp)
                {
                    ans[j] = true;
                }
            }
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            std::cout << 1;
        }
        else
        {
            std::cout << 0;
        }
    }
}