#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define ff first 
#define ss second
 
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
 
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
 
ll n, r;
vector<pair<ll, ll>> a;
vector<ll> colors;
vector<ll> ans;
void dfs(ll v, ll color) {
    colors[v] = color;
    for (int i = 0; i < n; ++i) {
        if ((a[i].ff - a[v].ff) * (a[i].ff - a[v].ff) + (a[i].ss - a[v].ss) * (a[i].ss - a[v].ss) <= r * r) {
            if (colors[v + n * (v < n)] == -1) dfs(v + n * (v < n), color);
        }
    }
}
 
void Solve() {
    cin >> n >> r;
    a.resize(n);
    for (auto &x : a) cin >> x.ff >> x.ss;
    if (n == 2) {
        cout << "00\n";
        return;
    }
    ans.resize(n, -1);
    colors.resize(n * 2, -1);
    ll color = 0;
    for (int i = 0; i < n * 2; ++i) {
        if (colors[i] == -1) dfs(i, ++color);
    }
    for (int i = 0; i < n; ++i) {
        cout << (colors[i] == colors[i + n]);
    }
}
 
 
int main() {
    Solve();
}