#include <bits/stdc++.h>

using namespace std;

//#pragma optimize("O3,avx,avx2,bmi,bmi2,unroll-loops")

#define int long long

int inf = 1000 * 1000 * 1000;

struct st {
    vector <int> t;

    void build(vector <int> &a) {
        int n = a.size();
        t.resize(4 * n);
    }

    void build2(int v, int l, int r, vector <int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build2(v * 2 + 1, l, m, a);
        build2(v * 2 + 2, m + 1, r, a);
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return -inf;
        }
        if (l == ll && r == rr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return max(get(v * 2 + 1, l, m, ll, min(m, rr)), get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr));
    }

    int get(int l, int r) {
        return get(0, 0, t.size() / 4 - 1, l, r);
    }
};

struct st2 {
    vector <int> a;

    void build(vector <int> aa) {
        a = aa;
    }

    int get(int l, int r) {
        int mn = inf;
        int ind = l;
        //cout << l << " " << r << '\n';
        for (int i = l; i <= r; i ++) {
            //cout << i << " f" << '\n';
            if (a[i] < mn) {
                mn = a[i];
                ind = i;
            }
        }
        return ind;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    for (int i = 0; i < n; i ++) {
        cin >> a[i];
    }

    int mx = a[0];
    for (int i = 1; i < n; i ++) {
        mx = max(mx, a[i]);
    }

    vector <int> f(n, n - 1);
    for (int i = 0; i < n; i ++) {
        for (int j = i + 1; j < n; j ++) {
            if (a[j] > a[i]) {
                f[i] = j;
                break;
            }
        }
    }

    vector <int> pref_mx(n);
    pref_mx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i --) {
        pref_mx[i] = max(pref_mx[i + 1], a[i]);
    }

    //st t;
    //t.build(a);

    st2 t2;
    t2.build(a);

    for (int _ = 0; _ < q; _ ++) {
        int k, ind;
        cin >> k >> ind;
        ind --;
        //cout << ind << " r" << '\n';

        if (ind == 0) {
            if (k > 1) {
                cout << a[0] << '\n';
            }
            else {
                cout << mx << '\n';
            }
        }
        else {
            int j = 0;
            for (int i = 0; i < ind; i ++) {
                int ind2 = t2.get(j + 1, min(f[j], n - k + i + 1));

                //cout << ind2 << " " << n - k + i + 1 << " " << f[j] << '\n';
                j = ind2;
            }
            if (ind != k - 1) {
                cout << a[j] << '\n';
            }
            else {
                cout << pref_mx[j] << '\n';
            }
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}