#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(a) a.begin(), a.end()

using pii = pair<int, int>;
const int INF = 1e12;


void dfs(int cur, vector<bool> &m1, vector<bool> &m2, vector<vector<int>> &g, int c) {
    if (c == 0) {
        if (m1[cur] == true) {
            return;
        }
        m1[cur] = true;
    } else {
        if (m2[cur] == true) {
            return;
        }
        m2[cur] = true;
    }
    for (auto u : g[cur]) {
        dfs(u, m1, m2, g, (c + 1) % 2);
    }
}


void solve() {
    int n, r;
    cin >> n >> r;
    vector<pii> a(n);
    map<int, vector<pii>> xs;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        xs[a[i].first].push_back({a[i].first, i});
    }
    for (auto &[x, v] : xs) {
        sort(all(v));
    }

    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        tie(x, y) = a[i];
        for (int x1 = x - r; x1 <= x + r; x1++) {
            if (xs.count(x1)) {
                auto it1 = lower_bound(all(xs[x1]), make_pair(y - r, 0));
                auto it2 = upper_bound(all(xs[x1]), make_pair(y + r, 0));

                while (it1 != it2) {
                    int y1, j;
                    tie(y1, j) = *it1;
                    if ((long long)(x1 - x) * (x1 - x) + (long long)(y - y1) * (y - y1) <= r * (long long)r) {
                        g[i].push_back(j);
                        g[j].push_back(i);
                    }
                    it1++;
                }
            }
        }
    }
    vector<bool> m1(n), m2(n);
    for (int i = 0; i < n; i++) {
        if (!m1[i] && !m2[i]) {
            dfs(i, m1, m2, g, 0);
        }
        if (m1[i] && m2[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
    
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}