#include <bits/stdc++.h>

using namespace std;
vector<int> a;
vector<int> tree;


void build(int i, int l, int r)
{
    if(r-l==1){
        tree[i]=l;
        return;
    }
    int m=(l+r)/2;
    build(2*i+1, l, m);
    build(2*i+2, m, r);
    if(a[tree[2*i+1]]<a[tree[2*i+2]]){
        tree[i]=tree[2*i+1];
    }else{
        tree[i]=tree[2*i+2];
    }
}

int get(int i, int l, int r, int ql, int qr)
{
    if(r<=ql || qr<=l){
        return -1;
    }
    if(ql<=l && r<=qr){
        return tree[i];
    }
    int m=(l+r)/2;
    int x=get(2*i+1, l, m, ql, qr);
    int y=get(2*i+2, m, r, ql, qr);

    if(x==-1){
        return y;
    }
    if(y==-1){
        return x;
    }
    if(a[x]<a[y]){
        return x;
    }
    return y;
}

int main()
{
    int n, q;
    cin>>n>>q;

    tree.resize(4*n);
    vector<int> ma(n);

    a.resize(n);
    for(int i=0; i<n; ++i){
        cin>>a[i];
    }
    ma[n-1]=a[n-1];
    for(int i=n-2; i>=0; --i){
        ma[i]=max(ma[i+1], a[i]);
    }

    build(0, 0, n);

    vector<int> b(n);

    vector<int> tec;
    for(int i=n-1; i>=0; --i){
        while(tec.size()>0 && a[tec.back()]<a[i]){
            tec.pop_back();
        }
        if(tec.size()==0){
            b[i]=n;
        }else{
            b[i]=tec.back();
        }
        tec.push_back(i);

    }

    while(q--){
        int k, i;
        cin>>k>>i;
        int j=0;
        for(int g=0; g<i-1; ++g){
            if(n-j==k-g){
                j=n-(k-i+1);
                break;
            }
            if(g==k-2){
                j=min(b[j], n-(k-g-1));
                continue;
            }
            int pr=min(b[j], n-(k-g-1));
            j=get(0, 0, n, j+1, pr+1);
        }
        if(i<k){
            cout<<a[j]<<endl;
        }else{
            cout<<ma[j]<<endl;
        }
    }


    return 0;
}
