#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lld = long double;
ll inf_ll = 1e18;
ll siz = 1e5 * 2;

vector<vector<ll> > g(siz);
vector<ll> color(siz);
vector<ll> c(siz);

struct Point {
    ll x, y;

    Point(ll X, ll Y): x(X), y(Y) {
    }

    Point() {
        x = 0;
        y = 0;
    }
};


lld dist(Point a, Point b) {
    return sqrt(lld((a.x - b.x) * (a.x - b.x)) + lld((a.y - b.y) * (a.y - b.y)));
}

bool fl = false;

void dfs(ll now, ll C, ll p = 0) {
    color[now] = (color[p] == 1 ? 2 : 1);
    c[now] = C;
    for (auto i: g[now]) {
        if (color[i] == color[now])fl = true;
        if (color[i] != 0)continue;
        dfs(i, C, now);
    }
}


void solve(ll n, lld r, vector<Point> &v) {
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            if (r >= dist(v[i], v[j])) {
                g[i].emplace_back(j);
                g[j].emplace_back(i);
            }
        }
    }
    ll C = 1;
    vector<ll> ans(n + 1);
    map<ll, ll> m;
    for (int i = 1; i <= n; i++) {
        if (color[i] != 0)continue;
        fl = false;
        dfs(i, C);
        m[C] = fl;
        C++;
    }
    for (int i = 1; i <= n; i++) {
        cout << m[c[i]];
    }
    cout << '\n';
}

void input() {
    ll n;
    lld r;
    cin >> n >> r;
    vector<Point> v(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> v[i].x >> v[i].y;
    }
    solve(n, r, v);
}


int main() {
    input();
}

/*
11 6
11010101001
*/
