#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

ll dist2(pair<int, int> p1, pair<int, int> p2) {
    return (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second);
}

ll r;
vector<pair<int, int>> p;
// bool operator < (const)

int dfs(const vector<vector<int>> & gr, vector<pair<int, int>> & used, int cur, int start, int col) {
    used[cur] = {col, start};

    int a = 0;
    for (auto v : gr[cur]) {
        if (used[v].first == 0) {
            a += dfs(gr, used, v, start, col ^ 1);
        } else if (used[v].first == col) {
            a += 1;
        }
    }
    return a > 0;
}

void solve() {
    int n;
    cin >> n >> r;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }

    vector<vector<int> > gr(n);
    int C = 0;

    if (r < C) {
        for (int i = 0; i < n; ++i) {
            for (ll x = min(0ll, p[i].first - r); x <= p[i].first + r; ++x) {
                for (ll y = min(0ll, p[i].second - r); y <= p[i].second + r; ++y) {
                    if (x == p[i].second && y == p[i].second) continue;
                    if (dist2({x, y}, p[i]) > r * r) continue;
                    // int idx = st[10e9 * x + y];
                    // if (idx > 0) gr[i].push_back(idx - 1);
                }
            }
        }
    }
    else {
        for (int i = 0; i < n - 1; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (dist2(p[i], p[j]) <= r * r) {
                    gr[i].push_back(j);
                    gr[j].push_back(i);
                }
            }
        }
    }
    vector<int> ans(n);
    vector<pair<int, int>> used(n);

    for (int i = 0; i < n; ++i) {
        if (used[i].first == 0) {
            ans[i] = dfs(gr, used, i, i, 3);
            cout << ans[i];
        } else {
            cout << ans[used[i].second];
        }
    }
}
