#include <bits/stdc++.h>
#define int long long
using namespace std;

ostream& operator<<(ostream& out, vector<int> v) {
    for (auto el : v) {
        out << el << " ";
    }
    return out << "\n";
}
ostream& operator<<(ostream& out, vector<vector<int>> v) {
    for (auto el : v) {
        out << el;
    }
    return out << "\n";
}

int n, m;
vector<vector<int>> v, dp;

const int INF = 1e15;

int f1(int i, int j) { // 
//    cout << "f1\n";
    vector<int> p(j + 1);
    for (int j2 = 0; j2 <= j; j2++) {
        p[j2] = v[i][j2];
    }
    int res = 0;
    for (int a = 0; a <= j; a++) {
        for (int b = a + 1; b <= j; b++) {
            if (p[a] < p[b]) {
                res++;
            }
        }
    }
    sort(p.begin(), p.end());
//    cout << p;
    for (int i2 = 0; i2 < i; i2++) {
        for (int j2 = 0; j2 <= j; j2++) {
            int l = -1;
            int r = j + 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (p[m] < v[i2][j2]) {
                    l = m;
                }
                else {
                    r = m;
                }
            }
            res += j + 1 - r;
//            cout << j + 1 - r << " ";
        }
    }
//    cout << "\n";
//    cout << res << "\n";

    if (i != 0) {
        res += dp[i - 1][j];
    }
    return res;
}

int f2(int i, int j) { // 
//    cout << "f2\n";
    vector<int> p(i + 1);
    for (int i2 = 0; i2 <= i; i2++) {
        p[i2] = v[i2][j];
    }
    int res = 0;
    for (int a = 0; a <= i; a++) {
        for (int b = a + 1; b <= i; b++) {
            if (p[a] < p[b]) {
                res++;
            }
        }
    }
//    cout << res << "\n";
    sort(p.begin(), p.end());
//    cout << p;
    for (int i2 = 0; i2 <= i; i2++) {
        for (int j2 = 0; j2 < j; j2++) {
            int l = -1;
            int r = i + 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (p[m] < v[i2][j2]) {
                    l = m;
                }
                else {
                    r = m;
                }
            }
            res += i + 1 - r;
//            cout << i + 1 - r << " ";
        }
    }
//    cout << "\n";
//    cout << res << "\n";

    if (j != 0) {
        res += dp[i][j - 1];
    }
    return res;
}


void rev() {
    if (n <= m) return;
    vector<vector<int>> v2(m, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            v2[j][i] = v[i][j];
        }
    }
    swap(n, m);
    swap(v2, v);
}

void solve() {
    cin >> n >> m;
    v = vector<vector<int>>(n, vector<int>(m));
    for (auto& mas : v) {
        for (auto& el : mas) {
            cin >> el;
        }
        reverse(mas.begin(), mas.end());
    }
    reverse(v.begin(), v.end());
    rev();
//    cout << v;
    dp = vector<vector<int>>(n, vector<int>(m, INF));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j == 0) {
                dp[i][j] = 0;
                continue;
            }
//            cout << "\n! " << i << " " << j << "\n";
            int res = INF;
            res = min(res, f1(i, j));
            res = min(res, f2(i, j));
            dp[i][j] = res;
        }
    }
//    cout << dp;
    cout << dp[n - 1][m - 1] << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
7 4
1010101
0
1
2
3

*/
