#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5 + 1;
using ll = long long;

ll dist(pair<int, int> a, pair<int, int> b) {
    return (ll(a.first) - ll(b.first)) * (ll(a.first) - ll(b.first)) +
           (ll(a.second) - ll(b.second)) * (ll(a.second) - ll(b.second));
}

mt19937 rng(23);

int rand_int(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

pair<int, int> a[maxn];
vector<int> gr[maxn];
int d[maxn];
bool res[maxn];
int n;
ll r;

string tup() {
    sort(a + 1, a + n + 1);
    a[n + 1] = {a[n].first + r + 4, a[n].second};
    a[n + 2] = {a[n].first + r + 5, a[n].second};
    int hh = 1;
    for (int i = 1; i <= n; i++) {
        if (dist(a[i], a[i + 1]) > r * r) {
            bool gg = false;
            for (int j = hh; j < i - 1; j++) {
                if (dist(a[j], a[j + 2]) <= r * r) {
                    gg = true;
                }
            }
            for (int j = hh; j <= i; j++) {
                res[j] = gg;
            }
            hh = i + 1;
        }
    }
    string ans="";
    for (int i = 1; i <= n; i++) {
        if (res[i])
            ans.push_back('1');
        else
            ans.push_back('0');
    }
    return ans;
}

string hhh() {
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            if (dist(a[i], a[j]) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (d[i] == 0) {
            vector<int> ver;
            queue<int> qu;
            qu.push(i);
            d[i] = 1;
            bool zikl = false;
            while (!qu.empty()) {
                int v = qu.front();
                ver.push_back(v);
                qu.pop();
                for (auto u: gr[v]) {
                    if (d[u] == 0) {
                        d[u] = d[v] + 1;
                        qu.push(u);
                    } else if (!((d[v] - d[u]) & 1)) {
                        zikl = true;
                    }
                }
            }
            for (auto v: ver)
                res[v] = zikl;
        }
    }
    string ans = "";
    for (int i = 1; i <= n; i++) {
        gr[i].clear();
        ans.push_back(char(res[i] + '0'));
    }
    return ans;
}
void gen() {
    n = rand_int(1, 1000);
    r = rand_int(1, 1e9);
    for (int i = 1; i<=n;i++) {
        a[i].first = rand_int(1, 5e8);
    }
}
void stress() {
    while (true) {
        gen();
        string ss = tup();
        string bb = hhh();
        if (ss != bb) {
            cout << n << ' ' << r << '\n';
            for (int i = 1; i<=n;i++) {
                cout << a[i].first << ' ' << a[i].second << '\n';
            }
            cout << '\n';
            cout << ss << ' ' << bb << '\n';
            return;
        }
        cout << 1 << endl;
    }
}
signed main() {
    stress();
}
