#include <bits/stdc++.h>

using ll = int;

using namespace std;

vector<vector<ll> > g;
vector<ll> used;

ll f = 0, a;

void dfs(ll v, ll k) {
    if (f) {
        return;
    }
    used[v] = k;
    for (ll i: g[v]) {
        if (used[i] == -1) {
            dfs(i, (k + 1) % 2);
            if (f) {
                return;
            }
        } else {
            if ((used[i] + used[v]) % 2 == 0) {
                f = 1;
                return;
            }
        }
    }
}

void solve() {
    ll n;
    long long r;
    cin >> n >> r;
    g.assign(n, vector<ll>(0));
    vector<pair<long long, long long> > A(n);
    for (ll i = 0; i < n; i++) {
        cin >> A[i].first >> A[i].second;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            __int128 a = (A[i].first - A[j].first) * (A[i].first - A[j].first) + (A[i].second - A[j].second) * (
                    A[i].second - A[j].second), b = r * r;
            if (a <= b) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        used.assign(n, -1);
        f = 0;
        a = i;
        dfs(i, 0);
        cout << f;
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    for (ll i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
