#include <bits/stdc++.h>
using namespace std;
const int N = 500 + 3, S = 1e6 + 3;
using ll = long long;
const ll inf = 1e18 + 7;
int tree[S];
int nl[S], nr[S];
int cur = 1;
int a[N][N], dp[N][N], root[N][N];
void build(int v, int l, int r) {
    if (l == r) {
        tree[v] = 0;
        return;
    }
    int m = (l + r )/ 2;
    nl[v] = cur;
    nr[v] = cur + 1;
    cur += 2;
    build(nl[v], l, m);
    build(nr[v], m + 1, r);
}
int update(int v, int l, int r, int pos, int t) {
    if (l == r) {
        int rt = cur;
        cur++;
        tree[rt] = tree[v] + t;
        return rt;
    }
    int rt = cur;
    cur++;
    int m = (l + r) / 2;
    if (pos <= m) {
        nl[rt] = update(nl[v], l, m, pos,t);
        nr[rt] = nr[v];
    } else {
        nl[rt] = nl[v];
        nr[rt] = update(nr[v], m + 1, r, pos,t);
    }
    tree[rt] = tree[nl[rt]] + tree[nr[rt]];
    return rt;
}
int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql > r || l > qr) {
        return 0;
    }
    int m = (l + r) / 2;
    return get(nl[v], l, m, ql, qr) + get( nr[v], m + 1, r, ql, qr);
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    //vector<vector<int>> a(n, vector<int> (m));
    //vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, inf));
    //vector<vector<int>> root(n + 1, vector<int> (m + 1));
    for (int i = 0 ;i < n; i++) {
        for (int j = 0 ;j < m; j++) {
            cin >> a[i][j];
        }
    }
    dp[0][0] = 0;
    root[0][0] = 0;
    build(0, 0, N - 1);
    for (int ci = 0; ci < n; ci++) {
        for (int cj =0; cj < m; cj++) {
            //cout << ci << " " << cj << "\n";
            int cr = root[ci][cj];
            ll c = 0;
            for (int j = cj; j < m; j++) {
                c += get(cr, 0, N - 1, a[ci][j], N - 1);
                cr = update(cr, 0, N - 1, a[ci][j], 1);
            }
            if (dp[ci][cj] + c < dp[ci + 1][cj]) {
                dp[ci + 1][cj] = dp[ci][cj] + c;
                root[ci + 1][cj] = cr;
            }
            cr = root[ci][cj];
            c = 0;
            for (int i = ci; i < n; i++) {
                c += get(cr, 0, N - 1, a[i][cj], N - 1);
                cr = update(cr, 0, N - 1, a[i][cj], 1);
            }
            if (dp[ci][cj] + c < dp[ci][cj + 1]) {
                dp[ci][cj + 1] = dp[ci][cj] + c;
                root[ci][cj + 1] = cr;
            }
        }
    }
    ll ans = inf;
    for (int i = 0 ;i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int j = 0; j <= m; j++) {
        ans = min(ans, dp[n][j]);
    }
    cout << ans;

}