#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("O2")
#pragma GCC optimize("Ofast")

vector<pair<int, int>> q;
map<pair<int, int>, int> w;
vector<array<int, 2>> used;
ll n, r;

bool qwe(pair<int, int> a, pair<int, int> b) {
    ll s = (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second);
    return s <= r * r;
}

void dfs(int i, int h) {
    used[i][h] = 1;
    //cout << i << " " << h << endl;
    for (int x = q[i].first - r; x <= q[i].first + r; x++) {
        for (int y = q[i].second - r; y <= q[i].second + r; y++) {
            if (x != q[i].first || y != q[i].second) {
                if (w[{x, y}]) {
                    if (qwe(q[i], make_pair(x, y)) && !used[w[{x, y}] - 1][1 - h]) dfs(w[{x, y}] - 1, 1 - h);
                }
                else w.erase({x, y});
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    q.resize(n);
    used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> q[i].first >> q[i].second;
        w[q[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i][0] && !used[i][1]) dfs(i, 0);
    }
    for (int i = 0; i < n; i++) {
        if (used[i][0] && used[i][1]) cout << 1;
        else cout << 0;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    //cin >> t;
    while (t--) solve();
}
