#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<ll> a;
vector<vector<ll>> tree;

void build(ll v, ll l, ll r) {
    if (r - l == 1) {
        tree[v] = {a[l]};
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v].resize(r - l);
    merge(all(tree[2 * v + 1]), all(tree[2 * v + 2]), tree[v].begin());
}

ll get(ll v, ll l, ll r, ll ql, ll qr, ll x) {
    if (ql <= l && r <= qr) {
        ll k = lower_bound(all(tree[v]), x) - tree[v].begin();
        return tree[v].size() - k;
    }
    if (r <= ql || qr <= l) return 0;
    ll m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr, x) + get(2 * v + 2, m, r, ql, qr, x);
}

void solve() {
    ll r, c;
    cin >> r >> c;
    a.resize(c);
    for (int i = 0; i < c; i++) {
        cin >> a[i];
    }
    tree.resize(4 * c);
    build(0, 0, c);
    vector<ll> dp(c + 1);
    for (int i = 0; i < c; i++) {
        dp[i + 1] = dp[i] + get(0, 0, c, 0, i, a[i]);
    }
    cout << dp[c] << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    //cin >> t;
    while (t--) solve();
}
