#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll n, q;
vector<ll> tree, a;

void build(ll v, ll l, ll r) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (ql <= l && r <= qr) return tree[v];
    if (r <= ql || qr <= l) return 1e18;
    ll m = (l + r) / 2;
    return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

void solve() {
    cin >> n >> q;
    a.resize(n);
    tree.resize(n * 4);
    vector<ll> ind(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ind[a[i]] = i;
    }
    build(0, 0, n);
    vector<ll> mx(n, n);
    vector<pair<ll, ll>> w;
    w.push_back({a[n - 1], n - 1});
    for (int i = n - 2; i > -1; i--) {
        while (!w.empty() && a[i] > w.back().first) w.pop_back();
        if (!w.empty()) mx[i] = w.back().second;
        w.push_back({a[i], i});
    }
    vector<ll> sufmx(n);
    sufmx[n - 1] = a[n - 1];
    for (int i = n - 2; i > -1; i--) sufmx[i] = max(sufmx[i + 1], a[i]);
    vector<ll> ans(3);
    for (int kk = 3; kk <= 3; kk++) {
        ll l = 0;
        for (int j = 1; j < kk; j++) {
            //cout << kk << " " << j << endl;
            //cout << l << endl;
            ans[j] = a[l];
            ll mn = get(0, 0, n, l + 1, min(mx[l] + 1, n - kk + 1 + j));
            if (j + 1 != kk) {
                l = ind[mn];
            }
            else {
                l = min(mx[l], n - kk + j);
                break;
            }
        }
        ans[kk] = sufmx[l];
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        cout << ans[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    //cin >> t;
    while (t--) solve();
}
