#include <bits/stdc++.h>

using namespace  std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    set<pair<ll, ll>> tec;
    ll cnt = 0;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        char x;
        cin >> x;
        a[i] = x - '0';
    }
    vector<ll> used(n);
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            continue;
        }
        if (i - 1 >= 0 && a[i - 1] != 0) {
            cnt++;
            used[i] = 1;
            continue;
        }
        if (i + 1 < n && a[i + 1] != 0) {
            used[i] = 1;
            cnt++;
        }
    }

    vector<ll> col(n);

    for (int i = 0; i < n; i++) {
        if (a[i] == 1) {
            continue;
        }
        ll c = 0;
        if (i - 1 >= 0 && a[i - 1] == 1 && !used[i - 1]) {
            c++;
        }
        if (i + 1 < n && a[i + 1] == 1 && !used[i + 1]) {
            c++;
        }
        col[i] = c;
        tec.insert({c, i});
    }

    vector<pair<ll, ll>> tt;
    vector<ll> ans(q);
    for (int i = 0; i < q; i++) {
        ll k;
        cin >> k;
        tt.emplace_back(k, i);
    }
    sort(tt.begin(), tt.end());


    ll ff = 0;
    for (auto [k, id] : tt) {
        while (ff < k && !empty(tec)) {
            ll idx = tec.rbegin()->second;
            tec.erase(--tec.end());
            a[idx] = 1;
            for (ll i = max(0ll, idx - 1); i < min(idx + 2, n); i++) {
                if (a[i] == 0) {
                    tec.erase({col[i], i});
                    ll c = 0;
                    if (i - 1 >= 0 && a[i - 1] == 1 && !used[i - 1]) {
                        c++;
                    }
                    if (i + 1 < n && a[i + 1] == 1 && !used[i + 1]) {
                        c++;
                    }
                    col[i] = c;
                    tec.insert({c, i});
                    continue;
                }
                if (used[i]) {
                    continue;
                }
                if (i - 1 >= 0 && a[i - 1] != 0) {
                    cnt++;
                    used[i] = 1;
                    continue;
                }
                if (i + 1 < n && a[i + 1] != 0) {
                    used[i] = 1;
                    cnt++;
                }
            }
            ff++;
        }
        ans[id] = cnt;
    }
    for (auto i : ans) {
        cout << i << '\n';
    }
}