#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<pair<pair<ll, ll>, ll> > p;

ll INF = 1e18;
ll n;
ll r;

vector<ll> used, d;
ll t = 0;
vector<bool> ans;

ll ro(ll i, ll j) {
    return abs(p[i].first.first - p[j].first.first) * abs(p[i].first.first - p[j].first.first) +
           abs(p[i].first.second - p[j].first.second) * abs(p[i].first.second - p[j].first.second);
}


bool dfs(ll v, ll depth) {
    used[v] = t;
    bool flag = false;
    for (ll i = 0; i < n; ++i) {
        if (i != v and used[v] == 0 and ro(v, i) <= r * r) {
            if (dfs(i, depth + 1)) {
                flag = true;
            }
        }
        if (i == v and used[v] == t and abs(d[v] - d[i]) % 2 == 0) {
            flag = true;
        }
    }
    if (flag) {
        ans[p[v].second] = true;
    }
    return flag;
}

int main() {
    cin >> n;
    used.resize(n, 0);
    cin >> r;
    p.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> p[i].first.first >> p[i].first.second;
        p[i].second = i;
    }
    // sort(p.begin(), p.end());
    std::random_shuffle(p.begin(), p.end());
    ans.resize(n, false);
    for (ll i = 0; i < n; ++i) {
        t++;
        if (used[i] == 0) {
            dfs(i, 0);
        }
    }
    for (auto u : ans) {
        if (u) {
            cout << '1';
        }
        else {
            cout << '0';
        }
    }
}
