#include<bits/stdc++.h>

using namespace std;

#pragma GCC optimize("unroll-loops")
long long r;
long long dist(pair<long long, long long> a, pair<long long, long long> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector<vector<long long>> g;
vector<long long> c;
vector<bool> answers;
vector<long long> comp;

bool is_good = true;

void dfs(long long v) {
    comp.push_back(v);
    if (comp.size() > g.size()) {
        throw(0);
    }
    for (auto &i : g[v]) {
        if (c[i] == -1) {
            c[i] = 1 - c[v];
            dfs(i);
        } else {
            if (c[i] == c[v]) {
                is_good = false;
            }
        }
    }
}
int main() {
    long long n;
    cin >> n >> r;
    c.resize(n, -1);
    g.resize(n);
    vector<pair<long long, long long>> a(n);
    for (auto &i : a) {
        cin >> i.first >> i.second;
    }
    for (long long i = 0; i < n; i++) {
        pair<long long, long long> mn1 = {1e18, -1}, mn2 = {1e18, -1};
        for (long long j = 0; j < n; j++) {
            if (i != j && dist(a[i], a[j]) <= r * r) {
                if (mn1 <= make_pair(dist(a[i], a[j]), j)) {
                    mn2 = mn1;
                    mn1 = {dist(a[i], a[j]), j};
                } else if (mn2 <= make_pair(dist(a[i], a[j]), j)) {
                    mn2  = {dist(a[i], a[j]), j};
                }
            }
        }
        if (mn1.second != -1) {
            g[i].push_back(mn1.second);
        }
        if (mn2.second != -1) {
            g[i].push_back(mn2.second);
        }
    }
    answers.resize(n);
    for (long long i = 0; i < n; i++) {
        if (c[i] == -1) {
            c[i] = 0;
            is_good = true;
            comp.clear();
            dfs(i);
            for  (auto &j : comp) {
                answers[j] = !is_good;
            }
        }
    }
    for (auto i : answers) {
        cout << i;
    }
}