#include<bits/stdc++.h>

using namespace std;

long long r;
long long dist(pair<int, int> a, pair<int, int> b) {
    return (long long) (a.first - b.first) * (a.first - b.first) + (long long) (a.second - b.second) * (a.second - b.second);
}

vector<vector<int>> g;
vector<int> c;
vector<bool> answers;
vector<int> comp;

bool is_good = true;

void dfs(int v) {
    comp.push_back(v);
    if (comp.size() > g.size()) {
        throw(0);
    }
    for (auto &i : g[v]) {
        if (c[i] == -1) {
            c[i] = 1 - c[v];
            dfs(i);
        } else {
            if (c[i] == c[v]) {
                is_good = false;
            }
        }
    }
}

mt19937 rnd(1902);
int main() {
    int n;
    cin >> n >> r;
    c.resize(n, -1);
    g.resize(n);
    vector<pair<int, int>> a(n);
    for (auto &i : a) {
        cin >> i.first >> i.second;
    }
    for (int i = 0; i < n; i++) {
        for (int k = 0; k < 250; k++) {
            long long j = rnd() % n;
            if (i != j && dist(a[i], a[j]) <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    answers.resize(n);
    for (int i = 0; i < n; i++) {
        if (c[i] == -1) {
            c[i] = 0;
            is_good = true;
            comp.clear();
            dfs(i);
            for  (auto &j : comp) {
                answers[j] = !is_good;
            }
        }
    }
    for (auto i : answers) {
        cout << i;
    }
}