#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

int timer = 0;

vector<vi> g;
vi comp;
vi bad;
vi col;
vi used;

void dfs(int v, int color) {
    used[v] = 1;
    col[v] = color;
    comp[v] = timer;
    for (int u : g[v]) {
        if ((col[u] == col[v])) {
            bad[comp[v]] = 1;
            return;
        } else if (used[u]) {
            // assert(comp[u] == comp[v]);
            continue;
        } else {
            dfs(u, 3 - color);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, r;
    cin >> n >> r;

    g.resize(n);
    col.resize(n);
    used.resize(n);
    comp.resize(n);
    vector<pi> ps(n);

    for (int i = 0; i < n; ++i) cin >> ps[i].first >> ps[i].second;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int dx = ps[i].first - ps[j].first;
            int dy = ps[i].second - ps[j].second;

            int d2 = dx * dx + dy * dy;

            if (r * r >= d2) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }

    bad.assign(n, 0);

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 1);
            ++timer;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << bad[comp[i]];
    }
}