#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <stack>

using namespace std;
typedef long long ll;

int main() {
    int n, q; cin >> n >> q;
    int arr[n];
    for (int i = 0; i < n; ++i)
        cin >> arr[i];

    vector<int> ans = {arr[0], INT_MAX, INT_MAX};
    int lg = -1;
    for (int i = n - 2; i >= 0 && lg == -1; --i)
        if (arr[i] > arr[n - 1])
            lg = i;

    stack<int> s;
    vector<int> rg(n, n);
    int suf[n + 1];
    suf[n] = 0;
    for (int i = 0; i < n; ++i) {
        while (!s.empty() && arr[i] > arr[s.top()]) {
            rg[s.top()] = i;
            s.pop();
        }
        s.push(i);

        suf[n - i - 1] = max(suf[n - i], arr[n - i - 1]);
    }

    for (int i = 1; i < n - 1; ++i) {
        int ans1 = arr[i];
        int ans2;
        if (lg < rg[i])
            ans2 = arr[n - 1];
        else
            ans2 = suf[rg[i]];

        if (ans1 < ans[1]) {
            ans[1] = ans1;
            ans[2] = ans2;
        } else if (ans1 == ans[1] && ans2 < ans[2]) {
            ans[2] = ans2;
        }
    }

    while (q--) {
        int k, i; cin >> k >> i;
        cout << ans[i - 1] << '\n';
    }

    return 0;
}
