#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}

#define int long long

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, r;
      cin >> n >> r;

      vector<pair<int, int>> a(n);
      for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            a[i].first = x;
            a[i].second = i;
      }

      sort(a.begin(), a.end());
      vector<int> f;
      for (int i = 0; i + 2 < n; ++i) {
            if (a[i + 2].first - a[i].first <= r) {
                  f.push_back(i);
            }
      }
      vector<int> res(n);
      vector<int> used(n);
      for (int i: f) {
            if (used[i]) continue;
            int now = i;
            while (true) {
                  used[now] = true;
                  res[now] = 1;
                  if (now > 0 and a[now].first - a[now - 1].first <= r and !used[now - 1]) {
                        now--;
                  } else {
                        break;
                  }
            }
            now = i;
            while (true) {
                  used[now] = true;
                  res[now] = 1;
                  if (now + 1 < n and a[now + 1].first - a[now].first <= r and !used[now + 1]) {
                        now++;
                  } else {
                        break;
                  }
            }
      }

      vector<int> anss(n);
      for (int i = 0; i < n; ++i) {
            anss[a[i].second] = res[i];
      }

      for (int i= 0; i < n; ++i) cout << anss[i];

}

