#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    string s;
    cin >> s;

    vector<vector<int>> poses(1, vector<int>());
    int cnt0 = 0, cnt1 = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') {
            if ((i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
                poses.back().push_back(i);
                cnt0++;
            } else {
                poses.push_back({});
                cnt1++;
            }
        }
    }

    vector<vector<int>> dist;
    for (int i = 0; i < (int)poses.size(); i++) {
        if ((int)poses[i].size() == 0)
            continue;
        dist.push_back({});
        for (int j = 1; j < (int)poses[i].size(); j++) {
            dist.back().push_back(poses[i][j] - poses[i][j - 1]);
        }
    }

    int seg1cnt = 0;
    for (int i = 0; i < (int)dist.size(); i++) {
        int cur = 0;
        for (int j = 0; j < (int)dist[i].size(); j++) {
            if (dist[i][j] == 2) {
                cur++;
            } else {
                seg1cnt += (cur + 1) / 2;
                cur = 0;
            }
        }
        seg1cnt += (cur + 1) / 2;
    }

    while (q--) {
        int k;
        cin >> k;

        if (cnt0 + cnt1 == 0 && k <= 1) {
            cout << 0 << '\n';
            continue;
        }

        cout << cnt1 + k + min(cnt0, min(k, seg1cnt) * 2 + max(0, k - seg1cnt)) << '\n';
    }
}