#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, r;
    cin >> n >> r;

    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        ll y;
        cin >> a[i] >> y;
    }
    sort(a.begin(), a.end());

    vector<bool> used(n, false);
    for (int i = 0; i < n - 2; i++) {
        if (a[i + 2] - a[i] <= r) {
            for (int j = i; j <= i + 2; j++) {
                used[j] = true;
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (a[i] - a[i - 1] <= r && used[i - 1])
            used[i] = true;
    }
    for (int i = n - 2; i >= 0; i--) {
        if (a[i + 1] - a[i] <= r && used[i + 1])
            used[i] = true;
    }

    for (int i = 0; i < n; i++) {
        if (used[i])
            cout << 1;
        else
            cout << 0;
    }
    cout << '\n';
}