#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int MAXN = 2e6 + 100;

int d[MAXN];

void update(int x) {
    for (; x < MAXN; x += (x & -x)) {
        d[x]++;
    }
}

int get(int x) {
    int ans = 0;
    for (; x > 0; x -= (x & -x)) {
        ans += d[x];
    }
    return ans;
}

ll check(vector<int> &a, int n) {
    fill(d, d + MAXN, 0);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans += i - get(a[i]);
        update(a[i]);
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mat(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mat[i][j];
        }
    }
    vector<int> a;
    for (int i = 0; i < n * m; i++) {
        a.push_back(mat[i / m][i % m]);
    }
    ll ans = check(a, n * m);
    a.clear();
    for (int i = 0; i < n * m; i++) {
        a.push_back(mat[i % n][i / n]);
    }
    ans = min(ans, check(a, n * m));
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}