#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int MAXN = 50;

int d[MAXN];
ll INF = 1e18;

void update(int x) {
    for (; x < MAXN; x += (x & -x)) {
        d[x]++;
    }
}

int get(int x) {
    int ans = 0;
    for (; x > 0; x -= (x & -x)) {
        ans += d[x];
    }
    return ans;
}

ll check(vector<int> &a, int n) {
    fill(d, d + MAXN, 0);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans += i - get(a[i]);
        update(a[i]);
    }
    // if (ans == 0) {
    //     for (auto el : a) cout << el << " ";
    //     cout << endl;
    // }
    return ans;
}

ll ans = INF;

void gen(int i, int j, int n, int m, vector<vector<int>> &mat, vector<int> &nw) {
    if (i == n || j == m) {
        ans = min(ans, check(nw, n * m));
        return;
    }
    for (int k = j; k < m; k++) {
        nw.push_back(mat[i][k]);
    }
    gen(i + 1, j, n, m, mat, nw);
    for (int k = j; k < m; k++) {
        nw.pop_back();
    }
    for (int k = i; k < n; k++) {
        nw.push_back(mat[k][j]);
    }
    gen(i, j + 1, n, m, mat, nw);
    for (int k = i; k < n; k++) {
        nw.pop_back();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), suf(n + 1), pref(n + 1);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = max(pref[i], a[i]);
    }
    for (int i = n - 1; i > -1; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    array<int, 3> ans;
    if (a[0] == n) {
        int i1 = -1, i2 = -1;
        for (int j = 0; j < n; j++) {
            if (a[j] == 1) i1 = j;
            if (a[j] == 2) i2 = j;
        }
        if (i1 == n - 1) {
            ans = {n, 2, suf[i2 + 1]};
        }
        else {
            ans = {n, 1, suf[i1 + 1]};
        }
    }
    else {
        int in = -1;
        for (int i = 0; i < n; i++) {
            if (a[i] == n) in = i;
        }
        if (in == 1) {
            ans = {a[0], n, 1};
            if (a[0] == 1) ans[2] = 2;
        }
        else {
            ans = {a[0], 0, n};
            int m = 0, j = -1;;
            for (int i = 1; i < in; i++) {
                if (a[i] > a[0]) {
                    j = i;
                    break;
                }
            }
            if (j == 1) ans[1] = a[j];
            else {
                int mn = n;
                for (int i = 1; i < j; i++) {
                    mn = min(mn, a[i]);
                }
                ans[1] = mn;
            }
        }
    }
    for (int _ = 0; _ < q; _++) {
        int k, j;
        cin >> k >> j;
        cout << ans[j - 1] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}