#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double

struct pnt {
    int x, y;

    pnt() {
        x = 0, y = 0;
    }

    pnt(int _x,int _y) {
        x = _x;
        y = _y;
    }
};

pnt operator-(pnt a, pnt b) {
    return {a.x - b.x, a.y - b.y};
}

ld len(pnt a) {
    return sqrtl(a.x * a.x + a.y * a.y);
}

vector<pair<int,int> > pos;
map<pair<int,int>, vector<int> > sq;
vector<pnt> p;
vector<vector<int> > g;
vector<int> used;
vector<int> step;
vector<bitset<500000> > s;


bool b = false;;

void dfs(int v) {
    if (b) {
        used[v] = 3;
        for (auto it: g[v]) {
            if (used[it] != 3) {
                dfs(it);
            }
        }
        return;
    } else {
        used[v] = 1;
        for (auto it: g[v]) {
            if (used[it] == 3 || (used[it] == 1 && (step[v] - step[it]) % 2 == 0)) {
                used[it] = 3;
                used[v] = 3;
                b = true;
                return;
            } else if (used[it] != 1) {
                step[it] = step[v] + 1;
                dfs(it);
                if (b) {
                    used[v] = 3;
                }
            }
        }
    }
    if (!b) {
        used[v] = 2;
    }
}

signed main() {
    int n, r;
    cin >> n >> r;
    pos.resize(n);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
        pos[i] = {p[i].x / r, p[i].y / r};
        sq[pos[i]].push_back(i);
    }

    s.resize(n);
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int x_b = pos[i].first - 1, x_e = pos[i].first + 1;
        int y_b = pos[i].second - 1, y_e = pos[i].second + 1;
        for (int x = x_b; x <= x_e; ++x) {
            for (int y = y_b; y <= y_e; ++y) {
                for (auto it: sq[{x, y}]) {
                    if (i != it && len(p[i] - p[it]) <= r) {
                        g[i].push_back(it);
                        s[i][it] = true;
                        if ((s[i] & s[it]) != 0) {
                            x = x_e;
                            y = y_e;
                            break;
                        }
                    }
                }
            }
        }
    }

    step.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] != 3) {
            dfs(i);
            b = false;
        }
    }

    string ans;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 3) {
            ans.push_back('1');
        } else {
            ans.push_back('0');
        }
    }
    cout << ans;
    return 0;
}
