#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <chrono>
#include <random>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)

using namespace std;

vector <vector <int>> g;

vector <int> used;
bool f = 0;
vector <int> inds;

void dfs(int u, int col) {
	used[u] = col;
	inds.push_back(u);
	for (auto v : g[u]) {
		if (used[v] == col) {
			f = 1;
		}
		if (!used[v]) {
			dfs(v, 3 - col);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll n, R;
	cin >> n >> R;
	vector <pair <int, int>> p(n);
	vector <pair <int, int>> s;
	g.resize(n);
	vector <int> ans(n);
	fi(0, n - 1) {
		cin >> p[i].first >> p[i].second;
		s.emplace_back(p[i].first, i);
	}
	sort(s.begin(), s.end());
	fi(0, n - 1) {
		int x = s[i].first;
		int ind = s[i].second;
		int r = upper_bound(s.begin(), s.end(), (pair <int, int>)make_pair((int)x + R, 1'000'000'009)) - s.begin() - 1;
		if (r - i + 1 >= 3 || ans[s[i].second] == 1 || ans[s[r].second] == 1) {
			for (int j = i; j <= r; j++) {
				ans[s[j].second] = 1;
			}
		}
	}
	for (int i = n - 1; i > 0; ) {
		int x = s[i].first;
		int ind = s[i].second;
		if (ans[ind] == 0) { i--; continue; }
		int l = lower_bound(s.begin(), s.end(), (pair <int, int>)make_pair((int)x - R, 0)) - s.begin();
		if (l == i) { i--; continue; }
		while (i > l) {
			i--;
			ans[i] = 1;
		}
	}
	fi(0, n - 1) {
		cout << ans[i];
	}
}