#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<bitset>
#include<iomanip>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

mt19937 mt(time(0));
const int N = 1e5 + 2, SZ = 2e5 + 2, inf = 1e9 + 100;
int n, d, p[N], r[N], c[N], ans[N];
int col(int v) {
	return p[v] == v ? c[v] : c[v] ^ col(p[v]);
}
int pr(int v) {
	return p[v] == v ? v : pr(p[v]);
}
void unite(int x, int y, int w) {
	int c1 = col(x), c2 = col(y);
	x = pr(x), y = pr(y);
	if (x == y) {
		if ((c1 ^ c2) == w) ans[x] = 1;
		return;
	}
	if (r[x] < r[y]) swap(x, y);
	if ((c1 ^ c2) == w) c[y] ^= 1;
	p[y] = x;
	r[x] += r[x] == r[y];
}
struct point {
	ll x, y;
	point() {}
	point(ll _x, ll _y) : x(_x), y(_y) {}
	point operator+(point a) {
		return point(x + a.x, y + a.y);
	}
	point operator-(point a) {
		return point(x - a.x, y - a.y);
	}
	ll operator%(point a) {
		return x * a.y - y * a.x;
	}
	point operator*(ll a) {
		return point(x * a, y * a);
	}
	ll dist2(point a) {
		return (x - a.x) * (x - a.x) + (y - a.y) * (y - a.y);
	}
};
bool cmp(point a, point b) {
	return a % b > 0;
}
//vector<point> cringe(vector<point> a) {
//	int ind, mn;
//}
//vector<point> inv(vector<point> a) {
//
//}
point a[N];
vector<pair<int, int>> g[N];
map<int, vector<point>> b;
map<int, vector<point>> obs;
map<pair<int, int>, int> ind;

void solve() {
	cin >> n >> d;
	for (int i = 0; i < n; ++i) cin >> a[i].x >> a[i].y;
	for (int i = 0; i < n * 2; ++i) p[i] = i;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[i].dist2(a[j]) <= 1ll * d * d) {
				g[i].push_back({ j, 0 });
				g[j].push_back({ i, 0 });
			}
		}
	}
	for (int v = 0; v < n * 2; ++v) {
		for (auto i : g[v]) {
			unite(v, i.first, i.second);
		}
	}
	for (int i = 0; i < n; ++i) cout << (ans[pr(i)] ? "YES" : "NO") << ' ';
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}