#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using namespace std;

struct Pt {
    ll x, y;
};

ll dist2(const Pt& a, const Pt& b) {
    return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}
int VERSION = 1;
ll n, r;
vector<Pt> pts;
vector<vector<ll>> g;
vector<int> used;

bool dfs(ll u, ll target) {
    if (u == target)
        return 1;
    used[u] = VERSION;
    for (auto &v : g[u]) {
        if (used[v] == VERSION)
            continue;
        if (dfs(v, target))
            return 1;
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    r *= r;
    pts.resize(n);
    for (auto &p : pts)
        cin >> p.x >> p.y;
    g.resize(2*n);
    used.resize(2*n, 0);
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < i; ++j) {
            if (dist2(pts[i], pts[j]) <= r) {
                g[i].push_back(n+j);
                g[n+j].push_back(i);
                g[n+i].push_back(j);
                g[j].push_back(n+i);
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << dfs(i, n+i);
        ++VERSION;
    }
    cout << endl;

    return 0;
}

