#include <iostream>
#include <iomanip>
#include <string>
#include <numeric>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <array>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#pragma gcc optimize("Ofast")
using namespace std;


bool check(vector<bool>& a, int i) {
	if (i < 0 or i >= a.size()) {
		return 1;
	}
	return !a[i];
}

bool odcpcom(vector<vector<int>>& a, vector<int>& v, int s, int p, int c, vector<int>& d) {
	bool f = 0;
	v[s] = c;
	d[s] = p;
	for (int i = 0; i < a[s].size(); i++) {
		if (v[a[s][i]] == 0) {
			f |= odcpcom(a, v, a[s][i], p + 1, c, d);
		}
		if ((d[a[s][i]] % 2) == (p % 2)) {
			f = 1;
		}
	}
	return f;
}


int main()
{
	long long n, r;
	cin >> n >> r;
	vector<array<long long, 2>> a;
	map<array<long long, 2>, array<int, 2>> b;
	map<array<int, 2>, vector<array<long long, 2>>> c;
	vector<vector<int>> d(n);
	map<array<long long, 2>, int> e;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		array <long long , 2 > qwe = { x,y };
		a.push_back(qwe);
		e[qwe] = i + 1;
	}
	/*
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((a[i][0] - a[j][0]) * (a[i][0] - a[j][0]) + (a[i][1] - a[j][1]) * (a[i][1] - a[j][1]) <= r * r) {
				d[i].push_back(j);
				d[j].push_back(i);
			}
		}
	}*/
	for (int i = 0; i < n; i++) {
		for (int j = a[i][0] - r; j <= a[i][0] + r; j++) {
			for (int k = a[i][1] - r; k <= a[i][1] + r; k++) {
				if (j == a[i][0] and k == a[i][1]) {
					continue;
				}
				if ((a[i][0] - j) * (a[i][0] - j) + (a[i][1] - k) * (a[i][1] - k) <= r * r) {
					if (e[{j, k}] > 0) {
						d[i].push_back(e[{j, k}] - 1);
					}
				}
			}
		}
	}
	vector<int> v(n);
	vector<int> dist(n);
	vector<int> w(n+1);
	int q = 1;
	for (int i = 0; i < n; i++) {
		if (v[i] == 0) {
			if (odcpcom(d, v, i, 0, q, dist)) {
				w[q] = 1;
			}
			q++;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << w[v[i]];
	}

}

