#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const ll INF = 1000000000;

void precalc() {

}

ll merge(ll l, ll m, ll r, vector<ll>& arr) {
	ll i = l;
	ll j = m;
	vector<ll> cur;
	ll cnt = 0;
	ll sum = 0;
	while (i < m and j < r) {
		if (arr[i] > arr[j]) {
			cur.push_back(arr[j]);
			j += 1;
			cnt += 1;
		}
		else {
			cur.push_back(arr[i]);
			i += 1;
			sum += cnt;
		}
	}
	for (; i < m; i++) {
		cur.push_back(arr[i]);
		sum += cnt;
	}
	for (; j < r; j++) {
		cur.push_back(arr[j]);
	}
	for (ll ind = 0; ind < r - l; ind++) {
		arr[ind + l] = cur[ind];
	}
	return sum;
}

ll merge_sort(ll l, ll r, vector<ll>& arr) {
	if (r - l <= 1) {
		return 0;
	}
	ll m = (l + r) / 2;
	ll ans = merge_sort(l, m, arr) + merge_sort(m, r, arr);
	return ans + merge(l, m, r, arr);
}

void solve() {
	ll r, c;
	cin >> r >> c;
	ll n = r + c;
	vector<vector<ll>> arr(r, vector<ll>(c, 0));
	for (ll i = 0; i < r; i++) {
		for (ll j = 0; j < c; j++) {
			cin >> arr[i][j];
		}
	}
	cout << merge_sort(0, c, arr[0]);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
}