#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<unordered_map>
#include<map>
#include<math.h>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
const int INF = 1e9 + 7;

struct pt
{
	ll x = 0, y = 0;
	pt(ll x, ll y) :x(x), y(y) {}
	pt() {}
};

pt operator-(pt a, pt b) { return pt(a.x - b.x, a.y - b.y); }
ll len(pt a) { return a.x * a.x + a.y * a.y; }
vector<pt> a;

struct hash_pair
{
	size_t operator()(pair<ll, ll> a) const {
		if (a.first == a.second)return hash<ll>()(a.first);
		return (hash<ll>()(a.first) ^ hash<ll>()(a.second));
	}
};

map<pair<ll, ll>,vector<int>> mp;
map<pair<ll, ll>,bool> ot;
vector<int> ans,used;
ll r;
ld rs;
const int rd = 2;

int dfs(int u,int c) {
	if (ans[u]) {
		return 1;
	}
	used[u] = c;
	ll x = a[u].x / rs, y = a[u].y / rs;
	for (ll i = -rd; i <= rd; ++i) {
		for (ll j = -rd; j <= rd; ++j) {
			if (!mp.count(make_pair(x + i, y + j)))continue;
			for (auto to : mp[make_pair(x + i, y + j)]) {
				if (len(a[u] - a[to]) > r * r or u == to) {
					continue;
				}
				if (used[to]) {
					if (used[to] == c) {
						ans[u] = 1;
					}
				}
				else {
					if (dfs(to, 3 - c)) {
						ans[u] = 1;
					}
				}
			}
		}
	}
	return ans[u];
}
ll n;
vector<int> us, s, gg;

int make(int u, int c) {
	us[u] = c;
	gg.push_back(u);
	for (int i = 0; i < n; ++i) {
		if (i == u or len(a[u] - a[i]) > r * r) {
			continue;
		}
		if (us[i]) {
			if (us[i] == c) {
				s[u] = 1;
			}
		}
		else {
			if (make(i, 3 - c)) {
				s[u] = 1;
			}
		}

	}
	return s[u];
}

void tup() {
	us.assign(n,0);
	s.assign(n,0);
	for (int i = 0; i < n; ++i) {
		if (!us[i]) {
			if (make(i, 1)) {
				for (auto j : gg) {
					s[j] = 1;
				}
			}
			gg.clear();
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << s[i];
	}
}


int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	cin >> n >> r;
	ans.assign(n, 0);
	used.assign(n,0);
	for (int i = 0; i < n; i++)
	{
		ll x, y;
		cin >> x >> y;
		a.push_back(pt(x, y));
	}
	rs = r / sqrtl(2LL);
	for (int i = 0; i < n; ++i) {
		ll x = a[i].x / rs,y = a[i].y / rs;
		mp[make_pair(x, y)].push_back(i);
	}
	for (const auto& i : mp) {
		if (i.second.size() >= 3) {
			ot[i.first] = 1;
			for (auto j : i.second) {
				ans[j] = 1;
			}
		}
		else {
			ot[i.first] = 0;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i] and !ans[i]) {
			dfs(i, 1);
		}
	}tup();
	//for (auto i : ans)cout << i;
}