import sys
input = sys.stdin.readline

def count_powers(s, n):
    powers = []
    counter = 0
    for i in range(n):
        if s[i] == "0":
            if powers != []:
                powers[-1][0] += counter

            if i == 0:
                if s[1] == "1":
                    counter += 1
            elif i == n-1:
                if s[-2] == "1":
                    counter += 1
            elif s[i-1] == "1" or s[i+1] == "1":
                counter += 1
            powers.append([counter, i])
            counter = 0
        else:
            counter += 1
            if i == 0:
                if s[0] == "1" and s[1] == "1":
                    counter -= 1
            elif i == n-1:
                if s[-1] == "1" and s[-2] == "1":
                    counter -= 1
            elif s[i-1] == "1" or s[i+1] == "1":
                counter -= 1

    if powers != []:
        powers[-1][0] += counter

    return powers

def counter(s, n):
    if n == 1:
        return 0
    if n == 2:
        return 1 if s.count("1") == 2 else 0

    ans = 0
    for i in range(1, n-1):
        if s[i] == "1" and (s[i-1] == "1" or s[i+1] == "1"):
            ans += 1

    if s[-1] == "1" and s[-2] == "1":
        ans += 1
    if s[0] == "1" and s[1] == "1":
        ans += 1
    
    return ans

def main():
    n, qc = map(int, input().split())
    s = list(input().strip())
    qs = [int(input()) for _ in range(qc)]

    # solve only for max k
    zeroc = 0
    for ch in s:
        if ch == "0":
            zeroc += 1
            
    k = min(zeroc, max(qs))
    
    answers = {
               0: counter(s, n)}
    for i in range(1, k+1):
        powers = count_powers(s, n)
        best = max(powers, key=lambda el: el[0])[1]
        
        s[best] = "1"

        answers[i] = counter(s, n)

    for q in qs:
        qq = min(zeroc, q)
        print(answers[qq])
    
main()
