import sys
input = sys.stdin.readline

def count_powers(s, n):
    powers = []
    counter = 0
    for i in range(n):
        if s[i] == "0":
            if powers != []:
                powers[-1][0] += counter

            if i == 0:
                if s[1] == "1":
                    counter += 1
            elif i == n-1:
                if s[-2] == "1":
                    counter += 1
            elif s[i-1] == "1" or s[i+1] == "1":
                counter += 1

            powers.append([counter, i])
            counter = 0
        else:
            counter += 1
            if i == 0:
                if s[0] == "1" and s[1] == "1":
                    counter -= 1
            elif i == n-1:
                if s[-1] == "1" and s[-2] == "1":
                    counter -= 1
            elif s[i-1] == "1" or s[i+1] == "1":
                counter -= 1

    if powers != []:
        powers[-1][0] += counter

    return powers

def counter(s, n):
    if n == 1:
        return 0
    if n == 2:
        return 2 if s.count("1") == 2 else 0

    ans = 0
    for i in range(1, n-1):
        if s[i] == "1" and (s[i-1] == "1" or s[i+1] == "1"):
            ans += 1

    if s[-1] == "1" and s[-2] == "1":
        ans += 1
    if s[0] == "1" and s[1] == "1":
        ans += 1
    
    return ans

def main():
    n, qc = map(int, input().split())
    s = input().strip()
    qs = [int(input()) for _ in range(qc)]
    
    if n == 1:
        for q in qs:
            print(0)
        return

    # solve only for max k
    k = max(qs)
    
    answers = {
               0: counter(s, n)}
    for i in range(1, k+1):
        if "10" in s:
            s = s.replace("10", "11", 1)
        elif "01" in s:
            s = s.replace("01", "11", 1)
        else:
            s = s.replace("0", "1", 1)
        
        print(s)

        answers[i] = counter(s, n)

    for q in qs:
        print(answers[q])
    
main()
