#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll n, r;
vector<pair<ll, ll>> a;
vector<int> used;
vector<int> cmp, color;

ll sqr(ll a) {
    return a * a;
}

bool check(int i, int j) {
    ll x = sqr(a[i].first - a[j].first) + sqr(a[i].second - a[j].second);
    return x <= r;
}

const int MAXN = 1e5;

vector<int> ans;
vector<int> g[MAXN];

void dfs(int v, int t, int c = 0) {
    used[v] = 1;
    cmp[v] = t;
    color[v] = c;
    for (auto j : g[v]) {
        if (used[j]) {
            if (color[j] == color[v]) {
                ans[t] = 1;
            }
            continue;
        }
        dfs(j, t, 1 - c);
    }
}

void solve() {
    cin >> n >> r;
    r *= r;
    a.resize(n);
    used.resize(n);
    ans.resize(n);
    cmp.resize(n);
    color.resize(n);
    unordered_map<pair<int, int>, int> q;
    int ind = 1;
    for (auto& [i, j] : a) {
        cin >> i >> j;
        q[{i, j}] = ind++;
    }
    for (int l = 0; l < n; l++) {
        for (int i = -r; i <= r; i++) {
            for (int j = -r; j <= r; j++) {
                if (abs(i) == r && abs(j) == r) continue;
                if (i == 0 && j == 0) continue;
                int z = q[{i + a[l].first, j + a[l].second}] - 1;
                if (z != -1) {
                    if (check(l, z)) {
                        g[l].push_back(z);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i);
        }
        cout << ans[cmp[i]];
    }

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
