#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("O3")

using namespace std;


int rast(pair <int, int> a, pair <int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

int n, r;
vector <int> used;
vector <pair <int, int>> arr;
set <pair <pair <int, int>, int>> s;

bool is(int v, int c) {
    used[v] = c;
    bool b = false;
    for (int x = arr[v].first - r; x <= arr[v].first + r; ++x) {
        for (int y = arr[v].second; y <= arr[v].second + r; ++y) {
            if (rast(arr[v], {x, y}) > r * r) break;
            auto it = s.lower_bound({{x, y}, 0});
            if (it == s.end() || (*it).first.first != x || (*it).first.second != y) continue;
            int j = (*it).second;
            if (v == j) continue;
            if (used[j] == -1) {
                b = (b || is(j, !c));
            } else if (used[j] == used[v]) {
                b = true;
            }
            if (b) break;
        }
        for (int y = arr[v].second; y >= arr[v].second - r; --y) {
            if (rast(arr[v], {x, y}) > r * r) break;
            auto it = s.lower_bound({{x, y}, 0});
            if (it == s.end() || (*it).first.first != x || (*it).first.second != y) continue;
            int j = (*it).second;
            if (v == j) continue;
            if (used[j] == -1) {
                b = (b || is(j, !c));
            } else if (used[j] == used[v]) {
                b = true;
            }
            if (b) break;
        }
    }
    return b;
}

vector <int> can;

void dfs(int v) {
    can[v] = 1;
    for (int x = arr[v].first - r; x <= arr[v].first + r; ++x) {
        for (int y = arr[v].second; y <= arr[v].second + r; ++y) {
            if (rast(arr[v], {x, y}) > r * r) break;
            auto it = s.lower_bound({{x, y}, 0});
            if (it == s.end() || (*it).first.first != x || (*it).first.second != y) continue;
            int j = (*it).second;
            if (v == j) continue;
            if (!can[j]) {
                dfs(j);
            }
        }
        for (int y = arr[v].second; y >= arr[v].second - r; --y) {
            if (rast(arr[v], {x, y}) > r * r) break;
            auto it = s.lower_bound({{x, y}, 0});
            if (it == s.end() || (*it).first.first != x || (*it).first.second != y) continue;
            int j = (*it).second;
            if (v == j) continue;
            if (!can[j]) {
                dfs(j);
            }
        }
    }
}

signed main() {
    cin >> n >> r;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first >> arr[i].second;
        s.insert({arr[i], i});
    }
    used.resize(n, -1);
    can.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            if (is(i, 0)) {
                dfs(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << can[i];
    }
    return 0;
}
