#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("O3")

using namespace std;

vector <vector <int>> g;


int rast(pair <int, int> a, pair <int, int> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector <int> used;
int n, r;
vector <pair <int, int>> arr;

bool is(int v, int c) {
    used[v] = c;
    bool b = false;
    for (int to = 0; to < n; ++to) {
        if (rast(arr[v], arr[to]) > r * r) continue;
        if (used[to] == -1) {
            b = (b || is(to, !c));
        } else if (used[to] == used[v]) {
            b = true;
        }
    }
    return b;
}

vector <int> can;

void dfs(int v) {
    can[v] = 1;
   for (int to = 0; to < n; ++to) {
        if (rast(arr[v], arr[to]) > r * r) continue;
        if (!can[to]) {
            dfs(to);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first >> arr[i].second;
    }
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if ( i == j) continue;
            if (rast(arr[i], arr[j]) <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    used.resize(n, -1);
    can.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            if (is(i, 0)) {
                dfs(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << can[i];
    }
    return 0;
}
