#include<bits/stdc++.h>

using namespace std;

const int MAX = 1e5;

vector<int> g[MAX];
int used[MAX];
int fl = 1;
int ans[MAX];

void dfs(int v, int num) {
    used[v] = num;
    for (int to : g[v]) {
        if (used[to] != 0) {
            if (used[to] == num) {
                fl = 0;
            }
            continue;
        }
        dfs(to, ((num - 1) ^ 1) + 1);
    }
    if (fl == 0) {
        ans[v] = 1;
    }
}

long long dist(pair<int, int> a, pair<int, int> b) {
    int x = a.first - b.first;
    int y = a.second - b.second;
    return 1ll * x * x + 1ll * y * y;
}

signed main() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j == i) continue;
            if (dist(a[i], a[j]) <= 1ll * r * r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            fl = 1;
            dfs(i, 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    return 0;
}
