#include<bits/stdc++.h>

using namespace std;

const int MAX = 3e5 + 5, LN = 19;
int a[MAX], p[MAX];
int pr[MAX + 1];
int sp[MAX][LN];
int nx[MAX];
int suf[MAX];

void st(int n) {
    pr[1] = 0;
    for (int i = 2; i <= n; ++i) {
        pr[i] = pr[i / 2] + 1;
    }
    for (int i = 0; i < n; ++i) {
        sp[i][0] = a[i];
    }
    for (int j = 1; j < LN; ++j) {
        for (int i = 0; i < n; ++i) {
            sp[i][j] = min(sp[i][j - 1], sp[min(n - 1, i + (1 << (j - 1)))][j - 1]);
        }
    }
}

int get(int l, int r) {
    if (l == r) return -1;
    int u = r - l;
    int x = (1 << pr[u]);
    return min(sp[l][pr[u]], sp[r - x][pr[u]]);
}

vector<int> ans[MAX];

void solve(int k, int n) {
    int l = 0;
    for (int i = 0; i < max(k, 3); ++i) {
        //cout << k << " " << l << endl;
        //cout << u << endl;
        if (i != k - 1 && i != k - 2) {
            ans[k].push_back(a[l]);
        } else if (i == k - 2) {
            ans[k].push_back(a[l]);
            l = min(nx[l], n - 1);
            continue;
        } else {
            ans[k].push_back(suf[l]);
            break;
        }
        int u = get(l + 1, min(nx[l], n - k + i + 2));
        if (u == -1) {
            l++;
            continue;
        }
        l = p[u];
    }
}

signed main() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        p[a[i]] = i;
    }
    vector<pair<int, int>> stc;
    stc.push_back({n, n});
    for (int i = n - 1; i >= 0; --i) {
        while (!stc.empty() && stc.back().first < a[i]) {
            stc.pop_back();
        }
        nx[i] = stc.back().second;
        stc.push_back({a[i], i});
    }
    st(n);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    vector<pair<int, int>> qs;
    vector<int> b;
    for (int i = 0; i < q; ++i) {
        int k, j;
        cin >> k >> j;
        --j;
        if (k == 1) {
            cout << n << endl;
            continue;
        }
        if (k % 2 == 1) {
            if (j < k - 1) {
                cout << a[j] + 1 << endl;
            } else {
                cout << a[n - 1] + 1 << endl;
            }
        } else {
            cout << a[j] + 1 << endl;
        }
        b.push_back(k);
        qs.push_back({k, j});
    }
    return 0;
    sort(b.begin(), b.end());
    b.erase(unique(b.begin(), b.end()), b.end());
    for (auto x : b) {
        //cout << x << endl;
        solve(x, n);
    }
    for (auto [k, j] : qs) {
        cout << ans[k][j] + 1 << endl;
    }
    return 0;
}
