#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  #pragma GCC target("avx2,fma")
#endif

using namespace std;

#define X first
#define Y second
#define all(x) begin(x), end(x)

int isz(const auto& x) {
  return x.size();
}

using ll = long long;
using ld = long double;

int calc(deque<deque<int>> a, const vector<char>& t) {
  vector<int> b;
  for (auto it : t) {
    while (!a.empty() && a[0].empty()) a.pop_front();
    if (a.empty()) break;
    if (!it) {
      b.insert(b.end(), all(a[0]));
      a.pop_front();
    } else {
      for (int i = 0; i < isz(a); ++i) {
        b.push_back(a[i][0]);
        a[i].pop_front();
      }
    }
  }
  int ans = 0;
  for (int i = 0; i < isz(b); ++i) {
    ans += count_if(b.begin(), b.begin() + i, [&](int x) {
      return x > b[i];
    });
  }
  return ans;
}

void solve() {
  int r, c;
  cin >> r >> c;
  deque a(r, deque<int>(c));
  for (auto& v : a) {
    for (auto& it : v) {
      cin >> it;
    }
  }
  mt19937 rng(17);
  vector<char> type(r + c - 1);
  for (auto& it : type) it = rng() & 1;
  int ans = calc(a, type), best = ans;
  ld t = 1;
  while (t > 1e-3) {
    auto tp = type;
    tp[rng() % (r + c - 1)] = rng() & 1;
    int cur = calc(a, tp);
    if (cur < ans || 1.L * rng() / INT_MAX < exp((cur - ans) / t)) {
      ans = cur;
      type = tp;
      best = min(best, ans);
    }
    t *= 0.99995;
  }
  cout << best << '\n';
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  solve();
}