#include <bits/stdc++.h>
using namespace std;
#define int long long
int cnt = 0;
vector <int> b, tree;
void update(int i, int l, int r, int qi, int x) {
    if (l + 1 == r) {
        tree[i] += x;
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) update(i * 2 + 1, l, m, qi, x);
    else update(i * 2 + 2, m, r, qi, x);
    tree[i] += x;
}
int get(int i, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) return 0;
    if (l >= ql && r <= qr) return tree[i];
    int m = (l +r ) / 2;
    return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int>(m));
    for (auto& x : a) {
        for (int & y : x) {
            cin >> y;
        }
    }
    int i = 0, j = 0, cur = 0;
    b = vector <int> (n * m);
    tree = vector<int>(4 * n * m, 0);
    while (i < n && j < m) {
        int ans1 = 0, ans2 = 0;
        for (int k = j; k < m; k++) {
            ans1 += a[i][k] - 1 - get(0, 0, n * m, 0, a[i][k]);
            update(0, 0, n * m, a[i][k] - 1, 1);
        }
        for (int k = j; k < m; k++) {
            update(0, 0, n * m, a[i][k] - 1, -1);
        }
        for (int k = i; k < n; k++) {
            ans2 += a[k][j] - 1 - get(0, 0, n * m, 0, a[k][j]);
            update(0, 0, n * m, a[k][j] - 1, 1);
        }
        for (int k = i; k < n; k++) {
            update(0, 0, n * m, a[k][j] - 1, -1);
        }
        // cout << ans1 << ' ' << ans2 << endl;
        if (ans1 < ans2) {
            cnt += ans1;
            for (int k = j; k < m; k++) {
                update(0, 0, n * m, a[i][k] - 1, 1);
            }
            i++;
        } else {
            cnt += ans2;
            for (int k = i; k < n; k++) {
                update(0, 0, n * m, a[k][j] - 1, 1);
            }
            j++;
        }
    }
    // for (int x : b) cout << x << ' ';
    // cout << endl;
    // mergesort(0, n * m);
    cout << cnt;
}
signed main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}