#include <bits/stdc++.h>
using namespace std;
#define int long long
void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    solve();
}

struct point {
    int x,y;
};

int dist2(point &a,point &b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

vector<vector<int>> g,gg;
vector<int> color,tin,tout;
vector<pair<int,int>> q;
vector<int> pr;

int timer=0;

void dfs(int v,int p) {
    timer+=2;
    pr[v]=p;

    tin[v]=timer;
    q.push_back({timer,v});
    timer+=2;

    for (auto i:g[v]) {
        if (i==p) continue;
        if (tin[i]==-1) dfs(i,v);
        else if (tin[i]<tin[v]){
            timer+=2;
            q.push_back({tin[i]+1,-2});
            q.push_back({tin[v]+1,-1});
            timer+=2;
        }
    }
    timer+=2;
    tout[v]=timer;
}

void DDD(int v,int p) {
    if (p==-1) color[v]=1;
    else color[v]=3-color[p];
    for (auto i:gg[v]) {
        if (i==p) continue;
        if (color[i]==0) DDD(i,v);
        if (color[i]==color[v]) {
            color[i]=-1;
        }
    }
}

void FILL(int v,int p) {
    color[v]=-1;
    for (auto i:gg[v]) {
        if (color[i]!=-1) FILL(i,v);
    }
}
int cmp=0;

int n,r;
void ddd(int v,vector<int> &used,int v1,int v2) {
    used[v]=1;
    for (auto i:g[v]) {
        if (used[i]==0 && !((v1==i) && (v2==v)) && !((v1==v) && v2==i)) ddd(i,used,v1,v2);
    }
}
bool most(int v1,int v2) {
    int cp=0;
    vector<int> used(n,0);
    for (int i=0;i<n;i++) {
        if (used[i]==0 ) {
            ddd(i,used,v1,v2);
            cp++;
        }
    }
    return (cp!=cmp);
}

void solve() {
    cin>>n>>r;
    vector<point> a(n);
    pr.resize(n);
    for (int i=0;i<n;i++) {
        cin>>a[i].x>>a[i].y;
    }
    g.resize(n);
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (dist2(a[i],a[j])<=r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i=0;i<n;i++) {
        for (auto j:g[i]) {
            cerr<<i<<' '<<j<<"\n";
        }
    }
    cerr<<"!\n";
    tin.resize(n,-1);
    tout.resize(n,-1);
    pr.resize(n,0);

    for (int i=0;i<n;i++) {
        if (tin[i]==-1) {
            dfs(i,-1);
            cmp++;
        }
    }
    sort(q.begin(),q.end());
    for (auto i:q) cerr<<i.first<<' '<<i.second<<"\n";
    cerr<<"!!!\n";
    int cur_sum=0;
    int z[n];
    for (int i=0;i<n;i++) z[i]=0;
    for(int i=0;i<q.size();i++) {
        if (q[i].second<0) {
            if (q[i].second==-2) cur_sum++;
            else cur_sum--;
        }
        else if (q[i].second>=0) {
            if (cur_sum>0) z[q[i].second]=1;
        }

    }
    for (auto i:z) cerr<<i<<' ';
    cerr<<"\n";
    gg.resize(n);
    for (int i=0;i<n;i++) {
        for (auto j:g[i]) {
            if(most(i,j)) {
                cerr<<i<<' '<<j<<"\n";
            }
            else {
                gg[i].push_back(j);
            }
        }
    }
    color.resize(n,0);
    for (int i=0;i<n;i++) if (color[i]==0) DDD(i,-1);
    for (int i=0;i<n;i++) if (color[i]==-1) FILL(i,-1);
    for (int i=0;i<n;i++) {
        if(color[i]==-1) cout<<"1";
        else cout<<"0";
    }
}