// Created by rost on 29.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

struct R {
    int x, y;
    int i;
};

inline ll dist2(const R &a, const R &b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return 1ll * dx * dx + 1ll * dy * dy;
}

const int MAX_N = 1e5;

int n, r;
int res[MAX_N];
R pt[MAX_N];
// vector<int> graph[MAX_N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    // vector<R> pt(n);
    for (int i = 0; i < n; ++i)
        cin >> pt[i].x >> pt[i].y;
    sort(pt, pt + n, [](const R &a, const R &b) {
        return a.x < b.x;
    });

    queue<int> q;
    for (int i = 1; i + 1 < n; ++i) {
        if (pt[i + 1].x - pt[i - 1].x <= r) {
            res[pt[i].i] = 1;
            q.emplace(i);
        }
    }
    while (!q.empty()) {
        int j = q.front();
        q.pop();

        if (j != 0 && res[pt[j - 1].i] == 0) {
            res[pt[j - 1].i] = 1;
            q.push(j - 1);
        }
        if (j != n - 1 && res[pt[j + 1].i] == 0) {
            res[pt[j + 1].i] = 1;
            q.push(j + 1);
        }
    }
    for (int i = 0; i < n; ++i)
        cout << res[i];
    cout << '\n';
}
