#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct segtree {
    vector <int> t;

    void upd(int p, int l, int r, int pos) {
        if (r - l == 1) {
            t[p]++;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m)
            upd(2 * p, l, m, pos);
        else
            upd(2 * p + 1, m, r, pos);
        t[p] = t[2 * p] + t[2 * p + 1];
    }

    int get(int p, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq)
            return 0;
        if (lq <= l && r <= rq)
            return t[p];
        int m = (l + r) / 2;
        return get(2 * p, l, m, lq, rq) + get(2 * p + 1, m, r, lq, rq);
    }
};

const int inf = 1e9;

int main() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n + 1);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector <vector <int>> ans(n + 1, {inf});
    for (int mask = 0; mask < (1 << n); mask++) {
        int k = __builtin_popcount(mask) + ((mask & (1 << (n - 1))) ? 0 : 1);
        vector <int> curr;
        int mx = 0;
        for (int i = 0; i < n; i++) {
            mx = max(mx, a[i]);
            if (mask & (1 << i)) {
                curr.push_back(mx);
                mx = 0;
            }
        }
        if (curr.size() < k)
            curr.push_back(mx);
        ans[k] = min(ans[k], curr);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k][i - 1] << '\n';
    }
}