#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector <short> g[10'001];

ll dist2(pair <ll, ll> a, pair <ll, ll> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector <bool> cycle(10'001);
vector <char> color(10'001);

bool has_cycle = false;

vector <int> path;
void dfs(int v, int c) {
    path.push_back(v);
    color[v] = c;
    for (auto u : g[v])
        if (color[u] == color[v]) {
            has_cycle = true;
        } else if (!color[u]) {
            dfs(u, (c == 1 ? 2 : 1));
        }
}


int main() {
    ll n, r;
    cin >> n >> r;
    vector <int> a(n);
    for (auto &x : a) {
        int y;
        cin >> x >> y;
    }
    vector <int> pos(n);
    iota(pos.begin(), pos.end(), 0);
    sort(pos.begin(), pos.end(), [&](int i, int j) {
       return a[i] < a[j];
    });
    bool can = false;
    vector <bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (i > 0 && a[pos[i]] - a[pos[i - 1]] > r)
            can = false;
        if (i > 1) {
            if (a[pos[i]] - a[pos[i - 2]] <= r)
                can = true;
        }
        if (can)
            ans[pos[i]] = true;
    }
    can = false;
    for (int i = n - 1; i >= 0; i--) {
        if (i < n - 1 && a[pos[i + 1]] - a[pos[i]] > r)
            can = false;
        if (i < n - 2) {
            if (a[pos[i + 2]] - a[pos[i]] <= r)
                can = true;
        }
        if (can)
            ans[pos[i]] = true;
    }
    for (int i = 0; i < n; i++)
        if (ans[i])
            cout << 1;
        else
            cout << 0;
}