#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(T a) {cerr << a;}
template<typename T>
void _print(vector<T> a) {
    cerr << "[";
    int f = 0;
    for (auto v : a) {
        if (f++)cerr << ", ";
        _print(v);
    }
    cerr << "]";
}
#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n'
#else
#define debug(x)
#endif


void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    bool flagg = true;
    for (int i = 0; i < n; ++i) {
        char c; cin >> c;
        a[i] = c - '0';
        if (a[i])flagg = false;
    }
    if (flagg) {
        while (q--) {
            int k; cin >> k;
            cout << k - (k == 1) << '\n';
        }
        return;
    }
    int now = 0;
    vector<int> zero;
    for (int i = 0; i < n; ++i) {
        if (!a[i])now++;
        else {
            if (now)zero.push_back(now);
            now = 0;
        }
    }
    if (now)zero.push_back(now);
    vector<int> one;
    now = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i])now++;
        else {
            if (now)one.push_back(now);
            now = 0;
        }
    }
    if (now)one.push_back(now);
    debug(zero);
    debug(one);
    ll ans = 0;
    bool flag = true;
    if (a[0])flag = false;
    int i = 0, j = 0;
    vector<int> val;
    while (i < (int)zero.size() || j < (int)one.size()) {
        if (flag && i < (int)zero.size()) {
            for (int k = 0; k < zero[i]; ++k)val.push_back(0);
            ++i;
            flag = !flag;
        } else {
            if (one[j] > 1)ans += one[j];
            else {
                val.push_back(1);
            }
            ++j;
            flag = !flag;
        }
    }
    debug(val);
    debug(ans);
    now = 0;
    zero.clear();
    zero.push_back(0);
    for (int i = 0; i < n; ++i) {
        if (!a[i])now++;
        else {
            if (now)zero.push_back(now);
            now = 0;
        }
    }
    if (now)zero.push_back(now);
    vector<int> c = {0};
    c.push_back(zero[1] + 2);
    if (val[0] == 0)c.back()--;
    for (i = 2; i < (int)zero.size(); ++i)c.push_back(zero[i] + 2);
    if (val.back() == 0)c.back()--;
    ll sum = 0;
    for (auto v : zero)sum += v;
    debug(zero);
    debug(c);

    vector<vector<ll>> dp(zero.size(), vector<ll> (sum + 1, INT_MIN));
    dp[0][0] = 0;
    dp[1][zero[1]] = c[1];
    dp[1][0] = 0;
    for (i = 2; i < (int)zero.size(); ++i) {
        for (int w = 0; w <= sum; ++w) {
            dp[i][w] = dp[i - 1][w];
            if (w >= zero[i]) {
                dp[i][w] = max(dp[i][w], dp[i - 1][w - zero[i]] + c[i] - 1);
                dp[i][w] = max(dp[i][w], dp[i - 2][w - zero[i]] + c[i]);
            }
        }
    }
    for (int w = 0; w <= sum; ++w) {
        for (int l = w - 1; l >= 0; --l) {
            int add = (w == 1);
            dp.back()[w] = max(dp.back()[w], dp.back()[l] + (w - l) + add);
        }
    }
    while (q--) {
        int k; cin >> k;
        cout << ans + dp.back()[k] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    solve();
}