#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(T a) {cerr << a;}
template<typename T>
void _print(vector<T> a) {
    cerr << "[";
    int f = 0;
    for (auto v : a) {
        if (f++)cerr << ", ";
        _print(v);
    }
    cerr << "]";
}
#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n'
#else
#define debug(x)
#endif
const int maxn = 100'000;
vector<int> g[maxn];
struct pnt {
    ld x, y;
};
ld dist(pnt a, pnt b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}



void solve() {
    ll n, r; cin >> n >> r;
    vector<pair<ll, int>> a(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        a[i] = {x, i};
    }
    sort(a.begin(), a.end());
    debug(a);

    vector<vector<pair<int, int>>> d = {{}};
    int j = 0;
    for (int i = 0; i < n; ++i) {
        d[j].push_back(a[i]);
        if (i < n - 1 && (a[i + 1].first - a[i].first > r)) {
            d.push_back({});
            j++;
        }
    }
    int m = (int)d.size();
    debug(m);
    vector<int> col(n);
    int i = 0;
    for (auto v : d) {
        for (auto to : v) {
            col[to.second] = i;
        }
        ++i;
    }
    debug(col);
    i = 0;
    vector<int> ans(m);
    for (auto vec : d) {
        vector<int> cord;
        for (auto v : vec) {
            auto [x, ind] = v;
            auto it = lower_bound(cord.begin(), cord.end(), x - r);
            if (it != cord.end()) {
                int j = it - cord.begin();
                if (j != (int)cord.size() - 1)ans[i] = true;
            }
            cord.push_back(x);
        }
        i++;
    }
    for (i = 0; i < n; ++i) {
        cout << ans[col[i]];
    }

}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    solve();
}