#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(T a) {cerr << a;}
template<typename T>
void _print(vector<T> a) {
    cerr << "[";
    int f = 0;
    for (auto v : a) {
        if (f++)cerr << ", ";
        _print(v);
    }
    cerr << "]";
}
#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n'
#else
#define debug(x)
#endif
const int maxn = 100'000;
#define int long long
vector<int> g[maxn];
struct pnt {
    ld x, y;
};
ld dist(pnt a, pnt b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

void dfs(int v, vector<bool> &used, bool &flag, vector<int> &s, int start, int p = -1) {
    used[v] = true;
    s[v] = start;
    for (auto to : g[v]) {
        if (to == p)continue;
        if (used[to]) {
            flag = true;
        } else {
            dfs(to, used, flag, s, start, v);
        }
    }
}

void solve() {
    ld n, r; cin >> n >> r;
    vector<pnt> a(n);
    for (auto &[x, y] : a)cin >> x >> y;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dist(a[i], a[j]) <= r) {
                debug(i);
                debug(j);
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(n);
    vector<bool> used(n);
    vector<int> s(n);
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            ans[i] = ans[s[i]];
            continue;
        }
        bool flag = false;
        dfs(i, used, flag, s, i);
        ans[i] = flag;
    }
    for (int i = 0; i < n; ++i)cout << ans[i];
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    solve();
}