#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;

// #define ll __int128

map<ll, vector<ll> > g;
map<ll, bool > used;
map<ll, bool> fl;
map<ll, vector<int> > d;

void dfs(ll v) {
    used[v] = true;
    fl[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

void solve() {
    int n;
    int rr;
    cin >> n >> rr;

    ll r = rr;

    if (r == 1) {
        for (int i = 0; i < n; ++i) {
            cout << 0;
        }
        return;
    }

    ll b = r / 2;
    ll ko = 1e9;
    ll sz = 100;

    vector<pair<ll, ll> > ps;
    for (int i = 0; i < n; ++i) {
        int xx, yy;
        cin >> xx >> yy;
        ll x = xx, y = yy;
        ps.emplace_back(x, y);
        d[(y / b) * ko + (x / b)].push_back(i);
    }

    vector<bool> res(n);
    vector<pair<ll, ll> > per = {};
    for (int i = -4; i <= 4; ++i) {
        for (int j = -4; j <= 4; ++j) {
            if (i != 0 || j != 0) {
                per.emplace_back(i, j);
            }
        }
    }
    for (auto &[nu, v] : d) {
        if (v.size() >= 3) {
            fl[nu] = true;
            continue;
        }

        vector<vector<int> > ss;

        for (auto cup : v) {
            auto [x, y] = ps[cup];
            vector<int> sos1;
            for (auto i : per) {
                ll nn = nu + i.first + ko * i.second;
                if (d.find(nn) != d.end()) {
                    auto &vv = d[nn];
                    for (int j = 0; j < vv.size() && sos1.size() < sz; ++j) {
                        ll dx = (ps[vv[j]].first - x);
                        ll dy = (ps[vv[j]].second - y);
                        if (dx * dx + dy * dy <= r * r) {
                            sos1.push_back(vv[j]);
                        }
                    }
                }

                if (sos1.size() >= sz) {
                    fl[nu] = true;
                    break;
                }
            }

            if (fl[nu]) {
                break;
            }

            ss.push_back(sos1);
        }

        unordered_set<int> se;

        if (!fl[nu]) {
            if (v.size() == 2) {
                for (auto i : ss[0]) {
                    se.insert(i);
                }
                for (auto i : ss[1]) {
                    if (se.contains(i)) {
                        fl[nu] = true;
                        break;
                    }
                    ss[0].push_back(i);
                }
            }

            if (ss[0].size() >= sz) {
                fl[nu] = true;
            }

            for (int i = 0; i < ss[0].size(); ++i) {
                if (fl[nu]) {
                    break;
                }
                auto [x1, y1] = ps[ss[0][i]];
                for (int j = i + 1; j < ss[0].size(); ++j) {
                    auto [x2, y2] = ps[ss[0][j]];
                    ll dx = x1 - x2;
                    ll dy = y1 - y2;
                    if (dx * dx + dy * dy <= r * r) {
                        fl[nu] = true;
                        break;
                    }
                }
            }
        }
    }



    for (auto &[nu, v] : d) {
        if (fl[nu]) {
            continue;
        }

        for (auto cup : v) {
            auto [x, y] = ps[cup];
            for (auto [fst, snd] : per) {
                ll nn = nu + fst + ko * snd;
                if (d.find(nn) != d.end()) {
                    auto &vv = d[nn];
                    for (int j : vv) {
                        ll dx = (ps[j].first - x);
                        ll dy = (ps[j].second - y);
                        if (dx * dx + dy * dy <= r * r) {
                            g[nu].push_back(nn);
                            g[nn].push_back(nu);
                            break;
                        }
                    }
                }
            }
        }
    }

    for (auto &[nu, v] : d) {
        if (fl[nu] && !used[nu]) {
            dfs(nu);
        }
    }

    for (auto &[nu, v] : d) {
        if (fl[nu]) {
            for (auto i : v) {
                res[i] = true;
            }
        }
    }

    for (auto i : res) {
        if (i) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int tt = 1;
    // cin >> tt;

    while (tt--) {
        solve();
    }
}
