#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

// #define ll __int128

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const int R = (1 << 3);

pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
    if (a.first < b.first) {
        return a;
    } else {
        return b;
    }
}
pair<int, int> t[2 * R];
void build() {
    for (int i = R - 1; i; --i) {
        t[i] = merge(t[i * 2], t[i * 2 + 1]);
    }
}

pair<int, int> calc(int ql, int qr, int v = 1, int vl = 0, int vr = R) {
    if (vl >= qr || vr <= ql) {
        return {inf, -1};
    }

    if (vl >= ql && vr <= qr) {
        return t[v];
    }

    int vm = (vl + vr) / 2;

    return merge(calc(ql, qr, v * 2, vl, vm), calc(ql, qr, v * 2 + 1, vm, vr));
}

vector<int> solve(int n, int q, vector<int> a, vector<pair<int, int> > ki) {
    vector<vector<int> > res(n + 1);
    for (int i = 0; i < n; ++i) {
        t[i + R] = {a[i], i};
    }
    build();

    vector<int> ne(n, -1);
    vector<int> st;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[i] > a[st.back()]) {
            st.pop_back();
        }

        if (!st.empty()) {
            ne[i] = st.back();
        }
        st.push_back(i);
    }

    vector<int> su(n);
    su[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        su[i] = max(a[i], su[i + 1]);
    }


    vector<int> ans;
    for (int u = 0; u < q; ++u) {
        auto [k, ind] = ki[u];
        res[k].clear();

        if (k == 1) {
            ans.push_back(n);
            continue;
        }

        if (k <= 3) {
            int la = 0;
            for (int i = 0; i < k - 2; ++i) {
                auto [mi, ami] = calc(la + 1, min(n - (k - i - 1) + 1, ne[la] + 1));
                res[k].push_back(a[la]);
                la = ami;
            }
            res[k].push_back(a[la]);

            if (ne[la] == -1) {
                res[k].push_back(a.back());
            } else {
                res[k].push_back(su[ne[la]]);
            }


            ans.push_back(res[k][ind - 1]);
        } else {
            int la = 0;
            for (int i = 0; i < ind; ++i) {
                auto [mi, ami] = calc(la + 1, min(n - (k - i - 1) + 1, ne[la] + 1));
                res[k].push_back(a[la]);
                la = ami;
            }
            res[k].push_back(a[la]);
        }
    }

    return ans;
}

mt19937 rnd(124);

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int tt = 1;
    // cin >> tt;

    while (tt--) {
        int n, q;
        cin >> n >> q;
        vector<int> a(n);
        for (auto &i : a) {
            cin >> i;
        }

        vector<pair<int, int> > ki;
        for (int i = 0; i < q; ++i) {
            int k, ind;
            cin >> k >> ind;
            ki.emplace_back(k, ind);
        }

        auto r = solve(n, q, a, ki);
        for (auto i : r) {
            cout << i << '\n';
        }
    }

    // int n = 10;
    // vector<int> a;
    // for (int i = 0; i < n; ++i) {
    //     a.push_back(i + 1);
    // }
    // while (true) {
    //     shuffle(a.begin(), a.end(), rnd);
    //     int q = 2;
    //     vector<pair<int, int> > ki;
    //     ki.emplace_back(2, 1);
    //     ki.emplace_back(2, 2);
    //     auto r = solve(n, q, a, ki);
    //     int f = a[0];
    //     int s;
    //
    //     for (int i = 1; i < n; ++i) {
    //         if (a)
    //     }
    //
    // }
}