#include <bits/stdc++.h>

using namespace std;
const int inf = 1e9;
using ll = long long;
const ll infll = 1e18;

vector<int> f;
int n;

void add(int i) {
    for (i; i <= n; i += (i&-i)) {
        f[i]++;
    }
}

int sum(int i) {
    int res = 0;
    for (i; i > 0; i -= (i & -i)) {
        res += f[i];
    }
    return res;
}

ll inv(vector<int> &a) {
    n = a.size();
    f.clear();
    f.resize(n + 1);
    vector<int> xs;
    for (auto x : a) {
        xs.push_back(x);
    }
    sort(xs.begin(), xs.end());
    for (auto &x : a) {
        x = (lower_bound(xs.begin(), xs.end(), x) - xs.begin()) + 1;
    }
    ll res = 0;
    for (int i = n - 1; i >= 0; --i) {
        res += sum(a[i]);
        add(a[i]);
    }
    return res;
}

vector<vector<int>> a;
vector<int> b;
ll r,c;
ll ans = infll;
vector<vector<bool>> used;

void rec() {
    if (b.size() == r * c) {
        ans = min(ans, inv(b));
        return;
    }
    for (int i = 0; i < r; ++i) {
        int cnt = 0;
        for (int j = 0; j < c; ++j) {
            if (!used[i][j]) {
                cnt++;
            }
        }
        if (cnt != 0) {
            vector<int> pos;
            for (int j = 0; j < c; ++j) {
                if (!used[i][j]) {
                    b.push_back(a[i][j]);
                    used[i][j] = true;
                    pos.push_back(j);
                }
            }
            rec();
            for (auto j : pos) {
                b.pop_back();
                used[i][j] = false;
            }
            break;
        }
    }
    for (int j = 0; j < c; ++j) {
        int cnt = 0;
        for (int i = 0; i < r; ++i) {
            if (!used[i][j]) {
                cnt++;
            }
        }
        if (cnt != 0) {
            vector<int> pos;
            for (int i = 0; i < r; ++i) {
                if (!used[i][j]) {
                    b.push_back(a[i][j]);
                    used[i][j] = true;
                    pos.push_back(i);
                }
            }
            rec();
            for (auto i : pos) {
                b.pop_back();
                used[i][j] = false;
            }
            break;
        }
    }
}

void solve() {
    cin >> r >> c;
    a.resize(r, vector<int> (c));
    used.resize(r, vector<bool> (c));
    for (auto &v: a) {
        for (auto &x: v) {
            cin >> x;
        }
    }
    rec();
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
