#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<numeric>
#include<functional>
#include<cstdint>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define print(a, s) for(auto now : a) cout << now << s;
#define cin(a) for(auto &now : a) cin >> now;
#define pii pair<int, int>
#define chmin(a, b) a=min(a, b)
#define chmax(a, b) a=max(a, b)
#define db double
#define inf 1000000000000000000

void add(int k, int x, vector<int>& a) {
	for (; k < a.size(); k += k & -k) a[k] += x;
}
int getpr(int k, const vector<int>& a) {
	int res = 0;
	for (; k > 0; k -= k & -k) res += a[k];
	return res;
}
int get(int l, int r, const vector<int>& a) {
	return getpr(r, a) - getpr(l - 1, a);
}
void solve() {
	int n, m; cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m)), inv(n, vector<int>(m + 1)), inv2(m, vector<int>(n + 1));
	for (int i = 0; i < n; ++i) {
		cin(a[i]);
		vector<int> b = a[i]; sort(all(b)); b.resize(unique(all(b)) - b.begin());
		vector<int> cnt(m);
		for (int j = m - 1; j >= 0; --j) {
			int ci = lower_bound(all(b), a[i][j]) - b.begin(); ++ci;
			inv[i][j] += inv[i][j + 1];
			inv[i][j] += getpr(ci - 1, cnt);
			add(ci, 1, cnt);
		}
	}
	cout << inv[0][0]; return;
	for (int i = 0; i < m; ++i) {
		vector<int> b(n);
		for (int j = 0; j < n; ++j) b[j] = a[j][i];
		sort(all(b)); b.resize(unique(all(b)) - b.begin());
		
		vector<int> cnt(n);
		for (int j = n - 1; j >= 0; --j) {
			int ci = lower_bound(all(b), a[j][i]) - b.begin(); ++ci;
			inv2[i][j] = inv2[i][j + 1];
			inv2[i][j] += getpr(ci - 1, cnt);
			add(ci, 1, cnt);
		}
	}
	vector<vector<int>> dp(n + 1, vector<int>(m + 1, inf));
	dp[0][0] = 0;
	int ans = inf;
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= m; ++j) {

			if (i < n) {
				vector<int> v(m - j);
				for (int k = j; k < m; ++k) v[k - j] = a[i][k];
				sort(all(v));
				int dpi = inv[i][j];
				for (int ii = 0; ii < i; ++ii) {
					for (int jj = 0; jj < m; ++jj) {
						dpi += lower_bound(all(v), a[ii][jj]) - v.begin();
					}
				}
				for (int ii = i; ii < n; ++ii) {
					for (int jj = 0; jj < j; ++jj) {
						dpi += lower_bound(all(v), a[ii][jj]) - v.begin();
					}
				}
				chmin(dp[i + 1][j], dp[i][j] + dpi);
			}
			if (j < m) {
				vector<int> v(n - i);
				for (int k = i; k < n; ++k) v[k - i] = a[k][j];
				sort(all(v));
				int dpi = inv2[j][i];
				for (int ii = 0; ii < i; ++ii) {
					for (int jj = 0; jj < m; ++jj) {
						dpi += lower_bound(all(v), a[ii][jj]) - v.begin();
					}
				}
				for (int ii = i; ii < n; ++ii) {
					for (int jj = 0; jj < j; ++jj) {
						dpi += lower_bound(all(v), a[ii][jj]) - v.begin();
					}
				}
				chmin(dp[i][j + 1], dp[i][j] + dpi);
			}
			if (i == n || j == m) chmin(ans, dp[i][j]);
		}
		
	}
	cout << ans;
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}