#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<numeric>
#include<functional>
#include<cstdint>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define print(a, s) for(auto now : a) cout << now << s;
#define cin(a) for(auto &now : a) cin >> now;
#define pii pair<int, int>
#define chmin(a, b) a=min(a, b)
#define chmax(a, b) a=max(a, b)
#define db double
#define inf 1000000000000000000

void add(int k, int x, vector<int> & a) {
	for (; k < a.size(); k += k & -k) a[k] += x;
}
int getpr(int k, const vector<int>& a) {
	int res = 0;
	for (; k > 0; k -= k & -k) res += a[k];
	return res;
}
int get(int l, int r, const vector<int>& a) {
	return getpr(r, a) - getpr(l - 1, a);
}
int inversions(const vector<int>& a) {
	vector<int> cnt(a.size() + 1);
	int res = 0;
	for (int i = a.size() - 1; i >= 0; --i) {
		res += getpr(a[i] - 1, cnt);
		add(a[i], 1, cnt);
	}
	return res;
}
void solve() {
	int n, m; cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	vector<int> v;
	vector<int> cnt(n * m + 1), cnt2(n * m + 1);
	int inv = 0;
	for (int i = 0; i < n; ++i) {
		cin(a[i]);
		for (int j = 0; j < m; ++j) {
			v.push_back(a[i][j]);
			inv += get(a[i][j] + 1, n * m, cnt);
			add(a[i][j], 1, cnt);
			if (i == 0 && j > 0) add(a[i][j], 1, cnt2);
		}
	}
	int ans = inv;
	if (n == 1) {
		cout << inv; return;
	}
	for (int i = 0; i + 1 < m; ++i) {
		inv -= get(v[m + i] + 1, n * m, cnt2);
		inv += getpr(v[m + i] - 1, cnt2);
		add(v[i + 1], -1, cnt2);
		chmin(ans, inv);
	}
	cout << ans;
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}