#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m));
    for (auto &el : a) {
        for (auto &x : el) {
            cin >> x;
            --x;
        }
    }

    vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, INF));
    dp[0][0] = 0;
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= m; j++) {
            if (i == 0 && j == 0) continue;

            if (i) {
                vector<ll> us(n * m);
                for (ll ni = 0; ni < n; ni++) {
                    for (ll nj = 0; nj < m; nj++) {
                        if (ni < i - 1 || nj < j) {
                            us[a[ni][nj]] = 1;
                        }
                    }
                }

                ll cn = 0;
                for (ll nj = j; nj < m; nj++) {
                    ll el = a[i - 1][nj];
                    for (ll x = el + 1; x < n * m; x++) {
                        cn += us[x];
                    }
                    us[el]++;
                }

                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cn);
            }
            if (j) {
                vector<ll> us(n * m);
                for (ll ni = 0; ni < n; ni++) {
                    for (ll nj = 0; nj < m; nj++) {
                        if (ni < i || nj < j - 1) {
                            us[a[ni][nj]] = 1;
                        }
                    }
                }

                ll cn = 0;
                for (ll ni = i; ni < n; ni++) {
                    ll el = a[ni][j - 1];
                    for (ll x = el + 1; x < n * m; x++) {
                        cn += us[x];
                    }
                    us[el]++;
                }

                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cn);
            }
        }
    }

    ll mn = INF;
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= m; j++) {
            if (j == m || i == n) {
                mn = min(mn, dp[i][j]);
            }
        }
    }
    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
