#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }

    vector<vector<ll>> rs(n + 1, {INF});
    for (ll ms = 0; ms < (1ll << (n - 1)); ms++) {
        ll id = (ll)__builtin_popcount(ms) + 1;
        vector<ll> cr = {0};
        for (ll i = 0; i < n; i++) {
            cr.back() = max(cr.back(), a[i]);
            if ((ms >> i) & 1) {
                cr.push_back(0);
            }
        }
        rs[id] = min(rs[id], cr);
    }

    while (q--) {
        ll k, i;
        cin >> k >> i;
        cout << rs[k][i - 1] << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
