#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, k;
    string s;
    cin >> n >> k >> s;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += s[i] - '0';
    }
    if (cnt == 0) {
        for (int i = 0; i < k; ++i) {
            int x; cin >> x;
            cout << (x < 2 ? 0 : x) << '\n';
        }
        return;
    }
    // vector<pair<pair<int, int>, int>> segs;
    // segs.emplace_back({0, 0}, s[0] - '0');
    // for (int i = 0; i < n; ++i) {
    //     if (s[i] - '0' != segs.back().second) {
    //         segs.emplace_back({i, i}, s[i] - '0');
    //     } else {
    //         segs.back().first.second++;
    //     }
    // }
    int start = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1' && ((i != 0 && s[i - 1] == s[i]) || (i != n - 1 && s[i + 1] == s[i]))) {
            start++;
        }
    }
    int bad = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1' && (i == 0 || s[i - 1] == '0') && (i == n - 1 || s[i + 1] == '0')) {
            bad++;
        }
    }
    vector<pair<ll, ll>> qs(k);
    for (int i = 0; i < k; ++i) {
        cin >> qs[i].first;
        qs[i].second = i;
    }
    sort(qs.begin(), qs.end());
    vector<int> ans(k);
    int used = 0, j = 0;
    for (int i = 0; i < k; ++i) {
        int now = qs[i].first - used;
        for (; j + 2 < n && now; ++j) {
            if (s[j] == '1' && (j == 0 || s[j - 1] == '0') && s[j + 1] == '0' && s[j + 2] == '1' && (j + 3 >= n || s[j + 3] == '0')) {
                used++;
                now--;
                s[j + 1] = '1';
                start += 3;
                bad -= 2;
            }
        }
        int will = start + min(bad, now) * 2 + max(0, now - bad);
        ans[qs[i].second] = min(will, n);
    }
    for (int i = 0; i < k; ++i) {
        cout << ans[i] << '\n';
     }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

