#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>

using namespace std;
typedef long long ll;

const int maxn = 1e5;
ll x[maxn], y[maxn], us[maxn], fl[maxn], cr[maxn];
vector<int> g[maxn];
map<pair<int, int>, vector<int>> mp;

void dfs(int v, int cl, int crc) {
	us[v] = cl;
	cr[v] = crc;
	for (auto u : g[v]) {
		if (!us[u]) {
			dfs(u, 3 - cl, crc);
		}
		else if (us[v] == us[u]) {
			fl[crc] = 1;
		}
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n, r;
	cin >> n >> r;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
		mp[{(x[i] * 2) / r, (y[i] * 2) / r}].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		int xx = x[i] * 2 / r;
		int yy = y[i] * 2 / r;
		for (int dx = 0; dx <= 2; ++dx) {
			for (int dy = 0; dy <= 2; ++dy) {
				if (mp[{xx, yy}].size() >= 3 && mp[{xx + dx, yy + dy}].size() >= 3 && (dx != 0 || dy != 0)) {
					continue;
				}
				int cn = 0;
				for (auto j : mp[{xx + dx, yy + dy}]) {
					if (i != j && (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
						g[i].push_back(j);
						++cn;
					}
					if (cn == 2) {
						break;
					}
				}
			}
		}
	}
	int pp = 0;
	for (int i = 0; i < n; ++i) {
		if (!us[i]) {
			dfs(i, 1, pp);
			++pp;
		}
		cout << fl[cr[i]];
	}

	return 0;
}