#include <bits/stdc++.h>
using namespace std;
#define int long long

struct ST {
    int sz = 1;
    vector<pair<int, int>> tr;
    ST(vector<int> & arr) {
        while (sz < (int)arr.size() + 1) sz *= 2;
        tr.assign(sz * 2, make_pair(1e9, 1e9));
        for (int i = 0; i < (int)arr.size(); ++i) {
            tr[i + sz] = {arr[i], i};
        }
        for (int i = sz - 1; i >= 1; --i) {
            tr[i] = min(tr[i * 2], tr[i * 2 + 1]);
        }
    }
    pair<int, int> get(int v, int cl, int cr, int l, int r) {
        if (l <= cl && cr <= r) {
            return tr[v];
        } else if (cr <= l || cl >= r) {
            return {1e9, 1e9};
        }
        int cm = (cl + cr) / 2;
        return min(get(v * 2, cl, cm, l, r), get(v * 2 + 1, cm, cr, l, r));
    }
};
struct STA {
    int sz = 1;
    vector<pair<int, int>> tr;
    STA(vector<int> & arr) {
        while (sz < (int)arr.size() + 1) sz *= 2;
        tr.assign(sz * 2, make_pair(-1, -1));
        for (int i = 0; i < (int)arr.size(); ++i) {
            tr[i + sz] = {arr[i], i};
        }
        for (int i = sz - 1; i >= 1; --i) {
            tr[i] = max(tr[i * 2], tr[i * 2 + 1]);
        }
    }
    pair<int, int> get(int v, int cl, int cr, int l, int r) {
        if (l <= cl && cr <= r) {
            return tr[v];
        } else if (cr <= l || cl >= r) {
            return {-1, -1};
        }
        int cm = (cl + cr) / 2;
        return max(get(v * 2, cl, cm, l, r), get(v * 2 + 1, cm, cr, l, r));
    }
};

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q; cin >> n >> q;
    vector<int> arr(n);
    for (auto & it : arr) cin >> it;
    vector<vector<int>> mem(n + 10);
    ST st(arr);
    STA sta(arr);

    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (sta.get(1, 0, sta.sz, i, m + 1).first > arr[i]) {
                r = m;
            } else {
                l = m;
            }
        }
        nxt[i] = l + 1;
    }

    for (int it = 0; it < q; ++it) {
        int k, i; cin >> k >> i;
        vector<int> ans;
        int cur = 0;
        while (k) {
            if ((int)ans.size() >= i) break;
            if (k == 1) {
                ans.push_back(sta.get(1, 0, sta.sz, cur, sta.sz).first);
                --k;
            } else if (k == 2) {
                int r = min(nxt[cur], n - 1);
                ans.push_back(sta.get(1, 0, sta.sz, cur, r).first);
                cur = r;
                --k;
            } else {
                int r = st.get(1, 0, st.sz, cur + 1, min(nxt[cur] + 1, n - k + 2)).second;
                ans.push_back(sta.get(1, 0, sta.sz, cur, r).first);
                cur = r;
                --k;
            }
        }
        cout << ans[i - 1] << "\n";
    }
    return 0;
}

/*



9 2
1 2 3 4 9 8 7 6 5
2 1
2 2

10 1
10 3 5 1 6 9 8 4 2 7
2 2



*/
