#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using ti = tuple<int, int, int>;

constexpr int N = 300000;
int arr[N];

void solve()
{
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
    }

    vector<int> pref(n);
    pref[0] = arr[0];
    for (int i = 1; i < n; ++i)
    {
        pref[i] = max(arr[i], pref[i - 1]);
    }

    vector<int> suf(n);
    suf[n - 1] = arr[n - 1];
    for (int i = n - 2; i >= 0; --i)
    {
        suf[i] = max(suf[i + 1], arr[i]);
    }

    vector<int> left_greater(n, -1);
    vector<int> right_greater(n, -1);

    vector<int> st;

    for (int i = 0; i < n; ++i)
    {
        while (!st.empty() && arr[i] > arr[st.back()])
        {
            right_greater[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();

    for (int i = n - 1; i >= 0; --i)
    {
        while (!st.empty() && arr[i] > arr[st.back()])
        {
            left_greater[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();

    ti ans = {INT_MAX, INT_MAX, INT_MAX};

    for (int i = 1; i < n - 1; ++i)
    {
        int x = left_greater[i] == -1 ? 0 : left_greater[i];
        int y = right_greater[i] == -1 ? n - 1 : right_greater[i];
        ti var = {pref[x], arr[i], suf[y]};
        ans = min(ans, var);
    }

    for (int qq = 0; qq < q; ++qq)
    {
        int k, i;
        cin >> k >> i;
        if (i == 1)
        {
            cout << get<0>(ans) << '\n';
        }
        else if (i == 2)
        {
            cout << get<1>(ans) << '\n';
        }
        else
        {
            cout << get<2>(ans) << '\n';
        }
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}