#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> g;
vector<int> col;
vector<int> ans;
vector<int> used;

struct point{
    long long x, y;
    int ind;
    long long len() {
        return x * x + y * y;
    }
    point operator-(point a) {
        return {x - a.x, y - a.y};
    }
    point operator+(point a) {
        return {x + a.x, y + a.y};
    }
    bool operator<(point a) {
        if (x != a.x) {
            return x < a.x;
        }
        return y < a.y;
    }
};

void dfs(int v, int c) {
    used[v] = 1;
    col[v] = c % 2 + 1;
    for (auto u : g[v]) {
        if (col[u] == col[v]) {
            ans[v] = 1;
            ans[u] = 1;
        }
        if (used[u]) {
            continue;
        }
        dfs(u, c + 1);
    }
}

void dfs2(int v) {
    used[v] = 1;
    ans[v] = 1;
    for (auto u : g[v]) {
        if (used[u])
            continue;
        dfs2(u);
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    long long r;
    cin >> r;
    vector<point> fr(n);
    for (int i = 0; i < n; i++) {
        cin >> fr[i].x >> fr[i].y;
        fr[i].ind = i;
    }
    ans.resize(n, 0);
    col.resize(n, 0);
    g.resize(n);
    used.resize(n, 0);
if (n > 2000) {
    sort(fr.begin(), fr.end());
    map<long long, pair<int, int>> mp;
    for (int i = 0; i < n; i++) {
        if (mp.find(fr[i].x) == mp.end()) {
            mp[fr[i].x] = {i, i};
        } else {
            mp[fr[i].x].second = i;
        }
    }
    for (int i = 0; i < n; i++) {
        for (long long x = fr[i].x - r; x <= fr[i].x + r; x++) {
            if (mp.find(x) == mp.end())
                continue;
            auto[l1, r1] = mp[x];
            while (l1 < r1 - 1) {
                int m = (l1 + r1) / 2;
                if (fr[m].y < fr[i].y - r) {
                    l1 = m;
                } else {
                    r1 = m;
                }
            }
            int l = l1;
            tie(l1, r1) = mp[x];
            while (l1 < r1 - 1) {
                int m = (l1 + r1) / 2;
                if (fr[m].y > fr[i].y + r) {
                    r1 = m;
                } else {
                    l1 = m;
                }
            }
            for (int j = l; j <= r1; j++) {
                if (i == j)
                    continue;
                if ((fr[i] - fr[j]).len() <= r * r) {
                    g[fr[j].ind].push_back(fr[i].ind);
                    g[fr[i].ind].push_back(fr[j].ind);
                }
            }
        }

    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, 1);
        }
    }
    for (int i = 0; i < n; i++) {
        used[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i] && ans[i]) {
            dfs2(i);
        }
    }
    for(int i = 0; i < n; i++) {
        cout << ans[i];
    }
    return 0;
}
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if ((fr[i] - fr[j]).len() <= r * r) {
                g[j].push_back(i);
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, 1);
        }
    }
    for (int i = 0; i < n; i++) {
        used[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i] && ans[i]) {
            dfs2(i);
        }
    }
    for(int i = 0; i < n; i++) {
        cout << ans[i];
    }
    return 0;
}
