#include <bits/stdc++.h>
using namespace std;
using ll = int;

#pragma optimize("unroll-loops")

vector<set<ll>> g;
vector<bool> ans;
vector<int> vis;
bool f = false;

void dfs(ll u, ll p) {
    if (p == -1) {
        vis[u] = 1;
    } else {
        vis[u] = 3 - vis[p];
    }
    for (auto v : g[u]) {
        if (vis[v] == 0) {
            dfs(v, u);
        } else if (vis[v] == vis[u]) {
            f = true;
        }
    }
}

void dfs(ll u) {
    ans[u] = true;
    for (auto v : g[u]) {
        if (!ans[v]) {
            dfs(v);
        }
    }
}

void solve() {
    long long n, r;
    cin >> n >> r;
    ans.resize(n, false);
    g.resize(n);
    vector<pair<ll, ll>> d(n);
    for (ll i = 0; i < n; i++) {
        cin >> d[i].first >> d[i].second;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            long long rast = (long long) (d[i].first - d[j].first) * (d[i].first - d[j].first) + (long long) (d[i].second - d[j].second) * (d[i].second - d[j].second);
            if (rast <= r * r) {
                g[i].insert(j);
                g[j].insert(i);
            }
        }
    }
    vis.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        if (vis[i] == 0) {
            f = false;
            dfs(i, -1);
            if (f) {
                dfs(i);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ans[i]) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}