#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#pragma optimize("unroll-loops")

vector<vector<ll>> g;
vector<bool> ans;
vector<int> vis;
ll last = -1;

bool dfs(ll u, ll p) {
    if (p == -1) {
        vis[u] = 1;
    } else {
        vis[u] = 3 - vis[p];
    }
    bool f = false;
    for (auto v : g[u]) {
        if (vis[v] == 0) {
            if (dfs(v, u)) {
                ans[u] = true;
                f = true;
            }
        } else if (vis[v] == vis[u]) {
            last = v;
            ans[u] = true;
            f = true;
        }
    }
    if (f && u == last) {
        f = false;
        last = -1;
    }
    return f;
}

void solve() {
    ll n, r;
    cin >> n >> r;
    ans.resize(n, false);
    g.resize(n);
    vector<pair<ll, ll>> d(n);
    for (ll i = 0; i < n; i++) {
        cin >> d[i].first >> d[i].second;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            ll rast = (d[i].first - d[j].first) * (d[i].first - d[j].first) + (d[i].second - d[j].second) * (d[i].second - d[j].second);
            if (rast <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vis.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        if (vis[i] == 0) {
            last = -1;
            dfs(i, -1);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ans[i]) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}