#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using ll = long long;
using namespace __gnu_pbds;
using namespace std;
#define int long long

using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<vector<int>>> dp(n, vector<vector<int>> (n + 1, vector<int> ()));
    int mx = 0;
    for (int i = 0; i < n; i++) {
        mx = max(mx, a[i]);
        dp[i][1] = {mx};
    }
    for (int k = 2; k <= n; k++) {
        for (int i = k - 1; i < n; i++) {
            int mx = a[i];
            for (int j = i - 1; j >= k - 2; j--) {
                vector<int> tmp = dp[j][k - 1];
                if (!tmp.empty()) {
                    tmp.push_back(mx);
                    if (dp[i][k].empty() || tmp < dp[i][k]) {
                        dp[i][k] = tmp;
                    }
                }
                mx = max(mx, a[j]);
            }
        }
    }
    while (q--) {
        int i, k;
        cin >> k >> i;
        cout << dp[n - 1][k][i - 1] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.