#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <queue>

using namespace std;

const int INF = 1e9;

typedef long long ll;
typedef short int si;

int f(vector<int> &a){
    int n = a.size(), ans = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < i; j++)
            ans += a[j] > a[i];
    return ans;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for(vector<int> & i : a)
        for(int & j : i)
            cin >> j;
    int mn = INF;
    for(int mask = 0; mask < (1 << (r + c)); mask++){
        int _r = 0, _c = 0;
        vector<int> now;
        for(int i = 0; i < r + c; i++){
            if(((mask >> i) & 1) && _r < r){
                for(int _ci = _c; _ci < c; _ci++)
                    now.push_back({a[_r][_ci]});
                _r++;
            }
            else{
                for (int _ri = _r; _ri < r; _ri++)
                    now.push_back({a[_ri][_c]});
                _c++;
            }
        }
        mn = min(mn, f(now));
    }
    cout << mn;
    return 0;
}