#include <bits/stdc++.h>
#define int long long

using namespace std;

struct point {
    int x, y;

    int dist(point other) {
        return pow(x - other.x, 2) + pow(y - other.y, 2);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, r; cin >> n >> r;

    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;

        a[i] = {x, y};
    }

    for (int v = 0; v < n; ++v) {
        vector<bool> d1(n, false), d2(n, false);
        d1[v] = true;

        queue<pair<int, int>> q; q.emplace(v, 0);
        while (!q.empty()) {
            auto [i, idx] = q.front(); q.pop();

            for (int j = 0; j < n; ++j) {
                if (i == j) continue;

                if (idx % 2 == 0) {
                    if (d2[j]) continue;

                    if (a[i].dist(a[j]) <= r * r) {
                        d2[j] = true;
                        q.emplace(j, idx + 1);
                    }
                } else {
                    if (d1[j]) continue;

                    if (a[i].dist(a[j]) <= r * r) {
                        d1[j] = true;
                        q.emplace(j, idx + 1);
                    }
                }
            }
        }

        if (d2[v]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}