#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct point {
    int x, y;

    ll dist(point other) {
        return pow(x - other.x, 2) + pow(y - other.y, 2);
    }
};

ll r;
bool flag;
vector<int> color, all;
vector<point> a;

void dfs(int v, int col) {
    color[v] = col;
    all.push_back(v);

    col = (col + 1) % 2;
    col = 2 - col;

    for (int u = 0; u < a.size(); ++u) {
        if (u == v || color[u] == col || a[v].dist(a[u]) > r * r) continue;

        if (!color[u]) {
            dfs(u, col);
        } else {
            flag = true;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n >> r;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;

        a[i] = {x, y};
    }

    string ans(n, '0');

    color.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!color[i]) {
            flag = false;

            all.clear();
            dfs(i, 1);

            if (flag) {
                for (int j : all) {
                    ans[j] = '1';
                }
            }
        }
    }

    cout << ans;
}