#include <iostream>
#include <vector>
#include <set>
using namespace std;
using ll = long long;
bool used[10001];
bool color[10001];
vector<int> graph[10001];
bool dfs(int compa, bool clr, int v) {
    if (used[v] and clr != color[v]) {
        return true;
    }else if (used[v] and clr == color[v]) {
        return false;
    }
    used[v] = true;
    color[v] = clr;
    for (auto u: graph[v]) {
        if (dfs(compa, not clr, u)) {
            return true;
        }
    }
    return false;
}
int main() {
    ll n, r, x, y;
    cin >> n >> r;
    vector<pair<int, int>> coords;
    for (int i=0;i<n;i++) {
        cin >> x >> y;
        coords.emplace_back(x, y);
    }
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (1LL*(coords[i].first-coords[j].first)*(coords[i].first-coords[j].first) + 1LL*(coords[i].second-coords[j].second)*(coords[i].second-coords[j].second) <=r*r) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) {
            used[j] = false;
            color[j] = false;
        }
        if (!used[i]) {
            if (dfs(i, false, i)) {
                cout << 1;
            }else {
                cout << 0;
            }
        }
    }
}