#include <iostream>
#include <vector>
#include <cmath>
#include <stack>
#include <algorithm>
using namespace std;



int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    /*
    int r = n - 2;
    for (int i = 1; i < n; i++) {
        if (a[i] > a[0]) {r = i; break;}
    }
    int ans2 = 2000000000;
    int ind2 = -1;
    for (int i = 1; i <= r; i++) {
        if (ans2 > a[i]) {ans2 = a[i], ind2 = i;}
    }
    int r2 = n - 1;
    for (int i = ind2 + 1; i < n; i++) {
        if (a[i] > a[ind2]) {r2 = i; break;}
    }
    int ans3 = -2000000000;
    for (int i = r2; i < n; i++) {
        ans3 = max(ans3, a[i]);
    }
    */
    vector<int> sprava(n, 2000000000);
    stack<pair<int, int>> cur;
    for (int i = 0; i < n; i++) {
        while (!cur.empty() && cur.top().first < a[i]) {
            sprava[cur.top().second] = i;
            cur.pop();
        }
        cur.push({a[i], i});
    }

    vector<vector<pair<int, int>>> query(n + 1);
    vector<int> ans(q);

    for (int i = 0; i < q; i++) {
        int k, ind; cin >> k >> ind;
        query[k].emplace_back(ind, i);
    }

    for (int k = 1; k <= n; k++) {
        if (query[k].empty()) continue;
        vector<int> inds(k);
        inds[0] = 0;
        int r;
        for (int i = 0; i < k; i++) {
            if (i != 0 && i != k - 1) {
                int ans2 = 2000000000;
                int ind2 = -1;
                for (int j = inds[i - 1] + 1; j <= r; j++) {
                    if (ans2 > a[j]) {ans2 = a[j], ind2 = j;}
                }
                inds[i] = ind2;
            }
            else if (i == k - 1) inds[i] = r;
            r = min(n - k + i + 1, sprava[inds[i]]);
        }
        for (auto i : query[k]) {
            if (i.first < k) ans[i.second] = a[inds[i.first - 1]];
            else {
                ans[i.second] = -2000000000;
                for (int j = inds[k - 1]; j < n; j++) {
                    ans[i.second] = max(ans[i.second], a[j]);
                }
            }
        }
    }
    for (auto i : ans) cout << i << endl;



    return 0;
}