#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

using namespace std;
#define int long long

int big(int a, int b, int c, int d) {
    return (a * d > b * c);
}

vector<int> tree;

void build(int x, int lx, int rx, vector<int>& v) {
    if (rx - lx == 1) {
        tree[x] = 1;
        return;
    }
    int m = (rx+lx)/2;
    build(2*x+1, lx, m, v);
    build(2*x+2, m, rx, v);
    tree[x] = tree[2*x+1] + tree[2*x+2];
}

void up(int x, int lx, int rx, int ind) {
    if (rx-lx == 1) {
        tree[x] = 0;
        return;
    }
    int m = (rx+lx) / 2;
    if (m > ind)
        up(2*x+1, lx, m, ind);
    else up(2*x+2, m, rx, ind);
    tree[x]--;
}

int get(int x, int lx, int rx, int l) {
    if (l >= rx) {
        return tree[x];
    }
    if (l <= lx)
        return 0;
    int m = (lx+rx) / 2;
    return get(2*x+1, lx, m , l) + get(2*x+2, m, rx, l);
}

signed main() {
    int n, m; cin >> n >> m;
    vector<vector<int>> mat(n, vector<int> (m));
    for (auto& i: mat) {
        for (auto& j: i)
            cin >> j;
    }
    int h = 0, l = 0;
    vector<int> v;
    for (; h < n- 1 && l < m - 1;) {
        int row = 0, col = 0;
        for (int i = l;i < m; ++i)
            row += mat[h][i];
        for (int i = h;i < n; ++i)
            col += mat[i][l];
        if (big(row, m- l, col, n - h)) {
            for (int i = h; i < n; ++i)
                v.push_back(mat[i][l]);
            l++;
        }
        else {
            for (int i = l; i < m; ++i)
                v.push_back(mat[h][i]);
            h++;
        }
    }
    if (h < n - 1) {
        for (int i = h; i < n; ++i)
            v.push_back(mat[i][l]);
    }
    else{
        for (int i = l; i < m; ++i)
            v.push_back(mat[h][i]);
    }

    tree.resize(4*v.size(),0);
    build(0,0,v.size(), v);
    int ans = 0;
    for (auto & i: v) {
        ans += get(0,0,v.size(), i - 1);
        up(0,0,v.size(), i - 1);
    }
    cout << ans << "\n";
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.