#include <bits/stdc++.h>

using namespace std;

vector<int> cl;
vector<vector<int>> g;

void dfs(int v, int c) {
    cl[v] = c;
    for (auto u : g[v]) {
        if (u == v) continue;
        if (cl[u] == 0) {
            dfs(u, 3 - c);
            if (cl[u] == 3) cl[v] = 3;
        } else if (cl[u] != 3 - c) {
            cl[v] = 3;
        }
    }
}

long long sqr(long long x) {
    long long l = 0, r = 2e9;
    while (r > l + 1) {
        long long m = (r + l) / 2;
        if (m * m > x) r = m;
        else l = m;
    }
    return l;
}

signed main() {
    long long n, r;
    cin >> n >> r;
    vector<tuple<long long, long long, int>> a(n);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        a[i] = {x, y, i};
    }
    sort(a.begin(), a.end());
    map<long long, vector<pair<long long, int>>> ma;
    for (auto [x, y, i] : a) ma[x].push_back({y, i});
    for (int in = 0; in < n; in++) {
        auto [x1, y1, i] = a[in];
        for (int jn = 0; jn < n; jn++) {
            auto [x2, y2, j] = a[jn];
            if ((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1) <= r * r) g[i].push_back(j);
        }
    }
    cl.resize(n);
    for (int in = 0; in < n; in++) {
        auto [x, y, i] = a[in];
        if (g[i].size() > 6) cl[i] = 3;
    }
    for (int in = 0; in < n; in++) {
        auto [x, y, i] = a[in];
        if (cl[i] == 0) dfs(i, 1);
    }
    vector<int> ans(n);
    for (int in = 0; in < n; in++) {
        auto [x, y, i] = a[in];
        if (cl[i] == 3) ans[i] = 1;
        else ans[i] = 0;
    }
    for (auto x : ans) cout << x;
}