#include <bits/stdc++.h>

using namespace std;

vector<int> cl;
vector<vector<int>> g;

void dfs(int v, int c) {
    cl[v] = c;
    for (auto u : g[v]) {
        if (u == v) continue;
        if (cl[u] == 0) {
            dfs(u, 3 - c);
            if (cl[u] == 3) cl[v] = 3;
        } else if (cl[u] != 3 - c) {
            cl[v] = 3;
        }
    }
}

signed main() {
    long long n, r;
    cin >> n >> r;
    vector<pair<long long, long long>> a(n);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    for (int i = 0; i < n; i++) {
        auto [x1, y1] = a[i];
        for (int j = 0; j < n; j++) {
            auto [x2, y2] = a[j];
            if ((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1) <= r * r) g[i].push_back(j);
        }
    }
    cl.resize(n);
    for (int i = 0; i < n; i++) {
        if (g[i].size() >= 6) cl[i] = 3;
    }
    for (int i = 0; i < n; i++) {
        if (cl[i] == 0) dfs(i, 1);
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (cl[i] == 3) ans[i] = 1;
        else ans[i] = 0;
    }
    for (auto x : ans) cout << x;
}