#include <bits/stdc++.h>

using namespace std;
#define int long long

struct Point {
    int x, y;
    Point() = default;
    Point(int x, int y): x(x), y(y) {}
};

int len(Point a, Point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector <vector <int>> g;
vector <vector <int>> cmp;
vector <int> used;
vector <int> cmps;
vector <int> flag;
vector <int> col;

void dfs1(int v) {
    used[v] = true;
    cmps[v] = cmp.size() - 1;
    cmp.back().push_back(v);
    for (auto u : g[v]) {
        if (!used[u]) dfs1(u);
    }
}

void dfs2(int v, int c) {
    used[v] = true;
    col[v] = c;
    for (auto u : g[v]) {
        if (!flag[cmps[v]]) break;
        if (used[u] && col[u] == c) {flag[cmps[v]] = false; break;}
        if (!used[u]) dfs2(u, 1 - c);
    }
}

signed main() {
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    int r;
    cin >> r;
    vector <Point> p(n);
    for (int i = 0; i < n; ++i) cin >> p[i].x >> p[i].y;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (len(p[i], p[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.resize(n, 0);
    cmps.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cmp.push_back({});
            dfs1(i);
        }
    }
    for (int i = 0; i < n; ++i) used[i] = false;
    flag.resize(cmp.size(), true);
    col.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs2(i, 0);
    }
    for (int i = 0; i < n; ++i) {
        flag[cmps[i]] ? cout << 0 : cout << 1;
    }
}