#include <bits/stdc++.h>

using namespace std;

long long sqdist(pair<long long, long long> a, pair<long long, long long> b) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

struct hashh {
    size_t operator()(pair<long long, long long> x) const {
        return x.first * 738947802 + x.second;
    }
};

int main() {
    long long n, r;
    cin >> n >> r;
    vector<pair<long long, long long>> pts(n);
    for(int i = 0; i < n; i++) cin >> pts[i].first >> pts[i].second;
    queue<int> qq;
    vector<int> oddcyc(n);
    vector<int> dist(n, -1);
    vector<int> col(n, -1);

    unordered_map<pair<long long, long long>, int, hashh> ptsR;
    for(int i = 0; i < n; i++) ptsR[pts[i]] = i;

    int colcnt = 0;
    for(int i = 0; i < n; i++) {
        if(col[i] != -1) continue;
        col[i] = colcnt;
        dist[i] = 0;
        qq.push(i);
        bool flOddCyc = false;
        while(qq.size()) {
            int v = qq.front();
            qq.pop();
            for(int dx = -r; dx <= r; dx++) {
                for(int dy = -r; dy <= r; dy++) {
                    if(dx * dx + dy * dy > r * r) continue;
                    auto it = ptsR.find({pts[v].first + dx, pts[v].second + dy});
                    if(it == ptsR.end()) continue;
                    int t = it->second;
                    if(t == v) continue;
                    // if(sqdist(pts[v], pts[t]) > r * r) continue;
                    if(col[t] != -1) {
                        if((dist[t] + dist[v] + 1) & 1) {
                            flOddCyc = true;
                            continue;
                        }
                    } else {
                        col[t] = col[v];
                        dist[t] = dist[v] + 1;
                        qq.push(t);
                    }
                }
            }
        }
        oddcyc[colcnt] = flOddCyc;
        colcnt++;
    }
    for(int i = 0; i < n; i++) {
        cout << oddcyc[col[i]];
    }
    cout << '\n';
}
