#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<vector<int>> mtx;

int main() {
    cin >> n >> m;
    mtx.resize(n, vector<int>(m));
    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) cin >> mtx[i][j];
    vector<vector<long long>> dp(n + 1, vector<long long>(m + 1));
    for(int i = n - 1; i >= 0; i--) {
        for(int j = m - 1; j >= 0; j--) {
            long long costDelRow = dp[i + 1][j];
            {
                for(int a = j; a < m; a++) {
                    for(int b = j; b < a; b++) {
                        if(mtx[i][b] > mtx[i][a]) costDelRow++;
                    }
                }
                for(int a = j; a < m; a++) {
                    for(int b = i + 1; b < n; b++) {
                        for(int c = j; c < m; c++) {
                            if(mtx[b][c] < mtx[i][a]) costDelRow++;
                        }
                    }
                }
            }

            long long costDelCol = dp[i][j + 1];
            {
                for(int a = i; a < n; a++) {
                    for(int b = i; b < a; b++) {
                        if(mtx[b][j] > mtx[a][j]) costDelCol++;
                    }
                }
                for(int a = i; a < n; a++) {
                    for(int b = i; b < n; b++) {
                        for(int c = j + 1; c < m; c++) {
                            if(mtx[b][c] < mtx[a][j]) costDelCol++;
                        }
                    }
                }
            }

            dp[i][j] = min(costDelCol, costDelRow);
        }
    }
    cout << dp[0][0] << '\n';
}
