#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> tree;

void upd(int i, pair<int, int> x) {
    while(i < tree.size()) {
        tree[i] = min(tree[i], x);
        i = i | (i + 1);
    }
}

pair<int, int> pref(int i) {
    pair<int, int> ans = {INT32_MAX, -1};
    while(i >= 0) {
        ans = min(ans, tree[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> arr(n);
    for(int i = 0; i < n; i++) cin >> arr[i];
    vector<int> pmax(n + 1);
    for(int i = 0; i < n; i++) pmax[i + 1] = max(pmax[i], arr[i]);
    while(q--) {
        int k, i;
        cin >> k >> i;
        // i--;
        if(k == 1) {
            cout << n << '\n';
            continue;
        }
        if(k & 1) {
            if(i == k) cout << arr.back() << '\n';
            else cout << arr[i - 1] << '\n';
        } else {
            cout << arr[i - 1] << '\n';
        }
    }
}
