#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> tree;

void upd(int i, pair<int, int> x) {
    while(i < tree.size()) {
        tree[i] = min(tree[i], x);
        i = i | (i + 1);
    }
}

pair<int, int> pref(int i) {
    pair<int, int> ans = {INT32_MAX, -1};
    while(i >= 0) {
        ans = min(ans, tree[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> arr(n);
    for(int i = 0; i < n; i++) cin >> arr[i];
    vector<vector<int>> dp(n + 1, vector<int>(5, INT32_MAX));
    vector<vector<int>> pr(n + 1, vector<int>(5, n));
    dp[1][n] = 0;
    for(int i = n - 1; i >= 0; i--) dp[1][i] = max(dp[1][i + 1], arr[i]);
    for(int t = 2; t <= 5; t++) {
        int lst = n + 1 - t;
        vector<pair<int, int>> st;
        st.push_back({INT32_MAX, lst});
        tree.assign(n + 1, {INT32_MAX, -1});
        for(int i = n; i > lst; i--) upd(i, {dp[t - 1][i], i});
        for(int i = lst; i >= 0; i--) {
            // int nxtMn = INT32_MAX, nxtIdx = -1;
            bool fl = false;
            while(st.back().first <= arr[i]) st.pop_back();
            int curMn = arr[i];
            int rr = st.back().second;

            auto [nxtMn, nxtIdx] = pref(rr);
            upd(i, {dp[t - 1][i], i});
            fl = true;
            // for(int j = i + 1; j <= rr; j++) {
            //     if(dp[t - 1][j] < nxtMn) {
            //         fl = true;
            //         nxtMn = dp[t - 1][j];
            //         nxtIdx = j;
            //     }
            // }

            st.push_back({arr[i], i});
            if(fl) {
                dp[t][i] = curMn;
                pr[t][i] = nxtIdx;
            }
        }
    }
    // cout << ">> NIGA\n";
    // for(auto i : dp) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }
    // cout << "\n\n";
    vector<vector<int>> anss(n);
    for(int t = 1; t <= 5; t++) {
        vector<int> ca;
        int cur = 0;
        int dd = t;
        while(cur < n) {
            int mxx = 0;
            for(int i = cur; i < pr[dd][cur]; i++) mxx = max(mxx, arr[i]);
            ca.push_back(mxx);
            cur = pr[dd][cur];
            dd--;
        }
        anss[t - 1] = ca;
        // cout << ">> " << t << ":  ";
        // for(auto i : ca) cout << i << ' ';
        // cout << '\n';
    }
    while(q--) {
        int k, i;
        cin >> k >> i;
        k--; i--;
        cout << anss[k][i] << '\n';
    }
}
