#include <bits/stdc++.h>
using namespace std;
using ll = long long;

class segtree {
public:
    struct seg {
        ll val;
    };

    vector <seg> tree;

    void upd(ll v,ll l,ll r,ll val,ll idx) {
        if (l>idx or r<idx) {
            return;
        }
        if (l==r) {
            tree[v].val+=val;
            return ;
        }
        ll mid = (l+r)/2;

        upd(v*2,l,mid,val,idx);
        upd(v*2+1,mid+1,r,val,idx);
        tree[v].val=tree[v*2].val+tree[v*2+1].val;
    }

    ll get(ll v,ll l,ll r,ll tl,ll tr) {
        if (l>tr or r<tl) {
            return 0;
        }
        if (l>=tl and r<=tr) {
            return tree[v].val;
        }
        ll mid = (l+r)/2;

        return get(v*2,l,mid,tl,tr)+get(v*2+1,mid+1,r,tl,tr);
    }
};
segtree a;
ll r1,c1;
ll ans = 1e9;
ll res = 0;

vector <vector <ll>> in;
void solve(ll r,ll c) {
    if (r==r1 or c==c1) {
        ans = min(ans,res);
        return ;
    }
    ll op1 =0;
    for (int i=c;i<c1;i++) {
        op1+=a.get(1,0,r1*c1,in[r][i],r1*c1);
        a.upd(1,0,r1*c1,1,in[r][i]);
    }
    res+=op1;
    solve(r+1,c);
    res-=op1;
    for (int i=c;i<c1;i++) {
        a.upd(1,0,r1*c1,-1,in[r][i]);
    }
    ll op = 0;
    for (int i=r;i<r1;i++) {
        op+=a.get(1,0,r1*c1,in[i][c],r1*c1);
        a.upd(1,0,r1*c1,1,in[i][c]);
    }
    if (op>op1) {
        return ;
    }
    res+=op;
    solve(r,c+1);
    res-=op;
    for (int i=r;i<r1;i++) {
        a.upd(1,0,r1*c1,-1,in[i][c]);

    }
}
int main() {
    ios::sync_with_stdio();
    cin.tie(nullptr);

    cin>>r1>>c1;

    in.resize(r1,vector <ll> (c1,0));

    for (int i=0;i<r1;i++) {
        for (int j=0;j<c1;j++) {
            cin>>in[i][j];
        }
    }

    a.tree.resize(4*r1*c1);


    ll res = 0;
    for (int i=0;i<c1;i++) {
        res += a.get(1,0,r1*c1,in[0][i],r1*c1);
        a.upd(1,0,r1*c1,1,in[0][i]);
    }
    cout<<res;
}