#include <bits/stdc++.h>
using namespace std;
using ll = long long;

class segtree {
public:
    struct seg {
        ll val;
    };

    vector <seg> tree;

    void upd(ll v,ll l,ll r,ll val,ll idx) {
        if (l>idx or r<idx) {
            return;
        }
        if (l==r) {
            tree[v].val+=val;
            return ;
        }
        ll mid = (l+r)/2;

        upd(v*2,l,mid,val,idx);
        upd(v*2+1,mid+1,r,val,idx);
        tree[v].val=max(tree[v*2].val,tree[v*2+1].val);
    }

    ll get(ll v,ll l,ll r,ll tl,ll tr) {
        if (l>tr or r<tl) {
            return 0;
        }
        if (l>=tl and r<=tr) {
            return tree[v].val;
        }
        ll mid = (l+r)/2;

        return max(get(v*2,l,mid,tl,tr),get(v*2+1,mid+1,r,tl,tr));
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    ll n,q;
    cin>>n>>q;

    segtree a;
    a.tree.resize(4*n);
    vector <ll> in(n);
    for (int i=0;i<n;i++) {
        ll x;
        cin>>x;
        in[i]=x;
        a.upd(1,0,n-1,x,i);
    }

    ll res=1e9,idx=0;
    for (int i=0;i<n;i++) {
        if (res>a.get(1,0,n-1,0,i)){
            res = a.get(1,0,n-1,0,i);
            idx=i;
        }
    }
    // cout<<ans1<<" "<<ans2<<"\n";

    ll ans1 = a.get(1,0,n-1,0,idx),ans2 = a.get(1,0,n-1,idx+1,n-1);


    while (q--) {
        ll k,i;
        cin>>k>>i;
        if (i==1) {
            cout<<ans1<<"\n";
        }else {
            cout<<ans2<<"\n";
        }
    }



}