#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Point
{
    ll x{}, y{};
};
bool check(Point a, Point b, ll r)
{
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r*r;
}
int maxn = 1e5;
vector<vector<int>> g(maxn);
vector<int> css(maxn, 0);
vector<char> col(maxn, 0);
int CURCSS = 1;
bool f = 0;
void dfs(int v, char c)
{
    css[v] = CURCSS;
    col[v] = c;
    for (auto to : g[v])
    {
        if (col[to] == c)
        {
            f = 1;
            // cout << "ASD\n";
        }
        if (!col[to])
            dfs(to, 3 - c);
    }
    // cout << "ASD\n";
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef HIRAIN
    freopen("/home/roi/work/input.txt", "r", stdin);
    freopen("/home/roi/work/output.txt", "w", stdout);
#endif
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> a(n);
    for (auto &x : a)
        cin >> x.x >> x.y;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (check(a[i], a[j], r))
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(n + 1, 0);
    for (int i = 0; i < n; i++)
    {
        f = 0;
        if (!col[i])
        {
            dfs(i, 1);
            CURCSS++;
            if (f)
            {
                ans[CURCSS-1] = 1;
            }
        }
    }
    // for (int i = 0; i < n; i++)
    // {
    //     cout << css[i] << " ";
    // }
    // cout << endl;
    for (int i = 0; i < n; i++)
    {
        cout << ans[css[i]];
    }
    cout << endl;
    return 0;
}