#include <iostream>
#include <cstdint>
#include <algorithm>

using namespace std;

struct Point {
    uint32_t x;
    uint32_t y;
    uint32_t index;
};

bool compare(const Point & point1, const Point & point2) {
    return point1.x < point2.x;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n, r;
    cin >> n >> r;
    Point * points = new Point[n];
    for (uint32_t i = 0; i < n; i++) {
        cin >> points[i].x >> points[i].y;
        points[i].index = i;
    }
    sort(points, points + n, compare);
    uint32_t index = 0;
    char * answer = new char[n + 1];
    while (index < n) {
        uint32_t since = index;
        while (index < n - 1 && points[index + 1].x - points[index].x <= r) index++;
        index++;
        char can = '0';
        for (uint32_t i = since; i + 2 < index; i++) {
            if (points[i + 2].x - points[i].x <= r) can = '1';
        }
        for (uint32_t i = since; i < index; i++) answer[points[i].index] = can;
    }
    delete[] points;
    answer[n] = '\0';
    cout << answer;
    delete[] answer;
}
