#include <bits/stdc++.h>

using namespace std;

using ld = long double;
using ll = long long;

#define int long long
#define all(x) x.begin(), x.end()

struct node {
    ll x, y;
};

ll dist(node p, node p1) {
    return ((p.x - p1.x) * (p.x - p1.x) + (p.y - p1.y) * (p.y - p1.y));
}

ll dist1(ll x, ll x1) {
    return ((x - x1) * (x - x1));
}

vector<vector<int>> g;
vector<bool> us, us1;
bool fx = true;

vector<int> clr, path;

void dfs(int u, int p) {
    path.push_back(u);
    if (p == -1) {
        clr[u] = 1;
    } else {
        clr[u] = 3 - clr[p];
    }
    us[u] = true;
    for (auto &el : g[u]) {
        if (!us[el]) {
            dfs(el, u);
        }
    }
}

void dfs1(int u) {
    us1[u] = true;
    for (auto &el : g[u]) {
        if (clr[u] == clr[el]) {
            fx = false;
            return;
        }
        if (!us1[el]) {
            dfs1(el);
        }
    }
}


signed main() {
    int n;
    ll r;
    cin >> n >> r;
    r = r * r;
    bool f = true;
    vector<node> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if (a[i].y != 0) {
            f = false;
        }
    }
    if (n == 2) {
        cout << "00";
        return 0;
    }
    if (f) {
        vector<pair<int, int>> x;
        for (int i = 0; i < n; i++) {
            x.push_back({a[i].x, i});
        }
        sort(all(x));
        vector<int> ans(n, 0);
        for (int i = 0; i < n; i++) {
            if (i == 0) {
                ld d2 = dist1(x[i].first, x[i + 2].first);
                if (d2 <= r) {
                    ans[x[i].second] = 1;
                }
            } else if (i == n - 1) {
                ld d2 = dist1(x[i].first, x[i - 2].first);
                if (d2 <= r) {
                    ans[x[i].second] = 1;
                }
            } else {
                ld d2 = 1e9 + 100;
                if (i - 2 >= 0) {
                    d2 = dist1(x[i].first, x[i - 2].first);
                }
                ld d1 = 1e9 + 100;
                if (i + 2 < n) {
                    d1 = dist1(x[i].first, x[i + 2].first);
                }
                if (min(d1, d2) <= r) {
                    ans[x[i].second] = 1;
                }
             }
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i];
        }
        cout << "\n";
        return 0;
    }
    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (dist(a[i], a[j]) <= r) {
                g[i].push_back(j);
            }
        }
    }
    us.assign(n, false);
    us1.assign(n, false);
    vector<int> ans(n, 0);
    clr.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            path.clear();
            dfs(i, -1);
            fx = true;
            dfs1(i);
            if (!fx) {
                for (auto &el : path) {
                    ans[el] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
}