#include <bits/stdc++.h>
 
using namespace std;
 
#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
 
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
 
const int maxn = 1e5 + 10;
 
pii s[maxn];
int used[maxn];

int dst(pii a, pii b) {
    return (a.ff - b.ff) * (a.ff - b.ff) + (a.ss - b.ss) * (a.ss - b.ss);
}
void solve() {
    int n, r; cin >> n >> r;
    for (int i = 0; i < n; i++) {
        cin >> s[i].ff >> s[i].ss;
    }
 
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;

        int f = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (dst(s[i], s[j]) > r * r) continue;
 
            for (int k = 0; k < n; k++) {
                if (k == i || k == j) continue;
                if (dst(s[i], s[k]) > r * r || dst(s[j], s[k]) > r * r) continue;
 
                f = 1;
                break;
            }
            if (f) break;
        }
        if (!f) continue;
 
        used[i] = 1;
        deque<int> q; q.pb(i);
        while (!q.empty()) {
            int a = q.front();
            q.pop_front();

 
            for (int j = 0; j < n; j++) {
                if (a == j || used[j]) continue;
                if (dst(s[a], s[j]) > r * r) continue;
                q.pb(j);
                used[j] = 1;
            }
        }
    }
 
    for (int i = 0; i < n; i++) cout << used[i];
}
 
int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------------------\n";
#endif
    }
#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}