#include <vector>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <string>
#include <array>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;
int n, q;

vector<int> a;

void calc(int I, int J, int k, vector<int>& ans){
    if (k == 1){
        ans[J] = *max_element(a.begin() + I, a.end());
    }
    ans[J] = a[I];
    for (int i = I; i < n; i++){
        if (a[i] > a[I] || i + k - 1 == n){
            if (i == I + 1){
                calc(I + 1, J + 1, k - 1, ans);
                break;
            }
            else{
                int it = min_element(a.begin() + I, a.begin() + i) - a.begin();
                calc(it, J + 1, k - 1, ans);
                break;
            }
        }
    }
}

int main(){
    cin >> n >> q;
    a.resize(n);
    for (auto& k: a){
        cin >> k;
    }
 
    vector<vector<int>> b(n, vector<int>(n));
    for (int k = 1; k <= n; k++){
        calc(0, 0, k, b[k - 1]);
    }
 
    while (q--){
        int k, i;
        cin >> k >> i;
        i--;
        k--;
        cout << b[k][i] << endl;
    }
}