#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define f first
#define s second
#define pii pair<ld, ld>


struct Node {
    ld x, y, id;
};

vector<Node> pnt;

vector<vector<int>> g;

ld r;

bool dst(ll i, ll j) {
    //ll d = abs(pnt[i].x - pnt[j].x);
    ld d = sqrt((pnt[i].x - pnt[j].x) * (pnt[i].x - pnt[j].x) + (pnt[i].y - pnt[j].y) * (pnt[i].y - pnt[j].y));
    //cout << fixed << d << endl;
    return d <= r;
}

ll n;


bool cmp(Node &a, Node &b) {
    return a.x < b.x;
}


vector<int> used, good;


void dfs(int v, int c) {
    used[v] = c;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u, 3 - c);
        }
    }
}


void col(int v) {
    used[v] = 1;
    good[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) col(u);
    }
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    pnt.resize(n);
    g.resize(n);
    used.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> pnt[i].x >> pnt[i].y;
        pnt[i].id = i;
    }
    //cout << dst(0, 1) << endl;
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dst(i, j)) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << i << ": ";
//        for (auto u : g[i]) {
//            cout << u << " ";
//        }
//        cout << endl;
//    }
    good.resize(n);
    for (int i = 0; i < n; ++i) {
        fill(used.begin(), used.end(), 0);
        dfs(i, 1);
        for (int i = 0; i < n; ++i) {
            for (auto u : g[i]) {
                if (used[i] == used[u] && used[i] != 0) good[i] = 1;
            }
        }
//        if (!used[i]) {
//            vector<int> buf;
//            dfs(i, buf);
//        }
    }
    for (auto el : good) {
        if (el) {
            fill(used.begin(), used.end(), 0);
            col(el);
        }
    }
    for (auto el : good)
        cout << el;
}

