#include <bits/stdc++.h>

#define int long long

int dis(int ax, int ay, int bx, int by)
{
    return ((ax - bx) * (ax - bx) + (ay - by) * (ay - by));
}

void dfs(std::vector< std::vector< int > >& g, int v, int p, std::vector< bool >& us, std::vector< int >& d, bool& flag)
{
    for (auto u : g[v])
        if (!us[u] && u != p)
        {
            us[u] = true;
            d[u] = d[v] + 1;

            dfs(g, u, v, us, d, flag);
        }
        else if (u != p)
        {
            if (d[v] % 2 == d[u] % 2)
                flag = true;
        }
}

void dfs_flag(std::vector< std::vector< int > >& g, int v, std::vector< bool >& us, std::vector< bool >& ans)
{
    for (auto u : g[v])
        if (!us[u])
        {
            us[u] = true;
            ans[u] = true;

            dfs_flag(g, u, us, ans);
        }
}

signed main()
{
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);

    int n, r;
    std::cin >> n >> r;

    std::vector< std::pair< int, int > > v(n);
    for (int i = 0; i < n; ++i)
        std::cin >> v[i].first >> v[i].second;

    std::vector< std::vector< int > > g(n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (i != j && dis(v[i].first, v[i].second, v[j].first, v[j].second) <= r * r)
                g[i].push_back(j);

    std::vector< bool > us(n, false), us2(n, false), ans(n, false);
    std::vector< int > d(n, 0);

    for (int i = 0; i < n; ++i)
        if (!us[i])
        {
            bool flag = false;

            us[i] = true, us2[i] = true;
            dfs(g, i, -1, us, d, flag);

            if (flag)
            {
                ans[i] = true;

                dfs_flag(g, i, us2, ans);
            }
        }

    for (int i = 0; i < n; ++i)
        if (ans[i])
            std::cout << "1";
        else
            std::cout << "0";

    std::cout << '\n';

    return 0;
}
