#include "iostream"
#include "queue"
#include "vector"
using namespace std;
//#define int long long
constexpr int maxn = 10'000;
vector<short> graph[maxn];
short color[maxn]{};
short curcol = 1;
void colorisation(int x) {
    if (color[x]) return;
    color[x] = curcol;
    for (auto& i : graph[x]) {
        colorisation(i);
    }
}
bool can;
char used_color[maxn];
short used[maxn]{};
void dfs_can(int x, int len) {
    if (used[x]) {
        if (used[x] % 2 != len % 2) {
            can = true;
        }
        return;
    }
    used[x] = len;
    for (auto& i : graph[x]) {
        dfs_can(i, len + 1);
        if (can) return;
    }
}
vector<pair<long long, long long>> pairs;
inline long long d(long long x) { return x * x; }
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    long long r; cin >> r; r = d(r);
    pairs.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pairs[i].first >> pairs[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (d(pairs[i].first - pairs[j].first) + d(pairs[i].second - pairs[j].second) <= r) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            colorisation(i);
            curcol++;
        }
    }
    fill(used_color, used_color + curcol, -1);
    for (int i = 0; i < n; i++) {
        if (used_color[color[i]] == -1) {
            can = false;
            dfs_can(i, 1);
            used_color[color[i]] = can;
        }
        cout << (int)used_color[color[i]];
    }
}