#include "iostream"
#include "queue"
#include "vector"
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
//#define int long long
vector<int> fenv;
void plus_fenv(int ind) {
    for (int i = ind; i < fenv.size(); i |= (i + 1)) fenv[i]++;
}
void minus_fenv(int ind) {
    for (int i = ind; i < fenv.size(); i |= (i + 1)) fenv[i]--;
}
int sz = 0;
int get_pref(int ind) {
    int rev = sz;
    for (int i = ind; i; i &= (i - 1)) rev -= fenv[i - 1];
    return rev;
}
long long cur_rev = 0;
long long best_rev;
long long n, m;
vector<vector<int>> arr;
void rec(int i1, int i2) {
    if (cur_rev >= best_rev) return;
    if (i2 == m - 1) {
        goto line;
    }
    for (int k = i2; k < m; k++) {
        plus_fenv(arr[i1][k]);
        cur_rev += get_pref(arr[i1][k]);
        sz++;
    }
    if (i1 == n - 1) {
        best_rev = min(cur_rev, best_rev);
    } else {
        rec(i1 + 1, i2);
    }
    for (int k = m - 1; k >= i2; k--) {
        sz--;
        cur_rev -= get_pref(arr[i1][k]);
        minus_fenv(arr[i1][k]);
    }
    if (i1 == n - 1) {
        return;
    }
    line:

    for (int k = i1; k < n; k++) {
        plus_fenv(arr[k][i2]);
        cur_rev += get_pref(arr[k][i2]);
        sz++;
    }
    if (i2 == m - 1) {
        best_rev = min(cur_rev, best_rev);
    } else {
        rec(i1, i2 + 1);
    }
    for (int k = n - 1; k >= i1; k--) {
        sz--;
        cur_rev -= get_pref(arr[k][i2]);
        minus_fenv(arr[k][i2]);
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    arr.resize(n, vector<int>(m));
    best_rev = (n * m) * (n * m) / 2;
    fenv.assign(n * m, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cin >> arr[i][j];
    }
    rec(0, 0);
    cout << best_rev;
}