#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const ll INF = 1e18;

map<int, vector<int>> mp;
int n;
vector<ll> a;
vector<int> rt;
vector<vector<int>> st;
const int N = 20;
vector<int> lg;

int get_ind(int l, int r)
{
    ++r;
    int k = lg[r - l];
    int v = st[k][l];
    int u = st[k][r - (1 << k)];
    if (a[v] >= a[u])
    {
        return u;
    }
    return v;
}

void f(int st, int k, int ok)
{
    mp[ok].push_back(a[st]);
    //if (len(mp[ok]) >= 3) return;
    //for (int i = st; i < n; ++i)
    int i = min(n + 1 - k, rt[st]);
    {
        if (a[i] > a[st] || i == n + 1 - k)
        {
            /*ll mni = -1;
            ll curmn = INF;
            for (int j = st + 1; j <= i; ++j)
            {
                if (a[j] <= curmn)
                {
                    curmn = a[j];
                    mni = j;
                }
            }*/
            ll mni = get_ind(st + 1, i);
            if (k == 2)
            {
                ll mx = -INF;
                for (int u = i; u < n; ++u)
                {
                    mx = max(mx, a[u]);
                }
                mp[ok].push_back(mx);
                return;
            }
            f(mni, k - 1, ok);
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int q;
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    rt.resize(n);
    deque<int> dq;
    for (int i = n - 1; i >= 0; --i)
    {
        while (!dq.empty() && a[i] >= a[dq.back()])
        {
            dq.pop_back();
        }
        if (!dq.empty())
        {
            rt[i] = dq.back();
        } else
        {
            rt[i] = n;
        }
        dq.push_back(i);
    }
    st.resize(N, vector<int>(n));
    for (int i = 0; i < n; ++i)
    {
        st[0][i] = i;
    }
    for (int i = 0; i + 1 < N; ++i)
    {
        for (int j = 0; j + (1 << i) < n; ++j)
        {
            int v = st[i][j];
            int u = st[i][j + (1 << i)];
            if (a[v] >= a[u])
            {
                st[i + 1][j] = u;
            } else
            {
                st[i + 1][j] = v;
            }
        }
    }
    lg.resize(n + 1, 0);
    for (int i = 2; i <= n; ++i)
    {
        lg[i] = lg[i / 2] + 1;
    }
    set<int> ks;
    vector<pair<ll, ll>> reqs;
    for (int i = 0; i < q; ++i)
    {
        int j, k;
        cin >> k >> j;
        --j;
        reqs.push_back({k, j});
        ks.insert(k);
    }
    for (int p : ks)
    {
        if (p == 1)
        {
            ll mx = -INF;
            for (int i = 0; i < n; ++i)
            {
                mx = max(mx, a[i]);
            }
            mp[1].push_back(mx);
            continue;
        }
        f(0, p, p);
    }
    for (auto p : reqs)
    {
        cout << mp[p.first][p.second] << '\n';
    }

    return 0;
}
