#include <bits/stdc++.h>
#define int int64_t
#define all(a) a.begin(), a.end()
#pragma GCC optimize("O3,unroll-loops")
using namespace std;

struct Vec {
    int x, y;
};

istream &operator>>(istream &in, Vec &a) {
    in >> a.x >> a.y;
    return in;
}

int len2(Vec a, Vec b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
int n;

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int r; cin >> n >> r;
    vector<Vec> a(n);
    for (auto &i : a)
        cin >> i;
    
    r *= r;

    vector<int> b(n);
    iota(all(b), 0);


    sort(all(b), [&](auto i, auto j) {
        return a[i].x < a[j].x;
    });

    vector<bool> ans(n);

    for (int i = 0; i + 2 < n; i++) {
        Vec fi = a[b[i]], se = a[b[i + 2]];
        if (len2(fi, se) <= r) {
            ans[b[i]] = ans[b[i + 1]] = ans[b[i + 2]] = 1;
        }
    }

    for (int i = 1; i < n; i++) {
        Vec fi = a[b[i]], se = a[b[i - 1]];

        if (ans[b[i - 1]] && len2(fi, se) <= r) {
            ans[b[i]] = 1;
        }
    }

    for (int i = n - 2; i >= 0; i--) {
        Vec fi = a[b[i]], se = a[b[i + 1]];

        if (ans[b[i + 1]] && len2(fi, se) <= r) {
            ans[b[i]] = 1;
        }
    }


    for (int i = 0; i < n; i++)
        cout << ans[i];
}