#include <bits/stdc++.h>
#define int int64_t
#define all(a) a.begin(), a.end()
using namespace std;


mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

uniform_real_distribution<double> d(0, 1);

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, m; cin >> n >> m;
    
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];

    auto cost = [&](vector<int> goyda) {
        vector<int> ans;
        int x = 0, y = 0;

        for (int i : goyda) {
         
            if (x == n || y == m)
                break;
            if (i) {
                for (int j = x; j < n; j++)
                    ans.push_back(a[j][y]);
                y++;
            } else {
                for (int j = y; j < m; j++)
                    ans.push_back(a[x][j]);
                x++;
            }
        }

        int z = ans.size();

        int cnt = 0;

        for (int j = 0; j < z; j++) {
            for (int k = 0; k < j; k++) {
                cnt += ans[j] < ans[k];
            }
        }

        return cnt;
    };


    vector<int> goyda;
    for (int i = 0; i < n; i++)
        goyda.push_back(0);
    for (int i = 0; i < m; i++)
        goyda.push_back(1);

    int res = cost(goyda);

    int z = goyda.size();

    double t = 1;

    for (int _ = 0; _ < 10'000; _++) {
        t*=0.99;
        int i1 = rnd()%z, i2 = rnd()%z;

        swap(goyda[i1], goyda[i2]);
        int val = cost(goyda);
        swap(goyda[i1], goyda[i2]);
    
        if (val < res || exp((val - res) / t) < d(rnd)) {
            res = val;
            swap(goyda[i1], goyda[i2]);
        }
    }

    cout << res;
}