#include <bits/stdc++.h>

using ll = long long;
using pll = std::pair<ll, ll>;

std::vector<ll> solve1(std::vector<ll> a) {
    ll n = a.size();
    std::vector<ll> suff(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = std::max(suff[i + 1], a[i]);
    }
    ll mx = 0;
    std::vector<ll> ans(2, 1e9);
    for (int i = 0; i < n - 1; ++i) {
        mx = std::max(mx, a[i]);
        ans = std::min(ans, {mx, suff[i + 1]});
    }
    return ans;
}

void solve() {
    ll n, q;
    std::cin >> n >> q;
    std::vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    ll optj = 0;
    for (int i = 1; i + 2 < a.size(); ++i) {
        if (a[optj] >= a[i]) {
            optj = i;
        }
        else {
            break;
        }
    }
    ll optj1 = optj;
    for (int i = optj - 1; i >= 0; --i) {
        optj = i;
        if (a[i] == a[i + 1]) {
            continue;
        }
        break;
    }
    std::vector<ll> ans(3, 1e9);
    std::vector<ll> c, c1, c2;
    for (int i = optj + 1; i < n; ++i) {
        c.push_back(a[i]);
    }
    for (int i = 1; i < n; ++i) {
        c1.push_back(a[i]);
    }
    for (int i = optj1 + 1; i < n; ++i) {
        c2.push_back(a[i]);
    }
    auto b = solve1(c);
    auto b1 = solve1(c1);
    auto b2 = solve1(c2);
    std::vector<ll> b_(3), b1_(3), b2_(3);
    b_[0] = a[0];
    b2_[0] = a[0];
    b1_[0] = a[0];
    for (int i = 1; i < 3; ++i) {
        b_[i] = b[i - 1];
        b1_[i] = b1[i - 1];
        b2_[i] = b2[i - 1];
    }
    b = std::min(b_, b1_);
    b = std::min(b, b2_);
    while (q--) {
        ll k, i;
        std::cin >> k >> i;
        --i;
        std::cout << b[i] << '\n';
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}
