#include <bits/stdc++.h>
using namespace std;
#define int int64_t

vector<vector<int> > a;
vector<bool> used;
vector<int> c;
vector<int> g;

void dfs(int v) {
    used[v] = true;
    for (int i = 0; i < a[v].size(); i++) {
        int u = a[v][i];
        if (used[u] == true) {
            if (c[u] == c[v]) {
                g[v] = 1;
            }
            continue;
        }
        c[u] = 1 - c[v];
        dfs(u);
    }
}

void get_ans(int v) {
    used[v] = true;
    g[v] = 1;
    for (int i = 0; i < a[v].size(); i++) {
        int u = a[v][i];
        if (used[u] == true) {
            continue;
        }
        get_ans(u);
    }
}

int dist(pair<int,int> a, pair<int,int> b) {
    int x = a.first - b.first;
    int y = a.second - b.second;
    //cout << x * x + y * y << endl;
    return (x * x + y * y);
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int,int> > d(n + 1, {0, 0});
    for (int i = 1; i <= n; i++) {
        cin >> d[i].first >> d[i].second;
    }
    sort(d.begin(), d.end());
    int h = r * r;
    a = vector<vector<int> > (n + 1);
    for (int i = 1; i <= n - 1; i++) {
        if (dist(d[i], d[i + 1]) <= r * r) {
            a[i].push_back(i + 1);
            a[i + 1].push_back(i);
        }
        if (i <= n - 2 && dist(d[i], d[i + 2]) <= r * r) {
            a[i].push_back(i + 2);
            a[i + 2].push_back(i);
        }
    }
    used = vector<bool> (n + 1, false);
    g = vector<int> (n + 1, 0);
    c = vector<int> (n + 1, 0);
    for (int i = 1; i <= n; i++) {
        if (used[i] == false) {
            dfs(i);
        }
    }
    for (int i = 1; i <= n; i++) {
        used[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        if (g[i] == 1 && used[i] == false) {
            get_ans(i);
        }
    }
    for (int i = 1; i <= n; i++) {
        cout << g[i];
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
