#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rev reverse
#define vec vector
#define str string
#define ld long double
#define len(a) a.size()

vec<vec<int> > g;
vec<bool> used;
vec<int> order;

bool flag = false;

void dfs(int v, int cur) {
    order.pb(v);
    used[v] = true;
    for (int u: g[v]) {
        if (!used[u]) {
            dfs(u, cur + 1);
        }
    }
}

void init(int n) {
    g.resize(n), used.assign(n, false);
}

ld dist(pair<ld, ld>& a, pair<ld, ld>& b) {
    ld p1 = a.ff - b.ff, p2 = a.ss - b.ss;
    return sqrt(p1 * p1 + p2 * p2);
}

signed main() {
    int n;
    ld r;
    cin >> n >> r;
    init(n);
    vec<pair<ld, ld>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].ff >> a[i].ss;
    vec<pair<ld, int>> p(n);
    for (int i = 0; i < n; i++) p[i] = {a[i].ff, i};
    sort(all(p));
    for (int i = 0; i < len(p) - 1; i++) {
        if (dist(a[p[i].ss], a[p[i + 1].ss]) <= r) g[p[i].ss].pb(p[i + 1].ss), g[p[i + 1].ss].pb(p[i].ss);
    }
    vec<bool> ans(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            order.clear();
            dfs(i, 0);
            bool ok = false;
            for (int j = 0; j + 2 < len(order); j++) {
                int id1 = order[j], id2 = order[j + 2];
                if (dist(a[id1], a[id2]) <= r) ok = true;
            }
            if (ok) {
                for (int v : order) ans[v] = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) cout << '1';
        else cout << '0';
    }
}