#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define oset tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

void solution() {
    int n, r;
    cin >> r >> n;

    if (r == 1) {
        vector<int> a(n);

        for (auto &x : a) {
            cin >> x;
        }

        oset st;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += st.size() - st.order_of_key(a[i]);
            st.insert(a[i]);
        }

        cout << ans << '\n';
        return;
    }

    vector<int> a(n), b(n);
    for (auto &x : a) {
        cin >> x;
    }
    for (auto &x : b) {
        cin >> x;
    }

    oset st;
    oset st_a, st_b;

    int cur = 0;
    for (int i = 0; i < n; ++i) {
        cur += st.size() - st.order_of_key(a[i]);
        st.insert(a[i]);
        cur += st.size() - st.order_of_key(b[i]);
        st.insert(b[i]);
    }

    int ans = cur;
    for (int i = n - 1; i >= 0; --i) {
        cur -= st_a.order_of_key(b[i]);
        cur += st_a.size() - st_a.order_of_key(b[i]);
        st_a.insert(a[i]);

        ans = min(ans, cur);
    }

    cout << ans << '\n';
}