#include <bits/stdc++.h>
#pragma GCC Optimize("Ofast,O3")
#pragma GCC Optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi")
using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}
#define int long long

const int MAXN = 1e5;

struct Point {
    int x,y;
    Point () {}
};

bool isok(Point a, Point b, int r) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}

int used[MAXN];
int tin[MAXN];

vector<int> gr[MAXN];

bool f=0;

void dfs(int v, int p) {
    used[v]=1;
    tin[v] = p;
    for (int i : gr[v]) {
        if (f)return;

         if (used[i]==1) {
            if ((p + tin[i]) % 2 == 0) {
                f=1;
                return;
            }
        }
    }
    for (int i : gr[v]) {
        if (f)return;

        if (used[i]==0) {
            dfs(i, 0);
        }
    }
    used[v]=2;
}


void solve(){
    int n;
    int r;
    cin >> n >> r;
    vector<Point> a(n);
    for (int i  = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    vector<pair<int,int>>gb;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (isok(a[i], a[j], r)) {
                gr[i].emplace_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        f=0;
        memset(used, 0, sizeof used);
        dfs(i, 0);
        if (f){
            cout << 1;
        } else {
            cout << 0;
        }
    }
}