#include <bits/stdc++.h>
// #pragma GCC Optimize("Ofast,O3")
// #pragma GCC Optimize("unroll-loops")
// #pragma GCC target("avx,avx2,bmi")
using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int int_fast32_t
const int MAXN = 1e5;

struct Point {
    int x,y;
    Point () {}
};

bool isok(Point a, Point b, int r) {
    return (long long)(a.x - b.x) * (a.x - b.x) + (long long)(a.y - b.y) * (a.y - b.y) <= (long long)r * r;
}

int used[MAXN];
int tin[MAXN];
int ans[MAXN];

vector<int> gr[MAXN];

int f=-1;

void dfs(int v, int p) {
    used[v]=1;
    tin[v] = p;
    for (int i : gr[v]) {
        if (used[i]==1) {
            if ((p + tin[i]) % 2 == 0) {
                f=v;
                return;
            }
        }
    }
    for (int i : gr[v]) {

        if (used[i]==0) {
            dfs(i, p+1);
        }
        if (f != -1) {
            return;
        }
    }
    used[v]=2;
}

bool used2[MAXN];

void dfs2(int v) {
    used2[v]=1;
    ans[v]=1;
    for (int i : gr[v]) {
        if (!used2[i]) {
            dfs2(i);
        }
    }
}


void solve(){
    int n;
    int r;
    cin >> n >> r;
    vector<Point> a(n);
    map<pair<int,int>, int>mp;
    for (int i  = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        mp[{a[i].x, a[i].y}]=i;
    }
    for (int i = 0; i < n; i++) {
        for (int x=a[i].x-3; x <= a[i].x + 3;x++) {
            for (int y = a[i].y-3; y <= a[i].y + 3;y++) {
                if (x==a[i].x && y==a[i].y)continue;
                if (mp.find({x,y})==mp.end()) continue;
                gr[i].emplace_back(mp[{x,y}]);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i])continue;
        f=-1;
        if (used[i] == 0) {
            dfs(i, 0);
        }
        if (f != -1) {
            dfs2(f);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }

}