#include <bits/stdc++.h>

using namespace std;
//--//
//#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--//

const int N = 1e4 + 10;

vector<int> G[N];
int color[N];

bool oddC[N];

bool used[N];


void dfs(int v, int parent = -1, int c = 1) {
    color[v] = c;
    oddC[v] = false;
    for (auto u : G[v]) {
        if (u != parent) {
            if (color[u] == 0) {
                dfs(u, v, -c);
                oddC[v] |= oddC[u];
            } else if (color[u] == c) {
                oddC[v] = true;
            }
        }
    }
}

void dfs_true(int v, int parent = -1) {
    oddC[v] = true;
    used[v] = true;
    for (auto u : G[v]) {
        if (u != parent && !used[u]) {
            dfs_true(u, v);
        }
    }
}

signed main() {
    int n;
    cin >> n;
    ll r;
    cin >> r;
    vector<ll> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            dfs(i);
            if (oddC[i]) {
                dfs_true(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (oddC[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    cout << "\n";
    return 0;
}
