#include <bits/stdc++.h>

using namespace std;
//--//
//#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--//

const int MAXN = 3e5 + 10;
const int Lg = 20;

int Log2[MAXN];
int st[Lg][MAXN];
int arr[MAXN];

int st_in[Lg][MAXN];

int get_max(int L, int R) {
    int Len = R - L + 1;
    int LogL = Log2[Len];
    return max(st[LogL][L], st[LogL][R - (1 << LogL) + 1]);
}

int get_min_index(int L, int R) {
    int Len = R - L + 1;
    int LogL = Log2[Len];
    if (arr[st_in[LogL][L]] > arr[ st_in[LogL][ R - (1 << LogL) + 1] ]) {
        return st_in[LogL][R - (1 << LogL) + 1];
    } else {
        return st_in[LogL][L];
    }
}

signed main() {
    fast;

    for (int i = 0; i < Lg - 1; ++i) {
        for (int p = (1 << i); p < (1 << (i + 1)); ++p) {
            if (p < MAXN) {
                Log2[p] = i;
            }
        }
    }

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        arr[i] = a[i];
    }

    for (int i = 0; i < n; ++i) {
        st[0][i] = arr[i];
        st_in[0][i] = i;
    }
    for (int row = 1; row < Lg; ++row) {
        for (int i = 0; i <= n - (1 << row); ++i) {
            st[row][i] = max(st[row - 1][i], st[row - 1][i + (1 << (row - 1))]);
            if (arr[ st_in[row - 1][i] ] > arr[ st_in[row - 1][i + (1 << (row - 1))] ]) {
                st_in[row][i] = st_in[row - 1][i + (1 << (row - 1))];
            } else {
                st_in[row][i] = st_in[row - 1][i];
            }
        }
    }

    vector<int> next_big(n);
    for (int i = n - 1; i >= 0; --i) {
        //searching for first bigger than i
        if (i == n - 1 || get_max(i, n - 1) == a[i]) {
            next_big[i] = n;
        } else {
            int L = i, R = n - 1;
            while (R - L > 1) {
                int mid = (L + R) / 2;
                if (get_max(i, mid) == a[i]) {
                    L = mid;
                } else {
                    R = mid;
                }
            }
            next_big[i] = R;
        }
    }

    vector<pii> queries(q);
    vector<int> answers(q);

    for (int t = 0; t < q; ++t) {
        int k, in;
        cin >> k >> in;
        --in;
        queries[t] = {k, in};
    }

    vector<int> results[n + 1];
    for (int K = 1; K <= n; ++K) {
        results[K].assign(3, 0);
        int cur_pos = 0;
        if (K <= 5) {
            results[K].clear();
            results[K].assign(K, 0);
            for (int cur_index = 0; cur_index < K - 1; ++cur_index) {
                results[K][cur_index] = a[cur_pos];
                int right_edge = next_big[cur_pos] - 1;
                if (right_edge >= n - (K - cur_index - 1)) right_edge = n - (K - cur_index);
                int next_target = get_min_index(cur_pos + 1, right_edge + 1);
                cur_pos = next_target;
            }
            results[K][K - 1] = get_max(cur_pos, n - 1);
        } else {
            for (int cur_index = 0; cur_index <= 2; ++cur_index) {
                results[K][cur_index] = a[cur_pos];
                int right_edge = next_big[cur_pos] - 1;
                if (right_edge >= n - (K - cur_index - 1)) right_edge = n - (K - cur_index);
                int next_target = get_min_index(cur_pos + 1, right_edge + 1);
                cur_pos = next_target;
            }
        }
    }

    for (int t = 0; t < q; ++t) {
        cout << results[queries[t].ft][queries[t].sd] << "\n";
    }
    return 0;
}
