#include <bits/stdc++.h>

using namespace std;


int n, r;

void dfs(int v, vector<pair<int, int>> &d, vector<pair<bool, bool>> &dp, vector<vector<int>> &gr, int c) {
    if (c == 0) {
        dp[v].first = true;
    } else {
        dp[v].second = true;
    }
    for (auto i : gr[v]) {
        if (i == v) {
            continue;
        }
        if (c == 0) {
            if (!dp[i].second) {
                dfs(i, d, dp, gr, 1);
            }
        } else {
            if (!dp[i].first) {
                dfs(i, d, dp, gr, 0);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    vector<pair<int, int>> d(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> d[i].first >> d[i].second;
        mp[{d[i].first, d[i].second}] = i + 1;
    }
    vector<pair<int, int>> s;
    for (int i = -10; i <= 10; i++) {
        for (int y = -10; y <= 10; y++) {
            if (i * i + y * y <= r * r) {
                s.push_back({i, y});
            }
        }
    }
    vector<vector<int>> gr(n);
    for (int i = 0; i < n; i++) {
        for (auto x : s) {
            int h = mp[{d[i].first + x.first, d[i].second + x.second}];
            if (h != 0 && h != i + 1) {
                gr[i].push_back(h - 1);
            }
        }
    }
    vector<pair<bool, bool>> dp(n);
    for (int i = 0; i < n; i++) {
        if (!dp[i].first && !dp[i].second) {
            dfs(i, d, dp, gr, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (dp[i].first && dp[i].second) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
