#include <iostream>
#include <vector>
#include <string>
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
//#define int long long

vector<vector<int>> a;

pair<vector<int>, ll> f(vector<int> b) {
    if (b.size() == 1) {
        return {b, 0};
    }
    int m = b.size() / 2;
    vector<int> l(m);
    vector<int> r(b.size() - m);
    for (int i = 0; i < b.size(); i++) {
        if (i < m) {
            l[i] = b[i];
        } else {
            r[i - m] = b[i];
        }
    }
    ll ans = 0;
    auto q = f(l);
    ans += q.second;
    l = q.first;
    q = f(r);
    ans += q.second;
    r = q.first;
    int il = 0, ir = 0;
    for (int i = 0; i < b.size(); i++) {
        if (il != l.size() && (ir == r.size() || l[il] <= r[ir])) {
            b[i] = l[il];
            il++;
        } else {
            b[i] = r[ir];
            ir++;
            ans += l.size() - il;
        }
    }
    return {b, ans};
}

signed main() {
	ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    a.resize(n, vector<int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    ll ans, mi_ans = 1e18;
    bool fl;
    int l, r, c1, c2;
    vector<int> tec;
    for (int i = 0; i < 1 << (n + m); i++) {
        ans = 0, c1 = 0, c2 = 0, l = 0, r = 0;
        for (int j = 0; j < n + m; j++) {
            if ((i >> j) & 1) {
                c1++;
            } else {
                c2++;
            }
        }
        if (c1 == n && c2 == m) {
            tec = {};
            for (int j = 0; j < n + m; j++) {
                if (l >= n || r >= m) {
                    continue;
                }
                
                if ((i >> j) & 1) {
                    for (int k = r; k < m; k++) {
                        tec.push_back(a[l][k]);    
                    }
                    l++;
                } else {
                    for (int k = l; k < n; k++) {
                        tec.push_back(a[k][r]);    
                    }
                    r++;
                }
                
            }
            ans = f(tec).second;
            mi_ans = min(mi_ans, ans);
        }
    }
    cout << mi_ans;
	return 0;
}