#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll INF = 1e9;


void solve() {
	ll r, c; cin >> r >> c;
	vector<vector<ll>>v(r, vector<ll>(c));
	for (auto& i : v) for (auto& j : i) cin >> j;
	ll ans = 0;
	for (ll x1 = 0; x1 < r; ++x1) {
		for (ll y1 = 0; y1 < c; ++y1) {
			for (ll x2 = x1; x2 < r; ++x2) {
				for (ll y2 = y1; y2 < c; ++y2) {
					if (v[x1][y1] > v[x2][y2]) ans++;
				}
			}
		}
	}
	cout << ans;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
