#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<int> alone(n, 0);
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') {
            res = 1;
        }
    }
    int cur_happy = 0;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') {
            if (i == 0 || s[i] != s[i - 1]) {
                cur = 1;
            } else {
                if (cur) {
                    cur_happy += 2;
                    cur = 0;
                } else {
                    cur_happy++;
                }
            }
        } else {
            cur = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            alone[i] = 0;
        } else if (i == n - 1 && s[i] != s[i - 1]) {
            alone[i] = 1;
        } else if (i == 0 && s[i] != s[i + 1]) {
            alone[i] = 1;
        } else if (s[i - 1] != s[i] && s[i + 1] != s[i]) {
            alone[i] = 1;
        }
    }
    int pairs = 0;
    for (int i = 0; i < n - 2; i++) {
        if (alone[i] && alone[i + 2]) {
            pairs++;
        }
    }
    while (q--) {
        int k;
        cin >> k;
        if (!res) {
            if (k <= 1) {
                cout << 0 << endl;
            } else {
                cout << k << endl;
            }
        } else {
            if (k >= pairs) {
                cout << cur_happy + 3 * (pairs) + k - pairs << endl;
            } else {
                cout << cur_happy + 3 * k << endl;
            }
        }
    }
    return 0;
}