#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
typedef long long ll;


int min(int a, int b) {
    return (a < b ? a : b);
}


const int MAXN = 1e4;
vector<int> g[MAXN];


ll pow2(ll a) {
    return a * a;
}


vector<int> comp;
int used[MAXN];
bool f = false;


void dfs(int v, int p, int c) {
    comp.pb(v);
    used[v] = c;
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        if (used[u]) {
            if (used[u] == used[v]) {
                f = true;
            }
        } else {
            dfs(u, v, 3 - c);
        }
    }
}

signed main() {
    fast;


    int n; ll r;
    cin >> n >> r;
    vector<pair<ll, ll>> arr(n);
    map<pii, int> have;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
        have[arr[i]] = i + 1;
    }
    vector<pii> can;
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = -r; dy <= r; dy++) {
            if (dx * dx + dy * dy <= r * r && (dx != 0 || dy != 0)) {
                can.pb({dx, dy});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (auto &u : can) {
            int p = have[{u.first + arr[i].first, u.second + arr[i].second}];
            if (p) {
                g[i].pb(p - 1);
            }
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i, 1);
            if (f) {
                for (auto &u : comp) {
                    ans[u] = true;
                }
            }
            f = false;
            comp.clear();
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    line;
}