#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
typedef long long ll;


int min(int a, int b) {
    return (a < b ? a : b);
}


const int MAXN = 2e5 + 10;
vector<int> g[MAXN];


ll pow2(ll a) {
    return a * a;
}


vector<int> comp;
int used[MAXN];
bool f = false;


void dfs(int v, int p, int c) {
    comp.pb(v);
    used[v] = c;
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        if (used[u]) {
            if (used[u] == used[v]) {
                f = true;
            }
        } else {
            dfs(u, v, 3 - c);
        }
    }
}

signed main() {
    fast;


    int n; ll r;
    cin >> n >> r;
    vector<pair<ll, ll>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (pow2((ll) arr[i].first - arr[j].first) + pow2((ll) arr[i].second - arr[j].second) <= r * r) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i, 1);
            if (f) {
                for (auto &u : comp) {
                    ans[u] = true;
                }
            }
            f = false;
            comp.clear();
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    line;
}