#include <iostream>
#include <vector>

using namespace std;

pair<int, int> min(pair<int, int> a, pair<int, int> b) {
	if (a > b)return b;
	return a;
}

int max(int a, int b) {
	if (a > b)return a; return b;
}

pair<int, int> solve2(vector<int> b, int n) {
	int A = 1;
	for (int i = 0; i < n; i++)if (b[0] < b[i])A = 0;
	int B1 = b[0], B2 = 0;
	if (A) {
		B2 = b.back();
	}
	else {
		B2 = -1;
		for (auto& i : b) if (i > B2) B2 = i;
	}
	return { B1, B2 };
}

int main()
{
	int n, q;
	cin >> n >> q;
	vector<int> b(n);
	for (auto& i : b)cin >> i;
	vector<int> nextr(n);
	vector<pair<int, int>> V = { {1e9, n} };
	for (int i = n - 1; i >= 0; i--) {
		while (V.back().first < b[i])V.pop_back();
		nextr[i] = V.back().second;
		V.push_back(pair<int, int>{ b[i], i });
	}
	vector<vector<pair<int, int>>> mins(n, vector<pair<int, int>>(n + 1));
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (i + 1 == j)mins[i][j] = { b[i], i };
			else mins[i][j] = min(mins[i][j - 1], { b[j - 1], j - 1 });
		}
	}
	//for (auto& i : nextr)cout << i << " ";
	//cout << endl;
	vector<vector<int>> ANS(n, vector<int>(n));
	for (int i = 1; i <= n; i++) {
		int NOW_ID = 0;
		if (i == 1) {
			ANS[0][0] = -1;
			for (auto& B : b)ANS[0][0] = max(ANS[0][0], B);
			continue;
		}
		if (i == 2) {
			auto F = solve2(b, n);
			ANS[1][0] = F.first;
			ANS[1][1] = F.second;
			continue;
		}
		for (int N = 0; N < i - 2; N++) {
			ANS[i - 1][N] = b[NOW_ID];
			int R = nextr[NOW_ID];
			if (R > n - i + N + 2)R = n - i + N + 2;
			if (NOW_ID + 1 == R) {
				NOW_ID += 1;
				continue;
			}
			auto ID = mins[NOW_ID + 1][R];
			NOW_ID = ID.second;
			//cout << i << " " << N << " " << NOW_ID << endl;
		}
		vector<int> h;
		for (int i = NOW_ID; i < n; i++)h.push_back(b[i]);
		auto A_2 = solve2(h, h.size());
		ANS[i - 1][i - 2] = A_2.first;
		ANS[i - 1][i - 1] = A_2.second;
	}
	for (int i = 0; i < q; i++) {
		int K, I;
		cin >> K >> I;
		cout << ANS[K - 1][I - 1];
		cout << endl;
	}
}