#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
#pragma GCC optimize("O3,unroll_loops")
template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

struct Test {
    int n;
    ll r;
    vector<pair<ll, ll> > a;
    vector<vector<int> > g;

    static ll dist(pair<ll, ll> x, pair<ll, ll> y) {
        ll dx = x.first - y.first;
        ll dy = x.second - y.second;
        return dx * dx + dy * dy;
    }

    ll dist(int i, int j) const {
        return dist(a[i], a[j]);
    }

    vector<int> used;

    bool dfs(int v, int c = 1) {
        used[v] = c;
        for (auto u: g[v]) {
            if (!used[u])if (dfs(u, 3 - c))return true;
            if (used[u] == c)return true;
        }
        return false;
    }

    vector<bool> ans;

    void set_dfs(int v) {
        ans[v] = true;
        used[v] = 4;
        for (auto u: g[v]) {
            if (used[u] != 4)set_dfs(u);
        }
    }

    unordered_map<ll, int> mp;

    static ll get(ll x, ll y) {
        return x * 1000000000ll + y;
    }

    Test() {
        cin >> n >> r;
        //r *= r;
        a.resize(n);
        cin >> a;
        g.resize(n);
        sort(a.begin(), a.end());
        vector<int> b;
        for (int i = 0; i < n; i++)b.push_back(a[i].first);
        sort(b.begin(),b.end());
        for (int l = 0; l < n-2; l++) {
            if (b[l+2]-b[l]<=r) {
                g[l].push_back(l+2);
                g[l+2].push_back(l);
            }
        }
        for (int i=0;i<n-1;i++) {
            if (b[i+1]-b[i]<=r) {
                g[i].push_back(i+1);
                g[i+1].push_back(i);
            }
        }
        used.resize(n, 0);
        ans.resize(n, false);
        for (int i = 0; i < n; i++) {
            if (!used[i])if (g[i].size() >= 6 || dfs(i))set_dfs(i);
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i];
        }
    }
};


signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--) {
        Test();
    }
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}
