#include <bits/stdc++.h>
using namespace std;
#define int long long
const long long INF = 1e18, MOD = 1e9 + 7;

void solve();

int f[10010];
void update(int pos, int delta) {
    for (int i = pos; i < 10010; i += (i&-i)) {
        f[i]+= delta;
    }
}
int get(int pos) {
    int ans = 0;
    for (int i = pos; i > 0; i -= (i&-i)) {
        ans += f[i];
    }
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector <vector <int>> dp(n + 1, vector <int> (m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < m + 1; j++) {
            for (int pos = 0; pos <= n * m; pos++) {
                f[pos] = 0;
            }
            for (int i1 = 0; i1 < i - 1; i1++) {
                for (int j1 = 0; j1 < m; j1++) {
                    update(a[i1][j1],1);
                }
            }
            for (int i1 = i - 1; i1 < n; i1++) {
                for (int j1 = 0; j1 < j - 1; j1++) {
                    update(a[i1][j1], 1);
                }
            }
            if (i > 0) {
                int sm1 = 0;
                for (int j1 = max(j - 1, 0ll); j1 < m; j1++) {
                    sm1 += get(n * m) - get(a[i - 1][j1]);
                    update(a[i - 1][j1], 1);
                }
                for (int j1 = max(j - 1, 0ll); j1 < m; j1++) {;
                    update(a[i - 1][j1], -1);
                }
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + sm1);
            }
            if (j != 0) {
                int sm2 = 0;
                for (int i1 = max(i - 1, 0ll); i1 < n; i1++) {
                    sm2 += get(n * m) - get(a[i1][j - 1]);
                    update(a[i1][j - 1], 1);
                }
                for (int i1 = max(i - 1, 0ll); i1 < n; i1++) {
                    update(a[i1][j - 1], -1);
                }
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + sm2);
            }
        }
    }
    int ans = INF;
    for (int i = 0; i < n + 1; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int i = 0; i < m + 1; i++) {
        ans = min(ans, dp[n][i]);
    }
    cout << ans;
}