#include <bits/stdc++.h>

using namespace std;

const int maxn = 3005;
const int maxlog = 13;

pair<int,int> st[maxlog][maxn];
int maxst[maxn];
int dp[maxn][maxn];
int ans[maxn][maxn];
int clb[maxn];
vector<int> sta;

pair<int,int> MIN(int l,int r)
{
    //cout << l << ' ' << r << endl;
    return min(st[maxst[r-l+1]][l],st[maxst[r-l+1]][r-(1<<maxst[r-l+1])+1]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    int suf[n];
    int tst = 0;
    for(int i = 0;i < maxn;++i)
    {
        maxst[i] = tst;
        if((1<<(tst+1)) <= i+1)
        {
            tst++;
        }
    }
    int a[n];
    for(int i = 0;i < n;++i)
    {
        cin >> a[i];
        suf[i] = a[i];
    }
    for(int i = n-2;i >= 0;--i)
    {
        suf[i] = max(suf[i],suf[i+1]);
    }
    for(int j = n-1;j >= 0;--j)
    {
        while(sta.size() && a[sta.back()] < a[j])
        {
            sta.pop_back();
        }
        clb[j] = (sta.size() == 0 ? n : sta.back());
       // cout << clb[j] << endl;
        sta.push_back(j);
    }
    for(int i = 0;i < int64_t(log2(n))+1;++i)
    {
        for(int j = 0;j < n-(1<<i)+1;++j)
        {
            st[i][j] = (i == 0 ? make_pair(a[j],j) : min(st[i-1][j],st[i-1][j+(1<<(i-1))]));
        }
    }
    for(int i = n-1;i >= 0;--i)
    {
        for(int k = 1;k <= n-i;++k)
        {
            //cout << i << ' ' << k << endl;
            if(k == 1)
            {
                dp[i][k] = n;
            }
            else if(k == 2)
            {
                if(clb[i] == n)
                {
                    dp[i][k] = n-1;
                }
                else
                {
                    dp[i][k] = clb[i];
                }
            } 
            else
            {
                if(clb[i] == i+1)
                {
                    dp[i][k] = i+1;
                }
                else
                {
                    dp[i][k] = MIN(i+1,min(n-k+1,clb[i]-1)).second; 
                }
            }  
        }
    }
    for(int i = 1;i <= n;++i)
    {
        int j = 0;
        int t =0;
        while(j != n)
        {
           //cout << i-t << endl;
            ans[i][t] = j;
            j = dp[j][i-t];
            t++;
        }
    }
    while(q--)
    {
        int k,i;
        cin >> k >> i;
        i--;
        int j = ans[k][i];
        cout << (k == i+1 ? suf[j] : a[j]) << "\n";
    }
}