//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
#define endl '\n'
#define cin(v) for (auto& el : v) {cin >> el;}
#define cout(v) for (auto& el : v) {cout << el << " ";} cout << "\n";
#define int long long

using namespace std;
using ll = long long;
using db = double;
const ll MOD = 1e9 + 7;

struct ftree {
    int n;
    vector<int> tree;

    ftree(int n_) {
        n = n_;
        tree.resize(n + 1);
    }

    int query(int r) {
        ll sum = 0;
        for (; r > 0; r -= r & (-r)) {
            sum += tree[r];
        }
        return sum;
    }

    void update(int i) {
        for (; i <= n; i += i & (-i)) {
            tree[i]++;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mas(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        cin(mas[i]);
    }
    ll MIN = 1e18;
    for (int mask = 0; mask < (1 << (n + m)); mask++) {
        vector<int> ans;
        int d1 = 0, d2 = 0;
        for (int i = 0; i < n + m && ans.size() < n * m; i++) {
            if ((mask >> i) & 1) {
                for (int j = d2; j < m; j++) {
                    ans.push_back(mas[d1][j]);
                }
                d1++;
            }else {
                for (int j = d1; j < n; j++) {
                    ans.push_back(mas[j][d2]);
                }
                d2++;
            }
        }
        ftree tr(n * m + 1);
        ll cnt = 0;
        for (int i = 0; i < ans.size(); i++) {
            cnt += ans[i] - 1 - tr.query(ans[i]);
            tr.update(ans[i]);
        }
        MIN = min(MIN, cnt);
    }
    cout << MIN;
    return 0;
}