//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
#define endl '\n'
#define cin(v) for (auto& el : v) {cin >> el;}
#define cout(v) for (auto& el : v) {cout << el << " ";} cout << "\n";
#define int long long

using namespace std;
using ll = long long;
using db = double;
const ll MOD = 1e9 + 7;

struct ftree {
    int n;
    vector<int> tree;

    ftree(int n_) {
        n = n_;
        tree.resize(n + 1);
    }

    int query(int r) {
        ll sum = 0;
        for (; r > 0; r -= r & (-r)) {
            sum += tree[r];
        }
        return sum;
    }

    void update(int i) {
        for (; i <= n; i += i & (-i)) {
            tree[i]++;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mas(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        cin(mas[i]);
    }
    if (n == 1) {
        vector<int> ans = mas[0];
        ftree tr(n * m + 1);
        ll cnt = 0;
        for (int i = 0; i < ans.size(); i++) {
            cnt += ans[i] - 1 - tr.query(ans[i]);
            tr.update(ans[i]);
        }
        cout << cnt;
        return 0;
    }
    vector<int> dp(m);
    ftree tr1(n * m + 1), tr2(n * m + 1);
    for (int i = m - 1; i >= 0; i--) {
        int a = mas[0][i], b = mas[1][i];
        if (i + 1 < m) {
            dp[i] = dp[i + 1];
        }
        if (a > b) {
            dp[i]++;
        }
        dp[i] += tr2.query(a);
        dp[i] += tr2.query(b);
        dp[i] += tr1.query(a);
        dp[i] += (m - i - 1) - tr1.query(b);
        tr1.update(a);
        tr2.update(b);
    }
    ftree tr(n * m + 1);
    ll ans = 1e18, add = 0;
    for (int i = 0; i < m; i++) {
        ll cur = dp[i] + add;
        ans = min(ans, cur);
        int a = mas[0][i], b = mas[1][i];
        add += a - 1 - tr.query(a);
        tr.update(a);
        add += b - 1 - tr.query(b);
        tr.update(b);
    }
    cout << ans;
    return 0;
}